/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(se){for(var t=[],E=0,T=se.length;E<T;E++)t[E]=be[se[E]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ut,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Tt}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,E,T){return t.apply(E,T)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Tt||(Tt=function(t,E){return new t(...E)});const oi=ut(Array.prototype.forEach),jt=ut(Array.prototype.pop),vt=ut(Array.prototype.push),kt=ut(String.prototype.toLowerCase),Rt=ut(String.prototype.toString),li=ut(String.prototype.match),dt=ut(String.prototype.replace),ai=ut(String.prototype.indexOf),hi=ut(String.prototype.trim),ht=ut(RegExp.prototype.test),Dt=ui(TypeError);function ut(se){return function(t){for(var E=arguments.length,T=new Array(E>1?E-1:0),n=1;n<E;n++)T[n-1]=arguments[n];return Nt(se,t,T)}}function ui(se){return function(){for(var t=arguments.length,E=new Array(t),T=0;T<t;T++)E[T]=arguments[T];return Tt(se,E)}}function He(se,t,E){var T;E=(T=E)!==null&&T!==void 0?T:kt,Ut&&Ut(se,null);let n=t.length;for(;n--;){let H=t[n];if(typeof H=="string"){const y=E(H);y!==H&&(ii(t)||(t[n]=y),H=y)}se[H]=!0}return se}function $t(se){const t=ri(null);for(const[E,T]of zt(se))t[E]=T;return t}function At(se,t){for(;se!==null;){const T=si(se,t);if(T){if(T.get)return ut(T.get);if(typeof T.value=="function")return ut(T.value)}se=ni(se)}function E(T){return console.warn("fallback value for",T),null}return E}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),qt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:qt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Vt});const vi=()=>typeof window>"u"?null:window,Di=function(t,E){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let T=null;const n="data-tt-policy-suffix";E&&E.hasAttribute(n)&&(T=E.getAttribute(n));const H="dompurify"+(T?"#"+T:"");try{return t.createPolicy(H,{createHTML(y){return y},createScriptURL(y){return y}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function xt(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=ze=>xt(ze);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const E=se.document,T=E.currentScript;let{document:n}=se;const{DocumentFragment:H,HTMLTemplateElement:y,Node:S,Element:m,NodeFilter:p,NamedNodeMap:v=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:M,DOMParser:l,trustedTypes:h}=se,e=m.prototype,s=At(e,"cloneNode"),f=At(e,"nextSibling"),c=At(e,"childNodes"),a=At(e,"parentNode");if(typeof y=="function"){const ze=n.createElement("template");ze.content&&ze.content.ownerDocument&&(n=ze.content.ownerDocument)}let $,d="";const{implementation:b,createNodeIterator:u,createDocumentFragment:N,getElementsByTagName:B}=n,{importNode:R}=E;let U={};t.isSupported=typeof zt=="function"&&typeof a=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:z,ERB_EXPR:D,TMPLIT_EXPR:O,DATA_ATTR:W,ARIA_ATTR:A,IS_SCRIPT_OR_DATA:P,ATTR_WHITESPACE:L}=Kt;let{IS_ALLOWED_URI:Y}=Kt,X=null;const de=He({},[...Ht,...Pt,...Lt,...It,...Wt]);let ue=null;const te=He({},[...Qt,...Mt,..._t,...St]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Pe=null,Ne=null,Be=!0,le=!0,J=!1,ae=!0,re=!1,G=!1,K=!1,ie=!1,fe=!1,ye=!1,Ce=!1,Ae=!0,q=!1;const g="user-content-";let k=!0,F=!1,r={},i=null;const o=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let w=null;const I=He({},["audio","video","img","source","image","track"]);let C=null;const j=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),_="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",oe="http://www.w3.org/1999/xhtml";let me=oe,De=!1,ve=null;const Se=He({},[_,Z,oe],Rt);let we;const Te=["application/xhtml+xml","text/html"],Ie="text/html";let Me,Xe=null;const nt=n.createElement("form"),Ke=function(he){return he instanceof RegExp||he instanceof Function},Ze=function(he){if(!(Xe&&Xe===he)){if((!he||typeof he!="object")&&(he={}),he=$t(he),we=Te.indexOf(he.PARSER_MEDIA_TYPE)===-1?we=Ie:we=he.PARSER_MEDIA_TYPE,Me=we==="application/xhtml+xml"?Rt:kt,X="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Me):de,ue="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Me):te,ve="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Rt):Se,C="ADD_URI_SAFE_ATTR"in he?He($t(j),he.ADD_URI_SAFE_ATTR,Me):j,w="ADD_DATA_URI_TAGS"in he?He($t(I),he.ADD_DATA_URI_TAGS,Me):I,i="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Me):o,Pe="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Me):{},Ne="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Me):{},r="USE_PROFILES"in he?he.USE_PROFILES:!1,Be=he.ALLOW_ARIA_ATTR!==!1,le=he.ALLOW_DATA_ATTR!==!1,J=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,G=he.WHOLE_DOCUMENT||!1,fe=he.RETURN_DOM||!1,ye=he.RETURN_DOM_FRAGMENT||!1,Ce=he.RETURN_TRUSTED_TYPE||!1,ie=he.FORCE_BODY||!1,Ae=he.SANITIZE_DOM!==!1,q=he.SANITIZE_NAMED_PROPS||!1,k=he.KEEP_CONTENT!==!1,F=he.IN_PLACE||!1,Y=he.ALLOWED_URI_REGEXP||qt,me=he.NAMESPACE||oe,ge=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Ke(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Ke(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),ye&&(fe=!0),r&&(X=He({},[...Wt]),ue=[],r.html===!0&&(He(X,Ht),He(ue,Qt)),r.svg===!0&&(He(X,Pt),He(ue,Mt),He(ue,St)),r.svgFilters===!0&&(He(X,Lt),He(ue,Mt),He(ue,St)),r.mathMl===!0&&(He(X,It),He(ue,_t),He(ue,St))),he.ADD_TAGS&&(X===de&&(X=$t(X)),He(X,he.ADD_TAGS,Me)),he.ADD_ATTR&&(ue===te&&(ue=$t(ue)),He(ue,he.ADD_ATTR,Me)),he.ADD_URI_SAFE_ATTR&&He(C,he.ADD_URI_SAFE_ATTR,Me),he.FORBID_CONTENTS&&(i===o&&(i=$t(i)),He(i,he.FORBID_CONTENTS,Me)),k&&(X["#text"]=!0),G&&He(X,["html","head","body"]),X.table&&(He(X,["tbody"]),delete Pe.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw Dt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw Dt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');$=he.TRUSTED_TYPES_POLICY,d=$.createHTML("")}else $===void 0&&($=Di(h,T)),$!==null&&typeof d=="string"&&(d=$.createHTML(""));ot&&ot(he),Xe=he}},x=He({},["mi","mo","mn","ms","mtext"]),ne=He({},["foreignobject","desc","title","annotation-xml"]),$e=He({},["title","style","font","a","script"]),Ee=He({},Pt);He(Ee,Lt),He(Ee,ci);const Re=He({},It);He(Re,fi);const je=function(he){let Fe=a(he);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:me,tagName:"template"});const Le=kt(he.tagName),_e=kt(Fe.tagName);return ve[he.namespaceURI]?he.namespaceURI===Z?Fe.namespaceURI===oe?Le==="svg":Fe.namespaceURI===_?Le==="svg"&&(_e==="annotation-xml"||x[_e]):!!Ee[Le]:he.namespaceURI===_?Fe.namespaceURI===oe?Le==="math":Fe.namespaceURI===Z?Le==="math"&&ne[_e]:!!Re[Le]:he.namespaceURI===oe?Fe.namespaceURI===Z&&!ne[_e]||Fe.namespaceURI===_&&!x[_e]?!1:!Re[Le]&&($e[Le]||!Ee[Le]):!!(we==="application/xhtml+xml"&&ve[he.namespaceURI]):!1},Qe=function(he){vt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},Je=function(he,Fe){try{vt(t.removed,{attribute:Fe.getAttributeNode(he),from:Fe})}catch{vt(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(he),he==="is"&&!ue[he])if(fe||ye)try{Qe(Fe)}catch{}else try{Fe.setAttribute(he,"")}catch{}},tt=function(he){let Fe,Le;if(ie)he="<remove></remove>"+he;else{const lt=li(he,/^[\r\n\t ]+/);Le=lt&&lt[0]}we==="application/xhtml+xml"&&me===oe&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const _e=$?$.createHTML(he):he;if(me===oe)try{Fe=new l().parseFromString(_e,we)}catch{}if(!Fe||!Fe.documentElement){Fe=b.createDocument(me,"template",null);try{Fe.documentElement.innerHTML=De?d:_e}catch{}}const it=Fe.body||Fe.documentElement;return he&&Le&&it.insertBefore(n.createTextNode(Le),it.childNodes[0]||null),me===oe?B.call(Fe,G?"html":"body")[0]:G?Fe.documentElement:it},st=function(he){return u.call(he.ownerDocument||he,he,p.SHOW_ELEMENT|p.SHOW_COMMENT|p.SHOW_TEXT,null,!1)},Ge=function(he){return he instanceof M&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof v)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof S=="object"?he instanceof S:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},et=function(he,Fe,Le){U[he]&&oi(U[he],_e=>{_e.call(t,Fe,Le,Xe)})},gt=function(he){let Fe;if(et("beforeSanitizeElements",he,null),Ge(he))return Qe(he),!0;const Le=Me(he.nodeName);if(et("uponSanitizeElement",he,{tagName:Le,allowedTags:X}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Qe(he),!0;if(!X[Le]||Pe[Le]){if(!Pe[Le]&&bt(Le)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Le)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Le)))return!1;if(k&&!i[Le]){const _e=a(he)||he.parentNode,it=c(he)||he.childNodes;if(it&&_e){const lt=it.length;for(let xe=lt-1;xe>=0;--xe)_e.insertBefore(s(it[xe],!0),f(he))}}return Qe(he),!0}return he instanceof m&&!je(he)||(Le==="noscript"||Le==="noembed"||Le==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Qe(he),!0):(re&&he.nodeType===3&&(Fe=he.textContent,Fe=dt(Fe,z," "),Fe=dt(Fe,D," "),Fe=dt(Fe,O," "),he.textContent!==Fe&&(vt(t.removed,{element:he.cloneNode()}),he.textContent=Fe)),et("afterSanitizeElements",he,null),!1)},mt=function(he,Fe,Le){if(Ae&&(Fe==="id"||Fe==="name")&&(Le in n||Le in nt))return!1;if(!(le&&!Ne[Fe]&&ht(W,Fe))){if(!(Be&&ht(A,Fe))){if(!ue[Fe]||Ne[Fe]){if(!(bt(he)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,he)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(he))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Fe)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Fe))||Fe==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Le)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Le))))return!1}else if(!C[Fe]){if(!ht(Y,dt(Le,L,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&he!=="script"&&ai(Le,"data:")===0&&w[he])){if(!(J&&!ht(P,dt(Le,L,"")))){if(Le)return!1}}}}}}return!0},bt=function(he){return he.indexOf("-")>0},Ft=function(he){let Fe,Le,_e,it;et("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ue};for(it=lt.length;it--;){Fe=lt[it];const{name:ct,namespaceURI:pt}=Fe;if(Le=ct==="value"?Fe.value:hi(Fe.value),_e=Me(ct),xe.attrName=_e,xe.attrValue=Le,xe.keepAttr=!0,xe.forceKeepAttr=void 0,et("uponSanitizeAttribute",he,xe),Le=xe.attrValue,xe.forceKeepAttr||(Je(ct,he),!xe.keepAttr))continue;if(!ae&&ht(/\/>/i,Le)){Je(ct,he);continue}re&&(Le=dt(Le,z," "),Le=dt(Le,D," "),Le=dt(Le,O," "));const yt=Me(he.nodeName);if(mt(yt,_e,Le)){if(q&&(_e==="id"||_e==="name")&&(Je(ct,he),Le=g+Le),$&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!pt)switch(h.getAttributeType(yt,_e)){case"TrustedHTML":{Le=$.createHTML(Le);break}case"TrustedScriptURL":{Le=$.createScriptURL(Le);break}}try{pt?he.setAttributeNS(pt,ct,Le):he.setAttribute(ct,Le),jt(t.removed)}catch{}}}et("afterSanitizeAttributes",he,null)},Ot=function ze(he){let Fe;const Le=st(he);for(et("beforeSanitizeShadowDOM",he,null);Fe=Le.nextNode();)et("uponSanitizeShadowNode",Fe,null),!gt(Fe)&&(Fe.content instanceof H&&ze(Fe.content),Ft(Fe));et("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(ze){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Le,_e,it;if(De=!ze,De&&(ze="<!-->"),typeof ze!="string"&&!rt(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw Dt("dirty is not a string, aborting")}else throw Dt("toString is not a function");if(!t.isSupported)return ze;if(K||Ze(he),t.removed=[],typeof ze=="string"&&(F=!1),F){if(ze.nodeName){const ct=Me(ze.nodeName);if(!X[ct]||Pe[ct])throw Dt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof S)Fe=tt("<!---->"),Le=Fe.ownerDocument.importNode(ze,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?Fe=Le:Fe.appendChild(Le);else{if(!fe&&!re&&!G&&ze.indexOf("<")===-1)return $&&Ce?$.createHTML(ze):ze;if(Fe=tt(ze),!Fe)return fe?null:Ce?d:""}Fe&&ie&&Qe(Fe.firstChild);const lt=st(F?ze:Fe);for(;_e=lt.nextNode();)gt(_e)||(_e.content instanceof H&&Ot(_e.content),Ft(_e));if(F)return ze;if(fe){if(ye)for(it=N.call(Fe.ownerDocument);Fe.firstChild;)it.appendChild(Fe.firstChild);else it=Fe;return(ue.shadowroot||ue.shadowrootmode)&&(it=R.call(E,it,!0)),it}let xe=G?Fe.outerHTML:Fe.innerHTML;return G&&X["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Vt,Fe.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+xe),re&&(xe=dt(xe,z," "),xe=dt(xe,D," "),xe=dt(xe,O," ")),$&&Ce?$.createHTML(xe):xe},t.setConfig=function(ze){Ze(ze),K=!0},t.clearConfig=function(){Xe=null,K=!1},t.isValidAttribute=function(ze,he,Fe){Xe||Ze({});const Le=Me(ze),_e=Me(he);return mt(Le,_e,Fe)},t.addHook=function(ze,he){typeof he=="function"&&(U[ze]=U[ze]||[],vt(U[ze],he))},t.removeHook=function(ze){if(U[ze])return jt(U[ze])},t.removeHooks=function(ze){U[ze]&&(U[ze]=[])},t.removeAllHooks=function(){U={}},t}var yi=xt();define("vs/base/browser/dompurify/dompurify",function(){return yi}),define(be[42],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MR=t.$LR=void 0;class E{constructor(y){this.domNode=y,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(y){const S=T(y);this.a!==S&&(this.a=S,this.domNode.style.maxWidth=this.a)}setWidth(y){const S=T(y);this.b!==S&&(this.b=S,this.domNode.style.width=this.b)}setHeight(y){const S=T(y);this.c!==S&&(this.c=S,this.domNode.style.height=this.c)}setTop(y){const S=T(y);this.d!==S&&(this.d=S,this.domNode.style.top=this.d)}setLeft(y){const S=T(y);this.e!==S&&(this.e=S,this.domNode.style.left=this.e)}setBottom(y){const S=T(y);this.f!==S&&(this.f=S,this.domNode.style.bottom=this.f)}setRight(y){const S=T(y);this.g!==S&&(this.g=S,this.domNode.style.right=this.g)}setPaddingTop(y){const S=T(y);this.h!==S&&(this.h=S,this.domNode.style.paddingTop=this.h)}setPaddingLeft(y){const S=T(y);this.i!==S&&(this.i=S,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(y){const S=T(y);this.j!==S&&(this.j=S,this.domNode.style.paddingBottom=this.j)}setPaddingRight(y){const S=T(y);this.k!==S&&(this.k=S,this.domNode.style.paddingRight=this.k)}setFontFamily(y){this.l!==y&&(this.l=y,this.domNode.style.fontFamily=this.l)}setFontWeight(y){this.m!==y&&(this.m=y,this.domNode.style.fontWeight=this.m)}setFontSize(y){const S=T(y);this.n!==S&&(this.n=S,this.domNode.style.fontSize=this.n)}setFontStyle(y){this.o!==y&&(this.o=y,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(y){this.p!==y&&(this.p=y,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(y){this.q!==y&&(this.q=y,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(y){this.r!==y&&(this.r=y,this.domNode.style.textDecoration=this.r)}setLineHeight(y){const S=T(y);this.s!==S&&(this.s=S,this.domNode.style.lineHeight=this.s)}setLetterSpacing(y){const S=T(y);this.t!==S&&(this.t=S,this.domNode.style.letterSpacing=this.t)}setClassName(y){this.u!==y&&(this.u=y,this.domNode.className=this.u)}toggleClassName(y,S){this.domNode.classList.toggle(y,S),this.u=this.domNode.className}setDisplay(y){this.v!==y&&(this.v=y,this.domNode.style.display=this.v)}setPosition(y){this.w!==y&&(this.w=y,this.domNode.style.position=this.w)}setVisibility(y){this.x!==y&&(this.x=y,this.domNode.style.visibility=this.x)}setColor(y){this.y!==y&&(this.y=y,this.domNode.style.color=this.y)}setBackgroundColor(y){this.z!==y&&(this.z=y,this.domNode.style.backgroundColor=this.z)}setLayerHinting(y){this.A!==y&&(this.A=y,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this.C!==y&&(this.C=y,this.domNode.style.boxShadow=y)}setContain(y){this.B!==y&&(this.B=y,this.domNode.style.contain=this.B)}setAttribute(y,S){this.domNode.setAttribute(y,S)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.$LR=E;function T(H){return typeof H=="number"?`${H}px`:H}function n(H){return new E(H)}t.$MR=n}),define(be[69],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4P=t.$3P=void 0;const E=new WeakMap;function T(S){if(!S.parent||S.parent===S)return null;try{const m=S.location,p=S.parent.location;if(m.origin!=="null"&&p.origin!=="null"&&m.origin!==p.origin)return null}catch{return null}return S.parent}class n{static a(m){let p=E.get(m);if(!p){p=[],E.set(m,p);let v=m,M;do M=T(v),M?p.push({window:new WeakRef(v),iframeElement:v.frameElement||null}):p.push({window:new WeakRef(v),iframeElement:null}),v=M;while(v)}return p.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,p){if(!p||m===p)return{top:0,left:0};let v=0,M=0;const l=this.a(m);for(const h of l){const e=h.window.deref();if(v+=e?.scrollY??0,M+=e?.scrollX??0,e===p||!h.iframeElement)break;const s=h.iframeElement.getBoundingClientRect();v+=s.top,M+=s.left}return{top:v,left:M}}}t.$3P=n;async function H(S,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const p=JSON.stringify({parentOrigin:S,salt:m}),M=new TextEncoder().encode(p),l=await crypto.subtle.digest("sha-256",M);return y(l)}t.$4P=H;function y(S){const p=Array.from(new Uint8Array(S)).map(v=>v.toString(16).padStart(2,"0")).join("");return BigInt(`0x${p}`).toString(32).padStart(52,"0")}}),define(be[70],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sS=t.$rS=t.$qS=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var E;(function(y){y[y.Copy=0]="Copy",y[y.Move=1]="Move"})(E||(t.ListDragOverEffectType=E={}));var T;(function(y){y.Over="drop-target",y.Before="drop-target-before",y.After="drop-target-after"})(T||(t.ListDragOverEffectPosition=T={})),t.$qS={reject(){return{accept:!1}},accept(){return{accept:!0}}};class n extends Error{constructor(S,m){super(`ListError [${S}] ${m}`)}}t.$rS=n;class H{constructor(){this.c=new WeakMap}getHeight(S){return this.c.get(S)??this.d(S)}setDynamicHeight(S,m){m>0&&this.c.set(S,m)}}t.$sS=H}),define(be[71],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gS=void 0;class E{constructor(n){this.a=n}splice(n,H,y){this.a.forEach(S=>S.splice(n,H,y))}}t.$gS=E}),define(be[43],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RR=void 0;const E=20;class T{constructor(H,y,S,m,p,v){this.a=Math.round(y),this.b=Math.round(S),this.c=Math.round(H),this.d=m,this.e=p,this.f=v,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new T(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const y=Math.round(H);return this.d!==y?(this.d=y,this.m(),!0):!1}setScrollSize(H){const y=Math.round(H);return this.e!==y?(this.e=y,this.m(),!0):!1}setScrollPosition(H){const y=Math.round(H);return this.f!==y?(this.f=y,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,y,S,m,p){const v=Math.max(0,S-H),M=Math.max(0,v-2*y),l=m>0&&m>S;if(!l)return{computedAvailableSize:Math.round(v),computedIsNeeded:l,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(E,Math.floor(S*M/m))),e=(M-h)/(m-S),s=p*e;return{computedAvailableSize:Math.round(v),computedIsNeeded:l,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=T.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const y=H-this.c-this.i/2;return Math.round(y/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const y=H-this.c;let S=this.f;return y<this.k?S-=this.d:S+=this.d,S}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const y=this.k+H;return Math.round(y/this.j)}}t.$RR=T}),define(be[26],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kU=t.$jU=t.$iU=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var E;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(E||(t.TreeVisibility=E={}));var T;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(T||(t.ObjectTreeElementCollapseState=T={}));var n;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var H;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$iU={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class y extends Error{constructor(p,v){super(`TreeError [${p}] ${v}`)}}t.$jU=y;class S{constructor(p){this.a=p,this.b=new WeakMap}map(p){let v=this.b.get(p);return v||(v=this.a(p),this.b.set(p,v)),v}}t.$kU=S}),define(be[21],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HP=t.$window=t.$FP=t.$EP=void 0;function E(n,H){const y=n;typeof y.vscodeWindowId!="number"&&Object.defineProperty(y,"vscodeWindowId",{get:()=>H})}t.$EP=E,t.$FP=window,t.$window=t.$FP;function T(n){return n===t.$FP?!1:typeof n?.vscodeWindowId=="number"}t.$HP=T}),define(be[72],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function E(s,f,c){const a=T(s,f);if(a!==-1)return s[a]}t.$fb=E;function T(s,f,c=s.length-1){for(let a=c;a>=0;a--){const $=s[a];if(f($))return a}return-1}t.$gb=T;function n(s,f){const c=H(s,f);return c===-1?void 0:s[c]}t.$hb=n;function H(s,f,c=0,a=s.length){let $=c,d=a;for(;$<d;){const b=Math.floor(($+d)/2);f(s[b])?$=b+1:d=b}return $-1}t.$ib=H;function y(s,f){const c=S(s,f);return c===s.length?void 0:s[c]}t.$jb=y;function S(s,f,c=0,a=s.length){let $=c,d=a;for(;$<d;){const b=Math.floor(($+d)/2);f(s[b])?d=b:$=b+1}return $}t.$kb=S;function m(s,f,c=0,a=s.length){const $=S(s,f,c,a);return $===s.length?-1:$}t.$lb=m;class p{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(p.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!f(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const c=H(this.e,f,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}t.$mb=p;function v(s,f){if(s.length===0)return;let c=s[0];for(let a=1;a<s.length;a++){const $=s[a];f($,c)>0&&(c=$)}return c}t.$nb=v;function M(s,f){if(s.length===0)return;let c=s[0];for(let a=1;a<s.length;a++){const $=s[a];f($,c)>=0&&(c=$)}return c}t.$ob=M;function l(s,f){return v(s,(c,a)=>-f(c,a))}t.$pb=l;function h(s,f){if(s.length===0)return-1;let c=0;for(let a=1;a<s.length;a++){const $=s[a];f($,s[c])>0&&(c=a)}return c}t.$qb=h;function e(s,f){for(const c of s){const a=f(c);if(a!==void 0)return a}}t.$rb=e}),define(be[73],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function E(y,S){const m=Object.create(null);for(const p of y){const v=S(p);let M=m[v];M||(M=m[v]=[]),M.push(p)}return m}t.$K=E;function T(y,S){const m=[],p=[];for(const v of y)S.has(v)||m.push(v);for(const v of S)y.has(v)||p.push(v);return{removed:m,added:p}}t.$L=T;function n(y,S){const m=[],p=[];for(const[v,M]of y)S.has(v)||m.push(M);for(const[v,M]of S)y.has(v)||p.push(M);return{removed:m,added:p}}t.$M=n;function H(y,S){const m=new Set;for(const p of S)y.has(p)&&m.add(p);return m}t.$N=H}),define(be[74],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rt=t.$qt=t.$pt=t.$ot=void 0;function E(S,m){const p=Math.pow(10,m);return Math.round(S*p)/p}class T{constructor(m,p,v,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=E(Math.max(Math.min(1,M),0),3)}static equals(m,p){return m.r===p.r&&m.g===p.g&&m.b===p.b&&m.a===p.a}}t.$ot=T;class n{constructor(m,p,v,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=E(Math.max(Math.min(1,p),0),3),this.l=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,M),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.l===p.l&&m.a===p.a}static fromRGBA(m){const p=m.r/255,v=m.g/255,M=m.b/255,l=m.a,h=Math.max(p,v,M),e=Math.min(p,v,M);let s=0,f=0;const c=(e+h)/2,a=h-e;if(a>0){switch(f=Math.min(c<=.5?a/(2*c):a/(2-2*c),1),h){case p:s=(v-M)/a+(v<M?6:0);break;case v:s=(M-p)/a+2;break;case M:s=(p-v)/a+4;break}s*=60,s=Math.round(s)}return new n(s,f,c,l)}static i(m,p,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?m+(p-m)*6*v:v<1/2?p:v<2/3?m+(p-m)*(2/3-v)*6:m}static toRGBA(m){const p=m.h/360,{s:v,l:M,a:l}=m;let h,e,s;if(v===0)h=e=s=M;else{const f=M<.5?M*(1+v):M+v-M*v,c=2*M-f;h=n.i(c,f,p+1/3),e=n.i(c,f,p),s=n.i(c,f,p-1/3)}return new T(Math.round(h*255),Math.round(e*255),Math.round(s*255),l)}}t.$pt=n;class H{constructor(m,p,v,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=E(Math.max(Math.min(1,p),0),3),this.v=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,M),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.v===p.v&&m.a===p.a}static fromRGBA(m){const p=m.r/255,v=m.g/255,M=m.b/255,l=Math.max(p,v,M),h=Math.min(p,v,M),e=l-h,s=l===0?0:e/l;let f;return e===0?f=0:l===p?f=((v-M)/e%6+6)%6:l===v?f=(M-p)/e+2:f=(p-v)/e+4,new H(Math.round(f*60),s,l,m.a)}static toRGBA(m){const{h:p,s:v,v:M,a:l}=m,h=M*v,e=h*(1-Math.abs(p/60%2-1)),s=M-h;let[f,c,a]=[0,0,0];return p<60?(f=h,c=e):p<120?(f=e,c=h):p<180?(c=h,a=e):p<240?(c=e,a=h):p<300?(f=e,a=h):p<=360&&(f=h,a=e),f=Math.round((f+s)*255),c=Math.round((c+s)*255),a=Math.round((a+s)*255),new T(f,c,a,l)}}t.$qt=H;class y{static fromHex(m){return y.Format.CSS.parseHex(m)||y.red}static equals(m,p){return!m&&!p?!0:!m||!p?!1:m.equals(p)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof T)this.rgba=m;else if(m instanceof n)this.i=m,this.rgba=n.toRGBA(m);else if(m instanceof H)this.j=m,this.rgba=H.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&T.equals(this.rgba,m.rgba)&&n.equals(this.hsla,m.hsla)&&H.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=y.k(this.rgba.r),p=y.k(this.rgba.g),v=y.k(this.rgba.b),M=.2126*m+.7152*p+.0722*v;return E(M,4)}static k(m){const p=m/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p>v?(p+.05)/(v+.05):(v+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p>v}isDarkerThan(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p<v}lighten(m){return new y(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new y(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:p,g:v,b:M,a:l}=this.rgba;return new y(new T(p,v,M,l*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const p=m.rgba,v=this.rgba.a,M=p.a,l=v+M*(1-v);if(l<1e-6)return y.transparent;const h=this.rgba.r*v/l+p.r*M*(1-v)/l,e=this.rgba.g*v/l+p.g*M*(1-v)/l,s=this.rgba.b*v/l+p.b*M*(1-v)/l;return new y(new T(h,e,s,l))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:p,g:v,b:M,a:l}=this.rgba;return new y(new T(m.rgba.r-l*(m.rgba.r-p),m.rgba.g-l*(m.rgba.g-v),m.rgba.b-l*(m.rgba.b-M),1))}flatten(...m){const p=m.reduceRight((v,M)=>y.o(M,v));return y.o(this,p)}static o(m,p){const v=1-m.rgba.a;return new y(new T(v*p.rgba.r+m.rgba.a*m.rgba.r,v*p.rgba.g+m.rgba.a*m.rgba.g,v*p.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=y.Format.CSS.format(this)),this.u}static getLighterColor(m,p,v){if(m.isLighterThan(p))return m;v=v||.5;const M=m.getRelativeLuminance(),l=p.getRelativeLuminance();return v=v*(l-M)/l,m.lighten(v)}static getDarkerColor(m,p,v){if(m.isDarkerThan(p))return m;v=v||.5;const M=m.getRelativeLuminance(),l=p.getRelativeLuminance();return v=v*(M-l)/M,m.darken(v)}static{this.white=new y(new T(255,255,255,1))}static{this.black=new y(new T(0,0,0,1))}static{this.red=new y(new T(255,0,0,1))}static{this.blue=new y(new T(0,0,255,1))}static{this.green=new y(new T(0,255,0,1))}static{this.cyan=new y(new T(0,255,255,1))}static{this.lightgrey=new y(new T(211,211,211,1))}static{this.transparent=new y(new T(0,0,0,0))}}t.$rt=y,function(S){let m;(function(p){let v;(function(M){function l(u){return u.rgba.a===1?`rgb(${u.rgba.r}, ${u.rgba.g}, ${u.rgba.b})`:S.Format.CSS.formatRGBA(u)}M.formatRGB=l;function h(u){return`rgba(${u.rgba.r}, ${u.rgba.g}, ${u.rgba.b}, ${+u.rgba.a.toFixed(2)})`}M.formatRGBA=h;function e(u){return u.hsla.a===1?`hsl(${u.hsla.h}, ${(u.hsla.s*100).toFixed(2)}%, ${(u.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(u)}M.formatHSL=e;function s(u){return`hsla(${u.hsla.h}, ${(u.hsla.s*100).toFixed(2)}%, ${(u.hsla.l*100).toFixed(2)}%, ${u.hsla.a.toFixed(2)})`}M.formatHSLA=s;function f(u){const N=u.toString(16);return N.length!==2?"0"+N:N}function c(u){return`#${f(u.rgba.r)}${f(u.rgba.g)}${f(u.rgba.b)}`}M.formatHex=c;function a(u,N=!1){return N&&u.rgba.a===1?S.Format.CSS.formatHex(u):`#${f(u.rgba.r)}${f(u.rgba.g)}${f(u.rgba.b)}${f(Math.round(u.rgba.a*255))}`}M.formatHexA=a;function $(u){return u.isOpaque()?S.Format.CSS.formatHex(u):S.Format.CSS.formatRGBA(u)}M.format=$;function d(u){const N=u.length;if(N===0||u.charCodeAt(0)!==35)return null;if(N===7){const B=16*b(u.charCodeAt(1))+b(u.charCodeAt(2)),R=16*b(u.charCodeAt(3))+b(u.charCodeAt(4)),U=16*b(u.charCodeAt(5))+b(u.charCodeAt(6));return new S(new T(B,R,U,1))}if(N===9){const B=16*b(u.charCodeAt(1))+b(u.charCodeAt(2)),R=16*b(u.charCodeAt(3))+b(u.charCodeAt(4)),U=16*b(u.charCodeAt(5))+b(u.charCodeAt(6)),z=16*b(u.charCodeAt(7))+b(u.charCodeAt(8));return new S(new T(B,R,U,z/255))}if(N===4){const B=b(u.charCodeAt(1)),R=b(u.charCodeAt(2)),U=b(u.charCodeAt(3));return new S(new T(16*B+B,16*R+R,16*U+U))}if(N===5){const B=b(u.charCodeAt(1)),R=b(u.charCodeAt(2)),U=b(u.charCodeAt(3)),z=b(u.charCodeAt(4));return new S(new T(16*B+B,16*R+R,16*U+U,(16*z+z)/255))}return null}M.parseHex=d;function b(u){switch(u){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=p.CSS||(p.CSS={}))})(m=S.Format||(S.Format={}))}(y||(t.$rt=y={}))}),define(be[27],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eh=t.$Dh=t.$Ch=void 0;function E(y){return(S,m,p)=>{let v=null,M=null;if(typeof p.value=="function"?(v="value",M=p.value):typeof p.get=="function"&&(v="get",M=p.get),!M)throw new Error("not supported");p[v]=y(M,m)}}function T(y,S,m){let p=null,v=null;if(typeof m.value=="function"?(p="value",v=m.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(p="get",v=m.get),!v)throw new Error("not supported");const M=`$memoize$${S}`;m[p]=function(...l){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,l)}),this[M]}}t.$Ch=T;function n(y,S,m){return E((p,v)=>{const M=`$debounce$${v}`,l=`$debounce$result$${v}`;return function(...h){this[l]||(this[l]=m?m():void 0),clearTimeout(this[M]),S&&(this[l]=S(this[l],...h),h=[this[l]]),this[M]=setTimeout(()=>{p.apply(this,h),this[l]=m?m():void 0},y)}})}t.$Dh=n;function H(y,S,m){return E((p,v)=>{const M=`$throttle$timer$${v}`,l=`$throttle$result$${v}`,h=`$throttle$lastRun$${v}`,e=`$throttle$pending$${v}`;return function(...s){if(this[l]||(this[l]=m?m():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[l]=S(this[l],...s)),this[e])return;const f=this[h]+y;f<=Date.now()?(this[h]=Date.now(),p.apply(this,[this[l]]),this[l]=m?m():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),p.apply(this,[this[l]]),this[l]=m?m():void 0},f-Date.now()))}})}t.$Eh=H}),define(be[75],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3s=void 0;class E{constructor(n,H,y,S){this.originalStart=n,this.originalLength=H,this.modifiedStart=y,this.modifiedLength=S}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$3s=E}),define(be[6],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class E{constructor(){this.b=[],this.a=function(u){setTimeout(()=>{throw u.stack?$.isErrorNoTelemetry(u)?new $(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.b.push(u),()=>{this.d(u)}}c(u){this.b.forEach(N=>{N(u)})}d(u){this.b.splice(this.b.indexOf(u),1)}setUnexpectedErrorHandler(u){this.a=u}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(u){this.a(u),this.c(u)}onUnexpectedExternalError(u){this.a(u)}}t.$W=E,t.$X=new E;function T(b){t.$X.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=T;function n(b){if(!b||typeof b!="object")return!1;const u=b;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}t.$Z=n;function H(b){p(b)||t.$X.onUnexpectedError(b)}t.$1=H;function y(b){p(b)||t.$X.onUnexpectedExternalError(b)}t.$2=y;function S(b){if(b instanceof Error){const{name:u,message:N}=b,B=b.stacktrace||b.stack;return{$isError:!0,name:u,message:N,stack:B,noTelemetry:$.isErrorNoTelemetry(b)}}return b}t.$3=S;const m="Canceled";function p(b){return b instanceof v?!0:b instanceof Error&&b.name===m&&b.message===m}t.$4=p;class v extends Error{constructor(){super(m),this.name=this.message}}t.$5=v;function M(){const b=new Error(m);return b.name=b.message,b}t.$6=M;function l(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.$7=l;function h(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.$8=h;class e extends TypeError{constructor(u){super(u?`${u} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.$0=s;class f extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}t.$$=f;class c extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}t.$_=c;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=a;class $ extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof $)return u;const N=new $;return N.message=u.message,N.stack=u.stack,N}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}t.$bb=$;class d extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}t.$cb=d}),define(be[12],pe([1,0,6,72]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function n(q,g=0){return q[q.length-(1+g)]}t.$sb=n;function H(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}t.$tb=H;function y(q,g,k=(F,r)=>F===r){if(q===g)return!0;if(!q||!g||q.length!==g.length)return!1;for(let F=0,r=q.length;F<r;F++)if(!k(q[F],g[F]))return!1;return!0}t.$ub=y;function S(q,g){const k=q.length-1;g<k&&(q[g]=q[k]),q.pop()}t.$vb=S;function m(q,g,k){return p(q.length,F=>k(q[F],g))}t.$wb=m;function p(q,g){let k=0,F=q-1;for(;k<=F;){const r=(k+F)/2|0,i=g(r);if(i<0)k=r+1;else if(i>0)F=r-1;else return r}return-(k+1)}t.$xb=p;function v(q,g,k){if(q=q|0,q>=g.length)throw new TypeError("invalid index");const F=g[Math.floor(g.length*Math.random())],r=[],i=[],o=[];for(const w of g){const I=k(w,F);I<0?r.push(w):I>0?i.push(w):o.push(w)}return q<r.length?v(q,r,k):q<r.length+o.length?o[0]:v(q-(r.length+o.length),i,k)}t.$yb=v;function M(q,g){const k=[];let F;for(const r of q.slice(0).sort(g))!F||g(F[0],r)!==0?(F=[r],k.push(F)):F.push(r);return k}t.$zb=M;function*l(q,g){let k,F;for(const r of q)F!==void 0&&g(F,r)?k.push(r):(k&&(yield k),k=[r]),F=r;k&&(yield k)}t.$Ab=l;function h(q,g){for(let k=0;k<=q.length;k++)g(k===0?void 0:q[k-1],k===q.length?void 0:q[k])}t.$Bb=h;function e(q,g){for(let k=0;k<q.length;k++)g(k===0?void 0:q[k-1],q[k],k+1===q.length?void 0:q[k+1])}t.$Cb=e;function s(q,g,k){const F=[];function r(w,I,C){if(I===0&&C.length===0)return;const j=F[F.length-1];j&&j.start+j.deleteCount===w?(j.deleteCount+=I,j.toInsert.push(...C)):F.push({start:w,deleteCount:I,toInsert:C})}let i=0,o=0;for(;;){if(i===q.length){r(i,0,g.slice(o));break}if(o===g.length){r(i,q.length-i,[]);break}const w=q[i],I=g[o],C=k(w,I);C===0?(i+=1,o+=1):C<0?(r(i,1,[]),i+=1):C>0&&(r(i,0,[I]),o+=1)}return F}t.$Db=s;function f(q,g,k){const F=s(q,g,k),r=[],i=[];for(const o of F)r.push(...q.slice(o.start,o.start+o.deleteCount)),i.push(...o.toInsert);return{removed:r,added:i}}t.$Eb=f;function c(q,g,k){if(k===0)return[];const F=q.slice(0,k).sort(g);return $(q,g,F,k,q.length),F}t.top=c;function a(q,g,k,F,r){return k===0?Promise.resolve([]):new Promise((i,o)=>{(async()=>{const w=q.length,I=q.slice(0,k).sort(g);for(let C=k,j=Math.min(k+F,w);C<w;C=j,j=Math.min(j+F,w)){if(C>k&&await new Promise(_=>setTimeout(_)),r&&r.isCancellationRequested)throw new E.$5;$(q,g,I,C,j)}return I})().then(i,o)})}t.$Gb=a;function $(q,g,k,F,r){for(const i=k.length;F<r;F++){const o=q[F];if(g(o,k[i-1])<0){k.pop();const w=(0,T.$kb)(k,I=>g(o,I)<0);k.splice(w,0,o)}}}function d(q){return q.filter(g=>!!g)}t.$Hb=d;function b(q){let g=0;for(let k=0;k<q.length;k++)q[k]&&(q[g]=q[k],g+=1);q.length=g}t.$Ib=b;function u(q,g,k){q.splice(k,0,q.splice(g,1)[0])}t.$Jb=u;function N(q){return!Array.isArray(q)||q.length===0}t.$Kb=N;function B(q){return Array.isArray(q)&&q.length>0}t.$Lb=B;function R(q,g=k=>k){const k=new Set;return q.filter(F=>{const r=g(F);return k.has(r)?!1:(k.add(r),!0)})}t.$Mb=R;function U(q){const g=new Set;return k=>{const F=q(k);return g.has(F)?!1:(g.add(F),!0)}}t.$Nb=U;function z(q,g){return q.length>0?q[0]:g}t.$Ob=z;function D(q,g){return q.length>0?q[q.length-1]:g}t.$Pb=D;function O(q,g,k=(F,r)=>F===r){let F=0;for(let r=0,i=Math.min(q.length,g.length);r<i&&k(q[r],g[r]);r++)F++;return F}t.$Qb=O;function W(q){return[].concat(...q)}t.$Rb=W;function A(q,g){let k=typeof g=="number"?q:0;typeof g=="number"?k=q:(k=0,g=q);const F=[];if(k<=g)for(let r=k;r<g;r++)F.push(r);else for(let r=k;r>g;r--)F.push(r);return F}t.$Sb=A;function P(q,g,k){return q.reduce((F,r)=>(F[g(r)]=k?k(r):r,F),Object.create(null))}t.$Tb=P;function L(q,g){return q.push(g),()=>Y(q,g)}t.$Ub=L;function Y(q,g){const k=q.indexOf(g);if(k>-1)return q.splice(k,1),g}t.$Vb=Y;function X(q,g,k){const F=q.slice(0,g),r=q.slice(g);return F.concat(k,r)}t.$Wb=X;function de(q,g){let k;if(typeof g=="number"){let F=g;k=()=>{const r=Math.sin(F++)*179426549;return r-Math.floor(r)}}else k=Math.random;for(let F=q.length-1;F>0;F-=1){const r=Math.floor(k()*(F+1)),i=q[F];q[F]=q[r],q[r]=i}}t.$Xb=de;function ue(q,g){const k=q.indexOf(g);k>-1&&(q.splice(k,1),q.unshift(g))}t.$Yb=ue;function te(q,g){const k=q.indexOf(g);k>-1&&(q.splice(k,1),q.push(g))}t.$Zb=te;function ge(q,g){for(const k of g)q.push(k)}t.$1b=ge;function Pe(q,g){return Array.isArray(q)?q.map(g):g(q)}t.$2b=Pe;function Ne(q){return Array.isArray(q)?q:[q]}t.$3b=Ne;function Be(q){return q[Math.floor(Math.random()*q.length)]}t.$4b=Be;function le(q,g,k){const F=ae(q,g),r=q.length,i=k.length;q.length=r+i;for(let o=r-1;o>=F;o--)q[o+i]=q[o];for(let o=0;o<i;o++)q[o+F]=k[o]}t.$5b=le;function J(q,g,k,F){const r=ae(q,g);let i=q.splice(r,k);return i===void 0&&(i=[]),le(q,r,F),i}t.$6b=J;function ae(q,g){return g<0?Math.max(g+q.length,0):Math.min(g,q.length)}var re;(function(q){function g(i){return i<0}q.isLessThan=g;function k(i){return i<=0}q.isLessThanOrEqual=k;function F(i){return i>0}q.isGreaterThan=F;function r(i){return i===0}q.isNeitherLessOrGreaterThan=r,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function G(q,g){return(k,F)=>g(q(k),q(F))}t.$7b=G;function K(...q){return(g,k)=>{for(const F of q){const r=F(g,k);if(!re.isNeitherLessOrGreaterThan(r))return r}return re.neitherLessOrGreaterThan}}t.$8b=K;const ie=(q,g)=>q-g;t.$9b=ie;const fe=(q,g)=>(0,t.$9b)(q?1:0,g?1:0);t.$0b=fe;function ye(q){return(g,k)=>-q(g,k)}t.$$b=ye;class Ce{constructor(g){this.g=g,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(g){let k=this.c;for(;k<this.g.length&&g(this.g[k]);)k++;const F=k===this.c?null:this.g.slice(this.c,k);return this.c=k,F}takeFromEndWhile(g){let k=this.d;for(;k>=0&&g(this.g[k]);)k--;const F=k===this.d?null:this.g.slice(k+1,this.d+1);return this.d=k,F}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const g=this.g[this.c];return this.c++,g}removeLast(){const g=this.g[this.d];return this.d--,g}takeCount(g){const k=this.g.slice(this.c,this.c+g);return this.c+=g,k}}t.$_b=Ce;class Ae{static{this.empty=new Ae(g=>{})}constructor(g){this.iterate=g}forEach(g){this.iterate(k=>(g(k),!0))}toArray(){const g=[];return this.iterate(k=>(g.push(k),!0)),g}filter(g){return new Ae(k=>this.iterate(F=>g(F)?k(F):!0))}map(g){return new Ae(k=>this.iterate(F=>k(g(F))))}some(g){let k=!1;return this.iterate(F=>(k=g(F),!k)),k}findFirst(g){let k;return this.iterate(F=>g(F)?(k=F,!1):!0),k}findLast(g){let k;return this.iterate(F=>(g(F)&&(k=F),!0)),k}findLastMaxBy(g){let k,F=!0;return this.iterate(r=>((F||re.isGreaterThan(g(r,k)))&&(F=!1,k=r),!0)),k}}t.$ac=Ae}),define(be[76],pe([1,0,6]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.ok=void 0;function T(p,v){if(!p)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}t.ok=T;function n(p,v="Unreachable"){throw new Error(v)}t.$9c=n;function H(p){if(!p)throw new E.$cb("Assertion Failed")}t.$0c=H;function y(p){p||(0,E.$1)(new E.$cb("Assertion Failed"))}t.$$c=y;function S(p){if(!p()){debugger;p(),(0,E.$1)(new E.$cb("Assertion Failed"))}}t.$_c=S;function m(p,v){let M=0;for(;M<p.length-1;){const l=p[M],h=p[M+1];if(!v(l,h))return!1;M++}return!0}t.$ad=m}),define(be[44],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function E(T,n){const H=this;let y=!1,S;return function(){if(y)return S;if(y=!0,n)try{S=T.apply(H,arguments)}finally{n()}else S=T.apply(H,arguments);return S}}t.$db=E}),define(be[77],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PN=t.$ON=void 0;class E{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$ON=E,t.$PN=new E("id#")}),define(be[28],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(T){function n(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}T.is=n;const H=Object.freeze([]);function y(){return H}T.empty=y;function*S(u){yield u}T.single=S;function m(u){return n(u)?u:S(u)}T.wrap=m;function p(u){return u||H}T.from=p;function*v(u){for(let N=u.length-1;N>=0;N--)yield u[N]}T.reverse=v;function M(u){return!u||u[Symbol.iterator]().next().done===!0}T.isEmpty=M;function l(u){return u[Symbol.iterator]().next().value}T.first=l;function h(u,N){for(const B of u)if(N(B))return!0;return!1}T.some=h;function e(u,N){for(const B of u)if(N(B))return B}T.find=e;function*s(u,N){for(const B of u)N(B)&&(yield B)}T.filter=s;function*f(u,N){let B=0;for(const R of u)yield N(R,B++)}T.map=f;function*c(...u){for(const N of u)yield*N}T.concat=c;function a(u,N,B){let R=B;for(const U of u)R=N(R,U);return R}T.reduce=a;function*$(u,N,B=u.length){for(N<0&&(N+=u.length),B<0?B+=u.length:B>u.length&&(B=u.length);N<B;N++)yield u[N]}T.slice=$;function d(u,N=Number.POSITIVE_INFINITY){const B=[];if(N===0)return[B,u];const R=u[Symbol.iterator]();for(let U=0;U<N;U++){const z=R.next();if(z.done)return[B,T.empty()];B.push(z.value)}return[B,{[Symbol.iterator](){return R}}]}T.consume=d;async function b(u){const N=[];for await(const B of u)N.push(B);return Promise.resolve(N)}T.asyncToArray=b})(E||(t.Iterable=E={}))}),define(be[45],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_q=t.KeyMod=t.KeyCodeUtils=t.$$q=t.$0q=t.$9q=t.$8q=t.$7q=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(E||(t.KeyCode=E={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,f){this._keyCodeToStr[s]=f,this._strToKeyCode[f.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new n,y=new n,S=new n;t.$7q=new Array(230),t.$8q={};const m=[],p=Object.create(null),v=Object.create(null);t.$9q={lowerCaseToEnum:e=>v[e]||0,toEnum:e=>p[e]||0,toString:e=>m[e]||"None"},t.$0q=[],t.$$q=[];for(let e=0;e<=193;e++)t.$0q[e]=-1;for(let e=0;e<=132;e++)t.$$q[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],f=[],c=[];for(const a of s){const[$,d,b,u,N,B,R,U,z]=a;if(c[d]||(c[d]=!0,m[d]=b,p[b]=d,v[b.toLowerCase()]=d,$&&(t.$0q[d]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(t.$$q[u]=d))),!f[u]){if(f[u]=!0,!N)throw new Error(`String representation missing for key code ${u} around scan code ${b}`);H.define(u,N),y.define(u,U||N),S.define(u,z||U||N)}B&&(t.$7q[B]=u),R&&(t.$8q[R]=u)}t.$$q[3]=46})();var M;(function(e){function s(b){return H.keyCodeToStr(b)}e.toString=s;function f(b){return H.strToKeyCode(b)}e.fromString=f;function c(b){return y.keyCodeToStr(b)}e.toUserSettingsUS=c;function a(b){return S.keyCodeToStr(b)}e.toUserSettingsGeneral=a;function $(b){return y.strToKeyCode(b)||S.strToKeyCode(b)}e.fromUserSettings=$;function d(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(b)}e.toElectronAccelerator=d})(M||(t.KeyCodeUtils=M={}));var l;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(l||(t.KeyMod=l={}));function h(e,s){const f=(s&65535)<<16>>>0;return(e|f)>>>0}t.$_q=h}),define(be[78],pe([1,0,6]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gr=t.$fr=t.$er=t.$dr=t.$cr=t.$br=t.$ar=void 0;var T;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(T||(T={}));function n(M,l){if(typeof M=="number"){if(M===0)return null;const h=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new m([H(h,l),H(e,l)]):new m([H(h,l)])}else{const h=[];for(let e=0;e<M.length;e++)h.push(H(M[e],l));return new m(h)}}t.$ar=n;function H(M,l){const h=!!(M&2048),e=!!(M&256),s=l===2?e:h,f=!!(M&1024),c=!!(M&512),a=l===2?h:e,$=M&255;return new y(s,f,c,a,$)}t.$br=H;class y{constructor(l,h,e,s,f){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.keyCode=f}equals(l){return l instanceof y&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${l}${h}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$cr=y;class S{constructor(l,h,e,s,f){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.scanCode=f}equals(l){return l instanceof S&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}getHashCode(){const l=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${l}${h}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$dr=S;class m{constructor(l){if(l.length===0)throw(0,E.$7)("chords");this.chords=l}getHashCode(){let l="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(l+=";"),l+=this.chords[h].getHashCode();return l}equals(l){if(l===null||this.chords.length!==l.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(l.chords[h]))return!1;return!0}}t.$er=m;class p{constructor(l,h,e,s,f,c){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.keyLabel=f,this.keyAriaLabel=c}}t.$fr=p;class v{}t.$gr=v}),define(be[23],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class E{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=E}),define(be[46],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class E{static{this.Undefined=new E(void 0)}constructor(H){this.element=H,this.next=E.Undefined,this.prev=E.Undefined}}class T{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let H=this.a;for(;H!==E.Undefined;){const y=H.next;H.prev=E.Undefined,H.next=E.Undefined,H=y}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,y){const S=new E(H);if(this.a===E.Undefined)this.a=S,this.b=S;else if(y){const p=this.b;this.b=S,S.prev=p,p.next=S}else{const p=this.a;this.a=S,S.next=p,p.prev=S}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(S))}}shift(){if(this.a!==E.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==E.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==E.Undefined&&H.next!==E.Undefined){const y=H.prev;y.next=H.next,H.next.prev=y}else H.prev===E.Undefined&&H.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):H.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):H.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==E.Undefined;)yield H.element,H=H.next}}t.$4c=T}),define(be[32],pe([1,0]),function(se,t){"use strict";var E,T,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function H($,d,b){let u=$.get(d);return u===void 0&&(u=b,$.set(d,u)),u}t.$xc=H;function y($){const d=[];return $.forEach((b,u)=>{d.push(`${u} => ${b}`)}),`Map(${$.size}) {${d.join(", ")}}`}t.$yc=y;function S($){const d=[];return $.forEach(b=>{d.push(b)}),`Set(${$.size}) {${d.join(", ")}}`}t.$zc=S;class m{constructor(d,b){this.uri=d,this.value=b}}function p($){return Array.isArray($)}class v{static{this.c=d=>d.toString()}constructor(d,b){if(this[E]="ResourceMap",d instanceof v)this.d=new Map(d.d),this.e=b??v.c;else if(p(d)){this.d=new Map,this.e=b??v.c;for(const[u,N]of d)this.set(u,N)}else this.d=new Map,this.e=d??v.c}set(d,b){return this.d.set(this.e(d),new m(d,b)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,b){typeof b<"u"&&(d=d.bind(b));for(const[u,N]of this.d)d(N.value,N.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}t.$Ac=v;class M{constructor(d,b){this[T]="ResourceSet",!d||typeof d=="function"?this.c=new v(d):(this.c=new v(b),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,b){this.c.forEach((u,N)=>d.call(b,N,N,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=M;var l;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(l||(t.Touch=l={}));class h{constructor(){this[n]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,b=0){const u=this.c.get(d);if(u)return b!==0&&this.l(u,b),u.value}set(d,b,u=0){let N=this.c.get(d);if(N)N.value=b,u!==0&&this.l(N,u);else{switch(N={key:d,value:b,next:void 0,previous:void 0},u){case 0:this.j(N);break;case 1:this.i(N);break;case 2:this.j(N);break;default:this.j(N);break}this.c.set(d,N),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const b=this.c.get(d);if(b)return this.c.delete(d),this.k(b),this.f--,b.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.k(d),this.f--,d.value}forEach(d,b){const u=this.g;let N=this.d;for(;N;){if(b?d.bind(b)(N.value,N.key,this):d(N.value,N.key,this),this.g!==u)throw new Error("LinkedMap got modified during iteration.");N=N.next}}keys(){const d=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(d.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:u.key,done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}values(){const d=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(d.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:u.value,done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}entries(){const d=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(d.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:[u.key,u.value],done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let b=this.d,u=this.size;for(;b&&u>d;)this.c.delete(b.key),b=b.next,u--;this.d=b,this.f=u,b&&(b.previous=void 0),this.g++}i(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}j(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}k(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const b=d.next,u=d.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}d.next=void 0,d.previous=void 0,this.g++}l(d,b){if(!this.d||!this.e)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(d===this.d)return;const u=d.next,N=d.previous;d===this.e?(N.next=void 0,this.e=N):(u.previous=N,N.next=u),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(b===2){if(d===this.e)return;const u=d.next,N=d.previous;d===this.d?(u.previous=void 0,this.d=u):(u.previous=N,N.next=u),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((b,u)=>{d.push([u,b])}),d}fromJSON(d){this.clear();for(const[b,u]of d)this.set(b,u)}}t.$Cc=h;class e extends h{constructor(d,b=1){super(),this.m=d,this.n=Math.min(Math.max(0,b),1)}get limit(){return this.m}set limit(d){this.m=d,this.o()}get ratio(){return this.n}set ratio(d){this.n=Math.min(Math.max(0,d),1),this.o()}get(d,b=2){return super.get(d,b)}peek(d){return super.get(d,0)}set(d,b){return super.set(d,b,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class s{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let b=this.c.get(d)||0;return b===0?!1:(b--,b===0?this.c.delete(d):this.c.set(d,b),!0)}has(d){return this.c.has(d)}}t.$Ec=s;class f{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[b,u]of d)this.set(b,u)}clear(){this.c.clear(),this.d.clear()}set(d,b){this.c.set(d,b),this.d.set(b,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const b=this.c.get(d);return b===void 0?!1:(this.c.delete(d),this.d.delete(b),!0)}forEach(d,b){this.c.forEach((u,N)=>{d.call(b,u,N,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=f;class c{constructor(){this.c=new Map}add(d,b){let u=this.c.get(d);u||(u=new Set,this.c.set(d,u)),u.add(b)}delete(d,b){const u=this.c.get(d);u&&(u.delete(b),u.size===0&&this.c.delete(d))}forEach(d,b){const u=this.c.get(d);u&&u.forEach(b)}get(d){const b=this.c.get(d);return b||new Set}}t.$Gc=c;function a($,d){if($===d)return!0;if($.size!==d.size)return!1;for(const[b,u]of $)if(!d.has(b)||d.get(b)!==u)return!1;for(const[b]of d)if(!$.has(b))return!1;return!0}t.$Hc=a}),define(be[3],pe([1,0,12,73,32,44,28]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const S=!1;let m=null;class p{constructor(){this.b=new Map}static{this.a=0}c(L){let Y=this.b.get(L);return Y||(Y={parent:null,source:null,isSingleton:!1,value:L,idx:p.a++},this.b.set(L,Y)),Y}trackDisposable(L){const Y=this.c(L);Y.source||(Y.source=new Error().stack)}setParent(L,Y){const X=this.c(L);X.parent=Y}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,Y){const X=Y.get(L);if(X)return X;const de=L.parent?this.f(this.c(L.parent),Y):L;return Y.set(L,de),de}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,X])=>X.source!==null&&!this.f(X,L).isSingleton).flatMap(([X])=>X)}computeLeakingDisposables(L=10,Y){let X;if(Y)X=Y;else{const Pe=new Map,Ne=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,Pe).isSingleton);if(Ne.length===0)return;const Be=new Set(Ne.map(le=>le.value));if(X=Ne.filter(le=>!(le.parent&&Be.has(le.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function de(Pe){function Ne(le,J){for(;le.length>0&&J.some(ae=>typeof ae=="string"?ae===le[0]:le[0].match(ae));)le.shift()}const Be=Pe.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ne(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const ue=new n.$Gc;for(const Pe of X){const Ne=de(Pe);for(let Be=0;Be<=Ne.length;Be++)ue.add(Ne.slice(0,Be).join(`
`),Pe)}X.sort((0,E.$7b)(Pe=>Pe.idx,E.$9b));let te="",ge=0;for(const Pe of X.slice(0,L)){ge++;const Ne=de(Pe),Be=[];for(let le=0;le<Ne.length;le++){let J=Ne[le];J=`(shared with ${ue.get(Ne.slice(0,le+1).join(`
`)).size}/${X.length} leaks) at ${J}`;const re=ue.get(Ne.slice(0,le).join(`
`)),G=(0,T.$K)([...re].map(K=>de(K)[le]),K=>K);delete G[Ne[le]];for(const[K,ie]of Object.entries(G))Be.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${K}`);Be.unshift(J)}te+=`


==================== Leaking disposable ${ge}/${X.length}: ${Pe.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return X.length>L&&(te+=`


... and ${X.length-L} more leaking disposables

`),{leaks:X,details:te}}}t.$Ic=p;function v(P){m=P}if(t.$Jc=v,S){const P="__is_disposable_tracked__";v(new class{trackDisposable(L){const Y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[P]||console.log(Y)},3e3)}setParent(L,Y){if(L&&L!==u.None)try{L[P]=!0}catch{}}markAsDisposed(L){if(L&&L!==u.None)try{L[P]=!0}catch{}}markAsSingleton(L){}})}function M(P){return m?.trackDisposable(P),P}t.$Kc=M;function l(P){m?.markAsDisposed(P)}t.$Lc=l;function h(P,L){m?.setParent(P,L)}function e(P,L){if(m)for(const Y of P)m.setParent(Y,L)}function s(P){return m?.markAsSingleton(P),P}t.$Mc=s;function f(P){return typeof P.dispose=="function"&&P.dispose.length===0}t.$Nc=f;function c(P){if(y.Iterable.is(P)){const L=[];for(const Y of P)if(Y)try{Y.dispose()}catch(X){L.push(X)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}t.$Oc=c;function a(P){for(const L of P)f(L)&&L.dispose();return[]}t.$Pc=a;function $(...P){const L=d(()=>c(P));return e(P,L),L}t.$Qc=$;function d(P){const L=M({dispose:(0,H.$db)(()=>{l(L),P()})});return L}t.$Rc=d;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,M(this)}dispose(){this.g||(l(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return h(L,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),h(L,null))}}t.$Sc=b;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,M(this),h(this.q,this)}dispose(){l(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}t.$Tc=u;class N{constructor(){this.b=!1,M(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&h(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&h(L,null),L}}t.$Uc=N;class B{constructor(L){this.a=new N,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=B;class R{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=R;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,M(this)}set(L){let Y=L;return this.unset=()=>Y=void 0,this.isset=()=>Y!==void 0,this.dispose=()=>{Y&&(Y(),Y=void 0,l(this))},this}}t.$Xc=U;class z{constructor(){this.a=new Map}acquire(L,...Y){let X=this.a.get(L);X||(X={counter:0,object:this.b(L,...Y)},this.a.set(L,X));const{object:de}=X,ue=(0,H.$db)(()=>{--X.counter===0&&(this.c(L,X.object),this.a.delete(L))});return X.counter++,{object:de,dispose:ue}}}t.$Yc=z;class D{constructor(L){this.a=L}async acquire(L,...Y){const X=this.a.acquire(L,...Y);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(de){throw X.dispose(),de}}}t.$Zc=D;class O{constructor(L){this.object=L}dispose(){}}t.$1c=O;function W(P){const L=new b;try{P(L)}finally{L.dispose()}}t.$2c=W;class A{constructor(){this.a=new Map,this.b=!1,M(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,Y,X=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this.a.get(L)?.dispose(),this.a.set(L,Y)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=A}),function(se,t){typeof define=="function"&&define.amd?define(be[79],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(g,k){for(var F=0;F<k.length;F++){var r=k[F];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(g,r.key,r)}}function E(g,k,F){return k&&t(g.prototype,k),F&&t(g,F),Object.defineProperty(g,"prototype",{writable:!1}),g}function T(g,k){if(g){if(typeof g=="string")return n(g,k);var F=Object.prototype.toString.call(g).slice(8,-1);if(F==="Object"&&g.constructor&&(F=g.constructor.name),F==="Map"||F==="Set")return Array.from(g);if(F==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(F))return n(g,k)}}function n(g,k){(k==null||k>g.length)&&(k=g.length);for(var F=0,r=new Array(k);F<k;F++)r[F]=g[F];return r}function H(g,k){var F=typeof Symbol<"u"&&g[Symbol.iterator]||g["@@iterator"];if(F)return(F=F.call(g)).next.bind(F);if(Array.isArray(g)||(F=T(g))||k&&g&&typeof g.length=="number"){F&&(g=F);var r=0;return function(){return r>=g.length?{done:!0}:{done:!1,value:g[r++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=y();function S(g){se.defaults=g}var m=/[&<>"']/,p=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(k){return l[k]};function e(g,k){if(k){if(m.test(g))return g.replace(p,h)}else if(v.test(g))return g.replace(M,h);return g}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(g){return g.replace(s,function(k,F){return F=F.toLowerCase(),F==="colon"?":":F.charAt(0)==="#"?F.charAt(1)==="x"?String.fromCharCode(parseInt(F.substring(2),16)):String.fromCharCode(+F.substring(1)):""})}var c=/(^|[^\[])\^/g;function a(g,k){g=typeof g=="string"?g:g.source,k=k||"";var F={replace:function(i,o){return o=o.source||o,o=o.replace(c,"$1"),g=g.replace(i,o),F},getRegex:function(){return new RegExp(g,k)}};return F}var $=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(g,k,F){if(g){var r;try{r=decodeURIComponent(f(F)).replace($,"").toLowerCase()}catch{return null}if(r.indexOf("javascript:")===0||r.indexOf("vbscript:")===0||r.indexOf("data:")===0)return null}k&&!d.test(F)&&(F=U(k,F));try{F=encodeURI(F).replace(/%25/g,"%")}catch{return null}return F}var u={},N=/^[^:]+:\/*[^/]*$/,B=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function U(g,k){u[" "+g]||(N.test(g)?u[" "+g]=g+"/":u[" "+g]=W(g,"/",!0)),g=u[" "+g];var F=g.indexOf(":")===-1;return k.substring(0,2)==="//"?F?k:g.replace(B,"$1")+k:k.charAt(0)==="/"?F?k:g.replace(R,"$1")+k:g+k}var z={exec:function(){}};function D(g){for(var k=1,F,r;k<arguments.length;k++){F=arguments[k];for(r in F)Object.prototype.hasOwnProperty.call(F,r)&&(g[r]=F[r])}return g}function O(g,k){var F=g.replace(/\|/g,function(o,w,I){for(var C=!1,j=w;--j>=0&&I[j]==="\\";)C=!C;return C?"|":" |"}),r=F.split(/ \|/),i=0;if(r[0].trim()||r.shift(),r.length>0&&!r[r.length-1].trim()&&r.pop(),r.length>k)r.splice(k);else for(;r.length<k;)r.push("");for(;i<r.length;i++)r[i]=r[i].trim().replace(/\\\|/g,"|");return r}function W(g,k,F){var r=g.length;if(r===0)return"";for(var i=0;i<r;){var o=g.charAt(r-i-1);if(o===k&&!F)i++;else if(o!==k&&F)i++;else break}return g.slice(0,r-i)}function A(g,k){if(g.indexOf(k[1])===-1)return-1;for(var F=g.length,r=0,i=0;i<F;i++)if(g[i]==="\\")i++;else if(g[i]===k[0])r++;else if(g[i]===k[1]&&(r--,r<0))return i;return-1}function P(g){g&&g.sanitize&&!g.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(g,k){if(k<1)return"";for(var F="";k>1;)k&1&&(F+=g),k>>=1,g+=g;return F+g}function Y(g,k,F,r){var i=k.href,o=k.title?e(k.title):null,w=g[1].replace(/\\([\[\]])/g,"$1");if(g[0].charAt(0)!=="!"){r.state.inLink=!0;var I={type:"link",raw:F,href:i,title:o,text:w,tokens:r.inlineTokens(w)};return r.state.inLink=!1,I}return{type:"image",raw:F,href:i,title:o,text:e(w)}}function X(g,k){var F=g.match(/^(\s+)(?:```)/);if(F===null)return k;var r=F[1];return k.split(`
`).map(function(i){var o=i.match(/^\s+/);if(o===null)return i;var w=o[0];return w.length>=r.length?i.slice(r.length):i}).join(`
`)}var de=function(){function g(F){this.options=F||se.defaults}var k=g.prototype;return k.space=function(r){var i=this.rules.block.newline.exec(r);if(i&&i[0].length>0)return{type:"space",raw:i[0]}},k.code=function(r){var i=this.rules.block.code.exec(r);if(i){var o=i[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:i[0],codeBlockStyle:"indented",text:this.options.pedantic?o:W(o,`
`)}}},k.fences=function(r){var i=this.rules.block.fences.exec(r);if(i){var o=i[0],w=X(o,i[3]||"");return{type:"code",raw:o,lang:i[2]?i[2].trim():i[2],text:w}}},k.heading=function(r){var i=this.rules.block.heading.exec(r);if(i){var o=i[2].trim();if(/#$/.test(o)){var w=W(o,"#");(this.options.pedantic||!w||/ $/.test(w))&&(o=w.trim())}return{type:"heading",raw:i[0],depth:i[1].length,text:o,tokens:this.lexer.inline(o)}}},k.hr=function(r){var i=this.rules.block.hr.exec(r);if(i)return{type:"hr",raw:i[0]}},k.blockquote=function(r){var i=this.rules.block.blockquote.exec(r);if(i){var o=i[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:i[0],tokens:this.lexer.blockTokens(o,[]),text:o}}},k.list=function(r){var i=this.rules.block.list.exec(r);if(i){var o,w,I,C,j,_,Z,oe,me,De,ve,Se,we=i[1].trim(),Te=we.length>1,Ie={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var Me=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");r&&(Se=!1,!(!(i=Me.exec(r))||this.rules.block.hr.test(r)));){if(o=i[0],r=r.substring(o.length),oe=i[2].split(`
`,1)[0],me=r.split(`
`,1)[0],this.options.pedantic?(C=2,ve=oe.trimLeft()):(C=i[2].search(/[^ ]/),C=C>4?1:C,ve=oe.slice(C),C+=i[1].length),_=!1,!oe&&/^ *$/.test(me)&&(o+=me+`
`,r=r.substring(me.length+1),Se=!0),!Se)for(var Xe=new RegExp("^ {0,"+Math.min(3,C-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,C-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ke=new RegExp("^ {0,"+Math.min(3,C-1)+"}(?:```|~~~)"),Ze=new RegExp("^ {0,"+Math.min(3,C-1)+"}#");r&&(De=r.split(`
`,1)[0],oe=De,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ke.test(oe)||Ze.test(oe)||Xe.test(oe)||nt.test(r)));){if(oe.search(/[^ ]/)>=C||!oe.trim())ve+=`
`+oe.slice(C);else if(!_)ve+=`
`+oe;else break;!_&&!oe.trim()&&(_=!0),o+=De+`
`,r=r.substring(De.length+1)}Ie.loose||(Z?Ie.loose=!0:/\n *\n *$/.test(o)&&(Z=!0)),this.options.gfm&&(w=/^\[[ xX]\] /.exec(ve),w&&(I=w[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:o,task:!!w,checked:I,loose:!1,text:ve}),Ie.raw+=o}Ie.items[Ie.items.length-1].raw=o.trimRight(),Ie.items[Ie.items.length-1].text=ve.trimRight(),Ie.raw=Ie.raw.trimRight();var x=Ie.items.length;for(j=0;j<x;j++){this.lexer.state.top=!1,Ie.items[j].tokens=this.lexer.blockTokens(Ie.items[j].text,[]);var ne=Ie.items[j].tokens.filter(function(Ee){return Ee.type==="space"}),$e=ne.every(function(Ee){for(var Re=Ee.raw.split(""),je=0,Qe=H(Re),Je;!(Je=Qe()).done;){var tt=Je.value;if(tt===`
`&&(je+=1),je>1)return!0}return!1});!Ie.loose&&ne.length&&$e&&(Ie.loose=!0,Ie.items[j].loose=!0)}return Ie}},k.html=function(r){var i=this.rules.block.html.exec(r);if(i){var o={type:"html",raw:i[0],pre:!this.options.sanitizer&&(i[1]==="pre"||i[1]==="script"||i[1]==="style"),text:i[0]};if(this.options.sanitize){var w=this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]);o.type="paragraph",o.text=w,o.tokens=this.lexer.inline(w)}return o}},k.def=function(r){var i=this.rules.block.def.exec(r);if(i){i[3]&&(i[3]=i[3].substring(1,i[3].length-1));var o=i[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:o,raw:i[0],href:i[2],title:i[3]}}},k.table=function(r){var i=this.rules.block.table.exec(r);if(i){var o={type:"table",header:O(i[1]).map(function(Z){return{text:Z}}),align:i[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:i[3]&&i[3].trim()?i[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(o.header.length===o.align.length){o.raw=i[0];var w=o.align.length,I,C,j,_;for(I=0;I<w;I++)/^ *-+: *$/.test(o.align[I])?o.align[I]="right":/^ *:-+: *$/.test(o.align[I])?o.align[I]="center":/^ *:-+ *$/.test(o.align[I])?o.align[I]="left":o.align[I]=null;for(w=o.rows.length,I=0;I<w;I++)o.rows[I]=O(o.rows[I],o.header.length).map(function(Z){return{text:Z}});for(w=o.header.length,C=0;C<w;C++)o.header[C].tokens=this.lexer.inline(o.header[C].text);for(w=o.rows.length,C=0;C<w;C++)for(_=o.rows[C],j=0;j<_.length;j++)_[j].tokens=this.lexer.inline(_[j].text);return o}}},k.lheading=function(r){var i=this.rules.block.lheading.exec(r);if(i)return{type:"heading",raw:i[0],depth:i[2].charAt(0)==="="?1:2,text:i[1],tokens:this.lexer.inline(i[1])}},k.paragraph=function(r){var i=this.rules.block.paragraph.exec(r);if(i){var o=i[1].charAt(i[1].length-1)===`
`?i[1].slice(0,-1):i[1];return{type:"paragraph",raw:i[0],text:o,tokens:this.lexer.inline(o)}}},k.text=function(r){var i=this.rules.block.text.exec(r);if(i)return{type:"text",raw:i[0],text:i[0],tokens:this.lexer.inline(i[0])}},k.escape=function(r){var i=this.rules.inline.escape.exec(r);if(i)return{type:"escape",raw:i[0],text:e(i[1])}},k.tag=function(r){var i=this.rules.inline.tag.exec(r);if(i)return!this.lexer.state.inLink&&/^<a /i.test(i[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(i[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(i[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(i[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:i[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]):i[0]}},k.link=function(r){var i=this.rules.inline.link.exec(r);if(i){var o=i[2].trim();if(!this.options.pedantic&&/^</.test(o)){if(!/>$/.test(o))return;var w=W(o.slice(0,-1),"\\");if((o.length-w.length)%2===0)return}else{var I=A(i[2],"()");if(I>-1){var C=i[0].indexOf("!")===0?5:4,j=C+i[1].length+I;i[2]=i[2].substring(0,I),i[0]=i[0].substring(0,j).trim(),i[3]=""}}var _=i[2],Z="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(_);oe&&(_=oe[1],Z=oe[3])}else Z=i[3]?i[3].slice(1,-1):"";return _=_.trim(),/^</.test(_)&&(this.options.pedantic&&!/>$/.test(o)?_=_.slice(1):_=_.slice(1,-1)),Y(i,{href:_&&_.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},i[0],this.lexer)}},k.reflink=function(r,i){var o;if((o=this.rules.inline.reflink.exec(r))||(o=this.rules.inline.nolink.exec(r))){var w=(o[2]||o[1]).replace(/\s+/g," ");if(w=i[w.toLowerCase()],!w||!w.href){var I=o[0].charAt(0);return{type:"text",raw:I,text:I}}return Y(o,w,o[0],this.lexer)}},k.emStrong=function(r,i,o){o===void 0&&(o="");var w=this.rules.inline.emStrong.lDelim.exec(r);if(w&&!(w[3]&&o.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=w[1]||w[2]||"";if(!I||I&&(o===""||this.rules.inline.punctuation.exec(o))){var C=w[0].length-1,j,_,Z=C,oe=0,me=w[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,i=i.slice(-1*r.length+C);(w=me.exec(i))!=null;)if(j=w[1]||w[2]||w[3]||w[4]||w[5]||w[6],!!j){if(_=j.length,w[3]||w[4]){Z+=_;continue}else if((w[5]||w[6])&&C%3&&!((C+_)%3)){oe+=_;continue}if(Z-=_,!(Z>0)){if(_=Math.min(_,_+Z+oe),Math.min(C,_)%2){var De=r.slice(1,C+w.index+_);return{type:"em",raw:r.slice(0,C+w.index+_+1),text:De,tokens:this.lexer.inlineTokens(De)}}var ve=r.slice(2,C+w.index+_-1);return{type:"strong",raw:r.slice(0,C+w.index+_+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},k.codespan=function(r){var i=this.rules.inline.code.exec(r);if(i){var o=i[2].replace(/\n/g," "),w=/[^ ]/.test(o),I=/^ /.test(o)&&/ $/.test(o);return w&&I&&(o=o.substring(1,o.length-1)),o=e(o,!0),{type:"codespan",raw:i[0],text:o}}},k.br=function(r){var i=this.rules.inline.br.exec(r);if(i)return{type:"br",raw:i[0]}},k.del=function(r){var i=this.rules.inline.del.exec(r);if(i)return{type:"del",raw:i[0],text:i[2],tokens:this.lexer.inlineTokens(i[2])}},k.autolink=function(r,i){var o=this.rules.inline.autolink.exec(r);if(o){var w,I;return o[2]==="@"?(w=e(this.options.mangle?i(o[1]):o[1]),I="mailto:"+w):(w=e(o[1]),I=w),{type:"link",raw:o[0],text:w,href:I,tokens:[{type:"text",raw:w,text:w}]}}},k.url=function(r,i){var o;if(o=this.rules.inline.url.exec(r)){var w,I;if(o[2]==="@")w=e(this.options.mangle?i(o[0]):o[0]),I="mailto:"+w;else{var C;do C=o[0],o[0]=this.rules.inline._backpedal.exec(o[0])[0];while(C!==o[0]);w=e(o[0]),o[1]==="www."?I="http://"+w:I=w}return{type:"link",raw:o[0],text:w,href:I,tokens:[{type:"text",raw:w,text:w}]}}},k.inlineText=function(r,i){var o=this.rules.inline.text.exec(r);if(o){var w;return this.lexer.state.inRawBlock?w=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(o[0]):e(o[0]):o[0]:w=e(this.options.smartypants?i(o[0]):o[0]),{type:"text",raw:o[0],text:w}}},g}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=a(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=a(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=a(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=a(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=a(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=a(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=D({},ue),ue.gfm=D({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=a(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=a(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=D({},ue.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:a(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=a(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=a(ue._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=a(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=a(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=a(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=a(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=a(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=a(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=a(te.reflink).replace("label",te._label).replace("ref",ue._label).getRegex(),te.nolink=a(te.nolink).replace("ref",ue._label).getRegex(),te.reflinkSearch=a(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=D({},te),te.pedantic=D({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=D({},te.normal,{escape:a(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=a(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=D({},te.gfm,{br:a(te.br).replace("{2,}","*").getRegex(),text:a(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(g){return g.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Pe(g){var k="",F,r,i=g.length;for(F=0;F<i;F++)r=g.charCodeAt(F),Math.random()>.5&&(r="x"+r.toString(16)),k+="&#"+r+";";return k}var Ne=function(){function g(F){this.tokens=[],this.tokens.links=Object.create(null),this.options=F||se.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var r={block:ue.normal,inline:te.normal};this.options.pedantic?(r.block=ue.pedantic,r.inline=te.pedantic):this.options.gfm&&(r.block=ue.gfm,this.options.breaks?r.inline=te.breaks:r.inline=te.gfm),this.tokenizer.rules=r}g.lex=function(r,i){var o=new g(i);return o.lex(r)},g.lexInline=function(r,i){var o=new g(i);return o.inlineTokens(r)};var k=g.prototype;return k.lex=function(r){r=r.replace(/\r\n|\r/g,`
`),this.blockTokens(r,this.tokens);for(var i;i=this.inlineQueue.shift();)this.inlineTokens(i.src,i.tokens);return this.tokens},k.blockTokens=function(r,i){var o=this;i===void 0&&(i=[]),this.options.pedantic?r=r.replace(/\t/g,"    ").replace(/^ +$/gm,""):r=r.replace(/^( *)(\t+)/gm,function(Z,oe,me){return oe+"    ".repeat(me.length)});for(var w,I,C,j;r;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(w=Z.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.space(r)){r=r.substring(w.raw.length),w.raw.length===1&&i.length>0?i[i.length-1].raw+=`
`:i.push(w);continue}if(w=this.tokenizer.code(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(w);continue}if(w=this.tokenizer.fences(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.heading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.hr(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.blockquote(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.list(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.html(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.def(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+w.raw,I.text+=`
`+w.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[w.tag]||(this.tokens.links[w.tag]={href:w.href,title:w.title});continue}if(w=this.tokenizer.table(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.lheading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(C=r,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,oe=r.slice(1),me=void 0;o.options.extensions.startBlock.forEach(function(De){me=De.call({lexer:this},oe),typeof me=="number"&&me>=0&&(Z=Math.min(Z,me))}),Z<1/0&&Z>=0&&(C=r.substring(0,Z+1))}(),this.state.top&&(w=this.tokenizer.paragraph(C))){I=i[i.length-1],j&&I.type==="paragraph"?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(w),j=C.length!==r.length,r=r.substring(w.raw.length);continue}if(w=this.tokenizer.text(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&I.type==="text"?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(w);continue}if(r){var _="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(_);break}else throw new Error(_)}}return this.state.top=!0,i},k.inline=function(r,i){return i===void 0&&(i=[]),this.inlineQueue.push({src:r,tokens:i}),i},k.inlineTokens=function(r,i){var o=this;i===void 0&&(i=[]);var w,I,C,j=r,_,Z,oe;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(_=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)me.includes(_[0].slice(_[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,_.index)+"["+L("a",_[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(_=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,_.index)+"["+L("a",_[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(_=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,_.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;r;)if(Z||(oe=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(w=ve.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.escape(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.tag(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&w.type==="text"&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):i.push(w);continue}if(w=this.tokenizer.link(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.reflink(r,this.tokens.links)){r=r.substring(w.raw.length),I=i[i.length-1],I&&w.type==="text"&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):i.push(w);continue}if(w=this.tokenizer.emStrong(r,j,oe)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.codespan(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.br(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.del(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.autolink(r,Pe)){r=r.substring(w.raw.length),i.push(w);continue}if(!this.state.inLink&&(w=this.tokenizer.url(r,Pe))){r=r.substring(w.raw.length),i.push(w);continue}if(C=r,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Se=r.slice(1),we=void 0;o.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},Se),typeof we=="number"&&we>=0&&(ve=Math.min(ve,we))}),ve<1/0&&ve>=0&&(C=r.substring(0,ve+1))}(),w=this.tokenizer.inlineText(C,ge)){r=r.substring(w.raw.length),w.raw.slice(-1)!=="_"&&(oe=w.raw.slice(-1)),Z=!0,I=i[i.length-1],I&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):i.push(w);continue}if(r){var De="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(De);break}else throw new Error(De)}}return i},E(g,null,[{key:"rules",get:function(){return{block:ue,inline:te}}}]),g}(),Be=function(){function g(F){this.options=F||se.defaults}var k=g.prototype;return k.code=function(r,i,o){var w=(i||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(r,w);I!=null&&I!==r&&(o=!0,r=I)}return r=r.replace(/\n$/,"")+`
`,w?'<pre><code class="'+this.options.langPrefix+e(w,!0)+'">'+(o?r:e(r,!0))+`</code></pre>
`:"<pre><code>"+(o?r:e(r,!0))+`</code></pre>
`},k.blockquote=function(r){return`<blockquote>
`+r+`</blockquote>
`},k.html=function(r){return r},k.heading=function(r,i,o,w){if(this.options.headerIds){var I=this.options.headerPrefix+w.slug(o);return"<h"+i+' id="'+I+'">'+r+"</h"+i+`>
`}return"<h"+i+">"+r+"</h"+i+`>
`},k.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},k.list=function(r,i,o){var w=i?"ol":"ul",I=i&&o!==1?' start="'+o+'"':"";return"<"+w+I+`>
`+r+"</"+w+`>
`},k.listitem=function(r){return"<li>"+r+`</li>
`},k.checkbox=function(r){return"<input "+(r?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},k.paragraph=function(r){return"<p>"+r+`</p>
`},k.table=function(r,i){return i&&(i="<tbody>"+i+"</tbody>"),`<table>
<thead>
`+r+`</thead>
`+i+`</table>
`},k.tablerow=function(r){return`<tr>
`+r+`</tr>
`},k.tablecell=function(r,i){var o=i.header?"th":"td",w=i.align?"<"+o+' align="'+i.align+'">':"<"+o+">";return w+r+("</"+o+`>
`)},k.strong=function(r){return"<strong>"+r+"</strong>"},k.em=function(r){return"<em>"+r+"</em>"},k.codespan=function(r){return"<code>"+r+"</code>"},k.br=function(){return this.options.xhtml?"<br/>":"<br>"},k.del=function(r){return"<del>"+r+"</del>"},k.link=function(r,i,o){if(r=b(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<a href="'+e(r)+'"';return i&&(w+=' title="'+i+'"'),w+=">"+o+"</a>",w},k.image=function(r,i,o){if(r=b(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<img src="'+r+'" alt="'+o+'"';return i&&(w+=' title="'+i+'"'),w+=this.options.xhtml?"/>":">",w},k.text=function(r){return r},g}(),le=function(){function g(){}var k=g.prototype;return k.strong=function(r){return r},k.em=function(r){return r},k.codespan=function(r){return r},k.del=function(r){return r},k.html=function(r){return r},k.text=function(r){return r},k.link=function(r,i,o){return""+o},k.image=function(r,i,o){return""+o},k.br=function(){return""},g}(),J=function(){function g(){this.seen={}}var k=g.prototype;return k.serialize=function(r){return r.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},k.getNextSafeSlug=function(r,i){var o=r,w=0;if(this.seen.hasOwnProperty(o)){w=this.seen[r];do w++,o=r+"-"+w;while(this.seen.hasOwnProperty(o))}return i||(this.seen[r]=w,this.seen[o]=0),o},k.slug=function(r,i){i===void 0&&(i={});var o=this.serialize(r);return this.getNextSafeSlug(o,i.dryrun)},g}(),ae=function(){function g(F){this.options=F||se.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new J}g.parse=function(r,i){var o=new g(i);return o.parse(r)},g.parseInline=function(r,i){var o=new g(i);return o.parseInline(r)};var k=g.prototype;return k.parse=function(r,i){i===void 0&&(i=!0);var o="",w,I,C,j,_,Z,oe,me,De,ve,Se,we,Te,Ie,Me,Xe,nt,Ke,Ze,x=r.length;for(w=0;w<x;w++){if(ve=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Ze=this.options.extensions.renderers[ve.type].call({parser:this},ve),Ze!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){o+=Ze||"";continue}switch(ve.type){case"space":continue;case"hr":{o+=this.renderer.hr();continue}case"heading":{o+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,f(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{o+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(me="",oe="",j=ve.header.length,I=0;I<j;I++)oe+=this.renderer.tablecell(this.parseInline(ve.header[I].tokens),{header:!0,align:ve.align[I]});for(me+=this.renderer.tablerow(oe),De="",j=ve.rows.length,I=0;I<j;I++){for(Z=ve.rows[I],oe="",_=Z.length,C=0;C<_;C++)oe+=this.renderer.tablecell(this.parseInline(Z[C].tokens),{header:!1,align:ve.align[C]});De+=this.renderer.tablerow(oe)}o+=this.renderer.table(me,De);continue}case"blockquote":{De=this.parse(ve.tokens),o+=this.renderer.blockquote(De);continue}case"list":{for(Se=ve.ordered,we=ve.start,Te=ve.loose,j=ve.items.length,De="",I=0;I<j;I++)Me=ve.items[I],Xe=Me.checked,nt=Me.task,Ie="",Me.task&&(Ke=this.renderer.checkbox(Xe),Te?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=Ke+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=Ke+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:Ke}):Ie+=Ke),Ie+=this.parse(Me.tokens,Te),De+=this.renderer.listitem(Ie,nt,Xe);o+=this.renderer.list(De,Se,we);continue}case"html":{o+=this.renderer.html(ve.text);continue}case"paragraph":{o+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(De=ve.tokens?this.parseInline(ve.tokens):ve.text;w+1<x&&r[w+1].type==="text";)ve=r[++w],De+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);o+=i?this.renderer.paragraph(De):De;continue}default:{var ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return o},k.parseInline=function(r,i){i=i||this.renderer;var o="",w,I,C,j=r.length;for(w=0;w<j;w++){if(I=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(C=this.options.extensions.renderers[I.type].call({parser:this},I),C!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){o+=C||"";continue}switch(I.type){case"escape":{o+=i.text(I.text);break}case"html":{o+=i.html(I.text);break}case"link":{o+=i.link(I.href,I.title,this.parseInline(I.tokens,i));break}case"image":{o+=i.image(I.href,I.title,I.text);break}case"strong":{o+=i.strong(this.parseInline(I.tokens,i));break}case"em":{o+=i.em(this.parseInline(I.tokens,i));break}case"codespan":{o+=i.codespan(I.text);break}case"br":{o+=i.br();break}case"del":{o+=i.del(this.parseInline(I.tokens,i));break}case"text":{o+=i.text(I.text);break}default:{var _='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(_);return}else throw new Error(_)}}}return o},g}();function re(g,k,F){if(typeof g>"u"||g===null)throw new Error("marked(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");if(typeof k=="function"&&(F=k,k=null),k=D({},re.defaults,k||{}),P(k),F){var r=k.highlight,i;try{i=Ne.lex(g,k)}catch(j){return F(j)}var o=function(_){var Z;if(!_)try{k.walkTokens&&re.walkTokens(i,k.walkTokens),Z=ae.parse(i,k)}catch(oe){_=oe}return k.highlight=r,_?F(_):F(null,Z)};if(!r||r.length<3||(delete k.highlight,!i.length))return o();var w=0;re.walkTokens(i,function(j){j.type==="code"&&(w++,setTimeout(function(){r(j.text,j.lang,function(_,Z){if(_)return o(_);Z!=null&&Z!==j.text&&(j.text=Z,j.escaped=!0),w--,w===0&&o()})},0))}),w===0&&o();return}function I(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(j.message+"",!0)+"</pre>";throw j}try{var C=Ne.lex(g,k);if(k.walkTokens){if(k.async)return Promise.all(re.walkTokens(C,k.walkTokens)).then(function(){return ae.parse(C,k)}).catch(I);re.walkTokens(C,k.walkTokens)}return ae.parse(C,k)}catch(j){I(j)}}re.options=re.setOptions=function(g){return D(re.defaults,g),S(re.defaults),re},re.getDefaults=y,re.defaults=se.defaults,re.use=function(){for(var g=arguments.length,k=new Array(g),F=0;F<g;F++)k[F]=arguments[F];var r=D.apply(void 0,[{}].concat(k)),i=re.defaults.extensions||{renderers:{},childTokens:{}},o;k.forEach(function(w){if(w.extensions&&(o=!0,w.extensions.forEach(function(C){if(!C.name)throw new Error("extension name required");if(C.renderer){var j=i.renderers?i.renderers[C.name]:null;j?i.renderers[C.name]=function(){for(var _=arguments.length,Z=new Array(_),oe=0;oe<_;oe++)Z[oe]=arguments[oe];var me=C.renderer.apply(this,Z);return me===!1&&(me=j.apply(this,Z)),me}:i.renderers[C.name]=C.renderer}if(C.tokenizer){if(!C.level||C.level!=="block"&&C.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");i[C.level]?i[C.level].unshift(C.tokenizer):i[C.level]=[C.tokenizer],C.start&&(C.level==="block"?i.startBlock?i.startBlock.push(C.start):i.startBlock=[C.start]:C.level==="inline"&&(i.startInline?i.startInline.push(C.start):i.startInline=[C.start]))}C.childTokens&&(i.childTokens[C.name]=C.childTokens)})),w.renderer&&function(){var C=re.defaults.renderer||new Be,j=function(oe){var me=C[oe];C[oe]=function(){for(var De=arguments.length,ve=new Array(De),Se=0;Se<De;Se++)ve[Se]=arguments[Se];var we=w.renderer[oe].apply(C,ve);return we===!1&&(we=me.apply(C,ve)),we}};for(var _ in w.renderer)j(_);r.renderer=C}(),w.tokenizer&&function(){var C=re.defaults.tokenizer||new de,j=function(oe){var me=C[oe];C[oe]=function(){for(var De=arguments.length,ve=new Array(De),Se=0;Se<De;Se++)ve[Se]=arguments[Se];var we=w.tokenizer[oe].apply(C,ve);return we===!1&&(we=me.apply(C,ve)),we}};for(var _ in w.tokenizer)j(_);r.tokenizer=C}(),w.walkTokens){var I=re.defaults.walkTokens;r.walkTokens=function(C){var j=[];return j.push(w.walkTokens.call(this,C)),I&&(j=j.concat(I.call(this,C))),j}}o&&(r.extensions=i),re.setOptions(r)})},re.walkTokens=function(g,k){for(var F=[],r=function(){var I=o.value;switch(F=F.concat(k.call(re,I)),I.type){case"table":{for(var C=H(I.header),j;!(j=C()).done;){var _=j.value;F=F.concat(re.walkTokens(_.tokens,k))}for(var Z=H(I.rows),oe;!(oe=Z()).done;)for(var me=oe.value,De=H(me),ve;!(ve=De()).done;){var Se=ve.value;F=F.concat(re.walkTokens(Se.tokens,k))}break}case"list":{F=F.concat(re.walkTokens(I.items,k));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[I.type]?re.defaults.extensions.childTokens[I.type].forEach(function(we){F=F.concat(re.walkTokens(I[we],k))}):I.tokens&&(F=F.concat(re.walkTokens(I.tokens,k)))}},i=H(g),o;!(o=i()).done;)r();return F},re.parseInline=function(g,k){if(typeof g>"u"||g===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");k=D({},re.defaults,k||{}),P(k);try{var F=Ne.lexInline(g,k);return k.walkTokens&&re.walkTokens(F,k.walkTokens),ae.parseInline(F,k)}catch(r){if(r.message+=`
Please report this to https://github.com/markedjs/marked.`,k.silent)return"<p>An error occurred:</p><pre>"+e(r.message+"",!0)+"</pre>";throw r}},re.Parser=ae,re.parser=ae.parse,re.Renderer=Be,re.TextRenderer=le,re.Lexer=Ne,re.lexer=Ne.lex,re.Tokenizer=de,re.Slugger=J,re.parse=re;var G=re.options,K=re.setOptions,ie=re.use,fe=re.walkTokens,ye=re.parseInline,Ce=re,Ae=ae.parse,q=Ne.lex;se.Lexer=Ne,se.Parser=ae,se.Renderer=Be,se.Slugger=J,se.TextRenderer=le,se.Tokenizer=de,se.getDefaults=y,se.lexer=q,se.marked=re,se.options=G,se.parse=Ce,se.parseInline=ye,se.parser=Ae,se.setOptions=K,se.use=ie,se.walkTokens=fe,Object.defineProperty(se,"__esModule",{value:!0})}),define(be[80],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wj=void 0;function E(s){const f=H(s);if(f&&f.length>0)return new Uint32Array(f)}t.$Wj=E;let T=0;const n=new Uint32Array(10);function H(s){if(T=0,y(s,M,4352),T>0||(y(s,l,4449),T>0)||(y(s,h,4520),T>0)||(y(s,e,12593),T))return n.subarray(0,T);if(s>=44032&&s<=55203){const f=s-44032,c=f%588,a=Math.floor(f/588),$=Math.floor(c/28),d=c%28-1;if(a<M.length?y(a,M,0):4352+a-12593<e.length&&y(4352+a,e,12593),$<l.length?y($,l,0):4449+$-12593<e.length&&y(4449+$-12593,e,12593),d>=0&&(d<h.length?y(d,h,0):4520+d-12593<e.length&&y(4520+d-12593,e,12593)),T>0)return n.subarray(0,T)}}function y(s,f,c){s>=c&&s<c+f.length&&S(f[s-c])}function S(s){s!==0&&(n[T++]=s&255,s>>8&&(n[T++]=s>>8&255),s>>16&&(n[T++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var p;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(p||(p={}));var v;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(v||(v={}));const M=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(be[81],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=void 0;class E{constructor(n,H=0,y=n.length,S=H-1){this.a=n,this.b=H,this.c=y,this.d=S}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$BT=E}),define(be[82],pe([1,0,81]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DT=t.$CT=void 0;class T{constructor(y=[],S=10){this.h(y),this.b=S,this.d()}getHistory(){return this.j}add(y){this.a.delete(y),this.a.add(y),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(y){return this.a.has(y)}clear(){this.h([]),this.d()}d(){this.f();const y=this.j;this.c=new E.$BT(y,0,y.length,y.length)}f(){const y=this.j;y.length>this.b&&this.h(y.slice(y.length-this.b))}g(){const y=this.c.current();return y?this.j.indexOf(y):-1}h(y){this.a=new Set;for(const S of y)this.a.add(S)}get j(){const y=[];return this.a.forEach(S=>y.push(S)),y}}t.$CT=T;class n{get size(){return this.f}constructor(y,S=10){if(this.g=S,y.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:y[0],previous:void 0,next:void 0},this.a=new Set([y[0]]);for(let m=1;m<y.length;m++)this.add(y[m])}add(y){const S={value:y,previous:this.c,next:void 0};for(this.c.next=S,this.c=S,this.d=this.c,this.f++,this.a.has(y)?this.h(y):this.a.add(y);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(y){if(this.c.value===y)return y;const S=this.c.value;return this.a.delete(S),this.c.value=y,this.a.has(y)?this.h(y):this.a.add(y),S}prepend(y){if(this.f===this.g||this.a.has(y))return;const S={value:y,previous:void 0,next:this.b};this.b.previous=S,this.b=S,this.f++,this.a.add(y)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(y){return this.a.has(y)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let y=this.b;for(;y;)yield y.value,y=y.next}h(y){let S=this.b;for(;S!==this.c;)S.value===y&&(S===this.b?(this.b=this.b.next,this.b.previous=void 0):(S.previous.next=S.next,S.next.previous=S.previous),this.f--),S=S.next}}t.$DT=n}),define(be[33],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dm=t.$cm=t.$bm=t.rot=t.$_l=void 0;function E(S,m,p){return Math.min(Math.max(S,m),p)}t.$_l=E;function T(S,m){return(m+S%m)%m}t.rot=T;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$bm=n;class H{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$cm=H;class y{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const p=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$dm=y}),define(be[47],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(T){function n(m,p){if(m.start>=p.end||p.start>=m.end)return{start:0,end:0};const v=Math.max(m.start,p.start),M=Math.min(m.end,p.end);return M-v<=0?{start:0,end:0}:{start:v,end:M}}T.intersect=n;function H(m){return m.end-m.start<=0}T.isEmpty=H;function y(m,p){return!H(n(m,p))}T.intersects=y;function S(m,p){const v=[],M={start:m.start,end:Math.min(p.start,m.end)},l={start:Math.max(p.end,m.start),end:m.end};return H(M)||v.push(M),H(l)||v.push(l),v}T.relativeComplement=S})(E||(t.Range=E={}))}),define(be[83],pe([1,0,47]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kS=t.$jS=t.$iS=t.$hS=void 0;function T(m,p){const v=[];for(const M of p){if(m.start>=M.range.end)continue;if(m.end<M.range.start)break;const l=E.Range.intersect(m,M.range);E.Range.isEmpty(l)||v.push({range:l,size:M.size})}return v}t.$hS=T;function n({start:m,end:p},v){return{start:m+v,end:p+v}}t.$iS=n;function H(m){const p=[];let v=null;for(const M of m){const l=M.range.start,h=M.range.end,e=M.size;if(v&&e===v.size){v.range.end=h;continue}v={range:{start:l,end:h},size:e},p.push(v)}return p}t.$jS=H;function y(...m){return H(m.reduce((p,v)=>p.concat(v),[]))}class S{get paddingTop(){return this.c}set paddingTop(p){this.b=this.b+p-this.c,this.c=p}constructor(p){this.a=[],this.b=0,this.c=0,this.c=p??0,this.b=this.c}splice(p,v,M=[]){const l=M.length-v,h=T({start:0,end:p},this.a),e=T({start:p+v,end:Number.POSITIVE_INFINITY},this.a).map(f=>({range:n(f.range,l),size:f.size})),s=M.map((f,c)=>({range:{start:p+c,end:p+c+1},size:f.size}));this.a=y(h,s,e),this.b=this.c+this.a.reduce((f,c)=>f+c.size*(c.range.end-c.range.start),0)}get count(){const p=this.a.length;return p?this.a[p-1].range.end:0}get size(){return this.b}indexAt(p){if(p<0)return-1;if(p<this.c)return 0;let v=0,M=this.c;for(const l of this.a){const h=l.range.end-l.range.start,e=M+h*l.size;if(p<e)return v+Math.floor((p-M)/l.size);v+=h,M=e}return v}indexAfter(p){return Math.min(this.indexAt(p)+1,this.count)}positionAt(p){if(p<0)return-1;let v=0,M=0;for(const l of this.a){const h=l.range.end-l.range.start,e=M+h;if(p<e)return this.c+v+(p-M)*l.size;v+=h*l.size,M=e}return-1}}t.$kS=S}),define(be[84],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ud=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(H){return new T(H)}constructor(H){this.c=E&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Ud=T}),define(be[4],pe([1,0,6,44,3,46,84]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.Event=void 0;const S=!1,m=!1;var p;(function(W){W.None=()=>n.$Tc.None;function A(r){if(m){const{onDidAddListener:i}=r,o=e.create();let w=0;r.onDidAddListener=()=>{++w===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),o.print()),i?.()}}}function P(r,i){return Be(r,()=>{},0,void 0,!0,void 0,i)}W.defer=P;function L(r){return(i,o=null,w)=>{let I=!1,C;return C=r(j=>{if(!I)return C?C.dispose():I=!0,i.call(o,j)},null,w),I&&C.dispose(),C}}W.once=L;function Y(r,i,o){return Pe((w,I=null,C)=>r(j=>w.call(I,i(j)),null,C),o)}W.map=Y;function X(r,i,o){return Pe((w,I=null,C)=>r(j=>{i(j),w.call(I,j)},null,C),o)}W.forEach=X;function de(r,i,o){return Pe((w,I=null,C)=>r(j=>i(j)&&w.call(I,j),null,C),o)}W.filter=de;function ue(r){return r}W.signal=ue;function te(...r){return(i,o=null,w)=>{const I=(0,n.$Qc)(...r.map(C=>C(j=>i.call(o,j))));return Ne(I,w)}}W.any=te;function ge(r,i,o,w){let I=o;return Y(r,C=>(I=i(I,C),I),w)}W.reduce=ge;function Pe(r,i){let o;const w={onWillAddFirstListener(){o=r(I.fire,I)},onDidRemoveLastListener(){o?.dispose()}};i||A(w);const I=new $(w);return i?.add(I),I.event}function Ne(r,i){return i instanceof Array?i.push(r):i&&i.add(r),r}function Be(r,i,o=100,w=!1,I=!1,C,j){let _,Z,oe,me=0,De;const ve={leakWarningThreshold:C,onWillAddFirstListener(){_=r(we=>{me++,Z=i(Z,we),w&&!oe&&(Se.fire(Z),Z=void 0),De=()=>{const Te=Z;Z=void 0,oe=void 0,(!w||me>1)&&Se.fire(Te),me=0},typeof o=="number"?(clearTimeout(oe),oe=setTimeout(De,o)):oe===void 0&&(oe=0,queueMicrotask(De))})},onWillRemoveListener(){I&&me>0&&De?.()},onDidRemoveLastListener(){De=void 0,_.dispose()}};j||A(ve);const Se=new $(ve);return j?.add(Se),Se.event}W.debounce=Be;function le(r,i=0,o){return W.debounce(r,(w,I)=>w?(w.push(I),w):[I],i,void 0,!0,void 0,o)}W.accumulate=le;function J(r,i=(w,I)=>w===I,o){let w=!0,I;return de(r,C=>{const j=w||!i(C,I);return w=!1,I=C,j},o)}W.latch=J;function ae(r,i,o){return[W.filter(r,i,o),W.filter(r,w=>!i(w),o)]}W.split=ae;function re(r,i=!1,o=[],w){let I=o.slice(),C=r(Z=>{I?I.push(Z):_.fire(Z)});w&&w.add(C);const j=()=>{I?.forEach(Z=>_.fire(Z)),I=null},_=new $({onWillAddFirstListener(){C||(C=r(Z=>_.fire(Z)),w&&w.add(C))},onDidAddFirstListener(){I&&(i?setTimeout(j):j())},onDidRemoveLastListener(){C&&C.dispose(),C=null}});return w&&w.add(_),_.event}W.buffer=re;function G(r,i){return(w,I,C)=>{const j=i(new ie);return r(function(_){const Z=j.evaluate(_);Z!==K&&w.call(I,Z)},void 0,C)}}W.chain=G;const K=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(i){return this.f.push(i),this}forEach(i){return this.f.push(o=>(i(o),o)),this}filter(i){return this.f.push(o=>i(o)?o:K),this}reduce(i,o){let w=o;return this.f.push(I=>(w=i(w,I),w)),this}latch(i=(o,w)=>o===w){let o=!0,w;return this.f.push(I=>{const C=o||!i(I,w);return o=!1,w=I,C?I:K}),this}evaluate(i){for(const o of this.f)if(i=o(i),i===K)break;return i}}function fe(r,i,o=w=>w){const w=(..._)=>j.fire(o(..._)),I=()=>r.on(i,w),C=()=>r.removeListener(i,w),j=new $({onWillAddFirstListener:I,onDidRemoveLastListener:C});return j.event}W.fromNodeEventEmitter=fe;function ye(r,i,o=w=>w){const w=(..._)=>j.fire(o(..._)),I=()=>r.addEventListener(i,w),C=()=>r.removeEventListener(i,w),j=new $({onWillAddFirstListener:I,onDidRemoveLastListener:C});return j.event}W.fromDOMEventEmitter=ye;function Ce(r){return new Promise(i=>L(r)(i))}W.toPromise=Ce;function Ae(r){const i=new $;return r.then(o=>{i.fire(o)},()=>{i.fire(void 0)}).finally(()=>{i.dispose()}),i.event}W.fromPromise=Ae;function q(r,i,o){return i(o),r(w=>i(w))}W.runAndSubscribe=q;class g{constructor(i,o){this._observable=i,this.f=0,this.g=!1;const w={onWillAddFirstListener:()=>{i.addObserver(this)},onDidRemoveLastListener:()=>{i.removeObserver(this)}};o||A(w),this.emitter=new $(w),o&&o.add(this.emitter)}beginUpdate(i){this.f++}handlePossibleChange(i){}handleChange(i,o){this.g=!0}endUpdate(i){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function k(r,i){return new g(r,i).emitter.event}W.fromObservable=k;function F(r){return(i,o,w)=>{let I=0,C=!1;const j={beginUpdate(){I++},endUpdate(){I--,I===0&&(r.reportChanges(),C&&(C=!1,i.call(o)))},handlePossibleChange(){},handleChange(){C=!0}};r.addObserver(j),r.reportChanges();const _={dispose(){r.removeObserver(j)}};return w instanceof n.$Sc?w.add(_):Array.isArray(w)&&w.push(_),_}}W.fromObservableLight=F})(p||(t.Event=p={}));class v{static{this.all=new Set}static{this.f=0}constructor(A){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${A}_${v.f++}`,v.all.add(this)}start(A){this.g=new y.$Ud,this.listenerCount=A}stop(){if(this.g){const A=this.g.elapsed();this.durations.push(A),this.elapsedOverall+=A,this.invocationCount+=1,this.g=void 0}}}t.$Wd=v;let M=-1;function l(W){const A=M;return M=W,{dispose(){M=A}}}t.$Xd=l;class h{constructor(A,P=Math.random().toString(18).slice(2,5)){this.threshold=A,this.name=P,this.g=0}dispose(){this.f?.clear()}check(A,P){const L=this.threshold;if(L<=0||P<L)return;this.f||(this.f=new Map);const Y=this.f.get(A.value)||0;if(this.f.set(A.value,Y+1),this.g-=1,this.g<=0){this.g=L*.5;let X,de=0;for(const[ue,te]of this.f)(!X||de<te)&&(X=ue,de=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${de}):`),console.warn(X)}return()=>{const X=this.f.get(A.value)||0;this.f.set(A.value,X-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(A){this.value=A}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class f{constructor(A){this.value=A,this.id=s++}}const c=2,a=(W,A)=>{if(W instanceof f)A(W);else for(let P=0;P<W.length;P++){const L=W[P];L&&A(L)}};class ${constructor(A){this.w=0,this.f=A,this.g=M>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??M):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const A=this.t;queueMicrotask(()=>{a(A,P=>P.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(A,P,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Tc.None;if(this.m)return n.$Tc.None;P&&(A=A.bind(P));const Y=new f(A);let X,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=e.create(),X=this.g.check(Y.stack,this.w+1)),S&&(Y.stack=de??e.create()),this.t?this.t instanceof f?(this.u??=new b,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const ue=(0,n.$Rc)(()=>{X?.(),this.x(Y)});return L instanceof n.$Sc?L.add(ue):Array.isArray(L)&&L.push(ue),ue},this.q}x(A){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const P=this.t,L=P.indexOf(A);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,P[L]=void 0;const Y=this.u.current===this;if(this.w*c<=P.length){let X=0;for(let de=0;de<P.length;de++)P[de]?P[X++]=P[de]:Y&&(this.u.end--,X<this.u.i&&this.u.i--);P.length=X}}y(A,P){if(!A)return;const L=this.f?.onListenerError||E.$1;if(!L){A.value(P);return}try{A.value(P)}catch(Y){L(Y)}}z(A){const P=A.current.t;for(;A.i<A.end;)this.y(P[A.i++],A.value);A.reset()}fire(A){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,A);else{const P=this.u;P.enqueue(this,A,this.t.length),this.z(P)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Yd=$;const d=()=>new b;t.$Zd=d;class b{constructor(){this.i=-1,this.end=0}enqueue(A,P,L){this.i=0,this.end=L,this.current=A,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class u extends ${async fireAsync(A,P,L){if(this.t)for(this.h||(this.h=new H.$4c),a(this.t,Y=>this.h.push([Y.value,A]));this.h.size>0&&!P.isCancellationRequested;){const[Y,X]=this.h.shift(),de=[],ue={...X,token:P,waitUntil:te=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");L&&(te=L(te,Y)),de.push(te)}};try{Y(ue)}catch(te){(0,E.$1)(te);continue}Object.freeze(de),await Promise.allSettled(de).then(te=>{for(const ge of te)ge.status==="rejected"&&(0,E.$1)(ge.reason)})}}}t.$1d=u;class N extends ${get isPaused(){return this.h!==0}constructor(A){super(A),this.h=0,this.s=new H.$4c,this.A=A?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const A=Array.from(this.s);this.s.clear(),super.fire(this.A(A))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(A){this.w&&(this.h!==0?this.s.push(A):super.fire(A))}}t.$2d=N;class B extends N{constructor(A){super(A),this.k=A.delay??100}fire(A){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(A)}}t.$3d=B;class R extends ${constructor(A){super(A),this.h=[],this.k=A?.merge}fire(A){this.hasListeners()&&(this.h.push(A),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}t.$4d=R;class U{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(A){const P={event:A,listener:null};this.h.push(P),this.g&&this.m(P);const L=()=>{this.g&&this.o(P);const Y=this.h.indexOf(P);this.h.splice(Y,1)};return(0,n.$Rc)((0,T.$db)(L))}j(){this.g=!0,this.h.forEach(A=>this.m(A))}k(){this.g=!1,this.h.forEach(A=>this.o(A))}m(A){A.listener=A.event(P=>this.f.fire(P))}o(A){A.listener?.dispose(),A.listener=null}dispose(){this.f.dispose();for(const A of this.h)A.listener?.dispose();this.h=[]}}t.$5d=U;class z{constructor(A,P,L,Y){this.f=new n.$Sc;const X=this.f.add(new U),de=this.f.add(new n.$3c);function ue(te){de.set(te,X.add(Y(te)))}for(const te of A)ue(te);this.f.add(P(te=>{ue(te)})),this.f.add(L(te=>{de.deleteAndDispose(te)})),this.event=X.event}dispose(){this.f.dispose()}}t.$6d=z;class D{constructor(){this.f=[]}wrapEvent(A){return(P,L,Y)=>A(X=>{const de=this.f[this.f.length-1];de?de.push(()=>P.call(L,X)):P.call(L,X)},void 0,Y)}bufferEvents(A){const P=[];this.f.push(P);const L=A();return this.f.pop(),P.forEach(Y=>Y()),L}}t.$7d=D;class O{constructor(){this.f=!1,this.g=p.None,this.h=n.$Tc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(A){this.g=A,this.f&&(this.h.dispose(),this.h=A(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$8d=O}),define(be[16],pe([1,0,21,4]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$UP=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=void 0;class n{constructor(){this.a=new Map,this.b=new T.$Yd,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new T.$Yd,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new n}getZoomLevel(c){return this.a.get(this.f(c))??0}setZoomLevel(c,a){if(this.getZoomLevel(a)===c)return;const $=this.f(a);this.a.set($,c),this.b.fire($)}getZoomFactor(c){return this.c.get(this.f(c))??1}setZoomFactor(c,a){this.c.set(this.f(a),c)}setFullscreen(c,a){if(this.isFullscreen(a)===c)return;const $=this.f(a);this.e.set($,c),this.d.fire($)}isFullscreen(c){return!!this.e.get(this.f(c))}f(c){return c.vscodeWindowId}}function H(f,c,a){typeof c=="string"&&(c=f.matchMedia(c)),c.addEventListener("change",a)}t.$JP=H;function y(f,c){n.INSTANCE.setZoomLevel(f,c)}t.$KP=y;function S(f){return n.INSTANCE.getZoomLevel(f)}t.$LP=S,t.$MP=n.INSTANCE.onDidChangeZoomLevel;function m(f){return n.INSTANCE.getZoomFactor(f)}t.$NP=m;function p(f,c){n.INSTANCE.setZoomFactor(f,c)}t.$OP=p;function v(f,c){n.INSTANCE.setFullscreen(f,c)}t.$PP=v;function M(f){return n.INSTANCE.isFullscreen(f)}t.$QP=M,t.$RP=n.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.$SP=l.indexOf("Firefox")>=0,t.$TP=l.indexOf("AppleWebKit")>=0,t.$UP=l.indexOf("Chrome")>=0,t.$VP=!t.$UP&&l.indexOf("Safari")>=0,t.$WP=!t.$UP&&!t.$VP&&t.$TP,t.$XP=l.indexOf("Electron/")>=0,t.$YP=l.indexOf("Android")>=0;let h=!1;if(typeof E.$FP.matchMedia=="function"){const f=E.$FP.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),c=E.$FP.matchMedia("(display-mode: fullscreen)");h=f.matches,H(E.$FP,f,({matches:a})=>{h&&c.matches||(h=a)})}function e(){return h}t.$ZP=e;function s(){return navigator?.windowControlsOverlay?.visible}t.$1P=s}),define(be[22],pe([1,0,4]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cS=void 0;class T{get event(){return this.a.event}constructor(H,y,S){const m=p=>this.a.fire(p);this.a=new E.$Yd({onWillAddFirstListener:()=>H.addEventListener(y,m,S),onDidRemoveLastListener:()=>H.removeEventListener(y,m,S)})}dispose(){this.a.dispose()}}t.$cS=T}),define(be[29],pe([1,0,4]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9d=t.CancellationToken=void 0;const T=Object.freeze(function(S,m){const p=setTimeout(S.bind(m),0);return{dispose(){clearTimeout(p)}}});var n;(function(S){function m(p){return p===S.None||p===S.Cancelled||p instanceof H?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}S.isCancellationToken=m,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(n||(t.CancellationToken=n={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new E.$Yd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class y{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=n.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=n.None}}t.$9d=y}),define(be[85],pe([1,0,29]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Je=t.$Ie=t.$He=void 0;class T{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new E.$9d,m=this.b(S.token);return this.a={promise:m,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}t.$He=T;class n{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const m=JSON.stringify(S);return this.b!==m&&(this.b=m,this.a=this.c(S)),this.a}}t.$Ie=n;class H{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const m=this.b(S);return this.a.set(S,m),m}}t.$Je=H}),define(be[48],pe([1,0,4,3]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ss=t.$rs=t.$qs=t.$ps=t.ScrollbarVisibility=void 0;var n;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class H{constructor(e,s,f,c,a,$,d){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,f=f|0,c=c|0,a=a|0,$=$|0,d=d|0),this.rawScrollLeft=c,this.rawScrollTop=d,s<0&&(s=0),c+s>f&&(c=f-s),c<0&&(c=0),a<0&&(a=0),d+a>$&&(d=$-a),d<0&&(d=0),this.width=s,this.scrollWidth=f,this.scrollLeft=c,this.height=a,this.scrollHeight=$,this.scrollTop=d}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const f=this.width!==e.width,c=this.scrollWidth!==e.scrollWidth,a=this.scrollLeft!==e.scrollLeft,$=this.height!==e.height,d=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:f,scrollWidthChanged:c,scrollLeftChanged:a,heightChanged:$,scrollHeightChanged:d,scrollTopChanged:b}}}t.$ps=H;class y extends T.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new E.$Yd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const f=this.g.withScrollDimensions(e,s);this.n(f,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const f=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===f.scrollLeft&&this.h.to.scrollTop===f.scrollTop)return;let c;s?c=new v(this.h.from,f,this.h.startTime,this.h.duration):c=this.h.combine(this.g,f,this.c),this.h.dispose(),this.h=c}else{const f=this.g.withScrollPosition(e);this.h=v.start(this.g,f,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const f=this.g;f.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(f,s)))}}t.$qs=y;class S{constructor(e,s,f){this.scrollLeft=e,this.scrollTop=s,this.isDone=f}}t.$rs=S;function m(h,e){const s=e-h;return function(f){return h+s*l(f)}}function p(h,e,s){return function(f){return f<s?h(f/s):e((f-s)/(1-s))}}class v{constructor(e,s,f,c){this.from=e,this.to=s,this.duration=c,this.startTime=f,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,f){if(Math.abs(e-s)>2.5*f){let a,$;return e<s?(a=e+.75*f,$=s-.75*f):(a=e-.75*f,$=s+.75*f),p(m(e,a),m($,s),.33)}return m(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const f=this.c(s),c=this.d(s);return new S(f,c,!1)}return new S(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,f){return v.start(e,s,f)}static start(e,s,f){f=f+10;const c=Date.now()-10;return new v(e,s,c,f)}}t.$ss=v;function M(h){return Math.pow(h,3)}function l(h){return 1-M(1-h)}}),define(be[86],pe([1,0,6,3]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=void 0;function n(d){const b=d;return b?typeof b.read=="function":!1}t.$0d=n;function H(d){const b=d;return b?[b.on,b.pause,b.resume,b.destroy].every(u=>typeof u=="function"):!1}t.$$d=H;function y(d){const b=d;return b?H(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.$_d=y;function S(d,b){return new m(d,b)}t.$ae=S;class m{constructor(b,u){this.e=b,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(u=>u(b))}h(b){this.c.error.length===0?(0,E.$1)(b):this.c.error.slice(0).forEach(u=>u(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,u){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(b,u){if(this.a.destroyed)return;let N;switch(b){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const B=N.indexOf(u);B>=0&&N.splice(B,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(d,b){const u=[];let N;for(;(N=d.read())!==null;)u.push(N);return b(u)}t.$be=p;function v(d,b,u){const N=[];let B;for(;(B=d.read())!==null&&N.length<u;)N.push(B);return B===null&&N.length>0?b(N):{read:()=>{if(N.length>0)return N.shift();if(typeof B<"u"){const R=B;return B=void 0,R}return d.read()}}}t.$ce=v;function M(d,b){return new Promise((u,N)=>{const B=[];l(d,{onData:R=>{b&&B.push(R)},onError:R=>{b?N(R):u(void 0)},onEnd:()=>{u(b?b(B):void 0)}})})}t.$de=M;function l(d,b,u){d.on("error",N=>{u?.isCancellationRequested||b.onError(N)}),d.on("end",()=>{u?.isCancellationRequested||b.onEnd()}),d.on("data",N=>{u?.isCancellationRequested||b.onData(N)})}t.$ee=l;function h(d,b){return new Promise((u,N)=>{const B=new T.$Sc,R=[],U=O=>{if(R.push(O),R.length>b)return B.dispose(),d.pause(),u({stream:d,buffer:R,ended:!1})},z=O=>(B.dispose(),N(O)),D=()=>(B.dispose(),u({stream:d,buffer:R,ended:!0}));B.add((0,T.$Rc)(()=>d.removeListener("error",z))),d.on("error",z),B.add((0,T.$Rc)(()=>d.removeListener("end",D))),d.on("end",D),B.add((0,T.$Rc)(()=>d.removeListener("data",U))),d.on("data",U)})}t.$fe=h;function e(d,b){const u=S(b);return u.end(d),u}t.$ge=e;function s(){const d=S(()=>{throw new Error("not supported")});return d.end(),d}t.$he=s;function f(d){let b=!1;return{read:()=>b?null:(b=!0,d)}}t.$ie=f;function c(d,b,u){const N=S(u);return l(d,{onData:B=>N.write(b.data(B)),onError:B=>N.error(b.error?b.error(B):B),onEnd:()=>N.end()}),N}t.$je=c;function a(d,b,u){let N=!1;return{read:()=>{const B=b.read();return N?B:(N=!0,B!==null?u([d,B]):d)}}}t.$ke=a;function $(d,b,u){let N=!1;const B=S(u);return l(b,{onData:R=>N?B.write(R):(N=!0,B.write(u([d,R]))),onError:R=>B.error(R),onEnd:()=>{N||(N=!0,B.write(d)),B.end()}}),B}t.$le=$}),define(be[34],pe([1,0,23,86]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=void 0;const n=typeof Buffer<"u",H=new E.$V(()=>new Uint8Array(256));let y,S;class m{static alloc(P){return n?new m(Buffer.allocUnsafe(P)):new m(new Uint8Array(P))}static wrap(P){return n&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new m(P)}static fromString(P,L){return!(L?.dontUseNodeBuffer||!1)&&n?new m(Buffer.from(P)):(y||(y=new TextEncoder),new m(y.encode(P)))}static fromByteArray(P){const L=m.alloc(P.length);for(let Y=0,X=P.length;Y<X;Y++)L.buffer[Y]=P[Y];return L}static concat(P,L){if(typeof L>"u"){L=0;for(let de=0,ue=P.length;de<ue;de++)L+=P[de].byteLength}const Y=m.alloc(L);let X=0;for(let de=0,ue=P.length;de<ue;de++){const te=P[de];Y.set(te,X),X+=te.byteLength}return Y}constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}clone(){const P=m.alloc(this.byteLength);return P.set(this),P}toString(){return n?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(P,L){return new m(this.buffer.subarray(P,L))}set(P,L){if(P instanceof m)this.buffer.set(P.buffer,L);else if(P instanceof Uint8Array)this.buffer.set(P,L);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),L);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return l(this.buffer,P)}writeUInt32BE(P,L){h(this.buffer,P,L)}readUInt32LE(P){return e(this.buffer,P)}writeUInt32LE(P,L){s(this.buffer,P,L)}readUInt8(P){return f(this.buffer,P)}writeUInt8(P,L){c(this.buffer,P,L)}indexOf(P,L=0){return p(this.buffer,P instanceof m?P.buffer:P,L)}}t.$me=m;function p(A,P,L=0){const Y=P.byteLength,X=A.byteLength;if(Y===0)return 0;if(Y===1)return A.indexOf(P[0]);if(Y>X-L)return-1;const de=H.value;de.fill(P.length);for(let Pe=0;Pe<P.length;Pe++)de[P[Pe]]=P.length-Pe-1;let ue=L+P.length-1,te=ue,ge=-1;for(;ue<X;)if(A[ue]===P[te]){if(te===0){ge=ue;break}ue--,te--}else ue+=Math.max(P.length-te,de[A[ue]]),te=P.length-1;return ge}t.$ne=p;function v(A,P){return A[P+0]<<0>>>0|A[P+1]<<8>>>0}t.$oe=v;function M(A,P,L){A[L+0]=P&255,P=P>>>8,A[L+1]=P&255}t.$pe=M;function l(A,P){return A[P]*2**24+A[P+1]*2**16+A[P+2]*2**8+A[P+3]}t.$qe=l;function h(A,P,L){A[L+3]=P,P=P>>>8,A[L+2]=P,P=P>>>8,A[L+1]=P,P=P>>>8,A[L]=P}t.$re=h;function e(A,P){return A[P+0]<<0>>>0|A[P+1]<<8>>>0|A[P+2]<<16>>>0|A[P+3]<<24>>>0}t.$se=e;function s(A,P,L){A[L+0]=P&255,P=P>>>8,A[L+1]=P&255,P=P>>>8,A[L+2]=P&255,P=P>>>8,A[L+3]=P&255}t.$te=s;function f(A,P){return A[P]}t.$ue=f;function c(A,P,L){A[L]=P}t.$ve=c;function a(A){return T.$be(A,P=>m.concat(P))}t.$we=a;function $(A){return T.$ie(A)}t.$xe=$;function d(A){return T.$de(A,P=>m.concat(P))}t.$ye=d;async function b(A){return A.ended?m.concat(A.buffer):m.concat([...A.buffer,await d(A.stream)])}t.$ze=b;function u(A){return T.$ge(A,P=>m.concat(P))}t.$Ae=u;function N(A){return T.$je(A,{data:P=>typeof P=="string"?m.fromString(P):m.wrap(P)},P=>m.concat(P))}t.$Be=N;function B(A){return T.$ae(P=>m.concat(P),A)}t.$Ce=B;function R(A,P){return T.$ke(A,P,L=>m.concat(L))}t.$De=R;function U(A,P){return T.$le(A,P,L=>m.concat(L))}t.$Ee=U;function z(A){let P=0,L=0,Y=0;const X=new Uint8Array(Math.floor(A.length/4*3)),de=te=>{switch(L){case 3:X[Y++]=P|te,L=0;break;case 2:X[Y++]=P|te>>>2,P=te<<6,L=3;break;case 1:X[Y++]=P|te>>>4,P=te<<4,L=2;break;default:P=te<<2,L=1}};for(let te=0;te<A.length;te++){const ge=A.charCodeAt(te);if(ge>=65&&ge<=90)de(ge-65);else if(ge>=97&&ge<=122)de(ge-97+26);else if(ge>=48&&ge<=57)de(ge-48+52);else if(ge===43||ge===45)de(62);else if(ge===47||ge===95)de(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${A[te]}`)}}const ue=Y;for(;L>0;)de(0);return m.wrap(X).slice(0,ue)}t.$Fe=z;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function W({buffer:A},P=!0,L=!1){const Y=L?O:D;let X="";const de=A.byteLength%3;let ue=0;for(;ue<A.byteLength-de;ue+=3){const te=A[ue+0],ge=A[ue+1],Pe=A[ue+2];X+=Y[te>>>2],X+=Y[(te<<4|ge>>>4)&63],X+=Y[(ge<<2|Pe>>>6)&63],X+=Y[Pe&63]}if(de===1){const te=A[ue+0];X+=Y[te>>>2],X+=Y[te<<4&63],P&&(X+="==")}else if(de===2){const te=A[ue+0],ge=A[ue+1];X+=Y[te>>>2],X+=Y[(te<<4|ge>>>4)&63],X+=Y[ge<<2&63],P&&(X+="=")}return X}t.$Ge=W}),define(be[10],pe([1,0,85,23]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lf=t.$Kf=t.$Jf=t.$If=t.GraphemeBreakType=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=void 0;function n(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.$Me=n;const H=/{(\d+)}/g;function y(x,...ne){return ne.length===0?x:x.replace(H,function($e,Ee){const Re=parseInt(Ee,10);return isNaN(Re)||Re<0||Re>=ne.length?$e:ne[Re]})}t.$Ne=y;const S=/{([^}]+)}/g;function m(x,ne){return Object.keys(ne).length===0?x:x.replace(S,($e,Ee)=>ne[Ee]??$e)}t.$Oe=m;function p(x){return x.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}t.$Pe=p;function v(x){return x.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}t.$Qe=v;function M(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Re=M;function l(x,ne){let $e=0;const Ee=ne.charCodeAt(0);for(let Re=x.length-1;Re>=0;Re--)x.charCodeAt(Re)===Ee&&$e++;return $e}t.$Se=l;function h(x,ne,$e="\u2026"){return x.length<=ne?x:`${x.substr(0,ne)}${$e}`}t.$Te=h;function e(x,ne,$e="\u2026"){if(x.length<=ne)return x;const Ee=Math.ceil(ne/2)-$e.length/2,Re=Math.floor(ne/2)-$e.length/2;return`${x.substr(0,Ee)}${$e}${x.substr(x.length-Re)}`}t.$Ue=e;function s(x,ne=" "){const $e=f(x,ne);return c($e,ne)}t.$Ve=s;function f(x,ne){if(!x||!ne)return x;const $e=ne.length;if($e===0||x.length===0)return x;let Ee=0;for(;x.indexOf(ne,Ee)===Ee;)Ee=Ee+$e;return x.substring(Ee)}t.$We=f;function c(x,ne){if(!x||!ne)return x;const $e=ne.length,Ee=x.length;if($e===0||Ee===0)return x;let Re=Ee,je=-1;for(;je=x.lastIndexOf(ne,Re-1),!(je===-1||je+$e!==Re);){if(je===0)return"";Re=je}return x.substring(0,Re)}t.$Xe=c;function a(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Ye=a;function $(x){return x.replace(/\*/g,"")}t.$Ze=$;function d(x,ne,$e={}){if(!x)throw new Error("Cannot create regex from empty string");ne||(x=M(x)),$e.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ee="";return $e.global&&(Ee+="g"),$e.matchCase||(Ee+="i"),$e.multiline&&(Ee+="m"),$e.unicode&&(Ee+="u"),new RegExp(x,Ee)}t.$1e=d;function b(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.$2e=b;function u(x){return x.split(/\r\n|\r|\n/)}t.$3e=u;function N(x){const ne=[],$e=x.split(/(\r\n|\r|\n)/);for(let Ee=0;Ee<Math.ceil($e.length/2);Ee++)ne.push($e[2*Ee]+($e[2*Ee+1]??""));return ne}t.$4e=N;function B(x){for(let ne=0,$e=x.length;ne<$e;ne++){const Ee=x.charCodeAt(ne);if(Ee!==32&&Ee!==9)return ne}return-1}t.$5e=B;function R(x,ne=0,$e=x.length){for(let Ee=ne;Ee<$e;Ee++){const Re=x.charCodeAt(Ee);if(Re!==32&&Re!==9)return x.substring(ne,Ee)}return x.substring(ne,$e)}t.$6e=R;function U(x,ne=x.length-1){for(let $e=ne;$e>=0;$e--){const Ee=x.charCodeAt($e);if(Ee!==32&&Ee!==9)return $e}return-1}t.$7e=U;function z(x,ne,$e){const Ee=[];let Re=0;for(const je of x.matchAll(ne)){if(Ee.push(x.slice(Re,je.index)),je.index===void 0)throw new Error("match.index should be defined");Re=je.index+je[0].length,Ee.push($e(je[0],...je.slice(1),je.index,x,je.groups))}return Ee.push(x.slice(Re)),Promise.all(Ee).then(je=>je.join(""))}t.$8e=z;function D(x,ne){return x<ne?-1:x>ne?1:0}t.$9e=D;function O(x,ne,$e=0,Ee=x.length,Re=0,je=ne.length){for(;$e<Ee&&Re<je;$e++,Re++){const tt=x.charCodeAt($e),st=ne.charCodeAt(Re);if(tt<st)return-1;if(tt>st)return 1}const Qe=Ee-$e,Je=je-Re;return Qe<Je?-1:Qe>Je?1:0}t.$0e=O;function W(x,ne){return A(x,ne,0,x.length,0,ne.length)}t.$$e=W;function A(x,ne,$e=0,Ee=x.length,Re=0,je=ne.length){for(;$e<Ee&&Re<je;$e++,Re++){let tt=x.charCodeAt($e),st=ne.charCodeAt(Re);if(tt===st)continue;if(tt>=128||st>=128)return O(x.toLowerCase(),ne.toLowerCase(),$e,Ee,Re,je);L(tt)&&(tt-=32),L(st)&&(st-=32);const Ge=tt-st;if(Ge!==0)return Ge}const Qe=Ee-$e,Je=je-Re;return Qe<Je?-1:Qe>Je?1:0}t.$_e=A;function P(x){return x>=48&&x<=57}t.$af=P;function L(x){return x>=97&&x<=122}t.$bf=L;function Y(x){return x>=65&&x<=90}t.$cf=Y;function X(x,ne){return x.length===ne.length&&A(x,ne)===0}t.$df=X;function de(x,ne){const $e=ne.length;return ne.length>x.length?!1:A(x,ne,0,$e)===0}t.$ef=de;function ue(x,ne){const $e=Math.min(x.length,ne.length);let Ee;for(Ee=0;Ee<$e;Ee++)if(x.charCodeAt(Ee)!==ne.charCodeAt(Ee))return Ee;return $e}t.$ff=ue;function te(x,ne){const $e=Math.min(x.length,ne.length);let Ee;const Re=x.length-1,je=ne.length-1;for(Ee=0;Ee<$e;Ee++)if(x.charCodeAt(Re-Ee)!==ne.charCodeAt(je-Ee))return Ee;return $e}t.$gf=te;function ge(x){return 55296<=x&&x<=56319}t.$hf=ge;function Pe(x){return 56320<=x&&x<=57343}t.$if=Pe;function Ne(x,ne){return(x-55296<<10)+(ne-56320)+65536}t.$jf=Ne;function Be(x,ne,$e){const Ee=x.charCodeAt($e);if(ge(Ee)&&$e+1<ne){const Re=x.charCodeAt($e+1);if(Pe(Re))return Ne(Ee,Re)}return Ee}t.$kf=Be;function le(x,ne){const $e=x.charCodeAt(ne-1);if(Pe($e)&&ne>1){const Ee=x.charCodeAt(ne-2);if(ge(Ee))return Ne(Ee,$e)}return $e}class J{get offset(){return this.e}constructor(ne,$e=0){this.c=ne,this.d=ne.length,this.e=$e}setOffset(ne){this.e=ne}prevCodePoint(){const ne=le(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Be(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$lf=J;class ae{get offset(){return this.c.offset}constructor(ne,$e=0){this.c=new J(ne,$e)}nextGraphemeLength(){const ne=we.getInstance(),$e=this.c,Ee=$e.offset;let Re=ne.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const je=$e.offset,Qe=ne.getGraphemeBreakType($e.nextCodePoint());if(ve(Re,Qe)){$e.setOffset(je);break}Re=Qe}return $e.offset-Ee}prevGraphemeLength(){const ne=we.getInstance(),$e=this.c,Ee=$e.offset;let Re=ne.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const je=$e.offset,Qe=ne.getGraphemeBreakType($e.prevCodePoint());if(ve(Qe,Re)){$e.setOffset(je);break}Re=Qe}return Ee-$e.offset}eol(){return this.c.eol()}}t.$mf=ae;function re(x,ne){return new ae(x,ne).nextGraphemeLength()}t.$nf=re;function G(x,ne){return new ae(x,ne).prevGraphemeLength()}t.$of=G;function K(x,ne){ne>0&&Pe(x.charCodeAt(ne))&&ne--;const $e=ne+re(x,ne);return[$e-G(x,$e),$e]}t.$pf=K;function ie(x){const ne=new ae(x);let $e=0;for(;!ne.eol();)$e++,ne.nextGraphemeLength();return $e}t.$qf=ie;let fe;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ce(x){return fe||(fe=ye()),fe.test(x)}t.$rf=Ce;const Ae=/^[\t\n\r\x20-\x7E]*$/;function q(x){return Ae.test(x)}t.$sf=q,t.$tf=/[\u2028\u2029]/;function g(x){return t.$tf.test(x)}t.$uf=g;function k(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.$vf=k;function F(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.$wf=F;function r(x,ne,$e=""){const Ee=x.trimStart();if(Ee.length<ne)return Ee;const Re=/\b/g;let je=0;for(;Re.test(Ee)&&!(Ee.length-Re.lastIndex<ne);)je=Re.lastIndex,Re.lastIndex+=1;return je===0?Ee:$e+Ee.substring(je).trimStart()}t.$xf=r;const i=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,o=/\x1b\].*?\x07/g;function w(x){return x&&(x=x.replace(i,"").replace(o,"")),x}t.$yf=w,t.$zf="\uFEFF";function I(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.$Af=I;function C(x){return I(x)?x.substr(1):x}t.$Bf=C;function j(x,ne){if(!x||!ne||x.length<ne.length)return!1;const $e=ne.length,Ee=x.toLowerCase();let Re=0,je=-1;for(;Re<$e;){const Qe=Ee.indexOf(ne[Re],je+1);if(Qe<0)return!1;je=Qe,Re++}return!0}t.$Cf=j;function _(x,ne=!1){return x?(ne&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.$Df=_;function Z(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.$Ef=Z;function oe(x,ne=1){if(ne===0)return"";let $e=-1;do $e=x.indexOf(`
`,$e+1),ne--;while(ne>0&&$e>=0);return $e===-1?x:(x[$e-1]==="\r"&&$e--,x.substr(0,$e))}t.$Ff=oe;function me(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.$Gf=me;function De(x){return we.getInstance().getGraphemeBreakType(x)}t.$Hf=De;function ve(x,ne){return x===0?ne!==5&&ne!==7:x===2&&ne===3?!1:x===4||x===2||x===3||ne===4||ne===2||ne===3?!0:!(x===8&&(ne===8||ne===9||ne===11||ne===12)||(x===11||x===9)&&(ne===9||ne===10)||(x===12||x===10)&&ne===10||ne===5||ne===13||ne===7||x===1||x===13&&ne===14||x===6&&ne===6)}var Se;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(t.GraphemeBreakType=Se={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Te()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const $e=this.d,Ee=$e.length/3;let Re=1;for(;Re<=Ee;)if(ne<$e[3*Re])Re=2*Re;else if(ne>$e[3*Re+1])Re=2*Re+1;else return $e[3*Re+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ie(x,ne){if(x===0)return 0;const $e=Me(x,ne);if($e!==void 0)return $e;const Ee=new J(ne,x);return Ee.prevCodePoint(),Ee.offset}t.$If=Ie;function Me(x,ne){const $e=new J(ne,x);let Ee=$e.prevCodePoint();for(;Xe(Ee)||Ee===65039||Ee===8419;){if($e.offset===0)return;Ee=$e.prevCodePoint()}if(!F(Ee))return;let Re=$e.offset;return Re>0&&$e.prevCodePoint()===8205&&(Re=$e.offset),Re}function Xe(x){return 127995<=x&&x<=127999}var nt;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),t.$Jf="\xA0";class Ke{static{this.c=new T.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new E.$Ie(ne=>{function $e(Ge){const rt=new Map;for(let et=0;et<Ge.length;et+=2)rt.set(Ge[et],Ge[et+1]);return rt}function Ee(Ge,rt){const et=new Map(Ge);for(const[gt,mt]of rt)et.set(gt,mt);return et}function Re(Ge,rt){if(!Ge)return rt;const et=new Map;for(const[gt,mt]of Ge)rt.has(gt)&&et.set(gt,mt);return et}const je=this.c.value;let Qe=ne.filter(Ge=>!Ge.startsWith("_")&&Ge in je);Qe.length===0&&(Qe=["_default"]);let Je;for(const Ge of Qe){const rt=$e(je[Ge]);Je=Re(Je,rt)}const tt=$e(je._common),st=Ee(tt,Je);return new Ke(st)})}static getInstance(ne){return Ke.d.get(Array.from(ne))}static{this.e=new T.$V(()=>Object.keys(Ke.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Ke.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Kf=Ke;class Ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ze.c())),this.d}static isInvisibleCharacter(ne){return Ze.e().has(ne)}static get codePoints(){return Ze.e()}}t.$Lf=Ze}),define(be[35],pe([1,0,32,80,10]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bk=t.$ak=t.$_j=t.$$j=t.FuzzyScore=t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.or=void 0;function H(...C){return function(j,_){for(let Z=0,oe=C.length;Z<oe;Z++){const me=C[Z](j,_);if(me)return me}return null}}t.or=H,t.$Yj=y.bind(void 0,!1),t.$Zj=y.bind(void 0,!0);function y(C,j,_){if(!_||_.length<j.length)return null;let Z;return C?Z=n.$ef(_,j):Z=_.indexOf(j)===0,Z?j.length>0?[{start:0,end:j.length}]:[]:null}function S(C,j){const _=j.toLowerCase().indexOf(C.toLowerCase());return _===-1?null:[{start:_,end:_+C.length}]}t.$1j=S;function m(C,j){return p(C.toLowerCase(),j.toLowerCase(),0,0)}t.$2j=m;function p(C,j,_,Z){if(_===C.length)return[];if(Z===j.length)return null;if(C[_]===j[Z]){let oe=null;return(oe=p(C,j,_+1,Z+1))?d({start:Z,end:Z+1},oe):null}return p(C,j,_,Z+1)}function v(C){return 97<=C&&C<=122}function M(C){return 65<=C&&C<=90}t.$3j=M;function l(C){return 48<=C&&C<=57}function h(C){return C===32||C===9||C===10||C===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(C=>e.add(C.charCodeAt(0)));function s(C){return h(C)||e.has(C)}function f(C,j){return C===j||s(C)&&s(j)}const c=new Map;function a(C){if(c.has(C))return c.get(C);let j;const _=(0,T.$Wj)(C);return _&&(j=_),c.set(C,j),j}function $(C){return v(C)||M(C)||l(C)}function d(C,j){return j.length===0?j=[C]:C.end===j[0].start?j[0].start=C.start:j.unshift(C),j}function b(C,j){for(let _=j;_<C.length;_++){const Z=C.charCodeAt(_);if(M(Z)||l(Z)||_>0&&!$(C.charCodeAt(_-1)))return _}return C.length}function u(C,j,_,Z){if(_===C.length)return[];if(Z===j.length)return null;if(C[_]!==j[Z].toLowerCase())return null;{let oe=null,me=Z+1;for(oe=u(C,j,_+1,Z+1);!oe&&(me=b(j,me))<j.length;)oe=u(C,j,_+1,me),me++;return oe===null?null:d({start:Z,end:Z+1},oe)}}function N(C){let j=0,_=0,Z=0,oe=0,me=0;for(let Te=0;Te<C.length;Te++)me=C.charCodeAt(Te),M(me)&&j++,v(me)&&_++,$(me)&&Z++,l(me)&&oe++;const De=j/C.length,ve=_/C.length,Se=Z/C.length,we=oe/C.length;return{upperPercent:De,lowerPercent:ve,alphaPercent:Se,numericPercent:we}}function B(C){const{upperPercent:j,lowerPercent:_}=C;return _===0&&j>.6}function R(C){const{upperPercent:j,lowerPercent:_,alphaPercent:Z,numericPercent:oe}=C;return _>.2&&j<.8&&Z>.6&&oe<.2}function U(C){let j=0,_=0,Z=0,oe=0;for(let me=0;me<C.length;me++)Z=C.charCodeAt(me),M(Z)&&j++,v(Z)&&_++,h(Z)&&oe++;return(j===0||_===0)&&oe===0?C.length<=30:j<=5}function z(C,j){if(!j||(j=j.trim(),j.length===0)||!U(C))return null;j.length>60&&(j=j.substring(0,60));const _=N(j);if(!R(_)){if(!B(_))return null;j=j.toLowerCase()}let Z=null,oe=0;for(C=C.toLowerCase();oe<j.length&&(Z=u(C,j,0,oe))===null;)oe=b(j,oe+1);return Z}t.$4j=z;function D(C,j,_=!1){if(!j||j.length===0)return null;let Z=null,oe=0;for(C=C.toLowerCase(),j=j.toLowerCase();oe<j.length&&(Z=O(C,j,0,oe,_),Z===null);)oe=W(j,oe+1);return Z}t.$5j=D;function O(C,j,_,Z,oe){let me=0;if(_===C.length)return[];if(Z===j.length)return null;if(!f(C.charCodeAt(_),j.charCodeAt(Z))){const Se=a(C.charCodeAt(_));if(!Se)return null;for(let we=0;we<Se.length;we++)if(!f(Se[we],j.charCodeAt(Z+we)))return null;me+=Se.length-1}let De=null,ve=Z+me+1;if(De=O(C,j,_+1,ve,oe),!oe)for(;!De&&(ve=W(j,ve))<j.length;)De=O(C,j,_+1,ve,oe),ve++;if(!De)return null;if(C.charCodeAt(_)!==j.charCodeAt(Z)){const Se=a(C.charCodeAt(_));if(!Se)return De;for(let we=0;we<Se.length;we++)if(Se[we]!==j.charCodeAt(Z+we))return De}return d({start:Z,end:Z+me+1},De)}function W(C,j){for(let _=j;_<C.length;_++)if(s(C.charCodeAt(_))||_>0&&s(C.charCodeAt(_-1)))return _;return C.length}const A=H(t.$Zj,z,S),P=H(t.$Zj,z,m),L=new E.$Dc(1e4);function Y(C,j,_=!1){if(typeof C!="string"||typeof j!="string")return null;let Z=L.get(C);Z||(Z=new RegExp(n.$Ye(C),"i"),L.set(C,Z));const oe=Z.exec(j);return oe?[{start:oe.index,end:oe.index+oe[0].length}]:_?P(C,j):A(C,j)}t.$6j=Y;function X(C,j){const _=k(C,C.toLowerCase(),0,j,j.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return _?ue(_):null}t.$7j=X;function de(C,j,_,Z,oe,me){const De=Math.min(13,C.length);for(;_<De;_++){const ve=k(C,j,_,Z,oe,me,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ve)return ve}return[0,me]}t.$8j=de;function ue(C){if(typeof C>"u")return[];const j=[],_=C[1];for(let Z=C.length-1;Z>1;Z--){const oe=C[Z]+_,me=j[j.length-1];me&&me.end===oe?me.end=oe+1:j.push({start:oe,end:oe+1})}return j}t.$9j=ue;const te=128;function ge(){const C=[],j=[];for(let _=0;_<=te;_++)j[_]=0;for(let _=0;_<=te;_++)C.push(j.slice(0));return C}function Pe(C){const j=[];for(let _=0;_<=C;_++)j[_]=0;return j}const Ne=Pe(2*te),Be=Pe(2*te),le=ge(),J=ge(),ae=ge(),re=!1;function G(C,j,_,Z,oe){function me(ve,Se,we=" "){for(;ve.length<Se;)ve=we+ve;return ve}let De=` |   |${Z.split("").map(ve=>me(ve,3)).join("|")}
`;for(let ve=0;ve<=_;ve++)ve===0?De+=" |":De+=`${j[ve-1]}|`,De+=C[ve].slice(0,oe+1).map(Se=>me(Se.toString(),3)).join("|")+`
`;return De}function K(C,j,_,Z){C=C.substr(j),_=_.substr(Z),console.log(G(J,C,C.length,_,_.length)),console.log(G(ae,C,C.length,_,_.length)),console.log(G(le,C,C.length,_,_.length))}function ie(C,j){if(j<0||j>=C.length)return!1;const _=C.codePointAt(j);switch(_){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$wf(_)}}function fe(C,j){if(j<0||j>=C.length)return!1;switch(C.charCodeAt(j)){case 32:case 9:return!0;default:return!1}}function ye(C,j,_){return j[C]!==_[C]}function Ce(C,j,_,Z,oe,me,De=!1){for(;j<_&&oe<me;)C[j]===Z[oe]&&(De&&(Ne[j]=oe),j+=1),oe+=1;return j===_}t.$0j=Ce;var Ae;(function(C){C[C.Diag=1]="Diag",C[C.Left=2]="Left",C[C.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var q;(function(C){C.Default=[-100,0];function j(_){return!_||_.length===2&&_[0]===-100&&_[1]===0}C.isDefault=j})(q||(t.FuzzyScore=q={}));class g{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(j,_){this.firstMatchCanBeWeak=j,this.boostFullMatch=_}}t.$$j=g;function k(C,j,_,Z,oe,me,De=g.default){const ve=C.length>te?te:C.length,Se=Z.length>te?te:Z.length;if(_>=ve||me>=Se||ve-_>Se-me||!Ce(j,_,ve,oe,me,Se,!0))return;F(ve,Se,_,me,j,oe);let we=1,Te=1,Ie=_,Me=me;const Xe=[!1];for(we=1,Ie=_;Ie<ve;we++,Ie++){const ne=Ne[Ie],$e=Be[Ie],Ee=Ie+1<ve?Be[Ie+1]:Se;for(Te=ne-me+1,Me=ne;Me<Ee;Te++,Me++){let Re=Number.MIN_SAFE_INTEGER,je=!1;Me<=$e&&(Re=r(C,j,Ie,_,Z,oe,Me,Se,me,le[we-1][Te-1]===0,Xe));let Qe=0;Re!==Number.MAX_SAFE_INTEGER&&(je=!0,Qe=Re+J[we-1][Te-1]);const Je=Me>ne,tt=Je?J[we][Te-1]+(le[we][Te-1]>0?-5:0):0,st=Me>ne+1&&le[we][Te-1]>0,Ge=st?J[we][Te-2]+(le[we][Te-2]>0?-5:0):0;if(st&&(!Je||Ge>=tt)&&(!je||Ge>=Qe))J[we][Te]=Ge,ae[we][Te]=3,le[we][Te]=0;else if(Je&&(!je||tt>=Qe))J[we][Te]=tt,ae[we][Te]=2,le[we][Te]=0;else if(je)J[we][Te]=Qe,ae[we][Te]=1,le[we][Te]=le[we-1][Te-1]+1;else throw new Error("not possible")}}if(re&&K(C,_,Z,me),!Xe[0]&&!De.firstMatchCanBeWeak)return;we--,Te--;const nt=[J[we][Te],me];let Ke=0,Ze=0;for(;we>=1;){let ne=Te;do{const $e=ae[we][ne];if($e===3)ne=ne-2;else if($e===2)ne=ne-1;else break}while(ne>=1);Ke>1&&j[_+we-1]===oe[me+Te-1]&&!ye(ne+me-1,Z,oe)&&Ke+1>le[we][ne]&&(ne=Te),ne===Te?Ke++:Ke=1,Ze||(Ze=ne),we--,Te=ne-1,nt.push(Te)}Se===ve&&De.boostFullMatch&&(nt[0]+=2);const x=Ze-ve;return nt[0]-=x,nt}t.$_j=k;function F(C,j,_,Z,oe,me){let De=C-1,ve=j-1;for(;De>=_&&ve>=Z;)oe[De]===me[ve]&&(Be[De]=ve,De--),ve--}function r(C,j,_,Z,oe,me,De,ve,Se,we,Te){if(j[_]!==me[De])return Number.MIN_SAFE_INTEGER;let Ie=1,Me=!1;return De===_-Z?Ie=C[_]===oe[De]?7:5:ye(De,oe,me)&&(De===0||!ye(De-1,oe,me))?(Ie=C[_]===oe[De]?7:5,Me=!0):ie(me,De)&&(De===0||!ie(me,De-1))?Ie=5:(ie(me,De-1)||fe(me,De-1))&&(Ie=5,Me=!0),Ie>1&&_===Z&&(Te[0]=!0),Me||(Me=ye(De,oe,me)||ie(me,De-1)||fe(me,De-1)),_===Z?De>Se&&(Ie-=Me?3:5):we?Ie+=Me?2:0:Ie+=Me?0:1,De+1===ve&&(Ie-=Me?3:5),Ie}function i(C,j,_,Z,oe,me,De){return w(C,j,_,Z,oe,me,!0,De)}t.$ak=i;function o(C,j,_,Z,oe,me,De){return w(C,j,_,Z,oe,me,!1,De)}t.$bk=o;function w(C,j,_,Z,oe,me,De,ve){let Se=k(C,j,_,Z,oe,me,ve);if(Se&&!De)return Se;if(C.length>=3){const we=Math.min(7,C.length-1);for(let Te=_+1;Te<we;Te++){const Ie=I(C,Te);if(Ie){const Me=k(Ie,Ie.toLowerCase(),_,Z,oe,me,ve);Me&&(Me[0]-=3,(!Se||Me[0]>Se[0])&&(Se=Me))}}}return Se}function I(C,j){if(j+1>=C.length)return;const _=C[j],Z=C[j+1];if(_!==Z)return C.slice(0,j)+Z+_+C.slice(j+2)}}),define(be[49],pe([1,0,10]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5i=t.$4i=t.$3i=t.$2i=t.$1i=t.$Zi=t.$Yi=void 0;function T(c){return n(c,0)}t.$Yi=T;function n(c,a){switch(typeof c){case"object":return c===null?H(349,a):Array.isArray(c)?m(c,a):p(c,a);case"string":return S(c,a);case"boolean":return y(c,a);case"number":return H(c,a);case"undefined":return H(937,a);default:return H(617,a)}}t.$Zi=n;function H(c,a){return(a<<5)-a+c|0}t.$1i=H;function y(c,a){return H(c?433:863,a)}function S(c,a){a=H(149417,a);for(let $=0,d=c.length;$<d;$++)a=H(c.charCodeAt($),a);return a}t.$2i=S;function m(c,a){return a=H(104579,a),c.reduce(($,d)=>n(d,$),a)}function p(c,a){return a=H(181387,a),Object.keys(c).sort().reduce(($,d)=>($=S(d,$),n(c[d],$)),a)}class v{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=n(a,this.g),this.g}}t.$3i=v;var M;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function l(c,a,$=32){const d=$-a,b=~((1<<d)-1);return(c<<a|(b&c)>>>d)>>>0}function h(c,a=0,$=c.byteLength,d=0){for(let b=0;b<$;b++)c[a+b]=d}function e(c,a,$="0"){for(;c.length<a;)c=$+c;return c}function s(c,a=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):e((c>>>0).toString(16),a/4)}t.$4i=s;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const $=a.length;if($===0)return;const d=this.p;let b=this.r,u=this.u,N,B;for(u!==0?(N=u,B=-1,u=0):(N=a.charCodeAt(0),B=0);;){let R=N;if(E.$hf(N))if(B+1<$){const U=a.charCodeAt(B+1);E.$if(U)?(B++,R=E.$jf(N,U)):R=65533}else{u=N;break}else E.$if(N)&&(R=65533);if(b=this.w(d,b,R),B++,B<$)N=a.charCodeAt(B);else break}this.r=b,this.u=u}w(a,$,d){return d<128?a[$++]=d:d<2048?(a[$++]=192|(d&1984)>>>6,a[$++]=128|(d&63)>>>0):d<65536?(a[$++]=224|(d&61440)>>>12,a[$++]=128|(d&4032)>>>6,a[$++]=128|(d&63)>>>0):(a[$++]=240|(d&1835008)>>>18,a[$++]=128|(d&258048)>>>12,a[$++]=128|(d&4032)>>>6,a[$++]=128|(d&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,a[0]=a[64],a[1]=a[65],a[2]=a[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=f.g,$=this.q;for(let D=0;D<64;D+=4)a.setUint32(D,$.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)a.setUint32(D,l(a.getUint32(D-12,!1)^a.getUint32(D-32,!1)^a.getUint32(D-56,!1)^a.getUint32(D-64,!1),1),!1);let d=this.h,b=this.l,u=this.m,N=this.n,B=this.o,R,U,z;for(let D=0;D<80;D++)D<20?(R=b&u|~b&N,U=1518500249):D<40?(R=b^u^N,U=1859775393):D<60?(R=b&u|b&N|u&N,U=2400959708):(R=b^u^N,U=3395469782),z=l(d,5)+R+B+U+a.getUint32(D*4,!1)&4294967295,B=N,N=u,u=l(b,30),b=d,d=z;this.h=this.h+d&4294967295,this.l=this.l+b&4294967295,this.m=this.m+u&4294967295,this.n=this.n+N&4294967295,this.o=this.o+B&4294967295}}t.$5i=f}),define(be[87],pe([1,0,75,49]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6s=t.$5s=t.$4s=void 0;class n{constructor(l){this.a=l}getElements(){const l=this.a,h=new Int32Array(l.length);for(let e=0,s=l.length;e<s;e++)h[e]=l.charCodeAt(e);return h}}t.$4s=n;function H(M,l,h){return new v(new n(M),new n(l)).ComputeDiff(h).changes}t.$5s=H;class y{static Assert(l,h){if(!l)throw new Error(h)}}class S{static Copy(l,h,e,s,f){for(let c=0;c<f;c++)e[s+c]=l[h+c]}static Copy2(l,h,e,s,f){for(let c=0;c<f;c++)e[s+c]=l[h+c]}}var m;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class p{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.$3s(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(l,h){this.b=Math.min(this.b,l),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(l,h){this.b=Math.min(this.b,l),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class v{constructor(l,h,e=null){this.a=e,this.b=l,this.c=h;const[s,f,c]=v.o(l),[a,$,d]=v.o(h);this.d=c&&d,this.e=s,this.f=f,this.g=a,this.h=$,this.k=[],this.m=[]}static n(l){return l.length>0&&typeof l[0]=="string"}static o(l){const h=l.getElements();if(v.n(h)){const e=new Int32Array(h.length);for(let s=0,f=h.length;s<f;s++)e[s]=(0,T.$2i)(h[s],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(l,h){return this.f[l]!==this.h[h]?!1:this.d?this.e[l]===this.g[h]:!0}q(l,h){if(!this.p(l,h))return!1;const e=v.r(this.b,l),s=v.r(this.c,h);return e===s}static r(l,h){return typeof l.getStrictElement=="function"?l.getStrictElement(h):null}s(l,h){return this.f[l]!==this.f[h]?!1:this.d?this.e[l]===this.e[h]:!0}u(l,h){return this.h[l]!==this.h[h]?!1:this.d?this.g[l]===this.g[h]:!0}ComputeDiff(l){return this.v(0,this.f.length-1,0,this.h.length-1,l)}v(l,h,e,s,f){const c=[!1];let a=this.w(l,h,e,s,c);return f&&(a=this.z(a)),{quitEarly:c[0],changes:a}}w(l,h,e,s,f){for(f[0]=!1;l<=h&&e<=s&&this.p(l,e);)l++,e++;for(;h>=l&&s>=e&&this.p(h,s);)h--,s--;if(l>h||e>s){let u;return e<=s?(y.Assert(l===h+1,"originalStart should only be one more than originalEnd"),u=[new E.$3s(l,0,e,s-e+1)]):l<=h?(y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),u=[new E.$3s(l,h-l+1,e,0)]):(y.Assert(l===h+1,"originalStart should only be one more than originalEnd"),y.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),u=[]),u}const c=[0],a=[0],$=this.y(l,h,e,s,c,a,f),d=c[0],b=a[0];if($!==null)return $;if(!f[0]){const u=this.w(l,d,e,b,f);let N=[];return f[0]?N=[new E.$3s(d+1,h-(d+1)+1,b+1,s-(b+1)+1)]:N=this.w(d+1,h,b+1,s,f),this.H(u,N)}return[new E.$3s(l,h-l+1,e,s-e+1)]}x(l,h,e,s,f,c,a,$,d,b,u,N,B,R,U,z,D,O){let W=null,A=null,P=new p,L=h,Y=e,X=B[0]-z[0]-s,de=-1073741824,ue=this.k.length-1;do{const te=X+l;te===L||te<Y&&d[te-1]<d[te+1]?(u=d[te+1],R=u-X-s,u<de&&P.MarkNextChange(),de=u,P.AddModifiedElement(u+1,R),X=te+1-l):(u=d[te-1]+1,R=u-X-s,u<de&&P.MarkNextChange(),de=u-1,P.AddOriginalElement(u,R+1),X=te-1-l),ue>=0&&(d=this.k[ue],l=d[0],L=1,Y=d.length-1)}while(--ue>=-1);if(W=P.getReverseChanges(),O[0]){let te=B[0]+1,ge=z[0]+1;if(W!==null&&W.length>0){const Pe=W[W.length-1];te=Math.max(te,Pe.getOriginalEnd()),ge=Math.max(ge,Pe.getModifiedEnd())}A=[new E.$3s(te,N-te+1,ge,U-ge+1)]}else{P=new p,L=c,Y=a,X=B[0]-z[0]-$,de=1073741824,ue=D?this.m.length-1:this.m.length-2;do{const te=X+f;te===L||te<Y&&b[te-1]>=b[te+1]?(u=b[te+1]-1,R=u-X-$,u>de&&P.MarkNextChange(),de=u+1,P.AddOriginalElement(u+1,R+1),X=te+1-f):(u=b[te-1],R=u-X-$,u>de&&P.MarkNextChange(),de=u,P.AddModifiedElement(u+1,R+1),X=te-1-f),ue>=0&&(b=this.m[ue],f=b[0],L=1,Y=b.length-1)}while(--ue>=-1);A=P.getChanges()}return this.H(W,A)}y(l,h,e,s,f,c,a){let $=0,d=0,b=0,u=0,N=0,B=0;l--,e--,f[0]=0,c[0]=0,this.k=[],this.m=[];const R=h-l+(s-e),U=R+1,z=new Int32Array(U),D=new Int32Array(U),O=s-e,W=h-l,A=l-e,P=h-s,Y=(W-O)%2===0;z[O]=l,D[W]=h,a[0]=!1;for(let X=1;X<=R/2+1;X++){let de=0,ue=0;b=this.J(O-X,X,O,U),u=this.J(O+X,X,O,U);for(let ge=b;ge<=u;ge+=2){ge===b||ge<u&&z[ge-1]<z[ge+1]?$=z[ge+1]:$=z[ge-1]+1,d=$-(ge-O)-A;const Pe=$;for(;$<h&&d<s&&this.p($+1,d+1);)$++,d++;if(z[ge]=$,$+d>de+ue&&(de=$,ue=d),!Y&&Math.abs(ge-W)<=X-1&&$>=D[ge])return f[0]=$,c[0]=d,Pe<=D[ge]&&1447>0&&X<=1448?this.x(O,b,u,A,W,N,B,P,z,D,$,h,f,d,s,c,Y,a):null}const te=(de-l+(ue-e)-X)/2;if(this.a!==null&&!this.a(de,te))return a[0]=!0,f[0]=de,c[0]=ue,te>0&&1447>0&&X<=1448?this.x(O,b,u,A,W,N,B,P,z,D,$,h,f,d,s,c,Y,a):(l++,e++,[new E.$3s(l,h-l+1,e,s-e+1)]);N=this.J(W-X,X,W,U),B=this.J(W+X,X,W,U);for(let ge=N;ge<=B;ge+=2){ge===N||ge<B&&D[ge-1]>=D[ge+1]?$=D[ge+1]-1:$=D[ge-1],d=$-(ge-W)-P;const Pe=$;for(;$>l&&d>e&&this.p($,d);)$--,d--;if(D[ge]=$,Y&&Math.abs(ge-O)<=X&&$<=z[ge])return f[0]=$,c[0]=d,Pe>=z[ge]&&1447>0&&X<=1448?this.x(O,b,u,A,W,N,B,P,z,D,$,h,f,d,s,c,Y,a):null}if(X<=1447){let ge=new Int32Array(u-b+2);ge[0]=O-b+1,S.Copy2(z,b,ge,1,u-b+1),this.k.push(ge),ge=new Int32Array(B-N+2),ge[0]=W-N+1,S.Copy2(D,N,ge,1,B-N+1),this.m.push(ge)}}return this.x(O,b,u,A,W,N,B,P,z,D,$,h,f,d,s,c,Y,a)}z(l){for(let h=0;h<l.length;h++){const e=l[h],s=h<l.length-1?l[h+1].originalStart:this.f.length,f=h<l.length-1?l[h+1].modifiedStart:this.h.length,c=e.originalLength>0,a=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<f&&(!c||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!a||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const d=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!d)break;e.originalStart++,e.modifiedStart++}const $=[null];if(h<l.length-1&&this.I(l[h],l[h+1],$)){l[h]=$[0],l.splice(h+1,1),h--;continue}}for(let h=l.length-1;h>=0;h--){const e=l[h];let s=0,f=0;if(h>0){const u=l[h-1];s=u.originalStart+u.originalLength,f=u.modifiedStart+u.modifiedLength}const c=e.originalLength>0,a=e.modifiedLength>0;let $=0,d=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let u=1;;u++){const N=e.originalStart-u,B=e.modifiedStart-u;if(N<s||B<f||c&&!this.s(N,N+e.originalLength)||a&&!this.u(B,B+e.modifiedLength))break;const U=(N===s&&B===f?5:0)+this.G(N,e.originalLength,B,e.modifiedLength);U>d&&(d=U,$=u)}e.originalStart-=$,e.modifiedStart-=$;const b=[null];if(h>0&&this.I(l[h-1],l[h],b)){l[h-1]=b[0],l.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=l.length;h<e;h++){const s=l[h-1],f=l[h],c=f.originalStart-s.originalStart-s.originalLength,a=s.originalStart,$=f.originalStart+f.originalLength,d=$-a,b=s.modifiedStart,u=f.modifiedStart+f.modifiedLength,N=u-b;if(c<5&&d<20&&N<20){const B=this.A(a,d,b,N,c);if(B){const[R,U]=B;(R!==s.originalStart+s.originalLength||U!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=R-s.originalStart,s.modifiedLength=U-s.modifiedStart,f.originalStart=R+c,f.modifiedStart=U+c,f.originalLength=$-f.originalStart,f.modifiedLength=u-f.modifiedStart)}}}return l}A(l,h,e,s,f){if(h<f||s<f)return null;const c=l+h-f+1,a=e+s-f+1;let $=0,d=0,b=0;for(let u=l;u<c;u++)for(let N=e;N<a;N++){const B=this.B(u,N,f);B>0&&B>$&&($=B,d=u,b=N)}return $>0?[d,b]:null}B(l,h,e){let s=0;for(let f=0;f<e;f++){if(!this.p(l+f,h+f))return 0;s+=this.e[l+f].length}return s}C(l){return l<=0||l>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[l])}D(l,h){if(this.C(l)||this.C(l-1))return!0;if(h>0){const e=l+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(l){return l<=0||l>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[l])}F(l,h){if(this.E(l)||this.E(l-1))return!0;if(h>0){const e=l+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(l,h,e,s){const f=this.D(l,h)?1:0,c=this.F(e,s)?1:0;return f+c}H(l,h){const e=[];if(l.length===0||h.length===0)return h.length>0?h:l;if(this.I(l[l.length-1],h[0],e)){const s=new Array(l.length+h.length-1);return S.Copy(l,0,s,0,l.length-1),s[l.length-1]=e[0],S.Copy(h,1,s,l.length,h.length-1),s}else{const s=new Array(l.length+h.length);return S.Copy(l,0,s,0,l.length),S.Copy(h,0,s,l.length,h.length),s}}I(l,h,e){if(y.Assert(l.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),y.Assert(l.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=h.originalStart||l.modifiedStart+l.modifiedLength>=h.modifiedStart){const s=l.originalStart;let f=l.originalLength;const c=l.modifiedStart;let a=l.modifiedLength;return l.originalStart+l.originalLength>=h.originalStart&&(f=h.originalStart+h.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=h.modifiedStart&&(a=h.modifiedStart+h.modifiedLength-l.modifiedStart),e[0]=new E.$3s(s,f,c,a),!0}else return e[0]=null,!1}J(l,h,e,s){if(l>=0&&l<s)return l;const f=e,c=s-e-1,a=h%2===0;if(l<0){const $=f%2===0;return a===$?0:1}else{const $=c%2===0;return a===$?s-1:s-2}}}t.$6s=v}),define(be[50],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=void 0,t.$Vd=Symbol("MicrotaskDelay")}),define(be[88],pe([1,0,12,10]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ei=t.$di=t.$ci=t.$bi=t.$ai=void 0;class n{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$ai=n;class H{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,T.$0e)(h,this.b,0,h.length,this.c,this.d):(0,T.$_e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$bi=H;class y{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,T.$0e)(h,this.b,0,h.length,this.d,this.e):(0,T.$_e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$ci=y;var S;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(S||(S={}));class m{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new y(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,T.$$e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,T.$$e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,T.$9e)(h,this.c.query);if(this.d[this.e]===5)return(0,T.$9e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$di=m;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(v||(v={}));class M{static forUris(h=()=>!1,e=()=>!1){return new M(new m(h,e))}static forPaths(h=!1){return new M(new y(void 0,!h))}static forStrings(){return new M(new n)}static forConfigKeys(){return new M(new H)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const s=e.slice(0);(0,E.$Xb)(s);for(const f of s)this.set(f,h)}else{const s=h.slice(0);(0,E.$Xb)(s);for(const f of s)this.set(f[0],f[1])}}set(h,e){const s=this.b.reset(h);let f;this.c||(this.c=new p,this.c.segment=s.value());const c=[];for(f=this.c;;){const $=s.cmp(f.segment);if($>0)f.left||(f.left=new p,f.left.segment=s.value()),c.push([-1,f]),f=f.left;else if($<0)f.right||(f.right=new p,f.right.segment=s.value()),c.push([1,f]),f=f.right;else if(s.hasNext())s.next(),f.mid||(f.mid=new p,f.mid.segment=s.value()),c.push([0,f]),f=f.mid;else break}const a=f.value;f.value=e,f.key=h;for(let $=c.length-1;$>=0;$--){const d=c[$][1];d.updateHeight();const b=d.balanceFactor();if(b<-1||b>1){const u=c[$][0],N=c[$+1][0];if(u===1&&N===1)c[$][1]=d.rotateLeft();else if(u===-1&&N===-1)c[$][1]=d.rotateRight();else if(u===1&&N===-1)d.right=c[$+1][1]=c[$+1][1].rotateRight(),c[$][1]=d.rotateLeft();else if(u===-1&&N===1)d.left=c[$+1][1]=c[$+1][1].rotateLeft(),c[$][1]=d.rotateRight();else throw new Error;if($>0)switch(c[$-1][0]){case-1:c[$-1][1].left=c[$][1];break;case 1:c[$-1][1].right=c[$][1];break;case 0:c[$-1][1].mid=c[$][1];break}else this.c=c[0][1]}}return a}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let s=this.c;for(;s;){const f=e.cmp(s.segment);if(f>0)s=s.left;else if(f<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const s=this.b.reset(h),f=[];let c=this.c;for(;c;){const a=s.cmp(c.segment);if(a>0)f.push([-1,c]),c=c.left;else if(a<0)f.push([1,c]),c=c.right;else if(s.hasNext())s.next(),f.push([0,c]),c=c.mid;else break}if(c){if(e?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const a=this.f(c.right);if(a.key){const{key:$,value:d,segment:b}=a;this.e(a.key,!1),c.key=$,c.value=d,c.segment=b}}else{const a=c.left??c.right;if(f.length>0){const[$,d]=f[f.length-1];switch($){case-1:d.left=a;break;case 0:d.mid=a;break;case 1:d.right=a;break}}else this.c=a}for(let a=f.length-1;a>=0;a--){const $=f[a][1];$.updateHeight();const d=$.balanceFactor();if(d>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),f[a][1]=$.rotateLeft()):d<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),f[a][1]=$.rotateRight()),a>0)switch(f[a-1][0]){case-1:f[a-1][1].left=f[a][1];break;case 1:f[a-1][1].right=f[a][1];break;case 0:f[a-1][1].mid=f[a][1];break}else this.c=f[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let s=this.c,f;for(;s;){const c=e.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(e.hasNext())e.next(),f=s.value||f,s=s.mid;else break}return s&&s.value||f}findSuperstr(h){return this.g(h,!1)}g(h,e){const s=this.b.reset(h);let f=this.c;for(;f;){const c=s.cmp(f.segment);if(c>0)f=f.left;else if(c<0)f=f.right;else if(s.hasNext())s.next(),f=f.mid;else return f.mid?this.h(f.mid):e?f.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,s]of this)h(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$ei=M}),define(be[7],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=void 0;function E(b){return typeof b=="string"}t.$Mf=E;function T(b){return Array.isArray(b)&&b.every(u=>E(u))}t.$Nf=T;function n(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}t.$Of=n;function H(b){const u=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof u}t.$Pf=H;function y(b){return typeof b=="number"&&!isNaN(b)}t.$Qf=y;function S(b){return!!b&&typeof b[Symbol.iterator]=="function"}t.$Rf=S;function m(b){return b===!0||b===!1}t.$Sf=m;function p(b){return typeof b>"u"}t.$Tf=p;function v(b){return!M(b)}t.$Uf=v;function M(b){return p(b)||b===null}t.$Vf=M;function l(b,u){if(!b)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}t.$Wf=l;function h(b){if(M(b))throw new Error("Assertion Failed: argument is undefined or null");return b}t.$Xf=h;function e(...b){const u=[];for(let N=0;N<b.length;N++){const B=b[N];if(M(B))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);u.push(B)}return u}t.$Yf=e;const s=Object.prototype.hasOwnProperty;function f(b){if(!n(b))return!1;for(const u in b)if(s.call(b,u))return!1;return!0}t.$Zf=f;function c(b){return typeof b=="function"}t.$1f=c;function a(...b){return b.length>0&&b.every(c)}t.$2f=a;function $(b,u){const N=Math.min(b.length,u.length);for(let B=0;B<N;B++)d(b[B],u[B])}t.$3f=$;function d(b,u){if(E(u)){if(typeof b!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(c(u)){try{if(b instanceof u)return}catch{}if(!M(b)&&b.constructor===u||u.length===1&&u.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$4f=d}),define(be[17],pe([1,0,7]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ek=t.$dk=t.$ck=void 0;const T=Object.create(null);function n(S,m){if((0,E.$Mf)(m)){const p=T[m];if(p===void 0)throw new Error(`${S} references an unknown codicon: ${m}`);m=p}return T[S]=m,{id:S}}function H(){return T}t.$ck=H;function y(){return Object.values(t.$ek)}t.$dk=y,t.$ek={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugBreakpointPending:n("debug-breakpoint-pending",60377),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),gitStash:n("git-stash",60454),gitStashApply:n("git-stash-apply",60455),gitStashPop:n("git-stash-pop",60456),coverage:n("coverage",60462),runAllCoverage:n("run-all-coverage",60461),runCoverage:n("run-all-coverage",60460),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(be[51],pe([1,0,7]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mn=t.$Ln=t.$Kn=t.$Jn=t.$In=t.$Hn=t.$Gn=t.$Fn=t.$En=t.$Dn=t.$Cn=t.$Bn=void 0;function T(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const a=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,d])=>{a[$]=d&&typeof d=="object"?T(d):d}),a}t.$Bn=T;function n(c){if(!c||typeof c!="object")return c;const a=[c];for(;a.length>0;){const $=a.shift();Object.freeze($);for(const d in $)if(H.call($,d)){const b=$[d];typeof b=="object"&&!Object.isFrozen(b)&&!(0,E.$Pf)(b)&&a.push(b)}}return c}t.$Cn=n;const H=Object.prototype.hasOwnProperty;function y(c,a){return S(c,a,new Set)}t.$Dn=y;function S(c,a,$){if((0,E.$Vf)(c))return c;const d=a(c);if(typeof d<"u")return d;if(Array.isArray(c)){const b=[];for(const u of c)b.push(S(u,a,$));return b}if((0,E.$Of)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const b={};for(const u in c)H.call(c,u)&&(b[u]=S(c[u],a,$));return $.delete(c),b}return c}function m(c,a,$=!0){return(0,E.$Of)(c)?((0,E.$Of)(a)&&Object.keys(a).forEach(d=>{d in c?$&&((0,E.$Of)(c[d])&&(0,E.$Of)(a[d])?m(c[d],a[d],$):c[d]=a[d]):c[d]=a[d]}),c):a}t.$En=m;function p(c,a){if(c===a)return!0;if(c==null||a===null||a===void 0||typeof c!=typeof a||typeof c!="object"||Array.isArray(c)!==Array.isArray(a))return!1;let $,d;if(Array.isArray(c)){if(c.length!==a.length)return!1;for($=0;$<c.length;$++)if(!p(c[$],a[$]))return!1}else{const b=[];for(d in c)b.push(d);b.sort();const u=[];for(d in a)u.push(d);if(u.sort(),!p(b,u))return!1;for($=0;$<b.length;$++)if(!p(c[b[$]],a[b[$]]))return!1}return!0}t.$Fn=p;function v(c){const a=new Set;return JSON.stringify(c,($,d)=>{if((0,E.$Of)(d)||Array.isArray(d)){if(a.has(d))return"[Circular]";a.add(d)}return d})}t.$Gn=v;function M(c,a){const $=Object.create(null);return!c||!a||Object.keys(a).forEach(b=>{const u=c[b],N=a[b];p(u,N)||($[b]=N)}),$}t.$Hn=M;function l(c,a){const $=a.toLowerCase(),d=Object.keys(c).find(b=>b.toLowerCase()===$);return d?c[d]:c[a]}t.$In=l;function h(c,a){const $=Object.create(null);for(const[d,b]of Object.entries(c))a(d,b)&&($[d]=b);return $}t.$Jn=h;function e(c){let a=[];for(;Object.prototype!==c;)a=a.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return a}t.$Kn=e;function s(c){const a=[];for(const $ of e(c))typeof c[$]=="function"&&a.push($);return a}t.$Ln=s;function f(c,a){const $=b=>function(){const u=Array.prototype.slice.call(arguments,0);return a(b,u)},d={};for(const b of c)d[b]=$(b);return d}t.$Mn=f}),define(be[18],pe([1,0,17]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$fk=t.ThemeColor=void 0;var T;(function(y){function S(m){return m&&typeof m=="object"&&typeof m.id=="string"}y.isThemeColor=S})(T||(t.ThemeColor=T={}));function n(y){return{id:y}}t.$fk=n;var H;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function m(a){const $=S.exec(a.id);if(!$)return m(E.$ek.error);const[,d,b]=$,u=["codicon","codicon-"+d];return b&&u.push("codicon-modifier-"+b.substring(1)),u}y.asClassNameArray=m;function p(a){return m(a).join(" ")}y.asClassName=p;function v(a){return"."+m(a).join(".")}y.asCSSSelector=v;function M(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||T.isThemeColor(a.color))}y.isThemeIcon=M;const l=new RegExp(`^\\$\\((${y.iconNameExpression}(?:${y.iconModifierExpression})?)\\)$`);function h(a){const $=l.exec(a);if(!$)return;const[,d]=$;return{id:d}}y.fromString=h;function e(a){return{id:a}}y.fromId=e;function s(a,$){let d=a.id;const b=d.lastIndexOf("~");return b!==-1&&(d=d.substring(0,b)),$&&(d=`${d}~${$}`),{id:d}}y.modify=s;function f(a){const $=a.id.lastIndexOf("~");if($!==-1)return a.id.substring($+1)}y.getModifier=f;function c(a,$){return a.id===$.id&&a.color?.id===$.color?.id}y.isEqual=c})(H||(t.ThemeIcon=H={}))}),define(be[36],pe([1,0,35,10,18]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lk=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=void 0;const H="$(",y=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${y.source}`,"g");function m(c){return c.replace(S,(a,$)=>$?a:`\\${a}`)}t.$gk=m;const p=new RegExp(`\\\\${y.source}`,"g");function v(c){return c.replace(p,a=>`\\${a}`)}t.$hk=v;const M=new RegExp(`(\\s)?(\\\\)?${y.source}(\\s)?`,"g");function l(c){return c.indexOf(H)===-1?c:c.replace(M,(a,$,d,b)=>d?a:$||b||"")}t.$ik=l;function h(c){return c?c.replace(/\$\((.*?)\)/g,(a,$)=>` ${$} `).trim():""}t.$jk=h;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(c){e.lastIndex=0;let a="";const $=[];let d=0;for(;;){const b=e.lastIndex,u=e.exec(c),N=c.substring(b,u?.index);if(N.length>0){a+=N;for(let B=0;B<N.length;B++)$.push(d)}if(!u)break;d+=u[0].length}return{text:a,iconOffsets:$}}t.$kk=s;function f(c,a,$=!1){const{text:d,iconOffsets:b}=a;if(!b||b.length===0)return(0,E.$6j)(c,d,$);const u=(0,T.$We)(d," "),N=d.length-u.length,B=(0,E.$6j)(c,u,$);if(B)for(const R of B){const U=b[R.start+N]+N;R.start+=U,R.end+=U}return B}t.$lk=f}),define(be[89],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4U=t.$3U=void 0,t.$3U="vscode:contextmenu",t.$4U="vscode:onCloseContextMenu"}),define(be[90],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$U=void 0;class E{constructor(n,H){this.a=n,this.onMessage=H}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$$U=E}),define(be[30],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const E=globalThis.vscode;t.$O=E.ipcRenderer,t.$P=E.ipcMessagePort,t.$Q=E.webFrame,t.$R=E.process,t.$S=E.context}),define(be[91],pe([1,0,89,30]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7U=void 0;let n=0;function H(S,m,p){const v=[],M=n++,l=`vscode:onContextMenu${M}`,h=(e,s,f)=>{v[s].click?.(f)};T.$O.once(l,h),T.$O.once(E.$4U,(e,s)=>{s===M&&(T.$O.removeListener(l,h),p?.())}),T.$O.send(E.$3U,M,S.map(e=>y(e,v)),l,m)}t.$7U=H;function y(S,m){const p={id:m.length,label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:typeof S.enabled=="boolean"?S.enabled:!0,visible:typeof S.visible=="boolean"?S.visible:!0};return m.push(S),Array.isArray(S.submenu)&&(p.submenu=S.submenu.map(v=>y(v,m))),p}}),define(be[52],pe([8]),{}),define(be[92],pe([8]),{}),define(be[93],pe([8]),{}),define(be[94],pe([8]),{}),define(be[95],pe([1,0,93,94]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[96],pe([8]),{}),define(be[97],pe([8]),{}),define(be[98],pe([8]),{}),define(be[99],pe([8]),{}),define(be[100],pe([8]),{}),define(be[101],pe([8]),{}),define(be[102],pe([8]),{}),define(be[103],pe([8]),{}),define(be[104],pe([8]),{}),define(be[105],pe([13,11]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[106],pe([13,11]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[107],pe([13,11]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[108],pe([13,11]),function(se,t){return se.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[109],pe([13,11]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[110],pe([13,11]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[111],pe([13,11]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[112],pe([13,11]),function(se,t){return se.create("vs/base/common/actions",t)}),define(be[37],pe([1,0,4,3,112]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ui=t.$Ti=t.$Si=t.$Ri=t.$Qi=t.$Pi=void 0;class H extends T.$Tc{constructor(l,h="",e="",s=!0,f){super(),this.h=this.B(new E.$Yd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=h,this.u=e,this.w=s,this.C=f}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,h){this.C&&await this.C(l)}}t.$Pi=H;class y extends T.$Tc{constructor(){super(...arguments),this.f=this.B(new E.$Yd),this.onWillRun=this.f.event,this.m=this.B(new E.$Yd),this.onDidRun=this.m.event}async run(l,h){if(!l.enabled)return;this.f.fire({action:l});let e;try{await this.u(l,h)}catch(s){e=s}this.m.fire({action:l,error:e})}async u(l,h){await l.run(h)}}t.$Qi=y;class S{constructor(){this.id=S.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let h=[];for(const e of l)e.length&&(h.length?h=[...h,new S,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$Ri=S;class m{get actions(){return this.a}constructor(l,h,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=h,this.class=s,this.a=e}async run(){}}t.$Si=m;class p extends H{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,n.localize(0,null),void 0,!1)}}t.$Ti=p;function v(M){return{id:M.id,label:M.label,class:M.class,enabled:M.enabled??!0,checked:M.checked,run:async(...l)=>M.run(...l),tooltip:M.label}}t.$Ui=v}),define(be[113],pe([13,11]),function(se,t){return se.create("vs/base/common/platform",t)}),define(be[5],pe([1,0,113]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let T=!1,n=!1,H=!1,y=!1,S=!1,m=!1,p=!1,v=!1,M=!1,l=!1,h,e=t.$g,s=t.$g,f,c;const a=globalThis;let $;typeof a.vscode<"u"&&typeof a.vscode.process<"u"?$=a.vscode.process:typeof process<"u"&&($=process);const d=typeof $?.versions?.electron=="string",b=d&&$?.type==="renderer";if(typeof $=="object"){T=$.platform==="win32",n=$.platform==="darwin",H=$.platform==="linux",y=H&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=d,M=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$g,e=t.$g;const A=$.env.VSCODE_NLS_CONFIG;if(A)try{const P=JSON.parse(A),L=P.availableLanguages["*"];h=P.locale,s=P.osLocale,e=L||t.$g,f=P._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!b?(c=navigator.userAgent,T=c.indexOf("Windows")>=0,n=c.indexOf("Macintosh")>=0,v=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=c.indexOf("Linux")>=0,l=c?.indexOf("Mobi")>=0,m=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||t.$g,e=h,s=navigator.language):console.error("Unable to resolve platform.");var u;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(u||(t.Platform=u={}));function N(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=N;let B=0;n?B=1:T?B=3:H&&(B=2),t.$i=T,t.$j=n,t.$k=H,t.$l=y,t.$m=S,t.$n=p,t.$o=m,t.$p=m&&typeof a.importScripts=="function",t.$q=t.$p?a.origin:void 0,t.$r=v,t.$s=l,t.$t=M,t.$u=B,t.$v=c,t.$w=e;var R;(function(A){function P(){return t.$w}A.value=P;function L(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}A.isDefaultVariant=L;function Y(){return t.$w==="en"}A.isDefault=Y})(R||(t.Language=R={})),t.$x=h,t.$y=s,t.$z=f,t.$A=typeof a.postMessage=="function"&&!a.importScripts,t.$B=(()=>{if(t.$A){const A=[];a.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let Y=0,X=A.length;Y<X;Y++){const de=A[Y];if(de.id===L.data.vscodeScheduleAsyncWork){A.splice(Y,1),de.callback();return}}});let P=0;return L=>{const Y=++P;A.push({id:Y,callback:L}),a.postMessage({vscodeScheduleAsyncWork:Y},"*")}}return A=>setTimeout(A)})();var U;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(U||(t.OperatingSystem=U={})),t.OS=n||v?2:T?1:3;let z=!0,D=!1;function O(){if(!D){D=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,z=new Uint16Array(A.buffer)[0]===513}return z}t.$D=O,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function W(A){return parseFloat(A)>=20}t.$J=W}),define(be[114],pe([1,0,16,21,5]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2P=t.KeyboardSupport=void 0;var H;(function(y){y[y.Always=0]="Always",y[y.FullScreen=1]="FullScreen",y[y.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$2P={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:n.$m||E.$ZP()?0:navigator.keyboard||E.$VP?1:2,touch:"ontouchstart"in T.$FP||navigator.maxTouchPoints>0,pointerEvents:T.$FP.PointerEvent&&("ontouchstart"in T.$FP||navigator.maxTouchPoints>0)}}),define(be[14],pe([1,0,16,45,78,5]),function(se,t,E,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0P=t.$9P=t.$8P=void 0;function y(e){if(e.charCode){const f=String.fromCharCode(e.charCode).toUpperCase();return T.KeyCodeUtils.fromString(f)}const s=e.keyCode;if(s===3)return 7;if(E.$SP)switch(s){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(E.$TP){if(H.$j&&s===93)return 57;if(!H.$j&&s===92)return 57}return T.$7q[s]||0}const S=H.$j?256:2048,m=512,p=1024,v=H.$j?2048:256;function M(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$8P=M;function l(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${T.KeyCodeUtils.toString(e.keyCode)}')`}t.$9P=l;class h{constructor(s){this._standardKeyboardEventBrand=!0;const f=s;this.browserEvent=f,this.target=f.target,this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,this.altGraphKey=f.getModifierState("AltGraph"),this.keyCode=y(f),this.code=f.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let f=0;return this.ctrlKey&&(f|=S),this.altKey&&(f|=m),this.shiftKey&&(f|=p),this.metaKey&&(f|=v),f|=s,f}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$cr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$0P=h}),define(be[19],pe([1,0,16,69,5]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7P=t.$6P=t.$5P=void 0;class H{constructor(p,v){this.timestamp=Date.now(),this.browserEvent=v,this.leftButton=v.button===0,this.middleButton=v.button===1,this.rightButton=v.button===2,this.buttons=v.buttons,this.target=v.target,this.detail=v.detail||1,v.type==="dblclick"&&(this.detail=2),this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,typeof v.pageX=="number"?(this.posx=v.pageX,this.posy=v.pageY):(this.posx=v.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=v.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const M=T.$3P.getPositionOfChildWindowRelativeToAncestorWindow(p,v.view);this.posx-=M.left,this.posy-=M.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$5P=H;class y extends H{constructor(p,v){super(p,v),this.dataTransfer=v.dataTransfer}}t.$6P=y;class S{constructor(p,v=0,M=0){this.browserEvent=p||null,this.target=p?p.target||p.targetNode||p.srcElement:null,this.deltaY=M,this.deltaX=v;let l=!1;if(E.$UP){const h=navigator.userAgent.match(/Chrome\/(\d+)/);l=(h?parseInt(h[1]):123)<=122}if(p){const h=p,e=p,s=p.view?.devicePixelRatio||1;if(typeof h.wheelDeltaY<"u")l?this.deltaY=h.wheelDeltaY/(120*s):this.deltaY=h.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(p.type==="wheel"){const f=p;f.deltaMode===f.DOM_DELTA_LINE?E.$SP&&!n.$j?this.deltaY=-p.deltaY/3:this.deltaY=-p.deltaY:this.deltaY=-p.deltaY/40}if(typeof h.wheelDeltaX<"u")E.$VP&&n.$i?this.deltaX=-(h.wheelDeltaX/120):l?this.deltaX=h.wheelDeltaX/(120*s):this.deltaX=h.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-p.detail/3;else if(p.type==="wheel"){const f=p;f.deltaMode===f.DOM_DELTA_LINE?E.$SP&&!n.$j?this.deltaX=-p.deltaX/3:this.deltaX=-p.deltaX:this.deltaX=-p.deltaX/40}this.deltaY===0&&this.deltaX===0&&p.wheelDelta&&(l?this.deltaY=p.wheelDelta/(120*s):this.deltaY=p.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$7P=S}),define(be[115],pe([1,0,5]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let T;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const H=n.process;T={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return E.$i?"win32":E.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.$dc=T.platform,t.$ec=T.arch}),define(be[24],pe([1,0,115]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const T=65,n=97,H=90,y=122,S=46,m=47,p=92,v=58,M=63;class l extends Error{constructor(N,B,R){let U;typeof B=="string"&&B.indexOf("not ")===0?(U="must not be",B=B.replace(/^not /,"")):U="must be";const z=N.indexOf(".")!==-1?"property":"argument";let D=`The "${N}" ${z} ${U} of type ${B}`;D+=`. Received type ${typeof R}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,N){if(u===null||typeof u!="object")throw new l(N,"Object",u)}function e(u,N){if(typeof u!="string")throw new l(N,"string",u)}const s=E.$dc==="win32";function f(u){return u===m||u===p}function c(u){return u===m}function a(u){return u>=T&&u<=H||u>=n&&u<=y}function $(u,N,B,R){let U="",z=0,D=-1,O=0,W=0;for(let A=0;A<=u.length;++A){if(A<u.length)W=u.charCodeAt(A);else{if(R(W))break;W=m}if(R(W)){if(!(D===A-1||O===1))if(O===2){if(U.length<2||z!==2||U.charCodeAt(U.length-1)!==S||U.charCodeAt(U.length-2)!==S){if(U.length>2){const P=U.lastIndexOf(B);P===-1?(U="",z=0):(U=U.slice(0,P),z=U.length-1-U.lastIndexOf(B)),D=A,O=0;continue}else if(U.length!==0){U="",z=0,D=A,O=0;continue}}N&&(U+=U.length>0?`${B}..`:"..",z=2)}else U.length>0?U+=`${B}${u.slice(D+1,A)}`:U=u.slice(D+1,A),z=A-D-1;D=A,O=0}else W===S&&O!==-1?++O:O=-1}return U}function d(u,N){h(N,"pathObject");const B=N.dir||N.root,R=N.base||`${N.name||""}${N.ext||""}`;return B?B===N.root?`${B}${R}`:`${B}${u}${R}`:R}t.$fc={resolve(...u){let N="",B="",R=!1;for(let U=u.length-1;U>=-1;U--){let z;if(U>=0){if(z=u[U],e(z,"path"),z.length===0)continue}else N.length===0?z=E.cwd():(z=E.env[`=${N}`]||E.cwd(),(z===void 0||z.slice(0,2).toLowerCase()!==N.toLowerCase()&&z.charCodeAt(2)===p)&&(z=`${N}\\`));const D=z.length;let O=0,W="",A=!1;const P=z.charCodeAt(0);if(D===1)f(P)&&(O=1,A=!0);else if(f(P))if(A=!0,f(z.charCodeAt(1))){let L=2,Y=L;for(;L<D&&!f(z.charCodeAt(L));)L++;if(L<D&&L!==Y){const X=z.slice(Y,L);for(Y=L;L<D&&f(z.charCodeAt(L));)L++;if(L<D&&L!==Y){for(Y=L;L<D&&!f(z.charCodeAt(L));)L++;(L===D||L!==Y)&&(W=`\\\\${X}\\${z.slice(Y,L)}`,O=L)}}}else O=1;else a(P)&&z.charCodeAt(1)===v&&(W=z.slice(0,2),O=2,D>2&&f(z.charCodeAt(2))&&(A=!0,O=3));if(W.length>0)if(N.length>0){if(W.toLowerCase()!==N.toLowerCase())continue}else N=W;if(R){if(N.length>0)break}else if(B=`${z.slice(O)}\\${B}`,R=A,A&&N.length>0)break}return B=$(B,!R,"\\",f),R?`${N}\\${B}`:`${N}${B}`||"."},normalize(u){e(u,"path");const N=u.length;if(N===0)return".";let B=0,R,U=!1;const z=u.charCodeAt(0);if(N===1)return c(z)?"\\":u;if(f(z))if(U=!0,f(u.charCodeAt(1))){let O=2,W=O;for(;O<N&&!f(u.charCodeAt(O));)O++;if(O<N&&O!==W){const A=u.slice(W,O);for(W=O;O<N&&f(u.charCodeAt(O));)O++;if(O<N&&O!==W){for(W=O;O<N&&!f(u.charCodeAt(O));)O++;if(O===N)return`\\\\${A}\\${u.slice(W)}\\`;O!==W&&(R=`\\\\${A}\\${u.slice(W,O)}`,B=O)}}}else B=1;else a(z)&&u.charCodeAt(1)===v&&(R=u.slice(0,2),B=2,N>2&&f(u.charCodeAt(2))&&(U=!0,B=3));let D=B<N?$(u.slice(B),!U,"\\",f):"";return D.length===0&&!U&&(D="."),D.length>0&&f(u.charCodeAt(N-1))&&(D+="\\"),R===void 0?U?`\\${D}`:D:U?`${R}\\${D}`:`${R}${D}`},isAbsolute(u){e(u,"path");const N=u.length;if(N===0)return!1;const B=u.charCodeAt(0);return f(B)||N>2&&a(B)&&u.charCodeAt(1)===v&&f(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let N,B;for(let z=0;z<u.length;++z){const D=u[z];e(D,"path"),D.length>0&&(N===void 0?N=B=D:N+=`\\${D}`)}if(N===void 0)return".";let R=!0,U=0;if(typeof B=="string"&&f(B.charCodeAt(0))){++U;const z=B.length;z>1&&f(B.charCodeAt(1))&&(++U,z>2&&(f(B.charCodeAt(2))?++U:R=!1))}if(R){for(;U<N.length&&f(N.charCodeAt(U));)U++;U>=2&&(N=`\\${N.slice(U)}`)}return t.$fc.normalize(N)},relative(u,N){if(e(u,"from"),e(N,"to"),u===N)return"";const B=t.$fc.resolve(u),R=t.$fc.resolve(N);if(B===R||(u=B.toLowerCase(),N=R.toLowerCase(),u===N))return"";let U=0;for(;U<u.length&&u.charCodeAt(U)===p;)U++;let z=u.length;for(;z-1>U&&u.charCodeAt(z-1)===p;)z--;const D=z-U;let O=0;for(;O<N.length&&N.charCodeAt(O)===p;)O++;let W=N.length;for(;W-1>O&&N.charCodeAt(W-1)===p;)W--;const A=W-O,P=D<A?D:A;let L=-1,Y=0;for(;Y<P;Y++){const de=u.charCodeAt(U+Y);if(de!==N.charCodeAt(O+Y))break;de===p&&(L=Y)}if(Y!==P){if(L===-1)return R}else{if(A>P){if(N.charCodeAt(O+Y)===p)return R.slice(O+Y+1);if(Y===2)return R.slice(O+Y)}D>P&&(u.charCodeAt(U+Y)===p?L=Y:Y===2&&(L=3)),L===-1&&(L=0)}let X="";for(Y=U+L+1;Y<=z;++Y)(Y===z||u.charCodeAt(Y)===p)&&(X+=X.length===0?"..":"\\..");return O+=L,X.length>0?`${X}${R.slice(O,W)}`:(R.charCodeAt(O)===p&&++O,R.slice(O,W))},toNamespacedPath(u){if(typeof u!="string"||u.length===0)return u;const N=t.$fc.resolve(u);if(N.length<=2)return u;if(N.charCodeAt(0)===p){if(N.charCodeAt(1)===p){const B=N.charCodeAt(2);if(B!==M&&B!==S)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(a(N.charCodeAt(0))&&N.charCodeAt(1)===v&&N.charCodeAt(2)===p)return`\\\\?\\${N}`;return u},dirname(u){e(u,"path");const N=u.length;if(N===0)return".";let B=-1,R=0;const U=u.charCodeAt(0);if(N===1)return f(U)?u:".";if(f(U)){if(B=R=1,f(u.charCodeAt(1))){let O=2,W=O;for(;O<N&&!f(u.charCodeAt(O));)O++;if(O<N&&O!==W){for(W=O;O<N&&f(u.charCodeAt(O));)O++;if(O<N&&O!==W){for(W=O;O<N&&!f(u.charCodeAt(O));)O++;if(O===N)return u;O!==W&&(B=R=O+1)}}}}else a(U)&&u.charCodeAt(1)===v&&(B=N>2&&f(u.charCodeAt(2))?3:2,R=B);let z=-1,D=!0;for(let O=N-1;O>=R;--O)if(f(u.charCodeAt(O))){if(!D){z=O;break}}else D=!1;if(z===-1){if(B===-1)return".";z=B}return u.slice(0,z)},basename(u,N){N!==void 0&&e(N,"ext"),e(u,"path");let B=0,R=-1,U=!0,z;if(u.length>=2&&a(u.charCodeAt(0))&&u.charCodeAt(1)===v&&(B=2),N!==void 0&&N.length>0&&N.length<=u.length){if(N===u)return"";let D=N.length-1,O=-1;for(z=u.length-1;z>=B;--z){const W=u.charCodeAt(z);if(f(W)){if(!U){B=z+1;break}}else O===-1&&(U=!1,O=z+1),D>=0&&(W===N.charCodeAt(D)?--D===-1&&(R=z):(D=-1,R=O))}return B===R?R=O:R===-1&&(R=u.length),u.slice(B,R)}for(z=u.length-1;z>=B;--z)if(f(u.charCodeAt(z))){if(!U){B=z+1;break}}else R===-1&&(U=!1,R=z+1);return R===-1?"":u.slice(B,R)},extname(u){e(u,"path");let N=0,B=-1,R=0,U=-1,z=!0,D=0;u.length>=2&&u.charCodeAt(1)===v&&a(u.charCodeAt(0))&&(N=R=2);for(let O=u.length-1;O>=N;--O){const W=u.charCodeAt(O);if(f(W)){if(!z){R=O+1;break}continue}U===-1&&(z=!1,U=O+1),W===S?B===-1?B=O:D!==1&&(D=1):B!==-1&&(D=-1)}return B===-1||U===-1||D===0||D===1&&B===U-1&&B===R+1?"":u.slice(B,U)},format:d.bind(null,"\\"),parse(u){e(u,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return N;const B=u.length;let R=0,U=u.charCodeAt(0);if(B===1)return f(U)?(N.root=N.dir=u,N):(N.base=N.name=u,N);if(f(U)){if(R=1,f(u.charCodeAt(1))){let L=2,Y=L;for(;L<B&&!f(u.charCodeAt(L));)L++;if(L<B&&L!==Y){for(Y=L;L<B&&f(u.charCodeAt(L));)L++;if(L<B&&L!==Y){for(Y=L;L<B&&!f(u.charCodeAt(L));)L++;L===B?R=L:L!==Y&&(R=L+1)}}}}else if(a(U)&&u.charCodeAt(1)===v){if(B<=2)return N.root=N.dir=u,N;if(R=2,f(u.charCodeAt(2))){if(B===3)return N.root=N.dir=u,N;R=3}}R>0&&(N.root=u.slice(0,R));let z=-1,D=R,O=-1,W=!0,A=u.length-1,P=0;for(;A>=R;--A){if(U=u.charCodeAt(A),f(U)){if(!W){D=A+1;break}continue}O===-1&&(W=!1,O=A+1),U===S?z===-1?z=A:P!==1&&(P=1):z!==-1&&(P=-1)}return O!==-1&&(z===-1||P===0||P===1&&z===O-1&&z===D+1?N.base=N.name=u.slice(D,O):(N.name=u.slice(D,z),N.base=u.slice(D,O),N.ext=u.slice(z,O))),D>0&&D!==R?N.dir=u.slice(0,D-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(s){const u=/\\/g;return()=>{const N=E.cwd().replace(u,"/");return N.slice(N.indexOf("/"))}}return()=>E.cwd()})();t.$gc={resolve(...u){let N="",B=!1;for(let R=u.length-1;R>=-1&&!B;R--){const U=R>=0?u[R]:b();e(U,"path"),U.length!==0&&(N=`${U}/${N}`,B=U.charCodeAt(0)===m)}return N=$(N,!B,"/",c),B?`/${N}`:N.length>0?N:"."},normalize(u){if(e(u,"path"),u.length===0)return".";const N=u.charCodeAt(0)===m,B=u.charCodeAt(u.length-1)===m;return u=$(u,!N,"/",c),u.length===0?N?"/":B?"./":".":(B&&(u+="/"),N?`/${u}`:u)},isAbsolute(u){return e(u,"path"),u.length>0&&u.charCodeAt(0)===m},join(...u){if(u.length===0)return".";let N;for(let B=0;B<u.length;++B){const R=u[B];e(R,"path"),R.length>0&&(N===void 0?N=R:N+=`/${R}`)}return N===void 0?".":t.$gc.normalize(N)},relative(u,N){if(e(u,"from"),e(N,"to"),u===N||(u=t.$gc.resolve(u),N=t.$gc.resolve(N),u===N))return"";const B=1,R=u.length,U=R-B,z=1,D=N.length-z,O=U<D?U:D;let W=-1,A=0;for(;A<O;A++){const L=u.charCodeAt(B+A);if(L!==N.charCodeAt(z+A))break;L===m&&(W=A)}if(A===O)if(D>O){if(N.charCodeAt(z+A)===m)return N.slice(z+A+1);if(A===0)return N.slice(z+A)}else U>O&&(u.charCodeAt(B+A)===m?W=A:A===0&&(W=0));let P="";for(A=B+W+1;A<=R;++A)(A===R||u.charCodeAt(A)===m)&&(P+=P.length===0?"..":"/..");return`${P}${N.slice(z+W)}`},toNamespacedPath(u){return u},dirname(u){if(e(u,"path"),u.length===0)return".";const N=u.charCodeAt(0)===m;let B=-1,R=!0;for(let U=u.length-1;U>=1;--U)if(u.charCodeAt(U)===m){if(!R){B=U;break}}else R=!1;return B===-1?N?"/":".":N&&B===1?"//":u.slice(0,B)},basename(u,N){N!==void 0&&e(N,"ext"),e(u,"path");let B=0,R=-1,U=!0,z;if(N!==void 0&&N.length>0&&N.length<=u.length){if(N===u)return"";let D=N.length-1,O=-1;for(z=u.length-1;z>=0;--z){const W=u.charCodeAt(z);if(W===m){if(!U){B=z+1;break}}else O===-1&&(U=!1,O=z+1),D>=0&&(W===N.charCodeAt(D)?--D===-1&&(R=z):(D=-1,R=O))}return B===R?R=O:R===-1&&(R=u.length),u.slice(B,R)}for(z=u.length-1;z>=0;--z)if(u.charCodeAt(z)===m){if(!U){B=z+1;break}}else R===-1&&(U=!1,R=z+1);return R===-1?"":u.slice(B,R)},extname(u){e(u,"path");let N=-1,B=0,R=-1,U=!0,z=0;for(let D=u.length-1;D>=0;--D){const O=u.charCodeAt(D);if(O===m){if(!U){B=D+1;break}continue}R===-1&&(U=!1,R=D+1),O===S?N===-1?N=D:z!==1&&(z=1):N!==-1&&(z=-1)}return N===-1||R===-1||z===0||z===1&&N===R-1&&N===B+1?"":u.slice(N,R)},format:d.bind(null,"/"),parse(u){e(u,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return N;const B=u.charCodeAt(0)===m;let R;B?(N.root="/",R=1):R=0;let U=-1,z=0,D=-1,O=!0,W=u.length-1,A=0;for(;W>=R;--W){const P=u.charCodeAt(W);if(P===m){if(!O){z=W+1;break}continue}D===-1&&(O=!1,D=W+1),P===S?U===-1?U=W:A!==1&&(A=1):U!==-1&&(A=-1)}if(D!==-1){const P=z===0&&B?1:z;U===-1||A===0||A===1&&U===D-1&&U===z+1?N.base=N.name=u.slice(P,D):(N.name=u.slice(P,U),N.base=u.slice(P,D),N.ext=u.slice(U,D))}return z>0?N.dir=u.slice(0,z-1):B&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define(be[116],pe([1,0,24,5,10,7]),function(se,t,E,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hg=t.$gg=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=void 0;function y(z){return z===47||z===92}t.$5f=y;function S(z){return z.replace(/[\\/]/g,E.$gc.sep)}t.$6f=S;function m(z){return z.indexOf("/")===-1&&(z=S(z)),/^[a-zA-Z]:(\/|$)/.test(z)&&(z="/"+z),z}t.$7f=m;function p(z,D=E.$gc.sep){if(!z)return"";const O=z.length,W=z.charCodeAt(0);if(y(W)){if(y(z.charCodeAt(1))&&!y(z.charCodeAt(2))){let P=3;const L=P;for(;P<O&&!y(z.charCodeAt(P));P++);if(L!==P&&!y(z.charCodeAt(P+1))){for(P+=1;P<O;P++)if(y(z.charCodeAt(P)))return z.slice(0,P+1).replace(/[\\/]/g,D)}}return D}else if(c(W)&&z.charCodeAt(1)===58)return y(z.charCodeAt(2))?z.slice(0,2)+D:z.slice(0,2);let A=z.indexOf("://");if(A!==-1){for(A+=3;A<O;A++)if(y(z.charCodeAt(A)))return z.slice(0,A+1)}return""}t.$8f=p;function v(z){if(!T.$i||!z||z.length<5)return!1;let D=z.charCodeAt(0);if(D!==92||(D=z.charCodeAt(1),D!==92))return!1;let O=2;const W=O;for(;O<z.length&&(D=z.charCodeAt(O),D!==92);O++);return!(W===O||(D=z.charCodeAt(O+1),isNaN(D)||D===92))}t.$9f=v;const M=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(z,D=T.$i){const O=D?M:l;return!(!z||z.length===0||/^\s+$/.test(z)||(O.lastIndex=0,O.test(z))||D&&h.test(z)||z==="."||z===".."||D&&z[z.length-1]==="."||D&&z.length!==z.trim().length||z.length>255)}t.$0f=e;function s(z,D,O){const W=z===D;return!O||W?W:!z||!D?!1:(0,n.$df)(z,D)}t.$$f=s;function f(z,D,O,W=E.sep){if(z===D)return!0;if(!z||!D||D.length>z.length)return!1;if(O){if(!(0,n.$ef)(z,D))return!1;if(D.length===z.length)return!0;let P=D.length;return D.charAt(D.length-1)===W&&P--,z.charAt(P)===W}return D.charAt(D.length-1)!==W&&(D+=W),z.indexOf(D)===0}t.$_f=f;function c(z){return z>=65&&z<=90||z>=97&&z<=122}t.$ag=c;function a(z,D){return T.$i&&z.endsWith(":")&&(z+=E.sep),(0,E.$ic)(z)||(z=(0,E.$jc)(D,z)),z=(0,E.$hc)(z),T.$i?(z=(0,n.$Xe)(z,E.sep),z.endsWith(":")&&(z+=E.sep)):(z=(0,n.$Xe)(z,E.sep),z||(z=E.sep)),z}t.$bg=a;function $(z){const D=(0,E.$hc)(z);return T.$i?z.length>3?!1:d(D)&&(z.length===2||D.charCodeAt(2)===92):D===E.$gc.sep}t.$cg=$;function d(z,D=T.$i){return D?c(z.charCodeAt(0))&&z.charCodeAt(1)===58:!1}t.$dg=d;function b(z,D=T.$i){return d(z,D)?z[0]:void 0}t.$eg=b;function u(z,D,O){return D.length>z.length?-1:z===D?0:(O&&(z=z.toLowerCase(),D=D.toLowerCase()),z.indexOf(D))}t.$fg=u;function N(z){const D=z.split(":");let O,W,A;for(const P of D){const L=Number(P);(0,H.$Qf)(L)?W===void 0?W=L:A===void 0&&(A=L):O=O?[O,P].join(":"):P}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:W!==void 0?W:void 0,column:A!==void 0?A:W!==void 0?1:void 0}}t.$gg=N;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U(z,D,O=8){let W="";for(let P=0;P<O;P++){let L;P===0&&T.$i&&!D&&(O===3||O===4)?L=R:L=B,W+=L.charAt(Math.floor(Math.random()*L.length))}let A;return D?A=`${D}-${W}`:A=W,z?(0,E.$jc)(z,A):A}t.$hg=U}),define(be[117],pe([1,0,24]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$os=t.$ns=t.$ms=t.$ls=t.$ks=void 0,t.$ks=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(v){const M=(0,E.$oc)(v),l=T[M.toLowerCase()];return l!==void 0?l:y(v)}t.$ls=H;function y(v){const M=(0,E.$oc)(v);return n[M.toLowerCase()]}t.$ms=y;function S(v){for(const M in n)if(n[M]===v)return M}t.$ns=S;const m=/^(.+)\/(.+?)(;.+)?$/;function p(v,M){const l=m.exec(v);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:M?void 0:v}t.$os=p}),define(be[15],pe([1,0,24,5]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,H=/^\//,y=/^\/\//;function S(R,U){if(!R.scheme&&U)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!n.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!H.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(R,U){return!R&&!U?"file":R}function p(R,U){switch(R){case"https":case"http":case"file":U?U[0]!==M&&(U=M+U):U=M;break}return U}const v="",M="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(U){return U instanceof h?!0:U?typeof U.authority=="string"&&typeof U.fragment=="string"&&typeof U.path=="string"&&typeof U.query=="string"&&typeof U.scheme=="string"&&typeof U.fsPath=="string"&&typeof U.with=="function"&&typeof U.toString=="function":!1}constructor(U,z,D,O,W,A=!1){typeof U=="object"?(this.scheme=U.scheme||v,this.authority=U.authority||v,this.path=U.path||v,this.query=U.query||v,this.fragment=U.fragment||v):(this.scheme=m(U,A),this.authority=z||v,this.path=p(this.scheme,D||v),this.query=O||v,this.fragment=W||v,S(this,A))}get fsPath(){return d(this,!1)}with(U){if(!U)return this;let{scheme:z,authority:D,path:O,query:W,fragment:A}=U;return z===void 0?z=this.scheme:z===null&&(z=v),D===void 0?D=this.authority:D===null&&(D=v),O===void 0?O=this.path:O===null&&(O=v),W===void 0?W=this.query:W===null&&(W=v),A===void 0?A=this.fragment:A===null&&(A=v),z===this.scheme&&D===this.authority&&O===this.path&&W===this.query&&A===this.fragment?this:new f(z,D,O,W,A)}static parse(U,z=!1){const D=l.exec(U);return D?new f(D[2]||v,B(D[4]||v),B(D[5]||v),B(D[7]||v),B(D[9]||v),z):new f(v,v,v,v,v)}static file(U){let z=v;if(T.$i&&(U=U.replace(/\\/g,M)),U[0]===M&&U[1]===M){const D=U.indexOf(M,2);D===-1?(z=U.substring(2),U=M):(z=U.substring(2,D),U=U.substring(D)||M)}return new f("file",z,U,v,v)}static from(U,z){return new f(U.scheme,U.authority,U.path,U.query,U.fragment,z)}static joinPath(U,...z){if(!U.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return T.$i&&U.scheme==="file"?D=h.file(E.$fc.join(d(U,!0),...z)).path:D=E.$gc.join(U.path,...z),U.with({path:D})}toString(U=!1){return b(this,U)}toJSON(){return this}static revive(U){if(U){if(U instanceof h)return U;{const z=new f(U);return z._formatted=U.external??null,z._fsPath=U._sep===s?U.fsPath??null:null,z}}else return U}}t.URI=h;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$vc=e;const s=T.$i?1:void 0;class f extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(U=!1){return U?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const U={$mid:1};return this._fsPath&&(U.fsPath=this._fsPath,U._sep=s),this._formatted&&(U.external=this._formatted),this.path&&(U.path=this.path),this.scheme&&(U.scheme=this.scheme),this.authority&&(U.authority=this.authority),this.query&&(U.query=this.query),this.fragment&&(U.fragment=this.fragment),U}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function a(R,U,z){let D,O=-1;for(let W=0;W<R.length;W++){const A=R.charCodeAt(W);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||U&&A===47||z&&A===91||z&&A===93||z&&A===58)O!==-1&&(D+=encodeURIComponent(R.substring(O,W)),O=-1),D!==void 0&&(D+=R.charAt(W));else{D===void 0&&(D=R.substr(0,W));const P=c[A];P!==void 0?(O!==-1&&(D+=encodeURIComponent(R.substring(O,W)),O=-1),D+=P):O===-1&&(O=W)}}return O!==-1&&(D+=encodeURIComponent(R.substring(O))),D!==void 0?D:R}function $(R){let U;for(let z=0;z<R.length;z++){const D=R.charCodeAt(z);D===35||D===63?(U===void 0&&(U=R.substr(0,z)),U+=c[D]):U!==void 0&&(U+=R[z])}return U!==void 0?U:R}function d(R,U){let z;return R.authority&&R.path.length>1&&R.scheme==="file"?z=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?U?z=R.path.substr(1):z=R.path[1].toLowerCase()+R.path.substr(2):z=R.path,T.$i&&(z=z.replace(/\//g,"\\")),z}t.$wc=d;function b(R,U){const z=U?$:a;let D="",{scheme:O,authority:W,path:A,query:P,fragment:L}=R;if(O&&(D+=O,D+=":"),(W||O==="file")&&(D+=M,D+=M),W){let Y=W.indexOf("@");if(Y!==-1){const X=W.substr(0,Y);W=W.substr(Y+1),Y=X.lastIndexOf(":"),Y===-1?D+=z(X,!1,!1):(D+=z(X.substr(0,Y),!1,!1),D+=":",D+=z(X.substr(Y+1),!1,!0)),D+="@"}W=W.toLowerCase(),Y=W.lastIndexOf(":"),Y===-1?D+=z(W,!1,!0):(D+=z(W.substr(0,Y),!1,!0),D+=W.substr(Y))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const Y=A.charCodeAt(1);Y>=65&&Y<=90&&(A=`/${String.fromCharCode(Y+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const Y=A.charCodeAt(0);Y>=65&&Y<=90&&(A=`${String.fromCharCode(Y+32)}:${A.substr(2)}`)}D+=z(A,!0,!1)}return P&&(D+="?",D+=z(P,!1,!1)),L&&(D+="#",D+=U?L:a(L,!1,!1)),D}function u(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+u(R.substr(3)):R}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function B(R){return R.match(N)?R.replace(N,U=>u(U)):R}}),define(be[53],pe([1,0,34,15]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hh=t.$Gh=t.$Fh=void 0;function n(m){return JSON.stringify(m,y)}t.$Fh=n;function H(m){let p=JSON.parse(m);return p=S(p),p}t.$Gh=H;function y(m,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function S(m,p=0){if(!m||p>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return T.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof E.$me||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let v=0;v<m.length;++v)m[v]=S(m[v],p+1);else for(const v in m)Object.hasOwnProperty.call(m,v)&&(m[v]=S(m[v],p+1))}return m}t.$Hh=S}),define(be[31],pe([1,0,6,5,10,15]),function(se,t,E,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.Schemas=void 0;var y;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.codeSetting="code-setting"})(y||(t.Schemas=y={}));function S(l,h){return H.URI.isUri(l)?(0,n.$df)(l.scheme,h):(0,n.$ef)(l,h+":")}t.$ig=S;function m(l,...h){return h.some(e=>S(l,e))}t.$jg=m,t.$kg="vscode-tkn",t.$lg="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${y.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${y.vscodeRemoteResource}`}set(h,e,s){this.a[h]=e,this.b[h]=s}setConnectionToken(h,e){this.c[h]=e}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch($){return E.$1($),h}const e=h.authority;let s=this.a[e];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const f=this.b[e],c=this.c[e];let a=`path=${encodeURIComponent(h.path)}`;return typeof c=="string"&&(a+=`&${t.$lg}=${encodeURIComponent(c)}`),H.URI.from({scheme:T.$o?this.d:y.vscodeRemoteResource,authority:`${s}:${f}`,path:this.f,query:a})}}t.$mg=new p,t.$ng="vs/../../extensions",t.$og="vs/../../node_modules",t.$pg="vs/../../node_modules.asar",t.$qg="vs/../../node_modules.asar.unpacked",t.$rg="vscode-app";class v{static{this.a=t.$rg}asBrowserUri(h){const e=this.b(h,se);return this.uriToBrowserUri(e)}uriToBrowserUri(h){return h.scheme===y.vscodeRemote?t.$mg.rewrite(h):h.scheme===y.file&&(T.$m||T.$q===`${y.vscodeFileResource}://${v.a}`)?h.with({scheme:y.vscodeFileResource,authority:h.authority||v.a,query:null,fragment:null}):h}asFileUri(h){const e=this.b(h,se);return this.uriToFileUri(e)}uriToFileUri(h){return h.scheme===y.vscodeFileResource?h.with({scheme:y.file,authority:h.authority!==v.a?h.authority:null,query:null,fragment:null}):h}b(h,e){return H.URI.isUri(h)?h:H.URI.parse(e.toUrl(h))}}t.$sg=new v;var M;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const e="vscode-coi";function s(c){let a;typeof c=="string"?a=new URL(c).searchParams:c instanceof URL?a=c.searchParams:H.URI.isUri(c)&&(a=new URL(c.toString(!0)).searchParams);const $=a?.get(e);if($)return h.get($)}l.getHeadersFromQuery=s;function f(c,a,$){if(!globalThis.crossOriginIsolated)return;const d=a&&$?"3":$?"2":"1";c instanceof URLSearchParams?c.set(e,d):c[e]=d}l.addSearchParam=f})(M||(t.COI=M={}))}),define(be[38],pe([1,0,116,31,24,5,10,15]),function(se,t,E,T,n,H,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vg=t.DataUri=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=void 0;function m(h){return(0,S.$wc)(h,!0)}t.$zg=m;class p{constructor(e){this.a=e}compare(e,s,f=!1){return e===s?0:(0,y.$9e)(this.getComparisonKey(e,f),this.getComparisonKey(s,f))}isEqual(e,s,f=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,f)===this.getComparisonKey(s,f)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,f=!1){if(e.scheme===s.scheme){if(e.scheme===T.Schemas.file)return E.$_f(m(e),m(s),this.a(e))&&e.query===s.query&&(f||e.fragment===s.fragment);if((0,t.$Qg)(e.authority,s.authority))return E.$_f(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(f||e.fragment===s.fragment)}return!1}joinPath(e,...s){return S.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Ig)(e)||e.authority}basename(e){return n.$gc.basename(e.path)}extname(e){return n.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===T.Schemas.file?s=S.URI.file(n.$mc(m(e))).path:(s=n.$gc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===T.Schemas.file?s=S.URI.file(n.$hc(m(e))).path:s=n.$gc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Qg)(e.authority,s.authority))return;if(e.scheme===T.Schemas.file){const a=n.$lc(m(e),m(s));return H.$i?E.$6f(a):a}let f=e.path||"/";const c=s.path||"/";if(this.a(e)){let a=0;for(const $=Math.min(f.length,c.length);a<$&&!(f.charCodeAt(a)!==c.charCodeAt(a)&&f.charAt(a).toLowerCase()!==c.charAt(a).toLowerCase());a++);f=c.substr(0,a)+f.substr(a)}return n.$gc.relative(f,c)}resolvePath(e,s){if(e.scheme===T.Schemas.file){const f=S.URI.file(n.$kc(m(e),s));return e.with({authority:f.authority,path:f.path})}return s=E.$7f(s),e.with({path:n.$gc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,y.$df)(e,s)}hasTrailingPathSeparator(e,s=n.sep){if(e.scheme===T.Schemas.file){const f=m(e);return f.length>E.$8f(f).length&&f[f.length-1]===s}else{const f=e.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=n.sep){return(0,t.$Rg)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=n.sep){let f=!1;if(e.scheme===T.Schemas.file){const c=m(e);f=c!==void 0&&c.length===E.$8f(c).length&&c[c.length-1]===s}else{s="/";const c=e.path;f=c.length===1&&c.charCodeAt(c.length-1)===47}return!f&&!(0,t.$Rg)(e,s)?e.with({path:e.path+"/"}):e}}t.$Ag=p,t.$Bg=new p(()=>!1),t.$Cg=new p(h=>h.scheme===T.Schemas.file?!H.$k:!0),t.$Dg=new p(h=>!0),t.$Eg=t.$Bg.isEqual.bind(t.$Bg),t.$Fg=t.$Bg.isEqualOrParent.bind(t.$Bg),t.$Gg=t.$Bg.getComparisonKey.bind(t.$Bg),t.$Hg=t.$Bg.basenameOrAuthority.bind(t.$Bg),t.$Ig=t.$Bg.basename.bind(t.$Bg),t.$Jg=t.$Bg.extname.bind(t.$Bg),t.$Kg=t.$Bg.dirname.bind(t.$Bg),t.$Lg=t.$Bg.joinPath.bind(t.$Bg),t.$Mg=t.$Bg.normalizePath.bind(t.$Bg),t.$Ng=t.$Bg.relativePath.bind(t.$Bg),t.$Og=t.$Bg.resolvePath.bind(t.$Bg),t.$Pg=t.$Bg.isAbsolutePath.bind(t.$Bg),t.$Qg=t.$Bg.isEqualAuthority.bind(t.$Bg),t.$Rg=t.$Bg.hasTrailingPathSeparator.bind(t.$Bg),t.$Sg=t.$Bg.removeTrailingPathSeparator.bind(t.$Bg),t.$Tg=t.$Bg.addTrailingPathSeparator.bind(t.$Bg);function v(h,e){const s=[];for(let f=0;f<h.length;f++){const c=e(h[f]);h.some((a,$)=>$===f?!1:(0,t.$Fg)(c,e(a)))||s.push(h[f])}return s}t.$Ug=v;var M;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(s){const f=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach($=>{const[d,b]=$.split(":");d&&b&&f.set(d,b)});const a=s.path.substring(0,s.path.indexOf(";"));return a&&f.set(h.META_DATA_MIME,a),f}h.parseMetaData=e})(M||(t.DataUri=M={}));function l(h,e,s){if(e){let f=h.path;return f&&f[0]!==n.$gc.sep&&(f=n.$gc.sep+f),h.with({scheme:s,authority:e,path:f})}return h.with({scheme:s})}t.$Vg=l}),define(be[9],pe([1,0,29,6,4,3,38,5,50,23]),function(se,t,E,T,n,H,y,S,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bh=t.$Ah=t.$zh=t.$yh=t.$xh=t.$wh=t.Promises=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=void 0;function v(F){return!!F&&typeof F.then=="function"}t.$Wg=v;function M(F){const r=new E.$9d,i=F(r.token),o=new Promise((w,I)=>{const C=r.token.onCancellationRequested(()=>{C.dispose(),I(new T.$5)});Promise.resolve(i).then(j=>{C.dispose(),r.dispose(),w(j)},j=>{C.dispose(),r.dispose(),I(j)})});return new class{cancel(){r.cancel(),r.dispose()}then(w,I){return o.then(w,I)}catch(w){return this.then(void 0,w)}finally(w){return o.finally(w)}}}t.$Xg=M;function l(F,r,i){return new Promise((o,w)=>{const I=r.onCancellationRequested(()=>{I.dispose(),o(i)});F.then(o,w).finally(()=>I.dispose())})}t.$Yg=l;function h(F,r){return new Promise((i,o)=>{const w=r.onCancellationRequested(()=>{w.dispose(),o(new T.$5)});F.then(i,o).finally(()=>w.dispose())})}t.$Zg=h;async function e(F){let r=-1;const i=F.map((o,w)=>o.then(I=>(r=w,I)));try{return await Promise.race(i)}finally{F.forEach((o,w)=>{w!==r&&o.cancel()})}}t.$1g=e;function s(F,r,i){let o;const w=setTimeout(()=>{o?.(void 0),i?.()},r);return Promise.race([F.finally(()=>clearTimeout(w)),new Promise(I=>o=I)])}t.$2g=s;function f(F){return new Promise((r,i)=>{const o=F();v(o)?o.then(r,i):r(o)})}t.$3g=f;function c(){let F,r;return{promise:new Promise((o,w)=>{F=o,r=w}),resolve:F,reject:r}}t.$4g=c;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const i=()=>{if(this.b=null,this.f)return;const o=this.queue(this.d);return this.d=null,o};this.b=new Promise(o=>{this.a.then(i,i).then(o)})}return new Promise((i,o)=>{this.b.then(i,o)})}return this.a=r(),new Promise((i,o)=>{this.a.then(w=>{this.a=null,i(w)},w=>{this.a=null,o(w)})})}dispose(){this.f=!0}}t.$5g=a;class ${constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}t.$6g=$;class d{constructor(){this.a=new Map}queue(r,i){const w=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(i).finally(()=>{this.a.get(r)===w&&this.a.delete(r)});return this.a.set(r,w),w}}t.$7g=d;const b=(F,r)=>{let i=!0;const o=setTimeout(()=>{i=!1,r()},F);return{isTriggered:()=>i,dispose:()=>{clearTimeout(o),i=!1}}},u=F=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,F())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class N{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,i=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((w,I)=>{this.d=w,this.f=I}).then(()=>{if(this.b=null,this.d=null,this.g){const w=this.g;return this.g=null,w()}}));const o=()=>{this.a=null,this.d?.(null)};return this.a=i===m.$Vd?u(o):b(i,o),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$8g=N;class B{constructor(r){this.a=new N(r),this.b=new a}trigger(r,i){return this.a.trigger(()=>this.b.queue(r),i)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$9g=B;class R{constructor(){this.a=!1,this.b=new Promise((r,i)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$0g=R;class U extends R{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}t.$$g=U;function z(F,r){return r?new Promise((i,o)=>{const w=setTimeout(()=>{I.dispose(),i()},F),I=r.onCancellationRequested(()=>{clearTimeout(w),I.dispose(),o(new T.$5)})}):M(i=>z(F,i))}t.$_g=z;function D(F,r=0,i){const o=setTimeout(()=>{F(),i&&w.dispose()},r),w=(0,H.$Rc)(()=>{clearTimeout(o),i?.deleteAndLeak(w)});return i?.add(w),w}t.$ah=D;function O(F){const r=[];let i=0;const o=F.length;function w(){return i<o?F[i++]():null}function I(C){C!=null&&r.push(C);const j=w();return j?j.then(I):Promise.resolve(r)}return Promise.resolve(null).then(I)}t.$bh=O;function W(F,r=o=>!!o,i=null){let o=0;const w=F.length,I=()=>{if(o>=w)return Promise.resolve(i);const C=F[o++];return Promise.resolve(C()).then(_=>r(_)?Promise.resolve(_):I())};return I()}t.$ch=W;function A(F,r=o=>!!o,i=null){if(F.length===0)return Promise.resolve(i);let o=F.length;const w=()=>{o=-1;for(const I of F)I.cancel?.()};return new Promise((I,C)=>{for(const j of F)j.then(_=>{--o>=0&&r(_)?(w(),I(_)):o===0&&I(i)}).catch(_=>{--o>=0&&(w(),C(_))})})}t.$dh=A;class P{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new n.$Yd}whenIdle(){return this.size>0?n.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((i,o)=>{this.g.push({factory:r,c:i,e:o}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const i=r.factory();i.then(r.c,r.e),i.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$eh=P;class L extends P{constructor(){super(1)}}t.$fh=L;class Y{constructor(){this.a=new ae,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}t.$gh=Y;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new K;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,i=y.$Bg){const o=i.getComparisonKey(r);return this.a.get(o)?.size??0}queueFor(r,i,o=y.$Bg){const w=o.getComparisonKey(r);let I=this.a.get(w);if(!I){I=new L;const C=this.f++,j=n.Event.once(I.onDrained)(()=>{I?.dispose(),this.a.delete(w),this.h(),this.d?.deleteAndDispose(C),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$3c),this.d.set(C,j),this.a.set(w,I)}return I.queue(i)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$hh=X;class de{constructor(r,i){this.a=-1,typeof r=="function"&&typeof i=="number"&&this.setIfNotSet(r,i)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,i){this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},i)}setIfNotSet(r,i){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},i))}}t.$ih=de;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,i,o=globalThis){this.cancel();const w=o.setInterval(()=>{r()},i);this.d=(0,H.$Rc)(()=>{o.clearInterval(w),this.d=void 0})}dispose(){this.cancel()}}t.$jh=ue;class te{constructor(r,i){this.b=-1,this.a=r,this.d=i,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$kh=te;class ge{constructor(r,i){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.a=r,this.b=i,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$lh=ge;class Pe extends te{constructor(r,i){super(r,i),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}t.$mh=Pe;class Ne extends H.$Tc{constructor(r,i){super(),this.g=r,this.h=i,this.a=[],this.b=this.B(new H.$Uc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const i of r)this.a.push(i);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$nh=Ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$ph=(F,r)=>{(0,S.$B)(()=>{if(i)return;const o=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,o-Date.now())}}))});let i=!1;return{dispose(){i||(i=!0)}}}:t.$ph=(F,r,i)=>{const o=F.requestIdleCallback(r,typeof i=="number"?{timeout:i}:void 0);let w=!1;return{dispose(){w||(w=!0,F.cancelIdleCallback(o))}}},t.$oh=F=>(0,t.$ph)(globalThis,F)}();class Be{constructor(r,i){this.g=!1,this.d=()=>{try{this.j=i()}catch(o){this.l=o}finally{this.g=!0}},this.f=(0,t.$ph)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$qh=Be;class le extends Be{constructor(r){super(globalThis,r)}}t.$rh=le;async function J(F,r,i){let o;for(let w=0;w<i;w++)try{return await F()}catch(I){o=I,await z(r)}throw o}t.$sh=J;class ae{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,i,o){return this.a={taskId:r,cancel:()=>o?.(),promise:i},i.then(()=>this.d(r),()=>this.d(r)),i}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:i,resolve:o,reject:w}=c();this.b={run:r,promise:i,promiseResolve:o,promiseReject:w}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$th=ae;class re{constructor(r,i=()=>Date.now()){this.d=r,this.f=i,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}t.$uh=re;var G;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(G||(G={}));class K{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((r,i)=>{this.a=r,this.b=i})}complete(r){return new Promise(i=>{this.a(r),this.d={outcome:0,value:r},i()})}error(r){return new Promise(i=>{this.b(r),this.d={outcome:1,value:r},i()})}cancel(){return this.error(new T.$5)}}t.$vh=K;var ie;(function(F){async function r(o){let w;const I=await Promise.all(o.map(C=>C.then(j=>j,j=>{w||(w=j)})));if(typeof w<"u")throw w;return I}F.settled=r;function i(o){return new Promise(async(w,I)=>{try{await o(w,I)}catch(C){I(C)}})}F.withAsyncBody=i})(ie||(t.Promises=ie={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(i=>(this.a=i,this.d=!0,i),i=>{throw this.b=i,this.d=!0,i})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$wh=fe;class ye{constructor(r){this.b=r,this.a=new p.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$xh=ye;var Ce;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(Ce||(Ce={}));class Ae{static fromArray(r){return new Ae(i=>{i.emitMany(r)})}static fromPromise(r){return new Ae(async i=>{i.emitMany(await r)})}static fromPromises(r){return new Ae(async i=>{await Promise.all(r.map(async o=>i.emitOne(await o)))})}static merge(r){return new Ae(async i=>{await Promise.all(r.map(async o=>{for await(const w of o)i.emitOne(w)}))})}static{this.EMPTY=Ae.fromArray([])}constructor(r){this.a=0,this.b=[],this.d=null,this.f=new n.$Yd,queueMicrotask(async()=>{const i={emitOne:o=>this.g(o),emitMany:o=>this.h(o),reject:o=>this.k(o)};try{await Promise.resolve(r(i)),this.j()}catch(o){this.k(o)}finally{i.emitOne=void 0,i.emitMany=void 0,i.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(r,i){return new Ae(async o=>{for await(const w of r)o.emitOne(i(w))})}map(r){return Ae.map(this,r)}static filter(r,i){return new Ae(async o=>{for await(const w of r)i(w)&&o.emitOne(w)})}filter(r){return Ae.filter(this,r)}static coalesce(r){return Ae.filter(r,i=>!!i)}coalesce(){return Ae.coalesce(this)}static async toPromise(r){const i=[];for await(const o of r)i.push(o);return i}toPromise(){return Ae.toPromise(this)}g(r){this.a===0&&(this.b.push(r),this.f.fire())}h(r){this.a===0&&(this.b=this.b.concat(r),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(r){this.a===0&&(this.a=2,this.d=r,this.f.fire())}}t.$yh=Ae;class q extends Ae{constructor(r,i){super(i),this.l=r}cancel(){this.l.cancel()}}t.$zh=q;function g(F){const r=new E.$9d,i=F(r.token);return new q(r,async o=>{const w=r.token.onCancellationRequested(()=>{w.dispose(),r.dispose(),o.reject(new T.$5)});try{for await(const I of i){if(r.token.isCancellationRequested)return;o.emitOne(I)}w.dispose(),r.dispose()}catch(I){w.dispose(),r.dispose(),o.reject(I)}})}t.$Ah=g;class k{constructor(){this.a=new K,this.b=new Ae(o=>{if(r){o.reject(r);return}return i&&o.emitMany(i),this.d=w=>o.reject(w),this.f=w=>o.emitOne(w),this.a.p});let r,i;this.f=o=>{i||(i=[]),i.push(o)},this.d=o=>{r||(r=o)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}t.$Bh=k}),define(be[2],pe([1,0,16,114,14,19,9,6,4,118,3,31,5,15,49,21]),function(se,t,E,T,n,H,y,S,m,p,v,M,l,h,e,s){"use strict";var f;Object.defineProperty(t,"__esModule",{value:!0}),t.$GR=t.$FR=t.h=t.$DR=t.$CR=t.$BR=t.$AR=t.$zR=t.$yR=t.$xR=t.$wR=t.DetectedFullscreenMode=t.$vR=t.$uR=t.$tR=t.$sR=t.$rR=t.$qR=t.$pR=t.$oR=t.$nR=t.$mR=t.$lR=t.$kR=t.$jR=t.$iR=t.$hR=t.$gR=t.$fR=t.$=t.Namespace=t.$dR=t.$cR=t.$bR=t.$aR=t.$_Q=t.$$Q=t.$0Q=t.$9Q=t.$8Q=t.$7Q=t.$6Q=t.$5Q=t.$4Q=t.$3Q=t.$2Q=t.$1Q=t.$ZQ=t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,f=function(){const Q=new Map;(0,s.$EP)(s.$FP,1);const V={window:s.$FP,disposables:new v.$Sc};Q.set(s.$FP.vscodeWindowId,V);const ee=new m.$Yd,ce=new m.$Yd,ke=new m.$Yd;function Ue(Oe,We){return(typeof Oe=="number"?Q.get(Oe):void 0)??(We?V:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:ke.event,onDidUnregisterWindow:ce.event,registerWindow(Oe){if(Q.has(Oe.vscodeWindowId))return v.$Tc.None;const We=new v.$Sc,qe={window:Oe,disposables:We.add(new v.$Sc)};return Q.set(Oe.vscodeWindowId,qe),We.add((0,v.$Rc)(()=>{Q.delete(Oe.vscodeWindowId),ce.fire(Oe)})),We.add($(Oe,t.$7Q.BEFORE_UNLOAD,()=>{ke.fire(Oe)})),ee.fire(qe),We},getWindows(){return Q.values()},getWindowsCount(){return Q.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return Q.has(Oe)},getWindowById:Ue,getWindow(Oe){const We=Oe;if(We?.ownerDocument?.defaultView)return We.ownerDocument.defaultView.window;const qe=Oe;return qe?.view?qe.view.window:s.$FP},getDocument(Oe){const We=Oe;return(0,t.getWindow)(We).document}}}(),t.registerWindow=f.registerWindow,t.getWindow=f.getWindow,t.getDocument=f.getDocument,t.getWindows=f.getWindows,t.getWindowsCount=f.getWindowsCount,t.getWindowId=f.getWindowId,t.getWindowById=f.getWindowById,t.hasWindow=f.hasWindow,t.onDidRegisterWindow=f.onDidRegisterWindow,t.onWillUnregisterWindow=f.onWillUnregisterWindow,t.onDidUnregisterWindow=f.onDidUnregisterWindow;function c(Q){for(;Q.firstChild;)Q.firstChild.remove()}t.$_P=c;class a{constructor(V,ee,ce,ke){this.f=V,this.g=ee,this.d=ce,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function $(Q,V,ee,ce){return new a(Q,V,ee,ce)}t.$aQ=$;function d(Q,V){return function(ee){return V(new H.$5P(Q,ee))}}function b(Q){return function(V){return Q(new n.$0P(V))}}const u=function(V,ee,ce,ke){let Ue=ce;return ee==="click"||ee==="mousedown"?Ue=d((0,t.getWindow)(V),ce):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(Ue=b(ce)),$(V,ee,Ue,ke)};t.$bQ=u;const N=function(V,ee,ce){const ke=d((0,t.getWindow)(V),ee);return R(V,ke,ce)};t.$cQ=N;const B=function(V,ee,ce){const ke=d((0,t.getWindow)(V),ee);return z(V,ke,ce)};t.$dQ=B;function R(Q,V,ee){return $(Q,l.$r&&T.$2P.pointerEvents?t.$7Q.POINTER_DOWN:t.$7Q.MOUSE_DOWN,V,ee)}t.$eQ=R;function U(Q,V,ee){return $(Q,l.$r&&T.$2P.pointerEvents?t.$7Q.POINTER_MOVE:t.$7Q.MOUSE_MOVE,V,ee)}t.$fQ=U;function z(Q,V,ee){return $(Q,l.$r&&T.$2P.pointerEvents?t.$7Q.POINTER_UP:t.$7Q.MOUSE_UP,V,ee)}t.$gQ=z;function D(Q,V,ee){return(0,y.$ph)(Q,V,ee)}t.$hQ=D;class O extends y.$qh{constructor(V,ee){super(V,ee)}}t.$iQ=O;function W(Q,V,ee,ce){let ke=0;const Ue=Q.setInterval(()=>{ke++,(typeof ce=="number"&&ke>=ce||V()===!0)&&Oe.dispose()},ee),Oe=(0,v.$Rc)(()=>{Q.clearInterval(Ue)});return Oe}t.$lQ=W;class A extends y.$jh{constructor(V){super(),this.f=V&&(0,t.getWindow)(V)}cancelAndSet(V,ee,ce){return super.cancelAndSet(V,ee,ce??this.f)}}t.$mQ=A;class P{constructor(V,ee=0){this.d=V,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(V){(0,S.$1)(V)}}static sort(V,ee){return ee.priority-V.priority}}(function(){const Q=new Map,V=new Map,ee=new Map,ce=new Map,ke=Ue=>{ee.set(Ue,!1);const Oe=Q.get(Ue)??[];for(V.set(Ue,Oe),Q.set(Ue,[]),ce.set(Ue,!0);Oe.length>0;)Oe.sort(P.sort),Oe.shift().execute();ce.set(Ue,!1)};t.$kQ=(Ue,Oe,We=0)=>{const qe=(0,t.getWindowId)(Ue),Ve=new P(Oe,We);let at=Q.get(qe);return at||(at=[],Q.set(qe,at)),at.push(Ve),ee.get(qe)||(ee.set(qe,!0),Ue.requestAnimationFrame(()=>ke(qe))),Ve},t.$jQ=(Ue,Oe,We)=>{const qe=(0,t.getWindowId)(Ue);if(ce.get(qe)){const Ve=new P(Oe,We);let at=V.get(qe);return at||(at=[],V.set(qe,at)),at.push(Ve),Ve}else return(0,t.$kQ)(Ue,Oe,We)}})();function L(Q,V){return(0,t.$kQ)(Q,V,1e4)}t.$nQ=L;function Y(Q,V){return(0,t.$kQ)(Q,V,-1e4)}t.$oQ=Y;const X=8,de=function(Q,V){return V};class ue extends v.$Tc{constructor(V,ee,ce,ke=de,Ue=X){super();let Oe=null,We=0;const qe=this.B(new y.$ih),Ve=()=>{We=new Date().getTime(),ce(Oe),Oe=null};this.B($(V,ee,at=>{Oe=ke(Oe,at);const Ct=new Date().getTime()-We;Ct>=Ue?(qe.cancel(),Ve()):qe.setIfNotSet(Ve,Ue-Ct)}))}}function te(Q,V,ee,ce,ke){return new ue(Q,V,ee,ce,ke)}t.$pQ=te;function ge(Q){return(0,t.getWindow)(Q).getComputedStyle(Q,null)}t.$qQ=ge;function Pe(Q,V){const ee=(0,t.getWindow)(Q),ce=ee.document;if(Q!==ce.body)return new Be(Q.clientWidth,Q.clientHeight);if(l.$r&&ee?.visualViewport)return new Be(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Be(ee.innerWidth,ee.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Be(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Be(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(V)return Pe(V);throw new Error("Unable to figure out browser width and height")}t.$rQ=Pe;class Ne{static d(V,ee){return parseFloat(ee)||0}static f(V,ee,ce){const ke=ge(V),Ue=ke?ke.getPropertyValue(ee):"0";return Ne.d(V,Ue)}static getBorderLeftWidth(V){return Ne.f(V,"border-left-width","borderLeftWidth")}static getBorderRightWidth(V){return Ne.f(V,"border-right-width","borderRightWidth")}static getBorderTopWidth(V){return Ne.f(V,"border-top-width","borderTopWidth")}static getBorderBottomWidth(V){return Ne.f(V,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(V){return Ne.f(V,"padding-left","paddingLeft")}static getPaddingRight(V){return Ne.f(V,"padding-right","paddingRight")}static getPaddingTop(V){return Ne.f(V,"padding-top","paddingTop")}static getPaddingBottom(V){return Ne.f(V,"padding-bottom","paddingBottom")}static getMarginLeft(V){return Ne.f(V,"margin-left","marginLeft")}static getMarginTop(V){return Ne.f(V,"margin-top","marginTop")}static getMarginRight(V){return Ne.f(V,"margin-right","marginRight")}static getMarginBottom(V){return Ne.f(V,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(V,ee){this.width=V,this.height=ee}with(V=this.width,ee=this.height){return V!==this.width||ee!==this.height?new Be(V,ee):this}static is(V){return typeof V=="object"&&typeof V.height=="number"&&typeof V.width=="number"}static lift(V){return V instanceof Be?V:new Be(V.width,V.height)}static equals(V,ee){return V===ee?!0:!V||!ee?!1:V.width===ee.width&&V.height===ee.height}}t.$sQ=Be;function le(Q){let V=Q.offsetParent,ee=Q.offsetTop,ce=Q.offsetLeft;for(;(Q=Q.parentNode)!==null&&Q!==Q.ownerDocument.body&&Q!==Q.ownerDocument.documentElement;){ee-=Q.scrollTop;const ke=I(Q)?null:ge(Q);ke&&(ce-=ke.direction!=="rtl"?Q.scrollLeft:-Q.scrollLeft),Q===V&&(ce+=Ne.getBorderLeftWidth(Q),ee+=Ne.getBorderTopWidth(Q),ee+=Q.offsetTop,ce+=Q.offsetLeft,V=Q.offsetParent)}return{left:ce,top:ee}}t.$tQ=le;function J(Q,V,ee){typeof V=="number"&&(Q.style.width=`${V}px`),typeof ee=="number"&&(Q.style.height=`${ee}px`)}t.$uQ=J;function ae(Q,V,ee,ce,ke,Ue="absolute"){typeof V=="number"&&(Q.style.top=`${V}px`),typeof ee=="number"&&(Q.style.right=`${ee}px`),typeof ce=="number"&&(Q.style.bottom=`${ce}px`),typeof ke=="number"&&(Q.style.left=`${ke}px`),Q.style.position=Ue}t.$vQ=ae;function re(Q){const V=Q.getBoundingClientRect(),ee=(0,t.getWindow)(Q);return{left:V.left+ee.scrollX,top:V.top+ee.scrollY,width:V.width,height:V.height}}t.$wQ=re;function G(Q){let V=Q,ee=1;do{const ce=ge(V).zoom;ce!=null&&ce!=="1"&&(ee*=ce),V=V.parentElement}while(V!==null&&V!==V.ownerDocument.documentElement);return ee}t.$xQ=G;function K(Q){const V=Ne.getMarginLeft(Q)+Ne.getMarginRight(Q);return Q.offsetWidth+V}t.$yQ=K;function ie(Q){const V=Ne.getBorderLeftWidth(Q)+Ne.getBorderRightWidth(Q),ee=Ne.getPaddingLeft(Q)+Ne.getPaddingRight(Q);return Q.offsetWidth-V-ee}t.$zQ=ie;function fe(Q){const V=Ne.getMarginLeft(Q)+Ne.getMarginRight(Q);return Q.scrollWidth+V}t.$AQ=fe;function ye(Q){const V=Ne.getBorderTopWidth(Q)+Ne.getBorderBottomWidth(Q),ee=Ne.getPaddingTop(Q)+Ne.getPaddingBottom(Q);return Q.offsetHeight-V-ee}t.$BQ=ye;function Ce(Q){const V=Ne.getMarginTop(Q)+Ne.getMarginBottom(Q);return Q.offsetHeight+V}t.$CQ=Ce;function Ae(Q,V){if(Q===null)return 0;const ee=le(Q),ce=le(V);return ee.left-ce.left}function q(Q,V){const ee=V.map(ke=>Math.max(fe(ke),K(ke))+Ae(ke,Q)||0);return Math.max(...ee)}t.$DQ=q;function g(Q,V){return!!V?.contains(Q)}t.$EQ=g;const k="parentFlowToElementId";function F(Q,V){Q.dataset[k]=V.id}t.$FQ=F;function r(Q){const V=Q.dataset[k];return typeof V=="string"?Q.ownerDocument.getElementById(V):null}function i(Q,V){let ee=Q;for(;ee;){if(ee===V)return!0;if(ee instanceof HTMLElement){const ce=r(ee);if(ce){ee=ce;continue}}ee=ee.parentNode}return!1}t.$GQ=i;function o(Q,V,ee){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q.classList.contains(V))return Q;if(ee){if(typeof ee=="string"){if(Q.classList.contains(ee))return null}else if(Q===ee)return null}Q=Q.parentNode}return null}t.$HQ=o;function w(Q,V,ee){return!!o(Q,V,ee)}t.$IQ=w;function I(Q){return Q&&!!Q.host&&!!Q.mode}t.$JQ=I;function C(Q){return!!j(Q)}t.$KQ=C;function j(Q){for(;Q.parentNode;){if(Q===Q.ownerDocument?.body)return null;Q=Q.parentNode}return I(Q)?Q:null}t.$LQ=j;function _(){let Q=De().activeElement;for(;Q?.shadowRoot;)Q=Q.shadowRoot.activeElement;return Q}t.$MQ=_;function Z(Q){return _()===Q}t.$NQ=Z;function oe(Q){return g(_(),Q)}t.$OQ=oe;function me(Q){return Q.ownerDocument===De()}t.$PQ=me;function De(){return(0,t.getWindowsCount)()<=1?s.$FP.document:Array.from((0,t.getWindows)()).map(({window:V})=>V.document).find(V=>V.hasFocus())??s.$FP.document}t.$QQ=De;function ve(){return De().defaultView?.window??s.$FP}t.$RQ=ve;function Se(Q){const V=(0,t.getWindow)(Q);V.document.hasFocus()||V.focus()}t.$SQ=Se;const we=new Map;function Te(Q){return we.has(Q)}t.$TQ=Te;function Ie(){return new Me}t.$UQ=Ie;class Me{constructor(){this.d="",this.f=void 0}setStyle(V){V!==this.d&&(this.d=V,this.f?this.f.innerText=V:this.f=Xe(s.$FP.document.head,ee=>ee.innerText=V))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Xe(Q=s.$FP.document.head,V,ee){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",V?.(ce),Q.appendChild(ce),ee&&ee.add((0,v.$Rc)(()=>Q.removeChild(ce))),Q===s.$FP.document.head){const ke=new Set;we.set(ce,ke);for(const{window:Ue,disposables:Oe}of(0,t.getWindows)()){if(Ue===s.$FP)continue;const We=Oe.add(Ke(ce,ke,Ue));ee?.add(We)}}return ce}t.$VQ=Xe;function nt(Q){const V=new v.$Sc;for(const[ee,ce]of we)V.add(Ke(ee,ce,Q));return V}t.$WQ=nt;function Ke(Q,V,ee){const ce=new v.$Sc,ke=Q.cloneNode(!0);ee.document.head.appendChild(ke),ce.add((0,v.$Rc)(()=>ee.document.head.removeChild(ke)));for(const Ue of Re(Q))ke.sheet?.insertRule(Ue.cssText,ke.sheet?.cssRules.length);return ce.add(t.$XQ.observe(Q,ce,{childList:!0})(()=>{ke.textContent=Q.textContent})),V.add(ke),ce.add((0,v.$Rc)(()=>V.delete(ke))),ce}t.$XQ=new class{constructor(){this.mutationObservers=new Map}observe(Q,V,ee){let ce=this.mutationObservers.get(Q);ce||(ce=new Map,this.mutationObservers.set(Q,ce));const ke=(0,e.$Yi)(ee);let Ue=ce.get(ke);if(Ue)Ue.users+=1;else{const Oe=new m.$Yd,We=new MutationObserver(Ve=>Oe.fire(Ve));We.observe(Q,ee);const qe=Ue={users:1,observer:We,onDidMutate:Oe.event};V.add((0,v.$Rc)(()=>{qe.users-=1,qe.users===0&&(Oe.dispose(),We.disconnect(),ce?.delete(ke),ce?.size===0&&this.mutationObservers.delete(Q))})),ce.set(ke,Ue)}return Ue.onDidMutate}};function Ze(Q=s.$FP.document.head){return ne("meta",Q)}t.$YQ=Ze;function x(Q=s.$FP.document.head){return ne("link",Q)}t.$ZQ=x;function ne(Q,V=s.$FP.document.head){const ee=document.createElement(Q);return V.appendChild(ee),ee}let $e=null;function Ee(){return $e||($e=Xe()),$e}function Re(Q){return Q?.sheet?.rules?Q.sheet.rules:Q?.sheet?.cssRules?Q.sheet.cssRules:[]}function je(Q,V,ee=Ee()){if(!(!ee||!V)){ee.sheet?.insertRule(`${Q} {${V}}`,0);for(const ce of we.get(ee)??[])je(Q,V,ce)}}t.$1Q=je;function Qe(Q,V=Ee()){if(!V)return;const ee=Re(V),ce=[];for(let ke=0;ke<ee.length;ke++){const Ue=ee[ke];Je(Ue)&&Ue.selectorText.indexOf(Q)!==-1&&ce.push(ke)}for(let ke=ce.length-1;ke>=0;ke--)V.sheet?.deleteRule(ce[ke]);for(const ke of we.get(V)??[])Qe(Q,ke)}t.$2Q=Qe;function Je(Q){return typeof Q.selectorText=="string"}function tt(Q){return Q instanceof MouseEvent||Q instanceof(0,t.getWindow)(Q).MouseEvent}t.$3Q=tt;function st(Q){return Q instanceof KeyboardEvent||Q instanceof(0,t.getWindow)(Q).KeyboardEvent}t.$4Q=st;function Ge(Q){return Q instanceof PointerEvent||Q instanceof(0,t.getWindow)(Q).PointerEvent}t.$5Q=Ge;function rt(Q){return Q instanceof DragEvent||Q instanceof(0,t.getWindow)(Q).DragEvent}t.$6Q=rt,t.$7Q={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.$TP?"webkitAnimationStart":"animationstart",ANIMATION_END:E.$TP?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.$TP?"webkitAnimationIteration":"animationiteration"};function et(Q){const V=Q;return!!(V&&typeof V.preventDefault=="function"&&typeof V.stopPropagation=="function")}t.$8Q=et,t.$9Q={stop:(Q,V)=>(Q.preventDefault(),V&&Q.stopPropagation(),Q)};function gt(Q){const V=[];for(let ee=0;Q&&Q.nodeType===Q.ELEMENT_NODE;ee++)V[ee]=Q.scrollTop,Q=Q.parentNode;return V}t.$0Q=gt;function mt(Q,V){for(let ee=0;Q&&Q.nodeType===Q.ELEMENT_NODE;ee++)Q.scrollTop!==V[ee]&&(Q.scrollTop=V[ee]),Q=Q.parentNode}t.$$Q=mt;class bt extends v.$Tc{static m(V){if(V instanceof HTMLElement){const ee=j(V),ce=ee?ee.activeElement:V.ownerDocument.activeElement;return g(ce,V)}else{const ee=V;return g(ee.document.activeElement,ee.document)}}constructor(V){super(),this.f=this.B(new m.$Yd),this.onDidFocus=this.f.event,this.g=this.B(new m.$Yd),this.onDidBlur=this.g.event;let ee=bt.m(V),ce=!1;const ke=()=>{ce=!1,ee||(ee=!0,this.f.fire())},Ue=()=>{ee&&(ce=!0,(V instanceof HTMLElement?(0,t.getWindow)(V):V).setTimeout(()=>{ce&&(ce=!1,ee=!1,this.g.fire())},0))};this.j=()=>{bt.m(V)!==ee&&(ee?Ue():ke())},this.B($(V,t.$7Q.FOCUS,ke,!0)),this.B($(V,t.$7Q.BLUR,Ue,!0)),V instanceof HTMLElement&&(this.B($(V,t.$7Q.FOCUS_IN,()=>this.j())),this.B($(V,t.$7Q.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Ft(Q){return new bt(Q)}t.$_Q=Ft;function Ot(Q,V){return Q.after(V),V}t.$aR=Ot;function ze(Q,...V){if(Q.append(...V),V.length===1&&typeof V[0]!="string")return V[0]}t.$bR=ze;function he(Q,V){return Q.insertBefore(V,Q.firstChild),V}t.$cR=he;function Fe(Q,...V){Q.innerText="",ze(Q,...V)}t.$dR=Fe;const Le=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var _e;(function(Q){Q.HTML="http://www.w3.org/1999/xhtml",Q.SVG="http://www.w3.org/2000/svg"})(_e||(t.Namespace=_e={}));function it(Q,V,ee,...ce){const ke=Le.exec(V);if(!ke)throw new Error("Bad use of emmet");const Ue=ke[1]||"div";let Oe;return Q!==_e.HTML?Oe=document.createElementNS(Q,Ue):Oe=document.createElement(Ue),ke[3]&&(Oe.id=ke[3]),ke[4]&&(Oe.className=ke[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([We,qe])=>{typeof qe>"u"||(/^on\w+$/.test(We)?Oe[We]=qe:We==="selected"?qe&&Oe.setAttribute(We,"true"):Oe.setAttribute(We,qe))}),Oe.append(...ce),Oe}function lt(Q,V,...ee){return it(_e.HTML,Q,V,...ee)}t.$=lt,lt.SVG=function(Q,V,...ee){return it(_e.SVG,Q,V,...ee)};function xe(Q,V){const ee=[];return Q.forEach((ce,ke)=>{ke>0&&(V instanceof Node?ee.push(V.cloneNode()):ee.push(document.createTextNode(V))),ee.push(ce)}),ee}t.$fR=xe;function ct(Q,...V){Q?pt(...V):yt(...V)}t.$gR=ct;function pt(...Q){for(const V of Q)V.style.display="",V.removeAttribute("aria-hidden")}t.$hR=pt;function yt(...Q){for(const V of Q)V.style.display="none",V.setAttribute("aria-hidden","true")}t.$iR=yt;function Yt(Q,V){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q instanceof HTMLElement&&Q.hasAttribute(V))return Q;Q=Q.parentNode}return null}function ki(Q){!Q||!Q.hasAttribute("tabIndex")||(Q.ownerDocument.activeElement===Q&&Yt(Q.parentElement,"tabIndex")?.focus(),Q.removeAttribute("tabindex"))}t.$jR=ki;function Ai(Q){return V=>{V.preventDefault(),V.stopPropagation(),Q(V)}}t.$kR=Ai;function Si(Q){return new Promise(V=>{if(Q.document.readyState==="complete"||Q.document&&Q.document.body!==null)V(void 0);else{const ce=()=>{Q.window.removeEventListener("DOMContentLoaded",ce,!1),V()};Q.window.addEventListener("DOMContentLoaded",ce,!1)}})}t.$lR=Si;function Fi(Q,V){const ee=Q.devicePixelRatio*V;return Math.max(1,Math.floor(ee))/Q.devicePixelRatio}t.$mR=Fi;function Ci(Q){s.$FP.open(Q,"_blank","noopener")}t.$nR=Ci;const Gt=780,Xt=640;function Ni(Q){const V=Math.floor(s.$FP.screenLeft+s.$FP.innerWidth/2-Gt/2),ee=Math.floor(s.$FP.screenTop+s.$FP.innerHeight/2-Xt/2);s.$FP.open(Q,"_blank",`width=${Gt},height=${Xt},top=${ee},left=${V}`)}t.$oR=Ni;function Ti(Q,V=!0){const ee=s.$FP.open();return ee?(V&&(ee.opener=null),ee.location.href=Q,!0):!1}t.$pR=Ti;function Ri(Q,V){const ee=()=>{V(),ce=(0,t.$kQ)(Q,ee)};let ce=(0,t.$kQ)(Q,ee);return(0,v.$Rc)(()=>ce.dispose())}t.$qR=Ri,M.$mg.setPreferredWebSchema(/^https:/.test(s.$FP.location.href)?"https":"http");function Pi(Q){return Q?`url('${M.$sg.uriToBrowserUri(Q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$rR=Pi;function Li(Q){return`'${Q.replace(/'/g,"%27")}'`}t.$sR=Li;function Zt(Q,V){if(Q!==void 0){const ee=Q.match(/^\s*var\((.+)\)$/);if(ee){const ce=ee[1].split(",",2);return ce.length===2&&(V=Zt(ce[1].trim(),V)),`var(${ce[0]}, ${V})`}return Q}return V}t.$tR=Zt;function Ii(Q,V){let ee;if(h.URI.isUri(Q))ee=Q.toString(!0);else{const Ue=new Blob([Q]);ee=URL.createObjectURL(Ue),setTimeout(()=>URL.revokeObjectURL(ee))}const ce=ve(),ke=document.createElement("a");ce.document.body.appendChild(ke),ke.download=V,ke.href=ee,ke.click(),setTimeout(()=>ce.document.body.removeChild(ke))}t.$uR=Ii;function Mi(){return new Promise(Q=>{const V=ve(),ee=document.createElement("input");V.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(ee,"input"))(()=>{Q(ee.files??void 0)}),ee.click(),setTimeout(()=>V.document.body.removeChild(ee))})}t.$vR=Mi;var Et;(function(Q){Q[Q.DOCUMENT=1]="DOCUMENT",Q[Q.BROWSER=2]="BROWSER"})(Et||(t.DetectedFullscreenMode=Et={}));function Oi(Q){return Q.document.fullscreenElement||Q.document.webkitFullscreenElement||Q.document.webkitIsFullScreen?{mode:Et.DOCUMENT,guess:!1}:Q.innerHeight===Q.screen.height?{mode:Et.BROWSER,guess:!1}:(l.$j||l.$k)&&Q.outerHeight===Q.screen.height&&Q.outerWidth===Q.screen.width?{mode:Et.BROWSER,guess:!0}:null}t.$wR=Oi;function Jt(Q,V=!1){const ee=document.createElement("a");return p.addHook("afterSanitizeAttributes",ce=>{for(const ke of["href","src"])if(ce.hasAttribute(ke)){const Ue=ce.getAttribute(ke);if(ke==="href"&&Ue.startsWith("#"))continue;if(ee.href=Ue,!Q.includes(ee.protocol.replace(/:$/,""))){if(V&&ke==="src"&&ee.href.startsWith("data:"))continue;ce.removeAttribute(ke)}}}),(0,v.$Rc)(()=>{p.removeHook("afterSanitizeAttributes")})}t.$xR=Jt;const Bi=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.$yR=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Ui(Q,V){const ee=Jt(Bi);try{const ce=p.sanitize(V,zi);Q.innerHTML=ce}finally{ee.dispose()}}t.$zR=Ui;function ji(Q){const V=new Uint16Array(Q.length);for(let ke=0;ke<V.length;ke++)V[ke]=Q.charCodeAt(ke);let ee="";const ce=new Uint8Array(V.buffer);for(let ke=0;ke<ce.length;ke++)ee+=String.fromCharCode(ce[ke]);return ee}function Hi(Q){return btoa(ji(Q))}t.$AR=Hi;class wt extends m.$Yd{constructor(){super(),this.o=new v.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:V,disposables:ee})=>this.C(V,ee),{window:s.$FP,disposables:this.o}))}C(V,ee){ee.add($(V,"keydown",ce=>{if(ce.defaultPrevented)return;const ke=new n.$0P(ce);if(!(ke.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(ce.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(ke.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyPressed&&(this.A.event=ce,this.fire(this.A))}},!0)),ee.add($(V,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!ce.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!ce.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!ce.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyReleased&&(this.A.event=ce,this.fire(this.A)))},!0)),ee.add($(V.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add($(V.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add($(V.document.body,"mousemove",ce=>{ce.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add($(V,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return wt.B||(wt.B=new wt),wt.B}dispose(){super.dispose(),this.o.dispose()}}t.$BR=wt;function Wi(Q){const V=document.cookie.match("(^|[^;]+)\\s*"+Q+"\\s*=\\s*([^;]+)");return V?V.pop():void 0}t.$CR=Wi;class Qi extends v.$Tc{constructor(V,ee){super(),this.j=V,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B($(this.j,t.$7Q.DRAG_START,V=>{this.m.onDragStart?.(V)})),this.m.onDrag&&this.B($(this.j,t.$7Q.DRAG,V=>{this.m.onDrag?.(V)})),this.B($(this.j,t.$7Q.DRAG_ENTER,V=>{this.f++,this.g=V.timeStamp,this.m.onDragEnter?.(V)})),this.B($(this.j,t.$7Q.DRAG_OVER,V=>{V.preventDefault(),this.m.onDragOver?.(V,V.timeStamp-this.g)})),this.B($(this.j,t.$7Q.DRAG_LEAVE,V=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(V))})),this.B($(this.j,t.$7Q.DRAG_END,V=>{this.f=0,this.g=0,this.m.onDragEnd?.(V)})),this.B($(this.j,t.$7Q.DROP,V=>{this.f=0,this.g=0,this.m.onDrop?.(V)}))}}t.$DR=Qi;const _i=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(Q,...V){let ee,ce;Array.isArray(V[0])?(ee={},ce=V[0]):(ee=V[0]||{},ce=V[1]);const ke=_i.exec(Q);if(!ke||!ke.groups)throw new Error("Bad use of h");const Ue=ke.groups.tag||"div",Oe=document.createElement(Ue);ke.groups.id&&(Oe.id=ke.groups.id);const We=[];if(ke.groups.class)for(const Ve of ke.groups.class.split("."))Ve!==""&&We.push(Ve);if(ee.className!==void 0)for(const Ve of ee.className.split("."))Ve!==""&&We.push(Ve);We.length>0&&(Oe.className=We.join(" "));const qe={};if(ke.groups.name&&(qe[ke.groups.name]=Oe),ce)for(const Ve of ce)Ve instanceof HTMLElement?Oe.appendChild(Ve):typeof Ve=="string"?Oe.append(Ve):"root"in Ve&&(Object.assign(qe,Ve),Oe.appendChild(Ve.root));for(const[Ve,at]of Object.entries(ee))if(Ve!=="className")if(Ve==="style")for(const[Ct,Bt]of Object.entries(at))Oe.style.setProperty(ei(Ct),typeof Bt=="number"?Bt+"px":""+Bt);else Ve==="tabIndex"?Oe.tabIndex=at:Oe.setAttribute(ei(Ve),at.toString());return qe.root=Oe,qe}t.h=qi;function ei(Q){return Q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(Q,V,ee){for(const{name:ce,value:ke}of Q.attributes)(!ee||ee.includes(ce))&&V.setAttribute(ce,ke)}t.$FR=ti;function Vi(Q,V,ee){const ce=Q.getAttribute(ee);ce?V.setAttribute(ee,ce):V.removeAttribute(ee)}function Ki(Q,V,ee){ti(Q,V,ee);const ce=new v.$Sc;return ce.add(t.$XQ.observe(Q,ce,{attributes:!0,attributeFilter:ee})(ke=>{for(const Ue of ke)Ue.type==="attributes"&&Ue.attributeName&&Vi(Q,V,Ue.attributeName)})),ce}t.$GR=Ki}),define(be[54],pe([1,0,2,3,117]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JR=t.$IR=t.$HR=void 0;class H extends T.$Tc{constructor(m,p){super(),this.B((0,E.$aQ)(m,"dragover",v=>{v.preventDefault(),this.a||(this.a=setTimeout(()=>{p(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(v=>{this.B((0,E.$aQ)(m,v,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$HR=H,t.$IR={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$ks.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function y(S,m,p,v,M){const l=document.createElement("div");if(l.className=p,l.textContent=m,M&&(l.style.color=M),v&&(l.style.background=v),S.dataTransfer){const h=(0,E.getWindow)(S).document;h.body.appendChild(l),S.dataTransfer.setDragImage(l,-10,-10),setTimeout(()=>h.body.removeChild(l),0)}}t.$JR=y}),define(be[55],pe([1,0,2]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bS=t.$aS=t.$_R=void 0;function T(l,h={}){const e=H(h);return e.textContent=l,e}t.$_R=T;function n(l,h={}){const e=H(h);return m(e,p(l,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}t.$aS=n;function H(l){const h=l.inline?"span":"div",e=document.createElement(h);return l.className&&(e.className=l.className),e}t.$bS=H;class y{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var S;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(S||(S={}));function m(l,h,e,s){let f;if(h.type===2)f=document.createTextNode(h.content||"");else if(h.type===3)f=document.createElement("b");else if(h.type===4)f=document.createElement("i");else if(h.type===7&&s)f=document.createElement("code");else if(h.type===5&&e){const c=document.createElement("a");e.disposables.add(E.$bQ(c,"click",a=>{e.callback(String(h.index),a)})),f=c}else h.type===8?f=document.createElement("br"):h.type===1&&(f=l);f&&l!==f&&l.appendChild(f),f&&Array.isArray(h.children)&&h.children.forEach(c=>{m(f,c,e,s)})}function p(l,h){const e={type:1,children:[]};let s=0,f=e;const c=[],a=new y(l);for(;!a.eos();){let $=a.next();const d=$==="\\"&&M(a.peek(),h)!==0;if(d&&($=a.next()),!d&&v($,h)&&$===a.peek()){a.advance(),f.type===2&&(f=c.pop());const b=M($,h);if(f.type===b||f.type===5&&b===6)f=c.pop();else{const u={type:b,children:[]};b===5&&(u.index=s,s++),f.children.push(u),c.push(f),f=u}}else if($===`
`)f.type===2&&(f=c.pop()),f.children.push({type:8});else if(f.type!==2){const b={type:2,content:$};f.children.push(b),c.push(f),f=b}else f.content+=$}return f.type===2&&(f=c.pop()),c.length,e}function v(l,h){return M(l,h)!==0}function M(l,h){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define(be[56],pe([1,0,2,3]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NR=void 0;class n{constructor(){this.a=new T.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(y,S){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,y&&m&&m(S)}isMonitoring(){return!!this.b}startMonitoring(y,S,m,p,v){this.isMonitoring()&&this.stopMonitoring(!1),this.b=p,this.c=v;let M=y;try{y.setPointerCapture(S),this.a.add((0,T.$Rc)(()=>{try{y.releasePointerCapture(S)}catch{}}))}catch{M=E.getWindow(y)}this.a.add(E.$aQ(M,E.$7Q.POINTER_MOVE,l=>{if(l.buttons!==m){this.stopMonitoring(!0);return}l.preventDefault(),this.b(l)})),this.a.add(E.$aQ(M,E.$7Q.POINTER_UP,l=>this.stopMonitoring(!0)))}}t.$NR=n});var Ye=this&&this.__decorate||function(se,t,E,T){var n=arguments.length,H=n<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,E):T,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(se,t,E,T);else for(var S=se.length-1;S>=0;S--)(y=se[S])&&(H=(n<3?y(H):n>3?y(t,E,H):y(t,E))||H);return n>3&&H&&Object.defineProperty(t,E,H),H};define(be[25],pe([1,0,2,21,12,27,4,3,46]),function(se,t,E,T,n,H,y,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KR=t.EventType=void 0;var p;(function(M){M.Tap="-monaco-gesturetap",M.Change="-monaco-gesturechange",M.Start="-monaco-gesturestart",M.End="-monaco-gesturesend",M.Contextmenu="-monaco-gesturecontextmenu"})(p||(t.EventType=p={}));class v extends S.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new m.$4c,this.h=new m.$4c,this.m={},this.j=null,this.n=0,this.B(y.Event.runAndSubscribe(E.onDidRegisterWindow,({window:l,disposables:h})=>{h.add(E.$aQ(l.document,"touchstart",e=>this.s(e),{passive:!1})),h.add(E.$aQ(l.document,"touchend",e=>this.u(l,e))),h.add(E.$aQ(l.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:T.$FP,disposables:this.q}))}static addTarget(l){if(!v.isTouchDevice())return S.$Tc.None;v.b||(v.b=(0,S.$Mc)(new v));const h=v.b.g.push(l);return(0,S.$Rc)(h)}static ignoreTarget(l){if(!v.isTouchDevice())return S.$Tc.None;v.b||(v.b=(0,S.$Mc)(new v));const h=v.b.h.push(l);return(0,S.$Rc)(h)}static isTouchDevice(){return"ontouchstart"in T.$FP||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(l){const h=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=l.targetTouches.length;e<s;e++){const f=l.targetTouches.item(e);this.m[f.identifier]={id:f.identifier,initialTarget:f.target,initialTimeStamp:h,initialPageX:f.pageX,initialPageY:f.pageY,rollingTimestamps:[h],rollingPageX:[f.pageX],rollingPageY:[f.pageY]};const c=this.w(p.Start,f.target);c.pageX=f.pageX,c.pageY=f.pageY,this.z(c)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}u(l,h){const e=Date.now(),s=Object.keys(this.m).length;for(let f=0,c=h.changedTouches.length;f<c;f++){const a=h.changedTouches.item(f);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const $=this.m[a.identifier],d=Date.now()-$.initialTimeStamp;if(d<v.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const b=this.w(p.Tap,$.initialTarget);b.pageX=n.$sb($.rollingPageX),b.pageY=n.$sb($.rollingPageY),this.z(b)}else if(d>=v.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const b=this.w(p.Contextmenu,$.initialTarget);b.pageX=n.$sb($.rollingPageX),b.pageY=n.$sb($.rollingPageY),this.z(b)}else if(s===1){const b=n.$sb($.rollingPageX),u=n.$sb($.rollingPageY),N=n.$sb($.rollingTimestamps)-$.rollingTimestamps[0],B=b-$.rollingPageX[0],R=u-$.rollingPageY[0],U=[...this.g].filter(z=>$.initialTarget instanceof Node&&z.contains($.initialTarget));this.C(l,U,e,Math.abs(B)/N,B>0?1:-1,b,Math.abs(R)/N,R>0?1:-1,u)}this.z(this.w(p.End,$.initialTarget)),delete this.m[a.identifier]}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}w(l,h){const e=document.createEvent("CustomEvent");return e.initEvent(l,!1,!0),e.initialTarget=h,e.tapCount=0,e}z(l){if(l.type===p.Tap){const h=new Date().getTime();let e=0;h-this.n>v.r?e=1:e=2,this.n=h,l.tapCount=e}else(l.type===p.Change||l.type===p.Contextmenu)&&(this.n=0);if(l.initialTarget instanceof Node){for(const h of this.h)if(h.contains(l.initialTarget))return;for(const h of this.g)h.contains(l.initialTarget)&&(h.dispatchEvent(l),this.f=!0)}}C(l,h,e,s,f,c,a,$,d){this.j=E.$kQ(l,()=>{const b=Date.now(),u=b-e;let N=0,B=0,R=!0;s+=v.a*u,a+=v.a*u,s>0&&(R=!1,N=f*s*u),a>0&&(R=!1,B=$*a*u);const U=this.w(p.Change);U.translationX=N,U.translationY=B,h.forEach(z=>z.dispatchEvent(U)),R||this.C(l,h,b,s,f,c+N,a,$,d+B)})}D(l){const h=Date.now();for(let e=0,s=l.changedTouches.length;e<s;e++){const f=l.changedTouches.item(e);if(!this.m.hasOwnProperty(String(f.identifier))){console.warn("end of an UNKNOWN touch",f);continue}const c=this.m[f.identifier],a=this.w(p.Change,c.initialTarget);a.translationX=f.pageX-n.$sb(c.rollingPageX),a.translationY=f.pageY-n.$sb(c.rollingPageY),a.pageX=f.pageX,a.pageY=f.pageY,this.z(a),c.rollingPageX.length>3&&(c.rollingPageX.shift(),c.rollingPageY.shift(),c.rollingTimestamps.shift()),c.rollingPageX.push(f.pageX),c.rollingPageY.push(f.pageY),c.rollingTimestamps.push(h)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}}t.$KR=v,Ye([H.$Ch],v,"isTouchDevice",null)}),define(be[57],pe([1,0,2,92]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fS=t.$eS=t.$dS=void 0;const T=2e4;let n,H,y,S,m;function p(h){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const f=document.createElement("div");return f.className="monaco-alert",f.setAttribute("role","alert"),f.setAttribute("aria-atomic","true"),n.appendChild(f),f};H=e(),y=e();const s=()=>{const f=document.createElement("div");return f.className="monaco-status",f.setAttribute("aria-live","polite"),f.setAttribute("aria-atomic","true"),n.appendChild(f),f};S=s(),m=s(),h.appendChild(n)}t.$dS=p;function v(h){n&&(H.textContent!==h?(E.$_P(y),l(H,h)):(E.$_P(H),l(y,h)))}t.$eS=v;function M(h){n&&(S.textContent!==h?(E.$_P(m),l(S,h)):(E.$_P(S),l(m,h)))}t.$fS=M;function l(h,e){E.$_P(h),e.length>T&&(e=e.substr(0,T)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define(be[119],pe([1,0,2,18]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JS=t.$IS=void 0;const n=new RegExp(`(\\\\)?\\$\\((${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(S){const m=new Array;let p,v=0,M=0;for(;(p=n.exec(S))!==null;){M=p.index||0,v<M&&m.push(S.substring(v,M)),v=(p.index||0)+p[0].length;const[,l,h]=p;m.push(l?`$(${h})`:y({id:h}))}return v<S.length&&m.push(S.substring(v)),m}t.$IS=H;function y(S){const m=E.$("span");return m.classList.add(...T.ThemeIcon.asClassNameArray(S)),m}t.$JS=y}),define(be[120],pe([1,0,2]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lS=void 0;function T(H){try{H.parentElement?.removeChild(H)}catch{}}class n{constructor(y){this.d=y,this.a=new Map,this.b=new Set,this.c=!1}alloc(y){let S=this.h(y).pop(),m=!1;if(S)m=this.b.has(S.domNode),m&&this.b.delete(S.domNode);else{const p=(0,E.$)(".monaco-list-row"),M=this.i(y).renderTemplate(p);S={domNode:p,templateId:y,templateData:M}}return{row:S,isReusingConnectedDomNode:m}}release(y){y&&this.f(y)}transact(y){if(this.c)throw new Error("Already in transaction");this.c=!0;try{y()}finally{for(const S of this.b)this.g(S);this.b.clear(),this.c=!1}}f(y){const{domNode:S,templateId:m}=y;S&&(this.c?this.b.add(S):this.g(S)),this.h(m).push(y)}g(y){y.classList.remove("scrolling"),T(y)}h(y){let S=this.a.get(y);return S||(S=[],this.a.set(y,S)),S}dispose(){this.a.forEach((y,S)=>{for(const m of y)this.i(S).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(y){const S=this.d.get(y);if(!S)throw new Error(`No renderer found for ${y}`);return S}}t.$lS=n}),define(be[121],pe([1,0,9,3]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SR=void 0;class n extends T.$Tc{constructor(y,S,m){super(),this.a=y,this.b=S,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new E.$ih)}setVisibility(y){this.a!==y&&(this.a=y,this.s())}setShouldBeVisible(y){this.g=y,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const y=this.r();this.h!==y&&(this.h=y,this.ensureVisibility())}setIsNeeded(y){this.j!==y&&(this.j=y,this.ensureVisibility())}setDomNode(y){this.f=y,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(y){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(y?" fade":"")))}}t.$SR=n}),define(be[122],pe([1,0,2,25,12,4,3,5]),function(se,t,E,T,n,H,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QS=void 0;class m extends y.$Tc{constructor(v,M,l,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$Yd),this.h=l,this.j(),this.setOptions(v,M)}j(){this.B(T.$KR.addTarget(this.a)),[T.EventType.Tap].forEach(v=>{this.B(E.$aQ(this.a,v,M=>{this.a.focus()}))}),this.B(E.$bQ(this.a,"click",v=>{E.$9Q.stop(v,!0)})),this.B(E.$bQ(this.a,"change",v=>{this.a.title=v.target.value,this.g.fire({index:v.target.selectedIndex,selected:v.target.value})})),this.B(E.$bQ(this.a,"keydown",v=>{let M=!1;S.$j?(v.keyCode===18||v.keyCode===16||v.keyCode===10)&&(M=!0):(v.keyCode===18&&v.altKey||v.keyCode===10||v.keyCode===3)&&(M=!0),M&&v.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(v,M){(!this.c||!n.$ub(this.c,v))&&(this.c=v,this.a.options.length=0,this.c.forEach((l,h)=>{this.a.add(this.m(l.text,h,l.isDisabled))})),M!==void 0&&this.select(M)}select(v){this.c.length===0?this.f=0:v>=0&&v<this.c.length?this.f=v:v>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(v){this.b.ariaLabel=v,this.a.setAttribute("aria-label",v)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(v){this.a.tabIndex=v?0:-1}render(v){v.classList.add("select-container"),v.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(v){this.h=v,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(v,M,l){const h=document.createElement("option");return h.value=v,h.text=v,h.disabled=!!l,h}}t.$QS=m}),define(be[58],pe([1,0,26,12,9,50,87,4,28]),function(se,t,E,T,n,H,y,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=t.$mU=t.$lU=void 0;function p(h){return typeof h=="object"&&"visibility"in h&&"data"in h}t.$lU=p;function v(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}t.$mU=v;function M(h){return typeof h.collapsible=="boolean"}class l{constructor(e,s,f,c={}){this.o=e,this.p=s,this.rootRef=[],this.d=new S.$7d,this.f=new S.$Yd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new S.$Yd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new S.$Yd,this.onDidSplice=this.l.event,this.m=new n.$8g(H.$Vd),this.h=typeof c.collapseByDefault>"u"?!1:c.collapseByDefault,this.j=c.filter,this.k=typeof c.autoExpandSingleChildren>"u"?!1:c.autoExpandSingleChildren,this.c={parent:void 0,element:f,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,f=m.Iterable.empty(),c={}){if(e.length===0)throw new E.$jU(this.o,"Invalid tree location");c.diffIdentityProvider?this.q(c.diffIdentityProvider,e,s,f,c):this.s(e,s,f,c)}q(e,s,f,c=m.Iterable.empty(),a,$=a.diffDepth??0){const{parentNode:d}=this.G(s);if(!d.lastDiffIds)return this.s(s,f,c,a);const b=[...c],u=s[s.length-1],N=new y.$6s({getElements:()=>d.lastDiffIds},{getElements:()=>[...d.children.slice(0,u),...b,...d.children.slice(u+f)].map(D=>e.getId(D.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return d.lastDiffIds=void 0,this.s(s,f,b,a);const B=s.slice(0,-1),R=(D,O,W)=>{if($>0)for(let A=0;A<W;A++)D--,O--,this.q(e,[...B,D,0],Number.MAX_SAFE_INTEGER,b[O].children,a,$-1)};let U=Math.min(d.children.length,u+f),z=b.length;for(const D of N.changes.sort((O,W)=>W.originalStart-O.originalStart))R(U,z,U-(D.originalStart+D.originalLength)),U=D.originalStart,z=D.modifiedStart-u,this.s([...B,U],D.originalLength,m.Iterable.slice(b,z,z+D.modifiedLength),a);R(U,z,U)}s(e,s,f=m.Iterable.empty(),{onDidCreateNode:c,onDidDeleteNode:a,diffIdentityProvider:$}){const{parentNode:d,listIndex:b,revealed:u,visible:N}=this.G(e),B=[],R=m.Iterable.map(f,Y=>this.w(Y,d,d.visible?1:0,u,B,c)),U=e[e.length-1];let z=0;for(let Y=U;Y>=0&&Y<d.children.length;Y--){const X=d.children[Y];if(X.visible){z=X.visibleChildIndex;break}}const D=[];let O=0,W=0;for(const Y of R)D.push(Y),W+=Y.renderNodeCount,Y.visible&&(Y.visibleChildIndex=z+O++);const A=(0,T.$6b)(d.children,U,s,D);$?d.lastDiffIds?(0,T.$6b)(d.lastDiffIds,U,s,D.map(Y=>$.getId(Y.element).toString())):d.lastDiffIds=d.children.map(Y=>$.getId(Y.element).toString()):d.lastDiffIds=void 0;let P=0;for(const Y of A)Y.visible&&P++;if(P!==0)for(let Y=U+D.length;Y<d.children.length;Y++){const X=d.children[Y];X.visible&&(X.visibleChildIndex-=P)}if(d.visibleChildrenCount+=O-P,u&&N){const Y=A.reduce((X,de)=>X+(de.visible?de.renderNodeCount:0),0);this.B(d,W-Y),this.p.splice(b,Y,B)}if(A.length>0&&a){const Y=X=>{a(X),X.children.forEach(Y)};A.forEach(Y)}this.l.fire({insertedNodes:D,deletedNodes:A});let L=d;for(;L;){if(L.visibility===2){this.m.trigger(()=>this.refilter());break}L=L.parent}}rerender(e){if(e.length===0)throw new E.$jU(this.o,"Invalid tree location");const{node:s,listIndex:f,revealed:c}=this.F(e);s.visible&&c&&this.p.splice(f,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new E.$jU(this.o,"Invalid tree location");const{listIndex:f}=this.F(e);this.p.updateElementHeight(f,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:f,revealed:c}=this.F(e);return f&&c?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const f=this.E(e);typeof s>"u"&&(s=!f.collapsible);const c={collapsible:s};return this.d.bufferEvents(()=>this.t(e,c))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,f){const c=this.E(e);typeof s>"u"&&(s=!c.collapsed);const a={collapsed:s,recursive:f||!1};return this.d.bufferEvents(()=>this.t(e,a))}t(e,s){const{node:f,listIndex:c,revealed:a}=this.F(e),$=this.u(f,c,a,s);if(f!==this.c&&this.k&&$&&!M(s)&&f.collapsible&&!f.collapsed&&!s.recursive){let d=-1;for(let b=0;b<f.children.length;b++)if(f.children[b].visible)if(d>-1){d=-1;break}else d=b;d>-1&&this.t([...e,d],s)}return $}u(e,s,f,c){const a=this.v(e,c,!1);if(!f||!e.visible||!a)return a;const $=e.renderNodeCount,d=this.x(e),b=$-(s===-1?0:1);return this.p.splice(s+1,b,d.slice(1)),a}v(e,s,f){let c;if(e===this.c?c=!1:(M(s)?(c=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(c=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):c=!1,c&&this.f.fire({node:e,deep:f})),!M(s)&&s.recursive)for(const a of e.children)c=this.v(a,s,!0)||c;return c}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,f,c,a,$){const d={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.C(d,f);d.visibility=b,c&&a.push(d);const u=e.children||m.Iterable.empty(),N=c&&b!==0&&!d.collapsed;let B=0,R=1;for(const U of u){const z=this.w(U,d,b,N,a,$);d.children.push(z),R+=z.renderNodeCount,z.visible&&(z.visibleChildIndex=B++)}return d.collapsible=d.collapsible||d.children.length>0,d.visibleChildrenCount=B,d.visible=b===2?B>0:b===1,d.visible?d.collapsed||(d.renderNodeCount=R):(d.renderNodeCount=0,c&&a.pop()),$?.(d),d}x(e){const s=e.renderNodeCount,f=[];return this.y(e,f),this.B(e.parent,f.length-s),f}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const f of e.children)e.renderNodeCount+=this.y(f,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,f=[];return this.A(e,e.visible?1:0,f),this.B(e.parent,f.length-s),f}A(e,s,f,c=!0){let a;if(e!==this.c){if(a=this.C(e,s),a===0)return e.visible=!1,e.renderNodeCount=0,!1;c&&f.push(e)}const $=f.length;e.renderNodeCount=e===this.c?0:1;let d=!1;if(!e.collapsed||a!==0){let b=0;for(const u of e.children)d=this.A(u,a,f,c&&!e.collapsed)||d,u.visible&&(u.visibleChildIndex=b++);e.visibleChildrenCount=b}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=a===2?d:a===1,e.visibility=a),e.visible?e.collapsed||(e.renderNodeCount+=f.length-$):(e.renderNodeCount=0,c&&f.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const f=this.j?this.j.filter(e.element,s):1;return typeof f=="boolean"?(e.filterData=void 0,f?1:0):p(f)?(e.filterData=f.data,v(f.visibility)):(e.filterData=void 0,v(f))}D(e,s=this.c){if(!e||e.length===0)return!0;const[f,...c]=e;return f<0||f>s.children.length?!1:this.D(c,s.children[f])}E(e,s=this.c){if(!e||e.length===0)return s;const[f,...c]=e;if(f<0||f>s.children.length)throw new E.$jU(this.o,"Invalid tree location");return this.E(c,s.children[f])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:f,revealed:c,visible:a}=this.G(e),$=e[e.length-1];if($<0||$>s.children.length)throw new E.$jU(this.o,"Invalid tree location");const d=s.children[$];return{node:d,listIndex:f,revealed:c,visible:a&&d.visible}}G(e,s=this.c,f=0,c=!0,a=!0){const[$,...d]=e;if($<0||$>s.children.length)throw new E.$jU(this.o,"Invalid tree location");for(let b=0;b<$;b++)f+=s.children[b].renderNodeCount;return c=c&&!s.collapsed,a=a&&s.visible,d.length===0?{parentNode:s,listIndex:f,revealed:c,visible:a}:this.G(d,s.children[$],f+1,c,a)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let f=e;for(;f.parent;)s.push(f.parent.children.indexOf(f)),f=f.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,T.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$nU=l}),define(be[123],pe([1,0,58,26,28]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uU=void 0;class H{get size(){return this.d.size}constructor(S,m,p={}){this.k=S,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new E.$nU(S,m,null,p),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,p.sorter&&(this.j={compare(v,M){return p.sorter.compare(v.element,M.element)}}),this.h=p.identityProvider}setChildren(S,m=n.Iterable.empty(),p={}){const v=this.o(S);this.l(v,this.m(m),p)}l(S,m=n.Iterable.empty(),p){const v=new Set,M=new Set,l=e=>{if(e.element===null)return;const s=e;if(v.add(s.element),this.d.set(s.element,s),this.h){const f=this.h.getId(s.element).toString();M.add(f),this.f.set(f,s)}p.onDidCreateNode?.(s)},h=e=>{if(e.element===null)return;const s=e;if(v.has(s.element)||this.d.delete(s.element),this.h){const f=this.h.getId(s.element).toString();M.has(f)||this.f.delete(f)}p.onDidDeleteNode?.(s)};this.c.splice([...S,0],Number.MAX_VALUE,m,{...p,onDidCreateNode:l,onDidDeleteNode:h})}m(S=n.Iterable.empty()){return this.j&&(S=[...S].sort(this.j.compare.bind(this.j))),n.Iterable.map(S,m=>{let p=this.d.get(m.element);if(!p&&this.h){const l=this.h.getId(m.element).toString();p=this.f.get(l)}if(!p){let l;return typeof m.collapsed>"u"?l=void 0:m.collapsed===T.ObjectTreeElementCollapseState.Collapsed||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed?l=!0:m.collapsed===T.ObjectTreeElementCollapseState.Expanded||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?l=!1:l=!!m.collapsed,{...m,children:this.m(m.children),collapsed:l}}const v=typeof m.collapsible=="boolean"?m.collapsible:p.collapsible;let M;return typeof m.collapsed>"u"||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?M=p.collapsed:m.collapsed===T.ObjectTreeElementCollapseState.Collapsed?M=!0:m.collapsed===T.ObjectTreeElementCollapseState.Expanded?M=!1:M=!!m.collapsed,{...m,collapsible:v,collapsed:M,children:this.m(m.children)}})}rerender(S){const m=this.o(S);this.c.rerender(m)}updateElementHeight(S,m){const p=this.o(S);this.c.updateElementHeight(p,m)}resort(S=null,m=!0){if(!this.j)return;const p=this.o(S),v=this.c.getNode(p);this.l(p,this.n(v,m),{})}n(S,m,p=!0){let v=[...S.children];return(m||p)&&(v=v.sort(this.j.compare.bind(this.j))),n.Iterable.map(v,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,m,!1)}))}getFirstElementChild(S=null){const m=this.o(S);return this.c.getFirstElementChild(m)}getLastElementAncestor(S=null){const m=this.o(S);return this.c.getLastElementAncestor(m)}has(S){return this.d.has(S)}getListIndex(S){const m=this.o(S);return this.c.getListIndex(m)}getListRenderCount(S){const m=this.o(S);return this.c.getListRenderCount(m)}isCollapsible(S){const m=this.o(S);return this.c.isCollapsible(m)}setCollapsible(S,m){const p=this.o(S);return this.c.setCollapsible(p,m)}isCollapsed(S){const m=this.o(S);return this.c.isCollapsed(m)}setCollapsed(S,m,p){const v=this.o(S);return this.c.setCollapsed(v,m,p)}expandTo(S){const m=this.o(S);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(S=null){if(S===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(S);if(!m)throw new T.$jU(this.k,`Tree element not found: ${S}`);return m}getNodeLocation(S){return S.element}getParentNodeLocation(S){if(S===null)throw new T.$jU(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(S);if(!m)throw new T.$jU(this.k,`Tree element not found: ${S}`);const p=this.c.getNodeLocation(m),v=this.c.getParentNodeLocation(p);return this.c.getNode(v).element}o(S){if(S===null)return[];const m=this.d.get(S);if(!m)throw new T.$jU(this.k,`Tree element not found: ${S}`);return this.c.getNodeLocation(m)}}t.$uU=H}),define(be[20],pe([1,0,2,14,19,25,3]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OR=void 0;class S extends y.$Tc{f(p,v){this.B(E.$aQ(p,E.$7Q.CLICK,M=>v(new n.$5P(E.getWindow(p),M))))}j(p,v){this.B(E.$aQ(p,E.$7Q.MOUSE_DOWN,M=>v(new n.$5P(E.getWindow(p),M))))}m(p,v){this.B(E.$aQ(p,E.$7Q.MOUSE_OVER,M=>v(new n.$5P(E.getWindow(p),M))))}u(p,v){this.B(E.$aQ(p,E.$7Q.MOUSE_LEAVE,M=>v(new n.$5P(E.getWindow(p),M))))}z(p,v){this.B(E.$aQ(p,E.$7Q.KEY_DOWN,M=>v(new T.$0P(M))))}C(p,v){this.B(E.$aQ(p,E.$7Q.KEY_UP,M=>v(new T.$0P(M))))}D(p,v){this.B(E.$aQ(p,E.$7Q.INPUT,v))}F(p,v){this.B(E.$aQ(p,E.$7Q.BLUR,v))}G(p,v){this.B(E.$aQ(p,E.$7Q.FOCUS,v))}H(p,v){this.B(E.$aQ(p,E.$7Q.CHANGE,v))}I(p){return H.$KR.ignoreTarget(p)}}t.$OR=S}),define(be[39],pe([1,0,56,20,9,18,2]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QR=t.$PR=void 0,t.$PR=11;class S extends T.$OR{constructor(p){super(),this.a=p.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=p.bgWidth+"px",this.bgDomNode.style.height=p.bgHeight+"px",typeof p.top<"u"&&(this.bgDomNode.style.top="0px"),typeof p.left<"u"&&(this.bgDomNode.style.left="0px"),typeof p.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof p.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=p.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(p.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$PR+"px",this.domNode.style.height=t.$PR+"px",typeof p.top<"u"&&(this.domNode.style.top=p.top+"px"),typeof p.left<"u"&&(this.domNode.style.left=p.left+"px"),typeof p.bottom<"u"&&(this.domNode.style.bottom=p.bottom+"px"),typeof p.right<"u"&&(this.domNode.style.right=p.right+"px"),this.g=this.B(new E.$NR),this.B(y.$bQ(this.bgDomNode,y.$7Q.POINTER_DOWN,v=>this.h(v))),this.B(y.$bQ(this.domNode,y.$7Q.POINTER_DOWN,v=>this.h(v))),this.b=this.B(new y.$mQ),this.c=this.B(new n.$ih)}h(p){if(!p.target||!(p.target instanceof Element))return;const v=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,y.getWindow(p))};this.a(),this.b.cancel(),this.c.cancelAndSet(v,200),this.g.startMonitoring(p.target,p.pointerId,p.buttons,M=>{},()=>{this.b.cancel(),this.c.cancel()}),p.preventDefault()}}t.$QR=S}),define(be[59],pe([1,0,2,42,56,39,121,20,5]),function(se,t,E,T,n,H,y,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TR=void 0;const p=140;class v extends S.$OR{constructor(l){super(),this.g=l.lazyRender,this.a=l.host,this.b=l.scrollable,this.c=l.scrollByPage,this.h=l.scrollbarState,this.n=this.B(new y.$SR(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$NR),this.s=!0,this.domNode=(0,T.$MR)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(E.$aQ(this.domNode.domNode,E.$7Q.POINTER_DOWN,h=>this.M(h)))}t(l){const h=this.B(new H.$QR(l));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(l,h,e,s){this.slider=(0,T.$MR)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(E.$aQ(this.slider.domNode,E.$7Q.POINTER_DOWN,f=>{f.button===0&&(f.preventDefault(),this.O(f))})),this.f(this.slider.domNode,f=>{f.leftButton&&f.stopPropagation()})}y(l){return this.h.setVisibleSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(l){return this.h.setScrollSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(l){return this.h.setScrollPosition(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(l){l.target===this.domNode.domNode&&this.N(l)}delegatePointerDown(l){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),s=h+this.h.getSliderPosition()+this.h.getSliderSize(),f=this.U(l);e<=f&&f<=s?l.button===0&&(l.preventDefault(),this.O(l)):this.N(l)}N(l){let h,e;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")h=l.offsetX,e=l.offsetY;else{const f=E.$wQ(this.domNode.domNode);h=l.pageX-f.left,e=l.pageY-f.top}const s=this.S(h,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),l.button===0&&(l.preventDefault(),this.O(l))}O(l){if(!l.target||!(l.target instanceof Element))return;const h=this.U(l),e=this.W(l),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(l.target,l.pointerId,l.buttons,f=>{const c=this.W(f),a=Math.abs(c-e);if(m.$i&&a>p){this.P(s.getScrollPosition());return}const d=this.U(f)-h;this.P(s.getDesiredScrollPositionFromDelta(d))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(l){const h={};this.writeScrollPosition(h,l),this.b.setScrollPositionNow(h)}updateScrollbarSize(l){this.X(l),this.h.setScrollbarSize(l),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$TR=v}),define(be[124],pe([1,0,19,59,39,43,17]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UR=void 0;class S extends T.$TR{constructor(p,v,M){const l=p.getScrollDimensions(),h=p.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:M,scrollbarState:new H.$RR(v.horizontalHasArrows?v.arrowSize:0,v.horizontal===2?0:v.horizontalScrollbarSize,v.vertical===2?0:v.verticalScrollbarSize,l.width,l.scrollWidth,h.scrollLeft),visibility:v.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:v.scrollByPage}),v.horizontalHasArrows){const e=(v.arrowSize-n.$PR)/2,s=(v.horizontalScrollbarSize-n.$PR)/2;this.t({className:"scra",icon:y.$ek.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.$7P(null,1,0))}),this.t({className:"scra",icon:y.$ek.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.$7P(null,-1,0))})}this.w(Math.floor((v.horizontalScrollbarSize-v.horizontalSliderSize)/2),0,void 0,v.horizontalSliderSize)}R(p,v){this.slider.setWidth(p),this.slider.setLeft(v)}Q(p,v){this.domNode.setWidth(p),this.domNode.setHeight(v),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,v){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,v){p.scrollLeft=v}updateOptions(p){this.updateScrollbarSize(p.horizontal===2?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}t.$UR=S}),define(be[125],pe([1,0,19,59,39,43,17]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VR=void 0;class S extends T.$TR{constructor(p,v,M){const l=p.getScrollDimensions(),h=p.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:M,scrollbarState:new H.$RR(v.verticalHasArrows?v.arrowSize:0,v.vertical===2?0:v.verticalScrollbarSize,0,l.height,l.scrollHeight,h.scrollTop),visibility:v.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:v.scrollByPage}),v.verticalHasArrows){const e=(v.arrowSize-n.$PR)/2,s=(v.verticalScrollbarSize-n.$PR)/2;this.t({className:"scra",icon:y.$ek.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.$7P(null,0,1))}),this.t({className:"scra",icon:y.$ek.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.$7P(null,0,-1))})}this.w(0,Math.floor((v.verticalScrollbarSize-v.verticalSliderSize)/2),v.verticalSliderSize,void 0)}R(p,v){this.slider.setHeight(p),this.slider.setTop(v)}Q(p,v){this.domNode.setWidth(v),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,v){return v}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,v){p.scrollTop=v}updateOptions(p){this.updateScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}t.$VR=S}),define(be[60],pe([1,0,16,2,42,19,124,125,20,9,4,3,5,48,99]),function(se,t,E,T,n,H,y,S,m,p,v,M,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1R=t.$ZR=t.$YR=t.$XR=t.$WR=void 0;const e=500,s=50,f=!0;class c{constructor(R,U,z){this.timestamp=R,this.deltaX=U,this.deltaY=z,this.score=0}}class a{static{this.INSTANCE=new a}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,U=0,z=1,D=this.d;do{const O=D===this.c?R:Math.pow(2,-z);if(R-=O,U+=this.b[D].score*O,D===this.c)break;D=(this.a+D-1)%this.a,z++}while(!0);return U<=.5}acceptStandardWheelEvent(R){if(E.$UP){const U=T.getWindow(R.browserEvent),z=(0,E.$NP)(U);this.accept(Date.now(),R.deltaX*z,R.deltaY*z)}else this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,U,z){const D=new c(R,U,z);D.score=this.f(D),this.c===-1&&this.d===-1?(this.b[0]=D,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=D)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let U=.5;const z=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(U+=.25),Math.min(Math.max(U,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$WR=a;class $ extends m.$OR{get options(){return this.a}constructor(R,U,z){super(),this.O=this.B(new v.$Yd),this.onScroll=this.O.event,this.P=this.B(new v.$Yd),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=N(U),this.b=z,this.B(this.b.onScroll(O=>{this.P.fire(O),this.S(O),this.O.fire(O)}));const D={onMouseWheel:O=>this.R(O),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new S.$VR(this.b,this.a,D)),this.g=this.B(new y.$UR(this.b,this.a,D)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$MR)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$MR)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$MR)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,O=>this.Z(O)),this.u(this.t,O=>this.Y(O)),this.L=this.B(new p.$ih),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,M.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,l.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new H.$7P(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,M.$Oc)(this.w),R)){const z=D=>{this.R(new H.$7P(D))};this.w.push(T.$aQ(this.t,T.$7Q.MOUSE_WHEEL,z,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const U=a.INSTANCE;f&&U.acceptStandardWheelEvent(R);let z=!1;if(R.deltaY||R.deltaX){let O=R.deltaY*this.a.mouseWheelScrollSensitivity,W=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&W+O===0?W=O=0:Math.abs(O)>=Math.abs(W)?W=0:O=0),this.a.flipAxes&&([O,W]=[W,O]);const A=!l.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||A)&&!W&&(W=O,O=0),R.browserEvent&&R.browserEvent.altKey&&(W=W*this.a.fastScrollSensitivity,O=O*this.a.fastScrollSensitivity);const P=this.b.getFutureScrollPosition();let L={};if(O){const Y=s*O,X=P.scrollTop-(Y<0?Math.floor(Y):Math.ceil(Y));this.c.writeScrollPosition(L,X)}if(W){const Y=s*W,X=P.scrollLeft-(Y<0?Math.floor(Y):Math.ceil(Y));this.g.writeScrollPosition(L,X)}L=this.b.validateScrollPosition(L),(P.scrollLeft!==L.scrollLeft||P.scrollTop!==L.scrollTop)&&(f&&this.a.mouseWheelSmoothScroll&&U.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(L):this.b.setScrollPositionNow(L),z=!0)}let D=z;!D&&this.a.alwaysConsumeMouseWheel&&(D=!0),!D&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(D=!0),D&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),U=R.scrollTop>0,z=R.scrollLeft>0,D=z?" left":"",O=U?" top":"",W=z||U?" top-left-corner":"";this.n.setClassName(`shadow${D}`),this.r.setClassName(`shadow${O}`),this.s.setClassName(`shadow${W}${O}${D}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$XR=$;class d extends ${constructor(R,U){U=U||{},U.mouseWheelSmoothScroll=!1;const z=new h.$qs({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:D=>T.$kQ(T.getWindow(R),D)});super(R,U,z),this.B(z)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$YR=d;class b extends ${constructor(R,U,z){super(R,U,z)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$ZR=b;class u extends ${constructor(R,U){U=U||{},U.mouseWheelSmoothScroll=!1;const z=new h.$qs({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:D=>T.$kQ(T.getWindow(R),D)});super(R,U,z),this.B(z),this.cb=R,this.B(this.onScroll(D=>{D.scrollTopChanged&&(this.cb.scrollTop=D.scrollTop),D.scrollLeftChanged&&(this.cb.scrollLeft=D.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$1R=u;function N(B){const R={lazyRender:typeof B.lazyRender<"u"?B.lazyRender:!1,className:typeof B.className<"u"?B.className:"",useShadows:typeof B.useShadows<"u"?B.useShadows:!0,handleMouseWheel:typeof B.handleMouseWheel<"u"?B.handleMouseWheel:!0,flipAxes:typeof B.flipAxes<"u"?B.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof B.consumeMouseWheelIfScrollbarIsNeeded<"u"?B.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof B.alwaysConsumeMouseWheel<"u"?B.alwaysConsumeMouseWheel:!1,scrollYToX:typeof B.scrollYToX<"u"?B.scrollYToX:!1,mouseWheelScrollSensitivity:typeof B.mouseWheelScrollSensitivity<"u"?B.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof B.fastScrollSensitivity<"u"?B.fastScrollSensitivity:5,scrollPredominantAxis:typeof B.scrollPredominantAxis<"u"?B.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof B.mouseWheelSmoothScroll<"u"?B.mouseWheelSmoothScroll:!0,arrowSize:typeof B.arrowSize<"u"?B.arrowSize:11,listenOnDomNode:typeof B.listenOnDomNode<"u"?B.listenOnDomNode:null,horizontal:typeof B.horizontal<"u"?B.horizontal:1,horizontalScrollbarSize:typeof B.horizontalScrollbarSize<"u"?B.horizontalScrollbarSize:10,horizontalSliderSize:typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:0,horizontalHasArrows:typeof B.horizontalHasArrows<"u"?B.horizontalHasArrows:!1,vertical:typeof B.vertical<"u"?B.vertical:1,verticalScrollbarSize:typeof B.verticalScrollbarSize<"u"?B.verticalScrollbarSize:10,verticalHasArrows:typeof B.verticalHasArrows<"u"?B.verticalHasArrows:!1,verticalSliderSize:typeof B.verticalSliderSize<"u"?B.verticalSliderSize:0,scrollByPage:typeof B.scrollByPage<"u"?B.scrollByPage:!1};return R.horizontalSliderSize=typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof B.verticalSliderSize<"u"?B.verticalSliderSize:R.verticalScrollbarSize,l.$j&&(R.className+=" mac"),R}}),define(be[61],pe([1,0,54,2,22,25,60,12,9,27,4,3,47,48,83,120,6,33]),function(se,t,E,T,n,H,y,S,m,p,v,M,l,h,e,s,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pS=t.$oS=t.$nS=t.$mS=t.ListViewTargetSector=void 0;const a={CurrentDragAndDropData:void 0};var $;(function(z){z[z.TOP=0]="TOP",z[z.CENTER_TOP=1]="CENTER_TOP",z[z.CENTER_BOTTOM=2]="CENTER_BOTTOM",z[z.BOTTOM=3]="BOTTOM"})($||(t.ListViewTargetSector=$={}));const d={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(z){return[z]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class b{get context(){return this.d}set context(D){this.d=D}constructor(D){this.elements=D}update(){}getData(){return this.elements}}t.$mS=b;class u{constructor(D){this.elements=D}update(){}getData(){return this.elements}}t.$nS=u;class N{constructor(){this.types=[],this.files=[]}update(D){if(D.types&&this.types.splice(0,this.types.length,...D.types),D.files){this.files.splice(0,this.files.length);for(let O=0;O<D.files.length;O++){const W=D.files.item(O);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.$oS=N;function B(z,D){return Array.isArray(z)&&Array.isArray(D)?(0,S.$ub)(z,D):z===D}class R{constructor(D){D?.getSetSize?this.getSetSize=D.getSetSize.bind(D):this.getSetSize=(O,W,A)=>A,D?.getPosInSet?this.getPosInSet=D.getPosInSet.bind(D):this.getPosInSet=(O,W)=>W+1,D?.getRole?this.getRole=D.getRole.bind(D):this.getRole=O=>"listitem",D?.isChecked?this.isChecked=D.isChecked.bind(D):this.isChecked=O=>{}}}class U{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(D){if(D!==this.P){if(D&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=D,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const O of this.d)this.ab(O);this.X(),this.q.setScrollDimensions({width:(0,T.$zQ)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(D,O,W,A=d){if(this.R=O,this.domId=`list_id_${++U.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$8g(50),this.v=!1,this.x=M.$Tc.None,this.y=0,this.G=!1,this.K=M.$Tc.None,this.L=M.$Tc.None,this.M=new M.$Sc,this.N=new v.$Yd,this.O=new v.$Yd,this.onDidChangeContentHeight=v.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=v.Event.latch(this.O.event,void 0,this.M),this.P=!1,A.horizontalScrolling&&A.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(A.paddingTop??0);for(const L of W)this.j.set(L.templateId,L);this.h=this.M.add(new s.$lS(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof A.mouseSupport=="boolean"?A.mouseSupport:!0),this.P=A.horizontalScrolling??d.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof A.paddingBottom>"u"?0:A.paddingBottom,this.D=new R(A.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(A.transformOptimization??d.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$KR.addTarget(this.o)),this.p=this.M.add(new h.$qs({forceIntegerValues:!0,smoothScrollDuration:A.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,T.$kQ)((0,T.getWindow)(this.domNode),L)})),this.q=this.M.add(new y.$ZR(this.o,{alwaysConsumeMouseWheel:A.alwaysConsumeMouseWheel??d.alwaysConsumeMouseWheel,horizontal:1,vertical:A.verticalScrollMode??d.verticalScrollMode,useShadows:A.useShadows??d.useShadows,mouseWheelScrollSensitivity:A.mouseWheelScrollSensitivity,fastScrollSensitivity:A.fastScrollSensitivity,scrollByPage:A.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),D.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,T.$aQ)(this.o,H.EventType.Change,L=>this.jb(L))),this.M.add((0,T.$aQ)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.M.add((0,T.$aQ)(this.domNode,"dragover",L=>this.lb(this.hb(L)))),this.M.add((0,T.$aQ)(this.domNode,"drop",L=>this.nb(this.hb(L)))),this.M.add((0,T.$aQ)(this.domNode,"dragleave",L=>this.mb(this.hb(L)))),this.M.add((0,T.$aQ)(this.domNode,"dragend",L=>this.ob(L))),this.z=A.setRowLineHeight??d.setRowLineHeight,this.A=A.setRowHeight??d.setRowHeight,this.B=A.supportDynamicHeights??d.supportDynamicHeights,this.F=A.dnd??this.M.add(d.dnd),this.layout(A.initialSize?.height,A.initialSize?.width)}updateOptions(D){D.paddingBottom!==void 0&&(this.C=D.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),D.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(D.smoothScrolling?125:0),D.horizontalScrolling!==void 0&&(this.Q=D.horizontalScrolling);let O;if(D.scrollByPage!==void 0&&(O={...O??{},scrollByPage:D.scrollByPage}),D.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:D.mouseWheelScrollSensitivity}),D.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:D.fastScrollSensitivity}),O&&this.q.updateOptions(O),D.paddingTop!==void 0&&D.paddingTop!==this.g.paddingTop){const W=this.vb(this.k,this.m),A=D.paddingTop-this.g.paddingTop;this.g.paddingTop=D.paddingTop,this.Y(W,Math.max(0,this.k+A),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(D){this.q.delegateScrollFromMouseWheelEvent(D)}delegateVerticalScrollbarPointerDown(D){this.q.delegateVerticalScrollbarPointerDown(D)}updateElementHeight(D,O,W){if(D<0||D>=this.d.length)return;const A=this.d[D].size;if(typeof O>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[D].lastDynamicHeightWidth=void 0,O=A+this.xb(D)}if(A===O)return;const P=this.vb(this.k,this.m);let L=0;D<P.start||W!==null&&W>D&&W<P.end?L=O-A:L=0,this.g.splice(D,1,[{size:O}]),this.d[D].size=O,this.Y(P,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(D){return new e.$kS(D)}splice(D,O,W=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(D,O,W)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(D,O,W=[]){const A=this.vb(this.k,this.m),P={start:D,end:D+O},L=l.Range.intersect(A,P),Y=new Map;for(let K=L.end-1;K>=L.start;K--){const ie=this.d[K];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let fe=Y.get(ie.templateId);fe||(fe=[],Y.set(ie.templateId,fe));const ye=this.j.get(ie.templateId);ye&&ye.disposeElement&&ye.disposeElement(ie.element,K,ie.row.templateData,ie.size),fe.push(ie.row)}ie.row=null,ie.stale=!0}const X={start:D+O,end:this.d.length},de=l.Range.intersect(X,A),ue=l.Range.relativeComplement(X,A),te=W.map(K=>({id:String(this.f++),element:K,templateId:this.R.getTemplateId(K),size:this.R.getHeight(K),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(K),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.$Tc.None,checkedDisposable:M.$Tc.None,stale:!1}));let ge;D===0&&O>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,te),ge=this.d,this.d=te):(this.g.splice(D,O,te),ge=this.d.splice(D,O,...te));const Pe=W.length-O,Ne=this.vb(this.k,this.m),Be=(0,e.$iS)(de,Pe),le=l.Range.intersect(Ne,Be);for(let K=le.start;K<le.end;K++)this.bb(this.d[K],K);const J=l.Range.relativeComplement(Be,Ne);for(const K of J)for(let ie=K.start;ie<K.end;ie++)this.db(ie);const ae=ue.map(K=>(0,e.$iS)(K,Pe)),G=[{start:D,end:D+W.length},...ae].map(K=>l.Range.intersect(Ne,K)).reverse();for(const K of G)for(let ie=K.end-1;ie>=K.start;ie--){const fe=this.d[ie],Ce=Y.get(fe.templateId)?.pop();this.Z(ie,Ce)}for(const K of Y.values())for(const ie of K)this.h.release(ie);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ge.map(K=>K.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,T.$kQ)((0,T.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let D=0;for(const O of this.d)typeof O.width<"u"&&(D=Math.max(D,O.width));this.E=D,this.q.setScrollDimensions({scrollWidth:D===0?0:D+10}),this.O.fire(this.E)}updateWidth(D){if(!this.Q||typeof this.E>"u")return;const O=this.d[D];this.ab(O),typeof O.width<"u"&&O.width>this.E&&(this.E=O.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const D of this.d)D.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const D=this.firstVisibleIndex,O=this.g.positionAt(D),W=this.g.positionAt(D+1);return W!==-1&&(W-O)/2+O<this.scrollTop?D+1:D}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(D){return this.d[D].element}indexOf(D){return this.d.findIndex(O=>O.element===D)}domElement(D){const O=this.d[D].row;return O&&O.domNode}elementHeight(D){return this.d[D].size}elementTop(D){return this.g.positionAt(D)}indexAt(D){return this.g.indexAt(D)}indexAfter(D){return this.g.indexAfter(D)}layout(D,O){const W={height:typeof D=="number"?D:(0,T.$BQ)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,W.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(W),typeof O<"u"&&(this.n=O,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof O=="number"?O:(0,T.$zQ)(this.domNode)})}Y(D,O,W,A,P,L=!1){const Y=this.vb(O,W),X=l.Range.relativeComplement(Y,D).reverse(),de=l.Range.relativeComplement(D,Y);if(L){const ue=l.Range.intersect(D,Y);for(let te=ue.start;te<ue.end;te++)this.bb(this.d[te],te)}this.h.transact(()=>{for(const ue of de)for(let te=ue.start;te<ue.end;te++)this.db(te);for(const ue of X)for(let te=ue.end-1;te>=ue.start;te--)this.Z(te)}),A!==void 0&&(this.o.style.left=`-${A}px`),this.o.style.top=`-${O}px`,this.Q&&P!==void 0&&(this.o.style.width=`${Math.max(P,this.n)}px`),this.k=O,this.m=W}Z(D,O){const W=this.d[D];if(!W.row)if(O)W.row=O,W.stale=!0;else{const X=this.h.alloc(W.templateId);W.row=X.row,W.stale||=X.isReusingConnectedDomNode}const A=this.D.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",A);const P=this.D.isChecked(W.element);if(typeof P=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!P));else if(P){const X=de=>W.row.domNode.setAttribute("aria-checked",String(!!de));X(P.value),W.checkedDisposable=P.onDidChange(X)}if(W.stale||!W.row.domNode.parentElement){const X=this.d.at(D+1)?.row?.domNode??null;this.o.insertBefore(W.row.domNode,X),W.stale=!1}this.bb(W,D);const L=this.j.get(W.templateId);if(!L)throw new Error(`No renderer found for template id ${W.templateId}`);L?.renderElement(W.element,D,W.row.templateData,W.size);const Y=this.F.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!Y,Y&&(W.dragStartDisposable=(0,T.$aQ)(W.row.domNode,"dragstart",X=>this.kb(W.element,Y,X))),this.Q&&(this.ab(W),this.W())}ab(D){if(!D.row||!D.row.domNode)return;D.row.domNode.style.width="fit-content",D.width=(0,T.$zQ)(D.row.domNode);const O=(0,T.getWindow)(D.row.domNode).getComputedStyle(D.row.domNode);O.paddingLeft&&(D.width+=parseFloat(O.paddingLeft)),O.paddingRight&&(D.width+=parseFloat(O.paddingRight)),D.row.domNode.style.width=""}bb(D,O){D.row.domNode.style.top=`${this.elementTop(O)}px`,this.A&&(D.row.domNode.style.height=`${D.size}px`),this.z&&(D.row.domNode.style.lineHeight=`${D.size}px`),D.row.domNode.setAttribute("data-index",`${O}`),D.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),D.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),D.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(D.element,O,this.length))),D.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(D.element,O))),D.row.domNode.setAttribute("id",this.getElementDomId(O)),D.row.domNode.classList.toggle("drop-target",D.dropTarget)}db(D){const O=this.d[D];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const W=this.j.get(O.templateId);W&&W.disposeElement&&W.disposeElement(O.element,D,O.row.templateData,O.size),this.h.release(O.row),O.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(D,O){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:D,reuseAnimation:O})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(D){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:D})}get scrollTop(){return this.getScrollTop()}set scrollTop(D){this.setScrollTop(D)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"click")).event,D=>this.eb(D),this.M)}get onMouseDblClick(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"dblclick")).event,D=>this.eb(D),this.M)}get onMouseMiddleClick(){return v.Event.filter(v.Event.map(this.M.add(new n.$cS(this.domNode,"auxclick")).event,D=>this.eb(D),this.M),D=>D.browserEvent.button===1,this.M)}get onMouseUp(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"mouseup")).event,D=>this.eb(D),this.M)}get onMouseDown(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"mousedown")).event,D=>this.eb(D),this.M)}get onMouseOver(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"mouseover")).event,D=>this.eb(D),this.M)}get onMouseMove(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"mousemove")).event,D=>this.eb(D),this.M)}get onMouseOut(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"mouseout")).event,D=>this.eb(D),this.M)}get onContextMenu(){return v.Event.any(v.Event.map(this.M.add(new n.$cS(this.domNode,"contextmenu")).event,D=>this.eb(D),this.M),v.Event.map(this.M.add(new n.$cS(this.domNode,H.EventType.Contextmenu)).event,D=>this.gb(D),this.M))}get onTouchStart(){return v.Event.map(this.M.add(new n.$cS(this.domNode,"touchstart")).event,D=>this.fb(D),this.M)}get onTap(){return v.Event.map(this.M.add(new n.$cS(this.o,H.EventType.Tap)).event,D=>this.gb(D),this.M)}eb(D){const O=this.ub(D.target||null),W=typeof O>"u"?void 0:this.d[O],A=W&&W.element;return{browserEvent:D,index:O,element:A}}fb(D){const O=this.ub(D.target||null),W=typeof O>"u"?void 0:this.d[O],A=W&&W.element;return{browserEvent:D,index:O,element:A}}gb(D){const O=this.ub(D.initialTarget||null),W=typeof O>"u"?void 0:this.d[O],A=W&&W.element;return{browserEvent:D,index:O,element:A}}hb(D){const O=this.ub(D.target||null),W=typeof O>"u"?void 0:this.d[O],A=W&&W.element,P=this.tb(D,O);return{browserEvent:D,index:O,element:A,sector:P}}ib(D){try{const O=this.vb(this.k,this.m);this.Y(O,D.scrollTop,D.height,D.scrollLeft,D.scrollWidth),this.B&&this.wb(D.scrollTop,D.height,D.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",D),O}}jb(D){D.preventDefault(),D.stopPropagation(),this.scrollTop-=D.translationY}kb(D,O,W){if(!W.dataTransfer)return;const A=this.F.getDragElements(D);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(E.$IR.TEXT,O),W.dataTransfer.setDragImage){let P;this.F.getDragLabel&&(P=this.F.getDragLabel(A,W)),typeof P>"u"&&(P=String(A.length));const L=(0,T.$)(".monaco-drag-image");L.textContent=P;const X=(de=>{for(;de&&!de.classList.contains("monaco-workbench");)de=de.parentElement;return de||this.domNode.ownerDocument})(this.domNode);X.appendChild(L),W.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>X.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new b(A),a.CurrentDragAndDropData=new u(A),this.F.onDragStart?.(this.H,W)}lb(D){if(D.browserEvent.preventDefault(),this.L.dispose(),a.CurrentDragAndDropData&&a.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(D.browserEvent),!D.browserEvent.dataTransfer))return!1;if(!this.H)if(a.CurrentDragAndDropData)this.H=a.CurrentDragAndDropData;else{if(!D.browserEvent.dataTransfer.types)return!1;this.H=new N}const O=this.F.onDragOver(this.H,D.element,D.index,D.sector,D.browserEvent);if(this.G=typeof O=="boolean"?O:O.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;D.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===0?"copy":"move";let W;typeof O!="boolean"&&O.feedback?W=O.feedback:typeof D.index>"u"?W=[-1]:W=[D.index],W=(0,S.$Mb)(W).filter(P=>P>=-1&&P<this.length).sort((P,L)=>P-L),W=W[0]===-1?[-1]:W;let A=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:"drop-target";if(B(this.I,W)&&this.J===A)return!0;if(this.I=W,this.J=A,this.K.dispose(),W[0]===-1)this.domNode.classList.add(A),this.o.classList.add(A),this.K=(0,M.$Rc)(()=>{this.domNode.classList.remove(A),this.o.classList.remove(A)});else{if(W.length>1&&A!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");A==="drop-target-after"&&W[0]<this.length-1&&(W[0]+=1,A="drop-target-before");for(const P of W){const L=this.d[P];L.dropTarget=!0,L.row?.domNode.classList.add(A)}this.K=(0,M.$Rc)(()=>{for(const P of W){const L=this.d[P];L.dropTarget=!1,L.row?.domNode.classList.remove(A)}})}return!0}mb(D){this.L.dispose(),this.L=(0,m.$ah)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,D.element,D.index,D.browserEvent)}nb(D){if(!this.G)return;const O=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,!(!O||!D.browserEvent.dataTransfer)&&(D.browserEvent.preventDefault(),O.update(D.browserEvent.dataTransfer),this.F.drop(O,D.element,D.index,D.sector,D.browserEvent))}ob(D){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(D)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=M.$Tc.None}qb(D){if(!this.w){const O=(0,T.$tQ)(this.domNode).top;this.w=(0,T.$qR)((0,T.getWindow)(this.domNode),this.rb.bind(this,O))}this.x.dispose(),this.x=(0,m.$ah)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=D.pageY}rb(D){if(this.y===void 0)return;const O=this.y-D,W=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-W))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(D,O){if(O===void 0)return;const W=D.offsetY/this.d[O].size,A=Math.floor(W/.25);return(0,c.$_l)(A,0,3)}ub(D){const O=this.q.getDomNode();let W=D;for(;W instanceof HTMLElement&&W!==this.o&&O.contains(W);){const A=W.getAttribute("data-index");if(A){const P=Number(A);if(!isNaN(P))return P}W=W.parentElement}}vb(D,O){return{start:this.g.indexAt(D),end:this.g.indexAfter(D+O-1)}}wb(D,O,W){const A=this.vb(D,O);let P,L;D===this.elementTop(A.start)?(P=A.start,L=0):A.end-A.start>1&&(P=A.start+1,L=this.elementTop(P)-D);let Y=0;for(;;){const X=this.vb(D,O);let de=!1;for(let ue=X.start;ue<X.end;ue++){const te=this.xb(ue);te!==0&&this.g.splice(ue,1,[this.d[ue]]),Y+=te,de=de||te!==0}if(!de){Y!==0&&this.V();const ue=l.Range.relativeComplement(A,X);for(const ge of ue)for(let Pe=ge.start;Pe<ge.end;Pe++)this.d[Pe].row&&this.db(Pe);const te=l.Range.relativeComplement(X,A).reverse();for(const ge of te)for(let Pe=ge.end-1;Pe>=ge.start;Pe--)this.Z(Pe);for(let ge=X.start;ge<X.end;ge++)this.d[ge].row&&this.bb(this.d[ge],ge);if(typeof P=="number"){const ge=this.p.getFutureScrollPosition().scrollTop-D,Pe=this.elementTop(P)-L+ge;this.setScrollTop(Pe,W)}this.N.fire(this.contentHeight);return}}}xb(D){const O=this.d[D];if(this.R.getDynamicHeight){const L=this.R.getDynamicHeight(O.element);if(L!==null){const Y=O.size;return O.size=L,O.lastDynamicHeightWidth=this.n,L-Y}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(O.element))return 0;const W=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.lastDynamicHeightWidth=this.n,O.size-W;const{row:A}=this.h.alloc(O.templateId);A.domNode.style.height="",this.o.appendChild(A.domNode);const P=this.j.get(O.templateId);if(!P)throw new f.$cb("Missing renderer for templateId: "+O.templateId);return P.renderElement(O.element,D,A.templateData,void 0),O.size=A.domNode.offsetHeight,P.disposeElement?.(O.element,D,A.templateData,void 0),this.R.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.n,this.o.removeChild(A.domNode),this.h.release(A),O.size-W}getElementDomId(D){return`${this.domId}_${D}`}dispose(){for(const D of this.d)if(D.dragStartDisposable.dispose(),D.checkedDisposable.dispose(),D.row){const O=this.j.get(D.row.templateId);O&&(O.disposeElement?.(D.element,-1,D.row.templateData,void 0),O.disposeTemplate(D.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$pS=U,Ye([p.$Ch],U.prototype,"onMouseClick",null),Ye([p.$Ch],U.prototype,"onMouseDblClick",null),Ye([p.$Ch],U.prototype,"onMouseMiddleClick",null),Ye([p.$Ch],U.prototype,"onMouseUp",null),Ye([p.$Ch],U.prototype,"onMouseDown",null),Ye([p.$Ch],U.prototype,"onMouseOver",null),Ye([p.$Ch],U.prototype,"onMouseMove",null),Ye([p.$Ch],U.prototype,"onMouseOut",null),Ye([p.$Ch],U.prototype,"onContextMenu",null),Ye([p.$Ch],U.prototype,"onTouchStart",null),Ye([p.$Ch],U.prototype,"onTap",null)}),define(be[40],pe([1,0,2,22,14,25,57,71,12,9,74,27,4,35,3,33,5,7,70,61,19,98]),function(se,t,E,T,n,H,y,S,m,p,v,M,l,h,e,s,f,c,a,$,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HS=t.$GS=t.$FS=t.$ES=t.$DS=t.$CS=t.$BS=t.TypeNavigationMode=t.$AS=t.$zS=t.$yS=t.$xS=t.$wS=t.$vS=t.$uS=t.$tS=void 0;class b{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,k,F){const r=this.c.findIndex(i=>i.templateData===F);if(r>=0){const i=this.c[r];this.d.unrender(F),i.index=k}else{const i={index:k,templateData:F};this.c.push(i)}this.d.renderIndex(k,F)}splice(g,k,F){const r=[];for(const i of this.c)i.index<g?r.push(i):i.index>=g+k&&r.push({index:i.index+F-k,templateData:i.templateData});this.c=r}renderIndexes(g){for(const{index:k,templateData:F}of this.c)g.indexOf(k)>-1&&this.d.renderIndex(k,F)}disposeTemplate(g){const k=this.c.findIndex(F=>F.templateData===g);k<0||this.c.splice(k,1)}}class u{get name(){return this.g}get renderer(){return new b(this)}constructor(g){this.g=g,this.c=[],this.d=[],this.f=new l.$Yd,this.onChange=this.f.event}splice(g,k,F){const r=F.length-k,i=g+k,o=[];let w=0;for(;w<this.d.length&&this.d[w]<g;)o.push(this.d[w++]);for(let I=0;I<F.length;I++)F[I]&&o.push(I+g);for(;w<this.d.length&&this.d[w]>=i;)o.push(this.d[w++]+r);this.renderer.splice(g,k,F.length),this.h(o,o)}renderIndex(g,k){k.classList.toggle(this.g,this.contains(g))}unrender(g){g.classList.remove(this.g)}set(g,k){return this.h(g,[...g].sort(ie),k)}h(g,k,F){const r=this.c,i=this.d;this.c=g,this.d=k;const o=G(i,g);return this.renderer.renderIndexes(o),this.f.fire({indexes:g,browserEvent:F}),r}get(){return this.c}contains(g){return(0,m.$wb)(this.d,g,ie)>=0}dispose(){(0,e.$Oc)(this.f)}}Ye([M.$Ch],u.prototype,"renderer",null);class N extends u{constructor(g){super("selected"),this.k=g}renderIndex(g,k){super.renderIndex(g,k),this.k&&(this.contains(g)?k.setAttribute("aria-selected","true"):k.setAttribute("aria-selected","false"))}}class B{constructor(g,k,F){this.c=g,this.d=k,this.f=F}splice(g,k,F){if(!this.f)return this.c.splice(g,k,new Array(F.length).fill(!1));const r=this.c.get().map(w=>this.f.getId(this.d.element(w)).toString());if(r.length===0)return this.c.splice(g,k,new Array(F.length).fill(!1));const i=new Set(r),o=F.map(w=>i.has(this.f.getId(w).toString()));this.c.splice(g,k,o)}}function R(q){return q.tagName==="INPUT"||q.tagName==="TEXTAREA"}t.$tS=R;function U(q,g){return q.classList.contains(g)?!0:q.classList.contains("monaco-list")||!q.parentElement?!1:U(q.parentElement,g)}function z(q){return U(q,"monaco-editor")}t.$uS=z;function D(q){return U(q,"monaco-custom-toggle")}t.$vS=D;function O(q){return U(q,"action-item")}t.$wS=O;function W(q){return U(q,"monaco-tl-twistie")}t.$xS=W;function A(q){return U(q,"monaco-tree-sticky-row")}t.$yS=A;function P(q){return q.classList.contains("monaco-tree-sticky-container")}t.$zS=P;function L(q){return q.tagName==="A"&&q.classList.contains("monaco-button")||q.tagName==="DIV"&&q.classList.contains("monaco-button-dropdown")?!0:q.classList.contains("monaco-list")||!q.parentElement?!1:L(q.parentElement)}t.$AS=L;class Y{get g(){return l.Event.chain(this.c.add(new T.$cS(this.k.domNode,"keydown")).event,g=>g.filter(k=>!R(k.target)).map(k=>new n.$0P(k)))}constructor(g,k,F){this.h=g,this.k=k,this.c=new e.$Sc,this.d=new e.$Sc,this.f=F.multipleSelectionSupport,this.c.add(this.g(r=>{switch(r.keyCode){case 3:return this.l(r);case 16:return this.o(r);case 18:return this.p(r);case 11:return this.q(r);case 12:return this.s(r);case 9:return this.u(r);case 31:this.f&&(f.$j?r.metaKey:r.ctrlKey)&&this.t(r)}}))}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.f=g.multipleSelectionSupport)}l(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection(this.h.getFocus(),g.browserEvent)}o(g){g.preventDefault(),g.stopPropagation(),this.h.focusPrevious(1,!1,g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.h.focusNext(1,!1,g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.h.focusPreviousPage(g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.h.focusNextPage(g.browserEvent);const k=this.h.getFocus()[0];this.h.setAnchor(k),this.h.reveal(k),this.k.domNode.focus()}t(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(g){this.h.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.h.setSelection([],g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ye([M.$Ch],Y.prototype,"g",null);var X;(function(q){q[q.Automatic=0]="Automatic",q[q.Trigger=1]="Trigger"})(X||(t.TypeNavigationMode=X={}));var de;(function(q){q[q.Idle=0]="Idle",q[q.Typing=1]="Typing"})(de||(de={})),t.$BS=new class{mightProducePrintableCharacter(q){return q.ctrlKey||q.metaKey||q.altKey?!1:q.keyCode>=31&&q.keyCode<=56||q.keyCode>=21&&q.keyCode<=30||q.keyCode>=98&&q.keyCode<=107||q.keyCode>=85&&q.keyCode<=95}};class ue{constructor(g,k,F,r,i){this.o=g,this.p=k,this.q=F,this.s=r,this.t=i,this.c=!1,this.d=de.Idle,this.f=X.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??X.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const k=l.Event.chain(this.k.add(new T.$cS(this.p.domNode,"keydown")).event,i=>i.filter(o=>!R(o.target)).filter(()=>this.f===X.Automatic||this.g).map(o=>new n.$0P(o)).filter(o=>g||this.s(o)).filter(o=>this.t.mightProducePrintableCharacter(o)).forEach(o=>E.$9Q.stop(o,!0)).map(o=>o.browserEvent.key)),F=l.Event.debounce(k,()=>null,800,void 0,void 0,void 0,this.k);l.Event.reduce(l.Event.any(k,F),(i,o)=>o===null?null:(i||"")+o,void 0,this.k)(this.x,this,this.k),F(this.w,this,this.k),k(()=>g=!0,void 0,this.k),F(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const k=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));k&&(0,y.$eS)(k)}this.h=-1}x(g){if(!g){this.d=de.Idle,this.g=!1;return}const k=this.o.getFocus(),F=k.length>0?k[0]:0,r=this.d===de.Idle?1:0;this.d=de.Typing;for(let i=0;i<this.o.length;i++){const o=(F+i+r)%this.o.length,w=this.q.getKeyboardNavigationLabel(this.p.element(o)),I=w&&w.toString();if(this.o.options.typeNavigationEnabled){if(typeof I<"u"){if((0,h.$Zj)(g,I)){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}const C=(0,h.$7j)(g,I);if(C&&C[0].end-C[0].start>1&&C.length===1){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}}}else if(typeof I>"u"||(0,h.$Zj)(g,I)){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class te{constructor(g,k){this.d=g,this.f=k,this.c=new e.$Sc;const F=l.Event.chain(this.c.add(new T.$cS(k.domNode,"keydown")).event,i=>i.filter(o=>!R(o.target)).map(o=>new n.$0P(o)));l.Event.chain(F,i=>i.filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey))(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const k=this.d.getFocus();if(k.length===0)return;const F=this.f.domElement(k[0]);if(!F)return;const r=F.querySelector("[tabIndex]");if(!r||!(r instanceof HTMLElement)||r.tabIndex===-1)return;const i=(0,E.getWindow)(r).getComputedStyle(r);i.visibility==="hidden"||i.display==="none"||(g.preventDefault(),g.stopPropagation(),r.focus())}dispose(){this.c.dispose()}}function ge(q){return f.$j?q.browserEvent.metaKey:q.browserEvent.ctrlKey}t.$CS=ge;function Pe(q){return q.browserEvent.shiftKey}t.$DS=Pe;function Ne(q){return(0,E.$3Q)(q)&&q.button===2}const Be={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Pe};class le{constructor(g){this.k=g,this.f=new e.$Sc,this.g=new l.$Yd,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(H.$KR.addTarget(g.getHTMLElement()))),l.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){z(g.browserEvent.target)||(0,E.$MQ)()!==g.browserEvent.target&&this.k.domFocus()}t(g){if(R(g.browserEvent.target)||z(g.browserEvent.target))return;const k=typeof g.index>"u"?[]:[g.index];this.k.setFocus(k,g.browserEvent)}u(g){if(!this.d||R(g.browserEvent.target)||z(g.browserEvent.target)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const k=g.index;if(typeof k>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.q(g))return this.w(g);this.k.setFocus([k],g.browserEvent),this.k.setAnchor(k),Ne(g.browserEvent)||this.k.setSelection([k],g.browserEvent),this.g.fire(g)}v(g){if(R(g.browserEvent.target)||z(g.browserEvent.target)||this.q(g)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const k=this.k.getFocus();this.k.setSelection(k,g.browserEvent)}w(g){const k=g.index;let F=this.k.getAnchor();if(this.p(g)){typeof F>"u"&&(F=this.k.getFocus()[0]??k,this.k.setAnchor(F));const r=Math.min(F,k),i=Math.max(F,k),o=(0,m.$Sb)(r,i+1),w=this.k.getSelection(),I=re(G(w,[F]),F);if(I.length===0)return;const C=G(o,K(w,I));this.k.setSelection(C,g.browserEvent),this.k.setFocus([k],g.browserEvent)}else if(this.o(g)){const r=this.k.getSelection(),i=r.filter(o=>o!==k);this.k.setFocus([k]),this.k.setAnchor(k),r.length===i.length?this.k.setSelection([...i,k],g.browserEvent):this.k.setSelection(i,g.browserEvent)}}dispose(){this.f.dispose()}}t.$ES=le;class J{constructor(g,k){this.c=g,this.d=k}style(g){const k=this.d&&`.${this.d}`,F=[];g.listBackground&&F.push(`.monaco-list${k} .monaco-list-rows { background: ${g.listBackground}; }`),g.listFocusBackground&&(F.push(`.monaco-list${k}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),F.push(`.monaco-list${k}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(F.push(`.monaco-list${k}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),F.push(`.monaco-list${k}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&F.push(`.monaco-list${k}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionBackground&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(F.push(`.monaco-list${k} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),F.push(`.monaco-list${k} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&F.push(`.monaco-list${k} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(F.push(`.monaco-list${k} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),F.push(`.monaco-list${k} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(F.push(`.monaco-list${k} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),F.push(`.monaco-list${k} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&F.push(`.monaco-list${k} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&F.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&F.push(`.monaco-list${k}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`);const r=(0,E.$tR)(g.listFocusAndSelectionOutline,(0,E.$tR)(g.listSelectionOutline,g.listFocusOutline??""));r&&F.push(`.monaco-list${k}:focus .monaco-list-row.focused.selected { outline: 1px solid ${r}; outline-offset: -1px;}`),g.listFocusOutline&&F.push(`
				.monaco-drag-image,
				.monaco-list${k}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${k}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`);const i=(0,E.$tR)(g.listSelectionOutline,g.listInactiveFocusOutline??"");i&&F.push(`.monaco-list${k} .monaco-list-row.focused.selected { outline: 1px dotted ${i}; outline-offset: -1px; }`),g.listSelectionOutline&&F.push(`.monaco-list${k} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listInactiveFocusOutline&&F.push(`.monaco-list${k} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&F.push(`.monaco-list${k} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropOverBackground&&F.push(`
				.monaco-list${k}.drop-target,
				.monaco-list${k} .monaco-list-rows.drop-target,
				.monaco-list${k} .monaco-list-row.drop-target { background-color: ${g.listDropOverBackground} !important; color: inherit !important; }
			`),g.listDropBetweenBackground&&(F.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${k} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`),F.push(`
			.monaco-list${k} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${k} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`)),g.tableColumnsBorder&&F.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&F.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=F.join(`
`)}}t.$FS=J,t.$GS={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:v.$rt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:v.$rt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:v.$rt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function re(q,g){const k=q.indexOf(g);if(k===-1)return[];const F=[];let r=k-1;for(;r>=0&&q[r]===g-(k-r);)F.push(q[r--]);for(F.reverse(),r=k;r<q.length&&q[r]===g+(r-k);)F.push(q[r++]);return F}function G(q,g){const k=[];let F=0,r=0;for(;F<q.length||r<g.length;)if(F>=q.length)k.push(g[r++]);else if(r>=g.length)k.push(q[F++]);else if(q[F]===g[r]){k.push(q[F]),F++,r++;continue}else q[F]<g[r]?k.push(q[F++]):k.push(g[r++]);return k}function K(q,g){const k=[];let F=0,r=0;for(;F<q.length||r<g.length;)if(F>=q.length)k.push(g[r++]);else if(r>=g.length)k.push(q[F++]);else if(q[F]===g[r]){F++,r++;continue}else q[F]<g[r]?k.push(q[F++]):r++;return k}const ie=(q,g)=>q-g;class fe{constructor(g,k){this.c=g,this.d=k}get templateId(){return this.c}renderTemplate(g){return this.d.map(k=>k.renderTemplate(g))}renderElement(g,k,F,r){let i=0;for(const o of this.d)o.renderElement(g,k,F[i++],r)}disposeElement(g,k,F,r){let i=0;for(const o of this.d)o.disposeElement?.(g,k,F[i],r),i+=1}disposeTemplate(g){let k=0;for(const F of this.d)F.disposeTemplate(g[k++])}}class ye{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,k,F){const r=this.c.getAriaLabel(g);r?F.setAttribute("aria-label",r):F.removeAttribute("aria-label");const i=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof i=="number"?F.setAttribute("aria-level",`${i}`):F.removeAttribute("aria-level")}disposeTemplate(g){}}class Ce{constructor(g,k){this.c=g,this.d=k}getDragElements(g){const k=this.c.getSelectedElements();return k.indexOf(g)>-1?k:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,k){if(this.d.getDragLabel)return this.d.getDragLabel(g,k)}onDragStart(g,k){this.d.onDragStart?.(g,k)}onDragOver(g,k,F,r,i){return this.d.onDragOver(g,k,F,r,i)}onDragLeave(g,k,F,r){this.d.onDragLeave?.(g,k,F,r)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,k,F,r,i){this.d.drop(g,k,F,r,i)}dispose(){this.d.dispose()}}class Ae{get onDidChangeFocus(){return l.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.G(g),this.y)}get onDidChangeSelection(){return l.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.G(g),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const k=l.Event.chain(this.y.add(new T.$cS(this.k.domNode,"keydown")).event,i=>i.map(o=>new n.$0P(o)).filter(o=>g=o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>E.$9Q.stop(o,!0)).filter(()=>!1)),F=l.Event.chain(this.y.add(new T.$cS(this.k.domNode,"keyup")).event,i=>i.forEach(()=>g=!1).map(o=>new n.$0P(o)).filter(o=>o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>E.$9Q.stop(o,!0)).map(({browserEvent:o})=>{const w=this.getFocus(),I=w.length?w[0]:void 0,C=typeof I<"u"?this.k.element(I):void 0,j=typeof I<"u"?this.k.domElement(I):this.k.domNode;return{index:I,element:C,anchor:j,browserEvent:o}})),r=l.Event.chain(this.k.onContextMenu,i=>i.filter(o=>!g).map(({element:o,index:w,browserEvent:I})=>({element:o,index:w,anchor:new d.$5P((0,E.getWindow)(this.k.domNode),I),browserEvent:I})));return l.Event.any(k,F,r)}get onKeyDown(){return this.y.add(new T.$cS(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new T.$cS(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new T.$cS(this.k.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.y.add(new T.$cS(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.y.add(new T.$cS(this.k.domNode,"blur",!0)).event)}constructor(g,k,F,r,i=ae){this.A=g,this.B=i,this.c=new u("focused"),this.f=new u("anchor"),this.g=new l.$7d,this.x="",this.y=new e.$Sc,this.z=new l.$Yd,this.onDidDispose=this.z.event;const o=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(o!=="listbox");const w=[this.c.renderer,this.d.renderer];this.u=i.accessibilityProvider,this.u&&(w.push(new ye(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),r=r.map(C=>new fe(C.templateId,[...w,C]));const I={...i,dnd:i.dnd&&new Ce(this,i.dnd)};if(this.k=this.C(k,F,r,I),this.k.domNode.setAttribute("role",o),i.styleController)this.q=i.styleController(this.k.domId);else{const C=(0,E.$VQ)(this.k.domNode);this.q=new J(C,this.k.domId)}if(this.o=new S.$gS([new B(this.c,this.k,i.identityProvider),new B(this.d,this.k,i.identityProvider),new B(this.f,this.k,i.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new te(this,this.k)),(typeof i.keyboardSupport!="boolean"||i.keyboardSupport)&&(this.v=new Y(this,this.k,i),this.y.add(this.v)),i.keyboardNavigationLabelProvider){const C=i.keyboardNavigationDelegate||t.$BS;this.t=new ue(this,this.k,i.keyboardNavigationLabelProvider,i.keyboardNavigationEventFilter??(()=>!0),C),this.y.add(this.t)}this.w=this.D(i),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(g,k,F,r){return new $.$pS(g,k,F,r)}D(g){return new le(this)}updateOptions(g={}){this.B={...this.B,...g},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.B}splice(g,k,F=[]){if(g<0||g>this.k.length)throw new a.$rS(this.A,`Invalid start index: ${g}`);if(k<0)throw new a.$rS(this.A,`Invalid delete count: ${k}`);k===0&&F.length===0||this.g.bufferEvents(()=>this.o.splice(g,k,F))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,k){this.k.updateElementHeight(g,k,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}indexAt(g){return this.k.indexAt(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(g){this.x=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,k){this.k.layout(g,k)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,k){for(const F of g)if(F<0||F>=this.length)throw new a.$rS(this.A,`Invalid index ${F}`);this.d.set(g,k)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new a.$rS(this.A,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,k){for(const F of g)if(F<0||F>=this.length)throw new a.$rS(this.A,`Invalid index ${F}`);this.c.set(g,k)}focusNext(g=1,k=!1,F,r){if(this.length===0)return;const i=this.c.get(),o=this.E(i.length>0?i[0]+g:0,k,r);o>-1&&this.setFocus([o],F)}focusPrevious(g=1,k=!1,F,r){if(this.length===0)return;const i=this.c.get(),o=this.F(i.length>0?i[0]-g:0,k,r);o>-1&&this.setFocus([o],F)}async focusNextPage(g,k){let F=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);F=F===0?0:F-1;const r=this.getFocus()[0];if(r!==F&&(r===void 0||F>r)){const i=this.F(F,!1,k);i>-1&&r!==i?this.setFocus([i],g):this.setFocus([F],g)}else{const i=this.k.getScrollTop();let o=i+this.k.renderHeight;F>r&&(o-=this.k.elementHeight(F)),this.k.setScrollTop(o),this.k.getScrollTop()!==i&&(this.setFocus([]),await(0,p.$_g)(0),await this.focusNextPage(g,k))}}async focusPreviousPage(g,k,F=()=>0){let r;const i=F(),o=this.k.getScrollTop()+i;o===0?r=this.k.indexAt(o):r=this.k.indexAfter(o-1);const w=this.getFocus()[0];if(w!==r&&(w===void 0||w>=r)){const I=this.E(r,!1,k);I>-1&&w!==I?this.setFocus([I],g):this.setFocus([r],g)}else{const I=o;this.k.setScrollTop(o-this.k.renderHeight-i),this.k.getScrollTop()+F()!==I&&(this.setFocus([]),await(0,p.$_g)(0),await this.focusPreviousPage(g,k,F))}}focusLast(g,k){if(this.length===0)return;const F=this.F(this.length-1,!1,k);F>-1&&this.setFocus([F],g)}focusFirst(g,k){this.focusNth(0,g,k)}focusNth(g,k,F){if(this.length===0)return;const r=this.E(g,!1,F);r>-1&&this.setFocus([r],k)}E(g,k=!1,F){for(let r=0;r<this.length;r++){if(g>=this.length&&!k)return-1;if(g=g%this.length,!F||F(this.element(g)))return g;g++}return-1}F(g,k=!1,F){for(let r=0;r<this.length;r++){if(g<0&&!k)return-1;if(g=(this.length+g%this.length)%this.length,!F||F(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,k,F=0){if(g<0||g>=this.length)throw new a.$rS(this.A,`Invalid index ${g}`);const r=this.k.getScrollTop(),i=this.k.elementTop(g),o=this.k.elementHeight(g);if((0,c.$Qf)(k)){const w=o-this.k.renderHeight+F;this.k.setScrollTop(w*(0,s.$_l)(k,0,1)+i-F)}else{const w=i+o,I=r+this.k.renderHeight;i<r+F&&w>=I||(i<r+F||w>=I&&o>=this.k.renderHeight?this.k.setScrollTop(i-F):w>=I&&this.k.setScrollTop(w-this.k.renderHeight))}}getRelativeTop(g,k=0){if(g<0||g>=this.length)throw new a.$rS(this.A,`Invalid index ${g}`);const F=this.k.getScrollTop(),r=this.k.elementTop(g),i=this.k.elementHeight(g);if(r<F+k||r+i>F+this.k.renderHeight)return null;const o=i-this.k.renderHeight+k;return Math.abs((F+k-r)/o)}isDOMFocused(){return(0,E.$NQ)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(g){return this.k.getElementDomId(g)}getElementTop(g){return this.k.elementTop(g)}style(g){this.q.style(g)}G({indexes:g,browserEvent:k}){return{indexes:g,elements:g.map(F=>this.k.element(F)),browserEvent:k}}H(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.I()}I(){const g=this.c.get();if(g.length>0){let k;this.u?.getActiveDescendantId&&(k=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",k||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$HS=Ae,Ye([M.$Ch],Ae.prototype,"onDidChangeFocus",null),Ye([M.$Ch],Ae.prototype,"onDidChangeSelection",null),Ye([M.$Ch],Ae.prototype,"onContextMenu",null),Ye([M.$Ch],Ae.prototype,"onKeyDown",null),Ye([M.$Ch],Ae.prototype,"onKeyUp",null),Ye([M.$Ch],Ae.prototype,"onKeyPress",null),Ye([M.$Ch],Ae.prototype,"onDidFocus",null),Ye([M.$Ch],Ae.prototype,"onDidBlur",null)}),define(be[62],pe([1,0,6,36,38,10,15]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uk=t.$tk=t.$sk=t.$rk=t.$qk=t.$pk=t.$ok=t.$nk=t.$mk=t.MarkdownStringTextNewlineStyle=void 0;var S;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(S||(t.MarkdownStringTextNewlineStyle=S={}));class m{constructor(a="",$=!1){if(this.value=a,typeof this.value!="string")throw(0,E.$7)("value");typeof $=="boolean"?(this.isTrusted=$,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=$.isTrusted??void 0,this.supportThemeIcons=$.supportThemeIcons??!1,this.supportHtml=$.supportHtml??!1)}appendText(a,$=0){return this.value+=l(this.supportThemeIcons?(0,T.$gk)(a):a).replace(/([ \t]+)/g,(d,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,$===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,$){return this.value+=`
${h($,a)}
`,this}appendLink(a,$,d){return this.value+="[",this.value+=this.c($,"]"),this.value+="](",this.value+=this.c(String(a),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(a,$){const d=new RegExp((0,H.$Re)($),"g");return a.replace(d,(b,u)=>a.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$mk=m;function p(c){return v(c)?!c.value:Array.isArray(c)?c.every(p):!0}t.$nk=p;function v(c){return c instanceof m?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}t.$ok=v;function M(c,a){return c===a?!0:!c||!a?!1:c.value===a.value&&c.isTrusted===a.isTrusted&&c.supportThemeIcons===a.supportThemeIcons&&c.supportHtml===a.supportHtml&&(c.baseUri===a.baseUri||!!c.baseUri&&!!a.baseUri&&(0,n.$Eg)(y.URI.from(c.baseUri),y.URI.from(a.baseUri)))}t.$pk=M;function l(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$qk=l;function h(c,a){const $=c.match(/^`+/gm)?.reduce((b,u)=>b.length>u.length?b:u).length??0,d=$>=3?$+1:3;return[`${"`".repeat(d)}${a}`,c,`${"`".repeat(d)}`].join(`
`)}t.$rk=h;function e(c){return c.replace(/"/g,"&quot;")}t.$sk=e;function s(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$tk=s;function f(c){const a=[],$=c.split("|").map(b=>b.trim());c=$[0];const d=$[1];if(d){const b=/height=(\d+)/.exec(d),u=/width=(\d+)/.exec(d),N=b?b[1]:"",B=u?u[1]:"",R=isFinite(parseInt(B)),U=isFinite(parseInt(N));R&&a.push(`width="${B}"`),U&&a.push(`height="${N}"`)}return{href:c,dimensions:a}}t.$uk=f}),define(be[126],pe([1,0,2,118,22,55,14,19,119,6,4,62,36,77,23,3,79,53,31,51,38,10,15]),function(se,t,E,T,n,H,y,S,m,p,v,M,l,h,e,s,f,c,a,$,d,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OS=t.$NS=t.$MS=t.$LS=t.$KS=void 0;const N=Object.freeze({image:(K,ie,fe)=>{let ye=[],Ce=[];return K&&({href:K,dimensions:ye}=(0,M.$uk)(K),Ce.push(`src="${(0,M.$sk)(K)}"`)),fe&&Ce.push(`alt="${(0,M.$sk)(fe)}"`),ie&&Ce.push(`title="${(0,M.$sk)(ie)}"`),ye.length&&(Ce=Ce.concat(ye)),"<img "+Ce.join(" ")+">"},paragraph:K=>`<p>${K}</p>`,link:(K,ie,fe)=>typeof K!="string"?"":(K===fe&&(fe=(0,M.$tk)(fe)),ie=typeof ie=="string"?(0,M.$sk)((0,M.$tk)(ie)):"",K=(0,M.$tk)(K),K=K.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${K}" title="${ie||K}" draggable="false">${fe}</a>`)});function B(K,ie={},fe={}){const ye=new s.$Sc;let Ce=!1;const Ae=(0,H.$bS)(ie),q=function(C){let j;try{j=(0,c.$Gh)(decodeURIComponent(C))}catch{}return j?(j=(0,$.$Dn)(j,_=>{if(K.uris&&K.uris[_])return u.URI.revive(K.uris[_])}),encodeURIComponent(JSON.stringify(j))):C},g=function(C,j){const _=K.uris&&K.uris[C];let Z=u.URI.revive(_);return j?C.startsWith(a.Schemas.data+":")?C:(Z||(Z=u.URI.parse(C)),a.$sg.uriToBrowserUri(Z).toString(!0)):!Z||u.URI.parse(C).toString()===Z.toString()?C:(Z.query&&(Z=Z.with({query:q(Z.query)})),Z.toString())},k=new f.marked.Renderer;k.image=N.image,k.link=N.link,k.paragraph=N.paragraph;const F=[],r=[];if(ie.codeBlockRendererSync?k.code=(C,j)=>{const _=h.$PN.nextId(),Z=ie.codeBlockRendererSync(R(j),C);return r.push([_,Z]),`<div class="code" data-code="${_}">${(0,b.$Qe)(C)}</div>`}:ie.codeBlockRenderer&&(k.code=(C,j)=>{const _=h.$PN.nextId(),Z=ie.codeBlockRenderer(R(j),C);return F.push(Z.then(oe=>[_,oe])),`<div class="code" data-code="${_}">${(0,b.$Qe)(C)}</div>`}),ie.actionHandler){const C=function(Z){let oe=Z.target;if(!(oe.tagName!=="A"&&(oe=oe.parentElement,!oe||oe.tagName!=="A")))try{let me=oe.dataset.href;me&&(K.baseUri&&(me=U(u.URI.from(K.baseUri),me)),ie.actionHandler.callback(me,Z))}catch(me){(0,p.$1)(me)}finally{Z.preventDefault()}},j=ie.actionHandler.disposables.add(new n.$cS(Ae,"click")),_=ie.actionHandler.disposables.add(new n.$cS(Ae,"auxclick"));ie.actionHandler.disposables.add(v.Event.any(j.event,_.event)(Z=>{const oe=new S.$5P(E.getWindow(Ae),Z);!oe.leftButton&&!oe.middleButton||C(oe)})),ie.actionHandler.disposables.add(E.$aQ(Ae,"keydown",Z=>{const oe=new y.$0P(Z);!oe.equals(10)&&!oe.equals(3)||C(oe)}))}K.supportHtml||(fe.sanitizer=C=>(K.isTrusted?C.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?C:"",fe.sanitize=!0,fe.silent=!0),fe.renderer=k;let i=K.value??"";i.length>1e5&&(i=`${i.substr(0,1e5)}\u2026`),K.supportThemeIcons&&(i=(0,l.$hk)(i));let o;if(ie.fillInIncompleteTokens){const C={...f.marked.defaults,...fe},j=f.marked.lexer(i,C),_=de(j);o=f.marked.parser(_,C)}else o=f.marked.parse(i,fe);K.supportThemeIcons&&(o=(0,m.$IS)(o).map(j=>typeof j=="string"?j:j.outerHTML).join(""));const I=new DOMParser().parseFromString(z(K,o),"text/html");if(I.body.querySelectorAll("img").forEach(C=>{const j=C.getAttribute("src");if(j){let _=j;try{K.baseUri&&(_=U(u.URI.from(K.baseUri),_))}catch{}C.src=g(_,!0)}}),I.body.querySelectorAll("a").forEach(C=>{const j=C.getAttribute("href");if(C.setAttribute("href",""),!j||/^data:|javascript:/i.test(j)||/^command:/i.test(j)&&!K.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(j))C.replaceWith(...C.childNodes);else{let _=g(j,!1);K.baseUri&&(_=U(u.URI.from(K.baseUri),j)),C.dataset.href=_}}),Ae.innerHTML=z(K,I.body.innerHTML),F.length>0)Promise.all(F).then(C=>{if(Ce)return;const j=new Map(C),_=Ae.querySelectorAll("div[data-code]");for(const Z of _){const oe=j.get(Z.dataset.code??"");oe&&E.$dR(Z,oe)}ie.asyncRenderCallback?.()});else if(r.length>0){const C=new Map(r),j=Ae.querySelectorAll("div[data-code]");for(const _ of j){const Z=C.get(_.dataset.code??"");Z&&E.$dR(_,Z)}}if(ie.asyncRenderCallback)for(const C of Ae.getElementsByTagName("img")){const j=ye.add(E.$aQ(C,"load",()=>{j.dispose(),ie.asyncRenderCallback()}))}return{element:Ae,dispose:()=>{Ce=!0,ye.dispose()}}}t.$KS=B;function R(K){if(!K)return"";const ie=K.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:K}function U(K,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:K.path.endsWith("/")?(0,d.$Og)(K,ie).toString():(0,d.$Og)((0,d.$Kg)(K),ie).toString()}function z(K,ie){const{config:fe,allowedSchemes:ye}=D(K);T.addHook("uponSanitizeAttribute",(Ae,q)=>{if(q.attrName==="style"||q.attrName==="class"){if(Ae.tagName==="SPAN"){if(q.attrName==="style"){q.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(q.attrValue);return}else if(q.attrName==="class"){q.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(q.attrValue);return}}q.keepAttr=!1;return}else if(Ae.tagName==="INPUT"&&Ae.attributes.getNamedItem("type")?.value==="checkbox"){if(q.attrName==="type"&&q.attrValue==="checkbox"||q.attrName==="disabled"||q.attrName==="checked"){q.keepAttr=!0;return}q.keepAttr=!1}}),T.addHook("uponSanitizeElement",(Ae,q)=>{q.tagName==="input"&&(Ae.attributes.getNamedItem("type")?.value==="checkbox"?Ae.setAttribute("disabled",""):Ae.parentElement?.removeChild(Ae))});const Ce=E.$xR(ye);try{return T.sanitize(ie,{...fe,RETURN_TRUSTED_TYPE:!0})}finally{T.removeHook("uponSanitizeAttribute"),Ce.dispose()}}t.$LS=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function D(K){const ie=[a.Schemas.http,a.Schemas.https,a.Schemas.mailto,a.Schemas.data,a.Schemas.file,a.Schemas.vscodeFileResource,a.Schemas.vscodeRemote,a.Schemas.vscodeRemoteResource];return K.isTrusted&&ie.push(a.Schemas.command),{config:{ALLOWED_TAGS:[...E.$yR],ALLOWED_ATTR:t.$LS,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function O(K){return typeof K=="string"?K:W(K)}t.$MS=O;function W(K){let ie=K.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const fe=f.marked.parse(ie,{renderer:P.value}).replace(/&(#\d+|[a-zA-Z]+);/g,ye=>A.get(ye)??ye);return z({isTrusted:!1},fe).toString()}t.$NS=W;const A=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),P=new e.$V(()=>{const K=new f.marked.Renderer;return K.code=ie=>ie,K.blockquote=ie=>ie,K.html=ie=>"",K.heading=(ie,fe,ye)=>ie+`
`,K.hr=()=>"",K.list=(ie,fe)=>ie,K.listitem=ie=>ie+`
`,K.paragraph=ie=>ie+`
`,K.table=(ie,fe)=>ie+fe+`
`,K.tablerow=ie=>ie,K.tablecell=(ie,fe)=>ie+" ",K.strong=ie=>ie,K.em=ie=>ie,K.codespan=ie=>ie,K.br=()=>`
`,K.del=ie=>ie,K.image=(ie,fe,ye)=>"",K.text=ie=>ie,K.link=(ie,fe,ye)=>ye,K});function L(K){let ie="";return K.forEach(fe=>{ie+=fe.raw}),ie}function Y(K){for(let ie=0;ie<K.tokens.length;ie++){const fe=K.tokens[ie];if(fe.type==="text"){const ye=fe.raw.split(`
`),Ce=ye[ye.length-1];if(Ce.includes("`"))return te(K);if(Ce.includes("**"))return J(K);if(Ce.match(/\*\w/))return ge(K);if(Ce.match(/(^|\s)__\w/))return ae(K);if(Ce.match(/(^|\s)_\w/))return Pe(K);if(Ce.match(/(^|\s)\[.*\]\(\w*/)){const Ae=K.tokens.slice(ie+1);return Ae[0]?.type==="link"&&Ae[1]?.type==="text"&&Ae[1].raw.match(/^ *"[^"]*$/)?Be(K):Ne(K)}else{if(X(Ce))return Ne(K);if(Ce.match(/(^|\s)\[\w/)&&!K.tokens.slice(ie+1).some(Ae=>X(Ae.raw)))return le(K)}}}}function X(K){return!!K.match(/^[^\[]*\]\([^\)]*$/)}function de(K){let ie,fe;for(ie=0;ie<K.length;ie++){const ye=K[ie];let Ce;if(ye.type==="paragraph"&&(Ce=ye.raw.match(/(\n|^)(````*)/))){const Ae=Ce[2];fe=ue(K.slice(ie),Ae);break}if(ye.type==="paragraph"&&ye.raw.match(/(\n|^)\|/)){fe=G(K.slice(ie));break}if(ie===K.length-1&&ye.type==="paragraph"){const Ae=Y(ye);if(Ae){fe=[Ae];break}}}if(fe){const ye=[...K.slice(0,ie),...fe];return ye.links=K.links,ye}return K}t.$OS=de;function ue(K,ie){const fe=L(K);return f.marked.lexer(fe+`
${ie}`)}function te(K){return re(K,"`")}function ge(K){return re(K,"*")}function Pe(K){return re(K,"_")}function Ne(K){return re(K,")")}function Be(K){return re(K,'")')}function le(K){return re(K,"](about:blank)")}function J(K){return re(K,"**")}function ae(K){return re(K,"__")}function re(K,ie){const fe=L(Array.isArray(K)?K:[K]);return f.marked.lexer(fe+ie)[0]}function G(K){const ie=L(K),fe=ie.split(`
`);let ye,Ce=!1;for(let Ae=0;Ae<fe.length;Ae++){const q=fe[Ae].trim();if(typeof ye>"u"&&q.match(/^\s*\|/)){const g=q.match(/(\|[^\|]+)(?=\||$)/g);g&&(ye=g.length)}else if(typeof ye=="number")if(q.match(/^\s*\|/)){if(Ae!==fe.length-1)return;Ce=!0}else return}if(typeof ye=="number"&&ye>0){const Ae=Ce?fe.slice(0,-1).join(`
`):ie,q=!!Ae.match(/\|\s*$/),g=Ae+(q?"":"|")+`
|${" --- |".repeat(ye)}`;return f.marked.lexer(g)}}}),define(be[127],pe([1,0,2,9,29,62,36,3,7,108]),function(se,t,E,T,n,H,y,S,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6R=t.$5R=void 0;function v(h,e){(0,m.$Mf)(e)?h.title=(0,y.$ik)(e):e?.markdownNotSupportedFallback?h.title=e.markdownNotSupportedFallback:h.removeAttribute("title")}t.$5R=v;class M{constructor(e,s,f){this.c=e,this.d=s,this.f=f}async update(e,s,f){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let c;if(e===void 0||(0,m.$Mf)(e)||e instanceof HTMLElement)c=e;else if(!(0,m.$1f)(e.markdown))c=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,p.localize)(0,null),s),this.b=new n.$9d;const a=this.b.token;if(c=await e.markdown(a),c===void 0&&(c=e.markdownNotSupportedFallback),this.isDisposed||a.isCancellationRequested)return}this.g(c,s,f)}g(e,s,f){const c=this.a;if(this.h(e)){const a={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!c},position:{hoverPosition:2},...f};this.a=this.c.showHover(a,s)}c?.dispose()}h(e){return e?(0,H.$ok)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function l(h,e,s,f){let c,a;const $=(W,A)=>{const P=a!==void 0;W&&(a?.dispose(),a=void 0),A&&(c?.dispose(),c=void 0),P&&h.onDidHideHover?.()},d=(W,A,P)=>new T.$ih(async()=>{(!a||a.isDisposed)&&(a=new M(h,P||e,W>0),await a.update(s,A,f))},W);let b=!1;const u=E.$aQ(e,E.$7Q.MOUSE_DOWN,()=>{b=!0,$(!0,!0)},!0),N=E.$aQ(e,E.$7Q.MOUSE_UP,()=>{b=!1},!0),B=E.$aQ(e,E.$7Q.MOUSE_LEAVE,W=>{b=!1,$(!1,W.fromElement===e)},!0),R=()=>{if(c)return;const W=new S.$Sc,A={targetElements:[e],dispose:()=>{}};if(h.placement===void 0||h.placement==="mouse"){const P=L=>{A.x=L.x+10,L.target instanceof HTMLElement&&L.target.classList.contains("action-label")&&$(!0,!0)};W.add(E.$aQ(e,E.$7Q.MOUSE_MOVE,P,!0))}W.add(d(h.delay,!1,A)),c=W},U=E.$aQ(e,E.$7Q.MOUSE_OVER,R,!0),z=()=>{if(b||c)return;const W={targetElements:[e],dispose:()=>{}},A=new S.$Sc,P=()=>$(!0,!0);A.add(E.$aQ(e,E.$7Q.BLUR,P,!0)),A.add(d(h.delay,!1,W)),c=A},D=E.$aQ(e,E.$7Q.FOCUS,z,!0);return{show:W=>{$(!1,!0),d(0,W)},hide:()=>{$(!0,!0)},update:async(W,A)=>{s=W,await a?.update(s,void 0,A)},dispose:()=>{U.dispose(),B.dispose(),u.dispose(),N.dispose(),D.dispose(),$(!0,!0)}}}t.$6R=l}),define(be[128],pe([1,0,2,22,14,126,40,12,4,45,3,5,110,101]),function(se,t,E,T,n,H,y,S,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PS=void 0;const h=E.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(a){const $=Object.create(null);return $.root=a,$.text=E.$bR(a,h(".option-text")),$.detail=E.$bR(a,h(".option-detail")),$.decoratorRight=E.$bR(a,h(".option-decorator-right")),$}renderElement(a,$,d){const b=d,u=a.text,N=a.detail,B=a.decoratorRight,R=a.isDisabled;b.text.textContent=u,b.detail.textContent=N||"",b.decoratorRight.innerText=B||"",R?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(a){}}class f extends v.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(a,$,d,b,u){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=b,this.g=u||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=f.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new m.$Yd,this.B(this.r),this.O(),this.N(d),this.n=$||0,a&&this.setOptions(a,$),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(a){this.u=a,this.w=E.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=E.$bR(this.w,h(".select-box-details-pane"));const $=E.$bR(this.w,h(".select-box-dropdown-container-width-control")),d=E.$bR($,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",E.$bR(d,this.D),this.G=0,this.y=E.$VQ(this.w),this.w.setAttribute("draggable","true"),this.B(E.$aQ(this.w,E.$7Q.DRAG_START,b=>{E.$9Q.stop(b,!0)}))}O(){this.B(E.$bQ(this.h,"change",$=>{this.n=$.target.selectedIndex,this.r.fire({index:$.target.selectedIndex,selected:$.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(E.$aQ(this.h,E.$7Q.CLICK,$=>{E.$9Q.stop($),this.f?this.X(!0):this.W()})),this.B(E.$aQ(this.h,E.$7Q.MOUSE_DOWN,$=>{E.$9Q.stop($)}));let a;this.B(E.$aQ(this.h,"touchstart",$=>{a=this.f})),this.B(E.$aQ(this.h,"touchend",$=>{E.$9Q.stop($),a?this.X(!0):this.W()})),this.B(E.$aQ(this.h,E.$7Q.KEY_DOWN,$=>{const d=new n.$0P($);let b=!1;M.$j?(d.keyCode===18||d.keyCode===16||d.keyCode===10||d.keyCode===3)&&(b=!0):(d.keyCode===18&&d.altKey||d.keyCode===16&&d.altKey||d.keyCode===10||d.keyCode===3)&&(b=!0),b&&(this.W(),E.$9Q.stop($,!0))}))}get onDidSelect(){return this.r.event}setOptions(a,$){S.$ub(this.m,a)||(this.m=a,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((d,b)=>{this.h.add(this.U(d.text,b,d.isDisabled)),typeof d.description=="string"&&(this.H=!0)})),$!==void 0&&(this.select($),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(a){a>=0&&a<this.m.length?this.n=a:a>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(a){this.g.ariaLabel=a,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(a){this.h.tabIndex=a?0:-1}render(a){this.j=a,a.classList.add("select-container"),a.appendChild(this.h),this.R()}Q(){const a=[];this.s.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=a.join(`
`)}R(){const a=this.s.selectBackground??"",$=this.s.selectForeground??"",d=this.s.selectBorder??"";this.h.style.backgroundColor=a,this.h.style.color=$,this.h.style.borderColor=d}S(){const a=this.s.selectBackground??"",$=E.$tR(this.s.selectListBackground,a);this.C.style.backgroundColor=$,this.I.style.backgroundColor=$;const d=this.s.focusBorder??"";this.w.style.outlineColor=d,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(a,$,d){const b=document.createElement("option");return b.value=a,b.text=a,b.disabled=!!d,b}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.Y(a,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.Y(a),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(a){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),a&&this.h.focus(),this.u.hideContextView())}Y(a,$){return a.appendChild(this.w),this.ab($),{dispose:()=>{try{a.removeChild(this.w)}catch{}}}}Z(){let a=0;return this.m.forEach(($,d)=>{this.hb(d),this.I.offsetHeight>a&&(a=this.I.offsetHeight)}),a}ab(a){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const $=E.getWindow(this.h),d=E.$wQ(this.h),b=E.getWindow(this.h).getComputedStyle(this.h),u=parseFloat(b.getPropertyValue("--dropdown-padding-top"))+parseFloat(b.getPropertyValue("--dropdown-padding-bottom")),N=$.innerHeight-d.top-d.height-(this.g.minBottomMargin||0),B=d.top-f.b,R=this.h.offsetWidth,U=this.bb(this.D),z=Math.max(U,Math.round(R)).toString()+"px";this.w.style.width=z,this.z.getHTMLElement().style.height="",this.z.layout();let D=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const O=this.H?this.L:0,W=D+u+O,A=Math.floor((N-u-O)/this.getHeight()),P=Math.floor((B-u-O)/this.getHeight());if(a)return d.top+d.height>$.innerHeight-22||d.top<f.b||A<1&&P<1?!1:(A<f.c&&P>A&&this.m.length>A?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(d.top+d.height>$.innerHeight-22||d.top<f.b||this.G===0&&A<1||this.G===1&&P<1)return this.X(!0),!1;if(this.G===0){if(this.f&&A+P<1)return this.X(!0),!1;W>N&&(D=A*this.getHeight())}else W>B&&(D=P*this.getHeight());return this.z.layout(D),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=D+u+"px",this.w.style.height=""):this.w.style.height=D+u+"px",this.hb(this.n),this.w.style.width=z,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(a){let $=0;if(a){let d=0,b=0;this.m.forEach((u,N)=>{const B=u.detail?u.detail.length:0,R=u.decoratorRight?u.decoratorRight.length:0,U=u.text.length+B+R;U>b&&(d=N,b=U)}),a.textContent=this.m[d].text+(this.m[d].decoratorRight?this.m[d].decoratorRight+" ":""),$=E.$yQ(a)}return $}cb(a){if(this.z)return;this.C=E.$bR(a,h(".select-box-dropdown-list-container")),this.t=new s,this.z=new y.$HS("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let u=b.text;return b.detail&&(u+=`. ${b.detail}`),b.decoratorRight&&(u+=`. ${b.decoratorRight}`),b.description&&(u+=`. ${b.description}`),u},getWidgetAriaLabel:()=>(0,l.localize)(0,null),getRole:()=>M.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const $=this.B(new T.$cS(this.C,"keydown")),d=m.Event.chain($.event,b=>b.filter(()=>this.z.length>0).map(u=>new n.$0P(u)));this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===3))(this.jb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===2))(this.jb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===9))(this.ib,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===16))(this.lb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===18))(this.kb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===12))(this.nb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===11))(this.mb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===14))(this.ob,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===13))(this.pb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode>=21&&u.keyCode<=56||u.keyCode>=85&&u.keyCode<=113))(this.qb,this)),this.B(E.$aQ(this.z.getHTMLElement(),E.$7Q.POINTER_UP,b=>this.db(b))),this.B(this.z.onMouseOver(b=>typeof b.index<"u"&&this.z.setFocus([b.index]))),this.B(this.z.onDidChangeFocus(b=>this.gb(b))),this.B(E.$aQ(this.w,E.$7Q.FOCUS_OUT,b=>{!this.f||E.$EQ(b.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(a){if(!this.z.length)return;E.$9Q.stop(a);const $=a.target;if(!$||$.classList.contains("slider"))return;const d=$.closest(".monaco-list-row");if(!d)return;const b=Number(d.getAttribute("data-index")),u=d.classList.contains("option-disabled");b>=0&&b<this.m.length&&!u&&(this.n=b,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(a,$){const d=u=>{for(let N=0;N<u.childNodes.length;N++){const B=u.childNodes.item(N);(B.tagName&&B.tagName.toLowerCase())==="img"?u.removeChild(B):d(B)}},b=(0,H.$KS)({value:a,supportThemeIcons:!0},{actionHandler:$});return b.element.classList.add("select-box-description-markdown"),d(b.element),b.element}gb(a){!this.f||!this.H||this.hb(a.indexes[0])}hb(a){this.I.innerText="";const $=this.m[a],d=$?.description??"",b=$?.descriptionIsMarkdown??!1;if(d){if(b){const u=$.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(d,u))}else this.I.innerText=d;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(a){E.$9Q.stop(a),this.select(this.F),this.X(!0)}jb(a){E.$9Q.stop(a),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(a){if(this.n<this.m.length-1){E.$9Q.stop(a,!0);const $=this.m[this.n+1].isDisabled;if($&&this.m.length>this.n+2)this.n+=2;else{if($)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(a){this.n>0&&(E.$9Q.stop(a,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(a){E.$9Q.stop(a),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(a){E.$9Q.stop(a),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(a){E.$9Q.stop(a),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(a){E.$9Q.stop(a),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(a){const $=p.KeyCodeUtils.toString(a.keyCode);let d=-1;for(let b=0;b<this.m.length-1;b++)if(d=(b+this.n+1)%this.m.length,this.m[d].text.charAt(0).toUpperCase()===$&&!this.m[d].isDisabled){this.select(d),this.z.setFocus([d]),this.z.reveal(this.z.getFocus()[0]),E.$9Q.stop(a);break}}dispose(){this.X(!1),super.dispose()}}t.$PS=f}),define(be[129],pe([1,0,40,128,122,20,5,100]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SS=t.$RS=void 0,t.$RS={...E.$GS,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class S extends H.$OR{constructor(p,v,M,l,h){super(),y.$j&&!h?.useCustomDrawn?this.a=new n.$QS(p,v,l,h):this.a=new T.$PS(p,v,M,l,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(p,v){this.a.setOptions(p,v)}select(p){this.a.select(p)}setAriaLabel(p){this.a.setAriaLabel(p)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(p){this.a.setFocusable(p)}render(p){this.a.render(p)}}t.$SS=S}),define(be[63],pe([1,0,16,54,2,25,127,129,37,3,5,7,105,52]),function(se,t,E,T,n,H,y,S,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1S=t.$ZS=t.$YS=void 0;class h extends p.$Tc{get action(){return this._action}constructor(c,a,$={}){super(),this.m=$,this._context=c||this,this._action=a,a instanceof m.$Pi&&this.B(a.onDidChange(d=>{this.element&&this.t(d)}))}t(c){c.enabled!==void 0&&this.u(),c.checked!==void 0&&this.H(),c.class!==void 0&&this.G(),c.label!==void 0&&(this.w(),this.D()),c.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new m.$Qi)),this.j}set actionRunner(c){this.j=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const a=this.element=c;this.B(H.$KR.addTarget(c));const $=this.m&&this.m.draggable;$&&(c.draggable=!0,E.$SP&&this.B((0,n.$aQ)(c,n.$7Q.DRAG_START,d=>d.dataTransfer?.setData(T.$IR.TEXT,this._action.label)))),this.B((0,n.$aQ)(a,H.EventType.Tap,d=>this.onClick(d,!0))),this.B((0,n.$aQ)(a,n.$7Q.MOUSE_DOWN,d=>{$||n.$9Q.stop(d,!0),this._action.enabled&&d.button===0&&a.classList.add("active")})),v.$j&&this.B((0,n.$aQ)(a,n.$7Q.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this.B((0,n.$aQ)(a,n.$7Q.CLICK,d=>{n.$9Q.stop(d,!0),this.m&&this.m.isMenu||this.onClick(d)})),this.B((0,n.$aQ)(a,n.$7Q.DBLCLICK,d=>{n.$9Q.stop(d,!0)})),[n.$7Q.MOUSE_UP,n.$7Q.MOUSE_OUT].forEach(d=>{this.B((0,n.$aQ)(a,d,b=>{n.$9Q.stop(b),a.classList.remove("active")}))})}onClick(c,a=!1){n.$9Q.stop(c,!0);const $=M.$Vf(this._context)?this.m?.useEventAsContext?c:{preserveFocus:a}:this._context;this.actionRunner.run(this._action,$)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const c=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(c):(this.f=(0,y.$6R)(this.m.hoverDelegate,this.element,c),this.q.add(this.f))):this.element.title=c}F(){if(this.element){const c=this.C()??"";this.element.setAttribute("aria-label",c)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$YS=h;class e extends h{constructor(c,a,$){super(c,a,$),this.m=$,this.m.icon=$.icon!==void 0?$.icon:!1,this.m.label=$.label!==void 0?$.label:!0,this.L=""}render(c){super.render(c),M.$Wf(this.element);const a=document.createElement("a");if(a.classList.add("action-label"),a.setAttribute("role",this.M()),this.I=a,this.element.appendChild(a),this.m.label&&this.m.keybinding){const $=document.createElement("span");$.classList.add("keybinding"),$.textContent=this.m.keybinding,this.element.appendChild($)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===m.$Ri.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(c){this.I&&(this.I.tabIndex=c?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(c=this.action.label,this.m.keybinding&&(c=l.localize(0,null,c,this.m.keybinding))),c??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const c=this.C()??"";this.I.setAttribute("aria-label",c)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$ZS=e;class s extends h{constructor(c,a,$,d,b,u,N){super(c,a),this.b=new S.$SS($,d,b,u,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(c,a){this.b.setOptions(c,a)}select(c){this.b.select(c)}g(){this.B(this.b.onDidSelect(c=>this.n(c.selected,c.index)))}n(c,a){this.actionRunner.run(this._action,this.r(c,a))}r(c,a){return c}setFocusable(c){this.b.setFocusable(c)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(c){this.b.render(c)}}t.$1S=s}),define(be[64],pe([1,0,2,14,63,37,4,3,7,52]),function(se,t,E,T,n,H,y,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8R=t.$7R=t.ActionsOrientation=void 0;var p;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(p||(t.ActionsOrientation=p={}));class v extends S.$Tc{constructor(h,e={}){super(),this.g=this.B(new S.$Sc),this.r=this.B(new S.$3c),this.w=!1,this.y=!0,this.C=this.B(new y.$Yd),this.onDidBlur=this.C.event,this.D=this.B(new y.$Yd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new y.$Yd),this.onDidRun=this.G.event,this.H=this.B(new y.$Yd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new H.$Qi,this.g.add(this.f)),this.g.add(this.f.onDidRun(c=>this.G.fire(c))),this.g.add(this.f.onWillRun(c=>this.H.fire(c))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,f;switch(this.m){case 0:s=[15],f=[17];break;case 1:s=[16],f=[18],this.domNode.className+=" vertical";break}this.B(E.$aQ(this.domNode,E.$7Q.KEY_DOWN,c=>{const a=new T.$0P(c);let $=!0;const d=typeof this.t=="number"?this.viewItems[this.t]:void 0;s&&(a.equals(s[0])||a.equals(s[1]))?$=this.P():f&&(a.equals(f[0])||a.equals(f[1]))?$=this.O():a.equals(9)&&this.F?this.D.fire():a.equals(14)?$=this.M():a.equals(13)?$=this.N():a.equals(2)&&d instanceof n.$YS&&d.trapsArrowNavigation?$=this.O():this.J(a)?this.n.keyDown?this.R(a):this.w=!0:$=!1,$&&(a.preventDefault(),a.stopPropagation())})),this.B(E.$aQ(this.domNode,E.$7Q.KEY_UP,c=>{const a=new T.$0P(c);this.J(a)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(a)),a.preventDefault(),a.stopPropagation()):(a.equals(2)||a.equals(1026)||a.equals(16)||a.equals(18)||a.equals(15)||a.equals(17))&&this.L()})),this.u=this.B(E.$_Q(this.domNode)),this.B(this.u.onDidBlur(()=>{(E.$MQ()===this.domNode||!E.$EQ(E.$MQ(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),h.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(h){h?this.z.setAttribute("aria-label",h):this.z.removeAttribute("aria-label")}setFocusable(h){if(this.y=h,this.y){const e=this.viewItems.find(s=>s instanceof n.$YS&&s.isEnabled());e instanceof n.$YS&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$YS&&e.setFocusable(!1)})}J(h){let e=!1;return this.n.keys.forEach(s=>{e=e||h.equals(s)}),e}L(){for(let h=0;h<this.z.children.length;h++){const e=this.z.children[h];if(E.$EQ(E.$MQ(),e)){this.t=h,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(h){this.j=h,this.viewItems.forEach(e=>e.setActionContext(h))}get actionRunner(){return this.f}set actionRunner(h){this.f=h,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=h)}getContainer(){return this.domNode}hasAction(h){return this.viewItems.findIndex(e=>e.action.id===h.id)!==-1}getAction(h){if(typeof h=="number")return this.viewItems[h]?.action;if(h instanceof HTMLElement){for(;h.parentElement!==this.z;){if(!h.parentElement)return;h=h.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===h)return this.viewItems[e].action}}push(h,e={}){const s=Array.isArray(h)?h:[h];let f=m.$Qf(e.index)?e.index:null;s.forEach(c=>{const a=document.createElement("li");a.className="action-item",a.setAttribute("role","presentation");let $;const d={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&($=this.b.actionViewItemProvider(c,d)),$||($=new n.$ZS(this.context,c,d)),this.b.allowContextMenu||this.r.set($,E.$aQ(a,E.$7Q.CONTEXT_MENU,b=>{E.$9Q.stop(b,!0)})),$.actionRunner=this.f,$.setActionContext(this.context),$.render(a),this.y&&$ instanceof n.$YS&&this.viewItems.length===0&&$.setFocusable(!0),f===null||f<0||f>=this.z.children.length?(this.z.appendChild(a),this.viewItems.push($)):(this.z.insertBefore(a,this.z.children[f]),this.viewItems.splice(f,0,$),f++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientWidth}return 0}getHeight(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientHeight}return 0}pull(h){h>=0&&h<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[h]),this.r.deleteAndDispose(this.viewItems[h]),(0,S.$Oc)(this.viewItems.splice(h,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,S.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),E.$_P(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(h){let e=!1,s;if(h===void 0?e=!0:typeof h=="number"?s=h:typeof h=="boolean"&&(e=h),e&&typeof this.t>"u"){const f=this.viewItems.findIndex(c=>c.isEnabled());this.t=f===-1?void 0:f,this.Q(void 0,void 0,!0)}else s!==void 0&&(this.t=s),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(h){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(!h&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.$Ri.ID));return this.Q(),!0}P(h){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(this.t=this.t-1,this.t<0){if(!h&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.$Ri.ID));return this.Q(!0),!0}Q(h,e,s=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const f=this.t!==void 0?this.viewItems[this.t]:void 0;if(f){let c=!0;m.$1f(f.focus)||(c=!1),this.b.focusOnlyEnabledItems&&m.$1f(f.isEnabled)&&!f.isEnabled()&&(c=!1),f.action.id===H.$Ri.ID&&(c=!1),c?(s||this.s!==this.t)&&(f.focus(h),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),c&&f.showHover?.()}}R(h){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$YS){const s=e._context===null||e._context===void 0?h:e._context;this.run(e._action,s)}}async run(h,e){await this.f.run(h,e)}dispose(){this.j=void 0,this.viewItems=(0,S.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$7R=v;function M(l){if(!l.length)return l;let h=-1;for(let s=0;s<l.length;s++)if(l[s].id!==H.$Ri.ID){h=s;break}if(h===-1)return[];l=l.slice(h);for(let s=l.length-1;s>=0&&l[s].id===H.$Ri.ID;s--)l.splice(s,1);let e=!1;for(let s=l.length-1;s>=0;s--){const f=l[s].id===H.$Ri.ID;f&&!e?l.splice(s,1):f?f&&(e=!1):e=!0}return l}t.$8R=M}),define(be[65],pe([1,0,2,22,55,64,57,60,20,4,82,51,109,97]),function(se,t,E,T,n,H,y,S,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GT=t.$FT=t.$ET=t.MessageType=void 0;const h=E.$;var e;(function(c){c[c.INFO=1]="INFO",c[c.WARNING=2]="WARNING",c[c.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$ET={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends m.$OR{constructor(a,$,d){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new p.$Yd),this.onDidChange=this.O.event,this.P=this.B(new p.$Yd),this.onDidHeightChange=this.P.event,this.a=$,this.g=d,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=E.$bR(a,h(".monaco-inputbox.idle"));const b=this.g.flexibleHeight?"textarea":"input",u=E.$bR(this.element,h(".ibwrapper"));if(this.b=E.$bR(u,h(b+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=E.$bR(u,h("div.mirror")),this.y.innerText="\xA0",this.N=new S.$YR(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),E.$bR(a,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const N=this.B(new T.$cS(a.ownerDocument,"selectionchange")),B=p.Event.filter(N.event,()=>a.ownerDocument.getSelection()?.anchorNode===u);this.B(B(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new H.$7R(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(a){this.n=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.r=a,this.b.title=a}setAriaLabel(a){this.s=a,a?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.Y())}get step(){return this.b.step}set step(a){this.b.step=a}get height(){return typeof this.J=="number"?this.J:E.$CQ(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return E.$NQ(this.b)}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(a){a?this.enable():this.disable()}get width(){return E.$yQ(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let $=0;if(this.y){const d=parseFloat(this.y.style.paddingLeft||"")||0,b=parseFloat(this.y.style.paddingRight||"")||0;$=d+b}this.b.style.width=a-$+"px"}else this.b.style.width=a+"px";this.y&&(this.y.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.y&&(this.y.style.paddingRight=a+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const a=this.L,$=this.J,d=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:a,height:$}),this.N.setScrollPosition({scrollTop:d})}showMessage(a,$){if(this.w==="open"&&(0,M.$Fn)(this.h,a))return;this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(a.type));const d=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${E.$tR(d.border,"transparent")}`,this.h.content&&(this.hasFocus()||$)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let a=null;return this.t&&(a=this.t(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const $=this.g.inputBoxStyles;switch(a){case 1:return{border:$.inputValidationInfoBorder,background:$.inputValidationInfoBackground,foreground:$.inputValidationInfoForeground};case 2:return{border:$.inputValidationWarningBorder,background:$.inputValidationWarningBackground,foreground:$.inputValidationWarningForeground};default:return{border:$.inputValidationErrorBorder,background:$.inputValidationErrorBackground,foreground:$.inputValidationErrorForeground}}}U(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let a;const $=()=>a.style.width=E.$yQ(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:b=>{if(!this.h)return null;a=E.$bR(b,h(".monaco-inputbox-container")),$();const u={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,n.$aS)(this.h.content,u):(0,n.$_R)(this.h.content,u);N.classList.add(this.U(this.h.type));const B=this.stylesForType(this.h.type);return N.style.backgroundColor=B.background??"",N.style.color=B.foreground??"",N.style.border=B.border?`1px solid ${B.border}`:"",E.$bR(a,N),null},onHide:()=>{this.w="closed"},layout:$});let d;this.h.type===3?d=l.localize(0,null,this.h.content):this.h.type===2?d=l.localize(1,null,this.h.content):d=l.localize(2,null,this.h.content),y.$eS(d),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const a=this.value,d=a.charCodeAt(a.length-1)===10?" ":"";(a+d).replace(/\u000c/g,"")?this.y.textContent=a+d:this.y.innerText="\xA0",this.layout()}ab(){const a=this.g.inputBoxStyles,$=a.inputBackground??"",d=a.inputForeground??"",b=a.inputBorder??"";this.element.style.backgroundColor=$,this.element.style.color=d,this.b.style.backgroundColor="inherit",this.b.style.color=d,this.element.style.border=`1px solid ${E.$tR(b,"transparent")}`}layout(){if(!this.y)return;const a=this.L;this.L=E.$CQ(this.y),a!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(a){const $=this.inputElement,d=$.selectionStart,b=$.selectionEnd,u=$.value;d!==null&&b!==null&&(this.value=u.substr(0,d)+a+u.substr(b),$.setSelectionRange(d+1,d+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$FT=s;class f extends s{constructor(a,$,d){const b=l.localize(3,null,"\u21C5"),u=l.localize(4,null,"\u21C5");super(a,$,d),this.db=this.B(new p.$Yd),this.onDidFocus=this.db.event,this.eb=this.B(new p.$Yd),this.onDidBlur=this.eb.event,this.bb=new v.$CT(d.history,100);const N=()=>{if(d.showHistoryHint&&d.showHistoryHint()&&!this.n.endsWith(b)&&!this.n.endsWith(u)&&this.bb.getHistory().length){const B=this.n.endsWith(")")?b:u,R=this.n+B;d.showPlaceholderOnFocus&&!E.$NQ(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((B,R)=>{B.forEach(U=>{U.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const B=R=>{if(this.n.endsWith(R)){const U=this.n.slice(0,this.n.length-R.length);return d.showPlaceholderOnFocus?this.n=U:this.setPlaceHolder(U),!0}else return!1};B(u)||B(b)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(a){this.value&&(a||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(a){const $=this.getHistory();this.clearHistory(),a.forEach(d=>{this.bb.add(d)}),$.forEach(d=>{this.bb.add(d)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let a=this.jb();a&&(a=a===this.value?this.jb():a),this.value=a??"",y.$fS(this.value?this.value:l.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let a=this.ib();a&&(a=a===this.value?this.ib():a),a&&(this.value=a,y.$fS(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(a){super.setPlaceHolder(a),this.setTooltip(a)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let a=this.bb.current();return a||(a=this.bb.last(),this.bb.next()),a}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$GT=f}),define(be[66],pe([1,0,63,20,17,18,4,2,102]),function(se,t,E,T,n,H,y,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XS=t.$WS=t.$VS=t.$US=t.$TS=void 0,t.$TS={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class m extends E.$YS{constructor(h,e,s){super(h,e,s),this.a=this.B(new p({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:s.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:s.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:s.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(h){this.element=h,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}t.$US=m;class p extends T.$OR{constructor(h){super(),this.a=this.B(new y.$Yd),this.onChange=this.a.event,this.b=this.B(new y.$Yd),this.onKeyDown=this.b.event,this.c=h,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,s=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),s.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,s=>{if(s.keyCode===10||s.keyCode===3){this.checked=!this.s,this.a.fire(!0),s.preventDefault(),s.stopPropagation();return}this.b.fire(s)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(h){this.s=h,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(h){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=h,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(h){this.domNode.title=h,this.domNode.setAttribute("aria-label",h)}}t.$VS=p;class v extends T.$OR{constructor(h,e,s){super(),this.g=h,this.h=e,this.a=this.B(new y.$Yd),this.onChange=this.a.event,this.b=new p({title:this.g,isChecked:this.h,icon:n.$ek.check,actionClassName:"monaco-checkbox",...t.$TS}),this.domNode=this.b.domNode,this.c=s,this.n(),this.B(this.b.onChange(f=>{this.n(),this.a.fire(f)}))}get checked(){return this.b.checked}set checked(h){this.b.checked=h,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,S.$NQ)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$WS=v;class M extends E.$YS{constructor(h,e,s){super(h,e,s),this.a=this.B(new v(this._action.label,!!this._action.checked,s.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(h){if(this.element=h,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,S.$)("span.checkbox-label",void 0,this._action.label));this.B((0,S.$aQ)(e,S.$7Q.CLICK,s=>{this.a.checked=!this.a.checked,s.stopPropagation(),s.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}t.$XS=M}),define(be[130],pe([1,0,66,17,107]),function(se,t,E,T,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=t.$ST=t.$RT=void 0;const H=n.localize(0,null),y=n.localize(1,null),S=n.localize(2,null);class m extends E.$VS{constructor(l){super({icon:T.$ek.caseSensitive,title:H+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$RT=m;class p extends E.$VS{constructor(l){super({icon:T.$ek.wholeWord,title:y+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$ST=p;class v extends E.$VS{constructor(l){super({icon:T.$ek.regex,title:S+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$TT=v}),define(be[131],pe([1,0,2,130,65,20,4,106,3,96]),function(se,t,E,T,n,H,y,S,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=void 0;const p=S.localize(0,null);class v extends H.$OR{static{this.OPTION_CHANGE="optionChange"}constructor(l,h,e){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Uc),this.N=[],this.O=this.B(new y.$Yd),this.onDidOptionChange=this.O.event,this.P=this.B(new y.$Yd),this.onKeyDown=this.P.event,this.Q=this.B(new y.$Yd),this.onMouseDown=this.Q.event,this.R=this.B(new y.$Yd),this.onInput=this.R.event,this.S=this.B(new y.$Yd),this.onKeyUp=this.S.event,this.U=this.B(new y.$Yd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new y.$Yd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||p,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",f=e.appendWholeWordsLabel||"",c=e.appendRegexLabel||"",a=e.history||[],$=!!e.flexibleHeight,d=!!e.flexibleWidth,b=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$GT(this.domNode,h,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:a,showHistoryHint:e.showHistoryHint,flexibleHeight:$,flexibleWidth:d,flexibleMaxHeight:b,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new T.$TT({appendTitle:c,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new T.$ST({appendTitle:f,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new T.$RT({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const u=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const B=u.indexOf(this.domNode.ownerDocument.activeElement);if(B>=0){let R=-1;N.equals(17)?R=(B+1)%u.length:N.equals(15)&&(B===0?R=u.length-1:R=B-1),N.equals(9)?(u[B].blur(),this.inputBox.focus()):R>=0&&u[R].focus(),E.$9Q.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),l?.appendChild(this.domNode),this.B(E.$aQ(this.inputBox.inputElement,"compositionstart",u=>{this.s=!0})),this.B(E.$aQ(this.inputBox.inputElement,"compositionend",u=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,u=>this.P.fire(u)),this.C(this.inputBox.inputElement,u=>this.S.fire(u)),this.D(this.inputBox.inputElement,u=>this.R.fire()),this.j(this.inputBox.inputElement,u=>this.Q.fire(u))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(l){this.inputBox.layout(),this.X(l.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const l of this.N)l.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const l of this.N)l.disable()}setFocusInputOnOptionClick(l){this.n=l}setEnabled(l){l?this.enable():this.disable()}setAdditionalToggles(l){for(const h of this.N)h.domNode.remove();this.N=[],this.w.value=new m.$Sc;for(const h of l??[])this.w.value.add(h),this.y.appendChild(h.domNode),this.w.value.add(h.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(h);this.N.length>0&&(this.y.style.display=""),this.X()}X(l=!1){l?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((h,e)=>h+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(l){this.inputBox.value!==l&&(this.inputBox.value=l)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(l){this.M&&(this.M.checked=l)}getWholeWords(){return this.L?.checked??!1}setWholeWords(l){this.L&&(this.L.checked=l)}getRegex(){return this.J?.checked??!1}setRegex(l){this.J&&(this.J.checked=l,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(l){this.inputBox.showMessage(l)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$UT=v}),define(be[132],pe([1,0,2,22,14,64,131,65,61,40,66,58,26,37,12,9,17,18,32,4,35,3,33,7,111,103]),function(se,t,E,T,n,H,y,S,m,p,v,M,l,h,e,s,f,c,a,$,d,b,u,N,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tU=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$sU=t.$rU=t.$qU=t.RenderIndentGuides=t.$pU=t.$oU=void 0;class R extends m.$mS{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(o=>o.element)),this.c=i}}function U(r){return r instanceof m.$mS?new R(r):r}class z{constructor(i,o){this.d=i,this.f=o,this.b=b.$Tc.None,this.c=new b.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,o){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(w=>w.element),o)}onDragStart(i,o){this.f.onDragStart?.(U(i),o)}onDragOver(i,o,w,I,C,j=!0){const _=this.f.onDragOver(U(i),o&&o.element,w,I,C),Z=this.a!==o;if(Z&&(this.b.dispose(),this.a=o),typeof o>"u")return _;if(Z&&typeof _!="boolean"&&_.autoExpand&&(this.b=(0,s.$ah)(()=>{const Se=this.d(),we=Se.getNodeLocation(o);Se.isCollapsed(we)&&Se.setCollapsed(we,!1),this.a=void 0},500,this.c)),typeof _=="boolean"||!_.accept||typeof _.bubble>"u"||_.feedback){if(!j){const Se=typeof _=="boolean"?_:_.accept,we=typeof _=="boolean"?void 0:_.effect;return{accept:Se,effect:we,feedback:[w]}}return _}if(_.bubble===1){const Se=this.d(),we=Se.getNodeLocation(o),Te=Se.getParentNodeLocation(we),Ie=Se.getNode(Te),Me=Te&&Se.getListIndex(Te);return this.onDragOver(i,Ie,Me,I,C,!1)}const oe=this.d(),me=oe.getNodeLocation(o),De=oe.getListIndex(me),ve=oe.getListRenderCount(me);return{..._,feedback:(0,e.$Sb)(De,De+ve)}}drop(i,o,w,I,C){this.b.dispose(),this.a=void 0,this.f.drop(U(i),o&&o.element,w,I,C)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function D(r,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(o){return i.identityProvider.getId(o.element)}},dnd:i.dnd&&new z(r,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(o){return i.multipleSelectionController.isSelectionSingleChangeEvent({...o,element:o.element})},isSelectionRangeChangeEvent(o){return i.multipleSelectionController.isSelectionRangeChangeEvent({...o,element:o.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(o){const w=r(),I=w.getNodeLocation(o),C=w.getParentNodeLocation(I);return w.getNode(C).visibleChildrenCount},getPosInSet(o){return o.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?o=>i.accessibilityProvider.isChecked(o.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?o=>i.accessibilityProvider.getRole(o.element):()=>"treeitem",getAriaLabel(o){return i.accessibilityProvider.getAriaLabel(o.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?o=>i.accessibilityProvider.getAriaLevel(o.element):o=>o.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(o=>i.accessibilityProvider.getActiveDescendantId(o.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(o){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o.element)}}}}class O{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,o){this.a.setDynamicHeight?.(i.element,o)}}t.$oU=O;class W{static lift(i){return i instanceof W?i:new W(i)}static empty(i=0){return new W({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const o of i.expanded)this.expanded[o]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$pU=W;var A;(function(r){r.None="none",r.OnHover="onHover",r.Always="always"})(A||(t.RenderIndentGuides=A={}));class P{get elements(){return this.b}constructor(i,o=[]){this.b=o,this.a=new b.$Sc,this.onDidChange=$.Event.forEach(i,w=>this.b=w,this.a)}dispose(){this.a.dispose()}}class L{static{this.a=8}constructor(i,o,w,I,C,j={}){this.o=i,this.p=o,this.q=I,this.s=C,this.b=new Map,this.c=new Map,this.d=L.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Tc.None,this.m=new b.$Sc,this.templateId=i.templateId,this.updateOptions(j),$.Event.map(w,_=>_.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const o=(0,u.$_l)(i.indent,0,40);if(o!==this.d){this.d=o;for(const[w,I]of this.c)this.v(w,I)}}if(typeof i.renderIndentGuides<"u"){const o=i.renderIndentGuides!==A.None;if(o!==this.g){this.g=o;for(const[w,I]of this.c)this.w(w,I);if(this.k.dispose(),o){const w=new b.$Sc;this.q.onDidChange(this.x,this,w),this.k=w,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const o=(0,E.$bR)(i,(0,E.$)(".monaco-tl-row")),w=(0,E.$bR)(o,(0,E.$)(".monaco-tl-indent")),I=(0,E.$bR)(o,(0,E.$)(".monaco-tl-twistie")),C=(0,E.$bR)(o,(0,E.$)(".monaco-tl-contents")),j=this.o.renderTemplate(C);return{container:i,indent:w,twistie:I,indentGuidesDisposable:b.$Tc.None,templateData:j}}renderElement(i,o,w,I){this.c.set(i,w),this.b.set(i.element,i),this.v(i,w),this.o.renderElement(i,o,w.templateData,I)}disposeElement(i,o,w,I){w.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,o,w.templateData,I),typeof I=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const o=this.b.get(i);o&&this.u(o)}u(i){const o=this.c.get(i);o&&(this.x(this.q.elements),this.v(i,o))}v(i,o){const w=L.a+(i.depth-1)*this.d;o.twistie.style.paddingLeft=`${w}px`,o.indent.style.width=`${w+this.d-16}px`,i.collapsible?o.container.setAttribute("aria-expanded",String(!i.collapsed)):o.container.removeAttribute("aria-expanded"),o.twistie.classList.remove(...c.ThemeIcon.asClassNameArray(f.$ek.treeItemExpanded));let I=!1;this.o.renderTwistie&&(I=this.o.renderTwistie(i.element,o.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(I||o.twistie.classList.add(...c.ThemeIcon.asClassNameArray(f.$ek.treeItemExpanded)),o.twistie.classList.add("collapsible"),o.twistie.classList.toggle("collapsed",i.collapsed)):o.twistie.classList.remove("collapsible","collapsed"),this.w(i,o)}w(i,o){if((0,E.$_P)(o.indent),o.indentGuidesDisposable.dispose(),!this.g)return;const w=new b.$Sc,I=this.p();for(;;){const C=I.getNodeLocation(i),j=I.getParentNodeLocation(C);if(!j)break;const _=I.getNode(j),Z=(0,E.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(_)&&Z.classList.add("active"),o.indent.childElementCount===0?o.indent.appendChild(Z):o.indent.insertBefore(Z,o.indent.firstElementChild),this.s.add(_,Z),w.add((0,b.$Rc)(()=>this.s.delete(_,Z))),i=_}o.indentGuidesDisposable=w}x(i){if(!this.g)return;const o=new Set,w=this.p();i.forEach(I=>{const C=w.getNodeLocation(I);try{const j=w.getParentNodeLocation(C);I.collapsible&&I.children.length>0&&!I.collapsed?o.add(I):j&&o.add(w.getNode(j))}catch{}}),this.j.forEach(I=>{o.has(I)||this.s.forEach(I,C=>C.classList.remove("active"))}),o.forEach(I=>{this.j.has(I)||this.s.forEach(I,C=>C.classList.add("active"))}),this.j=o}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Oc)(this.m)}}t.$qU=L;class Y{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,o,w){this.g=i,this.j=o,this.k=w,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,o){let w=1;if(this.k){const j=this.k.filter(i,o);if(typeof j=="boolean"?w=j?1:0:(0,M.$lU)(j)?w=(0,M.$mU)(j.visibility):w=j,w===0)return!1}if(this.a++,!this.c)return this.b++,{data:d.FuzzyScore.Default,visibility:w};const I=this.j.getKeyboardNavigationLabel(i),C=Array.isArray(I)?I:[I];for(const j of C){const _=j&&j.toString();if(typeof _>"u")return{data:d.FuzzyScore.Default,visibility:w};let Z;if(this.g.findMatchType===ge.Contiguous){const oe=_.toLowerCase().indexOf(this.d);if(oe>-1){Z=[Number.MAX_SAFE_INTEGER,0];for(let me=this.d.length;me>0;me--)Z.push(oe+me-1)}}else Z=(0,d.$_j)(this.c,this.d,0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return this.b++,C.length===1?{data:Z,visibility:w}:{data:{label:_,score:Z},visibility:w}}return this.g.findMode===te.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:d.FuzzyScore.Default,visibility:w}}m(){this.a=0,this.b=0}dispose(){(0,b.$Oc)(this.f)}}class X extends v.$VS{constructor(i){super({icon:f.$ek.listFilter,title:(0,B.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$rU=X;class de extends v.$VS{constructor(i){super({icon:f.$ek.searchFuzzy,title:(0,B.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$sU=de;const ue={inputBoxStyles:S.$ET,toggleStyles:v.$TS,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var te;(function(r){r[r.Highlight=0]="Highlight",r[r.Filter=1]="Filter"})(te||(t.TreeFindMode=te={}));var ge;(function(r){r[r.Fuzzy=0]="Fuzzy",r[r.Contiguous=1]="Contiguous"})(ge||(t.TreeFindMatchType=ge={}));class Pe extends b.$Tc{set mode(i){this.b.checked=i===te.Filter,this.f.inputBox.setPlaceHolder(i===te.Filter?(0,B.localize)(2,null):(0,B.localize)(3,null))}set matchType(i){this.c.checked=i===ge.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,o,w,I,C,j){super(),this.t=o,this.a=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new $.$Yd,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,b.$Rc)(()=>i.removeChild(this.a.root)));const _=j?.styles??ue;_.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=_.listFilterWidgetBackground),_.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${_.listFilterWidgetShadow}`),this.b=this.B(new X({..._.toggleStyles,isChecked:I===te.Filter})),this.c=this.B(new de({..._.toggleStyles,isChecked:C===ge.Fuzzy})),this.onDidChangeMode=$.Event.map(this.b.onChange,()=>this.b.checked?te.Filter:te.Highlight,this.q),this.onDidChangeMatchType=$.Event.map(this.c.onChange,()=>this.c.checked?ge.Fuzzy:ge.Contiguous,this.q),this.f=this.B(new y.$UT(this.a.findInput,w,{label:(0,B.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:_.inputBoxStyles,toggleStyles:_.toggleStyles,history:j?.history})),this.g=this.B(new H.$7R(this.a.actionbar)),this.mode=I;const Z=this.B(new T.$cS(this.f.inputBox.inputElement,"keydown")),oe=$.Event.chain(Z.event,Se=>Se.map(we=>new n.$0P(we)));this.B(oe(Se=>{if(Se.equals(3)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Se.equals(18)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Se.equals(16)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const me=this.B(new h.$Pi("close",(0,B.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(me,{icon:!0,label:!1});const De=this.B(new T.$cS(this.a.grab,"mousedown"));this.B(De.event(Se=>{const we=new b.$Sc,Te=we.add(new T.$cS((0,E.getWindow)(Se),"mousemove")),Ie=we.add(new T.$cS((0,E.getWindow)(Se),"mouseup")),Me=this.m,Xe=Se.pageX,nt=this.s,Ke=Se.pageY;this.a.grab.classList.add("grabbing");const Ze=this.a.root.style.transition;this.a.root.style.transition="unset";const x=ne=>{const $e=ne.pageX-Xe;this.m=Me-$e;const Ee=ne.pageY-Ke;this.s=nt+Ee,this.layout()};we.add(Te.event(x)),we.add(Ie.event(ne=>{x(ne),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ze,we.dispose()}))}));const ve=$.Event.chain(this.B(new T.$cS(this.a.grab,"keydown")).event,Se=>Se.map(we=>new n.$0P(we)));this.B(ve(Se=>{let we,Te;if(Se.keyCode===15?we=Number.POSITIVE_INFINITY:Se.keyCode===17?we=0:Se.keyCode===10&&(we=this.m===0?Number.POSITIVE_INFINITY:0),Se.keyCode===16?Te=0:Se.keyCode===18&&(Te=Number.POSITIVE_INFINITY),we!==void 0&&(Se.preventDefault(),Se.stopPropagation(),this.m=we,this.layout()),Te!==void 0){Se.preventDefault(),Se.stopPropagation(),this.s=Te;const Ie=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ie},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,u.$_l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,u.$_l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$_g)(300),super.dispose()}}class Ne{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,o,w,I,C,j={}){this.t=i,this.u=w,this.v=I,this.w=C,this.x=j,this.b="",this.c="",this.j=0,this.k=new $.$Yd,this.onDidChangeMode=this.k.event,this.m=new $.$Yd,this.onDidChangeMatchType=this.m.event,this.o=new $.$Yd,this.onDidChangePattern=this.o.event,this.p=new $.$Yd,this.onDidChangeOpenState=this.p.event,this.q=new b.$Sc,this.s=new b.$Sc,this.d=i.options.defaultFindMode??te.Highlight,this.f=i.options.defaultFindMatchType??ge.Fuzzy,o.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Pe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,w=>!d.FuzzyScore.isDefault(w.filterData));const o=this.t.getFocus();if(o.length>0){const w=o[0];this.t.getRelativeTop(w)===null&&this.t.reveal(w,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,B.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!d.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Be(r,i){return r.position===i.position&&le(r,i)}function le(r,i){return r.node.element===i.node.element&&r.startIndex===i.startIndex&&r.height===i.height&&r.endIndex===i.endIndex}class J{constructor(i=[]){this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Be)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const o=this.stickyNodes[this.count-2];return o.position+o.height!==i.position}animationStateChanged(i){if(!(0,e.$ub)(this.stickyNodes,i.stickyNodes,le)||this.count===0)return!1;const o=this.stickyNodes[this.count-1],w=i.stickyNodes[i.count-1];return o.position!==w.position}}class ae{constrainStickyScrollNodes(i,o,w){for(let I=0;I<i.length;I++){const C=i[I];if(C.position+C.height>w||I>=o)return i.slice(0,I)}return i}}class re extends b.$Tc{constructor(i,o,w,I,C,j={}){super(),this.g=i,this.j=o,this.m=w,this.s=C,this.c=.4;const _=this.validateStickySettings(j);this.b=_.stickyScrollMaxItemCount,this.a=j.stickyScrollDelegate??new ae,this.f=this.B(new G(w.getScrollableElement(),w,i,I,C,j.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(w.onDidScroll(()=>this.u())),this.B(w.onDidChangeContentHeight(()=>this.u())),this.B(i.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(i){return this.f.getNode(i)}t(i){let o;if(i===0?o=this.m.firstVisibleIndex:o=this.m.indexAt(i+this.m.scrollTop),!(o<0||o>=this.m.length))return this.m.element(o)}u(){const i=this.t(0);if(!i||this.g.scrollTop===0){this.f.setState(void 0);return}const o=this.w(i);this.f.setState(o)}w(i){const o=[];let w=i,I=0,C=this.z(w,void 0,I);for(;C&&(o.push(C),I+=C.height,!(o.length<=this.b&&(w=this.y(C),!w)));)C=this.z(w,C.node,I);const j=this.H(o);return j.length?new J(j):void 0}y(i){return this.t(i.position+i.height)}z(i,o,w){const I=this.F(i,o);if(I&&!(I===i&&(!this.J(i)||this.C(i,w))))return this.D(I,w)}C(i,o){const w=this.L(i),I=this.m.getElementTop(w),C=o;return this.m.scrollTop===I-C}D(i,o){const w=this.s.getHeight(i),{startIndex:I,endIndex:C}=this.M(i),j=this.G(C,o,w);return{node:i,position:j,height:w,startIndex:I,endIndex:C}}F(i,o=void 0){let w=i,I=this.I(w);for(;I;){if(I===o)return w;w=I,I=this.I(w)}if(o===void 0)return w}G(i,o,w){let I=this.m.getRelativeTop(i);if(I===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const oe=this.s.getHeight(this.m.element(i)),me=this.m.getRelativeTop(i+1);I=me?me-oe/this.m.renderHeight:null}if(I===null)return o;const C=this.m.element(i),j=this.s.getHeight(C),Z=I*this.m.renderHeight+j;return o+w>Z&&o<=Z?Z-w:o}H(i){if(i.length===0)return[];const o=this.m.renderHeight*this.c,w=i[i.length-1];if(i.length<=this.b&&w.position+w.height<=o)return i;const I=this.a.constrainStickyScrollNodes(i,this.b,o);if(!I.length)return[];const C=I[I.length-1];if(I.length>this.b||C.position+C.height>o)throw new Error("stickyScrollDelegate violates constraints");return I}I(i){const o=this.j.getNodeLocation(i),w=this.j.getParentNodeLocation(o);return w?this.j.getNode(w):void 0}J(i){const o=this.j.getNodeLocation(i);return this.j.getListRenderCount(o)>1}L(i){const o=this.j.getNodeLocation(i);return this.j.getListIndex(o)}M(i){const o=this.j.getNodeLocation(i),w=this.j.getListIndex(o);if(w<0)throw new Error("Node not found in tree");const I=this.j.getListRenderCount(o),C=w+I-1;return{startIndex:w,endIndex:C}}nodePositionTopBelowWidget(i){const o=[];let w=this.I(i);for(;w;)o.push(w),w=this.I(w);let I=0;for(let C=0;C<o.length&&C<this.b;C++)I+=this.s.getHeight(o[C]);return I}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(i={}){if(!i.stickyScrollMaxItemCount)return;const o=this.validateStickySettings(i);this.b!==o.stickyScrollMaxItemCount&&(this.b=o.stickyScrollMaxItemCount,this.u())}validateStickySettings(i){let o=7;return typeof i.stickyScrollMaxItemCount=="number"&&(o=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:o}}}class G{constructor(i,o,w,I,C,j){this.g=o,this.j=w,this.k=I,this.m=C,this.o=j,this.c=[],this.d=new b.$Sc,this.a=(0,E.$)(".monaco-tree-sticky-container.empty"),i.appendChild(this.a);const _=(0,E.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(_),this.f=new K(this.a,o),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(o=>o.node===i)}setState(i){const o=!!this.b&&this.b.count>0,w=!!i&&i.count>0;if(!o&&!w||o&&w&&this.b.equal(i))return;if(o!==w&&this.s(w),!w){this.b=void 0,this.c=[],this.d.clear();return}const I=i.stickyNodes[i.count-1];if(this.b&&i.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${I.position}px`;else{this.d.clear();const C=Array(i.count);for(let j=i.count-1;j>=0;j--){const _=i.stickyNodes[j],{element:Z,disposable:oe}=this.p(_,j,i.count);C[j]=Z,this.a.appendChild(Z),this.d.add(oe)}this.f.updateElements(C,i),this.c=C}this.b=i,this.a.style.height=`${I.position+I.height}px`}p(i,o,w){const I=i.startIndex,C=document.createElement("div");C.style.top=`${i.position}px`,C.style.height=`${i.height}px`,C.style.lineHeight=`${i.height}px`,C.classList.add("monaco-tree-sticky-row"),C.classList.add("monaco-list-row"),C.setAttribute("data-index",`${I}`),C.setAttribute("data-parity",I%2===0?"even":"odd"),C.setAttribute("id",this.g.getElementID(I)),this.q(C,i.node.element,o,w);const j=this.m.getTemplateId(i.node),_=this.k.find(De=>De.templateId===j);if(!_)throw new Error(`No renderer found for template id ${j}`);let Z=i.node;Z===this.j.getNode(this.j.getNodeLocation(i.node))&&(Z=new Proxy(i.node,{}));const oe=_.renderTemplate(C);_.renderElement(Z,i.startIndex,oe,i.height);const me=(0,b.$Rc)(()=>{_.disposeElement(Z,i.startIndex,oe,i.height),_.disposeTemplate(oe),C.remove()});return{element:C,disposable:me}}q(i,o,w,I){if(!this.o)return;this.o.getSetSize&&i.setAttribute("aria-setsize",String(this.o.getSetSize(o,w,I))),this.o.getPosInSet&&i.setAttribute("aria-posinset",String(this.o.getPosInSet(o,w))),this.o.getRole&&i.setAttribute("role",this.o.getRole(o)??"treeitem");const C=this.o.getAriaLabel(o);C&&i.setAttribute("aria-label",C);const j=this.o.getAriaLevel&&this.o.getAriaLevel(o);typeof j=="number"&&i.setAttribute("aria-level",`${j}`),i.setAttribute("aria-selected",String(!1))}s(i){this.a.classList.toggle("empty",!i),i||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class K extends b.$Tc{get m(){return this.j}set m(i){i!==this.j&&(this.f.fire(i),this.j=i)}constructor(i,o){super(),this.s=i,this.t=o,this.a=-1,this.b=[],this.f=new $.$Yd,this.onDidChangeHasFocus=this.f.event,this.g=new $.$Yd,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(w=>this.w(w))),this.B(this.t.onMouseDown(w=>this.y(w))),this.B(this.t.onContextMenu(w=>this.u(w)))}u(i){const o=i.browserEvent.target;if(!(0,p.$zS)(o)&&!(0,p.$yS)(o)){this.focusedLast()&&this.t.domFocus();return}if(!(0,E.$4Q)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const j=this.c.stickyNodes.findIndex(_=>_.node.element===i.element?.element);if(j===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(j);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const I=this.c.stickyNodes[this.a].node.element,C=this.b[this.a];this.g.fire({element:I,anchor:C,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const o=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([o]),this.C(o,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const o=i.browserEvent.target;!(0,p.$zS)(o)&&!(0,p.$yS)(o)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,o){if(o&&o.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(o&&o.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const w=this.a;if(this.D(),this.b=i,this.c=o,o){const I=(0,u.$_l)(w,0,o.count-1);this.F(I)}else this.m&&this.t.domFocus();this.s.tabIndex=o?0:-1}z(i){const o=this.c;if(!o)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<o.count-1)&&o.lastNodePartiallyVisible()){const w=o.stickyNodes[i];this.C(w.endIndex+1,o)}}C(i,o){const w=o.stickyNodes[o.count-1],I=o.count>1?o.stickyNodes[o.count-2]:void 0,C=this.t.getElementTop(i),j=I?I.position+I.height+w.height:w.height;this.t.scrollTop=C-j}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const o=this.a;o>=0&&this.G(this.b[o],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,o){i.classList.toggle("focused",o)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ie(r){let i=l.TreeMouseEventTarget.Unknown;return(0,E.$IQ)(r.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=l.TreeMouseEventTarget.Twistie:(0,E.$IQ)(r.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=l.TreeMouseEventTarget.Element:(0,E.$IQ)(r.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=l.TreeMouseEventTarget.Filter),{browserEvent:r.browserEvent,element:r.element?r.element.element:null,target:i}}function fe(r){const i=(0,p.$zS)(r.browserEvent.target);return{element:r.element?r.element.element:null,browserEvent:r.browserEvent,anchor:r.anchor,isStickyScroll:i}}function ye(r,i){i(r),r.children.forEach(o=>ye(o,i))}class Ce{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,o){this.g=i,this.j=o,this.a=[],this.c=new $.$Yd,this.onDidChange=this.c.event}set(i,o){!o?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,o)}k(i,o,w){if(this.a=[...i],this.b=void 0,this.d=void 0,!o){const I=this;this.c.fire({get elements(){return I.get()},browserEvent:w})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:o}){if(!this.j){const Z=this.m(),oe=me=>Z.delete(me);o.forEach(me=>ye(me,oe)),this.set([...Z.values()]);return}const w=new Set,I=Z=>w.add(this.j.getId(Z.element).toString());o.forEach(Z=>ye(Z,I));const C=new Map,j=Z=>C.set(this.j.getId(Z.element).toString(),Z);i.forEach(Z=>ye(Z,j));const _=[];for(const Z of this.a){const oe=this.j.getId(Z.element).toString();if(!w.has(oe))_.push(Z);else{const De=C.get(oe);De&&De.visible&&_.push(De)}}if(this.a.length>0&&_.length===0){const Z=this.g();Z&&_.push(Z)}this.k(_,!0)}m(){const i=new Set;for(const o of this.a)i.add(o);return i}}class Ae extends p.$ES{constructor(i,o,w){super(i),this.x=o,this.y=w}u(i){if((0,p.$AS)(i.browserEvent.target)||(0,p.$tS)(i.browserEvent.target)||(0,p.$uS)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const o=i.element;if(!o)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const w=i.browserEvent.target,I=w.classList.contains("monaco-tl-twistie")||w.classList.contains("monaco-icon-label")&&w.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,C=(0,p.$yS)(i.browserEvent.target);let j=!1;if(C?j=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?j=this.x.expandOnlyOnTwistieClick(o.element):j=!!this.x.expandOnlyOnTwistieClick,C)this.A(i,o);else{if(j&&!I&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(o.collapsible&&(!C||I)){const _=this.x.getNodeLocation(o),Z=i.browserEvent.altKey;if(this.x.setFocus([_]),this.x.toggleCollapsed(_,Z),j&&I){i.browserEvent.isHandledByList=!0;return}}C||super.u(i)}A(i,o){if((0,p.$vS)(i.browserEvent.target)||(0,p.$wS)(i.browserEvent.target))return;const w=this.y();if(!w)throw new Error("Sticky scroll controller not found");const I=this.k.indexOf(o),C=this.k.getElementTop(I),j=w.nodePositionTopBelowWidget(o);this.x.scrollTop=C-j,this.k.domFocus(),this.k.setFocus([I]),this.k.setSelection([I])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const o=i.browserEvent.target;if(!(0,p.$zS)(o)&&!(0,p.$yS)(o)){super.s(i);return}}t(i){const o=i.browserEvent.target;if(!(0,p.$zS)(o)&&!(0,p.$yS)(o)){super.t(i);return}}}class q extends p.$HS{constructor(i,o,w,I,C,j,_,Z){super(i,o,w,I,Z),this.p=C,this.s=j,this.K=_}D(i){return new Ae(this,i.tree,i.stickyScrollProvider)}splice(i,o,w=[]){if(super.splice(i,o,w),w.length===0)return;const I=[],C=[];let j;w.forEach((_,Z)=>{this.p.has(_)&&I.push(i+Z),this.s.has(_)&&C.push(i+Z),this.K.has(_)&&(j=i+Z)}),I.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...I])),C.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...C])),typeof j=="number"&&super.setAnchor(j)}setFocus(i,o,w=!1){super.setFocus(i,o),w||this.p.set(i.map(I=>this.element(I)),o)}setSelection(i,o,w=!1){super.setSelection(i,o),w||this.s.set(i.map(I=>this.element(I)),o)}setAnchor(i,o=!1){super.setAnchor(i),o||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var g;(function(r){r[r.Tree=0]="Tree",r[r.StickyScroll=1]="StickyScroll"})(g||(t.AbstractTreePart=g={}));class k{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return $.Event.map(this.j.onMouseClick,ie)}get onMouseDblClick(){return $.Event.filter($.Event.map(this.j.onMouseDblClick,ie),i=>i.target!==l.TreeMouseEventTarget.Filter)}get onContextMenu(){return $.Event.any($.Event.filter($.Event.map(this.j.onContextMenu,fe),i=>!i.isStickyScroll),this.B?.onContextMenu??$.Event.None)}get onTap(){return $.Event.map(this.j.onTap,ie)}get onPointer(){return $.Event.map(this.j.onPointer,ie)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return $.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??te.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??ge.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:$.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,o,w,I,C={}){this.G=i,this.H=C,this.y=new $.$7d,this.onDidChangeFindOpenState=$.Event.None,this.onDidChangeStickyScrollFocused=$.Event.None,this.D=new b.$Sc,this.E=new $.$Yd,this.onWillRefilter=this.E.event,this.F=new $.$Yd,this.onDidUpdateOptions=this.F.event,this.p=new O(w);const j=new $.$8d,_=new $.$8d,Z=this.D.add(new P(_.event)),oe=new a.$Gc;this.k=I.map(we=>new L(we,()=>this.o,j.event,Z,oe,C));for(const we of this.k)this.D.add(we);let me;C.keyboardNavigationLabelProvider&&(me=new Y(this,C.keyboardNavigationLabelProvider,C.filter),C={...C,filter:me},this.D.add(me)),this.q=new Ce(()=>this.j.getFocusedElements()[0],C.identityProvider),this.w=new Ce(()=>this.j.getSelectedElements()[0],C.identityProvider),this.x=new Ce(()=>this.j.getAnchorElement(),C.identityProvider),this.j=new q(i,o,this.p,this.k,this.q,this.w,this.x,{...D(()=>this.o,C),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,C),j.input=this.o.onDidChangeCollapseState;const De=$.Event.forEach(this.o.onDidSplice,we=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(we),this.w.onDidModelSplice(we)})},this.D);De(()=>null,null,this.D);const ve=this.D.add(new $.$Yd),Se=this.D.add(new s.$8g(0));if(this.D.add($.Event.any(De,this.q.onDidChange,this.w.onDidChange)(()=>{Se.trigger(()=>{const we=new Set;for(const Te of this.q.getNodes())we.add(Te);for(const Te of this.w.getNodes())we.add(Te);ve.fire([...we.values()])})})),_.input=ve.event,C.keyboardSupport!==!1){const we=$.Event.chain(this.j.onKeyDown,Te=>Te.filter(Ie=>!(0,p.$tS)(Ie.target)).map(Ie=>new n.$0P(Ie)));$.Event.chain(we,Te=>Te.filter(Ie=>Ie.keyCode===15))(this.J,this,this.D),$.Event.chain(we,Te=>Te.filter(Ie=>Ie.keyCode===17))(this.K,this,this.D),$.Event.chain(we,Te=>Te.filter(Ie=>Ie.keyCode===10))(this.L,this,this.D)}if((C.findWidgetEnabled??!0)&&C.keyboardNavigationLabelProvider&&C.contextViewProvider){const we=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Ne(this,this.o,this.j,me,C.contextViewProvider,we),this.A=Te=>this.z.shouldAllowFocus(Te),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=$.Event.None,this.onDidChangeFindMatchType=$.Event.None;C.enableStickyScroll&&(this.B=new re(this,this.o,this.j,this.k,this.p,C),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,E.$VQ)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===A.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const o of this.k)o.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===A.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new re(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=$.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const o=this.o.getListIndex(i);o!==-1&&this.j.updateWidth(o)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,E.$NQ)(this.getHTMLElement())}layout(i,o){this.j.layout(i,o),(0,N.$Qf)(o)&&this.z?.layout(o)}style(i){const o=`.${this.j.domId}`,w=[];i.treeIndentGuidesStroke&&(w.push(`.monaco-list${o}:hover .monaco-tl-indent > .indent-guide, .monaco-list${o}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),w.push(`.monaco-list${o} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const I=(0,E.$tR)(i.listFocusAndSelectionOutline,(0,E.$tR)(i.listSelectionOutline,i.listFocusOutline??""));I&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${I}; outline-offset: -1px;}`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=w.join(`
`),this.j.style(i)}getParentElement(i){const o=this.o.getParentNodeLocation(i);return this.o.getNode(o).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,o=!1){return this.o.setCollapsed(i,!0,o)}expand(i,o=!1){return this.o.setCollapsed(i,!1,o)}toggleCollapsed(i,o=!1){return this.o.setCollapsed(i,void 0,o)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,o){return this.o.setCollapsible(i,o)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const o=this.o.getNode(i);this.x.set([o]);const w=this.o.getListIndex(i);w>-1&&this.j.setAnchor(w,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,o){this.y.bufferEvents(()=>{const w=i.map(C=>this.o.getNode(C));this.w.set(w,o);const I=i.map(C=>this.o.getListIndex(C)).filter(C=>C>-1);this.j.setSelection(I,o,!0)})}getSelection(){return this.w.get()}setFocus(i,o){this.y.bufferEvents(()=>{const w=i.map(C=>this.o.getNode(C));this.q.set(w,o);const I=i.map(C=>this.o.getListIndex(C)).filter(C=>C>-1);this.j.setFocus(I,o,!0)})}focusNext(i=1,o=!1,w,I=(0,E.$4Q)(w)&&w.altKey?void 0:this.A){this.j.focusNext(i,o,w,I)}focusPrevious(i=1,o=!1,w,I=(0,E.$4Q)(w)&&w.altKey?void 0:this.A){this.j.focusPrevious(i,o,w,I)}focusNextPage(i,o=(0,E.$4Q)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,o)}focusPreviousPage(i,o=(0,E.$4Q)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,o,()=>this.B?.height??0)}focusLast(i,o=(0,E.$4Q)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,o)}focusFirst(i,o=(0,E.$4Q)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,o)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,o){this.o.expandTo(i);const w=this.o.getListIndex(i);if(w!==-1)if(!this.B)this.j.reveal(w,o);else{const I=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(w,o,I)}}getRelativeTop(i){const o=this.o.getListIndex(i);if(o===-1)return null;const w=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(o,w?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new l.$jU(this.G,"Can't get tree view state without an identity provider");const o=j=>i.getId(j).toString(),w=W.empty(this.scrollTop);for(const j of this.getFocus())w.focus.add(o(j));for(const j of this.getSelection())w.selection.add(o(j));const I=this.o.getNode(),C=[I];for(;C.length>0;){const j=C.shift();j!==I&&j.collapsible&&(w.expanded[o(j.element)]=j.collapsed?0:1),C.push(...j.children)}return w}J(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],I=this.o.getNodeLocation(w);if(!this.o.setCollapsed(I,!0)){const j=this.o.getParentNodeLocation(I);if(!j)return;const _=this.o.getListIndex(j);this.j.reveal(_),this.j.setFocus([_])}}K(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],I=this.o.getNodeLocation(w);if(!this.o.setCollapsed(I,!1)){if(!w.children.some(Z=>Z.visible))return;const[j]=this.j.getFocus(),_=j+1;this.j.reveal(_),this.j.setFocus([_])}}L(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],I=this.o.getNodeLocation(w),C=i.browserEvent.altKey;this.o.setCollapsed(I,void 0,C)}navigate(i){return new F(this.j,this.o,i)}dispose(){(0,b.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$tU=k;class F{constructor(i,o,w){this.b=i,this.c=o,w?this.a=this.c.getListIndex(w):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[133],pe([1,0,132,123,26,28]),function(se,t,E,T,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EU=void 0;class y extends E.$tU{constructor(m,p,v,M,l,h={}){super(m,p,v,M,h),this.f=m,this.g=l,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(m,p){if(p&&!this.c)throw new n.$jU(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!p){this.m(m);return}const v=[],M=[],l=e=>{const s=this.c.getId(e).toString();return!p.expanded[s]},h=e=>{const s=this.c.getId(e.element).toString();p.focus.has(s)&&v.push(e.element),p.selection.has(s)&&M.push(e.element)};this.m(m,l,h),this.setFocus(v),this.setSelection(M),p&&typeof p.scrollTop=="number"&&(this.scrollTop=p.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new n.$jU(this.f,"Tree input not set");let p;this.c&&(p=v=>{const M=this.c.getId(v).toString(),l=this.d.get(M);if(l)return l.collapsed}),this.m(m,p)}resort(m=this.b,p=!0){this.o.resort(m===this.b?null:m,p)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,p,v){let M;if(this.c){const l=new Set,h=v;v=e=>{const s=this.c.getId(e.element).toString();l.add(s),this.d.set(s,e),h?.(e)},M=e=>{const s=this.c.getId(e.element).toString();l.has(s)||this.d.delete(s)}}this.o.setChildren(m===this.b?null:m,this.s(m,p).elements,{onDidCreateNode:v,onDidDeleteNode:M})}s(m,p){const v=[...this.g.getChildren(m)];return{elements:H.Iterable.map(v,l=>{const{elements:h,size:e}=this.s(l,p),s=this.g.hasChildren?this.g.hasChildren(l):void 0,f=e===0?void 0:p&&p(l);return{element:l,children:h,collapsible:s,collapsed:f}}),size:v.length}}M(m,p,v){return new T.$uU(m,p,v)}}t.$EU=y}),define(be[67],pe([1,0,12,9,34,29,27,6,4,3,53,10,7]),function(se,t,E,T,n,H,y,S,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Th=t.ProxyChannel=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.RequestInitiator=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=void 0;var h;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(h||(h={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(s||(s={}));function f(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(c||(c={}));function a(le){let J=0;for(let ae=0;;ae+=7){const re=le.read(1);if(J|=(re.buffer[0]&127)<<ae,!(re.buffer[0]&128))return J}}const $=B(0);function d(le,J){if(J===0){le.write($);return}let ae=0;for(let G=J;G!==0;G=G>>>7)ae++;const re=n.$me.alloc(ae);for(let G=0;J!==0;G++)re.buffer[G]=J&127,J=J>>>7,J>0&&(re.buffer[G]|=128);le.write(re)}class b{constructor(J){this.b=J,this.a=0}read(J){const ae=this.b.slice(this.a,this.a+J);return this.a+=ae.byteLength,ae}}t.$Ih=b;class u{constructor(){this.a=[]}get buffer(){return n.$me.concat(this.a)}write(J){this.a.push(J)}}t.$Jh=u;var N;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(N||(N={}));function B(le){const J=n.$me.alloc(1);return J.writeUInt8(le,0),J}const R={Undefined:B(N.Undefined),String:B(N.String),Buffer:B(N.Buffer),VSBuffer:B(N.VSBuffer),Array:B(N.Array),Object:B(N.Object),Uint:B(N.Int)},U=typeof Buffer<"u";function z(le,J){if(typeof J>"u")le.write(R.Undefined);else if(typeof J=="string"){const ae=n.$me.fromString(J);le.write(R.String),d(le,ae.byteLength),le.write(ae)}else if(U&&Buffer.isBuffer(J)){const ae=n.$me.wrap(J);le.write(R.Buffer),d(le,ae.byteLength),le.write(ae)}else if(J instanceof n.$me)le.write(R.VSBuffer),d(le,J.byteLength),le.write(J);else if(Array.isArray(J)){le.write(R.Array),d(le,J.length);for(const ae of J)z(le,ae)}else if(typeof J=="number"&&(J|0)===J)le.write(R.Uint),d(le,J);else{const ae=n.$me.fromString(JSON.stringify(J));le.write(R.Object),d(le,ae.byteLength),le.write(ae)}}t.$Kh=z;function D(le){switch(le.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return le.read(a(le)).toString();case N.Buffer:return le.read(a(le)).buffer;case N.VSBuffer:return le.read(a(le));case N.Array:{const ae=a(le),re=[];for(let G=0;G<ae;G++)re.push(D(le));return re}case N.Object:return JSON.parse(le.read(a(le)).toString());case N.Int:return a(le)}}t.$Lh=D;class O{constructor(J,ae,re=null,G=1e3){this.h=J,this.j=ae,this.k=re,this.l=G,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(J,ae){this.b.set(J,ae),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const ae=this.o([J.type]);this.k?.logOutgoing(ae,0,1,f(J.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([J.type,J.id],J.data);this.k?.logOutgoing(ae,J.id,1,f(J.type),J.data);return}}}o(J,ae=void 0){const re=new u;return z(re,J),z(re,ae),this.p(re.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const ae=new b(J),re=D(ae),G=D(ae),K=re[0];switch(K){case 100:return this.k?.logIncoming(J.byteLength,re[1],1,`${e(K)}: ${re[2]}.${re[3]}`,G),this.s({type:K,id:re[1],channelName:re[2],name:re[3],arg:G});case 102:return this.k?.logIncoming(J.byteLength,re[1],1,`${e(K)}: ${re[2]}.${re[3]}`,G),this.t({type:K,id:re[1],channelName:re[2],name:re[3],arg:G});case 101:return this.k?.logIncoming(J.byteLength,re[1],1,`${e(K)}`),this.u({type:K,id:re[1]});case 103:return this.k?.logIncoming(J.byteLength,re[1],1,`${e(K)}`),this.u({type:K,id:re[1]})}}s(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const re=new H.$9d;let G;try{G=ae.call(this.j,J.name,J.arg,re.token)}catch(fe){G=Promise.reject(fe)}const K=J.id;G.then(fe=>{this.m({id:K,data:fe,type:201})},fe=>{fe instanceof Error?this.m({id:K,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:K,data:fe,type:203})}).finally(()=>{ie.dispose(),this.d.delete(J.id)});const ie=(0,p.$Rc)(()=>re.cancel());this.d.set(J.id,ie)}t(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const re=J.id,K=ae.listen(this.j,J.name,J.arg)(ie=>this.m({id:re,data:ie,type:204}));this.d.set(J.id,K)}u(J){const ae=this.d.get(J.id);ae&&(ae.dispose(),this.d.delete(J.id))}v(J){let ae=this.g.get(J.channelName);ae||(ae=[],this.g.set(J.channelName,ae));const re=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:J,timeoutTimer:re})}w(J){const ae=this.g.get(J);if(ae){for(const re of ae)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}t.$Mh=O;var W;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(W||(t.RequestInitiator=W={}));class A{constructor(J,ae=null){this.l=J,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$Yd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ae}getChannel(J){const ae=this;return{call(re,G,K){return ae.a?Promise.reject(new S.$5):ae.m(J,re,G,K)},listen(re,G){return ae.a?m.Event.None:ae.o(J,re,G)}}}m(J,ae,re,G=H.CancellationToken.None){const K=this.g++,fe={id:K,type:100,channelName:J,name:ae,arg:re};if(G.isCancellationRequested)return Promise.reject(new S.$5);let ye;return new Promise((Ae,q)=>{if(G.isCancellationRequested)return q(new S.$5);const g=()=>{const i=o=>{switch(o.type){case 201:this.f.delete(K),Ae(o.data);break;case 202:{this.f.delete(K);const w=new Error(o.data.message);w.stack=Array.isArray(o.data.stack)?o.data.stack.join(`
`):o.data.stack,w.name=o.data.name,q(w);break}case 203:this.f.delete(K),q(o.data);break}};this.f.set(K,i),this.p(fe)};let k=null;this.b===c.Idle?g():(k=(0,T.$Xg)(i=>this.u()),k.then(()=>{k=null,g()}));const F=()=>{k?(k.cancel(),k=null):this.p({id:K,type:101}),q(new S.$5)},r=G.onCancellationRequested(F);ye=(0,p.$Qc)((0,p.$Rc)(F),r),this.d.add(ye)}).finally(()=>{ye.dispose(),this.d.delete(ye)})}o(J,ae,re){const G=this.g++,ie={id:G,type:102,channelName:J,name:ae,arg:re};let fe=null;const ye=new m.$Yd({onWillAddFirstListener:()=>{fe=(0,T.$Xg)(Ae=>this.u()),fe.then(()=>{fe=null,this.d.add(ye),this.p(ie)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(ye),this.p({id:G,type:103}))}}),Ce=Ae=>ye.fire(Ae.data);return this.f.set(G,Ce),ye.event}p(J){switch(J.type){case 100:case 102:{const ae=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(ae,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const ae=this.q([J.type,J.id]);this.j?.logOutgoing(ae,J.id,0,e(J.type));return}}}q(J,ae=void 0){const re=new u;return z(re,J),z(re,ae),this.r(re.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const ae=new b(J),re=D(ae),G=D(ae),K=re[0];switch(K){case 200:return this.j?.logIncoming(J.byteLength,0,0,f(K)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,re[1],0,f(K),G),this.t({type:re[0],id:re[1],data:G})}}t(J){if(J.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}t.$Nh=A,Ye([y.$Ch],A.prototype,"onDidInitializePromise",null);class P{get connections(){const J=[];return this.f.forEach(ae=>J.push(ae)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new m.$Yd,this.onDidAddConnection=this.g.event,this.h=new m.$Yd,this.onDidRemoveConnection=this.h.event,this.j=new p.$Sc,this.j.add(J(({protocol:ae,onDidClientDisconnect:re})=>{const G=m.Event.once(ae.onMessage);this.j.add(G(K=>{const ie=new b(K),fe=D(ie),ye=new O(ae,fe),Ce=new A(ae);this.a.forEach((q,g)=>ye.registerChannel(g,q));const Ae={channelServer:ye,channelClient:Ce,ctx:fe};this.f.add(Ae),this.g.fire(Ae),this.j.add(re(()=>{ye.dispose(),Ce.dispose(),this.f.delete(Ae),this.h.fire(Ae)}))}))}))}getChannel(J,ae){const re=this;return{call(G,K,ie){let fe;if((0,l.$1f)(ae)){const Ce=(0,E.$4b)(re.connections.filter(ae));fe=Ce?Promise.resolve(Ce):m.Event.toPromise(m.Event.filter(re.onDidAddConnection,ae))}else fe=ae.routeCall(re,G,K);const ye=fe.then(Ce=>Ce.channelClient.getChannel(J));return Y(ye).call(G,K,ie)},listen(G,K){if((0,l.$1f)(ae))return re.k(J,ae,G,K);const ie=ae.routeEvent(re,G,K).then(fe=>fe.channelClient.getChannel(J));return Y(ie).listen(G,K)}}}k(J,ae,re,G){const K=this;let ie;const fe=new m.$Yd({onWillAddFirstListener:()=>{ie=new p.$Sc;const ye=new m.$5d,Ce=new Map,Ae=g=>{const F=g.channelClient.getChannel(J).listen(re,G),r=ye.add(F);Ce.set(g,r)},q=g=>{const k=Ce.get(g);k&&(k.dispose(),Ce.delete(g))};K.connections.filter(ae).forEach(Ae),m.Event.filter(K.onDidAddConnection,ae)(Ae,void 0,ie),K.onDidRemoveConnection(q,void 0,ie),ye.event(fe.fire,fe,ie),ie.add(ye)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return fe.event}registerChannel(J,ae){this.a.set(J,ae);for(const re of this.f)re.channelServer.registerChannel(J,ae)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Oh=P;class L{constructor(J,ae,re=null){const G=new u;z(G,ae),J.send(G.buffer),this.a=new A(J,re),this.d=new O(J,ae,re)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,ae){this.d.registerChannel(J,ae)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Ph=L;function Y(le){return{call(J,ae,re){return le.then(G=>G.call(J,ae,re))},listen(J,ae){const re=new m.$8d;return le.then(G=>re.input=G.listen(J,ae)),re.event}}}t.$Qh=Y;function X(le){let J=!1;return{call(ae,re,G){return J?le.call(ae,re,G):(0,T.$_g)(0).then(()=>J=!0).then(()=>le.call(ae,re,G))},listen(ae,re){if(J)return le.listen(ae,re);const G=new m.$8d;return(0,T.$_g)(0).then(()=>J=!0).then(()=>G.input=le.listen(ae,re)),G.event}}}t.$Rh=X;class de{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const ae of J.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await m.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Sh=de;var ue;(function(le){function J(K,ie,fe){const ye=K,Ce=fe&&fe.disableMarshalling,Ae=new Map;for(const q in ye)re(q)&&Ae.set(q,m.Event.buffer(ye[q],!0,void 0,ie));return new class{listen(q,g,k){const F=Ae.get(g);if(F)return F;if(G(g)){const r=ye[g];if(typeof r=="function")return r.call(ye,k)}throw new S.$bb(`Event not found: ${g}`)}call(q,g,k){const F=ye[g];if(typeof F=="function"){if(!Ce&&Array.isArray(k))for(let i=0;i<k.length;i++)k[i]=(0,v.$Hh)(k[i]);let r=F.apply(ye,k);return r instanceof Promise||(r=Promise.resolve(r)),r}throw new S.$bb(`Method not found: ${g}`)}}}le.fromService=J;function ae(K,ie){const fe=ie&&ie.disableMarshalling;return new Proxy({},{get(ye,Ce){if(typeof Ce=="string")return ie?.properties?.has(Ce)?ie.properties.get(Ce):G(Ce)?function(Ae){return K.listen(Ce,Ae)}:re(Ce)?K.listen(Ce):async function(...Ae){let q;ie&&!(0,l.$Vf)(ie.context)?q=[ie.context,...Ae]:q=Ae;const g=await K.call(Ce,q);return fe?g:(0,v.$Hh)(g)};throw new S.$bb(`Property not found: ${String(Ce)}`)}})}le.toService=ae;function re(K){return K[0]==="o"&&K[1]==="n"&&M.$cf(K.charCodeAt(2))}function G(K){return/^onDynamic/.test(K)&&M.$cf(K.charCodeAt(9))}})(ue||(t.ProxyChannel=ue={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const J=le.toString();if(J!=="[object Object]")return J}return le}function Pe(le){return Array.isArray(le)?le.map(ge):ge(le)}function Ne(le,J,ae,re,G,K,ie){ie=Pe(ie);const fe=te[G],ye=fe[re%fe.length];let Ce=[`%c[${le}]%c[${String(J).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(K)?(Ce=Ce.concat(ie),Ce.push(")")):Ce.push(ie),console.log.apply(console,Ce)}class Be{constructor(J,ae){this.d=J,this.f=ae,this.a=0,this.b=0}logOutgoing(J,ae,re,G,K){this.b+=J,Ne(this.d,this.b,J,ae,re,G,K)}logIncoming(J,ae,re,G,K){this.a+=J,Ne(this.f,this.a,J,ae,re,G,K)}}t.$Th=Be}),define(be[134],pe([1,0,34,4,67,90,30]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cV=void 0;class S extends n.$Ph{static f(){const p=T.Event.fromNodeEventEmitter(y.$O,"vscode:message",(v,M)=>E.$me.wrap(M));return y.$O.send("vscode:hello"),new H.$$U(y.$O,p)}constructor(p){const v=S.f();super(v,p),this.b=v}dispose(){this.b.disconnect(),super.dispose()}}t.$cV=S}),define(be[135],pe([13,11]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(be[136],pe([13,11]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(be[41],pe([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_h=t.$$h=t.$0h=t._util=void 0;var E;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function S(m){return m[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=S})(E||(t._util=E={})),t.$0h=n("instantiationService");function T(y,S,m){S[E.DI_TARGET]===S?S[E.DI_DEPENDENCIES].push({id:y,index:m}):(S[E.DI_DEPENDENCIES]=[{id:y,index:m}],S[E.DI_TARGET]=S)}function n(y){if(E.serviceIds.has(y))return E.serviceIds.get(y);const S=function(m,p,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(S,m,v)};return S.toString=()=>y,E.serviceIds.set(y,S),S}t.$$h=n;function H(y){return y}t.$_h=H}),define(be[137],pe([1,0,41]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qm=t.$Pm=t.$Om=t.ID=void 0,t.ID="diagnosticsService",t.$Om=(0,E.$$h)(t.ID);function T(H){return!!H.hostName&&!!H.errorMessage}t.$Pm=T;class n{async getPerformanceInfo(y,S){return{}}async getSystemInfo(y,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,S){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.$Qm=n}),define(be[138],pe([1,0,88,24,10,7,15,135,41,5,31,23]),function(se,t,E,T,n,H,y,S,m,p,v,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5k=t.$4k=t.$3k=t.$2k=t.$1k=t.FileKind=t.$Zk=t.$Yk=t.$Xk=t.$Wk=t.$Vk=t.$Uk=t.$Tk=t.FileOperationResult=t.$Sk=t.$Rk=t.$Qk=t.$Pk=t.$Ok=t.FileChangeType=t.$Nk=t.FileOperation=t.$Mk=t.$Lk=t.$Kk=t.$Jk=t.$Ik=t.$Hk=t.FileSystemProviderErrorCode=t.$Gk=t.$Fk=t.$Ek=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.$yk=t.FileSystemProviderCapabilities=t.$xk=t.FilePermission=t.FileType=t.$wk=t.$vk=void 0,t.$vk=(0,m.$$h)("fileService");function l(G){return G.create===!0}t.$wk=l;var h;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(h||(t.FileType=h={}));var e;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(G){const K=G;return!!K&&typeof K.onDidChange=="function"}t.$xk=s;var f;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(f||(t.FileSystemProviderCapabilities=f={}));function c(G){return!!(G.capabilities&2)}t.$yk=c;function a(G){return!!(G.capabilities&8)}t.$zk=a;function $(G){return!!(G.capabilities&131072)}t.$Ak=$;function d(G){return!!(G.capabilities&4)}t.$Bk=d;function b(G){return!!(G.capabilities&16)}t.$Ck=b;function u(G){return c(G)?!!(G.capabilities&16384):!1}t.$Dk=u;function N(G){return c(G)?!!(G.capabilities&32768):!1}t.$Ek=N;function B(G){return!!(G.capabilities&65536)}t.$Fk=B;function R(G){return!!(G.capabilities&2048)}t.$Gk=R;var U;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(U||(t.FileSystemProviderErrorCode=U={}));class z extends Error{static create(K,ie){const fe=new z(K.toString(),ie);return W(fe,ie),fe}constructor(K,ie){super(K),this.code=ie}}t.$Hk=z;function D(G,K){return z.create(G,K)}t.$Ik=D;function O(G){return G||D((0,S.localize)(0,null),U.Unknown)}t.$Jk=O;function W(G,K){return G.name=K?`${K} (FileSystemError)`:"FileSystemError",G}t.$Kk=W;function A(G){if(!G)return U.Unknown;if(G instanceof z)return G.code;const K=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!K)return U.Unknown;switch(K[1]){case U.FileExists:return U.FileExists;case U.FileIsADirectory:return U.FileIsADirectory;case U.FileNotADirectory:return U.FileNotADirectory;case U.FileNotFound:return U.FileNotFound;case U.FileTooLarge:return U.FileTooLarge;case U.FileWriteLocked:return U.FileWriteLocked;case U.NoPermissions:return U.NoPermissions;case U.Unavailable:return U.Unavailable}return U.Unknown}t.$Lk=A;function P(G){if(G instanceof te)return G.fileOperationResult;switch(A(G)){case U.FileNotFound:return 1;case U.FileIsADirectory:return 0;case U.FileNotADirectory:return 9;case U.FileWriteLocked:return 5;case U.NoPermissions:return 6;case U.FileExists:return 4;case U.FileTooLarge:return 7;default:return 10}}t.$Mk=P;var L;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(L||(t.FileOperation=L={}));class Y{constructor(K,ie,fe){this.resource=K,this.operation=ie,this.target=fe}isOperation(K){return this.operation===K}}t.$Nk=Y;var X;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(X||(t.FileChangeType=X={}));class de{static{this.a=null}constructor(K,ie){this.c=ie,this.b=void 0,this.d=new M.$V(()=>{const fe=E.$ei.forUris(()=>this.c);return fe.fill(this.rawAdded.map(ye=>[ye,!0])),fe}),this.f=new M.$V(()=>{const fe=E.$ei.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(ye=>[ye,!0])),fe}),this.g=new M.$V(()=>{const fe=E.$ei.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(ye=>[ye,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of K){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==de.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(K,...ie){return this.h(K,{includeChildren:!1},...ie)}affects(K,...ie){return this.h(K,{includeChildren:!0},...ie)}h(K,ie,...fe){if(!K)return!1;const ye=fe.length>0;return!!((!ye||fe.includes(1))&&(this.d.value.get(K)||ie.includeChildren&&this.d.value.findSuperstr(K))||(!ye||fe.includes(0))&&(this.f.value.get(K)||ie.includeChildren&&this.f.value.findSuperstr(K))||(!ye||fe.includes(2))&&(this.g.value.findSubstr(K)||ie.includeChildren&&this.g.value.findSuperstr(K)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(K){return this.b===K}hasCorrelation(){return typeof this.b=="number"}}t.$Ok=de;function ue(G,K,ie){return!G||!K||G===K||K.length>G.length?!1:(K.charAt(K.length-1)!==T.sep&&(K+=T.sep),ie?(0,n.$ef)(G,K):G.indexOf(K)===0)}t.$Pk=ue;class te extends Error{constructor(K,ie,fe){super(K),this.fileOperationResult=ie,this.options=fe}}t.$Qk=te;class ge extends te{constructor(K,ie,fe,ye){super(K,ie,ye),this.fileOperationResult=ie,this.size=fe}}t.$Rk=ge;class Pe extends te{constructor(K,ie,fe){super(K,2,fe),this.stat=ie}}t.$Sk=Pe;var Ne;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ne||(t.FileOperationResult=Ne={})),t.$Tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Vk="files.associations",t.$Wk="files.exclude",t.$Xk="files.readonlyInclude",t.$Yk="files.readonlyExclude",t.$Zk="files.readonlyFromPermissions";var Be;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(t.FileKind=Be={})),t.$1k="";function le(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}t.$2k=le;async function J(G,K){if(!K.hasProvider(y.URI.from({scheme:G.scheme})))return new Promise(ie=>{const fe=K.onDidChangeFileSystemProviderRegistrations(ye=>{ye.scheme===G.scheme&&ye.added&&(fe.dispose(),ie())})})}t.$3k=J;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(K){return(0,H.$Qf)(K)||(K=0),K<ae.KB?(0,S.localize)(1,null,K.toFixed(0)):K<ae.MB?(0,S.localize)(2,null,(K/ae.KB).toFixed(2)):K<ae.GB?(0,S.localize)(3,null,(K/ae.MB).toFixed(2)):K<ae.TB?(0,S.localize)(4,null,(K/ae.GB).toFixed(2)):(0,S.localize)(5,null,(K/ae.TB).toFixed(2))}}t.$4k=ae;function re(G){const K=typeof G=="string"||G?.scheme===v.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===v.Schemas.file?1024*ae.MB:K?10*ae.MB:p.$o?50*ae.MB:1024*ae.MB}t.$5k=re}),define(be[139],pe([1,0,41]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T_b=t.$S_b=void 0,t.$S_b=(0,E.$$h)("mainProcessService");class T{constructor(H,y){this.a=H,this.b=y}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,y){this.a.registerChannel(H,y)}}t.$T_b=T}),define(be[140],pe([1,0,3,134]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U_b=void 0;class n extends E.$Tc{constructor(y){super(),this.a=this.B(new T.$cV(`window:${y}`))}getChannel(y){return this.a.getChannel(y)}registerChannel(y,S){this.a.registerChannel(y,S)}}t.$U_b=n});var Ei=this&&this.__param||function(se,t){return function(E,T){t(E,T,se)}};define(be[141],pe([1,0,67,139]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Y_b=void 0;let n=class{constructor(y,S){return this.windowId=y,E.ProxyChannel.toService(S.getChannel("nativeHost"),{context:y,properties:(()=>{const m=new Map;return m.set("windowId",y),m})()})}};t.$Y_b=n,t.$Y_b=n=Ye([Ei(1,T.$S_b)],n)}),define(be[68],pe([1,0,76,7]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nn=void 0;class n{constructor(){this.a=new Map}add(y,S){E.ok(T.$Mf(y)),E.ok(T.$Of(S)),E.ok(!this.a.has(y),"There is already an extension with this id"),this.a.set(y,S)}knows(y){return this.a.has(y)}as(y){return this.a.get(y)||null}}t.$Nn=new n}),define(be[142],pe([1,0,4,68]),function(se,t,E,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$On=void 0,t.$On={JSONContribution:"base.contributions.json"};function n(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class H{constructor(){this.b=new E.$Yd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,p){this.a[n(m)]=p,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const y=new H;T.$Nn.add(t.$On.JSONContribution,y)}),define(be[143],pe([1,0,9,17,18,4,7,15,136,142,68]),function(se,t,E,T,n,H,y,S,m,p,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jw=t.$Iw=t.$Hw=t.$Gw=t.$Fw=t.$Ew=t.$Dw=t.$Cw=t.IconFontDefinition=t.IconContribution=t.$Bw=void 0,t.$Bw={IconContribution:"base.contributions.icons"};var M;(function(d){function b(u,N){let B=u.defaults;for(;n.ThemeIcon.isThemeIcon(B);){const R=e.getIcon(B.id);if(!R)return;B=R.defaults}return B}d.getDefinition=b})(M||(t.IconContribution=M={}));var l;(function(d){function b(N){return{weight:N.weight,style:N.style,src:N.src.map(B=>({format:B.format,location:B.location.toString()}))}}d.toJSONObject=b;function u(N){const B=R=>(0,y.$Mf)(R)?R:void 0;if(N&&Array.isArray(N.src)&&N.src.every(R=>(0,y.$Mf)(R.format)&&(0,y.$Mf)(R.location)))return{weight:B(N.weight),style:B(N.style),src:N.src.map(R=>({format:R.format,location:S.URI.parse(R.location)}))}}d.fromJSONObject=u})(l||(t.IconFontDefinition=l={}));class h{constructor(){this.a=new H.$Yd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,u,N,B){const R=this.b[b];if(R){if(N&&!R.description){R.description=N,this.d.properties[b].markdownDescription=`${N} $(${b})`;const D=this.e.enum.indexOf(b);D!==-1&&(this.e.enumDescriptions[D]=N),this.a.fire()}return R}const U={id:b,description:N,defaults:u,deprecationMessage:B};this.b[b]=U;const z={$ref:"#/definitions/icons"};return B&&(z.deprecationMessage=B),N&&(z.markdownDescription=`${N}: $(${b})`),this.d.properties[b]=z,this.e.enum.push(b),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const u=this.e.enum.indexOf(b);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,u){const N=this.f[b];return N||(this.f[b]=u,this.a.fire(),u)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(R,U)=>R.id.localeCompare(U.id),u=R=>{for(;n.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const B=Object.keys(this.b).map(R=>this.b[R]);for(const R of B.filter(U=>!!U.description).sort(b))N.push(`|<i class="${u(R)}"></i>|${R.id}|${n.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const R of B.filter(U=>!n.ThemeIcon.isThemeIcon(U.defaults)).sort(b))N.push(`|<i class="${u(R)}"></i>|${R.id}|`);return N.join(`
`)}}const e=new h;v.$Nn.add(t.$Bw.IconContribution,e);function s(d,b,u,N){return e.registerIcon(d,b,u,N)}t.$Cw=s;function f(){return e}t.$Dw=f;function c(){const d=(0,T.$ck)();for(const b in d){const u="\\"+d[b].toString(16);e.registerIcon(b,{fontCharacter:u})}}c(),t.$Ew="vscode://schemas/icons";const a=v.$Nn.as(p.$On.JSONContribution);a.registerSchema(t.$Ew,e.getIconSchema());const $=new E.$kh(()=>a.notifySchemaChanged(t.$Ew),200);e.onDidChange(()=>{$.isScheduled()||$.schedule()}),t.$Fw=s("widget-close",T.$ek.close,(0,m.localize)(2,null)),t.$Gw=s("goto-previous-location",T.$ek.arrowUp,(0,m.localize)(3,null)),t.$Hw=s("goto-next-location",T.$ek.arrowDown,(0,m.localize)(4,null)),t.$Iw=n.ThemeIcon.modify(T.$ek.sync,"spin"),t.$Jw=n.ThemeIcon.modify(T.$ek.loading,"spin")}),define(be[144],pe([1,0,2,4,3,18,143]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eGb=t.$dGb=void 0;function S(p){const v=new n.$Sc,M=v.add(new T.$Yd),l=(0,y.$Dw)();return v.add(l.onDidChange(()=>M.fire())),p&&v.add(p.onDidProductIconThemeChange(()=>M.fire())),{dispose:()=>v.dispose(),onDidChange:M.event,getCSS(){const h=p?p.getProductIconTheme():new m,e={},s=c=>{const a=h.getIcon(c);if(!a)return;const $=a.font;return $?(e[$.id]=$.definition,`.codicon-${c.id}:before { content: '${a.fontCharacter}'; font-family: ${(0,E.$sR)($.id)}; }`):`.codicon-${c.id}:before { content: '${a.fontCharacter}'; }`},f=[];for(const c of l.getIcons()){const a=s(c);a&&f.push(a)}for(const c in e){const a=e[c],$=a.weight?`font-weight: ${a.weight};`:"",d=a.style?`font-style: ${a.style};`:"",b=a.src.map(u=>`${(0,E.$rR)(u.location)} format('${u.format}')`).join(", ");f.push(`@font-face { src: ${b}; font-family: ${(0,E.$sR)(c)};${$}${d} font-display: block; }`)}return f.join(`
`)}}}t.$dGb=S;class m{getIcon(v){const M=(0,y.$Dw)();let l=v.defaults;for(;H.ThemeIcon.isThemeIcon(l);){const h=M.getIcon(l.id);if(!h)return;l=h.defaults}return l}}t.$eGb=m}),define(be[145],pe([1,0,5]),function(se,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4C=t.$3C=t.$2C=t.$1C=t.$ZC=t.$YC=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$XC=t.$WC=t.$VC=t.$UC=t.$TC=t.$SC=void 0,t.$SC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function T(c){return typeof c.parentId=="number"}t.$TC=T;function n(c){return!!c.workspaceUri}t.$UC=n;function H(c){return!!c.folderUri}t.$VC=H;function y(c){return!!c.fileUri}t.$WC=y;function S(c){const a=l(c),$=c.getValue("window.menuBarVisibility");return $==="default"||a&&$==="compact"||E.$j&&E.$m?"classic":$}t.$XC=S;var m;(function(c){c.TITLE_BAR_STYLE="window.titleBarStyle",c.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(m||(t.TitleBarSetting=m={}));var p;(function(c){c.NATIVE="native",c.CUSTOM="custom"})(p||(t.TitlebarStyle=p={}));var v;(function(c){c.AUTO="auto",c.WINDOWED="windowed",c.NEVER="never"})(v||(t.CustomTitleBarVisibility=v={}));function M(c,a){return!0}t.$YC=M;function l(c,a){return a||(a=h(c)),a==="native"}t.$ZC=l;function h(c){if(E.$o)return"custom";const a=c.getValue("window");if(a){if(E.$j&&a.nativeTabs===!0||E.$j&&a.nativeFullScreen===!1)return"native";const b=a.titleBarStyle;if(b==="native"||b==="custom")return b}return E.$k?"native":"custom"}t.$1C=h;function e(c){return!(!E.$i||E.$o||l(c))}t.$2C=e;function s(c){const a=c.getValue("window");return!a||typeof a.nativeFullScreen!="boolean"||a.nativeTabs?!0:a.nativeFullScreen!==!1}t.$3C=s;function f(c=0){return Math.pow(1.2,c)}t.$4C=f}),define(be[146],pe([1,0,16,2,21,30,145]),function(se,t,E,T,n,H,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5_b=t.$4_b=t.$3_b=t.$2_b=t.$1_b=t.ApplyZoomTarget=void 0;var S;(function(l){l[l.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",l[l.ALL_WINDOWS=2]="ALL_WINDOWS"})(S||(t.ApplyZoomTarget=S={})),t.$1_b=8,t.$2_b=-8;function m(l,h){l=Math.min(Math.max(l,t.$2_b),t.$1_b);const e=[];h===S.ACTIVE_WINDOW?e.push((0,T.$RQ)()):h===S.ALL_WINDOWS?e.push(...Array.from((0,T.getWindows)()).map(({window:s})=>s)):e.push(h);for(const s of e)p(s)?.webFrame?.setZoomLevel(l),(0,E.$OP)((0,y.$4C)(l),s),(0,E.$KP)(l,s)}t.$3_b=m;function p(l){if(l===n.$FP)return{ipcRenderer:H.$O,webFrame:H.$Q};{const h=l;if(h?.vscode?.ipcRenderer&&h?.vscode?.webFrame)return h.vscode}}function v(l){m((0,E.$LP)(typeof l=="number"?(0,T.$RQ)():l)+1,l)}t.$4_b=v;function M(l){m((0,E.$LP)(typeof l=="number"?(0,T.$RQ)():l)-1,l)}t.$5_b=M}),define(be[147],pe([1,0,11,2,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(se,t,E,T,n,H,y,S,m,p,v,M,l,h,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const f=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,c=/\s--inspect-port=(?<port>\d+)/;class a{getHeight(A){return 22}getTemplateId(A){return U(A)?"process":B(A)?"machine":(0,m.$Pm)(A)?"error":R(A)?"header":""}}class ${hasChildren(A){return(0,m.$Pm)(A)?!1:U(A)?!!A.children?.length:!0}getChildren(A){return U(A)?A.children?A.children:[]:(0,m.$Pm)(A)?[]:R(A)?A.processRoots.length>1?A.processRoots:[A.processRoots[0].rootProcess]:B(A)?[A.rootProcess]:[A.processes]}}class d{constructor(){this.templateId="header"}renderTemplate(A){const P=(0,T.$bR)(A,(0,T.$)(".row")),L=(0,T.$bR)(P,(0,T.$)(".nameLabel")),Y=(0,T.$bR)(P,(0,T.$)(".cpu")),X=(0,T.$bR)(P,(0,T.$)(".memory")),de=(0,T.$bR)(P,(0,T.$)(".pid"));return{name:L,CPU:Y,memory:X,PID:de}}renderElement(A,P,L,Y){L.name.textContent=(0,E.localize)(0,null),L.CPU.textContent=(0,E.localize)(1,null),L.PID.textContent=(0,E.localize)(2,null),L.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(A){}}class b{constructor(){this.templateId="machine"}renderTemplate(A){const P=Object.create(null),L=(0,T.$bR)(A,(0,T.$)(".row"));return P.name=(0,T.$bR)(L,(0,T.$)(".nameLabel")),P}renderElement(A,P,L,Y){L.name.textContent=A.element.name}disposeTemplate(A){}}class u{constructor(){this.templateId="error"}renderTemplate(A){const P=Object.create(null),L=(0,T.$bR)(A,(0,T.$)(".row"));return P.name=(0,T.$bR)(L,(0,T.$)(".nameLabel")),P}renderElement(A,P,L,Y){L.name.textContent=A.element.errorMessage}disposeTemplate(A){}}class N{constructor(A,P,L){this.a=A,this.b=P,this.c=L,this.templateId="process"}renderTemplate(A){const P=(0,T.$bR)(A,(0,T.$)(".row")),L=(0,T.$bR)(P,(0,T.$)(".nameLabel")),Y=(0,T.$bR)(P,(0,T.$)(".cpu")),X=(0,T.$bR)(P,(0,T.$)(".memory")),de=(0,T.$bR)(P,(0,T.$)(".pid"));return{name:L,CPU:Y,PID:de,memory:X}}renderElement(A,P,L,Y){const{element:X}=A,de=X.pid.toFixed(0);let ue=X.name;this.c.has(X.pid)&&(ue=this.c.get(X.pid)),L.name.textContent=ue,L.name.title=X.cmd,L.CPU.textContent=X.load.toFixed(0),L.PID.textContent=de,L.PID.parentElement.id=`pid-${de}`;const te=this.a==="win32"?X.mem:this.b*(X.mem/100);L.memory.textContent=(te/p.$4k.MB).toFixed(0)}disposeTemplate(A){}}function B(W){return!!W.name&&!!W.rootProcess}function R(W){return!!W.processRoots}function U(W){return!!W.pid}class z{constructor(A,P){this.f=P,this.b=new Map;const L=new v.$U_b(A);this.c=new M.$Y_b(A,L),this.k(P.styles),this.g(P),S.$O.on("vscode:pidToNameResponse",(Y,X)=>{this.b.clear();for(const[de,ue]of X)this.b.set(de,ue)}),S.$O.on("vscode:listProcessesResponse",async(Y,X)=>{X.forEach((de,ue)=>{U(de.rootProcess)&&(de.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:X}}),this.d.layout(s.$FP.innerHeight,s.$FP.innerWidth)):await this.h(X),this.m(0)}),this.a=Date.now(),S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")}g(A){s.$FP.document.onkeydown=P=>{const L=A.platform==="darwin"?P.metaKey:P.ctrlKey;L&&P.keyCode===87&&(P.stopPropagation(),P.preventDefault(),S.$O.send("vscode:closeProcessExplorer")),L&&P.keyCode===187&&(0,h.$4_b)(s.$FP),L&&P.keyCode===189&&(0,h.$5_b)(s.$FP)}}async h(A){const P=s.$FP.document.getElementById("process-list");if(!P)return;const{totalmem:L}=await this.c.getOSStatistics(),Y=[new N(this.f.platform,L,this.b),new d,new b,new u];this.d=new n.$EU("processExplorer",P,new a,Y,new $,{identityProvider:{getId:X=>U(X)?X.pid.toString():(0,m.$Pm)(X)?X.hostName:R(X)?"processes":B(X)?X.name:"header"}}),this.d.setInput({processes:{processRoots:A}}),this.d.layout(s.$FP.innerHeight,s.$FP.innerWidth),this.d.onKeyDown(X=>{const de=new e.$0P(X);if(de.keyCode===35&&de.altKey){const ue=this.n();Promise.all(ue.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(X=>{U(X.element)&&this.l(X.element,!0)}),P.style.height=`${s.$FP.innerHeight}px`,s.$FP.addEventListener("resize",()=>{P.style.height=`${s.$FP.innerHeight}px`,this.d?.layout(s.$FP.innerHeight,s.$FP.innerWidth)})}i(A){const P=f.exec(A);return P&&P.groups.port!=="0"||A.indexOf("node ")>=0||A.indexOf("node.exe")>=0}j(A){const P={type:"node",request:"attach",name:`process ${A.pid}`};let L=f.exec(A.cmd);L?P.port=Number(L.groups.port):P.processId=String(A.pid),L=c.exec(A.cmd),L&&(P.port=Number(L.groups.port)),S.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[P]})}k(A){const P=(0,T.$VQ)(),L=[];A.listFocusBackground&&(L.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${A.listFocusBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${A.listFocusBackground}; }`)),A.listFocusForeground&&L.push(`.monaco-list:focus .monaco-list-row.focused { color: ${A.listFocusForeground}; }`),A.listActiveSelectionBackground&&(L.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${A.listActiveSelectionBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${A.listActiveSelectionBackground}; }`)),A.listActiveSelectionForeground&&L.push(`.monaco-list:focus .monaco-list-row.selected { color: ${A.listActiveSelectionForeground}; }`),A.listHoverBackground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${A.listHoverBackground}; }`),A.listHoverForeground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${A.listHoverForeground}; }`),A.listFocusOutline&&L.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${A.listFocusOutline}; outline-offset: -1px; }`),A.listHoverOutline&&L.push(`.monaco-list-row:hover { outline: 1px dashed ${A.listHoverOutline}; outline-offset: -1px; }`),A.scrollbarShadowColor&&L.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${A.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${A.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${A.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),A.scrollbarSliderBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${A.scrollbarSliderBackgroundColor};
				}
			`),A.scrollbarSliderHoverBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${A.scrollbarSliderHoverBackgroundColor};
				}
			`),A.scrollbarSliderActiveBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${A.scrollbarSliderActiveBackgroundColor};
				}
			`),P.textContent=L.join(`
`),A.color&&(s.$FP.document.body.style.color=A.color)}l(A,P){const L=[],Y=Number(A.pid);P&&(L.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.c.killProcess(Y,"SIGTERM")}}),L.push({label:(0,E.localize)(5,null),click:()=>{this.c.killProcess(Y,"SIGKILL")}}),L.push({type:"separator"})),L.push({label:(0,E.localize)(6,null),click:()=>{const X=this.n();X?.includes(Y)||(X.length=0,X.push(Y));const de=X?.map(ue=>s.$FP.document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(de){const ue=de.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(ue.join(`
`))}}}),L.push({label:(0,E.localize)(7,null),click:()=>{const X=s.$FP.document.getElementById("process-list");X&&this.c.writeClipboardText(X.innerText)}}),A&&P&&this.i(A.cmd)&&(L.push({type:"separator"}),L.push({label:(0,E.localize)(8,null),click:()=>{this.j(A)}})),(0,y.$7U)(L)}m(A){setTimeout(()=>{const P=Date.now(),L=A+P-this.a;this.a=P,L>1e3?(S.$O.send("vscode:pidToNameRequest"),S.$O.send("vscode:listProcesses")):this.m(L)},200)}n(){return this.d?.getSelection()?.map(A=>{if(!(!A||!("pid"in A)))return A.pid}).filter(A=>!!A)}}function D(){const W=(0,T.$VQ)();W.id="codiconStyles";const A=(0,l.$dGb)(void 0);function P(){W.textContent=A.getCSS()}const L=new H.$kh(P,0);A.onDidChange(()=>L.schedule()),L.schedule()}function O(W){const A=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";s.$FP.document.body.classList.add(A),D(),(0,h.$3_b)(W.data.zoomLevel,s.$FP),new z(W.windowId,W.data)}t.startup=O})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4f2ff19ecacffa0aa4874db4d63ed4e899d98431/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
