/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","vs/base/common/htmlContent","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(me){for(var e=[],I=0,F=me.length;I<F;I++)e[I]=Ce[me[I]];return e};define(Ce[158],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const $=new Map,L=new Map,A=new Map,v=new Map;function p(E,S){E.has(S.detail)||E.set(S.detail,-S.timestamp)}function k(E,S){const l=E.get(S.detail);l&&(l>=0||E.set(S.detail,l+S.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((E,S)=>E.timestamp-S.timestamp));for(const E of R)switch(E.type){case 10:p($,E);break;case 11:case 12:k($,E);break;case 21:p(L,E);break;case 22:k(L,E);break;case 33:p(A,E);break;case 34:k(A,E);break;case 31:p(v,E);break;case 32:k(v,E);break}let C=0;A.forEach(E=>C+=E);function m(E){const S=[];return E.forEach((l,w)=>S.push([w,l])),S}return{amdLoad:m($),amdInvoke:m(L),nodeRequire:m(A),nodeEval:m(v),nodeRequireTotal:C}}static toMarkdownTable($,L){let A="";const v=[];return $.forEach((p,k)=>{v[k]=p.length}),L.forEach(p=>{p.forEach((k,R)=>{typeof k>"u"&&(k=p[R]="-");const C=k.toString().length;v[R]=Math.max(C,v[R])})}),$.forEach((p,k)=>{A+=`| ${p+" ".repeat(v[k]-p.toString().length)} `}),A+=`|
`,$.forEach((p,k)=>{A+=`| ${"-".repeat(v[k])} `}),A+=`|
`,L.forEach(p=>{p.forEach((k,R)=>{typeof k<"u"&&(A+=`| ${k+" ".repeat(v[R]-k.toString().length)} `)}),A+=`|
`}),A}}e.$U=I}),define(Ce[159],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function I(l,w,s){const i=F(l,w);if(i!==-1)return l[i]}e.$fb=I;function F(l,w,s=l.length-1){for(let i=s;i>=0;i--){const n=l[i];if(w(n))return i}return-1}e.$gb=F;function $(l,w){const s=L(l,w);return s===-1?void 0:l[s]}e.$hb=$;function L(l,w,s=0,i=l.length){let n=s,r=i;for(;n<r;){const a=Math.floor((n+r)/2);w(l[a])?n=a+1:r=a}return n-1}e.$ib=L;function A(l,w){const s=v(l,w);return s===l.length?void 0:l[s]}e.$jb=A;function v(l,w,s=0,i=l.length){let n=s,r=i;for(;n<r;){const a=Math.floor((n+r)/2);w(l[a])?r=a:n=a+1}return n}e.$kb=v;function p(l,w,s=0,i=l.length){const n=v(l,w,s,i);return n===l.length?-1:n}e.$lb=p;class k{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(k.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!w(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const s=L(this.e,w,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$mb=k;function R(l,w){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];w(n,s)>0&&(s=n)}return s}e.$nb=R;function C(l,w){if(l.length===0)return;let s=l[0];for(let i=1;i<l.length;i++){const n=l[i];w(n,s)>=0&&(s=n)}return s}e.$ob=C;function m(l,w){return R(l,(s,i)=>-w(s,i))}e.$pb=m;function E(l,w){if(l.length===0)return-1;let s=0;for(let i=1;i<l.length;i++){const n=l[i];w(n,l[s])>0&&(s=i)}return s}e.$qb=E;function S(l,w){for(const s of l){const i=w(s);if(i!==void 0)return i}}e.$rb=S}),define(Ce[74],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function I(A,v){const p=Object.create(null);for(const k of A){const R=v(k);let C=p[R];C||(C=p[R]=[]),C.push(k)}return p}e.$K=I;function F(A,v){const p=[],k=[];for(const R of A)v.has(R)||p.push(R);for(const R of v)A.has(R)||k.push(R);return{removed:p,added:k}}e.$L=F;function $(A,v){const p=[],k=[];for(const[R,C]of A)v.has(R)||p.push(C);for(const[R,C]of v)A.has(R)||k.push(C);return{removed:p,added:k}}e.$M=$;function L(A,v){const p=new Set;for(const k of v)A.has(k)&&p.add(k);return p}e.$N=L}),define(Ce[52],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function I(A){return(v,p,k)=>{let R=null,C=null;if(typeof k.value=="function"?(R="value",C=k.value):typeof k.get=="function"&&(R="get",C=k.get),!C)throw new Error("not supported");k[R]=A(C,p)}}function F(A,v,p){let k=null,R=null;if(typeof p.value=="function"?(k="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(k="get",R=p.get),!R)throw new Error("not supported");const C=`$memoize$${v}`;p[k]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[C]}}e.$Ch=F;function $(A,v,p){return I((k,R)=>{const C=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...E){this[m]||(this[m]=p?p():void 0),clearTimeout(this[C]),v&&(this[m]=v(this[m],...E),E=[this[m]]),this[C]=setTimeout(()=>{k.apply(this,E),this[m]=p?p():void 0},A)}})}e.$Dh=$;function L(A,v,p){return I((k,R)=>{const C=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,S=`$throttle$pending$${R}`;return function(...l){if(this[m]||(this[m]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),v&&(this[m]=v(this[m],...l)),this[S])return;const w=this[E]+A;w<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[m]]),this[m]=p?p():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[E]=Date.now(),k.apply(this,[this[m]]),this[m]=p?p():void 0},w-Date.now()))}})}e.$Eh=L}),define(Ce[14],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(h=>{h(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=I,e.$X=new I;function F(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=F;function $(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=$;function L(a){k(a)||e.$X.onUnexpectedError(a)}e.$1=L;function A(a){k(a)||e.$X.onUnexpectedExternalError(a)}e.$2=A;function v(a){if(a instanceof Error){const{name:t,message:h}=a,c=a.stacktrace||a.stack;return{$isError:!0,name:t,message:h,stack:c,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$3=v;const p="Canceled";function k(a){return a instanceof R?!0:a instanceof Error&&a.name===p&&a.message===p}e.$4=k;class R extends Error{constructor(){super(p),this.name=this.message}}e.$5=R;function C(){const a=new Error(p);return a.name=a.message,a}e.$6=C;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=m;function E(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=E;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function l(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=l;class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const h=new n;return h.message=t.message,h.stack=t.stack,h}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(Ce[19],Ie([1,0,14,159]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function $(le,de=0){return le[le.length-(1+de)]}e.$sb=$;function L(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}e.$tb=L;function A(le,de,ue=(ge,V)=>ge===V){if(le===de)return!0;if(!le||!de||le.length!==de.length)return!1;for(let ge=0,V=le.length;ge<V;ge++)if(!ue(le[ge],de[ge]))return!1;return!0}e.$ub=A;function v(le,de){const ue=le.length-1;de<ue&&(le[de]=le[ue]),le.pop()}e.$vb=v;function p(le,de,ue){return k(le.length,ge=>ue(le[ge],de))}e.$wb=p;function k(le,de){let ue=0,ge=le-1;for(;ue<=ge;){const V=(ue+ge)/2|0,Z=de(V);if(Z<0)ue=V+1;else if(Z>0)ge=V-1;else return V}return-(ue+1)}e.$xb=k;function R(le,de,ue){if(le=le|0,le>=de.length)throw new TypeError("invalid index");const ge=de[Math.floor(de.length*Math.random())],V=[],Z=[],he=[];for(const be of de){const Pe=ue(be,ge);Pe<0?V.push(be):Pe>0?Z.push(be):he.push(be)}return le<V.length?R(le,V,ue):le<V.length+he.length?he[0]:R(le-(V.length+he.length),Z,ue)}e.$yb=R;function C(le,de){const ue=[];let ge;for(const V of le.slice(0).sort(de))!ge||de(ge[0],V)!==0?(ge=[V],ue.push(ge)):ge.push(V);return ue}e.$zb=C;function*m(le,de){let ue,ge;for(const V of le)ge!==void 0&&de(ge,V)?ue.push(V):(ue&&(yield ue),ue=[V]),ge=V;ue&&(yield ue)}e.$Ab=m;function E(le,de){for(let ue=0;ue<=le.length;ue++)de(ue===0?void 0:le[ue-1],ue===le.length?void 0:le[ue])}e.$Bb=E;function S(le,de){for(let ue=0;ue<le.length;ue++)de(ue===0?void 0:le[ue-1],le[ue],ue+1===le.length?void 0:le[ue+1])}e.$Cb=S;function l(le,de,ue){const ge=[];function V(be,Pe,pe){if(Pe===0&&pe.length===0)return;const Le=ge[ge.length-1];Le&&Le.start+Le.deleteCount===be?(Le.deleteCount+=Pe,Le.toInsert.push(...pe)):ge.push({start:be,deleteCount:Pe,toInsert:pe})}let Z=0,he=0;for(;;){if(Z===le.length){V(Z,0,de.slice(he));break}if(he===de.length){V(Z,le.length-Z,[]);break}const be=le[Z],Pe=de[he],pe=ue(be,Pe);pe===0?(Z+=1,he+=1):pe<0?(V(Z,1,[]),Z+=1):pe>0&&(V(Z,0,[Pe]),he+=1)}return ge}e.$Db=l;function w(le,de,ue){const ge=l(le,de,ue),V=[],Z=[];for(const he of ge)V.push(...le.slice(he.start,he.start+he.deleteCount)),Z.push(...he.toInsert);return{removed:V,added:Z}}e.$Eb=w;function s(le,de,ue){if(ue===0)return[];const ge=le.slice(0,ue).sort(de);return n(le,de,ge,ue,le.length),ge}e.top=s;function i(le,de,ue,ge,V){return ue===0?Promise.resolve([]):new Promise((Z,he)=>{(async()=>{const be=le.length,Pe=le.slice(0,ue).sort(de);for(let pe=ue,Le=Math.min(ue+ge,be);pe<be;pe=Le,Le=Math.min(Le+ge,be)){if(pe>ue&&await new Promise(Me=>setTimeout(Me)),V&&V.isCancellationRequested)throw new I.$5;n(le,de,Pe,pe,Le)}return Pe})().then(Z,he)})}e.$Gb=i;function n(le,de,ue,ge,V){for(const Z=ue.length;ge<V;ge++){const he=le[ge];if(de(he,ue[Z-1])<0){ue.pop();const be=(0,F.$kb)(ue,Pe=>de(he,Pe)<0);ue.splice(be,0,he)}}}function r(le){return le.filter(de=>!!de)}e.$Hb=r;function a(le){let de=0;for(let ue=0;ue<le.length;ue++)le[ue]&&(le[de]=le[ue],de+=1);le.length=de}e.$Ib=a;function t(le,de,ue){le.splice(ue,0,le.splice(de,1)[0])}e.$Jb=t;function h(le){return!Array.isArray(le)||le.length===0}e.$Kb=h;function c(le){return Array.isArray(le)&&le.length>0}e.$Lb=c;function o(le,de=ue=>ue){const ue=new Set;return le.filter(ge=>{const V=de(ge);return ue.has(V)?!1:(ue.add(V),!0)})}e.$Mb=o;function u(le){const de=new Set;return ue=>{const ge=le(ue);return de.has(ge)?!1:(de.add(ge),!0)}}e.$Nb=u;function d(le,de){return le.length>0?le[0]:de}e.$Ob=d;function b(le,de){return le.length>0?le[le.length-1]:de}e.$Pb=b;function D(le,de,ue=(ge,V)=>ge===V){let ge=0;for(let V=0,Z=Math.min(le.length,de.length);V<Z&&ue(le[V],de[V]);V++)ge++;return ge}e.$Qb=D;function g(le){return[].concat(...le)}e.$Rb=g;function f(le,de){let ue=typeof de=="number"?le:0;typeof de=="number"?ue=le:(ue=0,de=le);const ge=[];if(ue<=de)for(let V=ue;V<de;V++)ge.push(V);else for(let V=ue;V>de;V--)ge.push(V);return ge}e.$Sb=f;function y(le,de,ue){return le.reduce((ge,V)=>(ge[de(V)]=ue?ue(V):V,ge),Object.create(null))}e.$Tb=y;function P(le,de){return le.push(de),()=>T(le,de)}e.$Ub=P;function T(le,de){const ue=le.indexOf(de);if(ue>-1)return le.splice(ue,1),de}e.$Vb=T;function U(le,de,ue){const ge=le.slice(0,de),V=le.slice(de);return ge.concat(ue,V)}e.$Wb=U;function z(le,de){let ue;if(typeof de=="number"){let ge=de;ue=()=>{const V=Math.sin(ge++)*179426549;return V-Math.floor(V)}}else ue=Math.random;for(let ge=le.length-1;ge>0;ge-=1){const V=Math.floor(ue()*(ge+1)),Z=le[ge];le[ge]=le[V],le[V]=Z}}e.$Xb=z;function M(le,de){const ue=le.indexOf(de);ue>-1&&(le.splice(ue,1),le.unshift(de))}e.$Yb=M;function N(le,de){const ue=le.indexOf(de);ue>-1&&(le.splice(ue,1),le.push(de))}e.$Zb=N;function O(le,de){for(const ue of de)le.push(ue)}e.$1b=O;function j(le,de){return Array.isArray(le)?le.map(de):de(le)}e.$2b=j;function Y(le){return Array.isArray(le)?le:[le]}e.$3b=Y;function ne(le){return le[Math.floor(Math.random()*le.length)]}e.$4b=ne;function ee(le,de,ue){const ge=X(le,de),V=le.length,Z=ue.length;le.length=V+Z;for(let he=V-1;he>=ge;he--)le[he+Z]=le[he];for(let he=0;he<Z;he++)le[he+ge]=ue[he]}e.$5b=ee;function Q(le,de,ue,ge){const V=X(le,de);let Z=le.splice(V,ue);return Z===void 0&&(Z=[]),ee(le,V,ge),Z}e.$6b=Q;function X(le,de){return de<0?Math.max(de+le.length,0):Math.min(de,le.length)}var ce;(function(le){function de(Z){return Z<0}le.isLessThan=de;function ue(Z){return Z<=0}le.isLessThanOrEqual=ue;function ge(Z){return Z>0}le.isGreaterThan=ge;function V(Z){return Z===0}le.isNeitherLessOrGreaterThan=V,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function ie(le,de){return(ue,ge)=>de(le(ue),le(ge))}e.$7b=ie;function fe(...le){return(de,ue)=>{for(const ge of le){const V=ge(de,ue);if(!ce.isNeitherLessOrGreaterThan(V))return V}return ce.neitherLessOrGreaterThan}}e.$8b=fe;const re=(le,de)=>le-de;e.$9b=re;const J=(le,de)=>(0,e.$9b)(le?1:0,de?1:0);e.$0b=J;function B(le){return(de,ue)=>-le(de,ue)}e.$$b=B;class ae{constructor(de){this.g=de,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(de){let ue=this.c;for(;ue<this.g.length&&de(this.g[ue]);)ue++;const ge=ue===this.c?null:this.g.slice(this.c,ue);return this.c=ue,ge}takeFromEndWhile(de){let ue=this.d;for(;ue>=0&&de(this.g[ue]);)ue--;const ge=ue===this.d?null:this.g.slice(ue+1,this.d+1);return this.d=ue,ge}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const de=this.g[this.c];return this.c++,de}removeLast(){const de=this.g[this.d];return this.d--,de}takeCount(de){const ue=this.g.slice(this.c,this.c+de);return this.c+=de,ue}}e.$_b=ae;class Ee{static{this.empty=new Ee(de=>{})}constructor(de){this.iterate=de}forEach(de){this.iterate(ue=>(de(ue),!0))}toArray(){const de=[];return this.iterate(ue=>(de.push(ue),!0)),de}filter(de){return new Ee(ue=>this.iterate(ge=>de(ge)?ue(ge):!0))}map(de){return new Ee(ue=>this.iterate(ge=>ue(de(ge))))}some(de){let ue=!1;return this.iterate(ge=>(ue=de(ge),!ue)),ue}findFirst(de){let ue;return this.iterate(ge=>de(ge)?(ue=ge,!1):!0),ue}findLast(de){let ue;return this.iterate(ge=>(de(ge)&&(ue=ge),!0)),ue}findLastMaxBy(de){let ue,ge=!0;return this.iterate(V=>((ge||ce.isGreaterThan(de(V,ue)))&&(ge=!1,ue=V),!0)),ue}}e.$ac=Ee}),define(Ce[61],Ie([1,0,14]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function F(k,R){if(!k)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=F;function $(k,R="Unreachable"){throw new Error(R)}e.$9c=$;function L(k){if(!k)throw new I.$cb("Assertion Failed")}e.$0c=L;function A(k){k||(0,I.$1)(new I.$cb("Assertion Failed"))}e.$$c=A;function v(k){if(!k()){debugger;k(),(0,I.$1)(new I.$cb("Assertion Failed"))}}e.$_c=v;function p(k,R){let C=0;for(;C<k.length-1;){const m=k[C],E=k[C+1];if(!R(m,E))return!1;C++}return!0}e.$ad=p}),define(Ce[75],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function I(F,$){const L=this;let A=!1,v;return function(){if(A)return v;if(A=!0,$)try{v=F.apply(L,arguments)}finally{$()}else v=F.apply(L,arguments);return v}}e.$db=I}),define(Ce[121],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=void 0;class I{constructor($){this.a=$,this.b=0}nextId(){return this.a+ ++this.b}}e.$ON=I,e.$PN=new I("id#")}),define(Ce[53],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(F){function $(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}F.is=$;const L=Object.freeze([]);function A(){return L}F.empty=A;function*v(t){yield t}F.single=v;function p(t){return $(t)?t:v(t)}F.wrap=p;function k(t){return t||L}F.from=k;function*R(t){for(let h=t.length-1;h>=0;h--)yield t[h]}F.reverse=R;function C(t){return!t||t[Symbol.iterator]().next().done===!0}F.isEmpty=C;function m(t){return t[Symbol.iterator]().next().value}F.first=m;function E(t,h){for(const c of t)if(h(c))return!0;return!1}F.some=E;function S(t,h){for(const c of t)if(h(c))return c}F.find=S;function*l(t,h){for(const c of t)h(c)&&(yield c)}F.filter=l;function*w(t,h){let c=0;for(const o of t)yield h(o,c++)}F.map=w;function*s(...t){for(const h of t)yield*h}F.concat=s;function i(t,h,c){let o=c;for(const u of t)o=h(o,u);return o}F.reduce=i;function*n(t,h,c=t.length){for(h<0&&(h+=t.length),c<0?c+=t.length:c>t.length&&(c=t.length);h<c;h++)yield t[h]}F.slice=n;function r(t,h=Number.POSITIVE_INFINITY){const c=[];if(h===0)return[c,t];const o=t[Symbol.iterator]();for(let u=0;u<h;u++){const d=o.next();if(d.done)return[c,F.empty()];c.push(d.value)}return[c,{[Symbol.iterator](){return o}}]}F.consume=r;async function a(t){const h=[];for await(const c of t)h.push(c);return Promise.resolve(h)}F.asyncToArray=a})(I||(e.Iterable=I={}))}),define(Ce[160],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var $;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})($||(e.ParseErrorCode=$={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,h=!1){let c=0;const o=t.length;let u="",d=0,b=16,D=0;function g(M){let N=0,O=0;for(;N<M;){const j=t.charCodeAt(c);if(j>=48&&j<=57)O=O*16+j-48;else if(j>=65&&j<=70)O=O*16+j-65+10;else if(j>=97&&j<=102)O=O*16+j-97+10;else break;c++,N++}return N<M&&(O=-1),O}function f(M){c=M,u="",d=0,b=16,D=0}function y(){const M=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&k(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&k(t.charCodeAt(c)))for(c++;c<t.length&&k(t.charCodeAt(c));)c++;else return D=3,t.substring(M,c);let N=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&k(t.charCodeAt(c))){for(c++;c<t.length&&k(t.charCodeAt(c));)c++;N=c}else D=3;return t.substring(M,N)}function P(){let M="",N=c;for(;;){if(c>=o){M+=t.substring(N,c),D=2;break}const O=t.charCodeAt(c);if(O===34){M+=t.substring(N,c),c++;break}if(O===92){if(M+=t.substring(N,c),c++,c>=o){D=2;break}switch(t.charCodeAt(c++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const Y=g(4);Y>=0?M+=String.fromCharCode(Y):D=4;break}default:D=5}N=c;continue}if(O>=0&&O<=31)if(p(O)){M+=t.substring(N,c),D=2;break}else D=6;c++}return M}function T(){if(u="",D=0,d=c,c>=o)return d=o,b=17;let M=t.charCodeAt(c);if(v(M)){do c++,u+=String.fromCharCode(M),M=t.charCodeAt(c);while(v(M));return b=15}if(p(M))return c++,u+=String.fromCharCode(M),M===13&&t.charCodeAt(c)===10&&(c++,u+=`
`),b=14;switch(M){case 123:return c++,b=1;case 125:return c++,b=2;case 91:return c++,b=3;case 93:return c++,b=4;case 58:return c++,b=6;case 44:return c++,b=5;case 34:return c++,u=P(),b=10;case 47:{const N=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<o&&!p(t.charCodeAt(c));)c++;return u=t.substring(N,c),b=12}if(t.charCodeAt(c+1)===42){c+=2;const O=o-1;let j=!1;for(;c<O;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,j=!0;break}c++}return j||(c++,D=1),u=t.substring(N,c),b=13}return u+=String.fromCharCode(M),c++,b=16}case 45:if(u+=String.fromCharCode(M),c++,c===o||!k(t.charCodeAt(c)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=y(),b=11;default:for(;c<o&&U(M);)c++,M=t.charCodeAt(c);if(d!==c){switch(u=t.substring(d,c),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode(M),c++,b=16}}function U(M){if(v(M)||p(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let M;do M=T();while(M>=12&&M<=15);return M}return{setPosition:f,getPosition:()=>c,scan:h?z:T,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>d,getTokenLength:()=>c-d,getTokenError:()=>D}}e.$gn=A;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function C(t,h){const c=[],o=new Object;let u;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function D(g,f,y,P){d.value=g,d.offset=f,d.length=y,d.type=P,d.colonOffset=void 0,u=d}try{n(t,{onObjectBegin:(g,f)=>{if(h<=g)throw o;u=void 0,b=h>g,c.push("")},onObjectProperty:(g,f,y)=>{if(h<f||(D(g,f,y,"property"),c[c.length-1]=g,h<=f+y))throw o},onObjectEnd:(g,f)=>{if(h<=g)throw o;u=void 0,c.pop()},onArrayBegin:(g,f)=>{if(h<=g)throw o;u=void 0,c.push(0)},onArrayEnd:(g,f)=>{if(h<=g)throw o;u=void 0,c.pop()},onLiteralValue:(g,f,y)=>{if(h<f||(D(g,f,y,a(g)),h<=f+y))throw o},onSeparator:(g,f,y)=>{if(h<=f)throw o;if(g===":"&&u&&u.type==="property")u.colonOffset=f,b=!1,u=void 0;else if(g===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(b=!0,c[c.length-1]=""),u=void 0}}})}catch(g){if(g!==o)throw g}return{path:c,previousNode:u,isAtPropertyKey:b,matches:g=>{let f=0;for(let y=0;f<g.length&&y<c.length;y++)if(g[f]===c[y]||g[f]==="*")f++;else if(g[f]!=="**")return!1;return f===g.length}}}e.$hn=C;function m(t,h=[],c=L.DEFAULT){let o=null,u=[];const d=[];function b(g){Array.isArray(u)?u.push(g):o!==null&&(u[o]=g)}return n(t,{onObjectBegin:()=>{const g={};b(g),d.push(u),u=g,o=null},onObjectProperty:g=>{o=g},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const g=[];b(g),d.push(u),u=g,o=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:b,onError:(g,f,y)=>{h.push({error:g,offset:f,length:y})}},c),u[0]}e.$in=m;function E(t,h=[],c=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(g){o.type==="property"&&(o.length=g-o.offset,o=o.parent)}function d(g){return o.children.push(g),g}n(t,{onObjectBegin:g=>{o=d({type:"object",offset:g,length:-1,parent:o,children:[]})},onObjectProperty:(g,f,y)=>{o=d({type:"property",offset:f,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:g,offset:f,length:y,parent:o})},onObjectEnd:(g,f)=>{o.length=g+f-o.offset,o=o.parent,u(g+f)},onArrayBegin:(g,f)=>{o=d({type:"array",offset:g,length:-1,parent:o,children:[]})},onArrayEnd:(g,f)=>{o.length=g+f-o.offset,o=o.parent,u(g+f)},onLiteralValue:(g,f,y)=>{d({type:a(g),offset:f,length:y,parent:o,value:g}),u(f+y)},onSeparator:(g,f,y)=>{o.type==="property"&&(g===":"?o.colonOffset=f:g===","&&u(f))},onError:(g,f,y)=>{h.push({error:g,offset:f,length:y})}},c);const D=o.children[0];return D&&delete D.parent,D}e.$jn=E;function S(t,h){if(!t)return;let c=t;for(const o of h)if(typeof o=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let u=!1;for(const d of c.children)if(Array.isArray(d.children)&&d.children[0].value===o){c=d.children[1],u=!0;break}if(!u)return}else{const u=o;if(c.type!=="array"||u<0||!Array.isArray(c.children)||u>=c.children.length)return;c=c.children[u]}return c}e.$kn=S;function l(t){if(!t.parent||!t.parent.children)return[];const h=l(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;h.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&h.push(c)}return h}e.$ln=l;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const h=Object.create(null);for(const c of t.children){const o=c.children[1];o&&(h[c.children[0].value]=w(o))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$mn=w;function s(t,h,c=!1){return h>=t.offset&&h<t.offset+t.length||c&&h===t.offset+t.length}e.$nn=s;function i(t,h,c=!1){if(s(t,h,c)){const o=t.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=h;u++){const d=i(o[u],h,c);if(d)return d}return t}}e.$on=i;function n(t,h,c=L.DEFAULT){const o=A(t,!1);function u(ie){return ie?()=>ie(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(ie){return ie?fe=>ie(fe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const b=u(h.onObjectBegin),D=d(h.onObjectProperty),g=u(h.onObjectEnd),f=u(h.onArrayBegin),y=u(h.onArrayEnd),P=d(h.onLiteralValue),T=d(h.onSeparator),U=u(h.onComment),z=d(h.onError),M=c&&c.disallowComments,N=c&&c.allowTrailingComma;function O(){for(;;){const ie=o.scan();switch(o.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:M||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ie){case 12:case 13:M?j(10):U();break;case 16:j(1);break;case 15:case 14:break;default:return ie}}}function j(ie,fe=[],re=[]){if(z(ie),fe.length+re.length>0){let J=o.getToken();for(;J!==17;){if(fe.indexOf(J)!==-1){O();break}else if(re.indexOf(J)!==-1)break;J=O()}}}function Y(ie){const fe=o.getTokenValue();return ie?P(fe):D(fe),O(),!0}function ne(){switch(o.getToken()){case 11:{let ie=0;try{ie=JSON.parse(o.getTokenValue()),typeof ie!="number"&&(j(2),ie=0)}catch{j(2)}P(ie);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function ee(){return o.getToken()!==10?(j(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(T(":"),O(),ce()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Q(){b(),O();let ie=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ie||j(4,[],[]),T(","),O(),o.getToken()===2&&N)break}else ie&&j(6,[],[]);ee()||j(4,[],[2,5]),ie=!0}return g(),o.getToken()!==2?j(7,[2],[]):O(),!0}function X(){f(),O();let ie=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ie||j(4,[],[]),T(","),O(),o.getToken()===4&&N)break}else ie&&j(6,[],[]);ce()||j(4,[],[4,5]),ie=!0}return y(),o.getToken()!==4?j(8,[4],[]):O(),!0}function ce(){switch(o.getToken()){case 3:return X();case 1:return Q();case 10:return Y(!0);default:return ne()}}return O(),o.getToken()===17?c.allowEmptyContent?!0:(j(4,[],[]),!1):ce()?(o.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.$pn=n;function r(t,h){const c=A(t),o=[];let u,d=0,b;do switch(b=c.getPosition(),u=c.scan(),u){case 12:case 13:case 17:d!==b&&o.push(t.substring(d,b)),h!==void 0&&o.push(c.getTokenValue().replace(/[^\r\n]/g,h)),d=c.getPosition();break}while(u!==17);return o.join("")}e.$qn=r;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$rn=a}),define(Ce[43],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor($){this.d=$,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch($){this.c=$}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(Ce[76],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(L){this.element=L,this.next=I.Undefined,this.prev=I.Undefined}}class F{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let L=this.a;for(;L!==I.Undefined;){const A=L.next;L.prev=I.Undefined,L.next=I.Undefined,L=A}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const v=new I(L);if(this.a===I.Undefined)this.a=v,this.b=v;else if(A){const k=this.b;this.b=v,v.prev=k,k.next=v}else{const k=this.a;this.a=v,v.next=k,k.prev=v}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(v))}}shift(){if(this.a!==I.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==I.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==I.Undefined&&L.next!==I.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===I.Undefined&&L.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):L.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):L.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==I.Undefined;)yield L.element,L=L.next}}e.$4c=F}),define(Ce[28],Ie([1,0]),function(me,e){"use strict";var I,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(n,r,a){let t=n.get(r);return t===void 0&&(t=a,n.set(r,t)),t}e.$xc=L;function A(n){const r=[];return n.forEach((a,t)=>{r.push(`${t} => ${a}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.$yc=A;function v(n){const r=[];return n.forEach(a=>{r.push(a)}),`Set(${n.size}) {${r.join(", ")}}`}e.$zc=v;class p{constructor(r,a){this.uri=r,this.value=a}}function k(n){return Array.isArray(n)}class R{static{this.c=r=>r.toString()}constructor(r,a){if(this[I]="ResourceMap",r instanceof R)this.d=new Map(r.d),this.e=a??R.c;else if(k(r)){this.d=new Map,this.e=a??R.c;for(const[t,h]of r)this.set(t,h)}else this.d=new Map,this.e=r??R.c}set(r,a){return this.d.set(this.e(r),new p(r,a)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,a){typeof a<"u"&&(r=r.bind(a));for(const[t,h]of this.d)r(h.value,h.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Ac=R;class C{constructor(r,a){this[F]="ResourceSet",!r||typeof r=="function"?this.c=new R(r):(this.c=new R(a),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,a){this.c.forEach((t,h)=>r.call(a,h,h,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var m;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class E{constructor(){this[$]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,a=0){const t=this.c.get(r);if(t)return a!==0&&this.l(t,a),t.value}set(r,a,t=0){let h=this.c.get(r);if(h)h.value=a,t!==0&&this.l(h,t);else{switch(h={key:r,value:a,next:void 0,previous:void 0},t){case 0:this.j(h);break;case 1:this.i(h);break;case 2:this.j(h);break;default:this.j(h);break}this.c.set(r,h),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this.c.get(r);if(a)return this.c.delete(r),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,a){const t=this.g;let h=this.d;for(;h;){if(a?r.bind(a)(h.value,h.key,this):r(h.value,h.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const r=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:t.key,done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return h}values(){const r=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:t.value,done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return h}entries(){const r=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:[t.key,t.value],done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return h}[($=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>r;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const a=r.next,t=r.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}r.next=void 0,r.previous=void 0,this.g++}l(r,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this.d)return;const t=r.next,h=r.previous;r===this.e?(h.next=void 0,this.e=h):(t.previous=h,h.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(a===2){if(r===this.e)return;const t=r.next,h=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=h,h.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((a,t)=>{r.push([t,a])}),r}fromJSON(r){this.clear();for(const[a,t]of r)this.set(a,t)}}e.$Cc=E;class S extends E{constructor(r,a=1){super(),this.m=r,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class l{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let a=this.c.get(r)||0;return a===0?!1:(a--,a===0?this.c.delete(r):this.c.set(r,a),!0)}has(r){return this.c.has(r)}}e.$Ec=l;class w{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[a,t]of r)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(r,a){this.c.set(r,a),this.d.set(a,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const a=this.c.get(r);return a===void 0?!1:(this.c.delete(r),this.d.delete(a),!0)}forEach(r,a){this.c.forEach((t,h)=>{r.call(a,t,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class s{constructor(){this.c=new Map}add(r,a){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(a)}delete(r,a){const t=this.c.get(r);t&&(t.delete(a),t.size===0&&this.c.delete(r))}forEach(r,a){const t=this.c.get(r);t&&t.forEach(a)}get(r){const a=this.c.get(r);return a||new Set}}e.$Gc=s;function i(n,r){if(n===r)return!0;if(n.size!==r.size)return!1;for(const[a,t]of n)if(!r.has(a)||r.get(a)!==t)return!1;for(const[a]of r)if(!n.has(a))return!1;return!0}e.$Hc=i}),define(Ce[3],Ie([1,0,19,74,28,75,53]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const v=!1;let p=null;class k{constructor(){this.b=new Map}static{this.a=0}c(P){let T=this.b.get(P);return T||(T={parent:null,source:null,isSingleton:!1,value:P,idx:k.a++},this.b.set(P,T)),T}trackDisposable(P){const T=this.c(P);T.source||(T.source=new Error().stack)}setParent(P,T){const U=this.c(P);U.parent=T}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,T){const U=T.get(P);if(U)return U;const z=P.parent?this.f(this.c(P.parent),T):P;return T.set(P,z),z}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,P).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(P=10,T){let U;if(T)U=T;else{const j=new Map,Y=[...this.b.values()].filter(ee=>ee.source!==null&&!this.f(ee,j).isSingleton);if(Y.length===0)return;const ne=new Set(Y.map(ee=>ee.value));if(U=Y.filter(ee=>!(ee.parent&&ne.has(ee.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(j){function Y(ee,Q){for(;ee.length>0&&Q.some(X=>typeof X=="string"?X===ee[0]:ee[0].match(X));)ee.shift()}const ne=j.source.split(`
`).map(ee=>ee.trim().replace("at ","")).filter(ee=>ee!=="");return Y(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const M=new $.$Gc;for(const j of U){const Y=z(j);for(let ne=0;ne<=Y.length;ne++)M.add(Y.slice(0,ne).join(`
`),j)}U.sort((0,I.$7b)(j=>j.idx,I.$9b));let N="",O=0;for(const j of U.slice(0,P)){O++;const Y=z(j),ne=[];for(let ee=0;ee<Y.length;ee++){let Q=Y[ee];Q=`(shared with ${M.get(Y.slice(0,ee+1).join(`
`)).size}/${U.length} leaks) at ${Q}`;const ce=M.get(Y.slice(0,ee).join(`
`)),ie=(0,F.$K)([...ce].map(fe=>z(fe)[ee]),fe=>fe);delete ie[Y[ee]];for(const[fe,re]of Object.entries(ie))ne.unshift(`    - stacktraces of ${re.length} other leaks continue with ${fe}`);ne.unshift(Q)}N+=`


==================== Leaking disposable ${O}/${U.length}: ${j.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return U.length>P&&(N+=`


... and ${U.length-P} more leaking disposables

`),{leaks:U,details:N}}}e.$Ic=k;function R(y){p=y}if(e.$Jc=R,v){const y="__is_disposable_tracked__";R(new class{trackDisposable(P){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(T)},3e3)}setParent(P,T){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function C(y){return p?.trackDisposable(y),y}e.$Kc=C;function m(y){p?.markAsDisposed(y)}e.$Lc=m;function E(y,P){p?.setParent(y,P)}function S(y,P){if(p)for(const T of y)p.setParent(T,P)}function l(y){return p?.markAsSingleton(y),y}e.$Mc=l;function w(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=w;function s(y){if(A.Iterable.is(y)){const P=[];for(const T of y)if(T)try{T.dispose()}catch(U){P.push(U)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=s;function i(y){for(const P of y)w(P)&&P.dispose();return[]}e.$Pc=i;function n(...y){const P=r(()=>s(y));return S(y,P),P}e.$Qc=n;function r(y){const P=C({dispose:(0,L.$db)(()=>{m(P),y()})});return P}e.$Rc=r;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return E(P,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),E(P,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,C(this),E(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t;class h{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&E(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&E(P,null),P}}e.$Uc=h;class c{constructor(P){this.a=new h,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=c;class o{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=o;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let T=P;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,m(this))},this}}e.$Xc=u;class d{constructor(){this.a=new Map}acquire(P,...T){let U=this.a.get(P);U||(U={counter:0,object:this.b(P,...T)},this.a.set(P,U));const{object:z}=U,M=(0,L.$db)(()=>{--U.counter===0&&(this.c(P,U.object),this.a.delete(P))});return U.counter++,{object:z,dispose:M}}}e.$Yc=d;class b{constructor(P){this.a=P}async acquire(P,...T){const U=this.a.acquire(P,...T);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Zc=b;class D{constructor(P){this.object=P}dispose(){}}e.$1c=D;function g(y){const P=new a;try{y(P)}finally{P.dispose()}}e.$2c=g;class f{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,T,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(P)?.dispose(),this.a.set(P,T)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=f}),function(me,e){typeof define=="function"&&define.amd?define(Ce[161],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(de,ue){for(var ge=0;ge<ue.length;ge++){var V=ue[ge];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(de,V.key,V)}}function I(de,ue,ge){return ue&&e(de.prototype,ue),ge&&e(de,ge),Object.defineProperty(de,"prototype",{writable:!1}),de}function F(de,ue){if(de){if(typeof de=="string")return $(de,ue);var ge=Object.prototype.toString.call(de).slice(8,-1);if(ge==="Object"&&de.constructor&&(ge=de.constructor.name),ge==="Map"||ge==="Set")return Array.from(de);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return $(de,ue)}}function $(de,ue){(ue==null||ue>de.length)&&(ue=de.length);for(var ge=0,V=new Array(ue);ge<ue;ge++)V[ge]=de[ge];return V}function L(de,ue){var ge=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(ge)return(ge=ge.call(de)).next.bind(ge);if(Array.isArray(de)||(ge=F(de))||ue&&de&&typeof de.length=="number"){ge&&(de=ge);var V=0;return function(){return V>=de.length?{done:!0}:{done:!1,value:de[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function v(de){me.defaults=de}var p=/[&<>"']/,k=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ue){return m[ue]};function S(de,ue){if(ue){if(p.test(de))return de.replace(k,E)}else if(R.test(de))return de.replace(C,E);return de}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function w(de){return de.replace(l,function(ue,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(de,ue){de=typeof de=="string"?de:de.source,ue=ue||"";var ge={replace:function(Z,he){return he=he.source||he,he=he.replace(s,"$1"),de=de.replace(Z,he),ge},getRegex:function(){return new RegExp(de,ue)}};return ge}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(de,ue,ge){if(de){var V;try{V=decodeURIComponent(w(ge)).replace(n,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}ue&&!r.test(ge)&&(ge=u(ue,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},h=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(de,ue){t[" "+de]||(h.test(de)?t[" "+de]=de+"/":t[" "+de]=g(de,"/",!0)),de=t[" "+de];var ge=de.indexOf(":")===-1;return ue.substring(0,2)==="//"?ge?ue:de.replace(c,"$1")+ue:ue.charAt(0)==="/"?ge?ue:de.replace(o,"$1")+ue:de+ue}var d={exec:function(){}};function b(de){for(var ue=1,ge,V;ue<arguments.length;ue++){ge=arguments[ue];for(V in ge)Object.prototype.hasOwnProperty.call(ge,V)&&(de[V]=ge[V])}return de}function D(de,ue){var ge=de.replace(/\|/g,function(he,be,Pe){for(var pe=!1,Le=be;--Le>=0&&Pe[Le]==="\\";)pe=!pe;return pe?"|":" |"}),V=ge.split(/ \|/),Z=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>ue)V.splice(ue);else for(;V.length<ue;)V.push("");for(;Z<V.length;Z++)V[Z]=V[Z].trim().replace(/\\\|/g,"|");return V}function g(de,ue,ge){var V=de.length;if(V===0)return"";for(var Z=0;Z<V;){var he=de.charAt(V-Z-1);if(he===ue&&!ge)Z++;else if(he!==ue&&ge)Z++;else break}return de.slice(0,V-Z)}function f(de,ue){if(de.indexOf(ue[1])===-1)return-1;for(var ge=de.length,V=0,Z=0;Z<ge;Z++)if(de[Z]==="\\")Z++;else if(de[Z]===ue[0])V++;else if(de[Z]===ue[1]&&(V--,V<0))return Z;return-1}function y(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(de,ue){if(ue<1)return"";for(var ge="";ue>1;)ue&1&&(ge+=de),ue>>=1,de+=de;return ge+de}function T(de,ue,ge,V){var Z=ue.href,he=ue.title?S(ue.title):null,be=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){V.state.inLink=!0;var Pe={type:"link",raw:ge,href:Z,title:he,text:be,tokens:V.inlineTokens(be)};return V.state.inLink=!1,Pe}return{type:"image",raw:ge,href:Z,title:he,text:S(be)}}function U(de,ue){var ge=de.match(/^(\s+)(?:```)/);if(ge===null)return ue;var V=ge[1];return ue.split(`
`).map(function(Z){var he=Z.match(/^\s+/);if(he===null)return Z;var be=he[0];return be.length>=V.length?Z.slice(V.length):Z}).join(`
`)}var z=function(){function de(ge){this.options=ge||me.defaults}var ue=de.prototype;return ue.space=function(V){var Z=this.rules.block.newline.exec(V);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},ue.code=function(V){var Z=this.rules.block.code.exec(V);if(Z){var he=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?he:g(he,`
`)}}},ue.fences=function(V){var Z=this.rules.block.fences.exec(V);if(Z){var he=Z[0],be=U(he,Z[3]||"");return{type:"code",raw:he,lang:Z[2]?Z[2].trim():Z[2],text:be}}},ue.heading=function(V){var Z=this.rules.block.heading.exec(V);if(Z){var he=Z[2].trim();if(/#$/.test(he)){var be=g(he,"#");(this.options.pedantic||!be||/ $/.test(be))&&(he=be.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:he,tokens:this.lexer.inline(he)}}},ue.hr=function(V){var Z=this.rules.block.hr.exec(V);if(Z)return{type:"hr",raw:Z[0]}},ue.blockquote=function(V){var Z=this.rules.block.blockquote.exec(V);if(Z){var he=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ue.list=function(V){var Z=this.rules.block.list.exec(V);if(Z){var he,be,Pe,pe,Le,Me,W,x,H,K,oe,ye,Re=Z[1].trim(),qe=Re.length>1,Ge={type:"list",raw:"",ordered:qe,start:qe?+Re.slice(0,-1):"",loose:!1,items:[]};Re=qe?"\\d{1,9}\\"+Re.slice(-1):"\\"+Re,this.options.pedantic&&(Re=qe?Re:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Re+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(ye=!1,!(!(Z=Xe.exec(V))||this.rules.block.hr.test(V)));){if(he=Z[0],V=V.substring(he.length),x=Z[2].split(`
`,1)[0],H=V.split(`
`,1)[0],this.options.pedantic?(pe=2,oe=x.trimLeft()):(pe=Z[2].search(/[^ ]/),pe=pe>4?1:pe,oe=x.slice(pe),pe+=Z[1].length),Me=!1,!x&&/^ *$/.test(H)&&(he+=H+`
`,V=V.substring(H.length+1),ye=!0),!ye)for(var it=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),lt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");V&&(K=V.split(`
`,1)[0],x=K,this.options.pedantic&&(x=x.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(x)||et.test(x)||it.test(x)||lt.test(V)));){if(x.search(/[^ ]/)>=pe||!x.trim())oe+=`
`+x.slice(pe);else if(!Me)oe+=`
`+x;else break;!Me&&!x.trim()&&(Me=!0),he+=K+`
`,V=V.substring(K.length+1)}Ge.loose||(W?Ge.loose=!0:/\n *\n *$/.test(he)&&(W=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(oe),be&&(Pe=be[0]!=="[ ] ",oe=oe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:he,task:!!be,checked:Pe,loose:!1,text:oe}),Ge.raw+=he}Ge.items[Ge.items.length-1].raw=he.trimRight(),Ge.items[Ge.items.length-1].text=oe.trimRight(),Ge.raw=Ge.raw.trimRight();var Ae=Ge.items.length;for(Le=0;Le<Ae;Le++){this.lexer.state.top=!1,Ge.items[Le].tokens=this.lexer.blockTokens(Ge.items[Le].text,[]);var Se=Ge.items[Le].tokens.filter(function(te){return te.type==="space"}),He=Se.every(function(te){for(var se=te.raw.split(""),De=0,Ve=L(se),Ke;!(Ke=Ve()).done;){var nt=Ke.value;if(nt===`
`&&(De+=1),De>1)return!0}return!1});!Ge.loose&&Se.length&&He&&(Ge.loose=!0,Ge.items[Le].loose=!0)}return Ge}},ue.html=function(V){var Z=this.rules.block.html.exec(V);if(Z){var he={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(Z[0]):S(Z[0]);he.type="paragraph",he.text=be,he.tokens=this.lexer.inline(be)}return he}},ue.def=function(V){var Z=this.rules.block.def.exec(V);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var he=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Z[0],href:Z[2],title:Z[3]}}},ue.table=function(V){var Z=this.rules.block.table.exec(V);if(Z){var he={type:"table",header:D(Z[1]).map(function(W){return{text:W}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Z[0];var be=he.align.length,Pe,pe,Le,Me;for(Pe=0;Pe<be;Pe++)/^ *-+: *$/.test(he.align[Pe])?he.align[Pe]="right":/^ *:-+: *$/.test(he.align[Pe])?he.align[Pe]="center":/^ *:-+ *$/.test(he.align[Pe])?he.align[Pe]="left":he.align[Pe]=null;for(be=he.rows.length,Pe=0;Pe<be;Pe++)he.rows[Pe]=D(he.rows[Pe],he.header.length).map(function(W){return{text:W}});for(be=he.header.length,pe=0;pe<be;pe++)he.header[pe].tokens=this.lexer.inline(he.header[pe].text);for(be=he.rows.length,pe=0;pe<be;pe++)for(Me=he.rows[pe],Le=0;Le<Me.length;Le++)Me[Le].tokens=this.lexer.inline(Me[Le].text);return he}}},ue.lheading=function(V){var Z=this.rules.block.lheading.exec(V);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},ue.paragraph=function(V){var Z=this.rules.block.paragraph.exec(V);if(Z){var he=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:he,tokens:this.lexer.inline(he)}}},ue.text=function(V){var Z=this.rules.block.text.exec(V);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},ue.escape=function(V){var Z=this.rules.inline.escape.exec(V);if(Z)return{type:"escape",raw:Z[0],text:S(Z[1])}},ue.tag=function(V){var Z=this.rules.inline.tag.exec(V);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):S(Z[0]):Z[0]}},ue.link=function(V){var Z=this.rules.inline.link.exec(V);if(Z){var he=Z[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var be=g(he.slice(0,-1),"\\");if((he.length-be.length)%2===0)return}else{var Pe=f(Z[2],"()");if(Pe>-1){var pe=Z[0].indexOf("!")===0?5:4,Le=pe+Z[1].length+Pe;Z[2]=Z[2].substring(0,Pe),Z[0]=Z[0].substring(0,Le).trim(),Z[3]=""}}var Me=Z[2],W="";if(this.options.pedantic){var x=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Me);x&&(Me=x[1],W=x[3])}else W=Z[3]?Z[3].slice(1,-1):"";return Me=Me.trim(),/^</.test(Me)&&(this.options.pedantic&&!/>$/.test(he)?Me=Me.slice(1):Me=Me.slice(1,-1)),T(Z,{href:Me&&Me.replace(this.rules.inline._escapes,"$1"),title:W&&W.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},ue.reflink=function(V,Z){var he;if((he=this.rules.inline.reflink.exec(V))||(he=this.rules.inline.nolink.exec(V))){var be=(he[2]||he[1]).replace(/\s+/g," ");if(be=Z[be.toLowerCase()],!be||!be.href){var Pe=he[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return T(he,be,he[0],this.lexer)}},ue.emStrong=function(V,Z,he){he===void 0&&(he="");var be=this.rules.inline.emStrong.lDelim.exec(V);if(be&&!(be[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=be[1]||be[2]||"";if(!Pe||Pe&&(he===""||this.rules.inline.punctuation.exec(he))){var pe=be[0].length-1,Le,Me,W=pe,x=0,H=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,Z=Z.slice(-1*V.length+pe);(be=H.exec(Z))!=null;)if(Le=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Le){if(Me=Le.length,be[3]||be[4]){W+=Me;continue}else if((be[5]||be[6])&&pe%3&&!((pe+Me)%3)){x+=Me;continue}if(W-=Me,!(W>0)){if(Me=Math.min(Me,Me+W+x),Math.min(pe,Me)%2){var K=V.slice(1,pe+be.index+Me);return{type:"em",raw:V.slice(0,pe+be.index+Me+1),text:K,tokens:this.lexer.inlineTokens(K)}}var oe=V.slice(2,pe+be.index+Me-1);return{type:"strong",raw:V.slice(0,pe+be.index+Me+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}}}}},ue.codespan=function(V){var Z=this.rules.inline.code.exec(V);if(Z){var he=Z[2].replace(/\n/g," "),be=/[^ ]/.test(he),Pe=/^ /.test(he)&&/ $/.test(he);return be&&Pe&&(he=he.substring(1,he.length-1)),he=S(he,!0),{type:"codespan",raw:Z[0],text:he}}},ue.br=function(V){var Z=this.rules.inline.br.exec(V);if(Z)return{type:"br",raw:Z[0]}},ue.del=function(V){var Z=this.rules.inline.del.exec(V);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},ue.autolink=function(V,Z){var he=this.rules.inline.autolink.exec(V);if(he){var be,Pe;return he[2]==="@"?(be=S(this.options.mangle?Z(he[1]):he[1]),Pe="mailto:"+be):(be=S(he[1]),Pe=be),{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ue.url=function(V,Z){var he;if(he=this.rules.inline.url.exec(V)){var be,Pe;if(he[2]==="@")be=S(this.options.mangle?Z(he[0]):he[0]),Pe="mailto:"+be;else{var pe;do pe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(pe!==he[0]);be=S(he[0]),he[1]==="www."?Pe="http://"+be:Pe=be}return{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ue.inlineText=function(V,Z){var he=this.rules.inline.text.exec(V);if(he){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):S(he[0]):he[0]:be=S(this.options.smartypants?Z(he[0]):he[0]),{type:"text",raw:he[0],text:be}}},de}(),M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=i(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.listItemStart=i(/^( *)(bull) */).replace("bull",M.bullet).getRegex(),M.list=i(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=i(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=i(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.blockquote=i(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=b({},M),M.gfm=b({},M.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.table=i(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.gfm.paragraph=i(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",M.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",M._tag).getRegex(),M.pedantic=b({},M.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=i(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=i(M._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=i(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=i(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=i(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=i(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=i(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=i(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=i(N.reflink).replace("label",N._label).replace("ref",M._label).getRegex(),N.nolink=i(N.nolink).replace("ref",M._label).getRegex(),N.reflinkSearch=i(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=b({},N),N.pedantic=b({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=b({},N.normal,{escape:i(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=i(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=b({},N.gfm,{br:i(N.br).replace("{2,}","*").getRegex(),text:i(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(de){var ue="",ge,V,Z=de.length;for(ge=0;ge<Z;ge++)V=de.charCodeAt(ge),Math.random()>.5&&(V="x"+V.toString(16)),ue+="&#"+V+";";return ue}var Y=function(){function de(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:M.normal,inline:N.normal};this.options.pedantic?(V.block=M.pedantic,V.inline=N.pedantic):this.options.gfm&&(V.block=M.gfm,this.options.breaks?V.inline=N.breaks:V.inline=N.gfm),this.tokenizer.rules=V}de.lex=function(V,Z){var he=new de(Z);return he.lex(V)},de.lexInline=function(V,Z){var he=new de(Z);return he.inlineTokens(V)};var ue=de.prototype;return ue.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},ue.blockTokens=function(V,Z){var he=this;Z===void 0&&(Z=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(W,x,H){return x+"    ".repeat(H.length)});for(var be,Pe,pe,Le;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(W){return(be=W.call({lexer:he},V,Z))?(V=V.substring(be.raw.length),Z.push(be),!0):!1}))){if(be=this.tokenizer.space(V)){V=V.substring(be.raw.length),be.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push(be);continue}if(be=this.tokenizer.code(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be);continue}if(be=this.tokenizer.fences(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.heading(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.hr(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.blockquote(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.list(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.html(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.def(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.lheading(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(pe=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var W=1/0,x=V.slice(1),H=void 0;he.options.extensions.startBlock.forEach(function(K){H=K.call({lexer:this},x),typeof H=="number"&&H>=0&&(W=Math.min(W,H))}),W<1/0&&W>=0&&(pe=V.substring(0,W+1))}(),this.state.top&&(be=this.tokenizer.paragraph(pe))){Pe=Z[Z.length-1],Le&&Pe.type==="paragraph"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be),Le=pe.length!==V.length,V=V.substring(be.raw.length);continue}if(be=this.tokenizer.text(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Z.push(be);continue}if(V){var Me="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Me);break}else throw new Error(Me)}}return this.state.top=!0,Z},ue.inline=function(V,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:V,tokens:Z}),Z},ue.inlineTokens=function(V,Z){var he=this;Z===void 0&&(Z=[]);var be,Pe,pe,Le=V,Me,W,x;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Me=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)H.includes(Me[0].slice(Me[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Me.index)+"["+P("a",Me[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Me=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Me.index)+"["+P("a",Me[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Me=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Me.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(W||(x=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(oe){return(be=oe.call({lexer:he},V,Z))?(V=V.substring(be.raw.length),Z.push(be),!0):!1}))){if(be=this.tokenizer.escape(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.tag(V)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(be=this.tokenizer.link(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(be.raw.length),Pe=Z[Z.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(be=this.tokenizer.emStrong(V,Le,x)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.codespan(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.br(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.del(V)){V=V.substring(be.raw.length),Z.push(be);continue}if(be=this.tokenizer.autolink(V,j)){V=V.substring(be.raw.length),Z.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(V,j))){V=V.substring(be.raw.length),Z.push(be);continue}if(pe=V,this.options.extensions&&this.options.extensions.startInline&&function(){var oe=1/0,ye=V.slice(1),Re=void 0;he.options.extensions.startInline.forEach(function(qe){Re=qe.call({lexer:this},ye),typeof Re=="number"&&Re>=0&&(oe=Math.min(oe,Re))}),oe<1/0&&oe>=0&&(pe=V.substring(0,oe+1))}(),be=this.tokenizer.inlineText(pe,O)){V=V.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(x=be.raw.slice(-1)),W=!0,Pe=Z[Z.length-1],Pe&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Z.push(be);continue}if(V){var K="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Z},I(de,null,[{key:"rules",get:function(){return{block:M,inline:N}}}]),de}(),ne=function(){function de(ge){this.options=ge||me.defaults}var ue=de.prototype;return ue.code=function(V,Z,he){var be=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(V,be);Pe!=null&&Pe!==V&&(he=!0,V=Pe)}return V=V.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+S(be,!0)+'">'+(he?V:S(V,!0))+`</code></pre>
`:"<pre><code>"+(he?V:S(V,!0))+`</code></pre>
`},ue.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},ue.html=function(V){return V},ue.heading=function(V,Z,he,be){if(this.options.headerIds){var Pe=this.options.headerPrefix+be.slug(he);return"<h"+Z+' id="'+Pe+'">'+V+"</h"+Z+`>
`}return"<h"+Z+">"+V+"</h"+Z+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(V,Z,he){var be=Z?"ol":"ul",Pe=Z&&he!==1?' start="'+he+'"':"";return"<"+be+Pe+`>
`+V+"</"+be+`>
`},ue.listitem=function(V){return"<li>"+V+`</li>
`},ue.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(V){return"<p>"+V+`</p>
`},ue.table=function(V,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Z+`</table>
`},ue.tablerow=function(V){return`<tr>
`+V+`</tr>
`},ue.tablecell=function(V,Z){var he=Z.header?"th":"td",be=Z.align?"<"+he+' align="'+Z.align+'">':"<"+he+">";return be+V+("</"+he+`>
`)},ue.strong=function(V){return"<strong>"+V+"</strong>"},ue.em=function(V){return"<em>"+V+"</em>"},ue.codespan=function(V){return"<code>"+V+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(V){return"<del>"+V+"</del>"},ue.link=function(V,Z,he){if(V=a(this.options.sanitize,this.options.baseUrl,V),V===null)return he;var be='<a href="'+S(V)+'"';return Z&&(be+=' title="'+Z+'"'),be+=">"+he+"</a>",be},ue.image=function(V,Z,he){if(V=a(this.options.sanitize,this.options.baseUrl,V),V===null)return he;var be='<img src="'+V+'" alt="'+he+'"';return Z&&(be+=' title="'+Z+'"'),be+=this.options.xhtml?"/>":">",be},ue.text=function(V){return V},de}(),ee=function(){function de(){}var ue=de.prototype;return ue.strong=function(V){return V},ue.em=function(V){return V},ue.codespan=function(V){return V},ue.del=function(V){return V},ue.html=function(V){return V},ue.text=function(V){return V},ue.link=function(V,Z,he){return""+he},ue.image=function(V,Z,he){return""+he},ue.br=function(){return""},de}(),Q=function(){function de(){this.seen={}}var ue=de.prototype;return ue.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(V,Z){var he=V,be=0;if(this.seen.hasOwnProperty(he)){be=this.seen[V];do be++,he=V+"-"+be;while(this.seen.hasOwnProperty(he))}return Z||(this.seen[V]=be,this.seen[he]=0),he},ue.slug=function(V,Z){Z===void 0&&(Z={});var he=this.serialize(V);return this.getNextSafeSlug(he,Z.dryrun)},de}(),X=function(){function de(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new Q}de.parse=function(V,Z){var he=new de(Z);return he.parse(V)},de.parseInline=function(V,Z){var he=new de(Z);return he.parseInline(V)};var ue=de.prototype;return ue.parse=function(V,Z){Z===void 0&&(Z=!0);var he="",be,Pe,pe,Le,Me,W,x,H,K,oe,ye,Re,qe,Ge,Xe,it,lt,at,et,Ae=V.length;for(be=0;be<Ae;be++){if(oe=V[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[oe.type]&&(et=this.options.extensions.renderers[oe.type].call({parser:this},oe),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(oe.type))){he+=et||"";continue}switch(oe.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(oe.tokens),oe.depth,w(this.parseInline(oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(oe.text,oe.lang,oe.escaped);continue}case"table":{for(H="",x="",Le=oe.header.length,Pe=0;Pe<Le;Pe++)x+=this.renderer.tablecell(this.parseInline(oe.header[Pe].tokens),{header:!0,align:oe.align[Pe]});for(H+=this.renderer.tablerow(x),K="",Le=oe.rows.length,Pe=0;Pe<Le;Pe++){for(W=oe.rows[Pe],x="",Me=W.length,pe=0;pe<Me;pe++)x+=this.renderer.tablecell(this.parseInline(W[pe].tokens),{header:!1,align:oe.align[pe]});K+=this.renderer.tablerow(x)}he+=this.renderer.table(H,K);continue}case"blockquote":{K=this.parse(oe.tokens),he+=this.renderer.blockquote(K);continue}case"list":{for(ye=oe.ordered,Re=oe.start,qe=oe.loose,Le=oe.items.length,K="",Pe=0;Pe<Le;Pe++)Xe=oe.items[Pe],it=Xe.checked,lt=Xe.task,Ge="",Xe.task&&(at=this.renderer.checkbox(it),qe?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=at+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=at+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:at}):Ge+=at),Ge+=this.parse(Xe.tokens,qe),K+=this.renderer.listitem(Ge,lt,it);he+=this.renderer.list(K,ye,Re);continue}case"html":{he+=this.renderer.html(oe.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(oe.tokens));continue}case"text":{for(K=oe.tokens?this.parseInline(oe.tokens):oe.text;be+1<Ae&&V[be+1].type==="text";)oe=V[++be],K+=`
`+(oe.tokens?this.parseInline(oe.tokens):oe.text);he+=Z?this.renderer.paragraph(K):K;continue}default:{var Se='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(Se);return}else throw new Error(Se)}}}return he},ue.parseInline=function(V,Z){Z=Z||this.renderer;var he="",be,Pe,pe,Le=V.length;for(be=0;be<Le;be++){if(Pe=V[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(pe=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){he+=pe||"";continue}switch(Pe.type){case"escape":{he+=Z.text(Pe.text);break}case"html":{he+=Z.html(Pe.text);break}case"link":{he+=Z.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,Z));break}case"image":{he+=Z.image(Pe.href,Pe.title,Pe.text);break}case"strong":{he+=Z.strong(this.parseInline(Pe.tokens,Z));break}case"em":{he+=Z.em(this.parseInline(Pe.tokens,Z));break}case"codespan":{he+=Z.codespan(Pe.text);break}case"br":{he+=Z.br();break}case"del":{he+=Z.del(this.parseInline(Pe.tokens,Z));break}case"text":{he+=Z.text(Pe.text);break}default:{var Me='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Me);return}else throw new Error(Me)}}}return he},de}();function ce(de,ue,ge){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof ue=="function"&&(ge=ue,ue=null),ue=b({},ce.defaults,ue||{}),y(ue),ge){var V=ue.highlight,Z;try{Z=Y.lex(de,ue)}catch(Le){return ge(Le)}var he=function(Me){var W;if(!Me)try{ue.walkTokens&&ce.walkTokens(Z,ue.walkTokens),W=X.parse(Z,ue)}catch(x){Me=x}return ue.highlight=V,Me?ge(Me):ge(null,W)};if(!V||V.length<3||(delete ue.highlight,!Z.length))return he();var be=0;ce.walkTokens(Z,function(Le){Le.type==="code"&&(be++,setTimeout(function(){V(Le.text,Le.lang,function(Me,W){if(Me)return he(Me);W!=null&&W!==Le.text&&(Le.text=W,Le.escaped=!0),be--,be===0&&he()})},0))}),be===0&&he();return}function Pe(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(Le.message+"",!0)+"</pre>";throw Le}try{var pe=Y.lex(de,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ce.walkTokens(pe,ue.walkTokens)).then(function(){return X.parse(pe,ue)}).catch(Pe);ce.walkTokens(pe,ue.walkTokens)}return X.parse(pe,ue)}catch(Le){Pe(Le)}}ce.options=ce.setOptions=function(de){return b(ce.defaults,de),v(ce.defaults),ce},ce.getDefaults=A,ce.defaults=me.defaults,ce.use=function(){for(var de=arguments.length,ue=new Array(de),ge=0;ge<de;ge++)ue[ge]=arguments[ge];var V=b.apply(void 0,[{}].concat(ue)),Z=ce.defaults.extensions||{renderers:{},childTokens:{}},he;ue.forEach(function(be){if(be.extensions&&(he=!0,be.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Le=Z.renderers?Z.renderers[pe.name]:null;Le?Z.renderers[pe.name]=function(){for(var Me=arguments.length,W=new Array(Me),x=0;x<Me;x++)W[x]=arguments[x];var H=pe.renderer.apply(this,W);return H===!1&&(H=Le.apply(this,W)),H}:Z.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[pe.level]?Z[pe.level].unshift(pe.tokenizer):Z[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?Z.startBlock?Z.startBlock.push(pe.start):Z.startBlock=[pe.start]:pe.level==="inline"&&(Z.startInline?Z.startInline.push(pe.start):Z.startInline=[pe.start]))}pe.childTokens&&(Z.childTokens[pe.name]=pe.childTokens)})),be.renderer&&function(){var pe=ce.defaults.renderer||new ne,Le=function(x){var H=pe[x];pe[x]=function(){for(var K=arguments.length,oe=new Array(K),ye=0;ye<K;ye++)oe[ye]=arguments[ye];var Re=be.renderer[x].apply(pe,oe);return Re===!1&&(Re=H.apply(pe,oe)),Re}};for(var Me in be.renderer)Le(Me);V.renderer=pe}(),be.tokenizer&&function(){var pe=ce.defaults.tokenizer||new z,Le=function(x){var H=pe[x];pe[x]=function(){for(var K=arguments.length,oe=new Array(K),ye=0;ye<K;ye++)oe[ye]=arguments[ye];var Re=be.tokenizer[x].apply(pe,oe);return Re===!1&&(Re=H.apply(pe,oe)),Re}};for(var Me in be.tokenizer)Le(Me);V.tokenizer=pe}(),be.walkTokens){var Pe=ce.defaults.walkTokens;V.walkTokens=function(pe){var Le=[];return Le.push(be.walkTokens.call(this,pe)),Pe&&(Le=Le.concat(Pe.call(this,pe))),Le}}he&&(V.extensions=Z),ce.setOptions(V)})},ce.walkTokens=function(de,ue){for(var ge=[],V=function(){var Pe=he.value;switch(ge=ge.concat(ue.call(ce,Pe)),Pe.type){case"table":{for(var pe=L(Pe.header),Le;!(Le=pe()).done;){var Me=Le.value;ge=ge.concat(ce.walkTokens(Me.tokens,ue))}for(var W=L(Pe.rows),x;!(x=W()).done;)for(var H=x.value,K=L(H),oe;!(oe=K()).done;){var ye=oe.value;ge=ge.concat(ce.walkTokens(ye.tokens,ue))}break}case"list":{ge=ge.concat(ce.walkTokens(Pe.items,ue));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Pe.type]?ce.defaults.extensions.childTokens[Pe.type].forEach(function(Re){ge=ge.concat(ce.walkTokens(Pe[Re],ue))}):Pe.tokens&&(ge=ge.concat(ce.walkTokens(Pe.tokens,ue)))}},Z=L(de),he;!(he=Z()).done;)V();return ge},ce.parseInline=function(de,ue){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");ue=b({},ce.defaults,ue||{}),y(ue);try{var ge=Y.lexInline(de,ue);return ue.walkTokens&&ce.walkTokens(ge,ue.walkTokens),X.parseInline(ge,ue)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+S(V.message+"",!0)+"</pre>";throw V}},ce.Parser=X,ce.parser=X.parse,ce.Renderer=ne,ce.TextRenderer=ee,ce.Lexer=Y,ce.lexer=Y.lex,ce.Tokenizer=z,ce.Slugger=Q,ce.parse=ce;var ie=ce.options,fe=ce.setOptions,re=ce.use,J=ce.walkTokens,B=ce.parseInline,ae=ce,Ee=X.parse,le=Y.lex;me.Lexer=Y,me.Parser=X,me.Renderer=ne,me.Slugger=Q,me.TextRenderer=ee,me.Tokenizer=z,me.getDefaults=A,me.lexer=le,me.marked=ce,me.options=ie,me.parse=ae,me.parseInline=B,me.parser=Ee,me.setOptions=fe,me.use=re,me.walkTokens=J,Object.defineProperty(me,"__esModule",{value:!0})}),define(Ce[162],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0;function I(l){const w=L(l);if(w&&w.length>0)return new Uint32Array(w)}e.$Wj=I;let F=0;const $=new Uint32Array(10);function L(l){if(F=0,A(l,C,4352),F>0||(A(l,m,4449),F>0)||(A(l,E,4520),F>0)||(A(l,S,12593),F))return $.subarray(0,F);if(l>=44032&&l<=55203){const w=l-44032,s=w%588,i=Math.floor(w/588),n=Math.floor(s/28),r=s%28-1;if(i<C.length?A(i,C,0):4352+i-12593<S.length&&A(4352+i,S,12593),n<m.length?A(n,m,0):4449+n-12593<S.length&&A(4449+n-12593,S,12593),r>=0&&(r<E.length?A(r,E,0):4520+r-12593<S.length&&A(4520+r-12593,S,12593)),F>0)return $.subarray(0,F)}}function A(l,w,s){l>=s&&l<s+w.length&&v(w[l-s])}function v(l){l!==0&&($[F++]=l&255,l>>8&&($[F++]=l>>8&255),l>>16&&($[F++]=l>>16&255))}var p;(function(l){l[l.InitialConsonant=4352]="InitialConsonant",l[l.Vowel=4449]="Vowel",l[l.FinalConsonant=4520]="FinalConsonant",l[l.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var k;(function(l){l[l.NUL=0]="NUL",l[l.A=65]="A",l[l.B=66]="B",l[l.C=67]="C",l[l.D=68]="D",l[l.E=69]="E",l[l.F=70]="F",l[l.G=71]="G",l[l.H=72]="H",l[l.I=73]="I",l[l.J=74]="J",l[l.K=75]="K",l[l.L=76]="L",l[l.M=77]="M",l[l.N=78]="N",l[l.O=79]="O",l[l.P=80]="P",l[l.Q=81]="Q",l[l.R=82]="R",l[l.S=83]="S",l[l.T=84]="T",l[l.U=85]="U",l[l.V=86]="V",l[l.W=87]="W",l[l.X=88]="X",l[l.Y=89]="Y",l[l.Z=90]="Z",l[l.a=97]="a",l[l.b=98]="b",l[l.c=99]="c",l[l.d=100]="d",l[l.e=101]="e",l[l.f=102]="f",l[l.g=103]="g",l[l.h=104]="h",l[l.i=105]="i",l[l.j=106]="j",l[l.k=107]="k",l[l.l=108]="l",l[l.m=109]="m",l[l.n=110]="n",l[l.o=111]="o",l[l.p=112]="p",l[l.q=113]="q",l[l.r=114]="r",l[l.s=115]="s",l[l.t=116]="t",l[l.u=117]="u",l[l.v=118]="v",l[l.w=119]="w",l[l.x=120]="x",l[l.y=121]="y",l[l.z=122]="z"})(k||(k={}));var R;(function(l){l[l.fa=24934]="fa",l[l.fg=26470]="fg",l[l.fq=29030]="fq",l[l.fr=29286]="fr",l[l.ft=29798]="ft",l[l.fv=30310]="fv",l[l.fx=30822]="fx",l[l.hk=27496]="hk",l[l.hl=27752]="hl",l[l.ho=28520]="ho",l[l.ml=27757]="ml",l[l.nj=27246]="nj",l[l.nl=27758]="nl",l[l.np=28782]="np",l[l.qt=29809]="qt",l[l.rt=29810]="rt",l[l.sg=26483]="sg",l[l.sw=30579]="sw"})(R||(R={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),m=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[77],Ie([1,0,28]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=e.$Ml=e.$Ll=void 0;const F=new I.$Dc(1e4);function $(k){return p(k,"NFC",F)}e.$Ll=$;const L=new I.$Dc(1e4);function A(k){return p(k,"NFD",L)}e.$Ml=A;const v=/[^\u0000-\u0080]/;function p(k,R,C){if(!k)return k;const m=C.get(k);if(m)return m;let E;return v.test(k)?E=k.normalize(R):E=k,C.set(k,E),E}e.$Nl=function(){const k=/[\u0300-\u036f]/g;return function(R){return A(R).replace(k,"")}}()}),define(Ce[122],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.rot=e.$_l=void 0;function I(v,p,k){return Math.min(Math.max(v,p),k)}e.$_l=I;function F(v,p){return(p+v%p)%p}e.rot=F;class ${constructor(){this.a=0}getNext(){return this.a++}}e.$bm=$;class L{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$cm=L;class A{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const k=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$dm=A}),function(){function me($){const L=[];typeof $=="number"&&L.push("code/timeOrigin",$);function A(p){L.push(p,Date.now())}function v(){const p=[];for(let k=0;k<L.length;k+=2)p.push({name:L[k],startTime:L[k+1]});return p}return{mark:A,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark($){performance.mark($)},getMarks(){let $=performance.timeOrigin;typeof $!="number"&&($=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round($)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round($+A.startTime)});return L}};if(typeof process=="object"){const $=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me($)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I($){return $.MonacoPerformanceMarks||($.MonacoPerformanceMarks=e()),$.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=I(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var F in I)(typeof exports=="object"?exports:me)[F]=I[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(F){if(e[F])return e[F].exports;var $=e[F]={i:F,l:!1,exports:{}};return me[F].call($.exports,$,$.exports,I),$.l=!0,$.exports}return I.m=me,I.c=e,I.d=function(F,$,L){I.o(F,$)||Object.defineProperty(F,$,{enumerable:!0,get:L})},I.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},I.t=function(F,$){if(1&$&&(F=I(F)),8&$||4&$&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(I.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&$&&typeof F!="string")for(var A in F)I.d(L,A,function(v){return F[v]}.bind(null,A));return L},I.n=function(F){var $=F&&F.__esModule?function(){return F.default}:function(){return F};return I.d($,"a",$),$},I.o=function(F,$){return Object.prototype.hasOwnProperty.call(F,$)},I.p="",I(I.s=0)}([function(me,e,I){(function(F){var $;e=me.exports=re,$=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],p=e.src=[],k=0,R=k++;p[R]="0|[1-9]\\d*";var C=k++;p[C]="[0-9]+";var m=k++;p[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;p[E]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var S=k++;p[S]="("+p[C]+")\\.("+p[C]+")\\.("+p[C]+")";var l=k++;p[l]="(?:"+p[R]+"|"+p[m]+")";var w=k++;p[w]="(?:"+p[C]+"|"+p[m]+")";var s=k++;p[s]="(?:-("+p[l]+"(?:\\."+p[l]+")*))";var i=k++;p[i]="(?:-?("+p[w]+"(?:\\."+p[w]+")*))";var n=k++;p[n]="[0-9A-Za-z-]+";var r=k++;p[r]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var a=k++,t="v?"+p[E]+p[s]+"?"+p[r]+"?";p[a]="^"+t+"$";var h="[v=\\s]*"+p[S]+p[i]+"?"+p[r]+"?",c=k++;p[c]="^"+h+"$";var o=k++;p[o]="((?:<|>)?=?)";var u=k++;p[u]=p[C]+"|x|X|\\*";var d=k++;p[d]=p[R]+"|x|X|\\*";var b=k++;p[b]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[s]+")?"+p[r]+"?)?)?";var D=k++;p[D]="[v=\\s]*("+p[u]+")(?:\\.("+p[u]+")(?:\\.("+p[u]+")(?:"+p[i]+")?"+p[r]+"?)?)?";var g=k++;p[g]="^"+p[o]+"\\s*"+p[b]+"$";var f=k++;p[f]="^"+p[o]+"\\s*"+p[D]+"$";var y=k++;p[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=k++;p[P]="(?:~>?)";var T=k++;p[T]="(\\s*)"+p[P]+"\\s+",v[T]=new RegExp(p[T],"g");var U=k++;p[U]="^"+p[P]+p[b]+"$";var z=k++;p[z]="^"+p[P]+p[D]+"$";var M=k++;p[M]="(?:\\^)";var N=k++;p[N]="(\\s*)"+p[M]+"\\s+",v[N]=new RegExp(p[N],"g");var O=k++;p[O]="^"+p[M]+p[b]+"$";var j=k++;p[j]="^"+p[M]+p[D]+"$";var Y=k++;p[Y]="^"+p[o]+"\\s*("+h+")$|^$";var ne=k++;p[ne]="^"+p[o]+"\\s*("+t+")$|^$";var ee=k++;p[ee]="(\\s*)"+p[o]+"\\s*("+h+"|"+p[b]+")",v[ee]=new RegExp(p[ee],"g");var Q=k++;p[Q]="^\\s*("+p[b]+")\\s+-\\s+("+p[b]+")\\s*$";var X=k++;p[X]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var ce=k++;p[ce]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)$(ie,p[ie]),v[ie]||(v[ie]=new RegExp(p[ie]));function fe(H,K){if(H instanceof re)return H;if(typeof H!="string"||H.length>L||!(K?v[c]:v[a]).test(H))return null;try{return new re(H,K)}catch{return null}}function re(H,K){if(H instanceof re){if(H.loose===K)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof re))return new re(H,K);$("SemVer",H,K),this.loose=K;var oe=H.trim().match(K?v[c]:v[a]);if(!oe)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Re=+ye;if(Re>=0&&Re<A)return Re}return ye}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=fe,e.valid=function(H,K){var oe=fe(H,K);return oe?oe.version:null},e.clean=function(H,K){var oe=fe(H.trim().replace(/^[=v]+/,""),K);return oe?oe.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(H){return $("SemVer.compare",this.version,this.loose,H),H instanceof re||(H=new re(H,this.loose)),this.compareMain(H)||this.comparePre(H)},re.prototype.compareMain=function(H){return H instanceof re||(H=new re(H,this.loose)),B(this.major,H.major)||B(this.minor,H.minor)||B(this.patch,H.patch)},re.prototype.comparePre=function(H){if(H instanceof re||(H=new re(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var K=0;do{var oe=this.prerelease[K],ye=H.prerelease[K];if($("prerelease compare",K,oe,ye),oe===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(oe===void 0)return-1;if(oe!==ye)return B(oe,ye)}while(++K)},re.prototype.inc=function(H,K){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,K,oe,ye){typeof oe=="string"&&(ye=oe,oe=void 0);try{return new re(H,oe).inc(K,ye).version}catch{return null}},e.diff=function(H,K){if(de(H,K))return null;var oe=fe(H),ye=fe(K);if(oe.prerelease.length||ye.prerelease.length){for(var Re in oe)if((Re==="major"||Re==="minor"||Re==="patch")&&oe[Re]!==ye[Re])return"pre"+Re;return"prerelease"}for(var Re in oe)if((Re==="major"||Re==="minor"||Re==="patch")&&oe[Re]!==ye[Re])return Re},e.compareIdentifiers=B;var J=/^[0-9]+$/;function B(H,K){var oe=J.test(H),ye=J.test(K);return oe&&ye&&(H=+H,K=+K),oe&&!ye?-1:ye&&!oe?1:H<K?-1:H>K?1:0}function ae(H,K,oe){return new re(H,oe).compare(new re(K,oe))}function Ee(H,K,oe){return ae(H,K,oe)>0}function le(H,K,oe){return ae(H,K,oe)<0}function de(H,K,oe){return ae(H,K,oe)===0}function ue(H,K,oe){return ae(H,K,oe)!==0}function ge(H,K,oe){return ae(H,K,oe)>=0}function V(H,K,oe){return ae(H,K,oe)<=0}function Z(H,K,oe,ye){var Re;switch(K){case"===":typeof H=="object"&&(H=H.version),typeof oe=="object"&&(oe=oe.version),Re=H===oe;break;case"!==":typeof H=="object"&&(H=H.version),typeof oe=="object"&&(oe=oe.version),Re=H!==oe;break;case"":case"=":case"==":Re=de(H,oe,ye);break;case"!=":Re=ue(H,oe,ye);break;case">":Re=Ee(H,oe,ye);break;case">=":Re=ge(H,oe,ye);break;case"<":Re=le(H,oe,ye);break;case"<=":Re=V(H,oe,ye);break;default:throw new TypeError("Invalid operator: "+K)}return Re}function he(H,K){if(H instanceof he){if(H.loose===K)return H;H=H.value}if(!(this instanceof he))return new he(H,K);$("comparator",H,K),this.loose=K,this.parse(H),this.semver===be?this.value="":this.value=this.operator+this.semver.version,$("comp",this)}e.rcompareIdentifiers=function(H,K){return B(K,H)},e.major=function(H,K){return new re(H,K).major},e.minor=function(H,K){return new re(H,K).minor},e.patch=function(H,K){return new re(H,K).patch},e.compare=ae,e.compareLoose=function(H,K){return ae(H,K,!0)},e.rcompare=function(H,K,oe){return ae(K,H,oe)},e.sort=function(H,K){return H.sort(function(oe,ye){return e.compare(oe,ye,K)})},e.rsort=function(H,K){return H.sort(function(oe,ye){return e.rcompare(oe,ye,K)})},e.gt=Ee,e.lt=le,e.eq=de,e.neq=ue,e.gte=ge,e.lte=V,e.cmp=Z,e.Comparator=he;var be={};function Pe(H,K){if(H instanceof Pe)return H.loose===K?H:new Pe(H.raw,K);if(H instanceof he)return new Pe(H.value,K);if(!(this instanceof Pe))return new Pe(H,K);if(this.loose=K,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function pe(H){return!H||H.toLowerCase()==="x"||H==="*"}function Le(H,K,oe,ye,Re,qe,Ge,Xe,it,lt,at,et,Ae){return((K=pe(oe)?"":pe(ye)?">="+oe+".0.0":pe(Re)?">="+oe+"."+ye+".0":">="+K)+" "+(Xe=pe(it)?"":pe(lt)?"<"+(+it+1)+".0.0":pe(at)?"<"+it+"."+(+lt+1)+".0":et?"<="+it+"."+lt+"."+at+"-"+et:"<="+Xe)).trim()}function Me(H,K){for(var oe=0;oe<H.length;oe++)if(!H[oe].test(K))return!1;if(K.prerelease.length){for(oe=0;oe<H.length;oe++)if($(H[oe].semver),H[oe].semver!==be&&H[oe].semver.prerelease.length>0){var ye=H[oe].semver;if(ye.major===K.major&&ye.minor===K.minor&&ye.patch===K.patch)return!0}return!1}return!0}function W(H,K,oe){try{K=new Pe(K,oe)}catch{return!1}return K.test(H)}function x(H,K,oe,ye){var Re,qe,Ge,Xe,it;switch(H=new re(H,ye),K=new Pe(K,ye),oe){case">":Re=Ee,qe=V,Ge=le,Xe=">",it=">=";break;case"<":Re=le,qe=ge,Ge=Ee,Xe="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(W(H,K,ye))return!1;for(var lt=0;lt<K.set.length;++lt){var at=K.set[lt],et=null,Ae=null;if(at.forEach(function(Se){Se.semver===be&&(Se=new he(">=0.0.0")),et=et||Se,Ae=Ae||Se,Re(Se.semver,et.semver,ye)?et=Se:Ge(Se.semver,Ae.semver,ye)&&(Ae=Se)}),et.operator===Xe||et.operator===it||(!Ae.operator||Ae.operator===Xe)&&qe(H,Ae.semver)||Ae.operator===it&&Ge(H,Ae.semver))return!1}return!0}he.prototype.parse=function(H){var K=this.loose?v[Y]:v[ne],oe=H.match(K);if(!oe)throw new TypeError("Invalid comparator: "+H);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new re(oe[2],this.loose):this.semver=be},he.prototype.toString=function(){return this.value},he.prototype.test=function(H){return $("Comparator.test",H,this.loose),this.semver===be||(typeof H=="string"&&(H=new re(H,this.loose)),Z(H,this.operator,this.semver,this.loose))},he.prototype.intersects=function(H,K){if(!(H instanceof he))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(H.value,K),W(this.value,oe,K);if(H.operator==="")return oe=new Pe(this.value,K),W(H.semver,oe,K);var ye=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),qe=this.semver.version===H.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Xe=Z(this.semver,"<",H.semver,K)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),it=Z(this.semver,">",H.semver,K)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return ye||Re||qe&&Ge||Xe||it},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(H){var K=this.loose;H=H.trim(),$("range",H,K);var oe=K?v[X]:v[Q];H=H.replace(oe,Le),$("hyphen replace",H),H=H.replace(v[ee],"$1$2$3"),$("comparator trim",H,v[ee]),H=(H=(H=H.replace(v[T],"$1~")).replace(v[N],"$1^")).split(/\s+/).join(" ");var ye=K?v[Y]:v[ne],Re=H.split(" ").map(function(qe){return function(Ge,Xe){return $("comp",Ge),Ge=function(it,lt){return it.trim().split(/\s+/).map(function(at){return function(et,Ae){$("caret",et,Ae);var Se=Ae?v[j]:v[O];return et.replace(Se,function(He,te,se,De,Ve){var Ke;return $("caret",et,He,te,se,De,Ve),pe(te)?Ke="":pe(se)?Ke=">="+te+".0.0 <"+(+te+1)+".0.0":pe(De)?Ke=te==="0"?">="+te+"."+se+".0 <"+te+"."+(+se+1)+".0":">="+te+"."+se+".0 <"+(+te+1)+".0.0":Ve?($("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ke=te==="0"?se==="0"?">="+te+"."+se+"."+De+Ve+" <"+te+"."+se+"."+(+De+1):">="+te+"."+se+"."+De+Ve+" <"+te+"."+(+se+1)+".0":">="+te+"."+se+"."+De+Ve+" <"+(+te+1)+".0.0"):($("no pr"),Ke=te==="0"?se==="0"?">="+te+"."+se+"."+De+" <"+te+"."+se+"."+(+De+1):">="+te+"."+se+"."+De+" <"+te+"."+(+se+1)+".0":">="+te+"."+se+"."+De+" <"+(+te+1)+".0.0"),$("caret return",Ke),Ke})}(at,lt)}).join(" ")}(Ge,Xe),$("caret",Ge),Ge=function(it,lt){return it.trim().split(/\s+/).map(function(at){return function(et,Ae){var Se=Ae?v[z]:v[U];return et.replace(Se,function(He,te,se,De,Ve){var Ke;return $("tilde",et,He,te,se,De,Ve),pe(te)?Ke="":pe(se)?Ke=">="+te+".0.0 <"+(+te+1)+".0.0":pe(De)?Ke=">="+te+"."+se+".0 <"+te+"."+(+se+1)+".0":Ve?($("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ke=">="+te+"."+se+"."+De+Ve+" <"+te+"."+(+se+1)+".0"):Ke=">="+te+"."+se+"."+De+" <"+te+"."+(+se+1)+".0",$("tilde return",Ke),Ke})}(at,lt)}).join(" ")}(Ge,Xe),$("tildes",Ge),Ge=function(it,lt){return $("replaceXRanges",it,lt),it.split(/\s+/).map(function(at){return function(et,Ae){et=et.trim();var Se=Ae?v[f]:v[g];return et.replace(Se,function(He,te,se,De,Ve,Ke){$("xRange",et,He,te,se,De,Ve,Ke);var nt=pe(se),st=nt||pe(De),je=st||pe(Ve);return te==="="&&je&&(te=""),nt?He=te===">"||te==="<"?"<0.0.0":"*":te&&je?(st&&(De=0),je&&(Ve=0),te===">"?(te=">=",st?(se=+se+1,De=0,Ve=0):je&&(De=+De+1,Ve=0)):te==="<="&&(te="<",st?se=+se+1:De=+De+1),He=te+se+"."+De+"."+Ve):st?He=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(He=">="+se+"."+De+".0 <"+se+"."+(+De+1)+".0"),$("xRange return",He),He})}(at,lt)}).join(" ")}(Ge,Xe),$("xrange",Ge),Ge=function(it,lt){return $("replaceStars",it,lt),it.trim().replace(v[ce],"")}(Ge,Xe),$("stars",Ge),Ge}(qe,K)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(qe){return!!qe.match(ye)})),Re=Re.map(function(qe){return new he(qe,K)})},Pe.prototype.intersects=function(H,K){if(!(H instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(ye){return H.set.some(function(Re){return Re.every(function(qe){return ye.intersects(qe,K)})})})})},e.toComparators=function(H,K){return new Pe(H,K).set.map(function(oe){return oe.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new re(H,this.loose));for(var K=0;K<this.set.length;K++)if(Me(this.set[K],H))return!0;return!1},e.satisfies=W,e.maxSatisfying=function(H,K,oe){var ye=null,Re=null;try{var qe=new Pe(K,oe)}catch{return null}return H.forEach(function(Ge){qe.test(Ge)&&(ye&&Re.compare(Ge)!==-1||(Re=new re(ye=Ge,oe)))}),ye},e.minSatisfying=function(H,K,oe){var ye=null,Re=null;try{var qe=new Pe(K,oe)}catch{return null}return H.forEach(function(Ge){qe.test(Ge)&&(ye&&Re.compare(Ge)!==1||(Re=new re(ye=Ge,oe)))}),ye},e.validRange=function(H,K){try{return new Pe(H,K).range||"*"}catch{return null}},e.ltr=function(H,K,oe){return x(H,K,"<",oe)},e.gtr=function(H,K,oe){return x(H,K,">",oe)},e.outside=x,e.prerelease=function(H,K){var oe=fe(H,K);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(H,K,oe){return H=new Pe(H,oe),K=new Pe(K,oe),H.intersects(K)},e.coerce=function(H){if(H instanceof re)return H;if(typeof H!="string")return null;var K=H.match(v[y]);return K==null?null:fe((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,I(1))},function(me,e){var I,F,$=me.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function v(w){if(I===setTimeout)return setTimeout(w,0);if((I===L||!I)&&setTimeout)return I=setTimeout,setTimeout(w,0);try{return I(w,0)}catch{try{return I.call(null,w,0)}catch{return I.call(this,w,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:L}catch{I=L}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var p,k=[],R=!1,C=-1;function m(){R&&p&&(R=!1,p.length?k=p.concat(k):C=-1,k.length&&E())}function E(){if(!R){var w=v(m);R=!0;for(var s=k.length;s;){for(p=k,k=[];++C<s;)p&&p[C].run();C=-1,s=k.length}p=null,R=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(w)}}function S(w,s){this.fun=w,this.array=s}function l(){}$.nextTick=function(w){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];k.push(new S(w,s)),k.length!==1||R||v(E)},S.prototype.run=function(){this.fun.apply(null,this.array)},$.title="browser",$.browser=!0,$.env={},$.argv=[],$.version="",$.versions={},$.on=l,$.addListener=l,$.once=l,$.off=l,$.removeListener=l,$.removeAllListeners=l,$.emit=l,$.prependListener=l,$.prependOnceListener=l,$.listeners=function(w){return[]},$.binding=function(w){throw new Error("process.binding is not supported")},$.cwd=function(){return"/"},$.chdir=function(w){throw new Error("process.chdir is not supported")},$.umask=function(){return 0}}])}),define(Ce[38],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=I&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Ud=F}),define(Ce[4],Ie([1,0,14,75,3,76,38]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.Event=void 0;const v=!1,p=!1;var k;(function(g){g.None=()=>$.$Tc.None;function f(V){if(p){const{onDidAddListener:Z}=V,he=S.create();let be=0;V.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),Z?.()}}}function y(V,Z){return ne(V,()=>{},0,void 0,!0,void 0,Z)}g.defer=y;function P(V){return(Z,he=null,be)=>{let Pe=!1,pe;return pe=V(Le=>{if(!Pe)return pe?pe.dispose():Pe=!0,Z.call(he,Le)},null,be),Pe&&pe.dispose(),pe}}g.once=P;function T(V,Z,he){return j((be,Pe=null,pe)=>V(Le=>be.call(Pe,Z(Le)),null,pe),he)}g.map=T;function U(V,Z,he){return j((be,Pe=null,pe)=>V(Le=>{Z(Le),be.call(Pe,Le)},null,pe),he)}g.forEach=U;function z(V,Z,he){return j((be,Pe=null,pe)=>V(Le=>Z(Le)&&be.call(Pe,Le),null,pe),he)}g.filter=z;function M(V){return V}g.signal=M;function N(...V){return(Z,he=null,be)=>{const Pe=(0,$.$Qc)(...V.map(pe=>pe(Le=>Z.call(he,Le))));return Y(Pe,be)}}g.any=N;function O(V,Z,he,be){let Pe=he;return T(V,pe=>(Pe=Z(Pe,pe),Pe),be)}g.reduce=O;function j(V,Z){let he;const be={onWillAddFirstListener(){he=V(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};Z||f(be);const Pe=new n(be);return Z?.add(Pe),Pe.event}function Y(V,Z){return Z instanceof Array?Z.push(V):Z&&Z.add(V),V}function ne(V,Z,he=100,be=!1,Pe=!1,pe,Le){let Me,W,x,H=0,K;const oe={leakWarningThreshold:pe,onWillAddFirstListener(){Me=V(Re=>{H++,W=Z(W,Re),be&&!x&&(ye.fire(W),W=void 0),K=()=>{const qe=W;W=void 0,x=void 0,(!be||H>1)&&ye.fire(qe),H=0},typeof he=="number"?(clearTimeout(x),x=setTimeout(K,he)):x===void 0&&(x=0,queueMicrotask(K))})},onWillRemoveListener(){Pe&&H>0&&K?.()},onDidRemoveLastListener(){K=void 0,Me.dispose()}};Le||f(oe);const ye=new n(oe);return Le?.add(ye),ye.event}g.debounce=ne;function ee(V,Z=0,he){return g.debounce(V,(be,Pe)=>be?(be.push(Pe),be):[Pe],Z,void 0,!0,void 0,he)}g.accumulate=ee;function Q(V,Z=(be,Pe)=>be===Pe,he){let be=!0,Pe;return z(V,pe=>{const Le=be||!Z(pe,Pe);return be=!1,Pe=pe,Le},he)}g.latch=Q;function X(V,Z,he){return[g.filter(V,Z,he),g.filter(V,be=>!Z(be),he)]}g.split=X;function ce(V,Z=!1,he=[],be){let Pe=he.slice(),pe=V(W=>{Pe?Pe.push(W):Me.fire(W)});be&&be.add(pe);const Le=()=>{Pe?.forEach(W=>Me.fire(W)),Pe=null},Me=new n({onWillAddFirstListener(){pe||(pe=V(W=>Me.fire(W)),be&&be.add(pe))},onDidAddFirstListener(){Pe&&(Z?setTimeout(Le):Le())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return be&&be.add(Me),Me.event}g.buffer=ce;function ie(V,Z){return(be,Pe,pe)=>{const Le=Z(new re);return V(function(Me){const W=Le.evaluate(Me);W!==fe&&be.call(Pe,W)},void 0,pe)}}g.chain=ie;const fe=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(Z){return this.f.push(Z),this}forEach(Z){return this.f.push(he=>(Z(he),he)),this}filter(Z){return this.f.push(he=>Z(he)?he:fe),this}reduce(Z,he){let be=he;return this.f.push(Pe=>(be=Z(be,Pe),be)),this}latch(Z=(he,be)=>he===be){let he=!0,be;return this.f.push(Pe=>{const pe=he||!Z(Pe,be);return he=!1,be=Pe,pe?Pe:fe}),this}evaluate(Z){for(const he of this.f)if(Z=he(Z),Z===fe)break;return Z}}function J(V,Z,he=be=>be){const be=(...Me)=>Le.fire(he(...Me)),Pe=()=>V.on(Z,be),pe=()=>V.removeListener(Z,be),Le=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Le.event}g.fromNodeEventEmitter=J;function B(V,Z,he=be=>be){const be=(...Me)=>Le.fire(he(...Me)),Pe=()=>V.addEventListener(Z,be),pe=()=>V.removeEventListener(Z,be),Le=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Le.event}g.fromDOMEventEmitter=B;function ae(V){return new Promise(Z=>P(V)(Z))}g.toPromise=ae;function Ee(V){const Z=new n;return V.then(he=>{Z.fire(he)},()=>{Z.fire(void 0)}).finally(()=>{Z.dispose()}),Z.event}g.fromPromise=Ee;function le(V,Z,he){return Z(he),V(be=>Z(be))}g.runAndSubscribe=le;class de{constructor(Z,he){this._observable=Z,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};he||f(be),this.emitter=new n(be),he&&he.add(this.emitter)}beginUpdate(Z){this.f++}handlePossibleChange(Z){}handleChange(Z,he){this.g=!0}endUpdate(Z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(V,Z){return new de(V,Z).emitter.event}g.fromObservable=ue;function ge(V){return(Z,he,be)=>{let Pe=0,pe=!1;const Le={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(V.reportChanges(),pe&&(pe=!1,Z.call(he)))},handlePossibleChange(){},handleChange(){pe=!0}};V.addObserver(Le),V.reportChanges();const Me={dispose(){V.removeObserver(Le)}};return be instanceof $.$Sc?be.add(Me):Array.isArray(be)&&be.push(Me),Me}}g.fromObservableLight=ge})(k||(e.Event=k={}));class R{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${R.f++}`,R.all.add(this)}start(f){this.g=new A.$Ud,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$Wd=R;let C=-1;function m(g){const f=C;return C=g,{dispose(){C=f}}}e.$Xd=m;class E{constructor(f,y=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=y,this.g=0}dispose(){this.f?.clear()}check(f,y){const P=this.threshold;if(P<=0||y<P)return;this.f||(this.f=new Map);const T=this.f.get(f.value)||0;if(this.f.set(f.value,T+1),this.g-=1,this.g<=0){this.g=P*.5;let U,z=0;for(const[M,N]of this.f)(!U||z<N)&&(U=M,z=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${z}):`),console.warn(U)}return()=>{const U=this.f.get(f.value)||0;this.f.set(f.value,U-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class w{constructor(f){this.value=f,this.id=l++}}const s=2,i=(g,f)=>{if(g instanceof w)f(g);else for(let y=0;y<g.length;y++){const P=g[y];P&&f(P)}};class n{constructor(f){this.w=0,this.f=f,this.g=C>0||this.f?.leakWarningThreshold?new E(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const f=this.t;queueMicrotask(()=>{i(f,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,y,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),$.$Tc.None;if(this.m)return $.$Tc.None;y&&(f=f.bind(y));const T=new w(f);let U,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=S.create(),U=this.g.check(T.stack,this.w+1)),v&&(T.stack=z??S.create()),this.t?this.t instanceof w?(this.u??=new a,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const M=(0,$.$Rc)(()=>{U?.(),this.x(T)});return P instanceof $.$Sc?P.add(M):Array.isArray(P)&&P.push(M),M},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,P=y.indexOf(f);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[P]=void 0;const T=this.u.current===this;if(this.w*s<=y.length){let U=0;for(let z=0;z<y.length;z++)y[z]?y[U++]=y[z]:T&&(this.u.end--,U<this.u.i&&this.u.i--);y.length=U}}y(f,y){if(!f)return;const P=this.f?.onListenerError||I.$1;if(!P){f.value(y);return}try{f.value(y)}catch(T){P(T)}}z(f){const y=f.current.t;for(;f.i<f.end;)this.y(y[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,f);else{const y=this.u;y.enqueue(this,f,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Yd=n;const r=()=>new a;e.$Zd=r;class a{constructor(){this.i=-1,this.end=0}enqueue(f,y,P){this.i=0,this.end=P,this.current=f,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(f,y,P){if(this.t)for(this.h||(this.h=new L.$4c),i(this.t,T=>this.h.push([T.value,f]));this.h.size>0&&!y.isCancellationRequested;){const[T,U]=this.h.shift(),z=[],M={...U,token:y,waitUntil:N=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");P&&(N=P(N,T)),z.push(N)}};try{T(M)}catch(N){(0,I.$1)(N);continue}Object.freeze(z),await Promise.allSettled(z).then(N=>{for(const O of N)O.status==="rejected"&&(0,I.$1)(O.reason)})}}}e.$1d=t;class h extends n{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new L.$4c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$2d=h;class c extends h{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$3d=c;class o extends n{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$4d=o;class u{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const y={event:f,listener:null};this.h.push(y),this.g&&this.m(y);const P=()=>{this.g&&this.o(y);const T=this.h.indexOf(y);this.h.splice(T,1)};return(0,$.$Rc)((0,F.$db)(P))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(y=>this.f.fire(y))}o(f){f.listener?.dispose(),f.listener=null}dispose(){this.f.dispose();for(const f of this.h)f.listener?.dispose();this.h=[]}}e.$5d=u;class d{constructor(f,y,P,T){this.f=new $.$Sc;const U=this.f.add(new u),z=this.f.add(new $.$3c);function M(N){z.set(N,U.add(T(N)))}for(const N of f)M(N);this.f.add(y(N=>{M(N)})),this.f.add(P(N=>{z.deleteAndDispose(N)})),this.event=U.event}dispose(){this.f.dispose()}}e.$6d=d;class b{constructor(){this.f=[]}wrapEvent(f){return(y,P,T)=>f(U=>{const z=this.f[this.f.length-1];z?z.push(()=>y.call(P,U)):y.call(P,U)},void 0,T)}bufferEvents(f){const y=[];this.f.push(y);const P=f();return this.f.pop(),y.forEach(T=>T()),P}}e.$7d=b;class D{constructor(){this.f=!1,this.g=k.None,this.h=$.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$8d=D}),define(Ce[22],Ie([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.CancellationToken=void 0;const F=Object.freeze(function(v,p){const k=setTimeout(v.bind(p),0);return{dispose(){clearTimeout(k)}}});var $;(function(v){function p(k){return k===v.None||k===v.Cancelled||k instanceof L?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}v.isCancellationToken=p,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})($||(e.CancellationToken=$={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new I.$Yd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=$.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=$.None}}e.$9d=A}),define(Ce[163],Ie([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=e.$Ie=e.$He=void 0;class F{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new I.$9d,p=this.b(v.token);return this.a={promise:p,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$He=F;class ${constructor(v){this.c=v,this.a=void 0,this.b=void 0}get(v){const p=JSON.stringify(v);return this.b!==p&&(this.b=p,this.a=this.c(v)),this.a}}e.$Ie=$;class L{get cachedValues(){return this.a}constructor(v){this.b=v,this.a=new Map}get(v){if(this.a.has(v))return this.a.get(v);const p=this.b(v);return this.a.set(v,p),p}}e.$Je=L}),define(Ce[98],Ie([1,0,14,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=void 0;function $(r){const a=r;return a?typeof a.read=="function":!1}e.$0d=$;function L(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$$d=L;function A(r){const a=r;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$_d=A;function v(r,a){return new p(r,a)}e.$ae=v;class p{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,I.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let h;switch(a){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const c=h.indexOf(t);c>=0&&h.splice(c,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(r,a){const t=[];let h;for(;(h=r.read())!==null;)t.push(h);return a(t)}e.$be=k;function R(r,a,t){const h=[];let c;for(;(c=r.read())!==null&&h.length<t;)h.push(c);return c===null&&h.length>0?a(h):{read:()=>{if(h.length>0)return h.shift();if(typeof c<"u"){const o=c;return c=void 0,o}return r.read()}}}e.$ce=R;function C(r,a){return new Promise((t,h)=>{const c=[];m(r,{onData:o=>{a&&c.push(o)},onError:o=>{a?h(o):t(void 0)},onEnd:()=>{t(a?a(c):void 0)}})})}e.$de=C;function m(r,a,t){r.on("error",h=>{t?.isCancellationRequested||a.onError(h)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",h=>{t?.isCancellationRequested||a.onData(h)})}e.$ee=m;function E(r,a){return new Promise((t,h)=>{const c=new F.$Sc,o=[],u=D=>{if(o.push(D),o.length>a)return c.dispose(),r.pause(),t({stream:r,buffer:o,ended:!1})},d=D=>(c.dispose(),h(D)),b=()=>(c.dispose(),t({stream:r,buffer:o,ended:!0}));c.add((0,F.$Rc)(()=>r.removeListener("error",d))),r.on("error",d),c.add((0,F.$Rc)(()=>r.removeListener("end",b))),r.on("end",b),c.add((0,F.$Rc)(()=>r.removeListener("data",u))),r.on("data",u)})}e.$fe=E;function S(r,a){const t=v(a);return t.end(r),t}e.$ge=S;function l(){const r=v(()=>{throw new Error("not supported")});return r.end(),r}e.$he=l;function w(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}e.$ie=w;function s(r,a,t){const h=v(t);return m(r,{onData:c=>h.write(a.data(c)),onError:c=>h.error(a.error?a.error(c):c),onEnd:()=>h.end()}),h}e.$je=s;function i(r,a,t){let h=!1;return{read:()=>{const c=a.read();return h?c:(h=!0,c!==null?t([r,c]):r)}}}e.$ke=i;function n(r,a,t){let h=!1;const c=v(t);return m(a,{onData:o=>h?c.write(o):(h=!0,c.write(t([r,o]))),onError:o=>c.error(o),onEnd:()=>{h||(h=!0,c.write(r)),c.end()}}),c}e.$le=n}),define(Ce[21],Ie([1,0,43,98]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;const $=typeof Buffer<"u",L=new I.$V(()=>new Uint8Array(256));let A,v;class p{static alloc(y){return $?new p(Buffer.allocUnsafe(y)):new p(new Uint8Array(y))}static wrap(y){return $&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new p(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&$?new p(Buffer.from(y)):(A||(A=new TextEncoder),new p(A.encode(y)))}static fromByteArray(y){const P=p.alloc(y.length);for(let T=0,U=y.length;T<U;T++)P.buffer[T]=y[T];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let z=0,M=y.length;z<M;z++)P+=y[z].byteLength}const T=p.alloc(P);let U=0;for(let z=0,M=y.length;z<M;z++){const N=y[z];T.set(N,U),U+=N.byteLength}return T}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=p.alloc(this.byteLength);return y.set(this),y}toString(){return $?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(y,P){return new p(this.buffer.subarray(y,P))}set(y,P){if(y instanceof p)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return m(this.buffer,y)}writeUInt32BE(y,P){E(this.buffer,y,P)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,P){l(this.buffer,y,P)}readUInt8(y){return w(this.buffer,y)}writeUInt8(y,P){s(this.buffer,y,P)}indexOf(y,P=0){return k(this.buffer,y instanceof p?y.buffer:y,P)}}e.$me=p;function k(f,y,P=0){const T=y.byteLength,U=f.byteLength;if(T===0)return 0;if(T===1)return f.indexOf(y[0]);if(T>U-P)return-1;const z=L.value;z.fill(y.length);for(let j=0;j<y.length;j++)z[y[j]]=y.length-j-1;let M=P+y.length-1,N=M,O=-1;for(;M<U;)if(f[M]===y[N]){if(N===0){O=M;break}M--,N--}else M+=Math.max(y.length-N,z[f[M]]),N=y.length-1;return O}e.$ne=k;function R(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0}e.$oe=R;function C(f,y,P){f[P+0]=y&255,y=y>>>8,f[P+1]=y&255}e.$pe=C;function m(f,y){return f[y]*2**24+f[y+1]*2**16+f[y+2]*2**8+f[y+3]}e.$qe=m;function E(f,y,P){f[P+3]=y,y=y>>>8,f[P+2]=y,y=y>>>8,f[P+1]=y,y=y>>>8,f[P]=y}e.$re=E;function S(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0|f[y+2]<<16>>>0|f[y+3]<<24>>>0}e.$se=S;function l(f,y,P){f[P+0]=y&255,y=y>>>8,f[P+1]=y&255,y=y>>>8,f[P+2]=y&255,y=y>>>8,f[P+3]=y&255}e.$te=l;function w(f,y){return f[y]}e.$ue=w;function s(f,y,P){f[P]=y}e.$ve=s;function i(f){return F.$be(f,y=>p.concat(y))}e.$we=i;function n(f){return F.$ie(f)}e.$xe=n;function r(f){return F.$de(f,y=>p.concat(y))}e.$ye=r;async function a(f){return f.ended?p.concat(f.buffer):p.concat([...f.buffer,await r(f.stream)])}e.$ze=a;function t(f){return F.$ge(f,y=>p.concat(y))}e.$Ae=t;function h(f){return F.$je(f,{data:y=>typeof y=="string"?p.fromString(y):p.wrap(y)},y=>p.concat(y))}e.$Be=h;function c(f){return F.$ae(y=>p.concat(y),f)}e.$Ce=c;function o(f,y){return F.$ke(f,y,P=>p.concat(P))}e.$De=o;function u(f,y){return F.$le(f,y,P=>p.concat(P))}e.$Ee=u;function d(f){let y=0,P=0,T=0;const U=new Uint8Array(Math.floor(f.length/4*3)),z=N=>{switch(P){case 3:U[T++]=y|N,P=0;break;case 2:U[T++]=y|N>>>2,y=N<<6,P=3;break;case 1:U[T++]=y|N>>>4,y=N<<4,P=2;break;default:y=N<<2,P=1}};for(let N=0;N<f.length;N++){const O=f.charCodeAt(N);if(O>=65&&O<=90)z(O-65);else if(O>=97&&O<=122)z(O-97+26);else if(O>=48&&O<=57)z(O-48+52);else if(O===43||O===45)z(62);else if(O===47||O===95)z(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${f[N]}`)}}const M=T;for(;P>0;)z(0);return p.wrap(U).slice(0,M)}e.$Fe=d;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:f},y=!0,P=!1){const T=P?D:b;let U="";const z=f.byteLength%3;let M=0;for(;M<f.byteLength-z;M+=3){const N=f[M+0],O=f[M+1],j=f[M+2];U+=T[N>>>2],U+=T[(N<<4|O>>>4)&63],U+=T[(O<<2|j>>>6)&63],U+=T[j&63]}if(z===1){const N=f[M+0];U+=T[N>>>2],U+=T[N<<4&63],y&&(U+="==")}else if(z===2){const N=f[M+0],O=f[M+1];U+=T[N>>>2],U+=T[(N<<4|O>>>4)&63],U+=T[O<<2&63],y&&(U+="=")}return U}e.$Ge=g}),define(Ce[12],Ie([1,0,163,43]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lf=e.$Kf=e.$Jf=e.$If=e.GraphemeBreakType=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=void 0;function $(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Me=$;const L=/{(\d+)}/g;function A(Ae,...Se){return Se.length===0?Ae:Ae.replace(L,function(He,te){const se=parseInt(te,10);return isNaN(se)||se<0||se>=Se.length?He:Se[se]})}e.$Ne=A;const v=/{([^}]+)}/g;function p(Ae,Se){return Object.keys(Se).length===0?Ae:Ae.replace(v,(He,te)=>Se[te]??He)}e.$Oe=p;function k(Ae){return Ae.replace(/[<>"'&]/g,Se=>{switch(Se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Se})}e.$Pe=k;function R(Ae){return Ae.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}e.$Qe=R;function C(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Re=C;function m(Ae,Se){let He=0;const te=Se.charCodeAt(0);for(let se=Ae.length-1;se>=0;se--)Ae.charCodeAt(se)===te&&He++;return He}e.$Se=m;function E(Ae,Se,He="\u2026"){return Ae.length<=Se?Ae:`${Ae.substr(0,Se)}${He}`}e.$Te=E;function S(Ae,Se,He="\u2026"){if(Ae.length<=Se)return Ae;const te=Math.ceil(Se/2)-He.length/2,se=Math.floor(Se/2)-He.length/2;return`${Ae.substr(0,te)}${He}${Ae.substr(Ae.length-se)}`}e.$Ue=S;function l(Ae,Se=" "){const He=w(Ae,Se);return s(He,Se)}e.$Ve=l;function w(Ae,Se){if(!Ae||!Se)return Ae;const He=Se.length;if(He===0||Ae.length===0)return Ae;let te=0;for(;Ae.indexOf(Se,te)===te;)te=te+He;return Ae.substring(te)}e.$We=w;function s(Ae,Se){if(!Ae||!Se)return Ae;const He=Se.length,te=Ae.length;if(He===0||te===0)return Ae;let se=te,De=-1;for(;De=Ae.lastIndexOf(Se,se-1),!(De===-1||De+He!==se);){if(De===0)return"";se=De}return Ae.substring(0,se)}e.$Xe=s;function i(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ye=i;function n(Ae){return Ae.replace(/\*/g,"")}e.$Ze=n;function r(Ae,Se,He={}){if(!Ae)throw new Error("Cannot create regex from empty string");Se||(Ae=C(Ae)),He.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let te="";return He.global&&(te+="g"),He.matchCase||(te+="i"),He.multiline&&(te+="m"),He.unicode&&(te+="u"),new RegExp(Ae,te)}e.$1e=r;function a(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$2e=a;function t(Ae){return Ae.split(/\r\n|\r|\n/)}e.$3e=t;function h(Ae){const Se=[],He=Ae.split(/(\r\n|\r|\n)/);for(let te=0;te<Math.ceil(He.length/2);te++)Se.push(He[2*te]+(He[2*te+1]??""));return Se}e.$4e=h;function c(Ae){for(let Se=0,He=Ae.length;Se<He;Se++){const te=Ae.charCodeAt(Se);if(te!==32&&te!==9)return Se}return-1}e.$5e=c;function o(Ae,Se=0,He=Ae.length){for(let te=Se;te<He;te++){const se=Ae.charCodeAt(te);if(se!==32&&se!==9)return Ae.substring(Se,te)}return Ae.substring(Se,He)}e.$6e=o;function u(Ae,Se=Ae.length-1){for(let He=Se;He>=0;He--){const te=Ae.charCodeAt(He);if(te!==32&&te!==9)return He}return-1}e.$7e=u;function d(Ae,Se,He){const te=[];let se=0;for(const De of Ae.matchAll(Se)){if(te.push(Ae.slice(se,De.index)),De.index===void 0)throw new Error("match.index should be defined");se=De.index+De[0].length,te.push(He(De[0],...De.slice(1),De.index,Ae,De.groups))}return te.push(Ae.slice(se)),Promise.all(te).then(De=>De.join(""))}e.$8e=d;function b(Ae,Se){return Ae<Se?-1:Ae>Se?1:0}e.$9e=b;function D(Ae,Se,He=0,te=Ae.length,se=0,De=Se.length){for(;He<te&&se<De;He++,se++){const nt=Ae.charCodeAt(He),st=Se.charCodeAt(se);if(nt<st)return-1;if(nt>st)return 1}const Ve=te-He,Ke=De-se;return Ve<Ke?-1:Ve>Ke?1:0}e.$0e=D;function g(Ae,Se){return f(Ae,Se,0,Ae.length,0,Se.length)}e.$$e=g;function f(Ae,Se,He=0,te=Ae.length,se=0,De=Se.length){for(;He<te&&se<De;He++,se++){let nt=Ae.charCodeAt(He),st=Se.charCodeAt(se);if(nt===st)continue;if(nt>=128||st>=128)return D(Ae.toLowerCase(),Se.toLowerCase(),He,te,se,De);P(nt)&&(nt-=32),P(st)&&(st-=32);const je=nt-st;if(je!==0)return je}const Ve=te-He,Ke=De-se;return Ve<Ke?-1:Ve>Ke?1:0}e.$_e=f;function y(Ae){return Ae>=48&&Ae<=57}e.$af=y;function P(Ae){return Ae>=97&&Ae<=122}e.$bf=P;function T(Ae){return Ae>=65&&Ae<=90}e.$cf=T;function U(Ae,Se){return Ae.length===Se.length&&f(Ae,Se)===0}e.$df=U;function z(Ae,Se){const He=Se.length;return Se.length>Ae.length?!1:f(Ae,Se,0,He)===0}e.$ef=z;function M(Ae,Se){const He=Math.min(Ae.length,Se.length);let te;for(te=0;te<He;te++)if(Ae.charCodeAt(te)!==Se.charCodeAt(te))return te;return He}e.$ff=M;function N(Ae,Se){const He=Math.min(Ae.length,Se.length);let te;const se=Ae.length-1,De=Se.length-1;for(te=0;te<He;te++)if(Ae.charCodeAt(se-te)!==Se.charCodeAt(De-te))return te;return He}e.$gf=N;function O(Ae){return 55296<=Ae&&Ae<=56319}e.$hf=O;function j(Ae){return 56320<=Ae&&Ae<=57343}e.$if=j;function Y(Ae,Se){return(Ae-55296<<10)+(Se-56320)+65536}e.$jf=Y;function ne(Ae,Se,He){const te=Ae.charCodeAt(He);if(O(te)&&He+1<Se){const se=Ae.charCodeAt(He+1);if(j(se))return Y(te,se)}return te}e.$kf=ne;function ee(Ae,Se){const He=Ae.charCodeAt(Se-1);if(j(He)&&Se>1){const te=Ae.charCodeAt(Se-2);if(O(te))return Y(te,He)}return He}class Q{get offset(){return this.e}constructor(Se,He=0){this.c=Se,this.d=Se.length,this.e=He}setOffset(Se){this.e=Se}prevCodePoint(){const Se=ee(this.c,this.e);return this.e-=Se>=65536?2:1,Se}nextCodePoint(){const Se=ne(this.c,this.d,this.e);return this.e+=Se>=65536?2:1,Se}eol(){return this.e>=this.d}}e.$lf=Q;class X{get offset(){return this.c.offset}constructor(Se,He=0){this.c=new Q(Se,He)}nextGraphemeLength(){const Se=Re.getInstance(),He=this.c,te=He.offset;let se=Se.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const De=He.offset,Ve=Se.getGraphemeBreakType(He.nextCodePoint());if(oe(se,Ve)){He.setOffset(De);break}se=Ve}return He.offset-te}prevGraphemeLength(){const Se=Re.getInstance(),He=this.c,te=He.offset;let se=Se.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const De=He.offset,Ve=Se.getGraphemeBreakType(He.prevCodePoint());if(oe(Ve,se)){He.setOffset(De);break}se=Ve}return te-He.offset}eol(){return this.c.eol()}}e.$mf=X;function ce(Ae,Se){return new X(Ae,Se).nextGraphemeLength()}e.$nf=ce;function ie(Ae,Se){return new X(Ae,Se).prevGraphemeLength()}e.$of=ie;function fe(Ae,Se){Se>0&&j(Ae.charCodeAt(Se))&&Se--;const He=Se+ce(Ae,Se);return[He-ie(Ae,He),He]}e.$pf=fe;function re(Ae){const Se=new X(Ae);let He=0;for(;!Se.eol();)He++,Se.nextGraphemeLength();return He}e.$qf=re;let J;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Ae){return J||(J=B()),J.test(Ae)}e.$rf=ae;const Ee=/^[\t\n\r\x20-\x7E]*$/;function le(Ae){return Ee.test(Ae)}e.$sf=le,e.$tf=/[\u2028\u2029]/;function de(Ae){return e.$tf.test(Ae)}e.$uf=de;function ue(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$vf=ue;function ge(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$wf=ge;function V(Ae,Se,He=""){const te=Ae.trimStart();if(te.length<Se)return te;const se=/\b/g;let De=0;for(;se.test(te)&&!(te.length-se.lastIndex<Se);)De=se.lastIndex,se.lastIndex+=1;return De===0?te:He+te.substring(De).trimStart()}e.$xf=V;const Z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function be(Ae){return Ae&&(Ae=Ae.replace(Z,"").replace(he,"")),Ae}e.$yf=be,e.$zf="\uFEFF";function Pe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$Af=Pe;function pe(Ae){return Pe(Ae)?Ae.substr(1):Ae}e.$Bf=pe;function Le(Ae,Se){if(!Ae||!Se||Ae.length<Se.length)return!1;const He=Se.length,te=Ae.toLowerCase();let se=0,De=-1;for(;se<He;){const Ve=te.indexOf(Se[se],De+1);if(Ve<0)return!1;De=Ve,se++}return!0}e.$Cf=Le;function Me(Ae,Se=!1){return Ae?(Se&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$Df=Me;function W(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$Ef=W;function x(Ae,Se=1){if(Se===0)return"";let He=-1;do He=Ae.indexOf(`
`,He+1),Se--;while(Se>0&&He>=0);return He===-1?Ae:(Ae[He-1]==="\r"&&He--,Ae.substr(0,He))}e.$Ff=x;function H(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$Gf=H;function K(Ae){return Re.getInstance().getGraphemeBreakType(Ae)}e.$Hf=K;function oe(Ae,Se){return Ae===0?Se!==5&&Se!==7:Ae===2&&Se===3?!1:Ae===4||Ae===2||Ae===3||Se===4||Se===2||Se===3?!0:!(Ae===8&&(Se===8||Se===9||Se===11||Se===12)||(Ae===11||Ae===9)&&(Se===9||Se===10)||(Ae===12||Ae===10)&&Se===10||Se===5||Se===13||Se===7||Ae===1||Ae===13&&Se===14||Ae===6&&Se===6)}var ye;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(ye||(e.GraphemeBreakType=ye={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=qe()}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const He=this.d,te=He.length/3;let se=1;for(;se<=te;)if(Se<He[3*se])se=2*se;else if(Se>He[3*se+1])se=2*se+1;else return He[3*se+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(Ae,Se){if(Ae===0)return 0;const He=Xe(Ae,Se);if(He!==void 0)return He;const te=new Q(Se,Ae);return te.prevCodePoint(),te.offset}e.$If=Ge;function Xe(Ae,Se){const He=new Q(Se,Ae);let te=He.prevCodePoint();for(;it(te)||te===65039||te===8419;){if(He.offset===0)return;te=He.prevCodePoint()}if(!ge(te))return;let se=He.offset;return se>0&&He.prevCodePoint()===8205&&(se=He.offset),se}function it(Ae){return 127995<=Ae&&Ae<=127999}var lt;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(lt||(lt={})),e.$Jf="\xA0";class at{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Ie(Se=>{function He(je){const yt=new Map;for(let kt=0;kt<je.length;kt+=2)yt.set(je[kt],je[kt+1]);return yt}function te(je,yt){const kt=new Map(je);for(const[Ot,Rt]of yt)kt.set(Ot,Rt);return kt}function se(je,yt){if(!je)return yt;const kt=new Map;for(const[Ot,Rt]of je)yt.has(Ot)&&kt.set(Ot,Rt);return kt}const De=this.c.value;let Ve=Se.filter(je=>!je.startsWith("_")&&je in De);Ve.length===0&&(Ve=["_default"]);let Ke;for(const je of Ve){const yt=He(De[je]);Ke=se(Ke,yt)}const nt=He(De._common),st=te(nt,Ke);return new at(st)})}static getInstance(Se){return at.d.get(Array.from(Se))}static{this.e=new F.$V(()=>Object.keys(at.c.value).filter(Se=>!Se.startsWith("_")))}static getLocales(){return at.e.value}constructor(Se){this.f=Se}isAmbiguous(Se){return this.f.has(Se)}getPrimaryConfusable(Se){return this.f.get(Se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Kf=at;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Se){return et.e().has(Se)}static get codePoints(){return et.e()}}e.$Lf=et}),define(Ce[123],Ie([1,0,28,162,12]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=e.$$j=e.FuzzyScore=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.or=void 0;function L(...pe){return function(Le,Me){for(let W=0,x=pe.length;W<x;W++){const H=pe[W](Le,Me);if(H)return H}return null}}e.or=L,e.$Yj=A.bind(void 0,!1),e.$Zj=A.bind(void 0,!0);function A(pe,Le,Me){if(!Me||Me.length<Le.length)return null;let W;return pe?W=$.$ef(Me,Le):W=Me.indexOf(Le)===0,W?Le.length>0?[{start:0,end:Le.length}]:[]:null}function v(pe,Le){const Me=Le.toLowerCase().indexOf(pe.toLowerCase());return Me===-1?null:[{start:Me,end:Me+pe.length}]}e.$1j=v;function p(pe,Le){return k(pe.toLowerCase(),Le.toLowerCase(),0,0)}e.$2j=p;function k(pe,Le,Me,W){if(Me===pe.length)return[];if(W===Le.length)return null;if(pe[Me]===Le[W]){let x=null;return(x=k(pe,Le,Me+1,W+1))?r({start:W,end:W+1},x):null}return k(pe,Le,Me,W+1)}function R(pe){return 97<=pe&&pe<=122}function C(pe){return 65<=pe&&pe<=90}e.$3j=C;function m(pe){return 48<=pe&&pe<=57}function E(pe){return pe===32||pe===9||pe===10||pe===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>S.add(pe.charCodeAt(0)));function l(pe){return E(pe)||S.has(pe)}function w(pe,Le){return pe===Le||l(pe)&&l(Le)}const s=new Map;function i(pe){if(s.has(pe))return s.get(pe);let Le;const Me=(0,F.$Wj)(pe);return Me&&(Le=Me),s.set(pe,Le),Le}function n(pe){return R(pe)||C(pe)||m(pe)}function r(pe,Le){return Le.length===0?Le=[pe]:pe.end===Le[0].start?Le[0].start=pe.start:Le.unshift(pe),Le}function a(pe,Le){for(let Me=Le;Me<pe.length;Me++){const W=pe.charCodeAt(Me);if(C(W)||m(W)||Me>0&&!n(pe.charCodeAt(Me-1)))return Me}return pe.length}function t(pe,Le,Me,W){if(Me===pe.length)return[];if(W===Le.length)return null;if(pe[Me]!==Le[W].toLowerCase())return null;{let x=null,H=W+1;for(x=t(pe,Le,Me+1,W+1);!x&&(H=a(Le,H))<Le.length;)x=t(pe,Le,Me+1,H),H++;return x===null?null:r({start:W,end:W+1},x)}}function h(pe){let Le=0,Me=0,W=0,x=0,H=0;for(let qe=0;qe<pe.length;qe++)H=pe.charCodeAt(qe),C(H)&&Le++,R(H)&&Me++,n(H)&&W++,m(H)&&x++;const K=Le/pe.length,oe=Me/pe.length,ye=W/pe.length,Re=x/pe.length;return{upperPercent:K,lowerPercent:oe,alphaPercent:ye,numericPercent:Re}}function c(pe){const{upperPercent:Le,lowerPercent:Me}=pe;return Me===0&&Le>.6}function o(pe){const{upperPercent:Le,lowerPercent:Me,alphaPercent:W,numericPercent:x}=pe;return Me>.2&&Le<.8&&W>.6&&x<.2}function u(pe){let Le=0,Me=0,W=0,x=0;for(let H=0;H<pe.length;H++)W=pe.charCodeAt(H),C(W)&&Le++,R(W)&&Me++,E(W)&&x++;return(Le===0||Me===0)&&x===0?pe.length<=30:Le<=5}function d(pe,Le){if(!Le||(Le=Le.trim(),Le.length===0)||!u(pe))return null;Le.length>60&&(Le=Le.substring(0,60));const Me=h(Le);if(!o(Me)){if(!c(Me))return null;Le=Le.toLowerCase()}let W=null,x=0;for(pe=pe.toLowerCase();x<Le.length&&(W=t(pe,Le,0,x))===null;)x=a(Le,x+1);return W}e.$4j=d;function b(pe,Le,Me=!1){if(!Le||Le.length===0)return null;let W=null,x=0;for(pe=pe.toLowerCase(),Le=Le.toLowerCase();x<Le.length&&(W=D(pe,Le,0,x,Me),W===null);)x=g(Le,x+1);return W}e.$5j=b;function D(pe,Le,Me,W,x){let H=0;if(Me===pe.length)return[];if(W===Le.length)return null;if(!w(pe.charCodeAt(Me),Le.charCodeAt(W))){const ye=i(pe.charCodeAt(Me));if(!ye)return null;for(let Re=0;Re<ye.length;Re++)if(!w(ye[Re],Le.charCodeAt(W+Re)))return null;H+=ye.length-1}let K=null,oe=W+H+1;if(K=D(pe,Le,Me+1,oe,x),!x)for(;!K&&(oe=g(Le,oe))<Le.length;)K=D(pe,Le,Me+1,oe,x),oe++;if(!K)return null;if(pe.charCodeAt(Me)!==Le.charCodeAt(W)){const ye=i(pe.charCodeAt(Me));if(!ye)return K;for(let Re=0;Re<ye.length;Re++)if(ye[Re]!==Le.charCodeAt(W+Re))return K}return r({start:W,end:W+H+1},K)}function g(pe,Le){for(let Me=Le;Me<pe.length;Me++)if(l(pe.charCodeAt(Me))||Me>0&&l(pe.charCodeAt(Me-1)))return Me;return pe.length}const f=L(e.$Zj,d,v),y=L(e.$Zj,d,p),P=new I.$Dc(1e4);function T(pe,Le,Me=!1){if(typeof pe!="string"||typeof Le!="string")return null;let W=P.get(pe);W||(W=new RegExp($.$Ye(pe),"i"),P.set(pe,W));const x=W.exec(Le);return x?[{start:x.index,end:x.index+x[0].length}]:Me?y(pe,Le):f(pe,Le)}e.$6j=T;function U(pe,Le){const Me=ue(pe,pe.toLowerCase(),0,Le,Le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Me?M(Me):null}e.$7j=U;function z(pe,Le,Me,W,x,H){const K=Math.min(13,pe.length);for(;Me<K;Me++){const oe=ue(pe,Le,Me,W,x,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,H]}e.$8j=z;function M(pe){if(typeof pe>"u")return[];const Le=[],Me=pe[1];for(let W=pe.length-1;W>1;W--){const x=pe[W]+Me,H=Le[Le.length-1];H&&H.end===x?H.end=x+1:Le.push({start:x,end:x+1})}return Le}e.$9j=M;const N=128;function O(){const pe=[],Le=[];for(let Me=0;Me<=N;Me++)Le[Me]=0;for(let Me=0;Me<=N;Me++)pe.push(Le.slice(0));return pe}function j(pe){const Le=[];for(let Me=0;Me<=pe;Me++)Le[Me]=0;return Le}const Y=j(2*N),ne=j(2*N),ee=O(),Q=O(),X=O(),ce=!1;function ie(pe,Le,Me,W,x){function H(oe,ye,Re=" "){for(;oe.length<ye;)oe=Re+oe;return oe}let K=` |   |${W.split("").map(oe=>H(oe,3)).join("|")}
`;for(let oe=0;oe<=Me;oe++)oe===0?K+=" |":K+=`${Le[oe-1]}|`,K+=pe[oe].slice(0,x+1).map(ye=>H(ye.toString(),3)).join("|")+`
`;return K}function fe(pe,Le,Me,W){pe=pe.substr(Le),Me=Me.substr(W),console.log(ie(Q,pe,pe.length,Me,Me.length)),console.log(ie(X,pe,pe.length,Me,Me.length)),console.log(ie(ee,pe,pe.length,Me,Me.length))}function re(pe,Le){if(Le<0||Le>=pe.length)return!1;const Me=pe.codePointAt(Le);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!$.$wf(Me)}}function J(pe,Le){if(Le<0||Le>=pe.length)return!1;switch(pe.charCodeAt(Le)){case 32:case 9:return!0;default:return!1}}function B(pe,Le,Me){return Le[pe]!==Me[pe]}function ae(pe,Le,Me,W,x,H,K=!1){for(;Le<Me&&x<H;)pe[Le]===W[x]&&(K&&(Y[Le]=x),Le+=1),x+=1;return Le===Me}e.$0j=ae;var Ee;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var le;(function(pe){pe.Default=[-100,0];function Le(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}pe.isDefault=Le})(le||(e.FuzzyScore=le={}));class de{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Le,Me){this.firstMatchCanBeWeak=Le,this.boostFullMatch=Me}}e.$$j=de;function ue(pe,Le,Me,W,x,H,K=de.default){const oe=pe.length>N?N:pe.length,ye=W.length>N?N:W.length;if(Me>=oe||H>=ye||oe-Me>ye-H||!ae(Le,Me,oe,x,H,ye,!0))return;ge(oe,ye,Me,H,Le,x);let Re=1,qe=1,Ge=Me,Xe=H;const it=[!1];for(Re=1,Ge=Me;Ge<oe;Re++,Ge++){const Se=Y[Ge],He=ne[Ge],te=Ge+1<oe?ne[Ge+1]:ye;for(qe=Se-H+1,Xe=Se;Xe<te;qe++,Xe++){let se=Number.MIN_SAFE_INTEGER,De=!1;Xe<=He&&(se=V(pe,Le,Ge,Me,W,x,Xe,ye,H,ee[Re-1][qe-1]===0,it));let Ve=0;se!==Number.MAX_SAFE_INTEGER&&(De=!0,Ve=se+Q[Re-1][qe-1]);const Ke=Xe>Se,nt=Ke?Q[Re][qe-1]+(ee[Re][qe-1]>0?-5:0):0,st=Xe>Se+1&&ee[Re][qe-1]>0,je=st?Q[Re][qe-2]+(ee[Re][qe-2]>0?-5:0):0;if(st&&(!Ke||je>=nt)&&(!De||je>=Ve))Q[Re][qe]=je,X[Re][qe]=3,ee[Re][qe]=0;else if(Ke&&(!De||nt>=Ve))Q[Re][qe]=nt,X[Re][qe]=2,ee[Re][qe]=0;else if(De)Q[Re][qe]=Ve,X[Re][qe]=1,ee[Re][qe]=ee[Re-1][qe-1]+1;else throw new Error("not possible")}}if(ce&&fe(pe,Me,W,H),!it[0]&&!K.firstMatchCanBeWeak)return;Re--,qe--;const lt=[Q[Re][qe],H];let at=0,et=0;for(;Re>=1;){let Se=qe;do{const He=X[Re][Se];if(He===3)Se=Se-2;else if(He===2)Se=Se-1;else break}while(Se>=1);at>1&&Le[Me+Re-1]===x[H+qe-1]&&!B(Se+H-1,W,x)&&at+1>ee[Re][Se]&&(Se=qe),Se===qe?at++:at=1,et||(et=Se),Re--,qe=Se-1,lt.push(qe)}ye===oe&&K.boostFullMatch&&(lt[0]+=2);const Ae=et-oe;return lt[0]-=Ae,lt}e.$_j=ue;function ge(pe,Le,Me,W,x,H){let K=pe-1,oe=Le-1;for(;K>=Me&&oe>=W;)x[K]===H[oe]&&(ne[K]=oe,K--),oe--}function V(pe,Le,Me,W,x,H,K,oe,ye,Re,qe){if(Le[Me]!==H[K])return Number.MIN_SAFE_INTEGER;let Ge=1,Xe=!1;return K===Me-W?Ge=pe[Me]===x[K]?7:5:B(K,x,H)&&(K===0||!B(K-1,x,H))?(Ge=pe[Me]===x[K]?7:5,Xe=!0):re(H,K)&&(K===0||!re(H,K-1))?Ge=5:(re(H,K-1)||J(H,K-1))&&(Ge=5,Xe=!0),Ge>1&&Me===W&&(qe[0]=!0),Xe||(Xe=B(K,x,H)||re(H,K-1)||J(H,K-1)),Me===W?K>ye&&(Ge-=Xe?3:5):Re?Ge+=Xe?2:0:Ge+=Xe?0:1,K+1===oe&&(Ge-=Xe?3:5),Ge}function Z(pe,Le,Me,W,x,H,K){return be(pe,Le,Me,W,x,H,!0,K)}e.$ak=Z;function he(pe,Le,Me,W,x,H,K){return be(pe,Le,Me,W,x,H,!1,K)}e.$bk=he;function be(pe,Le,Me,W,x,H,K,oe){let ye=ue(pe,Le,Me,W,x,H,oe);if(ye&&!K)return ye;if(pe.length>=3){const Re=Math.min(7,pe.length-1);for(let qe=Me+1;qe<Re;qe++){const Ge=Pe(pe,qe);if(Ge){const Xe=ue(Ge,Ge.toLowerCase(),Me,W,x,H,oe);Xe&&(Xe[0]-=3,(!ye||Xe[0]>ye[0])&&(ye=Xe))}}}return ye}function Pe(pe,Le){if(Le+1>=pe.length)return;const Me=pe[Le],W=pe[Le+1];if(Me!==W)return pe.slice(0,Le)+W+Me+pe.slice(Le+2)}}),define(Ce[54],Ie([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=void 0;function F(s){return $(s,0)}e.$Yi=F;function $(s,i){switch(typeof s){case"object":return s===null?L(349,i):Array.isArray(s)?p(s,i):k(s,i);case"string":return v(s,i);case"boolean":return A(s,i);case"number":return L(s,i);case"undefined":return L(937,i);default:return L(617,i)}}e.$Zi=$;function L(s,i){return(i<<5)-i+s|0}e.$1i=L;function A(s,i){return L(s?433:863,i)}function v(s,i){i=L(149417,i);for(let n=0,r=s.length;n<r;n++)i=L(s.charCodeAt(n),i);return i}e.$2i=v;function p(s,i){return i=L(104579,i),s.reduce((n,r)=>$(r,n),i)}function k(s,i){return i=L(181387,i),Object.keys(s).sort().reduce((n,r)=>(n=v(r,n),$(s[r],n)),i)}class R{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=$(i,this.g),this.g}}e.$3i=R;var C;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(s,i,n=32){const r=n-i,a=~((1<<r)-1);return(s<<i|(a&s)>>>r)>>>0}function E(s,i=0,n=s.byteLength,r=0){for(let a=0;a<n;a++)s[i+a]=r}function S(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function l(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((s>>>0).toString(16),i/4)}e.$4i=l;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let a=this.r,t=this.u,h,c;for(t!==0?(h=t,c=-1,t=0):(h=i.charCodeAt(0),c=0);;){let o=h;if(I.$hf(h))if(c+1<n){const u=i.charCodeAt(c+1);I.$if(u)?(c++,o=I.$jf(h,u)):o=65533}else{t=h;break}else I.$if(h)&&(o=65533);if(a=this.w(r,a,o),c++,c<n)h=i.charCodeAt(c);else break}this.r=a,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=w.g,n=this.q;for(let b=0;b<64;b+=4)i.setUint32(b,n.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)i.setUint32(b,m(i.getUint32(b-12,!1)^i.getUint32(b-32,!1)^i.getUint32(b-56,!1)^i.getUint32(b-64,!1),1),!1);let r=this.h,a=this.l,t=this.m,h=this.n,c=this.o,o,u,d;for(let b=0;b<80;b++)b<20?(o=a&t|~a&h,u=1518500249):b<40?(o=a^t^h,u=1859775393):b<60?(o=a&t|a&h|t&h,u=2400959708):(o=a^t^h,u=3395469782),d=m(r,5)+o+c+u+i.getUint32(b*4,!1)&4294967295,c=h,h=t,t=m(a,30),a=r,r=d;this.h=this.h+r&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+h&4294967295,this.o=this.o+c&4294967295}}e.$5i=w}),define(Ce[39],Ie([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function($){$[$.Ignore=0]="Ignore",$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(F||(F={})),function($){const L="error",A="warning",v="warn",p="info",k="ignore";function R(m){return m?I.$df(L,m)?$.Error:I.$df(A,m)||I.$df(v,m)?$.Warning:I.$df(p,m)?$.Info:$.Ignore:$.Ignore}$.fromValue=R;function C(m){switch(m){case $.Error:return L;case $.Warning:return A;case $.Info:return p;default:return k}}$.toString=C}(F||(F={})),e.default=F}),define(Ce[164],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=void 0,e.$Vd=Symbol("MicrotaskDelay")}),define(Ce[78],Ie([1,0,19,12]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=void 0;class ${constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const S=E.charCodeAt(0),l=this.b.charCodeAt(this.c);return S-l}value(){return this.b[this.c]}}e.$ai=$;class L{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,F.$0e)(E,this.b,0,E.length,this.c,this.d):(0,F.$_e)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$bi=L;class A{constructor(E=!0,S=!0){this.f=E,this.g=S}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let S=E.length-1;S>=0;S--,this.c--){const l=this.b.charCodeAt(S);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,F.$0e)(E,this.b,0,E.length,this.d,this.e):(0,F.$_e)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ci=A;var v;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(v||(v={}));class p{constructor(E,S){this.f=E,this.g=S,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,F.$$e)(E,this.c.scheme);if(this.d[this.e]===2)return(0,F.$$e)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,F.$9e)(E,this.c.query);if(this.d[this.e]===5)return(0,F.$9e)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$di=p;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(R||(R={}));class C{static forUris(E=()=>!1,S=()=>!1){return new C(new p(E,S))}static forPaths(E=!1){return new C(new A(void 0,!E))}static forStrings(){return new C(new $)}static forConfigKeys(){return new C(new L)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,S){if(S){const l=S.slice(0);(0,I.$Xb)(l);for(const w of l)this.set(w,E)}else{const l=E.slice(0);(0,I.$Xb)(l);for(const w of l)this.set(w[0],w[1])}}set(E,S){const l=this.b.reset(E);let w;this.c||(this.c=new k,this.c.segment=l.value());const s=[];for(w=this.c;;){const n=l.cmp(w.segment);if(n>0)w.left||(w.left=new k,w.left.segment=l.value()),s.push([-1,w]),w=w.left;else if(n<0)w.right||(w.right=new k,w.right.segment=l.value()),s.push([1,w]),w=w.right;else if(l.hasNext())l.next(),w.mid||(w.mid=new k,w.mid.segment=l.value()),s.push([0,w]),w=w.mid;else break}const i=w.value;w.value=S,w.key=E;for(let n=s.length-1;n>=0;n--){const r=s[n][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=s[n][0],h=s[n+1][0];if(t===1&&h===1)s[n][1]=r.rotateLeft();else if(t===-1&&h===-1)s[n][1]=r.rotateRight();else if(t===1&&h===-1)r.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=r.rotateLeft();else if(t===-1&&h===1)r.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(E){return this.d(E)?.value}d(E){const S=this.b.reset(E);let l=this.c;for(;l;){const w=S.cmp(l.segment);if(w>0)l=l.left;else if(w<0)l=l.right;else if(S.hasNext())S.next(),l=l.mid;else break}return l}has(E){const S=this.d(E);return!(S?.value===void 0&&S?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,S){const l=this.b.reset(E),w=[];let s=this.c;for(;s;){const i=l.cmp(s.segment);if(i>0)w.push([-1,s]),s=s.left;else if(i<0)w.push([1,s]),s=s.right;else if(l.hasNext())l.next(),w.push([0,s]),s=s.mid;else break}if(s){if(S?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:r,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=r,s.segment=a}}else{const i=s.left??s.right;if(w.length>0){const[n,r]=w[w.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=w.length-1;i>=0;i--){const n=w[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),w[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),w[i][1]=n.rotateRight()),i>0)switch(w[i-1][0]){case-1:w[i-1][1].left=w[i][1];break;case 1:w[i-1][1].right=w[i][1];break;case 0:w[i-1][1].mid=w[i][1];break}else this.c=w[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const S=this.b.reset(E);let l=this.c,w;for(;l;){const s=S.cmp(l.segment);if(s>0)l=l.left;else if(s<0)l=l.right;else if(S.hasNext())S.next(),w=l.value||w,l=l.mid;else break}return l&&l.value||w}findSuperstr(E){return this.g(E,!1)}g(E,S){const l=this.b.reset(E);let w=this.c;for(;w;){const s=l.cmp(w.segment);if(s>0)w=w.left;else if(s<0)w=w.right;else if(l.hasNext())l.next(),w=w.mid;else return w.mid?this.h(w.mid):S?w.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[S,l]of this)E(l,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const S=[];return this.j(E,S),S[Symbol.iterator]()}j(E,S){E&&(E.left&&this.j(E.left,S),E.value&&S.push([E.key,E.value]),E.mid&&this.j(E.mid,S),E.right&&this.j(E.right,S))}_isBalanced(){const E=S=>{if(!S)return!0;const l=S.balanceFactor();return l<-1||l>1?!1:E(S.left)&&E(S.right)};return E(this.c)}}e.$ei=C}),define(Ce[18],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=void 0;function I(a){return typeof a=="string"}e.$Mf=I;function F(a){return Array.isArray(a)&&a.every(t=>I(t))}e.$Nf=F;function $(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Of=$;function L(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Pf=L;function A(a){return typeof a=="number"&&!isNaN(a)}e.$Qf=A;function v(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Rf=v;function p(a){return a===!0||a===!1}e.$Sf=p;function k(a){return typeof a>"u"}e.$Tf=k;function R(a){return!C(a)}e.$Uf=R;function C(a){return k(a)||a===null}e.$Vf=C;function m(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Wf=m;function E(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Xf=E;function S(...a){const t=[];for(let h=0;h<a.length;h++){const c=a[h];if(C(c))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);t.push(c)}return t}e.$Yf=S;const l=Object.prototype.hasOwnProperty;function w(a){if(!$(a))return!1;for(const t in a)if(l.call(a,t))return!1;return!0}e.$Zf=w;function s(a){return typeof a=="function"}e.$1f=s;function i(...a){return a.length>0&&a.every(s)}e.$2f=i;function n(a,t){const h=Math.min(a.length,t.length);for(let c=0;c<h;c++)r(a[c],t[c])}e.$3f=n;function r(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!C(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$4f=r}),define(Ce[79],Ie([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ek=e.$dk=e.$ck=void 0;const F=Object.create(null);function $(v,p){if((0,I.$Mf)(p)){const k=F[p];if(k===void 0)throw new Error(`${v} references an unknown codicon: ${p}`);p=k}return F[v]=p,{id:v}}function L(){return F}e.$ck=L;function A(){return Object.values(e.$ek)}e.$dk=A,e.$ek={add:$("add",6e4),plus:$("plus",6e4),gistNew:$("gist-new",6e4),repoCreate:$("repo-create",6e4),lightbulb:$("lightbulb",60001),lightBulb:$("light-bulb",60001),repo:$("repo",60002),repoDelete:$("repo-delete",60002),gistFork:$("gist-fork",60003),repoForked:$("repo-forked",60003),gitPullRequest:$("git-pull-request",60004),gitPullRequestAbandoned:$("git-pull-request-abandoned",60004),recordKeys:$("record-keys",60005),keyboard:$("keyboard",60005),tag:$("tag",60006),tagAdd:$("tag-add",60006),tagRemove:$("tag-remove",60006),gitPullRequestLabel:$("git-pull-request-label",60006),person:$("person",60007),personFollow:$("person-follow",60007),personOutline:$("person-outline",60007),personFilled:$("person-filled",60007),gitBranch:$("git-branch",60008),gitBranchCreate:$("git-branch-create",60008),gitBranchDelete:$("git-branch-delete",60008),sourceControl:$("source-control",60008),mirror:$("mirror",60009),mirrorPublic:$("mirror-public",60009),star:$("star",60010),starAdd:$("star-add",60010),starDelete:$("star-delete",60010),starEmpty:$("star-empty",60010),comment:$("comment",60011),commentAdd:$("comment-add",60011),alert:$("alert",60012),warning:$("warning",60012),search:$("search",60013),searchSave:$("search-save",60013),logOut:$("log-out",60014),signOut:$("sign-out",60014),logIn:$("log-in",60015),signIn:$("sign-in",60015),eye:$("eye",60016),eyeUnwatch:$("eye-unwatch",60016),eyeWatch:$("eye-watch",60016),circleFilled:$("circle-filled",60017),primitiveDot:$("primitive-dot",60017),closeDirty:$("close-dirty",60017),debugBreakpoint:$("debug-breakpoint",60017),debugBreakpointDisabled:$("debug-breakpoint-disabled",60017),debugBreakpointPending:$("debug-breakpoint-pending",60377),debugHint:$("debug-hint",60017),primitiveSquare:$("primitive-square",60018),edit:$("edit",60019),pencil:$("pencil",60019),info:$("info",60020),issueOpened:$("issue-opened",60020),gistPrivate:$("gist-private",60021),gitForkPrivate:$("git-fork-private",60021),lock:$("lock",60021),mirrorPrivate:$("mirror-private",60021),close:$("close",60022),removeClose:$("remove-close",60022),x:$("x",60022),repoSync:$("repo-sync",60023),sync:$("sync",60023),clone:$("clone",60024),desktopDownload:$("desktop-download",60024),beaker:$("beaker",60025),microscope:$("microscope",60025),vm:$("vm",60026),deviceDesktop:$("device-desktop",60026),file:$("file",60027),fileText:$("file-text",60027),more:$("more",60028),ellipsis:$("ellipsis",60028),kebabHorizontal:$("kebab-horizontal",60028),mailReply:$("mail-reply",60029),reply:$("reply",60029),organization:$("organization",60030),organizationFilled:$("organization-filled",60030),organizationOutline:$("organization-outline",60030),newFile:$("new-file",60031),fileAdd:$("file-add",60031),newFolder:$("new-folder",60032),fileDirectoryCreate:$("file-directory-create",60032),trash:$("trash",60033),trashcan:$("trashcan",60033),history:$("history",60034),clock:$("clock",60034),folder:$("folder",60035),fileDirectory:$("file-directory",60035),symbolFolder:$("symbol-folder",60035),logoGithub:$("logo-github",60036),markGithub:$("mark-github",60036),github:$("github",60036),terminal:$("terminal",60037),console:$("console",60037),repl:$("repl",60037),zap:$("zap",60038),symbolEvent:$("symbol-event",60038),error:$("error",60039),stop:$("stop",60039),variable:$("variable",60040),symbolVariable:$("symbol-variable",60040),array:$("array",60042),symbolArray:$("symbol-array",60042),symbolModule:$("symbol-module",60043),symbolPackage:$("symbol-package",60043),symbolNamespace:$("symbol-namespace",60043),symbolObject:$("symbol-object",60043),symbolMethod:$("symbol-method",60044),symbolFunction:$("symbol-function",60044),symbolConstructor:$("symbol-constructor",60044),symbolBoolean:$("symbol-boolean",60047),symbolNull:$("symbol-null",60047),symbolNumeric:$("symbol-numeric",60048),symbolNumber:$("symbol-number",60048),symbolStructure:$("symbol-structure",60049),symbolStruct:$("symbol-struct",60049),symbolParameter:$("symbol-parameter",60050),symbolTypeParameter:$("symbol-type-parameter",60050),symbolKey:$("symbol-key",60051),symbolText:$("symbol-text",60051),symbolReference:$("symbol-reference",60052),goToFile:$("go-to-file",60052),symbolEnum:$("symbol-enum",60053),symbolValue:$("symbol-value",60053),symbolRuler:$("symbol-ruler",60054),symbolUnit:$("symbol-unit",60054),activateBreakpoints:$("activate-breakpoints",60055),archive:$("archive",60056),arrowBoth:$("arrow-both",60057),arrowDown:$("arrow-down",60058),arrowLeft:$("arrow-left",60059),arrowRight:$("arrow-right",60060),arrowSmallDown:$("arrow-small-down",60061),arrowSmallLeft:$("arrow-small-left",60062),arrowSmallRight:$("arrow-small-right",60063),arrowSmallUp:$("arrow-small-up",60064),arrowUp:$("arrow-up",60065),bell:$("bell",60066),bold:$("bold",60067),book:$("book",60068),bookmark:$("bookmark",60069),debugBreakpointConditionalUnverified:$("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:$("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:$("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:$("debug-breakpoint-data-unverified",60072),debugBreakpointData:$("debug-breakpoint-data",60073),debugBreakpointDataDisabled:$("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:$("debug-breakpoint-log-unverified",60074),debugBreakpointLog:$("debug-breakpoint-log",60075),debugBreakpointLogDisabled:$("debug-breakpoint-log-disabled",60075),briefcase:$("briefcase",60076),broadcast:$("broadcast",60077),browser:$("browser",60078),bug:$("bug",60079),calendar:$("calendar",60080),caseSensitive:$("case-sensitive",60081),check:$("check",60082),checklist:$("checklist",60083),chevronDown:$("chevron-down",60084),dropDownButton:$("drop-down-button",60084),chevronLeft:$("chevron-left",60085),chevronRight:$("chevron-right",60086),chevronUp:$("chevron-up",60087),chromeClose:$("chrome-close",60088),chromeMaximize:$("chrome-maximize",60089),chromeMinimize:$("chrome-minimize",60090),chromeRestore:$("chrome-restore",60091),circle:$("circle",60092),circleOutline:$("circle-outline",60092),debugBreakpointUnverified:$("debug-breakpoint-unverified",60092),circleSlash:$("circle-slash",60093),circuitBoard:$("circuit-board",60094),clearAll:$("clear-all",60095),clippy:$("clippy",60096),closeAll:$("close-all",60097),cloudDownload:$("cloud-download",60098),cloudUpload:$("cloud-upload",60099),code:$("code",60100),collapseAll:$("collapse-all",60101),colorMode:$("color-mode",60102),commentDiscussion:$("comment-discussion",60103),compareChanges:$("compare-changes",60157),creditCard:$("credit-card",60105),dash:$("dash",60108),dashboard:$("dashboard",60109),database:$("database",60110),debugContinue:$("debug-continue",60111),debugDisconnect:$("debug-disconnect",60112),debugPause:$("debug-pause",60113),debugRestart:$("debug-restart",60114),debugStart:$("debug-start",60115),debugStepInto:$("debug-step-into",60116),debugStepOut:$("debug-step-out",60117),debugStepOver:$("debug-step-over",60118),debugStop:$("debug-stop",60119),debug:$("debug",60120),deviceCameraVideo:$("device-camera-video",60121),deviceCamera:$("device-camera",60122),deviceMobile:$("device-mobile",60123),diffAdded:$("diff-added",60124),diffIgnored:$("diff-ignored",60125),diffModified:$("diff-modified",60126),diffRemoved:$("diff-removed",60127),diffRenamed:$("diff-renamed",60128),diff:$("diff",60129),discard:$("discard",60130),editorLayout:$("editor-layout",60131),emptyWindow:$("empty-window",60132),exclude:$("exclude",60133),extensions:$("extensions",60134),eyeClosed:$("eye-closed",60135),fileBinary:$("file-binary",60136),fileCode:$("file-code",60137),fileMedia:$("file-media",60138),filePdf:$("file-pdf",60139),fileSubmodule:$("file-submodule",60140),fileSymlinkDirectory:$("file-symlink-directory",60141),fileSymlinkFile:$("file-symlink-file",60142),fileZip:$("file-zip",60143),files:$("files",60144),filter:$("filter",60145),flame:$("flame",60146),foldDown:$("fold-down",60147),foldUp:$("fold-up",60148),fold:$("fold",60149),folderActive:$("folder-active",60150),folderOpened:$("folder-opened",60151),gear:$("gear",60152),gift:$("gift",60153),gistSecret:$("gist-secret",60154),gist:$("gist",60155),gitCommit:$("git-commit",60156),gitCompare:$("git-compare",60157),gitMerge:$("git-merge",60158),githubAction:$("github-action",60159),githubAlt:$("github-alt",60160),globe:$("globe",60161),grabber:$("grabber",60162),graph:$("graph",60163),gripper:$("gripper",60164),heart:$("heart",60165),home:$("home",60166),horizontalRule:$("horizontal-rule",60167),hubot:$("hubot",60168),inbox:$("inbox",60169),issueClosed:$("issue-closed",60324),issueReopened:$("issue-reopened",60171),issues:$("issues",60172),italic:$("italic",60173),jersey:$("jersey",60174),json:$("json",60175),bracket:$("bracket",60175),kebabVertical:$("kebab-vertical",60176),key:$("key",60177),law:$("law",60178),lightbulbAutofix:$("lightbulb-autofix",60179),linkExternal:$("link-external",60180),link:$("link",60181),listOrdered:$("list-ordered",60182),listUnordered:$("list-unordered",60183),liveShare:$("live-share",60184),loading:$("loading",60185),location:$("location",60186),mailRead:$("mail-read",60187),mail:$("mail",60188),markdown:$("markdown",60189),megaphone:$("megaphone",60190),mention:$("mention",60191),milestone:$("milestone",60192),gitPullRequestMilestone:$("git-pull-request-milestone",60192),mortarBoard:$("mortar-board",60193),move:$("move",60194),multipleWindows:$("multiple-windows",60195),mute:$("mute",60196),noNewline:$("no-newline",60197),note:$("note",60198),octoface:$("octoface",60199),openPreview:$("open-preview",60200),package:$("package",60201),paintcan:$("paintcan",60202),pin:$("pin",60203),play:$("play",60204),run:$("run",60204),plug:$("plug",60205),preserveCase:$("preserve-case",60206),preview:$("preview",60207),project:$("project",60208),pulse:$("pulse",60209),question:$("question",60210),quote:$("quote",60211),radioTower:$("radio-tower",60212),reactions:$("reactions",60213),references:$("references",60214),refresh:$("refresh",60215),regex:$("regex",60216),remoteExplorer:$("remote-explorer",60217),remote:$("remote",60218),remove:$("remove",60219),replaceAll:$("replace-all",60220),replace:$("replace",60221),repoClone:$("repo-clone",60222),repoForcePush:$("repo-force-push",60223),repoPull:$("repo-pull",60224),repoPush:$("repo-push",60225),report:$("report",60226),requestChanges:$("request-changes",60227),rocket:$("rocket",60228),rootFolderOpened:$("root-folder-opened",60229),rootFolder:$("root-folder",60230),rss:$("rss",60231),ruby:$("ruby",60232),saveAll:$("save-all",60233),saveAs:$("save-as",60234),save:$("save",60235),screenFull:$("screen-full",60236),screenNormal:$("screen-normal",60237),searchStop:$("search-stop",60238),server:$("server",60240),settingsGear:$("settings-gear",60241),settings:$("settings",60242),shield:$("shield",60243),smiley:$("smiley",60244),sortPrecedence:$("sort-precedence",60245),splitHorizontal:$("split-horizontal",60246),splitVertical:$("split-vertical",60247),squirrel:$("squirrel",60248),starFull:$("star-full",60249),starHalf:$("star-half",60250),symbolClass:$("symbol-class",60251),symbolColor:$("symbol-color",60252),symbolCustomColor:$("symbol-customcolor",60252),symbolConstant:$("symbol-constant",60253),symbolEnumMember:$("symbol-enum-member",60254),symbolField:$("symbol-field",60255),symbolFile:$("symbol-file",60256),symbolInterface:$("symbol-interface",60257),symbolKeyword:$("symbol-keyword",60258),symbolMisc:$("symbol-misc",60259),symbolOperator:$("symbol-operator",60260),symbolProperty:$("symbol-property",60261),wrench:$("wrench",60261),wrenchSubaction:$("wrench-subaction",60261),symbolSnippet:$("symbol-snippet",60262),tasklist:$("tasklist",60263),telescope:$("telescope",60264),textSize:$("text-size",60265),threeBars:$("three-bars",60266),thumbsdown:$("thumbsdown",60267),thumbsup:$("thumbsup",60268),tools:$("tools",60269),triangleDown:$("triangle-down",60270),triangleLeft:$("triangle-left",60271),triangleRight:$("triangle-right",60272),triangleUp:$("triangle-up",60273),twitter:$("twitter",60274),unfold:$("unfold",60275),unlock:$("unlock",60276),unmute:$("unmute",60277),unverified:$("unverified",60278),verified:$("verified",60279),versions:$("versions",60280),vmActive:$("vm-active",60281),vmOutline:$("vm-outline",60282),vmRunning:$("vm-running",60283),watch:$("watch",60284),whitespace:$("whitespace",60285),wholeWord:$("whole-word",60286),window:$("window",60287),wordWrap:$("word-wrap",60288),zoomIn:$("zoom-in",60289),zoomOut:$("zoom-out",60290),listFilter:$("list-filter",60291),listFlat:$("list-flat",60292),listSelection:$("list-selection",60293),selection:$("selection",60293),listTree:$("list-tree",60294),debugBreakpointFunctionUnverified:$("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:$("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:$("debug-breakpoint-function-disabled",60296),debugStackframeActive:$("debug-stackframe-active",60297),circleSmallFilled:$("circle-small-filled",60298),debugStackframeDot:$("debug-stackframe-dot",60298),debugStackframe:$("debug-stackframe",60299),debugStackframeFocused:$("debug-stackframe-focused",60299),debugBreakpointUnsupported:$("debug-breakpoint-unsupported",60300),symbolString:$("symbol-string",60301),debugReverseContinue:$("debug-reverse-continue",60302),debugStepBack:$("debug-step-back",60303),debugRestartFrame:$("debug-restart-frame",60304),callIncoming:$("call-incoming",60306),callOutgoing:$("call-outgoing",60307),menu:$("menu",60308),expandAll:$("expand-all",60309),feedback:$("feedback",60310),gitPullRequestReviewer:$("git-pull-request-reviewer",60310),groupByRefType:$("group-by-ref-type",60311),ungroupByRefType:$("ungroup-by-ref-type",60312),account:$("account",60313),gitPullRequestAssignee:$("git-pull-request-assignee",60313),bellDot:$("bell-dot",60314),debugConsole:$("debug-console",60315),library:$("library",60316),output:$("output",60317),runAll:$("run-all",60318),syncIgnored:$("sync-ignored",60319),pinned:$("pinned",60320),githubInverted:$("github-inverted",60321),debugAlt:$("debug-alt",60305),serverProcess:$("server-process",60322),serverEnvironment:$("server-environment",60323),pass:$("pass",60324),stopCircle:$("stop-circle",60325),playCircle:$("play-circle",60326),record:$("record",60327),debugAltSmall:$("debug-alt-small",60328),vmConnect:$("vm-connect",60329),cloud:$("cloud",60330),merge:$("merge",60331),exportIcon:$("export",60332),graphLeft:$("graph-left",60333),magnet:$("magnet",60334),notebook:$("notebook",60335),redo:$("redo",60336),checkAll:$("check-all",60337),pinnedDirty:$("pinned-dirty",60338),passFilled:$("pass-filled",60339),circleLargeFilled:$("circle-large-filled",60340),circleLarge:$("circle-large",60341),circleLargeOutline:$("circle-large-outline",60341),combine:$("combine",60342),gather:$("gather",60342),table:$("table",60343),variableGroup:$("variable-group",60344),typeHierarchy:$("type-hierarchy",60345),typeHierarchySub:$("type-hierarchy-sub",60346),typeHierarchySuper:$("type-hierarchy-super",60347),gitPullRequestCreate:$("git-pull-request-create",60348),runAbove:$("run-above",60349),runBelow:$("run-below",60350),notebookTemplate:$("notebook-template",60351),debugRerun:$("debug-rerun",60352),workspaceTrusted:$("workspace-trusted",60353),workspaceUntrusted:$("workspace-untrusted",60354),workspaceUnspecified:$("workspace-unspecified",60355),terminalCmd:$("terminal-cmd",60356),terminalDebian:$("terminal-debian",60357),terminalLinux:$("terminal-linux",60358),terminalPowershell:$("terminal-powershell",60359),terminalTmux:$("terminal-tmux",60360),terminalUbuntu:$("terminal-ubuntu",60361),terminalBash:$("terminal-bash",60362),arrowSwap:$("arrow-swap",60363),copy:$("copy",60364),personAdd:$("person-add",60365),filterFilled:$("filter-filled",60366),wand:$("wand",60367),debugLineByLine:$("debug-line-by-line",60368),inspect:$("inspect",60369),layers:$("layers",60370),layersDot:$("layers-dot",60371),layersActive:$("layers-active",60372),compass:$("compass",60373),compassDot:$("compass-dot",60374),compassActive:$("compass-active",60375),azure:$("azure",60376),issueDraft:$("issue-draft",60377),gitPullRequestClosed:$("git-pull-request-closed",60378),gitPullRequestDraft:$("git-pull-request-draft",60379),debugAll:$("debug-all",60380),debugCoverage:$("debug-coverage",60381),runErrors:$("run-errors",60382),folderLibrary:$("folder-library",60383),debugContinueSmall:$("debug-continue-small",60384),beakerStop:$("beaker-stop",60385),graphLine:$("graph-line",60386),graphScatter:$("graph-scatter",60387),pieChart:$("pie-chart",60388),bracketDot:$("bracket-dot",60389),bracketError:$("bracket-error",60390),lockSmall:$("lock-small",60391),azureDevops:$("azure-devops",60392),verifiedFilled:$("verified-filled",60393),newLine:$("newline",60394),layout:$("layout",60395),layoutActivitybarLeft:$("layout-activitybar-left",60396),layoutActivitybarRight:$("layout-activitybar-right",60397),layoutPanelLeft:$("layout-panel-left",60398),layoutPanelCenter:$("layout-panel-center",60399),layoutPanelJustify:$("layout-panel-justify",60400),layoutPanelRight:$("layout-panel-right",60401),layoutPanel:$("layout-panel",60402),layoutSidebarLeft:$("layout-sidebar-left",60403),layoutSidebarRight:$("layout-sidebar-right",60404),layoutStatusbar:$("layout-statusbar",60405),layoutMenubar:$("layout-menubar",60406),layoutCentered:$("layout-centered",60407),layoutSidebarRightOff:$("layout-sidebar-right-off",60416),layoutPanelOff:$("layout-panel-off",60417),layoutSidebarLeftOff:$("layout-sidebar-left-off",60418),target:$("target",60408),indent:$("indent",60409),recordSmall:$("record-small",60410),errorSmall:$("error-small",60411),arrowCircleDown:$("arrow-circle-down",60412),arrowCircleLeft:$("arrow-circle-left",60413),arrowCircleRight:$("arrow-circle-right",60414),arrowCircleUp:$("arrow-circle-up",60415),heartFilled:$("heart-filled",60420),map:$("map",60421),mapFilled:$("map-filled",60422),circleSmall:$("circle-small",60423),bellSlash:$("bell-slash",60424),bellSlashDot:$("bell-slash-dot",60425),commentUnresolved:$("comment-unresolved",60426),gitPullRequestGoToChanges:$("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:$("git-pull-request-new-changes",60428),searchFuzzy:$("search-fuzzy",60429),commentDraft:$("comment-draft",60430),send:$("send",60431),sparkle:$("sparkle",60432),insert:$("insert",60433),mic:$("mic",60434),thumbsDownFilled:$("thumbsdown-filled",60435),thumbsUpFilled:$("thumbsup-filled",60436),coffee:$("coffee",60437),snake:$("snake",60438),game:$("game",60439),vr:$("vr",60440),chip:$("chip",60441),piano:$("piano",60442),music:$("music",60443),micFilled:$("mic-filled",60444),gitFetch:$("git-fetch",60445),copilot:$("copilot",60446),lightbulbSparkle:$("lightbulb-sparkle",60447),lightbulbSparkleAutofix:$("lightbulb-sparkle-autofix",60447),robot:$("robot",60448),sparkleFilled:$("sparkle-filled",60449),diffSingle:$("diff-single",60450),diffMultiple:$("diff-multiple",60451),surroundWith:$("surround-with",60452),gitStash:$("git-stash",60454),gitStashApply:$("git-stash-apply",60455),gitStashPop:$("git-stash-pop",60456),coverage:$("coverage",60462),runAllCoverage:$("run-all-coverage",60461),runCoverage:$("run-all-coverage",60460),dialogError:$("dialog-error","error"),dialogWarning:$("dialog-warning","warning"),dialogInfo:$("dialog-info","info"),dialogClose:$("dialog-close","close"),treeItemExpanded:$("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:$("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:$("tree-filter-on-type-off","list-selection"),treeFilterClear:$("tree-filter-clear","close"),treeItemLoading:$("tree-item-loading","loading"),menuSelection:$("menu-selection","check"),menuSubmenu:$("menu-submenu","chevron-right"),menuBarMore:$("menubar-more","more"),scrollbarButtonLeft:$("scrollbar-button-left","triangle-left"),scrollbarButtonRight:$("scrollbar-button-right","triangle-right"),scrollbarButtonUp:$("scrollbar-button-up","triangle-up"),scrollbarButtonDown:$("scrollbar-button-down","triangle-down"),toolBarMore:$("toolbar-more","more"),quickInputBack:$("quick-input-back","arrow-left")}}),define(Ce[24],Ie([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0;function F(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?F(r):r}),i}e.$Bn=F;function $(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(L.call(n,r)){const a=n[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.$Pf)(a)&&i.push(a)}}return s}e.$Cn=$;const L=Object.prototype.hasOwnProperty;function A(s,i){return v(s,i,new Set)}e.$Dn=A;function v(s,i,n){if((0,I.$Vf)(s))return s;const r=i(s);if(typeof r<"u")return r;if(Array.isArray(s)){const a=[];for(const t of s)a.push(v(t,i,n));return a}if((0,I.$Of)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)L.call(s,t)&&(a[t]=v(s[t],i,n));return n.delete(s),a}return s}function p(s,i,n=!0){return(0,I.$Of)(s)?((0,I.$Of)(i)&&Object.keys(i).forEach(r=>{r in s?n&&((0,I.$Of)(s[r])&&(0,I.$Of)(i[r])?p(s[r],i[r],n):s[r]=i[r]):s[r]=i[r]}),s):i}e.$En=p;function k(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!k(s[n],i[n]))return!1}else{const a=[];for(r in s)a.push(r);a.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!k(a,t))return!1;for(n=0;n<a.length;n++)if(!k(s[a[n]],i[a[n]]))return!1}return!0}e.$Fn=k;function R(s){const i=new Set;return JSON.stringify(s,(n,r)=>{if((0,I.$Of)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$Gn=R;function C(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],h=i[a];k(t,h)||(n[a]=h)}),n}e.$Hn=C;function m(s,i){const n=i.toLowerCase(),r=Object.keys(s).find(a=>a.toLowerCase()===n);return r?s[r]:s[i]}e.$In=m;function E(s,i){const n=Object.create(null);for(const[r,a]of Object.entries(s))i(r,a)&&(n[r]=a);return n}e.$Jn=E;function S(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$Kn=S;function l(s){const i=[];for(const n of S(s))typeof s[n]=="function"&&i.push(n);return i}e.$Ln=l;function w(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},r={};for(const a of s)r[a]=n(a);return r}e.$Mn=w}),define(Ce[55],Ie([1,0,79]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$fk=e.ThemeColor=void 0;var F;(function(A){function v(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=v})(F||(e.ThemeColor=F={}));function $(A){return{id:A}}e.$fk=$;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(i){const n=v.exec(i.id);if(!n)return p(I.$ek.error);const[,r,a]=n,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=p;function k(i){return p(i).join(" ")}A.asClassName=k;function R(i){return"."+p(i).join(".")}A.asCSSSelector=R;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}A.isThemeIcon=C;const m=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(i){const n=m.exec(i);if(!n)return;const[,r]=n;return{id:r}}A.fromString=E;function S(i){return{id:i}}A.fromId=S;function l(i,n){let r=i.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),n&&(r=`${r}~${n}`),{id:r}}A.modify=l;function w(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}A.getModifier=w;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}A.isEqual=s})(L||(e.ThemeIcon=L={}))}),define(Ce[165],Ie([1,0,123,12,55]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=void 0;const L="$(",A=new RegExp(`\\$\\(${$.ThemeIcon.iconNameExpression}(?:${$.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${A.source}`,"g");function p(s){return s.replace(v,(i,n)=>n?i:`\\${i}`)}e.$gk=p;const k=new RegExp(`\\\\${A.source}`,"g");function R(s){return s.replace(k,i=>`\\${i}`)}e.$hk=R;const C=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function m(s){return s.indexOf(L)===-1?s:s.replace(C,(i,n,r,a)=>r?i:n||a||"")}e.$ik=m;function E(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$jk=E;const S=new RegExp(`\\$\\(${$.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(s){S.lastIndex=0;let i="";const n=[];let r=0;for(;;){const a=S.lastIndex,t=S.exec(s),h=s.substring(a,t?.index);if(h.length>0){i+=h;for(let c=0;c<h.length;c++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$kk=l;function w(s,i,n=!1){const{text:r,iconOffsets:a}=i;if(!a||a.length===0)return(0,I.$6j)(s,r,n);const t=(0,F.$We)(r," "),h=r.length-t.length,c=(0,I.$6j)(s,t,n);if(c)for(const o of c){const u=a[o.start+h]+h;o.start+=u,o.end+=u}return c}e.$lk=w}),define(Ce[124],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Le=e.$Ke=e.Constants=void 0;var I;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function F(L){return L<0?0:L>255?255:L|0}e.$Ke=F;function $(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Le=$}),define(Ce[30],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F($){return I.test($)}e.$tg=F,e.$ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let $;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?$=crypto.getRandomValues.bind(crypto):$=function(v){for(let p=0;p<v.length;p++)v[p]=Math.floor(Math.random()*256);return v};const L=new Uint8Array(16),A=[];for(let v=0;v<256;v++)A.push(v.toString(16).padStart(2,"0"));return function(){$(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let p=0,k="";return k+=A[L[p++]],k+=A[L[p++]],k+=A[L[p++]],k+=A[L[p++]],k+="-",k+=A[L[p++]],k+=A[L[p++]],k+="-",k+=A[L[p++]],k+=A[L[p++]],k+="-",k+=A[L[p++]],k+=A[L[p++]],k+="-",k+=A[L[p++]],k+=A[L[p++]],k+=A[L[p++]],k+=A[L[p++]],k+=A[L[p++]],k+=A[L[p++]],k}}()}),define(Ce[166],Ie([1,0,19,53,30]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.$ut=e.$tt=e.$st=void 0;function L(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$st=L;function A(C,m,E){const S={id:(0,$.$ug)(),name:C,uri:m,data:E};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$tt=A;class v{constructor(){this.a=new Map}get size(){let m=0;for(const E of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const E=[...this.a.keys()];return F.Iterable.some(this,([S,l])=>l.asFile())&&E.push("files"),R(p(m),E)}get(m){return this.a.get(this.b(m))?.[0]}append(m,E){const S=this.a.get(m);S?S.push(E):this.a.set(this.b(m),[E])}replace(m,E){this.a.set(this.b(m),[E])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,E]of this.a)for(const S of E)yield[m,S]}b(m){return p(m)}}e.$ut=v;function p(C){return C.toLowerCase()}function k(C,m){return R(p(C),m.map(p))}e.$vt=k;function R(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const E=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[S,l,w]=E;return w==="*"?m.some(s=>s.startsWith(l+"/")):!1}e.$wt=Object.freeze({create:C=>(0,I.$Mb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$wt.split(C).filter(m=>!m.startsWith("#"))})}),define(Ce[167],Ie([1,0,62]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=e.$xg=e.$wg=void 0;function F(v,p,k,R=1){let C=!1;return new Promise(m=>{const E=setTimeout(()=>{if(!C)return C=!0,m(0)},k);$(v,p,R,S=>{if(!C)return C=!0,clearTimeout(E),m(S)})})}e.$wg=F;function $(v,p,k,R){if(p===0)return R(0);const C=new I.Socket;C.once("connect",()=>(A(C),$(v+k,p-1,k,R))),C.once("data",()=>{}),C.once("error",m=>(A(C),m.code!=="ECONNREFUSED"?$(v+k,p-1,k,R):R(v))),C.connect(v,"127.0.0.1")}e.$xg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(v,p,k,R="127.0.0.1"){let C=!1,m,E=1;const S=I.createServer({pauseOnConnect:!0});function l(w,s){C||(C=!0,S.removeAllListeners(),S.close(),m&&clearTimeout(m),s(w))}return new Promise(w=>{m=setTimeout(()=>{l(0,w)},k),S.on("listening",()=>{l(v,w)}),S.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&E<p?(v++,E++,S.listen(v,R)):l(0,w)}),S.on("close",()=>{l(0,w)}),S.listen(v,R)})}e.$yg=L;function A(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch(p){console.error(p)}}}),define(Ce[125],Ie([1,0,124]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=void 0;class F{constructor(v){const p=(0,I.$Ke)(v);this.c=p,this.a=F.d(p),this.b=new Map}static d(v){const p=new Uint8Array(256);return p.fill(v),p}set(v,p){const k=(0,I.$Ke)(p);v>=0&&v<256?this.a[v]=k:this.b.set(v,k)}get(v){return v>=0&&v<256?this.a[v]:this.b.get(v)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$kt=F;var $;(function(A){A[A.False=0]="False",A[A.True=1]="True"})($||($={}));class L{constructor(){this.a=new F(0)}add(v){this.a.set(v,1)}has(v){return this.a.get(v)===1}clear(){return this.a.clear()}}e.$lt=L}),define(Ce[168],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.StringEOL=void 0;var I;(function($){$[$.Unknown=0]="Unknown",$[$.Invalid=3]="Invalid",$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function F($){let L=0,A=0,v=0,p=0;for(let k=0,R=$.length;k<R;k++){const C=$.charCodeAt(k);C===13?(L===0&&(A=k),L++,k+1<R&&$.charCodeAt(k+1)===10?(p|=2,k++):p|=3,v=k+1):C===10&&(p|=1,L===0&&(A=k),L++,v=k+1)}return L===0&&(A=$.length),[L,A,$.length-v,p]}e.$zt=F}),define(Ce[48],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class I{constructor($,L){this.lineNumber=$,this.column=L}with($=this.lineNumber,L=this.column){return $===this.lineNumber&&L===this.column?this:new I($,L)}delta($=0,L=0){return this.with(this.lineNumber+$,this.column+L)}equals($){return I.equals(this,$)}static equals($,L){return!$&&!L?!0:!!$&&!!L&&$.lineNumber===L.lineNumber&&$.column===L.column}isBefore($){return I.isBefore(this,$)}static isBefore($,L){return $.lineNumber<L.lineNumber?!0:L.lineNumber<$.lineNumber?!1:$.column<L.column}isBeforeOrEqual($){return I.isBeforeOrEqual(this,$)}static isBeforeOrEqual($,L){return $.lineNumber<L.lineNumber?!0:L.lineNumber<$.lineNumber?!1:$.column<=L.column}static compare($,L){const A=$.lineNumber|0,v=L.lineNumber|0;if(A===v){const p=$.column|0,k=L.column|0;return p-k}return A-v}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift($){return new I($.lineNumber,$.column)}static isIPosition($){return $&&typeof $.lineNumber=="number"&&typeof $.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ys=I}),define(Ce[29],Ie([1,0,48]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0;class F{constructor(L,A,v,p){L>v||L===v&&A>p?(this.startLineNumber=v,this.startColumn=p,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=v,this.endColumn=p)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,A){let v,p,k,R;return A.startLineNumber<L.startLineNumber?(v=A.startLineNumber,p=A.startColumn):A.startLineNumber===L.startLineNumber?(v=A.startLineNumber,p=Math.min(A.startColumn,L.startColumn)):(v=L.startLineNumber,p=L.startColumn),A.endLineNumber>L.endLineNumber?(k=A.endLineNumber,R=A.endColumn):A.endLineNumber===L.endLineNumber?(k=A.endLineNumber,R=Math.max(A.endColumn,L.endColumn)):(k=L.endLineNumber,R=L.endColumn),new F(v,p,k,R)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,A){let v=L.startLineNumber,p=L.startColumn,k=L.endLineNumber,R=L.endColumn;const C=A.startLineNumber,m=A.startColumn,E=A.endLineNumber,S=A.endColumn;return v<C?(v=C,p=m):v===C&&(p=Math.max(p,m)),k>E?(k=E,R=S):k===E&&(R=Math.min(R,S)),v>k||v===k&&p>R?null:new F(v,p,k,R)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new I.$Ys(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new I.$Ys(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new F(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new F(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new F(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const k=L.startLineNumber|0,R=A.startLineNumber|0;if(k===R){const C=L.startColumn|0,m=A.startColumn|0;if(C===m){const E=L.endLineNumber|0,S=A.endLineNumber|0;if(E===S){const l=L.endColumn|0,w=A.endColumn|0;return l-w}return E-S}return C-m}return k-R}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$Zs=F}),define(Ce[169],Ie([1,0,29]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1s=void 0;class F{static insert(L,A){return{range:new I.$Zs(L.lineNumber,L.column,L.lineNumber,L.column),text:A,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,A){return{range:L,text:A}}static replaceMove(L,A){return{range:L,text:A,forceMoveMarkers:!0}}}e.$1s=F}),define(Ce[170],Ie([1,0,48,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.SelectionDirection=void 0;var $;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})($||(e.SelectionDirection=$={}));class L extends F.$Zs{constructor(v,p,k,R){super(v,p,k,R),this.selectionStartLineNumber=v,this.selectionStartColumn=p,this.positionLineNumber=k,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return L.selectionsEqual(this,v)}static selectionsEqual(v,p){return v.selectionStartLineNumber===p.selectionStartLineNumber&&v.selectionStartColumn===p.selectionStartColumn&&v.positionLineNumber===p.positionLineNumber&&v.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,p){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,v,p):new L(v,p,this.startLineNumber,this.startColumn)}getPosition(){return new I.$Ys(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.$Ys(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,p){return this.getDirection()===0?new L(v,p,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,v,p)}static fromPositions(v,p=v){return new L(v.lineNumber,v.column,p.lineNumber,p.column)}static fromRange(v,p){return p===0?new L(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new L(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new L(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,p){if(v&&!p||!v&&p)return!1;if(!v&&!p)return!0;if(v.length!==p.length)return!1;for(let k=0,R=v.length;k<R;k++)if(!this.selectionsEqual(v[k],p[k]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,p,k,R,C){return C===0?new L(v,p,k,R):new L(k,R,v,p)}}e.$2s=L}),define(Ce[171],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0,e.$xs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[172],Ie([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class $ extends I.$kt{constructor(v){super(0);for(let p=0,k=v.length;p<k;p++)this.set(v.charCodeAt(p),2);this.set(32,1),this.set(9,1)}}e.$mt=$;function L(A){const v={};return p=>(v.hasOwnProperty(p)||(v[p]=A(p)),v[p])}e.$nt=L(A=>new $(A))}),define(Ce[126],Ie([1,0,53,3,76]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.$As=e.$zs=e.$ys=void 0,e.$ys="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$ys)C.indexOf(E)>=0||(m+="\\"+E);return m+="\\s]+)",new RegExp(m,"g")}e.$zs=L();function A(C){let m=e.$zs;if(C&&C instanceof RegExp)if(C.global)m=C;else{let E="g";C.ignoreCase&&(E+="i"),C.multiline&&(E+="m"),C.unicode&&(E+="u"),m=new RegExp(C.source,E)}return m.lastIndex=0,m}e.$As=A;const v=new $.$4c;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(C){const m=v.unshift(C);return(0,F.$Rc)(m)}e.$Bs=p;function k(C,m,E,S,l){if(m=A(m),l||(l=I.Iterable.first(v)),E.length>l.maxLen){let r=C-l.maxLen/2;return r<0?r=0:S+=r,E=E.substring(r,C+l.maxLen/2),k(C,m,E,S,l)}const w=Date.now(),s=C-1-S;let i=-1,n=null;for(let r=1;!(Date.now()-w>=l.timeBudget);r++){const a=s-l.windowSize*r;m.lastIndex=Math.max(0,a);const t=R(m,E,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const r={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return m.lastIndex=0,r}return null}e.$Cs=k;function R(C,m,E,S){let l;for(;l=C.exec(m);){const w=l.index||0;if(w<=E&&C.lastIndex>=E)return l;if(S>0&&w>S)return null}return null}}),define(Ce[173],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=e.$Wt=e.IndentAction=void 0;var I;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class F{constructor(v){if(this.e=null,this.f=!1,this.open=v.open,this.close=v.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(v.notIn))for(let p=0,k=v.notIn.length;p<k;p++)switch(v.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(v){switch(v){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(v,p){if(v.getTokenCount()===0)return!0;const k=v.findTokenIndexAtOffset(p-2),R=v.getStandardTokenType(k);return this.isOK(R)}g(v,p){for(let k=v;k<=p;k++){const R=String.fromCharCode(k);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Wt=F;class ${constructor(v){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of v)L(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),L(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),L(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),L(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&L(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$Xt=$;function L(A,v,p){A.has(v)?A.get(v).push(p):A.set(v,[p])}}),define(Ce[174],Ie([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Z=e.$0Z=e.$9Z=e.State=void 0;var F;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class ${constructor(S,l,w){const s=new Uint8Array(S*l);for(let i=0,n=S*l;i<n;i++)s[i]=w;this.a=s,this.rows=S,this.cols=l}get(S,l){return this.a[S*this.cols+l]}set(S,l,w){this.a[S*this.cols+l]=w}}class L{constructor(S){let l=0,w=0;for(let i=0,n=S.length;i<n;i++){const[r,a,t]=S[i];a>l&&(l=a),r>w&&(w=r),t>w&&(w=t)}l++,w++;const s=new $(w,l,0);for(let i=0,n=S.length;i<n;i++){const[r,a,t]=S[i];s.set(r,a,t)}this.a=s,this.b=l}nextState(S,l){return l<0||l>=this.b?0:this.a.get(S,l)}}e.$9Z=L;let A=null;function v(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var p;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let k=null;function R(){if(k===null){k=new I.$kt(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let l=0;l<E.length;l++)k.set(E.charCodeAt(l),1);const S=".,;:";for(let l=0;l<S.length;l++)k.set(S.charCodeAt(l),2)}return k}class C{static a(S,l,w,s,i){let n=i-1;do{const r=l.charCodeAt(n);if(S.get(r)!==2)break;n--}while(n>s);if(s>0){const r=l.charCodeAt(s-1),a=l.charCodeAt(n);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&n--}return{range:{startLineNumber:w,startColumn:s+1,endLineNumber:w,endColumn:n+2},url:l.substring(s,n+1)}}static computeLinks(S,l=v()){const w=R(),s=[];for(let i=1,n=S.getLineCount();i<=n;i++){const r=S.getLineContent(i),a=r.length;let t=0,h=0,c=0,o=1,u=!1,d=!1,b=!1,D=!1;for(;t<a;){let g=!1;const f=r.charCodeAt(t);if(o===13){let y;switch(f){case 40:u=!0,y=0;break;case 41:y=u?0:1;break;case 91:b=!0,d=!0,y=0;break;case 93:b=!1,y=d?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:c===f?y=1:c===39||c===34||c===96?y=0:y=1;break;case 42:y=c===42?1:0;break;case 124:y=c===124?1:0;break;case 32:y=b?0:1;break;default:y=w.get(f)}y===1&&(s.push(C.a(w,r,i,h,t)),g=!0)}else if(o===12){let y;f===91?(d=!0,y=0):y=w.get(f),y===1?g=!0:o=13}else o=l.nextState(o,f),o===0&&(g=!0);g&&(o=1,u=!1,d=!1,D=!1,h=t+1,c=f),t++}o===13&&s.push(C.a(w,r,i,h,a))}return s}}e.$0Z=C;function m(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:C.computeLinks(E)}e.$$Z=m}),define(Ce[80],Ie([1,0,24]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=e.$hv=e.ModelConstants=e.PositionAffinity=e.$gv=e.TrackedRangeStickiness=e.$fv=e.$ev=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var $;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})($||(e.GlyphMarginLane=$={}));var L;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var v;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var p;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(p||(e.DefaultEndOfLine=p={}));var k;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.$Fn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$ev=R;class C{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$fv=C;var m;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function E(r){return r&&typeof r.read=="function"}e.$gv=E;var S;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var l;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(l||(e.ModelConstants=l={}));class w{constructor(a,t,h,c,o,u){this.identifier=a,this.range=t,this.text=h,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=o,this._isTracked=u}}e.$hv=w;class s{constructor(a,t,h){this.regex=a,this.wordSeparators=t,this.simpleSearch=h}}e.$iv=s;class i{constructor(a,t,h){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=h}}e.$jv=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$kv=n}),define(Ce[175],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.NodeColor=e.$XB=void 0;class I{constructor(w,s){this.piece=w,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$YB)return $(this.right);let w=this;for(;w.parent!==e.$YB&&w.parent.left!==w;)w=w.parent;return w.parent===e.$YB?e.$YB:w.parent}prev(){if(this.left!==e.$YB)return L(this.left);let w=this;for(;w.parent!==e.$YB&&w.parent.right!==w;)w=w.parent;return w.parent===e.$YB?e.$YB:w.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$XB=I;var F;(function(l){l[l.Black=0]="Black",l[l.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$YB=new I(null,0),e.$YB.parent=e.$YB,e.$YB.left=e.$YB,e.$YB.right=e.$YB,e.$YB.color=0;function $(l){for(;l.left!==e.$YB;)l=l.left;return l}e.$ZB=$;function L(l){for(;l.right!==e.$YB;)l=l.right;return l}e.$1B=L;function A(l){return l===e.$YB?0:l.size_left+l.piece.length+A(l.right)}function v(l){return l===e.$YB?0:l.lf_left+l.piece.lineFeedCnt+v(l.right)}function p(){e.$YB.parent=e.$YB}function k(l,w){const s=w.right;s.size_left+=w.size_left+(w.piece?w.piece.length:0),s.lf_left+=w.lf_left+(w.piece?w.piece.lineFeedCnt:0),w.right=s.left,s.left!==e.$YB&&(s.left.parent=w),s.parent=w.parent,w.parent===e.$YB?l.root=s:w.parent.left===w?w.parent.left=s:w.parent.right=s,s.left=w,w.parent=s}e.$2B=k;function R(l,w){const s=w.left;w.left=s.right,s.right!==e.$YB&&(s.right.parent=w),s.parent=w.parent,w.size_left-=s.size_left+(s.piece?s.piece.length:0),w.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),w.parent===e.$YB?l.root=s:w===w.parent.right?w.parent.right=s:w.parent.left=s,s.right=w,w.parent=s}e.$3B=R;function C(l,w){let s,i;if(w.left===e.$YB?(i=w,s=i.right):w.right===e.$YB?(i=w,s=i.left):(i=$(w.right),s=i.right),i===l.root){l.root=s,s.color=0,w.detach(),p(),l.root.parent=e.$YB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===w?(s.parent=i.parent,S(l,s)):(i.parent===w?s.parent=i:s.parent=i.parent,S(l,s),i.left=w.left,i.right=w.right,i.parent=w.parent,i.color=w.color,w===l.root?l.root=i:w===w.parent.left?w.parent.left=i:w.parent.right=i,i.left!==e.$YB&&(i.left.parent=i),i.right!==e.$YB&&(i.right.parent=i),i.size_left=w.size_left,i.lf_left=w.lf_left,S(l,i)),w.detach(),s.parent.left===s){const a=A(s),t=v(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const h=a-s.parent.size_left,c=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,E(l,s.parent,h,c)}}if(S(l,s.parent),n){p();return}let r;for(;s!==l.root&&s.color===0;)s===s.parent.left?(r=s.parent.right,r.color===1&&(r.color=0,s.parent.color=1,k(l,s.parent),r=s.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,s=s.parent):(r.right.color===0&&(r.left.color=0,r.color=1,R(l,r),r=s.parent.right),r.color=s.parent.color,s.parent.color=0,r.right.color=0,k(l,s.parent),s=l.root)):(r=s.parent.left,r.color===1&&(r.color=0,s.parent.color=1,R(l,s.parent),r=s.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,s=s.parent):(r.left.color===0&&(r.right.color=0,r.color=1,k(l,r),r=s.parent.left),r.color=s.parent.color,s.parent.color=0,r.left.color=0,R(l,s.parent),s=l.root));s.color=0,p()}e.$4B=C;function m(l,w){for(S(l,w);w!==l.root&&w.parent.color===1;)if(w.parent===w.parent.parent.left){const s=w.parent.parent.right;s.color===1?(w.parent.color=0,s.color=0,w.parent.parent.color=1,w=w.parent.parent):(w===w.parent.right&&(w=w.parent,k(l,w)),w.parent.color=0,w.parent.parent.color=1,R(l,w.parent.parent))}else{const s=w.parent.parent.left;s.color===1?(w.parent.color=0,s.color=0,w.parent.parent.color=1,w=w.parent.parent):(w===w.parent.left&&(w=w.parent,R(l,w)),w.parent.color=0,w.parent.parent.color=1,k(l,w.parent.parent))}l.root.color=0}e.$5B=m;function E(l,w,s,i){for(;w!==l.root&&w!==e.$YB;)w.parent.left===w&&(w.parent.size_left+=s,w.parent.lf_left+=i),w=w.parent}e.$6B=E;function S(l,w){let s=0,i=0;if(w!==l.root){for(;w!==l.root&&w===w.parent.right;)w=w.parent;if(w!==l.root)for(w=w.parent,s=A(w.left)-w.size_left,i=v(w.left)-w.lf_left,w.size_left+=s,w.lf_left+=i;w!==l.root&&(s!==0||i!==0);)w.parent.left===w&&(w.parent.size_left+=s,w.parent.lf_left+=i),w=w.parent}}e.$7B=S}),define(Ce[176],Ie([1,0,19,124]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pv=e.$ov=e.$nv=void 0;class ${constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,k){p=(0,F.$Le)(p);const R=this.a,C=this.b,m=k.length;return m===0?!1:(this.a=new Uint32Array(R.length+m),this.a.set(R.subarray(0,p),0),this.a.set(R.subarray(p),p+m),this.a.set(k,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(p,k){return p=(0,F.$Le)(p),k=(0,F.$Le)(k),this.a[p]===k?!1:(this.a[p]=k,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,k){p=(0,F.$Le)(p),k=(0,F.$Le)(k);const R=this.a,C=this.b;if(p>=R.length)return!1;const m=R.length-p;return k>=m&&(k=m),k===0?!1:(this.a=new Uint32Array(R.length-k),this.a.set(R.subarray(0,p),0),this.a.set(R.subarray(p+k),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,F.$Le)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),p>=this.a.length&&(p=this.a.length-1);for(let R=k;R<=p;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let k=0,R=this.a.length-1,C=0,m=0,E=0;for(;k<=R;)if(C=k+(R-k)/2|0,m=this.b[C],E=m-this.a[C],p<E)R=C-1;else if(p>=m)k=C+1;else break;return new A(C,p-E)}}e.$nv=$;class L{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const k=this.e[p],R=k>0?this.d[k-1]:0;return new A(k,p-R)}removeValues(p,k){this.a.splice(p,k),this.f(p)}insertValues(p,k){this.a=(0,I.$Wb)(this.a,p,k),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,k=this.a.length;p<k;p++){const R=this.a[p],C=p>0?this.d[p-1]:0;this.d[p]=C+R;for(let m=0;m<R;m++)this.e[C+m]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,k){this.a[p]!==k&&(this.a[p]=k,this.f(p))}}e.$ov=L;class A{constructor(p,k){this.index=p,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=k}}e.$pv=A}),define(Ce[177],Ie([1,0,12,48,176]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=void 0;class L{constructor(v,p,k,R){this.d=v,this.f=p,this.g=k,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(v){v.eol&&v.eol!==this.g&&(this.g=v.eol,this.j=null);const p=v.changes;for(const k of p)this.o(k.range),this.p(new F.$Ys(k.range.startLineNumber,k.range.startColumn),k.text);this.h=v.versionId,this.k=null}l(){if(!this.j){const v=this.g.length,p=this.f.length,k=new Uint32Array(p);for(let R=0;R<p;R++)k[R]=this.f[R].length+v;this.j=new $.$nv(k)}}n(v,p){this.f[v]=p,this.j&&this.j.setValue(v,this.f[v].length+this.g.length)}o(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.startLineNumber-1].substring(v.endColumn-1));return}this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.endLineNumber-1].substring(v.endColumn-1)),this.f.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this.j&&this.j.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}p(v,p){if(p.length===0)return;const k=(0,I.$3e)(p);if(k.length===1){this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+k[0]+this.f[v.lineNumber-1].substring(v.column-1));return}k[k.length-1]+=this.f[v.lineNumber-1].substring(v.column-1),this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+k[0]);const R=new Uint32Array(k.length-1);for(let C=1;C<k.length;C++)this.f.splice(v.lineNumber+C-1,0,k[C]),R[C-1]=k[C].length+this.g.length;this.j&&this.j.insertValues(v.lineNumber,R)}}e.$qv=L}),define(Ce[99],Ie([1,0,12,172,48,29,80]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=e.$8B=void 0;const v=999;class p{constructor(i,n,r,a){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=k(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=I.$1e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new A.$iv(n,this.wordSeparators?(0,F.$nt)(this.wordSeparators):null,r?this.searchString:null)}}e.$8B=p;function k(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const r=s.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$9B=k;function R(s,i,n){if(!n)return new A.$fv(s,null);const r=[];for(let a=0,t=i.length;a<t;a++)r[a]=i[a];return new A.$fv(s,r)}e.$0B=R;class C{constructor(i){const n=[];let r=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[r++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(r=t,a=t):r=t+1}return r+1}}class m{static findMatches(i,n,r,a,t){const h=n.parseSearchRequest();return h?h.regex.multiline?this.b(i,r,new w(h.wordSeparators,h.regex),a,t):this.c(i,r,h,a,t):[]}static a(i,n,r,a,t,h){let c,o=0;a?(o=a.findLineFeedCountBeforeOffset(t),c=n+t+o):c=n+t;let u;if(a){const g=a.findLineFeedCountBeforeOffset(t+h.length)-o;u=c+h.length+g}else u=c+h.length;const d=i.getPositionAt(c),b=i.getPositionAt(u);return new L.$Zs(d.lineNumber,d.column,b.lineNumber,b.column)}static b(i,n,r,a,t){const h=i.getOffsetAt(n.getStartPosition()),c=i.getValueInRange(n,1),o=i.getEOL()===`\r
`?new C(c):null,u=[];let d=0,b;for(r.reset(0);b=r.next(c);)if(u[d++]=R(this.a(i,h,c,o,b.index,b[0]),b,a),d>=t)return u;return u}static c(i,n,r,a,t){const h=[];let c=0;if(n.startLineNumber===n.endLineNumber){const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return c=this.d(r,u,n.startLineNumber,n.startColumn-1,c,h,a,t),h}const o=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);c=this.d(r,o,n.startLineNumber,n.startColumn-1,c,h,a,t);for(let u=n.startLineNumber+1;u<n.endLineNumber&&c<t;u++)c=this.d(r,i.getLineContent(u),u,0,c,h,a,t);if(c<t){const u=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);c=this.d(r,u,n.endLineNumber,0,c,h,a,t)}return h}static d(i,n,r,a,t,h,c,o){const u=i.wordSeparators;if(!c&&i.simpleSearch){const D=i.simpleSearch,g=D.length,f=n.length;let y=-g;for(;(y=n.indexOf(D,y+g))!==-1;)if((!u||l(u,n,f,y,g))&&(h[t++]=new A.$fv(new L.$Zs(r,y+1+a,r,y+1+g+a),null),t>=o))return t;return t}const d=new w(i.wordSeparators,i.regex);let b;d.reset(0);do if(b=d.next(n),b&&(h[t++]=R(new L.$Zs(r,b.index+1+a,r,b.index+1+b[0].length+a),b,c),t>=o))return t;while(b);return t}static findNextMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const h=new w(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,h,a):this.f(i,r,h,a)}static e(i,n,r,a){const t=new $.$Ys(n.lineNumber,1),h=i.getOffsetAt(t),c=i.getLineCount(),o=i.getValueInRange(new L.$Zs(t.lineNumber,t.column,c,i.getLineMaxColumn(c)),1),u=i.getEOL()===`\r
`?new C(o):null;r.reset(n.column-1);const d=r.next(o);return d?R(this.a(i,h,o,u,d.index,d[0]),d,a):n.lineNumber!==1||n.column!==1?this.e(i,new $.$Ys(1,1),r,a):null}static f(i,n,r,a){const t=i.getLineCount(),h=n.lineNumber,c=i.getLineContent(h),o=this.g(r,c,h,n.column,a);if(o)return o;for(let u=1;u<=t;u++){const d=(h+u-1)%t,b=i.getLineContent(d+1),D=this.g(r,b,d+1,1,a);if(D)return D}return null}static g(i,n,r,a,t){i.reset(a-1);const h=i.next(n);return h?R(new L.$Zs(r,h.index+1,r,h.index+1+h[0].length),h,t):null}static findPreviousMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const h=new w(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,h,a):this.j(i,r,h,a)}static h(i,n,r,a){const t=this.b(i,new L.$Zs(1,1,n.lineNumber,n.column),r,a,10*v);if(t.length>0)return t[t.length-1];const h=i.getLineCount();return n.lineNumber!==h||n.column!==i.getLineMaxColumn(h)?this.h(i,new $.$Ys(h,i.getLineMaxColumn(h)),r,a):null}static j(i,n,r,a){const t=i.getLineCount(),h=n.lineNumber,c=i.getLineContent(h).substring(0,n.column-1),o=this.k(r,c,h,a);if(o)return o;for(let u=1;u<=t;u++){const d=(t+h-u-1)%t,b=i.getLineContent(d+1),D=this.k(r,b,d+1,a);if(D)return D}return null}static k(i,n,r,a){let t=null,h;for(i.reset(0);h=i.next(n);)t=R(new L.$Zs(r,h.index+1,r,h.index+1+h[0].length),h,a);return t}}e.$$B=m;function E(s,i,n,r,a){if(r===0)return!0;const t=i.charCodeAt(r-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(r);if(s.get(h)!==0)return!0}return!1}function S(s,i,n,r,a){if(r+a===n)return!0;const t=i.charCodeAt(r+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(r+a-1);if(s.get(h)!==0)return!0}return!1}function l(s,i,n,r,a){return E(s,i,n,r,a)&&S(s,i,n,r,a)}e.$_B=l;class w{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const a=r.index,t=r[0].length;if(a===this.b&&t===this.c){if(t===0){I.$kf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||l(this._wordSeparators,i,n,a,t))return r}while(r);return null}}e.$aC=w}),define(Ce[127],Ie([1,0,48,29,80,175,99]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=e.$cC=e.$bC=void 0;const v=65535;function p(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class k{constructor(i,n,r,a,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function R(s,i=!0){const n=[0];let r=1;for(let a=0,t=s.length;a<t;a++){const h=s.charCodeAt(a);h===13?a+1<t&&s.charCodeAt(a+1)===10?(n[r++]=a+2,a++):n[r++]=a+1:h===10&&(n[r++]=a+1)}return i?p(n):n}e.$bC=R;function C(s,i){s.length=0,s[0]=0;let n=1,r=0,a=0,t=0,h=!0;for(let o=0,u=i.length;o<u;o++){const d=i.charCodeAt(o);d===13?o+1<u&&i.charCodeAt(o+1)===10?(t++,s[n++]=o+2,o++):(r++,s[n++]=o+1):d===10?(a++,s[n++]=o+1):h&&d!==9&&(d<32||d>126)&&(h=!1)}const c=new k(p(s),r,a,t,h);return s.length=0,c}e.$cC=C;class m{constructor(i,n,r,a,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=a,this.length=t}}e.$dC=m;class E{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$eC=E;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==L.$YB&&i.iterate(i.root,r=>(r!==L.$YB&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class l{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=i){r[a]=null,n=!0;continue}}if(n){const a=[];for(const t of r)t!==null&&a.push(t);this.b=a}}}class w{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=L.$YB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let a=null;for(let t=0,h=i.length;t<h;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=R(i[t].buffer));const c=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,c)}this.h=new l(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=v,r=n-Math.floor(n/3),a=r*2;let t="",h=0;const c=[];if(this.iterate(this.root,o=>{const u=this.R(o),d=u.length;if(h<=r||h+d<a)return t+=u,h+=d,!0;const b=t.replace(/\r\n|\r|\n/g,i);return c.push(new E(b,R(b))),t=u,h=d,!0}),h>0){const o=t.replace(/\r\n|\r|\n/g,i);c.push(new E(o,R(o)))}this.create(c,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===L.$YB)return!0;const t=this.R(a),h=t.length,c=i.G(n),o=i.G(n+h),u=i.getValueInRange2(c,o);return n+=h,t===u})}getOffsetAt(i,n){let r=0,a=this.root;for(;a!==L.$YB;)if(a.left!==L.$YB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){r+=a.size_left;const t=this.B(a,i-a.lf_left-2);return r+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const a=i;for(;n!==L.$YB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const h=this.getOffsetAt(r+1,1),c=a-h;return new I.$Ys(r+1,c+1)}return new I.$Ys(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===L.$YB){const t=this.getOffsetAt(r+1,1),h=a-i-t;return new I.$Ys(r+1,h+1)}else n=n.right;return new I.$Ys(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const c=i.node,o=this.a[c.piece.bufferIndex].buffer,u=this.u(c.piece.bufferIndex,c.piece.start);return o.substring(u+i.remainder,u+n.remainder)}let r=i.node;const a=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let h=a.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==L.$YB;){const c=this.a[r.piece.bufferIndex].buffer,o=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){h+=c.substring(o,o+n.remainder);break}else h+=c.substr(o,r.piece.length);r=r.next()}return h}getLinesContent(){const i=[];let n=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===L.$YB)return!0;const h=t.piece;let c=h.length;if(c===0)return!0;const o=this.a[h.bufferIndex].buffer,u=this.a[h.bufferIndex].lineStarts,d=h.start.line,b=h.end.line;let D=u[d]+h.start.column;if(a&&(o.charCodeAt(D)===10&&(D++,c--),i[n++]=r,r="",a=!1,c===0))return!0;if(d===b)return!this.f&&o.charCodeAt(D+c-1)===13?(a=!0,r+=o.substr(D,c-1)):r+=o.substr(D,c),!0;r+=this.f?o.substring(D,Math.max(D,u[d+1]-this.e)):o.substring(D,u[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let g=d+1;g<b;g++)r=this.f?o.substring(u[g],u[g+1]-this.e):o.substring(u[g],u[g+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&o.charCodeAt(u[b]+h.end.column-1)===13?(a=!0,h.end.column===0?n--:r=o.substr(u[b],h.end.column-1)):r=o.substr(u[b],h.end.column),!0}),a&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,a,t,h,c,o,u,d,b){const D=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,h);let P;const T={line:0,column:0};let U,z;n._wordSeparators?(U=D.buffer.substring(f,y),z=M=>M+f,n.reset(0)):(U=D.buffer,z=M=>M,n.reset(f));do if(P=n.next(U),P){if(z(P.index)>=y)return d;this.s(i,z(P.index)-g,T);const M=this.t(i.piece.bufferIndex,t,T),N=T.line===t.line?T.column-t.column+a:T.column+1,O=N+P[0].length;if(b[d++]=(0,A.$0B)(new F.$Zs(r+M,N,r+M,O),P,o),z(P.index)+P[0].length>=y||d>=u)return d}while(P);return d}findMatchesLineByLine(i,n,r,a){const t=[];let h=0;const c=new A.$aC(n.wordSeparators,n.regex);let o=this.H(i.startLineNumber,i.startColumn);if(o===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let d=this.s(o.node,o.remainder);const b=this.s(u.node,u.remainder);if(o.node===u.node)return this.findMatchesInNode(o.node,c,i.startLineNumber,i.startColumn,d,b,n,r,a,h,t),t;let D=i.startLineNumber,g=o.node;for(;g!==u.node;){const y=this.t(g.piece.bufferIndex,d,g.piece.end);if(y>=1){const T=this.a[g.piece.bufferIndex].lineStarts,U=this.u(g.piece.bufferIndex,g.piece.start),z=T[d.line+y],M=D===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(g,c,D,M,d,this.s(g,z-U),n,r,a,h,t),h>=a)return t;D+=y}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const T=this.getLineContent(D).substring(P,i.endColumn-1);return h=this.n(n,c,T,i.endLineNumber,P,h,t,r,a),t}if(h=this.n(n,c,this.getLineContent(D).substr(P),D,P,h,t,r,a),h>=a)return t;D++,o=this.H(D,1),g=o.node,d=this.s(o.node,o.remainder)}if(D===i.endLineNumber){const y=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(y,i.endColumn-1);return h=this.n(n,c,P,i.endLineNumber,y,h,t,r,a),t}const f=D===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(u.node,c,D,f,d,b,n,r,a,h,t),t}n(i,n,r,a,t,h,c,o,u){const d=i.wordSeparators;if(!o&&i.simpleSearch){const D=i.simpleSearch,g=D.length,f=r.length;let y=-g;for(;(y=r.indexOf(D,y+g))!==-1;)if((!d||(0,A.$_B)(d,r,f,y,g))&&(c[h++]=new $.$fv(new F.$Zs(a,y+1+t,a,y+1+g+t),null),h>=u))return h;return h}let b;n.reset(0);do if(b=n.next(r),b&&(c[h++]=(0,A.$0B)(new F.$Zs(a,b.index+1+t,a,b.index+1+b[0].length+t),b,o),h>=u))return h;while(b);return h}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==L.$YB){const{node:a,remainder:t,nodeStartOffset:h}=this.G(i),c=a.piece,o=c.bufferIndex,u=this.s(a,t);if(a.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&h+c.length===i&&n.length<v){this.F(a,n),this.y();return}if(h===i)this.o(n,a),this.h.validate(i);else if(h+a.piece.length>i){const d=[];let b=new m(c.bufferIndex,u,c.end,this.t(c.bufferIndex,u,c.end),this.u(o,c.end)-this.u(o,u));if(this.K()&&this.M(n)&&this.I(a,t)===10){const y={line:b.start.line+1,column:0};b=new m(b.bufferIndex,y,b.end,this.t(b.bufferIndex,y,b.end),b.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const y=this.s(a,t-1);this.C(a,y),n="\r"+n,a.piece.length===0&&d.push(a)}else this.C(a,u);else this.C(a,u);const D=this.w(n);b.length>0&&this.S(a,b);let g=a;for(let f=0;f<D.length;f++)g=this.S(g,D[f]);this.v(d)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let h=1;h<a.length;h++)t=this.S(t,a[h])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===L.$YB)return;const r=this.G(i),a=this.G(i+n),t=r.node,h=a.node;if(t===h){const D=this.s(t,r.remainder),g=this.s(t,a.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const f=t.next();(0,L.$4B)(this,t),this.N(f),this.y();return}this.D(t,g),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,g),this.y();return}const c=[],o=this.s(t,r.remainder);this.C(t,o),this.h.validate(i),t.piece.length===0&&c.push(t);const u=this.s(h,a.remainder);this.D(h,u),h.piece.length===0&&c.push(h);const d=t.next();for(let D=d;D!==L.$YB&&D!==h;D=D.next())c.push(D);const b=t.piece.length===0?t.prev():t;this.v(c),this.O(b),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const h=n.piece,c={line:h.start.line+1,column:0},o=new m(h.bufferIndex,c,h.end,this.t(h.bufferIndex,c,h.end),h.length-1);n.piece=o,i+=`
`,(0,L.$6B)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let h=a.length-2;h>=0;h--)t=this.T(t,a[h]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),a=this.S(n,r[0]);let t=a;for(let h=1;h<r.length;h++)t=this.S(t,r[h]);this.N(a)}s(i,n,r){const a=i.piece,t=i.piece.bufferIndex,h=this.a[t].lineStarts,o=h[a.start.line]+a.start.column+n;let u=a.start.line,d=a.end.line,b=0,D=0,g=0;for(;u<=d&&(b=u+(d-u)/2|0,g=h[b],b!==d);)if(D=h[b+1],o<g)d=b-1;else if(o>=D)u=b+1;else break;return r?(r.line=b,r.column=o-g,null):{line:b,column:o-g}}t(i,n,r){if(r.column===0)return r.line-n.line;const a=this.a[i].lineStarts;if(r.line===a.length-1)return r.line-n.line;const t=a[r.line+1],h=a[r.line]+r.column;if(t>h+1)return r.line-n.line;const c=h-1;return this.a[i].buffer.charCodeAt(c)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,L.$4B)(this,i[n])}w(i){if(i.length>v){const d=[];for(;i.length>v;){const D=i.charCodeAt(v-1);let g;D===13||D>=55296&&D<=56319?(g=i.substring(0,v-1),i=i.substring(v-1)):(g=i.substring(0,v),i=i.substring(v));const f=R(g);d.push(new m(this.a.length,{line:0,column:0},{line:f.length-1,column:g.length-f[f.length-1]},f.length-1,g.length)),this.a.push(new E(g,f))}const b=R(i);return d.push(new m(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new E(i,b)),d}let n=this.a[0].buffer.length;const r=R(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let d=0;d<r.length;d++)r[d]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let d=0;d<r.length;d++)r[d]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[h],o={line:h,column:c},u=new m(0,a,o,this.t(0,a,o),t-n);return this.g=o,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,a="";const t=this.h.get2(i);if(t){r=t.node;const h=this.B(r,i-t.nodeStartLineNumber-1),c=this.a[r.piece.bufferIndex].buffer,o=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)a=c.substring(o+h,o+r.piece.length);else{const u=this.B(r,i-t.nodeStartLineNumber);return c.substring(o+h,o+u-n)}}else{let h=0;const c=i;for(;r!==L.$YB;)if(r.left!==L.$YB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const o=this.B(r,i-r.lf_left-2),u=this.B(r,i-r.lf_left-1),d=this.a[r.piece.bufferIndex].buffer,b=this.u(r.piece.bufferIndex,r.piece.start);return h+=r.size_left,this.h.set({node:r,nodeStartOffset:h,nodeStartLineNumber:c-(i-1-r.lf_left)}),d.substring(b+o,b+u-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const o=this.B(r,i-r.lf_left-2),u=this.a[r.piece.bufferIndex].buffer,d=this.u(r.piece.bufferIndex,r.piece.start);a=u.substring(d+o,d+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,h+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==L.$YB;){const h=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const c=this.B(r,0),o=this.u(r.piece.bufferIndex,r.piece.start);return a+=h.substring(o,o+c-n),a}else{const c=this.u(r.piece.bufferIndex,r.piece.start);a+=h.substr(c,r.piece.length)}r=r.next()}return a}y(){let i=this.root,n=1,r=0;for(;i!==L.$YB;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,a=this.s(i,n),t=a.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const h=this.t(i.piece.bufferIndex,r.start,a);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const r=i.piece,a=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}C(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),h=n,c=this.u(r.bufferIndex,h),o=this.t(r.bufferIndex,r.start,h),u=o-a,d=c-t,b=r.length+d;i.piece=new m(r.bufferIndex,r.start,h,o,b),(0,L.$6B)(this,i,d,u)}D(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),h=n,c=this.t(r.bufferIndex,h,r.end),o=this.u(r.bufferIndex,h),u=c-a,d=t-o,b=r.length+d;i.piece=new m(r.bufferIndex,h,r.end,c,b),(0,L.$6B)(this,i,d,u)}E(i,n,r){const a=i.piece,t=a.start,h=a.end,c=a.length,o=a.lineFeedCnt,u=n,d=this.t(a.bufferIndex,a.start,u),b=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new m(a.bufferIndex,a.start,u,d,b),(0,L.$6B)(this,i,b-c,d-o);const D=new m(a.bufferIndex,r,h,this.t(a.bufferIndex,r,h),this.u(a.bufferIndex,h)-this.u(a.bufferIndex,r)),g=this.S(i,D);this.N(g)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=R(n,!1);for(let g=0;g<t.length;g++)t[g]+=a;if(r){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const h=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[h],o={line:h,column:c},u=i.piece.length+n.length,d=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,o),D=b-d;i.piece=new m(i.piece.bufferIndex,i.piece.start,o,b,u),this.g=o,(0,L.$6B)(this,i,n.length,D)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let a=0;for(;n!==L.$YB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,a=0;for(;r!==L.$YB;)if(r.left!==L.$YB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),h=this.B(r,i-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+n-1,h),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:a};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==L.$YB;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),h=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:h}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$YB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=r[a]+n.start.column;return a===r.length-1||r[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$YB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,c=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,c,h),(0,L.$6B)(this,i,-1,-1),i.piece.length===0&&r.push(i);const o={line:n.piece.start.line+1,column:0},u=n.piece.length-1,d=this.t(n.piece.bufferIndex,o,n.piece.end);n.piece=new m(n.piece.bufferIndex,o,n.piece.end,d,u),(0,L.$6B)(this,n,-1,-1),n.piece.length===0&&r.push(n);const b=this.w(`\r
`);this.S(i,b[0]);for(let D=0;D<r.length;D++)(0,L.$4B)(this,r[D])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,L.$4B)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},h=a.length-1,c=this.t(a.bufferIndex,t,a.end);r.piece=new m(a.bufferIndex,t,a.end,c,h),(0,L.$6B)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===L.$YB)return n(L.$YB);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===L.$YB)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,a=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,a)}S(i,n){const r=new L.$XB(n,1);if(r.left=L.$YB,r.right=L.$YB,r.parent=L.$YB,r.size_left=0,r.lf_left=0,this.root===L.$YB)this.root=r,r.color=0;else if(i.right===L.$YB)i.right=r,r.parent=i;else{const t=(0,L.$ZB)(i.right);t.left=r,r.parent=t}return(0,L.$5B)(this,r),r}T(i,n){const r=new L.$XB(n,1);if(r.left=L.$YB,r.right=L.$YB,r.parent=L.$YB,r.size_left=0,r.lf_left=0,this.root===L.$YB)this.root=r,r.color=0;else if(i.left===L.$YB)i.left=r,r.parent=i;else{const a=(0,L.$1B)(i.left);a.right=r,r.parent=a}return(0,L.$5B)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$fC=w}),define(Ce[178],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58=e.$48=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$48=I;class F{constructor(L){this.identifier=L}}e.$58=F}),define(Ce[179],Ie([1,0,4,3]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=void 0;class ${constructor(){this.a=new Map,this.b=new Map,this.c=new I.$Yd,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,p){return this.a.set(v,p),this.handleChange([v]),(0,F.$Rc)(()=>{this.a.get(v)===p&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,p){this.b.get(v)?.dispose();const k=new L(this,v,p);return this.b.set(v,k),(0,F.$Rc)(()=>{const R=this.b.get(v);!R||R!==k||(this.b.delete(v),R.dispose())})}async getOrCreate(v){const p=this.get(v);if(p)return p;const k=this.b.get(v);return!k||k.isResolved?null:(await k.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const k=this.b.get(v);return!!(!k||k.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$yt=$;class L extends F.$Tc{get isResolved(){return this.c}constructor(v,p,k){super(),this.f=v,this.g=p,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Ce[180],Ie([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Ce[181],Ie([1,0,4,3,180]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;class L extends F.$Tc{constructor(m,E="",S="",l=!0,w){super(),this.h=this.B(new I.$Yd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=E,this.u=S,this.w=l,this.C=w}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,E){this.C&&await this.C(m)}}e.$Pi=L;class A extends F.$Tc{constructor(){super(...arguments),this.f=this.B(new I.$Yd),this.onWillRun=this.f.event,this.m=this.B(new I.$Yd),this.onDidRun=this.m.event}async run(m,E){if(!m.enabled)return;this.f.fire({action:m});let S;try{await this.u(m,E)}catch(l){S=l}this.m.fire({action:m,error:S})}async u(m,E){await m.run(E)}}e.$Qi=A;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let E=[];for(const S of m)S.length&&(E.length?E=[...E,new v,...S]:E=S);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$Ri=v;class p{get actions(){return this.a}constructor(m,E,S,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=E,this.class=l,this.a=S}async run(){}}e.$Si=p;class k extends L{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,$.localize(0,null),void 0,!1)}}e.$Ti=k;function R(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Ui=R}),define(Ce[182],Ie([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Ce[183],Ie([1,0,182]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0;const F=60,$=F*60,L=$*24,A=L*7,v=L*30,p=L*365;function k(m,E,S,l){typeof m!="number"&&(m=m.getTime());const w=Math.round((new Date().getTime()-m)/1e3);if(w<-30)return(0,I.localize)(0,null,k(new Date().getTime()+w*1e3,!1));if(!l&&w<30)return(0,I.localize)(1,null);let s;return w<F?(s=w,E?s===1?S?(0,I.localize)(2,null,s):(0,I.localize)(3,null,s):S?(0,I.localize)(4,null,s):(0,I.localize)(5,null,s):s===1?S?(0,I.localize)(6,null,s):(0,I.localize)(7,null,s):S?(0,I.localize)(8,null,s):(0,I.localize)(9,null,s)):w<$?(s=Math.floor(w/F),E?s===1?S?(0,I.localize)(10,null,s):(0,I.localize)(11,null,s):S?(0,I.localize)(12,null,s):(0,I.localize)(13,null,s):s===1?S?(0,I.localize)(14,null,s):(0,I.localize)(15,null,s):S?(0,I.localize)(16,null,s):(0,I.localize)(17,null,s)):w<L?(s=Math.floor(w/$),E?s===1?S?(0,I.localize)(18,null,s):(0,I.localize)(19,null,s):S?(0,I.localize)(20,null,s):(0,I.localize)(21,null,s):s===1?S?(0,I.localize)(22,null,s):(0,I.localize)(23,null,s):S?(0,I.localize)(24,null,s):(0,I.localize)(25,null,s)):w<A?(s=Math.floor(w/L),E?s===1?(0,I.localize)(26,null,s):(0,I.localize)(27,null,s):s===1?(0,I.localize)(28,null,s):(0,I.localize)(29,null,s)):w<v?(s=Math.floor(w/A),E?s===1?S?(0,I.localize)(30,null,s):(0,I.localize)(31,null,s):S?(0,I.localize)(32,null,s):(0,I.localize)(33,null,s):s===1?S?(0,I.localize)(34,null,s):(0,I.localize)(35,null,s):S?(0,I.localize)(36,null,s):(0,I.localize)(37,null,s)):w<p?(s=Math.floor(w/v),E?s===1?S?(0,I.localize)(38,null,s):(0,I.localize)(39,null,s):S?(0,I.localize)(40,null,s):(0,I.localize)(41,null,s):s===1?S?(0,I.localize)(42,null,s):(0,I.localize)(43,null,s):S?(0,I.localize)(44,null,s):(0,I.localize)(45,null,s)):(s=Math.floor(w/p),E?s===1?S?(0,I.localize)(46,null,s):(0,I.localize)(47,null,s):S?(0,I.localize)(48,null,s):(0,I.localize)(49,null,s):s===1?S?(0,I.localize)(50,null,s):(0,I.localize)(51,null,s):S?(0,I.localize)(52,null,s):(0,I.localize)(53,null,s))}e.$Am=k;function R(m,E){const S=Math.abs(m/1e3);return S<1?E?(0,I.localize)(54,null,m):(0,I.localize)(55,null,m):S<F?E?(0,I.localize)(56,null,Math.round(m)/1e3):(0,I.localize)(57,null,Math.round(m)/1e3):S<$?E?(0,I.localize)(58,null,Math.round(m/(1e3*F))):(0,I.localize)(59,null,Math.round(m/(1e3*F))):S<L?E?(0,I.localize)(60,null,Math.round(m/(1e3*$))):(0,I.localize)(61,null,Math.round(m/(1e3*$))):(0,I.localize)(62,null,Math.round(m/(1e3*L)))}e.$Bm=R;function C(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Cm=C}),define(Ce[184],Ie([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Ce[44],Ie([1,0,19,18,184]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Wi=e.$Vi=void 0;function L(C,m){return m&&(C.stack||C.stacktrace)?$.localize(0,null,v(C),A(C.stack)||A(C.stacktrace)):v(C)}function A(C){return Array.isArray(C)?C.join(`
`):C}function v(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?$.localize(1,null,C.message):C.message||$.localize(2,null)}function p(C=null,m=!1){if(!C)return $.localize(3,null);if(Array.isArray(C)){const E=I.$Hb(C),S=p(E[0],m);return E.length>1?$.localize(4,null,S,E.length):S}if(F.$Mf(C))return C;if(C.detail){const E=C.detail;if(E.error)return L(E.error,m);if(E.exception)return L(E.exception,m)}return C.stack?L(C,m):C.message?C.message:$.localize(5,null)}e.$Vi=p;function k(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Wi=k;function R(C,m){let E;return typeof C=="string"?E=new Error(C):E=C,E.actions=m,E}e.$Xi=R}),define(Ce[185],Ie([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Ce[11],Ie([1,0,185]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let F=!1,$=!1,L=!1,A=!1,v=!1,p=!1,k=!1,R=!1,C=!1,m=!1,E,S=e.$g,l=e.$g,w,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",a=r&&n?.type==="renderer";if(typeof n=="object"){F=n.platform==="win32",$=n.platform==="darwin",L=n.platform==="linux",A=L&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,k=r,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,S=e.$g;const f=n.env.VSCODE_NLS_CONFIG;if(f)try{const y=JSON.parse(f),P=y.availableLanguages["*"];E=y.locale,l=y.osLocale,S=P||e.$g,w=y._translationsConfigFile}catch{}v=!0}else typeof navigator=="object"&&!a?(s=navigator.userAgent,F=s.indexOf("Windows")>=0,$=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=s.indexOf("Linux")>=0,m=s?.indexOf("Mobi")>=0,p=!0,E=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,S=E,l=navigator.language):console.error("Unable to resolve platform.");var t;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(t||(e.Platform=t={}));function h(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=h;let c=0;$?c=1:F?c=3:L&&(c=2),e.$i=F,e.$j=$,e.$k=L,e.$l=A,e.$m=v,e.$n=k,e.$o=p,e.$p=p&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=R,e.$s=m,e.$t=C,e.$u=c,e.$v=s,e.$w=S;var o;(function(f){function y(){return e.$w}f.value=y;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=P;function T(){return e.$w==="en"}f.isDefault=T})(o||(e.Language=o={})),e.$x=E,e.$y=l,e.$z=w,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const f=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let T=0,U=f.length;T<U;T++){const z=f[T];if(z.id===P.data.vscodeScheduleAsyncWork){f.splice(T,1),z.callback();return}}});let y=0;return P=>{const T=++y;f.push({id:T,callback:P}),i.postMessage({vscodeScheduleAsyncWork:T},"*")}}return f=>setTimeout(f)})();var u;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=$||R?2:F?1:3;let d=!0,b=!1;function D(){if(!b){b=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,d=new Uint16Array(f.buffer)[0]===513}return d}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function g(f){return parseFloat(f)>=20}e.$J=g}),define(Ce[49],Ie([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let F;const $=globalThis.vscode;if(typeof $<"u"&&typeof $.process<"u"){const L=$.process;F={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$dc=F.platform,e.$ec=F.arch}),define(Ce[17],Ie([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const F=65,$=97,L=90,A=122,v=46,p=47,k=92,R=58,C=63;class m extends Error{constructor(h,c,o){let u;typeof c=="string"&&c.indexOf("not ")===0?(u="must not be",c=c.replace(/^not /,"")):u="must be";const d=h.indexOf(".")!==-1?"property":"argument";let b=`The "${h}" ${d} ${u} of type ${c}`;b+=`. Received type ${typeof o}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,h){if(t===null||typeof t!="object")throw new m(h,"Object",t)}function S(t,h){if(typeof t!="string")throw new m(h,"string",t)}const l=I.$dc==="win32";function w(t){return t===p||t===k}function s(t){return t===p}function i(t){return t>=F&&t<=L||t>=$&&t<=A}function n(t,h,c,o){let u="",d=0,b=-1,D=0,g=0;for(let f=0;f<=t.length;++f){if(f<t.length)g=t.charCodeAt(f);else{if(o(g))break;g=p}if(o(g)){if(!(b===f-1||D===1))if(D===2){if(u.length<2||d!==2||u.charCodeAt(u.length-1)!==v||u.charCodeAt(u.length-2)!==v){if(u.length>2){const y=u.lastIndexOf(c);y===-1?(u="",d=0):(u=u.slice(0,y),d=u.length-1-u.lastIndexOf(c)),b=f,D=0;continue}else if(u.length!==0){u="",d=0,b=f,D=0;continue}}h&&(u+=u.length>0?`${c}..`:"..",d=2)}else u.length>0?u+=`${c}${t.slice(b+1,f)}`:u=t.slice(b+1,f),d=f-b-1;b=f,D=0}else g===v&&D!==-1?++D:D=-1}return u}function r(t,h){E(h,"pathObject");const c=h.dir||h.root,o=h.base||`${h.name||""}${h.ext||""}`;return c?c===h.root?`${c}${o}`:`${c}${t}${o}`:o}e.$fc={resolve(...t){let h="",c="",o=!1;for(let u=t.length-1;u>=-1;u--){let d;if(u>=0){if(d=t[u],S(d,"path"),d.length===0)continue}else h.length===0?d=I.cwd():(d=I.env[`=${h}`]||I.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==h.toLowerCase()&&d.charCodeAt(2)===k)&&(d=`${h}\\`));const b=d.length;let D=0,g="",f=!1;const y=d.charCodeAt(0);if(b===1)w(y)&&(D=1,f=!0);else if(w(y))if(f=!0,w(d.charCodeAt(1))){let P=2,T=P;for(;P<b&&!w(d.charCodeAt(P));)P++;if(P<b&&P!==T){const U=d.slice(T,P);for(T=P;P<b&&w(d.charCodeAt(P));)P++;if(P<b&&P!==T){for(T=P;P<b&&!w(d.charCodeAt(P));)P++;(P===b||P!==T)&&(g=`\\\\${U}\\${d.slice(T,P)}`,D=P)}}}else D=1;else i(y)&&d.charCodeAt(1)===R&&(g=d.slice(0,2),D=2,b>2&&w(d.charCodeAt(2))&&(f=!0,D=3));if(g.length>0)if(h.length>0){if(g.toLowerCase()!==h.toLowerCase())continue}else h=g;if(o){if(h.length>0)break}else if(c=`${d.slice(D)}\\${c}`,o=f,f&&h.length>0)break}return c=n(c,!o,"\\",w),o?`${h}\\${c}`:`${h}${c}`||"."},normalize(t){S(t,"path");const h=t.length;if(h===0)return".";let c=0,o,u=!1;const d=t.charCodeAt(0);if(h===1)return s(d)?"\\":t;if(w(d))if(u=!0,w(t.charCodeAt(1))){let D=2,g=D;for(;D<h&&!w(t.charCodeAt(D));)D++;if(D<h&&D!==g){const f=t.slice(g,D);for(g=D;D<h&&w(t.charCodeAt(D));)D++;if(D<h&&D!==g){for(g=D;D<h&&!w(t.charCodeAt(D));)D++;if(D===h)return`\\\\${f}\\${t.slice(g)}\\`;D!==g&&(o=`\\\\${f}\\${t.slice(g,D)}`,c=D)}}}else c=1;else i(d)&&t.charCodeAt(1)===R&&(o=t.slice(0,2),c=2,h>2&&w(t.charCodeAt(2))&&(u=!0,c=3));let b=c<h?n(t.slice(c),!u,"\\",w):"";return b.length===0&&!u&&(b="."),b.length>0&&w(t.charCodeAt(h-1))&&(b+="\\"),o===void 0?u?`\\${b}`:b:u?`${o}\\${b}`:`${o}${b}`},isAbsolute(t){S(t,"path");const h=t.length;if(h===0)return!1;const c=t.charCodeAt(0);return w(c)||h>2&&i(c)&&t.charCodeAt(1)===R&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let h,c;for(let d=0;d<t.length;++d){const b=t[d];S(b,"path"),b.length>0&&(h===void 0?h=c=b:h+=`\\${b}`)}if(h===void 0)return".";let o=!0,u=0;if(typeof c=="string"&&w(c.charCodeAt(0))){++u;const d=c.length;d>1&&w(c.charCodeAt(1))&&(++u,d>2&&(w(c.charCodeAt(2))?++u:o=!1))}if(o){for(;u<h.length&&w(h.charCodeAt(u));)u++;u>=2&&(h=`\\${h.slice(u)}`)}return e.$fc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h)return"";const c=e.$fc.resolve(t),o=e.$fc.resolve(h);if(c===o||(t=c.toLowerCase(),h=o.toLowerCase(),t===h))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===k;)u++;let d=t.length;for(;d-1>u&&t.charCodeAt(d-1)===k;)d--;const b=d-u;let D=0;for(;D<h.length&&h.charCodeAt(D)===k;)D++;let g=h.length;for(;g-1>D&&h.charCodeAt(g-1)===k;)g--;const f=g-D,y=b<f?b:f;let P=-1,T=0;for(;T<y;T++){const z=t.charCodeAt(u+T);if(z!==h.charCodeAt(D+T))break;z===k&&(P=T)}if(T!==y){if(P===-1)return o}else{if(f>y){if(h.charCodeAt(D+T)===k)return o.slice(D+T+1);if(T===2)return o.slice(D+T)}b>y&&(t.charCodeAt(u+T)===k?P=T:T===2&&(P=3)),P===-1&&(P=0)}let U="";for(T=u+P+1;T<=d;++T)(T===d||t.charCodeAt(T)===k)&&(U+=U.length===0?"..":"\\..");return D+=P,U.length>0?`${U}${o.slice(D,g)}`:(o.charCodeAt(D)===k&&++D,o.slice(D,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const h=e.$fc.resolve(t);if(h.length<=2)return t;if(h.charCodeAt(0)===k){if(h.charCodeAt(1)===k){const c=h.charCodeAt(2);if(c!==C&&c!==v)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(i(h.charCodeAt(0))&&h.charCodeAt(1)===R&&h.charCodeAt(2)===k)return`\\\\?\\${h}`;return t},dirname(t){S(t,"path");const h=t.length;if(h===0)return".";let c=-1,o=0;const u=t.charCodeAt(0);if(h===1)return w(u)?t:".";if(w(u)){if(c=o=1,w(t.charCodeAt(1))){let D=2,g=D;for(;D<h&&!w(t.charCodeAt(D));)D++;if(D<h&&D!==g){for(g=D;D<h&&w(t.charCodeAt(D));)D++;if(D<h&&D!==g){for(g=D;D<h&&!w(t.charCodeAt(D));)D++;if(D===h)return t;D!==g&&(c=o=D+1)}}}}else i(u)&&t.charCodeAt(1)===R&&(c=h>2&&w(t.charCodeAt(2))?3:2,o=c);let d=-1,b=!0;for(let D=h-1;D>=o;--D)if(w(t.charCodeAt(D))){if(!b){d=D;break}}else b=!1;if(d===-1){if(c===-1)return".";d=c}return t.slice(0,d)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let c=0,o=-1,u=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(c=2),h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let b=h.length-1,D=-1;for(d=t.length-1;d>=c;--d){const g=t.charCodeAt(d);if(w(g)){if(!u){c=d+1;break}}else D===-1&&(u=!1,D=d+1),b>=0&&(g===h.charCodeAt(b)?--b===-1&&(o=d):(b=-1,o=D))}return c===o?o=D:o===-1&&(o=t.length),t.slice(c,o)}for(d=t.length-1;d>=c;--d)if(w(t.charCodeAt(d))){if(!u){c=d+1;break}}else o===-1&&(u=!1,o=d+1);return o===-1?"":t.slice(c,o)},extname(t){S(t,"path");let h=0,c=-1,o=0,u=-1,d=!0,b=0;t.length>=2&&t.charCodeAt(1)===R&&i(t.charCodeAt(0))&&(h=o=2);for(let D=t.length-1;D>=h;--D){const g=t.charCodeAt(D);if(w(g)){if(!d){o=D+1;break}continue}u===-1&&(d=!1,u=D+1),g===v?c===-1?c=D:b!==1&&(b=1):c!==-1&&(b=-1)}return c===-1||u===-1||b===0||b===1&&c===u-1&&c===o+1?"":t.slice(c,u)},format:r.bind(null,"\\"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const c=t.length;let o=0,u=t.charCodeAt(0);if(c===1)return w(u)?(h.root=h.dir=t,h):(h.base=h.name=t,h);if(w(u)){if(o=1,w(t.charCodeAt(1))){let P=2,T=P;for(;P<c&&!w(t.charCodeAt(P));)P++;if(P<c&&P!==T){for(T=P;P<c&&w(t.charCodeAt(P));)P++;if(P<c&&P!==T){for(T=P;P<c&&!w(t.charCodeAt(P));)P++;P===c?o=P:P!==T&&(o=P+1)}}}}else if(i(u)&&t.charCodeAt(1)===R){if(c<=2)return h.root=h.dir=t,h;if(o=2,w(t.charCodeAt(2))){if(c===3)return h.root=h.dir=t,h;o=3}}o>0&&(h.root=t.slice(0,o));let d=-1,b=o,D=-1,g=!0,f=t.length-1,y=0;for(;f>=o;--f){if(u=t.charCodeAt(f),w(u)){if(!g){b=f+1;break}continue}D===-1&&(g=!1,D=f+1),u===v?d===-1?d=f:y!==1&&(y=1):d!==-1&&(y=-1)}return D!==-1&&(d===-1||y===0||y===1&&d===D-1&&d===b+1?h.base=h.name=t.slice(b,D):(h.name=t.slice(b,d),h.base=t.slice(b,D),h.ext=t.slice(d,D))),b>0&&b!==o?h.dir=t.slice(0,b-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(l){const t=/\\/g;return()=>{const h=I.cwd().replace(t,"/");return h.slice(h.indexOf("/"))}}return()=>I.cwd()})();e.$gc={resolve(...t){let h="",c=!1;for(let o=t.length-1;o>=-1&&!c;o--){const u=o>=0?t[o]:a();S(u,"path"),u.length!==0&&(h=`${u}/${h}`,c=u.charCodeAt(0)===p)}return h=n(h,!c,"/",s),c?`/${h}`:h.length>0?h:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===p,c=t.charCodeAt(t.length-1)===p;return t=n(t,!h,"/",s),t.length===0?h?"/":c?"./":".":(c&&(t+="/"),h?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let h;for(let c=0;c<t.length;++c){const o=t[c];S(o,"path"),o.length>0&&(h===void 0?h=o:h+=`/${o}`)}return h===void 0?".":e.$gc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h||(t=e.$gc.resolve(t),h=e.$gc.resolve(h),t===h))return"";const c=1,o=t.length,u=o-c,d=1,b=h.length-d,D=u<b?u:b;let g=-1,f=0;for(;f<D;f++){const P=t.charCodeAt(c+f);if(P!==h.charCodeAt(d+f))break;P===p&&(g=f)}if(f===D)if(b>D){if(h.charCodeAt(d+f)===p)return h.slice(d+f+1);if(f===0)return h.slice(d+f)}else u>D&&(t.charCodeAt(c+f)===p?g=f:f===0&&(g=0));let y="";for(f=c+g+1;f<=o;++f)(f===o||t.charCodeAt(f)===p)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(d+g)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===p;let c=-1,o=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===p){if(!o){c=u;break}}else o=!1;return c===-1?h?"/":".":h&&c===1?"//":t.slice(0,c)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let c=0,o=-1,u=!0,d;if(h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let b=h.length-1,D=-1;for(d=t.length-1;d>=0;--d){const g=t.charCodeAt(d);if(g===p){if(!u){c=d+1;break}}else D===-1&&(u=!1,D=d+1),b>=0&&(g===h.charCodeAt(b)?--b===-1&&(o=d):(b=-1,o=D))}return c===o?o=D:o===-1&&(o=t.length),t.slice(c,o)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===p){if(!u){c=d+1;break}}else o===-1&&(u=!1,o=d+1);return o===-1?"":t.slice(c,o)},extname(t){S(t,"path");let h=-1,c=0,o=-1,u=!0,d=0;for(let b=t.length-1;b>=0;--b){const D=t.charCodeAt(b);if(D===p){if(!u){c=b+1;break}continue}o===-1&&(u=!1,o=b+1),D===v?h===-1?h=b:d!==1&&(d=1):h!==-1&&(d=-1)}return h===-1||o===-1||d===0||d===1&&h===o-1&&h===c+1?"":t.slice(h,o)},format:r.bind(null,"/"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const c=t.charCodeAt(0)===p;let o;c?(h.root="/",o=1):o=0;let u=-1,d=0,b=-1,D=!0,g=t.length-1,f=0;for(;g>=o;--g){const y=t.charCodeAt(g);if(y===p){if(!D){d=g+1;break}continue}b===-1&&(D=!1,b=g+1),y===v?u===-1?u=g:f!==1&&(f=1):u!==-1&&(f=-1)}if(b!==-1){const y=d===0&&c?1:d;u===-1||f===0||f===1&&u===b-1&&u===d+1?h.base=h.name=t.slice(y,b):(h.name=t.slice(y,u),h.base=t.slice(y,b),h.ext=t.slice(u,b))}return d>0?h.dir=t.slice(0,d-1):c&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=l?e.$fc.normalize:e.$gc.normalize,e.$ic=l?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=l?e.$fc.join:e.$gc.join,e.$kc=l?e.$fc.resolve:e.$gc.resolve,e.$lc=l?e.$fc.relative:e.$gc.relative,e.$mc=l?e.$fc.dirname:e.$gc.dirname,e.$nc=l?e.$fc.basename:e.$gc.basename,e.$oc=l?e.$fc.extname:e.$gc.extname,e.$pc=l?e.$fc.format:e.$gc.format,e.$qc=l?e.$fc.parse:e.$gc.parse,e.$rc=l?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=l?e.$fc.sep:e.$gc.sep,e.$tc=l?e.$fc.delimiter:e.$gc.delimiter}),define(Ce[128],Ie([1,0,43,17]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=void 0;const $=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),L=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function v(D,g,f=!1){const y=D||"",P=g||"",T=$.value.collator.compare(y,P);return $.value.collatorIsNumeric&&T===0&&y!==P?y<P?-1:1:T}e.$Nq=v;function p(D,g){const f=L.value.collator;return D=D||"",g=g||"",r(f,D,g)}e.$Oq=p;function k(D,g){const f=L.value.collator;return D=D||"",g=g||"",c(D,g)||r(f,D,g)}e.$Pq=k;function R(D,g){const f=L.value.collator;return D=D||"",g=g||"",h(D,g)||r(f,D,g)}e.$Qq=R;function C(D,g){return D=D||"",g=g||"",D===g?0:D<g?-1:1}e.$Rq=C;function m(D,g){const[f,y]=i(D),[P,T]=i(g);let U=$.value.collator.compare(y,T);if(U===0){if($.value.collatorIsNumeric&&y!==T)return y<T?-1:1;if(U=$.value.collator.compare(f,P),$.value.collatorIsNumeric&&U===0&&f!==P)return f<P?-1:1}return U}e.$Sq=m;function E(D,g){D=D||"",g=g||"";const f=n(D),y=n(g),P=L.value.collator,T=A.value.collator;return r(T,f,y)||r(P,D,g)}e.$Tq=E;function S(D,g){D=D||"",g=g||"";const f=n(D),y=n(g),P=L.value.collator,T=A.value.collator;return r(T,f,y)||c(D,g)||r(P,D,g)}e.$Uq=S;function l(D,g){D=D||"",g=g||"";const f=n(D),y=n(g),P=L.value.collator,T=A.value.collator;return r(T,f,y)||h(D,g)||r(P,D,g)}e.$Vq=l;function w(D,g){D=D||"",g=g||"";const f=n(D).toLowerCase(),y=n(g).toLowerCase();return f!==y?f<y?-1:1:D!==g?D<g?-1:1:0}e.$Wq=w;const s=/^(.*?)(\.([^.]*))?$/;function i(D,g=!1){const f=D?s.exec(D):[];let y=[f&&f[1]||"",f&&f[3]||""];return g&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(D){const g=D?s.exec(D):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function r(D,g,f){const y=D.compare(g,f);return y!==0?y:g.length!==f.length?g.length<f.length?-1:1:0}function a(D){const g=D.charAt(0);return g.toLocaleUpperCase()!==g}function t(D){const g=D.charAt(0);return g.toLocaleLowerCase()!==g}function h(D,g){return a(D)&&t(g)?-1:t(D)&&a(g)?1:0}function c(D,g){return t(D)&&a(g)?-1:a(D)&&t(g)?1:0}function o(D,g,f=!1){return f||(D=D&&D.toLowerCase(),g=g&&g.toLowerCase()),D===g?0:D<g?-1:1}function u(D,g,f=!1){const y=D.split(F.sep),P=g.split(F.sep),T=y.length-1,U=P.length-1;let z,M;for(let N=0;;N++){if(z=T===N,M=U===N,z&&M)return v(y[N],P[N],f);if(z)return-1;if(M)return 1;const O=o(y[N],P[N],f);if(O!==0)return O}}e.$Xq=u;function d(D,g,f){const y=D.toLowerCase(),P=g.toLowerCase(),T=b(D,g,f);if(T)return T;const U=y.endsWith(f),z=P.endsWith(f);if(U!==z)return U?-1:1;const M=v(y,P);return M!==0?M:y.localeCompare(P)}e.$Yq=d;function b(D,g,f){const y=D.toLowerCase(),P=g.toLowerCase(),T=y.startsWith(f),U=P.startsWith(f);if(T!==U)return T?-1:1;if(T&&U){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}e.$Zq=b}),define(Ce[34],Ie([1,0,17,11,12,18]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=void 0;function A(d){return d===47||d===92}e.$5f=A;function v(d){return d.replace(/[\\/]/g,I.$gc.sep)}e.$6f=v;function p(d){return d.indexOf("/")===-1&&(d=v(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$7f=p;function k(d,b=I.$gc.sep){if(!d)return"";const D=d.length,g=d.charCodeAt(0);if(A(g)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let y=3;const P=y;for(;y<D&&!A(d.charCodeAt(y));y++);if(P!==y&&!A(d.charCodeAt(y+1))){for(y+=1;y<D;y++)if(A(d.charCodeAt(y)))return d.slice(0,y+1).replace(/[\\/]/g,b)}}return b}else if(s(g)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+b:d.slice(0,2);let f=d.indexOf("://");if(f!==-1){for(f+=3;f<D;f++)if(A(d.charCodeAt(f)))return d.slice(0,f+1)}return""}e.$8f=k;function R(d){if(!F.$i||!d||d.length<5)return!1;let b=d.charCodeAt(0);if(b!==92||(b=d.charCodeAt(1),b!==92))return!1;let D=2;const g=D;for(;D<d.length&&(b=d.charCodeAt(D),b!==92);D++);return!(g===D||(b=d.charCodeAt(D+1),isNaN(b)||b===92))}e.$9f=R;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(d,b=F.$i){const D=b?C:m;return!(!d||d.length===0||/^\s+$/.test(d)||(D.lastIndex=0,D.test(d))||b&&E.test(d)||d==="."||d===".."||b&&d[d.length-1]==="."||b&&d.length!==d.trim().length||d.length>255)}e.$0f=S;function l(d,b,D){const g=d===b;return!D||g?g:!d||!b?!1:(0,$.$df)(d,b)}e.$$f=l;function w(d,b,D,g=I.sep){if(d===b)return!0;if(!d||!b||b.length>d.length)return!1;if(D){if(!(0,$.$ef)(d,b))return!1;if(b.length===d.length)return!0;let y=b.length;return b.charAt(b.length-1)===g&&y--,d.charAt(y)===g}return b.charAt(b.length-1)!==g&&(b+=g),d.indexOf(b)===0}e.$_f=w;function s(d){return d>=65&&d<=90||d>=97&&d<=122}e.$ag=s;function i(d,b){return F.$i&&d.endsWith(":")&&(d+=I.sep),(0,I.$ic)(d)||(d=(0,I.$jc)(b,d)),d=(0,I.$hc)(d),F.$i?(d=(0,$.$Xe)(d,I.sep),d.endsWith(":")&&(d+=I.sep)):(d=(0,$.$Xe)(d,I.sep),d||(d=I.sep)),d}e.$bg=i;function n(d){const b=(0,I.$hc)(d);return F.$i?d.length>3?!1:r(b)&&(d.length===2||b.charCodeAt(2)===92):b===I.$gc.sep}e.$cg=n;function r(d,b=F.$i){return b?s(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$dg=r;function a(d,b=F.$i){return r(d,b)?d[0]:void 0}e.$eg=a;function t(d,b,D){return b.length>d.length?-1:d===b?0:(D&&(d=d.toLowerCase(),b=b.toLowerCase()),d.indexOf(b))}e.$fg=t;function h(d){const b=d.split(":");let D,g,f;for(const y of b){const P=Number(y);(0,L.$Qf)(P)?g===void 0?g=P:f===void 0&&(f=P):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.$gg=h;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(d,b,D=8){let g="";for(let y=0;y<D;y++){let P;y===0&&F.$i&&!b&&(D===3||D===4)?P=o:P=c,g+=P.charAt(Math.floor(Math.random()*P.length))}let f;return b?f=`${b}-${g}`:f=g,d?(0,I.$jc)(d,f):f}e.$hg=u}),define(Ce[129],Ie([1,0,128,123,54,17,11,12]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=void 0;const p=0,k=[p,[]];function R(j,Y,ne,ee){if(!j||!Y)return k;const Q=j.length,X=Y.length;if(Q<X)return k;const ce=j.toLowerCase();return C(Y,ne,X,j,ce,Q,ee)}e.$1q=R;function C(j,Y,ne,ee,Q,X,ce){const ie=[],fe=[];for(let ae=0;ae<ne;ae++){const Ee=ae*X,le=Ee-X,de=ae>0,ue=j[ae],ge=Y[ae];for(let V=0;V<X;V++){const Z=V>0,he=Ee+V,be=he-1,Pe=le+V-1,pe=Z?ie[be]:0,Le=de&&Z?ie[Pe]:0,Me=de&&Z?fe[Pe]:0;let W;!Le&&de?W=0:W=m(ue,ge,ee,Q,V,Me),W&&Le+W>=pe&&(ce||de||Q.startsWith(Y,V))?(fe[he]=Me+1,ie[he]=Le+W):(fe[he]=p,ie[he]=pe)}}const re=[];let J=ne-1,B=X-1;for(;J>=0&&B>=0;){const ae=J*X+B;fe[ae]===p||(re.push(B),J--),B--}return[ie[ne*X-1],re.reverse()]}function m(j,Y,ne,ee,Q,X){let ce=0;if(!E(Y,ee[Q]))return ce;if(ce+=1,X>0&&(ce+=X*5),j===ne[Q]&&(ce+=1),Q===0)ce+=8;else{const ie=S(ne.charCodeAt(Q-1));ie?ce+=ie:(0,F.$3j)(ne.charCodeAt(Q))&&X===0&&(ce+=2)}return ce}function E(j,Y){return j===Y?!0:j==="/"||j==="\\"?Y==="/"||Y==="\\":!1}function S(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function w(j,Y,ne=0,ee=0){const Q=Y;return Q.values&&Q.values.length>1?s(j,Q.values,ne,ee):i(j,Y,ne,ee)}e.$2q=w;function s(j,Y,ne,ee){let Q=0;const X=[];for(const ce of Y){const[ie,fe]=i(j,ce,ne,ee);if(typeof ie!="number")return l;Q+=ie,X.push(...fe)}return[Q,D(X)]}function i(j,Y,ne,ee){const Q=(0,F.$_j)(Y.original,Y.originalLowercase,ne,j,j.toLowerCase(),ee,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,F.$9j)(Q)]:l}const n=Object.freeze({score:0}),r=1<<18,a=1<<17,t=65536;function h(j,Y,ne,ee){const Q=ee.values?ee.values:[ee];return(0,$.$Yi)({[ee.normalized]:{values:Q.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:j,description:Y,allowNonContiguousMatches:ne}})}function c(j,Y,ne,ee,Q){if(!j||!Y.normalized)return n;const X=ee.getItemLabel(j);if(!X)return n;const ce=ee.getItemDescription(j),ie=h(X,ce,ne,Y),fe=Q[ie];if(fe)return fe;const re=o(X,ce,ee.getItemPath(j),Y,ne);return Q[ie]=re,re}e.$3q=c;function o(j,Y,ne,ee,Q){const X=!ne||!ee.containsPathSeparator;return ne&&(A.$k?ee.pathNormalized===ne:(0,v.$df)(ee.pathNormalized,ne))?{score:r,labelMatch:[{start:0,end:j.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:ee.values&&ee.values.length>1?u(j,Y,ne,ee.values,X,Q):d(j,Y,ne,ee,X,Q)}function u(j,Y,ne,ee,Q,X){let ce=0;const ie=[],fe=[];for(const re of ee){const{score:J,labelMatch:B,descriptionMatch:ae}=d(j,Y,ne,re,Q,X);if(J===p)return n;ce+=J,B&&ie.push(...B),ae&&fe.push(...ae)}return{score:ce,labelMatch:D(ie),descriptionMatch:D(fe)}}function d(j,Y,ne,ee,Q,X){if(Q||!Y){const[ce,ie]=R(j,ee.normalized,ee.normalizedLowercase,X&&!ee.expectContiguousMatch);if(ce){const fe=(0,F.$Zj)(ee.normalized,j);let re;if(fe){re=a;const J=Math.round(ee.normalized.length/j.length*100);re+=J}else re=t;return{score:re+ce,labelMatch:fe||b(ie)}}}if(Y){let ce=Y;ne&&(ce=`${Y}${L.sep}`);const ie=ce.length,fe=`${ce}${j}`,[re,J]=R(fe,ee.normalized,ee.normalizedLowercase,X&&!ee.expectContiguousMatch);if(re){const B=b(J),ae=[],Ee=[];return B.forEach(le=>{le.start<ie&&le.end>ie?(ae.push({start:0,end:le.end-ie}),Ee.push({start:le.start,end:ie})):le.start>=ie?ae.push({start:le.start-ie,end:le.end-ie}):Ee.push(le)}),{score:re,labelMatch:ae,descriptionMatch:Ee}}}return n}function b(j){const Y=[];if(!j)return Y;let ne;for(const ee of j)ne&&ne.end===ee?ne.end+=1:(ne={start:ee,end:ee+1},Y.push(ne));return Y}function D(j){const Y=j.sort((Q,X)=>Q.start-X.start),ne=[];let ee;for(const Q of Y)!ee||!g(ee,Q)?(ee=Q,ne.push(Q)):(ee.start=Math.min(ee.start,Q.start),ee.end=Math.max(ee.end,Q.end));return ne}function g(j,Y){return!(j.end<Y.start||Y.end<j.start)}function f(j,Y,ne,ee,Q,X){const ce=c(j,ne,ee,Q,X),ie=c(Y,ne,ee,Q,X),fe=ce.score,re=ie.score;if((fe===r||re===r)&&fe!==re)return fe===r?-1:1;if(fe>t||re>t){if(fe!==re)return fe>re?-1:1;if(fe<a&&re<a){const ue=P(ce.labelMatch,ie.labelMatch);if(ue!==0)return ue}const le=Q.getItemLabel(j)||"",de=Q.getItemLabel(Y)||"";if(le.length!==de.length)return le.length-de.length}if(fe!==re)return fe>re?-1:1;const J=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,B=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(J&&!B)return-1;if(B&&!J)return 1;const ae=y(j,ce,Q),Ee=y(Y,ie,Q);return ae&&Ee&&ae!==Ee?Ee>ae?-1:1:T(j,Y,ne,Q)}e.$4q=f;function y(j,Y,ne){let ee=-1,Q=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?ee=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(ee=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(Q=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const X=ne.getItemDescription(j);X&&(Q+=X.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(Q=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return Q-ee}function P(j,Y){if(!j&&!Y||(!j||!j.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!j||!j.length)return 1;const ne=j[0].start,Q=j[j.length-1].end-ne,X=Y[0].start,ie=Y[Y.length-1].end-X;return Q===ie?0:ie<Q?1:-1}function T(j,Y,ne,ee){const Q=ee.getItemLabel(j)||"",X=ee.getItemLabel(Y)||"",ce=ee.getItemDescription(j),ie=ee.getItemDescription(Y),fe=Q.length+(ce?ce.length:0),re=X.length+(ie?ie.length:0);if(fe!==re)return fe-re;const J=ee.getItemPath(j),B=ee.getItemPath(Y);return J&&B&&J.length!==B.length?J.length-B.length:Q!==X?(0,I.$Yq)(Q,X,ne.normalized):ce&&ie&&ce!==ie?(0,I.$Yq)(ce,ie,ne.normalized):J&&B&&J!==B?(0,I.$Yq)(J,B,ne.normalized):0}function U(j){return j.startsWith('"')&&j.endsWith('"')}const z=" ";function M(j){typeof j!="string"&&(j="");const Y=j.toLowerCase(),{pathNormalized:ne,normalized:ee,normalizedLowercase:Q}=N(j),X=ne.indexOf(L.sep)>=0,ce=U(j);let ie;const fe=j.split(z);if(fe.length>1)for(const re of fe){const J=U(re),{pathNormalized:B,normalized:ae,normalizedLowercase:Ee}=N(re);ae&&(ie||(ie=[]),ie.push({original:re,originalLowercase:re.toLowerCase(),pathNormalized:B,normalized:ae,normalizedLowercase:Ee,expectContiguousMatch:J}))}return{original:j,originalLowercase:Y,pathNormalized:ne,normalized:ee,normalizedLowercase:Q,values:ie,containsPathSeparator:X,expectContiguousMatch:ce}}e.$5q=M;function N(j){let Y;A.$i?Y=j.replace(/\//g,L.sep):Y=j.replace(/\\/g,L.sep);const ne=(0,v.$Ze)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:ne,normalizedLowercase:ne.toLowerCase()}}function O(j){return Array.isArray(j)?M(j.map(Y=>Y.original).join(z)):M(j.original)}e.$6q=O}),define(Ce[100],Ie([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=e.$ls=e.$ks=void 0,e.$ks=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},$={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const C=(0,I.$oc)(R),m=F[C.toLowerCase()];return m!==void 0?m:A(R)}e.$ls=L;function A(R){const C=(0,I.$oc)(R);return $[C.toLowerCase()]}e.$ms=A;function v(R){for(const C in $)if($[C]===R)return C}e.$ns=v;const p=/^(.+)\/(.+?)(;.+)?$/;function k(R,C){const m=p.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:R}e.$os=k}),define(Ce[101],Ie([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.TerminateResponseCode=e.Source=void 0;var F;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(F||(e.Source=F={}));var $;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})($||(e.TerminateResponseCode=$={}));function L(v,...p){const k=p.reduce((m,E)=>(m[E]=!0,m),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(m=>!k[m]).forEach(m=>{for(let E=0;E<R.length;E++)if(m.search(R[E])!==-1){delete v[m];break}})}e.$Wl=L;function A(v){v&&(delete v.DEBUG,I.$j&&delete v.DYLD_LIBRARY_PATH,I.$k&&delete v.LD_PRELOAD)}e.$Xl=A}),define(Ce[2],Ie([1,0,17,11]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const $=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function v(o,u){if(!o.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!$.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!L.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(o,u){return!o&&!u?"file":o}function k(o,u){switch(o){case"https":case"http":case"file":u?u[0]!==C&&(u=C+u):u=C;break}return u}const R="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(u){return u instanceof E?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,d,b,D,g,f=!1){typeof u=="object"?(this.scheme=u.scheme||R,this.authority=u.authority||R,this.path=u.path||R,this.query=u.query||R,this.fragment=u.fragment||R):(this.scheme=p(u,f),this.authority=d||R,this.path=k(this.scheme,b||R),this.query=D||R,this.fragment=g||R,v(this,f))}get fsPath(){return r(this,!1)}with(u){if(!u)return this;let{scheme:d,authority:b,path:D,query:g,fragment:f}=u;return d===void 0?d=this.scheme:d===null&&(d=R),b===void 0?b=this.authority:b===null&&(b=R),D===void 0?D=this.path:D===null&&(D=R),g===void 0?g=this.query:g===null&&(g=R),f===void 0?f=this.fragment:f===null&&(f=R),d===this.scheme&&b===this.authority&&D===this.path&&g===this.query&&f===this.fragment?this:new w(d,b,D,g,f)}static parse(u,d=!1){const b=m.exec(u);return b?new w(b[2]||R,c(b[4]||R),c(b[5]||R),c(b[7]||R),c(b[9]||R),d):new w(R,R,R,R,R)}static file(u){let d=R;if(F.$i&&(u=u.replace(/\\/g,C)),u[0]===C&&u[1]===C){const b=u.indexOf(C,2);b===-1?(d=u.substring(2),u=C):(d=u.substring(2,b),u=u.substring(b)||C)}return new w("file",d,u,R,R)}static from(u,d){return new w(u.scheme,u.authority,u.path,u.query,u.fragment,d)}static joinPath(u,...d){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return F.$i&&u.scheme==="file"?b=E.file(I.$fc.join(r(u,!0),...d)).path:b=I.$gc.join(u.path,...d),u.with({path:b})}toString(u=!1){return a(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof E)return u;{const d=new w(u);return d._formatted=u.external??null,d._fsPath=u._sep===l?u.fsPath??null:null,d}}else return u}}e.URI=E;function S(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}e.$vc=S;const l=F.$i?1:void 0;class w extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(u=!1){return u?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=l),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const s={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(o,u,d){let b,D=-1;for(let g=0;g<o.length;g++){const f=o.charCodeAt(g);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||u&&f===47||d&&f===91||d&&f===93||d&&f===58)D!==-1&&(b+=encodeURIComponent(o.substring(D,g)),D=-1),b!==void 0&&(b+=o.charAt(g));else{b===void 0&&(b=o.substr(0,g));const y=s[f];y!==void 0?(D!==-1&&(b+=encodeURIComponent(o.substring(D,g)),D=-1),b+=y):D===-1&&(D=g)}}return D!==-1&&(b+=encodeURIComponent(o.substring(D))),b!==void 0?b:o}function n(o){let u;for(let d=0;d<o.length;d++){const b=o.charCodeAt(d);b===35||b===63?(u===void 0&&(u=o.substr(0,d)),u+=s[b]):u!==void 0&&(u+=o[d])}return u!==void 0?u:o}function r(o,u){let d;return o.authority&&o.path.length>1&&o.scheme==="file"?d=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?u?d=o.path.substr(1):d=o.path[1].toLowerCase()+o.path.substr(2):d=o.path,F.$i&&(d=d.replace(/\//g,"\\")),d}e.$wc=r;function a(o,u){const d=u?n:i;let b="",{scheme:D,authority:g,path:f,query:y,fragment:P}=o;if(D&&(b+=D,b+=":"),(g||D==="file")&&(b+=C,b+=C),g){let T=g.indexOf("@");if(T!==-1){const U=g.substr(0,T);g=g.substr(T+1),T=U.lastIndexOf(":"),T===-1?b+=d(U,!1,!1):(b+=d(U.substr(0,T),!1,!1),b+=":",b+=d(U.substr(T+1),!1,!0)),b+="@"}g=g.toLowerCase(),T=g.lastIndexOf(":"),T===-1?b+=d(g,!1,!0):(b+=d(g.substr(0,T),!1,!0),b+=g.substr(T))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const T=f.charCodeAt(1);T>=65&&T<=90&&(f=`/${String.fromCharCode(T+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const T=f.charCodeAt(0);T>=65&&T<=90&&(f=`${String.fromCharCode(T+32)}:${f.substr(2)}`)}b+=d(f,!0,!1)}return y&&(b+="?",b+=d(y,!1,!1)),P&&(b+="#",b+=u?P:i(P,!1,!1)),b}function t(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+t(o.substr(3)):o}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(o){return o.match(h)?o.replace(h,u=>t(u)):o}}),define(Ce[186],Ie([1,0,2]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$tq=e.$sq=e.$rq=void 0;function F(k){const R=k;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$rq=F;function $(k){const R=[];let C;try{const m=JSON.parse(k.arguments),E=m[m.length-1];E&&E.__$stack&&(m.pop(),C=E.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",k.arguments)}return{args:R,stack:C}}e.$sq=$;function L(k){if(typeof k!="string")return L($(k).stack);const R=k;if(R){const C=A(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:I.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$tq=L;function A(k){if(!k)return k;const R=k.indexOf(`
`);return R===-1?k:k.substring(0,R)}function v(k,R){const{args:C,stack:m}=$(k),E=typeof C[0]=="string"&&C.length===1;let S=A(m);S&&(S=`(${S.trim()})`);let l=[];if(typeof C[0]=="string"?S&&E?l=[`%c[${R}] %c${C[0]} %c${S}`,p("blue"),p(""),p("grey")]:l=[`%c[${R}] %c${C[0]}`,p("blue"),p(""),...C.slice(1)]:l=[`%c[${R}]%`,p("blue"),...C],S&&!E&&l.push(S),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,l)}e.log=v;function p(k){return`color: ${k}`}}),define(Ce[56],Ie([1,0,21,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=void 0;function $(p){return JSON.stringify(p,A)}e.$Fh=$;function L(p){let k=JSON.parse(p);return k=v(k),k}e.$Gh=L;function A(p,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function v(p,k=0){if(!p||k>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return F.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof I.$me||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let R=0;R<p.length;++R)p[R]=v(p[R],k+1);else for(const R in p)Object.hasOwnProperty.call(p,R)&&(p[R]=v(p[R],k+1))}return p}e.$Hh=v}),define(Ce[16],Ie([1,0,14,11,12,2]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.Schemas=void 0;var A;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(A||(e.Schemas=A={}));function v(m,E){return L.URI.isUri(m)?(0,$.$df)(m.scheme,E):(0,$.$ef)(m,E+":")}e.$ig=v;function p(m,...E){return E.some(S=>v(m,S))}e.$jg=p,e.$kg="vscode-tkn",e.$lg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${A.vscodeRemoteResource}`}set(E,S,l){this.a[E]=S,this.b[E]=l}setConnectionToken(E,S){this.c[E]=S}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)try{return this.e(E)}catch(n){return I.$1(n),E}const S=E.authority;let l=this.a[S];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const w=this.b[S],s=this.c[S];let i=`path=${encodeURIComponent(E.path)}`;return typeof s=="string"&&(i+=`&${e.$lg}=${encodeURIComponent(s)}`),L.URI.from({scheme:F.$o?this.d:A.vscodeRemoteResource,authority:`${l}:${w}`,path:this.f,query:i})}}e.$mg=new k,e.$ng="vs/../../extensions",e.$og="vs/../../node_modules",e.$pg="vs/../../node_modules.asar",e.$qg="vs/../../node_modules.asar.unpacked",e.$rg="vscode-app";class R{static{this.a=e.$rg}asBrowserUri(E){const S=this.b(E,me);return this.uriToBrowserUri(S)}uriToBrowserUri(E){return E.scheme===A.vscodeRemote?e.$mg.rewrite(E):E.scheme===A.file&&(F.$m||F.$q===`${A.vscodeFileResource}://${R.a}`)?E.with({scheme:A.vscodeFileResource,authority:E.authority||R.a,query:null,fragment:null}):E}asFileUri(E){const S=this.b(E,me);return this.uriToFileUri(S)}uriToFileUri(E){return E.scheme===A.vscodeFileResource?E.with({scheme:A.file,authority:E.authority!==R.a?E.authority:null,query:null,fragment:null}):E}b(E,S){return L.URI.isUri(E)?E:L.URI.parse(S.toUrl(E))}}e.$sg=new R;var C;(function(m){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(E.get("3"));const S="vscode-coi";function l(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:L.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(S);if(n)return E.get(n)}m.getHeadersFromQuery=l;function w(s,i,n){if(!globalThis.crossOriginIsolated)return;const r=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(S,r):s[S]=r}m.addSearchParam=w})(C||(e.COI=C={}))}),define(Ce[187],Ie([1,0,158,16,11,2]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0;class A{constructor(m,E,S){this.id=m,this.dependencies=E,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,E,S)=>{typeof m!="string"&&(S=E,E=m,m=null),(typeof E!="object"||!Array.isArray(E))&&(S=E,E=null),this.c.push(new A(m,E,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const E=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!E)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(m){return new Promise((E,S)=>{const l=document.createElement("script");l.setAttribute("async","async"),l.setAttribute("type","text/javascript");const w=()=>{l.removeEventListener("load",s),l.removeEventListener("error",i)},s=n=>{w(),E(this.c.pop())},i=n=>{w(),S(n)};l.addEventListener("load",s),l.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),l.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(l)})}i(m){return new Promise((E,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),E(this.c.pop())}catch(l){S(l)}})}async j(m){try{const E=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,l=globalThis._VSCODE_NODE_MODULES.module,w=L.URI.parse(m).fsPath,s=E.readFileSync(w).toString(),i=l.wrap(s.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const p=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function R(C,m,E){if(I.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[C]&&(C=k[C]);const S=`${C}/${m}`;if(p.has(S))return p.get(S);let l;if(/^\w[\w\d+.-]*:\/\//.test(S))l=S;else{const n=`${E&&!$.$o?F.$pg:F.$og}/${S}`;l=F.$sg.asBrowserUri(n).toString(!0)}const w=v.INSTANCE.load(l);return p.set(S,w),w}else return await new Promise((S,l)=>{me([C],S,l)})}e.$mD=R}),define(Ce[23],Ie([1,0,34,16,17,11,12,2]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.DataUri=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=void 0;function p(E){return(0,v.$wc)(E,!0)}e.$zg=p;class k{constructor(S){this.a=S}compare(S,l,w=!1){return S===l?0:(0,A.$9e)(this.getComparisonKey(S,w),this.getComparisonKey(l,w))}isEqual(S,l,w=!1){return S===l?!0:!S||!l?!1:this.getComparisonKey(S,w)===this.getComparisonKey(l,w)}getComparisonKey(S,l=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,l,w=!1){if(S.scheme===l.scheme){if(S.scheme===F.Schemas.file)return I.$_f(p(S),p(l),this.a(S))&&S.query===l.query&&(w||S.fragment===l.fragment);if((0,e.$Qg)(S.authority,l.authority))return I.$_f(S.path,l.path,this.a(S),"/")&&S.query===l.query&&(w||S.fragment===l.fragment)}return!1}joinPath(S,...l){return v.URI.joinPath(S,...l)}basenameOrAuthority(S){return(0,e.$Ig)(S)||S.authority}basename(S){return $.$gc.basename(S.path)}extname(S){return $.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let l;return S.scheme===F.Schemas.file?l=v.URI.file($.$mc(p(S))).path:(l=$.$gc.dirname(S.path),S.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),l="/")),S.with({path:l})}normalizePath(S){if(!S.path.length)return S;let l;return S.scheme===F.Schemas.file?l=v.URI.file($.$hc(p(S))).path:l=$.$gc.normalize(S.path),S.with({path:l})}relativePath(S,l){if(S.scheme!==l.scheme||!(0,e.$Qg)(S.authority,l.authority))return;if(S.scheme===F.Schemas.file){const i=$.$lc(p(S),p(l));return L.$i?I.$6f(i):i}let w=S.path||"/";const s=l.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(w.length,s.length);i<n&&!(w.charCodeAt(i)!==s.charCodeAt(i)&&w.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);w=s.substr(0,i)+w.substr(i)}return $.$gc.relative(w,s)}resolvePath(S,l){if(S.scheme===F.Schemas.file){const w=v.URI.file($.$kc(p(S),l));return S.with({authority:w.authority,path:w.path})}return l=I.$7f(l),S.with({path:$.$gc.resolve(S.path,l)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,l){return S===l||S!==void 0&&l!==void 0&&(0,A.$df)(S,l)}hasTrailingPathSeparator(S,l=$.sep){if(S.scheme===F.Schemas.file){const w=p(S);return w.length>I.$8f(w).length&&w[w.length-1]===l}else{const w=S.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,l=$.sep){return(0,e.$Rg)(S,l)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,l=$.sep){let w=!1;if(S.scheme===F.Schemas.file){const s=p(S);w=s!==void 0&&s.length===I.$8f(s).length&&s[s.length-1]===l}else{l="/";const s=S.path;w=s.length===1&&s.charCodeAt(s.length-1)===47}return!w&&!(0,e.$Rg)(S,l)?S.with({path:S.path+"/"}):S}}e.$Ag=k,e.$Bg=new k(()=>!1),e.$Cg=new k(E=>E.scheme===F.Schemas.file?!L.$k:!0),e.$Dg=new k(E=>!0),e.$Eg=e.$Bg.isEqual.bind(e.$Bg),e.$Fg=e.$Bg.isEqualOrParent.bind(e.$Bg),e.$Gg=e.$Bg.getComparisonKey.bind(e.$Bg),e.$Hg=e.$Bg.basenameOrAuthority.bind(e.$Bg),e.$Ig=e.$Bg.basename.bind(e.$Bg),e.$Jg=e.$Bg.extname.bind(e.$Bg),e.$Kg=e.$Bg.dirname.bind(e.$Bg),e.$Lg=e.$Bg.joinPath.bind(e.$Bg),e.$Mg=e.$Bg.normalizePath.bind(e.$Bg),e.$Ng=e.$Bg.relativePath.bind(e.$Bg),e.$Og=e.$Bg.resolvePath.bind(e.$Bg),e.$Pg=e.$Bg.isAbsolutePath.bind(e.$Bg),e.$Qg=e.$Bg.isEqualAuthority.bind(e.$Bg),e.$Rg=e.$Bg.hasTrailingPathSeparator.bind(e.$Bg),e.$Sg=e.$Bg.removeTrailingPathSeparator.bind(e.$Bg),e.$Tg=e.$Bg.addTrailingPathSeparator.bind(e.$Bg);function R(E,S){const l=[];for(let w=0;w<E.length;w++){const s=S(E[w]);E.some((i,n)=>n===w?!1:(0,e.$Fg)(s,S(i)))||l.push(E[w])}return l}e.$Ug=R;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function S(l){const w=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,a]=n.split(":");r&&a&&w.set(r,a)});const i=l.path.substring(0,l.path.indexOf(";"));return i&&w.set(E.META_DATA_MIME,i),w}E.parseMetaData=S})(C||(e.DataUri=C={}));function m(E,S,l){if(S){let w=E.path;return w&&w[0]!==$.$gc.sep&&(w=$.$gc.sep+w),E.with({scheme:l,authority:S,path:w})}return E.with({scheme:l})}e.$Vg=m}),define(Ce[8],Ie([1,0,22,14,4,3,23,11,164,43]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.Promises=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=void 0;function R(ge){return!!ge&&typeof ge.then=="function"}e.$Wg=R;function C(ge){const V=new I.$9d,Z=ge(V.token),he=new Promise((be,Pe)=>{const pe=V.token.onCancellationRequested(()=>{pe.dispose(),Pe(new F.$5)});Promise.resolve(Z).then(Le=>{pe.dispose(),V.dispose(),be(Le)},Le=>{pe.dispose(),V.dispose(),Pe(Le)})});return new class{cancel(){V.cancel(),V.dispose()}then(be,Pe){return he.then(be,Pe)}catch(be){return this.then(void 0,be)}finally(be){return he.finally(be)}}}e.$Xg=C;function m(ge,V,Z){return new Promise((he,be)=>{const Pe=V.onCancellationRequested(()=>{Pe.dispose(),he(Z)});ge.then(he,be).finally(()=>Pe.dispose())})}e.$Yg=m;function E(ge,V){return new Promise((Z,he)=>{const be=V.onCancellationRequested(()=>{be.dispose(),he(new F.$5)});ge.then(Z,he).finally(()=>be.dispose())})}e.$Zg=E;async function S(ge){let V=-1;const Z=ge.map((he,be)=>he.then(Pe=>(V=be,Pe)));try{return await Promise.race(Z)}finally{ge.forEach((he,be)=>{be!==V&&he.cancel()})}}e.$1g=S;function l(ge,V,Z){let he;const be=setTimeout(()=>{he?.(void 0),Z?.()},V);return Promise.race([ge.finally(()=>clearTimeout(be)),new Promise(Pe=>he=Pe)])}e.$2g=l;function w(ge){return new Promise((V,Z)=>{const he=ge();R(he)?he.then(V,Z):V(he)})}e.$3g=w;function s(){let ge,V;return{promise:new Promise((he,be)=>{ge=he,V=be}),resolve:ge,reject:V}}e.$4g=s;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const Z=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Z,Z).then(he)})}return new Promise((Z,he)=>{this.b.then(Z,he)})}return this.a=V(),new Promise((Z,he)=>{this.a.then(be=>{this.a=null,Z(be)},be=>{this.a=null,he(be)})})}dispose(){this.f=!0}}e.$5g=i;class n{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$6g=n;class r{constructor(){this.a=new Map}queue(V,Z){const be=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(V)===be&&this.a.delete(V)});return this.a.set(V,be),be}}e.$7g=r;const a=(ge,V)=>{let Z=!0;const he=setTimeout(()=>{Z=!1,V()},ge);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(he),Z=!1}}},t=ge=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,ge())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class h{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,Z=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((be,Pe)=>{this.d=be,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Z===p.$Vd?t(he):a(Z,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$8g=h;class c{constructor(V){this.a=new h(V),this.b=new i}trigger(V,Z){return this.a.trigger(()=>this.b.queue(V),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$9g=c;class o{constructor(){this.a=!1,this.b=new Promise((V,Z)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$0g=o;class u extends o{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$$g=u;function d(ge,V){return V?new Promise((Z,he)=>{const be=setTimeout(()=>{Pe.dispose(),Z()},ge),Pe=V.onCancellationRequested(()=>{clearTimeout(be),Pe.dispose(),he(new F.$5)})}):C(Z=>d(ge,Z))}e.$_g=d;function b(ge,V=0,Z){const he=setTimeout(()=>{ge(),Z&&be.dispose()},V),be=(0,L.$Rc)(()=>{clearTimeout(he),Z?.deleteAndLeak(be)});return Z?.add(be),be}e.$ah=b;function D(ge){const V=[];let Z=0;const he=ge.length;function be(){return Z<he?ge[Z++]():null}function Pe(pe){pe!=null&&V.push(pe);const Le=be();return Le?Le.then(Pe):Promise.resolve(V)}return Promise.resolve(null).then(Pe)}e.$bh=D;function g(ge,V=he=>!!he,Z=null){let he=0;const be=ge.length,Pe=()=>{if(he>=be)return Promise.resolve(Z);const pe=ge[he++];return Promise.resolve(pe()).then(Me=>V(Me)?Promise.resolve(Me):Pe())};return Pe()}e.$ch=g;function f(ge,V=he=>!!he,Z=null){if(ge.length===0)return Promise.resolve(Z);let he=ge.length;const be=()=>{he=-1;for(const Pe of ge)Pe.cancel?.()};return new Promise((Pe,pe)=>{for(const Le of ge)Le.then(Me=>{--he>=0&&V(Me)?(be(),Pe(Me)):he===0&&Pe(Z)}).catch(Me=>{--he>=0&&(be(),pe(Me))})})}e.$dh=f;class y{constructor(V){this.a=0,this.b=!1,this.f=V,this.g=[],this.d=0,this.h=new $.$Yd}whenIdle(){return this.size>0?$.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(V){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,he)=>{this.g.push({factory:V,c:Z,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const V=this.g.shift();this.d++;const Z=V.factory();Z.then(V.c,V.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$eh=y;class P extends y{constructor(){super(1)}}e.$fh=P;class T{constructor(){this.a=new X,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$gh=T;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new fe;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueSize(V,Z=A.$Bg){const he=Z.getComparisonKey(V);return this.a.get(he)?.size??0}queueFor(V,Z,he=A.$Bg){const be=he.getComparisonKey(V);let Pe=this.a.get(be);if(!Pe){Pe=new P;const pe=this.f++,Le=$.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(pe,Le),this.a.set(be,Pe)}return Pe.queue(Z)}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$hh=U;class z{constructor(V,Z){this.a=-1,typeof V=="function"&&typeof Z=="number"&&this.setIfNotSet(V,Z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,Z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},Z)}setIfNotSet(V,Z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},Z))}}e.$ih=z;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(V,Z,he=globalThis){this.cancel();const be=he.setInterval(()=>{V()},Z);this.d=(0,L.$Rc)(()=>{he.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$jh=M;class N{constructor(V,Z){this.b=-1,this.a=V,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$kh=N;class O{constructor(V,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=V,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$lh=O;class j extends N{constructor(V,Z){super(V,Z),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$mh=j;class Y extends L.$Tc{constructor(V,Z){super(),this.g=V,this.h=Z,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of V)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$nh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ph=(ge,V)=>{(0,v.$B)(()=>{if(Z)return;const he=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$ph=(ge,V,Z)=>{const he=ge.requestIdleCallback(V,typeof Z=="number"?{timeout:Z}:void 0);let be=!1;return{dispose(){be||(be=!0,ge.cancelIdleCallback(he))}}},e.$oh=ge=>(0,e.$ph)(globalThis,ge)}();class ne{constructor(V,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$ph)(V,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$qh=ne;class ee extends ne{constructor(V){super(globalThis,V)}}e.$rh=ee;async function Q(ge,V,Z){let he;for(let be=0;be<Z;be++)try{return await ge()}catch(Pe){he=Pe,await d(V)}throw he}e.$sh=Q;class X{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,Z,he){return this.a={taskId:V,cancel:()=>he?.(),promise:Z},Z.then(()=>this.d(V),()=>this.d(V)),Z}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{const{promise:Z,resolve:he,reject:be}=s();this.b={run:V,promise:Z,promiseResolve:he,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$th=X;class ce{constructor(V,Z=()=>Date.now()){this.d=V,this.f=Z,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$uh=ce;var ie;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(ie||(ie={}));class fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,Z)=>{this.a=V,this.b=Z})}complete(V){return new Promise(Z=>{this.a(V),this.d={outcome:0,value:V},Z()})}error(V){return new Promise(Z=>{this.b(V),this.d={outcome:1,value:V},Z()})}cancel(){return this.error(new F.$5)}}e.$vh=fe;var re;(function(ge){async function V(he){let be;const Pe=await Promise.all(he.map(pe=>pe.then(Le=>Le,Le=>{be||(be=Le)})));if(typeof be<"u")throw be;return Pe}ge.settled=V;function Z(he){return new Promise(async(be,Pe)=>{try{await he(be,Pe)}catch(pe){Pe(pe)}})}ge.withAsyncBody=Z})(re||(e.Promises=re={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(V){this.a=void 0,this.b=void 0,this.d=!1,this.promise=V.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$wh=J;class B{constructor(V){this.b=V,this.a=new k.$V(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$xh=B;var ae;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ae||(ae={}));class Ee{static fromArray(V){return new Ee(Z=>{Z.emitMany(V)})}static fromPromise(V){return new Ee(async Z=>{Z.emitMany(await V)})}static fromPromises(V){return new Ee(async Z=>{await Promise.all(V.map(async he=>Z.emitOne(await he)))})}static merge(V){return new Ee(async Z=>{await Promise.all(V.map(async he=>{for await(const be of he)Z.emitOne(be)}))})}static{this.EMPTY=Ee.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new $.$Yd,queueMicrotask(async()=>{const Z={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(V(Z)),this.j()}catch(he){this.k(he)}finally{Z.emitOne=void 0,Z.emitMany=void 0,Z.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await $.Event.toPromise(this.f.event)}while(!0)}}}static map(V,Z){return new Ee(async he=>{for await(const be of V)he.emitOne(Z(be))})}map(V){return Ee.map(this,V)}static filter(V,Z){return new Ee(async he=>{for await(const be of V)Z(be)&&he.emitOne(be)})}filter(V){return Ee.filter(this,V)}static coalesce(V){return Ee.filter(V,Z=>!!Z)}coalesce(){return Ee.coalesce(this)}static async toPromise(V){const Z=[];for await(const he of V)Z.push(he);return Z}toPromise(){return Ee.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$yh=Ee;class le extends Ee{constructor(V,Z){super(Z),this.l=V}cancel(){this.l.cancel()}}e.$zh=le;function de(ge){const V=new I.$9d,Z=ge(V.token);return new le(V,async he=>{const be=V.token.onCancellationRequested(()=>{be.dispose(),V.dispose(),he.reject(new F.$5)});try{for await(const Pe of Z){if(V.token.isCancellationRequested)return;he.emitOne(Pe)}be.dispose(),V.dispose()}catch(Pe){be.dispose(),V.dispose(),he.reject(Pe)}})}e.$Ah=de;class ue{constructor(){this.a=new fe,this.b=new Ee(he=>{if(V){he.reject(V);return}return Z&&he.emitMany(Z),this.d=be=>he.reject(be),this.f=be=>he.emitOne(be),this.a.p});let V,Z;this.f=he=>{Z||(Z=[]),Z.push(he)},this.d=he=>{V||(V=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(V){this.d(V),this.a.complete()}emitOne(V){this.f(V)}}e.$Bh=ue}),define(Ce[35],Ie([1,0,19,8,34,28,17,11,12]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=void 0;function k(){return Object.create(null)}e.$Mj=k,e.$Nj="**",e.$Oj="/";const R="[/\\\\]",C="[^/\\\\]",m=/\//g;function E(ne,ee){switch(ne){case 0:return"";case 1:return`${C}*?`;default:return`(?:${R}|${C}+${R}${ee?`|${R}${C}+`:""})*?`}}function S(ne,ee){if(!ne)return[];const Q=[];let X=!1,ce=!1,ie="";for(const fe of ne){switch(fe){case ee:if(!X&&!ce){Q.push(ie),ie="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ie+=fe}return ie&&Q.push(ie),Q}e.$Pj=S;function l(ne){if(!ne)return"";let ee="";const Q=S(ne,e.$Oj);if(Q.every(X=>X===e.$Nj))ee=".*";else{let X=!1;Q.forEach((ce,ie)=>{if(ce===e.$Nj){if(X)return;ee+=E(2,ie===Q.length-1)}else{let fe=!1,re="",J=!1,B="";for(const ae of ce){if(ae!=="}"&&fe){re+=ae;continue}if(J&&(ae!=="]"||!B)){let Ee;ae==="-"?Ee=ae:(ae==="^"||ae==="!")&&!B?Ee="^":ae===e.$Oj?Ee="":Ee=(0,p.$Re)(ae),B+=Ee;continue}switch(ae){case"{":fe=!0;continue;case"[":J=!0;continue;case"}":{const le=`(?:${S(re,",").map(de=>l(de)).join("|")})`;ee+=le,fe=!1,re="";break}case"]":{ee+="["+B+"]",J=!1,B="";break}case"?":ee+=C;continue;case"*":ee+=E(1);continue;default:ee+=(0,p.$Re)(ae)}}ie<Q.length-1&&(Q[ie+1]!==e.$Nj||ie+2<Q.length)&&(ee+=R)}X=ce===e.$Nj})}return ee}const w=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),h=function(){return!1},c=function(){return null};function o(ne,ee){if(!ne)return c;let Q;typeof ne!="string"?Q=ne.pattern:Q=ne,Q=Q.trim();const X=`${Q}_${!!ee.trimForExclusions}`;let ce=t.get(X);if(ce)return u(ce,ne);let ie;return w.test(Q)?ce=b(Q.substr(4),Q):(ie=s.exec(d(Q,ee)))?ce=D(ie[1],Q):(ee.trimForExclusions?n:i).test(Q)?ce=g(Q,ee):(ie=r.exec(d(Q,ee)))?ce=f(ie[1].substr(1),Q,!0):(ie=a.exec(d(Q,ee)))?ce=f(ie[1],Q,!1):ce=y(Q),t.set(X,ce),u(ce,ne)}function u(ne,ee){if(typeof ee=="string")return ne;const Q=function(X,ce){return(0,$.$_f)(X,ee.base,!v.$k)?ne((0,p.$We)(X.substr(ee.base.length),A.sep),ce):null};return Q.allBasenames=ne.allBasenames,Q.allPaths=ne.allPaths,Q.basenames=ne.basenames,Q.patterns=ne.patterns,Q}function d(ne,ee){return ee.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function b(ne,ee){return function(Q,X){return typeof Q=="string"&&Q.endsWith(ne)?ee:null}}function D(ne,ee){const Q=`/${ne}`,X=`\\${ne}`,ce=function(fe,re){return typeof fe!="string"?null:re?re===ne?ee:null:fe===ne||fe.endsWith(Q)||fe.endsWith(X)?ee:null},ie=[ne];return ce.basenames=ie,ce.patterns=[ee],ce.allBasenames=ie,ce}function g(ne,ee){const Q=j(ne.slice(1,-1).split(",").map(re=>o(re,ee)).filter(re=>re!==c),ne),X=Q.length;if(!X)return c;if(X===1)return Q[0];const ce=function(re,J){for(let B=0,ae=Q.length;B<ae;B++)if(Q[B](re,J))return ne;return null},ie=Q.find(re=>!!re.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const fe=Q.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return fe.length&&(ce.allPaths=fe),ce}function f(ne,ee,Q){const X=A.sep===A.$gc.sep,ce=X?ne:ne.replace(m,A.sep),ie=A.sep+ce,fe=A.$gc.sep+ne;let re;return Q?re=function(J,B){return typeof J=="string"&&(J===ce||J.endsWith(ie)||!X&&(J===ne||J.endsWith(fe)))?ee:null}:re=function(J,B){return typeof J=="string"&&(J===ce||!X&&J===ne)?ee:null},re.allPaths=[(Q?"*/":"./")+ne],re}function y(ne){try{const ee=new RegExp(`^${l(ne)}$`);return function(Q){return ee.lastIndex=0,typeof Q=="string"&&ee.test(Q)?ne:null}}catch{return c}}function P(ne,ee,Q){return!ne||typeof ee!="string"?!1:T(ne)(ee,void 0,Q)}e.$Qj=P;function T(ne,ee={}){if(!ne)return h;if(typeof ne=="string"||U(ne)){const Q=o(ne,ee);if(Q===c)return h;const X=function(ce,ie){return!!Q(ce,ie)};return Q.allBasenames&&(X.allBasenames=Q.allBasenames),Q.allPaths&&(X.allPaths=Q.allPaths),X}return N(ne,ee)}e.$Rj=T;function U(ne){const ee=ne;return ee?typeof ee.base=="string"&&typeof ee.pattern=="string":!1}e.$Sj=U;function z(ne){return ne.allBasenames||[]}e.$Tj=z;function M(ne){return ne.allPaths||[]}e.$Uj=M;function N(ne,ee){const Q=j(Object.getOwnPropertyNames(ne).map(re=>O(re,ne[re],ee)).filter(re=>re!==c)),X=Q.length;if(!X)return c;if(!Q.some(re=>!!re.requiresSiblings)){if(X===1)return Q[0];const re=function(ae,Ee){let le;for(let de=0,ue=Q.length;de<ue;de++){const ge=Q[de](ae,Ee);if(typeof ge=="string")return ge;(0,F.$Wg)(ge)&&(le||(le=[]),le.push(ge))}return le?(async()=>{for(const de of le){const ue=await de;if(typeof ue=="string")return ue}return null})():null},J=Q.find(ae=>!!ae.allBasenames);J&&(re.allBasenames=J.allBasenames);const B=Q.reduce((ae,Ee)=>Ee.allPaths?ae.concat(Ee.allPaths):ae,[]);return B.length&&(re.allPaths=B),re}const ce=function(re,J,B){let ae,Ee;for(let le=0,de=Q.length;le<de;le++){const ue=Q[le];ue.requiresSiblings&&B&&(J||(J=(0,A.$nc)(re)),ae||(ae=J.substr(0,J.length-(0,A.$oc)(re).length)));const ge=ue(re,J,ae,B);if(typeof ge=="string")return ge;(0,F.$Wg)(ge)&&(Ee||(Ee=[]),Ee.push(ge))}return Ee?(async()=>{for(const le of Ee){const de=await le;if(typeof de=="string")return de}return null})():null},ie=Q.find(re=>!!re.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const fe=Q.reduce((re,J)=>J.allPaths?re.concat(J.allPaths):re,[]);return fe.length&&(ce.allPaths=fe),ce}function O(ne,ee,Q){if(ee===!1)return c;const X=o(ne,Q);if(X===c)return c;if(typeof ee=="boolean")return X;if(ee){const ce=ee.when;if(typeof ce=="string"){const ie=(fe,re,J,B)=>{if(!B||!X(fe,re))return null;const ae=ce.replace("$(basename)",()=>J),Ee=B(ae);return(0,F.$Wg)(Ee)?Ee.then(le=>le?ne:null):Ee?ne:null};return ie.requiresSiblings=!0,ie}}return X}function j(ne,ee){const Q=ne.filter(re=>!!re.basenames);if(Q.length<2)return ne;const X=Q.reduce((re,J)=>{const B=J.basenames;return B?re.concat(B):re},[]);let ce;if(ee){ce=[];for(let re=0,J=X.length;re<J;re++)ce.push(ee)}else ce=Q.reduce((re,J)=>{const B=J.patterns;return B?re.concat(B):re},[]);const ie=function(re,J){if(typeof re!="string")return null;if(!J){let ae;for(ae=re.length;ae>0;ae--){const Ee=re.charCodeAt(ae-1);if(Ee===47||Ee===92)break}J=re.substr(ae)}const B=X.indexOf(J);return B!==-1?ce[B]:null};ie.basenames=X,ie.patterns=ce,ie.allBasenames=X;const fe=ne.filter(re=>!re.basenames);return fe.push(ie),fe}function Y(ne,ee){return(0,I.$ub)(ne,ee,(Q,X)=>typeof Q=="string"&&typeof X=="string"?Q===X:typeof Q!="string"&&typeof X!="string"?Q.base===X.base&&Q.pattern===X.pattern:!1)}e.$Vj=Y}),define(Ce[63],Ie([1,0,14,165,23,12,2]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.MarkdownStringTextNewlineStyle=void 0;var v;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(v||(e.MarkdownStringTextNewlineStyle=v={}));class p{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,I.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=m(this.supportThemeIcons?(0,F.$gk)(i):i).replace(/([ \t]+)/g,(r,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${E(n,i)}
`,this}appendLink(i,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(i,n){const r=new RegExp((0,L.$Re)(n),"g");return i.replace(r,(a,t)=>i.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.$mk=p;function k(s){return R(s)?!s.value:Array.isArray(s)?s.every(k):!0}e.$nk=k;function R(s){return s instanceof p?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$ok=R;function C(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,$.$Eg)(A.URI.from(s.baseUri),A.URI.from(i.baseUri)))}e.$pk=C;function m(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$qk=m;function E(s,i){const n=s.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,r=n>=3?n+1:3;return[`${"`".repeat(r)}${i}`,s,`${"`".repeat(r)}`].join(`
`)}e.$rk=E;function S(s){return s.replace(/"/g,"&quot;")}e.$sk=S;function l(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$tk=l;function w(s){const i=[],n=s.split("|").map(a=>a.trim());s=n[0];const r=n[1];if(r){const a=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),h=a?a[1]:"",c=t?t[1]:"",o=isFinite(parseInt(c)),u=isFinite(parseInt(h));o&&i.push(`width="${c}"`),u&&i.push(`height="${h}"`)}return{href:s,dimensions:i}}e.$uk=w}),define(Ce[102],Ie([1,0,19,34,17,11,23,12]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=void 0;function p(o,u){const{os:d,tildify:b,relative:D}=u;if(D){const y=k(o,D,d);if(typeof y=="string")return y}let g=o.fsPath;if(d===1&&!L.$i?g=g.replace(/\//g,"\\"):d!==1&&L.$i&&(g=g.replace(/\\/g,"/")),d!==1&&b?.userHome){const y=b.userHome.fsPath;let P;o.scheme!==b.userHome.scheme&&o.path[0]===$.$gc.sep&&o.path[1]!==$.$gc.sep?P=b.userHome.with({path:o.path}).fsPath:P=g,g=m(P,y,d)}return(d===1?$.$fc:$.$gc).normalize(R(g,d===1))}e.$1v=p;function k(o,u,d){const b=d===1?$.$fc:$.$gc,D=d===3?A.$Bg:A.$Dg,g=u.getWorkspace(),f=(0,I.$Ob)(g.folders);if(!f)return;o.scheme!==f.uri.scheme&&o.path[0]===$.$gc.sep&&o.path[1]!==$.$gc.sep&&(o=f.uri.with({path:o.path}));const y=u.getWorkspaceFolder(o);if(!y)return;let P;if(D.isEqual(y.uri,o)?P="":P=D.relativePath(y.uri,o)??"",P&&(P=b.normalize(P)),g.folders.length>1&&!u.noPrefix){const T=y.name?y.name:D.basenameOrAuthority(y.uri);P=P?`${T} \u2022 ${P}`:T}return P}function R(o,u=L.$i){return(0,F.$dg)(o,u)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$2v=R;let C=Object.create(null);function m(o,u,d=L.OS){if(d===1||!o||!u)return o;let b=C.original===u?C.normalized:void 0;b||(b=u,L.$i&&(b=(0,F.$6f)(b)),b=`${(0,v.$Xe)(b,$.$gc.sep)}${$.$gc.sep}`,C={original:u,normalized:b});let D=o;return L.$i&&(D=(0,F.$6f)(D)),(d===3?D.startsWith(b):(0,v.$ef)(D,b))?`~/${D.substr(b.length)}`:o}e.$3v=m;function E(o,u){return o.replace(/^~($|\/|\\)/,`${u}$1`)}e.$4v=E;const S="\u2026",l="\\\\",w="~";function s(o,u=$.sep){const d=new Array(o.length);let b=!1;for(let D=0;D<o.length;D++){const g=o[D];if(g===""){d[D]=`.${u}`;continue}if(!g){d[D]=g;continue}b=!0;let f="",y=g;y.indexOf(l)===0?(f=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(u)===0?(f=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(w)===0&&(f=y.substr(0,y.indexOf(w)+w.length),y=y.substr(y.indexOf(w)+w.length));const P=y.split(u);for(let T=1;b&&T<=P.length;T++)for(let U=P.length-T;b&&U>=0;U--){b=!1;let z=P.slice(U,U+T).join(u);for(let M=0;!b&&M<o.length;M++)if(M!==D&&o[M]&&o[M].indexOf(z)>-1){const N=U+T===P.length,O=U>0&&o[M].indexOf(u)>-1?u+z:z,j=o[M].endsWith(O);b=!N||j}if(!b){let M="";(P[0].endsWith(":")||f!=="")&&(U===1&&(U=0,T++,z=P[0]+u+z),U>0&&(M=P[0]+u),M=f+M),U>0&&(M=M+S+u),M=M+z,U+T<P.length&&(M=M+u+S),d[D]=M}}b&&(d[D]=g)}return d}e.$5v=s;var i;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(o,u=Object.create(null)){const d=[];let b=!1,D="";for(const g of o)if(g==="$"||b&&g==="{")D&&d.push({value:D,type:i.TEXT}),D="",b=!0;else if(g==="}"&&b){const f=u[D];if(typeof f=="string")f.length&&d.push({value:f,type:i.VARIABLE});else if(f){const y=d[d.length-1];(!y||y.type!==i.SEPARATOR)&&d.push({value:f.label,type:i.SEPARATOR})}D="",b=!1}else D+=g;return D&&!b&&d.push({value:D,type:i.TEXT}),d.filter((g,f)=>{if(g.type===i.SEPARATOR){const y=d[f-1],P=d[f+1];return[y,P].every(T=>T&&(T.type===i.VARIABLE||T.type===i.TEXT)&&T.value.length>0)}return!0}).map(g=>g.value).join("")}e.$6v=n;function r(o,u){return L.$j||u?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$7v=r;function a(o,u){return L.$j||u?o.replace(/\(&&\w\)|&&/g,""):L.$i?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$8v=a;function t(o){return o.replace(/&/g,"&&")}e.$9v=t;function h(o){if(o.endsWith("]")){const u=o.lastIndexOf(" [",o.length-2);if(u!==-1){const d=c(o.substring(0,u)),b=o.substring(u);return{name:d.name+b,parentPath:d.parentPath}}}return c(o)}e.$0v=h;function c(o){const u=o.indexOf("/")!==-1?$.$gc:$.$fc,d=u.basename(o),b=u.dirname(o);return d.length?{name:d,parentPath:b}:{name:b,parentPath:""}}}),define(Ce[130],Ie([1,0,21,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=void 0;function $(C){return C.toJSON()}class L{constructor(m){this.a=m}transformIncoming(m){const E=this.a.transformIncoming(m);return E===m?m:$(F.URI.from(E))}transformOutgoing(m){const E=this.a.transformOutgoing(m);return E===m?m:$(F.URI.from(E))}transformOutgoingURI(m){const E=this.a.transformOutgoing(m);return E===m?m:F.URI.from(E)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$0m=L,e.$$m=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function A(C,m,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof F.URI)return m.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const l=A(C[S],m,E+1);l!==null&&(C[S]=l)}}return null}function v(C,m){const E=A(C,m,0);return E===null?C:E}e.$_m=v;function p(C,m,E,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?F.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof I.$me)return null;for(const l in C)if(Object.hasOwnProperty.call(C,l)){const w=p(C[l],m,E,S+1);w!==null&&(C[l]=w)}}return null}function k(C,m){const E=p(C,m,!1,0);return E===null?C:E}e.$an=k;function R(C,m){const E=p(C,m,!0,0);return E===null?C:E}e.$bn=R}),define(Ce[31],Ie([1,0,57,64,388,8,34,77,17,11,23,2]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function E(O,j=m.UNLINK,Y){if((0,A.$cg)(O))throw new Error("rimraf - will refuse to recursively delete root");return j===m.UNLINK?l(O):S(O,Y)}async function S(O,j=(0,A.$hg)((0,F.tmpdir)())){try{try{await I.promises.rename(O,j)}catch(Y){return Y.code==="ENOENT"?void 0:l(O)}l(j).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function l(O){return(0,$.promisify)(I.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function w(O){if((0,A.$cg)(O))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function s(O,j){return r(await(j?i(O):(0,$.promisify)(I.readdir)(O)))}async function i(O){try{return await(0,$.promisify)(I.readdir)(O,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const j=[],Y=await s(O);for(const ne of Y){let ee=!1,Q=!1,X=!1;try{const ce=await e.Promises.lstat((0,p.$jc)(O,ne));ee=ce.isFile(),Q=ce.isDirectory(),X=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}j.push({name:ne,isFile:()=>ee,isDirectory:()=>Q,isSymbolicLink:()=>X})}return j}function n(O){return r(I.readdirSync(O))}e.readdirSync=n;function r(O){return O.map(j=>typeof j=="string"?k.$j?(0,v.$Ll)(j):j:(j.name=k.$j?(0,v.$Ll)(j.name):j.name,j))}async function a(O){const j=await s(O),Y=[];for(const ne of j)await h.existsDirectory((0,p.$jc)(O,ne))&&Y.push(ne);return Y}function t(O,j=1e3){return new Promise(Y=>{let ne=!1;const ee=setInterval(()=>{ne||(ne=!0,I.access(O,Q=>{ne=!1,Q&&(clearInterval(ee),Y(void 0))}))},j)})}e.whenDeleted=t;var h;(function(O){async function j(ee){let Q;try{if(Q=await e.Promises.lstat(ee),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(k.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ce}throw X}}O.stat=j;async function Y(ee){try{const{stat:Q,symbolicLink:X}=await O.stat(ee);return Q.isFile()&&X?.dangling!==!0}catch{}return!1}O.existsFile=Y;async function ne(ee){try{const{stat:Q,symbolicLink:X}=await O.stat(ee);return Q.isDirectory()&&X?.dangling!==!0}catch{}return!1}O.existsDirectory=ne})(h||(e.SymlinkSupport=h={}));const c=new L.$hh;function o(O,j,Y){return c.queueFor(C.URI.file(O),()=>{const ne=g(Y);return new Promise((ee,Q)=>b(O,j,ne,X=>X?Q(X):ee()))},R.$Cg)}let u=!0;function d(O){u=O}e.configureFlushOnWrite=d;function b(O,j,Y,ne){if(!u)return I.writeFile(O,j,{mode:Y.mode,flag:Y.flag},ne);I.open(O,Y.flag,Y.mode,(ee,Q)=>{if(ee)return ne(ee);I.writeFile(Q,j,X=>{if(X)return I.close(Q,()=>ne(X));I.fdatasync(Q,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),d(!1)),I.close(Q,ie=>ne(ie))))})})}function D(O,j,Y){const ne=g(Y);if(!u)return I.writeFileSync(O,j,{mode:ne.mode,flag:ne.flag});const ee=I.openSync(O,ne.flag,ne.mode);try{I.writeFileSync(ee,j);try{I.fdatasyncSync(ee)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),d(!1)}}finally{I.closeSync(ee)}}e.writeFileSync=D;function g(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function f(O,j,Y=6e4){if(O!==j)try{k.$i&&typeof Y=="number"?await y(O,j,Date.now(),Y):await(0,$.promisify)(I.rename)(O,j)}catch(ne){if(O.toLowerCase()!==j.toLowerCase()&&ne.code==="EXDEV"||O.endsWith("."))await P(O,j,{preserveSymlinks:!1}),await E(O,m.MOVE);else throw ne}}async function y(O,j,Y,ne,ee=0){try{return await(0,$.promisify)(I.rename)(O,j)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-Y>=ne)throw console.error(`[node.js fs] rename failed after ${ee} retries with error: ${Q}`),Q;if(ee===0){let X=!1;try{const{stat:ce}=await h.stat(j);ce.isFile()||(X=!0)}catch{}if(X)throw Q}return await(0,L.$_g)(Math.min(100,ee*10)),y(O,j,Y,ne,ee+1)}}async function P(O,j,Y){return U(O,j,{root:{source:O,target:j},options:Y,handledSourcePaths:new Set})}const T=511;async function U(O,j,Y){if(Y.handledSourcePaths.has(O))return;Y.handledSourcePaths.add(O);const{stat:ne,symbolicLink:ee}=await h.stat(O);if(ee){if(Y.options.preserveSymlinks)try{return await N(O,j,Y)}catch{}if(ee.dangling)return}return ne.isDirectory()?z(O,j,ne.mode&T,Y):M(O,j,ne.mode&T)}async function z(O,j,Y,ne){await e.Promises.mkdir(j,{recursive:!0,mode:Y});const ee=await s(O);for(const Q of ee)await U((0,p.$jc)(O,Q),(0,p.$jc)(j,Q),ne)}async function M(O,j,Y){await e.Promises.copyFile(O,j),await e.Promises.chmod(j,Y)}async function N(O,j,Y){let ne=await e.Promises.readlink(O);(0,A.$_f)(ne,Y.root.source,!k.$k)&&(ne=(0,p.$jc)(Y.root.target,ne.substr(Y.root.source.length+1))),await e.Promises.symlink(ne,j)}e.Promises=new class{get access(){return(0,$.promisify)(I.access)}get stat(){return(0,$.promisify)(I.stat)}get lstat(){return(0,$.promisify)(I.lstat)}get utimes(){return(0,$.promisify)(I.utimes)}get read(){return(O,j,Y,ne,ee)=>new Promise((Q,X)=>{I.read(O,j,Y,ne,ee,(ce,ie,fe)=>ce?X(ce):Q({bytesRead:ie,buffer:fe}))})}get readFile(){return(0,$.promisify)(I.readFile)}get write(){return(O,j,Y,ne,ee)=>new Promise((Q,X)=>{I.write(O,j,Y,ne,ee,(ce,ie,fe)=>ce?X(ce):Q({bytesWritten:ie,buffer:fe}))})}get appendFile(){return(0,$.promisify)(I.appendFile)}get fdatasync(){return(0,$.promisify)(I.fdatasync)}get truncate(){return(0,$.promisify)(I.truncate)}get copyFile(){return(0,$.promisify)(I.copyFile)}get open(){return(0,$.promisify)(I.open)}get close(){return(0,$.promisify)(I.close)}get symlink(){return(0,$.promisify)(I.symlink)}get readlink(){return(0,$.promisify)(I.readlink)}get chmod(){return(0,$.promisify)(I.chmod)}get mkdir(){return(0,$.promisify)(I.mkdir)}get unlink(){return(0,$.promisify)(I.unlink)}get rmdir(){return(0,$.promisify)(I.rmdir)}get realpath(){return(0,$.promisify)(I.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return o}get rm(){return E}get rename(){return f}get copy(){return P}}}),define(Ce[103],Ie([1,0,57,17,11,12,31]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$Aq=e.$zq=e.$yq=void 0;function v(m){if($.$k)return m;const E=(0,F.$mc)(m);if(m===E)return m;const S=((0,F.$nc)(m)||m).toLowerCase();try{const w=(0,A.readdirSync)(E).filter(s=>s.toLowerCase()===S);if(w.length===1){const s=v(E);if(s)return(0,F.$jc)(s,w[0])}else if(w.length>1){const s=w.indexOf(S);if(s>=0){const i=v(E);if(i)return(0,F.$jc)(i,w[s])}}}catch{}return null}e.$yq=v;async function p(m){if($.$k)return m;const E=(0,F.$mc)(m);if(m===E)return m;const S=((0,F.$nc)(m)||m).toLowerCase();try{const w=(await A.Promises.readdir(E)).filter(s=>s.toLowerCase()===S);if(w.length===1){const s=await p(E);if(s)return(0,F.$jc)(s,w[0])}else if(w.length>1){const s=w.indexOf(S);if(s>=0){const i=await p(E);if(i)return(0,F.$jc)(i,w[s])}}}catch{}return null}e.$zq=p;async function k(m){try{return await A.Promises.realpath(m)}catch{const S=C(m);return await A.Promises.access(S,I.constants.R_OK),S}}e.$Aq=k;function R(m){try{return I.realpathSync(m)}catch{const S=C(m);return I.accessSync(S,I.constants.R_OK),S}}e.$Bq=R;function C(m){return(0,L.$Xe)((0,F.$hc)(m),F.sep)}}),define(Ce[104],Ie([1,0,17,11,49,101,18,31]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Zl=e.$Yl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function p(C=$.env){return C.comspec||"cmd.exe"}e.$Yl=p;function k(C){let m=[],E=!1;const S=function(l){if(E){m.push(l);return}(!C.send(l,s=>{if(s&&console.error(s),E=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>S(n))}})||F.$i)&&(E=!0)};return{send:S}}e.$Zl=k;var R;(function(C){async function m(E,S,l){if(I.$ic(E))return E;if(S===void 0&&(S=$.cwd()),I.$mc(E)!=="."||(l===void 0&&A.$Mf($.env.PATH)&&(l=$.env.PATH.split(I.$tc)),l===void 0||l.length===0))return I.$jc(S,E);async function s(i){if(await v.Promises.exists(i)){let n;try{n=await v.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await v.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of l){let n;if(I.$ic(i)?n=I.$jc(i,E):n=I.$jc(S,i,E),await s(n))return n;let r=n+".com";if(await s(r)||(r=n+".exe",await s(r)))return r}return I.$jc(S,E)}C.findExecutable=m})(R||(e.win32=R={}))});var Je=this&&this.__decorate||function(me,e,I,F){var $=arguments.length,L=$<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,I):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(me,e,I,F);else for(var v=me.length-1;v>=0;v--)(A=me[v])&&(L=($<3?A(L):$>3?A(e,I,L):A(e,I))||L);return $>3&&L&&Object.defineProperty(e,I,L),L};define(Ce[81],Ie([1,0,19,8,21,22,52,14,4,3,56,12,18]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.ProxyChannel=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.RequestInitiator=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=void 0;var E;(function(ee){ee[ee.Promise=100]="Promise",ee[ee.PromiseCancel=101]="PromiseCancel",ee[ee.EventListen=102]="EventListen",ee[ee.EventDispose=103]="EventDispose"})(E||(E={}));function S(ee){switch(ee){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(ee){ee[ee.Initialize=200]="Initialize",ee[ee.PromiseSuccess=201]="PromiseSuccess",ee[ee.PromiseError=202]="PromiseError",ee[ee.PromiseErrorObj=203]="PromiseErrorObj",ee[ee.EventFire=204]="EventFire"})(l||(l={}));function w(ee){switch(ee){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(ee){ee[ee.Uninitialized=0]="Uninitialized",ee[ee.Idle=1]="Idle"})(s||(s={}));function i(ee){let Q=0;for(let X=0;;X+=7){const ce=ee.read(1);if(Q|=(ce.buffer[0]&127)<<X,!(ce.buffer[0]&128))return Q}}const n=c(0);function r(ee,Q){if(Q===0){ee.write(n);return}let X=0;for(let ie=Q;ie!==0;ie=ie>>>7)X++;const ce=$.$me.alloc(X);for(let ie=0;Q!==0;ie++)ce.buffer[ie]=Q&127,Q=Q>>>7,Q>0&&(ce.buffer[ie]|=128);ee.write(ce)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const X=this.b.slice(this.a,this.a+Q);return this.a+=X.byteLength,X}}e.$Ih=a;class t{constructor(){this.a=[]}get buffer(){return $.$me.concat(this.a)}write(Q){this.a.push(Q)}}e.$Jh=t;var h;(function(ee){ee[ee.Undefined=0]="Undefined",ee[ee.String=1]="String",ee[ee.Buffer=2]="Buffer",ee[ee.VSBuffer=3]="VSBuffer",ee[ee.Array=4]="Array",ee[ee.Object=5]="Object",ee[ee.Int=6]="Int"})(h||(h={}));function c(ee){const Q=$.$me.alloc(1);return Q.writeUInt8(ee,0),Q}const o={Undefined:c(h.Undefined),String:c(h.String),Buffer:c(h.Buffer),VSBuffer:c(h.VSBuffer),Array:c(h.Array),Object:c(h.Object),Uint:c(h.Int)},u=typeof Buffer<"u";function d(ee,Q){if(typeof Q>"u")ee.write(o.Undefined);else if(typeof Q=="string"){const X=$.$me.fromString(Q);ee.write(o.String),r(ee,X.byteLength),ee.write(X)}else if(u&&Buffer.isBuffer(Q)){const X=$.$me.wrap(Q);ee.write(o.Buffer),r(ee,X.byteLength),ee.write(X)}else if(Q instanceof $.$me)ee.write(o.VSBuffer),r(ee,Q.byteLength),ee.write(Q);else if(Array.isArray(Q)){ee.write(o.Array),r(ee,Q.length);for(const X of Q)d(ee,X)}else if(typeof Q=="number"&&(Q|0)===Q)ee.write(o.Uint),r(ee,Q);else{const X=$.$me.fromString(JSON.stringify(Q));ee.write(o.Object),r(ee,X.byteLength),ee.write(X)}}e.$Kh=d;function b(ee){switch(ee.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return ee.read(i(ee)).toString();case h.Buffer:return ee.read(i(ee)).buffer;case h.VSBuffer:return ee.read(i(ee));case h.Array:{const X=i(ee),ce=[];for(let ie=0;ie<X;ie++)ce.push(b(ee));return ce}case h.Object:return JSON.parse(ee.read(i(ee)).toString());case h.Int:return i(ee)}}e.$Lh=b;class D{constructor(Q,X,ce=null,ie=1e3){this.h=Q,this.j=X,this.k=ce,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(fe=>this.q(fe)),this.m({type:200})}registerChannel(Q,X){this.b.set(Q,X),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const X=this.o([Q.type]);this.k?.logOutgoing(X,0,1,w(Q.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(X,Q.id,1,w(Q.type),Q.data);return}}}o(Q,X=void 0){const ce=new t;return d(ce,Q),d(ce,X),this.p(ce.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const X=new a(Q),ce=b(X),ie=b(X),fe=ce[0];switch(fe){case 100:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}: ${ce[2]}.${ce[3]}`,ie),this.s({type:fe,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 102:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}: ${ce[2]}.${ce[3]}`,ie),this.t({type:fe,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 101:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}`),this.u({type:fe,id:ce[1]});case 103:return this.k?.logIncoming(Q.byteLength,ce[1],1,`${S(fe)}`),this.u({type:fe,id:ce[1]})}}s(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const ce=new L.$9d;let ie;try{ie=X.call(this.j,Q.name,Q.arg,ce.token)}catch(J){ie=Promise.reject(J)}const fe=Q.id;ie.then(J=>{this.m({id:fe,data:J,type:201})},J=>{J instanceof Error?this.m({id:fe,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:fe,data:J,type:203})}).finally(()=>{re.dispose(),this.d.delete(Q.id)});const re=(0,k.$Rc)(()=>ce.cancel());this.d.set(Q.id,re)}t(Q){const X=this.b.get(Q.channelName);if(!X){this.v(Q);return}const ce=Q.id,fe=X.listen(this.j,Q.name,Q.arg)(re=>this.m({id:ce,data:re,type:204}));this.d.set(Q.id,fe)}u(Q){const X=this.d.get(Q.id);X&&(X.dispose(),this.d.delete(Q.id))}v(Q){let X=this.g.get(Q.channelName);X||(X=[],this.g.set(Q.channelName,X));const ce=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Q,timeoutTimer:ce})}w(Q){const X=this.g.get(Q);if(X){for(const ce of X)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Mh=D;var g;(function(ee){ee[ee.LocalSide=0]="LocalSide",ee[ee.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));class f{constructor(Q,X=null){this.l=Q,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$Yd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=X}getChannel(Q){const X=this;return{call(ce,ie,fe){return X.a?Promise.reject(new v.$5):X.m(Q,ce,ie,fe)},listen(ce,ie){return X.a?p.Event.None:X.o(Q,ce,ie)}}}m(Q,X,ce,ie=L.CancellationToken.None){const fe=this.g++,J={id:fe,type:100,channelName:Q,name:X,arg:ce};if(ie.isCancellationRequested)return Promise.reject(new v.$5);let B;return new Promise((Ee,le)=>{if(ie.isCancellationRequested)return le(new v.$5);const de=()=>{const Z=he=>{switch(he.type){case 201:this.f.delete(fe),Ee(he.data);break;case 202:{this.f.delete(fe);const be=new Error(he.data.message);be.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,be.name=he.data.name,le(be);break}case 203:this.f.delete(fe),le(he.data);break}};this.f.set(fe,Z),this.p(J)};let ue=null;this.b===s.Idle?de():(ue=(0,F.$Xg)(Z=>this.u()),ue.then(()=>{ue=null,de()}));const ge=()=>{ue?(ue.cancel(),ue=null):this.p({id:fe,type:101}),le(new v.$5)},V=ie.onCancellationRequested(ge);B=(0,k.$Qc)((0,k.$Rc)(ge),V),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(Q,X,ce){const ie=this.g++,re={id:ie,type:102,channelName:Q,name:X,arg:ce};let J=null;const B=new p.$Yd({onWillAddFirstListener:()=>{J=(0,F.$Xg)(Ee=>this.u()),J.then(()=>{J=null,this.d.add(B),this.p(re)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(B),this.p({id:ie,type:103}))}}),ae=Ee=>B.fire(Ee.data);return this.f.set(ie,ae),B.event}p(Q){switch(Q.type){case 100:case 102:{const X=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(X,Q.id,0,`${S(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const X=this.q([Q.type,Q.id]);this.j?.logOutgoing(X,Q.id,0,S(Q.type));return}}}q(Q,X=void 0){const ce=new t;return d(ce,Q),d(ce,X),this.r(ce.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const X=new a(Q),ce=b(X),ie=b(X),fe=ce[0];switch(fe){case 200:return this.j?.logIncoming(Q.byteLength,0,0,w(fe)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ce[1],0,w(fe),ie),this.t({type:ce[0],id:ce[1],data:ie})}}t(Q){if(Q.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Nh=f,Je([A.$Ch],f.prototype,"onDidInitializePromise",null);class y{get connections(){const Q=[];return this.f.forEach(X=>Q.push(X)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new p.$Yd,this.onDidAddConnection=this.g.event,this.h=new p.$Yd,this.onDidRemoveConnection=this.h.event,this.j=new k.$Sc,this.j.add(Q(({protocol:X,onDidClientDisconnect:ce})=>{const ie=p.Event.once(X.onMessage);this.j.add(ie(fe=>{const re=new a(fe),J=b(re),B=new D(X,J),ae=new f(X);this.a.forEach((le,de)=>B.registerChannel(de,le));const Ee={channelServer:B,channelClient:ae,ctx:J};this.f.add(Ee),this.g.fire(Ee),this.j.add(ce(()=>{B.dispose(),ae.dispose(),this.f.delete(Ee),this.h.fire(Ee)}))}))}))}getChannel(Q,X){const ce=this;return{call(ie,fe,re){let J;if((0,m.$1f)(X)){const ae=(0,I.$4b)(ce.connections.filter(X));J=ae?Promise.resolve(ae):p.Event.toPromise(p.Event.filter(ce.onDidAddConnection,X))}else J=X.routeCall(ce,ie,fe);const B=J.then(ae=>ae.channelClient.getChannel(Q));return T(B).call(ie,fe,re)},listen(ie,fe){if((0,m.$1f)(X))return ce.k(Q,X,ie,fe);const re=X.routeEvent(ce,ie,fe).then(J=>J.channelClient.getChannel(Q));return T(re).listen(ie,fe)}}}k(Q,X,ce,ie){const fe=this;let re;const J=new p.$Yd({onWillAddFirstListener:()=>{re=new k.$Sc;const B=new p.$5d,ae=new Map,Ee=de=>{const ge=de.channelClient.getChannel(Q).listen(ce,ie),V=B.add(ge);ae.set(de,V)},le=de=>{const ue=ae.get(de);ue&&(ue.dispose(),ae.delete(de))};fe.connections.filter(X).forEach(Ee),p.Event.filter(fe.onDidAddConnection,X)(Ee,void 0,re),fe.onDidRemoveConnection(le,void 0,re),B.event(J.fire,J,re),re.add(B)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return J.event}registerChannel(Q,X){this.a.set(Q,X);for(const ce of this.f)ce.channelServer.registerChannel(Q,X)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Oh=y;class P{constructor(Q,X,ce=null){const ie=new t;d(ie,X),Q.send(ie.buffer),this.a=new f(Q,ce),this.d=new D(Q,X,ce)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,X){this.d.registerChannel(Q,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ph=P;function T(ee){return{call(Q,X,ce){return ee.then(ie=>ie.call(Q,X,ce))},listen(Q,X){const ce=new p.$8d;return ee.then(ie=>ce.input=ie.listen(Q,X)),ce.event}}}e.$Qh=T;function U(ee){let Q=!1;return{call(X,ce,ie){return Q?ee.call(X,ce,ie):(0,F.$_g)(0).then(()=>Q=!0).then(()=>ee.call(X,ce,ie))},listen(X,ce){if(Q)return ee.listen(X,ce);const ie=new p.$8d;return(0,F.$_g)(0).then(()=>Q=!0).then(()=>ie.input=ee.listen(X,ce)),ie.event}}}e.$Rh=U;class z{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const X of Q.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await p.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Sh=z;var M;(function(ee){function Q(fe,re,J){const B=fe,ae=J&&J.disableMarshalling,Ee=new Map;for(const le in B)ce(le)&&Ee.set(le,p.Event.buffer(B[le],!0,void 0,re));return new class{listen(le,de,ue){const ge=Ee.get(de);if(ge)return ge;if(ie(de)){const V=B[de];if(typeof V=="function")return V.call(B,ue)}throw new v.$bb(`Event not found: ${de}`)}call(le,de,ue){const ge=B[de];if(typeof ge=="function"){if(!ae&&Array.isArray(ue))for(let Z=0;Z<ue.length;Z++)ue[Z]=(0,R.$Hh)(ue[Z]);let V=ge.apply(B,ue);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new v.$bb(`Method not found: ${de}`)}}}ee.fromService=Q;function X(fe,re){const J=re&&re.disableMarshalling;return new Proxy({},{get(B,ae){if(typeof ae=="string")return re?.properties?.has(ae)?re.properties.get(ae):ie(ae)?function(Ee){return fe.listen(ae,Ee)}:ce(ae)?fe.listen(ae):async function(...Ee){let le;re&&!(0,m.$Vf)(re.context)?le=[re.context,...Ee]:le=Ee;const de=await fe.call(ae,le);return J?de:(0,R.$Hh)(de)};throw new v.$bb(`Property not found: ${String(ae)}`)}})}ee.toService=X;function ce(fe){return fe[0]==="o"&&fe[1]==="n"&&C.$cf(fe.charCodeAt(2))}function ie(fe){return/^onDynamic/.test(fe)&&C.$cf(fe.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(ee){if(Array.isArray(ee))return ee;if(ee&&typeof ee=="object"&&typeof ee.toString=="function"){const Q=ee.toString();if(Q!=="[object Object]")return Q}return ee}function j(ee){return Array.isArray(ee)?ee.map(O):O(ee)}function Y(ee,Q,X,ce,ie,fe,re){re=j(re);const J=N[ie],B=J[ce%J.length];let ae=[`%c[${ee}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${fe}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(fe)?(ae=ae.concat(re),ae.push(")")):ae.push(re),console.log.apply(console,ae)}class ne{constructor(Q,X){this.d=Q,this.f=X,this.a=0,this.b=0}logOutgoing(Q,X,ce,ie,fe){this.b+=Q,Y(this.d,this.b,Q,X,ce,ie,fe)}logIncoming(Q,X,ce,ie,fe){this.a+=Q,Y(this.f,this.a,Q,X,ce,ie,fe)}}e.$Th=ne}),define(Ce[82],Ie([1,0,21,4,3,81]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.ProtocolConstants=e.$Uh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(o){o.Created="created",o.Read="read",o.Write="write",o.Open="open",o.Error="error",o.Close="close",o.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",o.NodeEndReceived="nodeEndReceived",o.NodeEndSent="nodeEndSent",o.NodeDrainBegin="nodeDrainBegin",o.NodeDrainEnd="nodeDrainEnd",o.zlibInflateError="zlibInflateError",o.zlibInflateData="zlibInflateData",o.zlibInflateInitialWrite="zlibInflateInitialWrite",o.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",o.zlibInflateWrite="zlibInflateWrite",o.zlibInflateFlushFired="zlibInflateFlushFired",o.zlibDeflateError="zlibDeflateError",o.zlibDeflateData="zlibDeflateData",o.zlibDeflateWrite="zlibDeflateWrite",o.zlibDeflateFlushFired="zlibDeflateFlushFired",o.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",o.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",o.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",o.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",o.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",o.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",o.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",o.ProtocolHeaderRead="protocolHeaderRead",o.ProtocolMessageRead="protocolMessageRead",o.ProtocolHeaderWrite="protocolHeaderWrite",o.ProtocolMessageWrite="protocolMessageWrite",o.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var v;(function(o){o.enableDiagnostics=!1,o.records=[];const u=new WeakMap;let d=0;function b(g,f){if(!u.has(g)){const y=String(++d);u.set(g,y)}return u.get(g)}function D(g,f,y,P){if(!o.enableDiagnostics)return;const T=b(g,f);if(P instanceof I.$me||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const U=I.$me.alloc(P.byteLength);U.set(P),o.records.push({timestamp:Date.now(),id:T,label:f,type:y,buff:U})}else o.records.push({timestamp:Date.now(),id:T,label:f,type:y,data:P})}o.traceSocketEvent=D})(v||(e.SocketDiagnostics=v={}));var p;(function(o){o[o.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",o[o.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let k=null;function R(){return k||(k=I.$me.alloc(0)),k}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,d){if(u===0)return R();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const f=this.a[0];return d&&(this.a.shift(),this.b-=u),f}if(this.a[0].byteLength>u){const f=this.a[0].slice(0,u);return d&&(this.a[0]=this.a[0].slice(u),this.b-=u),f}const b=I.$me.alloc(u);let D=0,g=0;for(;u>0;){const f=this.a[g];if(f.byteLength>u){const y=f.slice(0,u);b.set(y,D),D+=u,d&&(this.a[g]=f.slice(u),this.b-=u),u-=u}else b.set(f,D),D+=f.byteLength,d?(this.a.shift(),this.b-=f.byteLength):g++,u-=f.byteLength}return b}}e.$Uh=C;var m;(function(o){o[o.None=0]="None",o[o.Regular=1]="Regular",o[o.Control=2]="Control",o[o.Ack=3]="Ack",o[o.Disconnect=5]="Disconnect",o[o.ReplayRequest=6]="ReplayRequest",o[o.Pause=7]="Pause",o[o.Resume=8]="Resume",o[o.KeepAlive=9]="KeepAlive"})(m||(m={}));function E(o){switch(o){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(o){o[o.HeaderLength=13]="HeaderLength",o[o.AcknowledgeTime=2e3]="AcknowledgeTime",o[o.TimeoutTime=2e4]="TimeoutTime",o[o.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",o[o.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",o[o.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class l{constructor(u,d,b,D){this.type=u,this.id=d,this.ack=b,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends $.$Tc{constructor(u){super(),this.f=this.B(new F.$Yd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=u,this.b=!1,this.c=new C,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,D=this.g.id,g=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new l(b,D,g,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=I.$me.alloc(13);d.writeUInt8(u.type,0),d.writeUInt32BE(u.id,1),d.writeUInt32BE(u.ack,5),d.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",u.data),this.j(d,u.data)}g(u,d){const b=this.f===0;return this.d.push(u,d),this.f+=u.byteLength+d.byteLength,b}h(){const u=I.$me.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,d){this.g(u,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this.c.write(u)}}class i extends $.$Tc{constructor(u){super(),this.f=new F.$Yd,this.onMessage=this.f.event,this.g=new F.$Yd,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new s(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new l(1,0,0,u))}}e.$Vh=i;class n extends L.$Ph{static fromSocket(u,d){return new n(new i(u),d)}get onDidDispose(){return this.b.onDidDispose}constructor(u,d,b=null){super(u,d,b),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$Wh=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$Yd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$Xh=r;class a{constructor(u){this.data=u,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let u=0,d=this.a;for(;d;)d=d.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let d=0,b=this.a;for(;b;)u[d++]=b.data,b=b.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const d=new a(u);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class h{static{this.a=10}static{this.b=null}static getInstance(){return h.b||(h.b=new h),h.b}constructor(){this.c=[];const u=Date.now();for(let d=0;d<h.a;d++)this.c[d]=u-1e3*d;setInterval(()=>{for(let d=h.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),d=(1+h.a)*1e3;let b=0;for(let D=0;D<h.a;D++)u-this.c[D]<=d&&b++;return 1-b/h.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??h.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new $.$Sc,this.o=u.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new l(5,0,0,R());this.p.write(u),this.p.flush()}sendPause(){const u=new l(7,0,0,R());this.p.write(u)}sendResume(){const u=new l(8,0,0,R());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,d){this.a=!0,this.r.dispose(),this.r=new $.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new l(3,0,this.h,R());this.p.write(u);const d=this.b.toArray();for(let b=0,D=d.length;b<D;b++)this.p.write(d[b]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const d=this.b.peek();if(d&&d.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this.g)if(u.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new l(6,0,0,R())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case 2:{this.u.fire(u.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let b=0,D=d.length;b<D;b++)this.p.write(d[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const d=++this.c;this.h=this.g;const b=new l(1,d,this.h,u);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(u){const d=new l(2,0,0,u);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),d=Date.now()-u.writtenTime,b=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(d>=2e4&&b>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:b});return}const g=Math.max(2e4-d,2e4-b,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},g)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new l(3,0,this.h,R());this.p.write(u)}D(){this.h=this.g;const u=new l(9,0,this.h,R());this.p.write(u)}}e.$Yh=c}),define(Ce[188],Ie([1,0,50,8,21,22,186,14,4,3,24,104,101,81]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=void 0;class S extends E.$Mh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",i=>$.$me.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$vq=S;class l{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new p.$Yd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new F.$8g(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,r,a){return i.k(s,n,r,a)},listen(n,r){return i.l(s,n,r)}}}k(s,i,n,r=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(v.$6());this.b.cancel();const a=this.n(s),t=(0,F.$Xg)(o=>a.call(i,n,o)),h=r.onCancellationRequested(()=>t.cancel()),c=(0,k.$Rc)(()=>t.cancel());return this.c.add(c),t.finally(()=>{h.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return p.Event.None;this.b.cancel();let r;const a=new p.$Yd({onWillAddFirstListener:()=>{r=this.n(s).listen(i,n)(a.fire,a),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,R.$Bn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,m.$Xl)(i.env),this.d=(0,I.fork)(this.i,s,i);const n=new p.$Yd;p.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,A.$rq)(u)){(0,A.log)(u,`IPC Library: ${this.j.serverName}`);return}n.fire($.$me.wrap(Buffer.from(u,"base64")))});const a=this.j.useQueue?(0,C.$Zl)(this.d):this.d,t=u=>this.d&&this.d.connected&&a.send(u.buffer.toString("base64")),h=n.event,c={send:t,onMessage:h};this.f=new E.$Nh(c);const o=()=>this.o();process.once("exit",o),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,d)=>{process.removeListener("exit",o),this.c.forEach(b=>(0,k.$Oc)(b)),this.c.clear(),u!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:d})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$wq=l}),define(Ce[189],Ie([1,0,8,4,3,56,18]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=e.$vp=e.StorageState=e.$up=e.StorageHint=void 0;var v;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function p(m){const E=m;return E?.changed instanceof Map||E?.deleted instanceof Set}e.$up=p;var k;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(k||(e.StorageState=k={}));class R extends $.$Tc{static{this.a=100}constructor(E,S=Object.create(null)){super(),this.r=E,this.s=S,this.b=this.B(new F.$2d),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new I.$9g(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((S,l)=>this.w(l,S)),E.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(E,S){if(this.c===k.Closed)return;let l=!1;(0,A.$Vf)(S)?l=this.f.delete(E):this.f.get(E)!==S&&(this.f.set(E,S),l=!0),l&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,S){const l=this.f.get(E);return(0,A.$Vf)(l)?S:l}getBoolean(E,S){const l=this.get(E);return(0,A.$Vf)(l)?S:l==="true"}getNumber(E,S){const l=this.get(E);return(0,A.$Vf)(l)?S:parseInt(l,10)}getObject(E,S){const l=this.get(E);return(0,A.$Vf)(l)?S:(0,L.$Gh)(l)}async set(E,S,l=!1){if(this.c===k.Closed)return;if((0,A.$Vf)(S))return this.delete(E,l);const w=(0,A.$Of)(S)||Array.isArray(S)?(0,L.$Fh)(S):String(S);if(this.f.get(E)!==w)return this.f.set(E,w),this.j.set(E,w),this.h.delete(E),this.b.fire({key:E,external:l}),this.D()}async delete(E,S=!1){if(!(this.c===k.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:S}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$vp=R;class C{constructor(){this.onDidChangeItemsExternal=F.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((S,l)=>this.a.set(l,S)),E.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$wp=C}),define(Ce[190],Ie([1,0,12,11,21]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.$ft=void 0;let L;function A(){return L||(L=new TextDecoder("UTF-16LE")),L}let v;function p(){return v||(v=new TextDecoder("UTF-16BE")),v}let k;function R(){return k||(k=F.$D()?A():p()),k}e.$ft=R;function C(S,l,w){const s=new Uint16Array(S.buffer,l,w);return w>0&&(s[0]===65279||s[0]===65534)?m(S,l,w):A().decode(s)}e.$gt=C;function m(S,l,w){const s=[];let i=0;for(let n=0;n<w;n++){const r=$.$oe(S,l);l+=2,s[i++]=String.fromCharCode(r)}return s.join("")}class E{constructor(l){this.a=l|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const l=new Uint16Array(this.b.buffer,0,this.d);return R().decode(l)}f(){const l=this.e();this.d=0,this.c===null?this.c=[l]:this.c[this.c.length]=l}appendCharCode(l){const w=this.a-this.d;w<=1&&(w===0||I.$hf(l))&&this.f(),this.b[this.d++]=l}appendASCIICharCode(l){this.d===this.a&&this.f(),this.b[this.d++]=l}appendString(l){const w=l.length;if(this.d+w>=this.a){this.f(),this.c[this.c.length]=l;return}for(let s=0;s<w;s++)this.b[this.d++]=l.charCodeAt(s)}}e.$ht=E}),define(Ce[191],Ie([1,0,21,190]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=void 0;function $(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,R,C,m){this.oldPosition=k,this.oldText=R,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${$(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${$(this.oldText)}")`:`(replace@${this.oldPosition} "${$(this.oldText)}" with "${$(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,R,C){const m=R.length;I.$re(k,m,C),C+=4;for(let E=0;E<m;E++)I.$pe(k,R.charCodeAt(E),C),C+=2;return C}static d(k,R){const C=I.$qe(k,R);return R+=4,(0,F.$gt)(k,R,C)}writeSize(){return 8+L.a(this.oldText)+L.a(this.newText)}write(k,R){return I.$re(k,this.oldPosition,R),R+=4,I.$re(k,this.newPosition,R),R+=4,R=L.c(k,this.oldText,R),R=L.c(k,this.newText,R),R}static read(k,R,C){const m=I.$qe(k,R);R+=4;const E=I.$qe(k,R);R+=4;const S=L.d(k,R);R+=L.a(S);const l=L.d(k,R);return R+=L.a(l),C.push(new L(m,S,E,l)),R}}e.$it=L;function A(p,k){return p===null||p.length===0?k:new v(p,k).compress()}e.$jt=A;class v{constructor(k,R){this.a=k,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,R=0,C=this.n(k),m=this.l(R);for(;k<this.f||R<this.h;){if(C===null){this.k(m),m=this.l(++R);continue}if(m===null){this.m(C),C=this.n(++k);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++R);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++k);continue}if(m.oldPosition<C.newPosition){const[s,i]=v.r(m,C.newPosition-m.oldPosition);this.k(s),m=i;continue}if(C.newPosition<m.oldPosition){const[s,i]=v.q(C,m.oldPosition-C.newPosition);this.m(s),C=i;continue}let l,w;if(m.oldEnd===C.newEnd)l=C,w=m,C=this.n(++k),m=this.l(++R);else if(m.oldEnd<C.newEnd){const[s,i]=v.q(C,m.oldLength);l=s,w=m,C=i,m=this.l(++R)}else{const[s,i]=v.r(m,C.newLength);l=C,w=s,C=this.n(++k),m=i}this.d[this.e++]=new L(l.oldPosition,l.oldText,w.newPosition,w.newText),this.g+=l.newLength-l.oldLength,this.j+=w.newLength-w.oldLength}const E=v.s(this.d);return v.t(E)}k(k){this.d[this.e++]=v.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=v.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,R){return new L(R.oldPosition-k,R.oldText,R.newPosition,R.newText)}static p(k,R){return new L(R.oldPosition,R.oldText,R.newPosition+k,R.newText)}static q(k,R){const C=k.newText.substr(0,R),m=k.newText.substr(R);return[new L(k.oldPosition,k.oldText,k.newPosition,C),new L(k.oldEnd,"",k.newPosition+R,m)]}static r(k,R){const C=k.oldText.substr(0,R),m=k.oldText.substr(R);return[new L(k.oldPosition,C,k.newPosition,k.newText),new L(k.oldPosition+R,m,k.newEnd,"")]}static s(k){if(k.length===0)return k;const R=[];let C=0,m=k[0];for(let E=1;E<k.length;E++){const S=k[E];m.oldEnd===S.oldPosition?m=new L(m.oldPosition,m.oldText+S.oldText,m.newPosition,m.newText+S.newText):(R[C++]=m,m=S)}return R[C++]=m,R}static t(k){if(k.length===0)return k;const R=[];let C=0;for(let m=0;m<k.length;m++){const E=k[m];E.oldText!==E.newText&&(R[C++]=E)}return R}}}),define(Ce[192],Ie([1,0,35,17]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0;function $(L,A,v,p,k,R){if(Array.isArray(L)){let C=0;for(const m of L){const E=$(m,A,v,p,k,R);if(E===10)return E;E>C&&(C=E)}return C}else{if(typeof L=="string")return p?L==="*"?5:L===v?10:0:0;if(L){const{language:C,pattern:m,scheme:E,hasAccessToAllModels:S,notebookType:l}=L;if(!p&&!S)return 0;l&&k&&(A=k);let w=0;if(E)if(E===A.scheme)w=10;else if(E==="*")w=5;else return 0;if(C)if(C===v)w=10;else if(C==="*")w=Math.max(w,5);else return 0;if(l)if(l===R)w=10;else if(l==="*"&&R!==void 0)w=Math.max(w,5);else return 0;if(m){let s;if(typeof m=="string"?s=m:s={...m,base:(0,F.$hc)(m.base)},s===A.fsPath||(0,I.$Qj)(s,A.fsPath))w=10;else return 0}return w}else return 0}}e.$Gt=$}),define(Ce[193],Ie([1,0,4,12,29,80,127,168,191,3]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class R extends k.$Tc{constructor(m,E,S,l,w,s,i){super(),this.m=this.B(new I.$Yd),this.onDidChangeContent=this.m.event,this.f=E,this.j=!s,this.g=l,this.h=w,this.c=new A.$fC(m,S,i)}equals(m){return!(m instanceof R)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,E){return this.c.getOffsetAt(m,E)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,E){const S=m+E,l=this.getPositionAt(m),w=this.getPositionAt(S);return new $.$Zs(l.lineNumber,l.column,w.lineNumber,w.column)}getValueInRange(m,E=0){if(m.isEmpty())return"";const S=this.n(E);return this.c.getValueInRange(m,S)}getValueLengthInRange(m,E=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const S=this.getOffsetAt(m.startLineNumber,m.startColumn),l=this.getOffsetAt(m.endLineNumber,m.endColumn);let w=0;const s=this.n(E),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,r=m.endLineNumber-m.startLineNumber;w=n*r}return l-S+w}getCharacterCountInRange(m,E=0){if(this.j){let S=0;const l=m.startLineNumber,w=m.endLineNumber;for(let s=l;s<=w;s++){const i=this.getLineContent(s),n=s===l?m.startColumn-1:0,r=s===w?m.endColumn-1:i.length;for(let a=n;a<r;a++)F.$hf(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(E).length*(w-l),S}return this.getValueLengthInRange(m,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,E){return this.c.getLineCharCode(m,E)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const E=F.$5e(this.getLineContent(m));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(m){const E=F.$7e(this.getLineContent(m));return E===-1?0:E+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,E,S){let l=this.g,w=this.h,s=this.j,i=!0,n=[];for(let u=0;u<m.length;u++){const d=m[u];i&&d._isTracked&&(i=!1);const b=d.range;if(d.text){let P=!0;s||(P=!F.$sf(d.text),s=P),!l&&P&&(l=F.$rf(d.text)),!w&&P&&(w=F.$uf(d.text))}let D="",g=0,f=0,y=0;if(d.text){let P;[g,f,y,P]=(0,v.$zt)(d.text);const T=this.getEOL();P===0||P===(T===`\r
`?2:1)?D=d.text:D=d.text.replace(/\r\n|\r|\n/g,T)}n[u]={sortIndex:u,identifier:d.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:D,eolCount:g,firstLineLength:f,lastLineLength:y,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}n.sort(R.u);let r=!1;for(let u=0,d=n.length-1;u<d;u++){const b=n[u].range.getEndPosition(),D=n[u+1].range.getStartPosition();if(D.isBeforeOrEqual(b)){if(D.isBefore(b))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const a=S||E?R._getInverseEditRanges(n):[],t=[];if(E)for(let u=0;u<n.length;u++){const d=n[u],b=a[u];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let D=b.startLineNumber;D<=b.endLineNumber;D++){let g="";D===b.startLineNumber&&(g=this.getLineContent(d.range.startLineNumber),F.$5e(g)!==-1)||t.push({lineNumber:D,oldContent:g})}}let h=null;if(S){let u=0;h=[];for(let d=0;d<n.length;d++){const b=n[d],D=a[d],g=this.getValueInRange(b.range),f=b.rangeOffset+u;u+=b.text.length-g.length,h[d]={sortIndex:b.sortIndex,identifier:b.identifier,range:D,text:g,textChange:new p.$it(b.rangeOffset,g,f,b.text)}}r||h.sort((d,b)=>d.sortIndex-b.sortIndex)}this.g=l,this.h=w,this.j=s;const c=this.t(n);let o=null;if(E&&t.length>0){t.sort((u,d)=>d.lineNumber-u.lineNumber),o=[];for(let u=0,d=t.length;u<d;u++){const b=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===b)continue;const D=t[u].oldContent,g=this.getLineContent(b);g.length===0||g===D||F.$5e(g)!==-1||o.push(b)}}return this.m.fire(),new L.$jv(h,c,o)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let E=!1;const S=m[0].range,l=m[m.length-1].range,w=new $.$Zs(S.startLineNumber,S.startColumn,l.endLineNumber,l.endColumn);let s=S.startLineNumber,i=S.startColumn;const n=[];for(let c=0,o=m.length;c<o;c++){const u=m[c],d=u.range;E=E||u.forceMoveMarkers,n.push(this.getValueInRange(new $.$Zs(s,i,d.startLineNumber,d.startColumn))),u.text.length>0&&n.push(u.text),s=d.endLineNumber,i=d.endColumn}const r=n.join(""),[a,t,h]=(0,v.$zt)(r);return{sortIndex:0,identifier:m[0].identifier,range:w,rangeOffset:this.getOffsetAt(w.startLineNumber,w.startColumn),rangeLength:this.getValueLengthInRange(w,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:h,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(m){m.sort(R.w);const E=[];for(let S=0;S<m.length;S++){const l=m[S],w=l.range.startLineNumber,s=l.range.startColumn,i=l.range.endLineNumber,n=l.range.endColumn;if(w===i&&s===n&&l.text.length===0)continue;l.text?(this.c.delete(l.rangeOffset,l.rangeLength),this.c.insert(l.rangeOffset,l.text,!0)):this.c.delete(l.rangeOffset,l.rangeLength);const r=new $.$Zs(w,s,i,n);E.push({range:r,rangeLength:l.rangeLength,text:l.text,rangeOffset:l.rangeOffset,forceMoveMarkers:l.forceMoveMarkers})}return E}findMatchesLineByLine(m,E,S,l){return this.c.findMatchesLineByLine(m,E,S,l)}getPieceTree(){return this.c}static _getInverseEditRange(m,E){const S=m.startLineNumber,l=m.startColumn,[w,s,i]=(0,v.$zt)(E);let n;if(E.length>0){const r=w+1;r===1?n=new $.$Zs(S,l,S,l+s):n=new $.$Zs(S,l,S+r-1,i+1)}else n=new $.$Zs(S,l,S,l);return n}static _getInverseEditRanges(m){const E=[];let S=0,l=0,w=null;for(let s=0,i=m.length;s<i;s++){const n=m[s];let r,a;w?w.range.endLineNumber===n.range.startLineNumber?(r=S,a=l+(n.range.startColumn-w.range.endColumn)):(r=S+(n.range.startLineNumber-w.range.endLineNumber),a=n.range.startColumn):(r=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const h=n.eolCount+1;h===1?t=new $.$Zs(r,a,r,a+n.firstLineLength):t=new $.$Zs(r,a,r+h-1,n.lastLineLength+1)}else t=new $.$Zs(r,a,r,a);S=t.endLineNumber,l=t.endColumn,E.push(t),w=n}return E}static u(m,E){const S=$.$Zs.compareRangesUsingEnds(m.range,E.range);return S===0?m.sortIndex-E.sortIndex:S}static w(m,E){const S=$.$Zs.compareRangesUsingEnds(m.range,E.range);return S===0?E.sortIndex-m.sortIndex:-S}}e.$gC=R}),define(Ce[194],Ie([1,0,12,127,193]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=void 0;class L{constructor(p,k,R,C,m,E,S,l,w){this.a=p,this.b=k,this.c=R,this.d=C,this.e=m,this.f=E,this.g=S,this.h=l,this.j=w}k(p){const k=this.c+this.d+this.e,R=this.c+this.e;return k===0?p===1?`
`:`\r
`:R>k/2?`\r
`:`
`}create(p){const k=this.k(p),R=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let m=0,E=R.length;m<E;m++){const S=R[m].buffer.replace(/\r\n|\r|\n/g,k),l=(0,F.$bC)(S);R[m]=new F.$eC(S,l)}const C=new $.$gC(R,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&I.$Af(p)&&(this.b=I.$zf,p=p.substr(1));const k=p.charCodeAt(p.length-1);k===13||k>=55296&&k<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=k):(this.m(p,!1),this.c=!1,this.d=k)}m(p,k){!k&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const k=(0,F.$cC)(this.e,p);this.a.push(new F.$eC(p,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=I.$rf(p)),this.k||(this.k=I.$uf(p)))}finish(p=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const k=(0,F.$bC)(p.buffer);p.lineStarts=k,this.d===13&&this.f++}}}e.$hC=A}),define(Ce[131],Ie([1,0,21,11]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_=e.$d_=void 0;var $;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})($||($={}));function L(C){for(let m=0,E=C.length;m<E;m+=4){const S=C[m+0],l=C[m+1],w=C[m+2],s=C[m+3];C[m+0]=s,C[m+1]=w,C[m+2]=l,C[m+3]=S}}function A(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return F.$D()||L(m),I.$me.wrap(m)}function v(C){const m=C.buffer;if(F.$D()||L(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const E=new Uint8Array(m.byteLength);return E.set(m),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(C){const m=new Uint32Array(k(C));let E=0;if(m[E++]=C.id,C.type==="full")m[E++]=1,m[E++]=C.data.length,m.set(C.data,E),E+=C.data.length;else{m[E++]=2,m[E++]=C.deltas.length;for(const S of C.deltas)m[E++]=S.start,m[E++]=S.deleteCount,S.data?(m[E++]=S.data.length,m.set(S.data,E),E+=S.data.length):m[E++]=0}return A(m)}e.$d_=p;function k(C){let m=0;if(m+=2,C.type==="full")m+=1+C.data.length;else{m+=1,m+=3*C.deltas.length;for(const E of C.deltas)E.data&&(m+=E.data.length)}return m}function R(C){const m=v(C);let E=0;const S=m[E++];if(m[E++]===1){const i=m[E++],n=m.subarray(E,E+i);return E+=i,{id:S,type:"full",data:n}}const w=m[E++],s=[];for(let i=0;i<w;i++){const n=m[E++],r=m[E++],a=m[E++];let t;a>0&&(t=m.subarray(E,E+a),E+=a),s[i]={start:n,deleteCount:r,data:t}}return{id:S,type:"delta",deltas:s}}e.$e_=R}),define(Ce[195],Ie([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Ce[132],Ie([1,0,19,24,11,171,126,195]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var p;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=k;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class C{constructor(se,De,Ve,Ke){this.id=se,this.name=De,this.defaultValue=Ve,this.schema=Ke}applyUpdate(se,De){return E(se,De)}compute(se,De,Ve){return Ve}}class m{constructor(se,De){this.newValue=se,this.didChange=De}}e.ApplyUpdateResult=m;function E(te,se){if(typeof te!="object"||typeof se!="object"||!te||!se)return new m(se,te!==se);if(Array.isArray(te)||Array.isArray(se)){const Ve=Array.isArray(te)&&Array.isArray(se)&&I.$ub(te,se);return new m(se,!Ve)}let De=!1;for(const Ve in se)if(se.hasOwnProperty(Ve)){const Ke=E(te[Ve],se[Ve]);Ke.didChange&&(te[Ve]=Ke.newValue,De=!0)}return new m(te,De)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,De){return E(se,De)}validate(se){return this.defaultValue}}class l{constructor(se,De,Ve,Ke){this.id=se,this.name=De,this.defaultValue=Ve,this.schema=Ke}applyUpdate(se,De){return E(se,De)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,De,Ve){return Ve}}function w(te,se){return typeof te>"u"?se:te==="false"?!1:!!te}e.boolean=w;class s extends l{constructor(se,De,Ve,Ke=void 0){typeof Ke<"u"&&(Ke.type="boolean",Ke.default=Ve),super(se,De,Ve,Ke)}validate(se){return w(se,this.defaultValue)}}function i(te,se,De,Ve){if(typeof te>"u")return se;let Ke=parseInt(te,10);return isNaN(Ke)?se:(Ke=Math.max(De,Ke),Ke=Math.min(Ve,Ke),Ke|0)}e.clampedInt=i;class n extends l{static clampedInt(se,De,Ve,Ke){return i(se,De,Ve,Ke)}constructor(se,De,Ve,Ke,nt,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ve,st.minimum=Ke,st.maximum=nt),super(se,De,Ve,st),this.minimum=Ke,this.maximum=nt}validate(se){return n.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function r(te,se,De,Ve){if(typeof te>"u")return se;const Ke=a.float(te,se);return a.clamp(Ke,De,Ve)}e.clampedFloat=r;class a extends l{static clamp(se,De,Ve){return se<De?De:se>Ve?Ve:se}static float(se,De){if(typeof se=="number")return se;if(typeof se>"u")return De;const Ve=parseFloat(se);return isNaN(Ve)?De:Ve}constructor(se,De,Ve,Ke,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(se,De,Ve,nt),this.validationFn=Ke}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class t extends l{static string(se,De){return typeof se!="string"?De:se}constructor(se,De,Ve,Ke=void 0){typeof Ke<"u"&&(Ke.type="string",Ke.default=Ve),super(se,De,Ve,Ke)}validate(se){return t.string(se,this.defaultValue)}}function h(te,se,De,Ve){return typeof te!="string"?se:Ve&&te in Ve?Ve[te]:De.indexOf(te)===-1?se:te}e.stringSet=h;class c extends l{constructor(se,De,Ve,Ke,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ke,nt.default=Ve),super(se,De,Ve,nt),this.c=Ke}validate(se){return h(se,this.defaultValue,this.c)}}class o extends C{constructor(se,De,Ve,Ke,nt,st,je=void 0){typeof je<"u"&&(je.type="string",je.enum=nt,je.default=Ke),super(se,De,Ve,je),this.c=nt,this.d=st}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function u(te){switch(te){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",tags:["accessibility"],description:v.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,De,Ve){return Ve===0?se.accessibilitySupport:Ve}}class b extends C{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:v.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{insertSpace:w(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:w(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function g(te){switch(te){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function y(te){switch(te){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function P(te){switch(te){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class T extends S{constructor(){super(140)}compute(se,De,Ve){const Ke=["monaco-editor"];return De.get(39)&&Ke.push(De.get(39)),se.extraEditorClassName&&Ke.push(se.extraEditorClassName),De.get(73)==="default"?Ke.push("mouse-default"):De.get(73)==="copy"&&Ke.push("mouse-copy"),De.get(110)&&Ke.push("showUnused"),De.get(138)&&Ke.push("showDeprecated"),Ke.join(" ")}}class U extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(se,De,Ve){return Ve&&se.emptySelectionClipboard}}class z extends C{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[v.localize(8,null),v.localize(9,null),v.localize(10,null)],description:v.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[v.localize(12,null),v.localize(13,null),v.localize(14,null)],description:v.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:v.localize(16,null),included:$.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:v.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:v.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{cursorMoveOnType:w(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":h(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":h(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:w(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:w(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:w(De.loop,this.defaultValue.loop)}}}class M extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",M.OFF,{anyOf:[{type:"boolean",description:v.localize(19,null)},{type:"string",description:v.localize(20,null)}],description:v.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?M.OFF:se==="true"?M.ON:se:se?M.ON:M.OFF}}e.EditorFontLigatures=M;class N extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:v.localize(22,null)},{type:"string",description:v.localize(23,null)}],description:v.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?N.OFF:se==="true"?N.TRANSLATE:se:se?N.TRANSLATE:N.OFF}compute(se,De,Ve){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=N;class O extends S{constructor(){super(50)}compute(se,De,Ve){return se.fontInfo}}class j extends l{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(25,null)})}validate(se){const De=a.float(se,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(De,6,100)}compute(se,De,Ve){return se.fontInfo.fontSize}}class Y extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:v.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(n.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ne extends C{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[v.localize(28,null),v.localize(29,null),v.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:v.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:v.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:v.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:v.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:v.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ve,description:v.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ve,description:v.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ve,description:v.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ve,description:v.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ve,description:v.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{multiple:h(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??h(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??h(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??h(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??h(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??h(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends C{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:v.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:v.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:v.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:v.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:v.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),delay:n.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:w(De.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:w(De.above,this.defaultValue.above)}}}var Q;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class X extends S{constructor(){super(143)}compute(se,De,Ve){return X.computeLayout(De,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const De=se.height/se.lineHeight,Ve=Math.floor(se.paddingTop/se.lineHeight);let Ke=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Ke=Math.max(Ke,De-1));const nt=(Ve+se.viewLineCount+Ke)/(se.pixelRatio*se.height),st=Math.floor(se.viewLineCount/nt);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ke,desiredRatio:nt,minimapLineCount:st}}static c(se,De){const Ve=se.outerWidth,Ke=se.outerHeight,nt=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ke};const st=De.stableMinimapLayoutInput,je=st&&se.outerHeight===st.outerHeight&&se.lineHeight===st.lineHeight&&se.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&se.pixelRatio===st.pixelRatio&&se.scrollBeyondLastLine===st.scrollBeyondLastLine&&se.paddingTop===st.paddingTop&&se.paddingBottom===st.paddingBottom&&se.minimap.enabled===st.minimap.enabled&&se.minimap.side===st.minimap.side&&se.minimap.size===st.minimap.size&&se.minimap.showSlider===st.minimap.showSlider&&se.minimap.renderCharacters===st.minimap.renderCharacters&&se.minimap.maxColumn===st.minimap.maxColumn&&se.minimap.scale===st.minimap.scale&&se.verticalScrollbarWidth===st.verticalScrollbarWidth&&se.isViewportWrapping===st.isViewportWrapping,yt=se.lineHeight,kt=se.typicalHalfwidthCharacterWidth,Ot=se.scrollBeyondLastLine,Rt=se.minimap.renderCharacters;let St=nt>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const ti=se.minimap.maxColumn,Wt=se.minimap.size,si=se.minimap.side,Xt=se.verticalScrollbarWidth,xt=se.viewLineCount,_e=se.remainingWidth,qt=se.isViewportWrapping,ii=Rt?2:3;let dt=Math.floor(nt*Ke);const $t=dt/nt;let Yt=!1,ni=!1,Lt=ii*St,ft=St/nt,Mt=1;if(Wt==="fill"||Wt==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:jt,extraLinesBeyondLastLine:Nt,desiredRatio:zt,minimapLineCount:Vt}=X.computeContainedMinimapLineCount({viewLineCount:xt,scrollBeyondLastLine:Ot,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Ke,lineHeight:yt,pixelRatio:nt});if(xt/Vt>1)Yt=!0,ni=!0,St=1,Lt=1,ft=St/nt;else{let Ct=!1,Ht=St+1;if(Wt==="fit"){const Et=Math.ceil((jt+xt+Nt)*Lt);qt&&je&&_e<=De.stableFitRemainingWidth?(Ct=!0,Ht=De.stableFitMaxMinimapScale):Ct=Et>dt}if(Wt==="fill"||Ct){Yt=!0;const Et=St;Lt=Math.min(yt*nt,Math.max(1,Math.floor(1/zt))),qt&&je&&_e<=De.stableFitRemainingWidth&&(Ht=De.stableFitMaxMinimapScale),St=Math.min(Ht,Math.max(1,Math.floor(Lt/ii))),St>Et&&(Mt=Math.min(2,St/Et)),ft=St/nt/Mt,dt=Math.ceil(Math.max(gt,jt+xt+Nt)*Lt),qt?(De.stableMinimapLayoutInput=se,De.stableFitRemainingWidth=_e,De.stableFitMaxMinimapScale=St):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const oi=Math.floor(ti*ft),Ft=Math.min(oi,Math.max(0,Math.floor((_e-Xt-2)*ft/(kt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Ye=Math.floor(nt*Ft);const Kt=Ye/nt;Ye=Math.floor(Ye*Mt);const Qt=Rt?1:2,_t=si==="left"?0:Ve-Ft-Xt;return{renderMinimap:Qt,minimapLeft:_t,minimapWidth:Ft,minimapHeightIsEditorHeight:Yt,minimapIsSampling:ni,minimapScale:St,minimapLineHeight:Lt,minimapCanvasInnerWidth:Ye,minimapCanvasInnerHeight:dt,minimapCanvasOuterWidth:Kt,minimapCanvasOuterHeight:$t}}static computeLayout(se,De){const Ve=De.outerWidth|0,Ke=De.outerHeight|0,nt=De.lineHeight|0,st=De.lineNumbersDigitCount|0,je=De.typicalHalfwidthCharacterWidth,yt=De.maxDigitWidth,kt=De.pixelRatio,Ot=De.viewLineCount,Rt=se.get(135),St=Rt==="inherit"?se.get(134):Rt,ti=St==="inherit"?se.get(130):St,Wt=se.get(133),si=De.isDominatedByLongLines,Xt=se.get(57),xt=se.get(67).renderType!==0,_e=se.get(68),qt=se.get(104),ii=se.get(83),dt=se.get(72),$t=se.get(102),Yt=$t.verticalScrollbarSize,ni=$t.verticalHasArrows,Lt=$t.arrowSize,ft=$t.horizontalScrollbarSize,Mt=se.get(43),oi=se.get(109)!=="never";let Ft=se.get(65);Mt&&oi&&(Ft+=16);let Ye=0;if(xt){const It=Math.max(st,_e);Ye=Math.round(It*yt)}let Kt=0;Xt&&(Kt=nt*De.glyphMarginDecorationLaneCount);let Qt=0,_t=Qt+Kt,gt=_t+Ye,jt=gt+Ft;const Nt=Ve-Kt-Ye-Ft;let zt=!1,Vt=!1,Ut=-1;St==="inherit"&&si?(zt=!0,Vt=!0):ti==="on"||ti==="bounded"?Vt=!0:ti==="wordWrapColumn"&&(Ut=Wt);const Ct=X.c({outerWidth:Ve,outerHeight:Ke,lineHeight:nt,typicalHalfwidthCharacterWidth:je,pixelRatio:kt,scrollBeyondLastLine:qt,paddingTop:ii.top,paddingBottom:ii.bottom,minimap:dt,verticalScrollbarWidth:Yt,viewLineCount:Ot,remainingWidth:Nt,isViewportWrapping:Vt},De.memory||new R);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Qt+=Ct.minimapWidth,_t+=Ct.minimapWidth,gt+=Ct.minimapWidth,jt+=Ct.minimapWidth);const Ht=Nt-Ct.minimapWidth,Et=Math.max(1,Math.floor((Ht-Yt-2)/je)),pt=ni?Lt:0;return Vt&&(Ut=Math.max(1,Et),ti==="bounded"&&(Ut=Math.min(Ut,Wt))),{width:Ve,height:Ke,glyphMarginLeft:Qt,glyphMarginWidth:Kt,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:Ye,decorationsLeft:gt,decorationsWidth:Ft,contentLeft:jt,contentWidth:Ht,minimap:Ct,viewportColumn:Et,isWordWrapMinified:zt,isViewportWrapping:Vt,wrappingColumn:Ut,verticalScrollbarWidth:Yt,horizontalScrollbarHeight:ft,overviewRuler:{top:pt,width:Yt,height:Ke-2*pt,right:0}}}}e.EditorLayoutInfoComputer=X;class ce extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[v.localize(47,null),v.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:v.localize(49,null)}})}validate(se){return h(se,"simple",["simple","advanced"])}compute(se,De,Ve){return De.get(2)===2?"advanced":Ve}}var ie;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class fe extends C{constructor(){const se={enabled:ie.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ie.Off,ie.OnCode,ie.On],default:se.enabled,enumDescriptions:[v.localize(50,null),v.localize(51,null),v.localize(52,null)],description:v.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:h(se.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class re extends C{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:v.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:v.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:v.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:v.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:w(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class J extends C{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:v.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[v.localize(59,null),v.localize(60,null,$.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(61,null,$.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:v.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:v.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:v.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:h(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily),padding:w(De.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):n.clampedInt(se,this.defaultValue,0,1e3)}compute(se,De,Ve){return Ve<0?n.clampedInt(-Ve*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ae extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:v.localize(66,null)})}compute(se,De,Ve){return se.fontInfo.lineHeight}}class Ee extends C{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:v.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:v.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(69,null),v.localize(70,null),v.localize(71,null)],default:se.size,description:v.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:v.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:v.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:v.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:v.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),autohide:w(De.autohide,this.defaultValue.autohide),size:h(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(De.side,this.defaultValue.side,["right","left"]),showSlider:h(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:w(De.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(De.scale,1,1,3),maxColumn:n.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(te){return te==="ctrlCmd"?$.$j?"metaKey":"ctrlKey":"altKey"}class de extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{top:n.clampedInt(De.top,0,0,1e3),bottom:n.clampedInt(De.bottom,0,0,1e3)}}}class ue extends C{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:v.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:v.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),cycle:w(De.cycle,this.defaultValue.cycle)}}}class ge extends S{constructor(){super(141)}compute(se,De,Ve){return se.pixelRatio}}class V extends C{constructor(){const se={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[v.localize(82,null),v.localize(83,null),v.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:se.strings,description:v.localize(85,null)},comments:{anyOf:De,default:se.comments,description:v.localize(86,null)},other:{anyOf:De,default:se.other,description:v.localize(87,null)}},default:se,markdownDescription:v.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const kt=se?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!se||typeof se!="object")return this.defaultValue;const{other:De,comments:Ve,strings:Ke}=se,nt=["on","inline","off"];let st,je,yt;return typeof De=="boolean"?st=De?"on":"off":st=h(De,this.defaultValue.other,nt),typeof Ve=="boolean"?je=Ve?"on":"off":je=h(Ve,this.defaultValue.comments,nt),typeof Ke=="boolean"?yt=Ke?"on":"off":yt=h(Ke,this.defaultValue.strings,nt),{other:st,comments:je,strings:yt}}}var Z;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(Z||(e.RenderLineNumbersType=Z={}));class he extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(89,null),v.localize(90,null),v.localize(91,null),v.localize(92,null)],default:"on",description:v.localize(93,null)})}validate(se){let De=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(De=4,Ve=se):se==="interval"?De=3:se==="relative"?De=2:se==="on"?De=1:De=0),{renderType:De,renderFn:Ve}}}function be(te){const se=te.get(97);return se==="editable"?te.get(90):se!=="on"}e.filterValidationDecorations=be;class Pe extends C{constructor(){const se=[],De={type:"number",description:v.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:v.localize(95,null),format:"color-hex"}}}]},default:se,description:v.localize(96,null)})}validate(se){if(Array.isArray(se)){const De=[];for(const Ve of se)if(typeof Ve=="number")De.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ke=Ve;De.push({column:n.clampedInt(Ke.column,0,0,1e4),color:Ke.color})}return De.sort((Ve,Ke)=>Ve.column-Ke.column),De}return this.defaultValue}}class pe extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Le(te,se){if(typeof te!="string")return se;switch(te){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends C{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(97,null),v.localize(98,null),v.localize(99,null)],default:"auto",description:v.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(101,null),v.localize(102,null),v.localize(103,null)],default:"auto",description:v.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:v.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:v.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:v.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:v.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se,Ve=n.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ke=n.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Le(De.vertical,this.defaultValue.vertical),horizontal:Le(De.horizontal,this.defaultValue.horizontal),useShadows:w(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:w(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:w(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:w(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:w(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(De.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ke,verticalSliderSize:n.clampedInt(De.verticalSliderSize,Ke,0,1e3),scrollByPage:w(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:w(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends C{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:v.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:v.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:v.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:v.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:v.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:v.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:v.localize(115,null)}})}applyUpdate(se,De){let Ve=!1;De.allowedCharacters&&se&&(F.$Fn(se.allowedCharacters,De.allowedCharacters)||(se={...se,allowedCharacters:De.allowedCharacters},Ve=!0)),De.allowedLocales&&se&&(F.$Fn(se.allowedLocales,De.allowedLocales)||(se={...se,allowedLocales:De.allowedLocales},Ve=!0));const Ke=super.applyUpdate(se,De);return Ve?new m(Ke.newValue,!0):Ke}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{nonBasicASCII:oe(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:w(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:w(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:oe(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:oe(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,De){if(typeof se!="object"||!se)return De;const Ve={};for(const[Ke,nt]of Object.entries(se))nt===!0&&(Ve[Ke]=!0);return Ve}}class x extends C{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:v.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[v.localize(117,null),v.localize(118,null),v.localize(119,null)],description:v.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:v.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:v.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),mode:h(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:w(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:w(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(De.fontFamily,this.defaultValue.fontFamily)}}}class H extends C{constructor(){const se={enabled:L.$xs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$xs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:v.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:w(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends C{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(125,null),v.localize(126,null),v.localize(127,null)],default:se.bracketPairs,description:v.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null)],default:se.bracketPairsHorizontal,description:v.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:v.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:v.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null)],default:se.highlightActiveIndentation,description:v.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{bracketPairs:oe(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:oe(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:w(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:w(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:oe(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function oe(te,se,De){const Ve=De.indexOf(te);return Ve===-1?se:De[Ve]}class ye extends C{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(139,null),v.localize(140,null)],default:se.insertMode,description:v.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:v.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:v.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:v.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[v.localize(145,null),v.localize(146,null),v.localize(147,null),v.localize(148,null)],default:se.selectionMode,markdownDescription:v.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:v.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:v.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:v.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:v.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:v.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:v.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{insertMode:h(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:w(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:w(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:w(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:w(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:w(De.showIcons,this.defaultValue.showIcons),showStatusBar:w(De.showStatusBar,this.defaultValue.showStatusBar),preview:w(De.preview,this.defaultValue.preview),previewMode:h(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:w(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:w(De.showMethods,this.defaultValue.showMethods),showFunctions:w(De.showFunctions,this.defaultValue.showFunctions),showConstructors:w(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:w(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:w(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:w(De.showFields,this.defaultValue.showFields),showVariables:w(De.showVariables,this.defaultValue.showVariables),showClasses:w(De.showClasses,this.defaultValue.showClasses),showStructs:w(De.showStructs,this.defaultValue.showStructs),showInterfaces:w(De.showInterfaces,this.defaultValue.showInterfaces),showModules:w(De.showModules,this.defaultValue.showModules),showProperties:w(De.showProperties,this.defaultValue.showProperties),showEvents:w(De.showEvents,this.defaultValue.showEvents),showOperators:w(De.showOperators,this.defaultValue.showOperators),showUnits:w(De.showUnits,this.defaultValue.showUnits),showValues:w(De.showValues,this.defaultValue.showValues),showConstants:w(De.showConstants,this.defaultValue.showConstants),showEnums:w(De.showEnums,this.defaultValue.showEnums),showEnumMembers:w(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:w(De.showKeywords,this.defaultValue.showKeywords),showWords:w(De.showWords,this.defaultValue.showWords),showColors:w(De.showColors,this.defaultValue.showColors),showFiles:w(De.showFiles,this.defaultValue.showFiles),showReferences:w(De.showReferences,this.defaultValue.showReferences),showFolders:w(De.showFolders,this.defaultValue.showFolders),showTypeParameters:w(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:w(De.showSnippets,this.defaultValue.showSnippets),showUsers:w(De.showUsers,this.defaultValue.showUsers),showIssues:w(De.showIssues,this.defaultValue.showIssues)}}}class Re extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:v.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:w(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:w(se.selectSubwords,this.defaultValue.selectSubwords)}}}var qe;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class Ge extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[v.localize(189,null),v.localize(190,null),v.localize(191,null),v.localize(192,null)],description:v.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,De,Ve){return De.get(2)===2?0:Ve}}class Xe extends S{constructor(){super(144)}compute(se,De,Ve){const Ke=De.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ke.isWordWrapMinified,isViewportWrapping:Ke.isViewportWrapping,wrappingColumn:Ke.wrappingColumn}}}class it extends C{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:v.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[v.localize(196,null),v.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),showDropSelector:h(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends C{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:v.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[v.localize(200,null),v.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const De=se;return{enabled:w(De.enabled,this.defaultValue.enabled),showPasteSelector:h(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const at="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",Ae="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:$.$j?et:$.$k?Ae:at,fontWeight:"normal",fontSize:$.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Se(te){return e.editorOptionsRegistry[te.id]=te,te}var He;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.letterSpacing=63]="letterSpacing",te[te.lightbulb=64]="lightbulb",te[te.lineDecorationsWidth=65]="lineDecorationsWidth",te[te.lineHeight=66]="lineHeight",te[te.lineNumbers=67]="lineNumbers",te[te.lineNumbersMinChars=68]="lineNumbersMinChars",te[te.linkedEditing=69]="linkedEditing",te[te.links=70]="links",te[te.matchBrackets=71]="matchBrackets",te[te.minimap=72]="minimap",te[te.mouseStyle=73]="mouseStyle",te[te.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=75]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",te[te.multiCursorModifier=77]="multiCursorModifier",te[te.multiCursorPaste=78]="multiCursorPaste",te[te.multiCursorLimit=79]="multiCursorLimit",te[te.occurrencesHighlight=80]="occurrencesHighlight",te[te.overviewRulerBorder=81]="overviewRulerBorder",te[te.overviewRulerLanes=82]="overviewRulerLanes",te[te.padding=83]="padding",te[te.pasteAs=84]="pasteAs",te[te.parameterHints=85]="parameterHints",te[te.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",te[te.quickSuggestions=88]="quickSuggestions",te[te.quickSuggestionsDelay=89]="quickSuggestionsDelay",te[te.readOnly=90]="readOnly",te[te.readOnlyMessage=91]="readOnlyMessage",te[te.renameOnType=92]="renameOnType",te[te.renderControlCharacters=93]="renderControlCharacters",te[te.renderFinalNewline=94]="renderFinalNewline",te[te.renderLineHighlight=95]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=97]="renderValidationDecorations",te[te.renderWhitespace=98]="renderWhitespace",te[te.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",te[te.roundedSelection=100]="roundedSelection",te[te.rulers=101]="rulers",te[te.scrollbar=102]="scrollbar",te[te.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=104]="scrollBeyondLastLine",te[te.scrollPredominantAxis=105]="scrollPredominantAxis",te[te.selectionClipboard=106]="selectionClipboard",te[te.selectionHighlight=107]="selectionHighlight",te[te.selectOnLineNumbers=108]="selectOnLineNumbers",te[te.showFoldingControls=109]="showFoldingControls",te[te.showUnused=110]="showUnused",te[te.snippetSuggestions=111]="snippetSuggestions",te[te.smartSelect=112]="smartSelect",te[te.smoothScrolling=113]="smoothScrolling",te[te.stickyScroll=114]="stickyScroll",te[te.stickyTabStops=115]="stickyTabStops",te[te.stopRenderingLineAfter=116]="stopRenderingLineAfter",te[te.suggest=117]="suggest",te[te.suggestFontSize=118]="suggestFontSize",te[te.suggestLineHeight=119]="suggestLineHeight",te[te.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",te[te.suggestSelection=121]="suggestSelection",te[te.tabCompletion=122]="tabCompletion",te[te.tabIndex=123]="tabIndex",te[te.unicodeHighlighting=124]="unicodeHighlighting",te[te.unusualLineTerminators=125]="unusualLineTerminators",te[te.useShadowDOM=126]="useShadowDOM",te[te.useTabStops=127]="useTabStops",te[te.wordBreak=128]="wordBreak",te[te.wordSeparators=129]="wordSeparators",te[te.wordWrap=130]="wordWrap",te[te.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=133]="wordWrapColumn",te[te.wordWrapOverride1=134]="wordWrapOverride1",te[te.wordWrapOverride2=135]="wordWrapOverride2",te[te.wrappingIndent=136]="wrappingIndent",te[te.wrappingStrategy=137]="wrappingStrategy",te[te.showDeprecated=138]="showDeprecated",te[te.inlayHints=139]="inlayHints",te[te.editorClassName=140]="editorClassName",te[te.pixelRatio=141]="pixelRatio",te[te.tabFocusMode=142]="tabFocusMode",te[te.layoutInfo=143]="layoutInfo",te[te.wrappingInfo=144]="wrappingInfo",te[te.defaultColorDecorators=145]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(He||(e.EditorOption=He={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Se(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(202,null)})),acceptSuggestionOnEnter:Se(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(203,null),""],markdownDescription:v.localize(204,null)})),accessibilitySupport:Se(new d),accessibilityPageSize:Se(new n(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(205,null),tags:["accessibility"]})),ariaLabel:Se(new t(4,"ariaLabel",v.localize(206,null))),ariaRequired:Se(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Se(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:v.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Se(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(208,null),v.localize(209,null),""],description:v.localize(210,null)})),autoClosingComments:Se(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(211,null),v.localize(212,null),""],description:v.localize(213,null)})),autoClosingDelete:Se(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(214,null),""],description:v.localize(215,null)})),autoClosingOvertype:Se(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(216,null),""],description:v.localize(217,null)})),autoClosingQuotes:Se(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(218,null),v.localize(219,null),""],description:v.localize(220,null)})),autoIndent:Se(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),automaticLayout:Se(new s(13,"automaticLayout",!1)),autoSurround:Se(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null),""],description:v.localize(230,null)})),bracketPairColorization:Se(new H),bracketPairGuides:Se(new K),stickyTabStops:Se(new s(115,"stickyTabStops",!1,{description:v.localize(231,null)})),codeLens:Se(new s(17,"codeLens",!0,{description:v.localize(232,null)})),codeLensFontFamily:Se(new t(18,"codeLensFontFamily","",{description:v.localize(233,null)})),codeLensFontSize:Se(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(234,null)})),colorDecorators:Se(new s(20,"colorDecorators",!0,{description:v.localize(235,null)})),colorDecoratorActivatedOn:Se(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[v.localize(236,null),v.localize(237,null),v.localize(238,null)],description:v.localize(239,null)})),colorDecoratorsLimit:Se(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:v.localize(240,null)})),columnSelection:Se(new s(22,"columnSelection",!1,{description:v.localize(241,null)})),comments:Se(new b),contextmenu:Se(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Se(new s(25,"copyWithSyntaxHighlighting",!0,{description:v.localize(242,null)})),cursorBlinking:Se(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:v.localize(243,null)})),cursorSmoothCaretAnimation:Se(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[v.localize(244,null),v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),cursorStyle:Se(new o(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:v.localize(248,null)})),cursorSurroundingLines:Se(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(249,null)})),cursorSurroundingLinesStyle:Se(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(250,null),v.localize(251,null)],markdownDescription:v.localize(252,null)})),cursorWidth:Se(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(253,null)})),disableLayerHinting:Se(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Se(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Se(new s(34,"domReadOnly",!1)),dragAndDrop:Se(new s(35,"dragAndDrop",!0,{description:v.localize(254,null)})),emptySelectionClipboard:Se(new U),dropIntoEditor:Se(new it),stickyScroll:Se(new re),experimentalWhitespaceRendering:Se(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[v.localize(255,null),v.localize(256,null),v.localize(257,null)],description:v.localize(258,null)})),extraEditorClassName:Se(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Se(new a(40,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:v.localize(259,null)})),find:Se(new z),fixedOverflowWidgets:Se(new s(42,"fixedOverflowWidgets",!1)),folding:Se(new s(43,"folding",!0,{description:v.localize(260,null)})),foldingStrategy:Se(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(261,null),v.localize(262,null)],description:v.localize(263,null)})),foldingHighlight:Se(new s(45,"foldingHighlight",!0,{description:v.localize(264,null)})),foldingImportsByDefault:Se(new s(46,"foldingImportsByDefault",!1,{description:v.localize(265,null)})),foldingMaximumRegions:Se(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:v.localize(266,null)})),unfoldOnClickAfterEndOfLine:Se(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(267,null)})),fontFamily:Se(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(268,null)})),fontInfo:Se(new O),fontLigatures2:Se(new M),fontSize:Se(new j),fontWeight:Se(new Y),fontVariations:Se(new N),formatOnPaste:Se(new s(55,"formatOnPaste",!1,{description:v.localize(269,null)})),formatOnType:Se(new s(56,"formatOnType",!1,{description:v.localize(270,null)})),glyphMargin:Se(new s(57,"glyphMargin",!0,{description:v.localize(271,null)})),gotoLocation:Se(new ne),hideCursorInOverviewRuler:Se(new s(59,"hideCursorInOverviewRuler",!1,{description:v.localize(272,null)})),hover:Se(new ee),inDiffEditor:Se(new s(61,"inDiffEditor",!1)),letterSpacing:Se(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>a.clamp(te,-5,20),{description:v.localize(273,null)})),lightbulb:Se(new fe),lineDecorationsWidth:Se(new B),lineHeight:Se(new ae),lineNumbers:Se(new he),lineNumbersMinChars:Se(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Se(new s(69,"linkedEditing",!1,{description:v.localize(274,null)})),links:Se(new s(70,"links",!0,{description:v.localize(275,null)})),matchBrackets:Se(new c(71,"matchBrackets","always",["always","near","never"],{description:v.localize(276,null)})),minimap:Se(new Ee),mouseStyle:Se(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Se(new a(74,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:v.localize(277,null)})),mouseWheelZoom:Se(new s(75,"mouseWheelZoom",!1,{markdownDescription:$.$j?v.localize(278,null):v.localize(279,null)})),multiCursorMergeOverlapping:Se(new s(76,"multiCursorMergeOverlapping",!0,{description:v.localize(280,null)})),multiCursorModifier:Se(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[v.localize(281,null),v.localize(282,null)],markdownDescription:v.localize(283,null)})),multiCursorPaste:Se(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(284,null),v.localize(285,null)],markdownDescription:v.localize(286,null)})),multiCursorLimit:Se(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:v.localize(287,null)})),occurrencesHighlight:Se(new c(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[v.localize(288,null),v.localize(289,null),v.localize(290,null)],markdownDescription:v.localize(291,null)})),overviewRulerBorder:Se(new s(81,"overviewRulerBorder",!0,{description:v.localize(292,null)})),overviewRulerLanes:Se(new n(82,"overviewRulerLanes",3,0,3)),padding:Se(new de),pasteAs:Se(new lt),parameterHints:Se(new ue),peekWidgetDefaultFocus:Se(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(293,null),v.localize(294,null)],description:v.localize(295,null)})),definitionLinkOpensInPeek:Se(new s(87,"definitionLinkOpensInPeek",!1,{description:v.localize(296,null)})),quickSuggestions:Se(new V),quickSuggestionsDelay:Se(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(297,null)})),readOnly:Se(new s(90,"readOnly",!1)),readOnlyMessage:Se(new pe),renameOnType:Se(new s(92,"renameOnType",!1,{description:v.localize(298,null),markdownDeprecationMessage:v.localize(299,null)})),renderControlCharacters:Se(new s(93,"renderControlCharacters",!0,{description:v.localize(300,null),restricted:!0})),renderFinalNewline:Se(new c(94,"renderFinalNewline",$.$k?"dimmed":"on",["off","on","dimmed"],{description:v.localize(301,null)})),renderLineHighlight:Se(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(302,null)],description:v.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Se(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(304,null)})),renderValidationDecorations:Se(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Se(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(305,null),v.localize(306,null),v.localize(307,null),""],description:v.localize(308,null)})),revealHorizontalRightPadding:Se(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Se(new s(100,"roundedSelection",!0,{description:v.localize(309,null)})),rulers:Se(new Pe),scrollbar:Se(new Me),scrollBeyondLastColumn:Se(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:v.localize(310,null)})),scrollBeyondLastLine:Se(new s(104,"scrollBeyondLastLine",!0,{description:v.localize(311,null)})),scrollPredominantAxis:Se(new s(105,"scrollPredominantAxis",!0,{description:v.localize(312,null)})),selectionClipboard:Se(new s(106,"selectionClipboard",!0,{description:v.localize(313,null),included:$.$k})),selectionHighlight:Se(new s(107,"selectionHighlight",!0,{description:v.localize(314,null)})),selectOnLineNumbers:Se(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Se(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[v.localize(315,null),v.localize(316,null),v.localize(317,null)],description:v.localize(318,null)})),showUnused:Se(new s(110,"showUnused",!0,{description:v.localize(319,null)})),showDeprecated:Se(new s(138,"showDeprecated",!0,{description:v.localize(320,null)})),inlayHints:Se(new J),snippetSuggestions:Se(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(321,null),v.localize(322,null),v.localize(323,null),v.localize(324,null)],description:v.localize(325,null)})),smartSelect:Se(new Re),smoothScrolling:Se(new s(113,"smoothScrolling",!1,{description:v.localize(326,null)})),stopRenderingLineAfter:Se(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Se(new ye),inlineSuggest:Se(new x),inlineCompletionsAccessibilityVerbose:Se(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:v.localize(327,null)})),suggestFontSize:Se(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Se(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Se(new s(120,"suggestOnTriggerCharacters",!0,{description:v.localize(330,null)})),suggestSelection:Se(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(331,null),v.localize(332,null),v.localize(333,null)],description:v.localize(334,null)})),tabCompletion:Se(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(335,null),v.localize(336,null),v.localize(337,null)],description:v.localize(338,null)})),tabIndex:Se(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Se(new W),unusualLineTerminators:Se(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(339,null),v.localize(340,null),v.localize(341,null)],description:v.localize(342,null)})),useShadowDOM:Se(new s(126,"useShadowDOM",!0)),useTabStops:Se(new s(127,"useTabStops",!0,{description:v.localize(343,null)})),wordBreak:Se(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[v.localize(344,null),v.localize(345,null)],description:v.localize(346,null)})),wordSeparators:Se(new t(129,"wordSeparators",A.$ys,{description:v.localize(347,null)})),wordWrap:Se(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(348,null),v.localize(349,null),v.localize(350,null),v.localize(351,null)],description:v.localize(352,null)})),wordWrapBreakAfterCharacters:Se(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Se(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Se(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(353,null)})),wordWrapOverride1:Se(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Se(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Se(new T),defaultColorDecorators:Se(new s(145,"defaultColorDecorators",!1,{markdownDescription:v.localize(354,null)})),pixelRatio:Se(new ge),tabFocusMode:Se(new s(142,"tabFocusMode",!1,{markdownDescription:v.localize(355,null)})),layoutInfo:Se(new X),wrappingInfo:Se(new Xe),wrappingIndent:Se(new Ge),wrappingStrategy:Se(new ce)}}),define(Ce[196],Ie([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Ce[83],Ie([1,0,79,2,169,29,179,196]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Rt=e.$Qt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$Pt=e.$Ot=e.SymbolKinds=e.SymbolTag=e.$Nt=e.$Mt=e.SymbolKind=e.$Lt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Kt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Jt=e.$It=e.$Ht=void 0;class p{constructor(N,O,j){this.offset=N,this.type=O,this.language=j,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ht=p;class k{constructor(N,O){this.tokens=N,this.endState=O,this._tokenizationResultBrand=void 0}}e.$It=k;class R{constructor(N,O){this.tokens=N,this.endState=O,this._encodedTokenizationResultBrand=void 0}}e.$Jt=R;var C;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(M){const N=new Map;N.set(0,I.$ek.symbolMethod),N.set(1,I.$ek.symbolFunction),N.set(2,I.$ek.symbolConstructor),N.set(3,I.$ek.symbolField),N.set(4,I.$ek.symbolVariable),N.set(5,I.$ek.symbolClass),N.set(6,I.$ek.symbolStruct),N.set(7,I.$ek.symbolInterface),N.set(8,I.$ek.symbolModule),N.set(9,I.$ek.symbolProperty),N.set(10,I.$ek.symbolEvent),N.set(11,I.$ek.symbolOperator),N.set(12,I.$ek.symbolUnit),N.set(13,I.$ek.symbolValue),N.set(15,I.$ek.symbolEnum),N.set(14,I.$ek.symbolConstant),N.set(15,I.$ek.symbolEnum),N.set(16,I.$ek.symbolEnumMember),N.set(17,I.$ek.symbolKeyword),N.set(27,I.$ek.symbolSnippet),N.set(18,I.$ek.symbolText),N.set(19,I.$ek.symbolColor),N.set(20,I.$ek.symbolFile),N.set(21,I.$ek.symbolReference),N.set(22,I.$ek.symbolCustomColor),N.set(23,I.$ek.symbolFolder),N.set(24,I.$ek.symbolTypeParameter),N.set(25,I.$ek.account),N.set(26,I.$ek.issues);function O(ne){let ee=N.get(ne);return ee||(console.info("No codicon found for CompletionItemKind "+ne),ee=I.$ek.symbolProperty),ee}M.toIcon=O;const j=new Map;j.set("method",0),j.set("function",1),j.set("constructor",2),j.set("field",3),j.set("variable",4),j.set("class",5),j.set("struct",6),j.set("interface",7),j.set("module",8),j.set("property",9),j.set("event",10),j.set("operator",11),j.set("unit",12),j.set("value",13),j.set("constant",14),j.set("enum",15),j.set("enum-member",16),j.set("enumMember",16),j.set("keyword",17),j.set("snippet",27),j.set("text",18),j.set("color",19),j.set("file",20),j.set("reference",21),j.set("customcolor",22),j.set("folder",23),j.set("type-parameter",24),j.set("typeParameter",24),j.set("account",25),j.set("issue",26);function Y(ne,ee){let Q=j.get(ne);return typeof Q>"u"&&!ee&&(Q=9),Q}M.fromString=Y})(m||(e.CompletionItemKinds=m={}));var E;(function(M){M[M.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var l;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(l||(e.CompletionTriggerKind=l={}));var w;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(w||(e.InlineCompletionTriggerKind=w={}));class s{constructor(N,O,j,Y){this.range=N,this.text=O,this.completionKind=j,this.isSnippetText=Y}equals(N){return L.$Zs.lift(this.range).equalsRange(N.range)&&this.text===N.text&&this.completionKind===N.completionKind&&this.isSnippetText===N.isSnippetText}}e.$Kt=s;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function a(M){return M&&F.URI.isUri(M.uri)&&L.$Zs.isIRange(M.range)&&(L.$Zs.isIRange(M.originSelectionRange)||L.$Zs.isIRange(M.targetSelectionRange))}e.$Lt=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Mt={17:(0,v.localize)(0,null),16:(0,v.localize)(1,null),4:(0,v.localize)(2,null),13:(0,v.localize)(3,null),8:(0,v.localize)(4,null),9:(0,v.localize)(5,null),21:(0,v.localize)(6,null),23:(0,v.localize)(7,null),7:(0,v.localize)(8,null),0:(0,v.localize)(9,null),11:(0,v.localize)(10,null),10:(0,v.localize)(11,null),19:(0,v.localize)(12,null),5:(0,v.localize)(13,null),1:(0,v.localize)(14,null),2:(0,v.localize)(15,null),20:(0,v.localize)(16,null),15:(0,v.localize)(17,null),18:(0,v.localize)(18,null),24:(0,v.localize)(19,null),3:(0,v.localize)(20,null),6:(0,v.localize)(21,null),14:(0,v.localize)(22,null),22:(0,v.localize)(23,null),25:(0,v.localize)(24,null),12:(0,v.localize)(25,null)};function h(M,N){return(0,v.localize)(26,null,M,e.$Mt[N])}e.$Nt=h;var c;(function(M){M[M.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var o;(function(M){const N=new Map;N.set(0,I.$ek.symbolFile),N.set(1,I.$ek.symbolModule),N.set(2,I.$ek.symbolNamespace),N.set(3,I.$ek.symbolPackage),N.set(4,I.$ek.symbolClass),N.set(5,I.$ek.symbolMethod),N.set(6,I.$ek.symbolProperty),N.set(7,I.$ek.symbolField),N.set(8,I.$ek.symbolConstructor),N.set(9,I.$ek.symbolEnum),N.set(10,I.$ek.symbolInterface),N.set(11,I.$ek.symbolFunction),N.set(12,I.$ek.symbolVariable),N.set(13,I.$ek.symbolConstant),N.set(14,I.$ek.symbolString),N.set(15,I.$ek.symbolNumber),N.set(16,I.$ek.symbolBoolean),N.set(17,I.$ek.symbolArray),N.set(18,I.$ek.symbolObject),N.set(19,I.$ek.symbolKey),N.set(20,I.$ek.symbolNull),N.set(21,I.$ek.symbolEnumMember),N.set(22,I.$ek.symbolStruct),N.set(23,I.$ek.symbolEvent),N.set(24,I.$ek.symbolOperator),N.set(25,I.$ek.symbolTypeParameter);function O(j){let Y=N.get(j);return Y||(console.info("No codicon found for SymbolKind "+j),Y=I.$ek.symbolProperty),Y}M.toIcon=O})(o||(e.SymbolKinds=o={}));class u{static asEditOperation(N){return $.$1s.replace(L.$Zs.lift(N.range),N.text)}}e.$Ot=u;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(N){switch(N){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(N)}constructor(N){this.value=N}}e.$Pt=d;var b;(function(M){M[M.AIGenerated=1]="AIGenerated"})(b||(e.NewSymbolNameTag=b={}));var D;(function(M){function N(O){return!O||typeof O!="object"?!1:typeof O.id=="string"&&typeof O.title=="string"}M.is=N})(D||(e.Command=D={}));var g;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(g||(e.CommentThreadCollapsibleState=g={}));var f;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(f||(e.CommentThreadState=f={}));var y;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(y||(e.CommentMode=y={}));var P;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(P||(e.CommentState=P={}));var T;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(T||(e.InlayHintKind=T={}));class U{constructor(N){this.b=N,this.a=null}dispose(){this.a&&this.a.then(N=>{N&&N.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Qt=U,e.$Rt=new A.$yt;var z;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(Ce[197],Ie([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[198],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[199],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[200],Ie([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(Ce[201],Ie([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[202],Ie([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[203],Ie([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[204],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Ce[205],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Ce[206],Ie([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ce[207],Ie([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Ce[208],Ie([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[209],Ie([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[210],Ie([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Ce[211],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[212],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Ce[213],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[214],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[215],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[216],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[217],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[218],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[219],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[220],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[221],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[222],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[223],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[224],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[225],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Ce[226],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Ce[227],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Ce[228],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[229],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[230],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[231],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[232],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[233],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[234],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[235],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[236],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ce[237],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[238],Ie([1,0,14,199]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.TokenType=void 0;var $;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})($||(e.TokenType=$={}));function L(...k){switch(k.length){case 1:return(0,F.localize)(0,null,k[0]);case 2:return(0,F.localize)(1,null,k[0],k[1]);case 3:return(0,F.localize)(2,null,k[0],k[1],k[2]);default:return}}const A=(0,F.localize)(3,null),v=(0,F.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const C=this.d,m=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:R}),this.f.push(E)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const C=this.c.substring(this.d,this.e),m=p.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,C=!1,m=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(v);return}const S=this.c.charCodeAt(R);if(C)C=!1;else if(S===47&&!m){R++;break}else S===91?m=!0:S===92?C=!0:S===93&&(m=!1);R++}for(;R<this.c.length&&p.a.has(this.c.charCodeAt(R));)R++;this.e=R;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$6i=p}),define(Ce[239],Ie([1,0,23,39,202,389]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function p(s){return s=s.trim(),s==="*"||A.test(s)}e.$fp=p;function k(s){if(!p(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(A);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$gp=k;function R(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,r=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let h=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),h=!1);let c=0;if(s.preRelease){const o=v.exec(s.preRelease);if(o){const[,u,d,b]=o;c=Date.UTC(Number(u),Number(d)-1,Number(b))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:h,isMinimum:s.hasGreaterEquals,notBefore:c}}e.$hp=R;function C(s,i,n){let r;typeof s=="string"?r=R(k(s)):r=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=R(k(n)):t=n,!r||!t)return!1;const h=r.majorBase,c=r.minorBase,o=r.patchBase;let u=t.majorBase,d=t.minorBase,b=t.patchBase;const D=t.notBefore;let g=t.majorMustEqual,f=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?h>u?!0:h<u?!1:c>d?!0:c<d||a&&a<D?!1:o>=b:(h===1&&u===0&&(!g||!f||!y)&&(u=1,d=0,b=0,g=!0,f=!1,y=!1),h<u?!1:h>u?!g:c<d?!1:c>d?!f:o<b?!1:o>b?!y:!(a&&a<D))}e.$ip=C;function m(s,i,n,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([F.default.Error,$.localize(0,null)]),t;if(typeof r.name!="string")return t.push([F.default.Error,$.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([F.default.Error,$.localize(2,null,"version")]),t;if(!r.engines)return t.push([F.default.Error,$.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([F.default.Error,$.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!w(r.extensionDependencies))return t.push([F.default.Error,$.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!w(r.activationEvents))return t.push([F.default.Error,$.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([F.default.Error,$.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([F.default.Warning,$.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([F.default.Error,$.localize(9,null,"main")]),t;{const o=(0,I.$Lg)(n,r.main);(0,I.$Fg)(o,n)||t.push([F.default.Warning,$.localize(10,null,o.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([F.default.Error,$.localize(11,null,"browser")]),t;{const o=(0,I.$Lg)(n,r.browser);(0,I.$Fg)(o,n)||t.push([F.default.Warning,$.localize(12,null,o.path,n.path)])}}if(!L.valid(r.version))return t.push([F.default.Error,$.localize(13,null)]),t;const h=[];if(!E(s,i,r,a,h))for(const o of h)t.push([F.default.Error,o]);return t}e.$jp=m;function E(s,i,n,r,a){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:l(s,i,n.engines.vscode,a)}e.$kp=E;function S(s,i,n){return s==="*"||l(i,n,s)}e.$lp=S;function l(s,i,n,r=[]){const a=R(k(n));if(!a)return r.push($.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push($.localize(15,null,n)),!1}else if(!a.majorMustEqual)return r.push($.localize(16,null,n)),!1;return C(s,i,a)?!0:(r.push($.localize(17,null,s,n)),!1)}function w(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Ce[105],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=void 0;class I{constructor($,L=[],A=!1){this.ctor=$,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$8h=I}),define(Ce[84],Ie([1,0,105]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.InstantiationType=void 0;const F=[];var $;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})($||(e.InstantiationType=$={}));function L(v,p,k){p instanceof I.$8h||(p=new I.$8h(p,[],!!k)),F.push([v,p])}e.$4r=L;function A(){return F}e.$5r=A}),define(Ce[240],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=void 0;class I{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Hq=I;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const v=this.lookupOrInsertNode(L),p=this.lookupOrInsertNode(A);v.outgoing.set(p.key,p),p.incoming.set(v.key,v)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const v of this.a.values())v.outgoing.delete(A),v.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let v=this.a.get(A);return v||(v=new I(A,L),this.a.set(A,v)),v}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,v]of this.a)L.push(`${A}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const v=new Set([L]),p=this.c(A,v);if(p)return p}}c(L,A){for(const[v,p]of L.outgoing){if(A.has(v))return[...A,v].join(" -> ");A.add(v);const k=this.c(p,A);if(k)return k;A.delete(v)}}}e.$Iq=F}),define(Ce[5],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e._util=void 0;var I;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function v(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=v})(I||(e._util=I={})),e.$0h=$("instantiationService");function F(A,v,p){v[I.DI_TARGET]===v?v[I.DI_DEPENDENCIES].push({id:A,index:p}):(v[I.DI_DEPENDENCIES]=[{id:A,index:p}],v[I.DI_TARGET]=v)}function $(A){if(I.serviceIds.has(A))return I.serviceIds.get(A);const v=function(p,k,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(v,p,R)};return v.toString=()=>A,I.serviceIds.set(A,v),v}e.$$h=$;function L(A){return A}e.$_h=L}),define(Ce[51],Ie([1,0,18,2,5]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ConfigurationTarget=e.$Gi=e.$Fi=e.$Ei=void 0,e.$Ei=(0,$.$$h)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}e.$Fi=L;function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}e.$Gi=A;var v;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function p(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Hi=p;function k(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Ii=k;function R(s,i){const n=Object.create(null);for(const r in s)C(n,r,s[r],i);return n}e.$Ji=R;function C(s,i,n,r){const a=i.split("."),t=a.pop();let h=s;for(let c=0;c<a.length;c++){const o=a[c];let u=h[o];switch(typeof u){case"undefined":u=h[o]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${a.slice(0,c+1).join(".")} is ${JSON.stringify(u)}`);return}h=u}if(typeof h=="object"&&h!==null)try{h[t]=n}catch{r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}else r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}e.$Ki=C;function m(s,i){const n=i.split(".");E(s,n)}e.$Li=m;function E(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const r=s[n];typeof r=="object"&&!Array.isArray(r)&&(E(r,i),Object.keys(r).length===0&&delete s[n])}}function S(s,i,n){function r(h,c){let o=h;for(const u of c){if(typeof o!="object"||o===null)return;o=o[u]}return o}const a=i.split("."),t=r(s,a);return typeof t>"u"?n:t}e.$Mi=S;function l(s,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in s?I.$Of(s[r])&&I.$Of(i[r])?l(s[r],i[r],n):n&&(s[r]=i[r]):s[r]=i[r])})}e.$Ni=l;function w(s){return s.replace(/[\[\]]/g,"")}e.$Oi=w}),define(Ce[45],Ie([1,0,11,12,238,5,198,14]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.ContextKeyExprType=e.$7i=void 0;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",I.$j),p.set("isLinux",I.$k),p.set("isWindows",I.$i),p.set("isWeb",I.$o),p.set("isMacNative",I.$j&&!I.$o),p.set("isEdge",I.$H),p.set("isFirefox",I.$F),p.set("isChrome",I.$E),p.set("isSafari",I.$G);function k(J,B){if(p.get(J)!==void 0)throw(0,v.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(J,B)}e.$7i=k;const R=Object.prototype.hasOwnProperty;var C;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},E=(0,A.localize)(0,null),S=(0,A.localize)(1,null),l=(0,A.localize)(2,null),w=(0,A.localize)(3,null),s=(0,A.localize)(4,null),i=(0,A.localize)(5,null),n=(0,A.localize)(6,null),r=(0,A.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=m){this.k=B,this.d=new $.$6i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ae=this.l();if(!this.E()){const Ee=this.D(),le=Ee.type===17?i:void 0;throw this.h.push({message:s,offset:Ee.offset,lexeme:$.$6i.getLexeme(Ee),additionalInfo:le}),a.c}return ae}catch(ae){if(ae!==a.c)throw ae;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ae=this.o();B.push(ae)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ae=this.s();B.push(ae)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ae=this.l();return this.A(1,w),ae?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ae=this.l();return this.A(1,w),ae}case 17:{const ae=B.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const de=le.lexeme,ue=de.lastIndexOf("/"),ge=ue===de.length-1?void 0:this.w(de.substring(ue+1));let V;try{V=new RegExp(de.substring(1,ue),ge)}catch{throw this.B("REGEX",le)}return O.create(ae,V)}switch(le.type){case 10:case 19:{const de=[le.lexeme];this.z();let ue=this.D(),ge=0;for(let Pe=0;Pe<le.lexeme.length;Pe++)le.lexeme.charCodeAt(Pe)===40?ge++:le.lexeme.charCodeAt(Pe)===41&&ge--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Pe=0;Pe<ue.lexeme.length;Pe++)ue.lexeme.charCodeAt(Pe)===40?ge++:le.lexeme.charCodeAt(Pe)===41&&ge--}if(ge<0)break;de.push($.$6i.getLexeme(ue)),this.z(),ue=this.D()}const V=de.join(""),Z=V.lastIndexOf("/"),he=Z===V.length-1?void 0:this.w(V.substring(Z+1));let be;try{be=new RegExp(V.substring(1,Z),he)}catch{throw this.B("REGEX",le)}return t.regex(ae,be)}case 18:{const de=le.lexeme;this.z();let ue=null;if(!(0,F.$Me)(de)){const ge=de.indexOf("/"),V=de.lastIndexOf("/");if(ge!==V&&ge>=0){const Z=de.slice(ge+1,V),he=de[V+1]==="i"?"i":"";try{ue=new RegExp(Z,he)}catch{throw this.B("REGEX",le)}}}if(ue===null)throw this.B("REGEX",le);return O.create(ae,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const le=this.u();return t.notIn(ae,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(ae,le);switch(le){case"true":return t.has(ae);case"false":return t.not(ae);default:return t.equals(ae,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(ae,le);switch(le){case"true":return t.not(ae);case"false":return t.has(ae);default:return t.notEquals(ae,le)}}case 5:return this.z(),M.create(ae,this.u());case 6:return this.z(),N.create(ae,this.u());case 7:return this.z(),U.create(ae,this.u());case 8:return this.z(),z.create(ae,this.u());case 13:return this.z(),t.in(ae,this.u());default:return t.has(ae)}}case 20:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:r}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ae){if(this.C(B))return this.z();throw this.B(ae,this.D())}B(B,ae,Ee){const le=(0,A.localize)(8,null,B,$.$6i.getLexeme(ae)),de=ae.offset,ue=$.$6i.getLexeme(ae);return this.h.push({message:le,offset:de,lexeme:ue,additionalInfo:Ee}),a.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$8i=a;class t{static false(){return u.INSTANCE}static true(){return d.INSTANCE}static has(B){return b.create(B)}static equals(B,ae){return D.create(B,ae)}static notEquals(B,ae){return y.create(B,ae)}static regex(B,ae){return O.create(B,ae)}static in(B,ae){return g.create(B,ae)}static notIn(B,ae){return f.create(B,ae)}static not(B){return P.create(B)}static and(...B){return ne.create(B,null,!0)}static or(...B){return ee.create(B,null,!0)}static greater(B,ae){return U.create(B,ae)}static greaterEquals(B,ae){return z.create(B,ae)}static smaller(B,ae){return M.create(B,ae)}static smallerEquals(B,ae){return N.create(B,ae)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$9i=t;function h(J){const B=new a({regexParsingWithErrorRecovery:!1});return J.map(ae=>(B.parse(ae),B.lexingErrors.length>0?B.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,A.localize)(9,null,Ee.additionalInfo):(0,A.localize)(10,null),offset:Ee.offset,length:Ee.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}e.$0i=h;function c(J,B){const ae=J?J.substituteConstants():void 0,Ee=B?B.substituteConstants():void 0;return!ae&&!Ee?!0:!ae||!Ee?!1:ae.equals(Ee)}e.$$i=c;function o(J,B){return J.cmp(B)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return d.INSTANCE}}e.$_i=u;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return u.INSTANCE}}e.$aj=d;class b{static create(B,ae=null){const Ee=p.get(B);return typeof Ee=="boolean"?Ee?d.INSTANCE:u.INSTANCE:new b(B,ae)}constructor(B,ae){this.key=B,this.c=ae,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:X(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=p.get(this.key);return typeof B=="boolean"?B?d.INSTANCE:u.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$bj=b;class D{static create(B,ae,Ee=null){if(typeof ae=="boolean")return ae?b.create(B,Ee):P.create(B,Ee);const le=p.get(B);return typeof le=="boolean"?ae===(le?"true":"false")?d.INSTANCE:u.INSTANCE:new D(B,ae,Ee)}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=p.get(this.c);if(typeof B=="boolean"){const ae=B?"true":"false";return this.d===ae?d.INSTANCE:u.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$cj=D;class g{static create(B,ae){return new g(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ae=B.getValue(this.f),Ee=B.getValue(this.d);return Array.isArray(ae)?ae.includes(Ee):typeof Ee=="string"&&typeof ae=="object"&&ae!==null?R.call(ae,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$dj=g;class f{static create(B,ae){return new f(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=11,this.c=g.create(B,ae)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$ej=f;class y{static create(B,ae,Ee=null){if(typeof ae=="boolean")return ae?P.create(B,Ee):b.create(B,Ee);const le=p.get(B);return typeof le=="boolean"?ae===(le?"true":"false")?u.INSTANCE:d.INSTANCE:new y(B,ae,Ee)}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=p.get(this.c);if(typeof B=="boolean"){const ae=B?"true":"false";return this.d===ae?u.INSTANCE:d.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$fj=y;class P{static create(B,ae=null){const Ee=p.get(B);return typeof Ee=="boolean"?Ee?u.INSTANCE:d.INSTANCE:new P(B,ae)}constructor(B,ae){this.c=B,this.d=ae,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:X(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=p.get(this.c);return typeof B=="boolean"?B?u.INSTANCE:d.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$gj=P;function T(J,B){if(typeof J=="string"){const ae=parseFloat(J);isNaN(ae)||(J=ae)}return typeof J=="string"||typeof J=="number"?B(J):u.INSTANCE}class U{static create(B,ae,Ee=null){return T(ae,le=>new U(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$hj=U;class z{static create(B,ae,Ee=null){return T(ae,le=>new z(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$ij=z;class M{static create(B,ae,Ee=null){return T(ae,le=>new M(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$jj=M;class N{static create(B,ae,Ee=null){return T(ae,le=>new N(B,le,Ee))}constructor(B,ae,Ee){this.c=B,this.d=ae,this.f=Ee,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$kj=N;class O{static create(B,ae){return new O(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ae=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return ae<Ee?-1:ae>Ee?1:0}equals(B){if(B.type===this.type){const ae=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return this.d===B.d&&ae===Ee}return!1}substituteConstants(){return this}evaluate(B){const ae=B.getValue(this.d);return this.f?this.f.test(ae):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=j.create(this)),this.c}}e.$lj=O;class j{static create(B){return new j(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new j(this.c.map(B))}negate(){return this.c}}e.$mj=j;function Y(J){let B=null;for(let ae=0,Ee=J.length;ae<Ee;ae++){const le=J[ae].substituteConstants();if(J[ae]!==le&&B===null){B=[];for(let de=0;de<ae;de++)B[de]=J[de]}B!==null&&(B[ae]=le)}return B===null?J:B}class ne{static create(B,ae,Ee){return ne.d(B,ae,Ee)}constructor(B,ae){this.expr=B,this.c=ae,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++){const le=o(this.expr[ae],B.expr[ae]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(!this.expr[ae].equals(B.expr[ae]))return!1;return!0}return!1}substituteConstants(){const B=Y(this.expr);return B===this.expr?this:ne.create(B,this.c,!1)}evaluate(B){for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(!this.expr[ae].evaluate(B))return!1;return!0}static d(B,ae,Ee){const le=[];let de=!1;for(const ue of B)if(ue){if(ue.type===1){de=!0;continue}if(ue.type===0)return u.INSTANCE;if(ue.type===6){le.push(...ue.expr);continue}le.push(ue)}if(le.length===0&&de)return d.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(o);for(let ue=1;ue<le.length;ue++)le[ue-1].equals(le[ue])&&(le.splice(ue,1),ue--);if(le.length===1)return le[0];for(;le.length>1;){const ue=le[le.length-1];if(ue.type!==9)break;le.pop();const ge=le.pop(),V=le.length===0,Z=ee.create(ue.expr.map(he=>ne.create([he,ge],null,Ee)),null,V);Z&&(le.push(Z),le.sort(o))}if(le.length===1)return le[0];if(Ee){for(let ue=0;ue<le.length;ue++)for(let ge=ue+1;ge<le.length;ge++)if(le[ue].negate().equals(le[ge]))return u.INSTANCE;if(le.length===1)return le[0]}return new ne(le,ae)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ae of this.expr)B.push(...ae.keys());return B}map(B){return new ne(this.expr.map(ae=>ae.map(B)),null)}negate(){if(!this.c){const B=[];for(const ae of this.expr)B.push(ae.negate());this.c=ee.create(B,this,!0)}return this.c}}e.$nj=ne;class ee{static create(B,ae,Ee){return ee.d(B,ae,Ee)}constructor(B,ae){this.expr=B,this.c=ae,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++){const le=o(this.expr[ae],B.expr[ae]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(!this.expr[ae].equals(B.expr[ae]))return!1;return!0}return!1}substituteConstants(){const B=Y(this.expr);return B===this.expr?this:ee.create(B,this.c,!1)}evaluate(B){for(let ae=0,Ee=this.expr.length;ae<Ee;ae++)if(this.expr[ae].evaluate(B))return!0;return!1}static d(B,ae,Ee){let le=[],de=!1;if(B){for(let ue=0,ge=B.length;ue<ge;ue++){const V=B[ue];if(V){if(V.type===0){de=!0;continue}if(V.type===1)return d.INSTANCE;if(V.type===9){le=le.concat(V.expr);continue}le.push(V)}}if(le.length===0&&de)return u.INSTANCE;le.sort(o)}if(le.length!==0){if(le.length===1)return le[0];for(let ue=1;ue<le.length;ue++)le[ue-1].equals(le[ue])&&(le.splice(ue,1),ue--);if(le.length===1)return le[0];if(Ee){for(let ue=0;ue<le.length;ue++)for(let ge=ue+1;ge<le.length;ge++)if(le[ue].negate().equals(le[ge]))return d.INSTANCE;if(le.length===1)return le[0]}return new ee(le,ae)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ae of this.expr)B.push(...ae.keys());return B}map(B){return new ee(this.expr.map(ae=>ae.map(B)),null)}negate(){if(!this.c){const B=[];for(const ae of this.expr)B.push(ae.negate());for(;B.length>1;){const ae=B.shift(),Ee=B.shift(),le=[];for(const de of re(ae))for(const ue of re(Ee))le.push(ne.create([de,ue],null,!1));B.unshift(ee.create(le,null,!1))}this.c=ee.create(B,this,!0)}return this.c}}e.$oj=ee;class Q extends b{static{this.d=[]}static all(){return Q.d.values()}constructor(B,ae,Ee){super(B,null),this.f=ae,typeof Ee=="object"?Q.d.push({...Ee,key:B}):Ee!==!0&&Q.d.push({key:B,description:Ee,type:ae!=null?typeof ae:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return y.create(this.key,B)}}e.$pj=Q,e.$qj=(0,L.$$h)("contextKeyService");function X(J,B){return J<B?-1:J>B?1:0}function ce(J,B,ae,Ee){return J<ae?-1:J>ae?1:B<Ee?-1:B>Ee?1:0}function ie(J,B){if(J.type===0||B.type===1)return!0;if(J.type===9)return B.type===9?fe(J.expr,B.expr):!1;if(B.type===9){for(const ae of B.expr)if(ie(J,ae))return!0;return!1}if(J.type===6){if(B.type===6)return fe(B.expr,J.expr);for(const ae of J.expr)if(ie(ae,B))return!0;return!1}return J.equals(B)}e.$rj=ie;function fe(J,B){let ae=0,Ee=0;for(;ae<J.length&&Ee<B.length;){const le=J[ae].cmp(B[Ee]);if(le<0)return!1;le===0&&ae++,Ee++}return ae===J.length}function re(J){return J.type===9?J.expr:[J]}}),define(Ce[241],Ie([1,0,23,39,200,5,102,11,24]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=e.$bw=e.ConfirmResult=e.$aw=e.$_v=e.$$v=void 0,e.$$v=(0,L.$$h)("dialogService");var k;(function(l){l[l.Confirmation=1]="Confirmation",l[l.Prompt=2]="Prompt",l[l.Input=3]="Input"})(k||(k={}));class R{a(w){return this.d(w,k.Confirmation)}b(w){return this.d(w,k.Prompt)}c(w){return this.d(w,k.Input)}d(w,s){const i=[];switch(s){case k.Confirmation:{const n=w;n.primaryButton?i.push(n.primaryButton):i.push((0,$.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,$.localize)(1,null));break}case k.Prompt:{const n=w;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,$.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,$.localize)(3,null))),i.length===0&&i.push((0,$.localize)(4,null));break}case k.Input:{const n=w;n.primaryButton?i.push(n.primaryButton):i.push((0,$.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,$.localize)(6,null));break}}return i}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===F.default.Info?"info":w===F.default.Error?"error":w===F.default.Warning?"warning":"none"}f(w,s,i){const n=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&n.push(w.cancelButton);let r=n[s]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$_v=R,e.$aw=(0,L.$$h)("fileDialogService");var C;(function(l){l[l.SAVE=0]="SAVE",l[l.DONT_SAVE=1]="DONT_SAVE",l[l.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function E(l){const w=[];return w.push(...l.slice(0,m).map(s=>typeof s=="string"?s:(0,I.$Ig)(s))),l.length>m&&(l.length-m===1?w.push((0,$.localize)(7,null)):w.push((0,$.localize)(8,null,l.length-m))),w.push(""),w.join(`
`)}e.$bw=E;function S(l,w){const s=(0,p.$Bn)(l);let i=(s.buttons??[]).map(t=>(0,A.$8v)(t)),n=(l.buttons||[]).map((t,h)=>h),r=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(v.$k||v.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const h=n[a];n.splice(a,1),n.splice(1,0,h),a=1}v.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(a=r-1))}else if(v.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const h=n[a];n.splice(a,1),n.push(h),a=i.length-1}}return s.buttons=i,s.defaultId=r,s.cancelId=a,s.noLink=!0,s.title=s.title||w.nameLong,{options:s,buttonIndeces:n}}e.$cw=S}),define(Ce[133],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=void 0,e.$fi=(0,I.$$h)("environmentService"),e.$gi=(0,I.$_h)(e.$fi)}),define(Ce[134],Ie([1,0,201,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.ExtensionGalleryErrorCode=e.$Fo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Eo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=void 0,e.$so="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$to=new RegExp(e.$so),e.$uo="__web_extension",e.$vo="skipWalkthrough",e.$wo="extensionsSync",e.$xo="dependecyOrPackExtensionInstall";function $(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$yo=$;function L(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$zo=L;function A(n,r){switch(n){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ao=A;function v(n,r){return r==="web"&&!n.includes("web")}e.$Bo=v;function p(n,r,a){return v(r,a)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===a}e.$Co=p;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Do=k;var R;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var C;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(n){n.Install="install",n.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var E;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Eo=(0,F.$$h)("extensionGalleryService");var S;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var l;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class w extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$Fo=w;var s;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class i extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$Go=i,e.$Ho=(0,F.$$h)("extensionManagementService"),e.$Io="extensionsIdentifiers/disabled",e.$Jo="extensionsIdentifiers/enabled",e.$Ko=(0,F.$$h)("IGlobalExtensionEnablementService"),e.$Lo=(0,F.$$h)("IExtensionTipsService"),e.$Mo=(0,I.localize2)(0,"Extensions"),e.$No=(0,I.localize2)(1,"Preferences")}),define(Ce[242],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E3b=e.$D3b=void 0,e.$D3b=(0,I.$$h)("externalTerminal"),e.$E3b="Terminal.app"}),define(Ce[243],Ie([1,0,50,52,16,17,11,101,31,104,203,242]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=e.$z$b=e.$y$b=void 0;const m=R.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends E{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(I,a,k.$Yl(),t)}spawnTerminal(a,t,h,c){const o=t.windowsExec||S.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const u=L.$nc(o,".exe").toLowerCase();if(u==="cmder")return a.spawn(o,c?[c]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return o.indexOf(" ")>=0&&d.push('""'),d.push(o),u==="wt"&&d.push("-d ."),new Promise((b,D)=>{const g=s(process),f=a.spawn(h,d,{cwd:c,env:g,detached:!0});f.on("error",D),f.on("exit",()=>b())})}async runInTerminal(a,t,h,c,o){const u="windowsExec"in o&&o.windowsExec?o.windowsExec:S.getDefaultTerminalWindows(),d=await S.f();return new Promise((b,D)=>{const g=`"${t} - ${m}"`,f=`""${h.join('" "')}" & pause"`,y=Object.assign({},s(process),c);Object.keys(y).filter(M=>y[M]===null).forEach(M=>delete y[M]);const P={cwd:t,env:y,windowsVerbatimArguments:!0};let T,U;L.$nc(u,".exe")==="wt"?(T=u,U=["-d",".",S.b,"/c",f]):d?(T=d,U=["-d",t||".",u,"/c",f]):(T=S.b,U=["/c","start",g,"/wait",u,"/c",f]),I.spawn(T,U,P).on("error",M=>{D(i(M))}),b(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const a=await k.win32.findExecutable("wt");return await p.Promises.exists(a)?a:void 0}catch{return}}}e.$y$b=S,Je([F.$Ch],S,"f",null);class l extends E{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,h,c,o){const u=o.osxExec||C.$E3b;return new Promise((d,b)=>{if(u===C.$E3b||u==="iTerm.app"){const D=u===C.$E3b?"TerminalHelper":"iTermHelper",f=[$.$sg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",a||m,"-w",t];for(const T of h)f.push("-a"),f.push(T);if(c){const T=Object.assign({},s(process),c);for(const U in T){const z=T[U];z===null?(f.push("-u"),f.push(U)):(f.push("-e"),f.push(`${U}=${z}`))}}let y="";const P=I.spawn(l.b,f);P.on("error",T=>{b(i(T))}),P.stderr.on("data",T=>{y+=T.toString()}),P.on("exit",T=>{if(T===0)d(void 0);else if(y){const U=y.split(`
`,1);b(new Error(U[0]))}else b(new Error(R.localize(1,null,D,T)))})}else b(new Error(R.localize(2,null,u)))})}spawnTerminal(a,t,h){const c=t.osxExec||C.$E3b;return new Promise((o,u)=>{const d=["-a",c];h&&d.push(h);const b=s(process),D=a.spawn("/usr/bin/open",d,{cwd:h,env:b});D.on("error",u),D.on("exit",()=>o())})}}e.$z$b=l;class w extends E{static{this.b=R.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,h,c,o){const u=o.linuxExec?Promise.resolve(o.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,b)=>{const D=[];u.then(g=>{g.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const f=`${n(h)}; echo; read -p "${w.b}" -n1;`;D.push(`''${f}''`);const y=Object.assign({},s(process),c);Object.keys(y).filter(z=>y[z]===null).forEach(z=>delete y[z]);const P={cwd:t,env:y};let T="";const U=I.spawn(g,D,P);U.on("error",z=>{b(i(z))}),U.stderr.on("data",z=>{T+=z.toString()}),U.on("exit",z=>{if(z===0)d(void 0);else if(T){const M=T.split(`
`,1);b(new Error(M[0]))}else b(new Error(R.localize(4,null,g,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!A.$k)w.d=Promise.resolve("xterm");else{const a=await p.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,h){const c=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((o,u)=>{c.then(d=>{const b=s(process),D=a.spawn(d,[],{cwd:h,env:b});D.on("error",u),D.on("exit",()=>o())})})}}e.$A$b=w;function s(r){const a={...r.env};return(0,v.$Wl)(a),a}function i(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(R.localize(5,null,r.path)):r}function n(r){let a="";for(const t of r)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(Ce[32],Ie([1,0,78,17,12,18,2,204,5,11,16,43]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.FileKind=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.FileOperationResult=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileChangeType=e.$Nk=e.FileOperation=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileSystemProviderErrorCode=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileSystemProviderCapabilities=e.$xk=e.FilePermission=e.FileType=e.$wk=e.$vk=void 0,e.$vk=(0,p.$$h)("fileService");function m(ie){return ie.create===!0}e.$wk=m;var E;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var S;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function l(ie){const fe=ie;return!!fe&&typeof fe.onDidChange=="function"}e.$xk=l;var w;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function s(ie){return!!(ie.capabilities&2)}e.$yk=s;function i(ie){return!!(ie.capabilities&8)}e.$zk=i;function n(ie){return!!(ie.capabilities&131072)}e.$Ak=n;function r(ie){return!!(ie.capabilities&4)}e.$Bk=r;function a(ie){return!!(ie.capabilities&16)}e.$Ck=a;function t(ie){return s(ie)?!!(ie.capabilities&16384):!1}e.$Dk=t;function h(ie){return s(ie)?!!(ie.capabilities&32768):!1}e.$Ek=h;function c(ie){return!!(ie.capabilities&65536)}e.$Fk=c;function o(ie){return!!(ie.capabilities&2048)}e.$Gk=o;var u;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class d extends Error{static create(fe,re){const J=new d(fe.toString(),re);return g(J,re),J}constructor(fe,re){super(fe),this.code=re}}e.$Hk=d;function b(ie,fe){return d.create(ie,fe)}e.$Ik=b;function D(ie){return ie||b((0,v.localize)(0,null),u.Unknown)}e.$Jk=D;function g(ie,fe){return ie.name=fe?`${fe} (FileSystemError)`:"FileSystemError",ie}e.$Kk=g;function f(ie){if(!ie)return u.Unknown;if(ie instanceof d)return ie.code;const fe=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!fe)return u.Unknown;switch(fe[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.$Lk=f;function y(ie){if(ie instanceof N)return ie.fileOperationResult;switch(f(ie)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}e.$Mk=y;var P;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class T{constructor(fe,re,J){this.resource=fe,this.operation=re,this.target=J}isOperation(fe){return this.operation===fe}}e.$Nk=T;var U;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class z{static{this.a=null}constructor(fe,re){this.c=re,this.b=void 0,this.d=new C.$V(()=>{const J=I.$ei.forUris(()=>this.c);return J.fill(this.rawAdded.map(B=>[B,!0])),J}),this.f=new C.$V(()=>{const J=I.$ei.forUris(()=>this.c);return J.fill(this.rawUpdated.map(B=>[B,!0])),J}),this.g=new C.$V(()=>{const J=I.$ei.forUris(()=>this.c);return J.fill(this.rawDeleted.map(B=>[B,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of fe){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==z.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(fe,...re){return this.h(fe,{includeChildren:!1},...re)}affects(fe,...re){return this.h(fe,{includeChildren:!0},...re)}h(fe,re,...J){if(!fe)return!1;const B=J.length>0;return!!((!B||J.includes(1))&&(this.d.value.get(fe)||re.includeChildren&&this.d.value.findSuperstr(fe))||(!B||J.includes(0))&&(this.f.value.get(fe)||re.includeChildren&&this.f.value.findSuperstr(fe))||(!B||J.includes(2))&&(this.g.value.findSubstr(fe)||re.includeChildren&&this.g.value.findSuperstr(fe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(fe){return this.b===fe}hasCorrelation(){return typeof this.b=="number"}}e.$Ok=z;function M(ie,fe,re){return!ie||!fe||ie===fe||fe.length>ie.length?!1:(fe.charAt(fe.length-1)!==F.sep&&(fe+=F.sep),re?(0,$.$ef)(ie,fe):ie.indexOf(fe)===0)}e.$Pk=M;class N extends Error{constructor(fe,re,J){super(fe),this.fileOperationResult=re,this.options=J}}e.$Qk=N;class O extends N{constructor(fe,re,J,B){super(fe,re,B),this.fileOperationResult=re,this.size=J}}e.$Rk=O;class j extends N{constructor(fe,re,J){super(fe,2,J),this.stat=re}}e.$Sk=j;var Y;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Vk="files.associations",e.$Wk="files.exclude",e.$Xk="files.readonlyInclude",e.$Yk="files.readonlyExclude",e.$Zk="files.readonlyFromPermissions";var ne;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.$1k="";function ee(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$2k=ee;async function Q(ie,fe){if(!fe.hasProvider(A.URI.from({scheme:ie.scheme})))return new Promise(re=>{const J=fe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ie.scheme&&B.added&&(J.dispose(),re())})})}e.$3k=Q;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(fe){return(0,L.$Qf)(fe)||(fe=0),fe<X.KB?(0,v.localize)(1,null,fe.toFixed(0)):fe<X.MB?(0,v.localize)(2,null,(fe/X.KB).toFixed(2)):fe<X.GB?(0,v.localize)(3,null,(fe/X.MB).toFixed(2)):fe<X.TB?(0,v.localize)(4,null,(fe/X.GB).toFixed(2)):(0,v.localize)(5,null,(fe/X.TB).toFixed(2))}}e.$4k=X;function ce(ie){const fe=typeof ie=="string"||ie?.scheme===R.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===R.Schemas.file?1024*X.MB:fe?10*X.MB:k.$o?50*X.MB:1024*X.MB}e.$5k=ce}),define(Ce[244],Ie([1,0,21,14,205,32]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;async function A(R,C,m,E,S,l){let w;try{await v(R,C,m,E,S,l)}catch(s){w=s}finally{w&&S.errorTransformer&&(w=S.errorTransformer(w)),typeof w<"u"&&m.error(w),m.end()}}e.$gq=A;async function v(R,C,m,E,S,l){p(l);const w=await R.open(C,{create:!1});try{p(l);let s=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,r=I.$me.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await R.read(w,a,r.buffer,t,r.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await m.write(E(r)),r=I.$me.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&p(l)&&k(s,S));if(t>0){let h=t;typeof n=="number"&&(h=Math.min(t,n)),m.write(E(r.slice(0,h)))}}catch(s){throw(0,L.$Jk)(s)}finally{await R.close(w)}}function p(R){if(R.isCancellationRequested)throw(0,F.$6)();return!0}function k(R,C){if(typeof C?.limits?.size=="number"&&R>C.limits.size)throw(0,L.$Ik)((0,$.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[85],Ie([1,0,35,3,17,11,2,32]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=void 0;function p(s){return s.recursive===!0}e.$iq=p;class k extends F.$Tc{static{this.a=5}constructor(i,n,r,a){super(),this.h=i,this.j=n,this.m=r,this.n=a,this.c=this.B(new F.$Uc),this.f=void 0,this.g=0}s(){const i=new F.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<k.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$jq=k;class R extends k{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$kq=R;class C extends k{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$lq=C;function m(s){return s.map(i=>({type:i.type,resource:A.URI.revive(i.resource),cId:i.cId}))}e.$mq=m;function E(s){const i=new w;for(const n of s)i.processEvent(n);return i.coalesce()}e.$nq=E;function S(s,i){return typeof i=="string"&&!i.startsWith(I.$Nj)&&!(0,$.$ic)(i)?{base:s,pattern:i}:i}e.$oq=S;function l(s,i){const n=[];for(const r of i)n.push((0,I.$Rj)(S(s,r)));return n}e.$pq=l;class w{constructor(){this.a=new Set,this.b=new Map}c(i){return L.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>n.some(a=>(0,v.$Pk)(r.resource.fsPath,a,!L.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(Ce[245],Ie([1,0,57,8,22,34,3,77,17,11,23,2,103,31,85]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class l extends A.$Tc{static{this.a=100}static{this.b=75}constructor(i,n,r,a){super(),this.m=i,this.n=n,this.r=r,this.s=a,this.c=this.B(new F.$nh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new F.$mh(t=>this.z(t),l.b)),this.g=(0,S.$pq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$pq)(this.m.path,this.m.includes):void 0,this.j=new $.$9d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await E.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await E.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$zq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(k.$j&&(0,L.$_f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Tc.None;const r=new $.$9d(this.j.token),a=new A.$Sc;try{const t=C.URI.file(this.m.path),h=(0,p.$nc)(i),c=(0,I.watch)(i);a.add((0,A.$Rc)(()=>{c.removeAllListeners(),c.close()})),this.G(`Started watching: '${i}'`);const o=new Set;if(n)try{for(const d of await E.Promises.readdir(i))o.add(d)}catch(d){this.D(d)}const u=new Map;a.add((0,A.$Rc)(()=>{for(const[,d]of u)d.dispose();u.clear()})),c.on("error",(d,b)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${d}, ${b})`),this.dispose()}),c.on("change",(d,b)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${d}"] ${b}`);let D="";if(b&&(D=b.toString(),k.$j&&(D=(0,v.$Ll)(D))),!(!D||d!=="change"&&d!=="rename"))if(n)if(d==="rename"){u.get(D)?.dispose();const g=setTimeout(async()=>{if(u.delete(D),D===h&&!await E.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,p.$jc)(i,D));if(r.token.isCancellationRequested)return;let y;f?o.has(D)?y=0:(y=1,o.add(D)):(o.delete(D),y=2),this.y({resource:(0,R.$Lg)(t,D),type:y,cId:this.m.correlationId})},l.a);u.set(D,(0,A.$Rc)(()=>clearTimeout(g)))}else{let g;o.has(D)?g=0:(g=1,o.add(D)),this.y({resource:(0,R.$Lg)(t,D),type:g,cId:this.m.correlationId})}else if(d==="rename"||D!==h){const g=setTimeout(async()=>{const f=await E.Promises.exists(i);r.token.isCancellationRequested||(f?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},l.a);a.clear(),a.add((0,A.$Rc)(()=>clearTimeout(g)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await E.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Rc)(()=>{r.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$nq)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(k.$k)return E.Promises.exists(i);try{const n=(0,p.$nc)(i);return(await E.Promises.readdir((0,p.$mc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Cq=l;async function w(s,i,n,r,a=512){const t=await E.Promises.open(s,"r"),h=Buffer.allocUnsafe(a),c=new $.$9d(r);let o,u=!1;const d={path:s,excludes:[],recursive:!1},b=new l(d,D=>{(async()=>{for(const{type:g}of D)if(g===0){if(u)return;u=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:f}=await E.Promises.read(t,h,0,a,null);if(!f||c.token.isCancellationRequested)break;i(h.slice(0,f))}}catch(f){o=new Error(f),c.dispose(!0)}finally{u=!1}}})()});return await b.ready,n(),new Promise((D,g)=>{c.token.onCancellationRequested(async()=>{b.dispose();try{await E.Promises.close(t)}catch(f){o=new Error(f)}o?g(o):D()})})}e.$Dq=w}),define(Ce[246],Ie([1,0,4,35,3,11,245]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class v extends $.$Tc{constructor(){super(...arguments),this.a=this.B(new I.$Yd),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$Yd),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(k){const R=this.j(k),C=R.filter(E=>{const S=this.c.get(E.path);return S?!(0,F.$Vj)(S.request.excludes,E.excludes)||!(0,F.$Vj)(S.request.includes,E.includes):!0}),m=Array.from(this.c.values()).filter(({request:E})=>!R.find(S=>S.path===E.path&&(0,F.$Vj)(S.excludes,E.excludes)&&(0,F.$Vj)(S.includes,E.includes))).map(({request:E})=>E.path);C.length&&this.m(`Request to start watching: ${C.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const E of m)this.h(E);for(const E of C)this.g(E)}g(k){const R=new A.$Cq(k,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:k,instance:R};this.c.set(k.path,C)}async stop(){for(const[k]of this.c)this.h(k);this.c.clear()}h(k){const R=this.c.get(k);R&&(this.c.delete(k),R.instance.dispose())}j(k){const R=new Map;for(const C of k){const m=L.$k?C.path:C.path.toLowerCase();let E=R.get(C.correlationId);E||(E=new Map,R.set(C.correlationId,E)),E.set(m,C)}return Array.from(R.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(k){this.f=k;for(const[,R]of this.c)R.instance.setVerboseLogging(k)}m(k){this.f&&this.b.fire({type:"trace",message:this.n(k)})}n(k,R){return R?`[File Watcher (node.js)] ${k} (path: ${R.request.path})`:`[File Watcher (node.js)] ${k}`}}e.$Eq=v}),define(Ce[247],Ie([1,0,85,246]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class $ extends I.$kq{constructor(A,v,p){super(A,v,p),this.s()}r(A){return A.add(new F.$Eq)}}e.$Fq=$}),define(Ce[248],Ie([1,0,16,81,188,85]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;class A extends L.$lq{constructor(p,k,R){super(p,k,R),this.s()}r(p){const k=p.add(new $.$wq(I.$sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(k.onDidProcessExit(({code:R,signal:C})=>this.t(`terminated by itself with code ${R}, signal: ${C}`))),F.ProxyChannel.toService((0,F.$Rh)(k.getChannel("watcher")))}}e.$xq=A}),define(Ce[106],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=void 0;class I{constructor(...$){this.a=new Map;for(const[L,A]of $)this.set(L,A)}set($,L){const A=this.a.get($);return this.a.set($,L),A}has($){return this.a.has($)}get($){return this.a.get($)}}e.$9h=I}),define(Ce[249],Ie([1,0,8,14,3,105,240,5,106,76]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;const R=!1;class C extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class m{constructor(w=new p.$9h,s=!1,i,n=R){this.f=w,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(v.$0h,this),this._globalGraph=n?i?._globalGraph??new A.$Iq(r=>r):void 0}createChild(w){return new m(w,this.g,this,this.i)}invokeFunction(w,...s){const i=S.traceInvocation(this.i,w);let n=!1;try{return w({get:a=>{if(n)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(w,...s){let i,n;return w instanceof L.$8h?(i=S.traceCreation(this.i,w.ctor),n=this.j(w.ctor,w.staticArguments.concat(s),i)):(i=S.traceCreation(this.i,w),n=this.j(w,s,i)),i.stop(),n}j(w,s=[],i){const n=v._util.getServiceDependencies(w).sort((t,h)=>t.index-h.index),r=[];for(const t of n){const h=this.m(t.id,i);h||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(h)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(w,s.concat(r))}k(w,s){if(this.f.get(w)instanceof L.$8h)this.f.set(w,s);else if(this.h)this.h.k(w,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const s=this.f.get(w);return!s&&this.h?this.h.l(w):s}m(w,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const i=this.l(w);return i instanceof L.$8h?this.q(w,i,s.branch(w,!0)):(s.branch(w,!1),i)}q(w,s,i){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,s,i)}finally{this.o.delete(w)}}r(w,s,i){const n=new A.$Iq(t=>t.id.toString());let r=0;const a=[{id:w,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new C(n);for(const h of v._util.getServiceDependencies(t.desc.ctor)){const c=this.l(h.id);if(c||this.u(`[createInstance] ${w} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),c instanceof L.$8h){const o={id:h.id,desc:c,_trace:t._trace.branch(h.id,!0)};n.insertEdge(t,o),a.push(o)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:h}of t){if(this.l(h.id)instanceof L.$8h){const o=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,o)}n.removeNode(h)}}return this.l(w)}s(w,s,i=[],n,r){if(this.f.get(w)instanceof L.$8h)return this.t(w,s,i,n,r);if(this.h)return this.h.s(w,s,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(w,s,i=[],n,r){if(n){const a=new m(void 0,this.g,this,this.i);a.c=String(w);const t=new Map,h=new I.$rh(()=>{const c=a.j(s,i,r);for(const[o,u]of t){const d=c[o];if(typeof d=="function")for(const b of u)b.disposable=d.apply(c,b.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,o){if(!h.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let b=t.get(o);return b||(b=new k.$4c,t.set(o,b)),(g,f,y)=>{if(h.isInitialized)return h.value[o](g,f,y);{const P={listener:[g,f,y],disposable:void 0},T=b.push(P);return(0,$.$Rc)(()=>{T(),P.disposable?.dispose()})}}}if(o in c)return c[o];const u=h.value;let d=u[o];return typeof d!="function"||(d=d.bind(u),c[o]=d),d},set(c,o,u){return h.value[o]=u,!0},getPrototypeOf(c){return s.prototype}})}else return this.j(s,i,r)}u(w,s){if(s&&console.warn(w),this.g)throw new Error(w)}}e.$Jq=m;var E;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(E||(E={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,s){return w?new S(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(w,s){return w?new S(1,s.name):S.c}static{this.f=0}constructor(w,s){this.type=w,this.name=s,this.g=Date.now(),this.h=[]}branch(w,s){const i=new S(3,w.toString());return this.h.push([w,s,i]),i}stop(){const w=Date.now()-this.g;S.f+=w;let s=!1;function i(r,a){const t=[],h=new Array(r+1).join("	");for(const[c,o,u]of a.h)if(o&&u){s=!0,t.push(`${h}CREATES -> ${c}`);const d=i(r+1,u);d&&t.push(d)}else t.push(`${h}uses -> ${c}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(w>2||s)&&S.all.add(n.join(`
`))}}e.$Kq=S}),define(Ce[13],Ie([1,0,44,4,54,3,28,11,23,18,2,45,5]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.log=e.$vj=e.LogLevel=e.$uj=e.$tj=e.$sj=void 0,e.$sj=(0,m.$$h)("logService"),e.$tj=(0,m.$$h)("loggerService");function E(){return new Date().toISOString()}function S(g){return(0,k.$Qf)(g)}e.$uj=S;var l;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$vj=l.Info;function w(g,f,y){switch(f){case l.Trace:g.trace(y);break;case l.Debug:g.debug(y);break;case l.Info:g.info(y);break;case l.Warning:g.warn(y);break;case l.Error:g.error(y);break;case l.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=w;function s(g,f=!1){let y="";for(let P=0;P<g.length;P++){let T=g[P];if(T instanceof Error&&(T=(0,I.$Vi)(T,f)),typeof T=="object")try{T=JSON.stringify(T)}catch{}y+=(P>0?" ":"")+T}return y}class i extends L.$Tc{constructor(){super(...arguments),this.b=e.$vj,this.c=this.B(new F.$Yd),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==l.Off&&this.b<=f}}e.$xj=i;class n extends i{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...y){this.f(l.Trace)&&this.g(l.Trace,s([f,...y],!0))}debug(f,...y){this.f(l.Debug)&&this.g(l.Debug,s([f,...y]))}info(f,...y){this.f(l.Info)&&this.g(l.Info,s([f,...y]))}warn(f,...y){this.f(l.Warning)&&this.g(l.Warning,s([f,...y]))}error(f,...y){if(this.f(l.Error))if(f instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=f.stack,this.g(l.Error,s(P))}else this.g(l.Error,s([f,...y]))}flush(){}}e.$yj=n;class r extends i{constructor(f=e.$vj){super(),this.setLevel(f),this.g=!v.$i}trace(f,...y){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}debug(f,...y){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}info(f,...y){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}warn(f,...y){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,f,...y):console.warn(`[main ${E()}]`,f,...y))}error(f,...y){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,f,...y):console.error(`[main ${E()}]`,f,...y))}flush(){}}e.$zj=r;class a extends i{constructor(f=e.$vj,y=!0){super(),this.g=y,this.setLevel(f)}trace(f,...y){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...y):console.log(f,...y))}debug(f,...y){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...y):console.log(f,...y))}info(f,...y){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...y):console.log(f,...y))}warn(f,...y){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...y):console.log(f,...y))}error(f,...y){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...y):console.error(f,...y))}flush(){}}e.$Aj=a;class t extends i{constructor(f,y=e.$vj){super(),this.g=f,this.setLevel(y)}trace(f,...y){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(f),...y])}debug(f,...y){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(f),...y])}info(f,...y){this.f(l.Info)&&this.g.log(l.Info,[this.h(f),...y])}warn(f,...y){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(f),...y])}error(f,...y){this.f(l.Error)&&this.g.log(l.Error,[this.h(f),...y])}h(f){return typeof f=="string"?f:(0,I.$Vi)(f,this.f(l.Trace))}flush(){}}e.$Bj=t;class h extends i{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const y of this.g)y.setLevel(f);super.setLevel(f)}trace(f,...y){for(const P of this.g)P.trace(f,...y)}debug(f,...y){for(const P of this.g)P.debug(f,...y)}info(f,...y){for(const P of this.g)P.info(f,...y)}warn(f,...y){for(const P of this.g)P.warn(f,...y)}error(f,...y){for(const P of this.g)P.error(f,...y)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose();super.dispose()}}e.$Cj=h;class c extends L.$Tc{constructor(f,y,P){if(super(),this.h=f,this.j=y,this.b=new A.$Ac,this.c=this.B(new F.$Yd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Yd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Yd),this.onDidChangeVisibility=this.g.event,P)for(const T of P)this.b.set(T.resource,{logger:void 0,info:T})}m(f){return(0,k.$Mf)(f)?[...this.b.values()].find(y=>y.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,y){const P=this.n(f),T=(0,k.$Mf)(f)?f:y?.id??(0,$.$Yi)(P.toString()).toString(16);let U=this.b.get(P)?.logger;const z=y?.logLevel==="always"?l.Trace:y?.logLevel;U||(U=this.s(P,z??this.getLogLevel(P)??this.h,{...y,id:T}));const M={logger:U,info:{resource:P,id:T,logLevel:z,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(M.info),this.b.set(P,M),U}n(f){return(0,k.$Mf)(f)?(0,p.$Lg)(this.j,`${f}.log`):f}setLogLevel(f,y){if(R.URI.isUri(f)){const P=f,T=y,U=this.b.get(P);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([P,T]))}else{this.h=f;for(const[P,T]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,y){const P=this.m(f);P&&y!==!P.info.hidden&&(P.info.hidden=!y,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,y]))}getLogLevel(f){let y;return f&&(y=this.b.get(f)?.info.logLevel),y??this.h}registerLogger(f){const y=this.b.get(f.resource);y?y.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const y=this.b.get(f);y&&(y.logger&&y.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Dj=c;class o{constructor(){this.onDidChangeLogLevel=new F.$Yd().event}setLevel(f){}getLevel(){return l.Info}trace(f,...y){}debug(f,...y){}info(f,...y){}warn(f,...y){}error(f,...y){}critical(f,...y){}dispose(){}flush(){}}e.$Ej=o;class u extends o{}e.$Fj=u;function d(g){if(g.verbose)return l.Trace;if(typeof g.logLevel=="string"){const f=D(g.logLevel.toLowerCase());if(f!==void 0)return f}return e.$vj}e.$Gj=d;function b(g){switch(g){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.$Hj=b;function D(g){switch(g){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$Ij=D,e.$Jj=new C.$pj("logLevel",b(l.Info))}),define(Ce[250],Ie([1,0,19,8,14,4,3,17,85,13]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;class R extends A.$Tc{constructor(m,E){super(),this.a=m,this.b=E,this.c=this.B(new L.$Yd),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Yd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new F.$9g(0)),this.w=[],this.y=this.B(new F.$9g(0))}watch(m,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(m,E):this.z(m,E)}n(m,E){const S={path:this.H(m),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},l=(0,I.$Ub)(this.j,S);return this.r(),(0,A.$Rc)(()=>{l(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,$.$1)(m))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,p.$mq)(E)),E=>this.G(E),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const E of this.j)(0,p.$iq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const E of this.j)(0,p.$iq)(E)&&m.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,E){const S={path:this.H(m),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},l=(0,I.$Ub)(this.w,S);return this.C(),(0,A.$Rc)(()=>{l(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,$.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,p.$mq)(m)),m=>this.G(m),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,v.$hc)(m.fsPath)}}e.$qq=R}),define(Ce[251],Ie([1,0,57,390,8,28,21,4,34,3,17,11,23,98,31,206,32,244,250,44,248,247]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0,(()=>{try{(0,F.gracefulify)(I)}catch(h){console.error(`Error enabling graceful-fs: ${(0,n.$Vi)(h)}`)}})();class t extends i.$qq{static{this.I=!1}constructor(c,o){super(c,o),this.onDidChangeCapabilities=v.Event.None,this.N=new L.$Ac(u=>m.$Cg.getComparisonKey(u)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(c){try{const{stat:o,symbolicLink:u}=await S.SymlinkSupport.stat(this.H(c));return{type:this.M(o,u),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size,permissions:o.mode&128?void 0:w.FilePermission.Locked}}catch(o){throw this.fb(o)}}async L(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const o=await S.Promises.readdir(this.H(c),{withFileTypes:!0}),u=[];return await Promise.all(o.map(async d=>{try{let b;d.isSymbolicLink()?b=(await this.stat((0,m.$Lg)(c,d.name))).type:b=this.M(d),u.push([d.name,b])}catch(b){this.a.trace(b)}})),u}catch(o){throw this.fb(o)}}M(c,o){let u;return o?.dangling?u=w.FileType.Unknown:c.isFile()?u=w.FileType.File:c.isDirectory()?u=w.FileType.Directory:u=w.FileType.Unknown,o&&(u|=w.FileType.SymbolicLink),u}async O(c){const o=this.H(c);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${o})`);let u;for(;u=this.N.get(c);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${o})`),await u.wait();const d=new $.$0g;return this.N.set(c,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${o})`),(0,k.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${o})`),this.N.get(c)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${o})`),this.N.delete(c)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${o})`),d.open()})}async readFile(c,o){let u;try{o?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(c)})`),u=await this.O(c));const d=this.H(c);return await S.Promises.readFile(d)}catch(d){throw this.fb(d)}finally{u?.dispose()}}P(c){t.I&&this.a.trace(c)}readFileStream(c,o,u){const d=(0,E.$ae)(b=>A.$me.concat(b.map(D=>A.$me.wrap(D))).buffer);return(0,s.$gq)(this,c,d,b=>b.buffer,{...o,bufferSize:256*1024},u),d}async writeFile(c,o,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.Q(c)?this.R(c,(0,m.$Lg)((0,m.$Kg)(c),`${(0,m.$Ig)(c)}${u.atomic.postfix}`),o,u):this.S(c,o,u)}async Q(c){try{const o=this.H(c),{symbolicLink:u}=await S.SymlinkSupport.stat(o);if(u)return!1}catch{}return!0}async R(c,o,u,d){const b=new k.$Sc;try{b.add(await this.O(c)),b.add(await this.O(o)),await this.S(o,u,d,!0);try{await this.rename(o,c,{overwrite:!0})}catch(D){try{await this.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{b.dispose()}}async S(c,o,u,d){let b;try{const D=this.H(c);if(!u.create||!u.overwrite){if(await S.Promises.exists(D)){if(!u.overwrite)throw(0,w.$Ik)((0,l.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,w.$Ik)((0,l.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(c,{create:!0,unlock:u.unlock},d),await this.write(b,0,o,0,o.byteLength)}catch(D){throw await this.gb(c,D)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(c){t.Y=c}async open(c,o,u){const d=this.H(c);let b;(0,w.$wk)(o)&&!u&&(b=await this.O(c));let D;try{if((0,w.$wk)(o)&&o.unlock)try{const{stat:f}=await S.SymlinkSupport.stat(d);f.mode&128||await S.Promises.chmod(d,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let g;if((0,w.$wk)(o)){if(C.$i)try{await S.Promises.truncate(d,0),g="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}g||(g="w")}else g="r";D=await S.Promises.open(d,g)}catch(g){throw b?.dispose(),(0,w.$wk)(o)?await this.gb(c,g):this.fb(g)}if(this.U.set(D,0),(0,w.$wk)(o)&&this.X.set(D,c),b){const g=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${d})`),this.W.set(D,b),g&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${d})`),g.dispose())}return D}async close(c){const o=this.W.get(c);try{if(this.U.delete(c),this.X.delete(c)&&t.Y)try{await S.Promises.fdatasync(c)}catch(u){t.configureFlushOnWrite(!1),this.a.error(u)}return await S.Promises.close(c)}catch(u){throw this.fb(u)}finally{o&&(this.W.get(c)===o&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.W.delete(c)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),o.dispose())}}async read(c,o,u,d,b){const D=this.Z(c,o);let g=null;try{g=(await S.Promises.read(c,u,d,b,D)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(c,D,g)}return g}Z(c,o){return o===this.U.get(c)?null:o}$(c,o,u){const d=this.U.get(c);typeof d=="number"&&(typeof o=="number"||(typeof u=="number"?this.U.set(c,d+u):this.U.delete(c)))}async write(c,o,u,d,b){return(0,$.$sh)(()=>this.ab(c,o,u,d,b),100,3)}async ab(c,o,u,d,b){const D=this.Z(c,o);let g=null;try{g=(await S.Promises.write(c,u,d,b,D)).bytesWritten}catch(f){throw await this.gb(this.X.get(c),f)}finally{this.$(c,D,g)}return g}async mkdir(c){try{await S.Promises.mkdir(this.H(c))}catch(o){throw this.fb(o)}}async delete(c,o){try{const u=this.H(c);if(o.recursive){let d;o?.atomic!==!1&&o.atomic.postfix&&(d=(0,R.$jc)((0,R.$mc)(u),`${(0,R.$nc)(u)}${o.atomic.postfix}`)),await S.Promises.rm(u,S.RimRafMode.MOVE,d)}else try{await S.Promises.unlink(u)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let b=!1;try{const{stat:D,symbolicLink:g}=await S.SymlinkSupport.stat(u);b=D.isDirectory()&&!g}catch{}if(b)await S.Promises.rmdir(u);else throw d}else throw d}}catch(u){throw this.fb(u)}}async rename(c,o,u){const d=this.H(c),b=this.H(o);if(d!==b)try{await this.bb(c,o,"move",u.overwrite),await S.Promises.rename(d,b)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(2,null,(0,R.$nc)(d),(0,R.$nc)((0,R.$mc)(b)),D.toString()))),this.fb(D)}}async copy(c,o,u){const d=this.H(c),b=this.H(o);if(d!==b)try{await this.bb(c,o,"copy",u.overwrite),await S.Promises.copy(d,b,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,l.localize)(3,null,(0,R.$nc)(d),(0,R.$nc)((0,R.$mc)(b)),D.toString()))),this.fb(D)}}async bb(c,o,u,d){const b=this.H(c),D=this.H(o);let g=!1;if(!!(this.capabilities&1024)||(g=(0,p.$$f)(b,D,!0)),g){if(u==="copy")throw(0,w.$Ik)((0,l.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const y=await this.L(c);if(!y)throw(0,w.$Ik)((0,l.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(o);if(P){if(!d)throw(0,w.$Ik)((0,l.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);y.type&w.FileType.File&&P.type&w.FileType.File||await this.delete(o,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,o){return this.cb(c,o,!1)}async cb(c,o,u){const d=this.H(c),b=this.H(o),D=!!(this.capabilities&1024);if((0,p.$$f)(d,b,!D))return;const g=new k.$Sc;try{g.add(await this.O(c)),g.add(await this.O(o)),u&&await S.Promises.mkdir((0,R.$mc)(b),{recursive:!0}),await S.Promises.copyFile(d,b)}catch(f){if(f.code==="ENOENT"&&!u)return this.cb(c,o,!0);throw this.fb(f)}finally{g.dispose()}}t(c,o,u){return new r.$xq(d=>c(d),d=>o(d),u)}F(c,o,u){return new a.$Fq(d=>c(d),d=>o(d),u)}fb(c){if(c instanceof w.$Hk)return c;let o=c,u;switch(c.code){case"ENOENT":u=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":o=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=w.FileSystemProviderErrorCode.Unknown;break;default:u=w.FileSystemProviderErrorCode.Unknown}return(0,w.$Ik)(o,u)}async gb(c,o){let u=this.fb(o);if(c&&u.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await S.SymlinkSupport.stat(this.H(c));d.mode&128||(u=(0,w.$Ik)(o,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return u}}e.$Gq=t}),define(Ce[252],Ie([1,0,3,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=void 0;class $ extends I.$Tc{constructor(A,v=[]){super(),this.a=new F.$Cj([A,...v]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...v){this.a.trace(A,...v)}debug(A,...v){this.a.debug(A,...v)}info(A,...v){this.a.info(A,...v)}warn(A,...v){this.a.warn(A,...v)}error(A,...v){this.a.error(A,...v)}flush(){this.a.flush()}}e.$7O=$}),define(Ce[253],Ie([1,0,32,13]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=void 0;var $;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})($||($={}));async function L(k,R,C,m,E){try{const S=await new Promise((w,s)=>{me(["@vscode/spdlog"],w,s)});S.setFlushOn($.Trace);const l=await S.createAsyncRotatingLogger(k,R,C,m);return E?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch(S){console.error(S)}return null}function A(k,R,C){switch(R){case F.LogLevel.Trace:k.trace(C);break;case F.LogLevel.Debug:k.debug(C);break;case F.LogLevel.Info:k.info(C);break;case F.LogLevel.Warning:k.warn(C);break;case F.LogLevel.Error:k.error(C);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function v(k,R){switch(R){case F.LogLevel.Trace:k.setLevel($.Trace);break;case F.LogLevel.Debug:k.setLevel($.Debug);break;case F.LogLevel.Info:k.setLevel($.Info);break;case F.LogLevel.Warning:k.setLevel($.Warning);break;case F.LogLevel.Error:k.setLevel($.Error);break;case F.LogLevel.Off:k.setLevel($.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class p extends F.$yj{constructor(R,C,m,E,S){super(),this.m=[],this.setLevel(S),this.n=this.s(R,C,m,E),this.B(this.onDidChangeLogLevel(l=>{this.r&&v(this.r,l)}))}async s(R,C,m,E){const S=m?6:1,l=30/S*I.$4k.MB,w=await L(R,C,l,S,E);if(w){this.r=w,v(this.r,this.getLevel());for(const{level:s,message:i}of this.m)A(this.r,s,i);this.m=[]}}g(R,C){this.r?A(this.r,R,C):this.getLevel()<=R&&this.m.push({level:R,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$VO=p}),define(Ce[135],Ie([1,0,39,207,5]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function k(S,l){return l-S}p.compare=k;const R=Object.create(null);R[p.Error]=(0,F.localize)(0,null),R[p.Warning]=(0,F.localize)(1,null),R[p.Info]=(0,F.localize)(2,null);function C(S){return R[S]||""}p.toString=C;function m(S){switch(S){case I.default.Error:return p.Error;case I.default.Warning:return p.Warning;case I.default.Info:return p.Info;case I.default.Ignore:return p.Hint}}p.fromSeverity=m;function E(S){switch(S){case p.Error:return I.default.Error;case p.Warning:return I.default.Warning;case p.Info:return I.default.Info;case p.Hint:return I.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var v;(function(p){const k="";function R(m){return C(m,!0)}p.makeKey=R;function C(m,E){const S=[k];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(k),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(k),m.severity!==void 0&&m.severity!==null?S.push(A.toString(m.severity)):S.push(k),m.message&&E?S.push(m.message.replace("\xA6","\\\xA6")):S.push(k),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(k),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(k),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(k),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(k),S.push(k),S.join("\xA6")}p.makeKeyOptionalMessage=C})(v||(e.IMarkerData=v={})),e.$Ft=(0,$.$$h)("markerService")}),define(Ce[254],Ie([1,0,4,39,5]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.NotificationsFilter=e.$vv=e.NeverShowAgainScope=e.NotificationPriority=e.$uv=e.Severity=void 0,e.Severity=F.default,e.$uv=(0,$.$$h)("notificationService");var L;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function v(C){if(C){const m=C;return typeof m.id=="string"&&typeof m.label=="string"}return!1}e.$vv=v;var p;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class k{constructor(){this.progress=new R,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(m){}updateMessage(m){}updateActions(m){}close(){}}e.$wv=k;class R{infinite(){}done(){}total(m){}worked(m){}}e.$xv=R}),define(Ce[255],Ie([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let F;const $=globalThis.vscode;if(typeof $<"u"&&typeof $.context<"u"){const L=$.context.configuration();if(L)F=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(F=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(F,{nameShort:`${F.nameShort} Dev`,nameLong:`${F.nameLong} Dev`,dataFolderName:`${F.dataFolderName}-dev`,serverDataFolderName:F.serverDataFolderName?`${F.serverDataFolderName}-dev`:void 0}),!F.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(F,{version:L.version})}}else F={},Object.keys(F).length===0&&Object.assign(F,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=F}),define(Ce[136],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=void 0,e.$Kj=(0,I.$$h)("productService"),e.$Lj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(I,F){e(I,F,me)}};define(Ce[107],Ie([1,0,8,22,3,5]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.ProgressLocation=e.$yv=void 0,e.$yv=(0,L.$$h)("progressService");var A;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$zv=Object.freeze({total(){},worked(){},done(){}});class v{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$Av=v;class p{get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const E=this.d;this.d=()=>{E?.(),m()}}):Promise.resolve()}}e.$Bv=p;let k=class extends $.$Tc{constructor(m,E){super(),this.a=new I.$vh,E.withProgress(m,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,$.$Rc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$Cv=k,e.$Cv=k=Je([We(1,e.$yv)],k);class R extends $.$Tc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new $.$Sc)}start(m){this.stop();const E=++this.a,S=new F.$9d;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,$.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,$.$Rc)(()=>S.cancel())),this.b.add((0,$.$Rc)(()=>this.c?this.c.done():void 0)),{id:E,token:S.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$Dv=R,e.$Ev=(0,L.$$h)("editorProgressService")}),define(Ce[37],Ie([1,0,61,18]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=void 0;class ${constructor(){this.a=new Map}add(A,v){I.ok(F.$Mf(A)),I.ok(F.$Of(v)),I.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,v)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Nn=new $}),define(Ce[108],Ie([1,0,4,37]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$On={JSONContribution:"base.contributions.json"};function $(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class L{constructor(){this.b=new I.$Yd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,k){this.a[$(p)]=k,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;F.$Nn.add(e.$On.JSONContribution,A)}),define(Ce[86],Ie([1,0,19,4,18,197,51,108,37]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.ConfigurationScope=e.$Sn=e.EditPresentationTypes=void 0;var k;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$Sn={Configuration:"base.contributions.configuration"};var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn={properties:{},patternProperties:{}},e.$Xn={properties:{},patternProperties:{}},e.$Yn={properties:{},patternProperties:{}},e.$Zn="vscode://schemas/settings/resourceLanguage",e.$1n="vscode://schemas/settings/configurationDefaults";const C=p.$Nn.as(v.$On.JSONContribution);class m{constructor(){this.h=new Set,this.i=new F.$Yd,this.onDidSchemaChange=this.i.event,this.j=new F.$Yd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Zn,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const c=new Set;this.n(t,h,c),C.registerSchema(e.$Zn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const h=new Set;this.o(t,h),C.registerSchema(e.$Zn,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const c=new Set;this.o(h,c),this.n(t,!1,c),C.registerSchema(e.$Zn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const c=[];for(const{overrides:o,source:u}of t)for(const d in o)if(h.add(d),e.$3n.test(d)){const b=this.a.get(d),D=b?.valuesSources??new Map;if(u)for(const P of Object.keys(o[d]))D.set(P,u);const g={...b?.value||{},...o[d]};this.a.set(d,{source:u,value:g,valuesSources:D});const f=(0,A.$Oi)(d),y={type:"object",default:g,description:L.localize(1,null,f),$ref:e.$Zn,defaultDefaultValue:g,source:$.$Mf(u)?void 0:u,defaultValueSource:u};c.push(...l(d)),this.d[d]=y,this.b.properties[d]=y}else{this.a.set(d,{value:o[d],source:u});const b=this.d[d];b&&(this.w(d,b),this.r(d,b))}this.m(c)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:c,source:o}of t)for(const u in c){const d=this.a.get(u),b=$.$Mf(o)?o:o?.id,D=$.$Mf(d?.source)?d?.source:d?.source?.id;if(b===D)if(h.add(u),this.a.delete(u),e.$3n.test(u))delete this.d[u],delete this.b.properties[u];else{const g=this.d[u];g&&(this.w(u,g),this.r(u,g))}}this.u()}deltaConfiguration(t){let h=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,c){t.forEach(o=>{this.p(o,h,o.extensionInfo,o.restrictedProperties,void 0,c),this.c.push(o),this.q(o)})}o(t,h){const c=o=>{if(o.properties)for(const u in o.properties){h.add(u);const d=this.d[u];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[u],this.s(u,o.properties[u])}o.allOf?.forEach(u=>c(u))};for(const o of t){c(o);const u=this.c.indexOf(o);u!==-1&&this.c.splice(u,1)}}p(t,h=!0,c,o,u=3,d){u=$.$Vf(t.scope)?u:t.scope;const b=t.properties;if(b)for(const g in b){const f=b[g];if(h&&n(g,f)){delete b[g];continue}if(f.source=c,f.defaultDefaultValue=b[g].default,this.w(g,f),e.$3n.test(g)?f.scope=void 0:(f.scope=$.$Vf(f.scope)?u:f.scope,f.restricted=$.$Vf(f.restricted)?!!o?.includes(g):f.restricted),b[g].hasOwnProperty("included")&&!b[g].included){this.f[g]=b[g],delete b[g];continue}else this.d[g]=b[g],b[g].policy?.name&&this.e.set(b[g].policy.name,g);!b[g].deprecationMessage&&b[g].markdownDeprecationMessage&&(b[g].deprecationMessage=b[g].markdownDeprecationMessage),d.add(g)}const D=t.allOf;if(D)for(const g of D)this.p(g,h,c,o,u,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=c=>{const o=c.properties;if(o)for(const d in o)this.r(d,o[d]);c.allOf?.forEach(h)};h(t)}r(t,h){switch(e.$Tn.properties[t]=h,h.scope){case 1:e.$Un.properties[t]=h;break;case 2:e.$Vn.properties[t]=h;break;case 6:e.$Wn.properties[t]=h;break;case 3:e.$Xn.properties[t]=h;break;case 4:e.$Yn.properties[t]=h;break;case 5:e.$Yn.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.$Tn.properties[t],h.scope){case 1:delete e.$Un.properties[t];break;case 2:delete e.$Vn.properties[t];break;case 6:delete e.$Wn.properties[t];break;case 3:delete e.$Xn.properties[t];break;case 4:case 5:delete e.$Yn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,c={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Zn};this.w(h,c),e.$Tn.properties[h]=c,e.$Un.properties[h]=c,e.$Vn.properties[h]=c,e.$Wn.properties[h]=c,e.$Xn.properties[h]=c,e.$Yn.properties[h]=c}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Zn};e.$Tn.patternProperties[e.$2n]=t,e.$Un.patternProperties[e.$2n]=t,e.$Vn.patternProperties[e.$2n]=t,e.$Wn.patternProperties[e.$2n]=t,e.$Xn.patternProperties[e.$2n]=t,e.$Yn.patternProperties[e.$2n]=t,this.i.fire()}w(t,h){const c=this.a.get(t);let o=c?.value,u=c?.source;$.$Tf(o)&&(o=h.defaultDefaultValue,u=void 0),$.$Tf(o)&&(o=s(h.type)),h.default=o,h.defaultValueSource=u}}const E="\\[([^\\]]+)\\]",S=new RegExp(E,"g");e.$2n=`^(${E})+$`,e.$3n=new RegExp(e.$2n);function l(a){const t=[];if(e.$3n.test(a)){let h=S.exec(a);for(;h?.length;){const c=h[1].trim();c&&t.push(c),h=S.exec(a)}}return(0,I.$Mb)(t)}e.$4n=l;function w(a){return a.reduce((t,h)=>`${t}[${h}]`,"")}e.$5n=w;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$6n=s;const i=new m;p.$Nn.add(e.$Sn.Configuration,i);function n(a,t){return a.trim()?e.$3n.test(a)?L.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?L.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$7n=n;function r(){const a=[],t=i.getConfigurationProperties();for(const h of Object.keys(t))a.push([h,t[h].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$8n=r}),define(Ce[256],Ie([1,0,19,4,160,3,28,24,18,2,51,86,37]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=void 0;function E(h){return Object.isFrozen(h)?h:v.$Cn(h)}class S{constructor(c={},o=[],u=[],d){this.b=c,this.c=o,this.d=u,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(o=>{if(o instanceof S)return o;const u=new l("");return u.parseRaw(o),u.configurationModel});this.f=c.reduce((o,u)=>u===o?u:o.merge(u),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,R.$Mi)(this.contents,c):this.contents}inspect(c,o){const u=this;return{get value(){return E(u.rawConfiguration.getValue(c))},get override(){return o?E(u.rawConfiguration.getOverrideValue(c,o)):void 0},get merged(){return E(o?u.rawConfiguration.override(o).getValue(c):u.rawConfiguration.getValue(c))},get overrides(){const d=[];for(const{contents:b,identifiers:D,keys:g}of u.rawConfiguration.overrides){const f=new S(b,g).getValue(c);f!==void 0&&d.push({identifiers:D,value:f})}return d.length?E(d):void 0}}}getOverrideValue(c,o){const u=this.i(o);return u?c?(0,R.$Mi)(u,c):u:void 0}getKeysForOverrideIdentifier(c){const o=[];for(const u of this.overrides)u.identifiers.includes(c)&&o.push(...u.keys);return I.$Mb(o)}getAllOverrideIdentifiers(){const c=[];for(const o of this.overrides)c.push(...o.identifiers);return I.$Mb(c)}override(c){let o=this.a.get(c);return o||(o=this.g(c),this.a.set(c,o)),o}merge(...c){const o=v.$Bn(this.contents),u=v.$Bn(this.overrides),d=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const D of c)if(b.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(o,D.contents);for(const g of D.overrides){const[f]=u.filter(y=>I.$ub(y.identifiers,g.identifiers));f?(this.h(f.contents,g.contents),f.keys.push(...g.keys),f.keys=I.$Mb(f.keys)):u.push(v.$Bn(g))}for(const g of D.keys)d.indexOf(g)===-1&&d.push(g)}return new S(o,d,u,b.every(D=>D instanceof S)?void 0:b)}g(c){const o=this.i(c);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const u={};for(const d of I.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let b=this.contents[d];const D=o[d];D&&(typeof b=="object"&&typeof D=="object"?(b=v.$Bn(b),this.h(b,D)):b=D),u[d]=b}return new S(u,this.keys,this.overrides)}h(c,o){for(const u of Object.keys(o)){if(u in c&&p.$Of(c[u])&&p.$Of(o[u])){this.h(c[u],o[u]);continue}c[u]=v.$Bn(o[u])}}i(c){let o=null,u=null;const d=b=>{b&&(u?this.h(u,b):u=v.$Bn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===c?o=b.contents:b.identifiers.includes(c)&&d(b.contents);return d(o),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,o){this.j(c,o,!0)}setValue(c,o){this.j(c,o,!1)}removeValue(c){const o=this.keys.indexOf(c);o!==-1&&(this.keys.splice(o,1),(0,R.$Li)(this.contents,c),C.$3n.test(c)&&this.overrides.splice(this.overrides.findIndex(u=>I.$ub(u.identifiers,(0,C.$4n)(c))),1))}j(c,o,u){(0,R.$Ki)(this.contents,c,o,d=>console.error(d)),u=u||this.keys.indexOf(c)===-1,u&&this.keys.push(c),C.$3n.test(c)&&this.overrides.push({identifiers:(0,C.$4n)(c),keys:Object.keys(this.contents[c]),contents:(0,R.$Ji)(this.contents[c],d=>console.error(d))})}}e.$9n=S;class l{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,o){if(!p.$Vf(c)){const u=this.g(c);this.parseRaw(u,o)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,o){this.a=c;const{contents:u,keys:d,overrides:b,restricted:D,hasExcludedProperties:g}=this.h(c,o);this.b=new S(u,d,b,g?[c]:void 0),this.c=D||[]}g(c){let o={},u=null,d=[];const b=[],D=[];function g(y){Array.isArray(d)?d.push(y):u!==null&&(d[u]=y)}const f={onObjectBegin:()=>{const y={};g(y),b.push(d),d=y,u=null},onObjectProperty:y=>{u=y},onObjectEnd:()=>{d=b.pop()},onArrayBegin:()=>{const y=[];g(y),b.push(d),d=y,u=null},onArrayEnd:()=>{d=b.pop()},onLiteralValue:g,onError:(y,P,T)=>{D.push({error:y,offset:P,length:T})}};if(c)try{$.$pn(c,f),o=d[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return o}h(c,o){const u=m.$Nn.as(C.$Sn.Configuration).getConfigurationProperties(),d=this.i(c,u,!0,o);c=d.raw;const b=(0,R.$Ji)(c,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),D=Object.keys(c),g=this.j(c,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:b,keys:D,overrides:g,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(c,o,u,d){let b=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:b};const D={},g=[];for(const f in c)if(C.$3n.test(f)&&u){const y=this.i(c[f],o,!1,d);D[f]=y.raw,b=b||y.hasExcludedProperties,g.push(...y.restricted)}else{const y=o[f],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&g.push(f),!d.exclude?.includes(f)&&(d.include?.includes(f)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&y?.restricted))?D[f]=c[f]:b=!0}return{raw:D,restricted:g,hasExcludedProperties:b}}j(c,o){const u=[];for(const d of Object.keys(c))if(C.$3n.test(d)){const b={};for(const D in c[d])b[D]=c[d][D];u.push({identifiers:(0,C.$4n)(d),keys:Object.keys(b),contents:(0,R.$Ji)(b,o)})}return u}}e.$0n=l;class w extends L.$Tc{constructor(c,o,u,d){super(),this.c=c,this.f=o,this.g=d,this.b=this.B(new F.$Yd),this.onDidChange=this.b.event,this.a=new l(this.c.toString()),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&u.isEqual(b.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$$n=w;class s{constructor(c,o,u,d,b,D,g,f,y,P,T,U,z){this.a=c,this.b=o,this.c=u,this.overrideIdentifiers=d,this.d=b,this.f=D,this.g=g,this.h=f,this.i=y,this.j=P,this.k=T,this.l=U,this.m=z}get value(){return E(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(c,o,u,d,b=new S,D=new S,g=new A.$Ac,f=new S,y=new A.$Ac){this.c=c,this.d=o,this.f=u,this.g=d,this.h=b,this.i=D,this.j=g,this.l=f,this.m=y,this.a=null,this.b=new A.$Ac,this.n=null}getValue(c,o,u){return this.p(c,o,u).getValue(c)}updateValue(c,o,u={}){let d;u.resource?(d=this.m.get(u.resource),d||(d=new S,this.m.set(u.resource,d))):d=this.l,o===void 0?d.removeValue(c):d.setValue(c,o),u.resource||(this.a=null)}inspect(c,o,u){const d=this.p(c,o,u),b=this.t(o.resource,u),D=o.resource?this.m.get(o.resource)||this.l:this.l,g=new Set;for(const f of d.overrides)for(const y of f.identifiers)d.getOverrideValue(c,y)!==void 0&&g.add(y);return new s(c,o,d.getValue(c),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.i:void 0,b||void 0,D)}keys(c){const o=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,o){this.j.set(c,o),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,o){const u=[];if(!o){const{added:d,updated:b,removed:D}=a(this.c,c);o=[...d,...b,...D]}for(const d of o)for(const b of(0,C.$4n)(d)){const D=this.c.getKeysForOverrideIdentifier(b),g=c.getKeysForOverrideIdentifier(b),f=[...g.filter(y=>D.indexOf(y)===-1),...D.filter(y=>g.indexOf(y)===-1),...D.filter(y=>!v.$Fn(this.c.override(b).getValue(y),c.override(b).getValue(y)))];u.push([b,f])}return this.updateDefaultConfiguration(c),{keys:o,overrides:u}}compareAndUpdatePolicyConfiguration(c){const{added:o,updated:u,removed:d}=a(this.d,c),b=[...o,...u,...d];return b.length&&this.updatePolicyConfiguration(c),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:o,updated:u,removed:d,overrides:b}=a(this.applicationConfiguration,c),D=[...o,...u,...d];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:b}}compareAndUpdateLocalUserConfiguration(c){const{added:o,updated:u,removed:d,overrides:b}=a(this.localUserConfiguration,c),D=[...o,...u,...d];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:b}}compareAndUpdateRemoteUserConfiguration(c){const{added:o,updated:u,removed:d,overrides:b}=a(this.remoteUserConfiguration,c),D=[...o,...u,...d];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:b}}compareAndUpdateWorkspaceConfiguration(c){const{added:o,updated:u,removed:d,overrides:b}=a(this.workspaceConfiguration,c),D=[...o,...u,...d];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:b}}compareAndUpdateFolderConfiguration(c,o){const u=this.folderConfigurations.get(c),{added:d,updated:b,removed:D,overrides:g}=a(u,o),f=[...d,...b,...D];return(f.length||!u)&&this.updateFolderConfiguration(c,o),{keys:f,overrides:g}}compareAndDeleteFolderConfiguration(c){const o=this.folderConfigurations.get(c);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:u,updated:d,removed:b,overrides:D}=a(o,void 0);return{keys:[...u,...d,...b],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,o,u){let d=this.q(o,u);return o.overrideIdentifier&&(d=d.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(d=d.merge(this.d)),d}q({resource:c},o){let u=this.r();if(o&&c){const d=o.getFolder(c);d&&(u=this.s(d.uri)||u);const b=this.m.get(c);b&&(u=u.merge(b))}return u}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let o=this.b.get(c);if(!o){const u=this.r(),d=this.j.get(c);d?(o=u.merge(d),this.b.set(c,o)):o=u}return o}t(c,o){if(o&&c){const u=o.getFolder(c);if(u)return this.j.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,o)=>{const{contents:u,overrides:d,keys:b}=this.j.get(o);return c.push([o,{contents:u,overrides:d,keys:b}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(o=>c.add(o)),this.userConfiguration.keys.forEach(o=>c.add(o)),this.i.keys.forEach(o=>c.add(o)),this.j.forEach(o=>o.keys.forEach(u=>c.add(u))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>c.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>c.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>c.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(u=>c.add(u))),[...c.values()]}v(c){const o=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(u=>o.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(u=>o.add(u)),this.i.getKeysForOverrideIdentifier(c).forEach(u=>o.add(u)),this.j.forEach(u=>u.getKeysForOverrideIdentifier(c).forEach(d=>o.add(d))),[...o.values()]}static parse(c){const o=this.w(c.defaults),u=this.w(c.policy),d=this.w(c.application),b=this.w(c.user),D=this.w(c.workspace),g=c.folders.reduce((f,y)=>(f.set(k.URI.revive(y[0]),this.w(y[1])),f),new A.$Ac);return new i(o,u,d,b,new S,D,g,new S,new A.$Ac)}static w(c){return new S(c.contents,c.keys,c.overrides)}}e.$_n=i;function n(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const c=new Set,o=new Map;for(const d of h)d.keys.forEach(b=>c.add(b)),d.overrides.forEach(([b,D])=>{const g=(0,A.$xc)(o,b,new Set);D.forEach(f=>g.add(f))});const u=[];return o.forEach((d,b)=>u.push([b,[...d.values()]])),{keys:[...c.values()],overrides:u}}e.$ao=n;class r{constructor(c,o,u,d){this.change=c,this.f=o,this.g=u,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of c.keys)this.affectedKeys.add(b);for(const[,b]of c.overrides)for(const D of b)this.affectedKeys.add(D);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(c,o){const u=this.a+c,d=this.d.indexOf(u);if(d<0)return!1;const b=d+u.length;if(b>=this.d.length)return!1;const D=this.d.charCodeAt(b);if(D!==this.b&&D!==this.c)return!1;if(o){const g=this.previousConfiguration?this.previousConfiguration.getValue(c,o,this.f?.workspace):void 0,f=this.g.getValue(c,o,this.h);return!v.$Fn(g,f)}return!0}}e.$bo=r;function a(h,c){const{added:o,removed:u,updated:d}=t(c?.rawConfiguration,h?.rawConfiguration),b=[],D=h?.getAllOverrideIdentifiers()||[],g=c?.getAllOverrideIdentifiers()||[];if(c){const f=g.filter(y=>!D.includes(y));for(const y of f)b.push([y,c.getKeysForOverrideIdentifier(y)])}if(h){const f=D.filter(y=>!g.includes(y));for(const y of f)b.push([y,h.getKeysForOverrideIdentifier(y)])}if(c&&h){for(const f of D)if(g.includes(f)){const y=t({contents:h.getOverrideValue(void 0,f)||{},keys:h.getKeysForOverrideIdentifier(f)},{contents:c.getOverrideValue(void 0,f)||{},keys:c.getKeysForOverrideIdentifier(f)});b.push([f,[...y.added,...y.removed,...y.updated]])}}return{added:o,removed:u,updated:d,overrides:b}}function t(h,c){const o=h?c?h.keys.filter(b=>c.keys.indexOf(b)===-1):[...h.keys]:[],u=c?h?c.keys.filter(b=>h.keys.indexOf(b)===-1):[...c.keys]:[],d=[];if(h&&c){for(const b of c.keys)if(h.keys.indexOf(b)!==-1){const D=(0,R.$Mi)(c.contents,b),g=(0,R.$Mi)(h.contents,b);v.$Fn(D,g)||d.push(b)}}return{added:o,removed:u,updated:d}}}),define(Ce[257],Ie([1,0,21,4,3,82]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tsb=e.$Ssb=e.$Rsb=e.$Qsb=void 0;const A=(k,R,C)=>{const m=new Uint8Array(16);for(let l=0;l<16;l++)m[l]=Math.round(Math.random()*256);const E=(0,I.$Ge)(I.$me.wrap(m));return[`GET ws://localhost${k}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$Qsb=A,e.$Rsb=I.$me.fromString(`\r
\r
`);async function v(k,R,C,m,E){k.write(I.$me.fromString((0,e.$Qsb)(R,C,m)));const S=new $.$Sc;try{return await new Promise((l,w)=>{let s;S.add(k.onData(i=>{s?s=I.$me.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$Rsb);if(n===-1)return;l(k),k.pauseData();const r=s.slice(n+e.$Rsb.byteLength);r.byteLength&&E.onData.fire(r)})),S.add(k.onClose(i=>w(i??new Error("socket closed")))),S.add(k.onEnd(()=>w(new Error("socket ended"))))})}catch(l){throw k.dispose(),l}finally{S.dispose()}}e.$Ssb=v;class p extends $.$Tc{constructor(R,C){super(),this.g=R,this.a=this.B(new F.$2d),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new F.$Yd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,C){L.SocketDiagnostics.traceSocketEvent(this,this.g,R,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Tsb=p}),define(Ce[65],Ie([1,0,14,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.RemoteAuthorityResolverErrorCode=e.$cl=e.$bl=e.RemoteConnectionType=e.$al=void 0,e.$al=(0,F.$$h)("remoteAuthorityResolverService");var $;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})($||(e.RemoteConnectionType=$={}));class L{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$bl=L;class A{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$cl=A;var v;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(v||(e.RemoteAuthorityResolverErrorCode=v={}));class p extends I.$bb{static isNotAvailable(C){return C instanceof p&&C._code===v.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof p&&C._code===v.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof p&&C._code===v.NoResolverFound}static isInvalidAuthority(C){return C instanceof p&&C._code===v.InvalidAuthority}static isHandled(C){return C instanceof p&&C.isHandled}constructor(C,m=v.Unknown,E){super(C),this._message=C,this._code=m,this._detail=E,this.isHandled=m===v.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$dl=p;function k(R){const C=R.indexOf("+");return C===-1?R:R.substring(0,C)}e.$el=k}),define(Ce[66],Ie([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=e.$gl=e.$fl=void 0;function F(k){return k.scheme===I.Schemas.vscodeRemote?k.authority:void 0}e.$fl=F;function $(k){if(!k)return;const R=k.indexOf("+");return R<0?k:k.substr(0,R)}e.$gl=$;function L(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.$hl=L;function A(k){const{host:R,port:C}=p(k);if(typeof C>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:R,port:C}}e.$il=A;function v(k,R){let{host:C,port:m}=p(k);return typeof m>"u"&&(m=R),{host:C,port:m}}e.$jl=v;function p(k){const R=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const C=k.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=k.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:k,port:void 0}}}),define(Ce[25],Ie([1,0,12,5,66]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.TargetPlatform=e.ExtensionType=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=void 0,e.$km="extensions.user.cache",e.$lm="extensions.builtin.cache",e.$mm="undefined_publisher",e.$nm=["ui","workspace","web"];function L(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.$om=L,e.$pm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(A||(e.ExtensionType=A={}));var v;(function(l){l.WIN32_X64="win32-x64",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class p{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,s){if(typeof w>"u"||w===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof w=="string"||typeof s=="string"){const i=typeof w=="string"?w:w.value,n=typeof s=="string"?s:s.value;return I.$df(i,n)}return w._lower===s._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$qm=p;class k{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const s of w)this.add(s)}add(w){this.c.add(p.toKey(w))}delete(w){return this.c.delete(p.toKey(w))}has(w){return this.c.has(p.toKey(w))}}e.$rm=k;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(p.toKey(w))}get(w){return this.c.get(p.toKey(w))}has(w){return this.c.has(p.toKey(w))}set(w,s){this.c.set(p.toKey(w),s)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sm=R;function C(l){return m(l)}e.$tm=C;function m(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.$um=m;function E(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.$vm=E;function S(l,w){if(w){const s=`onResolveRemoteAuthority:${(0,$.$gl)(w)}`;return!!l.activationEvents?.includes(s)}return!1}e.$wm=S,e.$xm=(0,F.$$h)("IBuiltinExtensionsScannerService")}),define(Ce[137],Ie([1,0,14,25]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=e.$sF=void 0;class ${constructor(){this.a=new Map,this.b=new WeakMap}register(A,v){this.a.set(A,v)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const v=Object.create(null);for(const p of A){const k=this.readActivationEvents(p);k.length>0&&(v[F.$qm.toKey(p.identifier)]=k)}return v}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const v=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<v.length;p++)v[p]==="onUri"&&(v[p]=`onUri:${F.$qm.toKey(A.identifier)}`);if(!A.contributes)return v;for(const p in A.contributes){const k=this.a.get(p);if(!k)continue;const R=A.contributes[p],C=Array.isArray(R)?R:[R];try{k(C,v)}catch(m){(0,I.$1)(m)}}return v}}e.$sF=$,e.$tF=new $}),define(Ce[258],Ie([1,0,8,21,22,14,4,3,58,38,30,82,65,66]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.PersistentConnectionEventType=e.$ql=e.$pl=e.$ol=e.ConnectionType=void 0;const S=30*1e3;var l;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(l||(e.ConnectionType=l={}));function w(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(J){const B=new $.$9d;return setTimeout(()=>B.cancel(),J),B.token}function i(J,B){if(J.isCancellationRequested||B.isCancellationRequested)return $.CancellationToken.Cancelled;const ae=new $.$9d;return J.onCancellationRequested(()=>ae.cancel()),B.onCancellationRequested(()=>ae.cancel()),ae.token}class n{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new v.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$4g)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function r(J,B){const ae=new n(B);return ae.registerDisposable(J.onControlMessage(Ee=>{const le=JSON.parse(Ee.toString()),de=Q(le);de?ae.reject(de):ae.resolve(le)})),ae.promise}function a(J,B,ae,Ee,le,de,ue,ge){const V=new n(ge),Z=k.$Ud.create(!1);return J.info(`Creating a socket (${ue})...`),p.mark(`code/willCreateSocket/${de}`),B.connect(ae,Ee,le,ue).then(he=>{V.didTimeout?(p.mark(`code/didCreateSocketError/${de}`),J.info(`Creating a socket (${ue}) finished after ${Z.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(p.mark(`code/didCreateSocketOK/${de}`),J.info(`Creating a socket (${ue}) was successful after ${Z.elapsed()} ms.`),V.resolve(he))},he=>{p.mark(`code/didCreateSocketError/${de}`),J.info(`Creating a socket (${ue}) returned an error after ${Z.elapsed()} ms.`),J.error(he),V.reject(he)}),V.promise}function t(J,B){const ae=new n(B);return J.then(Ee=>{ae.didTimeout||ae.resolve(Ee)},Ee=>{ae.didTimeout||ae.reject(Ee)}),ae.promise}async function h(J,B,ae,Ee){const le=fe(J,B);J.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let de;try{de=await a(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,E.$hl)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,w(B),`renderer-${w(B)}-${J.reconnectionToken}`,Ee)}catch(he){throw J.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),J.logService.error(he),he}J.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let ue,ge;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(de,null),ue=J.reconnectionProtocol,ge=!1):(ue=new C.$Yh({socket:de}),ge=!0),J.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const V=await t(J.signService.createNewMessage((0,R.$ug)()),Ee),Z={type:"auth",auth:J.connectionToken||"00000000000000000000",data:V.data};ue.sendControl(F.$me.fromString(JSON.stringify(Z)));try{const he=await r(ue,i(Ee,s(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(J.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(J.signService.validate(V,he.signedData),Ee)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const Pe=await t(J.signService.sign(he.data),Ee),pe={type:"connectionType",commit:J.commit,signedData:Pe,desiredConnectionType:B};return ae&&(pe.args=ae),J.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),ue.sendControl(F.$me.fromString(JSON.stringify(pe))),{protocol:ue,ownsProtocol:ge}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(J.logService.error(`${le} the handshake timed out. Error:`),J.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${le} received error control message when negotiating connection. Error:`),J.logService.error(he)),ge&&ee(ue),he}}async function c(J,B,ae,Ee){const le=Date.now(),de=fe(J,B),{protocol:ue,ownsProtocol:ge}=await h(J,B,ae,Ee),V=new n(Ee);return V.registerDisposable(ue.onControlMessage(Z=>{const he=JSON.parse(Z.toString()),be=Q(he);be?(J.logService.error(`${de} received error control message when negotiating connection. Error:`),J.logService.error(be),ge&&ee(ue),V.reject(be)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${re(le)}!`),V.resolve({protocol:ue,firstMessage:he}))})),V.promise}async function o(J,B){const{protocol:ae}=await c(J,1,void 0,B);return{protocol:ae}}async function u(J,B,ae){const{protocol:Ee,firstMessage:le}=await c(J,2,B,ae),de=le&&le.debugPort;return{protocol:Ee,debugPort:de}}async function d(J,B,ae){const Ee=Date.now(),le=fe(J,3),{protocol:de}=await h(J,3,B,ae);return J.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${re(Ee)}!`),de}async function b(J,B,ae){const{connectTo:Ee,connectionToken:le}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:Ee,connectionToken:le,reconnectionToken:B,reconnectionProtocol:ae,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function D(J,B,ae){return f(J,async Ee=>{const{protocol:le}=await o(Ee,$.CancellationToken.None);return new Y(J,B,ae,Ee.reconnectionToken,le)})}e.$ol=D;async function g(J,B){return f(J,async ae=>{const{protocol:Ee,debugPort:le}=await u(ae,B,$.CancellationToken.None);return new ne(J,B,ae.reconnectionToken,Ee,le)})}e.$pl=g;async function f(J,B){for(let Ee=1;;Ee++)try{const le=(0,R.$ug)(),de=await b(J,le,null);return await B(de)}catch(le){if(Ee<5)J.logService.error(`[remote-connection][attempt ${Ee}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(le);else throw J.logService.error(`[remote-connection][attempt ${Ee}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(le),j.triggerPermanentFailure(0,0,m.$dl.isHandled(le)),le}}async function y(J,B,ae){const Ee=await b(J,(0,R.$ug)(),null);return await d(Ee,{host:B,port:ae},$.CancellationToken.None)}e.$ql=y;function P(J){return(0,I.$Xg)(B=>new Promise((ae,Ee)=>{const le=setTimeout(ae,J*1e3);B.onCancellationRequested(()=>{clearTimeout(le),ae()})}))}var T;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class U{constructor(B,ae){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.type=0}}e.$rl=U;class z{constructor(B,ae,Ee,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.durationSeconds=Ee,this.c=le,this.type=1}skipWait(){this.c.cancel()}}e.$sl=z;class M{constructor(B,ae,Ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=Ee,this.type=2}}e.$tl=M;class N{constructor(B,ae,Ee){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=Ee,this.type=4}}e.$ul=N;class O{constructor(B,ae,Ee,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=Ee,this.handled=le,this.type=3}}e.$vl=O;class j extends v.$Tc{static triggerPermanentFailure(B,ae,Ee){this._permanentFailure=!0,this.f=B,this.g=ae,this.h=Ee,this.j.forEach(le=>le.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||j._permanentFailure}constructor(B,ae,Ee,le,de){super(),this.t=B,this.u=ae,this.reconnectionToken=Ee,this.protocol=le,this.w=de,this.m=this.B(new A.$Yd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(le.onSocketClose(ue=>{const ge=ie(this.t,this.reconnectionToken,!0);ue?ue.type===0?(this.u.logService.info(`${ge} received socket close event (hadError: ${ue.hadError}).`),ue.error&&this.u.logService.error(ue.error)):(this.u.logService.info(`${ge} received socket close event (wasClean: ${ue.wasClean}, code: ${ue.code}, reason: ${ue.reason}).`),ue.event&&this.u.logService.error(ue.event)):this.u.logService.info(`${ge} received socket close event.`),this.y()})),this.B(le.onSocketTimeout(ue=>{const ge=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ge} received socket timeout event (unacknowledgedMsgCount: ${ue.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ue.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ue.timeSinceLastReceivedSomeData}).`),this.y()})),j.j.push(this),this.B((0,v.$Rc)(()=>{const ue=j.j.indexOf(this);ue>=0&&j.j.splice(ue,1)})),this.n&&this.D(j.f,j.g,j.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ae=[0,5,5,10,10,10,10,10,30];let Ee=-1;do{Ee++;const le=Ee<ae.length?ae[Ee]:ae[ae.length-1];try{if(le>0){const ue=P(le);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,ue)),this.u.logService.info(`${B} waiting for ${le} seconds before reconnecting...`);try{await ue}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1)),this.u.logService.info(`${B} resolving connection...`);const de=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${de.connectTo}...`),await this.G(de,s(S)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Ee+1));break}catch(de){if(de.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if(Ee>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}if(m.$dl.isTemporarilyNotAvailable(de)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((de.code==="ETIMEDOUT"||de.code==="ENETUNREACH"||de.code==="ECONNREFUSED"||de.code==="ECONNRESET")&&de.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((0,L.$4)(de)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if(de instanceof m.$dl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,m.$dl.isHandled(de));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),Ee+1,!1);break}}while(!this.n&&!this.s)}C(B,ae,Ee){this.w?j.triggerPermanentFailure(B,ae,Ee):this.D(B,ae,Ee)}D(B,ae,Ee){this.m.fire(new O(this.reconnectionToken,B,ae,Ee)),ee(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$wl=j;class Y extends j{constructor(B,ae,Ee,le,de){super(1,B,le,de,!0),this.client=this.B(new C.$Wh(de,{remoteAuthority:ae,clientId:Ee},B.ipcLogger))}async G(B,ae){await o(B,ae)}}e.$xl=Y;class ne extends j{constructor(B,ae,Ee,le,de){super(2,B,Ee,le,!1),this.H=ae,this.debugPort=de}async G(B,ae){await u(B,this.H,ae)}}e.$yl=ne;function ee(J){try{J.acceptDisconnect();const B=J.getSocket();J.dispose(),B.dispose()}catch(B){(0,L.$1)(B)}}function Q(J){if(J&&J.type==="error"){const B=new Error(`Connection error: ${J.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function X(J,B){for(;J.length<B;)J+=" ";return J}function ce(J,B){return`[remote-connection][${X(w(J),13)}][${B.substr(0,5)}\u2026]`}function ie(J,B,ae){return`${ce(J,B)}[${ae?"reconnect":"initial"}]`}function fe(J,B){return`${ie(B,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function re(J){return`${Date.now()-J} ms`}}),define(Ce[259],Ie([1,0,3,5]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=void 0,e.$kl=(0,F.$$h)("remoteSocketFactoryService");class ${constructor(){this.a={}}register(A,v){return this.a[A]??=[],this.a[A].push(v),(0,I.$Rc)(()=>{const p=this.a[A]?.indexOf(v);typeof p=="number"&&p>=0&&this.a[A]?.splice(p,1)})}b(A){return(this.a[A.type]||[]).find(p=>p.supports(A))}connect(A,v,p,k){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,v,p,k)}}e.$ll=$}),define(Ce[260],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U7b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage($){try{const L=await this.c();if(L){const A=String(I.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage($)}}}catch{}return{id:"",data:$}}async validate($,L){if(!$.id)return!0;const A=this.b.get($.id);if(!A)return!1;this.b.delete($.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign($){try{return await this.d($)}catch{}return $}}e.$U7b=I}),define(Ce[109],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=void 0,e.$ml="signService",e.$nl=(0,I.$$h)(e.$ml)}),define(Ce[138],Ie([1,0,260]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=void 0;class F extends I.$U7b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>me(["vsda"],L,A))}}e.$O_b=F}),define(Ce[261],Ie([1,0,11,49,30]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=void 0;function L(p){if(I.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,k,R,C,m,E,S,l,w){const s=Object.create(null);s["common.machineId"]=E,s["common.sqmId"]=S,s.sessionID=(0,$.$ug)()+Date.now(),s.commitHash=C,s.version=m,s["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,I.$h)(I.$u),s["common.nodePlatform"]=F.$dc,s["common.nodeArch"]=R,s["common.product"]=w||"desktop",l&&(s["common.msftInternal"]=l);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(s["common.snap"]="true");const r=L(k);return r&&(s["common.platformDetail"]=r),s}e.$Oo=A;function v(p){const k=F.env.USERDNSDOMAIN;if(!k)return!1;const R=k.toLowerCase();return p.some(C=>R===C)}e.$Po=v}),define(Ce[262],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0,e.$zl=(0,I.$$h)("telemetryService"),e.$Al=(0,I.$$h)("customEndpointTelemetryService"),e.$Bl="telemetry.currentSessionDate",e.$Cl="telemetry.firstSessionDate",e.$Dl="telemetry.lastSessionDate",e.$El="telemetry.machineId",e.$Fl="telemetry.sqmId",e.$Gl="telemetry",e.$Hl="telemetry.telemetryLevel",e.$Il="telemetry.enableCrashReporter",e.$Jl="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var $;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})($||(e.TelemetryConfiguration=$={}))}),define(Ce[87],Ie([1,0,24,18,66,261,262]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;class v{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$Qo=v;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ro=p,e.$So=new p;class k{async publicLog(h,c,o){}async publicLogError(h,c,o){}}e.$To=k,e.$Uo="telemetry",e.$Vo="extensionTelemetryLog",e.$Wo={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}e.$Xo=R;function C(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Yo=C;function m(t){const h=t.getValue(A.$Hl),c=t.getValue(A.$Il);if(t.getValue(A.$Jl)===!1||c===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Zo=m;function E(t){const h={},c={},o={};w(t,o);for(let u in o){u=u.length>150?u.substr(u.length-149):u;const d=o[u];typeof d=="number"?c[u]=d:typeof d=="boolean"?c[u]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${d.length}`),h[u]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(h[u]=d)}return{properties:h,measurements:c}}e.$1o=E;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(t){if(!t)return"none";const h=(0,$.$gl)(t);return S.has(h)?h:"other"}e.$2o=l;function w(t,h,c=0,o){if(t)for(const u of Object.getOwnPropertyNames(t)){const d=t[u],b=o?o+u:u;Array.isArray(d)?h[b]=(0,I.$Gn)(d):d instanceof Date?h[b]=d.toISOString():(0,F.$Of)(d)?c<2?w(d,h,c+1,b+"."):h[b]=(0,I.$Gn)(d):h[b]=d}}function s(t,h){const c=t.msftInternalDomains||[],o=h.getValue("telemetry.internalTesting");return(0,L.$Po)(c)||o}e.$3o=s;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$4o=i;function n(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const o=[];for(const D of h)for(;;){const g=D.exec(t);if(!g)break;o.push([g.index,D.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(c="";;){const D=d.exec(t);if(!D)break;const g=o.some(([f,y])=>D.index<y&&f<d.lastIndex);!u.test(D[0])&&!g&&(c+=t.substring(b,D.index)+"<REDACTED: user-file-path>",b=d.lastIndex)}return b<t.length&&(c+=t.substr(b)),c}function r(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of h)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function a(t,h){return(0,I.$Dn)(t,c=>{if(c instanceof v||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let o=c.replaceAll("%20"," ");o=n(o,h);for(const u of h)o=o.replace(u,"");return o=r(o),o}})}e.$5o=a}),define(Ce[263],Ie([1,0,12,134,25,11,2,14,49,87]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0;function R(c,o){return c.uuid&&o.uuid?c.uuid===o.uuid:c.id===o.id?!0:(0,I.$$e)(c.id,o.id)===0}e.$6o=R;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(o){const u=o.manifest?o.manifest.version:o.version,d=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new m(o.identifier,u,d)}static parse(o){const u=C.exec(o);return u&&u[1]&&u[2]?new m({id:u[1]},u[2],u[4]||void 0):null}constructor(o,u,d="undefined"){this.version=u,this.targetPlatform=d,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof m?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$7o=m;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(c){const o=E.exec(c);return o&&o[1]?[w(o[1]),o[2]]:[w(c),void 0]}e.$8o=S;function l(c,o){return`${c}.${o}`}e.$9o=l;function w(c){return c.toLowerCase()}e.$0o=w;function s(c,o){return w(l(c??$.$mm,o))}e.$$o=s;function i(c,o){const u=[],d=b=>{for(const D of u)if(D.some(g=>R(o(g),o(b))))return D;return null};for(const b of c){const D=d(b);D?D.push(b):u.push([b])}return u}e.$_o=i;function n(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$ap=n;function r(c){return{id:new k.$Qo(c.identifier.id),name:new k.$Qo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$bp=r,e.$cp=new $.$qm("pprice.better-merge");function a(c,o){const u=[],d=o.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const b=d.shift();if(b&&u.every(D=>!R(D.identifier,{id:b}))){const D=c.filter(g=>R(g.identifier,{id:b}));D.length===1&&(u.push(D[0]),d.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.$dp=a;async function t(c,o){if(!L.$k)return!1;let u;try{u=(await c.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await c.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){o.debug("Error while getting the os-release file.",(0,v.$0)(b))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(c,o){const u=await t(c,o),d=(0,F.$Ao)(u?"alpine":L.$u,p.$ec);return o.debug("ComputeTargetPlatform:",d),d}e.$ep=h}),define(Ce[264],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=e.$Rr=void 0;function I(p){return[...p.entries()]}e.$Rr=I;function F(p){return p?[...p.entries()]:[]}e.$Sr=F;function $(p){return new Map(p)}e.$Tr=$;function L(p){return new Map(p??[])}e.$Ur=L;function A(p){return Array.from(p.entries()).map(k=>[k[0],I(k[1].map),F(k[1].descriptionMap)])}e.$Vr=A;function v(p){return new Map(p.map(k=>[k[0],{map:$(k[1]),descriptionMap:L(k[2])}]))}e.$Wr=v}),define(Ce[265],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$sb=void 0;class I{constructor($){this.b=$,this.a=new Map}dispose(){for(const $ of this.a.values())$.dispose()}startBuffering($,L,A=5){const v=L(p=>{const k=typeof p=="string"?p:p.data;let R=this.a.get($);if(R){R.data.push(k);return}const C=setTimeout(()=>this.flushBuffer($),A);R={data:[k],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer($),v.dispose()}},this.a.set($,R)});return v}stopBuffering($){this.a.get($)?.dispose()}flushBuffer($){const L=this.a.get($);L&&(this.a.delete($),this.b($,L.data.join("")))}}e.$$sb=I}),define(Ce[266],Ie([1,0,8,79,55,4,18,2,208,108,37]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.IconFontDefinition=e.IconContribution=e.$Bw=void 0,e.$Bw={IconContribution:"base.contributions.icons"};var C;(function(r){function a(t,h){let c=t.defaults;for(;$.ThemeIcon.isThemeIcon(c);){const o=S.getIcon(c.id);if(!o)return;c=o.defaults}return c}r.getDefinition=a})(C||(e.IconContribution=C={}));var m;(function(r){function a(h){return{weight:h.weight,style:h.style,src:h.src.map(c=>({format:c.format,location:c.location.toString()}))}}r.toJSONObject=a;function t(h){const c=o=>(0,A.$Mf)(o)?o:void 0;if(h&&Array.isArray(h.src)&&h.src.every(o=>(0,A.$Mf)(o.format)&&(0,A.$Mf)(o.location)))return{weight:c(h.weight),style:c(h.style),src:h.src.map(o=>({format:o.format,location:v.URI.parse(o.location)}))}}r.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class E{constructor(){this.a=new L.$Yd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,p.localize)(0,null)},fontCharacter:{type:"string",description:(0,p.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${$.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,h,c){const o=this.b[a];if(o){if(h&&!o.description){o.description=h,this.d.properties[a].markdownDescription=`${h} $(${a})`;const b=this.e.enum.indexOf(a);b!==-1&&(this.e.enumDescriptions[b]=h),this.a.fire()}return o}const u={id:a,description:h,defaults:t,deprecationMessage:c};this.b[a]=u;const d={$ref:"#/definitions/icons"};return c&&(d.deprecationMessage=c),h&&(d.markdownDescription=`${h}: $(${a})`),this.d.properties[a]=d,this.e.enum.push(a),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const h=this.f[a];return h||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(o,u)=>o.id.localeCompare(u.id),t=o=>{for(;$.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(o=>this.b[o]);for(const o of c.filter(u=>!!u.description).sort(a))h.push(`|<i class="${t(o)}"></i>|${o.id}|${$.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const o of c.filter(u=>!$.ThemeIcon.isThemeIcon(u.defaults)).sort(a))h.push(`|<i class="${t(o)}"></i>|${o.id}|`);return h.join(`
`)}}const S=new E;R.$Nn.add(e.$Bw.IconContribution,S);function l(r,a,t,h){return S.registerIcon(r,a,t,h)}e.$Cw=l;function w(){return S}e.$Dw=w;function s(){const r=(0,F.$ck)();for(const a in r){const t="\\"+r[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}s(),e.$Ew="vscode://schemas/icons";const i=R.$Nn.as(k.$On.JSONContribution);i.registerSchema(e.$Ew,S.getIconSchema());const n=new I.$kh(()=>i.notifySchemaChanged(e.$Ew),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Fw=l("widget-close",F.$ek.close,(0,p.localize)(2,null)),e.$Gw=l("goto-previous-location",F.$ek.arrowUp,(0,p.localize)(3,null)),e.$Hw=l("goto-next-location",F.$ek.arrowDown,(0,p.localize)(4,null)),e.$Iw=$.ThemeIcon.modify(F.$ek.sync,"spin"),e.$Jw=$.ThemeIcon.modify(F.$ek.loading,"spin")}),define(Ce[88],Ie([1,0,4,2,51,5,13]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.ProvidedOnAutoForward=e.$Hv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Gv=e.$Fv=void 0,e.$Fv=(0,L.$$h)("tunnelService"),e.$Gv=(0,L.$$h)("sharedTunnelsService");var v;(function(s){s.Http="http",s.Https="https"})(v||(e.TunnelProtocol=v={}));var p;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(p||(e.TunnelPrivacyId=p={}));function k(s){return!!s.forwardPort}e.$Hv=k;var R;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(R||(e.ProvidedOnAutoForward=R={}));function C(s,{checkQuery:i=!0}={}){if(s.scheme!=="http"&&s.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(n)return{address:n[1],port:+n[2]};if(!s.query||!i)return;const r=s.query.split("&");for(const a of r){const t=a.split("=")[1];if(/^https?:/.exec(t)){const h=C(F.URI.parse(t));if(h)return h}}}e.$Iv=C,e.$Jv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(s){return e.$Jv.indexOf(s)>=0}e.$Kv=m,e.$Lv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(s){return e.$Lv.indexOf(s)>=0}e.$Mv=E;function S(s,i,n,r){if(n===1)return!1;if(n===2&&E(i)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(a?.length===4&&parseInt(a[1])>=18)return!1}return s<1024}e.$Nv=S;class l{constructor(i,n,r){this.remoteAddress=i,this.localAddress=n,this.b=r,this.a=new I.$Yd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ov=l;let w=class{constructor(i,n){this.k=i,this.l=n,this.a=new I.$Yd,this.onTunnelOpened=this.a.event,this.b=new I.$Yd,this.onTunnelClosed=this.b.event,this.c=new I.$Yd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],n=Array.from(this.e.values());for(const r of n){const a=Array.from(r.values());for(const t of a){const h=await t.value;h&&typeof h!="string"&&i.push(h)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,r,a,t){this.q(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:r,privacy:a,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(E(i)||m(i))&&(i=e.$Jv[0]);const r=this.s(i,n);if(r)return++r.refcount,r.value}openTunnel(i,n,r,a,t,h=!1,c,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${t}.`);const u=this.f??i;if(!u)return;if(n||(n="localhost"),a||(a=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const d=this.t(u,n,r,a,t,h,c,o);return d?d.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,r),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(b);return(b.tunnelRemoteHost!==n||b.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&b.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),d)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const r=n.get(i.tunnelRemotePort);r&&(r.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,r))}}}}async p(i,n,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const a=r.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),a}}async closeTunnel(i,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const r=this.e.get(i);if(r&&r.has(n)){const a=r.get(n);a.refcount=0,await this.p(i,n,a)}}q(i,n,r){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:r})}async r(i,n){const r=this.e.get(i);if(r){const a=r.get(n),t=a?await a.value:void 0;(!t||typeof t=="string")&&r.delete(n),r.size===0&&this.e.delete(i)}}s(i,n){const r=[i];m(i)?(r.push(...e.$Jv),r.push(...e.$Lv)):E(i)&&r.push(...e.$Lv);const a=r.map(t=>this.e.get(t));for(const t of a){const h=t?.get(n);if(h)return h}}canTunnel(i){return!!C(i)}u(i,n,r,a,t,h,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${a}.`);const o=r;this.j.add(o);const u=a===void 0?r:a,d={elevationRequired:t?this.isPortPrivileged(u):!1},b={remoteAddress:{host:n,port:r},localAddressPort:a,privacy:h,public:h?h!==p.Private:void 0,protocol:c},D=i.forwardPort(b,d);return D?(this.q(n,r,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),D}};e.$Pv=w,e.$Pv=w=Je([We(0,A.$sj),We(1,$.$Ei)],w)}),define(Ce[267],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6k=void 0,e.$6k=(0,I.$$h)("IUriIdentityService")}),define(Ce[268],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Qv=void 0,e.$Qv=(0,I.$$h)("editSessionIdentityService");var F;(function($){$[$.Complete=100]="Complete",$[$.Partial=50]="Partial",$[$.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ce[269],Ie([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=void 0;function F(p){return p.scheme!==I.Schemas.file&&p.scheme!==I.Schemas.vscodeRemote}e.$1K=F;function $(p){if(p.folders.length)return p.folders.every(k=>F(k.uri))?p.folders[0].uri:void 0;if(p.configuration&&F(p.configuration))return p.configuration}e.$2K=$;function L(p){return $(p)?.scheme}e.$3K=L;function A(p){return $(p)?.authority}e.$4K=A;function v(p){return $(p)!==void 0}e.$5K=v}),define(Ce[40],Ie([1,0,210,17,78,23,2,5,16]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.WorkbenchState=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,v.$$h)("contextService");function k(o){const u=o;return typeof u?.id=="string"&&A.URI.isUri(u.uri)}e.$ii=k;function R(o){return typeof o?.id=="string"&&!k(o)&&!m(o)}e.$ji=R,e.$ki={id:"ext-dev"},e.$li={id:"empty-window"};function C(o,u){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,F.$nc)(o)}:u?e.$ki:e.$li;const d=o;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$mi=C;function m(o){const u=o;return typeof u?.id=="string"&&A.URI.isUri(u.configPath)}e.$ni=m;function E(o){const u=o;if(u?.uri)return{id:u.id,uri:A.URI.revive(u.uri)};const d=o;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(o?.id)return{id:o.id}}e.$oi=E;var S;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function l(o){const u=o;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.$pi=l;function w(o){const u=o;return!!(u&&typeof u=="object"&&A.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.$qi=w;class s{constructor(u,d,b,D,g){this.h=u,this.j=b,this.k=D,this.l=g,this.c=$.$ei.forUris(this.l,()=>!0),this.folders=d}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=$.$ei.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ri=s;class i{constructor(u,d){this.raw=d,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,L.$Lg)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$si=i;function n(o){return new i({uri:o,index:0,name:(0,L.$Hg)(o)},{uri:o.toString()})}e.$ti=n,e.$ui="code-workspace",e.$vi=`.${e.$ui}`,e.$wi=[{name:(0,I.localize)(0,null),extensions:[e.$ui]}],e.$xi="workspace.json";function r(o,u){return L.$Cg.isEqualOrParent(o,u.untitledWorkspacesHome)}e.$yi=r;function a(o){let u;return A.URI.isUri(o)?u=o:u=o.configuration,u?.scheme===p.Schemas.tmp}e.$zi=a,e.$Ai="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$Ai}e.$Bi=t;function h(o,u){return!r(o,u)&&!a(o)}e.$Ci=h;function c(o){return(typeof o=="string"?(0,F.$oc)(o):(0,L.$Jg)(o))===e.$vi}e.$Di=c}),define(Ce[270],Ie([1,0,54,4,3,23,2,209,133,32,5,13,40,28,267,8,30,12,18]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.ProfileResourceType=void 0;var n;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Tasks="tasks",o.Extensions="extensions",o.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(o){const u=o;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&A.URI.isUri(u.location)&&A.URI.isUri(u.globalStorageHome)&&A.URI.isUri(u.settingsResource)&&A.URI.isUri(u.keybindingsResource)&&A.URI.isUri(u.tasksResource)&&A.URI.isUri(u.snippetsHome)&&A.URI.isUri(u.extensionsResource))}e.$7k=r,e.$8k=(0,R.$$h)("IUserDataProfilesService");function a(o,u){return{id:o.id,isDefault:o.isDefault,name:o.name,shortName:o.shortName,icon:o.icon,location:A.URI.revive(o.location).with({scheme:u}),globalStorageHome:A.URI.revive(o.globalStorageHome).with({scheme:u}),settingsResource:A.URI.revive(o.settingsResource).with({scheme:u}),keybindingsResource:A.URI.revive(o.keybindingsResource).with({scheme:u}),tasksResource:A.URI.revive(o.tasksResource).with({scheme:u}),snippetsHome:A.URI.revive(o.snippetsHome).with({scheme:u}),extensionsResource:A.URI.revive(o.extensionsResource).with({scheme:u}),cacheHome:A.URI.revive(o.cacheHome).with({scheme:u}),useDefaultFlags:o.useDefaultFlags,isTransient:o.isTransient}}e.$9k=a;function t(o,u,d,b,D,g){return{id:o,name:u,location:d,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:g&&D?.useDefaultFlags?.globalState?g.globalStorageHome:(0,L.$Lg)(d,"globalStorage"),settingsResource:g&&D?.useDefaultFlags?.settings?g.settingsResource:(0,L.$Lg)(d,"settings.json"),keybindingsResource:g&&D?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,L.$Lg)(d,"keybindings.json"),tasksResource:g&&D?.useDefaultFlags?.tasks?g.tasksResource:(0,L.$Lg)(d,"tasks.json"),snippetsHome:g&&D?.useDefaultFlags?.snippets?g.snippetsHome:(0,L.$Lg)(d,"snippets"),extensionsResource:g&&D?.useDefaultFlags?.extensions?g.extensionsResource:(0,L.$Lg)(d,"extensions.json"),cacheHome:(0,L.$Lg)(b,o),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$0k=t;let h=class extends $.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,d,b,D){super(),this.t=u,this.u=d,this.w=b,this.y=D,this.f=!0,this.h=this.B(new F.$Yd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new F.$Yd),this.onWillCreateProfile=this.j.event,this.m=this.B(new F.$Yd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new F.$Yd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Lg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Lg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),d=[u];if(this.f)try{for(const g of this.O()){if(!g.name||!(0,i.$Mf)(g.name)||!g.location){this.y.warn("Skipping the invalid stored profile",g.location||g.name);continue}d.push(t((0,L.$Ig)(g.location),g.name,g.location,this.g,{shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags},u))}}catch(g){this.y.error(g)}const b=new E.$Ac,D=new Map;if(d.length)try{const g=this.Q();if(g.workspaces)for(const[f,y]of Object.entries(g.workspaces)){const P=A.URI.parse(f),T=d.find(U=>U.id===y);T&&b.set(P,T)}if(g.emptyWindows)for(const[f,y]of Object.entries(g.emptyWindows)){const P=d.find(T=>T.id===y);P&&D.set(f,P)}}catch(g){this.y.error(g)}this.z={profiles:d,workspaces:b,emptyWindows:D}}return this.z}D(){const u=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const d="Temp",b=new RegExp(`${(0,s.$Re)(d)}\\s(\\d+)`);let D=0;for(const f of this.profiles){const y=b.exec(f.name),P=y?parseInt(y[1]):0;D=P>D?P:D}const g=`${d} ${D+1}`;return this.createProfile((0,I.$Yi)((0,w.$ug)()).toString(16),g,{transient:!0},u)}async createNamedProfile(u,d,b){return this.createProfile((0,I.$Yi)((0,w.$ug)()).toString(16),u,d,b)}async createProfile(u,d,b,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.F(u,d,b);return D&&await this.setProfileForWorkspace(D,g),g}async F(u,d,b){if(!(0,i.$Mf)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(d);return D||(D=(async()=>{try{const g=this.profiles.find(P=>P.name===d||P.id===u);if(g)return g;const f=t(u,d,(0,L.$Lg)(this.profilesHome,u),this.g,b,this.defaultProfile);await this.u.createFolder(f.location);const y=[];return this.j.fire({profile:f,join(P){y.push(P)}}),await l.Promises.settled(y),this.I([f],[],[]),f}finally{this.r.delete(d)}})(),this.r.set(d,D)),D}async updateProfile(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(D=>D.id===u.id);if(!b)throw new Error(`Profile '${u.name}' does not exist`);return b=t(b.id,d.name??b.name,b.location,this.g,{shortName:d.shortName??b.shortName,icon:d.icon===null?void 0:d.icon??b.icon,transient:d.transient??b.isTransient,useDefaultFlags:d.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(D=>D.id===u.id);if(!d)throw new Error(`Profile '${u.name}' does not exist`);const b=[];this.m.fire({profile:d,join(D){b.push(D)}});try{await Promise.allSettled(b)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(D){(0,k.$Mk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(D=>D.id===d.id);if(!b)throw new Error(`Profile '${d.name}' does not exist`);this.L(u,b)}unsetWorkspace(u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(d=>d.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(u.map(d=>this.removeProfile(d)))}getProfileForWorkspace(u){const d=this.G(u);return A.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(u){return(0,m.$ii)(u)?u.uri:(0,m.$ni)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,u.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,u.location)))}I(u,d,b){const D=[...this.profiles,...u],g=[];this.s.profiles=[];for(let f of D)f.isDefault||d.some(y=>f.id===y.id)||(f=b.find(y=>f.id===y.id)??f,f.isTransient?this.s.profiles.push(f):g.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(g),this.z=void 0,this.J(u,d,b)}J(u,d,b){this.h.fire({added:u,removed:d,updated:b,all:this.profiles})}L(u,d,b){b=d?.isTransient?!0:b,b||this.L(u,void 0,!0);const D=this.G(u),g=b?this.s:this.C;A.URI.isUri(D)?(g.workspaces.delete(D),d&&g.workspaces.set(D,d)):(g.emptyWindows.delete(D),d&&g.emptyWindows.set(D,d)),b||this.M()}M(){const u={};for(const[b,D]of this.C.workspaces.entries())u[b.toString()]=D.id;const d={};for(const[b,D]of this.C.emptyWindows.entries())d[b.toString()]=D.id;this.R({workspaces:u,emptyWindows:d}),this.z=void 0}N(u){const d={},b=this.D();if(u.workspaces)for(const[g,f]of Object.entries(u.workspaces)){const y=A.URI.parse(f);d[g]=this.w.extUri.isEqual(y,b.location)?b.id:this.w.extUri.basename(y)}const D={};if(u.emptyWindows)for(const[g,f]of Object.entries(u.emptyWindows)){const y=A.URI.parse(f);D[g]=this.w.extUri.isEqual(y,b.location)?b.id:this.w.extUri.basename(y)}return{workspaces:d,emptyWindows:D}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$$k=h,e.$$k=h=Je([We(0,p.$fi),We(1,k.$vk),We(2,S.$6k),We(3,C.$sj)],h);class c extends h{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$_k=c}),define(Ce[271],Ie([1,0,8,4,3,58,18,189,5,270]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=e.$Bp=e.$Ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$zp=e.$yp=e.$xp=void 0,e.$xp="__$__isNewStorageMarker",e.$yp="__$__targetStorageMarker",e.$zp=(0,p.$$h)("storageService");var R;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function E(i){const n=i.get(e.$yp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$Ap=E;class S extends $.$Tc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new F.$2d),this.c=this.B(new F.$2d),this.onDidChangeTarget=this.c.event,this.f=this.B(new F.$Yd),this.onWillSaveState=this.f.event,this.h=this.B(new I.$kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new $.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,a){return F.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),a)}n(){this.j.value=(0,I.$oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,$.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:a,external:t}=r;if(a===e.$yp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,r,a){return this.P(r)?.get(n,a)}getBoolean(n,r,a){return this.P(r)?.getBoolean(n,a)}getNumber(n,r,a){return this.P(r)?.getNumber(n,a)}getObject(n,r,a){return this.P(r)?.getObject(n,a)}storeAll(n,r){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,r)})}store(n,r,a,t,h=!1){if((0,A.$Vf)(r)){this.remove(n,a,h);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,r,h)})}remove(n,r,a=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const a=[],t=this.J(n);for(const h of Object.keys(t))t[h]===r&&a.push(h);return a}z(n,r,a,t=!1){const h=this.J(r);typeof a=="number"?h[n]!==a&&(h[n]=a,this.P(r)?.set(e.$yp,JSON.stringify(h),t)):typeof h[n]=="number"&&(delete h[n],this.P(r)?.set(e.$yp,JSON.stringify(h),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?E(r):Object.create(null)}isNew(n){return this.getBoolean(e.$xp,n)===!0}async flush(n=R.NONE){this.f.fire({reason:n});const r=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case R.NONE:await I.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await I.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,r,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(R.NONE),(0,k.$7k)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||l(r)&&l(n))}N(n,r,a){this.y(()=>{const t=new Set;for(const[h,c]of n)t.add(h),r.get(h)!==c&&this.u(a,{key:h,external:!0});for(const[h]of r.items)t.has(h)||this.u(a,{key:h,external:!0})})}}e.$Bp=S;function l(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$Cp=l;class w extends S{constructor(){super(),this.U=this.B(new v.$vp(new v.$wp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$vp(new v.$wp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$vp(new v.$wp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Dp=w;async function s(i,n,r,a,t,h){const c=P=>{try{return JSON.parse(P)}catch{return P}},o=new Map,u=new Map;i.forEach((P,T)=>{o.set(T,P),u.set(T,c(P))});const d=new Map,b=new Map;n.forEach((P,T)=>{d.set(T,P),b.set(T,c(P))});const D=new Map,g=new Map;r.forEach((P,T)=>{D.set(T,P),g.set(T,c(P))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const f=[];if(o.forEach((P,T)=>{f.push({key:T,value:P})}),console.table(f),console.groupEnd(),console.log(u),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((T,U)=>{P.push({key:U,value:T})}),console.table(P),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${h})`);const y=[];D.forEach((P,T)=>{y.push({key:T,value:P})}),console.table(y),console.groupEnd(),console.log(g)}e.$Ep=s}),define(Ce[110],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class I{static{this.a=!1}constructor($){this.d=$,this.b=new Map,this.c=1}add($){const L=this.c++;return this.b.set(L,$),this.e(),L}get($,L){return this.b.has($)?this.b.get($)[L]:void 0}delete($){this.b.delete($),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Sgc=I}),define(Ce[59],Ie([1,0,16,23,5]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;class L{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new F.$Ag(v=>{const p=this.b.get(v.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(v,p){p===null?this.b.delete(v.scheme):this.b.set(v.scheme,p)}isFreeScheme(v){return!this.b.has(v)&&!this.a.has(v)}getCapabilities(v){return this.b.get(v)}}e.$Xgc=L,e.$Ygc=(0,$.$$h)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZN=void 0,e.$ZN=(0,I.$$h)("IExtHostInitDataService")}),define(Ce[272],Ie([1,0,216,13,252,27]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;let A=class extends $.$7O{constructor(p,k,R){const C=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",m=R.remote.isRemote?(0,I.localize)(0,null):p?(0,I.localize)(1,null):(0,I.localize)(2,null);super(k.createLogger(C,{name:m}))}};e.$3ic=A,e.$3ic=A=Je([We(1,F.$tj),We(2,L.$ZN)],A)}),define(Ce[273],Ie([1,0,8]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class F{constructor(A,v,p){this.h=new Map,this.a=A,this.b=v,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new I.$kh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of k.values())R.complete()}catch(R){for(const C of k.values())C.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,v){let p=this.f[A];return typeof p>"u"&&(p=v),p}update(A,v){this.f[A]=v;const p=this.h.get(A);if(p!==void 0)return p.p;const k=new I.$vh;return this.h.set(A,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$Ehc=F;class $ extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,v){super(A.identifier.value,!0,v),this.j=A}}e.$Fhc=$}),define(Ce[274],Ie([1,0,4,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;class ${constructor(A){this.c=A,this.a=new I.$Yd,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$Yd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,v,p,k){const C=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(v.value,p,k);this.b.fire(C)}$acceptDirtyStateChanged(A,v){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(v)}$acceptModelSaved(A){const v=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(v.apiNotebook)}}e.$sic=$}),define(Ce[20],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=void 0,e.$JN=(0,I.$$h)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$KN=F}),define(Ce[275],Ie([1,0,25,4]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class ${#e;constructor(A,v){this.b=new F.$Yd,this.onDidChange=this.b.event,this.a=I.$qm.toKey(A.identifier),this.#e=v,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(A){return this.#e.get(this.a,A)}store(A,v){return this.#e.store(this.a,A,v)}delete(A){return this.#e.delete(this.a,A)}}e.$Mhc=$}),define(Ce[67],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0,e.$chc=(0,I.$$h)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$dhc=F}),define(Ce[276],Ie([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmb=e.$emb=void 0;class F{constructor(){this.buffers=[]}add(p){let k=this.buffers.indexOf(p);return k<0&&(k=this.buffers.length,this.buffers.push(p)),k}}function $(v,p){if(p.serializeBuffersForPostMessage){const k=new F,C=JSON.stringify(v,(E,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S)};if(ArrayBuffer.isView(S)){const l=L(S);if(l)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S.buffer),view:{type:l,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=k.buffers.map(E=>{const S=new Uint8Array(E);return I.$me.wrap(S)});return{message:C,buffers:m}}else return{message:JSON.stringify(v),buffers:[]}}e.$emb=$;function L(v){switch(v.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(v,p){const k=p.map(m=>{const E=new ArrayBuffer(m.byteLength);return new Uint8Array(E).set(m.buffer),E}),R=p.length?(m,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const S=E,{index:l}=S,w=k[l];if(S.view)switch(S.view.type){case 1:return new Int8Array(w,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return E}:void 0;return{message:JSON.parse(v,R),arrayBuffers:k}}e.$fmb=A}),define(Ce[277],Ie([1,0,278,391,392,62,2,13,393]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;const k=!1;function R(n,r,a,t,h,c){const o=c.environment.useHostProxy,u=typeof o=="boolean"?o:!c.remote.isRemote,d={resolveProxy:g=>n.resolveProxy(g),lookupProxyAuthorization:w.bind(void 0,t,h,r,{},c.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(r),addCertificatesV2:()=>E(r),log:t,getLogLevel:()=>{const g=t.getLevel();switch(g){case v.LogLevel.Trace:return p.LogLevel.Trace;case v.LogLevel.Debug:return p.LogLevel.Debug;case v.LogLevel.Info:return p.LogLevel.Info;case v.LogLevel.Warning:return p.LogLevel.Warning;case v.LogLevel.Error:return p.LogLevel.Error;case v.LogLevel.Off:return p.LogLevel.Off;default:return f(g)}function f(y){return t.error("Unknown log level",y),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,loadAdditionalCertificates:async()=>{const g=[];if(c.remote.isRemote&&g.push((0,p.loadSystemCertificates)({log:t})),u){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const f=n.loadCertificates();f.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),g.push(f)}return(await Promise.all(g)).flat()},env:process.env},b=(0,p.createProxyResolver)(d),D=C(d,b);return l(a,D)}e.$yjc=R;function C(n,r){return{http:Object.assign(I,(0,p.createHttpPatch)(n,I,r)),https:Object.assign(F,(0,p.createHttpPatch)(n,F,r)),net:Object.assign(L,(0,p.createNetPatch)(n,L)),tls:Object.assign($,(0,p.createTlsPatch)(n,$))}}function m(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",k)&&!!r.get("systemCertificates")}function E(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",k)&&!!r.get("systemCertificates")}const S=new Map;function l(n,r){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,h=t._load;t._load=function(o,u,d){if(o==="net")return r.net;if(o==="tls")return r.tls;if(o!=="http"&&o!=="https")return h.apply(this,arguments);const b=a.findSubstr(A.URI.file(u.filename));let D=S.get(b);if(D||S.set(b,D={}),!D[o]){const g=r[o];D[o]={...g}}return D[o]}})}async function w(n,r,a,t,h,c,o,u){const d=t[c];o&&(t[c]=o),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${c}`,`proxyAuthenticate:${o}`,`proxyAuthenticateCache:${d}`);const b=o||d,D=Array.isArray(b)?b:typeof b=="string"?[b]:[];if(i(r,D,h),D.some(g=>/^(Negotiate|Kerberos)( |$)/i.test(g))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const g=await new Promise((U,z)=>{me(["kerberos"],U,z)}),f=new URL(c),y=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${c}`,`spn:${y}`),"Negotiate "+await(await g.initializeClient(y)).step("")}catch(g){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",g)}}let s=!1;function i(n,r,a){s||!r.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Ce[279],Ie([1,0,130]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;function F(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function $(L){return new I.$0m(F(L))}e.$8r=$}),define(Ce[139],Ie([1,0,226,18,2,3,5,37,32,16,44,181,39]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.$$E=e.$0E=e.EditorsOrder=e.$9E=e.CloseDirection=e.$8E=e.$7E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.EditorInputCapabilities=e.$XE=e.SaveReason=e.Verbosity=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=void 0,e.$KE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$LE={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$ME="workbench.editor.sidebysideEditor",e.$NE="workbench.editors.textDiffEditor",e.$OE="workbench.editors.binaryResourceDiffEditor";var E;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var S;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function l(re){const J=re;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.$PE=l;function w(re,J,B){for(const ae of B.visibleEditorPanes)if(ae.group.id===J&&re.matches(ae.input))return ae.getViewState()}e.$QE=w;function s(re){if(b(re))return!1;const J=re;return $.URI.isUri(J?.resource)}e.$RE=s;function i(re){if(b(re))return!1;const J=re;return J?.original!==void 0&&J.modified!==void 0}e.$SE=i;function n(re){if(b(re))return!1;const J=re;return!J||J.resources&&!Array.isArray(J.resources)?!1:!!J.resources||!!J.multiDiffSource}e.$TE=n;function r(re){if(b(re)||i(re))return!1;const J=re;return J?.primary!==void 0&&J.secondary!==void 0}e.$UE=r;function a(re){if(b(re))return!1;const J=re;return J?J.resource===void 0||J.resource.scheme===k.Schemas.untitled||J.forceUntitled===!0:!1}e.$VE=a;function t(re){if(b(re))return!1;const J=re;return $.URI.isUri(J?.base?.resource)&&$.URI.isUri(J?.input1?.resource)&&$.URI.isUri(J?.input2?.resource)&&$.URI.isUri(J?.result?.resource)}e.$WE=t;var h;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var c;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class o{constructor(){this.a=new Map}registerSource(J,B){let ae=this.a.get(J);return ae||(ae={source:J,label:B},this.a.set(J,ae)),ae.source}getSourceLabel(J){return this.a.get(J)?.label??J}}e.$XE=new o;var u;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad",re[re.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(u||(e.EditorInputCapabilities=u={}));class d extends L.$Tc{}e.$YE=d;function b(re){return re instanceof d}e.$ZE=b;function D(re){const J=re;return $.URI.isUri(J?.preferredResource)}function g(re){const J=re;return b(J?.primary)&&b(J?.secondary)}e.$1E=g;function f(re){const J=re;return b(J?.modified)&&b(J?.original)}e.$2E=f;function y(re,J,B,ae,Ee){return fe(ae,[(0,C.$Ui)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const le={...B,limits:{size:Number.MAX_VALUE}};re.openEditor(J,le)}}),(0,C.$Ui)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>Ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$3E=y;function P(re){return b(re?.editor)}e.$4E=P;function T(re){const J=re;return P(re)&&J?.group!==void 0}e.$5E=T;function U(re){const J=re;return typeof J?.groupId=="number"&&b(J.editor)}e.$6E=U;var z;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var M;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_STICKY=11]="EDITOR_STICKY",re[re.EDITOR_DIRTY=12]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(M||(e.GroupModelChangeKind=M={}));var N;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class O{getOriginalUri(J,B){if(!J)return;if(t(J))return e.$8E.getOriginalUri(J.result,B);if(B?.supportSideBySide){const{primary:Ee,secondary:le}=this.a(J);if(Ee&&le){if(B?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(Ee,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===N.ANY)return this.getOriginalUri(Ee,{filterByScheme:B.filterByScheme})??this.getOriginalUri(le,{filterByScheme:B.filterByScheme});J=B.supportSideBySide===N.PRIMARY?Ee:le}}if(i(J)||n(J)||r(J)||t(J))return;const ae=D(J)?J.preferredResource:J.resource;return!ae||!B||!B.filterByScheme?ae:this.b(ae,B.filterByScheme)}a(J){return g(J)||r(J)?{primary:J.primary,secondary:J.secondary}:f(J)||i(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,B){if(!J)return;if(t(J))return e.$8E.getCanonicalUri(J.result,B);if(B?.supportSideBySide){const{primary:Ee,secondary:le}=this.a(J);if(Ee&&le){if(B?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(Ee,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===N.ANY)return this.getCanonicalUri(Ee,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:B.filterByScheme});J=B.supportSideBySide===N.PRIMARY?Ee:le}}if(i(J)||n(J)||r(J)||t(J))return;const ae=J.resource;return!ae||!B||!B.filterByScheme?ae:this.b(ae,B.filterByScheme)}b(J,B){if(Array.isArray(B)){if(B.some(ae=>J.scheme===ae))return J}else if(B===J.scheme)return J}}var j;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(j||(e.EditorCloseMethod=j={}));function Y(re,J,B,ae){if(!re.isSticky(J))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return B===j.MOUSE||B===j.KEYBOARD;case"mouse":return B===j.MOUSE;case"keyboard":return B===j.KEYBOARD}return!1}e.$7E=Y,e.$8E=new O;var ne;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(ne||(e.CloseDirection=ne={}));class ee{constructor(){this.c=new Map,this.d=new Map}start(J){const B=this.a=J.get(A.$0h);for(const[ae,Ee]of this.c)this.e(ae,Ee,B);this.c.clear()}e(J,B,ae){const Ee=ae.createInstance(B);this.d.set(J,Ee)}registerFileEditorFactory(J){if(this.b)throw new Error("Can only register one file editor factory.");this.b=J}getFileEditorFactory(){return(0,F.$Xf)(this.b)}registerEditorSerializer(J,B){if(this.c.has(J)||this.d.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.a?this.e(J,B,this.a):this.c.set(J,B),(0,L.$Rc)(()=>{this.c.delete(J),this.d.delete(J)})}getEditorSerializer(J){return this.d.get(typeof J=="string"?J:J.typeId)}}v.$Nn.add(e.$KE.EditorFactory,new ee);async function Q(re,J,B){return!re||!re.length?[]:await Promise.all(re.map(async ae=>{const Ee=$.URI.revive(ae.fileUri);if(!Ee){B.info("Cannot resolve the path because it is not valid.",ae);return}if(!await J.canHandleResource(Ee)){B.info("Cannot resolve the path because it cannot be handled",ae);return}let de=ae.exists,ue=ae.type;if(typeof de!="boolean"||typeof ue!="number")try{ue=(await J.stat(Ee)).isDirectory?p.FileType.Directory:p.FileType.Unknown,de=!0}catch(V){B.error(V),de=!1}if(!de&&ae.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ae);return}if(ue===p.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ae);return}const ge={...ae.options,pinned:!0};return de?{resource:Ee,options:ge}:{resource:Ee,options:ge,forceUntitled:!0}}))}e.$9E=Q;var X;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function ce(re){const J=re;if(!J)return!1;const B=J;if(B.modified)return ce(B.modified);const ae=J;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.$0E=ce;function ie(re){return(0,R.$Wi)(re)}e.$$E=ie;function fe(re,J,B){const ae=(0,R.$Xi)(re,J);return ae.forceMessage=B?.forceMessage,ae.forceSeverity=B?.forceSeverity,ae.allowDialog=B?.allowDialog,ae}e.$_E=fe}),define(Ce[280],Ie([1,0,4,227,5,3,28,37,19,24,79,266]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$fF=e.ViewContentGroups=e.$eF=e.$dF=e.ViewContainerLocation=e.Extensions=e.$cF=e.$bF=e.$aF=void 0,e.$aF="views",e.$bF=(0,F.localize)(0,null),e.$cF=(0,C.$Cw)("default-view-icon",R.$ek.window,(0,F.localize)(1,null));var m;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var E;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$dF=[0,1,2];function S(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$eF=S;class l extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new I.$Yd),this.onDidRegister=this.c.event,this.f=this.B(new I.$Yd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(c,o,u){const d=this.get(c.id);if(d)return d;const b=c;return b.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:b.openCommandActionDescriptor??{id:b.id},(0,A.$xc)(this.g,o,[]).push(b),u?.isDefault&&this.h.push(b),this.c.fire({viewContainer:b,viewContainerLocation:o}),b}deregisterViewContainer(c){for(const o of this.g.keys()){const u=this.g.get(o),d=u?.indexOf(c);if(d!==-1){u?.splice(d,1),u.length===0&&this.g.delete(o),this.f.fire({viewContainer:c,viewContainerLocation:o});return}}}get(c){return this.all.filter(o=>o.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(u=>u?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(o=>this.getViewContainerLocation(o)===c)}}v.$Nn.add(m.ViewContainersRegistry,new l);var w;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(w||(e.ViewContentGroups=w={}));function s(h,c){const o=h.group??w.More,u=c.group??w.More;return o!==u?o.localeCompare(u):(h.order??5)-(c.order??5)}class i extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new I.$Yd),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$Yd),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$Yd),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$Yd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(c,o){this.registerViews2([{views:c,viewContainer:o}])}registerViews2(c){c.forEach(({views:o,viewContainer:u})=>this.r(o,u)),this.c.fire(c)}deregisterViews(c,o){const u=this.s(c,o);u.length&&this.f.fire({views:u,viewContainer:o})}moveViews(c,o){for(const u of this.m.keys())if(u!==o){const d=this.s(c,u);d.length&&(this.r(d,o),this.g.fire({views:d,from:u,to:o}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const o of this.j){const u=(this.m.get(o)||[]).filter(d=>d.id===c)[0];if(u)return u}return null}getViewContainer(c){for(const o of this.j)if((this.m.get(o)||[]).filter(d=>d.id===c)[0])return o;return null}registerViewWelcomeContent(c,o){return this.n.add(c,o),this.h.fire(c),(0,L.$Rc)(()=>{this.n.delete(c,o),this.h.fire(c)})}registerViewWelcomeContent2(c,o){const u=new Map;for(const[d,b]of o)this.n.add(c,b),u.set(d,(0,L.$Rc)(()=>{this.n.delete(c,b),this.h.fire(c)}));return this.h.fire(c),u}getViewWelcomeContent(c){const o=[];return this.n.forEach(c,u=>o.push(u)),o.sort(s)}r(c,o){let u=this.m.get(o);u||(u=[],this.m.set(o,u),this.j.push(o));for(const d of c){if(this.getView(d.id)!==null)throw new Error((0,F.localize)(2,null,d.id));u.push(d)}}s(c,o){const u=this.m.get(o);if(!u)return[];const d=[],b=[];for(const D of u)c.includes(D)?d.push(D):b.push(D);return d.length&&(b.length?this.m.set(o,b):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),d}}v.$Nn.add(m.ViewsRegistry,new i),e.$fF=(0,$.$$h)("viewDescriptorService");var n;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(c,o){this.c=!1,this.d=!1,(0,k.$En)(this,c),this.d=!!o,this.resolve=async u=>{if(o&&!this.c){const d=await o(u);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$gF=a;class t extends Error{constructor(c){super((0,F.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$hF=t}),define(Ce[281],Ie([1,0,2,29,5]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$pF=e.$oF=void 0;function L(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof I.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(F.$Zs.isIRange)}e.$oF=L;function A(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(L)}e.$pF=A;var v;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(v||(e.InteractiveSessionVoteDirection=v={}));var p;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})(p||(e.ChatAgentCopyKind=p={})),e.$qF=(0,$.$$h)("IChatService"),e.$rF="accessibility.voice.keywordActivation"}),define(Ce[140],Ie([1,0,4,8,228]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmb=void 0;class L{constructor(){this.f=new Map,this.m=[],this.n=new I.$Yd,this.o=new I.$Yd,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(v){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=v}onEvent(v){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=v}onRequest(v){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=v}sendResponse(v){v.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${v.command}`)):this.u("response",v)}sendRequest(v,p,k,R){const C={command:v};if(p&&Object.keys(p).length>0&&(C.arguments=p),this.u("request",C),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const E=this.f.get(C.seq);if(E){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:v,message:(0,$.localize)(0,null,R,v)};E(S)}},R)}return k&&this.f.set(C.seq,k),C.seq}acceptMessage(v){this.k?this.k(v):(this.m.push(v),this.m.length===1&&this.s())}q(v,p){return v.type!=="event"||p.type!=="event"}async s(){let v;for(;this.m.length;){if((!v||this.q(this.m[0],v))&&await(0,F.$_g)(0),v=this.m.shift(),!v)return;switch(v.type){case"event":this.j?.(v);break;case"request":this.g?.(v);break;case"response":{const p=v,k=this.f.get(p.request_seq);k&&(this.f.delete(p.request_seq),k(p));break}}}}u(v,p){p.type=v,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const v=new Map;this.f.forEach((p,k)=>v.set(k,p)),await(0,F.$_g)(500),v.forEach((p,k)=>{p({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Kmb=L}),define(Ce[282],Ie([1,0,2,229,45,5]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$2H=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$1H=e.MemoryRangeType=e.$ZH=e.State=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=void 0,e.$RG="workbench.view.debug",e.$SG="workbench.debug.variablesView",e.$TG="workbench.debug.watchExpressionsView",e.$UG="workbench.debug.callStackView",e.$VG="workbench.debug.loadedScriptsView",e.$WG="workbench.debug.breakPointsView",e.$XG="workbench.debug.disassemblyView",e.$YG="workbench.panel.repl",e.$ZG="workbench.panel.repl.view",e.$1G=new $.$pj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$2G=new $.$pj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$3G=new $.$pj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$4G="debugUx",e.$5G=new $.$pj(e.$4G,"default",{type:"string",description:F.localize(3,null)}),e.$6G=new $.$pj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$7G=new $.$pj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$8G=new $.$pj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$9G=new $.$pj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$0G=new $.$pj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$$G=new $.$pj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$_G=new $.$pj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$aH=new $.$pj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$bH=new $.$pj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$cH=new $.$pj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$dH=new $.$pj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$eH=new $.$pj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$fH=new $.$pj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$gH=new $.$pj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$hH=new $.$pj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$iH=new $.$pj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$jH=new $.$pj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$kH=new $.$pj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$lH=new $.$pj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(22,null)}),e.$mH=new $.$pj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(23,null)}),e.$nH=new $.$pj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(24,null)}),e.$oH=new $.$pj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(25,null)}),e.$pH=new $.$pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(26,null)}),e.$qH=new $.$pj("stepBackSupported",!1,{type:"boolean",description:F.localize(27,null)}),e.$rH=new $.$pj("restartFrameSupported",!1,{type:"boolean",description:F.localize(28,null)}),e.$sH=new $.$pj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(29,null)}),e.$tH=new $.$pj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(30,null)}),e.$uH=new $.$pj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(31,null)}),e.$vH=new $.$pj("breakpointsExist",!1,{type:"boolean",description:F.localize(32,null)}),e.$wH=new $.$pj("debuggersAvailable",!1,{type:"boolean",description:F.localize(33,null)}),e.$xH=new $.$pj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(34,null)}),e.$yH=new $.$pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(35,null)}),e.$zH=new $.$pj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(36,null)}),e.$AH=new $.$pj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(37,null)}),e.$BH=new $.$pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$CH=new $.$pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$DH=new $.$pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$EH=new $.$pj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$FH=new $.$pj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$GH=new $.$pj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(43,null)}),e.$HH=new $.$pj("variableIsReadonly",!1,{type:"boolean",description:F.localize(44,null)}),e.$IH=new $.$pj("variableValue",!1,{type:"string",description:F.localize(45,null)}),e.$JH=new $.$pj("variableType",!1,{type:"string",description:F.localize(46,null)}),e.$KH=new $.$pj("variableName",!1,{type:"string",description:F.localize(47,null)}),e.$LH=new $.$pj("variableLanguage",!1,{type:"string",description:F.localize(48,null)}),e.$MH=new $.$pj("variableExtensionId",!1,{type:"string",description:F.localize(49,null)}),e.$NH=new $.$pj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(50,null)}),e.$OH=new $.$pj("multiSessionRepl",!1,{type:"boolean",description:F.localize(51,null)}),e.$PH=new $.$pj("multiSessionDebug",!1,{type:"boolean",description:F.localize(52,null)}),e.$QH=new $.$pj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(53,null)}),e.$RH=new $.$pj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(54,null)}),e.$SH=new $.$pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(55,null)}),e.$TH=new $.$pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(56,null)});const A=s=>F.localize(57,null,s);e.$UH=A,e.$VH="editor.contrib.debug",e.$WH="editor.contrib.breakpoint",e.$XH="debug",e.$YH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(58,null)};var v;(function(s){s[s.Inactive=0]="Inactive",s[s.Initializing=1]="Initializing",s[s.Stopped=2]="Stopped",s[s.Running=3]="Running"})(v||(e.State=v={}));function p(s){switch(s){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$ZH=p;var k;(function(s){s[s.Valid=0]="Valid",s[s.Unreadable=1]="Unreadable",s[s.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$1H="vscode-debug-memory";var R;(function(s){s[s.Initial=1]="Initial",s[s.Dynamic=2]="Dynamic"})(R||(e.DebugConfigurationProviderTriggerKind=R={}));var C;(function(s){s.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$2H=(0,L.$$h)("debugService");var m;(function(s){s[s.CONDITION=0]="CONDITION",s[s.HIT_COUNT=1]="HIT_COUNT",s[s.LOG_MESSAGE=2]="LOG_MESSAGE",s[s.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var E;(function(s){s[s.Command=0]="Command",s[s.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var S;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(S||(e.DebugTreeItemCollapsibleState=S={}));var l;(function(s){s.deserialize=i=>i,s.serialize=i=>i})(l||(e.IDebugVisualizationTreeItem=l={}));var w;(function(s){s.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:I.URI.revive(i.iconPath.light),dark:I.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),s.serialize=i=>i})(w||(e.IDebugVisualization=w={}))}),define(Ce[283],Ie([1,0,12,2,17,24,16,29,22,19]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0;const R=/{([^}]+)}/g;function C(D,g,f){return D.replace(R,function(y,P){return g&&P.length>0&&P[0]!=="_"?y:f&&f.hasOwnProperty(P)?f[P]:y})}e.$gG=C;function m(D){const g={};for(const f of Object.keys(D))f.startsWith("!")||(g[f]=D[f]);return g}e.$hG=m;function E(D){return D.configuration.request==="attach"&&!S(D)&&(!D.parentSession||E(D.parentSession))}e.$iG=E;function S(D){let g=D.configuration.type;if(g)return g==="vslsShare"&&(g=D.configuration.adapterProxy.configuration.type),(0,I.$df)(g,"extensionhost")||(0,I.$df)(g,"pwa-extensionhost")?D:D.parentSession?S(D.parentSession):void 0}e.$jG=S;function l(D){return D.type&&(D.label||D.program||D.runtime)}e.$kG=l;function w(D,g,f){let y,P=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=T.exec(D);){const z=U.index+1,M=z+U[0].length;if(z<=g&&M>=f){y=U[0],P=z;break}}if(y){const z=/\w+/g;let M=null;for(;(M=z.exec(y))&&!(M.index+1+P+M[0].length>=f););M&&(y=y.substring(0,z.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}e.$lG=w;async function s(D,g,f,y){if(D.evaluatableExpressionProvider.has(g)){const P=D.evaluatableExpressionProvider.ordered(g),T=(0,k.$Hb)(await Promise.all(P.map(async U=>{try{return await U.provideEvaluatableExpression(g,f,y??p.CancellationToken.None)}catch{return}})));if(T.length>0){let U=T[0].expression;const z=T[0].range;return U||(U=g.getLineContent(f.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:U}}}else{const P=g.getLineContent(f.lineNumber),{start:T,end:U}=w(P,f.column,f.column),z=P.substring(T-1,U);return{matchingExpression:z,range:new v.$Zs(f.lineNumber,T,f.lineNumber,T+z.length)}}return null}e.$mG=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$nG=n;function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return F.URI.parse(D.path);if((0,$.$ic)(D.path))return F.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const g=F.URI.revive(D.path);if(g)return g.scheme===A.Schemas.file?g.fsPath:g.toString()}return D.path}function t(D,g){const f=g?r:a,y=(0,L.$Bn)(D);return c(y,(P,T)=>{P&&T&&(T.path=f(T))}),y}e.$oG=t;function h(D,g){const f=g?r:a,y=(0,L.$Bn)(D);return c(y,(P,T)=>{!P&&T&&(T.path=f(T))}),y}e.$pG=h;function c(D,g){switch(D.type){case"event":{const f=D;switch(f.event){case"output":g(!1,f.body.source);break;case"loadedSource":g(!1,f.body.source);break;case"breakpoint":g(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=D;switch(f.command){case"setBreakpoints":g(!0,f.arguments.source);break;case"breakpointLocations":g(!0,f.arguments.source);break;case"source":g(!0,f.arguments.source);break;case"gotoTargets":g(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(y=>g(!1,y));break;default:break}break}case"response":{const f=D;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(y=>g(!1,y.source));break;case"loadedSources":f.body.sources.forEach(y=>g(!1,y));break;case"scopes":f.body.scopes.forEach(y=>g(!1,y.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(y=>g(!1,y.source));break;case"setBreakpoints":f.body.breakpoints.forEach(y=>g(!1,y.source));break;case"disassemble":f.body?.instructions.forEach(P=>g(!1,P.location));break;default:break}break}}}function o(D){return D.filter(g=>!g.presentation?.hidden).sort((g,f)=>g.presentation?f.presentation?g.presentation.group?f.presentation.group?g.presentation.group!==f.presentation.group?g.presentation.group.localeCompare(f.presentation.group):u(g.presentation.order,f.presentation.order):-1:f.presentation.group?1:u(g.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$qG=o;function u(D,g){return typeof D!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:D-g}async function d(D,g){const f=D.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(f!=="none"&&(await g.saveAll(),f==="allEditorsInActiveGroup")){const y=g.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await g.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}e.$rG=d;const b=(D,g)=>!D||!g?D===g:D.name===g.name&&D.path===g.path&&D.sourceReference===g.sourceReference;e.$sG=b}),define(Ce[284],Ie([1,0,50,62,24,17,11,12,31,230,140]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=e.$$ic=e.$0ic=e.$9ic=void 0;class C extends R.$Kmb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(s,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,s.on("data",n=>this.v(n))}sendMessage(s){if(this.l){const i=JSON.stringify(s);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}v(s){for(this.p=Buffer.concat([this.p,s]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(C.a);if(i!==-1){const r=this.p.toString("utf8",0,i).split(C.b);for(const a of r){const t=a.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+C.a.length);continue}}break}}}e.$9ic=C;class m extends C{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.n.fire(r):i(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$0ic=m;class E extends m{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$$ic=E;class S extends m{constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.path,s)}}e.$_ic=S;class l extends C{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(L.$ic(s)){if(!await p.Promises.exists(s))throw new Error(k.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=$.$En($.$Bn(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const h=I.fork(i[0],i.slice(1),t);if(!h.pid)throw new Error(k.localize(2,null,i[0]));this.x=h}else throw new Error(k.localize(3,null));else{const a={env:r};n.cwd&&(a.cwd=n.cwd),this.x=I.spawn(s,i,a)}this.x.on("error",a=>{this.n.fire(a)}),this.x.on("exit",(a,t)=>{this.o.fire(a)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.n.fire(a)}),this.x.stdin.on("error",a=>{this.n.fire(a)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),A.$i?new Promise((s,i)=>{const n=I.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,a,t){if(r)return i(r)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=L.$jc(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(L.$ic(s.program)?n.program=s.program:n.program=L.$jc(i,s.program)),s.args&&(n.args=s.args);const r=s;return r.win&&(n.win=l.A(r.win,i)),r.winx86&&(n.winx86=l.A(r.winx86,i)),r.windows&&(n.windows=l.A(r.windows,i)),r.osx&&(n.osx=l.A(r.osx,i)),r.linux&&(n.linux=l.A(r.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const o of s)if(o.contributes){const u=o.contributes.debuggers;u&&u.length>0&&u.filter(d=>typeof d.type=="string"&&v.$df(d.type,i)).forEach(d=>{const b=l.A(d,o.extensionLocation.fsPath);n=$.$En(n,b,o.isBuiltin)})}let r;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:A.$i?r=n.win||n.windows:A.$j?r=n.osx:A.$k&&(r=n.linux),r=r||n;const a=r.program||n.program,t=r.args||n.args,h=r.runtime||n.runtime,c=r.runtimeArgs||n.runtimeArgs;if(h)return{type:"executable",command:h,args:(c||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$ajc=l}),define(Ce[285],Ie([1,0,50,34,11]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=e.$bjc=void 0;function L(k,R){return new Promise((C,m)=>{let E="";const S=I.spawn(k,R);S.pid&&S.stdout.on("data",l=>{E+=l.toString()}),S.on("error",l=>{m(l)}),S.on("close",l=>{C(E)})})}async function A(k){if(k)if($.$i){const R=await new Promise((C,m)=>{me(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{R.getProcessTree(k,m=>{C(!!m&&m.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(k)]).then(R=>{const C=R.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$bjc=A;var v;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(v||(v={}));function p(k,R,C,m,E){k=k.trim().toLowerCase();let S;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?S=1:k.indexOf("cmd.exe")>=0?S=0:k.indexOf("bash")>=0?S=2:$.$i?S=0:S=2;let l,w=" ";switch(S){case 1:if(l=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),m){const s=(0,F.$eg)(m);s&&(w+=`${s}:; `),w+=`cd ${l(m)}; `}if(E)for(const s in E){const i=E[s];i===null?w+=`Remove-Item env:${s}; `:w+=`\${env:${s}}='${i}'; `}if(R.length>0){const s=R.shift(),i=C?s:l(s);w+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of R)w+=n==="<"||n===">"||C?n:l(n),w+=" "}break;case 0:if(l=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),m){const s=(0,F.$eg)(m);s&&(w+=`${s}: && `),w+=`cd ${l(m)} && `}if(E){w+='cmd /C "';for(const s in E){let i=E[s];i===null?w+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),w+=`set "${s}=${i}" && `)}}for(const s of R)w+=s==="<"||s===">"||C?s:l(s),w+=" ";E&&(w+='"');break;case 2:{l=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(w+=`cd ${l(m)} ; `),E){w+="/usr/bin/env";for(const i in E){const n=E[i];n===null?w+=` -u ${s(i)}`:w+=` ${s(`${i}=${n}`)}`}w+=" "}for(const i of R)w+=i==="<"||i===">"||C?i:l(i),w+=" ";break}}return w}e.$cjc=p}),define(Ce[286],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.CellExecutionUpdateType=void 0;var F;(function($){$[$.Output=1]="Output",$[$.OutputItems=2]="OutputItems",$[$.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$xJ=(0,I.$$h)("INotebookExecutionService")}),define(Ce[287],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fb=e.$6fb=e.ProxyKernelState=e.$5fb=void 0,e.$5fb=100;var F;(function($){$[$.Disconnected=1]="Disconnected",$[$.Connected=2]="Connected",$[$.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$6fb=(0,I.$$h)("INotebookKernelService"),e.$7fb=(0,I.$$h)("INotebookKernelHistoryService")}),define(Ce[288],Ie([1,0,3,29,194,99]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qSb=void 0;class A extends I.$Tc{constructor(p,k,R){super(),this._source=p,this.b=k,this.c=R,this.a=void 0}f(p){const k=p.getLineCount();return new F.$Zs(1,1,k,this.g(p,k))}g(p,k){if(k<1||k>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const p=new $.$hC;p.acceptChunk(this._source);const k=p.finish(!0),{textBuffer:R,disposable:C}=k.create(1);this.b=R,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const k=new $.$hC;k.acceptChunk(p);const R=k.finish(!0),{textBuffer:C,disposable:m}=R.create(1);return this.B(m),C})),this.a}findInInputs(p){const R=new L.$8B(p,!1,!1,null).parseSearchRequest();if(!R)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,R,!0,5e3)}findInOutputs(p){const R=new L.$8B(p,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),R,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$qSb=A}),define(Ce[68],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iK=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(L){L.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class ${static fromExtHostTestItem(A,v,p=A.parent){if(A._isRoot)return new $([v]);const k=[A.id];for(let R=p;R&&R.id!==v;R=R.parent)k.push(R.id);return k.push(v),new $(k.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const v=A.indexOf("\0");return v===-1?A:A.slice(0,v)}static fromString(A){return new $(A.split("\0"))}static join(A,v){return new $([...A.path,v])}static joinToString(A,v){return A.toString()+"\0"+v}static parentId(A){const v=A.lastIndexOf("\0");return v===-1?void 0:A.slice(0,v)}static localId(A){const v=A.lastIndexOf("\0");return v===-1?A:A.slice(v+1)}static isChild(A,v){return v.startsWith(A)&&v[A.length]==="\0"}static compare(A,v){return A===v?0:$.isChild(A,v)?2:$.isChild(v,A)?3:1}constructor(A,v=A.length){if(this.path=A,this.d=v,A.length===0||v<1)throw new Error("cannot create test with empty path")}get rootId(){return new $(this.path,1)}get parentId(){return this.d>1?new $(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new $(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new $(this.path,A)}compare(A){if(typeof A=="string")return $.compare(this.toString(),A);for(let v=0;v<A.d&&v<this.d;v++)if(A.path[v]!==this.path[v])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$iK=$}),define(Ce[89],Ie([1,0,2,48,29,68]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$pK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$oK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nK=e.$mK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kK=e.$jK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var v;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(v||(e.ExtTestRunProfileKind=v={}));var p;(function(N){N[N.Run=2]="Run",N[N.Debug=4]="Debug",N[N.Coverage=8]="Coverage",N[N.HasNonDefaultProfile=16]="HasNonDefaultProfile",N[N.HasConfigurable=32]="HasConfigurable",N[N.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$jK=[2,4,8,16,32,64];const k=N=>"runId"in N;e.$kK=k;var R;(function(N){N.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),N.deserialize=(O,j)=>({range:$.$Zs.lift(j.range),uri:O.asCanonicalUri(I.URI.revive(j.uri))})})(R||(e.IRichLocation=R={}));var C;(function(N){N[N.Error=0]="Error",N[N.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(N){N.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&R.serialize(O.location)}),N.deserialize=(O,j)=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&R.deserialize(O,j.location)})})(m||(e.ITestErrorMessage=m={}));const E=(N,O)=>`${O?"s":"e"}${N}`;e.$lK=E;var S;(function(N){N.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&R.serialize(O.location)}),N.deserialize=(O,j)=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&R.deserialize(O,j.location)})})(S||(e.ITestOutputMessage=S={}));var l;(function(N){N.serialize=O=>O.type===0?m.serialize(O):S.serialize(O),N.deserialize=(O,j)=>j.type===0?m.deserialize(O,j):S.deserialize(O,j)})(l||(e.ITestMessage=l={}));var w;(function(N){N.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),N.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(l.serialize)}),N.deserialize=(O,j)=>({state:j.state,duration:j.duration,messages:j.messages.map(Y=>l.deserialize(O,Y))})})(w||(e.ITestTaskState=w={}));const s="\0",i=(N,O)=>N+s+O;e.$mK=i;const n=N=>{const O=N.indexOf(s);return{ctrlId:N.slice(0,O),tagId:N.slice(O+1)}};e.$nK=n;var r;(function(N){N.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),N.deserialize=(O,j)=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?O.asCanonicalUri(I.URI.revive(j.uri)):void 0,range:j.range?$.$Zs.lift(j.range):null,description:j.description,error:j.error,sortText:j.sortText})})(r||(e.ITestItem=r={}));var a;(function(N){N[N.NotExpandable=0]="NotExpandable",N[N.Expandable=1]="Expandable",N[N.BusyExpanding=2]="BusyExpanding",N[N.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(N){N.serialize=O=>({expand:O.expand,item:r.serialize(O.item)}),N.deserialize=(O,j)=>({controllerId:L.$iK.root(j.item.extId),expand:j.expand,item:r.deserialize(O,j.item)})})(t||(e.InternalTestItem=t={}));var h;(function(N){N.serialize=O=>{let j;return O.item&&(j={},O.item.label!==void 0&&(j.label=O.item.label),O.item.tags!==void 0&&(j.tags=O.item.tags),O.item.busy!==void 0&&(j.busy=O.item.busy),O.item.uri!==void 0&&(j.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(j.range=O.item.range?.toJSON()),O.item.description!==void 0&&(j.description=O.item.description),O.item.error!==void 0&&(j.error=O.item.error),O.item.sortText!==void 0&&(j.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:j}},N.deserialize=O=>{let j;return O.item&&(j={},O.item.label!==void 0&&(j.label=O.item.label),O.item.tags!==void 0&&(j.tags=O.item.tags),O.item.busy!==void 0&&(j.busy=O.item.busy),O.item.range!==void 0&&(j.range=O.item.range?$.$Zs.lift(O.item.range):null),O.item.description!==void 0&&(j.description=O.item.description),O.item.error!==void 0&&(j.error=O.item.error),O.item.sortText!==void 0&&(j.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:j}}})(h||(e.ITestItemUpdate=h={}));const c=(N,O)=>{O.expand!==void 0&&(N.expand=O.expand),O.item!==void 0&&(N.item=N.item?Object.assign(N.item,O.item):O.item)};e.$oK=c;var o;(function(N){N.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(w.serializeWithoutMessages)}),N.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(w.serialize)}),N.deserialize=(O,j)=>({...t.deserialize(O,j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(Y=>w.deserialize(O,Y)),retired:!0})})(o||(e.TestResultItem=o={}));var u;(function(N){N.empty=()=>({covered:0,total:0}),N.sum=(O,j)=>{O.covered+=j.covered,O.total+=j.total}})(u||(e.ICoveredCount=u={}));var d;(function(N){N.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(f.serialize),uri:O.uri.toJSON()}),N.deserialize=(O,j)=>({statement:j.statement,branch:j.branch,declaration:j.declaration,details:j.details?.map(f.deserialize),uri:O.asCanonicalUri(I.URI.revive(j.uri))})})(d||(e.IFileCoverage=d={}));function b(N){return{...N,location:N.location?.toJSON()}}function D(N){return N.location=N.location?F.$Ys.isIPosition(N.location)?F.$Ys.lift(N.location):$.$Zs.lift(N.location):void 0,N}e.$pK=3;var g;(function(N){N[N.Declaration=0]="Declaration",N[N.Statement=1]="Statement",N[N.Branch=2]="Branch"})(g||(e.DetailType=g={}));var f;(function(N){N.serialize=O=>O.type===0?P.serialize(O):T.serialize(O),N.deserialize=O=>O.type===0?P.deserialize(O):T.deserialize(O)})(f||(e.CoverageDetails=f={}));var y;(function(N){N.serialize=b,N.deserialize=D})(y||(e.IBranchCoverage=y={}));var P;(function(N){N.serialize=b,N.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var T;(function(N){N.serialize=O=>({...b(O),branches:O.branches?.map(y.serialize)}),N.deserialize=O=>({...D(O),branches:O.branches?.map(y.deserialize)})})(T||(e.IStatementCoverage=T={}));var U;(function(N){N[N.Add=0]="Add",N[N.Update=1]="Update",N[N.DocumentSynced=2]="DocumentSynced",N[N.Remove=3]="Remove",N[N.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",N[N.Retire=5]="Retire",N[N.AddTag=6]="AddTag",N[N.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var z;(function(N){N.deserialize=(O,j)=>j.op===0?{op:j.op,item:t.deserialize(O,j.item)}:j.op===1?{op:j.op,item:h.deserialize(j.item)}:j.op===2?{op:j.op,uri:O.asCanonicalUri(I.URI.revive(j.uri)),docv:j.docv}:j,N.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:h.serialize(O.item)}:O})(z||(e.TestsDiffOp=z={}));class M{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const j=this.v();for(const Y of O)switch(Y.op){case 0:this.l(t.deserialize(this.k,Y.item),j);break;case 1:this.o(h.deserialize(Y.item),j);break;case 3:this.p(Y.itemId,j);break;case 5:this.q(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}j.complete?.()}l(O,j){const Y=L.$iK.parentId(O.item.extId)?.toString();let ne;if(!Y)ne=this.w(O),this.g.add(ne),this.f.set(O.item.extId,ne);else if(this.f.has(Y)){const ee=this.f.get(Y);ee.children.add(O.item.extId),ne=this.w(O,ee),this.f.set(O.item.extId,ne)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return j.add?.(ne),O.expand===2&&this.h++,ne}o(O,j){const Y=this.f.get(O.extId);if(Y)return O.expand!==void 0&&(Y.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$oK)(Y,O),j.update?.(Y),Y}p(O,j){const Y=this.f.get(O);if(!Y)return;const ne=L.$iK.parentId(Y.item.extId)?.toString();ne?this.f.get(ne).children.delete(Y.item.extId):this.g.delete(Y);const ee=[[O]];for(;ee.length;)for(const Q of ee.pop()){const X=this.f.get(Q);X&&(ee.push(X.children),this.f.delete(Q),j.remove?.(X,X!==Y),X.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$qK=M}),define(Ce[111],Ie([1,0,8,4,3,61,89,68]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.TestItemEventOp=void 0;var p;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const k=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:k,label:k,description:k,error:k,sortText:k,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),m=(i,n)=>{let r;for(const[a,t]of C)t(i[a],n[a])||(r?r[a]=n[a]:r={[a]:n[a]});return r};class E extends $.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$kh(()=>this.flushDiff(),200)),this.g=this.B(new F.$Yd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,A.$oK)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,A.$oK)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.M(a);return t.isOpen()?this.L(a,r-1):t.wait().then(()=>this.L(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.L(a,r-1)):this.L(a,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,r){switch(r.op){case 3:this.O(v.$iK.joinToString(n.fullId,r.id));break;case 0:this.z(r.item,n);break;case 5:for(const a of r.ops)this.w(n,a);break;case 1:this.C(r.new,r.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.y(n.actual.uri);break;default:(0,L.$9c)(r)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,r){const a=v.$iK.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let h=this.tree.get(a.toString());if(!h){h={fullId:a,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(h.fullId.toString(),h),this.G(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:h.expand,item:this.s.toITestItem(n)}}),this.I(n,h,r);return}if(h.actual===n){this.H(n,h,r);return}if(h.actual.uri?.toString()!==n.uri?.toString())return this.O(a.toString()),this.z(n,r);const c=this.s.getChildren(h.actual),o=h.actual,u=m(this.s.toITestItem(o),this.s.toITestItem(n));this.s.getApiFor(o).listener=void 0,h.actual=n,h.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(n.tags,o.tags,a.toString()),delete u.tags),this.w(h,{op:4,update:u})),this.I(n,h,r);for(const[d,b]of c)this.s.getChildren(n).get(b.id)||this.O(v.$iK.joinToString(a,b.id));this.y(h.actual.uri)}C(n,r,a){const t=new Set(r.map(h=>h.id));for(const h of n)t.delete(h.id)||this.D(h);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(h=>(0,A.$mK)(this.s.controllerId,h.id))}}}),t.forEach(this.F,this)}D(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$mK)(this.s.controllerId,n.id)}}))}F(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,A.$mK)(this.s.controllerId,n)}))}G(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}H(n,r,a){this.G(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=h=>this.w(r,h),this.J(r)}I(n,r,a){this.H(n,r,a);for(const[t,h]of this.s.getChildren(n))this.z(h,r)}J(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.M(n))}L(n,r){if(r<0)return;const a=[];for(const[t,h]of this.s.getChildren(n.actual)){const c=this.expand(v.$iK.joinToString(n.fullId,h.id),r);(0,I.$Wg)(c)&&a.push(c)}if(a.length)return Promise.all(a).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const h=new I.$0g;return h.open(),h}n.expand=2,this.N(n);const r=n.resolveBarrier=new I.$0g,a=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,h)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(h){a(h)}return(0,I.$Wg)(t)?t.catch(a).then(()=>{r.open(),this.J(n)}):(r.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[r];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.F(h.id);this.tree.delete(t.fullId.toString());for(const[h,c]of this.s.getChildren(t.actual))a.push(this.tree.get(v.$iK.joinToString(t.fullId,c.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$zN=E;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$AN=S;class l extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$BN=l;class w extends Error{constructor(n,r,a){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.$CN=w;const s=(i,n,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,h){for(const c of a.values())t.call(h,c,this)},[Symbol.iterator](){return a.entries()},replace(t){const h=new Map,c=new Set(a.keys()),o={op:5,ops:[]};for(const u of t){if(!(u instanceof r))throw new l(u.id);const d=n(u).controllerId;if(d!==i.controllerId)throw new w(u.id,d,i.controllerId);if(h.has(u.id))throw new S(u.id);h.set(u.id,u),c.delete(u.id),o.ops.push({op:0,item:u})}for(const u of c.keys())o.ops.push({op:3,id:u});i.listener?.(o),a=h},add(t){if(!(t instanceof r))throw new l(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$DN=s}),define(Ce[141],Ie([1,0,111]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0;const F=new WeakMap,$=(A,v)=>{const p={controllerId:v};return F.set(A,p),p};e.$EN=$;const L=A=>{const v=F.get(A);if(!v)throw new I.$BN(A?.id||"<unknown>");return v};e.$FN=L}),define(Ce[112],Ie([1,0,16,2]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2wb=e.$1wb=e.$Zwb=e.$Ywb=e.$Xwb=void 0,e.$Xwb="vscode-cdn.net",e.$Ywb=`vscode-resource.${e.$Xwb}`,e.$Zwb=`'self' https://*.${e.$Xwb}`;function $(v,p){return v.scheme===I.Schemas.http||v.scheme===I.Schemas.https?v:(p&&p.authority&&p.isRemote&&v.scheme===I.Schemas.file&&(v=F.URI.from({scheme:I.Schemas.vscodeRemote,authority:p.authority,path:v.path})),F.URI.from({scheme:I.Schemas.https,authority:`${v.scheme}+${L(v.authority)}.${e.$Ywb}`,path:v.path,fragment:v.fragment,query:v.query}))}e.$1wb=$;function L(v){return v.replace(/./g,p=>{const k=p.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?p:"-"+k.toString(16).padStart(4,"0")})}function A(v){return v.replace(/-([0-9a-f]{4})/g,(p,k)=>String.fromCharCode(parseInt(k,16)))}e.$2wb=A}),define(Ce[289],Ie([1,0,4,3,112]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class L{constructor(v,p,k){this.d=v,this.e=p,this.f=k,this.a=0,this.b=new F.$Sc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const C of this.c.values())R.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(v=>v.inset.dispose()),this.b.dispose()}createWebviewEditorInset(v,p,k,R,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===v){m=n;break}if(!m)throw new Error("not a visible editor");const E=this,S=this.a++,l=new I.$Yd,w=new I.$Yd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,$.$1wb)(n,E.f)}get cspSource(){return $.$Zwb}set options(n){this.b=n,E.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,E.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(n){return E.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=v,this.line=p,this.height=k,this.webview=s,this.onDidDispose=w.event}dispose(){E.c.has(S)&&(E.c.delete(S),E.d.$disposeEditorInset(S),w.fire(),w.dispose(),l.dispose())}};return this.d.$createEditorInset(S,m.id,m.value.document.uri,p+1,k,R||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:v,inset:i,onDidReceiveMessage:l}),i}$onDidDispose(v){const p=this.c.get(v);p&&p.inset.dispose()}$onDidReceiveMessage(v,p){this.c.get(v)?.onDidReceiveMessage.fire(p)}}e.$ahc=L}),define(Ce[142],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yK=e.$xK=void 0,e.$xK="__",e.$yK=(0,I.$$h)("IAuthenticationService")}),define(Ce[290],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.VariableKind=e.$vO=void 0,e.$vO=(0,I.$$h)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class $ extends Error{constructor(A,v){super(v),this.variable=A}}e.$wO=$}),define(Ce[291],Ie([1,0,17,49,18,24,11,102,233,290,12]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,S,l,w){this.h=new Map,this.a=E,this.b=S,this.g=l,w&&(this.c=w.then(s=>this.i(s)))}i(E){if(A.$i){const S=Object.create(null);return Object.keys(E).forEach(l=>{S[l.toLowerCase()]=E[l]}),S}return E}resolveWithEnvironment(E,S,l){return this.l({env:this.i(E),userHome:void 0},S?S.uri:void 0,l)}async resolveAsync(E,S){const l={env:await this.c,userHome:await this.g};return this.l(l,E?E.uri:void 0,S)}async j(E,S,l,w){const s=L.$Bn(S);A.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):A.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):A.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,E?E.uri:void 0,s,l,w)}async resolveAnyAsync(E,S,l){return this.j(E,S,l)}async resolveAnyMap(E,S,l){const w=new Map;return{newConfig:await this.j(E,S,l,w),resolvedVariables:w}}resolveWithInteractionReplace(E,S,l,w){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,S,l,w){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,S){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,S)}async l(E,S,l,w,s){if($.$Mf(l))return this.m(E,S,l,w,s);if(Array.isArray(l))return Promise.all(l.map(i=>this.l(E,S,i,w,s)));if($.$Of(l)){const i=Object.create(null),n=await Promise.all(Object.keys(l).map(async r=>[await this.m(E,S,r,w,s),await this.l(E,S,l[r],w,s)]));for(const[r,a]of n)i[r]=a;return i}return l}m(E,S,l,w,s){return(0,R.$8e)(l,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let r=await this.o(E,i,n,S,w);return s?.set(n,r),r!==i&&$.$Mf(r)&&r.match(C.VARIABLE_REGEXP)&&(r=await this.m(E,S,r,w,s)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,S,l,w,s){let i;const n=l.split(":");n.length>1&&(l=n[0],i=n[1]);const r=h=>{const c=this.a.getFilePath();if(c)return(0,v.$2v)(c);throw new k.$wO(h,(0,p.localize)(0,null,S))},a=h=>{const c=r(h);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,v.$2v)(o)}throw new k.$wO(h,(0,p.localize)(1,null,S,I.$nc(c)))},t=h=>{if(i){const c=this.a.getFolderUri(i);if(c)return c;throw new k.$wO(h,(0,p.localize)(2,null,S,i))}if(w)return w;throw this.a.getWorkspaceFolderCount()>1?new k.$wO(h,(0,p.localize)(3,null,S)):new k.$wO(h,(0,p.localize)(4,null,S))};switch(l){case"env":if(i){if(E.env){const h=E.env[A.$i?i.toLowerCase():i];if($.$Mf(h))return h}return""}throw new k.$wO(k.VariableKind.Env,(0,p.localize)(5,null,S));case"config":if(i){const h=this.a.getConfigurationValue(w,i);if($.$Vf(h))throw new k.$wO(k.VariableKind.Config,(0,p.localize)(6,null,S,i));if($.$Of(h))throw new k.$wO(k.VariableKind.Config,(0,p.localize)(7,null,S,i));return h}throw new k.$wO(k.VariableKind.Config,(0,p.localize)(8,null,S));case"command":return this.p(k.VariableKind.Command,S,i,s,"command");case"input":return this.p(k.VariableKind.Input,S,i,s,"input");case"extensionInstallFolder":if(i){const h=await this.a.getExtension(i);if(!h)throw new k.$wO(k.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,S,i));return this.n(h.extensionLocation)}throw new k.$wO(k.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,S));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,v.$2v)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return w||i?(0,v.$2v)(this.n(t(k.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,v.$2v)(I.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new k.$wO(k.VariableKind.UserHome,(0,p.localize)(11,null,S))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new k.$wO(k.VariableKind.LineNumber,(0,p.localize)(12,null,S))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new k.$wO(k.VariableKind.SelectedText,(0,p.localize)(13,null,S))}case"file":return r(k.VariableKind.File);case"fileWorkspaceFolder":return a(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$nc(a(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return w||i?I.$lc(this.n(t(k.VariableKind.RelativeFile)),r(k.VariableKind.RelativeFile)):r(k.VariableKind.RelativeFile);case"relativeFileDirname":{const h=I.$mc(r(k.VariableKind.RelativeFileDirname));if(w||i){const c=I.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),h);return c.length===0?".":c}return h}case"fileDirname":return I.$mc(r(k.VariableKind.FileDirname));case"fileExtname":return I.$oc(r(k.VariableKind.FileExtname));case"fileBasename":return I.$nc(r(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=I.$nc(r(k.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-I.$oc(h).length)}case"fileDirnameBasename":return I.$nc(I.$mc(r(k.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||S}case"execInstallFolder":{const h=this.a.getAppRoot();return h||S}case"pathSeparator":case"/":return I.sep;default:try{const h=i?`${l}:${i}`:l;return this.p(k.VariableKind.Unknown,S,h,s,void 0)}catch{return S}}}}p(E,S,l,w,s){if(l&&w){const i=s===void 0?w[l]:w[s+":"+l];if(typeof i=="string")return i;throw new k.$wO(E,(0,p.localize)(14,null,S))}return S}}e.$KO=C}),define(Ce[143],Ie([1,0,5,139]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$fD=e.OpenEditorContext=e.GroupsOrder=e.$eD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$dD=void 0,e.$dD=(0,I.$$h)("editorGroupsService");var $;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})($||(e.GroupDirection=$={}));var L;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var v;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(v||(e.GroupsArrangement=v={}));var p;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function k(S){const l=S;return(0,F.$ZE)(l?.editor)&&(0,F.$ZE)(l?.replacement)}e.$eD=k;var R;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(S){const l=S;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.$fD=m;function E(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$gD=E}),define(Ce[292],Ie([1,0,5,143]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=void 0,e.$hD=(0,I.$$h)("editorService"),e.$iD=-1,e.$jD=-2,e.$kD=-3;function $(L){const A=L;return typeof L=="number"||(0,F.$fD)(A)}e.$lD=$}),define(Ce[144],Ie([1,0,5,133]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=void 0,e.$OK=(0,I.$_h)(F.$fi)}),define(Ce[145],Ie([1,0,25,4,17,3,8]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=e.$W8b=e.$V8b=e.$U8b=e.$T8b=void 0;class v{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$T8b=v;class p{static isHostExtension(i,n,r){if(n.getExtensionDescription(i))return!1;const a=r.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,n){this.j=i,this.c=new F.$Yd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(l),this.f=new I.$sm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const r of n)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=w(this.e,n),this.e=this.e.concat(i);const r=p.l(this.e);return this.e=w(this.e,r.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new v(this.d,r)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,o){this.addNode(c),this.addNode(o),this.c.has(c)?this.c.get(c).push(o):this.c.set(c,[o])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,o){const u=n.getArcs(c);for(let d=0;d<u.length;d++)if(!o.has(u[d]))return!1;return!0}getNodes(){return this.e}},r=new I.$sm;for(const c of i)if(r.set(c.identifier,c),c.extensionDependencies)for(const o of c.extensionDependencies)n.addArc(I.$qm.toKey(c.identifier),I.$qm.toKey(o));const a=new Set;n.getNodes().filter(c=>n.getArcs(c).length===0).forEach(c=>a.add(c));const t=n.getNodes().filter(c=>!a.has(c));let h;do{h=!1;for(let c=0;c<t.length;c++){const o=t[c];n.hasOnlyGoodArcs(o,a)&&(t.splice(c,1),c--,a.add(o),h=!0)}}while(h);return t.map(c=>r.get(c))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$U8b=p;class k{constructor(i,n){this.versionId=i,this.extensions=n}}e.$V8b=k;class R{constructor(i){this.d=new E,this.c=new p(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new C(this,n)}deltaExtensions(i,n,r){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,r)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$W8b=R;class C extends L.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$X8b=C;class m{constructor(i){this.name=i;const n=(0,A.$4g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class E{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new m(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const r=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{n&&(clearTimeout(r),n=!1,this.d=!1,this.e())};i.resolve((0,L.$Rc)(a))}}var S;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(S||(S={}));function l(s,i){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,r=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==r)return n-r;const a=$.$gc.basename(s.extensionLocation.path),t=$.$gc.basename(i.extensionLocation.path);return a<t?-1:a>t?1:0}function w(s,i){const n=new I.$rm(i);return s.filter(r=>!n.has(r.identifier))}}),define(Ce[293],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.ExtHostConnectionType=void 0;var I;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[F.ENV_KEY]=this.pipeName}}e.$Vm=F;class ${constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[$.ENV_KEY]="1"}}e.$Wm=$;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[L.ENV_KEY]="1"}}e.$Xm=L;function A(R){delete R[F.ENV_KEY],delete R[$.ENV_KEY],delete R[L.ENV_KEY]}function v(R,C){A(C),R.serialize(C)}e.$Ym=v;function p(R){if(R[F.ENV_KEY])return k(R,new F(R[F.ENV_KEY]));if(R[$.ENV_KEY])return k(R,new $);if(R[L.ENV_KEY])return k(R,new L);throw new Error("No connection information defined in environment!")}e.$Zm=p;function k(R,C){return A(R),C}}),define(Ce[113],Ie([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$zm=e.$ym=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(F||(e.UIKind=F={}));var $;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})($||(e.ExtensionHostExitCode=$={}));var L;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(k){const R=I.$me.alloc(1);switch(k){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$ym=A;function v(k,R){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$zm=v;var p;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[90],Ie([1,0,5,4,13,27,113,66,87,24,2,3,219]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=e.$2N=e.$1N=void 0;let E=class extends C.$Tc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new F.$Yd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Yd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:p.$Vo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,$.$uj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===$.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const r=this.getTelemetryDetails(),a=new S(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=l(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:i["common.uikind"]="web";break;case A.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.$gl)((0,p.$2o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(r):this.r.set(r,a)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const r=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(s.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$1N=E,e.$1N=E=Je([We(0,L.$ZN),We(1,$.$tj)],E);class S{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,r,a,t,h){this.g=n,this.h=r,this.i=a,this.j=t,this.a=new F.$Yd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,p.$5o)(i,[]),this.c&&(i=(0,k.$En)(i,this.c)),this.b||(i=(0,k.$En)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},r=(0,p.$5o)(n,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$2N=S;function l(w){const s=Date.now()-new Date(w).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$3N=l,e.$4N=(0,I.$$h)("IExtHostTelemetry")}),define(Ce[26],Ie([1,0,4,2,263,137,25,5]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=e.$RF=e.ActivationKind=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.ExtensionHostStartup=e.$LF=e.$KF=e.$JF=e.$IF=void 0,e.$IF=Object.freeze({identifier:new A.$qm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$JF="extensions.webWorker",e.$KF=(0,v.$$h)("extensionService");class p{constructor(a){this.dependency=a}}e.$LF=p;var k;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,h){this.c=a,this.d=t.slice(0),this.e=h.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$tF.createActivationEventsMap(this.d)}}set(a,t,h){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const c=[],o=[],u=[],d=[],b=C(this.d),D=C(t),g=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.d){const z=D.get(U.identifier);if(!z){c.push(U.identifier),b.delete(U.identifier);continue}if(!g(U,z)){c.push(U.identifier),b.delete(U.identifier);continue}}for(const U of t){const z=b.get(U.identifier);if(!z){o.push(U);continue}if(!g(z,U)){c.push(z.identifier),b.delete(z.identifier);continue}}const f=new A.$rm(this.e),y=new A.$rm(h);for(const U of this.e)y.has(U)||u.push(U);for(const U of h)f.has(U)||d.push(U);const P=L.$tF.createActivationEventsMap(o),T={versionId:a,toRemove:c,toAdd:o,addActivationEvents:P,myToRemove:u,myToAdd:d};return this.delta(T),T}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:c,myToAdd:o}=a,u=new A.$rm(t),d=new A.$rm(c);for(let b=0;b<this.d.length;b++)u.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)d.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of h)this.d.push(b);for(const b of o)this.e.push(b);return this.f=null,a}containsExtension(a){for(const t of this.e)if(A.$qm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const h=L.$tF.readActivationEvents(t);for(const c of h)a.add(c)}return a}}e.$MF=R;function C(r){const a=new A.$sm;for(const t of r)a.set(t.identifier,t);return a}function m(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.$NF=m;function E(r,a){if(!m(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$OF=E;class S{constructor(a,t,h,c){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=c}}e.$PF=S;class l{constructor(a,t){this.description=a,this.value=t}}e.$QF=l;var w;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(w||(e.ActivationKind=w={}));function s(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,$.$$o)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$RF=s;function i(r,a){return{identifier:new A.$qm((0,$.$9o)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$SF=i;class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$TF=n}),define(Ce[294],Ie([1,0,14,145,25,26,13,8]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=e.$xhc=e.$whc=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(s,i,n,r){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$whc=p;class k{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$xhc=k;class R{constructor(s,i,n,r,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=a,this.subscriptions=t}}e.$yhc=R;class C extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$zhc=C;class m extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ahc=m;class E extends R{constructor(s){super(!0,s,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(s,i,n,r){this.g=r,this.a=s,this.b=i,this.c=n,this.d=new $.$sm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new E(a));return this.c.onExtensionActivationError(s.id,a,new L.$LF(s.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of r){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const h=this.a.getExtensionDescription(a);if(h){if(!h.main&&!h.browser)continue;n.push(this.j({id:h.identifier,reason:s.reason}));continue}const c=i.displayName||i.identifier.value,o=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${a}'`),u=this.k(s,i.displayName,[],new E(o));return this.c.onExtensionActivationError(i.identifier,o,new L.$LF(a)),u}return this.k(s,i.displayName,n,null)}k(s,i,n,r){const a=new l(s.id,i,s.reason,n,r,this.c,this.g);return this.d.set(s.id,a),a}l(s){return F.$U8b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$Bhc=S,e.$Bhc=S=Je([We(3,A.$sj)],S);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,r,a,t,h){this.c=s,this.d=i,this.f=n,this.g=r,this.h=a,this.j=t,this.k=h,this.a=new v.$0g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new E(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new E(i),this.b&&I.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};l=Je([We(6,A.$sj)],l)}),define(Ce[295],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[296],Ie([1,0,235,14,39,134,108,37,25,295,136,137]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=void 0;const m=v.$Nn.as(A.$On.JSONContribution);class E{constructor(a,t,h){this.a=a,this.b=t,this.c=h}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d($.default.Error,a)}warn(a){this.d($.default.Warning,a)}info(a){this.d($.default.Info,a)}}e.$CF=E;class S{static a(a){const t=new p.$rm;for(let h=0,c=a.length;h<c;h++)t.add(a[h].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const h=this.a(a),c=this.a(t),o=t.filter(d=>!h.has(d.description.identifier)),u=a.filter(d=>!c.has(d.description.identifier));return new S(o,u)}constructor(a,t){this.added=a,this.removed=t}}e.$DF=S;class l{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,F.$1)(a)}}}e.$EF=l;const w={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$FF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$pm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$so}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$so}},extensionKind:{description:I.localize(52,null),type:"array",items:w,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new l(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&C.$tF.register(a.extensionPoint,a.activationEventsGenerator),e.$FF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,m.registerSchema(s,e.$FF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$GF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};v.$Nn.add(n.ExtensionsRegistry,new i),e.$HF=v.$Nn.as(n.ExtensionsRegistry),m.registerSchema(s,e.$FF),m.registerSchema(R.$Lj,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(Ce[297],Ie([1,0,231,18,24,296,45,4]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var k;(function(m){function E(S,l,w){if(!S)return;const s=F.$Mf(S.type)?S.type:void 0;if(!s||s.length===0){w.error(I.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)F.$Mf(n)&&i.push(n);return{extensionId:l.value,taskType:s,required:i,properties:S.properties?$.$Bn(S.properties):{},when:S.when?A.$9i.deserialize(S.when):void 0}}m.from=E})(k||(k={}));const R=L.$HF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,E)=>{for(const S of m)S.type&&E.push(`onTaskType:${S.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:p}});class C{constructor(){this.d=new v.$Yd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,S)=>{R.setHandler((l,w)=>{this.c=void 0;try{for(const s of w.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of w.added){const i=s.value;for(const n of i){const r=k.from(n,s.description.identifier,s.collector);r&&(this.a[r.taskType]=r)}}(w.removed.length>0||w.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const S of this.all()){const l={type:"object",additionalProperties:!1};S.required.length>0&&(l.required=S.required.slice(0)),S.properties!==void 0?l.properties=$.$Bn(S.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[S.taskType]},E.push(l)}this.c={oneOf:E}}return this.c}}e.$GG=new C}),define(Ce[298],Ie([1,0,232,18,23,24,45,297]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$QG=e.JsonSchemaVersion=e.ExecutionEngine=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$KG=e.ShellQuoting=e.$JG=e.$IG=e.$HG=void 0,e.$HG="settings",e.$IG=new A.$pj("taskRunning",!1,I.localize(0,null)),e.$JG=I.localize2(2,"Tasks");var p;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$KG="$customized",function(N){function O(j){if(!j)return N.Strong;switch(j.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=O}(p||(e.ShellQuoting=p={}));var k;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R||(e.RevealKind=R={})),function(N){function O(j){switch(j.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=O}(R||(e.RevealKind=R={}));var C;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(N){function O(j){switch(j.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=O}(C||(e.RevealProblemKind=C={}));var m;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(m||(e.PanelKind=m={})),function(N){function O(j){switch(j.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=O}(m||(e.PanelKind=m={}));var E;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var S;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(N){function O(Y){switch(Y.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=O;function j(Y){switch(Y){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=j}(S||(e.RuntimeType=S={}));var l;(function(N){function O(j){return F.$Mf(j)?j:j.value}N.value=O})(l||(e.CommandString=l={}));var w;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function O(Y){return Y===N.Clean._id||Y===N.Build._id||Y===N.Rebuild._id||Y===N.Test._id}N.is=O;function j(Y){if(Y!==void 0)return F.$Mf(Y)?O(Y)?{_id:Y,isDefault:!1}:void 0:Y}N.from=j})(w||(e.TaskGroup=w={}));var s;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function O(j){switch(j){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(N){N.parallel="parallel",N.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(O,j,Y,ne,ee,Q){this._label="",this._id=O,j&&(this._label=j),Y&&(this.type=Y),this.runOptions=ne,this.configurationProperties=ee,this._source=Q}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,j=!1){if(O===void 0)return!1;if(F.$Mf(O))return O===this._label||O===this.configurationProperties.identifier||j&&O===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$LG=t;class h extends t{constructor(O,j,Y,ne,ee,Q,X,ce){super(O,Y,void 0,X,ce,j),this.command={},this._source=j,this.hasDefinedMatchers=Q,ee&&(this.command=ee)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case S.Shell:j="shell";break;case S.Process:j="process";break;case S.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(O){return O instanceof h}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$HG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let j=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(j+=this._source.kind);const Y={type:e.$KG,folder:O,id:j};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?$.$Ig(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new h(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$MG=h;class c extends t{constructor(O,j,Y,ne,ee,Q,X){super(O,Y,ne,Q,X,j),this._source=j,this.configures=ee}static is(O){return O instanceof c}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?$.$Ig(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$HG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let j=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(j+=this._source.kind);const Y={type:e.$KG,folder:O,id:j};return JSON.stringify(Y)}}e.$NG=c;class o extends t{constructor(O,j,Y,ne,ee,Q,X,ce,ie){super(O,Y,ne,ce,ie,j),this.defines=ee,this.hasDefinedMatchers=X,this.command=Q,this.icon=ie.icon,this.hide=ie.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof o}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new o(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$OG=o;class u extends t{constructor(O,j,Y,ne,ee,Q){super(O,Y,ne,ee,Q,j),this._source=j}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new u(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$PG=u;var d;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(N){N._default=N.Terminal}(d||(e.ExecutionEngine=d={}));var b;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class D{constructor(O){this.c=new Map;for(let j=0;j<O.length;j++)this.c.set(O[j].uri.toString(),j)}compare(O,j){const Y=O.getWorkspaceFolder(),ne=j.getWorkspaceFolder();if(Y&&ne){let ee=this.c.get(Y.uri.toString());ee=ee===void 0?0:ee+1;let Q=this.c.get(ne.uri.toString());return Q=Q===void 0?0:Q+1,ee===Q?O._label.localeCompare(j._label):ee-Q}else return!Y&&ne?-1:Y&&!ne?1:0}}e.$QG=D;var g;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(g||(e.TaskEventKind=g={}));var f;(function(N){N.SingleRun="singleRun",N.Background="background"})(f||(e.TaskRunType=f={}));var y;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(N){function O(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function j(ce,ie,fe){return{...O(ce),kind:"start",terminalId:ie,resolvedVariables:fe}}N.start=j;function Y(ce,ie,fe){return{...O(ce),kind:"processStarted",terminalId:ie,processId:fe}}N.processStarted=Y;function ne(ce,ie,fe){return{...O(ce),kind:"processEnded",terminalId:ie,exitCode:fe}}N.processEnded=ne;function ee(ce,ie,fe){return{...O(ce),kind:"terminated",exitReason:fe,terminalId:ie}}N.terminated=ee;function Q(ce,ie,fe){return{...O(ie),kind:ce,terminalId:fe}}N.general=Q;function X(){return{kind:"changed"}}N.changed=X})(P||(e.TaskEvent=P={}));var T;(function(N){function O(Y){const ne=Object.keys(Y).sort();let ee="";for(const Q of ne){let X=Y[Q];X instanceof Object?X=O(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),ee+=Q+","+X+","}return ee}function j(Y){const ee={_key:O(Y),type:Y.taskType};return Object.assign(ee,Y),ee}N.create=j})(T||(e.KeyedTaskIdentifier=T={}));var U;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var z;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var M;(function(N){function O(j,Y){const ne=v.$GG.get(j.type);if(ne===void 0){const ce=L.$Bn(j);return delete ce._key,T.create(ce)}const ee=Object.create(null);ee.type=ne.taskType;const Q=new Set;ne.required.forEach(ce=>Q.add(ce));const X=ne.properties;for(const ce of Object.keys(X)){const ie=j[ce];if(ie!=null)ee[ce]=ie;else if(Q.has(ce)){const fe=X[ce];if(fe.default!==void 0)ee[ce]=L.$Bn(fe.default);else switch(fe.type){case"boolean":ee[ce]=!1;break;case"number":case"integer":ee[ce]=0;break;case"string":ee[ce]="";break;default:Y.error(I.localize(1,null,JSON.stringify(j,void 0,0),ce));return}}}return T.create(ee)}N.createTaskIdentifier=O})(M||(e.TaskDefinition=M={}))}),define(Ce[299],Ie([1,0,14]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=e.$Y8b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,v)=>{this.b=A,this.d=v,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,I.$1)(A))}then(A,v){return this.j().then(A,v)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Y8b=F;class $ extends F{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$Z8b=$}),define(Ce[69],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;class I{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++I.count}}e.$Vv=I;const F=[];function $(v){const p=new I(v);return F[p.nid]=p,p}e.$Wv=$;function L(v){return F[v].sid}e.$Xv=L;class A{constructor(p){this.value=p}}e.$Yv=A}),define(Ce[6],Ie([1,0,69]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sL=e.$rL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$qL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var $;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput",l[l.ChatEditorInput=10]="ChatEditorInput"})($||(e.TabInputKind=$={}));var L;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var v;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(v||(e.WebviewMessageArrayBufferViewType=v={}));var p;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var R;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class C{static{this.a=0}static mixin(w){return w._id=C.a++,w}}e.$qL=C;var m;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var E;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var S;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$rL={MainThreadAuthentication:(0,I.$Wv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$Wv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.$Wv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,I.$Wv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$Wv)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$Wv)("MainThreadClipboard"),MainThreadCommands:(0,I.$Wv)("MainThreadCommands"),MainThreadComments:(0,I.$Wv)("MainThreadComments"),MainThreadConfiguration:(0,I.$Wv)("MainThreadConfiguration"),MainThreadConsole:(0,I.$Wv)("MainThreadConsole"),MainThreadDebugService:(0,I.$Wv)("MainThreadDebugService"),MainThreadDecorations:(0,I.$Wv)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$Wv)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$Wv)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$Wv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$Wv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$Wv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$Wv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$Wv)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$Wv)("MainThreadErrors"),MainThreadTreeViews:(0,I.$Wv)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$Wv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$Wv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$Wv)("MainThreadLanguages"),MainThreadLogger:(0,I.$Wv)("MainThreadLogger"),MainThreadMessageService:(0,I.$Wv)("MainThreadMessageService"),MainThreadOutputService:(0,I.$Wv)("MainThreadOutputService"),MainThreadProgress:(0,I.$Wv)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$Wv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$Wv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$Wv)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$Wv)("MainThreadSecretState"),MainThreadStorage:(0,I.$Wv)("MainThreadStorage"),MainThreadSpeech:(0,I.$Wv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$Wv)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$Wv)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$Wv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$Wv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$Wv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$Wv)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$Wv)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$Wv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$Wv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$Wv)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$Wv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$Wv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$Wv)("MainThreadExtensionService"),MainThreadSCM:(0,I.$Wv)("MainThreadSCM"),MainThreadSearch:(0,I.$Wv)("MainThreadSearch"),MainThreadShare:(0,I.$Wv)("MainThreadShare"),MainThreadTask:(0,I.$Wv)("MainThreadTask"),MainThreadWindow:(0,I.$Wv)("MainThreadWindow"),MainThreadLabelService:(0,I.$Wv)("MainThreadLabelService"),MainThreadNotebook:(0,I.$Wv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$Wv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$Wv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$Wv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$Wv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$Wv)("MainThreadInteractive"),MainThreadChat:(0,I.$Wv)("MainThreadChat"),MainThreadInlineChat:(0,I.$Wv)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$Wv)("MainThreadTheming"),MainThreadTunnelService:(0,I.$Wv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$Wv)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$Wv)("MainThreadTimeline"),MainThreadTesting:(0,I.$Wv)("MainThreadTesting"),MainThreadLocalization:(0,I.$Wv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$Wv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$Wv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$Wv)("MainThreadIssueReporter")},e.$sL={ExtHostCommands:(0,I.$Wv)("ExtHostCommands"),ExtHostConfiguration:(0,I.$Wv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$Wv)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$Wv)("ExtHostDebugService"),ExtHostDecorations:(0,I.$Wv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$Wv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$Wv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$Wv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$Wv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$Wv)("ExtHostEditors"),ExtHostTreeViews:(0,I.$Wv)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$Wv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$Wv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$Wv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$Wv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$Wv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$Wv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$Wv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$Wv)("ExtHostStatusBar"),ExtHostShare:(0,I.$Wv)("ExtHostShare"),ExtHostExtensionService:(0,I.$Wv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$Wv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$Wv)("ExtHostTerminalService"),ExtHostSCM:(0,I.$Wv)("ExtHostSCM"),ExtHostSearch:(0,I.$Wv)("ExtHostSearch"),ExtHostTask:(0,I.$Wv)("ExtHostTask"),ExtHostWorkspace:(0,I.$Wv)("ExtHostWorkspace"),ExtHostWindow:(0,I.$Wv)("ExtHostWindow"),ExtHostWebviews:(0,I.$Wv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$Wv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$Wv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$Wv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$Wv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$Wv)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$Wv)("ExtHostProgress"),ExtHostComments:(0,I.$Wv)("ExtHostComments"),ExtHostSecretState:(0,I.$Wv)("ExtHostSecretState"),ExtHostStorage:(0,I.$Wv)("ExtHostStorage"),ExtHostUrls:(0,I.$Wv)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$Wv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$Wv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$Wv)("ExtHostOutputService"),ExtHostLabelService:(0,I.$Wv)("ExtHostLabelService"),ExtHostNotebook:(0,I.$Wv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$Wv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$Wv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$Wv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$Wv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$Wv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$Wv)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$Wv)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$Wv)("ExtHostChat"),ExtHostChatAgents2:(0,I.$Wv)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$Wv)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$Wv)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$Wv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$Wv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$Wv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$Wv)("ExtHostTheming"),ExtHostTunnelService:(0,I.$Wv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$Wv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$Wv)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$Wv)("ExtHostTimeline"),ExtHostTesting:(0,I.$Wv)("ExtHostTesting"),ExtHostTelemetry:(0,I.$Wv)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$Wv)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$Wv)("ExtHostIssueReporter")}}),define(Ce[91],Ie([1,0,5,13,6,20]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=e.$Ugc=void 0,e.$Ugc=(0,I.$$h)("IExtHostApiDeprecationService");let A=class{constructor(p,k){this.c=k,this.a=new Set,this.b=p.getProxy($.$rL.MainThreadTelemetry)}report(p,k,R){const C=this.d(p,k);this.a.has(C)||(this.a.add(C),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:p}))}d(p,k){return`${p}-${k.identifier.value}`}};e.$Vgc=A,e.$Vgc=A=Je([We(0,L.$JN),We(1,F.$sj)],A),e.$Wgc=Object.freeze(new class{report(v,p,k){}})}),define(Ce[300],Ie([1,0,53,3,6]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class L{static{this.a=0}constructor(p,k){this.extension=p,this.provider=k,this.handle=L.a++}}class A{static{this.a=0}constructor(p){this.b=new Map,this.c=new Map,this.d=p.getProxy($.$rL.MainThreadChat)}registerChatProvider(p,k,R){const C=new L(p,R);return this.b.set(C.handle,C),this.d.$registerChatProvider(C.handle,k),(0,F.$Rc)(()=>{this.d.$unregisterChatProvider(C.handle),this.b.delete(C.handle)})}transferChatSession(p,k){const R=I.Iterable.find(this.c.keys(),C=>this.c.get(C)===p)??0;typeof R=="number"&&this.d.$transferChatSession(R,k)}sendInteractiveRequestToProvider(p,k){this.d.$sendRequestToProvider(p,k)}async $prepareChat(p,k){const R=this.b.get(p);if(!R)return;const C=await R.provider.prepareSession(k);if(!C)return;const m=A.a++;return this.c.set(m,C),{id:m,requesterUsername:C.requester?.name,requesterAvatarIconUri:C.requester?.icon,responderUsername:C.responder?.name,responderAvatarIconUri:C.responder?.icon,inputPlaceholder:C.inputPlaceholder}}$releaseSession(p){this.c.delete(p)}}e.$7gc=A}),define(Ce[301],Ie([1,0,6]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class F{constructor(L){const A=L.getProxy(I.$rL.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(v){return A.$writeText(v)}})}}e.$$gc=F}),define(Ce[302],Ie([1,0,24,6,27,20]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let A=class{constructor(R,C){this.a=R.getProxy(F.$rL.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,C){const m=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m.e(R,C,E,arguments)}})}e(R,C,m,E){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:p(E,this.b)}),this.c&&this.f(R,m,E)}};e.$2ic=A,e.$2ic=A=Je([We(0,L.$JN),We(1,$.$ZN)],A);const v=1e5;function p(k,R){const C=[];if(k.length)for(let m=0;m<k.length;m++){let E=k[m];if(typeof E>"u")E="undefined";else if(E instanceof Error){const S=E;S.stack?E=S.stack:E=S.toString()}C.push(E)}if(R){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,I.$Gn)(C);return m.length>v?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[303],Ie([1,0,2,6,26]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class L{constructor(v){this.a=v.getProxy(F.$rL.MainThreadDialogs)}showOpenDialog(v,p){return p?.allowUIResources&&(0,$.$OF)(v,"showLocal"),this.a.$showOpenDialog(p).then(k=>k?k.map(R=>I.URI.revive(R)):void 0)}showSaveDialog(v){return this.a.$showSaveDialog(v).then(p=>p?I.URI.revive(p):void 0)}}e.$6hc=L}),define(Ce[304],Ie([1,0,3,6]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class ${constructor(A){this.b=0,this.a=A.getProxy(F.$rL.MainThreadLabelService)}$registerResourceLabelFormatter(A){const v=this.b++;return this.a.$registerResourceLabelFormatter(v,A),(0,I.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(v)})}}e.$oic=$}),define(Ce[114],Ie([1,0,11,12,2,5,13,6,27,20]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=void 0;let R=class{constructor(m,E,S){this.f=S,this.d=new Map,this.a=E.getProxy(v.$rL.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===I.$g}getMessage(m,E){const{message:S,args:l,comment:w}=E;if(this.c)return(0,F.$Oe)(S,l??{});let s=S;w&&w.length>0&&(s+=`/${Array.isArray(w)?w.join(""):w}`);const i=this.d.get(m)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$Oe)(i??S,l??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let E;const S=await this.g(m);if(!S){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(S),w=JSON.parse(l);E=m.isBuiltin?w.contents?.bundle:w}catch(l){this.f.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${l.message}`);return}E&&this.d.set(m.identifier.value,{contents:E,uri:S})}async g(m){if(m.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return $.URI.revive(E)}return m.l10n?$.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Nhc=R,e.$Nhc=R=Je([We(0,p.$ZN),We(1,k.$JN),We(2,A.$sj)],R),e.$Ohc=(0,L.$$h)("IExtHostLocalizationService")}),define(Ce[146],Ie([1,0,13,6,27,20,2,56]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;let p=class extends I.$Dj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(E=>(0,v.$Hh)(E))),this.r=C.getProxy(F.$rL.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(A.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,E){return new k(this.r,C,m,E)}};e.$1ic=p,e.$1ic=p=Je([We(0,L.$JN),We(1,$.$ZN)],p);class k extends I.$yj{constructor(C,m,E,S){super(S?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(m,S).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const E=[[C,m]];this.m?this.u(E):this.n.push(...E)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Ce[115],Ie([1,0,6,5,3,20,21]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0,e.$Phc=(0,F.$$h)("IExtHostManagedSockets");let v=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(I.$rL.MainThreadManagedSockets)}setFactory(C,m){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,E=await this.c.makeConnection(),S=new $.$Sc;return this.d.set(m,new k(m,E,S)),S.add((0,$.$Rc)(()=>this.d.delete(m))),S.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),S.dispose()})),S.add(E.onDidClose(l=>{this.a.$onDidManagedSocketClose(m,l?.stack??l?.message),S.dispose()})),S.add(E.onDidReceiveMessage(l=>this.a.$onDidManagedSocketHaveData(m,A.$me.wrap(l)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$Qhc=v,e.$Qhc=v=Je([We(0,L.$JN)],v);class p{constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class k extends $.$Tc{constructor(C,m,E){super(),this.socketId=C,this.actual=m,this.B(E)}}}),define(Ce[305],Ie([1,0,6,13,26]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;function L(v){return v&&v.title}let A=class{constructor(p,k){this.b=k,this.a=p.getProxy(I.$rL.MainThreadMessageService)}showMessage(p,k,R,C,m){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let S;typeof C=="string"||L(C)?S=[C,...m]:(E.modal=C?.modal,E.useCustom=C?.useCustom,E.detail=C?.detail,S=m),E.useCustom&&(0,$.$OF)(p,"resolvers");const l=[];let w=!1;for(let s=0;s<S.length;s++){const i=S[s];if(typeof i=="string")l.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:r}=i;l.push({title:n,isCloseAffordance:!!r,handle:s}),r&&(w?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,i):w=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,i)}return this.a.$showMessage(k,R,E,l).then(s=>{if(typeof s=="number")return S[s]})}};e.$qic=A,e.$qic=A=Je([We(1,F.$sj)],A)}),define(Ce[306],Ie([1,0,3,18,2,26,6]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;class v{constructor(k){this.b=new Map,this.a=k.getProxy(A.$rL.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,R,C){if((0,L.$OF)(k,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,C),this.a.$registerProfileContentHandler(R,C.name,C.description,k.identifier.value),(0,I.$Rc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(k,R,C,m){const E=this.b.get(k);if(!E)throw new Error(`Unknown handler with id: ${k}`);return E.saveProfile(R,C,m)}async $readProfile(k,R,C){const m=this.b.get(k);if(!m)throw new Error(`Unknown handler with id: ${k}`);return m.readProfile((0,F.$Mf)(R)?R:$.URI.revive(R),C)}}e.$zic=v}),define(Ce[116],Ie([1,0,6,4,5]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=void 0;class L{constructor(v){this.b=new F.$Yd,this.onDidChangePassword=this.b.event,this.a=v.getProxy(I.$rL.MainThreadSecretState)}async $onDidChangePassword(v){this.b.fire(v)}get(v,p){return this.a.$getPassword(v,p)}store(v,p,k){return this.a.$setPassword(v,p,k)}delete(v,p){return this.a.$deletePassword(v,p)}}e.$Khc=L,e.$Lhc=(0,$.$$h)("IExtHostSecretState")}),define(Ce[307],Ie([1,0,22,3,6]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;class L{static{this.a=1}constructor(v){this.c=new Map,this.d=new Map,this.b=v.getProxy($.$rL.MainThreadSpeech)}async $createSpeechToTextSession(v,p){const k=this.c.get(v);if(!k)return;const R=new F.$Sc,C=new I.$9d;this.d.set(p,C);const m=R.add(k.provideSpeechToTextSession(C.token));R.add(m.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,E)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}async $createKeywordRecognitionSession(v,p){const k=this.c.get(v);if(!k)return;const R=new F.$Sc,C=new I.$9d;this.d.set(p,C);const m=R.add(k.provideKeywordRecognitionSession(C.token));R.add(m.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),R.add(C.token.onCancellationRequested(()=>R.dispose()))}async $cancelKeywordRecognitionSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}registerProvider(v,p,k){const R=L.a++;return this.c.set(R,k),this.b.$registerProvider(R,p,{extension:v,displayName:v.value}),(0,F.$Rc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Gic=L}),define(Ce[117],Ie([1,0,6,4,5]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=void 0;class L{constructor(v,p){this.c=p,this.b=new F.$Yd,this.onDidChangeStorage=this.b.event,this.a=v.getProxy(I.$rL.MainThreadStorage)}registerExtensionStorageKeysToSync(v,p){this.a.$registerExtensionStorageKeysToSync(v,p)}async initializeExtensionStorage(v,p,k){const R=await this.a.$initializeExtensionStorage(v,p);let C;return R&&(C=this.d(v,p,R)),C||k}setValue(v,p,k){return this.a.$setValue(v,p,k)}$acceptValue(v,p,k){const R=this.d(v,p,k);R&&this.b.fire({shared:v,key:p,value:R})}d(v,p,k){try{return JSON.parse(k)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${v}): ${R}`)}}}e.$Chc=L,e.$Dhc=(0,$.$$h)("IExtHostStorage")}),define(Ce[308],Ie([1,0,3,16,2,6]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(L.$rL.MainThreadUriOpeners)}registerExternalUriOpener(p,k,R,C){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const m=C.schemes.find(E=>!A.a.has(E));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(k,R),this.b.$registerUriOpener(k,C.schemes,p,C.label),(0,I.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri(p,k,R){const C=this.c.get(p);if(!C)throw new Error(`Unknown opener with id: ${p}`);const m=$.URI.revive(k);return C.canOpenExternalUri(m,R)}async $openUri(p,k,R){const C=this.c.get(p);if(!C)throw new Error(`Unknown opener id: '${p}'`);return C.openExternalUri($.URI.revive(k.resolvedUri),{sourceUri:$.URI.revive(k.sourceUri)},R)}}e.$Uic=A}),define(Ce[309],Ie([1,0,6,2,3,14,25]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;class v{static{this.a=0}constructor(k){this.c=new A.$rm,this.d=new Map,this.b=k.getProxy(I.$rL.MainThreadUrls)}registerUriHandler(k,R){const C=k.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=v.a++;return this.c.add(C),this.d.set(m,R),this.b.$registerUriHandler(m,C,k.displayName||k.name),(0,$.$Rc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(k,R){const C=this.d.get(k);if(!C)return Promise.resolve(void 0);try{C.handleUri(F.URI.revive(R))}catch(m){(0,L.$1)(m)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this.b.$createAppUri(k))}}e.$Vic=v}),define(Ce[92],Ie([1,0,4,3,16,24,2,239,276,112,6]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=e.$qhc=e.$phc=e.$ohc=e.$nhc=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,a,t,h,c,o,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$Yd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$Yd,this._onDidDispose=this.#h.event,this.#e=r,this.#t=a,this.#o=t,this.#n=h,this.#s=c,this.#r=o,this.#l=m(o),this.#d=E(o),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,k.$1wb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===$.Schemas.https||r.scheme===$.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+k.$Zwb}return k.$Zwb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),L.$Fn(this.#o,r)||this.#t.$setOptions(this.#e,w(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const a=(0,p.$emb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const a=this.#r.extensionLocation?.scheme===$.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===$.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,c,o,u,d,b)=>{const D=A.URI.from({scheme:u||"file",path:decodeURIComponent(d)}),g=(0,k.$1wb)(D,{isRemote:a,authority:t}).toString();return`${c}${g}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,c,o,u,d,b)=>{const D=A.URI.from({scheme:u||"file",path:decodeURIComponent(d)}),g=(0,k.$1wb)(D,{isRemote:a,authority:t}).toString();return`${c}${g}${b}`})}}e.$nhc=C;function m(n){try{const r=(0,v.$hp)((0,v.$gp)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$ohc=m;function E(n){try{const r=(0,v.$hp)((0,v.$gp)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class S extends F.$Tc{constructor(r,a,t,h,c){super(),this.c=a,this.f=t,this.g=h,this.h=c,this.b=new Map,this.a=r.getProxy(R.$rL.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,a,t){const h=this.j(r);if(h){const{message:c}=(0,p.$fmb)(a,t.value);h._onMessageEmitter.fire(c)}}$onMissingCsp(r,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const h=new C(r,this.a,s(a),this.c,this.f,t,this.h);this.b.set(r,h);const c=h._onDidDispose(()=>{c.dispose(),this.deleteWebview(r)});return h}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$phc=S;function l(n){return{id:n.identifier,location:n.extensionLocation}}e.$qhc=l;function w(n,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,r)}}e.$rhc=w;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>A.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(Ce[147],Ie([1,0,4,6,2,16,12,5,20,26]),function(me,e,I,F,$,L,A,v,p,k){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=e.$Xic=void 0;let C=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(E){const S=this.d;return{get focused(){return S.focused},get active(){return(0,k.$OF)(E,"windowActivity"),S.active}}}constructor(E){this.c=new I.$Yd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=E.getProxy(F.$rL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:l})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",l)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,S){S!==this.d[E]&&(this.d={...this.d,[E]:S},this.c.fire(this.d))}openUri(E,S){let l;if(typeof E=="string"){l=E;try{E=$.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,A.$Me)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,l,S)}async asExternalUri(E,S){if((0,A.$Me)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const l=await this.b.$asExternalUri(E,S);return $.URI.from(l)}};e.$Xic=C,e.$Xic=C=R=Je([We(0,p.$JN)],C),e.$Yic=(0,v.$$h)("IExtHostWindow")}),define(Ce[310],Ie([1,0,302,27,20]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=void 0;const L=1024*1024;let A=class extends I.$2ic{constructor(p,k){super(p,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(p,k,R){const C=p==="error"||p==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),k.apply(console,R),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(p,k){const R=process[p],C=R.write;let m="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(E,S,l)=>{if(!this.g){m+=E.toString(S);const w=m.length>L?m.length:m.lastIndexOf(`
`);w!==-1&&(console[k](m.slice(0,w)),m=m.slice(w+1))}C.call(R,E,S,l)}})}};e.$Ajc=A,e.$Ajc=A=Je([We(0,$.$JN),We(1,F.$ZN)],A)}),define(Ce[311],Ie([1,0,146,16,253,30]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;class A extends I.$1ic{s(p,k,R){return p.scheme===F.Schemas.file?new $.$VO(R?.name||(0,L.$ug)(),p.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,k):super.s(p,k,R)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$Mjc=A}),define(Ce[312],Ie([1,0,8,21,22,14,4,3,130,299,69]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=e.ResponsiveState=e.RequestInitiator=e.$28b=e.$18b=void 0;function m(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const E="$$ref$$",S={[E]:-1};class l{constructor(P,T){this.jsonString=P,this.referencedBuffers=T}}function w(y,P=null,T=!1){const U=[];return{jsonString:(T?m:JSON.stringify)(y,(M,N)=>{if(typeof N>"u")return S;if(typeof N=="object"){if(N instanceof F.$me){const O=U.push(N)-1;return{[E]:O}}if(P)return P(M,N)}return N}),referencedBuffers:U}}e.$18b=w;function s(y,P,T){return JSON.parse(y,(U,z)=>{if(z){const M=z[E];if(typeof M=="number")return P[M];if(T&&z.$mid===1)return T.transformIncoming(z)}return z})}e.$28b=s;function i(y,P){return JSON.stringify(y,P)}function n(y){return y?(P,T)=>T&&T.$mid===1?y.transformOutgoing(T):T:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},h=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class o extends v.$Tc{static{C=h}static{this.a=3*1e3}constructor(P,T=null,U=null){super(),this[C]=!0,this.b=this.B(new A.$Yd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=T,this.g=U,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,M=R.$Vv.count;z<M;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$kh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const T=this.w[P];delete this.w[P],T.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,p.$an)(P,this.g):P}getProxy(P){const{nid:T,sid:U}=P;return this.s[T]||(this.s[T]=this.J(T,U)),this.s[T]}J(P,T){const U={get:(z,M)=>(typeof M=="string"&&!z[M]&&M.charCodeAt(0)===36&&(z[M]=(...N)=>this.U(P,M,N)),M===c?T:z[M])};return new Proxy(Object.create(null),U)}set(P,T){return this.m[P.nid]=T,T}assertRegistered(P){for(let T=0,U=P.length;T<U;T++){const z=P[T];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(P){if(this.j)return;const T=P.byteLength,U=d.read(P,0),z=U.readUInt8(),M=U.readUInt32();switch(z){case 1:case 2:{let{rpcId:N,method:O,args:j}=D.deserializeRequestJSONArgs(U);this.g&&(j=(0,p.$an)(j,this.g)),this.M(T,M,N,O,j,z===2);break}case 3:case 4:{let{rpcId:N,method:O,args:j}=D.deserializeRequestMixedArgs(U);this.g&&(j=(0,p.$an)(j,this.g)),this.M(T,M,N,O,j,z===4);break}case 5:{this.f?.logIncoming(T,M,0,"ack"),this.G(M);break}case 6:{this.N(T,M);break}case 7:{this.O(T,M,void 0);break}case 9:{let N=D.deserializeReplyOKJSON(U);this.g&&(N=(0,p.$an)(N,this.g)),this.O(T,M,N);break}case 10:{const N=D.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(T,M,N);break}case 8:{const N=D.deserializeReplyOKVSBuffer(U);this.O(T,M,N);break}case 11:{let N=D.deserializeReplyErrError(U);this.g&&(N=(0,p.$an)(N,this.g)),this.P(T,M,N);break}case 12:{this.P(T,M,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,T,U,z,M,N){this.f?.logIncoming(P,T,1,`receiveRequest ${(0,R.$Xv)(U)}.${z}(`,M);const O=String(T);let j,Y;if(N){const ee=new $.$9d;M.push(ee.token),j=this.Q(U,z,M),Y=()=>ee.cancel()}else j=this.Q(U,z,M),Y=t;this.u[O]=Y;const ne=D.serializeAcknowledged(T);this.f?.logOutgoing(ne.byteLength,T,1,"ack"),this.c.send(ne),j.then(ee=>{delete this.u[O];const Q=D.serializeReplyOK(T,ee,this.h);this.f?.logOutgoing(Q.byteLength,T,1,"reply:",ee),this.c.send(Q)},ee=>{delete this.u[O];const Q=D.serializeReplyErr(T,ee);this.f?.logOutgoing(Q.byteLength,T,1,"replyErr:",ee),this.c.send(Q)})}N(P,T){this.f?.logIncoming(P,T,1,"receiveCancel");const U=String(T);this.u[U]?.()}O(P,T,U){this.f?.logIncoming(P,T,0,"receiveReply:",U);const z=String(T);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z],M.resolveOk(U)}P(P,T,U){this.f?.logIncoming(P,T,0,"receiveReplyErr:",U);const z=String(T);if(!this.w.hasOwnProperty(z))return;const M=this.w[z];delete this.w[z];let N;U&&(U.$isError?(N=new Error,N.name=U.name,N.message=U.message,N.stack=U.stack):N=U),M.resolveErr(N)}Q(P,T,U){try{return Promise.resolve(this.S(P,T,U))}catch(z){return Promise.reject(z)}}S(P,T,U){const z=this.m[P];if(!z)throw new Error("Unknown actor "+(0,R.$Xv)(P));const M=z[T];if(typeof M!="function")throw new Error("Unknown method "+T+" on actor "+(0,R.$Xv)(P));return M.apply(z,U)}U(P,T,U){if(this.j)return new k.$Z8b;let z=null;if(U.length>0&&$.CancellationToken.isCancellationToken(U[U.length-1])&&(z=U.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$6());const M=D.serializeRequestArguments(U,this.h),N=++this.t,O=String(N),j=new k.$Y8b,Y=new v.$Sc;z&&Y.add(z.onCancellationRequested(()=>{const ee=D.serializeCancel(N);this.f?.logOutgoing(ee.byteLength,N,0,"cancel"),this.c.send(D.serializeCancel(N))})),this.w[O]=new u(j,Y),this.F(N);const ne=D.serializeRequest(N,P,T,M,!!z);return this.f?.logOutgoing(ne.byteLength,N,0,`request: ${(0,R.$Xv)(P)}.${T}(`,U),this.c.send(ne),j}}e.$38b=o;class u{constructor(P,T){this.a=P,this.b=T}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,T,U){const z=new d(F.$me.alloc(U+1+4),0);return z.writeUInt8(P),z.writeUInt32(T),z}static read(P,T){return new d(P,T)}get buffer(){return this.a}constructor(P,T){this.a=P,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+P);return this.b+=P,T}static sizeMixedArray(P){let T=0;T+=1;for(let U=0,z=P.length;U<z;U++){const M=P[U];switch(T+=1,M.type){case 1:T+=this.sizeLongString(M.value);break;case 2:T+=this.sizeVSBuffer(M.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(M.value);for(let N=0;N<M.buffers.length;++N)T+=this.sizeVSBuffer(M.buffers[N]);break;case 4:break}}return T}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let T=0,U=P.length;T<U;T++){const z=P[T];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let M=0;M<z.buffers.length;++M)this.writeBuffer(z.buffers[M]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const T=new Array(P);for(let U=0;U<P;U++)switch(this.readUInt8()){case 1:T[U]=this.readLongString();break;case 2:T[U]=this.readVSBuffer();break;case 3:{const M=this.readUInt32(),N=this.readLongString(),O=[];for(let j=0;j<M;++j)O.push(this.readVSBuffer());T[U]=new R.$Yv(s(N,O,null));break}case 4:T[U]=void 0;break}return T}}var b;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(b||(b={}));class D{static a(P){for(let T=0,U=P.length;T<U;T++)if(P[T]instanceof F.$me||P[T]instanceof R.$Yv||typeof P[T]>"u")return!0;return!1}static serializeRequestArguments(P,T){if(this.a(P)){const U=[];for(let z=0,M=P.length;z<M;z++){const N=P[z];if(N instanceof F.$me)U[z]={type:2,value:N};else if(typeof N>"u")U[z]={type:4};else if(N instanceof R.$Yv){const{jsonString:O,referencedBuffers:j}=w(N.value,T);U[z]={type:3,value:F.$me.fromString(O),buffers:j}}else U[z]={type:1,value:F.$me.fromString(i(N,T))}}return{type:1,args:U}}return{type:0,args:i(P,T)}}static serializeRequest(P,T,U,z,M){switch(z.type){case 0:return this.b(P,T,U,z.args,M);case 1:return this.c(P,T,U,z.args,M)}}static b(P,T,U,z,M){const N=F.$me.fromString(U),O=F.$me.fromString(z);let j=0;j+=d.sizeUInt8(),j+=d.sizeShortString(N),j+=d.sizeLongString(O);const Y=d.alloc(M?2:1,P,j);return Y.writeUInt8(T),Y.writeShortString(N),Y.writeLongString(O),Y.buffer}static deserializeRequestJSONArgs(P){const T=P.readUInt8(),U=P.readShortString(),z=P.readLongString();return{rpcId:T,method:U,args:JSON.parse(z)}}static c(P,T,U,z,M){const N=F.$me.fromString(U);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(N),O+=d.sizeMixedArray(z);const j=d.alloc(M?4:3,P,O);return j.writeUInt8(T),j.writeShortString(N),j.writeMixedArray(z),j.buffer}static deserializeRequestMixedArgs(P){const T=P.readUInt8(),U=P.readShortString(),z=P.readMixedArray(),M=new Array(z.length);for(let N=0,O=z.length;N<O;N++){const j=z[N];typeof j=="string"?M[N]=JSON.parse(j):M[N]=j}return{rpcId:T,method:U,args:M}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,T,U){if(typeof T>"u")return this.d(P);if(T instanceof F.$me)return this.e(P,T);if(T instanceof R.$Yv){const{jsonString:z,referencedBuffers:M}=w(T.value,U,!0);return this.g(P,z,M)}else return this.f(P,m(T,U))}static d(P){return d.alloc(7,P,0).buffer}static e(P,T){let U=0;U+=d.sizeVSBuffer(T);const z=d.alloc(8,P,U);return z.writeVSBuffer(T),z.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,T){const U=F.$me.fromString(T);let z=0;z+=d.sizeLongString(U);const M=d.alloc(9,P,z);return M.writeLongString(U),M.buffer}static g(P,T,U){const z=F.$me.fromString(T);let M=0;M+=d.sizeUInt32,M+=d.sizeLongString(z);for(const O of U)M+=d.sizeVSBuffer(O);const N=d.alloc(10,P,M);N.writeUInt32(U.length),N.writeLongString(z);for(const O of U)N.writeBuffer(O);return N.buffer}static deserializeReplyOKJSON(P){const T=P.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(P,T){const U=P.readUInt32(),z=P.readLongString(),M=[];for(let N=0;N<U;++N)M.push(P.readVSBuffer());return new R.$Yv(s(z,M,T))}static serializeReplyErr(P,T){const U=T?m(L.$3(T),null):void 0;if(typeof U!="string")return this.h(P);const z=F.$me.fromString(U);let M=0;M+=d.sizeLongString(z);const N=d.alloc(11,P,M);return N.writeLongString(z),N.buffer}static deserializeReplyErrError(P){const T=P.readLongString();return JSON.parse(T)}static h(P){return d.alloc(12,P,0).buffer}}var g;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var f;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(f||(f={}))}),define(Ce[313],Ie([1,0,21,28,16,84,5]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.$cJ=e.$bJ=e.$aJ=void 0,e.$aJ=(0,A.$$h)("notebookDocumentService");const v=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${v.join("")}]+`),k=7;function R(E){if(E.scheme!==$.Schemas.vscodeNotebookCell)return;const S=E.fragment.indexOf("s");if(S<0)return;const l=parseInt(E.fragment.substring(0,S).replace(p,""),k),w=(0,I.$Fe)(E.fragment.substring(S+1)).toString();if(!isNaN(l))return{handle:l,notebook:E.with({scheme:w,fragment:null})}}e.$bJ=R;function C(E,S){const l=S.toString(k),s=`${l.length<v.length?v[l.length-1]:"z"}${l}s${(0,I.$Ge)(I.$me.fromString(E.scheme),!0,!0)}`;return E.with({scheme:$.Schemas.vscodeNotebookCell,fragment:s})}e.$cJ=C;class m{constructor(){this.a=new F.$Ac}getNotebook(S){if(S.scheme===$.Schemas.vscodeNotebookCell){const l=R(S);if(l){const w=this.a.get(l.notebook);if(w)return w}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$dJ=m,(0,L.$4r)(e.$aJ,m,1)}),define(Ce[118],Ie([1,0,21,35,53,100,16,17,11,45,313]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.CellStatusbarAlignment=e.$rJ=e.$qJ=e.$pJ=e.NotebookEditorPriority=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.CellKind=e.$gJ=e.$fJ=e.$eJ=void 0,e.$eJ="workbench.editor.notebook",e.$fJ="workbench.editor.notebookTextDiffEditor",e.$gJ="workbench.editor.interactive";var C;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(C||(e.CellKind=C={})),e.$hJ=["application/json","application/javascript","text/html","image/svg+xml",L.$ks.latex,L.$ks.markdown,"image/png","image/jpeg",L.$ks.text],e.$iJ=[L.$ks.latex,L.$ks.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$ks.text],e.$jJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$kJ="_notAvailable";var m;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(m||(e.NotebookRunState=m={}));var E;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var S;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var l;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(l||(e.NotebookRendererMatch=l={}));var w;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var s;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var r;(function(j){j.scheme=A.Schemas.vscodeNotebookCell;function Y(ie,fe){return(0,R.$cJ)(ie,fe)}j.generate=Y;function ne(ie){return(0,R.$bJ)(ie)}j.parse=ne;function ee(ie,fe){return ie.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${ie.scheme!==A.Schemas.file?ie.scheme:""}`})}j.generateCellOutputUri=ee;function Q(ie){if(ie.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!fe)return;const re=fe[1]&&fe[1]!==""?fe[1]:void 0,J=fe[2];return{outputId:re,notebook:ie.with({scheme:J||A.Schemas.file,fragment:null})}}j.parseCellOutputUri=Q;function X(ie,fe,re){return j.generate(ie,fe).with({scheme:re})}j.generateCellPropertyUri=X;function ce(ie,fe){if(ie.scheme===fe)return j.parse(ie.with({scheme:j.scheme}))}j.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const a=j=>p.$i?j.replace(/\//g,"\\"):j;class t{constructor(Y=[],ne=e.$hJ){this.e=ne,this.d=[...new Set(Y)].map(ee=>({pattern:ee,matches:F.$Rj(a(ee))}))}sort(Y){const ne=new Map($.Iterable.map(Y,Q=>[Q,a(Q)]));let ee=[];for(const{matches:Q}of this.d)for(const[X,ce]of ne)if(Q(ce)){ee.push(X),ne.delete(X);break}return ne.size&&(ee=ee.concat([...ne.keys()].sort((Q,X)=>this.e.indexOf(Q)-this.e.indexOf(X)))),ee}prioritize(Y,ne){const ee=this.f(Y);if(ee===-1){this.d.unshift({pattern:Y,matches:F.$Rj(a(Y))});return}const Q=new Set(ne.map(ce=>this.f(ce,ee)));Q.delete(-1);const X=Array.from(Q).sort();this.d.splice(ee+1,0,...X.map(ce=>this.d[ce]));for(let ce=X.length-1;ce>=0;ce--)this.d.splice(X[ce],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,ne=this.d.length){const ee=a(Y);for(let Q=0;Q<ne;Q++)if(this.d[Q].matches(ee))return Q;return-1}}e.$lJ=t;function h(j,Y,ne,ee=(Q,X)=>Q===X){const Q=[];function X(fe,re,J){if(re===0&&J.length===0)return;const B=Q[Q.length-1];B&&B.start+B.deleteCount===fe?(B.deleteCount+=re,B.toInsert.push(...J)):Q.push({start:fe,deleteCount:re,toInsert:J})}let ce=0,ie=0;for(;;){if(ce===j.length){X(ce,0,Y.slice(ie));break}if(ie===Y.length){X(ce,j.length-ce,[]);break}const fe=j[ce],re=Y[ie];if(ee(fe,re)){ce+=1,ie+=1;continue}ne(re)?(X(ce,1,[]),ce+=1):(X(ce,0,[re]),ie+=1)}return Q}e.$mJ=h,e.$nJ=new k.$pj("notebookEditorCursorAtBoundary","none"),e.$oJ=new k.$pj("notebookEditorCursorAtLineBoundary","none");var c;(function(j){j.default="default",j.option="option"})(c||(e.NotebookEditorPriority=c={}));function o(j){const Y=j;return!!((typeof Y.include=="string"||F.$Sj(Y.include))&&(typeof Y.exclude=="string"||F.$Sj(Y.exclude)))}e.$pJ=o;function u(j,Y,ne){if(Array.isArray(j.viewType)&&j.viewType.indexOf(Y)>=0||j.viewType===Y)return!0;if(j.filenamePattern){const ee=o(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,Q=o(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(F.$Qj(ee,(0,v.$nc)(ne.fsPath).toLowerCase()))return!(Q&&F.$Qj(Q,(0,v.$nc)(ne.fsPath).toLowerCase()))}return!1}e.$qJ=u,e.$rJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var d;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class b{static{this.d="notebook/"}static create(Y){return`${b.d}${Y}`}static parse(Y){if(Y.startsWith(b.d))return Y.substring(b.d.length)}}e.$sJ=b;function D(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}e.$tJ=D;const g=new TextDecoder;function f(j){const Y=[];let ne=!1;for(const ce of j)(Y.length===0||ne)&&(Y.push(ce),ne=!0);let ee=T(Y);const Q=I.$me.concat(Y.map(ce=>I.$me.wrap(ce))),X=O(Q);return ee=ee||X.byteLength!==Q.byteLength,{data:X,didCompression:ee}}e.$uJ=f,e.$vJ="\x1B[A";const y=e.$vJ.split("").map(j=>j.charCodeAt(0)),P=10;function T(j){let Y=!1;return j.forEach((ne,ee)=>{if(ee===0||ne.length<e.$vJ.length)return;const Q=j[ee-1],X=ne.subarray(0,e.$vJ.length);if(X[0]===y[0]&&X[1]===y[1]&&X[2]===y[2]){const ce=Q.lastIndexOf(P);if(ce===-1)return;Y=!0,j[ee-1]=Q.subarray(0,ce),j[ee]=ne.subarray(e.$vJ.length)}}),Y}function U(j){let Y=j;do j=Y,Y=j.replace(/[^\n]\x08/gm,"");while(Y.length<j.length);return j}function z(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const Y=j.match(/^(.*)\r+/m)[1];let ne=j.match(/\r+(.*)$/m)[1];ne=ne+Y.slice(ne.length,Y.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return j}const M=8,N=13;function O(j){return!j.buffer.includes(M)&&!j.buffer.includes(N)?j:I.$me.fromString(z(U(g.decode(j.buffer))))}}),define(Ce[7],Ie([1,0,19,14,63,28,100,12,18,2,30,25,32,65,118]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S){"use strict";var l,w,s,i,n,r,a,t,h,c,o,u,d,b,D,g,f;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.ChatAgentResultFeedbackKind=e.$mN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$lN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.TestRunProfileKind=e.TestResultState=e.$4M=e.$3M=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$2M=e.NotebookVariablesRequestKind=e.$1M=e.$ZM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$YM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.ColorThemeKind=e.$SM=e.$RM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$QM=e.$PM=e.DebugConsoleMode=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$JM=e.$IM=e.FileChangeType=e.$HM=e.NewSymbolNameTag=e.$GM=e.$FM=e.$EM=e.$DM=e.InlineCompletionTriggerKind=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.ConfigurationTarget=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$gM=e.ViewBadge=e.ProgressLocation=e.$fM=e.$eM=e.TaskScope=e.ShellQuoting=e.$dM=e.$cM=e.$bM=e.TaskPanelKind=e.TaskRevealKind=e.$aM=e.TerminalLocation=e.$_L=e.$$L=e.$0L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$9L=e.$8L=e.$7L=e.$6L=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$5L=e.StatusBarAlignment=e.ViewColumn=e.$4L=e.$3L=e.$2L=e.$1L=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$ZL=e.$YL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.LanguageStatusSeverity=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.CodeActionTriggerKind=e.$ML=e.$LL=e.SymbolTag=e.SymbolKind=e.$KL=e.$JL=e.DocumentHighlightKind=e.$IL=e.$HL=e.$GL=e.$FL=e.DiagnosticSeverity=e.DiagnosticTag=e.$EL=e.$DL=e.FileEditType=e.$CL=e.$BL=e.$AL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(G){return Object.assign(G,{apply:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const Fe=we.length===1?[]:we[1];return Reflect.construct(G,Fe,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const[Fe,...Ze]=we;return Reflect.construct(G,Ze,Fe.constructor)}}})}var P;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var T;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let U=l=class{static from(...q){let we=q;return new l(function(){if(we){for(const Fe of we)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();we=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$tL=U,e.$tL=U=l=Je([y],U);let z=w=class{static Min(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Fe=1;Fe<q.length;Fe++){const Ze=q[Fe];Ze.isBefore(we)&&(we=Ze)}return we}static Max(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Fe=1;Fe<q.length;Fe++){const Ze=q[Fe];Ze.isAfter(we)&&(we=Ze)}return we}static isPosition(q){if(!q)return!1;if(q instanceof w)return!0;const{line:we,character:Fe}=q;return typeof we=="number"&&typeof Fe=="number"}static of(q){if(q instanceof w)return q;if(this.isPosition(q))return new w(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,we){if(q<0)throw(0,F.$7)("line must be non-negative");if(we<0)throw(0,F.$7)("character must be non-negative");this.c=q,this.e=we}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,we=0){if(q===null||we===null)throw(0,F.$7)();let Fe;return typeof q>"u"?Fe=0:typeof q=="number"?Fe=q:(Fe=typeof q.lineDelta=="number"?q.lineDelta:0,we=typeof q.characterDelta=="number"?q.characterDelta:0),Fe===0&&we===0?this:new w(this.line+Fe,this.character+we)}with(q,we=this.character){if(q===null||we===null)throw(0,F.$7)();let Fe;return typeof q>"u"?Fe=this.line:typeof q=="number"?Fe=q:(Fe=typeof q.line=="number"?q.line:this.line,we=typeof q.character=="number"?q.character:this.character),Fe===this.line&&we===this.character?this:new w(Fe,we)}toJSON(){return{line:this.line,character:this.character}}};e.$uL=z,e.$uL=z=w=Je([y],z);let M=s=class{static isRange(q){return q instanceof s?!0:q?z.isPosition(q.start)&&z.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,we,Fe,Ze){let tt,ht;if(typeof q=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Ze=="number"?(tt=new z(q,we),ht=new z(Fe,Ze)):z.isPosition(q)&&z.isPosition(we)&&(tt=z.of(q),ht=z.of(we)),!tt||!ht)throw new Error("Invalid arguments");tt.isBefore(ht)?(this.c=tt,this.e=ht):(this.c=ht,this.e=tt)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):z.isPosition(q)?!(z.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const we=z.Max(q.start,this.c),Fe=z.Min(q.end,this.e);if(!we.isAfter(Fe))return new s(we,Fe)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const we=z.Min(q.start,this.c),Fe=z.Max(q.end,this.end);return new s(we,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,we=this.end){if(q===null||we===null)throw(0,F.$7)();let Fe;return q?z.isPosition(q)?Fe=q:(Fe=q.start||this.start,we=q.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&we.isEqual(this.end)?this:new s(Fe,we)}toJSON(){return[this.start,this.end]}};e.$vL=M,e.$vL=M=s=Je([y],M);let N=i=class extends M{static isSelection(q){return q instanceof i?!0:q?M.isRange(q)&&z.isPosition(q.anchor)&&z.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,we,Fe,Ze){let tt,ht;if(typeof q=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Ze=="number"?(tt=new z(q,we),ht=new z(Fe,Ze)):z.isPosition(q)&&z.isPosition(we)&&(tt=z.of(q),ht=z.of(we)),!tt||!ht)throw new Error("Invalid arguments");super(tt,ht),this.f=tt,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$wL=N,e.$wL=N=i=Je([y],N);const O=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,F.$7)("connectionToken")};class j{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we,Fe){if(typeof q!="string"||q.length===0)throw(0,F.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,F.$7)("port");typeof Fe<"u"&&O(Fe),this.host=q,this.port=Math.round(we),this.connectionToken=Fe}}e.$xL=j;class Y{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we){this.makeConnection=q,this.connectionToken=we,typeof we<"u"&&O(we)}}e.$yL=Y;class ne extends Error{static NotAvailable(q,we){return new ne(q,E.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(q){return new ne(q,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,we=E.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(q),this._message=q,this._code=we,this._detail=Fe,Object.setPrototypeOf(this,ne.prototype)}}e.$zL=ne;var ee;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(ee||(e.EndOfLine=ee={}));var Q;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let X=n=class{static isTextEdit(q){return q instanceof n?!0:q?M.isRange(q)&&typeof q.newText=="string":!1}static replace(q,we){return new n(q,we)}static insert(q,we){return n.replace(new M(q,q),we)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const we=new n(new M(new z(0,0),new z(0,0)),"");return we.newEol=q,we}get range(){return this.c}set range(q){if(q&&!M.isRange(q))throw(0,F.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,F.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,F.$7)("newEol");this.f=q}constructor(q,we){this.c=q,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$AL=X,e.$AL=X=n=Je([y],X);let ce=r=class{static isNotebookCellEdit(q){return q instanceof r?!0:q?di.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,we){return new r(q,we)}static insertCells(q,we){return new r(new di(q,q),we)}static deleteCells(q){return new r(q,[])}static updateCellMetadata(q,we){const Fe=new r(new di(q,q),[]);return Fe.newCellMetadata=we,Fe}static updateNotebookMetadata(q){const we=new r(new di(0,0),[]);return we.newNotebookMetadata=q,we}constructor(q,we){this.range=q,this.newCells=we}};e.$BL=ce,e.$BL=ce=r=Je([y],ce);class ie{static isSnippetTextEdit(q){return q instanceof ie?!0:q?M.isRange(q.range)&&J.isSnippetString(q.snippet):!1}static replace(q,we){return new ie(q,we)}static insert(q,we){return ie.replace(new M(q,q),we)}constructor(q,we){this.range=q,this.snippet=we}}e.$CL=ie;var fe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(fe||(e.FileEditType=fe={}));let re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,we,Fe,Ze){this.c.push({_type:1,from:q,to:we,options:Fe,metadata:Ze})}createFile(q,we,Fe){this.c.push({_type:1,from:void 0,to:q,options:we,metadata:Fe})}deleteFile(q,we,Fe){this.c.push({_type:1,from:q,to:void 0,options:we,metadata:Fe})}e(q,we,Fe){this.c.push({_type:3,metadata:Fe,uri:q,edit:{editType:5,metadata:we},notebookMetadata:we})}f(q,we,Fe,Ze){const tt=we.start,ht=we.end;(tt!==ht||Fe.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:ht-tt,cells:Fe,metadata:Ze})}g(q,we,Fe,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:we,metadata:Fe}})}replace(q,we,Fe,Ze){this.c.push({_type:2,uri:q,edit:new X(we,Fe),metadata:Ze})}insert(q,we,Fe,Ze){this.replace(q,new M(we,we),Fe,Ze)}delete(q,we,Fe){this.replace(q,we,"",Fe)}has(q){return this.c.some(we=>we._type===2&&we.uri.toString()===q.toString())}set(q,we){if(we)for(const Fe of we){if(!Fe)continue;let Ze,tt;Array.isArray(Fe)?(Ze=Fe[0],tt=Fe[1]):Ze=Fe,ce.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,tt):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,tt):this.f(q,Ze.range,Ze.newCells,tt):ie.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Ze,metadata:tt})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Ze=this.c[Fe];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Fe]=void 0);break}}(0,I.$Ib)(this.c)}}get(q){const we=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===q.toString()&&we.push(Fe.edit);return we}entries(){const q=new L.$Ac;for(const we of this.c)if(we._type===2){let Fe=q.get(we.uri);Fe||(Fe=[we.uri,[]],q.set(we.uri,Fe)),Fe[1].push(we.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$DL=re,e.$DL=re=Je([y],re);let J=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,we=this.e++){if(typeof q=="function"){const Fe=new a;Fe.e=this.e,q(Fe),this.e=Fe.e,q=Fe.value}else q=a.c(q);return this.value+="${",this.value+=we,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,we=this.e++){const Fe=q.map(Ze=>Ze.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(q,we){if(typeof we=="function"){const Fe=new a;Fe.e=this.e,we(Fe),this.e=Fe.e,we=Fe.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$EL=J,e.$EL=J=a=Je([y],J);var B;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ae;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ae||(e.DiagnosticSeverity=ae={}));let Ee=t=class{static isLocation(q){return q instanceof t?!0:q?M.isRange(q.range)&&k.URI.isUri(q.uri):!1}constructor(q,we){if(this.uri=q,we)if(M.isRange(we))this.range=M.of(we);else if(z.isPosition(we))this.range=new M(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$FL=Ee,e.$FL=Ee=t=Je([y],Ee);let le=class{static is(q){return q?typeof q.message=="string"&&q.location&&M.isRange(q.location.range)&&k.URI.isUri(q.location.uri):!1}constructor(q,we){this.location=q,this.message=we}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.location.range.isEqual(we.location.range)&&q.location.uri.toString()===we.location.uri.toString()}};e.$GL=le,e.$GL=le=Je([y],le);let de=class{constructor(q,we,Fe=ae.Error){if(!M.isRange(q))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=q,this.message=we,this.severity=Fe}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.severity===we.severity&&q.code===we.code&&q.severity===we.severity&&q.source===we.source&&q.range.isEqual(we.range)&&(0,I.$ub)(q.tags,we.tags)&&(0,I.$ub)(q.relatedInformation,we.relatedInformation,le.isEqual)}};e.$HL=de,e.$HL=de=Je([y],de);let ue=class{constructor(q,we){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=we}};e.$IL=ue,e.$IL=ue=Je([y],ue);var ge;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let V=class{constructor(q,we=ge.Text){this.range=q,this.kind=we}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$JL=V,e.$JL=V=Je([y],V);let Z=class{constructor(q,we){this.uri=q,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$KL=Z,e.$KL=Z=Je([y],Z);var he;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var be;(function(G){G[G.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Pe=h=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,we,Fe,Ze,tt){this.name=q,this.kind=we,this.containerName=tt,typeof Fe=="string"&&(this.containerName=Fe),Ze instanceof Ee?this.location=Ze:Fe instanceof M&&(this.location=new Ee(Ze,Fe)),h.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$LL=Pe,e.$LL=Pe=h=Je([y],Pe);let pe=c=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(c.validate)}constructor(q,we,Fe,Ze,tt){this.name=q,this.detail=we,this.kind=Fe,this.range=Ze,this.selectionRange=tt,this.children=[],c.validate(this)}};e.$ML=pe,e.$ML=pe=c=Je([y],pe);var Le;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Le||(e.CodeActionTriggerKind=Le={}));let Me=class{constructor(q,we){this.title=q,this.kind=we}};e.$NL=Me,e.$NL=Me=Je([y],Me);let W=class{static{o=this}static{this.c="."}constructor(q){this.value=q}append(q){return new o(this.value?this.value+o.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+o.c)}};e.$OL=W,e.$OL=W=o=Je([y],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let x=class{constructor(q,we){if(this.range=q,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$PL=x,e.$PL=x=Je([y],x);class H{constructor(q,we,Fe,Ze,tt,ht){this.kind=q,this.name=we,this.detail=Fe,this.uri=Ze,this.range=tt,this.selectionRange=ht}}e.$QL=H;class K{constructor(q,we){this.fromRanges=we,this.from=q}}e.$RL=K;class oe{constructor(q,we){this.fromRanges=we,this.to=q}}e.$SL=oe;var ye;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(ye||(e.LanguageStatusSeverity=ye={}));let Re=class{constructor(q,we){this.range=q,this.command=we}get isResolved(){return!!this.command}};e.$TL=Re,e.$TL=Re=Je([y],Re);let qe=u=class{#e;static isMarkdownString(q){return q instanceof u?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,we=!1){this.#e=new $.$mk(q,{supportThemeIcons:we})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,we){return this.#e.appendCodeblock(we??"",q),this}};e.$UL=qe,e.$UL=qe=u=Je([y],qe);let Ge=class{constructor(q,we){this.label=q,this.documentation=we}};e.$VL=Ge,e.$VL=Ge=Je([y],Ge);let Xe=class{constructor(q,we){this.label=q,this.documentation=we,this.parameters=[]}};e.$WL=Xe,e.$WL=Xe=Je([y],Xe);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$XL=it,e.$XL=it=Je([y],it);var lt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(lt||(e.SignatureHelpTriggerKind=lt={}));var at;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let et=class{constructor(q){this.value=q}};e.$YL=et,e.$YL=et=Je([y],et);let Ae=class{constructor(q,we,Fe){this.position=q,this.label=we,this.kind=Fe}};e.$ZL=Ae,e.$ZL=Ae=Je([y],Ae);var Se;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Se||(e.CompletionTriggerKind=Se={}));var He;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var te;(function(G){G[G.Deprecated=1]="Deprecated"})(te||(e.CompletionItemTag=te={}));let se=class{constructor(q,we){this.label=q,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$1L=se,e.$1L=se=Je([y],se);let De=class{constructor(q=[],we=!1){this.items=q,this.isIncomplete=we}};e.$2L=De,e.$2L=De=Je([y],De);let Ve=class{constructor(q,we,Fe){this.insertText=q,this.range=we,this.command=Fe}};e.$3L=Ve,e.$3L=Ve=Je([y],Ve);let Ke=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$4L=Ke,e.$4L=Ke=Je([y],Ke);var nt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var st;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function je(G,q){return`${C.$qm.toKey(G)}.${q}`}e.$5L=je;var yt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var kt;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(kt||(e.TextDocumentSaveReason=kt={}));var Ot;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(Ot||(e.TextEditorRevealType=Ot={}));var Rt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Rt||(e.TextEditorSelectionChangeKind=Rt={}));var St;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var ti;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ti||(e.DecorationRangeBehavior=ti={})),function(G){function q(we){switch(we){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=q}(Rt||(e.TextEditorSelectionChangeKind=Rt={}));var Wt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(G){function q(we){switch(we){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=q}(Wt||(e.SyntaxTokenType=Wt={}));let si=class{constructor(q,we){if(we&&!k.URI.isUri(we))throw(0,F.$7)("target");if(!M.isRange(q)||q.isEmpty)throw(0,F.$7)("range");this.range=q,this.target=we}};e.$6L=si,e.$6L=si=Je([y],si);let Xt=class{constructor(q,we,Fe,Ze){this.red=q,this.green=we,this.blue=Fe,this.alpha=Ze}};e.$7L=Xt,e.$7L=Xt=Je([y],Xt);let xt=class{constructor(q,we){if(we&&!(we instanceof Xt))throw(0,F.$7)("color");if(!M.isRange(q)||q.isEmpty)throw(0,F.$7)("range");this.range=q,this.color=we}};e.$8L=xt,e.$8L=xt=Je([y],xt);let _e=class{constructor(q){if(!q||typeof q!="string")throw(0,F.$7)("label");this.label=q}};e.$9L=_e,e.$9L=_e=Je([y],_e);var qt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var ii;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var dt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class $t{constructor(q,we,Fe){if(this.startIndex=q,this.length=we,this.tooltip=Fe,typeof q!="number"||q<0)throw(0,F.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,F.$7)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,F.$7)("tooltip")}}e.$0L=$t;class Yt{constructor(q){this.uri=q}}e.$$L=Yt;class ni{constructor(q){this.terminalCommand=q}}e.$_L=ni;var Lt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Lt||(e.TerminalLocation=Lt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,F.$7)("options")}}e.$aM=ft;var Mt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Mt||(e.TaskRevealKind=Mt={}));var oi;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Ft=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(q){switch(q){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(q,we){if(this.label=we,typeof q!="string"||typeof we!="string")throw(0,F.$7)("name");this.c=q}get id(){return this.c}};e.$bM=Ft,e.$bM=Ft=d=Je([y],Ft);function Ye(G){let q="";for(let we=0;we<G.length;we++)q+=G[we].replace(/,/g,",,")+",";return q}let Kt=class{constructor(q,we,Fe){if(typeof q!="string")throw(0,F.$7)("process");this.e=[],this.c=q,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Fe):this.f=we)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,F.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const we of this.e)q.push(we);return Ye(q)}};e.$cM=Kt,e.$cM=Kt=Je([y],Kt);let Qt=class{constructor(q,we,Fe){if(this.f=[],Array.isArray(we)){if(!q)throw(0,F.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,F.$7)("command");this.e=q,this.f=we,this.g=Fe}else{if(typeof q!="string")throw(0,F.$7)("commandLine");this.c=q,this.g=we}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,F.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,F.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)q.push(typeof we=="string"?we:we.value);return Ye(q)}};e.$dM=Qt,e.$dM=Qt=Je([y],Qt);var _t;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(_t||(e.ShellQuoting=_t={}));var gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class jt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$ug)()}set callback(q){this.c=q}get callback(){return this.c}}e.$eM=jt;let Nt=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,we,Fe,Ze,tt,ht){this.k=!1,this.l=this.definition=q;let mt;typeof we=="string"?(this.o=this.name=we,this.w=this.source=Fe,this.execution=Ze,mt=tt,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.o=this.name=Fe,this.w=this.source=Ze,this.execution=tt,mt=ht):(this.target=we,this.o=this.name=Fe,this.w=this.source=Ze,this.execution=tt,mt=ht),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Kt?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Qt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof jt?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,R.$ug)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,F.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,F.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const we=this.l.type;(b.g===we||b.e===we||b.f===we||b.c===we)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,F.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$fM=Nt,e.$fM=Nt=b=Je([y],Nt);var zt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(zt||(e.ProgressLocation=zt={}));var Vt;(function(G){function q(we){const Fe=we;return(0,p.$Qf)(Fe.value)?Fe.tooltip&&!(0,p.$Mf)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}G.isViewBadge=q})(Vt||(e.ViewBadge=Vt={}));let Ut=D=class{static isTreeItem(q,we){const Fe=q;if(Fe.checkboxState!==void 0){const Ze=(0,p.$Qf)(Fe.checkboxState)?Fe.checkboxState:(0,p.$Of)(Fe.checkboxState)&&(0,p.$Qf)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,tt=!(0,p.$Qf)(Fe.checkboxState)&&(0,p.$Of)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Ht.Checked&&Ze!==Ht.Unchecked||tt!==void 0&&!(0,p.$Mf)(tt))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(q instanceof D)return!0;if(Fe.label!==void 0&&!(0,p.$Mf)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,p.$Mf)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,p.$Mf)(Fe.iconPath)&&!k.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,p.$Mf)(Fe.iconPath.id))){const Ze=Fe.iconPath;if(!Ze||!(0,p.$Mf)(Ze.light)&&!k.URI.isUri(Ze.light)&&!(0,p.$Mf)(Ze.dark)&&!k.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,p.$Mf)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!k.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,p.$Mf)(Fe.tooltip)&&!(Fe.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<Ct.None&&Fe.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,p.$Mf)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(q,we=Ct.None){this.collapsibleState=we,k.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$gM=Ut,e.$gM=Ut=D=Je([y],Ut);var Ct;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var Ht;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Ht||(e.TreeItemCheckboxState=Ht={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$hM=Et,e.$hM=Et=Je([y],Et);class pt extends Et{}e.$iM=pt;class It extends pt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$jM=It;class Dt{constructor(q,we,Fe,Ze){this.name=q,this.uri=we,this._itemId=Fe,this.c=Ze}data(){return this.c()}}e.$kM=Dt;let ci=class{#e=new Map;constructor(q){for(const[we,Fe]of q??[]){const Ze=this.#e.get(this.#t(we));Ze?Ze.push(Fe):this.#e.set(this.#t(we),[Fe])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,we){this.#e.set(this.#t(q),[we])}forEach(q,we){for(const[Fe,Ze]of this.#e)for(const tt of Ze)q.call(we,tt,Fe,this)}*[Symbol.iterator](){for(const[q,we]of this.#e)for(const Fe of we)yield[q,Fe]}#t(q){return q.toLowerCase()}};e.$lM=ci,e.$lM=ci=Je([y],ci);let Zt=class{constructor(q){this.insertText=q}};e.$mM=Zt,e.$mM=Zt=Je([y],Zt);let gi=class{constructor(q,we){this.label=we,this.insertText=q}};e.$nM=gi,e.$nM=gi=Je([y],gi);let Gt=class{constructor(q,we){this.id=q,this.color=we}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$oM=Gt,e.$oM=Gt=Je([y],Gt),Gt.File=new Gt("file"),Gt.Folder=new Gt("folder");let mi=class{constructor(q){this.id=q}};e.$pM=mi,e.$pM=mi=Je([y],mi);var At;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(At||(e.ConfigurationTarget=At={}));let Ne=class{get base(){return this.c}set base(q){this.c=q,this.e=k.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,we){if(typeof q!="string"&&(!q||!k.URI.isUri(q)&&!k.URI.isUri(q.uri)))throw(0,F.$7)("base");if(typeof we!="string")throw(0,F.$7)("pattern");typeof q=="string"?this.baseUri=k.URI.file(q):k.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$qM=Ne,e.$qM=Ne=Je([y],Ne);const Oe=new WeakMap;function ve(G,q){Oe.set(G,q)}e.$rM=ve;let _=class{constructor(q,we,Fe,Ze){this.enabled=typeof q=="boolean"?q:!0,typeof we=="string"&&(this.condition=we),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Oe.get(this)??(0,R.$ug)()),this.c}};e.$sM=_,e.$sM=_=Je([y],_);let Te=class extends _{constructor(q,we,Fe,Ze,tt){if(super(we,Fe,Ze,tt),q===null)throw(0,F.$7)("location");this.location=q}};e.$tM=Te,e.$tM=Te=Je([y],Te);let Be=class extends _{constructor(q,we,Fe,Ze,tt){super(we,Fe,Ze,tt),this.functionName=q}};e.$uM=Be,e.$uM=Be=Je([y],Be);let xe=class extends _{constructor(q,we,Fe,Ze,tt,ht,mt){if(super(Ze,tt,ht,mt),!we)throw(0,F.$7)("dataId");this.label=q,this.dataId=we,this.canPersist=Fe}};e.$vM=xe,e.$vM=xe=Je([y],xe);let Qe=class{constructor(q,we,Fe){this.command=q,this.args=we||[],this.options=Fe}};e.$wM=Qe,e.$wM=Qe=Je([y],Qe);let rt=class{constructor(q,we){this.port=q,this.host=we}};e.$xM=rt,e.$xM=rt=Je([y],rt);let vt=class{constructor(q){this.path=q}};e.$yM=vt,e.$yM=vt=Je([y],vt);let Jt=class{constructor(q){this.implementation=q}};e.$zM=Jt,e.$zM=Jt=Je([y],Jt);let Bt=class{constructor(q,we,Fe){this.session=q,this.threadId=we,this.frameId=Fe}};e.$AM=Bt,e.$AM=Bt=Je([y],Bt);let Pt=class{constructor(q,we){this.session=q,this.threadId=we}};e.$BM=Pt,e.$BM=Pt=Je([y],Pt);let ct=class{constructor(q,we){this.range=q,this.expression=we}};e.$CM=ct,e.$CM=ct=Je([y],ct);var Qi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let ui=class{constructor(q,we){this.range=q,this.text=we}};e.$DM=ui,e.$DM=ui=Je([y],ui);let $i=class{constructor(q,we,Fe=!0){this.range=q,this.variableName=we,this.caseSensitiveLookup=Fe}};e.$EM=$i,e.$EM=$i=Je([y],$i);let yi=class{constructor(q,we){this.range=q,this.expression=we}};e.$FM=yi,e.$FM=yi=Je([y],yi);let Ai=class{constructor(q,we){this.frameId=q,this.stoppedLocation=we}};e.$GM=Ai,e.$GM=Ai=Je([y],Ai);var Zi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Zi||(e.NewSymbolNameTag=Zi={}));class ln{constructor(q,we){this.newSymbolName=q,this.tags=we}}e.$HM=ln;var Ri;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Ni=g=class extends Error{static FileExists(q){return new g(q,m.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(q){return new g(q,m.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(q){return new g(q,m.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(q){return new g(q,m.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(q){return new g(q,m.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(q){return new g(q,m.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(q,we=m.FileSystemProviderErrorCode.Unknown,Fe){super(k.URI.isUri(q)?q.toString(!0):q),this.code=Fe?.name??"Unknown",(0,m.$Kk)(this,we),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$IM=Ni,e.$IM=Ni=g=Je([y],Ni);let Ei=class{constructor(q,we,Fe){this.start=q,this.end=we,this.kind=Fe}};e.$JM=Ei,e.$JM=Ei=Je([y],Ei);var bi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(bi||(e.FoldingRangeKind=bi={}));var Xi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var ki;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(ki||(e.CommentMode=ki={}));var Si;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Si||(e.CommentState=Si={}));var xi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(xi||(e.CommentThreadState=xi={}));class hn{constructor(q,we=[]){this.tokenTypes=q,this.tokenModifiers=we}}e.$KM=hn;function pi(G){return typeof G>"u"||(0,p.$Nf)(G)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let we=0,Fe=q.tokenTypes.length;we<Fe;we++)this.k.set(q.tokenTypes[we],we);for(let we=0,Fe=q.tokenModifiers.length;we<Fe;we++)this.l.set(q.tokenModifiers[we],we)}}push(q,we,Fe,Ze,tt){if(typeof q=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Ze=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(q,we,Fe,Ze,tt);if(M.isRange(q)&&typeof we=="string"&&pi(Fe))return this.o(q,we,Fe);throw(0,F.$7)()}o(q,we,Fe){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,tt=q.start.character,ht=q.end.character-q.start.character,mt=this.k.get(we);let ei=0;if(Fe)for(const ai of Fe){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);ei|=1<<hi>>>0}this.q(Ze,tt,ht,mt,ei)}q(q,we,Fe,Ze,tt){if(this.f&&(q<this.c||q===this.c&&we<this.e)){this.f=!1;const ei=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<ei;fi++){let wi=this.g[5*fi],Yi=this.g[5*fi+1];wi===0?(wi=ai,Yi+=hi):wi+=ai,this.g[5*fi]=wi,this.g[5*fi+1]=Yi,ai=wi,hi=Yi}}let ht=q,mt=we;this.f&&this.j>0&&(ht-=this.c,ht===0&&(mt-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=mt,this.g[this.j++]=Fe,this.g[this.j++]=Ze,this.g[this.j++]=tt,this.c=q,this.e=we}static r(q){const we=[],Fe=q.length/5|0;for(let mt=0;mt<Fe;mt++)we[mt]=mt;we.sort((mt,ei)=>{const ai=q[5*mt],hi=q[5*ei];if(ai===hi){const fi=q[5*mt+1],wi=q[5*ei+1];return fi-wi}return ai-hi});const Ze=new Uint32Array(q.length);let tt=0,ht=0;for(let mt=0;mt<Fe;mt++){const ei=5*we[mt],ai=q[ei+0],hi=q[ei+1],fi=q[ei+2],wi=q[ei+3],Yi=q[ei+4],In=ai-tt,_n=In===0?hi-ht:hi,Ki=5*mt;Ze[Ki+0]=In,Ze[Ki+1]=_n,Ze[Ki+2]=fi,Ze[Ki+3]=wi,Ze[Ki+4]=Yi,tt=ai,ht=hi}return Ze}build(q){return this.f?new Fi(new Uint32Array(this.g),q):new Fi(Mi.r(this.g),q)}}e.$LM=Mi;class Fi{constructor(q,we){this.resultId=we,this.data=q}}e.$MM=Fi;class dn{constructor(q,we,Fe){this.start=q,this.deleteCount=we,this.data=Fe}}e.$NM=dn;class Di{constructor(q,we){this.resultId=we,this.edits=q}}e.$OM=Di;var _i;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class fn{constructor(q){this.name=q}}e.$PM=fn;let vi=class{static{this.Back={iconPath:new Gt("arrow-left")}}constructor(){}};e.$QM=vi,e.$QM=vi=Je([y],vi);var Ti;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Ti||(e.QuickPickItemKind=Ti={}));var en;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(en||(e.InputBoxValidationSeverity=en={}));var Oi;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Oi||(e.ExtensionKind=Oi={}));class tn{static validate(q){if(typeof q.badge=="string"){let we=(0,v.$nf)(q.badge,0);if(we<q.badge.length&&(we+=(0,v.$nf)(q.badge,we)),q.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Gt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,we,Fe){this.badge=q,this.tooltip=we,this.color=Fe}}e.$RM=tn;let ji=class{constructor(q){this.kind=q}};e.$SM=ji,e.$SM=ji=Je([y],ji);var nn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class di{static isNotebookRange(q){return q instanceof di?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,we){if(q<0)throw(0,F.$7)("start must be positive");if(we<0)throw(0,F.$7)("end must be positive");q<=we?(this.c=q,this.e=we):(this.c=we,this.e=q)}with(q){let we=this.c,Fe=this.e;return q.start!==void 0&&(we=q.start),q.end!==void 0&&(Fe=q.end),we===this.c&&Fe===this.e?this:new di(we,Fe)}}e.$TM=di;class Ci{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(we=>Ci.isNotebookCellData(we))}static isNotebookCellData(q){return!0}constructor(q,we,Fe,Ze,tt,ht,mt){this.kind=q,this.value=we,this.languageId=Fe,this.mime=Ze,this.outputs=tt??[],this.metadata=ht,this.executionSummary=mt,Ci.validate(this)}}e.$UM=Ci;class zi{constructor(q){this.cells=q}}e.$VM=zi;class ri{static isNotebookCellOutputItem(q){return q instanceof ri?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const we={name:q.name,message:q.message,stack:q.stack};return ri.json(we,"application/vnd.code.notebook.error")}static stdout(q){return ri.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return ri.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,we="application/octet-stream"){return new ri(q,we)}static#e=new TextEncoder;static text(q,we=A.$ks.text){const Fe=ri.#e.encode(String(q));return new ri(Fe,we)}static json(q,we="text/x-json"){const Fe=JSON.stringify(q,void 0,"	");return ri.text(Fe,we)}constructor(q,we){this.data=q,this.mime=we;const Fe=(0,A.$os)(we,!0);if(!Fe)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$WM=ri;class ze{static isNotebookCellOutput(q){return q instanceof ze?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,we=!1){const Fe=new Set,Ze=new Set;for(let tt=0;tt<q.length;tt++){const ht=q[tt],mt=(0,A.$os)(ht.mime);if(!Fe.has(mt)||(0,S.$tJ)(mt)){Fe.add(mt);continue}Ze.add(tt),we&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ze.size===0?q:q.filter((tt,ht)=>!Ze.has(ht))}constructor(q,we,Fe){this.items=ze.ensureUniqueMimeTypes(q,!0),typeof we=="string"?(this.id=we,this.metadata=Fe):(this.id=(0,R.$ug)(),this.metadata=we??Fe)}}e.$XM=ze;var li;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var Ui;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(Ui||(e.NotebookCellExecutionState=Ui={}));var ot;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ot||(e.NotebookCellStatusBarAlignment=ot={}));var bt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(bt||(e.NotebookEditorRevealType=bt={}));class gn{constructor(q,we){this.text=q,this.alignment=we}}e.$YM=gn;var rn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var Bi;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(Bi||(e.NotebookControllerAffinity2=Bi={}));class mn{constructor(q,we=[]){this.uri=q,this.provides=(0,I.$3b)(we)}}e.$ZM=mn;class Ii{constructor(q){this.label=q}}e.$1M=Ii;var sn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Wi=class{constructor(q,we){this.label=q,this.timestamp=we}};e.$2M=Wi,e.$2M=Wi=Je([y],Wi);var on;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var qi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(qi||(e.ExtensionRuntime=qi={}));var an;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class $n{constructor(q,we){this.ranges=q,this.wordPattern=we}}e.$3M=$n;class bn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$4M=bn;var cn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Vi=class{constructor(q=void 0,we=void 0,Fe=void 0,Ze=!1){this.include=q,this.exclude=we,this.profile=Fe,this.continuous=Ze}};e.$5M=Vi,e.$5M=Vi=Je([y],Vi);let Hi=f=class{static diff(q,we,Fe){const Ze=new f(q);return Ze.expectedOutput=we,Ze.actualOutput=Fe,Ze}constructor(q){this.message=q}};e.$6M=Hi,e.$6M=Hi=f=Je([y],Hi);let Gi=class{constructor(q){this.id=q}};e.$7M=Gi,e.$7M=Gi=Je([y],Gi);class Pi{constructor(q,we){this.covered=q,this.total=we}}e.$8M=Pi;const Ji=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class $e{static fromDetails(q,we){const Fe=new Pi(0,0),Ze=new Pi(0,0),tt=new Pi(0,0);for(const mt of we)if("branches"in mt){Fe.total+=1,Fe.covered+=mt.executed?1:0;for(const ei of mt.branches)Ze.total+=1,Ze.covered+=ei.executed?1:0}else tt.total+=1,tt.covered+=mt.executed?1:0;const ht=new $e(q,Fe,Ze.total>0?Ze:void 0,tt.total>0?tt:void 0);return ht.detailedCoverage=we,ht}constructor(q,we,Fe,Ze){this.uri=q,this.statementCoverage=we,this.branchCoverage=Fe,this.declarationCoverage=Ze,Ji(we),Ji(Fe),Ji(Ze)}}e.$9M=$e;class ke{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Fe=[]){this.executed=q,this.location=we,this.branches=Fe}}e.$0M=ke;class Ue{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Fe){this.executed=q,this.location=we,this.label=Fe}}e.$$M=Ue;class ut{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Fe){this.name=q,this.executed=we,this.location=Fe}}e.$_M=ut;var wt;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(wt||(e.ExternalUriOpenerPriority=wt={}));var Tt;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(Tt||(e.WorkspaceTrustState=Tt={}));var Li;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Li||(e.PortAutoForwardAction=Li={}));class Pn{constructor(q,we,Fe,Ze,tt,ht){this.kind=q,this.name=we,this.detail=Fe,this.uri=Ze,this.range=tt,this.selectionRange=ht}}e.$aN=Pn;class Ln{constructor(q){this.uri=q}}e.$bN=Ln;class An{constructor(q,we){this.original=q,this.modified=we}}e.$cN=An;class Rn{constructor(q,we,Fe,Ze){this.base=q,this.input1=we,this.input2=Fe,this.result=Ze}}e.$dN=Rn;class Nn{constructor(q,we){this.uri=q,this.viewType=we}}e.$eN=Nn;class Mn{constructor(q){this.viewType=q}}e.$fN=Mn;class Fn{constructor(q,we){this.uri=q,this.notebookType=we}}e.$gN=Fn;class Tn{constructor(q,we,Fe){this.original=q,this.modified=we,this.notebookType=Fe}}e.$hN=Tn;class On{constructor(){}}e.$iN=On;class jn{constructor(q,we){this.uri=q,this.inputBoxUri=we}}e.$jN=jn;class zn{constructor(q){this.providerId=q}}e.$kN=zn;var wn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var pn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(pn||(e.ChatAgentCopyKind=pn={}));var vn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Un{constructor(q,we){this.label=q,this.values=we}}e.$lN=Un;var yn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(G){G[G.System=0]="System",G[G.User=1]="User",G[G.Assistant=2]="Assistant"})(En||(e.ChatMessageRole=En={}));class Bn{constructor(q,we){this.role=q,this.content=we}}e.$mN=Bn;var kn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));class Wn{constructor(q){this.value=q}}e.$nN=Wn;class qn{constructor(q){this.value=typeof q=="string"?new qe(q):q}}e.$oN=qn;class Vn{constructor(q,we){this.value=q,this.baseUri=we}}e.$pN=Vn;class Hn{constructor(q,we){this.value=q,this.title=we}}e.$qN=Hn;class Gn{constructor(q){this.value=q}}e.$rN=Gn;class Jn{constructor(q){this.value=q}}e.$sN=Jn;class Yn{constructor(q){this.value=q}}e.$tN=Yn;class Kn{constructor(q,we,Fe,Ze){this.prompt=q,this.command=we,this.variables=Fe,this.agent=Ze,this.agentId=Ze.agentId}}e.$uN=Kn;class Qn{constructor(q,we,Fe){this.response=q,this.result=we,this.agent=Fe,this.agentId=Fe.agentId}}e.$vN=Qn;class Zn{constructor(q){this.content=q}}e.$wN=Zn;class Xn{constructor(q,we){this.content=q,this.name=we}}e.$xN=Xn;class xn{constructor(q){this.content=q}}e.$yN=xn;var Sn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var Cn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(Ce[314],Ie([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class ${constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$rL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,v,p){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(A);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(v,p)??[]}getRelatedInformation(A,v,p){return this.c.$getAiRelatedInformation(v,p)}registerRelatedInformationProvider(A,v,p){const k=this.b;return this.b++,this.a.set(k,p),this.c.$registerAiRelatedInformationProvider(k,v),new F.$tL(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Tgc=$}),define(Ce[315],Ie([1,0,4,6,7,25,142]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class v{constructor(R){this.b=new Map,this.c=new I.$Yd,this.onDidChangeSessions=this.c.event,this.d=new p,this.f=new p,this.a=R.getProxy(F.$rL.MainThreadAuthentication)}async getSession(R,C,m,E={}){const S=L.$qm.toKey(R.identifier),l=[...m].sort().join(" ");return await this.d.getOrCreate(`${S} ${C} ${l}`,async()=>{await this.a.$ensureProvider(C);const w=R.displayName||R.name;return this.a.$getSession(C,m,S,w,E)})}async getSessions(R,C,m){const E=L.$qm.toKey(R.identifier),S=[...m].sort().join(" ");return await this.f.getOrCreate(`${E} ${S}`,async()=>{await this.a.$ensureProvider(C);const l=R.displayName||R.name;return this.a.$getSessions(C,m,E,l)})}async removeSession(R,C){const m=this.b.get(R);return m?m.provider.removeSession(C):this.a.$removeSession(R,C)}registerAuthenticationProvider(R,C,m,E){if(this.b.get(R))throw new Error(`An authentication provider with id '${R}' is already registered.`);this.b.set(R,{label:C,provider:m,options:E??{supportsMultipleAccounts:!1}});const S=m.onDidChangeSessions(l=>this.a.$sendDidChangeSessions(R,l));return this.a.$registerAuthenticationProvider(R,C,E?.supportsMultipleAccounts??!1),new $.$tL(()=>{S.dispose(),this.b.delete(R),this.a.$unregisterAuthenticationProvider(R)})}$createSession(R,C,m){const E=this.b.get(R);if(E)return Promise.resolve(E.provider.createSession(C,m));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$removeSession(R,C){const m=this.b.get(R);if(m)return Promise.resolve(m.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$getSessions(R,C){const m=this.b.get(R);if(m)return Promise.resolve(m.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${R}`)}$onDidChangeAuthenticationSessions(R,C){return R.startsWith(A.$xK)||this.c.fire({provider:{id:R,label:C}}),Promise.resolve()}}e.$5gc=v;class p{constructor(){this.a=new Map}getOrCreate(R,C){const m=this.a.get(R);if(m)return m;const E=C().finally(()=>this.a.delete(R));return this.a.set(R,E),E}}}),define(Ce[148],Ie([1,0,2,6,7,5,20,13,19,12,17,26]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=void 0;let E=class{static{m=this}static{this.c=0}static{this.d=250}constructor(l,w){this.h=w,this.f=new Map,this.g=l.getProxy(F.$rL.MainThreadDecorations)}registerFileDecorationProvider(l,w){const s=m.c++;this.f.set(s,{provider:l,extensionDescription:w}),this.g.$registerDecorationProvider(s,w.identifier.value);const i=l.onDidChangeFileDecorations&&l.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const r=(0,p.$3b)(n);if(r.length<=m.d){this.g.$onDidChange(s,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",w.identifier.value,r.length);const a=r.map(c=>({uri:c,rank:(0,k.$Se)(c.path,"/")})),t=(0,p.$zb)(a,(c,o)=>c.rank-o.rank||(0,k.$9e)(c.uri.path,o.uri.path)),h=[];e:for(const c of t){let o;for(const u of c){const d=(0,R.$mc)(u.uri.path);if(o!==d&&(o=d,h.push(u.uri)>=m.d))break e}}this.g.$onDidChange(s,h)});return new $.$tL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(l,w,s){if(!this.f.has(l))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(l);return await Promise.all(w.map(async a=>{try{const{uri:t,id:h}=a,c=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),s));if(!c)return;try{$.$RM.validate(c),c.badge&&typeof c.badge!="string"&&(0,C.$OF)(r,"codiconDecoration"),i[h]=[c.propagate,c.tooltip,c.badge,c.color]}catch(o){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),i}};e.$4hc=E,e.$4hc=E=m=Je([We(0,A.$JN),We(1,v.$sj)],E),e.$5hc=(0,L.$$h)("IExtHostDecorations")}),define(Ce[316],Ie([1,0,14,2,7,6,16,22,12]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class k{static{this.a=0}constructor(C,m,E){this.d=m,this.e=E,this.b=new Map,this.c=C.getProxy(L.$rL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(A.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const E=k.a++;this.b.set(E,m),this.c.$registerTextContentProvider(E,C);let S;if(typeof m.onDidChange=="function"){let l;S=m.onDidChange(async w=>{if(w.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(w))return;l&&await l;const s=this.$provideTextDocumentContent(E,w).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(w);if(!n)return;const r=(0,p.$3e)(i);if(!n.equalLines(r))return this.c.$onVirtualDocumentChange(w,i)}).catch(I.$1).finally(()=>{l===s&&(l=void 0)});l=s})}return new $.$tL(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,m){const E=this.b.get(C);return E?Promise.resolve(E.provideTextDocumentContent(F.URI.revive(m),v.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$7hc=k}),define(Ce[149],Ie([1,0,61,16,12,177,126,7,19]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=e.$MN=e.$LN=void 0;const k=new Map;function R(S,l){l?k.set(S,l):k.delete(S)}e.$LN=R;function C(S){return k.get(S)}class m extends L.$qv{constructor(l,w,s,i,n,r,a,t){super(w,s,i,n),this.c=l,this.m=r,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,p.$ub)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===F.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(w){return w?l.s(w):l.getText()},get eol(){return l.g===`
`?v.EndOfLine.LF:v.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(w){return l.t(w)},offsetAt(w){return l.u(w)},positionAt(w){return l.v(w)},validateRange(w){return l.w(w)},validatePosition(w){return l.x(w)},getWordRangeAtPosition(w,s){return l.y(w,s)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,I.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,I.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const w=this.w(l);if(w.isEmpty)return"";if(w.isSingleLine)return this.f[w.start.line].substring(w.start.character,w.end.character);const s=this.g,i=w.start.line,n=w.end.line,r=[];r.push(this.f[i].substring(w.start.character));for(let a=i+1;a<n;a++)r.push(this.f[a]);return r.push(this.f[n].substring(0,w.end.character)),r.join(s)}t(l){let w;if(l instanceof v.$uL?w=l.line:typeof l=="number"&&(w=l),typeof w!="number"||w<0||w>=this.f.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new E(w,this.f[w],w===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const w=this.j.getIndexOf(l),s=this.f[w.index].length;return new v.$uL(w.index,Math.min(w.remainder,s))}w(l){if(!(l instanceof v.$vL))throw new Error("Invalid argument");const w=this.x(l.start),s=this.x(l.end);return w===l.start&&s===l.end?l:new v.$vL(w.line,w.character,s.line,s.character)}x(l){if(!(l instanceof v.$uL))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:w,character:s}=l,i=!1;if(w<0)w=0,s=0,i=!0;else if(w>=this.f.length)w=this.f.length-1,s=this.f[w].length,i=!0;else{const n=this.f[w].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new v.$uL(w,s):l}y(l,w){const s=this.x(l);if(!w)w=C(this.m);else if((0,$.$2e)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const i=(0,A.$Cs)(s.character+1,(0,A.$As)(w),this.f[s.line],0);if(i)return new v.$vL(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$MN=m;class E{constructor(l,w,s){this.a=l,this.b=w,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new v.$vL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new v.$vL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$NN=E}),define(Ce[317],Ie([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class ${constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(I.$rL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,v,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(A);if(!k)throw new Error("Embedding vector provider not found");const R=await k.provideEmbeddingVector(v,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,v,p){const k=this.b;return this.b++,this.a.set(k,p),this.c.$registerAiEmbeddingVectorProvider(v,k),new F.$tL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$9hc=$}),define(Ce[70],Ie([1,0,6,32,7,21,5,20,59,3,8,23,16]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0;let S=E=class{constructor(w,s){this.b=new Map,this.c=new R.$hh,this.a=w.getProxy(I.$rL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),r=await a.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===F.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return E.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return E.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return E.e(r)}},async writeFile(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(a.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,L.$me.wrap(r))}catch(a){return E.e(a)}},async delete(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly&&!r?.useTrash?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return E.e(a)}},async rename(n,r,a){try{return await i.a.$rename(n,r,{overwrite:!1,...a})}catch(t){return E.e(t)}},async copy(n,r,a){try{return await i.a.$copy(n,r,{overwrite:!1,...a})}catch(t){return E.e(t)}},isWritableFileSystem(n){const r=s.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(w,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await w.stat(i)).type&F.FileType.Directory))throw $.$IM.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(F.$Lk(r)!==F.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(s.basename(i)),i=s.dirname(i)}for(let r=n.length-1;r>=0;r--){i=s.joinPath(i,n[r]);try{await w.createDirectory(i)}catch(a){if(F.$Lk(a)!==F.FileSystemProviderErrorCode.FileExists)throw a}}}static e(w){if(w instanceof $.$IM)throw w;if(w instanceof F.$Hk)switch(w.code){case F.FileSystemProviderErrorCode.FileExists:throw $.$IM.FileExists(w.message);case F.FileSystemProviderErrorCode.FileNotFound:throw $.$IM.FileNotFound(w.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw $.$IM.FileNotADirectory(w.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw $.$IM.FileIsADirectory(w.message);case F.FileSystemProviderErrorCode.NoPermissions:throw $.$IM.NoPermissions(w.message);case F.FileSystemProviderErrorCode.Unavailable:throw $.$IM.Unavailable(w.message);default:throw new $.$IM(w.message,w.name)}if(!(w instanceof Error))throw new $.$IM(String(w));if(w.name==="ENOPRO"||w.message.includes("ENOPRO"))throw $.$IM.Unavailable(w.message);switch(w.name){case F.FileSystemProviderErrorCode.FileExists:throw $.$IM.FileExists(w.message);case F.FileSystemProviderErrorCode.FileNotFound:throw $.$IM.FileNotFound(w.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw $.$IM.FileNotADirectory(w.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw $.$IM.FileIsADirectory(w.message);case F.FileSystemProviderErrorCode.NoPermissions:throw $.$IM.NoPermissions(w.message);case F.FileSystemProviderErrorCode.Unavailable:throw $.$IM.Unavailable(w.message);default:throw new $.$IM(w.message,w.name)}}addFileSystemProvider(w,s,i){return this.b.set(w,{impl:s,extUri:i?.isCaseSensitive?C.$Bg:C.$Dg,isReadonly:!!i?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(w))}getFileSystemProviderExtUri(w){return this.b.get(w)?.extUri??C.$Bg}};e.$jhc=S,e.$jhc=S=E=Je([We(0,v.$JN),We(1,p.$Ygc)],S),e.$khc=(0,A.$$h)("IExtHostConsumerFileSystem")}),define(Ce[318],Ie([1,0,6,7]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class ${constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(I.$rL.MainThreadIssueReporter)}async $getIssueReporterUri(A,v){if(this.a.size===0)throw new Error("No issue request handlers registered");const p=this.a.get(A);if(!p)throw new Error("Issue request handler not found");const k=await p.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(A,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(A);if(!p)throw new Error("Issue data provider not found");const k=await p.provideIssueData(v);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(A,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(A);if(!p)throw new Error("Issue data provider not found");const k=await p.provideIssueTemplate(v);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(A,v){const p=A.identifier.value;return this.a.set(p,v),this.c.$registerIssueUriRequestHandler(p),new F.$tL(()=>{this.c.$unregisterIssueUriRequestHandler(p),this.a.delete(p)})}registerIssueDataProvider(A,v){const p=A.identifier.value;return this.b.set(p,v),this.c.$registerIssueDataProvider(p),new F.$tL(()=>{this.c.$unregisterIssueDataProvider(p),this.b.delete(p)})}}e.$nic=$}),define(Ce[93],Ie([1,0,5,27,13,70,2]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0,e.$lhc=(0,I.$$h)("IExtensionStoragePaths");let v=class{constructor(k,R,C){this.d=R,this.f=C,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(k){return A.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,R=await this.g(k);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(k){if(this.c)return A.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return A.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$mhc=v,e.$mhc=v=Je([We(0,F.$ZN),We(1,$.$sj),We(2,L.$khc)],v)}),define(Ce[319],Ie([1,0,7,20,4]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;let L=class{constructor(v){this.a=new I.$SM(I.ColorThemeKind.Dark),this.b=new $.$Yd}get activeColorTheme(){return this.a}$onColorThemeChange(v){let p;switch(v){case"light":p=I.ColorThemeKind.Light;break;case"hcDark":p=I.ColorThemeKind.HighContrast;break;case"hcLight":p=I.ColorThemeKind.HighContrastLight;break;default:p=I.ColorThemeKind.Dark}this.a=new I.$SM(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Qic=L,e.$Qic=L=Je([We(0,F.$JN)],L)}),define(Ce[71],Ie([1,0,22,4,3,222,5,13,88,6,27,20,7]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lzb=e.$Kzb=e.TunnelDtoConverter=void 0;class E extends p.$Ov{}var S;(function(w){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}w.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}w.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Kzb=(0,A.$$h)("IExtHostTunnelService");let l=class extends $.$Tc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Yd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(k.$rL.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const r=new E(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new m.$tL(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,r,a){const t=[];for(const c of s){const o=this.r.get(c);if(!o)return[];t.push(...await Promise.all(i.map(async u=>{let d;try{d=await o.provider.providePortAttributes({port:u,pid:n,commandLine:r},a)}catch{d=await o.provider.providePortAttributes(u,n,r,a)}return{providedAttributes:d,port:u}})))}const h=t.filter(c=>!!c.providedAttributes);return h.length>0?h.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,a)=>await s.provideTunnel(r,a,new I.$9d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,$.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,$.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:r,disposeListener:a}),S.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(r=>this.f(r.host,r.port,r.detail??""))),n=s.filter((r,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$Lzb=l,e.$Lzb=l=Je([We(0,C.$JN),We(1,R.$ZN),We(2,v.$sj)],l)}),define(Ce[15],Ie([1,0,19,21,166,75,63,28,161,56,100,24,23,18,2,29,83,135,141,139,118,68,89,292,26,7]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.LanguageModelMessage=e.ChatMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$IN=e.$HN=e.MarkdownString=e.$GN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var u;(function(Ne){function Oe(_){const{selectionStartLineNumber:Te,selectionStartColumn:Be,positionLineNumber:xe,positionColumn:Qe}=_,rt=new o.$uL(Te-1,Be-1),vt=new o.$uL(xe-1,Qe-1);return new o.$wL(rt,vt)}Ne.to=Oe;function ve(_){const{anchor:Te,active:Be}=_;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ne.from=ve})(u||(e.Selection=u={}));var d;(function(Ne){function Oe(_){if(!_)return;const{start:Te,end:Be}=_;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ne.from=Oe;function ve(_){if(!_)return;const{startLineNumber:Te,startColumn:Be,endLineNumber:xe,endColumn:Qe}=_;return new o.$vL(Te-1,Be-1,xe-1,Qe-1)}Ne.to=ve})(d||(e.Range=d={}));var b;(function(Ne){function Oe(_){return{uri:_.uri,range:d.from(_.range)}}Ne.from=Oe;function ve(_){return new o.$FL(S.URI.revive(_.uri),d.to(_.range))}Ne.to=ve})(b||(e.Location=b={}));var D;(function(Ne){function Oe(ve){switch(ve){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}Ne.to=Oe})(D||(e.TokenType=D={}));var g;(function(Ne){function Oe(_){return new o.$uL(_.lineNumber-1,_.column-1)}Ne.to=Oe;function ve(_){return{lineNumber:_.line+1,column:_.character+1}}Ne.from=ve})(g||(e.Position=g={}));var f;(function(Ne){function Oe(Te,Be,xe){return(0,I.$Hb)((0,I.$3b)(Te).map(Qe=>ve(Qe,Be,xe)))}Ne.from=Oe;function ve(Te,Be,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:_(Te.scheme,Be),pattern:De.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function _(Te,Be){return Be&&typeof Te=="string"?Be.transformOutgoingScheme(Te):Te}})(f||(e.DocumentSelector=f={}));var y;(function(Ne){function Oe(_){switch(_){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}Ne.from=Oe;function ve(_){switch(_){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}Ne.to=ve})(y||(e.DiagnosticTag=y={}));var P;(function(Ne){function Oe(_){let Te;return _.code&&((0,E.$Mf)(_.code)||(0,E.$Qf)(_.code)?Te=String(_.code):Te={value:String(_.code.value),target:_.code.target}),{...d.from(_.range),message:_.message,source:_.source,code:Te,severity:U.from(_.severity),relatedInformation:_.relatedInformation&&_.relatedInformation.map(T.from),tags:Array.isArray(_.tags)?(0,I.$Hb)(_.tags.map(y.from)):void 0}}Ne.from=Oe;function ve(_){const Te=new o.$HL(d.to(_),_.message,U.to(_.severity));return Te.source=_.source,Te.code=(0,E.$Mf)(_.code)?_.code:_.code?.value,Te.relatedInformation=_.relatedInformation&&_.relatedInformation.map(T.to),Te.tags=_.tags&&(0,I.$Hb)(_.tags.map(y.to)),Te}Ne.to=ve})(P||(e.Diagnostic=P={}));var T;(function(Ne){function Oe(_){return{...d.from(_.location.range),message:_.message,resource:_.location.uri}}Ne.from=Oe;function ve(_){return new o.$GL(new o.$FL(_.resource,d.to(_)),_.message)}Ne.to=ve})(T||(e.DiagnosticRelatedInformation=T={}));var U;(function(Ne){function Oe(_){switch(_){case o.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}Ne.from=Oe;function ve(_){switch(_){case s.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}Ne.to=ve})(U||(e.DiagnosticSeverity=U={}));var z;(function(Ne){function Oe(_){return typeof _=="number"&&_>=o.ViewColumn.One?_-1:_===o.ViewColumn.Beside?h.$jD:h.$iD}Ne.from=Oe;function ve(_){if(typeof _=="number"&&_>=0)return _+1;throw new Error("invalid 'EditorGroupColumn'")}Ne.to=ve})(z||(e.ViewColumn=z={}));function M(Ne){return typeof Ne.range<"u"}function N(Ne){return Ne.length===0?!0:!!M(Ne[0])}e.$GN=N;var O;(function(Ne){function Oe(Qe){return Qe.map(Ne.from)}Ne.fromMany=Oe;function ve(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function _(Qe){let rt;if(ve(Qe)){const{language:Pt,value:ct}=Qe;rt={value:"```"+Pt+`
`+ct+"\n```\n"}}else o.$UL.isMarkdownString(Qe)?rt={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?rt={value:Qe}:rt={value:""};const vt=Object.create(null);rt.uris=vt;const Jt=Pt=>{try{let ct=S.URI.parse(Pt,!0);ct=ct.with({query:Te(ct.query,vt)}),vt[Pt]=ct}catch{}return""},Bt=new p.marked.Renderer;return Bt.link=Jt,Bt.image=Pt=>typeof Pt=="string"?Jt(A.$uk(Pt).href):"",(0,p.marked)(rt.value,{renderer:Bt}),rt}Ne.from=_;function Te(Qe,rt){if(!Qe)return Qe;let vt;try{vt=(0,k.$Gh)(Qe)}catch{}if(!vt)return Qe;let Jt=!1;return vt=(0,C.$Dn)(vt,Bt=>{if(S.URI.isUri(Bt)){const Pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[Pt]=Bt,Jt=!0,Pt}else return}),Jt?JSON.stringify(vt):Qe}function Be(Qe){const rt=new o.$UL(Qe.value,Qe.supportThemeIcons);return rt.isTrusted=Qe.isTrusted,rt.supportHtml=Qe.supportHtml,rt.baseUri=Qe.baseUri?S.URI.from(Qe.baseUri):void 0,rt}Ne.to=Be;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Ne.from(Qe)}Ne.fromStrict=xe})(O||(e.MarkdownString=O={}));function j(Ne){return N(Ne)?Ne.map(Oe=>({range:d.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?O.fromMany(Oe.hoverMessage):Oe.hoverMessage?O.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ne.map(Oe=>({range:d.from(Oe)}))}e.$HN=j;function Y(Ne){return typeof Ne>"u"?Ne:typeof Ne=="string"?S.URI.file(Ne):Ne}e.$IN=Y;var ne;(function(Ne){function Oe(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?Y(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ne.from=Oe})(ne||(e.ThemableDecorationAttachmentRenderOptions=ne={}));var ee;(function(Ne){function Oe(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?Y(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?ne.from(ve.before):void 0,after:ve.after?ne.from(ve.after):void 0}}Ne.from=Oe})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Q;(function(Ne){function Oe(ve){if(typeof ve>"u")return ve;switch(ve){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}Ne.from=Oe})(Q||(e.DecorationRangeBehavior=Q={}));var X;(function(Ne){function Oe(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?Q.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?ee.from(ve.light):void 0,dark:ve.dark?ee.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?Y(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?ne.from(ve.before):void 0,after:ve.after?ne.from(ve.after):void 0}}Ne.from=Oe})(X||(e.DecorationRenderOptions=X={}));var ce;(function(Ne){function Oe(_){return{text:_.newText,eol:_.newEol&&Ae.from(_.newEol),range:d.from(_.range)}}Ne.from=Oe;function ve(_){const Te=new o.$AL(d.to(_.range),_.text);return Te.newEol=typeof _.eol>"u"?void 0:Ae.to(_.eol),Te}Ne.to=ve})(ce||(e.TextEdit=ce={}));var ie;(function(Ne){function Oe(_,Te){const Be={edits:[]};if(_ instanceof o.$DL){const xe=new v.$Bc;for(const Qe of _._allEntries())Qe._type===1&&S.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of _._allEntries())if(Qe._type===1){let rt;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?rt={type:"base64",value:(0,F.$Ge)(F.$me.wrap(Qe.options.contents))}:rt={type:"dataTransferItem",id:Qe.options.contents._itemId}),Be.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:rt},metadata:Qe.metadata})}else Qe._type===2?Be.edits.push({resource:Qe.uri,textEdit:ce.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Be.edits.push({resource:Qe.uri,textEdit:{range:d.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Ot.from)}})}return Be}Ne.from=Oe;function ve(_){const Te=new o.$DL,Be=new v.$Ac;for(const xe of _.edits)if(xe.textEdit){const Qe=xe,rt=S.URI.revive(Qe.resource),vt=d.to(Qe.textEdit.range),Jt=Qe.textEdit.text,Bt=Qe.textEdit.insertAsSnippet;let Pt;Bt?Pt=o.$CL.replace(vt,new o.$EL(Jt)):Pt=o.$AL.replace(vt,Jt);const ct=Be.get(rt);ct?ct.push(Pt):Be.set(rt,[Pt])}else Te.renameFile(S.URI.revive(xe.oldResource),S.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of Be)Te.set(xe,Qe);return Te}Ne.to=ve})(ie||(e.WorkspaceEdit=ie={}));var fe;(function(Ne){const Oe=Object.create(null);Oe[o.SymbolKind.File]=0,Oe[o.SymbolKind.Module]=1,Oe[o.SymbolKind.Namespace]=2,Oe[o.SymbolKind.Package]=3,Oe[o.SymbolKind.Class]=4,Oe[o.SymbolKind.Method]=5,Oe[o.SymbolKind.Property]=6,Oe[o.SymbolKind.Field]=7,Oe[o.SymbolKind.Constructor]=8,Oe[o.SymbolKind.Enum]=9,Oe[o.SymbolKind.Interface]=10,Oe[o.SymbolKind.Function]=11,Oe[o.SymbolKind.Variable]=12,Oe[o.SymbolKind.Constant]=13,Oe[o.SymbolKind.String]=14,Oe[o.SymbolKind.Number]=15,Oe[o.SymbolKind.Boolean]=16,Oe[o.SymbolKind.Array]=17,Oe[o.SymbolKind.Object]=18,Oe[o.SymbolKind.Key]=19,Oe[o.SymbolKind.Null]=20,Oe[o.SymbolKind.EnumMember]=21,Oe[o.SymbolKind.Struct]=22,Oe[o.SymbolKind.Event]=23,Oe[o.SymbolKind.Operator]=24,Oe[o.SymbolKind.TypeParameter]=25;function ve(Te){return typeof Oe[Te]=="number"?Oe[Te]:6}Ne.from=ve;function _(Te){for(const Be in Oe)if(Oe[Be]===Te)return Number(Be);return o.SymbolKind.Property}Ne.to=_})(fe||(e.SymbolKind=fe={}));var re;(function(Ne){function Oe(_){switch(_){case o.SymbolTag.Deprecated:return 1}}Ne.from=Oe;function ve(_){switch(_){case 1:return o.SymbolTag.Deprecated}}Ne.to=ve})(re||(e.SymbolTag=re={}));var J;(function(Ne){function Oe(_){return{name:_.name,kind:fe.from(_.kind),tags:_.tags&&_.tags.map(re.from),containerName:_.containerName,location:de.from(_.location)}}Ne.from=Oe;function ve(_){const Te=new o.$LL(_.name,fe.to(_.kind),_.containerName,de.to(_.location));return Te.tags=_.tags&&_.tags.map(re.to),Te}Ne.to=ve})(J||(e.WorkspaceSymbol=J={}));var B;(function(Ne){function Oe(_){const Te={name:_.name||"!!MISSING: name!!",detail:_.detail,range:d.from(_.range),selectionRange:d.from(_.selectionRange),kind:fe.from(_.kind),tags:_.tags?.map(re.from)??[]};return _.children&&(Te.children=_.children.map(Oe)),Te}Ne.from=Oe;function ve(_){const Te=new o.$ML(_.name,_.detail,fe.to(_.kind),d.to(_.range),d.to(_.selectionRange));return(0,I.$Lb)(_.tags)&&(Te.tags=_.tags.map(re.to)),_.children&&(Te.children=_.children.map(ve)),Te}Ne.to=ve})(B||(e.DocumentSymbol=B={}));var ae;(function(Ne){function Oe(_){const Te=new o.$QL(fe.to(_.kind),_.name,_.detail||"",S.URI.revive(_.uri),d.to(_.range),d.to(_.selectionRange));return Te._sessionId=_._sessionId,Te._itemId=_._itemId,Te}Ne.to=Oe;function ve(_,Te,Be){if(Te=Te??_._sessionId,Be=Be??_._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,name:_.name,detail:_.detail,kind:fe.from(_.kind),uri:_.uri,range:d.from(_.range),selectionRange:d.from(_.selectionRange),tags:_.tags?.map(re.from)}}Ne.from=ve})(ae||(e.CallHierarchyItem=ae={}));var Ee;(function(Ne){function Oe(ve){return new o.$RL(ae.to(ve.from),ve.fromRanges.map(_=>d.to(_)))}Ne.to=Oe})(Ee||(e.CallHierarchyIncomingCall=Ee={}));var le;(function(Ne){function Oe(ve){return new o.$SL(ae.to(ve.to),ve.fromRanges.map(_=>d.to(_)))}Ne.to=Oe})(le||(e.CallHierarchyOutgoingCall=le={}));var de;(function(Ne){function Oe(_){return{range:_.range&&d.from(_.range),uri:_.uri}}Ne.from=Oe;function ve(_){return new o.$FL(S.URI.revive(_.uri),d.to(_.range))}Ne.to=ve})(de||(e.location=de={}));var ue;(function(Ne){function Oe(_){const Te=_,Be=_;return{originSelectionRange:Te.originSelectionRange?d.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Be.uri,range:d.from(Te.targetRange?Te.targetRange:Be.range),targetSelectionRange:Te.targetSelectionRange?d.from(Te.targetSelectionRange):void 0}}Ne.from=Oe;function ve(_){return{targetUri:S.URI.revive(_.uri),targetRange:d.to(_.range),targetSelectionRange:_.targetSelectionRange?d.to(_.targetSelectionRange):void 0,originSelectionRange:_.originSelectionRange?d.to(_.originSelectionRange):void 0}}Ne.to=ve})(ue||(e.DefinitionLink=ue={}));var ge;(function(Ne){function Oe(_){return{range:d.from(_.range),contents:O.fromMany(_.contents)}}Ne.from=Oe;function ve(_){return new o.$IL(_.contents.map(O.to),d.to(_.range))}Ne.to=ve})(ge||(e.Hover=ge={}));var V;(function(Ne){function Oe(_){return{range:d.from(_.range),expression:_.expression}}Ne.from=Oe;function ve(_){return new o.$CM(d.to(_.range),_.expression)}Ne.to=ve})(V||(e.EvaluatableExpression=V={}));var Z;(function(Ne){function Oe(_){if(_ instanceof o.$DM)return{type:"text",range:d.from(_.range),text:_.text};if(_ instanceof o.$EM)return{type:"variable",range:d.from(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};if(_ instanceof o.$FM)return{type:"expression",range:d.from(_.range),expression:_.expression};throw new Error("Unknown 'InlineValue' type")}Ne.from=Oe;function ve(_){switch(_.type){case"text":return{range:d.to(_.range),text:_.text};case"variable":return{range:d.to(_.range),variableName:_.variableName,caseSensitiveLookup:_.caseSensitiveLookup};case"expression":return{range:d.to(_.range),expression:_.expression}}}Ne.to=ve})(Z||(e.InlineValue=Z={}));var he;(function(Ne){function Oe(_){return{frameId:_.frameId,stoppedLocation:d.from(_.stoppedLocation)}}Ne.from=Oe;function ve(_){return new o.$GM(_.frameId,d.to(_.stoppedLocation))}Ne.to=ve})(he||(e.InlineValueContext=he={}));var be;(function(Ne){function Oe(_){return{range:d.from(_.range),kind:_.kind}}Ne.from=Oe;function ve(_){return new o.$JL(d.to(_.range),_.kind)}Ne.to=ve})(be||(e.DocumentHighlight=be={}));var Pe;(function(Ne){function Oe(_){return{uri:_.uri,highlights:_.highlights.map(be.from)}}Ne.from=Oe;function ve(_){return new o.$KL(S.URI.revive(_.uri),_.highlights.map(be.to))}Ne.to=ve})(Pe||(e.MultiDocumentHighlight=Pe={}));var pe;(function(Ne){function Oe(ve){switch(ve){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}Ne.to=Oe})(pe||(e.CompletionTriggerKind=pe={}));var Le;(function(Ne){function Oe(ve){return{triggerKind:pe.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ne.to=Oe})(Le||(e.CompletionContext=Le={}));var Me;(function(Ne){function Oe(_){switch(_){case o.CompletionItemTag.Deprecated:return 1}}Ne.from=Oe;function ve(_){switch(_){case 1:return o.CompletionItemTag.Deprecated}}Ne.to=ve})(Me||(e.CompletionItemTag=Me={}));var W;(function(Ne){const Oe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function ve(Be){return Oe.get(Be)??9}Ne.from=ve;const _=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Te(Be){return _.get(Be)??o.CompletionItemKind.Property}Ne.to=Te})(W||(e.CompletionItemKind=W={}));var x;(function(Ne){function Oe(ve,_){const Te=new o.$1L(ve.label);return Te.insertText=ve.insertText,Te.kind=W.to(ve.kind),Te.tags=ve.tags?.map(Me.to),Te.detail=ve.detail,Te.documentation=A.$ok(ve.documentation)?O.to(ve.documentation):ve.documentation,Te.sortText=ve.sortText,Te.filterText=ve.filterText,Te.preselect=ve.preselect,Te.commitCharacters=ve.commitCharacters,l.$Zs.isIRange(ve.range)?Te.range=d.to(ve.range):typeof ve.range=="object"&&(Te.range={inserting:d.to(ve.range.insert),replacing:d.to(ve.range.replace)}),Te.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Te.insertText=new o.$EL(ve.insertText):(Te.insertText=ve.insertText,Te.textEdit=Te.range instanceof o.$vL?new o.$AL(Te.range,Te.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Te.additionalTextEdits=ve.additionalTextEdits.map(Be=>ce.to(Be))),Te.command=_&&ve.command?_.fromInternal(ve.command):void 0,Te}Ne.to=Oe})(x||(e.CompletionItem=x={}));var H;(function(Ne){function Oe(_){if(typeof _.label!="string"&&!Array.isArray(_.label))throw new TypeError("Invalid label");return{label:_.label,documentation:O.fromStrict(_.documentation)}}Ne.from=Oe;function ve(_){return{label:_.label,documentation:A.$ok(_.documentation)?O.to(_.documentation):_.documentation}}Ne.to=ve})(H||(e.ParameterInformation=H={}));var K;(function(Ne){function Oe(_){return{label:_.label,documentation:O.fromStrict(_.documentation),parameters:Array.isArray(_.parameters)?_.parameters.map(H.from):[],activeParameter:_.activeParameter}}Ne.from=Oe;function ve(_){return{label:_.label,documentation:A.$ok(_.documentation)?O.to(_.documentation):_.documentation,parameters:Array.isArray(_.parameters)?_.parameters.map(H.to):[],activeParameter:_.activeParameter}}Ne.to=ve})(K||(e.SignatureInformation=K={}));var oe;(function(Ne){function Oe(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(K.from):[]}}Ne.from=Oe;function ve(_){return{activeSignature:_.activeSignature,activeParameter:_.activeParameter,signatures:Array.isArray(_.signatures)?_.signatures.map(K.to):[]}}Ne.to=ve})(oe||(e.SignatureHelp=oe={}));var ye;(function(Ne){function Oe(ve,_){const Te=new o.$ZL(g.to(_.position),typeof _.label=="string"?_.label:_.label.map(Re.to.bind(void 0,ve)),_.kind&&qe.to(_.kind));return Te.textEdits=_.textEdits&&_.textEdits.map(ce.to),Te.tooltip=A.$ok(_.tooltip)?O.to(_.tooltip):_.tooltip,Te.paddingLeft=_.paddingLeft,Te.paddingRight=_.paddingRight,Te}Ne.to=Oe})(ye||(e.InlayHint=ye={}));var Re;(function(Ne){function Oe(ve,_){const Te=new o.$YL(_.label);return Te.tooltip=A.$ok(_.tooltip)?O.to(_.tooltip):_.tooltip,w.Command.is(_.command)&&(Te.command=ve.fromInternal(_.command)),_.location&&(Te.location=de.to(_.location)),Te}Ne.to=Oe})(Re||(e.InlayHintLabelPart=Re={}));var qe;(function(Ne){function Oe(_){return _}Ne.from=Oe;function ve(_){return _}Ne.to=ve})(qe||(e.InlayHintKind=qe={}));var Ge;(function(Ne){function Oe(_){return{range:d.from(_.range),url:_.target,tooltip:_.tooltip}}Ne.from=Oe;function ve(_){let Te;if(_.url)try{Te=typeof _.url=="string"?S.URI.parse(_.url,!0):S.URI.revive(_.url)}catch{}return new o.$6L(d.to(_.range),Te)}Ne.to=ve})(Ge||(e.DocumentLink=Ge={}));var Xe;(function(Ne){function Oe(_){const Te=new o.$9L(_.label);return _.textEdit&&(Te.textEdit=ce.to(_.textEdit)),_.additionalTextEdits&&(Te.additionalTextEdits=_.additionalTextEdits.map(Be=>ce.to(Be))),Te}Ne.to=Oe;function ve(_){return{label:_.label,textEdit:_.textEdit?ce.from(_.textEdit):void 0,additionalTextEdits:_.additionalTextEdits?_.additionalTextEdits.map(Te=>ce.from(Te)):void 0}}Ne.from=ve})(Xe||(e.ColorPresentation=Xe={}));var it;(function(Ne){function Oe(_){return new o.$7L(_[0],_[1],_[2],_[3])}Ne.to=Oe;function ve(_){return[_.red,_.green,_.blue,_.alpha]}Ne.from=ve})(it||(e.Color=it={}));var lt;(function(Ne){function Oe(_){return{range:d.from(_.range)}}Ne.from=Oe;function ve(_){return new o.$PL(d.to(_.range))}Ne.to=ve})(lt||(e.SelectionRange=lt={}));var at;(function(Ne){function Oe(ve){switch(ve){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}Ne.to=Oe})(at||(e.TextDocumentSaveReason=at={}));var et;(function(Ne){function Oe(_){switch(_){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}Ne.from=Oe;function ve(_){switch(_){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}Ne.to=ve})(et||(e.TextEditorLineNumbersStyle=et={}));var Ae;(function(Ne){function Oe(_){if(_===o.EndOfLine.CRLF)return 1;if(_===o.EndOfLine.LF)return 0}Ne.from=Oe;function ve(_){if(_===1)return o.EndOfLine.CRLF;if(_===0)return o.EndOfLine.LF}Ne.to=ve})(Ae||(e.EndOfLine=Ae={}));var Se;(function(Ne){function Oe(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ne.from=Oe})(Se||(e.ProgressLocation=Se={}));var He;(function(Ne){function Oe(_){const Te={start:_.start+1,end:_.end+1};return _.kind&&(Te.kind=te.from(_.kind)),Te}Ne.from=Oe;function ve(_){const Te={start:_.start-1,end:_.end-1};return _.kind&&(Te.kind=te.to(_.kind)),Te}Ne.to=ve})(He||(e.FoldingRange=He={}));var te;(function(Ne){function Oe(_){if(_)switch(_){case o.FoldingRangeKind.Comment:return w.$Pt.Comment;case o.FoldingRangeKind.Imports:return w.$Pt.Imports;case o.FoldingRangeKind.Region:return w.$Pt.Region}}Ne.from=Oe;function ve(_){if(_)switch(_.value){case w.$Pt.Comment.value:return o.FoldingRangeKind.Comment;case w.$Pt.Imports.value:return o.FoldingRangeKind.Imports;case w.$Pt.Region.value:return o.FoldingRangeKind.Region}}Ne.to=ve})(te||(e.FoldingRangeKind=te={}));var se;(function(Ne){function Oe(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?d.from(ve.selection):void 0,override:typeof ve.override=="boolean"?n.$LE.id:void 0}}Ne.from=Oe})(se||(e.TextEditorOpenOptions=se={}));var De;(function(Ne){function Oe(Be){return Be instanceof o.$qM?Be.toJSON():typeof Be=="string"?Be:ve(Be)||_(Be)?new o.$qM(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ne.from=Oe;function ve(Be){const xe=Be;return xe?S.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function _(Be){const xe=Be;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(Be){return typeof Be=="string"?Be:new o.$qM(S.URI.revive(Be.baseUri),Be.pattern)}Ne.to=Te})(De||(e.GlobPattern=De={}));var Ve;(function(Ne){function Oe(ve){if(ve){if(Array.isArray(ve))return ve.map(Oe);if(typeof ve=="string")return ve;{const _=ve;return{language:_.language,scheme:_.scheme,pattern:De.from(_.pattern),exclusive:_.exclusive,notebookType:_.notebookType}}}else return}Ne.from=Oe})(Ve||(e.LanguageSelector=Ve={}));var Ke;(function(Ne){function Oe(_){return!!_&&typeof _=="object"&&"documents"in _&&Array.isArray(_.documents)&&_.documents.every(Te=>Array.isArray(Te)&&Te.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&S.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(xe=>xe instanceof o.$vL)))}Ne.is=Oe;function ve(_){return{documents:_.documents.map(Te=>Te.map(Be=>({uri:S.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>d.from(xe))})))}}Ne.from=ve})(Ke||(e.MappedEditsContext=Ke={}));var nt;(function(Ne){function Oe(_){return{start:_.start,end:_.end}}Ne.from=Oe;function ve(_){return new o.$TM(_.start,_.end)}Ne.to=ve})(nt||(e.NotebookRange=nt={}));var st;(function(Ne){function Oe(_){return{timing:typeof _.runStartTime=="number"&&typeof _.runEndTime=="number"?{startTime:_.runStartTime,endTime:_.runEndTime}:void 0,executionOrder:_.executionOrder,success:_.lastRunSuccess}}Ne.to=Oe;function ve(_){return{lastRunSuccess:_.success,runStartTime:_.timing?.startTime,runEndTime:_.timing?.endTime,executionOrder:_.executionOrder}}Ne.from=ve})(st||(e.NotebookCellExecutionSummary=st={}));var je;(function(Ne){function Oe(ve){if(ve===r.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(ve===r.NotebookCellExecutionState.Pending)return;if(ve===r.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ne.to=Oe})(je||(e.NotebookCellExecutionState=je={}));var yt;(function(Ne){function Oe(_){switch(_){case o.NotebookCellKind.Markup:return r.CellKind.Markup;case o.NotebookCellKind.Code:default:return r.CellKind.Code}}Ne.from=Oe;function ve(_){switch(_){case r.CellKind.Markup:return o.NotebookCellKind.Markup;case r.CellKind.Code:default:return o.NotebookCellKind.Code}}Ne.to=ve})(yt||(e.NotebookCellKind=yt={}));var kt;(function(Ne){function Oe(_){const Te={metadata:_.metadata??Object.create(null),cells:[]};for(const Be of _.cells)o.$UM.validate(Be),Te.cells.push(Ot.from(Be));return Te}Ne.from=Oe;function ve(_){const Te=new o.$VM(_.cells.map(Ot.to));return(0,E.$Zf)(_.metadata)||(Te.metadata=_.metadata),Te}Ne.to=ve})(kt||(e.NotebookData=kt={}));var Ot;(function(Ne){function Oe(_){return{cellKind:yt.from(_.kind),language:_.languageId,mime:_.mime,source:_.value,metadata:_.metadata,internalMetadata:st.from(_.executionSummary??{}),outputs:_.outputs?_.outputs.map(St.from):[]}}Ne.from=Oe;function ve(_){return new o.$UM(yt.to(_.cellKind),_.source,_.language,_.mime,_.outputs?_.outputs.map(St.to):void 0,_.metadata,_.internalMetadata?st.to(_.internalMetadata):void 0)}Ne.to=ve})(Ot||(e.NotebookCellData=Ot={}));var Rt;(function(Ne){function Oe(_){return{mime:_.mime,valueBytes:F.$me.wrap(_.data)}}Ne.from=Oe;function ve(_){return new o.$WM(_.valueBytes.buffer,_.mime)}Ne.to=ve})(Rt||(e.NotebookCellOutputItem=Rt={}));var St;(function(Ne){function Oe(_){return{outputId:_.id,items:_.items.map(Rt.from),metadata:_.metadata}}Ne.from=Oe;function ve(_){const Te=_.items.map(Rt.to);return new o.$XM(Te,_.outputId,_.metadata)}Ne.to=ve})(St||(e.NotebookCellOutput=St={}));var ti;(function(Ne){function Oe(Te){return _(Te)?{include:De.from(Te.include)??void 0,exclude:De.from(Te.exclude)??void 0}:De.from(Te)??void 0}Ne.from=Oe;function ve(Te){return _(Te)?{include:De.to(Te.include),exclude:De.to(Te.exclude)}:De.to(Te)}Ne.to=ve;function _(Te){const Be=Te;return Be?!(0,E.$Vf)(Be.include)&&!(0,E.$Vf)(Be.exclude):!1}})(ti||(e.NotebookExclusiveDocumentPattern=ti={}));var Wt;(function(Ne){function Oe(ve,_,Te){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:_.toInternal(Be,Te),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ne.from=Oe})(Wt||(e.NotebookStatusBarItem=Wt={}));var si;(function(Ne){function Oe(ve,_,Te){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:_.toInternal(Be,Te),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ne.from=Oe})(si||(e.NotebookKernelSourceAction=si={}));var Xt;(function(Ne){function Oe(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ne.from=Oe})(Xt||(e.NotebookDocumentContentOptions=Xt={}));var xt;(function(Ne){function Oe(_){return{uri:_.uri,provides:_.provides}}Ne.from=Oe;function ve(_){return new o.$ZM(S.URI.revive(_.uri),_.provides)}Ne.to=ve})(xt||(e.NotebookRendererScript=xt={}));var _e;(function(Ne){function Oe(_){return{message:O.fromStrict(_.message)||"",type:0,expected:_.expectedOutput,actual:_.actualOutput,contextValue:_.contextValue,location:_.location&&{range:d.from(_.location.range),uri:_.location.uri}}}Ne.from=Oe;function ve(_){const Te=new o.$6M(typeof _.message=="string"?_.message:O.to(_.message));return Te.actualOutput=_.actual,Te.expectedOutput=_.expected,Te.contextValue=_.contextValue,Te.location=_.location?de.to(_.location):void 0,Te}Ne.to=ve})(_e||(e.TestMessage=_e={}));var qt;(function(Ne){Ne.namespace=t.$mK,Ne.denamespace=t.$nK})(qt||(e.TestTag=qt={}));var ii;(function(Ne){function Oe(_){const Te=(0,i.$FN)(_).controllerId;return{extId:a.$iK.fromExtHostTestItem(_,Te).toString(),label:_.label,uri:S.URI.revive(_.uri),busy:_.busy,tags:_.tags.map(Be=>qt.namespace(Te,Be.id)),range:l.$Zs.lift(d.from(_.range)),description:_.description||null,sortText:_.sortText||null,error:_.error&&O.fromStrict(_.error)||null}}Ne.from=Oe;function ve(_){return{parent:void 0,error:void 0,id:a.$iK.fromString(_.extId).localId,label:_.label,uri:S.URI.revive(_.uri),tags:(_.tags||[]).map(Te=>{const{tagId:Be}=qt.denamespace(Te);return new o.$7M(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(_.range||void 0),canResolveChildren:!1,busy:_.busy,description:_.description||void 0,sortText:_.sortText||void 0}}Ne.toPlain=ve})(ii||(e.TestItem=ii={})),function(Ne){function Oe(_){return{id:_.id}}Ne.from=Oe;function ve(_){return new o.$7M(_.id)}Ne.to=ve}(qt||(e.TestTag=qt={}));var dt;(function(Ne){const Oe=(_,Te)=>{const Be=[];for(const[Qe,rt]of Te)a.$iK.compare(rt.item.extId,Qe)===2&&(Te.delete(Qe),Be.push(rt));const xe={...ii.toPlain(_.item),parent:void 0,taskStates:_.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(rt=>rt.type===0).map(_e.to)})),children:Be.map(Qe=>Oe(Qe,Te))};for(const Qe of xe.children)Qe.parent=xe;return xe};function ve(_){const Te=[],Be=new Map;for(const xe of _.items){Be.set(xe.item.extId,xe);const Qe=a.$iK.root(xe.item.extId);_.request.targets.some(rt=>rt.controllerId===Qe&&rt.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:_.completedAt,results:Te.map(xe=>Oe(xe,Be))}}Ne.to=ve})(dt||(e.TestResults=dt={}));var $t;(function(Ne){function Oe(Be){return{covered:Be.covered,total:Be.total}}function ve(Be){return"line"in Be?g.from(Be):d.from(Be)}function _(Be){return"branches"in Be?{count:Be.executed,location:ve(Be.location),type:1,branches:Be.branches.length?Be.branches.map(xe=>({count:xe.executed,location:xe.location&&ve(xe.location),label:xe.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:ve(Be.location)}}Ne.fromDetailed=_;function Te(Be){return{uri:Be.uri,statement:Oe(Be.statementCoverage),branch:Be.branchCoverage&&Oe(Be.branchCoverage),declaration:Be.declarationCoverage&&Oe(Be.declarationCoverage),details:Be.detailedCoverage?.map(_)}}Ne.fromFile=Te})($t||(e.TestCoverage=$t={}));var Yt;(function(Ne){function Oe(ve){switch(ve){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}Ne.to=Oe})(Yt||(e.CodeActionTriggerKind=Yt={}));var ni;(function(Ne){function Oe(_){const Te=new o.$aN(fe.to(_.kind),_.name,_.detail||"",S.URI.revive(_.uri),d.to(_.range),d.to(_.selectionRange));return Te._sessionId=_._sessionId,Te._itemId=_._itemId,Te}Ne.to=Oe;function ve(_,Te,Be){if(Te=Te??_._sessionId,Be=Be??_._itemId,Te===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Be,kind:fe.from(_.kind),name:_.name,detail:_.detail??"",uri:_.uri,range:d.from(_.range),selectionRange:d.from(_.selectionRange),tags:_.tags?.map(re.from)}}Ne.from=ve})(ni||(e.TypeHierarchyItem=ni={}));var Lt;(function(Ne){function Oe(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ne.from=Oe})(Lt||(e.ViewBadge=Lt={}));var ft;(function(Ne){function Oe(Be,xe,Qe){const rt=xe.fileData;return rt?new o.$jM(new o.$kM(rt.name,S.URI.revive(rt.uri),rt.id,(0,L.$db)(()=>Qe(rt.id)))):Be===R.$ks.uriList&&xe.uriListData?new o.$iM(Te(xe.uriListData)):new o.$iM(xe.asString)}Ne.to=Oe;async function ve(Be,xe){const Qe=await xe.asString();if(Be===R.$ks.uriList)return{asString:Qe,fileData:void 0,uriListData:_(Qe)};const rt=xe.asFile();return{asString:Qe,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Ne.from=ve;function _(Be){return $.$wt.split(Be).map(xe=>{if(xe.startsWith("#"))return xe;try{return S.URI.parse(xe)}catch{}return xe})}function Te(Be){return $.$wt.create(Be.map(xe=>typeof xe=="string"?xe:S.URI.revive(xe)))}})(ft||(e.DataTransferItem=ft={}));var Mt;(function(Ne){function Oe(_,Te){const Be=_.items.map(([xe,Qe])=>[xe,ft.to(xe,Qe,Te)]);return new o.$lM(Be)}Ne.toDataTransfer=Oe;async function ve(_){const Te={items:[]},Be=[];for(const[xe,Qe]of _)Be.push((async()=>{Te.items.push([xe,await ft.from(xe,Qe)])})());return await Promise.all(Be),Te}Ne.from=ve})(Mt||(e.DataTransfer=Mt={}));var oi;(function(Ne){function Oe(_,Te){return{kind:"reply",agentId:_.agentId??Te?.agentId??"",subCommand:_.command??Te?.command,message:_.prompt,title:_.title,tooltip:_.tooltip}}Ne.from=Oe;function ve(_){return{prompt:_.message,title:_.title,agentId:_.agentId,command:_.subCommand,tooltip:_.tooltip}}Ne.to=ve})(oi||(e.ChatFollowup=oi={}));var Ft;(function(Ne){function Oe(ve){return"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Ne.from=Oe})(Ft||(e.ChatInlineFollowup=Ft={}));var Ye;(function(Ne){function Oe(ve){return new o.$mN(Qt.to(ve.role),ve.content)}Ne.to=Oe})(Ye||(e.ChatMessage=Ye={}));var Kt;(function(Ne){function Oe(_){switch(_.role){case 0:return new o.$wN(_.content);case 1:return new o.$xN(_.content);case 2:return new o.$yN(_.content)}}Ne.to=Oe;function ve(_){if(_ instanceof o.$wN)return{role:0,content:_.content};if(_ instanceof o.$xN)return{role:1,content:_.content};if(_ instanceof o.$yN)return{role:2,content:_.content};throw new Error("Invalid LanguageModelMessage")}Ne.from=ve})(Kt||(e.LanguageModelMessage=Kt={}));var Qt;(function(Ne){function Oe(_){switch(_){case 0:return o.ChatMessageRole.System;case 1:return o.ChatMessageRole.User;case 2:return o.ChatMessageRole.Assistant}}Ne.to=Oe;function ve(_){switch(_){case o.ChatMessageRole.System:return 0;case o.ChatMessageRole.Assistant:return 2;case o.ChatMessageRole.User:default:return 1}}Ne.from=ve})(Qt||(e.ChatMessageRole=Qt={}));var _t;(function(Ne){function Oe(Te){const Be={};for(const xe of Object.keys(Te))Be[xe]=Te[xe].map(Ne.to);return Be}Ne.objectTo=Oe;function ve(Te){return{level:gt.to(Te.level),kind:Te.kind,value:(0,S.$vc)(Te.value)?S.URI.revive(Te.value):Te.value,description:Te.description}}Ne.to=ve;function _(Te){return{level:gt.from(Te.level),kind:Te.kind,value:Te.value,description:Te.description}}Ne.from=_})(_t||(e.ChatVariable=_t={}));var gt;(function(Ne){function Oe(_){switch(_){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}Ne.to=Oe;function ve(_){switch(_){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}Ne.from=ve})(gt||(e.ChatVariableLevel=gt={}));var jt;(function(Ne){function Oe(ve){switch(ve){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}Ne.to=Oe})(jt||(e.InteractiveEditorResponseFeedbackKind=jt={}));var Nt;(function(Ne){function Oe(_){return{kind:"markdownContent",content:O.from(new o.$UL().appendText(_.value))}}Ne.to=Oe;function ve(_){return new o.$nN(_.content.value)}Ne.from=ve})(Nt||(e.ChatResponseTextPart=Nt={}));var zt;(function(Ne){function Oe(_){return{kind:"markdownContent",content:O.from(_.value)}}Ne.to=Oe;function ve(_){return new o.$oN(O.to(_.content))}Ne.from=ve})(zt||(e.ChatResponseMarkdownPart=zt={}));var Vt;(function(Ne){function Oe(_){const{value:Te,baseUri:Be}=_;function xe(Qe,rt){return Qe.map(vt=>{const Jt=S.URI.joinPath(rt,vt.name);return{label:vt.name,uri:Jt,children:vt.children&&xe(vt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,m.$Ig)(Be),uri:Be,children:xe(Te,Be)}}}Ne.to=Oe;function ve(_){const Te=(0,k.$Hh)(_.treeData);function Be(rt){return rt.map(vt=>({name:vt.label,children:vt.children&&Be(vt.children)}))}const xe=Te.uri,Qe=Te.children?Be(Te.children):[];return new o.$pN(Qe,xe)}Ne.from=ve})(Vt||(e.ChatResponseFilesPart=Vt={}));var Ut;(function(Ne){function Oe(_){return{kind:"inlineReference",name:_.title,inlineReference:S.URI.isUri(_.value)?_.value:b.from(_.value)}}Ne.to=Oe;function ve(_){const Te=(0,k.$Hh)(_);return new o.$qN(S.URI.isUri(Te.inlineReference)?Te.inlineReference:b.to(Te.inlineReference),_.name)}Ne.from=ve})(Ut||(e.ChatResponseAnchorPart=Ut={}));var Ct;(function(Ne){function Oe(_){return{kind:"progressMessage",content:O.from(_.value)}}Ne.to=Oe;function ve(_){return new o.$rN(_.content.value)}Ne.from=ve})(Ct||(e.ChatResponseProgressPart=Ct={}));var Ht;(function(Ne){function Oe(_,Te,Be){return{kind:"command",command:Te.toInternal(_.value,Be)??{command:_.value.command,title:_.value.title}}}Ne.to=Oe;function ve(_,Te){return new o.$sN(Te.fromInternal(_.command)??{command:_.command.id,title:_.command.title})}Ne.from=ve})(Ht||(e.ChatResponseCommandButtonPart=Ht={}));var Et;(function(Ne){function Oe(_){return{kind:"reference",reference:S.URI.isUri(_.value)?_.value:b.from(_.value)}}Ne.to=Oe;function ve(_){const Te=(0,k.$Hh)(_);return new o.$tN(S.URI.isUri(Te.reference)?Te.reference:b.to(Te.reference))}Ne.from=ve})(Et||(e.ChatResponseReferencePart=Et={}));var pt;(function(Ne){function Oe(_){return _ instanceof o.$oN?zt.to(_):_ instanceof o.$qN?Ut.to(_):_ instanceof o.$tN?Et.to(_):_ instanceof o.$rN?Ct.to(_):_ instanceof o.$pN?Vt.to(_):{kind:"content",content:""}}Ne.to=Oe;function ve(_,Te){switch(_.kind){case"markdownContent":return zt.from(_);case"inlineReference":return Ut.from(_);case"reference":return Et.from(_);case"progressMessage":return Ct.from(_);case"treeData":return Vt.from(_);case"command":return Ht.from(_,Te)}}Ne.from=ve})(pt||(e.ChatResponsePart=pt={}));var It;(function(Ne){function Oe(Te,Be){return"markdownContent"in Be?((0,c.$OF)(Te,"chatAgents2Additions"),{content:O.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,c.$OF)(Te,"chatAgents2Additions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,c.$OF)(Te,"chatAgents2Additions"),{content:O.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Qe=>d.from(Qe))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:d.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:d.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"agentName"in Be?((0,c.$OF)(Te,"chatAgents2Additions"),{agentName:Be.agentName,command:Be.command,kind:"agentDetection"}):"message"in Be?{content:O.from(Be.message),kind:"progressMessage"}:void 0}Ne.from=Oe;function ve(Te){switch(Te.kind){case"markdownContent":case"inlineReference":case"treeData":return Ne.to(Te);case"content":return{content:Te.content};case"usedContext":return{documents:Te.documents.map(Be=>({uri:S.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>d.to(xe))}))};case"reference":return{reference:(0,S.$vc)(Te.reference)?S.URI.revive(Te.reference):b.to(Te.reference)};case"agentDetection":return;case"progressMessage":return{message:Te.content.value};case"vulnerability":return{content:Te.content,vulnerabilities:Te.vulnerabilities};default:return}}Ne.to=ve;function _(Te,Be){switch(Te.kind){case"markdownContent":return{content:Te.content.value};case"inlineReference":return{inlineReference:(0,S.$vc)(Te.inlineReference)?S.URI.revive(Te.inlineReference):b.to(Te.inlineReference),title:Te.name};case"command":return{command:Be.fromInternal(Te.command)??{command:Te.command.id,title:Te.command.title}};default:return}}Ne.toProgressContent=_})(It||(e.ChatResponseProgress=It={}));var Dt;(function(Ne){function Oe(ve){return{prompt:ve.message,command:ve.command,variables:ve.variables.variables.map(ci.to)}}Ne.to=Oe})(Dt||(e.ChatAgentRequest=Dt={}));var ci;(function(Ne){function Oe(ve){return{name:ve.name,range:[ve.range.start,ve.range.endExclusive],values:ve.values.map(_t.to)}}Ne.to=Oe})(ci||(e.ChatAgentResolvedVariable=ci={}));var Zt;(function(Ne){function Oe(ve){return{label:ve.label,values:ve.values.map(_t.from),insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation}}Ne.from=Oe})(Zt||(e.ChatAgentCompletionItem=Zt={}));var gi;(function(Ne){function Oe(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Ne.to=Oe})(gi||(e.ChatAgentResult=gi={}));var Gt;(function(Ne){function Oe(ve,_,Te){if(_.action.kind==="vote")return;const Be=gi.to(ve);return _.action.kind==="command"?{action:{kind:"command",commandButton:It.toProgressContent(_.action.commandButton,Te)},result:Be}:_.action.kind==="followUp"?{action:{kind:"followUp",followup:oi.to(_.action.followup)},result:Be}:{action:_.action,result:Be}}Ne.to=Oe})(Gt||(e.ChatAgentUserActionEvent=Gt={}));var mi;(function(Ne){function Oe(ve,_,Te){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:_.toInternal(ve,Te)}Ne.from=Oe})(mi||(e.TerminalQuickFix=mi={}));var At;(function(Ne){function Oe(ve,_){return{id:_,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||0,contextValue:ve.contextValue}}Ne.from=Oe})(At||(e.DebugTreeItem=At={}))}),define(Ce[320],Ie([1,0,6,20,15]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;let L=class{constructor(v,p){this.a=v.getProxy(I.$rL.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>p.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,p,k){const R=$.WorkspaceEdit.from(v,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,k?.isRefactoring??!1)}};e.$6gc=L,e.$6gc=L=Je([We(0,F.$JN)],L)}),define(Ce[321],Ie([1,0,19,8,44,4,63,3,38,2,211,6,15,7,281,26]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class w{constructor(r,a,t,h,c,o){this.i=r,this.j=a,this.k=t,this.l=h,this.m=c,this.n=o,this.a=p.$Ud.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let a=function(h){if(r.b){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,h),c}};const r=this;this.a.reset();const t=h=>{typeof this.d>"u"&&"content"in h&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,h)};this.g={text(h){return a(this.text),this.markdown(new A.$mk().appendText(h)),this},markdown(h){a(this.markdown);const c=new E.$oN(h),o=m.ChatResponseMarkdownPart.to(c);return t(o),this},filetree(h,c){a(this.filetree);const o=new E.$pN(h,c),u=m.ChatResponseFilesPart.to(o);return t(u),this},anchor(h,c){a(this.anchor);const o=new E.$qN(h,c),u=m.ChatResponseAnchorPart.to(o);return t(u),this},button(h){a(this.anchor);const c=new E.$sN(h),o=m.ChatResponseCommandButtonPart.to(c,r.m,r.n);return t(o),this},progress(h){a(this.progress);const c=new E.$rN(h),o=m.ChatResponseProgressPart.to(c);return t(o),this},reference(h){a(this.reference);const c=new E.$tN(h),o=m.ChatResponseReferencePart.to(c);return t(o),this},push(h){a(this.push);const c=m.ChatResponsePart.to(h);return t(c),this},report(h){if(a(this.report),"placeholder"in h&&"resolvedContent"in h)return;const c=m.ChatResponseProgress.from(r.i,h);if(!c){r.l.error("Unknown progress type: "+JSON.stringify(h));return}return t(c),this}}}return this.g}}class s{static{this.a=0}constructor(r,a,t){this.i=a,this.j=t,this.b=new Map,this.g=new v.$3c,this.d=r.getProxy(C.$rL.MainThreadChatAgents2)}createChatAgent(r,a,t){const h=s.a++,c=new i(r,a,this.d,h,t);return this.b.set(h,c),this.d.$registerAgent(h,r.identifier,a,{}),c.apiAgent}async $invokeAgent(r,a,t,h){const c=this.b.get(r);if(!c)throw new Error(`[CHAT](${r}) CANNOT invoke agent because the agent is not registered`);let o=this.g.get(a.sessionId);o||(o=new v.$Sc,this.g.set(a.sessionId,o));const u=new w(c.extension,a,this.d,this.i,this.j.converter,o);try{const d=await this.k(a,t),b=c.invoke(m.ChatAgentRequest.to(a),{history:d},u.apiObject,h);return await(0,F.$Yg)(Promise.resolve(b).then(D=>{if(D?.metadata)try{JSON.stringify(D.metadata)}catch(g){const f=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${f}`,c.extension),{errorDetails:{message:f},timings:u.timings}}return{errorDetails:D?.errorDetails,timings:u.timings,metadata:D?.metadata}}),h)}catch(d){return this.i.error(d,c.extension),{errorDetails:{message:(0,R.localize)(0,null,(0,$.$Vi)(d)),responseIsIncomplete:!0}}}finally{u.close()}}async k(r,a){const t=[];for(const h of a.history){const c=m.ChatAgentResult.to(h.result),o=r.agentId===h.request.agentId?c:{...c,metadata:void 0};t.push(new E.$uN(h.request.message,h.request.command,h.request.variables.variables.map(m.ChatAgentResolvedVariable.to),{extensionId:"",agentId:h.request.agentId}));const u=(0,I.$Hb)(h.response.map(d=>m.ChatResponsePart.from(d,this.j.converter)));t.push(new E.$vN(u,o,{extensionId:"",agentId:h.request.agentId}))}return t}$releaseSession(r){this.g.deleteAndDispose(r)}async $provideSlashCommands(r,a){const t=this.b.get(r);return t?t.provideSlashCommands(a):[]}async $provideFollowups(r,a,t,h){const c=this.b.get(a);if(!c)return Promise.resolve([]);const o=m.ChatAgentResult.to(t);return(await c.provideFollowups(o,h)).map(u=>m.ChatFollowup.from(u,r))}$acceptFeedback(r,a,t,h){const c=this.b.get(r);if(!c)return;const o=m.ChatAgentResult.to(a);let u;switch(t){case S.InteractiveSessionVoteDirection.Down:u=E.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:u=E.ChatAgentResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(h?{result:o,kind:u,reportIssue:h}:{result:o,kind:u}))}$acceptAction(r,a,t){const h=this.b.get(r);if(!h||t.action.kind==="vote")return;const c=m.ChatAgentUserActionEvent.to(a,t,this.j.converter);c&&h.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(r,a,t){const h=this.b.get(r);return h?(await h.invokeCompletionProvider(a,t)).map(m.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(r,a){const t=this.b.get(r);if(t)return await t.provideWelcomeMessage(a)}async $provideSampleQuestions(r,a){const t=this.b.get(r);if(t)return(await t.provideSampleQuestions(a)).map(h=>m.ChatFollowup.from(h,void 0))}}e.$8gc=s;class i{constructor(r,a,t,h,c){this.extension=r,this.id=a,this.u=t,this.w=h,this.x=c,this.o=new L.$Yd,this.p=new L.$Yd}acceptFeedback(r){this.o.fire(r)}acceptAction(r){this.p.fire(r)}async invokeCompletionProvider(r,a){return this.s?await this.s.provider.provideCompletionItems(r,a)??[]:[]}async provideSlashCommands(r){if(!this.a)return[];const a=await this.a.provideCommands(r);return a?a.map(t=>("repopulate2"in t&&(0,l.$OF)(this.extension,"chatAgents2Additions"),{name:t.name,description:t.description,followupPlaceholder:t.isSticky2?.placeholder,shouldRepopulate:t.isSticky2?.isSticky??t.isSticky,sampleRequest:t.sampleRequest})):[]}async provideFollowups(r,a){if(!this.b)return[];const t=await this.b.provideFollowups(r,a);return t?t.filter(h=>!(h&&"commandId"in h)).filter(h=>!(h&&"message"in h)):[]}async provideWelcomeMessage(r){if(!this.t)return[];const a=await this.t.provideWelcomeMessage(r);return a?a.map(t=>typeof t=="string"?t:m.MarkdownString.from(t)):[]}async provideSampleQuestions(r){if(!this.t||!this.t.provideSampleQuestions)return[];const a=await this.t.provideSampleQuestions(r);return a||[]}get apiAgent(){let r=!1,a=!1;const t=()=>{r||a||(a=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof k.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof E.$oM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q}),a=!1}))},h=this;return{get name(){return h.id},get description(){return h.d??""},set description(c){h.d=c,t()},get fullName(){return h.g??h.extension.displayName??h.extension.name},set fullName(c){h.g=c,t()},get iconPath(){return h.i},set iconPath(c){h.i=c,t()},get commandProvider(){return h.a},set commandProvider(c){h.a=c,t()},get followupProvider(){return h.b},set followupProvider(c){h.b=c,t()},get isDefault(){return(0,l.$OF)(h.extension,"defaultChatAgent"),h.j},set isDefault(c){(0,l.$OF)(h.extension,"defaultChatAgent"),h.j=c,t()},get helpTextPrefix(){return(0,l.$OF)(h.extension,"defaultChatAgent"),h.k},set helpTextPrefix(c){if((0,l.$OF)(h.extension,"defaultChatAgent"),!h.j)throw new Error("helpTextPrefix is only available on the default chat agent");h.k=c,t()},get helpTextPostfix(){return(0,l.$OF)(h.extension,"defaultChatAgent"),h.l},set helpTextPostfix(c){if((0,l.$OF)(h.extension,"defaultChatAgent"),!h.j)throw new Error("helpTextPostfix is only available on the default chat agent");h.l=c,t()},get isSecondary(){return(0,l.$OF)(h.extension,"defaultChatAgent"),h.n},set isSecondary(c){(0,l.$OF)(h.extension,"defaultChatAgent"),h.n=c,t()},get sampleRequest(){return h.m},set sampleRequest(c){h.m=c,t()},get supportIssueReporting(){return(0,l.$OF)(h.extension,"chatAgents2Additions"),h.q},set supportIssueReporting(c){(0,l.$OF)(h.extension,"chatAgents2Additions"),h.q=c,t()},get onDidReceiveFeedback(){return h.o.event},set agentVariableProvider(c){if(h.s=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");h.u.$registerAgentCompletionsProvider(h.w,c.triggerCharacters)}else h.u.$unregisterAgentCompletionsProvider(h.w)},get agentVariableProvider(){return h.s},set welcomeMessageProvider(c){h.t=c,t()},get welcomeMessageProvider(){return h.t},onDidPerformAction:(0,l.$NF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,dispose(){r=!0,h.a=void 0,h.b=void 0,h.o.dispose(),h.u.$unregisterAgent(h.w)}}}invoke(r,a,t,h){return this.x(r,a,t,h)}}}),define(Ce[322],Ie([1,0,22,3,6,15,107,25,8,4,212,142]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class m{constructor(w,s){this.option=w,this.stream=new p.$Bh,this.stream=s??new p.$Bh}}class E{constructor(w,s){this.cts=s,this.a=new Map,this.b=new p.$Bh,this.c=!1;const i=this;this.apiObject={result:w,stream:i.b.asyncIterable},w.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,n]of this.a)n.stream.resolve();else this.b.resolve()})}handleFragment(w){if(this.c)return;let s=this.a.get(w.index);s||(this.a.size===0?s=new m(w.index,this.b):s=new m(w.index),this.a.set(w.index,s)),s.stream.emitOne(w.part)}}class S{static{this.a=1}constructor(w,s,i){this.k=s,this.l=i,this.c=new k.$Yd,this.d=new k.$Yd,this.f=new k.$Yd,this.onDidChangeProviders=this.f.event,this.g=new Map,this.h=new Set,this.i=new v.$sm,this.j=new Map,this.b=w.getProxy($.$rL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.f.dispose()}registerLanguageModel(w,s,i,n){const r=S.a++;this.g.set(r,{extension:w.identifier,provider:i});let a;return n.auth&&(a={providerLabel:w.displayName||w.name,accountLabel:typeof n.auth=="object"?n.auth.label:void 0}),this.b.$registerProvider(r,s,{extension:w.identifier,model:n.name??"",auth:a}),(0,F.$Rc)(()=>{this.g.delete(r),this.b.$unregisterProvider(r)})}async $provideLanguageModelResponse(w,s,i,n,r,a){const t=this.g.get(w);if(!t)return;const h=new A.$Av(async c=>{if(a.isCancellationRequested){this.k.warn(`[CHAT](${t.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(s,{index:c.index,part:c.part})});return t.provider.provideLanguageModelResponse2?t.provider.provideLanguageModelResponse2(n.map(L.LanguageModelMessage.to),r,v.$qm.toKey(i),h,a):t.provider.provideLanguageModelResponse(n.map(L.ChatMessage.to),r,v.$qm.toKey(i),h,a)}$updateLanguageModels(w){const s=[],i=[];if(w.added)for(const n of w.added)this.h.add(n),s.push(n);if(w.removed)for(const n of w.removed){this.h.delete(n),i.push(n);for(const[r,a]of this.j)a.languageModelId===n&&(a.res.cts.cancel(),this.j.delete(r))}this.f.fire(Object.freeze({added:Object.freeze(s),removed:Object.freeze(i)}))}getLanguageModelIds(){return Array.from(this.h)}$updateModelAccesslist(w){const s=new Array;for(const{from:i,to:n,enabled:r}of w){const a=this.i.get(i)??new v.$rm;if(a.has(n)!==r){r?a.add(n):a.delete(n),this.i.set(i,a);const h={from:i,to:n};s.push(h),this.d.fire(h)}}}async requestLanguageModelAccess(w,s,i){const n=w.identifier,r=i?.justification,a=await this.b.$prepareChatAccess(n,s,r);if(!a)throw new Error(`Language model '${s}' NOT found`);this.n(n,a)&&await this.m(w,{identifier:a.extension,displayName:a.auth.providerLabel},r);const t=this;return{get model(){return a.model},get isRevoked(){return t.n(n,a)&&!t.i.get(n)?.has(a.extension)||!t.h.has(s)},get onDidChangeAccess(){const h=k.Event.filter(t.c.event,u=>u.has(n)),c=k.Event.filter(t.f.event,u=>u.removed.includes(s)),o=k.Event.filter(t.d.event,u=>v.$qm.equals(u.from,n)&&v.$qm.equals(u.to,a.extension));return k.Event.signal(k.Event.any(h,c,o))},makeChatRequest(h,c,o){if(t.n(n,a)&&!t.i.get(n)?.has(a.extension))throw new Error("Access to chat has been revoked");if(!t.h.has(s))throw new Error("Language Model has been removed");const u=new I.$9d(o),d=Math.random()*1e6|0,b=t.b.$fetchResponse(n,s,d,h.map(L.LanguageModelMessage.from),c??{},u.token),D=new E(b,u);return t.j.set(d,{languageModelId:s,res:D}),b.finally(()=>{t.j.delete(d),u.dispose()}),D.apiObject}}}async $handleResponseFragment(w,s){const i=this.j.get(w);i&&i.res.handleFragment(s)}async m(w,s,i){const n=C.$xK+s.identifier.value;if(!await this.l.getSession(w,n,[],{silent:!0}))try{await this.l.getSession(w,n,[],{forceNewSession:{detail:i??(0,R.localize)(0,null,s.displayName)}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:w.identifier,to:s.identifier,enabled:!0}])}n(w,s){return!!s.auth&&!v.$qm.equals(s.extension,w)}}e.$9gc=S}),define(Ce[323],Ie([1,0,3,6,14,15]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class A{static{this.a=0}constructor(p){this.b=new Map,this.c=p.getProxy(F.$rL.MainThreadChatVariables)}async $resolveVariable(p,k,R){const C=this.b.get(p);if(C)try{const m=await C.resolver.resolve(C.data.name,{prompt:k},R);if(m)return m.map(L.ChatVariable.from)}catch(m){(0,$.$2)(m)}}registerVariableResolver(p,k,R,C){const m=A.a++;return this.b.set(m,{extension:p.identifier,data:{name:k,description:R},resolver:C}),this.c.$registerVariable(m,{name:k,description:R}),(0,I.$Rc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$0gc=A}),define(Ce[324],Ie([1,0,8,52,4,3,2,83,25,15,7,6,26]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;function E(S,l,w){const s=S.getProxy(C.$rL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$sm,l.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const b=this.b.get(d.handle);return b?b.value:d}else if(d&&d.$mid===7){const b=this.b.get(d.commentControlHandle);if(!b)return d;const D=b.getCommentThread(d.commentThreadHandle);return D?D.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const D=b.getCommentThread(d.thread.commentThreadHandle);return D?d.$mid===8?D.value:{thread:D.value,text:d.text}:d}else if(d&&d.$mid===10){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const D=b.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const g=d.commentUniqueId,f=D.getCommentByUniqueId(g);return f||d}else if(d&&d.$mid===11){const b=this.b.get(d.thread.commentControlHandle);if(!b)return d;const D=b.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const g=d.text,f=d.commentUniqueId,y=D.getCommentByUniqueId(f);return y?(typeof y.body=="string"?y.body=g:y.body=new R.$UL(g),y):d}return d}})}createCommentController(d,b,D){const g=i.a++,f=new r(d,g,b,D);this.b.set(f.handle,f);const y=this.c.get(d.identifier)||[];return y.push(f),this.c.set(d.identifier,y),f.value}async $createCommentThreadTemplate(d,b,D){const g=this.b.get(d);g&&g.$createCommentThreadTemplate(b,D)}async $setActiveComment(d,b){const D=this.b.get(d);D&&D.$setActiveComment(b??void 0)}async $updateCommentThreadTemplate(d,b,D){const g=this.b.get(d);g&&g.$updateCommentThreadTemplate(b,D)}$deleteCommentThread(d,b){this.b.get(d)?.$deleteCommentThread(b)}$provideCommentingRanges(d,b,D){const g=this.b.get(d);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const f=w.getDocument(A.URI.revive(b));return(0,I.$3g)(async()=>{const y=await g.commentingRangeProvider.provideCommentingRanges(f,D);let P;return Array.isArray(y)?P={ranges:y,fileComments:!1}:y?P={ranges:y.ranges||[],fileComments:y.fileComments||!1}:P=y??void 0,P}).then(y=>{let P;return y&&(P={ranges:y.ranges.map(T=>k.Range.from(T)),fileComments:y.fileComments}),P})}$toggleReaction(d,b,D,g,f){const y=this.b.get(d);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,I.$3g)(()=>{const P=y.getCommentThread(b);if(P){const T=P.getCommentByUniqueId(g.uniqueIdInThread);if(y!==void 0&&T&&y.reactionHandler)return y.reactionHandler(T,h(f))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,b,D,g,f,y,P,T){this.m=b,this.n=D,this.o=g,this.p=f,this.q=y,this.extensionDescription=P,this.r=T,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new $.$Yd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Uc,this.l.value=new L.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),s.$createCommentThread(b,this.handle,this.n,this.o,k.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{s.$deleteCommentThread(b,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(z){U.range=z},get comments(){return U.comments},set comments(z){U.comments=z},get collapsibleState(){return U.collapsibleState},set collapsibleState(z){U.collapsibleState=z},get canReply(){return U.canReply},set canReply(z){U.canReply=z},get contextValue(){return U.contextValue},set contextValue(z){U.contextValue=z},get label(){return U.label},set label(z){U.label=z},get state(){return U.state},set state(z){U.state=z},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Sc);const d=D=>Object.prototype.hasOwnProperty.call(this.b,D),b={};d("range")&&(b.range=k.Range.from(this.p)),d("label")&&(b.label=this.label),d("contextValue")&&(b.contextValue=this.contextValue??null),d("comments")&&(b.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),d("collapsibleState")&&(b.collapseState=c(this.g)),d("canReply")&&(b.canReply=this.canReply),d("state")&&(b.state=o(this.h)),d("isTemplate")&&(b.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(d){for(const b of this.k){const D=b[0],g=b[1];if(d===g)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Je([(0,F.$Dh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,m.$OF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,m.$OF)(this.h,"activeComment"),this.f}constructor(d,b,D,g){this.h=d,this.i=b,this.j=D,this.k=g,this.a=new Map,s.$registerCommentController(this.handle,D,g,this.h.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(y){f.options=y},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(y){f.commentingRangeProvider=y},get reactionHandler(){return f.reactionHandler},set reactionHandler(y){f.reactionHandler=y},get activeCommentThread(){return f.activeCommentThread},createCommentThread(y,P,T){return f.createCommentThread(y,P,T).value},dispose:()=>{f.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(d,b,D){b===void 0&&(0,m.$OF)(this.h,"fileComments");const g=new n(this.id,this.handle,void 0,d,b,D,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const b=this.a.get(d.commentThreadHandle);b&&(this.e=d.uniqueIdInThread?b.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=b)}$createCommentThreadTemplate(d,b){const D=new n(this.id,this.handle,void 0,A.URI.revive(d),k.Range.to(b),[],this.h,!0);return D.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(d,b){const D=this.a.get(d);D&&(D.range=k.Range.to(b))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function a(u,d,b,D){let g=b.get(d);return g||(g=++u.commentHandle,b.set(d,g)),d.state!==void 0&&(0,m.$OF)(D,"commentsDraftState"),d.reactions?.some(f=>f.reactors!==void 0)&&(0,m.$OF)(D,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:g,body:typeof d.body=="string"?d.body:k.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(f=>t(f)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(u){return{label:u.label,iconPath:u.iconPath?k.$IN(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted,reactors:u.reactors&&u.reactors.length>0&&typeof u.reactors[0]!="string"?u.reactors.map(d=>d.name):u.reactors}}function h(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1,reactors:u.reactors?.map(d=>({name:d}))}}function c(u){if(u!==void 0)switch(u){case R.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function o(u){if(u!==void 0)switch(u){case R.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}return new i}e.$bhc=E}),define(Ce[325],Ie([1,0,22,54,3,16,23,2,15,92,110,6,7]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;class E{constructor(h,c){this.document=h,this.b=c,this.a=1,this.c=new R.$Sgc("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,c){await this.f(h).undo(),c||this.disposeBackup()}async redo(h,c){await this.f(h).redo(),c||this.disposeBackup()}disposeEdits(h){for(const c of h)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=a(this.document.uri)+this.a++;return(0,A.$Lg)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const c=this.c.get(h,0);if(!c)throw new Error("No edit found");return c}}class S{constructor(){this.a=new Map}get(h,c){return this.a.get(this.b(h,c))}add(h,c,o){const u=this.b(h,c.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${h} resource:${c.uri}`);const d=new E(c,o);return this.a.set(u,d),d}delete(h,c){const o=this.b(h,c.uri);this.a.delete(o)}b(h,c){return`${h}@@@${c}`}}var l;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(l||(l={}));class w{constructor(){this.a=new Map}addTextProvider(h,c,o){return this.b(0,h,c,o)}addCustomProvider(h,c,o){return this.b(1,h,c,o)}get(h){return this.a.get(h)}b(h,c,o,u){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:h,extension:o,provider:u}),new m.$tL(()=>this.a.delete(c))}}class s{constructor(h,c,o,u,d){this.d=c,this.f=o,this.g=u,this.h=d,this.b=new w,this.c=new S,this.a=h.getProxy(C.$rL.MainThreadCustomEditors)}registerCustomEditorProvider(h,c,o,u){const d=new $.$Sc;return n(o)?(d.add(this.b.addTextProvider(c,h,o)),this.a.$registerTextEditorProvider((0,k.$qhc)(h),c,u.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,k.$ohc)(h))):(d.add(this.b.addCustomProvider(c,h,o)),i(o)&&d.add(o.onDidChangeCustomDocument(b=>{const D=this.i(c,b.document.uri);if(r(b)){const g=D.addEdit(b);this.a.$onDidEdit(b.document.uri,c,g,b.label)}else this.a.$onContentChange(b.document.uri,c)})),this.a.$registerCustomEditorProvider((0,k.$qhc)(h),c,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,k.$ohc)(h))),m.$tL.from(d,new m.$tL(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(h,c,o,u,d){const b=this.b.get(c);if(!b)throw new Error(`No provider found for '${c}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=v.URI.revive(h),g=await b.provider.openCustomDocument(D,{backupId:o,untitledDocumentData:u?.buffer},d);let f;return i(b.provider)&&this.f&&(f=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(c,g,f),{editable:i(b.provider)}}async $disposeCustomDocument(h,c){const o=this.b.get(c);if(!o)throw new Error(`No provider found for '${c}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${c}'`);const u=v.URI.revive(h),{document:d}=this.i(c,u);this.c.delete(c,d),d.dispose()}async $resolveCustomEditor(h,c,o,u,d,b){const D=this.b.get(o);if(!D)throw new Error(`No provider found for '${o}'`);const g=p.ViewColumn.to(d),f=this.g.createNewWebview(c,u.contentOptions,D.extension),y=this.h.createNewWebviewPanel(c,o,u.title,g,u.options,f,u.active),P=v.URI.revive(h);switch(D.type){case 1:{const{document:T}=this.i(o,P);return D.provider.resolveCustomEditor(T,y,b)}case 0:{const T=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(T,y,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,c,o){this.i(c,h).disposeEdits(o)}async $onMoveCustomEditor(h,c,o){const u=this.b.get(o);if(!u)throw new Error(`No provider found for '${o}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this.h.getWebviewPanel(h);if(!d)throw new Error("No webview found");const b=v.URI.revive(c),D=this.d.getDocument(b);await u.provider.moveCustomTextEditor(D,d,I.CancellationToken.None)}async $undo(h,c,o,u){return this.i(c,h).undo(o,u)}async $redo(h,c,o,u){return this.i(c,h).redo(o,u)}async $revert(h,c,o){const u=this.i(c,h);await this.j(c).revertCustomDocument(u.document,o),u.disposeBackup()}async $onSave(h,c,o){const u=this.i(c,h);await this.j(c).saveCustomDocument(u.document,o),u.disposeBackup()}async $onSaveAs(h,c,o,u){const d=this.i(c,h);return this.j(c).saveCustomDocumentAs(d.document,v.URI.revive(o),u)}async $backup(h,c,o){const u=this.i(c,h),b=await this.j(c).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},o);return u.updateBackup(b),b.id}i(h,c){const o=this.c.get(h,v.URI.revive(c));if(!o)throw new Error("No custom document found");return o}j(h){const o=this.b.get(h)?.provider;if(!o||!i(o))throw new Error("Custom document is not editable");return o}}e.$thc=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const h=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$Yi)(h)+""}}),define(Ce[326],Ie([1,0,213,135,2,6,7,15,4,13,28,59]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class E{#e;#t;#i;constructor(w,s,i,n,r,a,t,h){this.d=w,this.e=s,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new R.$Ac(c=>a.getComparisonKey(c)),this.#e=t,this.#t=h}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(w,s){if(!w){this.clear();return}this.j();let i=[];if($.URI.isUri(w)){if(!s){this.delete(w);return}this.#i.set(w,s.slice()),i=[w]}else if(Array.isArray(w)){i=[];let a;w=[...w].sort(E.k);for(const t of w){const[h,c]=t;if((!a||h.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=h,i.push(h),this.#i.set(h,[])),c)this.#i.get(h)?.push(...c);else{const o=this.#i.get(h);o&&(o.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const a of i){let t=[];const h=this.#i.get(a);if(h)if(h.length>this.g){t=[];const c=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const u of h)if(u.severity===c[o]&&t.push({...v.Diagnostic.from(u),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,I.localize)(0,null,h.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=h.map(c=>({...v.Diagnostic.from(c),modelVersionId:this.h(a)}));if(n.push([a,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(w){this.j(),this.#t.fire([w]),this.#i.delete(w),this.#e?.$changeMany(this.e,[[w,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(w,s){this.j();for(const[i,n]of this)w.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const w of this.#i.keys())yield[w,this.get(w)]}get(w){this.j();const s=this.#i.get(w);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(w){return this.j(),Array.isArray(this.#i.get(w))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(w,s){return w[0].toString()<s[0].toString()?-1:w[0].toString()>s[0].toString()?1:0}}e.$Zgc=E;let S=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(w){const s=new R.$Ac;for(const i of w)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(w,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new p.$3d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,m._mapper),this.f=w.getProxy(L.$rL.MainThreadDiagnostics)}createDiagnosticCollection(w,s){const{g:i,f:n,h:r,j:a,k:t,l:h}=this,c=new class{$changeMany(d,b){n.$changeMany(d,b),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",w.value,d,b.length===0?"CLEARING":b)}$clear(d){n.$clear(d),a.trace("[DiagnosticCollection] remove all (extension, owner)",w.value,d)}dispose(){n.dispose()}};let o;if(!s)s="_generated_diagnostic_collection_name_#"+m.c++,o=s;else if(!i.has(s))o=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do o=s+m.c++;while(i.has(o))}return new class extends E{constructor(){super(s,o,m.e,m.d,d=>h.getDocument(d)?.version,t.extUri,c,r),i.set(o,this)}dispose(){super.dispose(),i.delete(o)}}}getDiagnostics(w){if(w)return this.m(w);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((r,a)=>{let t=s.get(r.toString());typeof t>"u"&&(t=i.length,s.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(w){let s=[];for(const i of this.g.values())i.has(w)&&(s=s.concat(i.get(w)));return s}$acceptMarkersChange(w){if(!this.n){const s="_generated_mirror",i=new E(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of w)this.n.set($.URI.revive(s),i.map(v.Diagnostic.to))}};e.$1gc=S,e.$1gc=S=m=Je([We(1,k.$sj),We(2,C.$Ygc)],S)}),define(Ce[327],Ie([1,0,2,14,7,15,76]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class v{constructor(k,R,C,m={timeout:1500,errors:3}){this.c=k,this.d=R,this.f=C,this.g=m,this.a=new A.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(R,C,m)=>{const S={dispose:this.a.push([R,C,k])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(k,R){const C=I.URI.revive(k);let m=!1;const E=setTimeout(()=>m=!0,this.g.timeout),S=[];try{for(const l of[...this.a]){if(m)break;const w=this.d.getDocument(C),s=await this.h(l,{document:w,reason:L.TextDocumentSaveReason.to(R)});S.push(s)}}finally{clearTimeout(E)}return S}h([k,R,C],m){const E=this.b.get(k);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(C,k,R,m).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const l=this.b.get(k);this.b.set(k,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,R,C,m){const E=[],S=Date.now(),{document:l,reason:w}=m,{version:s}=l,i=Object.freeze({document:l,reason:w,waitUntil(n){if(Object.isFrozen(E))throw(0,F.$8)("waitUntil can not be called async");E.push(Promise.resolve(n))}});try{R.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(E),new Promise((n,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(n=>{const r={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof $.$AL))for(const{newText:t,newEol:h,range:c}of a)r.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:c&&L.Range.from(c),text:t,eol:h&&L.EndOfLine.from(h)}});if(r.edits.length!==0)return s===l.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$8hc=v}),define(Ce[328],Ie([1,0,4,3,2,6,149,15,18,24,7]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0;class C{constructor(E,S){this.a=new I.$Yd,this.b=new I.$Yd,this.c=new I.$Yd,this.d=new I.$Yd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Sc,this.h=new Map,this.f=E.getProxy(L.$rL.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(l=>{for(const w of l)this.b.fire(w.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const w of l)this.a.fire(w.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const S=this.g.getDocument(E);if(S)return S}getDocument(E){const S=this.getDocumentData(E);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return S.document}ensureDocumentData(E){const S=this.g.getDocument(E);if(S)return Promise.resolve(S);let l=this.h.get(E.toString());return l||(l=this.f.$tryOpenDocument(E).then(w=>{this.h.delete(E.toString());const s=$.URI.revive(w);return(0,p.$Xf)(this.g.getDocument(s))},w=>(this.h.delete(E.toString()),Promise.reject(w))),this.h.set(E.toString(),l)),l}createDocumentData(E){return this.f.$tryCreateDocument(E).then(S=>$.URI.revive(S))}$acceptModelLanguageChanged(E,S){const l=$.URI.revive(E),w=this.g.getDocument(l);if(!w)throw new Error("unknown document");this.b.fire(w.document),w._acceptLanguageId(S),this.a.fire(w.document)}$acceptModelSaved(E){const S=$.URI.revive(E),l=this.g.getDocument(S);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(E,S){const l=$.URI.revive(E),w=this.g.getDocument(l);if(!w)throw new Error("unknown document");w._acceptIsDirty(S),this.c.fire({document:w.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,S,l){const w=$.URI.revive(E),s=this.g.getDocument(w);if(!s)throw new Error("unknown document");s._acceptIsDirty(l),s.onEvents(S);let i;S.isUndoing?i=R.TextDocumentChangeReason.Undo:S.isRedoing&&(i=R.TextDocumentChangeReason.Redo),this.c.fire((0,k.$Cn)({document:s.document,contentChanges:S.changes.map(n=>({range:v.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(E,S){(0,A.$LN)(E,S)}}e.$2gc=C}),define(Ce[72],Ie([1,0,74,4,18,2,5,6,20,15,7]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0,e.$uhc=(0,A.$$h)("IExtHostEditorTabs");class C{constructor(w,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(w)}get apiObject(){if(!this.a){const w=this,s={get isActive(){return w.b.id===w.e()},get label(){return w.b.label},get input(){return w.c},get isDirty(){return w.b.isDirty},get isPinned(){return w.b.isPinned},get isPreview(){return w.b.isPreview},get group(){return w.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(w){this.b=w,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$bN(L.URI.revive(this.b.input.uri));case 2:return new R.$cN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new R.$dN(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new R.$eN(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$fN(this.b.input.viewType);case 4:return new R.$gN(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$hN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$iN;case 9:return new R.$jN(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$kN(this.b.input.providerId);default:return}}}class m{constructor(w,s){this.c=[],this.d="",this.b=w,this.e=s;for(const i of w.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const w=this,s={get isActive(){return w.b.groupId===w.e()},get viewColumn(){return k.ViewColumn.to(w.b.viewColumn)},get activeTab(){return w.c.find(i=>i.tabId===w.d)?.apiObject},get tabs(){return Object.freeze(w.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(w){this.b=w}acceptTabOperation(w){if(w.kind===0){const i=new C(w.tabDto,this,()=>this.activeTabId());return this.c.splice(w.index,0,i),w.tabDto.isActive&&(this.d=i.tabId),i}else if(w.kind===1){const i=this.c.splice(w.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${w.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(w.kind===3){if(w.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(w.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${w.oldIndex} which does not exist`);return this.c.splice(w.index,0,i),i}const s=this.c.find(i=>i.tabId===w.tabDto.id);if(!s)throw new Error("INVALID tab");return w.tabDto.isActive?this.d=w.tabDto.id:this.d===w.tabDto.id&&!w.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(w.tabDto),s}activeTabId(){return this.d}}let E=class{constructor(w){this.b=new F.$Yd,this.c=new F.$Yd,this.e=[],this.a=w.getProxy(v.$rL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const w=this,s={onDidChangeTabGroups:w.c.event,onDidChangeTabs:w.b.event,get all(){return Object.freeze(w.e.map(i=>i.apiObject))},get activeTabGroup(){const i=w.d;return(0,$.$Xf)(w.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?S(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(w){const s=new Set(this.e.map(c=>c.groupId)),i=new Set(w.map(c=>c.groupId)),n=(0,I.$L)(s,i),r=this.e.filter(c=>n.removed.includes(c.groupId)).map(c=>c.apiObject),a=[],t=[];this.e=w.map(c=>{const o=new m(c,()=>this.d);return n.added.includes(o.groupId)?a.push(o.apiObject):t.push(o.apiObject),o});const h=(0,$.$Xf)(w.find(c=>c.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(w){const s=this.e.find(i=>i.groupId===w.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(w),w.isActive&&(this.d=w.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(w){const s=this.e.find(n=>n.groupId===w.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(w);switch(w.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(w){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===w)return i}h(w){return this.e.find(s=>s.apiObject===w)}async i(w,s){const i=[];for(const n of w){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,s)}async j(w,s){const i=[];for(const n of w){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,s)}};e.$vhc=E,e.$vhc=E=Je([We(0,p.$JN)],E);function S(l){return l.tabs!==void 0}}),define(Ce[329],Ie([1,0,2,6,3,7,15,174,12,21,26,63]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class m{constructor(){this.a=[]}add(l){this.b=void 0,this.a.push(l)}delete(l){const w=this.a.indexOf(l);w>=0&&(this.a.splice(w,1),this.b=void 0)}c(){if(!this.b){const l=this.a.sort(),w=[];let s,i,n=14,r=14;for(const a of l){let t=s?(0,p.$ff)(s,a):0;for(t===0?i=1:i=r;t<a.length;t++)t+1===a.length?(n=r,r=9):r+=1,w.push([i,a.toUpperCase().charCodeAt(t),r]),w.push([i,a.toLowerCase().charCodeAt(t),r]),i=r;s=a,r=n}w.push([9,58,10]),w.push([10,47,12]),this.b=new v.$9Z(w)}}provideDocumentLinks(l){this.c();const w=[],s=v.$0Z.computeLinks({getLineContent(i){return l.lineAt(i-1).text},getLineCount(){return l.lineCount}},this.b);for(const i of s){const n=A.DocumentLink.to(i);n.target&&w.push(n)}return w}}class E{constructor(l,w){this.i=w,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=l.getProxy(F.$rL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(l,w,s,i={}){if(E.j(s),this.d.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(l,"*",this.b));const n=this.h++;this.b.add(w),this.d.add(w),this.c.set(n,s);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof s.copy=="function"&&(r+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.$OF)(l,"fsChunks"),r+=4);let a;i.isReadonly&&(0,C.$ok)(i.isReadonly)&&i.isReadonly.value!==""&&(a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,w,r,a).catch(h=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${w}`),console.error(h)});const t=s.onDidChangeFile(h=>{const c=[];for(const o of h){const{uri:u,type:d}=o;if(u.scheme!==w)continue;let b;switch(d){case L.FileChangeType.Changed:b=0;break;case L.FileChangeType.Created:b=1;break;case L.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:u,type:b})}this.a.$onFileSystemChange(n,c)});return(0,$.$Rc)(()=>{t.dispose(),this.b.delete(w),this.d.delete(w),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(l){if(!l)throw new Error("MISSING provider");if(typeof l.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof l.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof l.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof l.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof l.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof l.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof l.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof l.rename!="function")throw new Error("Provider does NOT implement rename")}static k(l){const{type:w,ctime:s,mtime:i,size:n,permissions:r}=l;return{type:w,ctime:s,mtime:i,size:n,permissions:r}}$stat(l,w){return Promise.resolve(this.l(l).stat(I.URI.revive(w))).then(s=>E.k(s))}$readdir(l,w){return Promise.resolve(this.l(l).readDirectory(I.URI.revive(w)))}$readFile(l,w){return Promise.resolve(this.l(l).readFile(I.URI.revive(w))).then(s=>k.$me.wrap(s))}$writeFile(l,w,s,i){return Promise.resolve(this.l(l).writeFile(I.URI.revive(w),s.buffer,i))}$delete(l,w,s){return Promise.resolve(this.l(l).delete(I.URI.revive(w),s))}$rename(l,w,s,i){return Promise.resolve(this.l(l).rename(I.URI.revive(w),I.URI.revive(s),i))}$copy(l,w,s,i){const n=this.l(l);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(w),I.URI.revive(s),i))}$mkdir(l,w){return Promise.resolve(this.l(l).createDirectory(I.URI.revive(w)))}$watch(l,w,s,i){const n=this.l(l).watch(I.URI.revive(s),i);this.f.set(w,n)}$unwatch(l,w){const s=this.f.get(w);s&&(s.dispose(),this.f.delete(w))}$open(l,w,s){const i=this.l(l);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(w),s))}$close(l,w){const s=this.l(l);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(w))}$read(l,w,s,i){const n=this.l(l);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=k.$me.alloc(i);return Promise.resolve(n.read(w,s,r.buffer,0,i)).then(a=>r.slice(0,a))}$write(l,w,s,i){const n=this.l(l);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(w,s,i.buffer,0,i.byteLength))}l(l){const w=this.c.get(l);if(!w){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return w}}e.$0hc=E}),define(Ce[330],Ie([1,0,4,35,2,6,15,7,43]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,S,l,w,s,i){this.a=Math.random(),this.b=new I.$Yd,this.c=new I.$Yd,this.d=new I.$Yd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$Rj)(s),r=typeof s=="string",a=i?.correlate,t=w(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(a&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const c of h.created){const o=$.URI.revive(c);n(o.fsPath)&&(!r||S.getWorkspaceFolder(o))&&this.b.fire(o)}if(!i?.ignoreChangeEvents)for(const c of h.changed){const o=$.URI.revive(c);n(o.fsPath)&&(!r||S.getWorkspaceFolder(o))&&this.c.fire(o)}if(!i?.ignoreDeleteEvents)for(const c of h.deleted){const o=$.URI.revive(c);n(o.fsPath)&&(!r||S.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=v.$tL.from(this.i(E,l,s,i,i?.correlate),this.b,this.c,this.d,t)}i(E,S,l,w,s){const i=v.$tL.from();if(typeof l=="string")return i;const n=E.getProxy(L.$rL.MainThreadFileSystemEventService);let r=!1;return(l.pattern.includes(F.$Nj)||l.pattern.includes(F.$Oj))&&(r=!0),n.$watch(S.identifier.value,this.a,l.baseUri,{recursive:r,excludes:w?.excludes??[]},!!s),v.$tL.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(E){this.a=E,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map($.URI.revive)),this.c=new p.$V(()=>this.a.changed.map($.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map($.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(E,S,l){this.j=E,this.k=S,this.l=l,this.a=new I.$Yd,this.b=new I.$Yd,this.c=new I.$Yd,this.d=new I.$Yd,this.g=new I.$1d,this.h=new I.$1d,this.i=new I.$1d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,S,l,w){return new k(this.j,E,S,this.a.event,A.GlobPattern.from(l),w)}$onFileEvent(E){this.a.fire(new R(E))}$onDidRunFileOperation(E,S){switch(E){case 2:this.b.fire(Object.freeze({files:S.map(l=>({oldUri:$.URI.revive(l.source),newUri:$.URI.revive(l.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(l=>$.URI.revive(l.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(l=>$.URI.revive(l.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,S){return(l,w,s)=>{const i=function(r){l.call(w,r)};return i.extension=E,S.event(i,void 0,s)}}async $onWillRunFileOperation(E,S,l,w){switch(E){case 2:return await this.n(this.g,{files:S.map(s=>({oldUri:$.URI.revive(s.source),newUri:$.URI.revive(s.target)}))},l,w);case 1:return await this.n(this.i,{files:S.map(s=>$.URI.revive(s.target))},l,w);case 0:case 3:return await this.n(this.h,{files:S.map(s=>$.URI.revive(s.target))},l,w)}}async n(E,S,l,w){const s=new Set,i=[];if(await E.fireAsync(S,w,async(r,a)=>{const t=Date.now(),h=await Promise.resolve(r);h instanceof v.$DL&&(i.push([a.extension,h]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>l&&this.k.warn("SLOW file-participant",a.extension.identifier)}),w.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:a}=A.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$$hc=C}),define(Ce[331],Ie([1,0,19,8,22,14,121,3,24,38,12,18,2,29,170,83,131,215,25,15,7,26,110,6]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;class c{constructor(W,x){this.d=W,this.e=x}async provideDocumentSymbols(W,x){const H=this.d.getDocument(W),K=await this.e.provideDocumentSymbols(H,x);if(!(0,I.$Kb)(K))return K[0]instanceof r.$ML?K.map(n.DocumentSymbol.from):c.f(K)}static f(W){W=W.slice(0).sort((K,oe)=>{let ye=K.location.range.start.compareTo(oe.location.range.start);return ye===0&&(ye=oe.location.range.end.compareTo(K.location.range.end)),ye});const x=[],H=[];for(const K of W){const oe={name:K.name||"!!MISSING: name!!",kind:n.SymbolKind.from(K.kind),tags:K.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:n.Range.from(K.location.range),selectionRange:n.Range.from(K.location.range),children:[]};for(;;){if(H.length===0){H.push(oe),x.push(oe);break}const ye=H[H.length-1];if(E.$Zs.containsRange(ye.range,oe.range)&&!E.$Zs.equalsRange(ye.range,oe.range)){ye.children?.push(oe),H.push(oe);break}H.pop()}}return x}}class o{constructor(W,x,H,K,oe,ye){this.f=W,this.g=x,this.h=H,this.j=K,this.k=oe,this.l=ye,this.d=new t.$Sgc("CodeLens"),this.e=new Map}async provideCodeLenses(W,x){const H=this.f.getDocument(W),K=await this.h.provideCodeLenses(H,x);if(!K||x.isCancellationRequested)return;const oe=this.d.add(K),ye=new v.$Sc;this.e.set(oe,ye);const Re={cacheId:oe,lenses:[]};for(let qe=0;qe<K.length;qe++)Re.lenses.push({cacheId:[oe,qe],range:n.Range.from(K[qe].range),command:this.g.toInternal(K[qe].command,ye)});return Re}async resolveCodeLens(W,x){const H=W.cacheId&&this.d.get(...W.cacheId);if(!H)return;let K;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?K=H:K=await this.h.resolveCodeLens(H,x),K||(K=H),x.isCancellationRequested)return;const oe=W.cacheId&&this.e.get(W.cacheId[0]);if(oe){if(!K.command){const ye=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ye),this.l.error(ye);return}return W.command=this.g.toInternal(K.command,oe),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function u(Me){return Array.isArray(Me)?Me.map(n.DefinitionLink.from):Me?[n.DefinitionLink.from(Me)]:[]}class d{constructor(W,x){this.d=W,this.e=x}async provideDefinition(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideDefinition(K,oe,H);return u(ye)}}class b{constructor(W,x){this.d=W,this.e=x}async provideDeclaration(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideDeclaration(K,oe,H);return u(ye)}}class D{constructor(W,x){this.d=W,this.e=x}async provideImplementation(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideImplementation(K,oe,H);return u(ye)}}class g{constructor(W,x){this.d=W,this.e=x}async provideTypeDefinition(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideTypeDefinition(K,oe,H);return u(ye)}}class f{constructor(W,x){this.d=W,this.e=x}async provideHover(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideHover(K,oe,H);if(!(!ye||(0,I.$Kb)(ye.contents)))return ye.range||(ye.range=K.getWordRangeAtPosition(oe)),ye.range||(ye.range=new r.$vL(oe,oe)),n.Hover.from(ye)}}class y{constructor(W,x){this.d=W,this.e=x}async provideEvaluatableExpression(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideEvaluatableExpression(K,oe,H);if(ye)return n.EvaluatableExpression.from(ye)}}class P{constructor(W,x){this.d=W,this.e=x}async provideInlineValues(W,x,H,K){const oe=this.d.getDocument(W),ye=await this.e.provideInlineValues(oe,n.Range.to(x),n.InlineValueContext.to(H),K);if(Array.isArray(ye))return ye.map(Re=>n.InlineValue.from(Re))}}class T{constructor(W,x){this.d=W,this.e=x}async provideDocumentHighlights(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideDocumentHighlights(K,oe,H);if(Array.isArray(ye))return ye.map(n.DocumentHighlight.from)}}class U{constructor(W,x){this.d=W,this.e=x}async provideMultiDocumentHighlights(W,x,H,K){const oe=this.d.getDocument(W),ye=H.map(Ge=>this.d.getDocument(Ge)),Re=n.Position.to(x),qe=await this.e.provideMultiDocumentHighlights(oe,Re,ye,K);if(Array.isArray(qe))return qe.map(n.MultiDocumentHighlight.from)}}class z{constructor(W,x){this.d=W,this.e=x}async provideLinkedEditingRanges(W,x,H){const K=this.d.getDocument(W),oe=n.Position.to(x),ye=await this.e.provideLinkedEditingRanges(K,oe,H);if(ye&&Array.isArray(ye.ranges))return{ranges:(0,I.$Hb)(ye.ranges.map(n.Range.from)),wordPattern:ye.wordPattern}}}class M{constructor(W,x){this.d=W,this.e=x}async provideReferences(W,x,H,K){const oe=this.d.getDocument(W),ye=n.Position.to(x),Re=await this.e.provideReferences(oe,ye,H,K);if(Array.isArray(Re))return Re.map(n.location.from)}}class N{static{this.d=1e3}constructor(W,x,H,K,oe,ye,Re){this.g=W,this.h=x,this.j=H,this.k=K,this.l=oe,this.m=ye,this.n=Re,this.e=new t.$Sgc("CodeAction"),this.f=new Map}async provideCodeActions(W,x,H,K){const oe=this.g.getDocument(W),ye=S.$2s.isISelection(x)?n.Selection.to(x):n.Range.to(x),Re=[];for(const at of this.j.getDiagnostics(W))if(ye.intersection(at.range)&&Re.push(at)>N.d)break;const qe={diagnostics:Re,only:H.only?new r.$OL(H.only):void 0,triggerKind:n.CodeActionTriggerKind.to(H.trigger)},Ge=await this.k.provideCodeActions(oe,ye,qe,K);if(!(0,I.$Lb)(Ge)||K.isCancellationRequested)return;const Xe=this.e.add(Ge),it=new v.$Sc;this.f.set(Xe,it);const lt=[];for(let at=0;at<Ge.length;at++){const et=Ge[at];if(et)if(N.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,it)});else{qe.only&&(et.kind?qe.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Ae=et.ranges??[];lt.push({cacheId:[Xe,at],title:et.title,command:et.command&&this.h.toInternal(et.command,it),diagnostics:et.diagnostics&&et.diagnostics.map(n.Diagnostic.from),edit:et.edit&&n.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,a.$NF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,a.$NF)(this.m,"codeActionRanges")?(0,I.$Hb)(Ae.map(n.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Xe,actions:lt}}async resolveCodeAction(W,x){const[H,K]=W,oe=this.e.get(H,K);if(!oe||N.o(oe))return{};if(!this.k.resolveCodeAction)return{};const ye=await this.k.resolveCodeAction(oe,x)??oe;let Re;ye.edit&&(Re=n.WorkspaceEdit.from(ye.edit,void 0));let qe;if(ye.command){const Ge=this.f.get(H);Ge&&(qe=this.h.toInternal(ye.command,Ge))}return{edit:Re,command:qe}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class O{static toInternalProviderId(W,x){return W+"."+x}constructor(W,x,H,K,oe){this.d=W,this.e=x,this.f=H,this.g=K,this.h=oe}async prepareDocumentPaste(W,x,H,K){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(W),ye=x.map(Ge=>n.Range.to(Ge)),Re=n.DataTransfer.toDataTransfer(H,()=>{throw new L.$$});if(await this.f.prepareDocumentPaste(oe,ye,Re,K),K.isCancellationRequested)return;const qe=Array.from(Re).filter(([,Ge])=>!(Ge instanceof r.$iM));return n.DataTransfer.from(qe)}async providePasteEdits(W,x,H,K,oe){if(!this.f.provideDocumentPasteEdits)return;const ye=this.e.getDocument(x),Re=H.map(Xe=>n.Range.to(Xe)),qe=n.DataTransfer.toDataTransfer(K,async Xe=>(await this.d.$resolvePasteFileData(this.g,W,Xe)).buffer),Ge=await this.f.provideDocumentPasteEdits(ye,Re,qe,oe);if(Ge)return{label:Ge.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ge.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:O.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?n.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class j{constructor(W,x){this.d=W,this.e=x}async provideDocumentFormattingEdits(W,x,H){const K=this.d.getDocument(W),oe=await this.e.provideDocumentFormattingEdits(K,x,H);if(Array.isArray(oe))return oe.map(n.TextEdit.from)}}class Y{constructor(W,x){this.d=W,this.e=x}async provideDocumentRangeFormattingEdits(W,x,H,K){const oe=this.d.getDocument(W),ye=n.Range.to(x),Re=await this.e.provideDocumentRangeFormattingEdits(oe,ye,H,K);if(Array.isArray(Re))return Re.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,x,H,K){(0,C.$Wf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(W),ye=x.map(n.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(oe,ye,H,K);if(Array.isArray(Re))return Re.map(n.TextEdit.from)}}class ne{constructor(W,x){this.d=W,this.e=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,x,H,K,oe){const ye=this.d.getDocument(W),Re=n.Position.to(x),qe=await this.e.provideOnTypeFormattingEdits(ye,Re,H,K,oe);if(Array.isArray(qe))return qe.map(n.TextEdit.from)}}class ee{constructor(W,x){this.e=W,this.f=x,this.d=new t.$Sgc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,x){const H=await this.e.provideWorkspaceSymbols(W,x);if(!(0,I.$Lb)(H))return{symbols:[]};const K=this.d.add(H),oe={cacheId:K,symbols:[]};for(let ye=0;ye<H.length;ye++){const Re=H[ye];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}oe.symbols.push({...n.WorkspaceSymbol.from(Re),cacheId:[K,ye]})}return oe}async resolveWorkspaceSymbol(W,x){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const H=this.d.get(...W.cacheId);if(H){const K=await this.e.resolveWorkspaceSymbol(H,x);return K&&(0,p.$En)(W,n.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class Q{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideRenameEdits(W,x,H,K){const oe=this.d.getDocument(W),ye=n.Position.to(x);try{const Re=await this.e.provideRenameEdits(oe,ye,H,K);return Re?n.WorkspaceEdit.from(Re):void 0}catch(Re){const qe=Q.g(Re);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(W,x,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(W),oe=n.Position.to(x);try{const ye=await this.e.prepareRename(K,oe,H);let Re,qe;if(r.$vL.isRange(ye)?(Re=ye,qe=K.getText(ye)):(0,C.$Of)(ye)&&(Re=ye.range,qe=ye.placeholder),!Re||!qe)return;if(Re.start.line>oe.line||Re.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Re),text:qe}}catch(ye){const Re=Q.g(ye);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(ye)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class X{constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideNewSymbolNames(W,x,H){const K=this.d.getDocument(W),oe=n.Range.to(x);try{const ye=await this.e.provideNewSymbolNames(K,oe,H);return ye?ye.map(Re=>typeof Re=="string"?{newSymbolName:Re}:{newSymbolName:Re.newSymbolName,tags:Re.tags}):void 0}catch(ye){this.f.error(X.g(ye)??JSON.stringify(ye,null,"	"));return}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ce{constructor(W,x){this.resultId=W,this.tokens=x}}class ie{constructor(W,x){this.f=W,this.g=x,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,x,H){const K=this.f.getDocument(W),oe=x!==0?this.d.get(x):null;let ye=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,oe.resultId,H):await this.g.provideDocumentSemanticTokens(K,H);return oe&&this.d.delete(x),ye?(ye=ie.h(ye),this.o(ie.n(oe,ye),ye)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return ie.j(W)?ie.k(W)?W:new r.$MM(new Uint32Array(W.data),W.resultId):ie.l(W)?ie.m(W)?W:new r.$OM(W.edits.map(x=>new r.$NM(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const x of W.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static n(W,x){if(!ie.j(x)||!W||!W.tokens)return x;const H=W.tokens,K=H.length,oe=x.data,ye=oe.length;let Re=0;const qe=Math.min(K,ye);for(;Re<qe&&H[Re]===oe[Re];)Re++;if(Re===K&&Re===ye)return new r.$OM([],x.resultId);let Ge=0;const Xe=qe-Re;for(;Ge<Xe&&H[K-Ge-1]===oe[ye-Ge-1];)Ge++;return new r.$OM([{start:Re,deleteCount:K-Re-Ge,data:oe.subarray(Re,ye-Ge)}],x.resultId)}o(W,x){if(ie.j(W)){const H=this.e++;return this.d.set(H,new ce(W.resultId,W.data)),(0,w.$d_)({id:H,type:"full",data:W.data})}if(ie.l(W)){const H=this.e++;return ie.j(x)?this.d.set(H,new ce(x.resultId,x.data)):this.d.set(H,new ce(W.resultId)),(0,w.$d_)({id:H,type:"delta",deltas:(W.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class fe{constructor(W,x){this.d=W,this.e=x}async provideDocumentRangeSemanticTokens(W,x,H){const K=this.d.getDocument(W),oe=await this.e.provideDocumentRangeSemanticTokens(K,n.Range.to(x),H);return oe?this.f(oe):null}f(W){return(0,w.$d_)({id:0,type:"full",data:W.data})}}class re{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,x,H,K,oe){this.f=W,this.g=x,this.h=H,this.j=K,this.k=oe,this.d=new t.$Sgc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,x,H,K){const oe=this.f.getDocument(W),ye=n.Position.to(x),Re=oe.getWordRangeAtPosition(ye)||new r.$vL(ye,ye),qe=Re.with({end:ye}),Ge=new k.$Ud,Xe=await this.h.provideCompletionItems(oe,ye,K,n.CompletionContext.to(H));if(!Xe||K.isCancellationRequested)return;const it=Array.isArray(Xe)?new r.$2L(Xe):Xe,lt=re.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),at=new v.$Sc;this.e.set(lt,at);const et=[],Ae={x:lt,b:et,a:{replace:n.Range.from(Re),insert:n.Range.from(qe)},c:it.isIncomplete||void 0,d:Ge.elapsed()};for(let Se=0;Se<it.items.length;Se++){const He=it.items[Se],te=this.l(He,[lt,Se],qe,Re);et.push(te)}return Ae}async resolveCompletionItem(W,x){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...W);if(!H)return;const K=this.l(H,W),oe=await this.h.resolveCompletionItem(H,x);if(!oe)return;const ye=this.l(oe,W);return(K.h!==ye.h||K.i!==ye.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==ye.n||K.o!==ye.o||!(0,p.$Fn)(K.p,ye.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:ye.d,c:ye.c,l:ye.l,h:ye.h,i:ye.i,n:ye.n,o:ye.o,p:ye.p}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,x,H,K){const oe=this.e.get(x[0]);if(!oe)throw Error("DisposableStore is missing...");const ye=this.g.toInternal(W.command,oe),Re={x,a:W.label,b:W.kind!==void 0?n.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(n.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:n.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(n.TextEdit.from),n:ye?.$ident,o:ye?.id,p:ye?.$ident?void 0:ye?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=W.textEdit.newText):typeof W.insertText=="string"?Re.h=W.insertText:W.insertText instanceof r.$EL&&(Re.h=W.insertText.value,Re.i|=4);let qe;return W.textEdit?qe=W.textEdit.range:W.range&&(qe=W.range),r.$vL.isRange(qe)?Re.j=n.Range.from(qe):qe&&(!H?.isEqual(qe.inserting)||!K?.isEqual(qe.replacing))&&(Re.j={insert:n.Range.from(qe.inserting),replace:n.Range.from(qe.replacing)}),Re}}class J{async provideInlineCompletions(W,x,H,K){}disposeCompletions(W){}handleDidShowCompletionItem(W,x,H){}handlePartialAccept(W,x,H){}}class B extends J{constructor(W,x,H,K){super(),this.f=W,this.g=x,this.h=H,this.j=K,this.d=new ae,this.e=(0,a.$NF)(this.f,"inlineCompletionsAdditions"),this.k={[l.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[l.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,a.$NF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,x,H,K){const oe=this.g.getDocument(W),ye=n.Position.to(x),Re=await this.h.provideInlineCompletionItems(oe,ye,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:n.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},K);if(!Re||K.isCancellationRequested)return;const qe=Array.isArray(Re)?Re:Re.items,Ge=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Xe=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:qe}),items:qe.map((at,et)=>{let Ae;at.command&&(it||(it=new v.$Sc),Ae=this.j.toInternal(at.command,it));const Se=at.insertText;return{insertText:typeof Se=="string"?Se:{snippet:Se.value},filterText:at.filterText,range:at.range?n.Range.from(at.range):void 0,command:Ae,idx:et,completeBracketPairs:this.e?at.completeBracketPairs:!1}}),commands:Ge.map(at=>(it||(it=new v.$Sc),this.j.toInternal(at,it))),suppressSuggestions:!1,enableForwardStability:Xe}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,x,H){const K=this.d.get(W)?.items[x];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,H)}handlePartialAccept(W,x,H){const K=this.d.get(W)?.items[x];K&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(K,H)}}class ae{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const x=this.e++;return this.d.set(x,W),x}disposeReferenceId(W){const x=this.d.get(W);return this.d.delete(W),x}get(W){return this.d.get(W)}}class Ee{constructor(W,x){this.e=W,this.f=x,this.d=new t.$Sgc("SignatureHelp")}async provideSignatureHelp(W,x,H,K){const oe=this.e.getDocument(W),ye=n.Position.to(x),Re=this.g(H),qe=await this.f.provideSignatureHelp(oe,ye,K,Re);if(qe){const Ge=this.d.add([qe]);return{...n.SignatureHelp.from(qe),id:Ge}}}g(W){let x;if(W.activeSignatureHelp){const H=n.SignatureHelp.to(W.activeSignatureHelp),K=this.d.get(W.activeSignatureHelp.id,0);K?(x=K,x.activeSignature=H.activeSignature,x.activeParameter=H.activeParameter):x=H}return{...W,activeSignatureHelp:x}}releaseSignatureHelp(W){this.d.delete(W)}}class le{constructor(W,x,H,K,oe){this.f=W,this.g=x,this.h=H,this.j=K,this.k=oe,this.d=new t.$Sgc("InlayHints"),this.e=new Map}async provideInlayHints(W,x,H){const K=this.f.getDocument(W),oe=n.Range.to(x),ye=await this.h.provideInlayHints(K,oe,H);if(!Array.isArray(ye)||ye.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`);return}if(H.isCancellationRequested)return;const Re=this.d.add(ye);this.e.set(Re,new v.$Sc);const qe={hints:[],cacheId:Re};for(let Ge=0;Ge<ye.length;Ge++)this.l(ye[Ge],oe)&&qe.hints.push(this.m(ye[Ge],[Re,Ge]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`),qe}async resolveInlayHint(W,x){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...W);if(!H)return;const K=await this.h.resolveInlayHint(H,x);if(K&&this.l(K))return this.m(K,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,x){return W.label.length===0||Array.isArray(W.label)&&W.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(x&&!x.contains(W.position))}m(W,x){const H=this.e.get(x[0]);if(!H)throw Error("DisposableStore is missing...");const K={label:"",cacheId:x,tooltip:n.MarkdownString.fromStrict(W.tooltip),position:n.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(n.TextEdit.from),kind:W.kind&&n.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")K.label=W.label;else{const oe=[];K.label=oe;for(const ye of W.label){if(!ye.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:ye.value,tooltip:n.MarkdownString.fromStrict(ye.tooltip)};r.$FL.isLocation(ye.location)&&(Re.location=n.location.from(ye.location)),ye.command&&(Re.command=this.g.toInternal(ye.command,H)),oe.push(Re)}}return K}}class de{constructor(W,x){this.e=W,this.f=x,this.d=new t.$Sgc("DocumentLink")}async provideLinks(W,x){const H=this.e.getDocument(W),K=await this.f.provideDocumentLinks(H,x);if(!(!Array.isArray(K)||K.length===0)&&!x.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(de.g).map(n.DocumentLink.from)};{const oe=this.d.add(K),ye={links:[],cacheId:oe};for(let Re=0;Re<K.length;Re++){if(!de.g(K[Re]))continue;const qe=n.DocumentLink.from(K[Re]);qe.cacheId=[oe,Re],ye.links.push(qe)}return ye}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,x){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...W);if(!H)return;const K=await this.f.resolveDocumentLink(H,x);if(!(!K||!de.g(K)))return n.DocumentLink.from(K)}releaseLinks(W){this.d.delete(W)}}class ue{constructor(W,x){this.d=W,this.e=x}async provideColors(W,x){const H=this.d.getDocument(W),K=await this.e.provideDocumentColors(H,x);return Array.isArray(K)?K.map(ye=>({color:n.Color.from(ye.color),range:n.Range.from(ye.range)})):[]}async provideColorPresentations(W,x,H){const K=this.d.getDocument(W),oe=n.Range.to(x.range),ye=n.Color.to(x.color),Re=await this.e.provideColorPresentations(ye,{document:K,range:oe},H);if(Array.isArray(Re))return Re.map(n.ColorPresentation.from)}}class ge{constructor(W,x){this.d=W,this.e=x}async provideFoldingRanges(W,x,H){const K=this.d.getDocument(W),oe=await this.e.provideFoldingRanges(K,x,H);if(Array.isArray(oe))return oe.map(n.FoldingRange.from)}}class V{constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideSelectionRanges(W,x,H){const K=this.d.getDocument(W),oe=x.map(n.Position.to),ye=await this.e.provideSelectionRanges(K,oe,H);if(!(0,I.$Lb)(ye))return[];if(ye.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let qe=0;qe<oe.length;qe++){const Ge=[];Re.push(Ge);let Xe=oe[qe],it=ye[qe];for(;;){if(!it.range.contains(Xe))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(n.SelectionRange.from(it)),!it.parent)break;Xe=it.range,it=it.parent}}return Re}}class Z{constructor(W,x){this.f=W,this.g=x,this.d=new A.$ON(""),this.e=new Map}async prepareSession(W,x,H){const K=this.f.getDocument(W),oe=n.Position.to(x),ye=await this.g.prepareCallHierarchy(K,oe,H);if(!ye)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(ye)?ye.map(qe=>this.h(Re,qe)):[this.h(Re,ye)]}async provideCallsTo(W,x,H){const K=this.j(W,x);if(!K)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(K,H);if(oe)return oe.map(ye=>({from:this.h(W,ye.from),fromRanges:ye.fromRanges.map(Re=>n.Range.from(Re))}))}async provideCallsFrom(W,x,H){const K=this.j(W,x);if(!K)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(K,H);if(oe)return oe.map(ye=>({to:this.h(W,ye.to),fromRanges:ye.fromRanges.map(Re=>n.Range.from(Re))}))}releaseSession(W){this.e.delete(W)}h(W,x){const H=this.e.get(W),K=n.CallHierarchyItem.from(x,W,H.size.toString(36));return H.set(K._itemId,x),K}j(W,x){return this.e.get(W)?.get(x)}}class he{constructor(W,x){this.f=W,this.g=x,this.d=new A.$ON(""),this.e=new Map}async prepareSession(W,x,H){const K=this.f.getDocument(W),oe=n.Position.to(x),ye=await this.g.prepareTypeHierarchy(K,oe,H);if(!ye)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(ye)?ye.map(qe=>this.h(Re,qe)):[this.h(Re,ye)]}async provideSupertypes(W,x,H){const K=this.j(W,x);if(!K)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(K,H);if(oe)return oe.map(ye=>this.h(W,ye))}async provideSubtypes(W,x,H){const K=this.j(W,x);if(!K)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(K,H);if(oe)return oe.map(ye=>this.h(W,ye))}releaseSession(W){this.e.delete(W)}h(W,x){const H=this.e.get(W),K=n.TypeHierarchyItem.from(x,W,H.size.toString(36));return H.set(K._itemId,x),K}j(W,x){return this.e.get(W)?.get(x)}}class be{static toInternalProviderId(W,x){return W+"."+x}constructor(W,x,H,K,oe){this.d=W,this.e=x,this.f=H,this.g=K,this.h=oe}async provideDocumentOnDropEdits(W,x,H,K,oe){const ye=this.e.getDocument(x),Re=n.Position.to(H),qe=n.DataTransfer.toDataTransfer(K,async Xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,W,Xe)).buffer),Ge=await this.f.provideDocumentDropEdits(ye,Re,qe,oe);if(Ge)return{label:Ge.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ge.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:be.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?n.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class Pe{constructor(W,x){this.d=W,this.e=x}async provideMappedEdits(W,x,H,K){const oe=m.URI.revive(W),ye=this.d.getDocument(oe),Re=H.documents.map(Xe=>Xe.map(it=>({uri:m.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(lt=>n.Range.to(lt))}))),qe={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(ye,x,qe,K);return Ge?n.WorkspaceEdit.from(Ge):null}}class pe{constructor(W,x){this.adapter=W,this.extension=x}}class Le{static{this.d=0}constructor(W,x,H,K,oe,ye,Re,qe){this.g=x,this.h=H,this.j=K,this.k=oe,this.l=ye,this.m=Re,this.n=qe,this.f=new Map,this.e=W.getProxy(h.$rL.MainThreadLanguageFeatures)}o(W,x){return n.DocumentSelector.from(W,this.g,x)}p(W){return new r.$tL(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Le.d++}async s(W,x,H,K,oe,ye=!1){const Re=this.f.get(W);if(!Re||!(Re.adapter instanceof x))return K;const qe=Date.now();ye||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ge=H(Re.adapter,Re.extension);return Promise.resolve(Ge).catch(Xe=>{(0,L.$4)(Xe)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Xe),this.n.onExtensionError(Re.extension.identifier,Xe))}).finally(()=>{ye||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),$.CancellationToken.isCancellationToken(oe)?(0,F.$Zg)(Ge,oe):Ge}t(W,x){const H=this.q();return this.f.set(H,new pe(W,x)),H}static u(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,x,H,K){const oe=this.t(new c(this.h,H),W),ye=K&&K.label||Le.u(W);return this.e.$registerDocumentSymbolProvider(oe,this.o(x,W),ye),this.p(oe)}$provideDocumentSymbols(W,x,H){return this.s(W,c,K=>K.provideDocumentSymbols(m.URI.revive(x),H),void 0,H)}registerCodeLensProvider(W,x,H){const K=this.q(),oe=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new pe(new o(this.h,this.j.converter,H,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(K,this.o(x,W),oe);let ye=this.p(K);if(oe!==void 0){const Re=H.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(oe));ye=r.$tL.from(ye,Re)}return ye}$provideCodeLenses(W,x,H){return this.s(W,o,K=>K.provideCodeLenses(m.URI.revive(x),H),void 0,H)}$resolveCodeLens(W,x,H){return this.s(W,o,K=>K.resolveCodeLens(x,H),void 0,void 0)}$releaseCodeLenses(W,x){this.s(W,o,H=>Promise.resolve(H.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(W,x,H){const K=this.t(new d(this.h,H),W);return this.e.$registerDefinitionSupport(K,this.o(x,W)),this.p(K)}$provideDefinition(W,x,H,K){return this.s(W,d,oe=>oe.provideDefinition(m.URI.revive(x),H,K),[],K)}registerDeclarationProvider(W,x,H){const K=this.t(new b(this.h,H),W);return this.e.$registerDeclarationSupport(K,this.o(x,W)),this.p(K)}$provideDeclaration(W,x,H,K){return this.s(W,b,oe=>oe.provideDeclaration(m.URI.revive(x),H,K),[],K)}registerImplementationProvider(W,x,H){const K=this.t(new D(this.h,H),W);return this.e.$registerImplementationSupport(K,this.o(x,W)),this.p(K)}$provideImplementation(W,x,H,K){return this.s(W,D,oe=>oe.provideImplementation(m.URI.revive(x),H,K),[],K)}registerTypeDefinitionProvider(W,x,H){const K=this.t(new g(this.h,H),W);return this.e.$registerTypeDefinitionSupport(K,this.o(x,W)),this.p(K)}$provideTypeDefinition(W,x,H,K){return this.s(W,g,oe=>oe.provideTypeDefinition(m.URI.revive(x),H,K),[],K)}registerHoverProvider(W,x,H,K){const oe=this.t(new f(this.h,H),W);return this.e.$registerHoverProvider(oe,this.o(x,W)),this.p(oe)}$provideHover(W,x,H,K){return this.s(W,f,oe=>oe.provideHover(m.URI.revive(x),H,K),void 0,K)}registerEvaluatableExpressionProvider(W,x,H,K){const oe=this.t(new y(this.h,H),W);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(x,W)),this.p(oe)}$provideEvaluatableExpression(W,x,H,K){return this.s(W,y,oe=>oe.provideEvaluatableExpression(m.URI.revive(x),H,K),void 0,K)}registerInlineValuesProvider(W,x,H,K){const oe=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ye=this.t(new P(this.h,H),W);this.e.$registerInlineValuesProvider(ye,this.o(x,W),oe);let Re=this.p(ye);if(oe!==void 0){const qe=H.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(oe));Re=r.$tL.from(Re,qe)}return Re}$provideInlineValues(W,x,H,K,oe){return this.s(W,P,ye=>ye.provideInlineValues(m.URI.revive(x),H,K,oe),void 0,oe)}registerDocumentHighlightProvider(W,x,H){const K=this.t(new T(this.h,H),W);return this.e.$registerDocumentHighlightProvider(K,this.o(x,W)),this.p(K)}registerMultiDocumentHighlightProvider(W,x,H){const K=this.t(new U(this.h,H),W);return this.e.$registerMultiDocumentHighlightProvider(K,this.o(x,W)),this.p(K)}$provideDocumentHighlights(W,x,H,K){return this.s(W,T,oe=>oe.provideDocumentHighlights(m.URI.revive(x),H,K),void 0,K)}$provideMultiDocumentHighlights(W,x,H,K,oe){return this.s(W,U,ye=>ye.provideMultiDocumentHighlights(m.URI.revive(x),H,K.map(Re=>m.URI.revive(Re)),oe),void 0,oe)}registerLinkedEditingRangeProvider(W,x,H){const K=this.t(new z(this.h,H),W);return this.e.$registerLinkedEditingRangeProvider(K,this.o(x,W)),this.p(K)}$provideLinkedEditingRanges(W,x,H,K){return this.s(W,z,async oe=>{const ye=await oe.provideLinkedEditingRanges(m.URI.revive(x),H,K);if(ye)return{ranges:ye.ranges,wordPattern:ye.wordPattern?Le.w(ye.wordPattern):void 0}},void 0,K)}registerReferenceProvider(W,x,H){const K=this.t(new M(this.h,H),W);return this.e.$registerReferenceSupport(K,this.o(x,W)),this.p(K)}$provideReferences(W,x,H,K,oe){return this.s(W,M,ye=>ye.provideReferences(m.URI.revive(x),H,K,oe),void 0,oe)}registerCodeActionProvider(W,x,H,K){const oe=new v.$Sc,ye=this.t(new N(this.h,this.j.converter,this.k,H,this.l,W,this.m),W);return this.e.$registerQuickFixSupport(ye,this.o(x,W),{providedKinds:K?.providedCodeActionKinds?.map(Re=>Re.value),documentation:K?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,oe)}))},Le.u(W),!!H.resolveCodeAction),oe.add(this.p(ye)),oe}$provideCodeActions(W,x,H,K,oe){return this.s(W,N,ye=>ye.provideCodeActions(m.URI.revive(x),H,K,oe),void 0,oe)}$resolveCodeAction(W,x,H){return this.s(W,N,K=>K.resolveCodeAction(x,H),{},void 0)}$releaseCodeActions(W,x){this.s(W,N,H=>Promise.resolve(H.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(W,x,H){const K=this.t(new j(this.h,H),W);return this.e.$registerDocumentFormattingSupport(K,this.o(x,W),W.identifier,W.displayName||W.name),this.p(K)}$provideDocumentFormattingEdits(W,x,H,K){return this.s(W,j,oe=>oe.provideDocumentFormattingEdits(m.URI.revive(x),H,K),void 0,K)}registerDocumentRangeFormattingEditProvider(W,x,H){const K=typeof H.provideDocumentRangesFormattingEdits=="function",oe=this.t(new Y(this.h,H),W);return this.e.$registerRangeFormattingSupport(oe,this.o(x,W),W.identifier,W.displayName||W.name,K),this.p(oe)}$provideDocumentRangeFormattingEdits(W,x,H,K,oe){return this.s(W,Y,ye=>ye.provideDocumentRangeFormattingEdits(m.URI.revive(x),H,K,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(W,x,H,K,oe){return this.s(W,Y,ye=>ye.provideDocumentRangesFormattingEdits(m.URI.revive(x),H,K,oe),void 0,oe)}registerOnTypeFormattingEditProvider(W,x,H,K){const oe=this.t(new ne(this.h,H),W);return this.e.$registerOnTypeFormattingSupport(oe,this.o(x,W),K,W.identifier),this.p(oe)}$provideOnTypeFormattingEdits(W,x,H,K,oe,ye){return this.s(W,ne,Re=>Re.provideOnTypeFormattingEdits(m.URI.revive(x),H,K,oe,ye),void 0,ye)}registerWorkspaceSymbolProvider(W,x){const H=this.t(new ee(x,this.l),W);return this.e.$registerNavigateTypeSupport(H,typeof x.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(W,x,H){return this.s(W,ee,K=>K.provideWorkspaceSymbols(x,H),{symbols:[]},H)}$resolveWorkspaceSymbol(W,x,H){return this.s(W,ee,K=>K.resolveWorkspaceSymbol(x,H),void 0,void 0)}$releaseWorkspaceSymbols(W,x){this.s(W,ee,H=>H.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(W,x,H){const K=this.t(new Q(this.h,H,this.l),W);return this.e.$registerRenameSupport(K,this.o(x,W),Q.supportsResolving(H)),this.p(K)}$provideRenameEdits(W,x,H,K,oe){return this.s(W,Q,ye=>ye.provideRenameEdits(m.URI.revive(x),H,K,oe),void 0,oe)}$resolveRenameLocation(W,x,H,K){return this.s(W,Q,oe=>oe.resolveRenameLocation(m.URI.revive(x),H,K),void 0,K)}registerNewSymbolNamesProvider(W,x,H){const K=this.t(new X(this.h,H,this.l),W);return this.e.$registerNewSymbolNamesProvider(K,this.o(x,W)),this.p(K)}$provideNewSymbolNames(W,x,H,K){return this.s(W,X,oe=>oe.provideNewSymbolNames(m.URI.revive(x),H,K),void 0,K)}registerDocumentSemanticTokensProvider(W,x,H,K){const oe=this.t(new ie(this.h,H),W),ye=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(x,W),K,ye);let Re=this.p(oe);if(ye){const qe=H.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(ye));Re=r.$tL.from(Re,qe)}return Re}$provideDocumentSemanticTokens(W,x,H,K){return this.s(W,ie,oe=>oe.provideDocumentSemanticTokens(m.URI.revive(x),H,K),null,K)}$releaseDocumentSemanticTokens(W,x){this.s(W,ie,H=>H.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,x,H,K){const oe=this.t(new fe(this.h,H),W);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(x,W),K),this.p(oe)}$provideDocumentRangeSemanticTokens(W,x,H,K){return this.s(W,fe,oe=>oe.provideDocumentRangeSemanticTokens(m.URI.revive(x),H,K),null,K)}registerCompletionItemProvider(W,x,H,K){const oe=this.t(new re(this.h,this.j.converter,H,this.m,W),W);return this.e.$registerCompletionsProvider(oe,this.o(x,W),K,re.supportsResolving(H),W.identifier),this.p(oe)}$provideCompletionItems(W,x,H,K,oe){return this.s(W,re,ye=>ye.provideCompletionItems(m.URI.revive(x),H,K,oe),void 0,oe)}$resolveCompletionItem(W,x,H){return this.s(W,re,K=>K.resolveCompletionItem(x,H),void 0,H)}$releaseCompletionItems(W,x){this.s(W,re,H=>H.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(W,x,H,K){const oe=new B(W,this.h,H,this.j.converter),ye=this.t(oe,W);return this.e.$registerInlineCompletionsSupport(ye,this.o(x,W),oe.supportsHandleEvents,i.$qm.toKey(W.identifier.value),K?.yieldTo?.map(Re=>i.$qm.toKey(Re))||[]),this.p(ye)}$provideInlineCompletions(W,x,H,K,oe){return this.s(W,J,ye=>ye.provideInlineCompletions(m.URI.revive(x),H,K,oe),void 0,oe)}$handleInlineCompletionDidShow(W,x,H,K){this.s(W,J,async oe=>{oe.handleDidShowCompletionItem(x,H,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,x,H,K){this.s(W,J,async oe=>{oe.handlePartialAccept(x,H,K)},void 0,void 0)}$freeInlineCompletionsList(W,x){this.s(W,J,async H=>{H.disposeCompletions(x)},void 0,void 0)}registerSignatureHelpProvider(W,x,H,K){const oe=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,ye=this.t(new Ee(this.h,H),W);return this.e.$registerSignatureHelpProvider(ye,this.o(x,W),oe),this.p(ye)}$provideSignatureHelp(W,x,H,K,oe){return this.s(W,Ee,ye=>ye.provideSignatureHelp(m.URI.revive(x),H,K,oe),void 0,oe)}$releaseSignatureHelp(W,x){this.s(W,Ee,H=>H.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(W,x,H){const K=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new le(this.h,this.j.converter,H,this.l,W),W);this.e.$registerInlayHintsProvider(oe,this.o(x,W),typeof H.resolveInlayHint=="function",K,Le.u(W));let ye=this.p(oe);if(K!==void 0){const Re=H.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(K));ye=r.$tL.from(ye,Re)}return ye}$provideInlayHints(W,x,H,K){return this.s(W,le,oe=>oe.provideInlayHints(m.URI.revive(x),H,K),void 0,K)}$resolveInlayHint(W,x,H){return this.s(W,le,K=>K.resolveInlayHint(x,H),void 0,H)}$releaseInlayHints(W,x){this.s(W,le,H=>H.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(W,x,H){const K=this.t(new de(this.h,H),W);return this.e.$registerDocumentLinkProvider(K,this.o(x,W),typeof H.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(W,x,H){return this.s(W,de,K=>K.provideLinks(m.URI.revive(x),H),void 0,H,x.scheme==="output")}$resolveDocumentLink(W,x,H){return this.s(W,de,K=>K.resolveLink(x,H),void 0,void 0,!0)}$releaseDocumentLinks(W,x){this.s(W,de,H=>H.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(W,x,H){const K=this.t(new ue(this.h,H),W);return this.e.$registerDocumentColorProvider(K,this.o(x,W)),this.p(K)}$provideDocumentColors(W,x,H){return this.s(W,ue,K=>K.provideColors(m.URI.revive(x),H),[],H)}$provideColorPresentations(W,x,H,K){return this.s(W,ue,oe=>oe.provideColorPresentations(m.URI.revive(x),H,K),void 0,K)}registerFoldingRangeProvider(W,x,H){const K=this.q(),oe=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new pe(new ge(this.h,H),W)),this.e.$registerFoldingRangeProvider(K,this.o(x,W),W.identifier,oe);let ye=this.p(K);if(oe!==void 0){const Re=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));ye=r.$tL.from(ye,Re)}return ye}$provideFoldingRanges(W,x,H,K){return this.s(W,ge,oe=>oe.provideFoldingRanges(m.URI.revive(x),H,K),void 0,K)}registerSelectionRangeProvider(W,x,H){const K=this.t(new V(this.h,H,this.l),W);return this.e.$registerSelectionRangeProvider(K,this.o(x,W)),this.p(K)}$provideSelectionRanges(W,x,H,K){return this.s(W,V,oe=>oe.provideSelectionRanges(m.URI.revive(x),H,K),[],K)}registerCallHierarchyProvider(W,x,H){const K=this.t(new Z(this.h,H),W);return this.e.$registerCallHierarchyProvider(K,this.o(x,W)),this.p(K)}$prepareCallHierarchy(W,x,H,K){return this.s(W,Z,oe=>Promise.resolve(oe.prepareSession(m.URI.revive(x),H,K)),void 0,K)}$provideCallHierarchyIncomingCalls(W,x,H,K){return this.s(W,Z,oe=>oe.provideCallsTo(x,H,K),void 0,K)}$provideCallHierarchyOutgoingCalls(W,x,H,K){return this.s(W,Z,oe=>oe.provideCallsFrom(x,H,K),void 0,K)}$releaseCallHierarchy(W,x){this.s(W,Z,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(W,x,H){const K=this.t(new he(this.h,H),W);return this.e.$registerTypeHierarchyProvider(K,this.o(x,W)),this.p(K)}$prepareTypeHierarchy(W,x,H,K){return this.s(W,he,oe=>Promise.resolve(oe.prepareSession(m.URI.revive(x),H,K)),void 0,K)}$provideTypeHierarchySupertypes(W,x,H,K){return this.s(W,he,oe=>oe.provideSupertypes(x,H,K),void 0,K)}$provideTypeHierarchySubtypes(W,x,H,K){return this.s(W,he,oe=>oe.provideSubtypes(x,H,K),void 0,K)}$releaseTypeHierarchy(W,x){this.s(W,he,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(W,x,H,K){const oe=this.q();this.f.set(oe,new pe(new be(this.e,this.h,H,oe,W),W));const ye=(0,a.$NF)(W,"dropMetadata")&&K?be.toInternalProviderId(W.identifier.value,K.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(x,W),ye,(0,a.$NF)(W,"dropMetadata")?K:void 0),this.p(oe)}$provideDocumentOnDropEdits(W,x,H,K,oe,ye){return this.s(W,be,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(x,m.URI.revive(H),K,oe,ye)),void 0,void 0)}registerMappedEditsProvider(W,x,H){const K=this.t(new Pe(this.h,H),W);return this.e.$registerMappedEditsProvider(K,this.o(x,W)),this.p(K)}$provideMappedEdits(W,x,H,K,oe){return this.s(W,Pe,ye=>Promise.resolve(ye.provideMappedEdits(x,H,K,oe)),null,oe)}registerDocumentPasteEditProvider(W,x,H,K){const oe=this.q();this.f.set(oe,new pe(new O(this.e,this.h,H,oe,W),W));const ye=O.toInternalProviderId(W.identifier.value,K.id);return this.e.$registerPasteEditProvider(oe,this.o(x,W),ye,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(W,x,H,K,oe){return this.s(W,O,ye=>ye.prepareDocumentPaste(m.URI.revive(x),H,K,oe),void 0,oe)}$providePasteEdits(W,x,H,K,oe,ye){return this.s(W,O,Re=>Re.providePasteEdits(x,m.URI.revive(H),K,oe,ye),void 0,ye)}static w(W){return{pattern:W.source,flags:W.flags}}static y(W){return{decreaseIndentPattern:Le.w(W.decreaseIndentPattern),increaseIndentPattern:Le.w(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Le.w(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Le.w(W.unIndentedLinePattern):void 0}}static z(W){return{beforeText:Le.w(W.beforeText),afterText:W.afterText?Le.w(W.afterText):void 0,previousLineText:W.previousLineText?Le.w(W.previousLineText):void 0,action:W.action}}static B(W){return W.map(Le.z)}static C(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(x=>r.SyntaxTokenType.toString(x)):void 0}}static D(W){return W.map(Le.C)}setLanguageConfiguration(W,x,H){const{wordPattern:K}=H;if(K&&(0,R.$2e)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(x,K):this.h.setWordDefinitionFor(x,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const oe=this.q(),ye={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Le.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Le.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Le.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Le.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,x,ye),this.p(oe)}$setWordDefinitions(W){for(const x of W)this.h.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.$3gc=Le}),define(Ce[332],Ie([1,0,6,15,7,39,8,3,26]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class k{constructor(C,m,E,S){this.c=m,this.d=E,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(I.$rL.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const E=this.c.getDocumentData(C);if(!E)throw new Error(`document '${C.toString()}' NOT found`);return E.document}async tokenAtPosition(C,m){const E=C.version,S=F.Position.from(m),l=await this.a.$tokensAtPosition(C.uri,S),w={type:$.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new $.$vL(m.line,m.character,m.line,m.character)};if(!l)return w;const s={range:F.Range.to(l.range),type:F.TokenType.to(l.type)};return!s.range.contains(m)||E!==C.version?w:s}createLanguageStatusItem(C,m,E){const S=this.f++,l=this.a,w=this.g,s=`${C.identifier.value}/${m}`;if(w.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);w.add(s);const i={selector:E,id:m,name:C.displayName??C.name,severity:$.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new v.$Sc,a=()=>{if(n?.dispose(),!w.has(s)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.$ah)(()=>{r.clear(),this.a.$setLanguageStatus(S,{id:s,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===$.LanguageStatusSeverity.Error?L.default.Error:i.severity===$.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),l.$removeLanguageStatus(S),w.delete(s)},get id(){return i.id},get name(){return i.name},set name(h){i.name=h,a()},get selector(){return i.selector},set selector(h){i.selector=h,a()},get text(){return i.text},set text(h){i.text=h,a()},set text2(h){(0,p.$OF)(C,"languageStatusText"),i.text=h,a()},get text2(){return(0,p.$OF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(h){i.detail=h,a()},get severity(){return i.severity},set severity(h){i.severity=h,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(h){i.accessibilityInformation=h,a()},get command(){return i.command},set command(h){i.command=h,a()},get busy(){return i.busy},set busy(h){i.busy=h,a()}};return a(),t}}e.$pic=k}),define(Ce[333],Ie([1,0,16,2,15,7,118]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=void 0;class v{constructor(C,m,E,S){this.start=C,this.deletedCount=m,this.deletedItems=E,this.items=S}asApiEvent(){return{range:new L.$TM(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,E){this.notebook=C,this.h=m,this.j=E,this.handle=E.handle,this.uri=F.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map($.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze($.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:$.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(E)}return this.f}setOutputs(C){this.a=C.map($.NotebookCellOutput.to)}setOutputItems(C,m,E){const S=E.map($.NotebookCellOutputItem.to),l=this.a.find(w=>w.id===C);if(l&&(m||(l.items.length=0),l.items.push(...S),l.items.length>1&&l.items.every(w=>A.$tJ(w.mime)))){const w=new Map,s=[];l.items.forEach(i=>{let n;w.has(i.mime)?n=w.get(i.mime):(n=[],w.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),l.items.length=0,s.forEach(i=>{const n=A.$uJ(w.get(i));l.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze($.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$aic=p;class k{static{this.a=0}constructor(C,m,E,S,l){this.k=C,this.l=m,this.m=E,this.uri=S,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===I.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(E){return E=C.n(E),C.b[E].apiCell},getCells(E){return(E?C.p(E):C.b).map(l=>l.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,E){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:E});const S={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},l=[];for(const s of C.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,S.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,S.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),l.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),l.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),l.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const w=new Map;for(let s=0;s<l.length;s++){const i=l[s],n=w.get(i.cell);if(n===void 0){const r=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});w.set(i.cell,r-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,E=C.end|0;return m<0&&(m=0),E>this.b.length&&(E=this.b.length),C.with({start:m,end:E})}p(C){C=this.o(C);const m=[];for(let E=C.start;E<C.end;E++)m.push(this.b[E]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,E){if(this.j)return;const S=[],l=[],w=[];if(C.reverse().forEach(s=>{const n=s[2].map(t=>{const h=new p(this,this.l,t);return m||l.push(p.asModelAddData(this.apiNotebook,t)),h}),r=new v(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)w.push(t.uri),r.deletedItems.push(t.apiCell);S.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:w}),E)for(const s of S)E.push(s.asApiEvent())}s(C,m,E,S){const l=this.b.splice(C,m);this.b.splice(E,0,...l);const w=[new v(C,m,l.map(s=>s.apiCell),[]),new v(E,0,[],l)];for(const s of w)S.push(s.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,E,S){this.b[C].setOutputItems(m,E,S)}v(C,m){const E=this.b[C];E.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(E.uri,m)}w(C,m){const E=this.b[C];E.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$bic=k}),define(Ce[334],Ie([1,0,4,2,15,7]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;class A{constructor(p,k,R,C={timeout:1500,errors:3}){this.b=p,this.c=k,this.d=R,this.f=C,this.a=new I.$1d}dispose(){}getOnWillSaveNotebookDocumentEvent(p){return(k,R,C)=>{const m=function(S){k.call(R,S)};return m.extension=p,this.a.event(m,void 0,C)}}async $participateInSave(p,k,R){const C=F.URI.revive(p),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:$.TextDocumentSaveReason.to(k)},R,async(l,w)=>{const s=Date.now(),i=await await Promise.resolve(l);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",w.extension.identifier),!R.isCancellationRequested&&i&&(i instanceof L.$DL?E.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",w.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(E.length===0)return!0;const S={edits:[]};for(const l of E){const{edits:w}=$.WorkspaceEdit.from(l);S.edits=S.edits.concat(w)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$ric=A}),define(Ce[150],Ie([1,0,14,15,7]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(v,p,k,R,C,m){this.id=v,this.f=p,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=R,this.c=m}get apiEditor(){if(!this.e){const v=this;this.e={get notebook(){return v.notebookData.apiNotebook},get selection(){return v.a[0]},set selection(p){this.selections=[p]},get selections(){return v.a},set selections(p){if(!Array.isArray(p)||!p.every($.$TM.isNotebookRange))throw(0,I.$7)("selections");v.a=p,v.g(p)},get visibleRanges(){return v.b},revealRange(p,k){v.f.$tryRevealRange(v.id,F.NotebookRange.from(p),k??$.NotebookEditorRevealType.Default)},get viewColumn(){return v.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(v){this.d=v}_acceptVisibleRanges(v){this.b=v}_acceptSelections(v){this.a=v}g(v){this.f.$trySetSelections(this.id,v.map(F.NotebookRange.from))}_acceptViewColumn(v){this.c=v}}e.$cic=L}),define(Ce[335],Ie([1,0,4,13,15]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;let L=class{constructor(v,p){this.c=v,this.d=p,this.a=new I.$Yd,this.b=new I.$Yd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(v,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,p);const k=this.d.getEditorById(v);p.visibleRanges&&k._acceptVisibleRanges(p.visibleRanges.ranges.map($.NotebookRange.to)),p.selections&&k._acceptSelections(p.selections.selections.map($.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const p in v)this.d.getEditorById(p)._acceptViewColumn($.ViewColumn.to(v[p]))}};e.$tic=L,e.$tic=L=Je([We(0,F.$sj)],L)}),define(Ce[336],Ie([1,0,4,6,150]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class L{constructor(v,p){this.c=p,this.a=new Map,this.b=v.getProxy(F.$rL.MainThreadNotebookRenderers)}$postRendererMessage(v,p,k){const R=this.c.getEditorById(v);this.a.get(p)?.fire({editor:R.apiEditor,message:k})}createRendererMessaging(v,p){if(!v.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,C,m)=>this.d(p).event(R,C,m),postMessage:(R,C)=>{$.$cic.apiEditorsToExtHost.has(R)&&([R,C]=[C,R]);const m=C&&$.$cic.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,p,R)}}}d(v){let p=this.a.get(v);return p||(p=new I.$Yd({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(v)}}),this.a.set(v,p),p)}}e.$wic=L}),define(Ce[337],Ie([1,0,15,107,22,52,14]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class v{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,m,E){const S=this.b++,{title:l,location:w,cancellable:s}=m,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(S,{location:I.ProgressLocation.from(w),title:l,source:i,cancellable:s},C.isUnderDevelopment?void 0:C.identifier.value).catch(A.$2),this.d(S,E,!!s)}d(C,m,E){let S;E&&(S=new $.$9d,this.c.set(C,S));const l=s=>{this.a.$progressEnd(s),this.c.delete(s),S?.dispose()};let w;try{w=m(new k(this.a,C),E&&S?S.token:$.CancellationToken.None)}catch(s){throw l(C),s}return w.then(s=>l(C),s=>l(C)),w}$acceptProgressCanceled(C){const m=this.c.get(C);m&&(m.cancel(),this.c.delete(C))}}e.$Aic=v;function p(R,C){return R.message=C.message,typeof C.increment=="number"&&(typeof R.increment=="number"?R.increment+=C.increment:R.increment=C.increment),R}class k extends F.$Av{constructor(C,m){super(E=>this.throttledReport(E)),this.c=C,this.d=m}throttledReport(C){this.c.$progressReport(this.d,C)}}Je([(0,L.$Eh)(100,(R,C)=>p(R,C),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(Ce[338],Ie([1,0,2,6,8,15]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class A{static{this.a=0}constructor(p,k){this.d=k,this.c=new Map,this.b=p.getProxy(F.$rL.MainThreadQuickDiff)}$provideOriginalResource(p,k,R){const C=I.URI.revive(k),m=this.c.get(p);return m?(0,$.$3g)(()=>m.provideOriginalResource(C,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,k,R,C){const m=A.a++;return this.c.set(m,k),this.b.$registerQuickDiffProvider(m,L.DocumentSelector.from(p,this.d),R,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$Bic=A}),define(Ce[339],Ie([1,0,22,4,3,6,2,7,14,19,39,55,26,15]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;function S(l,w,s){const i=l.getProxy(L.$rL.MainThreadQuickOpen);class n{constructor(b,D){this.e=new Map,this.f=0,this.a=b,this.b=D}showQuickPick(b,D,g,f=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),P=++this.f,T=i.$show(P,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},f),U={},z=T.then(()=>U);return Promise.race([z,y]).then(M=>{if(M===U)return;const N=(0,m.$NF)(b,"quickPickItemTooltip");return y.then(O=>{const j=[];for(let Y=0;Y<O.length;Y++){const ne=O[Y];if(typeof ne=="string")j.push({label:ne,handle:Y});else if(ne.kind===v.QuickPickItemKind.Separator)j.push({type:"separator",label:ne.label});else{ne.tooltip&&!N&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const ee=ne.iconPath?c(ne.iconPath):void 0;j.push({label:ne.label,iconPath:ee?.iconPath,iconClass:ee?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:N?E.MarkdownString.fromStrict(ne.tooltip):void 0,handle:Y})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=Y=>{g.onDidSelectItem(O[Y])}),i.$setItems(P,j),T.then(Y=>{if(typeof Y=="number")return O[Y];if(Array.isArray(Y))return Y.map(ne=>O[ne])})})}).then(void 0,M=>{if(!(0,p.$4)(M))return i.$setError(P,M),Promise.reject(M)})}$onItemSelected(b){this.c?.(b)}showInput(b,D=I.CancellationToken.None){return this.d=b?.validateInput,i.$input(b,typeof this.d=="function",D).then(void 0,g=>{if(!(0,p.$4)(g))return Promise.reject(g)})}async $validateInput(b){if(!this.d)return;const D=await this.d(b);if(!D||typeof D=="string")return D;let g;switch(D.severity){case v.InputBoxValidationSeverity.Info:g=R.default.Info;break;case v.InputBoxValidationSeverity.Warning:g=R.default.Warning;break;case v.InputBoxValidationSeverity.Error:g=R.default.Error;break;default:g=D.message?R.default.Error:R.default.Ignore;break}return{content:D.message,severity:g}}async showWorkspaceFolderPick(b,D=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!g)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(y=>y.uri.toString()===g.uri.toString())}createQuickPick(b){const D=new o(b,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(b){const D=new u(b,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(b,D){this.e.get(b)?._fireDidChangeValue(D)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,D){const g=this.e.get(b);g instanceof o&&g._fireDidChangeActive(D)}$onDidChangeSelection(b,D){const g=this.e.get(b);g instanceof o&&g._fireDidChangeSelection(D)}$onDidTriggerButton(b,D){this.e.get(b)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(b,D,g){const f=this.e.get(b);f instanceof o&&f._fireDidTriggerItemButton(D,g)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class r{static{this.a=1}constructor(b,D){this.x=b,this.y=D,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Yd,this.q=new F.$Yd,this.r=new F.$Yd,this.s=new F.$Yd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((D,g)=>{const f=D===v.$QM.Back?-1:g;this.o.set(f,D)}),this.z({buttons:b.map((D,g)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===v.$QM.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const D=this.o.get(b);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,$.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(b){if(!this.v){for(const D of Object.keys(b)){const g=b[D];this.u[D]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(d){if(d instanceof v.$oM)return{id:d.id};const b=h(d),D=t(d);return{dark:typeof b=="string"?A.URI.file(b):b,light:typeof D=="string"?A.URI.file(D):D}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function h(d){return typeof d=="object"&&"dark"in d?d.dark:d}function c(d){const b=a(d);let D,g;return"id"in b?g=C.ThemeIcon.asClassName(b):D=b,{iconPath:D,iconClass:g}}class o extends r{constructor(b,D){super(b.identifier,D),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Yd,this.L=[],this.M=new F.$Yd,this.N=new F.$Yd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((f,y)=>{this.C.set(y,f),this.D.set(f,y)});const D=(0,m.$NF)(this.O,"quickPickItemTooltip"),g=[];for(let f=0;f<b.length;f++){const y=b[f];if(y.kind===v.QuickPickItemKind.Separator)g.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?c(y.iconPath):void 0;g.push({handle:f,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((T,U)=>({...c(T.iconPath),tooltip:T.tooltip,handle:U}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(b){const D=(0,k.$Hb)(b.map(g=>this.C.get(g)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(b){const D=(0,k.$Hb)(b.map(g=>this.C.get(g)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(b,D){const g=this.C.get(b);if(!g||!g.buttons||!g.buttons.length)return;const f=g.buttons[D];f&&this.N.fire({button:f,item:g})}}class u extends r{constructor(b,D){super(b.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:R.default.Error}):this.z({validationMessage:b.message,severity:b.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new n(w,s)}e.$Cic=S}),define(Ce[340],Ie([1,0,2,4,52,3,8,6,19,128,13,25,55,15,26,16,11]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=void 0;function i(P){return P instanceof I.URI}function n(P,T){return P.scheme===l.Schemas.file&&T.scheme===l.Schemas.file&&w.$k?P.toString()===T.toString():P.toString().toLowerCase()===T.toString().toLowerCase()}function r(P){if(P)return typeof P.iconPath=="string"?I.URI.file(P.iconPath):I.URI.isUri(P.iconPath)||m.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function a(P){if(P.icon){if(I.URI.isUri(P.icon))return P.icon;if(m.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const T=P.icon;return{light:T.light,dark:T.dark}}}else return}function t(P,T){if(!P.iconPath&&!T.iconPath)return 0;if(P.iconPath){if(!T.iconPath)return 1}else return-1;const U=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,z=typeof T.iconPath=="string"?T.iconPath:I.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,k.$Xq)(U,z)}function h(P,T){let U=0;if(P.strikeThrough!==T.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==T.faded)return P.faded?1:-1;if(P.tooltip!==T.tooltip)return(P.tooltip||"").localeCompare(T.tooltip||"");if(U=t(P,T),U!==0)return U;if(P.light&&T.light)U=t(P.light,T.light);else{if(P.light)return 1;if(T.light)return-1}if(U!==0)return U;if(P.dark&&T.dark)U=t(P.dark,T.dark);else{if(P.dark)return 1;if(T.dark)return-1}return U}function c(P,T){if(P.command!==T.command)return P.command<T.command?-1:1;if(P.title!==T.title)return P.title<T.title?-1:1;if(P.tooltip!==T.tooltip){if(P.tooltip!==void 0&&T.tooltip!==void 0)return P.tooltip<T.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(P.arguments===T.arguments)return 0;if(P.arguments)if(T.arguments){if(P.arguments.length!==T.arguments.length)return P.arguments.length-T.arguments.length}else return 1;else return-1;for(let U=0;U<P.arguments.length;U++){const z=P.arguments[U],M=T.arguments[U];if(z!==M&&!(i(z)&&i(M)&&n(z,M)))return z<M?-1:1}return 0}function o(P,T){let U=(0,k.$Xq)(P.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(U!==0)return U;if(P.command&&T.command)U=c(P.command,T.command);else{if(P.command)return 1;if(T.command)return-1}if(U!==0)return U;if(P.decorations&&T.decorations)U=h(P.decorations,T.decorations);else{if(P.decorations)return 1;if(T.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)U=(0,k.$Xq)(P.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)U=(0,k.$Xq)(P.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return U}function u(P,T){for(let U=0;U<P.length;U++)if(P[U]!==T[U])return!1;return!0}function d(P,T){return P.command===T.command&&P.title===T.title&&P.tooltip===T.tooltip&&(P.arguments&&T.arguments?u(P.arguments,T.arguments):P.arguments===T.arguments)}function b(P,T){return(0,p.$ub)(P,T,d)}class D{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,S.$OF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,S.$OF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,S.$OF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,U,z,M,N){this.k=T,this.l=M,this.m=N,this.d="",this.e=new F.$Yd,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=z}showValidationMessage(T,U){(0,S.$OF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,U)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Dic=D;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,U,z,M,N,O,j){this.q=T,this.s=U,this.t=z,this.u=M,this.v=N,this.multiDiffEditorEnableViewChanges=O,this.w=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Yd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Yd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,U){const z=this.h.get(T);return z?(0,A.$3g)(()=>this.s.executeCommand(z.command,...z.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(o),z=(0,p.$Db)(this.o,T,o).map(O=>{const j=O.toInsert.map(Y=>{const ne=this.e++;this.g.set(ne,Y);const ee=Y.resourceUri;let Q;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"||Y.command.command==="vscode.changes"){const ge=new L.$Sc;Q=this.s.converter.toInternal(Y.command,ge),this.j.set(ne,ge)}else this.h.set(ne,Y.command);const X=(0,S.$NF)(this.w,"scmMultiDiffEditor"),ce=X?Y.multiDiffEditorOriginalUri:void 0,ie=X?Y.multiFileDiffEditorModifiedUri:void 0,fe=r(Y.decorations),re=Y.decorations&&r(Y.decorations.light)||fe,J=Y.decorations&&r(Y.decorations.dark)||fe,B=[re,J],ae=Y.decorations&&Y.decorations.tooltip||"",Ee=Y.decorations&&!!Y.decorations.strikeThrough,le=Y.decorations&&!!Y.decorations.faded,de=Y.contextValue||"";return{rawResource:[ne,ee,B,ae,Ee,le,de,Q,ce,ie],handle:ne}});return{start:O.start,deleteCount:O.deleteCount,toInsert:j}}),M=z.map(({start:O,deleteCount:j,toInsert:Y})=>[O,j,Y.map(ne=>ne.rawResource)]),N=z.reverse();for(const{start:O,deleteCount:j,toInsert:Y}of N){const ne=Y.map(Q=>Q.handle),ee=this.n.splice(O,j,...ne);for(const Q of ee)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=T,M}dispose(){this.l=!0,this.m.fire()}}class f{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let U;(0,S.$NF)(this.x,"quickDiffProvider")&&(U=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:U})}get historyProvider(){return(0,S.$OF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,S.$OF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new L.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new L.$Sc,this.o=T;const U=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,S.$OF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,S.$OF)(this.x,"scmActionButton"),this.p.value=new L.$Sc,this.q=T;const U=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(z=>z.map(M=>this.y.converter.toInternal(M,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&b(this.t,T))return;this.s.value=new L.$Sc,this.t=T;const U=(T||[]).map(z=>this.y.converter.toInternal(z,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(T,U,z,M,N,O,j){this.x=T,this.y=M,this.z=N,this.A=O,this.B=j,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Uc,this.m=void 0,this.n=new L.$Uc,this.o=void 0,this.p=new L.$Uc,this.s=new L.$Uc,this.t=void 0,this.u=!1,this.v=new F.$Yd,this.onDidChangeSelection=this.v.event,this.w=f.d++,this.C=new Map,this.D=new Set,this.#e=z;const Y=I.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${N}/scm${this.w}/input`,query:j?`rootUri=${encodeURIComponent(j.toString())}`:void 0});this.f=new D(T,U,this.#e,this.w,Y),this.#e.$registerSourceControl(this.w,N,O,j,Y)}createResourceGroup(T,U,z){const M=(0,S.$NF)(this.x,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,N=new g(this.#e,this.y,this.w,T,U,M,this.x),O=F.Event.once(N.onDidDispose)(()=>this.C.delete(N));return this.C.set(N,O),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const T=[],U=[];for(const[z,M]of this.C){M.dispose();const N=z.onDidUpdateResourceStates(()=>{this.D.add(z),this.eventuallyUpdateResourceStates()});F.Event.once(z.onDidDispose)(()=>{this.D.delete(z),N.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.w,z.handle)}),T.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const O=z._takeResourceStateSnapshot();O.length>0&&U.push([z.handle,O]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.w,T,U),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(U=>{const z=U._takeResourceStateSnapshot();z.length!==0&&T.push([U.handle,z])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,$.$Dh)(100)],f.prototype,"eventuallyAddResourceGroups",null),Je([(0,$.$Dh)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,U,z,M){this.l=U,this.m=z,this.n=M,this.g=new Map,this.h=new C.$sm,this.j=new F.$Yd,this.e=T.getProxy(v.$rL.MainThreadSCM),this.f=T.getProxy(v.$rL.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const O=this.g.get(N.sourceControlHandle);if(!O)return N;const j=O.getResourceGroup(N.groupHandle);return j?j.getResourceState(N.handle):N}else if(N&&N.$mid===4){const O=this.g.get(N.sourceControlHandle);return O?O.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const O=this.g.get(N.handle);return O||N}return N}})}createSourceControl(T,U,z,M){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,U,z,M),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const N=s.d++,O=new f(T,this.m,this.e,this.l,U,z,M);this.g.set(N,O);const j=this.h.get(T.identifier)||[];return j.push(O),this.h.set(T.identifier,j),O}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const U=this.h.get(T.identifier),z=U&&U[U.length-1];return z&&z.inputBox}$provideOriginalResource(T,U,z){const M=I.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",T,M.toString());const N=this.g.get(T);return!N||!N.quickDiffProvider||!N.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$3g)(()=>N.quickDiffProvider.provideOriginalResource(M,z)).then(O=>O||null)}$onInputBoxValueChange(T,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const z=this.g.get(T);return z&&z.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(T,U,z,M){this.n.trace("ExtHostSCM#$executeResourceCommand",T,U,z);const N=this.g.get(T);if(!N)return Promise.resolve(void 0);const O=N.getResourceGroup(U);return O?O.$executeResourceCommand(z,M):Promise.resolve(void 0)}$validateInput(T,U,z){this.n.trace("ExtHostSCM#$validateInput",T);const M=this.g.get(T);return!M||!M.inputBox.validateInput?Promise.resolve(void 0):(0,A.$3g)(()=>M.inputBox.validateInput(U,z)).then(N=>{if(!N)return Promise.resolve(void 0);const O=E.MarkdownString.fromStrict(N.message);return O?Promise.resolve([O,N.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,U,z,M){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,z,M)??void 0}async $provideHistoryItems(T,U,z,M){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(U,z,M))?.map(j=>({...j,icon:a(j)}))??void 0}async $provideHistoryItemSummary(T,U,z,M){const N=this.g.get(T)?.historyProvider;if(typeof N?.provideHistoryItemSummary!="function")return;const O=await N.provideHistoryItemSummary(U,z,M);return O?{...O,icon:a(O)}:void 0}async $provideHistoryItemChanges(T,U,z,M){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(U,z,M)??void 0}};e.$Eic=y,e.$Eic=y=s=Je([We(3,R.$sj)],y)}),define(Ce[341],Ie([1,0,6,15,2]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class L{static{this.a=0}constructor(v,p){this.d=p,this.c=new Map,this.b=v.getProxy(I.$rL.MainThreadShare)}async $provideShare(v,p,k){return await this.c.get(v)?.provideShare({selection:F.Range.to(p.selection),resourceUri:$.URI.revive(p.resourceUri)},k)??void 0}registerShareProvider(v,p){const k=L.a++;return this.c.set(k,p),this.b.$registerShareProvider(k,F.DocumentSelector.from(v,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$Fic=L}),define(Ce[342],Ie([1,0,7,6,218,3,15,18]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$pM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$pM("statusBarItem.warningForeground")]])}#e;#t;constructor(m,E,S,l,w,s=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new L.$Sc,this.#e=m,this.#t=E,w&&l){this.c=(0,I.$5L)(l.identifier,w);const n=S.get(this.c);n&&(s=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=l,this.f=w,this.g=s,this.h=this.u(i)}u(m){if((0,v.$Qf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!p.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new L.$Sc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let E;this.m?E=this.m:E=(0,$.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=p.b.get(this.o.id));const l=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,E,this.k,l,this.r?.internal,S,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Hic=p;class k{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,$.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const E={message:m};return this.b.unshift(E),this.c(),new I.$tL(()=>{const S=this.b.indexOf(E);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(m,E){this.e=new Map,this.a=m.getProxy(F.$rL.MainThreadStatusBar),this.b=E,this.c=new k(this)}$acceptStaticEntries(m){for(const E of m)this.e.set(E.entryId,E)}createStatusBarEntry(m,E,S,l){return new p(this.a,this.b,this.e,m,E,S,l)}setStatusBarMessage(m,E){const S=this.c.setMessage(m);let l;return typeof E=="number"?l=setTimeout(()=>S.dispose(),E):typeof E<"u"&&E.then(()=>S.dispose(),()=>S.dispose()),new I.$tL(()=>{S.dispose(),clearTimeout(l)})}}e.$Iic=R}),define(Ce[151],Ie([1,0,29,141,68,111,89,15,2]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=e.$XN=e.$WN=e.$VN=void 0;const k=(n,r,a,t)=>{let h=r;return{enumerable:!0,configurable:!1,get(){return h},set(c){if(!a(h,c)){const o=h;h=c,n.listener?.(t(c,o))}}}},R=(n,r)=>n===r,C={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.find(t=>a.id===t.id)))},m=n=>r=>({op:4,update:n(r)}),E=(n,r)=>({range:(()=>{let a;const t=m(h=>({range:I.$Zs.lift(v.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return a},set(h){n.listener?.({op:6}),C.range(a,h)||(a=h,n.listener?.(t(h)))}}})(),label:k(n,r,C.label,m(a=>({label:a}))),description:k(n,void 0,C.description,m(a=>({description:a}))),sortText:k(n,void 0,C.sortText,m(a=>({sortText:a}))),canResolveChildren:k(n,!1,C.canResolveChildren,a=>({op:2,state:a})),busy:k(n,!1,C.busy,m(a=>({busy:a}))),error:k(n,void 0,C.error,m(a=>({error:v.MarkdownString.fromStrict(a)||null}))),tags:k(n,[],C.tags,(a,t)=>({op:1,new:a.map(v.TestTag.from),old:t.map(v.TestTag.from)}))}),S=n=>{const r=$.$iK.fromString(n.extId),a=new w(r.controllerId,r.localId,n.label,p.URI.revive(n.uri)||void 0);return a.range=v.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>v.TestTag.to({id:(0,A.$nK)(t).tagId})),a},l=n=>{let r;for(const a of n.tests){const t=S(a.item);(0,F.$FN)(t).parent=r,r=t}return r};e.$VN=l;class w{constructor(r,a,t,h){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const c=(0,F.$EN)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof s?void 0:c.parent}},children:{value:(0,L.$DN)(c,F.$FN,w),enumerable:!0,writable:!1},...E(c,t)})}}e.$WN=w;class s extends w{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.$XN=s;class i extends L.$zN{constructor(r,a,t){super({controllerId:r,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:F.$FN,getChildren:h=>h.children,root:new s(r,a),toITestItem:v.TestItem.from})}}e.$YN=i}),define(Ce[33],Ie([1,0,18,7,15,24,6,19,13,56,29,48,2,3,5,20,151,21,69,44,38,87,90,30]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=void 0;let c=class{#e;#t;#i;constructor(g,f,y){this.b=new Map,this.c=new Map,this.#e=g.getProxy(A.$rL.MainThreadCommands),this.d=f,this.#i=y,this.#t=g.getProxy(A.$rL.MainThreadTelemetry),this.converter=new o(this,P=>{const T=this.c.get(P);return T?.result===d.Void?T:void 0},f),this.f=[{processArgument(P){return(0,k.$Hh)(P)}},{processArgument(P){return(0,L.$Dn)(P,function(T){if(R.$Zs.isIRange(T))return $.Range.to(T);if(C.$Ys.isIPosition(T))return $.Position.to(T);if(R.$Zs.isIRange(T.range)&&m.URI.isUri(T.uri))return $.location.to(T);if(T instanceof s.$me)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const f=this.registerCommand(!1,g.id,async(...y)=>{const P=g.args.map((U,z)=>{if(!U.validate(y[z]))throw new Error(`Invalid argument '${U.name}' when running '${g.id}', received: ${typeof y[z]=="object"?JSON.stringify(y[z],null,"	"):y[z]} `);return U.convert(y[z])}),T=await this.executeCommand(g.internalId,...P);return g.result.convert(T,y,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new F.$tL(()=>{f.dispose(),this.c.delete(g.id)})}registerCommand(g,f,y,P,T,U){if(this.d.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this.b.has(f))throw new Error(`command '${f}' already exists`);return this.b.set(f,{callback:y,thisArg:P,metadata:T,extension:U}),g&&this.#e.$registerCommand(f),new F.$tL(()=>{this.b.delete(f)&&g&&this.#e.$unregisterCommand(f)})}executeCommand(g,...f){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,f,!0)}async g(g,f,y){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,f,!1);{let P=!1;const T=(0,L.$Dn)(f,function(U){if(U instanceof F.$uL)return $.Position.from(U);if(U instanceof F.$vL)return $.Range.from(U);if(U instanceof F.$FL)return $.location.from(U);if(F.$TM.isNotebookRange(U))return $.NotebookRange.from(U);if(U instanceof ArrayBuffer)return P=!0,s.$me.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return P=!0,s.$me.wrap(U);if(U instanceof s.$me)return P=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(g,P?new i.$Yv(T):T,y);return(0,k.$Hh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(g,f,!1);throw U}}}async h(g,f,y){const P=this.b.get(g);if(!P)throw new Error("Unknown command");const{callback:T,thisArg:U,metadata:z}=P;if(z?.args)for(let N=0;N<z.args.length;N++)try{(0,I.$4f)(f[N],z.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${z.args[N].name}' - ${z.args[N].description}`)}const M=r.$Ud.create();try{return await T.apply(U,f)}catch(N){if(g===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...f);O&&(g=O.command)}if(this.d.error(N,g,P.extension?.identifier),!y)throw N;if(P.extension?.identifier){const O=this.#i.onExtensionError(P.extension.identifier,N);this.d.trace("forwarded error to extension?",O,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Vi)(N)),this.id=g,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,g,M.elapsed())}}j(g,f,y){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new a.$Qo(f),duration:y})}$executeContributedCommand(g,...f){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const y=this.b.get(g);return y?(f=f.map(P=>this.f.reduce((T,U)=>U.processArgument(T,y.extension?.identifier),P)),this.h(g,f,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(f=>(g&&(f=f.filter(y=>y[0]!=="_")),f))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[f,y]of this.b){const{metadata:P}=y;P&&(g[f]=P)}return Promise.resolve(g)}};e.$5N=c,e.$5N=c=Je([We(0,l.$JN),We(1,p.$sj),We(2,t.$4N)],c),e.$6N=(0,S.$$h)("IExtHostCommands");class o{constructor(g,f,y){this.d=g,this.f=f,this.g=y,this.delegatingCommandId=`__vsc${(0,h.$ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,f){if(!g)return;const y={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return y;const P=this.f(g.command);if(P)y.id=P.internalId,y.arguments=P.args.map((T,U)=>T.convert(g.arguments&&g.arguments[U]));else if((0,v.$Lb)(g.arguments)){const T=`${g.command} /${++this.c}`;this.b.set(T,g),f.add((0,E.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),y.$ident=T,y.id=this.delegatingCommandId,y.arguments=[T],this.g.trace("CommandsConverter#CREATE",g.command,T)}return y}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const f=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],f?f.command:"MISSING"),f?this.d.executeCommand(f.command,...f.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$7N=o;class u{static{this.Uri=new u("uri","Uri of a text document",g=>m.URI.isUri(g),g=>g)}static{this.Position=new u("position","A position in a text document",g=>F.$uL.isPosition(g),$.Position.from)}static{this.Range=new u("range","A range in a text document",g=>F.$vL.isRange(g),$.Range.from)}static{this.Selection=new u("selection","A selection in a text document",g=>F.$wL.isSelection(g),$.Selection.from)}static{this.Number=new u("number","",g=>typeof g=="number",g=>g)}static{this.String=new u("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=u.Arr(u.String)}static Arr(g){return new u(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,f=>Array.isArray(f)&&f.every(y=>g.validate(y)),f=>f.map(y=>g.convert(y)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",g=>g instanceof F.$QL,$.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",g=>g instanceof F.$aN,$.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",g=>g instanceof w.$WN,$.TestItem.from)}constructor(g,f,y,P){this.name=g,this.description=f,this.validate=y,this.convert=P}optional(){return new u(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,f){return new u(g??this.name,f??this.description,this.validate,this.convert)}}e.$8N=u;class d{static{this.Void=new d("no result",g=>g)}constructor(g,f){this.description=g,this.convert=f}}e.$9N=d;class b{constructor(g,f,y,P,T){this.id=g,this.internalId=f,this.description=y,this.args=P,this.result=T}}e.$0N=b}),define(Ce[343],Ie([1,0,19,16,2,83,131,45,33,15,7]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;const C=[new p.$0N("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new p.$0N("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$8N.Uri],new p.$9N("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,w)=>{if((0,I.$Kb)(l))return;class s extends R.$LL{static to(n){const r=new s(n.name,k.SymbolKind.to(n.kind),n.containerName||"",new R.$FL(w[0],k.Range.to(n.range)));return r.detail=n.detail,r.range=r.location.range,r.selectionRange=k.Range.to(n.selectionRange),r.children=n.children?n.children.map(s.to):[],r}}return l.map(s.to)})),new p.$0N("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$8N.Uri,new p.$8N("options","Formatting options",l=>!0,l=>l)],new p.$9N("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new p.$0N("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$8N.Uri,p.$8N.Range,new p.$8N("options","Formatting options",l=>!0,l=>l)],new p.$9N("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new p.$0N("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$8N.Uri,p.$8N.Position,new p.$8N("ch","Trigger character",l=>typeof l=="string",l=>l),new p.$8N("options","Formatting options",l=>!0,l=>l)],new p.$9N("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new p.$0N("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.$0N("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.$0N("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.$0N("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of Location or LocationLink instances.",S)),new p.$0N("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of Location-instances.",E(k.location.to))),new p.$0N("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new p.$0N("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$8N.Uri,new p.$8N("position","A position in a text document",l=>Array.isArray(l)&&l.every(w=>R.$uL.isPosition(w)),l=>l.map(k.Position.from))],new p.$9N("A promise that resolves to an array of ranges.",l=>l.map(w=>{let s;for(const i of w.reverse())s=new R.$PL(k.Range.to(i),s);return s}))),new p.$0N("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$8N.String.with("query","Search string")],new p.$9N("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(k.WorkspaceSymbol.to))),new p.$0N("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(k.CallHierarchyItem.to))),new p.$0N("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$8N.CallHierarchyItem],new p.$9N("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(k.CallHierarchyIncomingCall.to))),new p.$0N("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$8N.CallHierarchyItem],new p.$9N("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(k.CallHierarchyOutgoingCall.to))),new p.$0N("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:k.Range.to(l.range),placeholder:l.text}})),new p.$0N("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$8N.Uri,p.$8N.Position,p.$8N.String.with("newName","The new symbol name")],new p.$9N("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return k.WorkspaceEdit.to(l)}})),new p.$0N("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$8N.Uri,p.$8N.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$9N("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(k.DocumentLink.to))),new p.$0N("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$8N.Uri],new p.$9N("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new R.$KM(l.tokenTypes,l.tokenModifiers)})),new p.$0N("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$8N.Uri],new p.$9N("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const w=(0,A.$e_)(l);if(w.type==="full")return new R.$MM(w.data,void 0)})),new p.$0N("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$8N.Uri,p.$8N.Range.optional()],new p.$9N("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new R.$KM(l.tokenTypes,l.tokenModifiers)})),new p.$0N("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$8N.Uri,p.$8N.Range],new p.$9N("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const w=(0,A.$e_)(l);if(w.type==="full")return new R.$MM(w.data,void 0)})),new p.$0N("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$8N.Uri,p.$8N.Position,p.$8N.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$8N.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$9N("A promise that resolves to a CompletionList-instance.",(l,w,s)=>{if(!l)return new R.$2L([]);const i=l.suggestions.map(n=>k.CompletionItem.to(n,s));return new R.$2L(i,l.incomplete)})),new p.$0N("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$8N.Uri,p.$8N.Position,p.$8N.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$9N("A promise that resolves to SignatureHelp.",l=>{if(l)return k.SignatureHelp.to(l)})),new p.$0N("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$8N.Uri,p.$8N.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$9N("A promise that resolves to an array of CodeLens-instances.",(l,w,s)=>E(i=>new R.$TL(k.Range.to(i.range),i.command&&s.fromInternal(i.command)))(l))),new p.$0N("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$8N.Uri,new p.$8N("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.$vL.isRange(l),l=>R.$wL.isSelection(l)?k.Selection.from(l):k.Range.from(l)),p.$8N.String.with("kind","Code action kind to return code actions for").optional(),p.$8N.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$9N("A promise that resolves to an array of Command-instances.",(l,w,s)=>E(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new R.$NL(i.title,i.kind?new R.$OL(i.kind):void 0);return i.edit&&(n.edit=k.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(l))),new p.$0N("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$8N.Uri],new p.$9N("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(w=>new R.$8L(k.Range.to(w.range),k.Color.to(w.color))):[])),new p.$0N("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$8N("color","The color to show and insert",l=>l instanceof R.$7L,k.Color.from),new p.$8N("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:k.Range.from(l.range)}))],new p.$9N("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(k.ColorPresentation.to):[])),new p.$0N("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$8N.Uri,p.$8N.Range],new p.$9N("A promise that resolves to an array of Inlay objects",(l,w,s)=>l.map(k.InlayHint.to.bind(void 0,s)))),new p.$0N("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$8N.Uri],new p.$9N("A promise that resolves to an array of FoldingRange objects",(l,w)=>{if(l)return l.map(k.FoldingRange.to)})),new p.$0N("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$9N("A promise that resolves to an array of NotebookContentProvider static info objects.",E(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(w=>k.NotebookExclusiveDocumentPattern.to(w))})))),new p.$0N("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$8N.Uri,p.$8N.Range,new p.$8N("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof R.$vL,l=>k.InlineValueContext.from(l))],new p.$9N("A promise that resolves to an array of InlineValue objects",l=>l.map(k.InlineValue.to))),new p.$0N("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$8N("uriOrString","Uri-instance or string (only http/https)",l=>$.URI.isUri(l)||typeof l=="string"&&(0,F.$jg)(l,F.Schemas.http,F.Schemas.https),l=>l),new p.$8N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[k.ViewColumn.from(l),void 0]:[k.ViewColumn.from(l.viewColumn),k.TextEditorOpenOptions.from(l)])).optional(),p.$8N.String.with("label","").optional()],p.$9N.Void),new p.$0N("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$8N.Uri.with("resource","Resource to open"),p.$8N.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$8N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[k.ViewColumn.from(l),void 0]:[k.ViewColumn.from(l.viewColumn),k.TextEditorOpenOptions.from(l)])).optional()],p.$9N.Void),new p.$0N("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$8N.Uri.with("left","Left-hand side resource of the diff editor"),p.$8N.Uri.with("right","Right-hand side resource of the diff editor"),p.$8N.String.with("title","Human readable title for the diff editor").optional(),new p.$8N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[k.ViewColumn.from(l.viewColumn),k.TextEditorOpenOptions.from(l)]).optional()],p.$9N.Void),new p.$0N("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$8N.String.with("title","Human readable title for the changes editor"),new p.$8N("resourceList","List of resources to compare",l=>{for(const w of l){if(w.length!==3)return!1;const[s,i,n]=w;if(!$.URI.isUri(s)||!$.URI.isUri(i)&&i!==void 0&&i!==null||!$.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},l=>l)],p.$9N.Void),new p.$0N("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$8N.Uri,p.$8N.Position],new p.$9N("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(k.TypeHierarchyItem.to))),new p.$0N("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$8N.TypeHierarchyItem],new p.$9N("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(k.TypeHierarchyItem.to))),new p.$0N("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$8N.TypeHierarchyItem],new p.$9N("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(k.TypeHierarchyItem.to))),new p.$0N("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$8N.TestItem],p.$9N.Void),new p.$0N("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$8N.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$9N.Void),new p.$0N("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$8N.String.with("name","The context key name"),new p.$8N("value","The context key value",()=>!0,l=>l)],p.$9N.Void),new p.$0N("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$8N.Uri,p.$8N.StringArray,new p.$8N("MappedEditsContext","Mapped Edits Context",l=>k.MappedEditsContext.is(l),l=>k.MappedEditsContext.from(l))],new p.$9N("A promise that resolves to a workspace edit or null",l=>l?k.WorkspaceEdit.to(l):null))];class m{static register(w){C.forEach(w.registerApiCommand,w),this.a(w)}static a(w){w.registerCommand(!1,"_validateWhenClauses",v.$0i)}}e.$4gc=m;function E(l){return w=>{if(Array.isArray(w))return w.map(l)}}function S(l){if(!Array.isArray(l))return;const w=[];for(const s of l)L.$Lt(s)?w.push(k.DefinitionLink.to(s)):w.push(k.location.to(s));return w}}),define(Ce[344],Ie([1,0,8,3,2,6,33,15,7]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class k{static{this.a=0}constructor(E,S){this.extension=E,this.provider=S,this.handle=k.a++}}class R{constructor(E){this.session=E,this.responses=[]}}class C{static{this.a=0}constructor(E,S,l,w){this.f=l,this.g=w,this.b=new Map,this.d=new Map,this.e=E.getProxy(L.$rL.MainThreadInlineChat),S.registerApiCommand(new A.$0N("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new A.$8N("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?v.Range.from(s.initialRange):void 0,initialSelection:p.$wL.isSelection(s.initialSelection)?v.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?v.Position.from(s.position):void 0}})],A.$9N.Void))}registerProvider(E,S,l){const w=new k(E,S);return this.b.set(w.handle,w),this.e.$registerInteractiveEditorProvider(w.handle,l?.label??E.displayName??E.name,E.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",l?.supportReportIssue??!1),(0,F.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(w.handle),this.b.delete(w.handle)})}async $prepareSession(E,S,l,w){const s=this.b.get(E);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument($.URI.revive(S)),n=v.Selection.to(l),r=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},w);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=C.a++;return this.d.set(a,new R(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:v.Range.from(r.wholeRange),message:r.message}}async $provideResponse(E,S,l,w){const s=this.b.get(E);if(!s)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:l.prompt,selection:v.Selection.to(l.selection),wholeRange:v.Range.to(l.wholeRange),attempt:l.attempt,live:l.live,previewDocument:this.f.getDocument($.URI.revive(l.previewDocument)),withIntentDetection:l.withIntentDetection};let r=!1;const a={report:async D=>{if(!l.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||w.isCancellationRequested||await this.e.$handleProgressChunk(l.requestId,{message:D.message,edits:D.edits?.map(v.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:p.$UL.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,w));let h;try{h=await(0,I.$Yg)(t,w)}finally{r=!0}if(!h)return;const c=i.responses.push(h)-1,o={wholeRange:v.Range.from(h.wholeRange),placeholder:h.placeholder};if(!C.h(h))return{...o,id:c,type:"editorEdit",message:v.MarkdownString.from(h.contents),edits:[]};const{edits:u,contents:d}=h,b=d!==void 0?v.MarkdownString.from(d):void 0;return u instanceof p.$DL?{...o,id:c,type:"bulkEdit",edits:v.WorkspaceEdit.from(u),message:b}:{...o,id:c,type:"editorEdit",edits:u.map(v.TextEdit.from),message:b}}async $provideFollowups(E,S,l,w){const s=this.b.get(E),i=this.d.get(S),n=i?.responses[l];if(s&&n&&s.provider.provideFollowups){const r=Promise.resolve(s.provider.provideFollowups(i.session,n,w));return(await(0,I.$Yg)(r,w))?.map(v.ChatInlineFollowup.from)}}$handleFeedback(E,S,l,w){const s=this.b.get(E),i=this.d.get(S),n=i?.responses[l];if(s&&n){const r=v.InteractiveEditorResponseFeedbackKind.to(w);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(E,S){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$_hc=C}),define(Ce[345],Ie([1,0,2,33]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class ${constructor(A,v,p,k,R){this.a=v,this.b=p,this.c=k;const C=new F.$0N("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$8N("showOptions","Show Options",m=>!0,m=>m),new F.$8N("resource","Interactive resource Uri",m=>!0,m=>m),new F.$8N("controllerId","Notebook controller Id",m=>!0,m=>m),new F.$8N("title","Interactive editor title",m=>!0,m=>m)],new F.$9N("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const E=this.a.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:I.URI.revive(m.notebookUri),inputUri:I.URI.revive(m.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:I.URI.revive(m.notebookUri),inputUri:I.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(A,v,p,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:v,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(I.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,v){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$mic=$}),define(Ce[346],Ie([1,0,19,8,22,4,3,28,2,25,13,6,33,15,7,112,286,26,69,287]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=e.$uic=void 0;let r=class{constructor(b,D,g,f,y){this.m=D,this.n=g,this.o=f,this.q=y,this.b=new v.$Ac,this.c=new v.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$Yd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(C.$rL.MainThreadNotebookKernels);const P=new m.$0N("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$8N("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const U=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:U}}else if(T&&"notebookEditor"in T){const U=this.n.getIdByEditor(T.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:U}}return T})],m.$9N.Void);this.o.registerApiCommand(P)}createNotebookController(b,D,g,f,y,P){for(const fe of this.j.values())if(fe.controller.id===D&&k.$qm.equals(b.identifier,fe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const T=this.k++,U=this;this.q.trace(`NotebookController[${T}], CREATED by ${b.identifier.value}, ${D}`);const z=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${b.identifier}'`);let M=!1;const N=new L.$Yd,O=new L.$Yd,j={id:u(b.identifier,D),notebookType:g,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:f||b.identifier.value,preloads:P?P.map(E.NotebookRendererScript.from):[]};let Y=y??z,ne,ee;this.a.$addKernel(T,j).catch(fe=>{console.log(fe),M=!0});let Q=0;const X=()=>{if(M)return;const fe=++Q;Promise.resolve().then(()=>{fe===Q&&this.a.$updateKernel(T,j)})},ce=new v.$Ac,ie={get id(){return D},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return j.label},set label(fe){j.label=fe??b.displayName??b.name,X()},get detail(){return j.detail??""},set detail(fe){j.detail=fe,X()},get description(){return j.description??""},set description(fe){j.description=fe,X()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(fe){j.supportedLanguages=fe,X()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){j.supportsExecutionOrder=fe,X()},get rendererScripts(){return j.preloads?j.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(fe){Y=fe??z},get interruptHandler(){return ne},set interruptHandler(fe){ne=fe,j.supportsInterrupt=!!fe,X()},set variableProvider(fe){(0,s.$OF)(b,"notebookVariableProvider"),ee=fe,j.hasVariableProvider=!!fe,fe?.onDidChangeVariables(re=>U.a.$variablesUpdated(re.uri)),X()},get variableProvider(){return ee},createNotebookCellExecution(fe){if(M)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.notebook.uri))throw U.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return U._createNotebookCellExecution(fe,u(b.identifier,this.id))},createNotebookExecution(fe){if((0,s.$OF)(b,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.uri))throw U.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.uri.toString()}`);return U._createNotebookExecution(fe,u(b.identifier,this.id))},dispose:()=>{M||(this.q.trace(`NotebookController[${T}], DISPOSED`),M=!0,this.j.delete(T),N.dispose(),O.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity(fe,re){re===S.NotebookControllerAffinity2.Hidden&&(0,s.$OF)(b,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(T,fe.uri,re)},onDidReceiveMessage:O.event,postMessage(fe,re){return(0,s.$OF)(b,"notebookMessaging"),U.a.$postMessage(T,re&&U.n.getIdByEditor(re),fe)},asWebviewUri(fe){return(0,s.$OF)(b,"notebookMessaging"),(0,l.$1wb)(fe,U.m.remote)}};return this.j.set(T,{extensionId:b.identifier,controller:ie,onDidReceiveMessage:O,onDidChangeSelection:N,associatedNotebooks:ce}),ie}getIdByController(b){for(const[D,g]of this.j)if(g.controller===b)return u(g.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,D){const g=this.g++,f=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(g,D);const y={dispose:()=>{this.f.delete(g),f.a.$removeKernelDetectionTask(g)}};return this.f.set(g,y),y}registerKernelSourceActionProvider(b,D,g){const f=this.i++,y=typeof g.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,P=this;this.h.set(f,g),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,D);let T;return y!==void 0&&(T=g.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(f),P.a.$removeKernelSourceActionProvider(f,f),T?.dispose()}}}async $provideKernelSourceActions(b,D){const g=this.h.get(b);if(g){const f=new A.$Sc;return(await g.provideNotebookKernelSourceActions(D)??[]).map(P=>E.NotebookKernelSourceAction.from(P,this.o.converter,f))}return[]}$acceptNotebookAssociation(b,D,g){const f=this.j.get(b);if(f){const y=this.n.getNotebookDocument(p.URI.revive(D));g?f.associatedNotebooks.set(y.uri,!0):f.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,y.uri.toString(),g),f.onDidChangeSelection.fire({selected:g,notebook:y.apiNotebook})}}async $executeCells(b,D,g){const f=this.j.get(b);if(!f)return;const y=this.n.getNotebookDocument(p.URI.revive(D)),P=[];for(const T of g){const U=y.getCell(T);U&&P.push(U.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,y.uri.toString(),P.length),await f.controller.executeHandler.call(f.controller,P,y.apiNotebook,f.controller)}catch(T){this.q.error(`NotebookController[${b}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(b,D,g){const f=this.j.get(b);if(!f)return;const y=this.n.getNotebookDocument(p.URI.revive(D));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,y.apiNotebook);else for(const P of g){const T=y.getCell(P);T&&this.b.get(T.uri)?.cancel()}if(f.controller.interruptHandler){const P=this.c.get(y.uri);g.length&&Array.isArray(P)&&P.length&&P.forEach(T=>T.dispose())}}async $provideVariables(b,D,g,f,y,P,T){const U=this.j.get(b);if(!U)return;const z=this.n.getNotebookDocument(p.URI.revive(g)),M=U.controller.variableProvider;if(!M)return;let N;if(f!==void 0){if(N=this.s[f],!N)return}else this.s={};const O=y==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,j=M.provideVariables(z.apiNotebook,N,O,P,T);let Y=0;for await(const ne of j){if(T.isCancellationRequested)return;const ee={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:U.extensionId.value};if(this.s[ee.id]=ne.variable,this.a.$receiveVariable(D,ee),Y++>=n.$5fb)return}}$acceptKernelMessageFromRenderer(b,D,g){const f=this.j.get(b);if(!f)return;const y=this.n.getEditorById(D);f.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:g}))}$cellExecutionChanged(b,D,g){const y=this.n.getNotebookDocument(p.URI.revive(b)).getCell(D);if(y){const P=g?E.NotebookCellExecutionState.to(g):S.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution(b,D){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const y=new t(D,f,this.a);this.b.set(f.uri,y);const P=y.onDidChangeState(()=>{y.state===a.Resolved&&(y.dispose(),P.dispose(),this.b.delete(f.uri))});return y.asApiObject()}_createNotebookExecution(b,D){const g=this.n.getNotebookDocument(b.uri),f=b.getCells().find(T=>{const U=g.getCellFromApiCell(T);return U&&this.b.has(U.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const y=new c(D,g,this.a),P=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),P.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[y,P]),y.asApiObject()}};e.$uic=r,e.$uic=r=Je([We(4,R.$sj)],r);var a;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(a||(a={}));class t extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(b,D,g){super(),this.m=D,this.n=g,this.b=t.a++,this.c=new L.$Yd,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new $.$9d),this.h=new o(10,f=>this.s(f)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const D=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new i.$Yv(D))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let D=this.m;if(b&&(D=this.m.notebook.getCellFromApiCell(b)),!D)throw new Error("INVALID cell");return D.handle}y(b){return b.map(D=>{const g=S.$XM.ensureUniqueMimeTypes(D.items,!0);return g===D.items?E.NotebookCellOutput.from(D):E.NotebookCellOutput.from({items:g,id:D.id,metadata:D.metadata})})}async z(b,D,g){const f=this.w(D),y=this.y((0,I.$3b)(b));return this.r({editType:w.CellExecutionUpdateType.Output,cellHandle:f,append:g,outputs:y})}async C(b,D,g){return b=S.$XM.ensureUniqueMimeTypes((0,I.$3b)(b),!0),this.r({editType:w.CellExecutionUpdateType.OutputItems,items:b.map(E.NotebookCellOutputItem.from),outputId:D.id,append:g})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(g){b.j=g,b.s([{editType:w.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(g){if(b.f===a.Resolved||b.f===a.Started)throw new Error("Cannot call start again");b.f=a.Started,b.c.fire(),b.s({editType:w.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,f){if(b.f===a.Resolved)throw new Error("Cannot call resolve twice");b.f=a.Resolved,b.c.fire(),b.h.flush(),b.n.$completeExecution(b.b,new i.$Yv({runEndTime:f,lastRunSuccess:g}))},clearOutput(g){return b.t(),b.z([],g,!1)},appendOutput(g,f){return b.t(),b.z(g,f,!0)},replaceOutput(g,f){return b.t(),b.z(g,f,!1)},appendOutputItems(g,f){return b.t(),b.C(g,f,!0)},replaceOutputItems(g,f){return b.t(),b.C(g,f,!1)}})}}var h;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(h||(h={}));class c extends A.$Tc{static{this.a=0}get state(){return this.f}constructor(b,D,g){super(),this.h=D,this.j=g,this.b=c.a++,this.c=new L.$Yd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new $.$9d),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(b,D){this.f=b,this.g=D,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new F.$vh,this.b=Date.now(),(0,F.$_g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>b.complete())}}function u(d,b){return`${d.value}/${b}`}e.$vic=u}),define(Ce[46],Ie([1,0,4,6,5,2,20,3,7,220,14,264,22,30,265,55,8,15,33]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=e.$Hhc=e.$Ghc=void 0,e.$Ghc=(0,$.$$h)("IExtHostTerminalService");class n{constructor(g,f,y,P){this.l=g,this._id=f,this.m=y,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(U,z=!0){T.q(),T.l.$sendText(T._id,U,z)},show(U){T.q(),T.l.$show(T._id,U)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(g,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??f?.cwd??void 0,env:g.env??void 0,icon:u(g.iconPath)??void 0,color:l.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o(g.location,f?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,f,y,P,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:l.ThemeColor.isThemeColor(T)?T.id:void 0,location:f?.location||this.o(g,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,f){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,f){this.h=Object.freeze({code:g,reason:f})}setDimensions(g,f){return g===this.d&&f===this.g||g===0||f===0?!1:(this.d=g,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(f=>{f!==g&&(this.b=Promise.resolve(g))})}}e.$Hhc=n;class r{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$Yd,this.onProcessData=this.a.event,this.b=new I.$Yd,this.d=new I.$Yd,this.onDidChangeProperty=this.d.event,this.f=new I.$Yd,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,f){this.g.setDimensions?.({columns:g,rows:f})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends v.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,f,y){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new v.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$Yd,this.onDidCloseTerminal=this.H.event,this.I=new I.$Yd,this.onDidOpenTerminal=this.I.event,this.J=new I.$Yd,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$Yd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$Yd,this.onDidChangeTerminalState=this.M.event,this.N=new I.$Yd,this.onDidChangeShell=this.N.event,this.O=new I.$Yd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$Yd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(F.$rL.MainThreadTerminalService),this.y=new S.$$sb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:P=>{const T=U=>{const z=U;return this.W(z.instanceId)?.value};switch(P?.$mid){case 15:return T(P);default:{if(Array.isArray(P))for(let U=0;U<P.length&&P[U].$mid===15;U++)P[U]=T(P[U]);return P}}}}),this.B({dispose:()=>{for(const[P,T]of this.g)T.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,f){const y=new n(this.a,(0,E.$ug)(),g,g.name),P=new r(g.pty);return y.createExtensionTerminal(g.location,f,this.R(g,f).resolvedExtHostIdentifier,u(g.iconPath),d(g.color)).then(T=>{const U=this.S(T,P);this.h[T]=U}),this.f.push(y),y.value}R(g,f){if(f=f||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const y=g.location.parentTerminal;if(y){const P=this.f.find(T=>T.value===y);P&&(f.resolvedExtHostIdentifier=P._id)}}else g.location&&typeof g.location!="object"?f.location=g.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(g,f){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const P=new r(f),T=this.S(g,P);this.h[g]=T}async $acceptActiveTerminalChanged(g){const f=this.b;if(g===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const y=this.W(g);y&&(this.b=y,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,f){const y=this.W(g);y&&this.O.fire({terminal:y.value,data:f})}async $acceptTerminalDimensions(g,f,y){const P=this.W(g);P&&P.setDimensions(f,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(g,f){const y=this.W(g);y&&this.P.fire({terminal:y.value,...f})}async $acceptTerminalMaximumDimensions(g,f,y){this.g.get(g)?.resize(f,y)}async $acceptTerminalTitleChange(g,f){const y=this.W(g);y&&(y.name=f)}async $acceptTerminalClosed(g,f,y){const P=this.Y(this.f,g);if(P!==null){const T=this.f.splice(P,1)[0];T.setExitStatus(f,y),this.H.fire(T.value)}}$acceptTerminalOpened(g,f,y,P){if(f){const z=this.Y(this.f,f);if(z!==null){this.f[z]._id=g,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const T={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},U=new n(this.a,g,T,y);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(g,f){this.W(g)?._setProcessId(f)}async $startExtensionTerminal(g,f){const y=this.W(g);if(!y)return{message:(0,k.localize)(0,null,g)};y.isOpen||await new Promise(T=>{const U=this.onDidOpenTerminal(async z=>{z===y.value&&(U.dispose(),T())})});const P=this.g.get(g);P?P.startSendingEvents(f):this.j[g]={initialDimensions:f}}S(g,f){const y=new v.$Sc;y.add(f.onProcessReady(T=>this.a.$sendProcessReady(g,T.pid,T.cwd,T.windowsPty))),y.add(f.onDidChangeProperty(T=>this.a.$sendProcessProperty(g,T))),this.y.startBuffering(g,f.onProcessData),y.add(f.onProcessExit(T=>this.U(g,T))),this.g.set(g,f);const P=this.j[g];return P&&f instanceof r&&(f.startSendingEvents(P.initialDimensions),delete this.j[g]),y}$acceptProcessAckDataEvent(g,f){this.g.get(g)?.acknowledgeDataEvent(f)}$acceptProcessInput(g,f){this.g.get(g)?.input(f)}$acceptTerminalInteraction(g){const f=this.W(g);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(g,f){this.W(g)?.setSelection(f)}$acceptProcessResize(g,f,y){try{this.g.get(g)?.resize(f,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(g,f){this.g.get(g)?.shutdown(f)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(f=>this.a.$sendProcessProperty(g,{type:"cwd",value:f}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new p.$tL(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,f,y){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,y),this.a.$registerProfileProvider(f,g.identifier.value),new p.$tL(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(g,f,y){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,y),this.a.$registerQuickFixProvider(g,f),new p.$tL(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,f){const y=new m.$9d().token;if(y.isCancellationRequested)return;const P=this.D.get(g);if(!P)return;const T=await P.provideTerminalQuickFixes(f,y);if(T===null||Array.isArray(T)&&T.length===0)return;const U=new v.$Sc;if(this.w.value=U,!Array.isArray(T))return T?s.TerminalQuickFix.from(T,this.Q.converter,U):void 0;const z=[];for(const M of T){const N=s.TerminalQuickFix.from(M,this.Q.converter,U);N&&z.push(N)}return z}async $createContributedProfileTerminal(g,f){const y=new m.$9d().token;let P=await this.C.get(g)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,f);return}this.createTerminalFromOptions(P.options,f)}}async $provideLinks(g,f){const y=this.W(g);if(!y)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const T=new m.$9d;this.G.set(g,T);const U=[],z={terminal:y.value,line:f},M=[];for(const j of this.z)M.push(w.Promises.withAsyncBody(async Y=>{T.token.onCancellationRequested(()=>Y({provider:j,links:[]}));const ne=await j.provideTerminalLinks(z,T.token)||[];T.token.isCancellationRequested||Y({provider:j,links:ne})}));const N=await Promise.all(M);if(T.token.isCancellationRequested)return[];const O=new Map;for(const j of N)j&&j.links.length>0&&U.push(...j.links.map(Y=>{const ne={id:a++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return O.set(ne.id,{provider:j.provider,link:Y}),ne}));return this.F.set(g,O),U}$activateLink(g,f){const y=this.F.get(g)?.get(f);y&&y.provider.handleTerminalLink(y.link)}U(g,f){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const y=this.h[g];y&&(y.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,f)}W(g){return this.X(this.f,g)}X(g,f){const y=this.Y(g,f);return y!==null?g[y]:null}Y(g,f){const y=g.findIndex(P=>P._id===f);return y===-1?null:y}getEnvironmentVariableCollection(g){let f=this.n.get(g.identifier.value);return f||(f=new h,this.$(g.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z(g,f){const y=(0,C.$Rr)(f.map),P=(0,C.$Sr)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(g,f.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(g){g.forEach(f=>{const y=f[0],P=new h(f[1]);this.$(y,P)})}$acceptDefaultProfile(g,f){const y=this.s;this.s=g,this.u=f,y?.path!==g.path&&this.N.fire(g.path)}$(g,f){this.n.set(g,f),f.onDidChangeCollection(()=>{this.Z(g,f)})}};e.$Ihc=t,e.$Ihc=t=Je([We(1,i.$6N),We(2,A.$JN)],t);class h{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$Yd,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const f=this.h(g);let y=this.a.get(f);return y||(y=new c(this,g),this.a.set(f,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(g,f,y,P){this.f(g,{value:f,type:p.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(g,f,y,P){this.f(g,{value:f,type:p.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(g,f,y,P){this.f(g,{value:f,type:p.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(g,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(g,f.scope),P=this.map.get(y),T=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==f.value||P.type!==f.type||P.options?.applyAtProcessCreation!==T.applyAtProcessCreation||P.options?.applyAtShellIntegration!==T.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const U=this.g(g,f.scope),z={variable:g,...f,options:T};this.map.set(U,z),this.d.fire()}}get(g,f){const y=this.g(g,f),P=this.map.get(y);return P?b(P):void 0}g(g,f){const y=this.h(f);return y.length?`${g}:::${y}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const f=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(g)&&f.set(P.variable,b(P));return f}delete(g,f){const y=this.g(g,f);this.map.delete(y),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[f,y]of this.map)y.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(f);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,f){const y=this.h(f),P=this.descriptionMap.get(y);if(!P||P.description!==g){let T;typeof g=="string"?T=g:T=g?.value.split(`

`)[0];const U={description:T,scope:f};this.descriptionMap.set(y,U),this.d.fire()}}getDescription(g){const f=this.h(g);return this.descriptionMap.get(f)?.description}k(g){const f=this.h(g);this.descriptionMap.delete(f)}}class c{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,f){this.b=g,this.d=f,this.a=new I.$Yd}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,f,y){this.b.replace(g,f,y,this.d)}append(g,f,y){this.b.append(g,f,y,this.d)}prepend(g,f,y){this.b.prepend(g,f,y,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,f){this.b.getVariableMap(this.d).forEach((y,P)=>g.call(f,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends t{constructor(g,f){super(!1,g,f)}createTerminal(g,f,y){throw new R.$_}createTerminalFromOptions(g,f){throw new R.$_}};e.$Jhc=o,e.$Jhc=o=Je([We(0,i.$6N),We(1,A.$JN)],o);function u(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function d(D){return l.ThemeColor.isThemeColor(D)?D:void 0}function b(D){const g={...D};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[347],Ie([1,0,8,21,22,4,75,54,3,24,18,30,13,6,20,151,15,7,68,111,89,26]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=e.$Nic=e.$Mic=void 0;let t=class extends p.$Tc{constructor(M,N,O,j){super(),this.w=j,this.f=this.B(new L.$Yd),this.g=new Map,this.s=this.B(new L.$Yd),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(E.$rL.MainThreadTesting),this.m=new y(this.h),this.j=new u(this.h,N),O.registerArgumentProcessor({processArgument:Y=>{switch(Y?.$mid){case 16:{const ne=Y,ee=ne.tests[ne.tests.length-1].item.extId;return this.g.get(i.$iK.root(ee))?.collection.tree.get(ee)?.actual??(0,l.$VN)(Y)}case 18:{const{extId:ne,message:ee}=Y;return{test:this.g.get(i.$iK.root(ne))?.collection.tree.get(ne)?.actual,message:w.TestMessage.to(ee)}}default:return Y}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const Y=await O.executeCommand("_testing.getExplorerSelection"),ne=ee=>{const Q=this.g.get(i.$iK.root(ee));if(Q)return i.$iK.isRoot(ee)?Q.controller:Q.collection.tree.get(ee)?.actual};return{include:Y?.include.map(ne).filter(R.$Uf)||[],exclude:Y?.exclude.map(ne).filter(R.$Uf)||[]}})}createTestController(M,N,O,j){if(this.g.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const Y=new p.$Sc,ne=Y.add(new l.$YN(N,O,this.w));ne.root.label=O;const ee=new Map,Q=new Set,X=this.h,ce={items:ne.root.children,get label(){return O},set label(fe){O=fe,ne.root.label=fe,X.$updateController(N,{label:O})},get refreshHandler(){return j},set refreshHandler(fe){j=fe,X.$updateController(N,{canRefresh:!!fe})},get id(){return N},createRunProfile:(fe,re,J,B,ae,Ee)=>{let le=(0,v.$Yi)(fe);for(;ee.has(le);)le++;return new T(this.h,ee,Q,this.s.event,N,le,fe,re,J,B,ae,Ee)},createTestItem(fe,re,J){return new l.$WN(N,fe,re,J)},createTestRun:(fe,re,J=!0)=>this.j.createTestRun(M,N,ne,fe,re,J),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const re=fe instanceof Array?fe:[fe];this.h.$markTestRetired(re.map(J=>i.$iK.fromExtHostTestItem(J,N).toString()))}},set resolveHandler(fe){ne.resolveHandler=fe},get resolveHandler(){return ne.resolveHandler},dispose:()=>{Y.dispose()}};X.$registerTestController(N,O,!!j),Y.add((0,p.$Rc)(()=>X.$unregisterTestController(N)));const ie={controller:ce,collection:ne,profiles:ee,extension:M,activeProfiles:Q};return this.g.set(N,ie),Y.add((0,p.$Rc)(()=>this.g.delete(N))),Y.add(ne.onDidGenerateDiff(fe=>X.$publishDiff(N,fe.map(r.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.m.checkout()}async runTests(M,N=$.CancellationToken.None){const O=d(M);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.g.get(O.controllerId);if(!j)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(Y=>i.$iK.fromExtHostTestItem(Y,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:U[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:M.exclude?.map(Y=>Y.id)},N)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}async $provideFileCoverage(M,N,O){return await this.j.getCoverageReport(M,N)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(M,N,O,j){return await this.j.getCoverageReport(M,N)?.resolveFileCoverage(O,j)??[]}$configureRunProfile(M,N){this.g.get(M)?.profiles.get(N)?.configureHandler?.()}$setDefaultRunProfiles(M){const N=new Map;for(const[O,j]of Object.entries(M)){const Y=this.g.get(O);if(!Y)continue;const ne=new Map,ee=j.filter(X=>!Y.activeProfiles.has(X)),Q=[...Y.activeProfiles].filter(X=>!j.includes(X));for(const X of ee)ne.set(X,!0),Y.activeProfiles.add(X);for(const X of Q)ne.set(X,!1),Y.activeProfiles.delete(X);ne.size&&N.set(O,ne)}this.s.fire(N)}async $refreshTests(M,N){await this.g.get(M)?.controller.refreshHandler?.(N)}$publishTestResults(M){this.results=Object.freeze(M.map(N=>(0,k.$Cn)(w.TestResults.to(N))).concat(this.results).sort((N,O)=>O.completedAt-N.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,N){const O=this.g.get(i.$iK.fromString(M).controllerId)?.collection;O&&(await O.expand(M,N<0?1/0:N),O.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(N=>r.TestsDiffOp.deserialize({asCanonicalUri:O=>O},N)))}async $runControllerTests(M,N){return Promise.all(M.map(O=>this.y(O,!1,N)))}async $startContinuousRun(M,N){const O=new $.$9d(N),j=await Promise.all(M.map(Y=>this.y(Y,!0,O.token)));return!N.isCancellationRequested&&!j.some(Y=>Y.error)&&await new Promise(Y=>N.onCancellationRequested(Y)),O.dispose(!0),j}async y(M,N,O){const j=this.g.get(M.controllerId);if(!j)return{};const{collection:Y,profiles:ne,extension:ee}=j,Q=ne.get(M.profileId);if(!Q)return{};const X=M.testIds.map(re=>Y.tree.get(re)).filter(R.$Uf),ce=M.excludeExtIds.map(re=>j.collection.tree.get(re)).filter(R.$Uf).filter(re=>X.some(J=>J.fullId.compare(re.fullId)===2));if(!X.length)return{};const ie=new s.$5M(X.some(re=>re.actual instanceof l.$XN)?void 0:X.map(re=>re.actual),ce.map(re=>re.actual),Q,N),fe=(0,r.$kK)(M)&&this.j.prepareForMainThreadTestRun(ie,b.fromInternal(M,j.collection),ee,O);try{return await Q.runHandler(ie,O),{}}catch(re){return{error:String(re)}}finally{fe&&(fe.hasRunningTasks&&!O.isCancellationRequested&&await L.Event.toPromise(fe.onEnd),fe.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$Mic=t,e.$Mic=t=Je([We(0,S.$JN),We(1,m.$sj)],t);const h=1e4;var c;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(c||(c={}));class o extends p.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(M,N,O,j,Y){super(),this.s=M,this.w=N,this.y=O,this.z=j,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Yd),this.m=this.B(new L.$Yd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new $.$9d(Y));const ne=this.B(new I.$kh(()=>this.C(),h));this.B(this.h.token.onCancellationRequested(()=>ne.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(M){const N=this.s.id,O=this.s.controllerId,j=(0,C.$ug)(),Y=this.y,ne=this.m;let ee;const Q=fe=>(re,...J)=>{if(ce){this.z.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.s.isIncluded(re)&&(this.F(re),fe(re,...J))},X=(fe,re)=>{const J=re instanceof Array?re.map(w.TestMessage.from):[w.TestMessage.from(re)];if(fe.uri&&fe.range){const B={range:w.Range.from(fe.range),uri:fe.uri};for(const ae of J)ae.location=ae.location||B}this.w.$appendTestMessagesInRun(N,j,i.$iK.fromExtHostTestItem(fe,O).toString(),J)};let ce=!1;const ie={isPersisted:this.s.isPersisted,token:this.h.token,name:M,get coverageProvider(){return ee?.provider},set coverageProvider(fe){(0,a.$OF)(Y,"testCoverage"),ee=fe&&new D(fe),ne.fire({taskId:j,runId:N,coverage:ee})},enqueued:Q(fe=>{this.w.$updateTestStateInRun(N,j,i.$iK.fromExtHostTestItem(fe,O).toString(),1)}),skipped:Q(fe=>{this.w.$updateTestStateInRun(N,j,i.$iK.fromExtHostTestItem(fe,O).toString(),5)}),started:Q(fe=>{this.w.$updateTestStateInRun(N,j,i.$iK.fromExtHostTestItem(fe,O).toString(),2)}),errored:Q((fe,re,J)=>{X(fe,re),this.w.$updateTestStateInRun(N,j,i.$iK.fromExtHostTestItem(fe,O).toString(),6,J)}),failed:Q((fe,re,J)=>{X(fe,re),this.w.$updateTestStateInRun(N,j,i.$iK.fromExtHostTestItem(fe,O).toString(),4,J)}),passed:Q((fe,re)=>{this.w.$updateTestStateInRun(N,j,i.$iK.fromExtHostTestItem(fe,this.s.controllerId).toString(),3,re)}),appendOutput:(fe,re,J)=>{ce||(J&&(this.s.isIncluded(J)?this.F(J):J=void 0),this.w.$appendOutputToRun(N,j,F.$me.fromString(fe),re&&w.location.from(re),J&&i.$iK.fromExtHostTestItem(J,O).toString()))},end:()=>{ce||(ce=!0,this.w.$finishedTestRunTask(N,j),this.f.delete(j),this.f.size||this.D())}};return this.f.set(j,{run:ie}),this.w.$startedTestRunTask(N,{id:j,name:M,running:!0}),ie}C(){for(const{run:M}of this.f.values())M.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(M){if(!(M instanceof l.$WN))throw new n.$BN(M.id);if(this.g.has(i.$iK.fromExtHostTestItem(M,this.s.controllerId).toString()))return;const N=[],O=this.s.colllection.root;for(;;){const j=w.TestItem.from(M);if(N.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),M===O))break;M=M.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,N)}dispose(){this.D(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(M,N){this.g=M,this.h=N,this.c=new Map,this.f=[]}getCoverageReport(M,N){return this.f.find(O=>O.runId===M)?.coverage.get(N)}prepareForMainThreadTestRun(M,N,O,j){return this.j(M,N,O,j)}cancelRunById(M){for(const N of this.c.values())if(N.id===M){N.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,N,O,j,Y,ne){const ee=this.c.get(j);if(ee)return ee.createRun(Y);const Q=b.fromPublic(N,O,j,ne),X=d(j);this.g.$startedExtensionTestRun({controllerId:N,continuous:!!j.continuous,profile:X&&{group:U[X.kind],id:X.profileId},exclude:j.exclude?.map(ie=>i.$iK.fromExtHostTestItem(ie,O.root.id).toString())??[],id:Q.id,include:j.include?.map(ie=>i.$iK.fromExtHostTestItem(ie,O.root.id).toString())??[O.root.id],persist:ne});const ce=this.j(j,Q,M);return L.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(Q.id),ce.dispose()}),ce.createRun(Y)}j(M,N,O,j){const Y=new o(N,this.g,O,this.h,j);this.c.set(M,Y);let ne;const ee=Y.onDidCoverage(({runId:Q,taskId:X,coverage:ce})=>{ne||(ne={runId:Q,coverage:new Map},this.f.unshift(ne),this.f.length>r.$pK&&this.f.pop()),ne.coverage.set(X,ce),this.g.$signalCoverageAvailable(Q,X,!!ce)});return L.Event.once(Y.onEnd)(()=>{this.c.delete(M),ee.dispose()}),Y}}e.$Nic=u;const d=z=>{if(z.profile){if(!(z.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class b{static fromPublic(M,N,O,j){return new b(M,(0,C.$ug)(),O.include?.map(Y=>i.$iK.fromExtHostTestItem(Y,M).toString())??[M],O.exclude?.map(Y=>i.$iK.fromExtHostTestItem(Y,M).toString())??[],j,N)}static fromInternal(M,N){return new b(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,N)}constructor(M,N,O,j,Y,ne){this.controllerId=M,this.id=N,this.isPersisted=Y,this.colllection=ne,this.c=O.map(ee=>ee+"\0"),this.f=j.map(ee=>ee+"\0")}isIncluded(M){const N=i.$iK.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const O of this.f)if(N===O||N.startsWith(O))return!1;for(const O of this.c)if(N===O||N.startsWith(O))return!0;return!1}}e.$Oic=b;class D{constructor(M){this.provider=M}async provideFileCoverage(M){this.c||(this.c=(async()=>this.provider.provideFileCoverage(M))());try{return(await this.c)?.map(w.TestCoverage.fromFile)??[]}catch(N){throw this.c=void 0,N}}async resolveFileCoverage(M,N){const O=await this.c;let j=O?.[M];return!this.provider||!O||!j?[]:(j.detailedCoverage||(j=O[M]=await this.provider.resolveFileCoverage?.(j,N)??j),j.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(M){this.j=M,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,w.TestItem.toPlain(M.item)),this.c.has(M)||this.f.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.f.delete(M);const N=i.$iK.parentId(M.item.extId);if(N&&this.h.has(N.toString())){this.h.add(M.item.extId);return}this.g.add(M)}getChangeEvent(){const{c:M,f:N,g:O}=this;return{get added(){return[...M].map(j=>j.revived)},get updated(){return[...N].map(j=>j.revived)},get removed(){return[...O].map(j=>j.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends r.$qK{constructor(){super(...arguments),this.s=new L.$Yd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(M){return this.f.get(M)}getMirroredTestDataByReference(M){return this.f.get(M.id)}w(M,N){return{...M,revived:w.TestItem.toPlain(M.item),depth:N?N.depth+1:0,children:new Set}}v(){return new g(this.s)}}class y{constructor(M){this.f=M}checkout(){this.c||(this.c=this.g());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(N=>N.revived)},dispose:(0,A.$db)(()=>{--M.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}g(){const M=new f({asCanonicalUri:N=>N});return this.f.$subscribeToDiffs(),{observers:0,tests:M}}}const P=(z,M,N,O)=>{N?Object.assign(N,O):M.$updateTestRunConfig(z.controllerId,z.profileId,O)};class T{#e;#t;#i;#n;#s;get label(){return this.f}set label(M){M!==this.f&&(this.f=M,P(this,this.#e,this.#n,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,P(this,this.#e,this.#n,{supportsContinuousRun:M}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(M){M!==this.isDefault&&(M?this.#t.add(this.profileId):this.#t.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,P(this,this.#e,this.#n,{tag:M?w.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,P(this,this.#e,this.#n,{hasConfigurationHandler:!!M}))}get onDidChangeDefault(){return L.Event.chain(this.#i,M=>M.map(N=>N.get(this.controllerId)?.get(this.profileId)).filter(R.$Uf))}constructor(M,N,O,j,Y,ne,ee,Q,X,ce=!1,ie=void 0,fe=!1){this.controllerId=Y,this.profileId=ne,this.f=ee,this.kind=Q,this.runHandler=X,this._tag=ie,this.g=fe,this.#e=M,this.#s=N,this.#t=O,this.#i=j,N.set(ne,this);const re=U[Q];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);ce&&O.add(ne),this.#n={profileId:ne,controllerId:Y,tag:ie?w.TestTag.namespace(this.controllerId,ie.id):null,label:ee,group:re,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Pic=T;const U={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Ce[152],Ie([1,0,61,14,121,15,7]),function(me,e,I,F,$,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=e.$RN=e.$QN=void 0;class v{static{this.c=new $.$ON("TextEditorDecorationType")}constructor(m,E,S){const l=v.c.nextId();m.$registerTextEditorDecorationType(E.identifier,l,L.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:l,dispose(){m.$removeTextEditorDecorationType(l)}})}}e.$QN=v;class p{constructor(m,E){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,E){this.k();let S=null;if(m instanceof A.$uL)S=new A.$vL(m,m);else if(m instanceof A.$vL)S=m;else throw new Error("Unrecognized location");this.l(S,E,!1)}insert(m,E){this.k(),this.l(new A.$vL(m,m),E,!0)}delete(m){this.k();let E=null;if(m instanceof A.$vL)E=m;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(m,E,S){const l=this.c.validateRange(m);this.g.push({range:l,text:E,forceMoveMarkers:S})}setEndOfLine(m){if(this.k(),m!==A.EndOfLine.LF&&m!==A.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=m}}class k{constructor(m,E,S,l){this.c=m,this.d=E,this._accept(S),this.e=l;const w=this;this.value={get tabSize(){return w.f},set tabSize(s){w.n(s)},get indentSize(){return w.g},set indentSize(s){w.p(s)},get insertSpaces(){return w.j},set insertSpaces(s){w.s(s)},get cursorStyle(){return w.k},set cursorStyle(s){w.t(s)},get lineNumbers(){return w.l},set lineNumbers(s){w.u(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.originalIndentSize,this.j=m.insertSpaces,this.k=m.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}m(m){if(m==="auto")return"auto";if(typeof m=="number"){const E=Math.floor(m);return E>0?E:null}if(typeof m=="string"){const E=parseInt(m,10);return isNaN(E)?null:E>0?E:null}return null}n(m){const E=this.m(m);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const E=Math.floor(m);return E>0?E:null}if(typeof m=="string"){const E=parseInt(m,10);return isNaN(E)?null:E>0?E:null}return null}p(m){const E=this.o(m);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(m){return m==="auto"?"auto":m==="false"?!1:!!m}s(m){const E=this.q(m);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(m){this.k!==m&&(this.k=m,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}u(m){this.l!==m&&(this.l=m,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const E={};let S=!1;if(typeof m.tabSize<"u"){const l=this.m(m.tabSize);l==="auto"?(S=!0,E.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,S=!0,E.tabSize=l)}if(typeof m.indentSize<"u"){const l=this.o(m.indentSize);l==="tabSize"?(S=!0,E.indentSize=l):typeof l=="number"&&this.h!==l&&(this.g=l,this.h=l,S=!0,E.indentSize=l)}if(typeof m.insertSpaces<"u"){const l=this.q(m.insertSpaces);l==="auto"?(S=!0,E.insertSpaces=l):this.j!==l&&(this.j=l,S=!0,E.insertSpaces=l)}typeof m.cursorStyle<"u"&&this.k!==m.cursorStyle&&(this.k=m.cursorStyle,S=!0,E.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.l!==m.lineNumbers&&(this.l=m.lineNumbers,S=!0,E.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(m,E){E.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(S)})}}e.$RN=k;class R{constructor(m,E,S,l,w,s,i,n){this.id=m,this.j=E,this.k=S,this.g=!1,this.h=new Set,this.c=w,this.d=new k(this.j,this.id,s,S),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return l.value},set document(a){throw new F.$9("document")},get selection(){return r.c&&r.c[0]},set selection(a){if(!(a instanceof A.$wL))throw(0,F.$7)("selection");r.c=[a],r.l()},get selections(){return r.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof A.$wL)))throw(0,F.$7)("selections");r.c=a,r.l()},get visibleRanges(){return r.e},set visibleRanges(a){throw new F.$9("visibleRanges")},get options(){return r.d.value},set options(a){r.g||r.d.assign(a)},get viewColumn(){return r.f},set viewColumn(a){throw new F.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new p(l.value,t);return a(h),r.m(h)},insertSnippet(a,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=r.c.map(o=>L.Range.from(o));else if(t instanceof A.$uL){const{lineNumber:o,column:u}=L.Position.from(t);c=[{startLineNumber:o,startColumn:u,endLineNumber:o,endColumn:u}]}else if(t instanceof A.$vL)c=[L.Range.from(t)];else{c=[];for(const o of t)if(o instanceof A.$vL)c.push(L.Range.from(o));else{const{lineNumber:u,column:d}=L.Position.from(o);c.push({startLineNumber:u,startColumn:d,endLineNumber:u,endColumn:d})}}return E.$tryInsertSnippet(m,l.value.version,a.value,c,h)},setDecorations(a,t){const h=t.length===0;h&&!r.h.has(a.key)||(h?r.h.delete(a.key):r.h.add(a.key),r.n(()=>{if(L.$GN(t))return E.$trySetDecorations(m,a.key,L.$HN(t));{const c=new Array(4*t.length);for(let o=0,u=t.length;o<u;o++){const d=t[o];c[4*o]=d.start.line+1,c[4*o+1]=d.start.character+1,c[4*o+2]=d.end.line+1,c[4*o+3]=d.end.character+1}return E.$trySetDecorationsFast(m,a.key,c)}}))},revealRange(a,t){r.n(()=>E.$tryRevealRange(m,L.Range.from(a),t||A.TextEditorRevealType.Default))},show(a){E.$tryShowEditor(m,L.ViewColumn.from(a))},hide(){E.$tryHideEditor(m)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,I.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,I.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,I.ok)(!this.g),this.f=m}_acceptSelections(m){(0,I.ok)(!this.g),this.c=m}async l(){const m=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const E=m.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const S=E.edits.map(w=>w.range);S.sort((w,s)=>w.end.line===s.end.line?w.end.character===s.end.character?w.start.line===s.start.line?w.start.character-s.start.character:w.start.line-s.start.line:w.end.character-s.end.character:w.end.line-s.end.line);for(let w=0,s=S.length-1;w<s;w++){const i=S[w].end;if(S[w+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=E.edits.map(w=>({range:L.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,l,{setEndOfLine:typeof E.setEndOfLine=="number"?L.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$SN=R}),define(Ce[73],Ie([1,0,61,4,3,2,5,6,149,20,152,15,13,28,16,53,43]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0;class s{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,a){this.h=r,this.i=a,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new F.$Yd,this.e=new F.$Yd,this.f=new F.$Yd,this.g=new F.$Yd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],h=[];if(r.removedDocuments)for(const c of r.removedDocuments){const o=L.URI.revive(c),u=this.c.get(o);u?.unref()&&(this.c.delete(o),a.push(u.value))}if(r.addedDocuments)for(const c of r.addedDocuments){const o=L.URI.revive(c.uri);let u=this.c.get(o);if(u&&o.scheme!==S.Schemas.vscodeNotebookCell&&o.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);u||(u=new s(new p.$MN(this.h.getProxy(v.$rL.MainThreadDocuments),o,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(o,u),t.push(u.value)),u.ref()}if(r.removedEditors)for(const c of r.removedEditors){const o=this.b.get(c);this.b.delete(c),o&&h.push(o)}if(r.addedEditors)for(const c of r.addedEditors){const o=L.URI.revive(c.documentUri);I.ok(this.c.has(o),`document '${o}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const u=this.c.get(o).value,d=new R.$SN(c.id,this.h.getProxy(v.$rL.MainThreadTextEditors),this.i,new w.$V(()=>u.document),c.selections.map(C.Selection.to),c.options,c.visibleRanges.map(b=>C.Range.to(b)),typeof c.editorPosition=="number"?C.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,d)}r.newActiveEditor!==void 0&&(I.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,$.$Oc)(a),(0,$.$Oc)(h),r.removedDocuments&&this.e.fire(a),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return l.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const a=this.b.get(this.a);return r?a:a?.value}allEditors(){return[...this.b.values()]}};e.$TN=i,e.$TN=i=Je([We(0,k.$JN),We(1,m.$sj)],i),e.$UN=(0,A.$$h)("IExtHostDocumentsAndEditors")}),define(Ce[348],Ie([1,0,19,4,6,152,15,7]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class p{constructor(R,C){this.i=C,this.a=new F.$Yd,this.b=new F.$Yd,this.c=new F.$Yd,this.d=new F.$Yd,this.f=new F.$Yd,this.g=new F.$Yd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=R.getProxy($.$rL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(m=>this.g.fire(m)),this.i.onDidChangeActiveTextEditor(m=>this.f.fire(m))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(R){const C=this.i.allEditors();return R?C:C.map(m=>m.value)}async showTextDocument(R,C,m){let E;typeof C=="number"?E={position:A.ViewColumn.from(C),preserveFocus:m}:typeof C=="object"?E={position:A.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?A.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:E={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(R.uri,E),l=S&&this.i.getEditor(S);if(l)return l.value;throw S?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,C){return new L.$QN(this.h,R,C).value}$acceptEditorPropertiesChanged(R,C){const m=this.i.getEditor(R);if(!m)throw new Error("unknown text editor");if(C.options&&m._acceptOptions(C.options),C.selections){const E=C.selections.selections.map(A.Selection.to);m._acceptSelections(E)}if(C.visibleRanges){const E=I.$Hb(C.visibleRanges.map(A.Range.to));m._acceptVisibleRanges(E)}if(C.options&&this.b.fire({textEditor:m.value,options:{...C.options,lineNumbers:A.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const E=v.TextEditorSelectionChangeKind.fromValue(C.selections.source),S=C.selections.selections.map(A.Selection.to);this.a.fire({textEditor:m.value,selections:S,kind:E})}if(C.visibleRanges){const E=I.$Hb(C.visibleRanges.map(A.Range.to));this.c.fire({textEditor:m.value,visibleRanges:E})}}$acceptEditorPositionData(R){for(const C in R){const m=this.i.getEditor(C);if(!m)throw new Error("Unknown text editor");const E=A.ViewColumn.to(R[C]);m.value.viewColumn!==E&&(m._acceptViewColumn(E),this.d.fire({textEditor:m.value,viewColumn:E}))}}getDiffInformation(R){return Promise.resolve(this.h.$getDiffInformation(R))}}e.$_gc=p}),define(Ce[349],Ie([1,0,2,5,6,3,7,15,25,18]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=void 0,e.$Ric=(0,F.$$h)("IExtHostTimeline");class R{constructor(E,S){this.b=new Map,this.c=new Map,this.a=E.getProxy($.$rL.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(l,w)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&p.$qm.equals(w,this.b.get(l.source)?.extension)){const s=l.uri===void 0?void 0:I.URI.revive(l.uri);return this.c.get(l.source)?.get(C(s))?.get(l.handle)}else return;return l}})}async $getTimeline(E,S,l,w){return this.b.get(E)?.provider.provideTimeline(I.URI.revive(S),l,w)}registerTimelineProvider(E,S,l,w){const s=new L.$Sc,i=this.d(S.id,w,s).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const r=this.c;return this.f({...S,scheme:E,onDidChange:void 0,async provideTimeline(a,t,h){t?.resetCache&&(s.clear(),r.get(S.id)?.clear());const c=await S.provideTimeline(a,t,h);if(c==null)return;const o=i(a,t);return{...c,source:S.id,items:c.items.map(o)}},dispose(){for(const a of r.values())a.get(S.id)?.clear();n?.dispose(),s.dispose()}},l)}d(E,S,l){return(w,s)=>{let i;if(s?.cacheResults){let n=this.c.get(E);n===void 0&&(n=new Map,this.c.set(E,n));const r=C(w);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...a}=n,t=`${E}|${n.id??n.timestamp}`;i?.set(t,n);let h,c,o;n.iconPath&&(r instanceof A.$oM?o={id:r.id,color:r.color}:I.URI.isUri(r)?(h=r,c=r):{light:h,dark:c}=r);let u;return A.$UL.isMarkdownString(a.tooltip)?u=v.MarkdownString.from(a.tooltip):(0,k.$Mf)(a.tooltip)?u=a.tooltip:A.$UL.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=v.MarkdownString.from(a.detail)):(0,k.$Mf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=a.detail),{...a,id:a.id??void 0,handle:t,source:E,command:n.command?S.toInternal(n.command,l):void 0,icon:h,iconDark:c,themeIcon:o,tooltip:u,accessibilityInformation:n.accessibilityInformation}}}}f(E,S){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:S}),(0,L.$Rc)(()=>{for(const w of this.c.values())w.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$Sic=R;function C(m){return m?.toString()}}),define(Ce[350],Ie([1,0,221,23,2,4,3,280,8,7,18,19,15,63,22,178,26]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;function s(r,a){if((0,R.$Mf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends A.$Tc{constructor(a,t,h){super(),this.f=a,this.g=t,this.h=h,this.a=new Map,this.b=new l.$48;function c(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>c(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(u=>c(u)?this.r(u):u):o})}registerTreeDataProvider(a,t,h){const c=this.createTreeView(a,{treeDataProvider:t},h);return{dispose:()=>c.dispose()}}createTreeView(a,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,b=this.m(a,t,h),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:o,hasHandleDrag:u,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(a,D),f={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,w.$OF)(h,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,w.$OF)(h,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(y){(0,E.$ok)(y)&&(0,w.$OF)(h,"treeViewMarkdownMessage"),b.message=y},get title(){return b.title},set title(y){b.title=y},get description(){return b.description},set description(y){b.description=y},get badge(){return b.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?b.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(b.badge=void 0)},reveal:(y,P)=>b.reveal(y,P),dispose:async()=>{await g,this.a.delete(a),b.dispose()}};return this.B(f),f}$getChildren(a,t){const h=this.a.get(a);return h?h.getChildren(t):Promise.reject(new v.$hF(a))}async $handleDrop(a,t,h,c,o,u,d,b){const D=this.a.get(a);if(!D)return Promise.reject(new v.$hF(a));const g=m.DataTransfer.toDataTransfer(h,async f=>(await this.f.$resolveDropFileData(a,t,f)).buffer);return d===a&&b&&await this.j(g,D,b,o,u),D.onDrop(g,c,o)}async j(a,t,h,c,o){const u=this.b.removeDragOperationTransfer(o);if(u)(await u)?.forEach((d,b)=>{d&&a.set(b,d)});else if(o&&t.handleDrag){const d=t.handleDrag(h,a,c);this.b.addDragOperationTransfer(o,d),await d}return a}async $handleDrag(a,t,h,c){const o=this.a.get(a);if(!o)return Promise.reject(new v.$hF(a));const u=await this.j(new k.$lM,o,t,c,h);if(!(!u||c.isCancellationRequested))return m.DataTransfer.from(u)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new v.$hF(a);return t.hasResolve}$resolve(a,t,h){const c=this.a.get(a);if(!c)throw new v.$hF(a);return c.resolveTreeItem(t,h)}$setExpanded(a,t,h){const c=this.a.get(a);if(!c)throw new v.$hF(a);c.setExpanded(t,h)}$setSelectionAndFocus(a,t,h){const c=this.a.get(a);if(!c)throw new v.$hF(a);c.setSelectionAndFocus(t,h)}$setVisible(a,t){const h=this.a.get(a);if(!h){if(!t)return;throw new v.$hF(a)}h.setVisible(t)}$changeCheckboxState(a,t){const h=this.a.get(a);if(!h)throw new v.$hF(a);h.setCheckboxState(t)}m(a,t,h){const c=this.B(new n(a,t,this.f,this.g.converter,this.h,h));return this.a.set(a,c),c}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Tic=i;class n extends A.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.$Vf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,h,c,o,u){if(super(),this.I=a,this.J=h,this.L=c,this.M=o,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Yd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Yd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Yd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Yd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Yd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Yd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Yd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$9d,u.contributes&&u.contributes.views)for(const g in u.contributes.views)for(const f of u.contributes.views[g])f.id===a&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let d,b;const D=L.Event.debounce(this.F.event,(g,f)=>(g||(g={message:!1,elements:[]}),f.element!==!1&&(d||(d=new Promise(y=>b=y),this.G=this.G.then(()=>d)),Array.isArray(f.element)?g.elements.push(...f.element):g.elements.push(f.element)),f.message&&(g.message=!0),g),200,!0);this.B(D(({message:g,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const y=b;return d=null,this.$(f).then(()=>y())})),g&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let h=this.X(a);return h||(h=await this.Y(t)),h?h.map(c=>c.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const h=(0,R.$Vf)(t.select)?!0:t.select,c=(0,R.$Vf)(t.focus)?!1:t.focus,o=(0,R.$Vf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(u=>this.W(a,u[u.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:u.map(b=>b.item)},{select:h,focus:c,expand:o})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:h,focus:c,expand:o})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=m.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const h=this.getExtensionElement(a);h&&(t?this.u.fire(Object.freeze({element:h})):this.w.fire(Object.freeze({element:h})))}setSelectionAndFocus(a,t){const h=!(0,C.$ub)(this.s,a);this.s=a;const c=this.t!==t;this.t=t,h&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async h=>{const c=this.getExtensionElement(h.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:h.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(a,t,h){const c=[];for(const o of a){const u=this.getExtensionElement(o);u&&c.push(u)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,h){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,p.$3g)(()=>this.g?.handleDrop?this.g.handleDrop(c,a,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const h=this.j.get(a);if(h){const c=this.m.get(h);if(c){const o=await this.f.resolveTreeItem(c.extensionItem,h,t)??c.extensionItem;return this.hb(o),c.item.tooltip=this.eb(o.tooltip),c.item.command=this.fb(c.disposableStore,o.command),c.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(h=>this.W(t,h[h.length-1]).then(c=>(h.push(c),h))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$3g)(()=>this.f.getParent(a))}W(a,t){const h=this.m.get(a);return h?Promise.resolve(h):(0,p.$3g)(()=>this.f.getTreeItem(a)).then(c=>this.kb(a,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(c);if(o){const u=this.m.get(o);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const h=this.getExtensionElement(a);t=h?this.m.get(h):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$9d(this.Z.token);try{const h=a?this.m.get(a):void 0,c=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const o=(0,C.$Hb)(c||[]),u=await Promise.all((0,C.$Hb)(o).map(b=>this.f.getTreeItem(b)));if(t.token.isCancellationRequested)return;const d=u.map((b,D)=>b?this.db(o[D],b,h):null);return(0,C.$Hb)(d)}finally{t.dispose()}}$(a){if(a.some(h=>!h))return this.Z.dispose(!0),this.Z=new S.$9d,this.tb(),this.J.$refresh(this.I);{const h=this.ab(a);if(h.length)return this.bb(h)}return Promise.resolve(void 0)}ab(a){const t=new Set,h=a.map(o=>this.m.get(o));for(const o of h)if(o&&!t.has(o.item.handle)){let u=o;for(;u&&u.parent&&h.findIndex(d=>u&&u.parent&&d&&d.item.handle===u.parent.item.handle)===-1;){const d=this.j.get(u.parent.item.handle);u=d?this.m.get(d):void 0}u&&!u.parent&&t.add(o.item.handle)}const c=[];return t.forEach(o=>{const u=this.j.get(o);if(u){const d=this.m.get(u);d&&(!d.parent||!t.has(d.parent.item.handle))&&c.push(o)}}),c}bb(a){const t={};return Promise.all(a.map(h=>this.cb(h).then(c=>{c&&(t[h]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const h=this.m.get(t);if(h)return this.rb(t),(0,p.$3g)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const o=this.ib(t,c,h.parent);return this.pb(t,o,h,h.parent),h.dispose(),o}return null})}return Promise.resolve(null)}db(a,t,h){const c=this.ib(a,t,h);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(a,c),this.qb(c,h),c}eb(a){return k.$UL.isMarkdownString(a)?m.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,h,c;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,h=a.checkboxState.tooltip,c=a.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:c}}hb(a){if(!k.$gM.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,h){this.hb(t);const c=this.B(new A.$Sc),o=this.kb(a,t,h),u=this.lb(t);return{item:{handle:o,parentHandle:h?h.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,R.$Vf)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(a){return a.iconPath instanceof k.$oM?a.iconPath:void 0}kb(a,{id:t,label:h,resourceUri:c},o,u){if(t)return`${n.b}/${t}`;const d=s(h,this.N),b=o?o.item.handle:n.a;let D=d?d.label:c?(0,F.$Ig)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const g=this.m.has(a)?this.m.get(a).item.handle:void 0,f=this.X(o)||[];let y,P=0;do{if(y=`${b}/${P}:${D}`,u||!this.j.has(y)||g===y)break;P++}while(P<=f.length);return y}lb(a){if(a.iconPath&&!(a.iconPath instanceof k.$oM))return typeof a.iconPath=="string"||$.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof k.$oM)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return $.URI.isUri(a)?a:$.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,h,c){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==h.item.handle&&this.j.delete(h.item.handle),this.ob(a,t);const o=this.X(c)||[],u=o.filter(d=>d.item.handle===h.item.handle)[0];u&&o.splice(o.indexOf(u),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const h of t.children){const c=this.j.get(h.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const h of t.children){const c=this.j.get(h.item.handle);c&&this.sb(c)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[351],Ie([1,0,4,3,2,30,15,92,6,7]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class R extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(S,l,w,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$Yd),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$Yd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=l,this.#n=w,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,$.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#o=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,l){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:A.ViewColumn.from(S),preserveFocus:!!l})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends F.$Tc{static c(){return(0,L.$ug)()}constructor(S,l,w){super(),this.j=l,this.m=w,this.g=new Map,this.h=new Map,this.f=S.getProxy(p.$rL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,l,w,s,i={}){const n=typeof s=="object"?s.viewColumn:s,r={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,v.$ohc)(S),t=C.c();this.f.$createWebviewPanel((0,v.$qhc)(S),t,l,{title:w,panelOptions:m(i),webviewOptions:(0,v.$rhc)(S,this.m,i),serializeBuffersForPostMessage:a},r);const h=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,l,w,n,i,h,!0)}$onDidChangeWebviewPanelViewStates(S){const l=Object.keys(S);l.sort((w,s)=>{const i=S[w],n=S[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const w of l){const s=this.getWebviewPanel(w);if(!s)continue;const i=S[w];s._updateViewState({active:i.active,visible:i.visible,viewColumn:A.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,l,w){if(this.h.has(l))throw new Error(`Serializer for '${l}' already registered`);return this.h.set(l,{serializer:w,extension:S}),this.f.$registerSerializer(l,{serializeBuffersForPostMessage:(0,v.$ohc)(S)}),new k.$tL(()=>{this.h.delete(l),this.f.$unregisterSerializer(l)})}async $deserializeWebviewPanel(S,l,w,s){const i=this.h.get(l);if(!i)throw new Error(`No serializer found for '${l}'`);const{serializer:n,extension:r}=i,a=this.j.createNewWebview(S,w.webviewOptions,r),t=this.createNewWebviewPanel(S,l,w.title,s,w.panelOptions,a,w.active);await n.deserializeWebviewPanel(t,w.state)}createNewWebviewPanel(S,l,w,s,i,n,r){const a=new R(S,this.f,n,{viewType:l,title:w,viewColumn:s,panelOptions:i,active:r});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$shc=C;function m(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[352],Ie([1,0,4,3,92,15,6,7]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class p extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,m,E,S,l,w){super(),this.#s=!1,this.#u=this.B(new I.$Yd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$Yd),this.onDidDispose=this.#l.event,this.#i=E,this.#a=S,this.#e=C,this.#t=m,this.#n=l,this.#r=w}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class k{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(A.$rL.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,E,S){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:E,extension:C}),this.a.$registerWebviewViewProvider((0,$.$qhc)(C),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,$.$ohc)(C)}),new v.$tL(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,E,S,l){const w=this.b.get(m);if(!w)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:i}=w,n=this.d.createNewWebview(C,{},i),r=new p(C,this.a,m,E,n,!0);this.c.set(C,r),await s.resolveWebviewView(r,{state:S},l)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$Wic=k}),define(Ce[353],Ie([1,0,70,16,13,251,32,11]),function(me,e,I,F,$,L,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=void 0;let p=class{constructor(C,m){C.addFileSystemProvider(F.Schemas.file,new k(m),{isCaseSensitive:v.$k})}};e.$Bjc=p,e.$Bjc=p=Je([We(0,I.$khc),We(1,$.$sj)],p);class k{constructor(C){this.b=C,this.a=new L.$Gq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,E){return this.a.writeFile(C,m,{...E,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,E){return this.a.rename(C,m,E)}copy(C,m,E){return this.a.copy(C,m,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(Ce[354],Ie([1,0,17,64,30,33,3,6,2,20]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;let R=class extends A.$Tc{constructor(m,E){super();const S=m.getProxy(v.$rL.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async l=>{const w=p.URI.file((0,I.$jc)((0,F.tmpdir)(),(0,$.$ug)()));return await S.$download(l,w),w})}};e.$zjc=R,e.$zjc=R=Je([We(0,k.$JN),We(1,L.$6N)],R)}),define(Ce[355],Ie([1,0,57,17,2,93,3,16,8,31]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0;class R extends L.$mhc{constructor(){super(...arguments),this.i=null}async g(t){const h=await super.g(t);if(h.scheme!==v.Schemas.file)return h;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const c=h.fsPath;let o=0;do{let u;o===0?u=c:u=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${o}`:`${c}-${o}`,await C(u);const d=F.$jc(u,"vscode.lock"),b=await l(this.d,d,!1);if(b)return this.i=b,process.on("exit",()=>{b.dispose()}),$.URI.file(u);o++}while(o<10);return h}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Ljc=R;async function C(a){try{await k.Promises.stat(a);return}catch{}try{await k.Promises.mkdir(a,{recursive:!0})}catch{}}const m=1e3,E=10*60*1e3;class S extends A.$Tc{constructor(t,h){super(),this.b=t,this.c=h,this.a=this.B(new p.$jh),this.a.cancelAndSet(async()=>{const c=await w(t,h);(!c||c.pid!==process.pid)&&(t.info(`Lock '${h}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(h,new Date,new Date)}catch(o){t.error(o),t.info(`Lock '${h}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{I.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(h),{flag:"w"})}catch(h){this.b.error(h)}}}async function l(a,t,h){try{const o={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(o),{flag:"wx"})}catch(o){a.error(o)}const c=await w(a,t);return!c||c.pid!==process.pid?h?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function w(a,t){let h;try{h=await k.Promises.readFile(t)}catch(c){return a.error(c),null}try{return JSON.parse(String(h))}catch(c){return a.error(c),null}}async function s(a,t){let h;try{h=await k.Promises.stat(t)}catch(c){return a.error(c),0}return h.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const h=await w(a,t);if(!h)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(h.willReleaseAt){let b=h.willReleaseAt-Date.now();if(b<5e3){for(b>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${b} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);b>0;){if(await(0,p.$_g)(Math.min(100,b)),await s(a,t)===0)return r(a,t);b=h.willReleaseAt-Date.now()}return r(a,t)}}if(!i(h.pid))return a.info(`Lock '${t}': The pid ${h.pid} appears to be gone.`),r(a,t);const c=await s(a,t),o=Date.now()-c;if(o<=E)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$_g)(2e3);const u=await s(a,t),d=Date.now()-u;return d<=E?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return l(a,t,!0)}}),define(Ce[356],Ie([1,0,30,20,46,33]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;let A=class extends $.$Ihc{constructor(p,k){super(!0,p,k)}createTerminal(p,k,R){return this.createTerminalFromOptions({name:p,shellPath:k,shellArgs:R})}createTerminalFromOptions(p,k){const R=new $.$Hhc(this.a,(0,I.$ug)(),p,p.name);return this.f.push(R),R.create(p,this.R(p,k)),R.value}};e.$7ic=A,e.$7ic=A=Je([We(0,L.$6N),We(1,F.$JN)],A)}),define(Ce[357],Ie([1,0,4,37,45,5]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.OutputChannelUpdateMode=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=void 0,e.$CK="text/x-code-output",e.$DK="output",e.$EK="Log",e.$FK="text/x-code-log-output",e.$GK="log",e.$HK="workbench.panel.output",e.$IK=new $.$pj("inOutput",!1),e.$JK=new $.$pj("activeLogOutput",!1),e.$KK=new $.$pj("outputView.scrollLock",!1),e.$LK=(0,L.$$h)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$MK={OutputChannels:"workbench.contributions.outputChannels"};class v{constructor(){this.a=new Map,this.b=new I.$Yd,this.onDidRegisterChannel=this.b.event,this.c=new I.$Yd,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(R=>k.push(R)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}F.$Nn.add(e.$MK.OutputChannels,new v),e.$NK=new $.$pj("activeOutputChannel","")}),define(Ce[153],Ie([1,0,6,5,20,25,13,357,70,27,59,183,21,18,32,4,3]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=void 0;class s extends A.$yj{get disposed(){return this.n}constructor(a,t,h,c,o){super(),this.id=a,this.name=t,this.r=h,this.s=c,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,v.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=m.$me.fromString(t).byteLength,(0,A.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,h,c,o,u){this.i=t,this.j=h,this.k=c,this.l=o,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(I.$rL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Cm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(a,t,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,o=(0,E.$Mf)(t)?t:void 0;if((0,E.$Mf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const d=this.i.environment.extensionLogLevel?.find(([D])=>L.$qm.equals(h.identifier,D))?.[1];d&&(u=(0,A.$Ij)(d));const b=c?this.o(a,u,h):this.n(a,o,h);return b.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(a,u??this.m.getLevel(),b):this.q(a,b)}async n(a,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,o=this.k.extUri.joinPath(c,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(a,o,t,h.identifier.value);return new s(d,a,u,this.a,h)}async o(a,t,h){const c=await this.p(h),o=a.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(c,`${o}.log`),d=`${h.identifier.value}.${o}`,b=this.l.createLogger(u,{id:d,name:a,logLevel:t,extensionId:h.identifier.value});return new i(d,a,b,this.a,h)}p(a){let t=this.d.get(a.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(c){if((0,S.$Lk)(c)!==S.FileSystemProviderErrorCode.FileExists)throw c}return h})())}return t}q(a,t){let h=!1;const c=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return a},append(o){c(),t.then(u=>u.append(o))},appendLine(o){c(),t.then(u=>u.appendLine(o))},clear(){c(),t.then(o=>o.clear())},replace(o){c(),t.then(u=>u.replace(o))},show(o,u){c(),t.then(d=>d.show(o,u))},hide(){c(),t.then(o=>o.hide())},dispose(){h=!0,t.then(o=>o.dispose())}}}r(a,t,h){const c=new w.$Sc,o=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},u=c.add(new l.$Yd);function d(b){t=b,u.fire(b)}return h.then(b=>{c.add(b),b.logLevel!==t&&d(b.logLevel),c.add(b.onDidChangeLogLevel(D=>d(D)))}),{...this.q(a,h),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(b,...D){o(),h.then(g=>g.trace(b,...D))},debug(b,...D){o(),h.then(g=>g.debug(b,...D))},info(b,...D){o(),h.then(g=>g.info(b,...D))},warn(b,...D){o(),h.then(g=>g.warn(b,...D))},error(b,...D){o(),h.then(g=>g.error(b,...D))},dispose(){c.dispose()}}}};e.$xic=n,e.$xic=n=Je([We(0,$.$JN),We(1,k.$ZN),We(2,p.$khc),We(3,R.$Ygc),We(4,A.$tj),We(5,A.$sj)],n),e.$yic=(0,F.$$h)("IExtHostOutputService")}),define(Ce[154],Ie([1,0,5,8]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=void 0,e.$Rm=(0,I.$$h)("remoteAgentService"),e.$Sm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure($){let L=1/0;for(let v=0;v<this.maxSampleCount;v++){const p=await $.getRoundTripTime();if(p===void 0)return;L=Math.min(L,p/2),await(0,F.$_g)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((v,p)=>v+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((v,p)=>v+p,0)/this.average.length,high:typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[358],Ie([1,0,225,86,37,40,51,3,4,154,11,24,8]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=void 0,e.$0H=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$$H=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$_H=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$aI=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$bI={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new p.$Yd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const S=new E;$.$Nn.add(e.$bI.ConfigurationMigration,S);let l=class extends v.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const a of r.added)await this.f(a,S.migrations)})),this.c(S.migrations),this.B(S.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(r=>this.g(r,i?.uri))])}async g(i,n){const r=this.a.inspect(i.key,{resource:n}),a=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,h]of a){const c=r[t];if(!c)continue;const o=[];if(c.value!==void 0){const u=await this.h(i,t,c.value,n,void 0);for(const d of u??[])o.push([d,[]])}for(const{identifiers:u,value:d}of c.overrides??[])if(d!==void 0){const b=await this.h(i,t,d,n,u);for(const D of b??[])o.push([D,u])}o.length&&await Promise.allSettled(o.map(async([[u,d],b])=>this.a.updateValue(u,d.value,{resource:n,overrideIdentifiers:b},h)))}}async h(i,n,r,a,t){const h=o=>{const d=this.a.inspect(o,{resource:a})[n];if(d)return t?d.overrides?.find(({identifiers:b})=>(0,C.$Fn)(b,t))?.value:d.value},c=await i.migrateFn(r,h);return Array.isArray(c)?c:[[i.key,c]]}};e.$cI=l,e.$cI=l=Je([We(0,A.$Ei),We(1,L.$hi)],l);let w=class extends v.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new m.$vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==1)return;$.$Nn.as(F.$Sn.Configuration).registerConfiguration({...e.$_H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$dI=w,e.$dI=w=Je([We(0,k.$Rm)],w)}),define(Ce[359],Ie([1,0,35,16,17,23,234,358,86,5,37]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9db=e.$8db=e.ResolvedStatus=e.RegisteredEditorPriority=e.$7db=e.$6db=void 0,e.$6db=(0,k.$$h)("editorResolverService"),e.$7db="workbench.editorAssociations";const C=R.$Nn.as(p.$Sn.Configuration),m={...v.$$H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var E;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(E||(e.RegisteredEditorPriority=E={}));var S;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function l(s){switch(s){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.$8db=l;function w(s,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf($.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,L.$Ig)(i);return I.$Qj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$9db=w}),define(Ce[360],Ie([1,0,34,16,17,11,23,2,5,269,40,144,154]),function(me,e,I,F,$,L,A,v,p,k,R,C,m){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=void 0,e.$6K=(0,p.$$h)("pathService");let S=E=class{constructor(w,s,i,n){this.d=w,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??w})()}hasValidBasename(w,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(w,n,s)):this.h(w,s,i)}h(w,s,i){return w.scheme===F.Schemas.file||w.scheme===F.Schemas.vscodeRemote?(0,I.$0f)(i??(0,A.$Ig)(w),s===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(w,s){if(w.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,k.$3K)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=s.getWorkspace().configuration;return r?r.scheme:F.Schemas.file}userHome(w){return w?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(w=>w===1?$.$fc:$.$gc)}async fileURI(w){let s="";if(await this.a===1&&(w=w.replace(/\\/g,"/")),w[0]==="/"&&w[1]==="/"){const n=w.indexOf("/",2);n===-1?(s=w.substring(2),w="/"):(s=w.substring(2,n),w=w.substring(n)||"/")}return v.URI.from({scheme:F.Schemas.file,authority:s,path:w,query:"",fragment:""})}};e.$7K=S,e.$7K=S=E=Je([We(1,m.$Rm),We(2,C.$OK),We(3,R.$hi)],S)}),define(Ce[361],Ie([1,0,236,19,52,4,54,3,2,51,241,13,65,271,88,40,144,26,22,18,24,45]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.$YK=e.$XK=e.OnPortForward=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.TunnelSource=e.TunnelCloseReason=e.$RK=e.$QK=e.$PK=void 0;const t=10*1e3,h="remote.tunnels.toRestore",c="remote.tunnels.toRestoreExpiration",o=1e3*60*60*24*14;e.$PK="onTunnel",e.$QK=new a.$pj("forwardedPortsViewEnabled",!1,I.localize(0,null));function u(z){const M=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}e.$RK=u;var d;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var b;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(b||(e.TunnelSource=b={})),e.$SK={source:b.User,description:I.localize(1,null)},e.$TK={source:b.Auto,description:I.localize(2,null)};function D(z,M,N){const O=z.get(f(M,N));if(O)return O;if((0,S.$Kv)(M))for(const j of S.$Jv){const Y=f(j,N);if(z.has(Y))return z.get(Y)}else if((0,S.$Mv)(M))for(const j of S.$Lv){const Y=f(j,N);if(z.has(Y))return z.get(Y)}}e.$UK=D;function g(z,M,N){const O=D(z,M,N);if(O)return O;const j=(0,S.$Mv)(M)?"localhost":(0,S.$Kv)(M)?"0.0.0.0":void 0;if(j)return D(z,j,N)}e.$VK=g;function f(z,M){return z+":"+M}e.$WK=f;var y;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(y||(e.OnPortForward=y={}));function P(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$XK=P;class T extends v.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.r=M,this.j=[],this.n=new L.$Yd,this.onDidChangeAttributes=this.n.event,this.B(M.onDidChangeConfiguration(N=>{(N.affectsConfiguration(T.c)||N.affectsConfiguration(T.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(M,N,O){let j=this.w(M,N,O,this.j,0);const Y={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const ne=this.j[j];ne.key===M?(Y.onAutoForward=ne.onAutoForward??Y.onAutoForward,Y.elevateIfNeeded=ne.elevateIfNeeded!==void 0?ne.elevateIfNeeded:Y.elevateIfNeeded,Y.label=ne.label??Y.label,Y.requireLocalPort=ne.requireLocalPort,Y.protocol=ne.protocol):(Y.onAutoForward=Y.onAutoForward??ne.onAutoForward,Y.elevateIfNeeded=Y.elevateIfNeeded!==void 0?Y.elevateIfNeeded:ne.elevateIfNeeded,Y.label=Y.label??ne.label,Y.requireLocalPort=Y.requireLocalPort!==void 0?Y.requireLocalPort:void 0,Y.protocol=Y.protocol??ne.protocol),j=this.w(M,N,O,this.j,j+1)}return Y.onAutoForward!==void 0||Y.elevateIfNeeded!==void 0||Y.label!==void 0||Y.requireLocalPort!==void 0||Y.protocol!==void 0?Y:this.C()}t(M){return M.start!==void 0&&M.end!==void 0}u(M){return M.host!==void 0&&M.port!==void 0&&(0,n.$Mf)(M.host)&&(0,n.$Qf)(M.port)}w(M,N,O,j,Y){if(Y>=j.length)return-1;const ne=!(0,S.$Kv)(N)&&!(0,S.$Mv)(N),Q=j.slice(Y).findIndex(X=>(0,n.$Qf)(X.key)?ne?!1:X.key===M:this.t(X.key)?ne?!1:M>=X.key.start&&M<=X.key.end:this.u(X.key)?M===X.key.port&&N===X.key.host:O?X.key.test(O):!1);return Q>=0?Q+Y:-1}y(){const M=this.r.getValue(T.c);if(!M||!(0,n.$Of)(M))return[];const N=[];for(const j in M){if(j===void 0)continue;const Y=M[j];let ne;if(Number(j))ne=Number(j);else if((0,n.$Mf)(j))if(T.g.test(j)){const ee=j.match(T.g);ne={start:Number(ee[1]),end:Number(ee[2])}}else if(T.h.test(j)){const ee=j.match(T.h);ne={host:ee[1],port:Number(ee[2])}}else{let ee;try{ee=RegExp(j)}catch{}ee&&(ne=ee)}ne&&N.push({key:ne,elevateIfNeeded:Y.elevateIfNeeded,onAutoForward:Y.onAutoForward,label:Y.label,requireLocalPort:Y.requireLocalPort,protocol:Y.protocol})}const O=this.r.getValue(T.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(N)}z(M){function N(O,j){return(0,n.$Qf)(O.key)?O.key:j.t(O.key)?O.key.start:j.u(O.key)?O.key.port:Number.MAX_VALUE}return M.sort((O,j)=>N(O,this)-N(j,this))}C(){return this.m}static providedActionToAction(M){switch(M){case S.ProvidedOnAutoForward.Notify:return y.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case S.ProvidedOnAutoForward.Silent:return y.Silent;case S.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(M,N,O){const Y=this.r.inspect(T.c).userRemoteValue;let ne;!Y||!(0,n.$Of)(Y)?ne={}:ne=(0,r.$Bn)(Y),ne[`${M}`]||(ne[`${M}`]={});for(const ee in N)ne[`${M}`][ee]=N[ee];return this.r.updateValue(T.c,ne,O)}}e.$YK=T;let U=class extends v.$Tc{constructor(M,N,O,j,Y,ne,ee,Q,X,ce){super(),this.H=M,this.I=N,this.J=O,this.L=j,this.M=Y,this.N=ne,this.O=ee,this.P=Q,this.Q=X,this.R=ce,this.c=new Map,this.g=new L.$Yd,this.onForwardPort=this.g.event,this.h=new L.$Yd,this.onClosePort=this.h.event,this.j=new L.$Yd,this.onPortName=this.j.event,this.n=new L.$Yd,this.onCandidatesChanged=this.n.event,this.t=new L.$Yd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Yd,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new T(O),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ie=>{const fe=await this.getAttributes(ie.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ie)if(re.localAddress){const J=f(re.tunnelRemoteHost,re.tunnelRemotePort),B=g(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(J,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:fe?.get(re.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(re.localAddress,fe?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:re.privacy,source:e.$SK}),this.f.set(J,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ie=>{const fe=f(ie.tunnelRemoteHost,ie.tunnelRemotePort);if(!g(this.forwarded,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&!g(this.detected,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&!g(this.c,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&ie.localAddress){const re=g(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort),J=(await this.getAttributes([{port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost}]))?.get(ie.tunnelRemotePort);this.forwarded.set(fe,{remoteHost:ie.tunnelRemoteHost,remotePort:ie.tunnelRemotePort,localAddress:ie.localAddress,protocol:J?.protocol??S.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,J),localPort:ie.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ie.privacy,source:e.$SK})}await this.cb(),this.f.set(fe,ie),this.g.fire(this.forwarded.get(fe))})),this.B(this.H.onTunnelClosed(ie=>this.W(ie,d.Other))),this.U()}S(){return this.Q.extensions.find(M=>M.activationEvents?.includes(e.$PK))?(this.R.createKey(e.$QK.key,!0),!0):!1}U(){if(this.S())return;const M=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&M.dispose()}))}async W(M,N){const O=f(M.host,M.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.cb(),this.h.fire(M))}X(M,N){if(M.startsWith("http"))return p.URI.parse(M);const O=N?.protocol??"http";return p.URI.parse(`${O}://${M}`)}async Y(M){const N=this.N.getWorkspace(),O=N.configuration?(0,A.$Yi)(N.configuration.path):N.folders.length>0?(0,A.$Yi)(N.folders[0].uri.path):void 0;if(O===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${M}.${this.L.remoteAuthority}.${O}`}async Z(){return this.Y(h)}async $(){return this.Y(c)}async ab(){const M=this.I.get(h,1);if(M)return this.I.remove(h,1),await this.cb(),M;const N=await this.Z();if(N)return this.I.get(N,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const M=await this.s;if(M&&M!==this.y){const N=JSON.parse(M)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${N.map(O=>O.remotePort).join(", ")}`);for(const O of N){const j=g(this.detected,O.remoteHost,O.remotePort);O.source.source!==b.Extension&&!j||O.source.source===b.Extension&&j?await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,elevateIfNeeded:!0,source:O.source}):O.source.source===b.Extension&&!j&&this.D.set(f(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const M=await this.Z();this.w=this.B(new v.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async N=>{N.key===M&&(this.s=Promise.resolve(this.I.get(M,0)),await this.restoreForwarded())}))}}bb(){const M=this.I.keys(0,0).filter(N=>N.startsWith(c));for(const N of M){const O=this.I.getNumber(N,0);if(O&&O<Date.now()){this.s=Promise.resolve(void 0);const j=N.replace(c,h);this.I.remove(N,0),this.I.remove(j,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=Array.from(this.forwarded.values()),N=M.map(ne=>({remoteHost:ne.remoteHost,remotePort:ne.remotePort,localPort:ne.localPort,name:ne.name,localAddress:ne.localAddress,localUri:ne.localUri,protocol:ne.protocol,source:ne.source}));let O;M.length>0&&(O=JSON.stringify(N));const j=await this.Z(),Y=await this.$();!O&&j&&Y?(this.I.remove(j,0),this.I.remove(Y,0)):O!==this.y&&j&&Y&&(this.I.store(j,O,0,0),this.I.store(Y,Date.now()+o,0,0)),this.y=O}}async eb(M,N,O){if(!M.tunnelLocalPort||!O?.requireLocalPort||M.tunnelLocalPort===N)return;const j=new Date;if(this.db.getTime()+t>j.getTime())return;this.db=j;const Y=I.localize(3,null,N,M.tunnelRemotePort,M.tunnelLocalPort);return this.P.info(Y)}async forward(M,N){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.fb(M,N)}async fb(M,N){await this.Q.activateByEvent(e.$PK);const O=g(this.forwarded,M.remote.host,M.remote.port);N=N??(N!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const j=M.local!==void 0?M.local:M.remote.port;let Y;if(O)return this.hb(O,M,N);{const ne=this.L.remoteAuthority,ee=ne?{getAddress:async()=>(await this.M.resolveAuthority(ne)).authority}:void 0,Q=f(M.remote.host,M.remote.port);this.c.set(Q,!0),M=this.gb(Q,M);const X=await this.H.openTunnel(ee,M.remote.host,M.remote.port,void 0,j,M.elevateIfNeeded?M.elevateIfNeeded:N?.elevateIfNeeded,M.privacy,N?.protocol);if(typeof X=="string")Y=X;else if(X&&X.localAddress){const ce=g(this.m??new Map,M.remote.host,M.remote.port),ie=X.protocol?X.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:N?.protocol??S.TunnelProtocol.Http,fe={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:N?.label??M.name,closeable:!0,localAddress:X.localAddress,protocol:ie,localUri:await this.X(X.localAddress,N),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:M.source??e.$SK,privacy:X.privacy};return this.forwarded.set(Q,fe),this.f.set(Q,X),this.c.delete(Q),await this.cb(),await this.eb(X,j,N),this.g.fire(fe),X}this.c.delete(Q)}return Y}gb(M,N){const O=this.D.has(M)?this.D:this.F.has(M)?this.F:void 0;if(O){const j=O.get(M);O.delete(M),j&&(N.name=j.name??N.name,N.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??N.local,N.privacy=N.privacy)}return N}async hb(M,N,O){const j=O?.label??N.name;let Y;(function(ee){ee[ee.None=0]="None",ee[ee.Fire=1]="Fire",ee[ee.Reopen=2]="Reopen"})(Y||(Y={}));let ne=Y.None;switch(j!==M.name&&(M.name=j,ne=Y.Fire),(O?.protocol||M.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==M.protocol&&(N.source=M.source,ne=Y.Reopen),N.privacy&&M.privacy!==N.privacy&&(ne=Y.Reopen),ne){case Y.Fire:{this.g.fire();break}case Y.Reopen:await this.close(M.remoteHost,M.remotePort,d.User),await this.fb(N,O)}return g(this.f,N.remote.host,N.remote.port)}async name(M,N,O){const j=g(this.forwarded,M,N),Y=f(M,N);if(j){j.name=O,await this.cb(),this.j.fire({host:M,port:N});return}else this.detected.has(Y)&&(this.detected.get(Y).name=O,this.j.fire({host:M,port:N}))}async close(M,N,O){const j=f(M,N),Y=this.forwarded.get(j);return O===d.AutoForwardEnd&&Y&&Y.source.source===b.Auto&&this.F.set(j,{local:Y.localPort,name:Y.name,privacy:Y.privacy}),await this.H.closeTunnel(M,N),this.W({host:M,port:N},O)}address(M,N){const O=f(M,N);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(M){if(M)for(const N of M){const O=g(this.m??new Map,N.remoteAddress.host,N.remoteAddress.port),j=typeof N.localAddress=="string"?N.localAddress:f(N.localAddress.host,N.localAddress.port);this.detected.set(f(N.remoteAddress.host,N.remoteAddress.port),{remoteHost:N.remoteAddress.host,remotePort:N.remoteAddress.port,localAddress:j,protocol:S.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:b.Extension,description:I.localize(4,null)}}),this.H.setEnvironmentTunnel(N.remoteAddress.host,N.remoteAddress.port,j,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(M){this.r=M}async setCandidates(M){let N=M;this.r&&(N=await this.r(M));const O=this.ib(N);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(j=>j.port).join(", ")}`),this.n.fire(O)}ib(M){const N=this.m??new Map,O=new Map;return this.m=O,M.forEach(j=>{const Y=f(j.host,j.port);O.set(Y,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),N.has(Y)&&N.delete(Y);const ne=g(this.forwarded,j.host,j.port);ne&&(ne.runningProcess=j.detail,ne.hasRunningProcess=!0,ne.pid=j.pid)}),N.forEach((j,Y)=>{const ne=u(Y);if(!ne)return;const ee=g(this.forwarded,ne.host,ne.port);ee&&(ee.runningProcess=void 0,ee.hasRunningProcess=!1,ee.pid=void 0);const Q=g(this.detected,ne.host,ne.port);Q&&(Q.runningProcess=void 0,Q.hasRunningProcess=!1,Q.pid=void 0)}),N}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const M=Array.from(this.forwarded.values()),N=await this.getAttributes(M.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(N)for(const O of M){const j=N.get(O.remotePort);(j?.protocol||O.protocol!==S.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},j),j&&j.label&&j.label!==O.name&&await this.name(O.remoteHost,O.remotePort,j.label)}}async getAttributes(M,N=!0){const O=new Map,j=new Map;M.forEach(X=>{const ce=g(this.m??new Map,S.$Jv[0],X.port)??X;if(ce){O.set(X.port,ce);const ie=P(ce)?ce.pid:void 0;j.has(ie)||j.set(ie,[]),j.get(ie)?.push(X.port)}});const Y=new Map;if(M.forEach(X=>{const ce=this.configPortsAttributes.getAttributes(X.port,X.host,O.get(X.port)?.detail);ce&&Y.set(X.port,ce)}),this.G.length===0||!N)return Y.size>0?Y:void 0;const ne=await Promise.all((0,F.$Rb)(this.G.map(X=>Array.from(j.entries()).map(ce=>{const ie=ce[1],fe=O.get(ie[0]);return X.providePortAttributes(ie,fe?.pid,fe?.detail,new i.$9d().token)})))),ee=new Map;if(ne.forEach(X=>X.forEach(ce=>{ce&&ee.set(ce.port,ce)})),!Y&&!ee)return;const Q=new Map;return M.forEach(X=>{const ce=Y.get(X.port),ie=ee.get(X.port);Q.set(X.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??T.providedActionToAction(ie?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),Q}addAttributesProvider(M){this.G.push(M)}};e.$ZK=U,Je([(0,$.$Dh)(1e3)],U.prototype,"cb",null),e.$ZK=U=Je([We(0,S.$Fv),We(1,E.$zp),We(2,k.$Ei),We(3,w.$OK),We(4,m.$al),We(5,l.$hi),We(6,C.$sj),We(7,R.$$v),We(8,s.$KF),We(9,a.$qj)],U)}),define(Ce[94],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GJ=e.$FJ=void 0;class I{constructor(A,v){this.line=A,this.character=v}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,v){return new I(0,0)}with(A){return new I(0,0)}}e.$FJ=I;class F{constructor(A,v,p,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(A,v),this.end=new I(p,k)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$GJ=F;var $;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})($||(e.TextSearchCompleteMessageType=$={}))}),define(Ce[36],Ie([1,0,19,35,24,34,12,5,17,14,94,8]),function(me,e,I,F,$,L,A,v,p,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.SearchErrorCode=e.$VJ=e.$UJ=e.SearchSortOrder=e.ViewMode=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.SearchCompletionExitCode=e.$PJ=e.$OJ=e.$NJ=e.QueryType=e.SearchProviderType=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$HJ="workbench.view.search",e.$IJ="workbench.panel.search",e.$JJ="workbench.view.search",e.$KJ="search-result",e.$LJ="search.exclude";const m="\u27EA ",E=" characters skipped \u27EB",S=(m.length+E.length+5)*2;e.$MJ=(0,v.$$h)("searchService");var l;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(l||(e.SearchProviderType=l={}));var w;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(w||(e.QueryType=w={}));function s(X){return!!X.preview}e.$NJ=s;function i(X){return!!X.resource}e.$OJ=i;function n(X){return!!X.message}e.$PJ=n;var r;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(ce){this.resource=ce,this.results=[]}}e.$QJ=a;class t{constructor(ce,ie,fe,re){this.ranges=ie,this.webviewIndex=re;const J=Array.isArray(ie)?ie:[ie];if(fe&&fe.matchLines===1&&h(J)){ce=(0,A.$Ff)(ce,fe.matchLines);let B="",ae=0,Ee=0;const le=Math.floor(fe.charsPerLine/5),de=[];for(const ue of J){const ge=Math.max(ue.startColumn-le,0),V=ue.startColumn+fe.charsPerLine;if(ge>Ee+le+S){const Z=m+(ge-Ee)+E;B+=Z+ce.slice(ge,V),ae+=ge-(Ee+Z.length)}else B+=ce.slice(Ee,V);de.push(new o(0,ue.startColumn-ae,ue.endColumn-ae)),Ee=V}this.preview={text:B,matches:Array.isArray(this.ranges)?de:de[0]}}else{const B=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ce,matches:(0,I.$2b)(ie,ae=>new c(ae.startLineNumber-B,ae.startColumn,ae.endLineNumber-B,ae.endColumn))}}}}e.$RJ=t;function h(X){const ce=X[0].startLineNumber;for(const ie of X)if(ie.startLineNumber!==ce||ie.endLineNumber!==ce)return!1;return!0}class c{constructor(ce,ie,fe,re){this.startLineNumber=ce,this.startColumn=ie,this.endLineNumber=fe,this.endColumn=re}}e.$SJ=c;class o extends c{constructor(ce,ie,fe){super(ce,ie,ce,fe)}}e.$TJ=o;var u;(function(X){X.List="list",X.Tree="tree"})(u||(e.ViewMode=u={}));var d;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function b(X,ce=!0){const ie=X&&X.files&&X.files.exclude,fe=ce&&X&&X.search&&X.search.exclude;if(!ie&&!fe)return;if(!ie||!fe)return ie||fe;let re=Object.create(null);return re=$.$En(re,$.$Bn(ie)),re=$.$En(re,$.$Bn(fe),!0),re}e.$UJ=b;function D(X,ce){return X.excludePattern&&F.$Qj(X.excludePattern,ce)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&F.$Qj(X.includePattern,ce)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(ie=>{const fe=ie.folder.fsPath;if(L.$_f(ce,fe)){const re=p.$lc(fe,ce);return!ie.includePattern||!!F.$Qj(ie.includePattern,re)}else return!1}):!1:!0}e.$VJ=D;var g;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class f extends Error{constructor(ce,ie){super(ce),this.code=ie}}e.$WJ=f;function y(X){const ce=X.message;if((0,k.$4)(X))return new f(ce,g.canceled);try{const ie=JSON.parse(ce);return new f(ie.message,ie.code)}catch{return new f(ce,g.other)}}e.$XJ=y;function P(X){const ce={message:X.message,code:X.code};return new Error(JSON.stringify(ce))}e.$YJ=P;function T(X){return X.type==="error"?!0:X.type==="success"}e.$ZJ=T;function U(X){return X.type==="success"}e.$1J=U;function z(X){return!!X.path}e.$2J=z;function M(X,ce,ie=!0){const fe=X.searchPath?X.searchPath:X.relativePath;return ie?(0,A.$Cf)(fe,ce):F.$Qj(ce,fe)}e.$3J=M;class N{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$4J=N;function O(X,ce){const ie={...X||{},...ce||{}};return Object.keys(ie).filter(fe=>{const re=ie[fe];return typeof re=="boolean"&&re})}e.$5J=O;class j{constructor(ce,ie){this.c=null,this.a={...ce.excludePattern||{},...ie.excludePattern||{}},this.b=F.$Rj(this.a);let fe=ce.includePattern;ie.includePattern&&(fe?fe={...fe,...ie.includePattern}:fe=ie.includePattern),fe&&(this.c=F.$Rj(fe))}matchesExcludesSync(ce,ie,fe){return!!(this.b&&this.b(ce,ie,fe))}includedInQuerySync(ce,ie,fe){return!(this.b&&this.b(ce,ie,fe)||this.c&&!this.c(ce,ie,fe))}includedInQuery(ce,ie,fe){const re=this.b(ce,ie,fe),J=()=>this.c?!!this.c(ce,ie,fe):!0;return(0,C.$Wg)(re)?re.then(B=>B?!1:J()):J()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$6J=j;function Y(X){for(const ce in X)if(typeof X[ce]!="boolean")return!0;return!1}function ne(X){if(!X)return;let ce;return ie=>(ce||(ce=(X()||Promise.resolve([])).then(fe=>fe?Q(fe):{})),ce.then(fe=>!!fe[ie]))}e.$7J=ne;function ee(X){if(!X)return;let ce;return ie=>{if(!ce){const fe=X();ce=fe?Q(fe):{}}return!!ce[ie]}}e.$8J=ee;function Q(X){const ce={};for(const ie of X)ce[ie]=!0;return ce}}),define(Ce[41],Ie([1,0,19,8,22,4,3,78,16,122,23,12,2,223,5,13,254,40,59,27,20,15,7,67,36,6,56]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;function d(U,z,M){return new R.$Ag(N=>f(N,M)).isEqual(U,z)}function b(U,z,M){return d(U.uri,z.uri,M)?0:(0,C.$9e)(U.uri.toString(),z.uri.toString())}function D(U,z,M){return U.index!==z.index?U.index<z.index?-1:1:d(U.uri,z.uri,M)?(0,C.$9e)(U.name,z.name):(0,C.$9e)(U.uri.toString(),z.uri.toString())}function g(U,z,M,N){const O=U.slice(0).sort((Y,ne)=>M(Y,ne,N)),j=z.slice(0).sort((Y,ne)=>M(Y,ne,N));return(0,I.$Eb)(O,j,(Y,ne)=>M(Y,ne,N))}function f(U,z){const M=z.getCapabilities(U.scheme);return!(M&&M&1024)}class y extends s.$ri{static toExtHostWorkspace(z,M,N,O){if(!z)return{workspace:null,added:[],removed:[]};const{id:j,name:Y,folders:ne,configuration:ee,transient:Q,isUntitled:X}=z,ce=[],ie=M;M?ne.forEach((B,ae)=>{const Ee=m.URI.revive(B.uri),le=y.o(N||M,Ee,O);le?(le.name=B.name,le.index=B.index,ce.push(le)):ce.push({uri:Ee,name:B.name,index:ae})}):ce.push(...ne.map(({uri:B,name:ae,index:Ee})=>({uri:m.URI.revive(B),name:ae,index:Ee}))),ce.sort((B,ae)=>B.index<ae.index?-1:1);const fe=new y(j,Y,ce,!!Q,ee?m.URI.revive(ee):null,!!X,B=>f(B,O)),{added:re,removed:J}=g(ie?ie.workspaceFolders:[],fe.workspaceFolders,b,O);return{workspace:fe,added:re,removed:J}}static o(z,M,N){for(let O=0;O<z.folders.length;O++){const j=z.workspaceFolders[O];if(d(j.uri,M,N))return j}}constructor(z,M,N,O,j,Y,ne){super(z,N.map(ee=>new s.$si(ee)),O,j,ne),this.t=M,this.u=Y,this.q=[],this.s=v.$ei.forUris(ne),N.forEach(ee=>{this.q.push(ee),this.s.set(ee.uri,ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,M){return M&&this.s.get(z)&&(z=(0,R.$Kg)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let P=class{constructor(z,M,N,O,j){this.c=new L.$Yd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Yd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new L.$1d,this.C=new Map,this.h=O,this.s=N,this.t=j,this.j=new k.$bm,this.k=new F.$0g,this.o=z.getProxy(o.$rL.MainThreadWorkspace),this.q=z.getProxy(o.$rL.MainThreadMessageService);const Y=M.workspace;this.l=Y?new y(Y.id,Y.name,[],!!Y.transient,Y.configuration?m.URI.revive(Y.configuration):null,!!Y.isUntitled,ne=>f(ne,N)):void 0}$initializeWorkspace(z,M){this.v=M,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:p.Schemas.untitled,path:(0,R.$Ig)((0,R.$Kg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,M,N,...O){const j=[];if(Array.isArray(O)&&O.forEach(X=>{m.URI.isUri(X.uri)&&!j.some(ce=>d(ce.uri,X.uri,this.s))&&j.push({uri:X.uri,name:X.name||(0,R.$Hg)(X.uri)})}),this.n||[M,N].some(X=>typeof X!="number"||X<0)||N===0&&j.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(M+N>Y.length)return!1;const ne=Y.slice(0);ne.splice(M,N,...j.map(X=>({uri:X.uri,name:X.name||(0,R.$Hg)(X.uri),index:void 0})));for(let X=0;X<ne.length;X++){const ce=ne[X];if(ne.some((ie,fe)=>fe!==X&&d(ce.uri,ie.uri,this.s)))return!1}ne.forEach((X,ce)=>X.index=ce);const{added:ee,removed:Q}=g(Y,ne,D,this.s);if(ee.length===0&&Q.length===0)return!1;if(this.o){const X=z.displayName||z.name;this.o.$updateWorkspaceFolders(X,M,N,j).then(void 0,ce=>{this.n=void 0;const ie={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(w.Severity.Error,(0,E.localize)(0,null,X,ce.toString()),ie,[])})}return this.y(ne),!0}getWorkspaceFolder(z,M){if(this.x)return this.x.getWorkspaceFolder(z,M)}async getWorkspaceFolder2(z,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,M)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,M){let N,O="";if(typeof z=="string"?(N=m.URI.file(z),O=z):typeof z<"u"&&(N=z,O=z.fsPath),!N)return O;const j=this.getWorkspaceFolder(N,!0);if(!j)return O;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let Y=(0,R.$Ng)(j.uri,N);return M&&j.name&&(Y=`${j.name}/${Y}`),Y}y(z){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:M,added:N,removed:O}=y.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:O}))}findFiles(z,M,N,O,j=$.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let Y="",ne=!0;return M===null?ne=!1:M!==void 0&&(typeof M=="string"?Y=M:Y=M.pattern),this.z(z,void 0,{exclude:Y,maxResults:N,useDefaultExcludes:ne,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},j)}findFiles2(z,M={},N,O=$.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,z,M,O)}async z(z,M,N,O=$.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const j=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,Y={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:j,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let ne;if(z){const{includePattern:ee,folder:Q}=T(a.GlobPattern.from(z));ne=Q,Y.includePattern=ee}else{const{includePattern:ee,folder:Q}=T(a.GlobPattern.from(M));ne=Q,Y.filePattern=ee}return this.o.$startFileSearch(ne??null,Y,O).then(ee=>Array.isArray(ee)?ee.map(Q=>m.URI.revive(Q)):[])}async findTextInFiles(z,M,N,O,j=$.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),ne=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:ee,folder:Q}=T(a.GlobPattern.from(M.include)),X=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,ce={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:ne,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:ee,excludePattern:X},ie=!1;if(this.u[Y]=fe=>{if(ie)return;const re=m.URI.revive(fe.resource);fe.results.forEach(J=>{const B=(0,u.$Hh)(J);(0,c.$NJ)(B)?N({uri:re,preview:{text:B.preview.text,matches:(0,I.$2b)(B.preview.matches,ae=>new t.$vL(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))},ranges:(0,I.$2b)(B.ranges,ae=>new t.$vL(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))}):N({uri:re,text:B.text,lineNumber:B.lineNumber})})},j.isCancellationRequested)return{};try{const fe=await this.o.$startTextSearch(z,Q??null,ce,Y,j);return delete this.u[Y],fe||{}}catch(fe){throw delete this.u[Y],fe}}$handleTextSearchResult(z,M){this.u[M]?.(z)}async save(z){const M=await this.o.$save(z,{saveAs:!1});return m.URI.revive(M)}async saveAs(z){const M=await this.o.$save(z,{saveAs:!0});return m.URI.revive(M)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,M){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,M);const N=this.t.transformOutgoingScheme(z),O=this.A++;return this.o.$registerEditSessionIdentityProvider(O,N),(0,A.$Rc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(z,M){this.h.info("Getting edit session identifier for workspaceFolder",z);const N=await this.resolveWorkspaceFolder(m.URI.revive(z));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const O=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!O),!O)return;const j=await O.provideEditSessionIdentity(N,M);if(this.h.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(z,M,N,O){this.h.info("Getting edit session identifier for workspaceFolder",z);const j=await this.resolveWorkspaceFolder(m.URI.revive(z));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const Y=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!Y),!Y)return;const ne=await Y.provideEditSessionIdentityMatch?.(M,N,O);if(this.h.info("Provider returned edit session identifier match result: ",ne),!!ne)return ne}getOnWillCreateEditSessionIdentityEvent(z){return(M,N,O)=>{const j=function(ne){M.call(N,ne)};return j.extension=z,this.B.event(j,void 0,O)}}async $onWillCreateEditSessionIdentity(z,M,N){const O=await this.resolveWorkspaceFolder(m.URI.revive(z));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:O},M,async(j,Y)=>{const ne=Date.now();await Promise.resolve(j),Date.now()-ne>N&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(z,M){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,M);const N=this.t.transformOutgoingScheme(z),O=this.A++;return this.o.$registerCanonicalUriProvider(O,N),(0,A.$Rc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(z,M,N){const O=this.C.get(z.scheme);if(!O)return;const j=await O.provideCanonicalUri?.(m.URI.revive(z),M,N);if(j)return j}async $provideCanonicalUri(z,M,N){return this.provideCanonicalUri(m.URI.revive(z),{targetScheme:M},N)}};e.$ehc=P,e.$ehc=P=Je([We(0,r.$JN),We(1,n.$ZN),We(2,i.$Ygc),We(3,l.$sj),We(4,h.$chc)],P),e.$fhc=(0,S.$$h)("IExtHostWorkspace");function T(U){let z,M;return U&&(typeof U=="string"?z=U:(z=U.pattern,M=m.URI.revive(U.baseUri))),{includePattern:z,folder:M}}}),define(Ce[42],Ie([1,0,24,4,41,6,7,256,86,18,8,5,20,13,2]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=e.$hhc=e.$ghc=void 0;function l(h,c){if(c){const o=c.split(".");let u=h;for(let d=0;u&&d<o.length;d++)u=u[o[d]];return u}}function w(h){return h instanceof S.URI}function s(h){return h&&h.uri instanceof S.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function n(h){return h&&h.uri instanceof S.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function r(h){if(w(h))return{resource:h};if(s(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(n(h))return{resource:h.uri};if(h===null)return{resource:null}}let a=class{constructor(c,o,u){this.a=c.getProxy(L.$rL.MainThreadConfiguration),this.c=o,this.b=u,this.d=new R.$0g,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,o){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(c,o))}};e.$ghc=a,e.$ghc=a=Je([We(0,m.$JN),We(1,$.$fhc),We(2,E.$sj)],a);class t{constructor(c,o,u,d){this.a=new F.$Yd,this.b=c,this.f=d,this.c=o,this.e=v.$_n.parse(u),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,o){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=v.$_n.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(o,u))}getConfiguration(c,o,u){const d=r(o)||{},b=this.g(c?l(this.e.getValue(void 0,d,this.c.workspace),c):this.e.getValue(void 0,d,this.c.workspace));c&&this.h(c,d,u?.identifier);function D(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(f){return typeof l(b,f)<"u"},get:(f,y)=>{this.h(c?`${c}.${f}`:f,d,u?.identifier);let P=l(b,f);if(typeof P>"u")P=y;else{let T;const U=(z,M)=>{if((0,k.$Of)(z)){let N;const O=()=>{T=T||(0,I.$Bn)(b),N=N||l(T,M)};return new Proxy(z,{get:(j,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return O(),()=>N;if(T)return N=N||l(T,M),N[Y];const ne=j[Y];return typeof Y=="string"?U(ne,`${M}.${Y}`):ne},set:(j,Y,ne)=>(O(),N&&(N[Y]=ne),!0),deleteProperty:(j,Y)=>(O(),N&&delete N[Y],!0),defineProperty:(j,Y,ne)=>(O(),N&&Object.defineProperty(N,Y,ne),!0)})}return Array.isArray(z)?(0,I.$Bn)(z):z};P=U(P,f)}return P},update:(f,y,P,T)=>{f=c?`${c}.${f}`:f;const U=D(P);return y!==void 0?this.b.$updateConfigurationOption(U,f,y,d,T):this.b.$removeConfigurationOption(U,f,d,T)},inspect:f=>{f=c?`${c}.${f}`:f;const y=this.e.inspect(f,d,this.c.workspace);if(y)return{key:f,defaultValue:(0,I.$Bn)(y.policy?.value??y.default?.value),globalValue:(0,I.$Bn)(y.user?.value??y.application?.value),workspaceValue:(0,I.$Bn)(y.workspace?.value),workspaceFolderValue:(0,I.$Bn)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$Bn)(y.default?.override),globalLanguageValue:(0,I.$Bn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$Bn)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$Bn)(y.workspaceFolder?.override),languageIds:(0,I.$Bn)(y.overrideIdentifiers)}}};return typeof b=="object"&&(0,I.$En)(g,b,!1),Object.freeze(g)}g(c){const o=u=>(0,k.$Of)(u)?new Proxy(u,{get:(d,b)=>o(d[b]),set:(d,b,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(d,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(d,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return o(c)}h(c,o,u){const d=p.$3n.test(c)?4:this.d.get(c),b=u?`[${u.value}] `:"";if(d===4){typeof o?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,o){const u=new v.$bo(c,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,b)=>u.affectsConfiguration(d,r(b))})}k(c){return c.reduce((o,u)=>(o.set(u[0],u[1]),o),new Map)}}e.$hhc=t,e.$ihc=(0,C.$$h)("IExtHostConfiguration")}),define(Ce[95],Ie([1,0,2,8,4,6,7,41,73,42,22,46,20,27,5,16,11,13,91,298,14]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=e.$Kic=e.$Jic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(U){function z(N){if(N!=null)return N}U.from=z;function M(N){if(N!=null)return N}U.to=M})(a||(a={}));var t;(function(U){function z(N){if(N!=null)return N}U.from=z;function M(N){if(N!=null)return N}U.to=M})(t||(t={}));var h;(function(U){function z(N){if(N!=null)return N}U.from=z;function M(N){if(N!=null)return N}U.to=M})(h||(h={}));var c;(function(U){function z(O){if(O){const j=O;return j&&!!j.process}else return!1}U.is=z;function M(O){if(O==null)return;const j={process:O.process,args:O.args};return O.options&&(j.options=h.from(O.options)),j}U.from=M;function N(O){if(O!=null)return new A.$cM(O.process,O.args,O.options)}U.to=N})(c||(c={}));var o;(function(U){function z(N){if(N!=null)return N}U.from=z;function M(N){if(N!=null)return N}U.to=M})(o||(o={}));var u;(function(U){function z(O){if(O){const j=O;return j&&(!!j.commandLine||!!j.command)}else return!1}U.is=z;function M(O){if(O==null)return;const j={};return O.commandLine!==void 0?j.commandLine=O.commandLine:(j.command=O.command,j.args=O.args),O.options&&(j.options=o.from(O.options)),j}U.from=M;function N(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$dM(O.commandLine,O.options):new A.$dM(O.command,O.args?O.args:[],O.options)}U.to=N})(u||(u={}));var d;(function(U){function z(O){if(O){const j=O;return j&&j.customExecution==="customExecution"}else return!1}U.is=z;function M(O){return{customExecution:"customExecution"}}U.from=M;function N(O,j){return j.get(O)}U.to=N})(d||(e.CustomExecutionDTO=d={}));var b;(function(U){function z(M,N){let O;return M.scope!==void 0&&typeof M.scope!="number"?O=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===A.TaskScope.Workspace&&N&&N.workspaceFile?O=N.workspaceFile:O=n.$HG),{id:M._id,workspaceFolder:O}}U.from=z})(b||(e.TaskHandleDTO=b={}));var D;(function(U){function z(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}U.from=z})(D||(D={}));var g;(function(U){function z(O,j){if(O==null)return[];const Y=[];for(const ne of O){const ee=M(ne,j);ee&&Y.push(ee)}return Y}U.fromMany=z;function M(O,j){if(O==null)return;let Y;O.execution instanceof A.$cM?Y=c.from(O.execution):O.execution instanceof A.$dM?Y=u.from(O.execution):O.execution&&O.execution instanceof A.$eM&&(Y=d.from(O.execution));const ne=a.from(O.definition);let ee;return O.scope?typeof O.scope=="number"?ee=O.scope:ee=O.scope.uri:ee=A.TaskScope.Workspace,!ne||!ee?void 0:{_id:O._id,definition:ne,name:O.name,source:{extensionId:j.identifier.value,label:O.source,scope:ee},execution:Y,isBackground:O.isBackground,group:D.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=M;async function N(O,j,Y){if(O==null)return;let ne;c.is(O.execution)?ne=c.to(O.execution):u.is(O.execution)?ne=u.to(O.execution):d.is(O.execution)&&(ne=d.to(O._id,Y));const ee=a.to(O.definition);let Q;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Q=O.source.scope:Q=await j.resolveWorkspaceFolder(I.URI.revive(O.source.scope)):Q=A.TaskScope.Workspace),!ee||!Q)return;const X=new A.$fM(ee,Q,O.name,O.source.label,ne,O.problemMatchers);return O.isBackground!==void 0&&(X.isBackground=O.isBackground),O.group!==void 0&&(X.group=A.$bM.from(O.group._id),X.group&&O.group.isDefault&&(X.group=new A.$bM(X.group.id,X.group.label),O.group.isDefault===!0&&(X.group.isDefault=O.group.isDefault))),O.presentationOptions&&(X.presentationOptions=t.to(O.presentationOptions)),O._id&&(X._id=O._id),O.detail&&(X.detail=O.detail),X}U.to=N})(g||(e.TaskDTO=g={}));var f;(function(U){function z(N){return N}U.from=z;function M(N){if(N)return Object.assign(Object.create(null),N)}U.to=M})(f||(f={}));class y{#e;constructor(z,M,N){this._id=M,this.a=N,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let P=class{constructor(z,M,N,O,j,Y,ne,ee){this.q=new $.$Yd,this.r=new $.$Yd,this.s=new $.$Yd,this.u=new $.$Yd,this.a=z.getProxy(L.$rL.MainThreadTask),this.b=N,this.c=O,this.d=j,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ne,this.g=ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,M,N){if(!N)return new A.$tL(()=>{});const O=this.x();return this.j.set(O,{type:M,provider:N,extension:z}),this.a.$registerTaskProvider(O,M),new A.$tL(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(z,M){this.a.$registerTaskSystem(z,M)}fetchTasks(z){return this.a.$fetchTasks(f.from(z)).then(async M=>{const N=[];for(const O of M){const j=await g.to(O,this.b,this.m);j&&N.push(j)}return N})}get taskExecutions(){const z=[];return this.k.forEach(M=>z.push(M)),z}terminateTask(z){if(!(z instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,M,N){const O=this.m.get(z.id);O&&(this.o.set(z.id,O),this.e.attachPtyToTerminal(M,await O.callback(N))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const M=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const M=await this.z(z.id);this.s.fire({execution:M,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const M=await this.z(z.id);this.u.fire({execution:M,exitCode:z.exitCode})}$provideTasks(z,M){const N=this.j.get(z);if(!N)return Promise.reject(new Error("no handler found"));const O=[],j=(0,F.$3g)(()=>N.provider.provideTasks(R.CancellationToken.None)).then(Y=>this.v(M,O,N,Y));return new Promise(Y=>{j.then(ne=>{Promise.all(O).then(()=>{Y(ne)})})})}async $resolveTask(z,M){const N=this.j.get(z);if(!N)return Promise.reject(new Error("no handler found"));if(M.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${N.type}].`);const O=await g.to(M,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const j=await N.provider.resolveTask(O,R.CancellationToken.None);if(!j)return;this.A(j,N);const Y=g.from(j,N.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(Y.execution)&&await this.y(Y,j,!0),await this.w(Y)}x(){return this.h++}async y(z,M,N){const O=await this.a.$createTaskId(z);!N&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,M.execution)),this.m.set(O,M.execution)}async z(z,M){if(typeof z=="string"){const j=this.l.get(z);if(!j)throw new r.$bb("Unexpected: The specified task is missing an execution");return j}const N=this.l.get(z.id);if(N)return N;let O;return M?O=Promise.resolve(new y(this,z.id,M)):O=g.to(z.task,this.b,this.m).then(j=>{if(!j)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,z.id,j)}),this.l.set(z.id,O),O.then(j=>(this.k.set(z.id,j),j))}A(z,M){z._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const N=this.n.values();let O=N.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=N.next()}};e.$Jic=P,e.$Jic=P=Je([We(0,m.$JN),We(1,E.$ZN),We(2,v.$fhc),We(3,p.$UN),We(4,k.$ihc),We(5,C.$Ghc),We(6,s.$sj),We(7,i.$Ugc)],P);let T=class extends P{constructor(z,M,N,O,j,Y,ne,ee){super(z,M,N,O,j,Y,ne,ee),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:w.$h(0)})}async executeTask(z,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const N=g.from(M,z);if(N===void 0)throw new Error("Task is not valid");if(d.is(N.execution))await this.y(N,M,!1);else throw new r.$_;const O=await this.z(await this.a.$getTaskExecution(N),M);return this.a.$executeTask(N).catch(j=>{throw new Error(j)}),O}v(z,M,N,O){const j=[];if(O)for(const Y of O){if(this.A(Y,N),!Y.definition||!z[Y.definition.type]){const ee=Y.source?Y.source:"No task source";this.f.warn(`The task [${ee}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ne=g.from(Y,N.extension);ne&&d.is(ne.execution)?(j.push(ne),M.push(this.y(ne,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:N.extension}}async w(z){if(d.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,M,N){}};e.$Kic=T,e.$Kic=T=Je([We(0,m.$JN),We(1,E.$ZN),We(2,v.$fhc),We(3,p.$UN),We(4,k.$ihc),We(5,C.$Ghc),We(6,s.$sj),We(7,i.$Ugc)],T),e.$Lic=(0,S.$$h)("IExtHostTask")}),define(Ce[362],Ie([1,0,36,29]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=e.$bK=void 0;function $(A){return"cellResults"in A}e.$bK=$,e.$cK="rawCell#";function L(A,v){let p=-1;const k=[];let R=[];return A.forEach(m=>{m.range.startLineNumber!==p&&R.length>0&&(k.push([...R]),R=[]),R.push(m),p=m.range.endLineNumber}),R.length>0&&k.push([...R]),k.map(m=>{const E=[],S=m[0].range.startLineNumber,l=m[m.length-1].range.endLineNumber;for(let w=S;w<=l;w++)E.push(v.getLineContent(w));return new I.$RJ(E.join(`
`)+`
`,m.map(w=>new F.$Zs(w.range.startLineNumber-1,w.range.startColumn-1,w.range.endLineNumber-1,w.range.endColumn-1)))})}e.$dK=L}),define(Ce[363],Ie([1,0,217,21,4,3,28,12,18,2,32,110,6,33,15,7,69,333,150,24,16,288,362,359]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,d,b,D,g,f){this.q=b,this.r=D,this.s=g,this.t=f,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new $.$Yd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new $.$Yd,this.onDidOpenNotebookDocument=this.m.event,this.n=new $.$Yd,this.onDidCloseNotebookDocument=this.n.event,this.o=new $.$Yd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$Sgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(m.$rL.MainThreadNotebook),this.c=u.getProxy(m.$rL.MainThreadNotebookDocuments),this.d=u.getProxy(m.$rL.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,T=y.cell.handle,z=this.g.get(P)?.getCell(T);if(z)return z.apiCell}if(y&&y.$mid===14){const P=y.uri,T=this.g.get(P);if(T)return T.apiNotebook}return y}}),c.B(d)}getEditorById(u){const d=this.h.get(u);if(!d)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(u){for(const[d,b]of this.h)if(b.apiEditor===u)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,d){const b=this.g.get(u);if(!b&&!d)throw new Error(`NO notebook document for '${u}'`);return b}static u(u,d){if(!d)return;const b=d.filenamePattern.map(D=>S.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(d.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:d.displayName,filenamePattern:b,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,d,b){const D=c.a++,g=typeof b.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,b),this.b.$registerNotebookCellStatusBarItemProvider(D,g,d);let f;return g!==void 0&&(f=b.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(g))),new l.$tL(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,g),f?.dispose()})}async createNotebookDocument(u){const d=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&S.NotebookData.from(u.content)});return k.URI.revive(d)}async openNotebookDocument(u){const d=this.g.get(u);if(d)return d.apiNotebook;const b=await this.c.$tryOpenNotebook(u),D=this.g.get(k.URI.revive(b));return(0,p.$Xf)(D?.apiNotebook)}async showNotebookDocument(u,d){k.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let b;typeof d=="object"?b={position:S.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(S.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:b={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,b),g=D&&this.h.get(D)?.apiEditor;if(g)return g;throw D?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,d,b,D){const g=this.f.get(u),f=k.URI.revive(d),y=this.g.get(f);if(!y||!g)return;const P=y.getCellFromIndex(b);if(!P)return;const T=await g.provideCellStatusBarItems(P.apiCell,D);if(!T)return;const U=new L.$Sc,z=this.p.add([U]),N=(Array.isArray(T)?T:[T]).map(O=>S.NotebookStatusBarItem.from(O,this.i,U));return{cacheId:z,items:N}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,d,b,D,g){if((0,v.$Me)(d))throw new Error("viewType cannot be empty or just whitespace");const f=this.w++;return this.x.set(f,{viewType:d,serializer:b,options:D}),this.b.$registerNotebookSerializer(f,{id:u.identifier,location:u.extensionLocation},d,S.NotebookDocumentContentOptions.from(D),c.u(u,g)),(0,L.$Rc)(()=>{this.b.$unregisterNotebookSerializer(f)})}async $dataToNotebook(u,d,b){const D=this.x.get(u);if(!D)throw new Error("NO serializer found");const g=await D.serializer.deserializeNotebook(d.buffer,b);return new w.$Yv(S.NotebookData.from(g))}async $notebookToData(u,d,b){const D=this.x.get(u);if(!D)throw new Error("NO serializer found");const g=await D.serializer.serializeNotebook(S.NotebookData.to(d.value),b);return F.$me.wrap(g)}async $saveNotebook(u,d,b,D,g){const f=k.URI.revive(d),y=this.x.get(u);if(!y)throw new Error("NO serializer found");const P=this.g.get(f);if(!P)throw new Error("Document NOT found");if(P.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(f.scheme))throw new R.$Qk((0,I.localize)(0,null,this.z(f)),6);await this.y(f,D);const T={metadata:(0,n.$Jn)(P.apiNotebook.metadata,O=>!(y.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of P.apiNotebook.getCells()){const j=new l.$UM(O.kind,O.document.getText(),O.document.languageId,O.mime,y.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);j.metadata=(0,n.$Jn)(O.metadata,Y=>!(y.options?.transientCellMetadata??{})[Y]),T.cells.push(j)}const U=await y.serializer.serializeNotebook(T,g);await this.s.value.writeFile(f,U);const z=this.s.getFileSystemProviderExtUri(f.scheme),M=await this.s.value.stat(f);return{name:z.basename(f),isFile:(M.type&R.FileType.File)!==0,isDirectory:(M.type&R.FileType.Directory)!==0,isSymbolicLink:(M.type&R.FileType.SymbolicLink)!==0,mtime:M.mtime,ctime:M.ctime,size:M.size,readonly:!!((M.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(f.scheme),locked:!!((M.permissions??0)&R.FilePermission.Locked),etag:R.$2k({mtime:M.mtime,size:M.size}),children:void 0}}async $searchInNotebooks(u,d,b,D,g){const f=this.x.get(u)?.serializer;if(!f)return{limitHit:!1,results:[]};const y=new A.$Bc;await(async(M,N,O)=>{await Promise.all(M.map(async j=>await Promise.all(j.filenamePatterns.map(Y=>{const ne={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:Y};return this.t.doInternalFileSearchWithCustomCallback(ne,N,ee=>{ee.forEach(Q=>{y.has(Q)||D.some(ce=>j.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(ie=>(0,h.$9db)(ie,Q)))||y.add(Q)})}).catch(ee=>{if(ee.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ee})}))))})(b,g,d);const T=new A.$Ac;let U=!1;const z=Array.from(y).map(async M=>{const N=[];try{if(g.isCancellationRequested)return;if(d.maxResults&&[...T.values()].reduce((ne,ee)=>ne+ee.cellResults.length,0)>d.maxResults){U=!0;return}const O=[],j=this.g.get(M);if(j)j.apiNotebook.getCells().forEach(ee=>O.push({input:ee.document.getText(),outputs:ee.outputs.flatMap(Q=>Q.items.map(X=>X.data.toString()))}));else{const ne=await this.s.value.readFile(M),ee=F.$me.fromString(ne.toString()),Q=await f.deserializeNotebook(ee.buffer,g);if(g.isCancellationRequested)return;S.NotebookData.from(Q).cells.forEach(ce=>O.push({input:ce.source,outputs:ce.outputs.flatMap(ie=>ie.items.map(fe=>fe.valueBytes.toString()))}))}if(g.isCancellationRequested)return;O.forEach((ne,ee)=>{const Q=d.contentPattern.pattern,X=new a.$qSb(ne.input,void 0,ne.outputs),ce=X.findInInputs(Q),ie=X.findInOutputs(Q),fe=ie.flatMap(re=>(0,t.$dK)(re.matches,re.textBuffer)).map((re,J)=>(re.webviewIndex=J,re));if(ce.length>0||ie.length>0){const re={index:ee,contentResults:(0,t.$dK)(ce,X.inputTextBuffer),webviewResults:fe};N.push(re)}});const Y={resource:M,cellResults:N};T.set(M,Y);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...T.values()]}}async y(u,d){const b=await this.s.value.stat(u);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==R.$1k&&typeof b.mtime=="number"&&typeof b.size=="number"&&d.mtime<b.mtime&&d.etag!==R.$2k({mtime:d.mtime,size:b.size}))throw new R.$Qk((0,I.localize)(1,null),3,d)}z(u){return u.scheme===r.Schemas.file?u.fsPath:u.toString()}A(u,d,b){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const D=new i.$cic(d,this.d,u,b.visibleRanges.map(S.NotebookRange.to),b.selections.map(S.NotebookRange.to),typeof b.viewColumn=="number"?S.ViewColumn.to(b.viewColumn):void 0);this.h.set(d,D)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const b of u.value.removedDocuments){const D=k.URI.revive(b),g=this.g.get(D);g&&(g.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(f=>f.document.uri)}),this.n.fire(g.apiNotebook));for(const f of this.h.values())f.notebookData.uri.toString()===D.toString()&&this.h.delete(f.id)}if(u.value.addedDocuments){const b=[];for(const D of u.value.addedDocuments){const g=k.URI.revive(D.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const f=new s.$bic(this.c,this.q,this.r,g,D);b.push(...D.cells.map(y=>s.$aic.asModelAddData(f.apiNotebook,y))),this.g.get(g)?.dispose(),this.g.set(g,f),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(f.apiNotebook)}}if(u.value.addedEditors)for(const b of u.value.addedEditors){if(this.h.has(b.id))return;const D=k.URI.revive(b.documentUri),g=this.g.get(D);g&&this.A(g,b.id,b)}const d=[];if(u.value.removedEditors)for(const b of u.value.removedEditors){const D=this.h.get(b);D&&(this.h.delete(b),this.k?.id===D.id&&(this.k=void 0),d.push(D))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const b=new Set;this.l.forEach(D=>b.add(D.id));for(const D of this.h.values()){const g=b.has(D.id);D._acceptVisibility(g)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const d=E.$8N.String.with("notebookType","A notebook type"),b=new E.$0N("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new E.$8N("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>F.$me.wrap(g))],new E.$9N("Notebook Data",g=>S.NotebookData.to(g.value))),D=new E.$0N("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new E.$8N("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new w.$Yv(S.NotebookData.from(g)))],new E.$9N("Bytes",g=>g.buffer));u.registerApiCommand(b),u.registerApiCommand(D)}}e.$lic=c}),define(Ce[364],Ie([1,0,17,22,44,35,23,38,36]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class k{constructor(m,E,S){this.k=m,this.l=E,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&L.$Rj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&L.$Rj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const E=this.k.folderQueries||[];return new Promise((S,l)=>{const w=s=>{this.f++,m(s)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=I.$nc(i);this.j&&this.j(i,n)||this.v(w,{base:s,basename:n})}),Promise.all(E.map(s=>this.p(s,w))).then(s=>{S({limitHit:this.e,stats:s[0]||void 0})},s=>{l(new Error((0,$.$Vi)(s)))})})}async p(m,E){const S=new F.$9d,l=this.q(m),w=this.r(),s=new p.$6J(this.k,m),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=v.$Ud.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,S.token),a=n.elapsed(),t=v.$Ud.create();return this.g&&!this.e||(r&&r.forEach(h=>{const c=I.$gc.relative(m.folder.path,h.path);if(i){const o=I.$nc(h.path);this.v(E,{base:m.folder,relativePath:c,basename:o});return}this.s(w,m.folder,c,E)}),this.g&&!this.e)?null:(this.u(w,s,E),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(m){const E=(0,p.$5J)(this.k.includePattern,m.includePattern),S=(0,p.$5J)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:E,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},E,S,l){if(S===this.a){const s=I.$nc(this.a);this.v(l,{base:E,relativePath:this.a,basename:s})}function w(s){const i=I.$nc(s),n=I.$mc(s);let r=m[n];r||(r=m[n]=[],w(n)),r.push({base:E,relativePath:s,basename:i})}w(S)}u({rootEntries:m,pathToEntries:E},S,l){const w=this,s=this.a;function i(n){const r=(0,p.$8J)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const h=n[a],{relativePath:c,basename:o}=h;if(S.matchesExcludesSync(c,o,s!==o?r:void 0))continue;const u=E[c];if(u)i(u);else{if(c===s)continue;w.v(l,h)}if(w.e)break}}i(m)}v(m,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,E,S,l){const w=this.c(m.cacheKey),s=new k(m,E,w&&w.token);let i=0;const n=r=>{i+=r.length,S(r.map(a=>this.d(a)))};return this.e(s,R.a,n,l).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new F.$9d),this.b.get(m)}d(m){return m.relativePath?{resource:A.$Lg(m.base,m.relativePath)}:{resource:m.base}}e(m,E,S,l){const w=l.onCancellationRequested(()=>{m.cancel()}),s=n=>{n&&(i.push(n),E>0&&i.length>=E&&(S(i),i=[]))};let i=[];return m.search(s).then(n=>(i.length&&S(i),w.dispose(),n),n=>(i.length&&S(i),w.dispose(),Promise.reject(n)))}}e.$dic=R}),define(Ce[365],Ie([1,0,19,74,35,102,28,16,17,23,12,18,2,99,237,51,13,40,143,360,36]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$8K=void 0;let a=class{constructor(f,y,P,T,U){this.a=f,this.b=y,this.c=P,this.d=T,this.e=U}text(f,y,P={}){f=this.f(f,P);const T=this.a.getValue(),U=y&&y.some(M=>!this.a.getValue({resource:M}).search.useRipgrep);return{...this.h(y?.map(s.$ti),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:T.search.usePCRE2||U||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(f,y){const P=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const T={...f,wordSeparators:P.editor.wordSeparators};return this.j(f,y)&&(T.isCaseSensitive=!0),this.k(f)&&(T.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),T}file(f,y={}){return{...this.h(f,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(f,y){return f?(f=Array.isArray(f)?f.map(u):u(f),y?this.parseSearchPaths(f):{pattern:h(...Array.isArray(f)?f:[f])}):{}}h(f=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),T=this.g(y.excludePattern,y.expandPatterns),U=f.length>1,z=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,y,T)):f.map(O=>this.r(O,y,T,U))).filter(O=>!!O),M={_reason:y._reason,folderQueries:z,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:T.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const O=I.$Hb(I.$Rb(this.c.groups.map(ne=>ne.editors.map(ee=>ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const j=O.filter(ne=>(0,r.$VJ)(M,ne.fsPath)),Y=this.i(j);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...M,...Y}}const N=y.extraFileResources&&y.extraFileResources.filter(O=>(0,r.$VJ)(M,O.fsPath));return M.extraFileResources=N&&N.length?N:void 0,M}i(f){const y=[],P=new A.$Ac,T={};let U=!1;return f.forEach(z=>{if(z.scheme===v.Schemas.walkThrough)return;if((0,k.$Pg)(z)){const N=this.b.getWorkspaceFolder(z)?.uri??z.with({path:p.$mc(z.fsPath)});let O=P.get(N);O||(U=!0,O={folder:N,includePattern:{}},y.push(O),P.set(N,O));const j=p.$lc(N.fsPath,z.fsPath);(0,C.$Xf)(O.includePattern)[j.replace(/\\/g,"/")]=!0}else z.fsPath&&(U=!0,T[z.fsPath]=!0)}),{folderQueries:y,includePattern:T,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(f,y){if(y.isSmartCase){if(f.isRegExp){if(R.$Df(f.pattern,!0))return!0}else if(R.$Df(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,E.$9B)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const y=Y=>p.$ic(Y)||/^\.\.?([\/\\]|$)/.test(Y),T=(Array.isArray(f)?f:c(f)).map(Y=>{const ne=this.e.resolvedUserHome;return ne?(0,L.$4v)(Y,ne.scheme===v.Schemas.file?ne.fsPath:ne.path):Y}),U=F.$K(T,Y=>y(Y)?"searchPaths":"exprSegments"),z=(U.exprSegments||[]).map(Y=>R.$Xe(Y,"/")).map(Y=>R.$Xe(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),M={},N=this.m(U.searchPaths||[]);N&&N.length&&(M.searchPaths=N);const O=I.$Rb(z),j=h(...O);return j&&(M.pattern=j),M}l(f,y){return y.disregardExcludeSettings?void 0:(0,r.$UJ)(f,!y.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const y=f.flatMap(T=>{let{pathPortion:U,globPortion:z}=t(T);return z&&(z=d(z)),this.n(U).flatMap(N=>this.o(N,z))}),P=new Map;return y.forEach(T=>{const U=T.searchPath.toString(),z=P.get(U);z?T.pattern&&(z.pattern=z.pattern||{},z.pattern[T.pattern]=!0):P.set(U,{searchPath:T.searchPath,pattern:T.pattern?h(T.pattern):void 0})}),Array.from(P.values())}n(f){if(p.$ic(f)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==v.Schemas.file?[{searchPath:y[0].uri.with({path:f})}]:[{searchPath:m.URI.file(p.$hc(f))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(f=u(f),f.startsWith("../")||f===".."){const T=p.$gc.resolve(y.path,f);return[{searchPath:y.with({path:T})}]}const P=d(f);return[{searchPath:y,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const y=f.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(U=>{const z=y.match(new RegExp(`^${R.$Re(U.name)}(?:/(.*)|$)`));return z?{match:z,folder:U}:null}).filter(C.$Uf);if(T.length)return T.map(U=>{const z=U.match[1];return{searchPath:U.folder.uri,pattern:z&&d(z)}});{const U=f.match(/\.[\/\\](.+)[\/\\]?/),z=U?U[1]:f,M=S.localize(0,null,z);throw new Error(M)}}}}o(f,y){const P=f.pattern&&y?`${f.pattern}/${y}`:f.pattern||y,T=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&T.push({searchPath:f.searchPath,pattern:P+"/**"}),T}q(f,y,P){const T=this.r((0,s.$ti)(f.searchPath),y,P,!1);return T?{...T,includePattern:f.pattern}:null}r(f,y,P,T){let U;const z=m.URI.isUri(f)?f:f.uri;if(P.searchPaths){const Y=P.searchPaths.filter(ne=>(0,k.$Eg)(ne.searchPath,z))[0];if(Y&&!Y.pattern)return null;Y&&(U=Y.pattern)}const M=this.a.getValue({resource:z}),O={...this.l(M,y)||{},...U||{}},j=m.URI.isUri(f)?(0,k.$Ig)(f):f.name;return{folder:z,folderName:T?j:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:M.files&&M.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!M.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!M.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!M.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!M.search.followSymlinks}}};e.$8K=a,e.$8K=a=Je([We(0,l.$Ei),We(1,s.$hi),We(2,i.$dD),We(3,w.$sj),We(4,n.$6K)],a);function t(g){const f=g.match(/[\*\{\}\(\)\[\]\?]/);if(f){const y=f.index,P=g.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let T=g.substr(0,P.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function h(...g){return g.length?g.reduce((f,y)=>(f[y]=!0,f),Object.create(null)):void 0}function c(g){return $.$Pj(g,",").map(f=>f.trim()).filter(f=>!!f.length)}function o(g){return[`**/${g}/**`,`**/${g}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function u(g){return g.replace(/\\/g,"/")}function d(g){return u(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(g){return g.replace(/([?*[\]])/g,"[$1]")}function D(g,f){g=I.$Mb(g,T=>T.toString());const y=[],P=f.getWorkspace();return g&&g.forEach(T=>{let U;if(f.getWorkbenchState()===2)U=(0,k.$Ng)(P.folders[0].uri,T),U&&U!=="."&&(U="./"+U);else{const z=f.getWorkspaceFolder(T);if(z){const M=z.name;if(P.folders.filter(O=>O.name===M).length===1){const O=(0,k.$Ng)(z.uri,T);O===""?U=`./${z.name}`:U=`./${z.name}/${O}`}else U=T.fsPath}}U&&y.push(b(U))}),y}e.$9K=D}),define(Ce[366],Ie([1,0,23,2,22,14,5,365,36,40,8]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rtb=e.$Qtb=void 0;const C=7e3;function m(w,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],r=[];for(const u of i)if(/^workspaceContains:/.test(u)){const d=u.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||w.forceUsingSearch?r.push(d):n.push(d)}if(n.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:a,resolve:t}=(0,R.$4g)(),h=u=>t({activationEvent:u}),c=Promise.all(n.map(u=>E(w,u,h))).then(()=>{}),o=S(w,s.identifier,r,h);return Promise.all([c,o]).then(()=>{t(void 0)}),a}e.$Qtb=m;async function E(w,s,i){for(const n of w.folders)if(await w.exists(I.$Lg(F.URI.revive(n),s))){i(`workspaceContains:${s}`);return}}async function S(w,s,i,n){if(i.length===0)return Promise.resolve(void 0);const r=new $.$9d,a=w.checkExists(w.folders,i,r.token),t=setTimeout(async()=>{r.cancel(),w.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let h=!1;try{h=await a}catch(c){L.$4(c)||L.$1(c)}r.dispose(),clearTimeout(t),h&&n(`workspaceContains:${i.join(",")}`)}function l(w,s,i,n){const r=w.get(A.$0h),a=w.get(p.$MJ),h=r.createInstance(v.$8K).file(s.map(c=>(0,k.$ti)(F.URI.revive(c))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(h,n).then(c=>!!c.limitHit,c=>L.$4(c)?!1:Promise.reject(c))}e.$Rtb=l}),define(Ce[47],Ie([1,0,214,17,58,23,8,3,78,2,13,6,42,294,117,41,26,145,14,25,21,273,7,65,5,27,93,20,106,71,46,4,366,116,275,16,114,38,11,115]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h,c,o,u,d,b,D,g,f,y,P,T,U,z,M,N,O){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=e.$Uhc=e.$Thc=e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,c.$$h)("IHostUtils");let Y=j=class extends v.$Tc{constructor(J,B,ae,Ee,le,de,ue,ge,V,Z,he,be){super(),this.X=be,this.a=this.B(new f.$Yd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ae,this.f=ue,this.j=Ee,this.m=le,this.s=de,this.t=V,this.u=Z,this.w=he,this.y=this.g.getProxy(C.$rL.MainThreadWorkspace),this.z=this.g.getProxy(C.$rL.MainThreadTelemetry),this.C=this.g.getProxy(C.$rL.MainThreadExtensionService),this.D=new A.$0g,this.F=new A.$0g,this.G=new A.$0g,this.H=new A.$0g,this.I=new fe(this.f.extensions.activationEvents),this.L=new s.$U8b(this.I,this.f.extensions.allExtensions);const Pe=new n.$rm(this.f.extensions.myExtensions);this.J=new s.$U8b(this.I,ce(this.L,Pe)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new S.$Chc(this.g,this.s),this.N=new P.$Khc(this.g),this.O=ge,this.h=J.createChild(new b.$9h([S.$Dhc,this.M],[P.$Lhc,this.N])),this.P=this.B(new E.$Bhc(this.J,this.L,{onExtensionActivationError:(pe,Le,Me)=>{this.C.$onExtensionActivationError(pe,i.$3(Le),Me)},actualActivateExtension:async(pe,Le)=>{if(s.$U8b.isHostExtension(pe,this.J,this.L))return await this.C.$activateExtension(pe,Le),new E.$Ahc;const Me=this.J.getExtensionDescription(pe);return this.db(Me,Le)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),$.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(J){i.$1(J)}}async Y(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this.cb(le))}catch{}await Promise.all(J)}terminate(J,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ee=>{this.s.error(Ee)}),this.g.dispose();const ae=this.Y();Promise.race([(0,A.$_g)(5e3),ae]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const B=await this.C.$getExtension(J);return B&&{...B,identifier:new n.$qm(B.identifier.value),extensionLocation:k.URI.revive(B.extensionLocation)}}Z(J,B){return this.P.activateByEvent(J,B)}$(J,B){return this.P.activateById(J,B)}activateByIdWithErrors(J,B){return this.$(J,B).then(()=>{const ae=this.P.getActivatedExtension(J);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async ab(J){if(J.scheme===U.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(J.fsPath);return k.URI.file(B)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(J=>new ie(J))),this.Q}async bb(J){const B=p.$ei.forUris(ae=>L.$Cg.ignorePathCasing(ae));return await Promise.all(J.map(async ae=>{if(this.ub(ae)){const Ee=await this.ab(ae.extensionLocation);B.set(Ee,ae)}})),B}cb(J){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return B;const ae=this.P.getActivatedExtension(J);if(!ae)return B;try{typeof ae.module.deactivate=="function"&&(B=Promise.resolve(ae.module.deactivate()).then(void 0,Ee=>(this.s.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(Ee)}try{(0,v.$Oc)(ae.subscriptions)}catch(Ee){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(Ee)}return B}async db(J,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.fb(J,B).then(ae=>{const Ee=ae.activationTimes;return this.C.$onDidActivateExtension(J.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,B),this.eb(J,B,"success",Ee),ae},ae=>{throw this.eb(J,B,"failure"),ae})}eb(J,B,ae,Ee){const le=ee(J,B);this.z.$publicLog2("extensionActivationTimes",{...le,...Ee||{},outcome:ae})}fb(J,B){const ae=ee(J,B);this.z.$publicLog2("activatePlugin",ae);const Ee=this.ub(J);if(!Ee)return Promise.resolve(new E.$zhc(E.$whc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${J.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const le=new E.$xhc(B.startup);return Promise.all([this.vb(J,(0,L.$Lg)(J.extensionLocation,Ee),le),this.gb(J)]).then(de=>($.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),j.hb(this.s,J.identifier,de[0],de[1],le))).then(de=>($.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),de))}gb(J){const B=new a.$Fhc(J,this.M),ae=new a.$Ehc(J.identifier.value,!1,this.M),Ee=new T.$Mhc(J,this.N),le=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([B.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const ue=this;let ge,V;const Z=(0,w.$NF)(J,"ipc")?this.f.messagePorts?.get(n.$qm.toKey(J.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ae,secrets:Ee,subscriptions:[],get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(he){return F.$jc(J.extensionLocation.fsPath,he)},get storagePath(){return ue.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return ue.O.globalValue(J).fsPath},get logPath(){return F.$jc(ue.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return k.URI.joinPath(ue.f.logsLocation,J.identifier.value)},get storageUri(){return ue.O.workspaceValue(J)},get globalStorageUri(){return ue.O.globalValue(J)},get extensionMode(){return le},get extension(){return ge===void 0&&(ge=new X(ue,J.identifier,J,de,!1)),ge},get extensionRuntime(){return(0,w.$OF)(J,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!V){if(!Z)return;const he=f.Event.buffer(f.Event.fromDOMEventEmitter(Z,"message",be=>be.data));Z.start(),V={onDidReceiveMessage:he,postMessage:Z.postMessage.bind(Z)}}return V}})})}static hb(J,B,ae,Ee,le){return ae=ae||{activate:void 0,deactivate:void 0},this.ib(J,B,ae,Ee,le).then(de=>new E.$yhc(!1,null,le.build(),ae,de,Ee.subscriptions))}static ib(J,B,ae,Ee,le){if(typeof ae.activate=="function")try{le.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${B.value}`);const de=typeof global=="object"?global:self,ue=ae.activate.apply(de,[Ee]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ue).then(ge=>(le.activateResolveStop(),ge))}catch(de){return Promise.reject(de)}else return Promise.resolve(ae)}jb(J,B){this.$(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:B}).then(void 0,ae=>{this.s.error(ae)})}kb(J,B=0){const Ee=Date.now();(0,N.$B)(()=>{for(let le=B;le<J.length;le+=1){const de=J[le];for(const ue of de.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-Ee>50){this.kb(J,le);break}else this.jb(de,ue)}})}lb(){this.C.$setPerformanceMarks($.getMarks()),this.m.getConfigProvider().then(J=>{const B=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ae=this.J.getAllExtensionDescriptions();if(B)this.kb(ae);else for(const Ee of ae)if(Ee.activationEvents)for(const le of Ee.activationEvents)le==="onStartupFinished"&&this.jb(Ee,le)})}mb(){const J=this.Z("*",!0).then(void 0,de=>{this.s.error(de)});this.B(this.j.onDidChangeWorkspace(de=>this.nb(de.added)));const B=this.j.workspace?this.j.workspace.folders:[],ae=this.nb(B),Ee=this.pb(),le=Promise.all([Ee,J,ae]).then(()=>{});return Promise.race([le,(0,A.$_g)(1e4)]).then(()=>{this.lb()}),le}nb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(J,B))).then(()=>{})}async ob(J,B){if(this.isActivated(B.identifier))return;const ae=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.s,folders:J.map(de=>de.uri),forceUsingSearch:ae||!this.c.fsExists,exists:de=>this.c.fsExists(de.fsPath),checkExists:(de,ue,ge)=>this.y.$checkExists(de,ue,ge)},le=await(0,y.$Qtb)(Ee,B);if(le)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:le.activationEvent}).then(void 0,de=>this.s.error(de))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(J){throw console.error(J),J}}async qb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:B}=this.f.environment;if(!J||!B)throw new Error(I.localize(0,null));const ae=await this.vb(null,B,new E.$xhc(!1));if(!ae||typeof ae.run!="function")throw new Error(I.localize(1,null,B.toString()));return new Promise((Ee,le)=>{const de=(V,Z)=>{V?(N.$t&&this.s.error("Test runner called back with error",V),le(V)):(N.$t&&(Z?this.s.info(`Test runner called back with ${Z} failures.`):this.s.info("Test runner called back with successful outcome.")),Ee(typeof Z=="number"&&Z>0?1:0))},ue=(0,L.$zg)(B),ge=ae.run(ue,de);ge&&ge.then&&ge.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),Ee(0)}).catch(V=>{N.$t&&this.s.error("Test runner finished with error",V),le(V instanceof Error&&V.stack?V.stack:String(V))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$_g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,B){return this.R[J]=B,(0,v.$Rc)(()=>{delete this.R[J]})}async getRemoteExecServer(J){const{resolver:B}=await this.sb(J);return B?.resolveExecServer?.(J,{resolveAttempt:0})}async sb(J){const B=J.indexOf("+");if(B===-1)throw new t.$zL("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ae=J.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this.R[ae]}}async $resolveAuthority(J,B){const ae=M.$Ud.create(!1),Ee=()=>`[resolveAuthority(${(0,h.$el)(J)},${B})][${ae.elapsed()}ms] `,le=x=>this.s.info(`${Ee()}${x}`),de=x=>this.s.warn(`${Ee()}${x}`),ue=(x,H=void 0)=>this.s.error(`${Ee()}${x}`,H),ge=x=>{if(x instanceof t.$zL)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},V=async x=>{le(`activating resolver for ${x}...`);const{resolver:H,authorityPrefix:K}=await this.sb(x);if(!H)throw ue(`no resolver for ${K}`),new t.$zL(`No remote extension installed to resolve ${K}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:K,remoteAuthority:x}},Z=J.split(/@|%40/g).reverse();le(`activating remote resolvers ${Z.join(" -> ")}`);let he;try{he=await Promise.all(Z.map(V)).catch(async x=>{if(!(x instanceof t.$zL)||x._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return de(`resolving nested authorities failed: ${x.message}`),[await V(J)]})}catch(x){return ge(x)}const be=new A.$jh;be.cancelAndSet(()=>le("waiting..."),1e3);let Pe,pe;for(const[x,{authorityPrefix:H,resolver:K,remoteAuthority:oe}]of he.entries())try{if(x===he.length-1)le("invoking final resolve()..."),$.mark(`code/extHost/willResolveAuthority/${H}`),Pe=await K.resolve(oe,{resolveAttempt:B,execServer:pe}),$.mark(`code/extHost/didResolveAuthorityOK/${H}`),le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(K,t.$yL.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(le(`invoking resolveExecServer() for ${oe}`),$.mark(`code/extHost/willResolveExecServer/${H}`),pe=await K.resolveExecServer?.(oe,{resolveAttempt:B,execServer:pe}),!pe)throw new t.$zL(`Exec server was not available for ${oe}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);$.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ye){return $.mark(`code/extHost/didResolveAuthorityError/${H}`),ue("returned an error",ye),be.dispose(),ge(ye)}be.dispose();const Le={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},Me={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${t.$yL.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let W;if(t.$yL.isManagedResolvedAuthority(Pe)){const x=B;this.X.setFactory(x,Pe.makeConnection),W={authority:J,connectTo:new h.$bl(x),connectionToken:Pe.connectionToken}}else W={authority:J,connectTo:new h.$cl(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:W,options:Me,tunnelInformation:Le}}}async $getCanonicalURI(J,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,h.$el)(J)})`);const{resolver:ae}=await this.sb(J);if(!ae)return null;const Ee=k.URI.revive(B);if(typeof ae.getCanonicalURI>"u")return Ee;const le=await(0,A.$3g)(()=>ae.getCanonicalURI(Ee));return le||Ee}$startExtensionHost(J){J.toAdd.forEach(Ee=>Ee.extensionLocation=k.URI.revive(Ee.extensionLocation));const{globalRegistry:B,myExtensions:ae}=ne(this.I,this.L,this.J,J);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ae),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(J,B){return B===1?this.D.wait().then(ae=>this.Z(J,!1)):this.G.wait().then(ae=>this.Z(J,!1))}async $activate(J,B){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.$(J,B),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(de=>de.extensionLocation=k.URI.revive(de.extensionLocation));const{globalRegistry:B,myExtensions:ae}=ne(this.I,this.L,this.J,J),Ee=await this.bb(ae);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ae),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const B=r.$me.alloc(J),ae=Math.random()%256;for(let Ee=0;Ee<J;Ee++)B.writeUInt8(ae,Ee);return B}async $updateRemoteConnectionData(J){this.W=J,this.a.fire()}};e.$Shc=Y,e.$Shc=Y=j=Je([We(0,c.$0h),We(1,e.$Rhc),We(2,d.$JN),We(3,l.$fhc),We(4,m.$ihc),We(5,R.$sj),We(6,o.$ZN),We(7,u.$lhc),We(8,D.$Kzb),We(9,g.$Ghc),We(10,z.$Ohc),We(11,O.$Phc)],Y);function ne(re,J,B,ae){re.addActivationEvents(ae.addActivationEvents);const Ee=new s.$U8b(re,J.getAllExtensionDescriptions());Ee.deltaExtensions(ae.toAdd,ae.toRemove);const le=new n.$rm(B.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of ae.myToRemove)le.delete(ue);for(const ue of ae.myToAdd)le.add(ue);const de=ce(Ee,le);return{globalRegistry:Ee,myExtensions:de}}function ee(re,J){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function Q(re){return re.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$Thc=(0,c.$$h)("IExtHostExtensionService");class X{#e;#t;#i;constructor(J,B,ae,Ee,le){this.#e=J,this.#t=B,this.#i=ae.identifier,this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=F.$hc((0,L.$zg)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=Ee,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Uhc=X;function ce(re,J){return re.getAllExtensionDescriptions().filter(B=>J.has(B.identifier))}class ie{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$Vhc=ie;class fe{constructor(J){this.a=new n.$sm,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)??[]}addActivationEvents(J){for(const B of Object.keys(J))this.a.set(B,J[B])}}}),define(Ce[367],Ie([1,0,58,2,6,42,26,25,20,27,5,47,13,12]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;let l=class{constructor(r,a,t,h,c,o,u){this.c=r,this.d=a,this.e=t,this.f=h,this.g=c,this.h=o,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,r,this.i)),this.register(this.e.createInstance(w)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this.a.set(a,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(a=>r.alternativeModuleName(a))}};e.$4ic=l,e.$4ic=l=Je([We(2,R.$0h),We(3,L.$ihc),We(4,C.$Thc),We(5,k.$ZN),We(6,m.$sj)],l);let w=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&S.a.size){const a=(0,E.$Re)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${c}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const a=this.b.exec(this.c(r));if(!a)return;const[,t,h,c]=a,o=S.a.get(h);if(o!==void 0)return console.warn(`${h} as been renamed to ${o}, please update your imports`),t+o+c}c(r){return r.replace(/\\/g,"/")}};w=S=Je([We(0,k.$ZN)],w);class s{constructor(r,a,t,h,c){this.c=r,this.d=a,this.e=t,this.f=h,this.g=c,this.nodeModuleName="vscode",this.a=new v.$sm}load(r,a){const t=this.d.findSubstr(a);if(t){let h=this.a.get(t.identifier);return h||(h=this.c(t,this.e,this.f),this.a.set(t.identifier,h)),h}if(!this.b){let h="";this.d.forEach((c,o)=>h+=`	${o} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${h}`),this.b=this.c(A.$IF,this.e,this.f)}return this.b}}let i=class{constructor(r,a,t){this.e=r,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy($.$rL.MainThreadTelemetry);const h=t.getProxy($.$rL.MainThreadWindow);this.c=(c,o)=>{const u=F.URI.parse(c);return o?this.g(c,o):u.scheme==="http"||u.scheme==="https"?h.$openUri(u,c,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?h.$openUri(u,c,{}):this.g(c,o)}}load(r,a,t){const h=this.e.findSubstr(a);return h&&(this.a=h.identifier.value,this.h()),this.b=t(r),this.c}g(r,a){return this.i(),this.b(r,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([We(2,p.$JN)],i)}),define(Ce[60],Ie([1,0,43,3,17,49,5,73,72,47,7,41,291,42]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=void 0,e.$Whc=(0,A.$$h)("IExtHostVariableResolverProvider");class S extends m.$KO{constructor(s,i,n,r,a,t,h){function c(){if(n){const o=n.activeEditor();if(o)return o.document.uri;const u=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof R.$cN||u.input instanceof R.$hN)return u.input.modified;if(u.input instanceof R.$bN||u.input instanceof R.$gN||u.input instanceof R.$eN)return u.input.uri}}}super({getFolderUri:o=>{const u=t.folders.filter(d=>d.name===o);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,u)=>a.getConfiguration(void 0,o).get(u),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=c();if(o)return $.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const o=c();if(o){const u=i.getWorkspaceFolder(o);if(u)return $.$hc(u.uri.fsPath)}}},getSelectedText:()=>{if(n){const o=n.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(n){const o=n.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>s.getExtension(o)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(L.env))}}let l=class extends F.$Tc{constructor(s,i,n,r,a){super(),this.b=s,this.c=i,this.g=n,this.h=r,this.j=a,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xhc=l,e.$Xhc=l=Je([We(0,k.$Thc),We(1,C.$fhc),We(2,v.$UN),We(3,E.$ihc),We(4,p.$uhc)],l)}),define(Ce[96],Ie([1,0,8,4,2,25,5,6,72,47,20,7,41,140,283,42,60,3,55,33,15]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=e.$1hc=e.$Zhc=e.$Yhc=void 0,e.$Yhc=(0,A.$$h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(b,D,g,f,y,P,T){this.N=D,this.O=g,this.P=f,this.Q=y,this.R=P,this.S=T,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new F.$Yd,this.o=new F.$Yd,this.q=new F.$Yd,this.w=new F.$Yd,this.l=b.getProxy(v.$rL.MainThreadDebugService),this.A=new F.$Yd,this.C=new F.$Yd,this.y=new h(this.l),this.z=new Map,this.O.getExtensionRegistry().then(U=>{U.onDidChange(z=>{this.V(U)}),this.V(U)})}async $getVisualizerTreeItem(b,D){const g=this.W(D);if(!g)return;const f=await this.H.get(b)?.getTreeItem?.(g);return f?this.U(b,f):void 0}registerDebugVisualizationTree(b,D,g){const f=L.$qm.toKey(b.identifier),y=this.jb(f,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,g),this.l.$registerDebugVisualizerTree(y,!!g.editItem),(0,s.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(b,D){const g=this.J.get(D)?.item;return g?(await this.H.get(b)?.getChildren?.(g))?.map(y=>this.U(b,y))||[]:[]}async $editVisualizerTreeItem(b,D){const g=this.J.get(b);if(!g)return;const f=await this.H.get(g.provider)?.editItem?.(g.item,D);return this.U(g.provider,f||g.item)}$disposeVisualizedTree(b){const D=this.J.get(b);if(!D)return;const g=[D.children];for(const f of g)if(f)for(const y of f)g.push(this.J.get(y)?.children),this.J.delete(y)}U(b,D){let g=this.I.get(D);return g||(g=this.F++,this.I.set(D,g),this.J.set(g,{provider:b,item:D})),r.DebugTreeItem.from(D,g)}asDebugSourceUri(b,D){const g=b;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let f=`debug:${encodeURIComponent(g.path||"")}`,y="?";return D&&(f+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),f+=`${y}ref=${g.sourceReference}`,$.URI.parse(f)}else{if(g.path)return $.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(b){const D=[];for(const g of b.getAllExtensionDescriptions())if(g.contributes){const f=g.contributes.debuggers;if(f&&f.length>0)for(const y of f)(0,S.$kG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const b=[];return this.z.forEach(D=>b.push(D)),b}async $resolveDebugVisualizer(b,D){const g=this.L.get(b);if(!g)throw new Error(`No debug visualizer found with id '${b}'`);let{v:f,provider:y,extensionId:P}=g;if(f.visualization||(f=await y.resolveDebugVisualization?.(f,D)||f,g.v=f),!f.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,f.visualization)}async $executeDebugVisualizerCommand(b){const D=this.L.get(b);if(!D)throw new Error(`No debug visualizer found with id '${b}'`);const g=D.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(b){const D=this.m.get(b.sessionId);return D&&{session:D.api,variable:b.variable,containerId:b.containerId,frameId:b.frameId,threadId:b.threadId}}async $provideDebugVisualizers(b,D,g,f){const y=this.W(g),P=this.jb(b,D),T=this.G.get(P);if(!y||!T)return[];const U=await T.provideDebugVisualization(y,f);return U?U.map(z=>{const M=++this.M;this.L.set(M,{v:z,provider:T,extensionId:b});const N=z.iconPath?this.lb(z.iconPath):void 0;return{id:M,name:z.name,iconClass:N?.iconClass,iconPath:N?.iconPath,visualization:this.kb(b,z.visualization)}}):[]}$disposeDebugVisualizers(b){for(const D of b)this.L.delete(D)}registerDebugVisualizationProvider(b,D,g){if(!b.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const f=L.$qm.toKey(b.identifier),y=this.jb(f,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,g),this.l.$registerDebugVisualizer(f,D),(0,s.$Rc)(()=>{this.l.$unregisterDebugVisualizer(f,D),this.G.delete(D)})}addBreakpoints(b){const D=b.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(D,[],[]);const g=[],f=new Map;for(const y of D)if(y instanceof C.$tM){let P=f.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},f.set(y.location.uri.toString(),P),g.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character})}else y instanceof C.$uM&&g.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName});return this.l.$registerBreakpoints(g)}removeBreakpoints(b){const D=b.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const g=D.filter(P=>P instanceof C.$tM).map(P=>P.id),f=D.filter(P=>P instanceof C.$uM).map(P=>P.id),y=D.filter(P=>P instanceof C.$vM).map(P=>P.id);return this.l.$unregisterBreakpoints(g,f,y)}startDebugging(b,D,g){return this.l.$startDebugging(b?b.uri:void 0,D,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(b){return this.l.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,D,g){if(!D)return new C.$tL(()=>{});const f=this.d++;return this.f.push({type:b,handle:f,provider:D}),this.l.$registerDebugConfigurationProvider(b,g,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,f),new C.$tL(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(b,D,g){if(!g)return new C.$tL(()=>{});if(!this.cb(b,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this.g++;return this.h.push({type:D,handle:f,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(D,f),new C.$tL(()=>{this.h=this.h.filter(y=>y.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(b,D){if(!D)return new C.$tL(()=>{});const g=this.j++;return this.k.push({type:b,handle:g,factory:D}),new C.$tL(()=>{this.k=this.k.filter(f=>f.factory!==D)})}async $runInTerminal(b,D){return Promise.resolve(void 0)}async $substituteVariables(b,D){let g;const f=await this.ib(b);return f&&(g={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,D)}X(b,D){if(b.type==="implementation")return new o(b.implementation)}Y(){}async $startDASession(b,D){const g=this,f=await this.hb(D);return this.eb(this.$(f.type),f).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const P=this.Z(y),T=this.X(P,f);if(!T)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const U=T;return this.D.set(b,U),this.db(f).then(z=>(z&&this.E.set(b,z),U.onMessage(async M=>{if(M.type==="request"&&M.command==="handshake"){const N=M,O={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const j=await this.K.sign(N.arguments.value);O.body={signature:j},U.sendResponse(O)}else throw new Error("no signer")}catch(j){O.success=!1,O.message=j.message,U.sendResponse(O)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(M),M=(0,S.$pG)(M,!0),g.l.$acceptDAMessage(b,M)}),U.onError(M=>{z&&z.onError&&z.onError(M),this.l.$acceptDAError(b,M.name,M.message,M.stack)}),U.onExit(M=>{z&&z.onExit&&z.onExit(M??void 0,void 0),this.l.$acceptDAExit(b,M??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),U.startSession()))})}$sendDAMessage(b,D){D=(0,S.$oG)(D,!1);const g=this.E.get(b);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(D),this.D.get(b)?.sendMessage(D)}$stopDASession(b){const D=this.E.get(b);this.E.delete(b),D&&D.onWillStopSession&&D.onWillStopSession();const g=this.D.get(b);return this.D.delete(b),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const D=[],g=[],f=[];if(b.added)for(const y of b.added){const P=y.id;if(P&&!this.z.has(P)){let T;if(y.type==="function")T=new C.$uM(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage);else if(y.type==="data")T=new C.$vM(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage);else{const U=$.URI.revive(y.uri);T=new C.$tM(new C.$FL(U,new C.$uL(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage)}(0,C.$rM)(T,P),this.z.set(P,T),D.push(T)}}if(b.removed)for(const y of b.removed){const P=this.z.get(y);P&&(this.z.delete(y),g.push(P))}if(b.changed){for(const y of b.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof C.$uM&&y.type==="function"){const T=P;T.enabled=y.enabled,T.condition=y.condition,T.hitCondition=y.hitCondition,T.logMessage=y.logMessage,T.functionName=y.functionName}else if(P instanceof C.$tM&&y.type==="source"){const T=P;T.enabled=y.enabled,T.condition=y.condition,T.hitCondition=y.hitCondition,T.logMessage=y.logMessage,T.location=new C.$FL($.URI.revive(y.uri),new C.$uL(y.line,y.character))}f.push(P)}}}this.gb(D,g,f)}async $acceptStackFrameFocus(b){let D;const g=b.sessionId?await this.hb(b.sessionId):void 0;if(!g)throw new Error("no DebugSession found for debug focus context");b.kind==="thread"?D=new C.$BM(g.api,b.threadId):D=new C.$AM(g.api,b.threadId,b.frameId),this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(b,D,g){return(0,I.$3g)(async()=>{const f=this.bb(b);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return f.provideDebugConfigurations(y,g)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(b,D,g,f){return(0,I.$3g)(async()=>{const y=this.bb(b);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return y.resolveDebugConfiguration(P,g,f)})}$resolveDebugConfigurationWithSubstitutedVariables(b,D,g,f){return(0,I.$3g)(async()=>{const y=this.bb(b);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(P,g,f)})}async $provideDebugAdapter(b,D){const g=this.ab(b);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.hb(D);return this.eb(g,f).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(b){const D=await this.hb(b);this.n.fire(D.api)}async $acceptDebugSessionTerminated(b){const D=await this.hb(b);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(b){this.u=b?await this.hb(b):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(b,D){(await this.hb(b))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(b,D){const f={session:(await this.hb(b)).api,event:D.event,body:D.body};this.w.fire(f)}Z(b){if(b instanceof C.$wM)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof C.$xM)return{type:"server",port:b.port,host:b.host};if(b instanceof C.$yM)return{type:"pipeServer",path:b.path};if(b instanceof C.$zM)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}$(b){const D=this.h.filter(g=>g.type===b);if(D.length>0)return D[0].factory}ab(b){const D=this.h.filter(g=>g.handle===b);if(D.length>0)return D[0].factory}bb(b){const D=this.f.filter(g=>g.handle===b);if(D.length>0)return D[0].provider}cb(b,D){if(b.contributes){const g=b.contributes.debuggers;if(g&&g.length>0){for(const f of g)if(f.label&&f.type&&f.type===D)return!0}}return!1}db(b){const g=b.configuration.type,f=this.k.filter(y=>y.type===g||y.type==="*").map(y=>(0,I.$3g)(()=>y.factory.createDebugAdapterTracker(b.api)).then(P=>P,P=>null));return Promise.race([Promise.all(f).then(y=>{const P=y.filter(T=>!!T);if(P.length>0)return new c(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(b,D){const g=D.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new C.$xM(g));if(b){const y=await this.O.getExtensionRegistry();return(0,I.$3g)(()=>b.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(P=>{if(P)return P})}const f=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,f))}fb(b,D){}gb(b,D,g){(b.length>0||D.length>0||g.length>0)&&this.A.fire(Object.freeze({added:b,removed:D,changed:g}))}async hb(b){if(b)if(typeof b=="string"){const D=this.m.get(b);if(D)return D}else{let D=this.m.get(b.id);if(!D){const g=await this.ib(b.folderUri),f=b.parent?this.m.get(b.parent):void 0;D=new t(this.l,b.id,b.type,b.name,g,b.configuration,f?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(b){if(b){const D=$.URI.revive(b);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(b,D){return`${b}\0${D}`}kb(b,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${b}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(b){const D=this.mb(b);let g,f;return"id"in D?f=i.ThemeIcon.asClassName(D):g=D,{iconPath:g,iconClass:f}}mb(b){if(b instanceof C.$oM)return{id:b.id};const D=typeof b=="object"&&"dark"in b?b.dark:b,g=typeof b=="object"&&"light"in b?b.light:b;return{dark:typeof D=="string"?$.URI.file(D):D,light:typeof g=="string"?$.URI.file(g):g}}};e.$Zhc=a,e.$Zhc=a=Je([We(0,R.$JN),We(1,m.$fhc),We(2,k.$Thc),We(3,l.$ihc),We(4,p.$uhc),We(5,w.$Whc),We(6,n.$6N)],a);class t{constructor(b,D,g,f,y,P,T){this.f=b,this.g=D,this.h=g,this.j=f,this.k=y,this.l=P,this.m=T}get api(){const b=this;return this.d??=Object.freeze({id:b.g,type:b.h,get name(){return b.j},set name(D){b.j=D,b.f.$setDebugSessionName(b.g,D)},parentSession:b.m,workspaceFolder:b.k,configuration:b.l,customRequest(D,g){return b.f.$customDebugAdapterRequest(b.g,D,g)},getDebugProtocolBreakpoint(D){return b.f.$getDebugProtocolBreakpoint(b.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(b){this.j=b}get configuration(){return this.l}}e.$1hc=t;class h{constructor(b){this.value=Object.freeze({append(D){b.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$2hc=h;class c{constructor(b){this.d=b}onWillStartSession(){this.d.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(b):void 0)}onWillStopSession(){this.d.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.d.forEach(D=>D.onError?D.onError(b):void 0)}onExit(b,D){this.d.forEach(g=>g.onExit?g.onExit(b,D):void 0)}}class o extends E.$Kmb{constructor(b){super(),this.h=b,b.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.h.handleMessage(b)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let u=class extends a{constructor(b,D,g,f,y,P,T){super(b,D,g,f,y,P,T)}};e.$3hc=u,e.$3hc=u=Je([We(0,R.$JN),We(1,m.$fhc),We(2,k.$Thc),We(3,l.$ihc),We(4,p.$uhc),We(5,w.$Whc),We(6,n.$6N)],u)}),define(Ce[368],Ie([1,0,14,58,2,6,312,13,84,106,27,249,20,67,47,90]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=void 0;class w{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(v.$sj),t=n.get(m.$JN).getProxy(L.$rL.MainThreadErrors);I.setUnexpectedErrorHandler(h=>{r.error(h);const c=I.$3(h);t.$onUnexpectedError(c)})}static async installFullHandler(n){const r=n.get(v.$sj),a=n.get(m.$JN),t=n.get(S.$Thc),h=n.get(l.$4N),c=a.getProxy(L.$rL.MainThreadExtensionService),o=a.getProxy(L.$rL.MainThreadErrors),u=await t.getExtensionPathIndex(),d=new WeakMap;function b(f,y){if(d.has(f))return d.get(f).stack;let P="",T,U;for(const M of y)P+=`
	at ${M.toString()}`,U=M.getFileName(),!T&&U&&(T=u.findSubstr($.URI.file(U)));const z=`${f.name||"Error"}: ${f.message||""}${P}`;return d.set(f,{extensionIdentifier:T?.identifier,stack:z}),z}const D=Symbol("prepareStackTrace wrapped");let g=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(f){if(f===b||!f||f[D]){g=f||b;return}g=function(y,P){return b(y,P),f.call(Error,y,P)},Object.assign(g,{[D]:!0})}}),I.setUnexpectedErrorHandler(f=>{r.error(f);const y=I.$3(f),P=d.get(f);if(!P?.extensionIdentifier){o.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(P.extensionIdentifier,y);const T=h.onExtensionError(P.extensionIdentifier,f);r.trace("forwarded error to extension?",T,P)})}}e.$5ic=w;class s{constructor(n,r,a,t,h){this.a=a,this.b=new A.$38b(n,null,t),r=s.e(r,this.b);const c=new k.$9h(...(0,p.$5r)());c.set(R.$ZN,{_serviceBrand:void 0,...r,messagePorts:h}),c.set(m.$JN,new m.$KN(this.b)),c.set(E.$chc,new E.$dhc(t)),c.set(S.$Rhc,a);const o=new C.$Jq(c,!0);o.invokeFunction(w.installEarlyHandler),this.d=o.invokeFunction(u=>u.get(v.$sj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=o.invokeFunction(u=>u.get(S.$Thc)),this.c.initialize(),o.invokeFunction(w.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(L.$rL.MainThreadExtensionService);return $.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=$.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=$.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>$.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=$.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=$.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=$.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=$.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=$.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=$.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$6ic=s}),define(Ce[369],Ie([1,0,8,11,224,243,138,96,72,47,20,46,7,60,41,284,285,42,33]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;let n=class extends v.$Zhc{constructor(c,o,u,d,b,D,g,f){super(c,o,u,d,D,g,f),this.pb=b,this.nb=new t}X(c,o){switch(c.type){case"server":return new l.$$ic(c);case"pipeServer":return new l.$_ic(c);case"executable":return new l.$ajc(c,o.type)}return super.X(c,o)}fb(c,o){const u=l.$ajc.platformAdapterExecutable(o.getAllExtensionDescriptions(),c.type);if(u)return new m.$wM(u.command,u.args,u.options)}Y(){return new A.$O_b}async $runInTerminal(c,o){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(M=>{this.nb.onTerminalClosed(M)}));const u=await this.P.getConfigProvider(),d=this.pb.getDefaultShell(!0),b=this.pb.getDefaultShellArgs(!0),D=c.title||$.localize(0,null),g=JSON.stringify({shell:d,shellArgs:b});let f=await this.nb.checkout(g,D),y,P=!1;if(f)y=c.cwd;else{const M={shellPath:d,shellArgs:b,cwd:c.cwd,name:D,iconPath:new m.$oM("debug")};P=!0,f=this.pb.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.nb.insert(f,g)}f.show(!0);const T=await f.processId;P?await new Promise(M=>setTimeout(M,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(d.indexOf("powershell")>=0||d.indexOf("pwsh")>=0||d.indexOf("cmd.exe")>=0?f.sendText("cls"):d.indexOf("bash")>=0?f.sendText("clear"):F.$i?f.sendText("cls"):f.sendText("clear"));const U=(0,w.$cjc)(d,c.args,!!c.argsCanBeInterpretedByShell,y,c.env);f.sendText(U);const z=this.onDidTerminateDebugSession(M=>{M.id===o&&(this.nb.free(f),z.dispose())});return T}else if(c.kind==="external")return a(c,await this.P.getConfigProvider());return super.$runInTerminal(c,o)}};e.$djc=n,e.$djc=n=Je([We(0,R.$JN),We(1,S.$fhc),We(2,k.$Thc),We(3,s.$ihc),We(4,C.$Ghc),We(5,p.$uhc),We(6,E.$Whc),We(7,i.$6N)],n);let r;function a(h,c){if(!r)if(F.$i)r=new L.$y$b;else if(F.$j)r=new L.$z$b;else if(F.$k)r=new L.$A$b;else throw new Error("external terminals not supported on this platform");const o=c.getConfiguration("terminal");return r.runInTerminal(h.title,h.cwd,h.args,h.env||{},o.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(c,o){const d=[...this.b.entries()].map(([b,D])=>(0,I.$Xg)(async g=>{if(b.name!==o||D.lastUsedAt!==-1&&await(0,w.$bjc)(await b.processId))return null;const f=Date.now();return D.lastUsedAt+t.a>f||g.isCancellationRequested||D.config!==c?null:(D.lastUsedAt=f,b)}));return await(0,I.$dh)(d,b=>!!b)}insert(c,o){this.b.set(c,{lastUsedAt:Date.now(),config:o})}free(c){const o=this.b.get(c);o&&(o.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}}),define(Ce[370],Ie([1,0,17,2,104,41,73,42,40,46,20,27,95,16,13,91,23,64,60]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;let n=class extends m.$Jic{constructor(a,t,h,c,o,u,d,b,D){super(a,t,h,c,o,u,d,b),this.C=h,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const h=t;if(!t.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const c=m.TaskHandleDTO.from(h,this.C),o=await this.a.$getTaskExecution(c);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.z(o,t);return this.a.$executeTask(c).catch(()=>{}),u}else{const c=m.TaskDTO.from(t,a);if(c===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(c.execution)&&await this.y(c,t,!1);const o=await this.z(await this.a.$getTaskExecution(c),t);return this.a.$executeTask(c).catch(()=>{}),o}}v(a,t,h,c){const o=[];if(c)for(const u of c){this.A(u,h),(!u.definition||!a[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const d=m.TaskDTO.from(u,h.extension);d&&(o.push(d),m.CustomExecutionDTO.is(d.execution)&&t.push(this.y(d,u,!0)))}return{tasks:o,extension:h.extension}}async w(a){return a}async G(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const h=F.URI.file((0,s.homedir)());t=new p.$si({uri:h,name:w.$Ig(h),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const h=F.URI.revive(a),c={process:void 0,variables:Object.create(null)},o=await this.b.resolveWorkspaceFolder(h),u=await this.b.getWorkspaceFolders2()??[],d=await this.D.getResolver(),b=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(u);for(const D of t.variables)c.variables[D]=await d.resolveAsync(b,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(I.$tc);for(let g=0;g<D.length;g++)D[g]=await d.resolveAsync(b,D[g])}c.process=await $.win32.findExecutable(await d.resolveAsync(b,t.process.name),t.process.cwd!==void 0?await d.resolveAsync(b,t.process.cwd):void 0,D)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,h){return $.win32.findExecutable(a,t,h)}};e.$8ic=n,e.$8ic=n=Je([We(0,R.$JN),We(1,C.$ZN),We(2,L.$fhc),We(3,A.$UN),We(4,v.$ihc),We(5,k.$Ghc),We(6,S.$sj),We(7,l.$Ugc),We(8,i.$Whc)],n)}),define(Ce[371],Ie([1,0,64,60]),function(me,e,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class $ extends F.$Xhc{m(){return(0,I.homedir)()}}e.$Njc=$}),define(Ce[155],Ie([1,0,19,8,22,44,16,17,23,2,36]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=e.$gic=e.$fic=e.$eic=void 0;class C{constructor(i,n,r,a){this.d=i,this.e=n,this.f=r,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const r=this.d.folderQueries||[],a=new $.$9d(n);return new Promise((t,h)=>{this.a=new E(i);let c=!1;const o=(u,d)=>{if(!c&&!this.b){const b=this.h(u);l(u)&&typeof this.d.maxResults=="number"&&this.c+b>this.d.maxResults&&(this.b=!0,c=!0,a.cancel(),u=this.j(u,this.d.maxResults-this.c));const D=this.h(u);this.c+=D,(D>0||!l(u))&&this.a.add(u,d)}};Promise.all(r.map((u,d)=>this.k(u,b=>o(b,d),a.token))).then(u=>{a.dispose(),this.a.flush();const d=u.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||d,messages:(0,I.$Rb)(u.map(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[])),stats:{type:this.g}})},u=>{a.dispose();const d=(0,L.$Vi)(u);h(new Error(d))})})}h(i){return l(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const a=new R.$6J(this.d,i),t=[],h={report:u=>{if(!this.l(u))return;const d=i.folder.scheme===A.Schemas.file?(0,R.$7J)(()=>this.f.readdir(p.$Kg(u.uri))):void 0,b=p.$Ng(i.folder,u.uri);if(b){const D=a.includedInQuery(b,v.$nc(b),d);(0,F.$Wg)(D)?t.push(D.then(g=>{g&&n(u)})):D&&n(u)}}},c=this.n(i),o=await this.e.provideTextSearchResults(m(this.d.contentPattern),c,h,r);return t.length&&await Promise.all(t),o}l(i){if(l(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,R.$5J)(this.d.includePattern,i.includePattern),r=(0,R.$5J)(this.d.excludePattern,i.excludePattern),a={folder:k.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$eic=C;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class E{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new w(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!p.$Eg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$fic=E;function S(s){return l(s)?{preview:{matches:(0,I.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,I.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function l(s){return!!s.preview}e.$gic=l;class w{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<w.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},w.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$hic=w}),define(Ce[97],Ie([1,0,3,6,5,364,20,67,13,2,155]),function(me,e,I,F,$,L,A,v,p,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=e.$iic=void 0,e.$iic=(0,$.$$h)("IExtHostSearch");let C=class{constructor(l,w,s){this.k=l,this.l=w,this.n=s,this.c=this.k.getProxy(F.$rL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$dic}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,w){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const s=this.d++;return this.e.set(s,w),this.c.$registerTextSearchProvider(s,this.o(l)),(0,I.$Rc)(()=>{this.g.delete(l),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(l,w){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const s=this.d++;return this.h.set(s,w),this.c.$registerFileSearchProvider(s,this.o(l)),(0,I.$Rc)(()=>{this.i.delete(l),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(l,w,s,i){const n=m(s),r=this.h.get(l);if(r)return this.j.fileSearch(n,r,a=>{this.c.$handleFileMatch(l,w,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+l)}async doInternalFileSearchWithCustomCallback(l,w,s){return{messages:[]}}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,w,s,i){const n=this.e.get(l);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const r=m(s);return this.q(r,n).search(t=>this.c.$handleTextMatch(l,w,t),i)}$enableExtensionHostSearch(){}q(l,w){return new R.$eic(l,w,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$jic=C,e.$jic=C=Je([We(0,A.$JN),We(1,v.$chc),We(2,p.$sj)],C);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(E),extraFileResources:S.extraFileResources&&S.extraFileResources.map(l=>k.URI.revive(l))}}e.$kic=m;function E(S){return{...S,folder:k.URI.revive(S.folder)}}}),define(Ce[372],Ie([1,0,22,14,4,3,16,39,2,132,192,173,80,25,32,13,66,87,268,6,314,343,91,315,320,300,321,322,323,301,289,33,324,42,325,96,148,326,303,316,327,328,73,72,317,47,329,70,330,59,27,344,345,318,304,331,332,114,115,305,363,334,274,335,346,336,153,306,337,338,339,20,340,97,116,341,307,342,117,93,95,90,46,347,348,319,349,350,71,15,7,308,67,309,92,351,352,147,41,282,113,26,94]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h,c,o,u,d,b,D,g,f,y,P,T,U,z,M,N,O,j,Y,ne,ee,Q,X,ce,ie,fe,re,J,B,ae,Ee,le,de,ue,ge,V,Z,he,be,Pe,pe,Le,Me,W,x,H,K,oe,ye,Re,qe,Ge,Xe,it,lt,at,et,Ae,Se,He,te,se,De,Ve,Ke,nt,st,je,yt,kt,Ot,Rt,St,ti,Wt,si,Xt,xt,_e,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;function ii(dt){const $t=dt.get(J.$ZN),Yt=dt.get(re.$Ygc),ni=dt.get(ie.$khc),Lt=dt.get(X.$Thc),ft=dt.get(si.$fhc),Mt=dt.get(Se.$4N),oi=dt.get(P.$ihc),Ft=dt.get(kt.$chc),Ye=dt.get(ye.$JN),Kt=dt.get(at.$Dhc),Qt=dt.get(et.$lhc),_t=dt.get(l.$tj),gt=dt.get(l.$sj),jt=dt.get(nt.$Kzb),Nt=dt.get(t.$Ugc),zt=dt.get(Wt.$Yic),Vt=dt.get(Ge.$Lhc),Ut=dt.get(ee.$uhc),Ct=dt.get(V.$Phc);Ye.set(n.$sL.ExtHostFileSystemInfo,Yt),Ye.set(n.$sL.ExtHostLogLevelServiceShape,_t),Ye.set(n.$sL.ExtHostWorkspace,ft),Ye.set(n.$sL.ExtHostConfiguration,oi),Ye.set(n.$sL.ExtHostExtensionService,Lt),Ye.set(n.$sL.ExtHostStorage,Kt),Ye.set(n.$sL.ExtHostTunnelService,jt),Ye.set(n.$sL.ExtHostWindow,zt),Ye.set(n.$sL.ExtHostSecretState,Vt),Ye.set(n.$sL.ExtHostTelemetry,Mt),Ye.set(n.$sL.ExtHostEditorTabs,Ut),Ye.set(n.$sL.ExtHostManagedSockets,Ct);const Ht=Ye.set(n.$sL.ExtHostDecorations,dt.get(z.$5hc)),Et=Ye.set(n.$sL.ExtHostDocumentsAndEditors,dt.get(ne.$UN)),pt=Ye.set(n.$sL.ExtHostCommands,dt.get(f.$6N)),It=Ye.set(n.$sL.ExtHostTerminalService,dt.get(He.$Ghc)),Dt=Ye.set(n.$sL.ExtHostDebugService,dt.get(U.$Yhc)),ci=Ye.set(n.$sL.ExtHostSearch,dt.get(qe.$iic)),Zt=Ye.set(n.$sL.ExtHostTask,dt.get(Ae.$Lic)),gi=Ye.set(n.$sL.ExtHostOutputService,dt.get(W.$yic)),Gt=Ye.set(n.$sL.ExtHostLocalization,dt.get(ge.$Ohc)),mi=Ye.set(n.$sL.ExtHostUrls,new Ot.$Vic(Ye)),At=Ye.set(n.$sL.ExtHostDocuments,new Y.$2gc(Ye,Et)),Ne=Ye.set(n.$sL.ExtHostDocumentContentProviders,new O.$7hc(Ye,Et,gt)),Oe=Ye.set(n.$sL.ExtHostDocumentSaveParticipant,new j.$8hc(gt,At,Ye.getProxy(n.$rL.MainThreadBulkEdits))),ve=Ye.set(n.$sL.ExtHostNotebook,new he.$lic(Ye,pt,Et,At,ni,ci)),_=Ye.set(n.$sL.ExtHostNotebookDocuments,new Pe.$sic(ve)),Te=Ye.set(n.$sL.ExtHostNotebookEditors,new pe.$tic(gt,ve)),Be=Ye.set(n.$sL.ExtHostNotebookKernels,new Le.$uic(Ye,$t,ve,pt,gt)),xe=Ye.set(n.$sL.ExtHostNotebookRenderers,new Me.$wic(Ye,ve)),Qe=Ye.set(n.$sL.ExtHostNotebookDocumentSaveParticipant,new be.$ric(gt,ve,Ye.getProxy(n.$rL.MainThreadBulkEdits))),rt=Ye.set(n.$sL.ExtHostEditors,new se.$_gc(Ye,Et)),vt=Ye.set(n.$sL.ExtHostTreeViews,new Ke.$Tic(Ye.getProxy(n.$rL.MainThreadTreeViews),pt,gt)),Jt=Ye.set(n.$sL.ExtHostEditorInsets,new g.$ahc(Ye.getProxy(n.$rL.MainThreadEditorInsets),rt,$t.remote)),Bt=Ye.set(n.$sL.ExtHostDiagnostics,new M.$1gc(Ye,gt,Yt,Et)),Pt=Ye.set(n.$sL.ExtHostLanguages,new ue.$pic(Ye,At,pt.converter,Ft)),ct=Ye.set(n.$sL.ExtHostLanguageFeatures,new de.$3gc(Ye,Ft,At,pt,Bt,gt,Nt,Mt)),Qi=Ye.set(n.$sL.ExtHostFileSystem,new ce.$0hc(Ye,ct)),ui=Ye.set(n.$sL.ExtHostFileSystemEventService,new fe.$$hc(Ye,gt,Et)),$i=Ye.set(n.$sL.ExtHostQuickOpen,(0,oe.$Cic)(Ye,ft,pt)),yi=Ye.set(n.$sL.ExtHostSCM,new Re.$Eic(Ye,pt,At,gt)),Ai=Ye.set(n.$sL.ExtHostQuickDiff,new K.$Bic(Ye,Ft)),Zi=Ye.set(n.$sL.ExtHostShare,new Xe.$Fic(Ye,Ft)),ln=Ye.set(n.$sL.ExtHostComments,(0,y.$bhc)(Ye,pt,At)),Ri=Ye.set(n.$sL.ExtHostProgress,new H.$Aic(Ye.getProxy(n.$rL.MainThreadProgress))),Ni=Ye.set(n.$sL.ExtHostLabelService,new le.$oic(Ye)),Ei=Ye.set(n.$sL.ExtHostTheming,new De.$Qic(Ye)),bi=Ye.set(n.$sL.ExtHostAuthentication,new h.$5gc(Ye)),Xi=Ye.set(n.$sL.ExtHostTimeline,new Ve.$Sic(Ye,pt)),ki=Ye.set(n.$sL.ExtHostWebviews,new Rt.$phc(Ye,$t.remote,ft,gt,Nt)),Si=Ye.set(n.$sL.ExtHostWebviewPanels,new St.$shc(Ye,ki,ft)),xi=Ye.set(n.$sL.ExtHostCustomEditors,new T.$thc(Ye,At,Qt,ki,Si)),hn=Ye.set(n.$sL.ExtHostWebviewViews,new ti.$Wic(Ye,ki)),pi=Ye.set(n.$sL.ExtHostTesting,new te.$Mic(Ye,gt,pt,Et)),Mi=Ye.set(n.$sL.ExtHostUriOpeners,new yt.$Uic(Ye)),Fi=Ye.set(n.$sL.ExtHostProfileContentHandlers,new x.$zic(Ye));Ye.set(n.$sL.ExtHostInteractive,new ae.$mic(Ye,ve,Et,pt,gt));const dn=Ye.set(n.$sL.ExtHostInlineChat,new B.$_hc(Ye,pt,At,gt)),Di=Ye.set(n.$sL.ExtHostChatProvider,new d.$9gc(Ye,gt,bi)),_i=Ye.set(n.$sL.ExtHostChatAgents2,new u.$8gc(Ye,gt,pt)),fn=Ye.set(n.$sL.ExtHostChatVariables,new b.$0gc(Ye)),vi=Ye.set(n.$sL.ExtHostChat,new o.$7gc(Ye)),Ti=Ye.set(n.$sL.ExtHostAiRelatedInformation,new r.$Tgc(Ye)),en=Ye.set(n.$sL.ExtHostAiEmbeddingVector,new Q.$9hc(Ye)),Oi=Ye.set(n.$sL.ExtHostIssueReporter,new Ee.$nic(Ye)),tn=Ye.set(n.$sL.ExtHostStatusBar,new lt.$Iic(Ye,pt.converter)),ji=Ye.set(n.$sL.ExtHostSpeech,new it.$Gic(Ye)),nn=Object.values(n.$sL);Ye.assertRegistered(nn);const di=new c.$6gc(Ye,Et),Ci=new D.$$gc(Ye),zi=new Z.$qic(Ye,gt),ri=new N.$6hc(Ye);return a.$4gc.register(pt),function(ze,li,Ui){function ot($e){return(ke,Ue,ut)=>{const wt=$e(Tt=>{try{ke.call(Ue,Tt)}catch(Li){F.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Li.toString()}`,{cause:Li})),Mt.onExtensionError(ze.identifier,Li)}});return ut?.push(wt),wt}}const bt=function(){let $e=!ze.isUnderDevelopment;function ke(){$e||(gt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ue(ut){if(Array.isArray(ut))ut.forEach(Ue);else if(typeof ut=="string")ke();else{const wt=ut;typeof wt.scheme>"u"&&ke(),typeof wt.exclusive=="boolean"&&(0,_e.$OF)(ze,"documentFiltersExclusive")}return ut}}(),gn={getSession($e,ke,Ue){return bi.getSession(ze,$e,ke,Ue)},getSessions($e,ke){return(0,_e.$OF)(ze,"authGetSessions"),bi.getSessions(ze,$e,ke)},async hasSession($e,ke){return(0,_e.$OF)(ze,"authSession"),!!await bi.getSession(ze,$e,ke,{silent:!0})},get onDidChangeSessions(){return ot(bi.onDidChangeSessions)},registerAuthenticationProvider($e,ke,Ue,ut){return bi.registerAuthenticationProvider($e,ke,Ue,ut)}},rn={registerCommand($e,ke,Ue){return pt.registerCommand(!0,$e,ke,Ue,void 0,ze)},registerTextEditorCommand($e,ke,Ue){return pt.registerCommand(!0,$e,(...ut)=>{const wt=rt.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return wt.edit(Tt=>{ke.apply(Ue,[wt,Tt,...ut])}).then(Tt=>{Tt||gt.warn("Edits from command "+$e+" were not applied.")},Tt=>{gt.warn("An error occurred while running command "+$e,Tt)})},void 0,void 0,ze)},registerDiffInformationCommand:($e,ke,Ue)=>((0,_e.$OF)(ze,"diffCommand"),pt.registerCommand(!0,$e,async(...ut)=>{const wt=Et.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Tt=await rt.getDiffInformation(wt.id);ke.apply(Ue,[Tt,...ut])},void 0,void 0,ze)),executeCommand($e,...ke){return pt.executeCommand($e,...ke)},getCommands($e=!1){return pt.getCommands($e)}},Bi={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ci.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return ot(It.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$OF)(ze,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$OF)(ze,"telemetry"),ot(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Se.$3N)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,ke){return Se.$2N.validateSender($e),Mt.instantiateLogger(ze,$e,ke)},openExternal($e,ke){return zt.openUri($e,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===$t.environment.appUriScheme)return mi.createAppUri($e);try{return await zt.asExternalUri($e,{allowTunneling:!!$t.remote.authority})}catch(ke){if((0,A.$ig)($e,A.Schemas.http)||(0,A.$ig)($e,A.Schemas.https))return $e;throw ke}},get remoteName(){return(0,w.$gl)($t.remote.authority)},get remoteAuthority(){return(0,_e.$OF)(ze,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,_e.$OF)(ze,"handleIssueUri"),Oi.registerIssueUriRequestHandler(ze,$e)},registerIssueDataProvider($e){return(0,_e.$OF)(ze,"handleIssueUri"),Oi.registerIssueDataProvider(ze,$e)},get appQuality(){return(0,_e.$OF)(ze,"resolvers"),$t.quality},get appCommit(){return(0,_e.$OF)(ze,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Bi);const mn={createTestController($e,ke,Ue){return pi.createTestController(ze,$e,ke,Ue)},createTestObserver(){return(0,_e.$OF)(ze,"testObserver"),pi.createTestObserver()},runTests($e){return(0,_e.$OF)(ze,"testObserver"),pi.runTests($e)},get onDidChangeTestResults(){return(0,_e.$OF)(ze,"testObserver"),ot(pi.onResultsChanged)},get testResults(){return(0,_e.$OF)(ze,"testObserver"),pi.results}},Ii=$t.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,sn={getExtension($e,ke){(0,_e.$NF)(ze,"extensionsAny")||(ke=!1);const Ue=li.mine.getExtensionDescription($e);if(Ue)return new X.$Uhc(Lt,ze.identifier,Ue,Ii,!1);if(ke){const ut=li.all.getExtensionDescription($e);if(ut)return new X.$Uhc(Lt,ze.identifier,ut,Ii,!0)}},get all(){const $e=[];for(const ke of li.mine.getAllExtensionDescriptions())$e.push(new X.$Uhc(Lt,ze.identifier,ke,Ii,!1));return $e},get allAcrossExtensionHosts(){(0,_e.$OF)(ze,"extensionsAny");const $e=new E.$rm(li.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ke=[];for(const Ue of li.all.getAllExtensionDescriptions()){const ut=!$e.has(Ue.identifier);ke.push(new X.$Uhc(Lt,ze.identifier,Ue,Ii,ut))}return ke},get onDidChange(){return(0,_e.$NF)(ze,"extensionsAny")?ot($.Event.any(li.mine.onDidChange,li.all.onDidChange)):ot(li.mine.onDidChange)}},Wi={createDiagnosticCollection($e){return Bt.createDiagnosticCollection(ze.identifier,$e)},get onDidChangeDiagnostics(){return ot(Bt.onDidChangeDiagnostics)},getDiagnostics:$e=>Bt.getDiagnostics($e),getLanguages(){return Pt.getLanguages()},setTextDocumentLanguage($e,ke){return Pt.changeLanguage($e.uri,ke)},match($e,ke){const Ue=At.getDocumentData(ke.uri)?.notebook;return(0,R.$Gt)(st.LanguageSelector.from($e),ke.uri,ke.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider($e,ke,Ue){return ct.registerCodeActionProvider(ze,bt($e),ke,Ue)},registerDocumentPasteEditProvider($e,ke,Ue){return(0,_e.$OF)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,bt($e),ke,Ue)},registerCodeLensProvider($e,ke){return ct.registerCodeLensProvider(ze,bt($e),ke)},registerDefinitionProvider($e,ke){return ct.registerDefinitionProvider(ze,bt($e),ke)},registerDeclarationProvider($e,ke){return ct.registerDeclarationProvider(ze,bt($e),ke)},registerImplementationProvider($e,ke){return ct.registerImplementationProvider(ze,bt($e),ke)},registerTypeDefinitionProvider($e,ke){return ct.registerTypeDefinitionProvider(ze,bt($e),ke)},registerHoverProvider($e,ke){return ct.registerHoverProvider(ze,bt($e),ke,ze.identifier)},registerEvaluatableExpressionProvider($e,ke){return ct.registerEvaluatableExpressionProvider(ze,bt($e),ke,ze.identifier)},registerInlineValuesProvider($e,ke){return ct.registerInlineValuesProvider(ze,bt($e),ke,ze.identifier)},registerDocumentHighlightProvider($e,ke){return ct.registerDocumentHighlightProvider(ze,bt($e),ke)},registerMultiDocumentHighlightProvider($e,ke){return ct.registerMultiDocumentHighlightProvider(ze,bt($e),ke)},registerLinkedEditingRangeProvider($e,ke){return ct.registerLinkedEditingRangeProvider(ze,bt($e),ke)},registerReferenceProvider($e,ke){return ct.registerReferenceProvider(ze,bt($e),ke)},registerRenameProvider($e,ke){return ct.registerRenameProvider(ze,bt($e),ke)},registerNewSymbolNamesProvider($e,ke){return(0,_e.$OF)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,bt($e),ke)},registerDocumentSymbolProvider($e,ke,Ue){return ct.registerDocumentSymbolProvider(ze,bt($e),ke,Ue)},registerWorkspaceSymbolProvider($e){return ct.registerWorkspaceSymbolProvider(ze,$e)},registerDocumentFormattingEditProvider($e,ke){return ct.registerDocumentFormattingEditProvider(ze,bt($e),ke)},registerDocumentRangeFormattingEditProvider($e,ke){return ct.registerDocumentRangeFormattingEditProvider(ze,bt($e),ke)},registerOnTypeFormattingEditProvider($e,ke,Ue,...ut){return ct.registerOnTypeFormattingEditProvider(ze,bt($e),ke,[Ue].concat(ut))},registerDocumentSemanticTokensProvider($e,ke,Ue){return ct.registerDocumentSemanticTokensProvider(ze,bt($e),ke,Ue)},registerDocumentRangeSemanticTokensProvider($e,ke,Ue){return ct.registerDocumentRangeSemanticTokensProvider(ze,bt($e),ke,Ue)},registerSignatureHelpProvider($e,ke,Ue,...ut){return typeof Ue=="object"?ct.registerSignatureHelpProvider(ze,bt($e),ke,Ue):ct.registerSignatureHelpProvider(ze,bt($e),ke,typeof Ue>"u"?[]:[Ue,...ut])},registerCompletionItemProvider($e,ke,...Ue){return ct.registerCompletionItemProvider(ze,bt($e),ke,Ue)},registerInlineCompletionItemProvider($e,ke,Ue){return ke.handleDidShowCompletionItem&&(0,_e.$OF)(ze,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,_e.$OF)(ze,"inlineCompletionsAdditions"),Ue&&(0,_e.$OF)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,bt($e),ke,Ue)},registerDocumentLinkProvider($e,ke){return ct.registerDocumentLinkProvider(ze,bt($e),ke)},registerColorProvider($e,ke){return ct.registerColorProvider(ze,bt($e),ke)},registerFoldingRangeProvider($e,ke){return ct.registerFoldingRangeProvider(ze,bt($e),ke)},registerSelectionRangeProvider($e,ke){return ct.registerSelectionRangeProvider(ze,$e,ke)},registerCallHierarchyProvider($e,ke){return ct.registerCallHierarchyProvider(ze,$e,ke)},registerTypeHierarchyProvider($e,ke){return ct.registerTypeHierarchyProvider(ze,$e,ke)},setLanguageConfiguration:($e,ke)=>ct.setLanguageConfiguration(ze,$e,ke),getTokenInformationAtPosition($e,ke){return(0,_e.$OF)(ze,"tokenInformation"),Pt.tokenAtPosition($e,ke)},registerInlayHintsProvider($e,ke){return ct.registerInlayHintsProvider(ze,$e,ke)},createLanguageStatusItem($e,ke){return Pt.createLanguageStatusItem(ze,$e,ke)},registerDocumentDropEditProvider($e,ke,Ue){return ct.registerDocumentOnDropEditProvider(ze,$e,ke,(0,_e.$NF)(ze,"dropMetadata")?Ue:void 0)}},on={get activeTextEditor(){return rt.getActiveTextEditor()},get visibleTextEditors(){return rt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument($e,ke,Ue){p.URI.isUri($e)&&$e.scheme===A.Schemas.vscodeRemote&&!$e.authority&&Nt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await(p.URI.isUri($e)?Promise.resolve(qi.openTextDocument($e)):Promise.resolve($e));return rt.showTextDocument(ut,ke,Ue)},createTextEditorDecorationType($e){return rt.createTextEditorDecorationType(ze,$e)},onDidChangeActiveTextEditor($e,ke,Ue){return ot(rt.onDidChangeActiveTextEditor)($e,ke,Ue)},onDidChangeVisibleTextEditors($e,ke,Ue){return ot(rt.onDidChangeVisibleTextEditors)($e,ke,Ue)},onDidChangeTextEditorSelection($e,ke,Ue){return ot(rt.onDidChangeTextEditorSelection)($e,ke,Ue)},onDidChangeTextEditorOptions($e,ke,Ue){return ot(rt.onDidChangeTextEditorOptions)($e,ke,Ue)},onDidChangeTextEditorVisibleRanges($e,ke,Ue){return ot(rt.onDidChangeTextEditorVisibleRanges)($e,ke,Ue)},onDidChangeTextEditorViewColumn($e,ke,Ue){return ot(rt.onDidChangeTextEditorViewColumn)($e,ke,Ue)},onDidCloseTerminal($e,ke,Ue){return ot(It.onDidCloseTerminal)($e,ke,Ue)},onDidOpenTerminal($e,ke,Ue){return ot(It.onDidOpenTerminal)($e,ke,Ue)},onDidChangeActiveTerminal($e,ke,Ue){return ot(It.onDidChangeActiveTerminal)($e,ke,Ue)},onDidChangeTerminalDimensions($e,ke,Ue){return(0,_e.$OF)(ze,"terminalDimensions"),ot(It.onDidChangeTerminalDimensions)($e,ke,Ue)},onDidChangeTerminalState($e,ke,Ue){return ot(It.onDidChangeTerminalState)($e,ke,Ue)},onDidWriteTerminalData($e,ke,Ue){return(0,_e.$OF)(ze,"terminalDataWriteEvent"),ot(It.onDidWriteTerminalData)($e,ke,Ue)},onDidExecuteTerminalCommand($e,ke,Ue){return(0,_e.$OF)(ze,"terminalExecuteCommandEvent"),ot(It.onDidExecuteTerminalCommand)($e,ke,Ue)},get state(){return zt.getState(ze)},onDidChangeWindowState($e,ke,Ue){return ot(zt.onDidChangeWindowState)($e,ke,Ue)},showInformationMessage($e,...ke){return zi.showMessage(ze,v.default.Info,$e,ke[0],ke.slice(1))},showWarningMessage($e,...ke){return zi.showMessage(ze,v.default.Warning,$e,ke[0],ke.slice(1))},showErrorMessage($e,...ke){return zi.showMessage(ze,v.default.Error,$e,ke[0],ke.slice(1))},showQuickPick($e,ke,Ue){return $i.showQuickPick(ze,$e,ke,Ue)},showWorkspaceFolderPick($e){return $i.showWorkspaceFolderPick($e)},showInputBox($e,ke){return $i.showInput($e,ke)},showOpenDialog($e){return ri.showOpenDialog(ze,$e)},showSaveDialog($e){return ri.showSaveDialog($e)},createStatusBarItem($e,ke,Ue){let ut,wt,Tt;return typeof $e=="string"?(ut=$e,wt=ke,Tt=Ue):(wt=$e,Tt=ke),tn.createStatusBarEntry(ze,ut,wt,Tt)},setStatusBarMessage($e,ke){return tn.setStatusBarMessage($e,ke)},withScmProgress($e){return Nt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ri.withProgress(ze,{location:je.ProgressLocation.SourceControl},(ke,Ue)=>$e({report(ut){}}))},withProgress($e,ke){return Ri.withProgress(ze,$e,ke)},createOutputChannel($e,ke){return gi.createOutputChannel($e,ke,ze)},createWebviewPanel($e,ke,Ue,ut){return Si.createWebviewPanel(ze,$e,ke,Ue,ut)},createWebviewTextEditorInset($e,ke,Ue,ut){return(0,_e.$OF)(ze,"editorInsets"),Jt.createWebviewEditorInset($e,ke,Ue,ut,ze)},createTerminal($e,ke,Ue){return typeof $e=="object"?"pty"in $e?It.createExtensionTerminal($e):It.createTerminalFromOptions($e):It.createTerminal($e,ke,Ue)},registerTerminalLinkProvider($e){return It.registerLinkProvider($e)},registerTerminalProfileProvider($e,ke){return It.registerProfileProvider(ze,$e,ke)},registerTerminalQuickFixProvider($e,ke){return(0,_e.$OF)(ze,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider($e,ze.identifier.value,ke)},registerTreeDataProvider($e,ke){return vt.registerTreeDataProvider($e,ke,ze)},createTreeView($e,ke){return vt.createTreeView($e,ke,ze)},registerWebviewPanelSerializer:($e,ke)=>Si.registerWebviewPanelSerializer(ze,$e,ke),registerCustomEditorProvider:($e,ke,Ue={})=>xi.registerCustomEditorProvider(ze,$e,ke,Ue),registerFileDecorationProvider($e){return Ht.registerFileDecorationProvider($e,ze)},registerUriHandler($e){return mi.registerUriHandler(ze,$e)},createQuickPick(){return $i.createQuickPick(ze)},createInputBox(){return $i.createInputBox(ze)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme($e,ke,Ue){return ot(Ei.onDidChangeActiveColorTheme)($e,ke,Ue)},registerWebviewViewProvider($e,ke,Ue){return hn.registerWebviewViewProvider(ze,$e,ke,Ue?.webviewOptions)},get activeNotebookEditor(){return ve.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,ke,Ue){return ot(ve.onDidChangeActiveNotebookEditor)($e,ke,Ue)},get visibleNotebookEditors(){return ve.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(ve.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,ke,Ue){return ot(Te.onDidChangeNotebookEditorSelection)($e,ke,Ue)},onDidChangeNotebookEditorVisibleRanges($e,ke,Ue){return ot(Te.onDidChangeNotebookEditorVisibleRanges)($e,ke,Ue)},showNotebookDocument($e,ke){return ve.showNotebookDocument($e,ke)},registerExternalUriOpener($e,ke,Ue){return(0,_e.$OF)(ze,"externalUriOpener"),Mi.registerExternalUriOpener(ze.identifier,$e,ke,Ue)},registerProfileContentHandler($e,ke){return(0,_e.$OF)(ze,"profileContentHandlers"),Fi.registerProfileContentHandler(ze,$e,ke)},registerQuickDiffProvider($e,ke,Ue,ut){return(0,_e.$OF)(ze,"quickDiffProvider"),Ai.registerQuickDiffProvider(bt($e),ke,Ue,ut)},get tabGroups(){return Ut.tabGroups},registerShareProvider($e,ke){return(0,_e.$OF)(ze,"shareProvider"),Zi.registerShareProvider(bt($e),ke)}},qi={get rootPath(){return Nt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new F.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new F.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new F.$9("workspaceFile")},updateWorkspaceFolders:($e,ke,...Ue)=>ft.updateWorkspaceFolders(ze,$e,ke||0,...Ue),onDidChangeWorkspaceFolders:function($e,ke,Ue){return ot(ft.onDidChangeWorkspace)($e,ke,Ue)},asRelativePath:($e,ke)=>ft.getRelativePath($e,ke),findFiles:($e,ke,Ue,ut)=>ft.findFiles($e,ke,Ue,ze.identifier,ut),findFiles2:($e,ke,Ue)=>((0,_e.$OF)(ze,"findFiles2"),ft.findFiles2($e,ke,ze.identifier,Ue)),findTextInFiles:($e,ke,Ue,ut)=>{(0,_e.$OF)(ze,"findTextInFiles");let wt,Tt;return typeof ke=="object"?(wt=ke,Tt=Ue):(wt={},Tt=ke,ut=Ue),ft.findTextInFiles($e,wt||{},Tt,ze.identifier,ut)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,ke){return di.applyWorkspaceEdit($e,ze,ke)},createFileSystemWatcher:($e,ke,Ue,ut)=>{let wt;return typeof ke=="boolean"?wt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ut,correlate:!1}:ke&&((0,_e.$OF)(ze,"createFileSystemWatcher"),wt={...ke,correlate:!0}),ui.createFileSystemWatcher(ft,ze,$e,wt)},get textDocuments(){return At.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new F.$9("textDocuments")},openTextDocument($e){let ke;const Ue=$e;if(typeof $e=="string")ke=Promise.resolve(p.URI.file($e));else if(p.URI.isUri($e))ke=Promise.resolve($e);else if(!Ue||typeof Ue=="object")ke=At.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(ut=>(ut.scheme===A.Schemas.vscodeRemote&&!ut.authority&&Nt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),At.ensureDocumentData(ut).then(wt=>wt.document)))},onDidOpenTextDocument:($e,ke,Ue)=>ot(At.onDidAddDocument)($e,ke,Ue),onDidCloseTextDocument:($e,ke,Ue)=>ot(At.onDidRemoveDocument)($e,ke,Ue),onDidChangeTextDocument:($e,ke,Ue)=>ot(At.onDidChangeDocument)($e,ke,Ue),onDidSaveTextDocument:($e,ke,Ue)=>ot(At.onDidSaveDocument)($e,ke,Ue),onWillSaveTextDocument:($e,ke,Ue)=>ot(Oe.getOnWillSaveTextDocumentEvent(ze))($e,ke,Ue),get notebookDocuments(){return ve.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,ke){let Ue;if(p.URI.isUri($e))Ue=$e,await ve.openNotebookDocument($e);else if(typeof $e=="string")Ue=p.URI.revive(await ve.createNotebookDocument({viewType:$e,content:ke}));else throw new Error("Invalid arguments");return ve.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument($e,ke,Ue){return ot(_.onDidSaveNotebookDocument)($e,ke,Ue)},onDidChangeNotebookDocument($e,ke,Ue){return ot(_.onDidChangeNotebookDocument)($e,ke,Ue)},onWillSaveNotebookDocument($e,ke,Ue){return ot(Qe.getOnWillSaveNotebookDocumentEvent(ze))($e,ke,Ue)},get onDidOpenNotebookDocument(){return ot(ve.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(ve.onDidCloseNotebookDocument)},registerNotebookSerializer($e,ke,Ue,ut){return ve.registerNotebookSerializer(ze,$e,ke,Ue,(0,_e.$NF)(ze,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:($e,ke,Ue)=>ot(Ui.onDidChangeConfiguration)($e,ke,Ue),getConfiguration($e,ke){return ke=arguments.length===1?void 0:ke,Ui.getConfiguration($e,ke,ze)},registerTextDocumentContentProvider($e,ke){return Ne.registerTextDocumentContentProvider($e,ke)},registerTaskProvider:($e,ke)=>(Nt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(ze,$e,ke)),registerFileSystemProvider($e,ke,Ue){return(0,L.$Qc)(Qi.registerFileSystemProvider(ze,$e,ke,Ue),ni.addFileSystemProvider($e,ke,Ue))},get fs(){return ni.value},registerFileSearchProvider:($e,ke)=>((0,_e.$OF)(ze,"fileSearchProvider"),ci.registerFileSearchProvider($e,ke)),registerTextSearchProvider:($e,ke)=>((0,_e.$OF)(ze,"textSearchProvider"),ci.registerTextSearchProvider($e,ke)),registerRemoteAuthorityResolver:($e,ke)=>((0,_e.$OF)(ze,"resolvers"),Lt.registerRemoteAuthorityResolver($e,ke)),registerResourceLabelFormatter:$e=>((0,_e.$OF)(ze,"resolvers"),Ni.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,_e.$OF)(ze,"resolvers"),Lt.getRemoteExecServer($e)),onDidCreateFiles:($e,ke,Ue)=>ot(ui.onDidCreateFile)($e,ke,Ue),onDidDeleteFiles:($e,ke,Ue)=>ot(ui.onDidDeleteFile)($e,ke,Ue),onDidRenameFiles:($e,ke,Ue)=>ot(ui.onDidRenameFile)($e,ke,Ue),onWillCreateFiles:($e,ke,Ue)=>ot(ui.getOnWillCreateFileEvent(ze))($e,ke,Ue),onWillDeleteFiles:($e,ke,Ue)=>ot(ui.getOnWillDeleteFileEvent(ze))($e,ke,Ue),onWillRenameFiles:($e,ke,Ue)=>ot(ui.getOnWillRenameFileEvent(ze))($e,ke,Ue),openTunnel:$e=>((0,_e.$OF)(ze,"tunnels"),jt.openTunnel(ze,$e).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,_e.$OF)(ze,"tunnels"),jt.getTunnels()},onDidChangeTunnels:($e,ke,Ue)=>((0,_e.$OF)(ze,"tunnels"),ot(jt.onDidChangeTunnels)($e,ke,Ue)),registerPortAttributesProvider:($e,ke)=>((0,_e.$OF)(ze,"portsAttributes"),jt.registerPortsAttributesProvider($e,ke)),registerTunnelProvider:($e,ke)=>((0,_e.$OF)(ze,"tunnelFactory"),jt.registerTunnelProvider($e,ke)),registerTimelineProvider:($e,ke)=>((0,_e.$OF)(ze,"timeline"),Xi.registerTimelineProvider($e,ke,ze.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,_e.$OF)(ze,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,ke,Ue)=>ot(ft.onDidGrantWorkspaceTrust)($e,ke,Ue),registerEditSessionIdentityProvider:($e,ke)=>((0,_e.$OF)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,ke)),onWillCreateEditSessionIdentity:($e,ke,Ue)=>((0,_e.$OF)(ze,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(ze))($e,ke,Ue)),registerCanonicalUriProvider:($e,ke)=>((0,_e.$OF)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,ke)),getCanonicalUri:($e,ke,Ue)=>((0,_e.$OF)(ze,"canonicalUriProvider"),ft.provideCanonicalUri($e,ke,Ue))},an={get inputBox(){return Nt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(ze)},createSourceControl($e,ke,Ue){return yi.createSourceControl(ze,$e,ke,Ue)}},$n={createCommentController($e,ke){return ln.createCommentController(ze,$e,ke)}},bn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get stackFrameFocus(){return Dt.stackFrameFocus},registerDebugVisualizationProvider($e,ke){return(0,_e.$OF)(ze,"debugVisualization"),Dt.registerDebugVisualizationProvider(ze,$e,ke)},registerDebugVisualizationTreeProvider($e,ke){return(0,_e.$OF)(ze,"debugVisualization"),Dt.registerDebugVisualizationTree(ze,$e,ke)},onDidStartDebugSession($e,ke,Ue){return ot(Dt.onDidStartDebugSession)($e,ke,Ue)},onDidTerminateDebugSession($e,ke,Ue){return ot(Dt.onDidTerminateDebugSession)($e,ke,Ue)},onDidChangeActiveDebugSession($e,ke,Ue){return ot(Dt.onDidChangeActiveDebugSession)($e,ke,Ue)},onDidReceiveDebugSessionCustomEvent($e,ke,Ue){return ot(Dt.onDidReceiveDebugSessionCustomEvent)($e,ke,Ue)},onDidChangeBreakpoints($e,ke,Ue){return ot(Dt.onDidChangeBreakpoints)($e,ke,Ue)},onDidChangeStackFrameFocus($e,ke,Ue){return(0,_e.$OF)(ze,"debugFocus"),ot(Dt.onDidChangeStackFrameFocus)($e,ke,Ue)},registerDebugConfigurationProvider($e,ke,Ue){return Dt.registerDebugConfigurationProvider($e,ke,Ue||Xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,ke){return Dt.registerDebugAdapterDescriptorFactory(ze,$e,ke)},registerDebugAdapterTrackerFactory($e,ke){return Dt.registerDebugAdapterTrackerFactory($e,ke)},startDebugging($e,ke,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging($e,ke,{parentSession:Ue}):Dt.startDebugging($e,ke,Ue||{})},stopDebugging($e){return Dt.stopDebugging($e)},addBreakpoints($e){return Dt.addBreakpoints($e)},removeBreakpoints($e){return Dt.removeBreakpoints($e)},asDebugSourceUri($e,ke){return Dt.asDebugSourceUri($e,ke)}},cn={registerTaskProvider:($e,ke)=>Zt.registerTaskProvider(ze,$e,ke),fetchTasks:$e=>Zt.fetchTasks($e),executeTask:$e=>Zt.executeTask(ze,$e),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:($e,ke,Ue)=>ot(Zt.onDidStartTask)($e,ke,Ue),onDidEndTask:($e,ke,Ue)=>ot(Zt.onDidEndTask)($e,ke,Ue),onDidStartTaskProcess:($e,ke,Ue)=>ot(Zt.onDidStartTaskProcess)($e,ke,Ue),onDidEndTaskProcess:($e,ke,Ue)=>ot(Zt.onDidEndTaskProcess)($e,ke,Ue)},un={createNotebookController($e,ke,Ue,ut,wt){return Be.createNotebookController(ze,$e,ke,Ue,ut,(0,_e.$NF)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:($e,ke)=>ve.registerNotebookCellStatusBarItemProvider(ze,$e,ke),createRendererMessaging($e){return xe.createRendererMessaging(ze,$e)},createNotebookControllerDetectionTask($e){return(0,_e.$OF)(ze,"notebookKernelSource"),Be.createNotebookControllerDetectionTask(ze,$e)},registerKernelSourceActionProvider($e,ke){return(0,_e.$OF)(ze,"notebookKernelSource"),Be.registerKernelSourceActionProvider(ze,$e,ke)},onDidChangeNotebookCellExecutionState($e,ke,Ue){return(0,_e.$OF)(ze,"notebookCellExecutionState"),ot(Be.onDidChangeNotebookCellExecutionState)($e,ke,Ue)}},Vi={t(...$e){if(typeof $e[0]=="string"){const ke=$e.shift(),Ue=!$e||typeof $e[0]!="object"?$e:$e[0];return Gt.getMessage(ze.identifier.value,{message:ke,args:Ue})}return Gt.getMessage(ze.identifier.value,$e[0])},get bundle(){return Gt.getBundle(ze.identifier.value)},get uri(){return Gt.getBundleUri(ze.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider($e,ke){return(0,_e.$OF)(ze,"interactive"),dn.registerProvider(ze,$e,ke)},registerInteractiveSessionProvider($e,ke){return(0,_e.$OF)(ze,"interactive"),vi.registerChatProvider(ze,$e,ke)},sendInteractiveRequestToProvider($e,ke){return(0,_e.$OF)(ze,"interactive"),vi.sendInteractiveRequestToProvider($e,ke)},transferChatSession($e,ke){return(0,_e.$OF)(ze,"interactive"),vi.transferChatSession($e,ke)}},Gi={getRelatedInformation($e,ke){return(0,_e.$OF)(ze,"aiRelatedInformation"),Ti.getRelatedInformation(ze,$e,ke)},registerRelatedInformationProvider($e,ke){return(0,_e.$OF)(ze,"aiRelatedInformation"),Ti.registerRelatedInformationProvider(ze,$e,ke)},registerEmbeddingVectorProvider($e,ke){return(0,_e.$OF)(ze,"aiRelatedInformation"),en.registerEmbeddingVectorProvider(ze,$e,ke)}},Pi={registerChatResponseProvider($e,ke,Ue){return(0,_e.$OF)(ze,"chatProvider"),Di.registerLanguageModel(ze,$e,ke,Ue)},requestLanguageModelAccess($e,ke){return(0,_e.$OF)(ze,"chatRequestAccess"),Di.requestLanguageModelAccess(ze,$e,ke)},get languageModels(){return(0,_e.$OF)(ze,"chatRequestAccess"),Di.getLanguageModelIds()},onDidChangeLanguageModels:($e,ke,Ue)=>((0,_e.$OF)(ze,"chatRequestAccess"),Di.onDidChangeProviders($e,ke,Ue)),registerVariable($e,ke,Ue){return(0,_e.$OF)(ze,"chatAgents2"),fn.registerVariableResolver(ze,$e,ke,Ue)},registerMappedEditsProvider($e,ke){return(0,_e.$OF)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,$e,ke)},createChatAgent($e,ke){return(0,_e.$OF)(ze,"chatAgents2"),_i.createChatAgent(ze,$e,ke)}},Ji={registerSpeechProvider($e,ke){return(0,_e.$OF)(ze,"speech"),ji.registerProvider(ze.identifier,$e,ke)}};return{version:$t.version,ai:Gi,authentication:gn,commands:rn,comments:$n,chat:Pi,debug:bn,env:Bi,extensions:sn,interactive:Hi,l10n:Vi,languages:Wi,notebooks:un,scm:an,speech:Ji,tasks:cn,tests:mn,window:on,workspace:qi,Breakpoint:je.$sM,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatAgentResultFeedbackKind:je.ChatAgentResultFeedbackKind,ChatMessage:je.$mN,ChatMessageRole:je.ChatMessageRole,ChatVariableLevel:je.ChatVariableLevel,ChatAgentCompletionItem:je.$lN,CallHierarchyIncomingCall:je.$RL,CallHierarchyItem:je.$QL,CallHierarchyOutgoingCall:je.$SL,CancellationError:F.$5,CancellationTokenSource:I.$9d,CandidatePortSource:n.CandidatePortSource,CodeAction:je.$NL,CodeActionKind:je.$OL,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$TL,Color:je.$7L,ColorInformation:je.$8L,ColorPresentation:je.$9L,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$1L,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$2L,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$eM,DebugAdapterExecutable:je.$wM,DebugAdapterInlineImplementation:je.$zM,DebugAdapterNamedPipeServer:je.$yM,DebugAdapterServer:je.$xM,DebugConfigurationProviderTriggerKind:Xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DebugVisualization:je.$PM,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$HL,DiagnosticRelatedInformation:je.$GL,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$tL,DocumentHighlight:je.$JL,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$KL,DocumentLink:je.$6L,DocumentSymbol:je.$ML,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$CM,InlineValueText:je.$DM,InlineValueVariableLookup:je.$EM,InlineValueEvaluatableExpression:je.$FM,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:$.$Yd,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$RM,FileDecoration2:je.$RM,FileSystemError:je.$IM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:je.$JM,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$uM,InlineCompletionItem:je.$3L,InlineCompletionList:je.$4L,Hover:je.$IL,IndentAction:C.IndentAction,Location:je.$FL,MarkdownString:je.$UL,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:je.$VL,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$uL,ProcessExecution:je.$cM,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$QM,Range:je.$vL,RelativePattern:je.$qM,Selection:je.$wL,SelectionRange:je.$PL,SemanticTokens:je.$MM,SemanticTokensBuilder:je.$LM,SemanticTokensEdit:je.$NM,SemanticTokensEdits:je.$OM,SemanticTokensLegend:je.$KM,ShellExecution:je.$dM,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$XL,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$WL,SnippetString:je.$EL,SourceBreakpoint:je.$tM,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$LL,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$fM,TaskGroup:je.$bM,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$0L,TerminalQuickFixTerminalCommand:je.$_L,TerminalQuickFixOpener:je.$$L,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$aM,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$AL,SnippetTextEdit:je.$CL,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$pM,ThemeIcon:je.$oM,TreeItem:je.$gM,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$aN,UIKind:xt.UIKind,Uri:p.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$DL,DocumentDropEdit:je.$mM,DocumentPasteEdit:je.$nM,InlayHint:je.$ZL,InlayHintLabelPart:je.$YL,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$zL,ResolvedAuthority:je.$xL,ManagedResolvedAuthority:je.$yL,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$2M,NotebookRange:je.$TM,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$UM,NotebookData:je.$VM,NotebookRendererScript:je.$ZM,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$XM,NotebookCellOutputItem:je.$WM,NotebookCellStatusBarItem:je.$YM,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$BL,NotebookKernelSourceAction:je.$1M,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$4M,LinkedEditingRanges:je.$3M,TestResultState:je.TestResultState,TestRunRequest:je.$5M,TestMessage:je.$6M,TestTag:je.$7M,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:qt.TextSearchCompleteMessageType,DataTransfer:je.$lM,DataTransferItem:je.$hM,CoveredCount:je.$8M,FileCoverage:je.$9M,StatementCoverage:je.$0M,BranchCoverage:je.$$M,DeclarationCoverage:je.$_M,FunctionCoverage:je.$_M,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$bN,TabInputTextDiff:je.$cN,TabInputTextMerge:je.$dN,TabInputCustom:je.$eN,TabInputNotebook:je.$gN,TabInputNotebookDiff:je.$hN,TabInputWebview:je.$fN,TabInputTerminal:je.$iN,TabInputInteractiveWindow:je.$jN,TabInputChat:je.$kN,TelemetryTrustedValue:s.$Qo,LogLevel:l.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,ChatAgentCopyKind:je.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrameFocus:je.$AM,ThreadFocus:je.$BM,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus,KeywordRecognitionStatus:je.KeywordRecognitionStatus,ChatResponseTextPart:je.$nN,ChatResponseMarkdownPart:je.$oN,ChatResponseFileTreePart:je.$pN,ChatResponseAnchorPart:je.$qN,ChatResponseProgressPart:je.$rN,ChatResponseReferencePart:je.$tN,ChatResponseCommandButtonPart:je.$sN,ChatAgentRequestTurn:je.$uN,ChatAgentResponseTurn:je.$vN,LanguageModelSystemMessage:je.$wN,LanguageModelUserMessage:je.$xN,LanguageModelAssistantMessage:je.$yN,NewSymbolName:je.$HM,NewSymbolNameTag:je.NewSymbolNameTag}}}e.$Zic=ii}),define(Ce[373],Ie([1,0,84,153,41,148,42,33,73,46,95,96,97,117,71,91,147,70,59,116,90,72,146,13,60,114,115]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h,c,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$4r)(o.$Ohc,o.$Nhc,1),(0,I.$4r)(h.$tj,t.$1ic,1),(0,I.$4r)(l.$Ugc,l.$Vgc,1),(0,I.$4r)(v.$6N,v.$5N,0),(0,I.$4r)(A.$ihc,A.$ghc,0),(0,I.$4r)(s.$khc,s.$jhc,0),(0,I.$4r)(C.$Yhc,C.$3hc,0),(0,I.$4r)(L.$5hc,L.$4hc,0),(0,I.$4r)(p.$UN,p.$TN,0),(0,I.$4r)(u.$Phc,u.$Qhc,0),(0,I.$4r)(i.$Ygc,i.$Xgc,0),(0,I.$4r)(F.$yic,F.$xic,1),(0,I.$4r)(m.$iic,m.$jic,0),(0,I.$4r)(E.$Dhc,E.$Chc,0),(0,I.$4r)(R.$Lic,R.$Kic,0),(0,I.$4r)(k.$Ghc,k.$Jhc,0),(0,I.$4r)(S.$Kzb,S.$Lzb,0),(0,I.$4r)(w.$Yic,w.$Xic,0),(0,I.$4r)($.$fhc,$.$ehc,0),(0,I.$4r)(n.$Lhc,n.$Khc,0),(0,I.$4r)(r.$4N,r.$1N,0),(0,I.$4r)(a.$uhc,a.$vhc,0),(0,I.$4r)(c.$Whc,c.$Xhc,0)}),define(Ce[119],Ie([1,0,19,13,36,94]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=e.$fjc=e.$ejc=void 0;function A(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$ejc=A;function v(C,m,E,S){const l=(0,I.$2b)(E,p),w=new $.$RJ(m,l,S),s=w.preview.matches;return{ranges:(0,I.$2b)(l,k),uri:C,preview:{text:w.preview.text,matches:(0,I.$2b)(s,k)}}}e.$fjc=v;function p(C){return new $.$SJ(C.start.line,C.start.character,C.end.line,C.end.character)}function k(C){return new L.$GJ(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let R=class{constructor(m,E){this.a=m,this.b=E}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$gjc=R,e.$gjc=R=Je([We(1,F.$sj)],R)}),define(Ce[374],Ie([1,0,50,17,77,34,11,12,119,375]),function(me,e,I,F,$,L,A,v,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=e.$ijc=e.$hjc=void 0;const R=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,r,a,t){const h=m(n,r,a,t),c=r.folder.fsPath;return{cmd:I.spawn(R,h.args,{cwd:c}),rgDiskPath:R,siblingClauses:h.siblingClauses,rgArgs:h,cwd:c}}e.$hjc=C;function m(n,r,a,t){const h=["--files","--hidden","--case-sensitive","--no-require-git"];S([r],a,!1).forEach(o=>{const u=(0,p.$ejc)(o);if(h.push("-g",u),A.$j){const d=(0,$.$Ml)(u);d!==u&&h.push("-g",d)}});const c=E([r],t,void 0,!1);return c.globArgs.forEach(o=>{const u=`!${(0,p.$ejc)(o)}`;if(h.push("-g",u),A.$j){const d=(0,$.$Ml)(u);d!==u&&h.push("-g",d)}}),r.disregardIgnoreFiles!==!1?h.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),r.ignoreSymlinks||h.push("--follow"),n.exists&&h.push("--quiet"),h.push("--no-config"),r.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:c.siblingClauses}}function E(n,r,a,t=!0){const h=[];let c={};return n.forEach(o=>{const u=Object.assign({},o.excludePattern||{},r||{}),d=l(u,t?o.folder.fsPath:void 0,a);h.push(...d.globArgs),d.siblingClauses&&(c=Object.assign(c,d.siblingClauses))}),{globArgs:h,siblingClauses:c}}function S(n,r,a=!0){const t=[];return n.forEach(h=>{const c=Object.assign({},r||{},h.includePattern||{}),o=l(c,a?h.folder.fsPath:void 0);t.push(...o.globArgs)}),t}function l(n,r,a){const t=[],h={};return Object.keys(n).forEach(c=>{if(a&&a.has(c)||!c)return;const o=n[c];c=s(r?w(r,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof o=="boolean"&&o?(c.startsWith("\\\\")&&(c+="**"),t.push(i(c))):o&&o.when&&(h[c]=o)}),{globArgs:t,siblingClauses:h}}function w(n,r){return F.$ic(r)?r:F.$jc(n,r)}e.$ijc=w;function s(n){return n=v.$Xe(n,"\\"),v.$Xe(n,"/")}function i(n){return L.$8f(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$jjc=i}),define(Ce[376],Ie([1,0,50,57,17,377,19,44,35,77,34,11,38,12,18,31,36,374,129]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=e.$kjc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(c=>c())});class r{constructor(o){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=o,this.b=o.filePattern||"",this.d=o.includePattern&&p.$Rj(o.includePattern),this.f=o.maxResults||null,this.g=!!o.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=o.shouldGlobMatchFilePattern?null:(0,i.$5q)(this.b).normalizedLowercase),this.u=o.excludePattern&&p.$Rj(o.excludePattern),this.t=new Map,o.folderQueries.forEach(u=>{const d=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),b=u.folder.fsPath;o.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==b).forEach(D=>{(0,R.$_f)(D,b)&&(d[$.$lc(b,D)]=!0)}),this.t.set(b,new t(d,b))})}cancel(){this.l=!0,n.forEach(o=>o())}walk(o,u,d,b,D){if(this.m=m.$Ud.create(!1),this.l)return D(null,this.j);u.forEach(g=>{const f=$.$nc(g.fsPath);this.u&&this.u(g.fsPath,f)||this.J(d,{relativePath:g.fsPath,searchPath:void 0})}),this.r=m.$Ud.create(!1),this.w(o,(g,f)=>{this.x(this.y,this,g,d,b,y=>{if(y){const P=(0,v.$Vi)(y);console.error(P),this.q.push(P),f(y,void 0)}else f(null,void 0)})},(g,f)=>{this.m.stop();const y=g?A.$Hb(g)[0]:null;D(y,this.j)})}w(o,u,d){const b=new Array(o.length),D=new Array(o.length);let g=!1,f=0;if(o.length===0)return d(null,[]);o.forEach((y,P)=>{u(y,(T,U)=>{if(T?(g=!0,b[P]=null,D[P]=T):(b[P]=U,D[P]=null),++f===o.length)return d(g?D:null,b)})})}x(o,u,...d){try{o.apply(u,d)}catch(b){d[d.length-1](b)}}y(o,u,d,b){const D=o.folder.fsPath,g=C.$j,f=()=>z&&z.kill();n.add(f);let y=j=>{n.delete(f),y=()=>{},b(j)},P="";const T=this.D(),U=(0,s.$hjc)(this.a,o,this.a.includePattern,this.t.get(o.folder.fsPath).expression),z=U.cmd,M=!Object.keys(U.siblingClauses).length,N=U.rgArgs.args.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");let O=`${U.rgDiskPath} ${N}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),d({message:O}),this.s=0,this.z(z,"utf8",d,(j,Y,ne)=>{if(j){y(j);return}if(this.j){y();return}const Q=(P+(g?k.$Ll(Y||""):Y)).split(`
`);if(ne){const X=Q.length;Q[X-1]=Q[X-1].trim(),Q[X-1]||Q.pop()}else P=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Q.length,M){for(const X of Q)if(this.J(u,{base:D,relativePath:X,searchPath:this.N(o,X)}),this.j){f();break}(ne||this.j)&&y();return}this.G(o,T,D,Q,u),ne&&(this.H(T,D,u),y())})}spawnFindCmd(o){const u=this.t.get(o.folder.fsPath),d=u.getBasenameTerms(),b=u.getPathTerms(),D=["-L","."];if(d.length||b.length){D.push("-not","(","(");for(const g of d)D.push("-name",g),D.push("-o");for(const g of b)D.push("-path",g),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),I.spawn("find",D,{cwd:o.folder.fsPath})}readStdout(o,u,d){let b="";this.z(o,u,()=>{},(D,g,f)=>{if(D){d(D);return}b+=g,f&&d(null,b)})}z(o,u,d,b){let D=(y,P,T)=>{(y||T)&&(D=()=>{},this.r?.stop()),b(y,P,T)},g=!1;o.stdout?(this.A(o.stdout,u,D),o.stdout.once("data",()=>g=!0)):d({message:"stdout is null"});let f;o.stderr?f=this.B(o.stderr):d({message:"stderr is null"}),o.on("error",y=>{D(y)}),o.on("close",y=>{let P;!g&&(P=this.C(f,u))&&h(P)?D(new Error(`command failed with error code ${y}: ${this.C(f,u)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(o,u,d){const b=new L.StringDecoder(u);return o.on("data",D=>{d(null,b.write(D))}),b}B(o){const u=[];return o.on("data",d=>{u.push(d)}),u}C(o,u){const d=new L.StringDecoder(u);return o.map(b=>d.write(b)).join("")}D(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}G(o,{pathToEntries:u},d,b,D){b.indexOf(this.b)!==-1&&this.J(D,{base:d,relativePath:this.b,searchPath:this.N(o,this.b)});const g=f=>{const y=$.$nc(f),P=$.$mc(f);let T=u[P];T||(T=u[P]=[],g(P)),T.push({base:d,relativePath:f,basename:y,searchPath:this.N(o,f)})};b.forEach(g)}H({rootEntries:o,pathToEntries:u},d,b){const D=this,g=this.t.get(d),f=this.b;function y(P){D.o++;const T=(0,w.$8J)(()=>P.map(U=>U.basename));for(let U=0,z=P.length;U<z;U++){const M=P[U],{relativePath:N,basename:O}=M;if(g.test(N,O,f!==O?T:void 0))continue;const j=u[N];if(j)y(j);else{if(D.p++,N===f)continue;D.J(b,M)}if(D.j)break}}y(o)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(o,u,d,b,D){const g=o.folder,f=(0,w.$8J)(()=>d);this.w(d,(y,P)=>{if(this.l||this.j)return P(null);const T=u?[u,y].join($.sep):y;if(this.t.get(o.folder.fsPath).test(T,y,this.a.filePattern!==y?f:void 0))return P(null);const U=[g.fsPath,T].join($.sep);F.lstat(U,(z,M)=>{if(z||this.l||this.j)return P(null);this.L(U,M,(N,O)=>N||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(U,M,(j,Y)=>j||this.l||this.j||(Y=Y||"",this.v[Y])?P(null):(this.v[Y]=!0,l.Promises.readdir(U).then(ne=>{if(this.l||this.j)return P(null);this.I(o,T,ne,b,ee=>P(ee||null))},ne=>{P(null)})))):(this.p++,T===this.b||this.h&&S.$Qf(O.size)&&O.size>this.h||this.J(b,{base:g.fsPath,relativePath:T,searchPath:this.N(o,T)}),P(null,void 0)))})},y=>{const P=y&&A.$Hb(y);return D(P&&P.length>0?P[0]:void 0)})}J(o,u){this.K(u)&&(!this.d||this.d(u.relativePath,$.$nc(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||o(u))}K(o){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,w.$3J)(o,this.c);if(this.b)return(0,w.$3J)(o,this.b,!1)}return!0}L(o,u,d){return u.isSymbolicLink()?F.stat(o,d):d(null,u)}M(o,u,d){return u.isSymbolicLink()?F.realpath(o,(b,D)=>b?d(b):d(null,D)):d(null,o)}N(o,u){return o.folderName?$.$jc(o.folderName,u):u}}e.$kjc=r;class a{constructor(o){this.a=o.folderQueries,this.b=o.extraFileResources||[],this.c=new r(o)}search(o,u,d){this.c.walk(this.a,this.b,o,u,(b,D)=>{d(b,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$ljc=a;class t{constructor(o,u){this.expression=o,this.c=u,this.d(o)}d(o){let u,d;Object.keys(o).filter(b=>o[b]).forEach(b=>{$.$ic(b)?(u=u||p.$Mj(),u[b]=o[b]):(d=d||p.$Mj(),d[b]=o[b])}),this.a=u&&p.$Rj(u,{trimForExclusions:!0}),this.b=d&&p.$Rj(d,{trimForExclusions:!0})}test(o,u,d){return this.b&&this.b(o,u,d)||this.a&&this.a($.$jc(this.c,o),u,d)}getBasenameTerms(){const o=[];return this.a&&o.push(...p.$Tj(this.a)),this.b&&o.push(...p.$Tj(this.b)),o}getPathTerms(){const o=[];return this.a&&o.push(...p.$Uj(this.a)),this.b&&o.push(...p.$Uj(this.b)),o}}function h(c){const o=c.trim().split(`
`),u=o[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return E.$Ef(o[o.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(Ce[378],Ie([1,0,98,21,187,22]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.DecodeStreamErrorKind=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=void 0,e.$nD="utf8",e.$oD="utf8bom",e.$pD="utf16be",e.$qD="utf16le";function A(u){return[e.$nD,e.$oD,e.$pD,e.$qD].some(d=>d===u)}e.$rD=A,e.$sD=[254,255],e.$tD=[255,254],e.$uD=[239,187,191];const v=512,p=512,k=512*8,R=512*128;var C;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(d,b){super(d),this.decodeStreamErrorKind=b}}e.$vD=m;class E{static async create(d){let b;if(d!==e.$nD)b=(await(0,$.$mD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(d));else{const D=new TextDecoder;b={write(g){return D.decode(g,{stream:!0})},end(){return D.decode()}}}return new E(b)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function S(u,d){const b=d.minBytesRequiredForDetection??d.guessEncoding?k:p;return new Promise((D,g)=>{const f=(0,I.$ae)(M=>M.join("")),y=[];let P=0,T;const U=new L.$9d,z=async()=>{try{const M=await o({buffer:F.$me.concat(y),bytesRead:P},d.guessEncoding);if(M.seemsBinary&&d.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);M.encoding=await d.overwriteEncoding(M.encoding),T=await E.create(M.encoding);const N=T.write(F.$me.concat(y).buffer);f.write(N),y.length=0,P=0,D({stream:f,detected:M})}catch(M){U.cancel(),f.destroy(),g(M)}};(0,I.$ee)(u,{onData:async M=>{T?f.write(T.write(M.buffer)):(y.push(M),P+=M.byteLength,P>=b&&(u.pause(),await z(),setTimeout(()=>u.resume())))},onError:M=>f.error(M),onEnd:async()=>{T||await z(),f.end(T?.end())}},U.token)})}e.$wD=S;async function l(u,d,b){const g=(await(0,$.$mD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(d),b);let f=!1,y=!1;return{read(){if(y)return null;const P=u.read();if(typeof P!="string"){if(y=!0,!f&&b?.addBOM)switch(d){case e.$nD:case e.$oD:return F.$me.wrap(Uint8Array.from(e.$uD));case e.$pD:return F.$me.wrap(Uint8Array.from(e.$sD));case e.$qD:return F.$me.wrap(Uint8Array.from(e.$tD))}const T=g.end();return T&&T.length>0?(f=!0,F.$me.wrap(T)):null}return f=!0,F.$me.wrap(g.write(P))}}}e.$xD=l;async function w(u){return(await(0,$.$mD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(u))}e.$yD=w;function s(u){return u===e.$oD||u===null?e.$nD:u}e.$zD=s;function i(u,d){if(!u||d<e.$sD.length)return null;const b=u.readUInt8(0),D=u.readUInt8(1);if(b===e.$sD[0]&&D===e.$sD[1])return e.$pD;if(b===e.$tD[0]&&D===e.$tD[1])return e.$qD;if(d<e.$uD.length)return null;const g=u.readUInt8(2);return b===e.$uD[0]&&D===e.$uD[1]&&g===e.$uD[2]?e.$oD:null}e.$AD=i;const n=["ascii","utf-16","utf-32"];async function r(u){const d=await(0,$.$mD)("jschardet","dist/jschardet.min.js"),b=u.slice(0,R),D=h(b.buffer),g=d.detect(D);if(!g||!g.encoding)return null;const f=g.encoding.toLowerCase();return 0<=n.indexOf(f)?null:t(g.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(u){const d=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[d]||d}function h(u){let d="";for(let b=0;b<u.length;b++)d+=String.fromCharCode(u[b]);return d}function c(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=u.match(/windows(\d+)/);return d?"windows-"+d[1]:u}}}e.$BD=c;function o({buffer:u,bytesRead:d},b){let D=i(u,d),g=!1;if(D!==e.$pD&&D!==e.$qD&&u){let f=!0,y=!0,P=!1;for(let T=0;T<d&&T<v;T++){const U=T%2===1,z=u.readUInt8(T)===0;if(z&&(P=!0),f&&(U&&!z||!U&&z)&&(f=!1),y&&(U&&z||!U&&!z)&&(y=!1),z&&!f&&!y)break}P&&(f?D=e.$qD:y?D=e.$pD:g=!0)}return b&&!g&&!D&&u?r(u.slice(0,d)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:g,encoding:D}}e.$CD=o,e.$DD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[156],Ie([1,0,378,31,155]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;class L extends $.$eic{constructor(v,p,k=F,R="searchProcess"){super(v,p,{readdir:C=>k.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,I.$BD)(C)},R)}}e.$tjc=L}),define(Ce[157],Ie([1,0,50,394,377,19,74,35,12,2,36,94,395,375,119]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=e.$rjc=e.$qjc=e.$pjc=e.$ojc=e.$njc=e.$mjc=void 0;const l=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(f){this.a=f}provideTextSearchResults(f,y,P,T){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,z)=>{T.onCancellationRequested(()=>Q());const M=t(f,y),N=y.folder.fsPath,O=M.map(re=>re.match(/^-/)?re:`'${re}'`).join(" ");this.a.appendLine(`${l} ${O}
 - cwd: ${N}`);let j=I.spawn(l,M,{cwd:N});j.on("error",re=>{console.error(re),this.a.appendLine("Error: "+(re&&re.message)),z((0,R.$YJ)(new R.$WJ(re&&re.message,R.SearchErrorCode.rgProcessError)))});let Y=!1;const ne=new n(y.maxResults,y.folder,y.previewOptions);ne.on("result",re=>{Y=!0,ce="",P.report(re)});let ee=!1;const Q=()=>{ee=!0,j?.kill(),ne?.cancel()};let X=!1;ne.on("hitLimit",()=>{X=!0,Q()});let ce="";j.stdout.on("data",re=>{ne.handleData(re),Y||(ce+=re)});let ie=!1;j.stdout.once("data",()=>ie=!0);let fe="";j.stderr.on("data",re=>{const J=re.toString();this.a.appendLine(J),fe.length+J.length<1e6&&(fe+=J)}),j.on("close",()=>{if(this.a.appendLine(ie?"Got data from stdout":"No data from stdout"),this.a.appendLine(Y?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),ee)U({limitHit:X});else{ne.flush(),j=null;let re;fe&&!ie&&(re=s(fe))?z((0,R.$YJ)(new R.$WJ(re.message,re.code))):U({limitHit:X})}})})}}e.$mjc=w;function s(g){const f=g.split(`
`),y=f[0].trim();if(f.some(T=>T.startsWith("regex parse error")))return new R.$WJ(i(f),R.SearchErrorCode.regexParseError);const P=y.match(/grep config error: unknown encoding: (.*)/);if(P)return new R.$WJ(`Unknown encoding: ${P[1]}`,R.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new R.$WJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new R.$WJ(y.charAt(0).toUpperCase()+y.substr(1),R.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new R.$WJ(y,R.SearchErrorCode.regexParseError)}function i(g){const f=["Regex parse error"],y=g.filter(P=>P.startsWith("PCRE2:"));if(y.length>=1){const P=y[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const T=P.split(":")[1];f.push(":"+T)}}return f.join("")}class n extends F.EventEmitter{constructor(f,y,P){super(),this.g=f,this.h=y,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new $.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,y){return super.on(f,y),this}handleData(f){if(this.b)return;const y=typeof f=="string"?f:this.d.write(f);this.k(y)}k(f){let y=f.indexOf(`
`);const P=this.a+f;if(y>=0)y+=this.a.length;else{this.a=P;return}let T=0;for(;y>=0;)this.m(P.substring(T,y).trim()),T=y+1,y=P.indexOf(`
`,T);this.a=P.substring(T)}m(f){if(this.b||!f)return;let y;try{y=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(y.type==="match"){const P=r(y.data.path),T=k.URI.joinPath(this.h,P),U=this.n(y.data,T);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const P=r(y.data.path),T=k.URI.joinPath(this.h,P);this.o(y.data,T).forEach(z=>this.p(z))}}n(f,y){const P=f.line_number-1,T=r(f.lines),U=Buffer.from(T);let z=0,M=0,N=P;f.submatches.length===0&&f.submatches.push(T.length?{start:0,end:1,match:{text:T[0]}}:{start:0,end:0,match:{text:""}});const O=(0,L.$Hb)(f.submatches.map((j,Y)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ne=r(j.match),ee=U.slice(z,j.start).toString(),Q=a(ee),X=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+M,ce=a(ne),ie=Q.numLines+N,fe=ce.numLines+ie,re=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+X;return z=j.end,M=re,N=fe,new C.$GJ(ie,X,fe,re)}));return(0,S.$fjc)(y,T,O,this.j)}o(f,y){const P=r(f.lines),T=f.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((U,z)=>({text:U,uri:y,lineNumber:T+z}))}p(f){this.emit("result",f)}}e.$njc=n;function r(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function a(g){const f=/\n/g;let y=0,P=-1,T;for(;T=f.exec(g);)y++,P=T.index;const U=P>=0?g.length-P-1:g.length;return{numLines:y,lastLineLength:U}}function t(g,f){const y=["--hidden","--no-require-git"];y.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:T}=(0,A.$K)(f.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(T&&T.length){const z=new Set;T.forEach(M=>{z.add(M)}),y.push("-g","!*"),z.forEach(M=>{h(M).map(S.$ejc).forEach(N=>{y.push("-g",N)})})}P&&P.length&&P.forEach(z=>{y.push("-g",z)}),f.excludes.map(S.$ejc).forEach(z=>y.push("-g",`!${z}`)),f.maxFileSize&&y.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),f.followSymlinks&&y.push("--follow"),f.encoding&&f.encoding!=="utf8"&&y.push("--encoding",f.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,p.$Re)(g.pattern),g.isRegExp=!0),f.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),g.isRegExp&&(g.pattern=c(g.pattern),y.push("--engine","auto"));let U;if(g.isWordMatch){const M=(0,p.$1e)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",M)}else if(g.isRegExp){let z=u(g.pattern);z=d(z),y.push("--regexp",z)}else U=g.pattern,y.push("--fixed-strings");return y.push("--no-config"),f.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),g.isMultiline&&y.push("--multiline"),f.beforeContext&&y.push("--before-context",f.beforeContext+""),f.afterContext&&y.push("--after-context",f.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}e.$ojc=t;function h(g){return D(g).flatMap(y=>{const P=(0,v.$Pj)(y,"/");return P.map((T,U)=>P.slice(0,U+1).join("/"))})}function c(g){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(f);)g=g.replace(f,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(y);)g=g.replace(y,"$1\\x{$2}");return g}e.$pjc=c;const o=g=>g.type==="Assertion"&&g.kind==="lookbehind";function u(g){let f;try{f=new m.RegExpParser().parsePattern(g)}catch{return g}let y="",P=0;const T=(M,N,O)=>{y+=g.slice(P,M)+O,P=N},U=[];return new m.RegExpVisitor({onCharacterEnter(M){if(M.raw!=="\\n")return;const N=U[0];if(!N)T(M.start,M.end,"\\r?\\n");else if(!U.some(o))if(N.type==="CharacterClass")if(N.negate){const O=g.slice(N.start+2,M.start)+g.slice(M.end,N.end-1);N.parent?.type==="Quantifier"?T(N.start,N.end,O?`[^${O}]`:"."):T(N.start,N.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=g.slice(N.start+1,M.start)+g.slice(M.end,N.end-1);T(N.start,N.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else N.type==="Quantifier"&&T(M.start,M.end,"(?:\\r?\\n)")},onQuantifierEnter(M){U.unshift(M)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(M){U.unshift(M)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(M){U.unshift(M)},onCharacterClassLeave(){U.shift()},onAssertionEnter(M){o(M)&&U.push(M)},onAssertionLeave(M){U[0]===M&&U.shift()}}).visit(f),y+=g.slice(P),y}e.$qjc=u;function d(g){return g.replace(/\n/g,"\\r?\\n")}e.$rjc=d;function b(g){let f=!1,y=!1,P="",T="";for(let U=0;U<g.length;U++){const z=g[U];switch(z){case"\\":y?(f?T+="\\"+z:P+="\\"+z,y=!1):y=!0;break;case"{":if(y)f?T+=z:P+=z,y=!1;else{if(f)return{strInBraces:P+"{"+T+"{"+g.substring(U+1)};f=!0}break;case"}":if(y)f?T+=z:P+=z,y=!1;else{if(f)return{fixedStart:P,strInBraces:T,fixedEnd:g.substring(U+1)};P+=z}break;default:f?T+=(y?"\\":"")+z:P+=(y?"\\":"")+z,y=!1;break}}return{strInBraces:P+(f?"{"+T:"")}}function D(g){const{fixedStart:f,strInBraces:y,fixedEnd:P}=b(g);if(f===void 0||P===void 0)return[y];let T=(0,v.$Pj)(y,",");T.length||(T=[""]);const U=D(P);return T.flatMap(z=>{const M=f+z;return U.map(N=>M+N)})}e.$sjc=D}),define(Ce[379],Ie([1,0,22,157,107,16]),function(me,e,I,F,$,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class A{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,R,C,m){const E=new F.$mjc(this.b);if(R.folder.scheme===L.Schemas.vscodeUserData){const S={...R,folder:R.folder.with({scheme:L.Schemas.file})},l=new $.$Av(w=>C.report({...w,uri:w.uri.with({scheme:R.folder.scheme})}));return this.c(m,w=>E.provideTextSearchResults(k,S,l,w))}else return this.c(m,S=>E.provideTextSearchResults(k,R,C,S))}async c(k,R){const C=v(k);this.a.add(C);const m=await R(C.token);return this.a.delete(C),m}d(){this.a.forEach(k=>k.cancel())}}e.$wjc=A;function v(p){const k=new I.$9d;return p.onCancellationRequested(()=>k.cancel()),k}}),define(Ce[380],Ie([1,0,31,157,156]),function(me,e,I,F,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=void 0;class L{constructor(p){this.a=p}search(p,k,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(E){R({message:E})}},m=new $.$tjc(this.a,new F.$mjc(C),I);return new Promise((E,S)=>m.search(l=>{k(l.map(A))},p).then(l=>E({limitHit:l.limitHit,type:"success",stats:l.stats}),S))}}e.$ujc=L;function A(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce((p,k)=>{if(k.ranges){const R=k;return p+(Array.isArray(R.ranges)?R.ranges.length:1)}else return p+1},0)}}}),define(Ce[381],Ie([1,0,19,8,14,4,129,17,38,2,32,36,376,380]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;class S{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let a;const t=s(r),h=new L.$Yd({onDidAddFirstListener:()=>{a=(0,F.$Xg)(c=>this.doFileSearchWithEngine(m.$ljc,t,o=>h.fire(o),c)),a.then(c=>h.fire(c),c=>h.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}textSearch(r){let a;const t=s(r),h=new L.$Yd({onDidAddFirstListener:()=>{a=(0,F.$Xg)(c=>this.f(t,o=>h.fire(o),c)),a.then(c=>h.fire(c),c=>h.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}f(r,a,t){return r.maxFileSize=this.g().maxFileSize,new E.$ujc(r).search(t,a,a)}g(){return{maxFileSize:16*R.$4k.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine(m.$ljc,r,a,t)}doFileSearchWithEngine(r,a,t,h,c=S.a){let o=0;const u=b=>{Array.isArray(b)?(o+=b.length,t(b.map(D=>this.h(D)))):b.relativePath?(o++,t(this.h(b))):t(b)};if(a.sortByScore){let b=this.l(a,u,h);if(!b){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,g=new r(D);b=this.j(g,a,t,u,h)}return new Promise((D,g)=>{b.then(([f,y])=>{const P=y.map(T=>this.h(T));this.o(P,t,c),D(f)},g)})}const d=new r(a);return this.r(d,u,c,h).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:this.d,fromCache:!1,resultCount:o,sortingTime:void 0}}))}h(r){return{path:r.base?(0,v.$jc)(r.base,r.relativePath):r.relativePath}}j(r,a,t,h,c){const o=new L.$Yd;let u=(0,F.$Xg)(b=>{let D=[];const g=f=>{Array.isArray(f)?D=f:(h(f),o.fire(f))};return this.r(r,g,-1,b).then(f=>[f,D])}),d;if(a.cacheKey){d=this.k(a.cacheKey);const b={promise:u,event:o.event,resolved:!1};d.resultsToSearchCache[a.filePattern||""]=b,u.then(()=>{b.resolved=!0},D=>{delete d.resultsToSearchCache[a.filePattern||""]}),u=this.s(u)}return u.then(([b,D])=>{const g=d?d.scorerCache:Object.create(null),f=(typeof a.maxResults!="number"||a.maxResults>0)&&p.$Ud.create(!1);return this.n(a,D,g,c).then(y=>{const P=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:y.length},messages:b.messages,limitHit:b.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},y]})})}k(r){const a=this.b[r];return a||(this.b[r]=new l)}l(r,a,t){const h=r.cacheKey&&this.b[r.cacheKey];if(!h)return;const c=this.q(h,r.filePattern||"",a,t);if(c)return c.then(([o,u,d])=>{const b=p.$Ud.create(!1);return this.n(r,u,h.scorerCache,t).then(D=>{const g=b.elapsed(),f={fromCache:!0,detailStats:d,type:this.d,resultCount:u.length,sortingTime:g};return[{type:"success",limitHit:o.limitHit||typeof r.maxResults=="number"&&u.length>r.maxResults,stats:f},D]})})}n(r,a,t,h){const c=(0,A.$5q)(r.filePattern||""),o=(d,b)=>(0,A.$4q)(d,b,c,!0,w,t),u=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return I.$Gb(a,o,u,1e4,h)}o(r,a,t){if(t&&t>0)for(let h=0;h<r.length;h+=t)a(r.slice(h,h+t));else a(r)}q(r,a,t,h){const c=p.$Ud.create(!1),o=a.indexOf(v.sep)>=0;let u;for(const g in r.resultsToSearchCache)if(a.startsWith(g)){if(o&&g.indexOf(v.sep)<0&&g!=="")continue;const f=r.resultsToSearchCache[g];u={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!u)return null;const d=c.elapsed(),b=p.$Ud.create(!1),D=u.event(t);return h&&h.onCancellationRequested(()=>{D.dispose()}),u.promise.then(([g,f])=>{if(h&&h.isCancellationRequested)throw(0,$.$6)();const y=[],P=(0,A.$5q)(a).normalizedLowercase;for(const T of f)(0,C.$3J)(T,P)&&y.push(T);return[g,y,{cacheWasResolved:u.resolved,cacheLookupTime:d,cacheFilterTime:b.elapsed(),cacheEntryCount:f.length}]})}r(r,a,t,h){return new Promise((c,o)=>{let u=[];h?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(t?(u.push(d),t>0&&u.length>=t&&(a(u),u=[])):a(d))},d=>{a(d)},(d,b)=>{u.length&&a(u),d?(a({message:"Search finished. Error: "+d.message}),o(d)):(a({message:"Search finished. Stats: "+JSON.stringify(b.stats)}),c(b))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.$vjc=S;class l{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(n){return(0,v.$nc)(n.relativePath)}getItemDescription(n){return(0,v.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>k.URI.revive(r))}}function i(n){return{...n,folder:k.URI.revive(n.folder)}}}),define(Ce[382],Ie([1,0,3,16,2,31,13,27,20,97,67,36,381,379,119,156]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;let w=class extends k.$jic{constructor(i,n,r,a){super(i,r,a),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new I.$Sc;const t=new S.$gjc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.vscodeUserData,new E.$wjc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$gjc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(F.Schemas.file,new E.$wjc(i))),this.x.add(this.z(F.Schemas.file,new m.$vjc("fileSearchProvider")))}z(i,n){const r=this.d++;return this.v=n,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,I.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,a){const t=(0,k.$kic)(r);if(i===this.t){const h=Date.now();return this.A(i,n,t,a).then(c=>{const o=Date.now()-h;return this.n.debug(`Ext host file search time: ${o}ms`),c})}return super.$provideFileSearchResults(i,n,r,a)}doInternalFileSearchWithCustomCallback(i,n,r){const a=t=>{if((0,C.$2J)(t)&&(t=[t]),Array.isArray(t)){r(t.map(h=>$.URI.file(h.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new l.$tjc(i,n,void 0,"textSearchProvider")}};e.$xjc=w,e.$xjc=w=Je([We(0,p.$JN),We(1,v.$ZN),We(2,R.$chc),We(3,A.$sj)],w)}),define(Ce[120],Ie([1,0,396,62,64,397,21,14,4,3,17,11,30,81,82]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0;class l{traceSocketEvent(f,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,y)}constructor(f,y=""){this.f=!0,this.debugLabel=y,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,v.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const y=P=>{this.traceSocketEvent("read",P),f(A.$me.wrap(P))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(f){const y=P=>{f({type:0,hadError:P,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(f){const y=()=>{f()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Zh=l;var w;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var s;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(s||(s={}));class i extends k.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,y){this.socket.traceSocketEvent(f,y)}constructor(f,y,P,T){super(),this.f=this.B(new p.$Yd),this.g=this.B(new p.$Yd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:P?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new n(this,y,P,T,this.f,(U,z)=>this.m(U,z))),this.B(this.a.onError(U=>{console.error(U),(0,v.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new S.$Uh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let y=0;for(;y<f.byteLength;)this.a.writeMessage(f.slice(y,Math.min(y+262144,f.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(f,{compressed:y,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let T=2;f.byteLength<126?T+=0:f.byteLength<2**16?T+=2:T+=8;const U=A.$me.alloc(T),z=y?64:0,M=P&15;if(U.writeUInt8(128|z|M,0),f.byteLength<126)U.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){U.writeUInt8(126,1);let N=1;U.writeUInt8(f.byteLength>>>8&255,++N),U.writeUInt8(f.byteLength>>>0&255,++N)}else{U.writeUInt8(127,1);let N=1;U.writeUInt8(0,++N),U.writeUInt8(0,++N),U.writeUInt8(0,++N),U.writeUInt8(0,++N),U.writeUInt8(f.byteLength>>>24&255,++N),U.writeUInt8(f.byteLength>>>16&255,++N),U.writeUInt8(f.byteLength>>>8&255,++N),U.writeUInt8(f.byteLength>>>0&255,++N)}this.socket.write(A.$me.concat([U,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),P=y.readUInt8(0),T=(P&128)>>>7,U=(P&64)>>>6,z=P&15,M=y.readUInt8(1),N=(M&128)>>>7,O=M&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),P=y.readUInt8(1),T=(P&128)>>>7;let U=P&127,z=1;U===126?U=y.readUInt8(++z)*2**8+y.readUInt8(++z):U===127&&(U=y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z));let M=0;T&&(M=y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z)),this.j.state=3,this.j.readLen=U,this.j.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$1h=i;class n extends k.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$me.alloc(0)}constructor(f,y,P,T,U,z){super(),this.n=f,this.r=U,this.s=z,this.a=this.B(new p.$Yd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$Yd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$Yd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,T,P,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(M=>this.a.fire(M))),this.B(this.f.onError(M=>this.a.fire(M)))):(this.b=null,this.f=null)}writeMessage(f,y){this.g.push({data:f,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:y}=this.g.shift();if(this.f&&y.compressed){const P=await this.w(this.f,f);this.s(P,y)}else this.s(f,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,y){return new Promise((P,T)=>{f.write(y),f.flush(U=>P(U))})}acceptFrame(f,y,P){this.h.push({data:f,isCompressed:y,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const y=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,y,P){return new Promise((T,U)=>{f.write(y),P&&f.write(A.$me.fromByteArray([0,0,255,255])),f.flush(z=>T(z))})}}class r extends k.$Tc{get recordedInflateBytes(){return this.j?A.$me.concat(this.f):A.$me.alloc(0)}constructor(f,y,P,T){super(),this.h=f,this.j=y,this.a=this.B(new p.$Yd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(T),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(A.$me.wrap(U))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=A.$me.concat(this.g);this.g.length=0,f(y)})}}class a extends k.$Tc{constructor(f,y){super(),this.g=f,this.a=this.B(new p.$Yd),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$me.wrap(P))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=A.$me.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),f(y)})}}function t(g,f){if(f===0)return;const y=g.byteLength>>>2;for(let N=0;N<y;N++){const O=g.readUInt32BE(N*4);g.writeUInt32BE(O^f,N*4)}const P=y*4,T=g.byteLength-P,U=f>>>24&255,z=f>>>16&255,M=f>>>8&255;T>=1&&g.writeUInt8(g.readUInt8(P)^U,P),T>=2&&g.writeUInt8(g.readUInt8(P+1)^z,P+1),T>=3&&g.writeUInt8(g.readUInt8(P+2)^M,P+2)}e.$2h=process.env.XDG_RUNTIME_DIR;const h={2:107,1:103};function c(){const g=(0,m.$ug)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;const f=process.platform!=="darwin"&&e.$2h?e.$2h:(0,$.tmpdir)(),y=(0,R.$jc)(f,`vscode-ipc-${g}.sock`);return u(y),y}e.$3h=c;function o(g,f,y){const T=(0,I.createHash)("sha256").update(g).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${y}-${f}-sock`;const U=y.substr(0,4),z=f.substr(0,6);let M;return process.platform!=="darwin"&&e.$2h&&!process.env.VSCODE_PORTABLE?M=(0,R.$jc)(e.$2h,`vscode-${T}-${U}-${z}.sock`):M=(0,R.$jc)(g,`${U}-${z}.sock`),u(M),M}e.$4h=o;function u(g){const f=h[C.$u];typeof f=="number"&&g.length>=f&&console.warn(`WARNING: IPC handle "${g}" is longer than ${f} chars, try a shorter --user-data-dir`)}class d extends E.$Oh{static b(f){const y=p.Event.fromNodeEventEmitter(f,"connection");return p.Event.map(y,P=>({protocol:new S.$Vh(new l(P,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(P,"close"))}))}constructor(f){super(d.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$5h=d;function b(g){return new Promise((f,y)=>{const P=(0,F.createServer)();P.on("error",y),P.listen(g,()=>{P.removeListener("error",y),f(new d(P))})})}e.$6h=b;function D(g,f){return new Promise((y,P)=>{const T=(0,F.createConnection)(g,()=>{T.removeListener("error",P),y(S.$Wh.fromSocket(new l(T,`ipc-client${f}`),f))});T.once("error",P)})}e.$7h=D}),define(Ce[383],Ie([1,0,62,64,167,120,8,3,11,51,13,136,258,259,109,88,21]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M_b=e.$L_b=e.$K_b=e.$J_b=void 0;async function s(t,h,c,o,u){let d;for(let b=3;b&&(d?.dispose(),d=await new i(t,h,c,o,u).waitForReady(),!(u&&$.$xg[u]||!$.$xg[d.tunnelLocalPort]));b--);return d}class i extends v.$Tc{constructor(h,c,o,u,d){super(),this.m=c,this.n=d,this.privacy=l.TunnelPrivacyId.Private,this.j=new Map,this.a=h,this.b=I.createServer(),this.c=new A.$0g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const h=this.n??this.tunnelRemotePort,c=(0,l.$Mv)(this.m)?"0.0.0.0":"127.0.0.1";let o=await(0,$.$yg)(h,2,1e3,c),u=null;return this.b.listen(o,this.m),await this.c.wait(),u=this.b.address(),u||(o=0,this.b.listen(o,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(h){h.pause();const c=(0,l.$Kv)(this.tunnelRemoteHost)||(0,l.$Mv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,m.$ql)(this.a,c,this.tunnelRemotePort),u=o.getSocket(),d=o.readEntireBuffer();o.dispose(),d.byteLength>0&&h.write(d.buffer),h.on("end",()=>{h.localAddress&&this.j.delete(h.localAddress),u.end()}),h.on("close",()=>u.end()),h.on("error",()=>{h.localAddress&&this.j.delete(h.localAddress),u instanceof L.$Zh?u.socket.destroy():u.end()}),u instanceof L.$Zh?this.t(h,u):this.s(h,u),h.localAddress&&this.j.set(h.localAddress,()=>{h.end(),u.end()})}s(h,c){c.onClose(()=>h.destroy()),c.onEnd(()=>h.end()),c.onData(o=>h.write(o.buffer)),h.on("data",o=>c.write(w.$me.wrap(o))),h.resume()}t(h,c){const o=c.socket;o.on("end",()=>h.end()),o.on("close",()=>h.end()),o.on("error",()=>{h.destroy()}),o.pipe(h),h.pipe(o)}}e.$J_b=i;let n=class extends l.$Pv{constructor(h,c,o,u,d){super(c,d),this.v=h,this.w=o,this.y=u}isPortPrivileged(h){return(0,l.$Nv)(h,this.m,p.OS,F.release())}t(h,c,o,u,d,b,D,g){const f=this.s(c,o);if(f)return++f.refcount,f.value;if((0,l.$Hv)(h))return this.u(h,c,o,d,b,D,g);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${o} on local port ${d}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:h,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=s(y,u,c,o,d);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(c,o,P),P}}};e.$K_b=n,e.$K_b=n=Je([We(0,E.$kl),We(1,R.$sj),We(2,S.$nl),We(3,C.$Kj),We(4,k.$Ei)],n);let r=class extends n{constructor(h,c,o,u,d){super(h,c,o,u,d)}};e.$L_b=r,e.$L_b=r=Je([We(0,E.$kl),We(1,R.$sj),We(2,S.$nl),We(3,C.$Kj),We(4,k.$Ei)],r);let a=class extends v.$Tc{constructor(h,c,o,u,d){super(),this.b=h,this.c=c,this.f=o,this.g=u,this.h=d,this.a=new Map}async openTunnel(h,c,o,u,d,b,D,g,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${u} on local port ${b}.`),!this.a.has(h)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(h,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(h))})}return this.a.get(h).openTunnel(c,o,u,d,b,D,g,f)}};e.$M_b=a,e.$M_b=a=Je([We(0,E.$kl),We(1,R.$sj),We(2,C.$Kj),We(3,S.$nl),We(4,k.$Ei)],a)}),define(Ce[384],Ie([1,0,120,278,57,33,2,13,40]),function(me,e,I,F,$,L,A,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=e.$$N=void 0;class k{constructor(m,E,S){this.b=m,this.c=E,this.f=S,this.a=F.createServer((l,w)=>this.h(l,w)),this.g().catch(l=>(E.error(l),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,E){const S=(w,s)=>{E.writeHead(w,{"content-type":"application/json"}),E.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},l=[];m.setEncoding("utf8"),m.on("data",w=>l.push(w)),m.on("end",async()=>{try{const w=JSON.parse(l.join(""));let s;switch(w.type){case"open":s=await this.i(w);break;case"openExternal":s=await this.j(w);break;case"status":s=await this.l(w);break;case"extensionManagement":s=await this.k(w);break;default:S(404,`Unknown message type: ${w.type}`);break}S(200,s)}catch(w){const s=w instanceof Error?w.message:JSON.stringify(w);S(500,s),this.c.error("Error while processing pipe request",w)}})}async i(m){const{fileURIs:E,folderURIs:S,forceNewWindow:l,diffMode:w,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=m,h=[];if(Array.isArray(S))for(const d of S)try{h.push({folderUri:A.URI.parse(d)})}catch{}if(Array.isArray(E))for(const d of E)try{(0,p.$Di)(d)?h.push({workspaceUri:A.URI.parse(d)}):h.push({fileUri:A.URI.parse(d)})}catch{}const c=a?A.URI.file(a):void 0,u={forceNewWindow:l,diffMode:w,mergeMode:s,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!c&&!i,waitMarkerFileURI:c,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",h,u)}async j(m){for(const E of m.uris){const S=A.URI.parse(E),l=S.scheme==="file"?S:E;await this.b.executeCommand("_remoteCLI.openExternal",l)}}async k(m){const E=l=>l?.map(w=>/\.vsix$/i.test(w)?A.URI.parse(w):w),S={list:m.list,install:E(m.install),uninstall:E(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&$.existsSync(this.f)&&$.unlinkSync(this.f)}}e.$$N=k;let R=class extends k{constructor(m,E){super(m,E,(0,I.$3h)())}};e.$_N=R,e.$_N=R=Je([We(0,L.$6N),We(1,v.$sj)],R)}),define(Ce[385],Ie([1,0,58,372,367,277,47,354,2,16,7,384,103,310,353]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;class l extends $.$4ic{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(c,o,u){return c=t(c),i.a.has(c)?i.a.get(c).load(c,p.URI.file((0,m.$Bq)(o.filename)),d=>r.apply(this,[d,o,u])):r.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(h,c)=>a.call(this,t(h),c);const t=h=>{for(const c of i.b){const o=c(h);if(o){h=o;break}}return h}}}class w extends A.$Shc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async tb(){this.h.createInstance(E.$Ajc);const i=this.h.invokeFunction(F.$Zic);if(this.h.createInstance(v.$zjc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(C.$_N);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$Bjc),await this.h.createInstance(l,i,{mine:this.J,all:this.L}).install(),I.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,L.$yjc)(this.j,r,this,this.s,this.z,this.f),I.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,r){if(n.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$Cjc=w}),define(Ce[386],Ie([1,0,50,21,4,3,122,11,23,2,31,13,257,65,109,88,383,27,20,71,361]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=e.$Jjc=e.$Ijc=e.$Hjc=e.$Gjc=e.$Fjc=e.$Ejc=e.$Djc=void 0;function a(f){const y=f.trim().split(`
`),P=[];return y.forEach(U=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);z&&z.length>=3&&P.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),P.reduce((U,z)=>(U[z.socket]=z,U),{})}e.$Djc=a;function t(...f){const y=[].concat(...f.map(c));return[...new Map(y.filter(P=>P.st==="0A").map(P=>{const T=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:h(T[0]),port:parseInt(T[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Ejc=t;function h(f){let y="";if(f.length===8)for(let P=f.length-2;P>=0;P-=2)y+=parseInt(f.substr(P,2),16),P!==0&&(y+=".");else for(let P=0;P<f.length;P+=8){const T=f.substring(P,P+8);let U="";for(let z=8;z>=2;z-=2)U+=T.substring(z-2,z),(z===6||z===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",P+z!==f.length-6&&(y+=":"))}return y}e.$Fjc=h;function c(f){const y=f.trim().split(`
`),P=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((z,M,N)=>(z[P[N]||N]=M,z),{}))}e.$Gjc=c;function o(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function u(f){const y=f.trim().split(`
`),P=[];return y.forEach(T=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(T);U&&U.length>=4&&P.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),P}e.$Hjc=u;async function d(f,y,P){const T=P.reduce((z,M)=>(z[M.pid]=M,z),{}),U=[];return f.forEach(({socket:z,ip:M,port:N})=>{const O=y[z]?y[z].pid:void 0,j=O?T[O]?.cmd:void 0;O&&j&&!o(j)&&U.push({host:M,port:N,detail:j,pid:O})}),U}e.$Ijc=d;function b(f,y,P){const T=new Map,U=u(y);for(const z of f){const M=P.get(z.port);if(M){T.set(z.port,M);continue}const N=U.find(O=>O.cmd.includes(`${z.port}`));if(N){let O=N,j;do j=U.find(Y=>Y.ppid===O.pid),j&&(O=j);while(j);T.set(z.port,{host:z.ip,port:z.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else T.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return T}e.$Jjc=b;let D=class extends n.$Lzb{constructor(y,P,T,U){super(y,P,T),this.D=P,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,v.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const T=new A.$cm;let U=0;for(;this.C;){const z=new Date().getTime(),M=(await this.I()).filter(j=>(0,l.$Kv)(j.host)||(0,l.$Mv)(j.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(j=>j.port).join(", ")}`);const N=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),U++>3&&T.update(N),(!P||JSON.stringify(P)!==JSON.stringify(M))&&(P=M,await this.a.$onFoundNewCandidates(P));const O=this.G(T.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(j=>setTimeout(()=>j(),O))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",P="";try{y=await R.Promises.readFile("/proc/net/tcp","utf8"),P=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const T=t(y,P),U=await new Promise(ee=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,X,ce)=>{ee(X)})}),z=a(U),M=await R.Promises.readdir("/proc"),N=[];for(const ee of M)try{const Q=Number(ee),X=p.$Lg(k.URI.file("/proc"),ee);if((await R.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Q)){const ie=await R.Promises.readlink(p.$Lg(X,"cwd").fsPath),fe=await R.Promises.readFile(p.$Lg(X,"cmdline").fsPath,"utf8");N.push({pid:Q,cwd:ie,cmd:fe})}}catch{}const O=[],j=T.filter(ee=>{const Q=z[ee.socket];return Q||O.push(ee),Q}),Y=d(j,z,N);let ne;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const ee=await new Promise(Q=>{(0,I.exec)("ps -F -A -l | grep root",(X,ce,ie)=>{Q(ce)})});this.z=b(O,ee,this.z),ne=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ne.map(Q=>Q.port).join(", ")}`)}return Y.then(ee=>ne?ee.concat(ne):ee)}w(y){return async P=>{const T=new w.$J_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,M,N,O){const j=await y.makeConnection();return g.connect(j,M,N,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$bl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await T.waitForReady();const U=new $.$Yd;return{localAddress:(0,r.$RK)(T.localAddress)??T.localAddress,remoteAddress:{port:T.tunnelRemotePort,host:T.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{T.dispose(),U.fire(),U.dispose()}}}}};e.$Kjc=D,e.$Kjc=D=Je([We(0,i.$JN),We(1,s.$ZN),We(2,C.$sj),We(3,S.$nl)],D);class g extends m.$Tsb{static connect(y,P,T,U){const z=new L.$Sc,M={onClose:z.add(new $.$Yd),onData:z.add(new $.$Yd),onEnd:z.add(new $.$Yd)};z.add(y.onDidReceiveMessage(O=>M.onData.fire(F.$me.wrap(O)))),z.add(y.onDidEnd(()=>M.onEnd.fire())),z.add(y.onDidClose(O=>M.onClose.fire({type:0,error:O,hadError:!!O})));const N=new g(y,U,M);return N.B(z),(0,m.$Ssb)(N,P,T,U,M)}constructor(y,P,T){super(P,T),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ce[387],Ie([1,0,84,356,370,369,382,385,386,96,47,97,95,46,71,93,355,311,13,371,60,272,105,109,138]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s,i,n,r,a,t,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$4r)(R.$Thc,v.$Cjc,0),(0,I.$4r)(i.$tj,s.$Mjc,1),(0,I.$4r)(i.$sj,new t.$8h(a.$3ic,[!1],!0)),(0,I.$4r)(h.$nl,c.$O_b,1),(0,I.$4r)(l.$lhc,w.$Ljc,0),(0,I.$4r)(k.$Yhc,L.$djc,0),(0,I.$4r)(C.$iic,A.$xjc,0),(0,I.$4r)(m.$Lic,$.$8ic,0),(0,I.$4r)(E.$Ghc,F.$7ic,0),(0,I.$4r)(S.$Kzb,p.$Kjc,0),(0,I.$4r)(r.$Whc,n.$Njc,0)}),define(Ce[398],Ie([1,0,62,399,58,14,82,120,255,113,368,21,31,103,8,132,279,293,373,387]),function(me,e,I,F,$,L,A,v,p,k,R,C,m,E,S,l,w,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let b=0;b<process.execArgv.length;b++)process.execArgv[b]==="--inspect-port=0"&&(process.execArgv.splice(b,1),b--)}();const i=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,b=d._load;d._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return b.apply(this,arguments)}})();const n=process.exit.bind(process),r=process.on.bind(process);function a(d){process.exit=function(b){if(d)n(b);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const b=new Error("An extension called process.crash() and this was prevented.");console.warn(b.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(b,D){b==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(b,D)}}let t=function(d){n()};function h(){const d=(0,s.$Zm)(process.env);if(d.type===3)return new Promise((b,D)=>{const g=f=>{const y=f[0],P=new A.$Xh;y.on("message",T=>P.fire(C.$me.wrap(T.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),b({onMessage:P.event,send:T=>y.postMessage(T.buffer)})};process.parentPort.on("message",f=>g(f.ports))});if(d.type===2)return new Promise((b,D)=>{let g=null;const f=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,P=3e5,T=new S.$lh(()=>t("renderer disconnected for too long (1)"),y),U=new S.$lh(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(M,N)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const O=C.$me.wrap(Buffer.from(M.initialDataChunk,"base64"));let j;if(M.skipWebSocketFrames)j=new v.$Zh(N,"extHost-socket");else{const Y=C.$me.wrap(Buffer.from(M.inflateBytes,"base64"));j=new v.$1h(new v.$Zh(N,"extHost-socket"),M.permessageDeflate,Y,!1)}g?(T.cancel(),U.cancel(),g.beginAcceptReconnection(j,O),g.endAcceptReconnection(),g.sendResume()):(clearTimeout(f),g=new A.$Yh({socket:j,initialChunk:O}),g.sendResume(),g.onDidDispose(()=>t("renderer disconnected")),b(g),g.onSocketClose(()=>{T.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;T.isScheduled()&&U.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const b=d.pipeName;return new Promise((D,g)=>{const f=I.createConnection(b,()=>{f.removeListener("error",g);const y=new A.$Yh({socket:new v.$Zh(f,"extHost-renderer")});y.sendResume(),D(y)});f.once("error",g),f.on("close",()=>{t("renderer closed the socket")})})}}async function c(){const d=await h();return new class{constructor(){this.a=new A.$Xh,this.onMessage=this.a.event,this.b=!1,d.onMessage(b=>{(0,k.$zm)(b,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(b)})}send(b){this.b||d.send(b)}async drain(){if(d.drain)return d.drain()}}}function o(d){return new Promise(b=>{const D=d.onMessage(g=>{D.dispose();const f=JSON.parse(g.toString()),y=f.commit,P=p.default.commit;if(y&&P&&y!==P&&n(55),f.parentPid){let T=0;setInterval(function(){try{process.kill(f.parentPid,0),T=0}catch(z){z&&z.code==="EPERM"?(T++,T>=3&&t(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):t(`parent process ${f.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(f.parentPid)}catch(z){(0,L.$1)(z)}}d.send((0,k.$ym)(0)),b({protocol:d,initData:f})});d.send((0,k.$ym)(1))})}async function u(){const d=[];process.on("unhandledRejection",(T,U)=>{d.push(U),setTimeout(()=>{const z=d.indexOf(U);z>=0&&U.catch(M=>{d.splice(z,1),(0,L.$4)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),T&&(0,L.$1)(T))})},1e3)}),process.on("rejectionHandled",T=>{const U=d.indexOf(T);U>=0&&d.splice(U,1)}),process.on("uncaughtException",function(T){(0,L.$Z)(T)||(0,L.$1)(T)}),$.mark("code/extHost/willConnectToRenderer");const b=await c();$.mark("code/extHost/didConnectToRenderer");const D=await o(b);$.mark("code/extHost/didWaitForInitData");const{initData:g}=D;a(!!g.environment.extensionTestsLocationURI),g.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,g.environment.skipWorkspaceStorageLock=(0,l.boolean)(i.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(U){n(U)}fsExists(U){return m.Promises.exists(U)}fsRealpath(U){return(0,E.$Aq)(U)}};let y=null;g.remote.authority&&i.transformURIs&&(y=(0,w.$8r)(g.remote.authority));const P=new R.$6ic(D.protocol,g,f,y);t=T=>P.terminate(T)}u().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4f2ff19ecacffa0aa4874db4d63ed4e899d98431/core/vs/workbench/api/node/extensionHostProcess.js.map
