/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Le=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/htmlContent","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Me=function(fe){for(var e=[],S=0,M=fe.length;S<M;S++)e[S]=Le[fe[S]];return e};define(Le[67],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function S(R){return(m,g,D)=>{let A=null,k=null;if(typeof D.value=="function"?(A="value",k=D.value):typeof D.get=="function"&&(A="get",k=D.get),!k)throw new Error("not supported");D[A]=R(k,g)}}function M(R,m,g){let D=null,A=null;if(typeof g.value=="function"?(D="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(D="get",A=g.get),!A)throw new Error("not supported");const k=`$memoize$${m}`;g[D]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[k]}}e.$Ch=M;function P(R,m,g){return S((D,A)=>{const k=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...v){this[l]||(this[l]=g?g():void 0),clearTimeout(this[k]),m&&(this[l]=m(this[l],...v),v=[this[l]]),this[k]=setTimeout(()=>{D.apply(this,v),this[l]=g?g():void 0},R)}})}e.$Dh=P;function N(R,m,g){return S((D,A)=>{const k=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...s){if(this[l]||(this[l]=g?g():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...s)),this[p])return;const a=this[v]+R;a<=Date.now()?(this[v]=Date.now(),D.apply(this,[this[l]]),this[l]=g?g():void 0):(this[p]=!0,this[k]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),D.apply(this,[this[l]]),this[l]=g?g():void 0},a-Date.now()))}})}e.$Eh=N}),define(Le[88],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=e.$ON=void 0;class S{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$ON=S,e.$PN=new S("id#")}),define(Le[120],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var N;(function(t){t.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function R(t,f=!1){let c=0;const u=t.length;let E="",y=0,$=16,I=0;function d(U){let C=0,F=0;for(;C<U;){const W=t.charCodeAt(c);if(W>=48&&W<=57)F=F*16+W-48;else if(W>=65&&W<=70)F=F*16+W-65+10;else if(W>=97&&W<=102)F=F*16+W-97+10;else break;c++,C++}return C<U&&(F=-1),F}function w(U){c=U,E="",y=0,$=16,I=0}function b(){const U=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&D(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&D(t.charCodeAt(c)))for(c++;c<t.length&&D(t.charCodeAt(c));)c++;else return I=3,t.substring(U,c);let C=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&D(t.charCodeAt(c))){for(c++;c<t.length&&D(t.charCodeAt(c));)c++;C=c}else I=3;return t.substring(U,C)}function L(){let U="",C=c;for(;;){if(c>=u){U+=t.substring(C,c),I=2;break}const F=t.charCodeAt(c);if(F===34){U+=t.substring(C,c),c++;break}if(F===92){if(U+=t.substring(C,c),c++,c>=u){I=2;break}switch(t.charCodeAt(c++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const re=d(4);re>=0?U+=String.fromCharCode(re):I=4;break}default:I=5}C=c;continue}if(F>=0&&F<=31)if(g(F)){U+=t.substring(C,c),I=2;break}else I=6;c++}return U}function T(){if(E="",I=0,y=c,c>=u)return y=u,$=17;let U=t.charCodeAt(c);if(m(U)){do c++,E+=String.fromCharCode(U),U=t.charCodeAt(c);while(m(U));return $=15}if(g(U))return c++,E+=String.fromCharCode(U),U===13&&t.charCodeAt(c)===10&&(c++,E+=`
`),$=14;switch(U){case 123:return c++,$=1;case 125:return c++,$=2;case 91:return c++,$=3;case 93:return c++,$=4;case 58:return c++,$=6;case 44:return c++,$=5;case 34:return c++,E=L(),$=10;case 47:{const C=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<u&&!g(t.charCodeAt(c));)c++;return E=t.substring(C,c),$=12}if(t.charCodeAt(c+1)===42){c+=2;const F=u-1;let W=!1;for(;c<F;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,W=!0;break}c++}return W||(c++,I=1),E=t.substring(C,c),$=13}return E+=String.fromCharCode(U),c++,$=16}case 45:if(E+=String.fromCharCode(U),c++,c===u||!D(t.charCodeAt(c)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=b(),$=11;default:for(;c<u&&Y(U);)c++,U=t.charCodeAt(c);if(y!==c){switch(E=t.substring(y,c),E){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return E+=String.fromCharCode(U),c++,$=16}}function Y(U){if(m(U)||g(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=T();while(U>=12&&U<=15);return U}return{setPosition:w,getPosition:()=>c,scan:f?q:T,getToken:()=>$,getTokenValue:()=>E,getTokenOffset:()=>y,getTokenLength:()=>c-y,getTokenError:()=>I}}e.$gn=R;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function D(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function k(t,f){const c=[],u=new Object;let E;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function I(d,w,b,L){y.value=d,y.offset=w,y.length=b,y.type=L,y.colonOffset=void 0,E=y}try{n(t,{onObjectBegin:(d,w)=>{if(f<=d)throw u;E=void 0,$=f>d,c.push("")},onObjectProperty:(d,w,b)=>{if(f<w||(I(d,w,b,"property"),c[c.length-1]=d,f<=w+b))throw u},onObjectEnd:(d,w)=>{if(f<=d)throw u;E=void 0,c.pop()},onArrayBegin:(d,w)=>{if(f<=d)throw u;E=void 0,c.push(0)},onArrayEnd:(d,w)=>{if(f<=d)throw u;E=void 0,c.pop()},onLiteralValue:(d,w,b)=>{if(f<w||(I(d,w,b,h(d)),f<=w+b))throw u},onSeparator:(d,w,b)=>{if(f<=w)throw u;if(d===":"&&E&&E.type==="property")E.colonOffset=w,$=!1,E=void 0;else if(d===","){const L=c[c.length-1];typeof L=="number"?c[c.length-1]=L+1:($=!0,c[c.length-1]=""),E=void 0}}})}catch(d){if(d!==u)throw d}return{path:c,previousNode:E,isAtPropertyKey:$,matches:d=>{let w=0;for(let b=0;w<d.length&&b<c.length;b++)if(d[w]===c[b]||d[w]==="*")w++;else if(d[w]!=="**")return!1;return w===d.length}}}e.$hn=k;function l(t,f=[],c=N.DEFAULT){let u=null,E=[];const y=[];function $(d){Array.isArray(E)?E.push(d):u!==null&&(E[u]=d)}return n(t,{onObjectBegin:()=>{const d={};$(d),y.push(E),E=d,u=null},onObjectProperty:d=>{u=d},onObjectEnd:()=>{E=y.pop()},onArrayBegin:()=>{const d=[];$(d),y.push(E),E=d,u=null},onArrayEnd:()=>{E=y.pop()},onLiteralValue:$,onError:(d,w,b)=>{f.push({error:d,offset:w,length:b})}},c),E[0]}e.$in=l;function v(t,f=[],c=N.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(d){u.type==="property"&&(u.length=d-u.offset,u=u.parent)}function y(d){return u.children.push(d),d}n(t,{onObjectBegin:d=>{u=y({type:"object",offset:d,length:-1,parent:u,children:[]})},onObjectProperty:(d,w,b)=>{u=y({type:"property",offset:w,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:d,offset:w,length:b,parent:u})},onObjectEnd:(d,w)=>{u.length=d+w-u.offset,u=u.parent,E(d+w)},onArrayBegin:(d,w)=>{u=y({type:"array",offset:d,length:-1,parent:u,children:[]})},onArrayEnd:(d,w)=>{u.length=d+w-u.offset,u=u.parent,E(d+w)},onLiteralValue:(d,w,b)=>{y({type:h(d),offset:w,length:b,parent:u,value:d}),E(w+b)},onSeparator:(d,w,b)=>{u.type==="property"&&(d===":"?u.colonOffset=w:d===","&&E(w))},onError:(d,w,b)=>{f.push({error:d,offset:w,length:b})}},c);const I=u.children[0];return I&&delete I.parent,I}e.$jn=v;function p(t,f){if(!t)return;let c=t;for(const u of f)if(typeof u=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let E=!1;for(const y of c.children)if(Array.isArray(y.children)&&y.children[0].value===u){c=y.children[1],E=!0;break}if(!E)return}else{const E=u;if(c.type!=="array"||E<0||!Array.isArray(c.children)||E>=c.children.length)return;c=c.children[E]}return c}e.$kn=p;function s(t){if(!t.parent||!t.parent.children)return[];const f=s(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;f.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&f.push(c)}return f}e.$ln=s;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const f=Object.create(null);for(const c of t.children){const u=c.children[1];u&&(f[c.children[0].value]=a(u))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$mn=a;function r(t,f,c=!1){return f>=t.offset&&f<t.offset+t.length||c&&f===t.offset+t.length}e.$nn=r;function i(t,f,c=!1){if(r(t,f,c)){const u=t.children;if(Array.isArray(u))for(let E=0;E<u.length&&u[E].offset<=f;E++){const y=i(u[E],f,c);if(y)return y}return t}}e.$on=i;function n(t,f,c=N.DEFAULT){const u=R(t,!1);function E(se){return se?()=>se(u.getTokenOffset(),u.getTokenLength()):()=>!0}function y(se){return se?$e=>se($e,u.getTokenOffset(),u.getTokenLength()):()=>!0}const $=E(f.onObjectBegin),I=y(f.onObjectProperty),d=E(f.onObjectEnd),w=E(f.onArrayBegin),b=E(f.onArrayEnd),L=y(f.onLiteralValue),T=y(f.onSeparator),Y=E(f.onComment),q=y(f.onError),U=c&&c.disallowComments,C=c&&c.allowTrailingComma;function F(){for(;;){const se=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(se){case 12:case 13:U?W(10):Y();break;case 16:W(1);break;case 15:case 14:break;default:return se}}}function W(se,$e=[],te=[]){if(q(se),$e.length+te.length>0){let X=u.getToken();for(;X!==17;){if($e.indexOf(X)!==-1){F();break}else if(te.indexOf(X)!==-1)break;X=F()}}}function re(se){const $e=u.getTokenValue();return se?L($e):I($e),F(),!0}function ue(){switch(u.getToken()){case 11:{let se=0;try{se=JSON.parse(u.getTokenValue()),typeof se!="number"&&(W(2),se=0)}catch{W(2)}L(se);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return F(),!0}function ye(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(re(!1),u.getToken()===6?(T(":"),F(),ve()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function ke(){$(),F();let se=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(se||W(4,[],[]),T(","),F(),u.getToken()===2&&C)break}else se&&W(6,[],[]);ye()||W(4,[],[2,5]),se=!0}return d(),u.getToken()!==2?W(7,[2],[]):F(),!0}function he(){w(),F();let se=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(se||W(4,[],[]),T(","),F(),u.getToken()===4&&C)break}else se&&W(6,[],[]);ve()||W(4,[],[4,5]),se=!0}return b(),u.getToken()!==4?W(8,[4],[]):F(),!0}function ve(){switch(u.getToken()){case 3:return he();case 1:return ke();case 10:return re(!0);default:return ue()}}return F(),u.getToken()===17?c.allowEmptyContent?!0:(W(4,[],[]),!1):ve()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$pn=n;function o(t,f){const c=R(t),u=[];let E,y=0,$;do switch($=c.getPosition(),E=c.scan(),E){case 12:case 13:case 17:y!==$&&u.push(t.substring(y,$)),f!==void 0&&u.push(c.getTokenValue().replace(/[^\r\n]/g,f)),y=c.getPosition();break}while(E!==17);return u.join("")}e.$qn=o;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$rn=h}),function(fe,e){typeof define=="function"&&define.amd?define(Le[121],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(Pe,we){for(var me=0;me<we.length;me++){var J=we[me];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(Pe,J.key,J)}}function S(Pe,we,me){return we&&e(Pe.prototype,we),me&&e(Pe,me),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function M(Pe,we){if(Pe){if(typeof Pe=="string")return P(Pe,we);var me=Object.prototype.toString.call(Pe).slice(8,-1);if(me==="Object"&&Pe.constructor&&(me=Pe.constructor.name),me==="Map"||me==="Set")return Array.from(Pe);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return P(Pe,we)}}function P(Pe,we){(we==null||we>Pe.length)&&(we=Pe.length);for(var me=0,J=new Array(we);me<we;me++)J[me]=Pe[me];return J}function N(Pe,we){var me=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(me)return(me=me.call(Pe)).next.bind(me);if(Array.isArray(Pe)||(me=M(Pe))||we&&Pe&&typeof Pe.length=="number"){me&&(Pe=me);var J=0;return function(){return J>=Pe.length?{done:!0}:{done:!1,value:Pe[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=R();function m(Pe){fe.defaults=Pe}var g=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(we){return l[we]};function p(Pe,we){if(we){if(g.test(Pe))return Pe.replace(D,v)}else if(A.test(Pe))return Pe.replace(k,v);return Pe}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Pe){return Pe.replace(s,function(we,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var r=/(^|[^\[])\^/g;function i(Pe,we){Pe=typeof Pe=="string"?Pe:Pe.source,we=we||"";var me={replace:function(x,le){return le=le.source||le,le=le.replace(r,"$1"),Pe=Pe.replace(x,le),me},getRegex:function(){return new RegExp(Pe,we)}};return me}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Pe,we,me){if(Pe){var J;try{J=decodeURIComponent(a(me)).replace(n,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}we&&!o.test(me)&&(me=E(we,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},f=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(Pe,we){t[" "+Pe]||(f.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=d(Pe,"/",!0)),Pe=t[" "+Pe];var me=Pe.indexOf(":")===-1;return we.substring(0,2)==="//"?me?we:Pe.replace(c,"$1")+we:we.charAt(0)==="/"?me?we:Pe.replace(u,"$1")+we:Pe+we}var y={exec:function(){}};function $(Pe){for(var we=1,me,J;we<arguments.length;we++){me=arguments[we];for(J in me)Object.prototype.hasOwnProperty.call(me,J)&&(Pe[J]=me[J])}return Pe}function I(Pe,we){var me=Pe.replace(/\|/g,function(le,de,Ae){for(var ge=!1,Se=de;--Se>=0&&Ae[Se]==="\\";)ge=!ge;return ge?"|":" |"}),J=me.split(/ \|/),x=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>we)J.splice(we);else for(;J.length<we;)J.push("");for(;x<J.length;x++)J[x]=J[x].trim().replace(/\\\|/g,"|");return J}function d(Pe,we,me){var J=Pe.length;if(J===0)return"";for(var x=0;x<J;){var le=Pe.charAt(J-x-1);if(le===we&&!me)x++;else if(le!==we&&me)x++;else break}return Pe.slice(0,J-x)}function w(Pe,we){if(Pe.indexOf(we[1])===-1)return-1;for(var me=Pe.length,J=0,x=0;x<me;x++)if(Pe[x]==="\\")x++;else if(Pe[x]===we[0])J++;else if(Pe[x]===we[1]&&(J--,J<0))return x;return-1}function b(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(Pe,we){if(we<1)return"";for(var me="";we>1;)we&1&&(me+=Pe),we>>=1,Pe+=Pe;return me+Pe}function T(Pe,we,me,J){var x=we.href,le=we.title?p(we.title):null,de=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){J.state.inLink=!0;var Ae={type:"link",raw:me,href:x,title:le,text:de,tokens:J.inlineTokens(de)};return J.state.inLink=!1,Ae}return{type:"image",raw:me,href:x,title:le,text:p(de)}}function Y(Pe,we){var me=Pe.match(/^(\s+)(?:```)/);if(me===null)return we;var J=me[1];return we.split(`
`).map(function(x){var le=x.match(/^\s+/);if(le===null)return x;var de=le[0];return de.length>=J.length?x.slice(J.length):x}).join(`
`)}var q=function(){function Pe(me){this.options=me||fe.defaults}var we=Pe.prototype;return we.space=function(J){var x=this.rules.block.newline.exec(J);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},we.code=function(J){var x=this.rules.block.code.exec(J);if(x){var le=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?le:d(le,`
`)}}},we.fences=function(J){var x=this.rules.block.fences.exec(J);if(x){var le=x[0],de=Y(le,x[3]||"");return{type:"code",raw:le,lang:x[2]?x[2].trim():x[2],text:de}}},we.heading=function(J){var x=this.rules.block.heading.exec(J);if(x){var le=x[2].trim();if(/#$/.test(le)){var de=d(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:le,tokens:this.lexer.inline(le)}}},we.hr=function(J){var x=this.rules.block.hr.exec(J);if(x)return{type:"hr",raw:x[0]}},we.blockquote=function(J){var x=this.rules.block.blockquote.exec(J);if(x){var le=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},we.list=function(J){var x=this.rules.block.list.exec(J);if(x){var le,de,Ae,ge,Se,Ie,O,G,B,H,Q,ae,Ee=x[1].trim(),Be=Ee.length>1,We={type:"list",raw:"",ordered:Be,start:Be?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Be?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Be?Ee:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(ae=!1,!(!(x=Qe.exec(J))||this.rules.block.hr.test(J)));){if(le=x[0],J=J.substring(le.length),G=x[2].split(`
`,1)[0],B=J.split(`
`,1)[0],this.options.pedantic?(ge=2,Q=G.trimLeft()):(ge=x[2].search(/[^ ]/),ge=ge>4?1:ge,Q=G.slice(ge),ge+=x[1].length),Ie=!1,!G&&/^ *$/.test(B)&&(le+=B+`
`,J=J.substring(B.length+1),ae=!0),!ae)for(var xe=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");J&&(H=J.split(`
`,1)[0],G=H,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(G)||et.test(G)||xe.test(G)||ct.test(J)));){if(G.search(/[^ ]/)>=ge||!G.trim())Q+=`
`+G.slice(ge);else if(!Ie)Q+=`
`+G;else break;!Ie&&!G.trim()&&(Ie=!0),le+=H+`
`,J=J.substring(H.length+1)}We.loose||(O?We.loose=!0:/\n *\n *$/.test(le)&&(O=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Q),de&&(Ae=de[0]!=="[ ] ",Q=Q.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:le,task:!!de,checked:Ae,loose:!1,text:Q}),We.raw+=le}We.items[We.items.length-1].raw=le.trimRight(),We.items[We.items.length-1].text=Q.trimRight(),We.raw=We.raw.trimRight();var ut=We.items.length;for(Se=0;Se<ut;Se++){this.lexer.state.top=!1,We.items[Se].tokens=this.lexer.blockTokens(We.items[Se].text,[]);var Ue=We.items[Se].tokens.filter(function(Z){return Z.type==="space"}),pt=Ue.every(function(Z){for(var _=Z.raw.split(""),pe=0,Ve=N(_),Ye;!(Ye=Ve()).done;){var nt=Ye.value;if(nt===`
`&&(pe+=1),pe>1)return!0}return!1});!We.loose&&Ue.length&&pt&&(We.loose=!0,We.items[Se].loose=!0)}return We}},we.html=function(J){var x=this.rules.block.html.exec(J);if(x){var le={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},we.def=function(J){var x=this.rules.block.def.exec(J);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var le=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:x[0],href:x[2],title:x[3]}}},we.table=function(J){var x=this.rules.block.table.exec(J);if(x){var le={type:"table",header:I(x[1]).map(function(O){return{text:O}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=x[0];var de=le.align.length,Ae,ge,Se,Ie;for(Ae=0;Ae<de;Ae++)/^ *-+: *$/.test(le.align[Ae])?le.align[Ae]="right":/^ *:-+: *$/.test(le.align[Ae])?le.align[Ae]="center":/^ *:-+ *$/.test(le.align[Ae])?le.align[Ae]="left":le.align[Ae]=null;for(de=le.rows.length,Ae=0;Ae<de;Ae++)le.rows[Ae]=I(le.rows[Ae],le.header.length).map(function(O){return{text:O}});for(de=le.header.length,ge=0;ge<de;ge++)le.header[ge].tokens=this.lexer.inline(le.header[ge].text);for(de=le.rows.length,ge=0;ge<de;ge++)for(Ie=le.rows[ge],Se=0;Se<Ie.length;Se++)Ie[Se].tokens=this.lexer.inline(Ie[Se].text);return le}}},we.lheading=function(J){var x=this.rules.block.lheading.exec(J);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},we.paragraph=function(J){var x=this.rules.block.paragraph.exec(J);if(x){var le=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:le,tokens:this.lexer.inline(le)}}},we.text=function(J){var x=this.rules.block.text.exec(J);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},we.escape=function(J){var x=this.rules.inline.escape.exec(J);if(x)return{type:"escape",raw:x[0],text:p(x[1])}},we.tag=function(J){var x=this.rules.inline.tag.exec(J);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]):x[0]}},we.link=function(J){var x=this.rules.inline.link.exec(J);if(x){var le=x[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=d(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Ae=w(x[2],"()");if(Ae>-1){var ge=x[0].indexOf("!")===0?5:4,Se=ge+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,Se).trim(),x[3]=""}}var Ie=x[2],O="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);G&&(Ie=G[1],O=G[3])}else O=x[3]?x[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(le)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),T(x,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:O&&O.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},we.reflink=function(J,x){var le;if((le=this.rules.inline.reflink.exec(J))||(le=this.rules.inline.nolink.exec(J))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=x[de.toLowerCase()],!de||!de.href){var Ae=le[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return T(le,de,le[0],this.lexer)}},we.emStrong=function(J,x,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(J);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=de[1]||de[2]||"";if(!Ae||Ae&&(le===""||this.rules.inline.punctuation.exec(le))){var ge=de[0].length-1,Se,Ie,O=ge,G=0,B=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,x=x.slice(-1*J.length+ge);(de=B.exec(x))!=null;)if(Se=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Se){if(Ie=Se.length,de[3]||de[4]){O+=Ie;continue}else if((de[5]||de[6])&&ge%3&&!((ge+Ie)%3)){G+=Ie;continue}if(O-=Ie,!(O>0)){if(Ie=Math.min(Ie,Ie+O+G),Math.min(ge,Ie)%2){var H=J.slice(1,ge+de.index+Ie);return{type:"em",raw:J.slice(0,ge+de.index+Ie+1),text:H,tokens:this.lexer.inlineTokens(H)}}var Q=J.slice(2,ge+de.index+Ie-1);return{type:"strong",raw:J.slice(0,ge+de.index+Ie+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}}}}},we.codespan=function(J){var x=this.rules.inline.code.exec(J);if(x){var le=x[2].replace(/\n/g," "),de=/[^ ]/.test(le),Ae=/^ /.test(le)&&/ $/.test(le);return de&&Ae&&(le=le.substring(1,le.length-1)),le=p(le,!0),{type:"codespan",raw:x[0],text:le}}},we.br=function(J){var x=this.rules.inline.br.exec(J);if(x)return{type:"br",raw:x[0]}},we.del=function(J){var x=this.rules.inline.del.exec(J);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},we.autolink=function(J,x){var le=this.rules.inline.autolink.exec(J);if(le){var de,Ae;return le[2]==="@"?(de=p(this.options.mangle?x(le[1]):le[1]),Ae="mailto:"+de):(de=p(le[1]),Ae=de),{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},we.url=function(J,x){var le;if(le=this.rules.inline.url.exec(J)){var de,Ae;if(le[2]==="@")de=p(this.options.mangle?x(le[0]):le[0]),Ae="mailto:"+de;else{var ge;do ge=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(ge!==le[0]);de=p(le[0]),le[1]==="www."?Ae="http://"+de:Ae=de}return{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},we.inlineText=function(J,x){var le=this.rules.inline.text.exec(J);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):p(le[0]):le[0]:de=p(this.options.smartypants?x(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Pe}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=$({},U),U.gfm=$({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=$({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=i(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=i(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=i(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=i(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=i(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=i(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=i(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=i(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=i(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=i(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=$({},C),C.pedantic=$({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=$({},C.normal,{escape:i(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=i(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=$({},C.gfm,{br:i(C.br).replace("{2,}","*").getRegex(),text:i(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Pe){var we="",me,J,x=Pe.length;for(me=0;me<x;me++)J=Pe.charCodeAt(me),Math.random()>.5&&(J="x"+J.toString(16)),we+="&#"+J+";";return we}var re=function(){function Pe(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||fe.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:U.normal,inline:C.normal};this.options.pedantic?(J.block=U.pedantic,J.inline=C.pedantic):this.options.gfm&&(J.block=U.gfm,this.options.breaks?J.inline=C.breaks:J.inline=C.gfm),this.tokenizer.rules=J}Pe.lex=function(J,x){var le=new Pe(x);return le.lex(J)},Pe.lexInline=function(J,x){var le=new Pe(x);return le.inlineTokens(J)};var we=Pe.prototype;return we.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},we.blockTokens=function(J,x){var le=this;x===void 0&&(x=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(O,G,B){return G+"    ".repeat(B.length)});for(var de,Ae,ge,Se;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(O){return(de=O.call({lexer:le},J,x))?(J=J.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.space(J)){J=J.substring(de.raw.length),de.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(de);continue}if(de=this.tokenizer.code(J)){J=J.substring(de.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(de);continue}if(de=this.tokenizer.fences(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.heading(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.hr(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.blockquote(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.list(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.html(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.def(J)){J=J.substring(de.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.lheading(J)){J=J.substring(de.raw.length),x.push(de);continue}if(ge=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var O=1/0,G=J.slice(1),B=void 0;le.options.extensions.startBlock.forEach(function(H){B=H.call({lexer:this},G),typeof B=="number"&&B>=0&&(O=Math.min(O,B))}),O<1/0&&O>=0&&(ge=J.substring(0,O+1))}(),this.state.top&&(de=this.tokenizer.paragraph(ge))){Ae=x[x.length-1],Se&&Ae.type==="paragraph"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(de),Se=ge.length!==J.length,J=J.substring(de.raw.length);continue}if(de=this.tokenizer.text(J)){J=J.substring(de.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(de);continue}if(J){var Ie="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,x},we.inline=function(J,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:J,tokens:x}),x},we.inlineTokens=function(J,x){var le=this;x===void 0&&(x=[]);var de,Ae,ge,Se=J,Ie,O,G;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)B.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ie.index)+"["+L("a",Ie[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ie.index)+"["+L("a",Ie[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ie.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(O||(G=""),O=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Q){return(de=Q.call({lexer:le},J,x))?(J=J.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.escape(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.tag(J)){J=J.substring(de.raw.length),Ae=x[x.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):x.push(de);continue}if(de=this.tokenizer.link(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(de.raw.length),Ae=x[x.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):x.push(de);continue}if(de=this.tokenizer.emStrong(J,Se,G)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.codespan(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.br(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.del(J)){J=J.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.autolink(J,W)){J=J.substring(de.raw.length),x.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(J,W))){J=J.substring(de.raw.length),x.push(de);continue}if(ge=J,this.options.extensions&&this.options.extensions.startInline&&function(){var Q=1/0,ae=J.slice(1),Ee=void 0;le.options.extensions.startInline.forEach(function(Be){Ee=Be.call({lexer:this},ae),typeof Ee=="number"&&Ee>=0&&(Q=Math.min(Q,Ee))}),Q<1/0&&Q>=0&&(ge=J.substring(0,Q+1))}(),de=this.tokenizer.inlineText(ge,F)){J=J.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(G=de.raw.slice(-1)),O=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):x.push(de);continue}if(J){var H="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return x},S(Pe,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Pe}(),ue=function(){function Pe(me){this.options=me||fe.defaults}var we=Pe.prototype;return we.code=function(J,x,le){var de=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(J,de);Ae!=null&&Ae!==J&&(le=!0,J=Ae)}return J=J.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+p(de,!0)+'">'+(le?J:p(J,!0))+`</code></pre>
`:"<pre><code>"+(le?J:p(J,!0))+`</code></pre>
`},we.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},we.html=function(J){return J},we.heading=function(J,x,le,de){if(this.options.headerIds){var Ae=this.options.headerPrefix+de.slug(le);return"<h"+x+' id="'+Ae+'">'+J+"</h"+x+`>
`}return"<h"+x+">"+J+"</h"+x+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(J,x,le){var de=x?"ol":"ul",Ae=x&&le!==1?' start="'+le+'"':"";return"<"+de+Ae+`>
`+J+"</"+de+`>
`},we.listitem=function(J){return"<li>"+J+`</li>
`},we.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(J){return"<p>"+J+`</p>
`},we.table=function(J,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+x+`</table>
`},we.tablerow=function(J){return`<tr>
`+J+`</tr>
`},we.tablecell=function(J,x){var le=x.header?"th":"td",de=x.align?"<"+le+' align="'+x.align+'">':"<"+le+">";return de+J+("</"+le+`>
`)},we.strong=function(J){return"<strong>"+J+"</strong>"},we.em=function(J){return"<em>"+J+"</em>"},we.codespan=function(J){return"<code>"+J+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(J){return"<del>"+J+"</del>"},we.link=function(J,x,le){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var de='<a href="'+p(J)+'"';return x&&(de+=' title="'+x+'"'),de+=">"+le+"</a>",de},we.image=function(J,x,le){if(J=h(this.options.sanitize,this.options.baseUrl,J),J===null)return le;var de='<img src="'+J+'" alt="'+le+'"';return x&&(de+=' title="'+x+'"'),de+=this.options.xhtml?"/>":">",de},we.text=function(J){return J},Pe}(),ye=function(){function Pe(){}var we=Pe.prototype;return we.strong=function(J){return J},we.em=function(J){return J},we.codespan=function(J){return J},we.del=function(J){return J},we.html=function(J){return J},we.text=function(J){return J},we.link=function(J,x,le){return""+le},we.image=function(J,x,le){return""+le},we.br=function(){return""},Pe}(),ke=function(){function Pe(){this.seen={}}var we=Pe.prototype;return we.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(J,x){var le=J,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[J];do de++,le=J+"-"+de;while(this.seen.hasOwnProperty(le))}return x||(this.seen[J]=de,this.seen[le]=0),le},we.slug=function(J,x){x===void 0&&(x={});var le=this.serialize(J);return this.getNextSafeSlug(le,x.dryrun)},Pe}(),he=function(){function Pe(me){this.options=me||fe.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new ke}Pe.parse=function(J,x){var le=new Pe(x);return le.parse(J)},Pe.parseInline=function(J,x){var le=new Pe(x);return le.parseInline(J)};var we=Pe.prototype;return we.parse=function(J,x){x===void 0&&(x=!0);var le="",de,Ae,ge,Se,Ie,O,G,B,H,Q,ae,Ee,Be,We,Qe,xe,ct,rt,et,ut=J.length;for(de=0;de<ut;de++){if(Q=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(et=this.options.extensions.renderers[Q.type].call({parser:this},Q),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Q.type))){le+=et||"";continue}switch(Q.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(Q.tokens),Q.depth,a(this.parseInline(Q.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(Q.text,Q.lang,Q.escaped);continue}case"table":{for(B="",G="",Se=Q.header.length,Ae=0;Ae<Se;Ae++)G+=this.renderer.tablecell(this.parseInline(Q.header[Ae].tokens),{header:!0,align:Q.align[Ae]});for(B+=this.renderer.tablerow(G),H="",Se=Q.rows.length,Ae=0;Ae<Se;Ae++){for(O=Q.rows[Ae],G="",Ie=O.length,ge=0;ge<Ie;ge++)G+=this.renderer.tablecell(this.parseInline(O[ge].tokens),{header:!1,align:Q.align[ge]});H+=this.renderer.tablerow(G)}le+=this.renderer.table(B,H);continue}case"blockquote":{H=this.parse(Q.tokens),le+=this.renderer.blockquote(H);continue}case"list":{for(ae=Q.ordered,Ee=Q.start,Be=Q.loose,Se=Q.items.length,H="",Ae=0;Ae<Se;Ae++)Qe=Q.items[Ae],xe=Qe.checked,ct=Qe.task,We="",Qe.task&&(rt=this.renderer.checkbox(xe),Be?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=rt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=rt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:rt}):We+=rt),We+=this.parse(Qe.tokens,Be),H+=this.renderer.listitem(We,ct,xe);le+=this.renderer.list(H,ae,Ee);continue}case"html":{le+=this.renderer.html(Q.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(Q.tokens));continue}case"text":{for(H=Q.tokens?this.parseInline(Q.tokens):Q.text;de+1<ut&&J[de+1].type==="text";)Q=J[++de],H+=`
`+(Q.tokens?this.parseInline(Q.tokens):Q.text);le+=x?this.renderer.paragraph(H):H;continue}default:{var Ue='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Ue);return}else throw new Error(Ue)}}}return le},we.parseInline=function(J,x){x=x||this.renderer;var le="",de,Ae,ge,Se=J.length;for(de=0;de<Se;de++){if(Ae=J[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(ge=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){le+=ge||"";continue}switch(Ae.type){case"escape":{le+=x.text(Ae.text);break}case"html":{le+=x.html(Ae.text);break}case"link":{le+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{le+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{le+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{le+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{le+=x.codespan(Ae.text);break}case"br":{le+=x.br();break}case"del":{le+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{le+=x.text(Ae.text);break}default:{var Ie='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return le},Pe}();function ve(Pe,we,me){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof we=="function"&&(me=we,we=null),we=$({},ve.defaults,we||{}),b(we),me){var J=we.highlight,x;try{x=re.lex(Pe,we)}catch(Se){return me(Se)}var le=function(Ie){var O;if(!Ie)try{we.walkTokens&&ve.walkTokens(x,we.walkTokens),O=he.parse(x,we)}catch(G){Ie=G}return we.highlight=J,Ie?me(Ie):me(null,O)};if(!J||J.length<3||(delete we.highlight,!x.length))return le();var de=0;ve.walkTokens(x,function(Se){Se.type==="code"&&(de++,setTimeout(function(){J(Se.text,Se.lang,function(Ie,O){if(Ie)return le(Ie);O!=null&&O!==Se.text&&(Se.text=O,Se.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Ae(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+p(Se.message+"",!0)+"</pre>";throw Se}try{var ge=re.lex(Pe,we);if(we.walkTokens){if(we.async)return Promise.all(ve.walkTokens(ge,we.walkTokens)).then(function(){return he.parse(ge,we)}).catch(Ae);ve.walkTokens(ge,we.walkTokens)}return he.parse(ge,we)}catch(Se){Ae(Se)}}ve.options=ve.setOptions=function(Pe){return $(ve.defaults,Pe),m(ve.defaults),ve},ve.getDefaults=R,ve.defaults=fe.defaults,ve.use=function(){for(var Pe=arguments.length,we=new Array(Pe),me=0;me<Pe;me++)we[me]=arguments[me];var J=$.apply(void 0,[{}].concat(we)),x=ve.defaults.extensions||{renderers:{},childTokens:{}},le;we.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Se=x.renderers?x.renderers[ge.name]:null;Se?x.renderers[ge.name]=function(){for(var Ie=arguments.length,O=new Array(Ie),G=0;G<Ie;G++)O[G]=arguments[G];var B=ge.renderer.apply(this,O);return B===!1&&(B=Se.apply(this,O)),B}:x.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ge.level]?x[ge.level].unshift(ge.tokenizer):x[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?x.startBlock?x.startBlock.push(ge.start):x.startBlock=[ge.start]:ge.level==="inline"&&(x.startInline?x.startInline.push(ge.start):x.startInline=[ge.start]))}ge.childTokens&&(x.childTokens[ge.name]=ge.childTokens)})),de.renderer&&function(){var ge=ve.defaults.renderer||new ue,Se=function(G){var B=ge[G];ge[G]=function(){for(var H=arguments.length,Q=new Array(H),ae=0;ae<H;ae++)Q[ae]=arguments[ae];var Ee=de.renderer[G].apply(ge,Q);return Ee===!1&&(Ee=B.apply(ge,Q)),Ee}};for(var Ie in de.renderer)Se(Ie);J.renderer=ge}(),de.tokenizer&&function(){var ge=ve.defaults.tokenizer||new q,Se=function(G){var B=ge[G];ge[G]=function(){for(var H=arguments.length,Q=new Array(H),ae=0;ae<H;ae++)Q[ae]=arguments[ae];var Ee=de.tokenizer[G].apply(ge,Q);return Ee===!1&&(Ee=B.apply(ge,Q)),Ee}};for(var Ie in de.tokenizer)Se(Ie);J.tokenizer=ge}(),de.walkTokens){var Ae=ve.defaults.walkTokens;J.walkTokens=function(ge){var Se=[];return Se.push(de.walkTokens.call(this,ge)),Ae&&(Se=Se.concat(Ae.call(this,ge))),Se}}le&&(J.extensions=x),ve.setOptions(J)})},ve.walkTokens=function(Pe,we){for(var me=[],J=function(){var Ae=le.value;switch(me=me.concat(we.call(ve,Ae)),Ae.type){case"table":{for(var ge=N(Ae.header),Se;!(Se=ge()).done;){var Ie=Se.value;me=me.concat(ve.walkTokens(Ie.tokens,we))}for(var O=N(Ae.rows),G;!(G=O()).done;)for(var B=G.value,H=N(B),Q;!(Q=H()).done;){var ae=Q.value;me=me.concat(ve.walkTokens(ae.tokens,we))}break}case"list":{me=me.concat(ve.walkTokens(Ae.items,we));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Ae.type]?ve.defaults.extensions.childTokens[Ae.type].forEach(function(Ee){me=me.concat(ve.walkTokens(Ae[Ee],we))}):Ae.tokens&&(me=me.concat(ve.walkTokens(Ae.tokens,we)))}},x=N(Pe),le;!(le=x()).done;)J();return me},ve.parseInline=function(Pe,we){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");we=$({},ve.defaults,we||{}),b(we);try{var me=re.lexInline(Pe,we);return we.walkTokens&&ve.walkTokens(me,we.walkTokens),he.parseInline(me,we)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+p(J.message+"",!0)+"</pre>";throw J}},ve.Parser=he,ve.parser=he.parse,ve.Renderer=ue,ve.TextRenderer=ye,ve.Lexer=re,ve.lexer=re.lex,ve.Tokenizer=q,ve.Slugger=ke,ve.parse=ve;var se=ve.options,$e=ve.setOptions,te=ve.use,X=ve.walkTokens,V=ve.parseInline,ne=ve,Ce=he.parse,Fe=re.lex;fe.Lexer=re,fe.Parser=he,fe.Renderer=ue,fe.Slugger=ke,fe.TextRenderer=ye,fe.Tokenizer=q,fe.getDefaults=R,fe.lexer=Fe,fe.marked=ve,fe.options=se,fe.parse=ne,fe.parseInline=V,fe.parser=Ce,fe.setOptions=$e,fe.use=te,fe.walkTokens=X,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Le[122],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0;function S(s){const a=N(s);if(a&&a.length>0)return new Uint32Array(a)}e.$Wj=S;let M=0;const P=new Uint32Array(10);function N(s){if(M=0,R(s,k,4352),M>0||(R(s,l,4449),M>0)||(R(s,v,4520),M>0)||(R(s,p,12593),M))return P.subarray(0,M);if(s>=44032&&s<=55203){const a=s-44032,r=a%588,i=Math.floor(a/588),n=Math.floor(r/28),o=r%28-1;if(i<k.length?R(i,k,0):4352+i-12593<p.length&&R(4352+i,p,12593),n<l.length?R(n,l,0):4449+n-12593<p.length&&R(4449+n-12593,p,12593),o>=0&&(o<v.length?R(o,v,0):4520+o-12593<p.length&&R(4520+o-12593,p,12593)),M>0)return P.subarray(0,M)}}function R(s,a,r){s>=r&&s<r+a.length&&m(a[s-r])}function m(s){s!==0&&(P[M++]=s&255,s>>8&&(P[M++]=s>>8&255),s>>16&&(P[M++]=s>>16&255))}var g;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var D;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(D||(D={}));var A;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(A||(A={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Le[123],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=e.$cm=e.$bm=e.rot=e.$_l=void 0;function S(m,g,D){return Math.min(Math.max(m,g),D)}e.$_l=S;function M(m,g){return(g+m%g)%g}e.rot=M;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$bm=P;class N{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$cm=N;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const D=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$dm=R}),function(){function fe(P){const N=[];typeof P=="number"&&N.push("code/timeOrigin",P);function R(g){N.push(g,Date.now())}function m(){const g=[];for(let D=0;D<N.length;D+=2)g.push({name:N[D],startTime:N[D+1]});return g}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))N.push({name:R.name,startTime:Math.round(P+R.startTime)});return N}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:fe)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function S(M){if(e[M])return e[M].exports;var P=e[M]={i:M,l:!1,exports:{}};return fe[M].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=fe,S.c=e,S.d=function(M,P,N){S.o(M,P)||Object.defineProperty(M,P,{enumerable:!0,get:N})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,P){if(1&P&&(M=S(M)),8&P||4&P&&typeof M=="object"&&M&&M.__esModule)return M;var N=Object.create(null);if(S.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:M}),2&P&&typeof M!="string")for(var R in M)S.d(N,R,function(m){return M[m]}.bind(null,R));return N},S.n=function(M){var P=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(P,"a",P),P},S.o=function(M,P){return Object.prototype.hasOwnProperty.call(M,P)},S.p="",S(S.s=0)}([function(fe,e,S){(function(M){var P;e=fe.exports=te,P=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],D=0,A=D++;g[A]="0|[1-9]\\d*";var k=D++;g[k]="[0-9]+";var l=D++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=D++;g[v]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var p=D++;g[p]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var s=D++;g[s]="(?:"+g[A]+"|"+g[l]+")";var a=D++;g[a]="(?:"+g[k]+"|"+g[l]+")";var r=D++;g[r]="(?:-("+g[s]+"(?:\\."+g[s]+")*))";var i=D++;g[i]="(?:-?("+g[a]+"(?:\\."+g[a]+")*))";var n=D++;g[n]="[0-9A-Za-z-]+";var o=D++;g[o]="(?:\\+("+g[n]+"(?:\\."+g[n]+")*))";var h=D++,t="v?"+g[v]+g[r]+"?"+g[o]+"?";g[h]="^"+t+"$";var f="[v=\\s]*"+g[p]+g[i]+"?"+g[o]+"?",c=D++;g[c]="^"+f+"$";var u=D++;g[u]="((?:<|>)?=?)";var E=D++;g[E]=g[k]+"|x|X|\\*";var y=D++;g[y]=g[A]+"|x|X|\\*";var $=D++;g[$]="[v=\\s]*("+g[y]+")(?:\\.("+g[y]+")(?:\\.("+g[y]+")(?:"+g[r]+")?"+g[o]+"?)?)?";var I=D++;g[I]="[v=\\s]*("+g[E]+")(?:\\.("+g[E]+")(?:\\.("+g[E]+")(?:"+g[i]+")?"+g[o]+"?)?)?";var d=D++;g[d]="^"+g[u]+"\\s*"+g[$]+"$";var w=D++;g[w]="^"+g[u]+"\\s*"+g[I]+"$";var b=D++;g[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=D++;g[L]="(?:~>?)";var T=D++;g[T]="(\\s*)"+g[L]+"\\s+",m[T]=new RegExp(g[T],"g");var Y=D++;g[Y]="^"+g[L]+g[$]+"$";var q=D++;g[q]="^"+g[L]+g[I]+"$";var U=D++;g[U]="(?:\\^)";var C=D++;g[C]="(\\s*)"+g[U]+"\\s+",m[C]=new RegExp(g[C],"g");var F=D++;g[F]="^"+g[U]+g[$]+"$";var W=D++;g[W]="^"+g[U]+g[I]+"$";var re=D++;g[re]="^"+g[u]+"\\s*("+f+")$|^$";var ue=D++;g[ue]="^"+g[u]+"\\s*("+t+")$|^$";var ye=D++;g[ye]="(\\s*)"+g[u]+"\\s*("+f+"|"+g[$]+")",m[ye]=new RegExp(g[ye],"g");var ke=D++;g[ke]="^\\s*("+g[$]+")\\s+-\\s+("+g[$]+")\\s*$";var he=D++;g[he]="^\\s*("+g[I]+")\\s+-\\s+("+g[I]+")\\s*$";var ve=D++;g[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)P(se,g[se]),m[se]||(m[se]=new RegExp(g[se]));function $e(B,H){if(B instanceof te)return B;if(typeof B!="string"||B.length>N||!(H?m[c]:m[h]).test(B))return null;try{return new te(B,H)}catch{return null}}function te(B,H){if(B instanceof te){if(B.loose===H)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof te))return new te(B,H);P("SemVer",B,H),this.loose=H;var Q=B.trim().match(H?m[c]:m[h]);if(!Q)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+Q[1],this.minor=+Q[2],this.patch=+Q[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Q[4]?this.prerelease=Q[4].split(".").map(function(ae){if(/^[0-9]+$/.test(ae)){var Ee=+ae;if(Ee>=0&&Ee<R)return Ee}return ae}):this.prerelease=[],this.build=Q[5]?Q[5].split("."):[],this.format()}e.parse=$e,e.valid=function(B,H){var Q=$e(B,H);return Q?Q.version:null},e.clean=function(B,H){var Q=$e(B.trim().replace(/^[=v]+/,""),H);return Q?Q.version:null},e.SemVer=te,te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},te.prototype.toString=function(){return this.version},te.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof te||(B=new te(B,this.loose)),this.compareMain(B)||this.comparePre(B)},te.prototype.compareMain=function(B){return B instanceof te||(B=new te(B,this.loose)),V(this.major,B.major)||V(this.minor,B.minor)||V(this.patch,B.patch)},te.prototype.comparePre=function(B){if(B instanceof te||(B=new te(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var H=0;do{var Q=this.prerelease[H],ae=B.prerelease[H];if(P("prerelease compare",H,Q,ae),Q===void 0&&ae===void 0)return 0;if(ae===void 0)return 1;if(Q===void 0)return-1;if(Q!==ae)return V(Q,ae)}while(++H)},te.prototype.inc=function(B,H){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Q=this.prerelease.length;--Q>=0;)typeof this.prerelease[Q]=="number"&&(this.prerelease[Q]++,Q=-2);Q===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,H,Q,ae){typeof Q=="string"&&(ae=Q,Q=void 0);try{return new te(B,Q).inc(H,ae).version}catch{return null}},e.diff=function(B,H){if(Pe(B,H))return null;var Q=$e(B),ae=$e(H);if(Q.prerelease.length||ae.prerelease.length){for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==ae[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in Q)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Q[Ee]!==ae[Ee])return Ee},e.compareIdentifiers=V;var X=/^[0-9]+$/;function V(B,H){var Q=X.test(B),ae=X.test(H);return Q&&ae&&(B=+B,H=+H),Q&&!ae?-1:ae&&!Q?1:B<H?-1:B>H?1:0}function ne(B,H,Q){return new te(B,Q).compare(new te(H,Q))}function Ce(B,H,Q){return ne(B,H,Q)>0}function Fe(B,H,Q){return ne(B,H,Q)<0}function Pe(B,H,Q){return ne(B,H,Q)===0}function we(B,H,Q){return ne(B,H,Q)!==0}function me(B,H,Q){return ne(B,H,Q)>=0}function J(B,H,Q){return ne(B,H,Q)<=0}function x(B,H,Q,ae){var Ee;switch(H){case"===":typeof B=="object"&&(B=B.version),typeof Q=="object"&&(Q=Q.version),Ee=B===Q;break;case"!==":typeof B=="object"&&(B=B.version),typeof Q=="object"&&(Q=Q.version),Ee=B!==Q;break;case"":case"=":case"==":Ee=Pe(B,Q,ae);break;case"!=":Ee=we(B,Q,ae);break;case">":Ee=Ce(B,Q,ae);break;case">=":Ee=me(B,Q,ae);break;case"<":Ee=Fe(B,Q,ae);break;case"<=":Ee=J(B,Q,ae);break;default:throw new TypeError("Invalid operator: "+H)}return Ee}function le(B,H){if(B instanceof le){if(B.loose===H)return B;B=B.value}if(!(this instanceof le))return new le(B,H);P("comparator",B,H),this.loose=H,this.parse(B),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,H){return V(H,B)},e.major=function(B,H){return new te(B,H).major},e.minor=function(B,H){return new te(B,H).minor},e.patch=function(B,H){return new te(B,H).patch},e.compare=ne,e.compareLoose=function(B,H){return ne(B,H,!0)},e.rcompare=function(B,H,Q){return ne(H,B,Q)},e.sort=function(B,H){return B.sort(function(Q,ae){return e.compare(Q,ae,H)})},e.rsort=function(B,H){return B.sort(function(Q,ae){return e.rcompare(Q,ae,H)})},e.gt=Ce,e.lt=Fe,e.eq=Pe,e.neq=we,e.gte=me,e.lte=J,e.cmp=x,e.Comparator=le;var de={};function Ae(B,H){if(B instanceof Ae)return B.loose===H?B:new Ae(B.raw,H);if(B instanceof le)return new Ae(B.value,H);if(!(this instanceof Ae))return new Ae(B,H);if(this.loose=H,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(Q){return this.parseRange(Q.trim())},this).filter(function(Q){return Q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function ge(B){return!B||B.toLowerCase()==="x"||B==="*"}function Se(B,H,Q,ae,Ee,Be,We,Qe,xe,ct,rt,et,ut){return((H=ge(Q)?"":ge(ae)?">="+Q+".0.0":ge(Ee)?">="+Q+"."+ae+".0":">="+H)+" "+(Qe=ge(xe)?"":ge(ct)?"<"+(+xe+1)+".0.0":ge(rt)?"<"+xe+"."+(+ct+1)+".0":et?"<="+xe+"."+ct+"."+rt+"-"+et:"<="+Qe)).trim()}function Ie(B,H){for(var Q=0;Q<B.length;Q++)if(!B[Q].test(H))return!1;if(H.prerelease.length){for(Q=0;Q<B.length;Q++)if(P(B[Q].semver),B[Q].semver!==de&&B[Q].semver.prerelease.length>0){var ae=B[Q].semver;if(ae.major===H.major&&ae.minor===H.minor&&ae.patch===H.patch)return!0}return!1}return!0}function O(B,H,Q){try{H=new Ae(H,Q)}catch{return!1}return H.test(B)}function G(B,H,Q,ae){var Ee,Be,We,Qe,xe;switch(B=new te(B,ae),H=new Ae(H,ae),Q){case">":Ee=Ce,Be=J,We=Fe,Qe=">",xe=">=";break;case"<":Ee=Fe,Be=me,We=Ce,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(O(B,H,ae))return!1;for(var ct=0;ct<H.set.length;++ct){var rt=H.set[ct],et=null,ut=null;if(rt.forEach(function(Ue){Ue.semver===de&&(Ue=new le(">=0.0.0")),et=et||Ue,ut=ut||Ue,Ee(Ue.semver,et.semver,ae)?et=Ue:We(Ue.semver,ut.semver,ae)&&(ut=Ue)}),et.operator===Qe||et.operator===xe||(!ut.operator||ut.operator===Qe)&&Be(B,ut.semver)||ut.operator===xe&&We(B,ut.semver))return!1}return!0}le.prototype.parse=function(B){var H=this.loose?m[re]:m[ue],Q=B.match(H);if(!Q)throw new TypeError("Invalid comparator: "+B);this.operator=Q[1],this.operator==="="&&(this.operator=""),Q[2]?this.semver=new te(Q[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===de||(typeof B=="string"&&(B=new te(B,this.loose)),x(B,this.operator,this.semver,this.loose))},le.prototype.intersects=function(B,H){if(!(B instanceof le))throw new TypeError("a Comparator is required");var Q;if(this.operator==="")return Q=new Ae(B.value,H),O(this.value,Q,H);if(B.operator==="")return Q=new Ae(this.value,H),O(B.semver,Q,H);var ae=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Be=this.semver.version===B.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Qe=x(this.semver,"<",B.semver,H)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),xe=x(this.semver,">",B.semver,H)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return ae||Ee||Be&&We||Qe||xe},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(B){var H=this.loose;B=B.trim(),P("range",B,H);var Q=H?m[he]:m[ke];B=B.replace(Q,Se),P("hyphen replace",B),B=B.replace(m[ye],"$1$2$3"),P("comparator trim",B,m[ye]),B=(B=(B=B.replace(m[T],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ae=H?m[re]:m[ue],Ee=B.split(" ").map(function(Be){return function(We,Qe){return P("comp",We),We=function(xe,ct){return xe.trim().split(/\s+/).map(function(rt){return function(et,ut){P("caret",et,ut);var Ue=ut?m[W]:m[F];return et.replace(Ue,function(pt,Z,_,pe,Ve){var Ye;return P("caret",et,pt,Z,_,pe,Ve),ge(Z)?Ye="":ge(_)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":ge(pe)?Ye=Z==="0"?">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+".0 <"+(+Z+1)+".0.0":Ve?(P("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ye=Z==="0"?_==="0"?">="+Z+"."+_+"."+pe+Ve+" <"+Z+"."+_+"."+(+pe+1):">="+Z+"."+_+"."+pe+Ve+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+pe+Ve+" <"+(+Z+1)+".0.0"):(P("no pr"),Ye=Z==="0"?_==="0"?">="+Z+"."+_+"."+pe+" <"+Z+"."+_+"."+(+pe+1):">="+Z+"."+_+"."+pe+" <"+Z+"."+(+_+1)+".0":">="+Z+"."+_+"."+pe+" <"+(+Z+1)+".0.0"),P("caret return",Ye),Ye})}(rt,ct)}).join(" ")}(We,Qe),P("caret",We),We=function(xe,ct){return xe.trim().split(/\s+/).map(function(rt){return function(et,ut){var Ue=ut?m[q]:m[Y];return et.replace(Ue,function(pt,Z,_,pe,Ve){var Ye;return P("tilde",et,pt,Z,_,pe,Ve),ge(Z)?Ye="":ge(_)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":ge(pe)?Ye=">="+Z+"."+_+".0 <"+Z+"."+(+_+1)+".0":Ve?(P("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ye=">="+Z+"."+_+"."+pe+Ve+" <"+Z+"."+(+_+1)+".0"):Ye=">="+Z+"."+_+"."+pe+" <"+Z+"."+(+_+1)+".0",P("tilde return",Ye),Ye})}(rt,ct)}).join(" ")}(We,Qe),P("tildes",We),We=function(xe,ct){return P("replaceXRanges",xe,ct),xe.split(/\s+/).map(function(rt){return function(et,ut){et=et.trim();var Ue=ut?m[w]:m[d];return et.replace(Ue,function(pt,Z,_,pe,Ve,Ye){P("xRange",et,pt,Z,_,pe,Ve,Ye);var nt=ge(_),st=nt||ge(pe),Te=st||ge(Ve);return Z==="="&&Te&&(Z=""),nt?pt=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Te?(st&&(pe=0),Te&&(Ve=0),Z===">"?(Z=">=",st?(_=+_+1,pe=0,Ve=0):Te&&(pe=+pe+1,Ve=0)):Z==="<="&&(Z="<",st?_=+_+1:pe=+pe+1),pt=Z+_+"."+pe+"."+Ve):st?pt=">="+_+".0.0 <"+(+_+1)+".0.0":Te&&(pt=">="+_+"."+pe+".0 <"+_+"."+(+pe+1)+".0"),P("xRange return",pt),pt})}(rt,ct)}).join(" ")}(We,Qe),P("xrange",We),We=function(xe,ct){return P("replaceStars",xe,ct),xe.trim().replace(m[ve],"")}(We,Qe),P("stars",We),We}(Be,H)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Be){return!!Be.match(ae)})),Ee=Ee.map(function(Be){return new le(Be,H)})},Ae.prototype.intersects=function(B,H){if(!(B instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(Q){return Q.every(function(ae){return B.set.some(function(Ee){return Ee.every(function(Be){return ae.intersects(Be,H)})})})})},e.toComparators=function(B,H){return new Ae(B,H).set.map(function(Q){return Q.map(function(ae){return ae.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new te(B,this.loose));for(var H=0;H<this.set.length;H++)if(Ie(this.set[H],B))return!0;return!1},e.satisfies=O,e.maxSatisfying=function(B,H,Q){var ae=null,Ee=null;try{var Be=new Ae(H,Q)}catch{return null}return B.forEach(function(We){Be.test(We)&&(ae&&Ee.compare(We)!==-1||(Ee=new te(ae=We,Q)))}),ae},e.minSatisfying=function(B,H,Q){var ae=null,Ee=null;try{var Be=new Ae(H,Q)}catch{return null}return B.forEach(function(We){Be.test(We)&&(ae&&Ee.compare(We)!==1||(Ee=new te(ae=We,Q)))}),ae},e.validRange=function(B,H){try{return new Ae(B,H).range||"*"}catch{return null}},e.ltr=function(B,H,Q){return G(B,H,"<",Q)},e.gtr=function(B,H,Q){return G(B,H,">",Q)},e.outside=G,e.prerelease=function(B,H){var Q=$e(B,H);return Q&&Q.prerelease.length?Q.prerelease:null},e.intersects=function(B,H,Q){return B=new Ae(B,Q),H=new Ae(H,Q),B.intersects(H)},e.coerce=function(B){if(B instanceof te)return B;if(typeof B!="string")return null;var H=B.match(m[b]);return H==null?null:$e((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(fe,e){var S,M,P=fe.exports={};function N(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(a){if(S===setTimeout)return setTimeout(a,0);if((S===N||!S)&&setTimeout)return S=setTimeout,setTimeout(a,0);try{return S(a,0)}catch{try{return S.call(null,a,0)}catch{return S.call(this,a,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:N}catch{S=N}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var g,D=[],A=!1,k=-1;function l(){A&&g&&(A=!1,g.length?D=g.concat(D):k=-1,D.length&&v())}function v(){if(!A){var a=m(l);A=!0;for(var r=D.length;r;){for(g=D,D=[];++k<r;)g&&g[k].run();k=-1,r=D.length}g=null,A=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(a)}}function p(a,r){this.fun=a,this.array=r}function s(){}P.nextTick=function(a){var r=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)r[i-1]=arguments[i];D.push(new p(a,r)),D.length!==1||A||m(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=s,P.addListener=s,P.once=s,P.off=s,P.removeListener=s,P.removeAllListeners=s,P.emit=s,P.prependListener=s,P.prependOnceListener=s,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Le[124],Me([1,0,15,6]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=void 0;function P(o){const h=o;return h?typeof h.read=="function":!1}e.$0d=P;function N(o){const h=o;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$$d=N;function R(o){const h=o;return h?N(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$_d=R;function m(o,h){return new g(o,h)}e.$ae=m;class g{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let f;switch(h){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const c=f.indexOf(t);c>=0&&f.splice(c,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(o,h){const t=[];let f;for(;(f=o.read())!==null;)t.push(f);return h(t)}e.$be=D;function A(o,h,t){const f=[];let c;for(;(c=o.read())!==null&&f.length<t;)f.push(c);return c===null&&f.length>0?h(f):{read:()=>{if(f.length>0)return f.shift();if(typeof c<"u"){const u=c;return c=void 0,u}return o.read()}}}e.$ce=A;function k(o,h){return new Promise((t,f)=>{const c=[];l(o,{onData:u=>{h&&c.push(u)},onError:u=>{h?f(u):t(void 0)},onEnd:()=>{t(h?h(c):void 0)}})})}e.$de=k;function l(o,h,t){o.on("error",f=>{t?.isCancellationRequested||h.onError(f)}),o.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),o.on("data",f=>{t?.isCancellationRequested||h.onData(f)})}e.$ee=l;function v(o,h){return new Promise((t,f)=>{const c=new M.$Sc,u=[],E=I=>{if(u.push(I),u.length>h)return c.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},y=I=>(c.dispose(),f(I)),$=()=>(c.dispose(),t({stream:o,buffer:u,ended:!0}));c.add((0,M.$Rc)(()=>o.removeListener("error",y))),o.on("error",y),c.add((0,M.$Rc)(()=>o.removeListener("end",$))),o.on("end",$),c.add((0,M.$Rc)(()=>o.removeListener("data",E))),o.on("data",E)})}e.$fe=v;function p(o,h){const t=m(h);return t.end(o),t}e.$ge=p;function s(){const o=m(()=>{throw new Error("not supported")});return o.end(),o}e.$he=s;function a(o){let h=!1;return{read:()=>h?null:(h=!0,o)}}e.$ie=a;function r(o,h,t){const f=m(t);return l(o,{onData:c=>f.write(h.data(c)),onError:c=>f.error(h.error?h.error(c):c),onEnd:()=>f.end()}),f}e.$je=r;function i(o,h,t){let f=!1;return{read:()=>{const c=h.read();return f?c:(f=!0,c!==null?t([o,c]):o)}}}e.$ke=i;function n(o,h,t){let f=!1;const c=m(t);return l(h,{onData:u=>f?c.write(u):(f=!0,c.write(t([o,u]))),onError:u=>c.error(u),onEnd:()=>{f||(f=!0,c.write(o)),c.end()}}),c}e.$le=n}),define(Le[23],Me([1,0,39,124]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;const P=typeof Buffer<"u",N=new S.$V(()=>new Uint8Array(256));let R,m;class g{static alloc(b){return P?new g(Buffer.allocUnsafe(b)):new g(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new g(b)}static fromString(b,L){return!(L?.dontUseNodeBuffer||!1)&&P?new g(Buffer.from(b)):(R||(R=new TextEncoder),new g(R.encode(b)))}static fromByteArray(b){const L=g.alloc(b.length);for(let T=0,Y=b.length;T<Y;T++)L.buffer[T]=b[T];return L}static concat(b,L){if(typeof L>"u"){L=0;for(let q=0,U=b.length;q<U;q++)L+=b[q].byteLength}const T=g.alloc(L);let Y=0;for(let q=0,U=b.length;q<U;q++){const C=b[q];T.set(C,Y),Y+=C.byteLength}return T}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=g.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(b,L){return new g(this.buffer.subarray(b,L))}set(b,L){if(b instanceof g)this.buffer.set(b.buffer,L);else if(b instanceof Uint8Array)this.buffer.set(b,L);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),L);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return l(this.buffer,b)}writeUInt32BE(b,L){v(this.buffer,b,L)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,L){s(this.buffer,b,L)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,L){r(this.buffer,b,L)}indexOf(b,L=0){return D(this.buffer,b instanceof g?b.buffer:b,L)}}e.$me=g;function D(w,b,L=0){const T=b.byteLength,Y=w.byteLength;if(T===0)return 0;if(T===1)return w.indexOf(b[0]);if(T>Y-L)return-1;const q=N.value;q.fill(b.length);for(let W=0;W<b.length;W++)q[b[W]]=b.length-W-1;let U=L+b.length-1,C=U,F=-1;for(;U<Y;)if(w[U]===b[C]){if(C===0){F=U;break}U--,C--}else U+=Math.max(b.length-C,q[w[U]]),C=b.length-1;return F}e.$ne=D;function A(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}e.$oe=A;function k(w,b,L){w[L+0]=b&255,b=b>>>8,w[L+1]=b&255}e.$pe=k;function l(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}e.$qe=l;function v(w,b,L){w[L+3]=b,b=b>>>8,w[L+2]=b,b=b>>>8,w[L+1]=b,b=b>>>8,w[L]=b}e.$re=v;function p(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}e.$se=p;function s(w,b,L){w[L+0]=b&255,b=b>>>8,w[L+1]=b&255,b=b>>>8,w[L+2]=b&255,b=b>>>8,w[L+3]=b&255}e.$te=s;function a(w,b){return w[b]}e.$ue=a;function r(w,b,L){w[L]=b}e.$ve=r;function i(w){return M.$be(w,b=>g.concat(b))}e.$we=i;function n(w){return M.$ie(w)}e.$xe=n;function o(w){return M.$de(w,b=>g.concat(b))}e.$ye=o;async function h(w){return w.ended?g.concat(w.buffer):g.concat([...w.buffer,await o(w.stream)])}e.$ze=h;function t(w){return M.$ge(w,b=>g.concat(b))}e.$Ae=t;function f(w){return M.$je(w,{data:b=>typeof b=="string"?g.fromString(b):g.wrap(b)},b=>g.concat(b))}e.$Be=f;function c(w){return M.$ae(b=>g.concat(b),w)}e.$Ce=c;function u(w,b){return M.$ke(w,b,L=>g.concat(L))}e.$De=u;function E(w,b){return M.$le(w,b,L=>g.concat(L))}e.$Ee=E;function y(w){let b=0,L=0,T=0;const Y=new Uint8Array(Math.floor(w.length/4*3)),q=C=>{switch(L){case 3:Y[T++]=b|C,L=0;break;case 2:Y[T++]=b|C>>>2,b=C<<6,L=3;break;case 1:Y[T++]=b|C>>>4,b=C<<4,L=2;break;default:b=C<<2,L=1}};for(let C=0;C<w.length;C++){const F=w.charCodeAt(C);if(F>=65&&F<=90)q(F-65);else if(F>=97&&F<=122)q(F-97+26);else if(F>=48&&F<=57)q(F-48+52);else if(F===43||F===45)q(62);else if(F===47||F===95)q(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${w[C]}`)}}const U=T;for(;L>0;)q(0);return g.wrap(Y).slice(0,U)}e.$Fe=y;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:w},b=!0,L=!1){const T=L?I:$;let Y="";const q=w.byteLength%3;let U=0;for(;U<w.byteLength-q;U+=3){const C=w[U+0],F=w[U+1],W=w[U+2];Y+=T[C>>>2],Y+=T[(C<<4|F>>>4)&63],Y+=T[(F<<2|W>>>6)&63],Y+=T[W&63]}if(q===1){const C=w[U+0];Y+=T[C>>>2],Y+=T[C<<4&63],b&&(Y+="==")}else if(q===2){const C=w[U+0],F=w[U+1];Y+=T[C>>>2],Y+=T[(C<<4|F>>>4)&63],Y+=T[F<<2&63],b&&(Y+="=")}return Y}e.$Ge=d}),define(Le[125],Me([1,0,28,122,13]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bk=e.$ak=e.$_j=e.$$j=e.FuzzyScore=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.or=void 0;function N(...ge){return function(Se,Ie){for(let O=0,G=ge.length;O<G;O++){const B=ge[O](Se,Ie);if(B)return B}return null}}e.or=N,e.$Yj=R.bind(void 0,!1),e.$Zj=R.bind(void 0,!0);function R(ge,Se,Ie){if(!Ie||Ie.length<Se.length)return null;let O;return ge?O=P.$ef(Ie,Se):O=Ie.indexOf(Se)===0,O?Se.length>0?[{start:0,end:Se.length}]:[]:null}function m(ge,Se){const Ie=Se.toLowerCase().indexOf(ge.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+ge.length}]}e.$1j=m;function g(ge,Se){return D(ge.toLowerCase(),Se.toLowerCase(),0,0)}e.$2j=g;function D(ge,Se,Ie,O){if(Ie===ge.length)return[];if(O===Se.length)return null;if(ge[Ie]===Se[O]){let G=null;return(G=D(ge,Se,Ie+1,O+1))?o({start:O,end:O+1},G):null}return D(ge,Se,Ie,O+1)}function A(ge){return 97<=ge&&ge<=122}function k(ge){return 65<=ge&&ge<=90}e.$3j=k;function l(ge){return 48<=ge&&ge<=57}function v(ge){return ge===32||ge===9||ge===10||ge===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>p.add(ge.charCodeAt(0)));function s(ge){return v(ge)||p.has(ge)}function a(ge,Se){return ge===Se||s(ge)&&s(Se)}const r=new Map;function i(ge){if(r.has(ge))return r.get(ge);let Se;const Ie=(0,M.$Wj)(ge);return Ie&&(Se=Ie),r.set(ge,Se),Se}function n(ge){return A(ge)||k(ge)||l(ge)}function o(ge,Se){return Se.length===0?Se=[ge]:ge.end===Se[0].start?Se[0].start=ge.start:Se.unshift(ge),Se}function h(ge,Se){for(let Ie=Se;Ie<ge.length;Ie++){const O=ge.charCodeAt(Ie);if(k(O)||l(O)||Ie>0&&!n(ge.charCodeAt(Ie-1)))return Ie}return ge.length}function t(ge,Se,Ie,O){if(Ie===ge.length)return[];if(O===Se.length)return null;if(ge[Ie]!==Se[O].toLowerCase())return null;{let G=null,B=O+1;for(G=t(ge,Se,Ie+1,O+1);!G&&(B=h(Se,B))<Se.length;)G=t(ge,Se,Ie+1,B),B++;return G===null?null:o({start:O,end:O+1},G)}}function f(ge){let Se=0,Ie=0,O=0,G=0,B=0;for(let Be=0;Be<ge.length;Be++)B=ge.charCodeAt(Be),k(B)&&Se++,A(B)&&Ie++,n(B)&&O++,l(B)&&G++;const H=Se/ge.length,Q=Ie/ge.length,ae=O/ge.length,Ee=G/ge.length;return{upperPercent:H,lowerPercent:Q,alphaPercent:ae,numericPercent:Ee}}function c(ge){const{upperPercent:Se,lowerPercent:Ie}=ge;return Ie===0&&Se>.6}function u(ge){const{upperPercent:Se,lowerPercent:Ie,alphaPercent:O,numericPercent:G}=ge;return Ie>.2&&Se<.8&&O>.6&&G<.2}function E(ge){let Se=0,Ie=0,O=0,G=0;for(let B=0;B<ge.length;B++)O=ge.charCodeAt(B),k(O)&&Se++,A(O)&&Ie++,v(O)&&G++;return(Se===0||Ie===0)&&G===0?ge.length<=30:Se<=5}function y(ge,Se){if(!Se||(Se=Se.trim(),Se.length===0)||!E(ge))return null;Se.length>60&&(Se=Se.substring(0,60));const Ie=f(Se);if(!u(Ie)){if(!c(Ie))return null;Se=Se.toLowerCase()}let O=null,G=0;for(ge=ge.toLowerCase();G<Se.length&&(O=t(ge,Se,0,G))===null;)G=h(Se,G+1);return O}e.$4j=y;function $(ge,Se,Ie=!1){if(!Se||Se.length===0)return null;let O=null,G=0;for(ge=ge.toLowerCase(),Se=Se.toLowerCase();G<Se.length&&(O=I(ge,Se,0,G,Ie),O===null);)G=d(Se,G+1);return O}e.$5j=$;function I(ge,Se,Ie,O,G){let B=0;if(Ie===ge.length)return[];if(O===Se.length)return null;if(!a(ge.charCodeAt(Ie),Se.charCodeAt(O))){const ae=i(ge.charCodeAt(Ie));if(!ae)return null;for(let Ee=0;Ee<ae.length;Ee++)if(!a(ae[Ee],Se.charCodeAt(O+Ee)))return null;B+=ae.length-1}let H=null,Q=O+B+1;if(H=I(ge,Se,Ie+1,Q,G),!G)for(;!H&&(Q=d(Se,Q))<Se.length;)H=I(ge,Se,Ie+1,Q,G),Q++;if(!H)return null;if(ge.charCodeAt(Ie)!==Se.charCodeAt(O)){const ae=i(ge.charCodeAt(Ie));if(!ae)return H;for(let Ee=0;Ee<ae.length;Ee++)if(ae[Ee]!==Se.charCodeAt(O+Ee))return H}return o({start:O,end:O+B+1},H)}function d(ge,Se){for(let Ie=Se;Ie<ge.length;Ie++)if(s(ge.charCodeAt(Ie))||Ie>0&&s(ge.charCodeAt(Ie-1)))return Ie;return ge.length}const w=N(e.$Zj,y,m),b=N(e.$Zj,y,g),L=new S.$Dc(1e4);function T(ge,Se,Ie=!1){if(typeof ge!="string"||typeof Se!="string")return null;let O=L.get(ge);O||(O=new RegExp(P.$Ye(ge),"i"),L.set(ge,O));const G=O.exec(Se);return G?[{start:G.index,end:G.index+G[0].length}]:Ie?b(ge,Se):w(ge,Se)}e.$6j=T;function Y(ge,Se){const Ie=we(ge,ge.toLowerCase(),0,Se,Se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?U(Ie):null}e.$7j=Y;function q(ge,Se,Ie,O,G,B){const H=Math.min(13,ge.length);for(;Ie<H;Ie++){const Q=we(ge,Se,Ie,O,G,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,B]}e.$8j=q;function U(ge){if(typeof ge>"u")return[];const Se=[],Ie=ge[1];for(let O=ge.length-1;O>1;O--){const G=ge[O]+Ie,B=Se[Se.length-1];B&&B.end===G?B.end=G+1:Se.push({start:G,end:G+1})}return Se}e.$9j=U;const C=128;function F(){const ge=[],Se=[];for(let Ie=0;Ie<=C;Ie++)Se[Ie]=0;for(let Ie=0;Ie<=C;Ie++)ge.push(Se.slice(0));return ge}function W(ge){const Se=[];for(let Ie=0;Ie<=ge;Ie++)Se[Ie]=0;return Se}const re=W(2*C),ue=W(2*C),ye=F(),ke=F(),he=F(),ve=!1;function se(ge,Se,Ie,O,G){function B(Q,ae,Ee=" "){for(;Q.length<ae;)Q=Ee+Q;return Q}let H=` |   |${O.split("").map(Q=>B(Q,3)).join("|")}
`;for(let Q=0;Q<=Ie;Q++)Q===0?H+=" |":H+=`${Se[Q-1]}|`,H+=ge[Q].slice(0,G+1).map(ae=>B(ae.toString(),3)).join("|")+`
`;return H}function $e(ge,Se,Ie,O){ge=ge.substr(Se),Ie=Ie.substr(O),console.log(se(ke,ge,ge.length,Ie,Ie.length)),console.log(se(he,ge,ge.length,Ie,Ie.length)),console.log(se(ye,ge,ge.length,Ie,Ie.length))}function te(ge,Se){if(Se<0||Se>=ge.length)return!1;const Ie=ge.codePointAt(Se);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$wf(Ie)}}function X(ge,Se){if(Se<0||Se>=ge.length)return!1;switch(ge.charCodeAt(Se)){case 32:case 9:return!0;default:return!1}}function V(ge,Se,Ie){return Se[ge]!==Ie[ge]}function ne(ge,Se,Ie,O,G,B,H=!1){for(;Se<Ie&&G<B;)ge[Se]===O[G]&&(H&&(re[Se]=G),Se+=1),G+=1;return Se===Ie}e.$0j=ne;var Ce;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Fe;(function(ge){ge.Default=[-100,0];function Se(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}ge.isDefault=Se})(Fe||(e.FuzzyScore=Fe={}));class Pe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Se,Ie){this.firstMatchCanBeWeak=Se,this.boostFullMatch=Ie}}e.$$j=Pe;function we(ge,Se,Ie,O,G,B,H=Pe.default){const Q=ge.length>C?C:ge.length,ae=O.length>C?C:O.length;if(Ie>=Q||B>=ae||Q-Ie>ae-B||!ne(Se,Ie,Q,G,B,ae,!0))return;me(Q,ae,Ie,B,Se,G);let Ee=1,Be=1,We=Ie,Qe=B;const xe=[!1];for(Ee=1,We=Ie;We<Q;Ee++,We++){const Ue=re[We],pt=ue[We],Z=We+1<Q?ue[We+1]:ae;for(Be=Ue-B+1,Qe=Ue;Qe<Z;Be++,Qe++){let _=Number.MIN_SAFE_INTEGER,pe=!1;Qe<=pt&&(_=J(ge,Se,We,Ie,O,G,Qe,ae,B,ye[Ee-1][Be-1]===0,xe));let Ve=0;_!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ve=_+ke[Ee-1][Be-1]);const Ye=Qe>Ue,nt=Ye?ke[Ee][Be-1]+(ye[Ee][Be-1]>0?-5:0):0,st=Qe>Ue+1&&ye[Ee][Be-1]>0,Te=st?ke[Ee][Be-2]+(ye[Ee][Be-2]>0?-5:0):0;if(st&&(!Ye||Te>=nt)&&(!pe||Te>=Ve))ke[Ee][Be]=Te,he[Ee][Be]=3,ye[Ee][Be]=0;else if(Ye&&(!pe||nt>=Ve))ke[Ee][Be]=nt,he[Ee][Be]=2,ye[Ee][Be]=0;else if(pe)ke[Ee][Be]=Ve,he[Ee][Be]=1,ye[Ee][Be]=ye[Ee-1][Be-1]+1;else throw new Error("not possible")}}if(ve&&$e(ge,Ie,O,B),!xe[0]&&!H.firstMatchCanBeWeak)return;Ee--,Be--;const ct=[ke[Ee][Be],B];let rt=0,et=0;for(;Ee>=1;){let Ue=Be;do{const pt=he[Ee][Ue];if(pt===3)Ue=Ue-2;else if(pt===2)Ue=Ue-1;else break}while(Ue>=1);rt>1&&Se[Ie+Ee-1]===G[B+Be-1]&&!V(Ue+B-1,O,G)&&rt+1>ye[Ee][Ue]&&(Ue=Be),Ue===Be?rt++:rt=1,et||(et=Ue),Ee--,Be=Ue-1,ct.push(Be)}ae===Q&&H.boostFullMatch&&(ct[0]+=2);const ut=et-Q;return ct[0]-=ut,ct}e.$_j=we;function me(ge,Se,Ie,O,G,B){let H=ge-1,Q=Se-1;for(;H>=Ie&&Q>=O;)G[H]===B[Q]&&(ue[H]=Q,H--),Q--}function J(ge,Se,Ie,O,G,B,H,Q,ae,Ee,Be){if(Se[Ie]!==B[H])return Number.MIN_SAFE_INTEGER;let We=1,Qe=!1;return H===Ie-O?We=ge[Ie]===G[H]?7:5:V(H,G,B)&&(H===0||!V(H-1,G,B))?(We=ge[Ie]===G[H]?7:5,Qe=!0):te(B,H)&&(H===0||!te(B,H-1))?We=5:(te(B,H-1)||X(B,H-1))&&(We=5,Qe=!0),We>1&&Ie===O&&(Be[0]=!0),Qe||(Qe=V(H,G,B)||te(B,H-1)||X(B,H-1)),Ie===O?H>ae&&(We-=Qe?3:5):Ee?We+=Qe?2:0:We+=Qe?0:1,H+1===Q&&(We-=Qe?3:5),We}function x(ge,Se,Ie,O,G,B,H){return de(ge,Se,Ie,O,G,B,!0,H)}e.$ak=x;function le(ge,Se,Ie,O,G,B,H){return de(ge,Se,Ie,O,G,B,!1,H)}e.$bk=le;function de(ge,Se,Ie,O,G,B,H,Q){let ae=we(ge,Se,Ie,O,G,B,Q);if(ae&&!H)return ae;if(ge.length>=3){const Ee=Math.min(7,ge.length-1);for(let Be=Ie+1;Be<Ee;Be++){const We=Ae(ge,Be);if(We){const Qe=we(We,We.toLowerCase(),Ie,O,G,B,Q);Qe&&(Qe[0]-=3,(!ae||Qe[0]>ae[0])&&(ae=Qe))}}}return ae}function Ae(ge,Se){if(Se+1>=ge.length)return;const Ie=ge[Se],O=ge[Se+1];if(Ie!==O)return ge.slice(0,Se)+O+Ie+ge.slice(Se+2)}}),define(Le[32],Me([1,0,13]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(M||(M={})),function(P){const N="error",R="warning",m="warn",g="info",D="ignore";function A(l){return l?S.$df(N,l)?P.Error:S.$df(R,l)||S.$df(m,l)?P.Warning:S.$df(g,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function k(l){switch(l){case P.Error:return N;case P.Warning:return R;case P.Info:return g;default:return D}}P.toString=k}(M||(M={})),e.default=M}),define(Le[126],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=void 0,e.$Vd=Symbol("MicrotaskDelay")}),define(Le[51],Me([1,0,18,13]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return p-s}value(){return this.b[this.c]}}e.$ai=P;class N{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,M.$0e)(v,this.b,0,v.length,this.c,this.d):(0,M.$_e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$bi=N;class R{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const s=this.b.charCodeAt(p);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,M.$0e)(v,this.b,0,v.length,this.d,this.e):(0,M.$_e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ci=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class g{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,M.$$e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,M.$$e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,M.$9e)(v,this.c.query);if(this.d[this.e]===5)return(0,M.$9e)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$di=g;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class k{static forUris(v=()=>!1,p=()=>!1){return new k(new g(v,p))}static forPaths(v=!1){return new k(new R(void 0,!v))}static forStrings(){return new k(new P)}static forConfigKeys(){return new k(new N)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const s=p.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a,v)}else{const s=v.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(v,p){const s=this.b.reset(v);let a;this.c||(this.c=new D,this.c.segment=s.value());const r=[];for(a=this.c;;){const n=s.cmp(a.segment);if(n>0)a.left||(a.left=new D,a.left.segment=s.value()),r.push([-1,a]),a=a.left;else if(n<0)a.right||(a.right=new D,a.right.segment=s.value()),r.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new D,a.mid.segment=s.value()),r.push([0,a]),a=a.mid;else break}const i=a.value;a.value=p,a.key=v;for(let n=r.length-1;n>=0;n--){const o=r[n][1];o.updateHeight();const h=o.balanceFactor();if(h<-1||h>1){const t=r[n][0],f=r[n+1][0];if(t===1&&f===1)r[n][1]=o.rotateLeft();else if(t===-1&&f===-1)r[n][1]=o.rotateRight();else if(t===1&&f===-1)o.right=r[n+1][1]=r[n+1][1].rotateRight(),r[n][1]=o.rotateLeft();else if(t===-1&&f===1)o.left=r[n+1][1]=r[n+1][1].rotateLeft(),r[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let s=this.c;for(;s;){const a=p.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(p.hasNext())p.next(),s=s.mid;else break}return s}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const s=this.b.reset(v),a=[];let r=this.c;for(;r;){const i=s.cmp(r.segment);if(i>0)a.push([-1,r]),r=r.left;else if(i<0)a.push([1,r]),r=r.right;else if(s.hasNext())s.next(),a.push([0,r]),r=r.mid;else break}if(r){if(p?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const i=this.f(r.right);if(i.key){const{key:n,value:o,segment:h}=i;this.e(i.key,!1),r.key=n,r.value=o,r.segment=h}}else{const i=r.left??r.right;if(a.length>0){const[n,o]=a[a.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=a.length-1;i>=0;i--){const n=a[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),a[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),a[i][1]=n.rotateRight()),i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let s=this.c,a;for(;s;){const r=p.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(p.hasNext())p.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(v){return this.g(v,!1)}g(v,p){const s=this.b.reset(v);let a=this.c;for(;a;){const r=s.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):p?a.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,s]of this)v(s,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const s=p.balanceFactor();return s<-1||s>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$ei=k}),define(Le[40],Me([1,0,89]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$fk=e.ThemeColor=void 0;var M;(function(R){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=m})(M||(e.ThemeColor=M={}));function P(R){return{id:R}}e.$fk=P;var N;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(i){const n=m.exec(i.id);if(!n)return g(S.$ek.error);const[,o,h]=n,t=["codicon","codicon-"+o];return h&&t.push("codicon-modifier-"+h.substring(1)),t}R.asClassNameArray=g;function D(i){return g(i).join(" ")}R.asClassName=D;function A(i){return"."+g(i).join(".")}R.asCSSSelector=A;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(i){const n=l.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=v;function p(i){return{id:i}}R.fromId=p;function s(i,n){let o=i.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),n&&(o=`${o}~${n}`),{id:o}}R.modify=s;function a(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=a;function r(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=r})(N||(e.ThemeIcon=N={}))}),define(Le[127],Me([1,0,125,13,40]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=void 0;const N="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function g(r){return r.replace(m,(i,n)=>n?i:`\\${i}`)}e.$gk=g;const D=new RegExp(`\\\\${R.source}`,"g");function A(r){return r.replace(D,i=>`\\${i}`)}e.$hk=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(r){return r.indexOf(N)===-1?r:r.replace(k,(i,n,o,h)=>o?i:n||h||"")}e.$ik=l;function v(r){return r?r.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$jk=v;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){p.lastIndex=0;let i="";const n=[];let o=0;for(;;){const h=p.lastIndex,t=p.exec(r),f=r.substring(h,t?.index);if(f.length>0){i+=f;for(let c=0;c<f.length;c++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$kk=s;function a(r,i,n=!1){const{text:o,iconOffsets:h}=i;if(!h||h.length===0)return(0,S.$6j)(r,o,n);const t=(0,M.$We)(o," "),f=o.length-t.length,c=(0,S.$6j)(r,t,n);if(c)for(const u of c){const E=h[u.start+f]+f;u.start+=E,u.end+=E}return c}e.$lk=a}),define(Le[33],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(P){return S.test(P)}e.$tg=M,e.$ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const N=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){P(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let g=0,D="";return D+=R[N[g++]],D+=R[N[g++]],D+=R[N[g++]],D+=R[N[g++]],D+="-",D+=R[N[g++]],D+=R[N[g++]],D+="-",D+=R[N[g++]],D+=R[N[g++]],D+="-",D+=R[N[g++]],D+=R[N[g++]],D+="-",D+=R[N[g++]],D+=R[N[g++]],D+=R[N[g++]],D+=R[N[g++]],D+=R[N[g++]],D+=R[N[g++]],D}}()}),define(Le[128],Me([1,0,18,68,33]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.$ut=e.$tt=e.$st=void 0;function N(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$st=N;function R(k,l,v){const p={id:(0,P.$ug)(),name:k,uri:l,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$tt=R;class m{constructor(){this.a=new Map}get size(){let l=0;for(const v of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const v=[...this.a.keys()];return M.Iterable.some(this,([p,s])=>s.asFile())&&v.push("files"),A(g(l),v)}get(l){return this.a.get(this.b(l))?.[0]}append(l,v){const p=this.a.get(l);p?p.push(v):this.a.set(this.b(l),[v])}replace(l,v){this.a.set(this.b(l),[v])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,v]of this.a)for(const p of v)yield[l,p]}b(l){return g(l)}}e.$ut=m;function g(k){return k.toLowerCase()}function D(k,l){return A(g(k),l.map(g))}e.$vt=D;function A(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const v=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,s,a]=v;return a==="*"?l.some(r=>r.startsWith(s+"/")):!1}e.$wt=Object.freeze({create:k=>(0,S.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$wt.split(k).filter(l=>!l.startsWith("#"))})}),define(Le[129],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.StringEOL=void 0;var S;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function M(P){let N=0,R=0,m=0,g=0;for(let D=0,A=P.length;D<A;D++){const k=P.charCodeAt(D);k===13?(N===0&&(R=D),N++,D+1<A&&P.charCodeAt(D+1)===10?(g|=2,D++):g|=3,m=D+1):k===10&&(g|=1,N===0&&(R=D),N++,m=D+1)}return N===0&&(R=P.length),[N,R,P.length-m,g]}e.$zt=M}),define(Le[130],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0,e.$xs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Le[131],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xt=e.$Wt=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,D=m.notIn.length;g<D;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const D=m.findTokenIndexAtOffset(g-2),A=m.getStandardTokenType(D);return this.isOK(A)}g(m,g){for(let D=m;D<=g;D++){const A=String.fromCharCode(D);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Wt=M;class P{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)N(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),N(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),N(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),N(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&N(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Xt=P;function N(R,m,g){R.has(m)?R.get(m).push(g):R.set(m,[g])}}),define(Le[132],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.NodeColor=e.$XB=void 0;class S{constructor(a,r){this.piece=a,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$YB)return P(this.right);let a=this;for(;a.parent!==e.$YB&&a.parent.left!==a;)a=a.parent;return a.parent===e.$YB?e.$YB:a.parent}prev(){if(this.left!==e.$YB)return N(this.left);let a=this;for(;a.parent!==e.$YB&&a.parent.right!==a;)a=a.parent;return a.parent===e.$YB?e.$YB:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$XB=S;var M;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$YB=new S(null,0),e.$YB.parent=e.$YB,e.$YB.left=e.$YB,e.$YB.right=e.$YB,e.$YB.color=0;function P(s){for(;s.left!==e.$YB;)s=s.left;return s}e.$ZB=P;function N(s){for(;s.right!==e.$YB;)s=s.right;return s}e.$1B=N;function R(s){return s===e.$YB?0:s.size_left+s.piece.length+R(s.right)}function m(s){return s===e.$YB?0:s.lf_left+s.piece.lineFeedCnt+m(s.right)}function g(){e.$YB.parent=e.$YB}function D(s,a){const r=a.right;r.size_left+=a.size_left+(a.piece?a.piece.length:0),r.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=r.left,r.left!==e.$YB&&(r.left.parent=a),r.parent=a.parent,a.parent===e.$YB?s.root=r:a.parent.left===a?a.parent.left=r:a.parent.right=r,r.left=a,a.parent=r}e.$2B=D;function A(s,a){const r=a.left;a.left=r.right,r.right!==e.$YB&&(r.right.parent=a),r.parent=a.parent,a.size_left-=r.size_left+(r.piece?r.piece.length:0),a.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),a.parent===e.$YB?s.root=r:a===a.parent.right?a.parent.right=r:a.parent.left=r,r.right=a,a.parent=r}e.$3B=A;function k(s,a){let r,i;if(a.left===e.$YB?(i=a,r=i.right):a.right===e.$YB?(i=a,r=i.left):(i=P(a.right),r=i.right),i===s.root){s.root=r,r.color=0,a.detach(),g(),s.root.parent=e.$YB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=r:i.parent.right=r,i===a?(r.parent=i.parent,p(s,r)):(i.parent===a?r.parent=i:r.parent=i.parent,p(s,r),i.left=a.left,i.right=a.right,i.parent=a.parent,i.color=a.color,a===s.root?s.root=i:a===a.parent.left?a.parent.left=i:a.parent.right=i,i.left!==e.$YB&&(i.left.parent=i),i.right!==e.$YB&&(i.right.parent=i),i.size_left=a.size_left,i.lf_left=a.lf_left,p(s,i)),a.detach(),r.parent.left===r){const h=R(r),t=m(r);if(h!==r.parent.size_left||t!==r.parent.lf_left){const f=h-r.parent.size_left,c=t-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=t,v(s,r.parent,f,c)}}if(p(s,r.parent),n){g();return}let o;for(;r!==s.root&&r.color===0;)r===r.parent.left?(o=r.parent.right,o.color===1&&(o.color=0,r.parent.color=1,D(s,r.parent),o=r.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,r=r.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(s,o),o=r.parent.right),o.color=r.parent.color,r.parent.color=0,o.right.color=0,D(s,r.parent),r=s.root)):(o=r.parent.left,o.color===1&&(o.color=0,r.parent.color=1,A(s,r.parent),o=r.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,r=r.parent):(o.left.color===0&&(o.right.color=0,o.color=1,D(s,o),o=r.parent.left),o.color=r.parent.color,r.parent.color=0,o.left.color=0,A(s,r.parent),r=s.root));r.color=0,g()}e.$4B=k;function l(s,a){for(p(s,a);a!==s.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const r=a.parent.parent.right;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,D(s,a)),a.parent.color=0,a.parent.parent.color=1,A(s,a.parent.parent))}else{const r=a.parent.parent.left;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,A(s,a)),a.parent.color=0,a.parent.parent.color=1,D(s,a.parent.parent))}s.root.color=0}e.$5B=l;function v(s,a,r,i){for(;a!==s.root&&a!==e.$YB;)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=i),a=a.parent}e.$6B=v;function p(s,a){let r=0,i=0;if(a!==s.root){for(;a!==s.root&&a===a.parent.right;)a=a.parent;if(a!==s.root)for(a=a.parent,r=R(a.left)-a.size_left,i=m(a.left)-a.lf_left,a.size_left+=r,a.lf_left+=i;a!==s.root&&(r!==0||i!==0);)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=i),a=a.parent}}e.$7B=p}),define(Le[90],Me([1,0,91,29,92,132,93]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=e.$cC=e.$bC=void 0;const m=65535;function g(r){let i;return r[r.length-1]<65536?i=new Uint16Array(r.length):i=new Uint32Array(r.length),i.set(r,0),i}class D{constructor(i,n,o,h,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=h,this.isBasicASCII=t}}function A(r,i=!0){const n=[0];let o=1;for(let h=0,t=r.length;h<t;h++){const f=r.charCodeAt(h);f===13?h+1<t&&r.charCodeAt(h+1)===10?(n[o++]=h+2,h++):n[o++]=h+1:f===10&&(n[o++]=h+1)}return i?g(n):n}e.$bC=A;function k(r,i){r.length=0,r[0]=0;let n=1,o=0,h=0,t=0,f=!0;for(let u=0,E=i.length;u<E;u++){const y=i.charCodeAt(u);y===13?u+1<E&&i.charCodeAt(u+1)===10?(t++,r[n++]=u+2,u++):(o++,r[n++]=u+1):y===10?(h++,r[n++]=u+1):f&&y!==9&&(y<32||y>126)&&(f=!1)}const c=new D(g(r),o,h,t,f);return r.length=0,c}e.$cC=k;class l{constructor(i,n,o,h,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=h,this.length=t}}e.$dC=l;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$eC=v;class p{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==N.$YB&&i.iterate(i.root,o=>(o!==N.$YB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let h=0;h<o.length;h++){const t=o[h];if(t.node.parent===null||t.nodeStartOffset>=i){o[h]=null,n=!0;continue}}if(n){const h=[];for(const t of o)t!==null&&h.push(t);this.b=h}}}class a{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=N.$YB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let h=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const c=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),h=this.S(h,c)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=m,o=n-Math.floor(n/3),h=o*2;let t="",f=0;const c=[];if(this.iterate(this.root,u=>{const E=this.R(u),y=E.length;if(f<=o||f+y<h)return t+=E,f+=y,!0;const $=t.replace(/\r\n|\r|\n/g,i);return c.push(new v($,A($))),t=E,f=y,!0}),f>0){const u=t.replace(/\r\n|\r|\n/g,i);c.push(new v(u,A(u)))}this.create(c,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new p(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,h=>{if(h===N.$YB)return!0;const t=this.R(h),f=t.length,c=i.G(n),u=i.G(n+f),E=i.getValueInRange2(c,u);return n+=f,t===E})}getOffsetAt(i,n){let o=0,h=this.root;for(;h!==N.$YB;)if(h.left!==N.$YB&&h.lf_left+1>=i)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=i){o+=h.size_left;const t=this.B(h,i-h.lf_left-2);return o+=t+n-1}else i-=h.lf_left+h.piece.lineFeedCnt,o+=h.size_left+h.piece.length,h=h.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const h=i;for(;n!==N.$YB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(o+1,1),c=h-f;return new S.$Ys(o+1,c+1)}return new S.$Ys(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===N.$YB){const t=this.getOffsetAt(o+1,1),f=h-i-t;return new S.$Ys(o+1,f+1)}else n=n.right;return new S.$Ys(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),h=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,h);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const c=i.node,u=this.a[c.piece.bufferIndex].buffer,E=this.u(c.piece.bufferIndex,c.piece.start);return u.substring(E+i.remainder,E+n.remainder)}let o=i.node;const h=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let f=h.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==N.$YB;){const c=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){f+=c.substring(u,u+n.remainder);break}else f+=c.substr(u,o.piece.length);o=o.next()}return f}getLinesContent(){const i=[];let n=0,o="",h=!1;return this.iterate(this.root,t=>{if(t===N.$YB)return!0;const f=t.piece;let c=f.length;if(c===0)return!0;const u=this.a[f.bufferIndex].buffer,E=this.a[f.bufferIndex].lineStarts,y=f.start.line,$=f.end.line;let I=E[y]+f.start.column;if(h&&(u.charCodeAt(I)===10&&(I++,c--),i[n++]=o,o="",h=!1,c===0))return!0;if(y===$)return!this.f&&u.charCodeAt(I+c-1)===13?(h=!0,o+=u.substr(I,c-1)):o+=u.substr(I,c),!0;o+=this.f?u.substring(I,Math.max(I,E[y+1]-this.e)):u.substring(I,E[y+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let d=y+1;d<$;d++)o=this.f?u.substring(E[d],E[d+1]-this.e):u.substring(E[d],E[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(E[$]+f.end.column-1)===13?(h=!0,f.end.column===0?n--:o=u.substr(E[$],f.end.column-1)):o=u.substr(E[$],f.end.column),!0}),h&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(h)}else{const n=this.a[i.node.piece.bufferIndex],h=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(h)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,h,t,f,c,u,E,y,$){const I=this.a[i.piece.bufferIndex],d=this.u(i.piece.bufferIndex,i.piece.start),w=this.u(i.piece.bufferIndex,t),b=this.u(i.piece.bufferIndex,f);let L;const T={line:0,column:0};let Y,q;n._wordSeparators?(Y=I.buffer.substring(w,b),q=U=>U+w,n.reset(0)):(Y=I.buffer,q=U=>U,n.reset(w));do if(L=n.next(Y),L){if(q(L.index)>=b)return y;this.s(i,q(L.index)-d,T);const U=this.t(i.piece.bufferIndex,t,T),C=T.line===t.line?T.column-t.column+h:T.column+1,F=C+L[0].length;if($[y++]=(0,R.$0B)(new M.$Zs(o+U,C,o+U,F),L,u),q(L.index)+L[0].length>=b||y>=E)return y}while(L);return y}findMatchesLineByLine(i,n,o,h){const t=[];let f=0;const c=new R.$aC(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let y=this.s(u.node,u.remainder);const $=this.s(E.node,E.remainder);if(u.node===E.node)return this.findMatchesInNode(u.node,c,i.startLineNumber,i.startColumn,y,$,n,o,h,f,t),t;let I=i.startLineNumber,d=u.node;for(;d!==E.node;){const b=this.t(d.piece.bufferIndex,y,d.piece.end);if(b>=1){const T=this.a[d.piece.bufferIndex].lineStarts,Y=this.u(d.piece.bufferIndex,d.piece.start),q=T[y.line+b],U=I===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(d,c,I,U,y,this.s(d,q-Y),n,o,h,f,t),f>=h)return t;I+=b}const L=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const T=this.getLineContent(I).substring(L,i.endColumn-1);return f=this.n(n,c,T,i.endLineNumber,L,f,t,o,h),t}if(f=this.n(n,c,this.getLineContent(I).substr(L),I,L,f,t,o,h),f>=h)return t;I++,u=this.H(I,1),d=u.node,y=this.s(u.node,u.remainder)}if(I===i.endLineNumber){const b=I===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(I).substring(b,i.endColumn-1);return f=this.n(n,c,L,i.endLineNumber,b,f,t,o,h),t}const w=I===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(E.node,c,I,w,y,$,n,o,h,f,t),t}n(i,n,o,h,t,f,c,u,E){const y=i.wordSeparators;if(!u&&i.simpleSearch){const I=i.simpleSearch,d=I.length,w=o.length;let b=-d;for(;(b=o.indexOf(I,b+d))!==-1;)if((!y||(0,R.$_B)(y,o,w,b,d))&&(c[f++]=new P.$fv(new M.$Zs(h,b+1+t,h,b+1+d+t),null),f>=E))return f;return f}let $;n.reset(0);do if($=n.next(o),$&&(c[f++]=(0,R.$0B)(new M.$Zs(h,$.index+1+t,h,$.index+1+$[0].length+t),$,u),f>=E))return f;while($);return f}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==N.$YB){const{node:h,remainder:t,nodeStartOffset:f}=this.G(i),c=h.piece,u=c.bufferIndex,E=this.s(h,t);if(h.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&f+c.length===i&&n.length<m){this.F(h,n),this.y();return}if(f===i)this.o(n,h),this.h.validate(i);else if(f+h.piece.length>i){const y=[];let $=new l(c.bufferIndex,E,c.end,this.t(c.bufferIndex,E,c.end),this.u(u,c.end)-this.u(u,E));if(this.K()&&this.M(n)&&this.I(h,t)===10){const b={line:$.start.line+1,column:0};$=new l($.bufferIndex,b,$.end,this.t($.bufferIndex,b,$.end),$.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(h,t-1)===13){const b=this.s(h,t-1);this.C(h,b),n="\r"+n,h.piece.length===0&&y.push(h)}else this.C(h,E);else this.C(h,E);const I=this.w(n);$.length>0&&this.S(h,$);let d=h;for(let w=0;w<I.length;w++)d=this.S(d,I[w]);this.v(y)}else this.q(n,h)}else{const h=this.w(n);let t=this.T(null,h[0]);for(let f=1;f<h.length;f++)t=this.S(t,h[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===N.$YB)return;const o=this.G(i),h=this.G(i+n),t=o.node,f=h.node;if(t===f){const I=this.s(t,o.remainder),d=this.s(t,h.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const w=t.next();(0,N.$4B)(this,t),this.N(w),this.y();return}this.D(t,d),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,I),this.O(t),this.y();return}this.E(t,I,d),this.y();return}const c=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&c.push(t);const E=this.s(f,h.remainder);this.D(f,E),f.piece.length===0&&c.push(f);const y=t.next();for(let I=y;I!==N.$YB&&I!==f;I=I.next())c.push(I);const $=t.piece.length===0?t.prev():t;this.v(c),this.O($),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,c={line:f.start.line+1,column:0},u=new l(f.bufferIndex,c,f.end,this.t(f.bufferIndex,c,f.end),f.length-1);n.piece=u,i+=`
`,(0,N.$6B)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const h=this.w(i);let t=this.T(n,h[h.length-1]);for(let f=h.length-2;f>=0;f--)t=this.T(t,h[f]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),h=this.S(n,o[0]);let t=h;for(let f=1;f<o.length;f++)t=this.S(t,o[f]);this.N(h)}s(i,n,o){const h=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,u=f[h.start.line]+h.start.column+n;let E=h.start.line,y=h.end.line,$=0,I=0,d=0;for(;E<=y&&($=E+(y-E)/2|0,d=f[$],$!==y);)if(I=f[$+1],u<d)y=$-1;else if(u>=I)E=$+1;else break;return o?(o.line=$,o.column=u-d,null):{line:$,column:u-d}}t(i,n,o){if(o.column===0)return o.line-n.line;const h=this.a[i].lineStarts;if(o.line===h.length-1)return o.line-n.line;const t=h[o.line+1],f=h[o.line]+o.column;if(t>f+1)return o.line-n.line;const c=f-1;return this.a[i].buffer.charCodeAt(c)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,N.$4B)(this,i[n])}w(i){if(i.length>m){const y=[];for(;i.length>m;){const I=i.charCodeAt(m-1);let d;I===13||I>=55296&&I<=56319?(d=i.substring(0,m-1),i=i.substring(m-1)):(d=i.substring(0,m),i=i.substring(m));const w=A(d);y.push(new l(this.a.length,{line:0,column:0},{line:w.length-1,column:d.length-w[w.length-1]},w.length-1,d.length)),this.a.push(new v(d,w))}const $=A(i);return y.push(new l(this.a.length,{line:0,column:0},{line:$.length-1,column:i.length-$[$.length-1]},$.length-1,i.length)),this.a.push(new v(i,$)),y}let n=this.a[0].buffer.length;const o=A(i,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let y=0;y<o.length;y++)o[y]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let y=0;y<o.length;y++)o[y]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[f],u={line:f,column:c},E=new l(0,h,u,this.t(0,h,u),t-n);return this.g=u,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,h="";const t=this.h.get2(i);if(t){o=t.node;const f=this.B(o,i-t.nodeStartLineNumber-1),c=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)h=c.substring(u+f,u+o.piece.length);else{const E=this.B(o,i-t.nodeStartLineNumber);return c.substring(u+f,u+E-n)}}else{let f=0;const c=i;for(;o!==N.$YB;)if(o.left!==N.$YB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),E=this.B(o,i-o.lf_left-1),y=this.a[o.piece.bufferIndex].buffer,$=this.u(o.piece.bufferIndex,o.piece.start);return f+=o.size_left,this.h.set({node:o,nodeStartOffset:f,nodeStartLineNumber:c-(i-1-o.lf_left)}),y.substring($+u,$+E-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),E=this.a[o.piece.bufferIndex].buffer,y=this.u(o.piece.bufferIndex,o.piece.start);h=E.substring(y+u,y+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,f+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==N.$YB;){const f=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const c=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return h+=f.substring(u,u+c-n),h}else{const c=this.u(o.piece.bufferIndex,o.piece.start);h+=f.substr(c,o.piece.length)}o=o.next()}return h}y(){let i=this.root,n=1,o=0;for(;i!==N.$YB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,h=this.s(i,n),t=h.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const f=this.t(i.piece.bufferIndex,o.start,h);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:h.column}}B(i,n){if(n<0)return 0;const o=i.piece,h=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?h[o.end.line]+o.end.column-h[o.start.line]-o.start.column:h[t]-h[o.start.line]-o.start.column}C(i,n){const o=i.piece,h=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),f=n,c=this.u(o.bufferIndex,f),u=this.t(o.bufferIndex,o.start,f),E=u-h,y=c-t,$=o.length+y;i.piece=new l(o.bufferIndex,o.start,f,u,$),(0,N.$6B)(this,i,y,E)}D(i,n){const o=i.piece,h=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),f=n,c=this.t(o.bufferIndex,f,o.end),u=this.u(o.bufferIndex,f),E=c-h,y=t-u,$=o.length+y;i.piece=new l(o.bufferIndex,f,o.end,c,$),(0,N.$6B)(this,i,y,E)}E(i,n,o){const h=i.piece,t=h.start,f=h.end,c=h.length,u=h.lineFeedCnt,E=n,y=this.t(h.bufferIndex,h.start,E),$=this.u(h.bufferIndex,n)-this.u(h.bufferIndex,t);i.piece=new l(h.bufferIndex,h.start,E,y,$),(0,N.$6B)(this,i,$-c,y-u);const I=new l(h.bufferIndex,o,f,this.t(h.bufferIndex,o,f),this.u(h.bufferIndex,f)-this.u(h.bufferIndex,o)),d=this.S(i,I);this.N(d)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),h=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let d=0;d<t.length;d++)t[d]+=h;if(o){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[f],u={line:f,column:c},E=i.piece.length+n.length,y=i.piece.lineFeedCnt,$=this.t(0,i.piece.start,u),I=$-y;i.piece=new l(i.piece.bufferIndex,i.piece.start,u,$,E),this.g=u,(0,N.$6B)(this,i,n.length,I)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let h=0;for(;n!==N.$YB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){h+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:h};return this.h.set(t),t}else i-=n.size_left+n.piece.length,h+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,h=0;for(;o!==N.$YB;)if(o.left!==N.$YB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),f=this.B(o,i-o.lf_left-1);return h+=o.size_left,{node:o,remainder:Math.min(t+n-1,f),nodeStartOffset:h}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:h};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,h+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==N.$YB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),f=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(h)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===N.$YB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,h=n.start.line,t=o[h]+n.start.column;return h===o.length-1||o[h+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===N.$YB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],h=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:h[i.piece.end.line]-h[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,c=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,c,f),(0,N.$6B)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},E=n.piece.length-1,y=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new l(n.piece.bufferIndex,u,n.piece.end,y,E),(0,N.$6B)(this,n,-1,-1),n.piece.length===0&&o.push(n);const $=this.w(`\r
`);this.S(i,$[0]);for(let I=0;I<o.length;I++)(0,N.$4B)(this,o[I])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,N.$4B)(this,o);else{const h=o.piece,t={line:h.start.line+1,column:0},f=h.length-1,c=this.t(h.bufferIndex,t,h.end);o.piece=new l(h.bufferIndex,t,h.end,c,f),(0,N.$6B)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===N.$YB)return n(N.$YB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===N.$YB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,h=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(h,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),h=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,h)}S(i,n){const o=new N.$XB(n,1);if(o.left=N.$YB,o.right=N.$YB,o.parent=N.$YB,o.size_left=0,o.lf_left=0,this.root===N.$YB)this.root=o,o.color=0;else if(i.right===N.$YB)i.right=o,o.parent=i;else{const t=(0,N.$ZB)(i.right);t.left=o,o.parent=t}return(0,N.$5B)(this,o),o}T(i,n){const o=new N.$XB(n,1);if(o.left=N.$YB,o.right=N.$YB,o.parent=N.$YB,o.size_left=0,o.lf_left=0,this.root===N.$YB)this.root=o,o.color=0;else if(i.left===N.$YB)i.left=o,o.parent=i;else{const h=(0,N.$1B)(i.left);h.right=o,o.parent=h}return(0,N.$5B)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$fC=a}),define(Le[133],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$58=e.$48=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(N){if(N&&this.a.has(N)){const R=this.a.get(N);return this.a.delete(N),R}}addDragOperationTransfer(N,R){this.a.set(N,R)}}e.$48=S;class M{constructor(N){this.identifier=N}}e.$58=M}),define(Le[134],Me([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Le[135],Me([1,0,5,6,134]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=void 0;class N extends M.$Tc{constructor(l,v="",p="",s=!0,a){super(),this.h=this.B(new S.$Yd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=v,this.u=p,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,v){this.C&&await this.C(l)}}e.$Pi=N;class R extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$Yd),this.onWillRun=this.f.event,this.m=this.B(new S.$Yd),this.onDidRun=this.m.event}async run(l,v){if(!l.enabled)return;this.f.fire({action:l});let p;try{await this.u(l,v)}catch(s){p=s}this.m.fire({action:l,error:p})}async u(l,v){await l.run(v)}}e.$Qi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let v=[];for(const p of l)p.length&&(v.length?v=[...v,new m,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Ri=m;class g{get actions(){return this.a}constructor(l,v,p,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=v,this.class=s,this.a=p}async run(){}}e.$Si=g;class D extends N{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,P.localize(0,null),void 0,!1)}}e.$Ti=D;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Ui=A}),define(Le[136],Me([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Le[137],Me([1,0,136]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cm=e.$Bm=e.$Am=void 0;const M=60,P=M*60,N=P*24,R=N*7,m=N*30,g=N*365;function D(l,v,p,s){typeof l!="number"&&(l=l.getTime());const a=Math.round((new Date().getTime()-l)/1e3);if(a<-30)return(0,S.localize)(0,null,D(new Date().getTime()+a*1e3,!1));if(!s&&a<30)return(0,S.localize)(1,null);let r;return a<M?(r=a,v?r===1?p?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):p?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?p?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):p?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):a<P?(r=Math.floor(a/M),v?r===1?p?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):p?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?p?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):p?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):a<N?(r=Math.floor(a/P),v?r===1?p?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):p?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?p?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):p?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):a<R?(r=Math.floor(a/N),v?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):a<m?(r=Math.floor(a/R),v?r===1?p?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):p?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?p?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):p?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):a<g?(r=Math.floor(a/m),v?r===1?p?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):p?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?p?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):p?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(a/g),v?r===1?p?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):p?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?p?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):p?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}e.$Am=D;function A(l,v){const p=Math.abs(l/1e3);return p<1?v?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):p<M?v?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):p<P?v?(0,S.localize)(58,null,Math.round(l/(1e3*M))):(0,S.localize)(59,null,Math.round(l/(1e3*M))):p<N?v?(0,S.localize)(60,null,Math.round(l/(1e3*P))):(0,S.localize)(61,null,Math.round(l/(1e3*P))):(0,S.localize)(62,null,Math.round(l/(1e3*N)))}e.$Bm=A;function k(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Cm=k}),define(Le[138],Me([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Le[41],Me([1,0,18,16,138]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Wi=e.$Vi=void 0;function N(k,l){return l&&(k.stack||k.stacktrace)?P.localize(0,null,m(k),R(k.stack)||R(k.stacktrace)):m(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?P.localize(1,null,k.message):k.message||P.localize(2,null)}function g(k=null,l=!1){if(!k)return P.localize(3,null);if(Array.isArray(k)){const v=S.$Hb(k),p=g(v[0],l);return v.length>1?P.localize(4,null,p,v.length):p}if(M.$Mf(k))return k;if(k.detail){const v=k.detail;if(v.error)return N(v.error,l);if(v.exception)return N(v.exception,l)}return k.stack?N(k,l):k.message?k.message:P.localize(5,null)}e.$Vi=g;function D(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Wi=D;function A(k,l){let v;return typeof k=="string"?v=new Error(k):v=k,v.actions=l,v}e.$Xi=A}),define(Le[139],Me([1,0,39,19]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=void 0;const P=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),N=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(I,d,w=!1){const b=I||"",L=d||"",T=P.value.collator.compare(b,L);return P.value.collatorIsNumeric&&T===0&&b!==L?b<L?-1:1:T}e.$Nq=m;function g(I,d){const w=N.value.collator;return I=I||"",d=d||"",o(w,I,d)}e.$Oq=g;function D(I,d){const w=N.value.collator;return I=I||"",d=d||"",c(I,d)||o(w,I,d)}e.$Pq=D;function A(I,d){const w=N.value.collator;return I=I||"",d=d||"",f(I,d)||o(w,I,d)}e.$Qq=A;function k(I,d){return I=I||"",d=d||"",I===d?0:I<d?-1:1}e.$Rq=k;function l(I,d){const[w,b]=i(I),[L,T]=i(d);let Y=P.value.collator.compare(b,T);if(Y===0){if(P.value.collatorIsNumeric&&b!==T)return b<T?-1:1;if(Y=P.value.collator.compare(w,L),P.value.collatorIsNumeric&&Y===0&&w!==L)return w<L?-1:1}return Y}e.$Sq=l;function v(I,d){I=I||"",d=d||"";const w=n(I),b=n(d),L=N.value.collator,T=R.value.collator;return o(T,w,b)||o(L,I,d)}e.$Tq=v;function p(I,d){I=I||"",d=d||"";const w=n(I),b=n(d),L=N.value.collator,T=R.value.collator;return o(T,w,b)||c(I,d)||o(L,I,d)}e.$Uq=p;function s(I,d){I=I||"",d=d||"";const w=n(I),b=n(d),L=N.value.collator,T=R.value.collator;return o(T,w,b)||f(I,d)||o(L,I,d)}e.$Vq=s;function a(I,d){I=I||"",d=d||"";const w=n(I).toLowerCase(),b=n(d).toLowerCase();return w!==b?w<b?-1:1:I!==d?I<d?-1:1:0}e.$Wq=a;const r=/^(.*?)(\.([^.]*))?$/;function i(I,d=!1){const w=I?r.exec(I):[];let b=[w&&w[1]||"",w&&w[3]||""];return d&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function n(I){const d=I?r.exec(I):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function o(I,d,w){const b=I.compare(d,w);return b!==0?b:d.length!==w.length?d.length<w.length?-1:1:0}function h(I){const d=I.charAt(0);return d.toLocaleUpperCase()!==d}function t(I){const d=I.charAt(0);return d.toLocaleLowerCase()!==d}function f(I,d){return h(I)&&t(d)?-1:t(I)&&h(d)?1:0}function c(I,d){return t(I)&&h(d)?-1:h(I)&&t(d)?1:0}function u(I,d,w=!1){return w||(I=I&&I.toLowerCase(),d=d&&d.toLowerCase()),I===d?0:I<d?-1:1}function E(I,d,w=!1){const b=I.split(M.sep),L=d.split(M.sep),T=b.length-1,Y=L.length-1;let q,U;for(let C=0;;C++){if(q=T===C,U=Y===C,q&&U)return m(b[C],L[C],w);if(q)return-1;if(U)return 1;const F=u(b[C],L[C],w);if(F!==0)return F}}e.$Xq=E;function y(I,d,w){const b=I.toLowerCase(),L=d.toLowerCase(),T=$(I,d,w);if(T)return T;const Y=b.endsWith(w),q=L.endsWith(w);if(Y!==q)return Y?-1:1;const U=m(b,L);return U!==0?U:b.localeCompare(L)}e.$Yq=y;function $(I,d,w){const b=I.toLowerCase(),L=d.toLowerCase(),T=b.startsWith(w),Y=L.startsWith(w);if(T!==Y)return T?-1:1;if(T&&Y){if(b.length<L.length)return-1;if(b.length>L.length)return 1}return 0}e.$Zq=$}),define(Le[45],Me([1,0,19,20,13,16]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=void 0;function R(y){return y===47||y===92}e.$5f=R;function m(y){return y.replace(/[\\/]/g,S.$gc.sep)}e.$6f=m;function g(y){return y.indexOf("/")===-1&&(y=m(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}e.$7f=g;function D(y,$=S.$gc.sep){if(!y)return"";const I=y.length,d=y.charCodeAt(0);if(R(d)){if(R(y.charCodeAt(1))&&!R(y.charCodeAt(2))){let b=3;const L=b;for(;b<I&&!R(y.charCodeAt(b));b++);if(L!==b&&!R(y.charCodeAt(b+1))){for(b+=1;b<I;b++)if(R(y.charCodeAt(b)))return y.slice(0,b+1).replace(/[\\/]/g,$)}}return $}else if(r(d)&&y.charCodeAt(1)===58)return R(y.charCodeAt(2))?y.slice(0,2)+$:y.slice(0,2);let w=y.indexOf("://");if(w!==-1){for(w+=3;w<I;w++)if(R(y.charCodeAt(w)))return y.slice(0,w+1)}return""}e.$8f=D;function A(y){if(!M.$i||!y||y.length<5)return!1;let $=y.charCodeAt(0);if($!==92||($=y.charCodeAt(1),$!==92))return!1;let I=2;const d=I;for(;I<y.length&&($=y.charCodeAt(I),$!==92);I++);return!(d===I||($=y.charCodeAt(I+1),isNaN($)||$===92))}e.$9f=A;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(y,$=M.$i){const I=$?k:l;return!(!y||y.length===0||/^\s+$/.test(y)||(I.lastIndex=0,I.test(y))||$&&v.test(y)||y==="."||y===".."||$&&y[y.length-1]==="."||$&&y.length!==y.trim().length||y.length>255)}e.$0f=p;function s(y,$,I){const d=y===$;return!I||d?d:!y||!$?!1:(0,P.$df)(y,$)}e.$$f=s;function a(y,$,I,d=S.sep){if(y===$)return!0;if(!y||!$||$.length>y.length)return!1;if(I){if(!(0,P.$ef)(y,$))return!1;if($.length===y.length)return!0;let b=$.length;return $.charAt($.length-1)===d&&b--,y.charAt(b)===d}return $.charAt($.length-1)!==d&&($+=d),y.indexOf($)===0}e.$_f=a;function r(y){return y>=65&&y<=90||y>=97&&y<=122}e.$ag=r;function i(y,$){return M.$i&&y.endsWith(":")&&(y+=S.sep),(0,S.$ic)(y)||(y=(0,S.$jc)($,y)),y=(0,S.$hc)(y),M.$i?(y=(0,P.$Xe)(y,S.sep),y.endsWith(":")&&(y+=S.sep)):(y=(0,P.$Xe)(y,S.sep),y||(y=S.sep)),y}e.$bg=i;function n(y){const $=(0,S.$hc)(y);return M.$i?y.length>3?!1:o($)&&(y.length===2||$.charCodeAt(2)===92):$===S.$gc.sep}e.$cg=n;function o(y,$=M.$i){return $?r(y.charCodeAt(0))&&y.charCodeAt(1)===58:!1}e.$dg=o;function h(y,$=M.$i){return o(y,$)?y[0]:void 0}e.$eg=h;function t(y,$,I){return $.length>y.length?-1:y===$?0:(I&&(y=y.toLowerCase(),$=$.toLowerCase()),y.indexOf($))}e.$fg=t;function f(y){const $=y.split(":");let I,d,w;for(const b of $){const L=Number(b);(0,N.$Qf)(L)?d===void 0?d=L:w===void 0&&(w=L):I=I?[I,b].join(":"):b}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.$gg=f;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(y,$,I=8){let d="";for(let b=0;b<I;b++){let L;b===0&&M.$i&&!$&&(I===3||I===4)?L=u:L=c,d+=L.charAt(Math.floor(Math.random()*L.length))}let w;return $?w=`${$}-${d}`:w=d,y?(0,S.$jc)(y,w):w}e.$hg=E}),define(Le[69],Me([1,0,19]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$os=e.$ns=e.$ms=e.$ls=e.$ks=void 0,e.$ks=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function N(A){const k=(0,S.$oc)(A),l=M[k.toLowerCase()];return l!==void 0?l:R(A)}e.$ls=N;function R(A){const k=(0,S.$oc)(A);return P[k.toLowerCase()]}e.$ms=R;function m(A){for(const k in P)if(P[k]===A)return k}e.$ns=m;const g=/^(.+)\/(.+?)(;.+)?$/;function D(A,k){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:A}e.$os=D}),define(Le[52],Me([1,0,23,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=void 0;function P(g){return JSON.stringify(g,R)}e.$Fh=P;function N(g){let D=JSON.parse(g);return D=m(D),D}e.$Gh=N;function R(g,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function m(g,D=0){if(!g||D>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return M.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof S.$me||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=m(g[A],D+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=m(g[A],D+1))}return g}e.$Hh=m}),define(Le[12],Me([1,0,15,20,13,2]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm",l.codeSetting="code-setting"})(R||(e.Schemas=R={}));function m(l,v){return N.URI.isUri(l)?(0,P.$df)(l.scheme,v):(0,P.$ef)(l,v+":")}e.$ig=m;function g(l,...v){return v.some(p=>m(l,p))}e.$jg=g,e.$kg="vscode-tkn",e.$lg="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,p,s){this.a[v]=p,this.b[v]=s}setConnectionToken(v,p){this.c[v]=p}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(n){return S.$1(n),v}const p=v.authority;let s=this.a[p];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[p],r=this.c[p];let i=`path=${encodeURIComponent(v.path)}`;return typeof r=="string"&&(i+=`&${e.$lg}=${encodeURIComponent(r)}`),N.URI.from({scheme:M.$o?this.d:R.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:i})}}e.$mg=new D,e.$ng="vs/../../extensions",e.$og="vs/../../node_modules",e.$pg="vs/../../node_modules.asar",e.$qg="vs/../../node_modules.asar.unpacked",e.$rg="vscode-app";class A{static{this.a=e.$rg}asBrowserUri(v){const p=this.b(v,fe);return this.uriToBrowserUri(p)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$mg.rewrite(v):v.scheme===R.file&&(M.$m||M.$q===`${R.vscodeFileResource}://${A.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||A.a,query:null,fragment:null}):v}asFileUri(v){const p=this.b(v,fe);return this.uriToFileUri(p)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==A.a?v.authority:null,query:null,fragment:null}):v}b(v,p){return N.URI.isUri(v)?v:N.URI.parse(p.toUrl(v))}}e.$sg=new A;var k;(function(l){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(v.get("3"));const p="vscode-coi";function s(r){let i;typeof r=="string"?i=new URL(r).searchParams:r instanceof URL?i=r.searchParams:N.URI.isUri(r)&&(i=new URL(r.toString(!0)).searchParams);const n=i?.get(p);if(n)return v.get(n)}l.getHeadersFromQuery=s;function a(r,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";r instanceof URLSearchParams?r.set(p,o):r[p]=o}l.addSearchParam=a})(k||(e.COI=k={}))}),define(Le[24],Me([1,0,45,12,19,20,13,2]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.DataUri=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=void 0;function g(v){return(0,m.$wc)(v,!0)}e.$zg=g;class D{constructor(p){this.a=p}compare(p,s,a=!1){return p===s?0:(0,R.$9e)(this.getComparisonKey(p,a),this.getComparisonKey(s,a))}isEqual(p,s,a=!1){return p===s?!0:!p||!s?!1:this.getComparisonKey(p,a)===this.getComparisonKey(s,a)}getComparisonKey(p,s=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,s,a=!1){if(p.scheme===s.scheme){if(p.scheme===M.Schemas.file)return S.$_f(g(p),g(s),this.a(p))&&p.query===s.query&&(a||p.fragment===s.fragment);if((0,e.$Qg)(p.authority,s.authority))return S.$_f(p.path,s.path,this.a(p),"/")&&p.query===s.query&&(a||p.fragment===s.fragment)}return!1}joinPath(p,...s){return m.URI.joinPath(p,...s)}basenameOrAuthority(p){return(0,e.$Ig)(p)||p.authority}basename(p){return P.$gc.basename(p.path)}extname(p){return P.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let s;return p.scheme===M.Schemas.file?s=m.URI.file(P.$mc(g(p))).path:(s=P.$gc.dirname(p.path),p.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),s="/")),p.with({path:s})}normalizePath(p){if(!p.path.length)return p;let s;return p.scheme===M.Schemas.file?s=m.URI.file(P.$hc(g(p))).path:s=P.$gc.normalize(p.path),p.with({path:s})}relativePath(p,s){if(p.scheme!==s.scheme||!(0,e.$Qg)(p.authority,s.authority))return;if(p.scheme===M.Schemas.file){const i=P.$lc(g(p),g(s));return N.$i?S.$6f(i):i}let a=p.path||"/";const r=s.path||"/";if(this.a(p)){let i=0;for(const n=Math.min(a.length,r.length);i<n&&!(a.charCodeAt(i)!==r.charCodeAt(i)&&a.charAt(i).toLowerCase()!==r.charAt(i).toLowerCase());i++);a=r.substr(0,i)+a.substr(i)}return P.$gc.relative(a,r)}resolvePath(p,s){if(p.scheme===M.Schemas.file){const a=m.URI.file(P.$kc(g(p),s));return p.with({authority:a.authority,path:a.path})}return s=S.$7f(s),p.with({path:P.$gc.resolve(p.path,s)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,s){return p===s||p!==void 0&&s!==void 0&&(0,R.$df)(p,s)}hasTrailingPathSeparator(p,s=P.sep){if(p.scheme===M.Schemas.file){const a=g(p);return a.length>S.$8f(a).length&&a[a.length-1]===s}else{const a=p.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,s=P.sep){return(0,e.$Rg)(p,s)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,s=P.sep){let a=!1;if(p.scheme===M.Schemas.file){const r=g(p);a=r!==void 0&&r.length===S.$8f(r).length&&r[r.length-1]===s}else{s="/";const r=p.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.$Rg)(p,s)?p.with({path:p.path+"/"}):p}}e.$Ag=D,e.$Bg=new D(()=>!1),e.$Cg=new D(v=>v.scheme===M.Schemas.file?!N.$k:!0),e.$Dg=new D(v=>!0),e.$Eg=e.$Bg.isEqual.bind(e.$Bg),e.$Fg=e.$Bg.isEqualOrParent.bind(e.$Bg),e.$Gg=e.$Bg.getComparisonKey.bind(e.$Bg),e.$Hg=e.$Bg.basenameOrAuthority.bind(e.$Bg),e.$Ig=e.$Bg.basename.bind(e.$Bg),e.$Jg=e.$Bg.extname.bind(e.$Bg),e.$Kg=e.$Bg.dirname.bind(e.$Bg),e.$Lg=e.$Bg.joinPath.bind(e.$Bg),e.$Mg=e.$Bg.normalizePath.bind(e.$Bg),e.$Ng=e.$Bg.relativePath.bind(e.$Bg),e.$Og=e.$Bg.resolvePath.bind(e.$Bg),e.$Pg=e.$Bg.isAbsolutePath.bind(e.$Bg),e.$Qg=e.$Bg.isEqualAuthority.bind(e.$Bg),e.$Rg=e.$Bg.hasTrailingPathSeparator.bind(e.$Bg),e.$Sg=e.$Bg.removeTrailingPathSeparator.bind(e.$Bg),e.$Tg=e.$Bg.addTrailingPathSeparator.bind(e.$Bg);function A(v,p){const s=[];for(let a=0;a<v.length;a++){const r=p(v[a]);v.some((i,n)=>n===a?!1:(0,e.$Fg)(r,p(i)))||s.push(v[a])}return s}e.$Ug=A;var k;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,h]=n.split(":");o&&h&&a.set(o,h)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&a.set(v.META_DATA_MIME,i),a}v.parseMetaData=p})(k||(e.DataUri=k={}));function l(v,p,s){if(p){let a=v.path;return a&&a[0]!==P.$gc.sep&&(a=P.$gc.sep+a),v.with({scheme:s,authority:p,path:a})}return v.with({scheme:s})}e.$Vg=l}),define(Le[11],Me([1,0,21,15,5,6,24,20,126,39]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.Promises=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=void 0;function A(me){return!!me&&typeof me.then=="function"}e.$Wg=A;function k(me){const J=new S.$9d,x=me(J.token),le=new Promise((de,Ae)=>{const ge=J.token.onCancellationRequested(()=>{ge.dispose(),Ae(new M.$5)});Promise.resolve(x).then(Se=>{ge.dispose(),J.dispose(),de(Se)},Se=>{ge.dispose(),J.dispose(),Ae(Se)})});return new class{cancel(){J.cancel(),J.dispose()}then(de,Ae){return le.then(de,Ae)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}e.$Xg=k;function l(me,J,x){return new Promise((le,de)=>{const Ae=J.onCancellationRequested(()=>{Ae.dispose(),le(x)});me.then(le,de).finally(()=>Ae.dispose())})}e.$Yg=l;function v(me,J){return new Promise((x,le)=>{const de=J.onCancellationRequested(()=>{de.dispose(),le(new M.$5)});me.then(x,le).finally(()=>de.dispose())})}e.$Zg=v;async function p(me){let J=-1;const x=me.map((le,de)=>le.then(Ae=>(J=de,Ae)));try{return await Promise.race(x)}finally{me.forEach((le,de)=>{de!==J&&le.cancel()})}}e.$1g=p;function s(me,J,x){let le;const de=setTimeout(()=>{le?.(void 0),x?.()},J);return Promise.race([me.finally(()=>clearTimeout(de)),new Promise(Ae=>le=Ae)])}e.$2g=s;function a(me){return new Promise((J,x)=>{const le=me();A(le)?le.then(J,x):J(le)})}e.$3g=a;function r(){let me,J;return{promise:new Promise((le,de)=>{me=le,J=de}),resolve:me,reject:J}}e.$4g=r;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const x=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(x,x).then(le)})}return new Promise((x,le)=>{this.b.then(x,le)})}return this.a=J(),new Promise((x,le)=>{this.a.then(de=>{this.a=null,x(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$5g=i;class n{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$6g=n;class o{constructor(){this.a=new Map}queue(J,x){const de=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(J)===de&&this.a.delete(J)});return this.a.set(J,de),de}}e.$7g=o;const h=(me,J)=>{let x=!0;const le=setTimeout(()=>{x=!1,J()},me);return{isTriggered:()=>x,dispose:()=>{clearTimeout(le),x=!1}}},t=me=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,me())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class f{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,x=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((de,Ae)=>{this.d=de,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=x===g.$Vd?t(le):h(x,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$8g=f;class c{constructor(J){this.a=new f(J),this.b=new i}trigger(J,x){return this.a.trigger(()=>this.b.queue(J),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$9g=c;class u{constructor(){this.a=!1,this.b=new Promise((J,x)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$0g=u;class E extends u{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$$g=E;function y(me,J){return J?new Promise((x,le)=>{const de=setTimeout(()=>{Ae.dispose(),x()},me),Ae=J.onCancellationRequested(()=>{clearTimeout(de),Ae.dispose(),le(new M.$5)})}):k(x=>y(me,x))}e.$_g=y;function $(me,J=0,x){const le=setTimeout(()=>{me(),x&&de.dispose()},J),de=(0,N.$Rc)(()=>{clearTimeout(le),x?.deleteAndLeak(de)});return x?.add(de),de}e.$ah=$;function I(me){const J=[];let x=0;const le=me.length;function de(){return x<le?me[x++]():null}function Ae(ge){ge!=null&&J.push(ge);const Se=de();return Se?Se.then(Ae):Promise.resolve(J)}return Promise.resolve(null).then(Ae)}e.$bh=I;function d(me,J=le=>!!le,x=null){let le=0;const de=me.length,Ae=()=>{if(le>=de)return Promise.resolve(x);const ge=me[le++];return Promise.resolve(ge()).then(Ie=>J(Ie)?Promise.resolve(Ie):Ae())};return Ae()}e.$ch=d;function w(me,J=le=>!!le,x=null){if(me.length===0)return Promise.resolve(x);let le=me.length;const de=()=>{le=-1;for(const Ae of me)Ae.cancel?.()};return new Promise((Ae,ge)=>{for(const Se of me)Se.then(Ie=>{--le>=0&&J(Ie)?(de(),Ae(Ie)):le===0&&Ae(x)}).catch(Ie=>{--le>=0&&(de(),ge(Ie))})})}e.$dh=w;class b{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new P.$Yd}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,le)=>{this.g.push({factory:J,c:x,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const x=J.factory();x.then(J.c,J.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$eh=b;class L extends b{constructor(){super(1)}}e.$fh=L;class T{constructor(){this.a=new he,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$gh=T;class Y{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new $e;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,x=R.$Bg){const le=x.getComparisonKey(J);return this.a.get(le)?.size??0}queueFor(J,x,le=R.$Bg){const de=le.getComparisonKey(J);let Ae=this.a.get(de);if(!Ae){Ae=new L;const ge=this.f++,Se=P.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$3c),this.d.set(ge,Se),this.a.set(de,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$hh=Y;class q{constructor(J,x){this.a=-1,typeof J=="function"&&typeof x=="number"&&this.setIfNotSet(J,x)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,x){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},x)}setIfNotSet(J,x){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},x))}}e.$ih=q;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,x,le=globalThis){this.cancel();const de=le.setInterval(()=>{J()},x);this.d=(0,N.$Rc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$jh=U;class C{constructor(J,x){this.b=-1,this.a=J,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$kh=C;class F{constructor(J,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=J,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$lh=F;class W extends C{constructor(J,x){super(J,x),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$mh=W;class re extends N.$Tc{constructor(J,x){super(),this.g=J,this.h=x,this.a=[],this.b=this.B(new N.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of J)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$nh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ph=(me,J)=>{(0,m.$B)(()=>{if(x)return;const le=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$ph=(me,J,x)=>{const le=me.requestIdleCallback(J,typeof x=="number"?{timeout:x}:void 0);let de=!1;return{dispose(){de||(de=!0,me.cancelIdleCallback(le))}}},e.$oh=me=>(0,e.$ph)(globalThis,me)}();class ue{constructor(J,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$ph)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$qh=ue;class ye extends ue{constructor(J){super(globalThis,J)}}e.$rh=ye;async function ke(me,J,x){let le;for(let de=0;de<x;de++)try{return await me()}catch(Ae){le=Ae,await y(J)}throw le}e.$sh=ke;class he{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,x,le){return this.a={taskId:J,cancel:()=>le?.(),promise:x},x.then(()=>this.d(J),()=>this.d(J)),x}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:x,resolve:le,reject:de}=r();this.b={run:J,promise:x,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$th=he;class ve{constructor(J,x=()=>Date.now()){this.d=J,this.f=x,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$uh=ve;var se;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(se||(se={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,x)=>{this.a=J,this.b=x})}complete(J){return new Promise(x=>{this.a(J),this.d={outcome:0,value:J},x()})}error(J){return new Promise(x=>{this.b(J),this.d={outcome:1,value:J},x()})}cancel(){return this.error(new M.$5)}}e.$vh=$e;var te;(function(me){async function J(le){let de;const Ae=await Promise.all(le.map(ge=>ge.then(Se=>Se,Se=>{de||(de=Se)})));if(typeof de<"u")throw de;return Ae}me.settled=J;function x(le){return new Promise(async(de,Ae)=>{try{await le(de,Ae)}catch(ge){Ae(ge)}})}me.withAsyncBody=x})(te||(e.Promises=te={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$wh=X;class V{constructor(J){this.b=J,this.a=new D.$V(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$xh=V;var ne;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ne||(ne={}));class Ce{static fromArray(J){return new Ce(x=>{x.emitMany(J)})}static fromPromise(J){return new Ce(async x=>{x.emitMany(await J)})}static fromPromises(J){return new Ce(async x=>{await Promise.all(J.map(async le=>x.emitOne(await le)))})}static merge(J){return new Ce(async x=>{await Promise.all(J.map(async le=>{for await(const de of le)x.emitOne(de)}))})}static{this.EMPTY=Ce.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new P.$Yd,queueMicrotask(async()=>{const x={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(J(x)),this.j()}catch(le){this.k(le)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(J,x){return new Ce(async le=>{for await(const de of J)le.emitOne(x(de))})}map(J){return Ce.map(this,J)}static filter(J,x){return new Ce(async le=>{for await(const de of J)x(de)&&le.emitOne(de)})}filter(J){return Ce.filter(this,J)}static coalesce(J){return Ce.filter(J,x=>!!x)}coalesce(){return Ce.coalesce(this)}static async toPromise(J){const x=[];for await(const le of J)x.push(le);return x}toPromise(){return Ce.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$yh=Ce;class Fe extends Ce{constructor(J,x){super(x),this.l=J}cancel(){this.l.cancel()}}e.$zh=Fe;function Pe(me){const J=new S.$9d,x=me(J.token);return new Fe(J,async le=>{const de=J.token.onCancellationRequested(()=>{de.dispose(),J.dispose(),le.reject(new M.$5)});try{for await(const Ae of x){if(J.token.isCancellationRequested)return;le.emitOne(Ae)}de.dispose(),J.dispose()}catch(Ae){de.dispose(),J.dispose(),le.reject(Ae)}})}e.$Ah=Pe;class we{constructor(){this.a=new $e,this.b=new Ce(le=>{if(J){le.reject(J);return}return x&&le.emitMany(x),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let J,x;this.f=le=>{x||(x=[]),x.push(le)},this.d=le=>{J||(J=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Bh=we}),define(Le[34],Me([1,0,18,11,45,28,19,20,13]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=void 0;function D(){return Object.create(null)}e.$Mj=D,e.$Nj="**",e.$Oj="/";const A="[/\\\\]",k="[^/\\\\]",l=/\//g;function v(ue,ye){switch(ue){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${ye?`|${A}${k}+`:""})*?`}}function p(ue,ye){if(!ue)return[];const ke=[];let he=!1,ve=!1,se="";for(const $e of ue){switch($e){case ye:if(!he&&!ve){ke.push(se),se="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=$e}return se&&ke.push(se),ke}e.$Pj=p;function s(ue){if(!ue)return"";let ye="";const ke=p(ue,e.$Oj);if(ke.every(he=>he===e.$Nj))ye=".*";else{let he=!1;ke.forEach((ve,se)=>{if(ve===e.$Nj){if(he)return;ye+=v(2,se===ke.length-1)}else{let $e=!1,te="",X=!1,V="";for(const ne of ve){if(ne!=="}"&&$e){te+=ne;continue}if(X&&(ne!=="]"||!V)){let Ce;ne==="-"?Ce=ne:(ne==="^"||ne==="!")&&!V?Ce="^":ne===e.$Oj?Ce="":Ce=(0,g.$Re)(ne),V+=Ce;continue}switch(ne){case"{":$e=!0;continue;case"[":X=!0;continue;case"}":{const Fe=`(?:${p(te,",").map(Pe=>s(Pe)).join("|")})`;ye+=Fe,$e=!1,te="";break}case"]":{ye+="["+V+"]",X=!1,V="";break}case"?":ye+=k;continue;case"*":ye+=v(1);continue;default:ye+=(0,g.$Re)(ne)}}se<ke.length-1&&(ke[se+1]!==e.$Nj||se+2<ke.length)&&(ye+=A)}he=ve===e.$Nj})}return ye}const a=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new N.$Dc(1e4),f=function(){return!1},c=function(){return null};function u(ue,ye){if(!ue)return c;let ke;typeof ue!="string"?ke=ue.pattern:ke=ue,ke=ke.trim();const he=`${ke}_${!!ye.trimForExclusions}`;let ve=t.get(he);if(ve)return E(ve,ue);let se;return a.test(ke)?ve=$(ke.substr(4),ke):(se=r.exec(y(ke,ye)))?ve=I(se[1],ke):(ye.trimForExclusions?n:i).test(ke)?ve=d(ke,ye):(se=o.exec(y(ke,ye)))?ve=w(se[1].substr(1),ke,!0):(se=h.exec(y(ke,ye)))?ve=w(se[1],ke,!1):ve=b(ke),t.set(he,ve),E(ve,ue)}function E(ue,ye){if(typeof ye=="string")return ue;const ke=function(he,ve){return(0,P.$_f)(he,ye.base,!m.$k)?ue((0,g.$We)(he.substr(ye.base.length),R.sep),ve):null};return ke.allBasenames=ue.allBasenames,ke.allPaths=ue.allPaths,ke.basenames=ue.basenames,ke.patterns=ue.patterns,ke}function y(ue,ye){return ye.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function $(ue,ye){return function(ke,he){return typeof ke=="string"&&ke.endsWith(ue)?ye:null}}function I(ue,ye){const ke=`/${ue}`,he=`\\${ue}`,ve=function($e,te){return typeof $e!="string"?null:te?te===ue?ye:null:$e===ue||$e.endsWith(ke)||$e.endsWith(he)?ye:null},se=[ue];return ve.basenames=se,ve.patterns=[ye],ve.allBasenames=se,ve}function d(ue,ye){const ke=W(ue.slice(1,-1).split(",").map(te=>u(te,ye)).filter(te=>te!==c),ue),he=ke.length;if(!he)return c;if(he===1)return ke[0];const ve=function(te,X){for(let V=0,ne=ke.length;V<ne;V++)if(ke[V](te,X))return ue;return null},se=ke.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=ke.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function w(ue,ye,ke){const he=R.sep===R.$gc.sep,ve=he?ue:ue.replace(l,R.sep),se=R.sep+ve,$e=R.$gc.sep+ue;let te;return ke?te=function(X,V){return typeof X=="string"&&(X===ve||X.endsWith(se)||!he&&(X===ue||X.endsWith($e)))?ye:null}:te=function(X,V){return typeof X=="string"&&(X===ve||!he&&X===ue)?ye:null},te.allPaths=[(ke?"*/":"./")+ue],te}function b(ue){try{const ye=new RegExp(`^${s(ue)}$`);return function(ke){return ye.lastIndex=0,typeof ke=="string"&&ye.test(ke)?ue:null}}catch{return c}}function L(ue,ye,ke){return!ue||typeof ye!="string"?!1:T(ue)(ye,void 0,ke)}e.$Qj=L;function T(ue,ye={}){if(!ue)return f;if(typeof ue=="string"||Y(ue)){const ke=u(ue,ye);if(ke===c)return f;const he=function(ve,se){return!!ke(ve,se)};return ke.allBasenames&&(he.allBasenames=ke.allBasenames),ke.allPaths&&(he.allPaths=ke.allPaths),he}return C(ue,ye)}e.$Rj=T;function Y(ue){const ye=ue;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$Sj=Y;function q(ue){return ue.allBasenames||[]}e.$Tj=q;function U(ue){return ue.allPaths||[]}e.$Uj=U;function C(ue,ye){const ke=W(Object.getOwnPropertyNames(ue).map(te=>F(te,ue[te],ye)).filter(te=>te!==c)),he=ke.length;if(!he)return c;if(!ke.some(te=>!!te.requiresSiblings)){if(he===1)return ke[0];const te=function(ne,Ce){let Fe;for(let Pe=0,we=ke.length;Pe<we;Pe++){const me=ke[Pe](ne,Ce);if(typeof me=="string")return me;(0,M.$Wg)(me)&&(Fe||(Fe=[]),Fe.push(me))}return Fe?(async()=>{for(const Pe of Fe){const we=await Pe;if(typeof we=="string")return we}return null})():null},X=ke.find(ne=>!!ne.allBasenames);X&&(te.allBasenames=X.allBasenames);const V=ke.reduce((ne,Ce)=>Ce.allPaths?ne.concat(Ce.allPaths):ne,[]);return V.length&&(te.allPaths=V),te}const ve=function(te,X,V){let ne,Ce;for(let Fe=0,Pe=ke.length;Fe<Pe;Fe++){const we=ke[Fe];we.requiresSiblings&&V&&(X||(X=(0,R.$nc)(te)),ne||(ne=X.substr(0,X.length-(0,R.$oc)(te).length)));const me=we(te,X,ne,V);if(typeof me=="string")return me;(0,M.$Wg)(me)&&(Ce||(Ce=[]),Ce.push(me))}return Ce?(async()=>{for(const Fe of Ce){const Pe=await Fe;if(typeof Pe=="string")return Pe}return null})():null},se=ke.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=ke.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function F(ue,ye,ke){if(ye===!1)return c;const he=u(ue,ke);if(he===c)return c;if(typeof ye=="boolean")return he;if(ye){const ve=ye.when;if(typeof ve=="string"){const se=($e,te,X,V)=>{if(!V||!he($e,te))return null;const ne=ve.replace("$(basename)",()=>X),Ce=V(ne);return(0,M.$Wg)(Ce)?Ce.then(Fe=>Fe?ue:null):Ce?ue:null};return se.requiresSiblings=!0,se}}return he}function W(ue,ye){const ke=ue.filter(te=>!!te.basenames);if(ke.length<2)return ue;const he=ke.reduce((te,X)=>{const V=X.basenames;return V?te.concat(V):te},[]);let ve;if(ye){ve=[];for(let te=0,X=he.length;te<X;te++)ve.push(ye)}else ve=ke.reduce((te,X)=>{const V=X.patterns;return V?te.concat(V):te},[]);const se=function(te,X){if(typeof te!="string")return null;if(!X){let ne;for(ne=te.length;ne>0;ne--){const Ce=te.charCodeAt(ne-1);if(Ce===47||Ce===92)break}X=te.substr(ne)}const V=he.indexOf(X);return V!==-1?ve[V]:null};se.basenames=he,se.patterns=ve,se.allBasenames=he;const $e=ue.filter(te=>!te.basenames);return $e.push(se),$e}function re(ue,ye){return(0,S.$ub)(ue,ye,(ke,he)=>typeof ke=="string"&&typeof he=="string"?ke===he:typeof ke!="string"&&typeof he!="string"?ke.base===he.base&&ke.pattern===he.pattern:!1)}e.$Vj=re}),define(Le[46],Me([1,0,15,127,24,13,2]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,S.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=l(this.supportThemeIcons?(0,M.$gk)(i):i).replace(/([ \t]+)/g,(o,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${v(n,i)}
`,this}appendLink(i,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(i,n){const o=new RegExp((0,N.$Re)(n),"g");return i.replace(o,(h,t)=>i.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$mk=g;function D(r){return A(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.$nk=D;function A(r){return r instanceof g?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$ok=A;function k(r,i){return r===i?!0:!r||!i?!1:r.value===i.value&&r.isTrusted===i.isTrusted&&r.supportThemeIcons===i.supportThemeIcons&&r.supportHtml===i.supportHtml&&(r.baseUri===i.baseUri||!!r.baseUri&&!!i.baseUri&&(0,P.$Eg)(R.URI.from(r.baseUri),R.URI.from(i.baseUri)))}e.$pk=k;function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$qk=l;function v(r,i){const n=r.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${i}`,r,`${"`".repeat(o)}`].join(`
`)}e.$rk=v;function p(r){return r.replace(/"/g,"&quot;")}e.$sk=p;function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$tk=s;function a(r){const i=[],n=r.split("|").map(h=>h.trim());r=n[0];const o=n[1];if(o){const h=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),f=h?h[1]:"",c=t?t[1]:"",u=isFinite(parseInt(c)),E=isFinite(parseInt(f));u&&i.push(`width="${c}"`),E&&i.push(`height="${f}"`)}return{href:r,dimensions:i}}e.$uk=a}),define(Le[94],Me([1,0,18,45,19,20,24,13]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=void 0;function g(u,E){const{os:y,tildify:$,relative:I}=E;if(I){const b=D(u,I,y);if(typeof b=="string")return b}let d=u.fsPath;if(y===1&&!N.$i?d=d.replace(/\//g,"\\"):y!==1&&N.$i&&(d=d.replace(/\\/g,"/")),y!==1&&$?.userHome){const b=$.userHome.fsPath;let L;u.scheme!==$.userHome.scheme&&u.path[0]===P.$gc.sep&&u.path[1]!==P.$gc.sep?L=$.userHome.with({path:u.path}).fsPath:L=d,d=l(L,b,y)}return(y===1?P.$fc:P.$gc).normalize(A(d,y===1))}e.$1v=g;function D(u,E,y){const $=y===1?P.$fc:P.$gc,I=y===3?R.$Bg:R.$Dg,d=E.getWorkspace(),w=(0,S.$Ob)(d.folders);if(!w)return;u.scheme!==w.uri.scheme&&u.path[0]===P.$gc.sep&&u.path[1]!==P.$gc.sep&&(u=w.uri.with({path:u.path}));const b=E.getWorkspaceFolder(u);if(!b)return;let L;if(I.isEqual(b.uri,u)?L="":L=I.relativePath(b.uri,u)??"",L&&(L=$.normalize(L)),d.folders.length>1&&!E.noPrefix){const T=b.name?b.name:I.basenameOrAuthority(b.uri);L=L?`${T} \u2022 ${L}`:T}return L}function A(u,E=N.$i){return(0,M.$dg)(u,E)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$2v=A;let k=Object.create(null);function l(u,E,y=N.OS){if(y===1||!u||!E)return u;let $=k.original===E?k.normalized:void 0;$||($=E,N.$i&&($=(0,M.$6f)($)),$=`${(0,m.$Xe)($,P.$gc.sep)}${P.$gc.sep}`,k={original:E,normalized:$});let I=u;return N.$i&&(I=(0,M.$6f)(I)),(y===3?I.startsWith($):(0,m.$ef)(I,$))?`~/${I.substr($.length)}`:u}e.$3v=l;function v(u,E){return u.replace(/^~($|\/|\\)/,`${E}$1`)}e.$4v=v;const p="\u2026",s="\\\\",a="~";function r(u,E=P.sep){const y=new Array(u.length);let $=!1;for(let I=0;I<u.length;I++){const d=u[I];if(d===""){y[I]=`.${E}`;continue}if(!d){y[I]=d;continue}$=!0;let w="",b=d;b.indexOf(s)===0?(w=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length)):b.indexOf(E)===0?(w=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(a)===0&&(w=b.substr(0,b.indexOf(a)+a.length),b=b.substr(b.indexOf(a)+a.length));const L=b.split(E);for(let T=1;$&&T<=L.length;T++)for(let Y=L.length-T;$&&Y>=0;Y--){$=!1;let q=L.slice(Y,Y+T).join(E);for(let U=0;!$&&U<u.length;U++)if(U!==I&&u[U]&&u[U].indexOf(q)>-1){const C=Y+T===L.length,F=Y>0&&u[U].indexOf(E)>-1?E+q:q,W=u[U].endsWith(F);$=!C||W}if(!$){let U="";(L[0].endsWith(":")||w!=="")&&(Y===1&&(Y=0,T++,q=L[0]+E+q),Y>0&&(U=L[0]+E),U=w+U),Y>0&&(U=U+p+E),U=U+q,Y+T<L.length&&(U=U+E+p),y[I]=U}}$&&(y[I]=d)}return y}e.$5v=r;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,E=Object.create(null)){const y=[];let $=!1,I="";for(const d of u)if(d==="$"||$&&d==="{")I&&y.push({value:I,type:i.TEXT}),I="",$=!0;else if(d==="}"&&$){const w=E[I];if(typeof w=="string")w.length&&y.push({value:w,type:i.VARIABLE});else if(w){const b=y[y.length-1];(!b||b.type!==i.SEPARATOR)&&y.push({value:w.label,type:i.SEPARATOR})}I="",$=!1}else I+=d;return I&&!$&&y.push({value:I,type:i.TEXT}),y.filter((d,w)=>{if(d.type===i.SEPARATOR){const b=y[w-1],L=y[w+1];return[b,L].every(T=>T&&(T.type===i.VARIABLE||T.type===i.TEXT)&&T.value.length>0)}return!0}).map(d=>d.value).join("")}e.$6v=n;function o(u,E){return N.$j||E?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,N.$j?"&":"&&"):u.replace(/&&|&/g,y=>y==="&"?"&&":"&")}e.$7v=o;function h(u,E){return N.$j||E?u.replace(/\(&&\w\)|&&/g,""):N.$i?u.replace(/&&|&/g,y=>y==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$8v=h;function t(u){return u.replace(/&/g,"&&")}e.$9v=t;function f(u){if(u.endsWith("]")){const E=u.lastIndexOf(" [",u.length-2);if(E!==-1){const y=c(u.substring(0,E)),$=u.substring(E);return{name:y.name+$,parentPath:y.parentPath}}}return c(u)}e.$0v=f;function c(u){const E=u.indexOf("/")!==-1?P.$gc:P.$fc,y=E.basename(u),$=E.dirname(u);return y.length?{name:y,parentPath:$}:{name:$,parentPath:""}}}),define(Le[140],Me([1,0,23,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=e.$$m=e.$0m=void 0;function P(k){return k.toJSON()}class N{constructor(l){this.a=l}transformIncoming(l){const v=this.a.transformIncoming(l);return v===l?l:P(M.URI.from(v))}transformOutgoing(l){const v=this.a.transformOutgoing(l);return v===l?l:P(M.URI.from(v))}transformOutgoingURI(l){const v=this.a.transformOutgoing(l);return v===l?l:M.URI.from(v)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$0m=N,e.$$m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,v){if(!k||v>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return l.transformOutgoing(k);for(const p in k)if(Object.hasOwnProperty.call(k,p)){const s=R(k[p],l,v+1);s!==null&&(k[p]=s)}}return null}function m(k,l){const v=R(k,l,0);return v===null?k:v}e.$_m=m;function g(k,l,v,p){if(!k||p>200)return null;if(typeof k=="object"){if(k.$mid===1)return v?M.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof S.$me)return null;for(const s in k)if(Object.hasOwnProperty.call(k,s)){const a=g(k[s],l,v,p+1);a!==null&&(k[s]=a)}}return null}function D(k,l){const v=g(k,l,!1,0);return v===null?k:v}e.$an=D;function A(k,l){const v=g(k,l,!0,0);return v===null?k:v}e.$bn=A}),define(Le[141],Me([1,0,13,20,23]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=e.$ft=void 0;let N;function R(){return N||(N=new TextDecoder("UTF-16LE")),N}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let D;function A(){return D||(D=M.$D()?R():g()),D}e.$ft=A;function k(p,s,a){const r=new Uint16Array(p.buffer,s,a);return a>0&&(r[0]===65279||r[0]===65534)?l(p,s,a):R().decode(r)}e.$gt=k;function l(p,s,a){const r=[];let i=0;for(let n=0;n<a;n++){const o=P.$oe(p,s);s+=2,r[i++]=String.fromCharCode(o)}return r.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return A().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const a=this.a-this.d;a<=1&&(a===0||S.$hf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const a=s.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<a;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$ht=v}),define(Le[142],Me([1,0,23,141]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.$it=void 0;function P(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class N{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,A,k,l){this.oldPosition=D,this.oldText=A,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,A,k){const l=A.length;S.$re(D,l,k),k+=4;for(let v=0;v<l;v++)S.$pe(D,A.charCodeAt(v),k),k+=2;return k}static d(D,A){const k=S.$qe(D,A);return A+=4,(0,M.$gt)(D,A,k)}writeSize(){return 8+N.a(this.oldText)+N.a(this.newText)}write(D,A){return S.$re(D,this.oldPosition,A),A+=4,S.$re(D,this.newPosition,A),A+=4,A=N.c(D,this.oldText,A),A=N.c(D,this.newText,A),A}static read(D,A,k){const l=S.$qe(D,A);A+=4;const v=S.$qe(D,A);A+=4;const p=N.d(D,A);A+=N.a(p);const s=N.d(D,A);return A+=N.a(s),k.push(new N(l,p,v,s)),A}}e.$it=N;function R(g,D){return g===null||g.length===0?D:new m(g,D).compress()}e.$jt=R;class m{constructor(D,A){this.a=D,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,A=0,k=this.n(D),l=this.l(A);for(;D<this.f||A<this.h;){if(k===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(k),k=this.n(++D);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++A);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++D);continue}if(l.oldPosition<k.newPosition){const[r,i]=m.r(l,k.newPosition-l.oldPosition);this.k(r),l=i;continue}if(k.newPosition<l.oldPosition){const[r,i]=m.q(k,l.oldPosition-k.newPosition);this.m(r),k=i;continue}let s,a;if(l.oldEnd===k.newEnd)s=k,a=l,k=this.n(++D),l=this.l(++A);else if(l.oldEnd<k.newEnd){const[r,i]=m.q(k,l.oldLength);s=r,a=l,k=i,l=this.l(++A)}else{const[r,i]=m.r(l,k.newLength);s=k,a=r,k=this.n(++D),l=i}this.d[this.e++]=new N(s.oldPosition,s.oldText,a.newPosition,a.newText),this.g+=s.newLength-s.oldLength,this.j+=a.newLength-a.oldLength}const v=m.s(this.d);return m.t(v)}k(D){this.d[this.e++]=m.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=m.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,A){return new N(A.oldPosition-D,A.oldText,A.newPosition,A.newText)}static p(D,A){return new N(A.oldPosition,A.oldText,A.newPosition+D,A.newText)}static q(D,A){const k=D.newText.substr(0,A),l=D.newText.substr(A);return[new N(D.oldPosition,D.oldText,D.newPosition,k),new N(D.oldEnd,"",D.newPosition+A,l)]}static r(D,A){const k=D.oldText.substr(0,A),l=D.oldText.substr(A);return[new N(D.oldPosition,k,D.newPosition,D.newText),new N(D.oldPosition+A,l,D.newEnd,"")]}static s(D){if(D.length===0)return D;const A=[];let k=0,l=D[0];for(let v=1;v<D.length;v++){const p=D[v];l.oldEnd===p.oldPosition?l=new N(l.oldPosition,l.oldText+p.oldText,l.newPosition,l.newText+p.newText):(A[k++]=l,l=p)}return A[k++]=l,A}static t(D){if(D.length===0)return D;const A=[];let k=0;for(let l=0;l<D.length;l++){const v=D[l];v.oldText!==v.newText&&(A[k++]=v)}return A}}}),define(Le[143],Me([1,0,34,19]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=void 0;function P(N,R,m,g,D,A){if(Array.isArray(N)){let k=0;for(const l of N){const v=P(l,R,m,g,D,A);if(v===10)return v;v>k&&(k=v)}return k}else{if(typeof N=="string")return g?N==="*"?5:N===m?10:0:0;if(N){const{language:k,pattern:l,scheme:v,hasAccessToAllModels:p,notebookType:s}=N;if(!g&&!p)return 0;s&&D&&(R=D);let a=0;if(v)if(v===R.scheme)a=10;else if(v==="*")a=5;else return 0;if(k)if(k===m)a=10;else if(k==="*")a=Math.max(a,5);else return 0;if(s)if(s===A)a=10;else if(s==="*"&&A!==void 0)a=Math.max(a,5);else return 0;if(l){let r;if(typeof l=="string"?r=l:r={...l,base:(0,M.$hc)(l.base)},r===R.fsPath||(0,S.$Qj)(r,R.fsPath))a=10;else return 0}return a}else return 0}}e.$Gt=P}),define(Le[144],Me([1,0,5,13,29,92,90,129,142,6]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class A extends D.$Tc{constructor(l,v,p,s,a,r,i){super(),this.m=this.B(new S.$Yd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!r,this.g=s,this.h=a,this.c=new R.$fC(l,p,i)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,v){return this.c.getOffsetAt(l,v)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,v){const p=l+v,s=this.getPositionAt(l),a=this.getPositionAt(p);return new P.$Zs(s.lineNumber,s.column,a.lineNumber,a.column)}getValueInRange(l,v=0){if(l.isEmpty())return"";const p=this.n(v);return this.c.getValueInRange(l,p)}getValueLengthInRange(l,v=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const p=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const r=this.n(v),i=this.getEOL();if(r.length!==i.length){const n=r.length-i.length,o=l.endLineNumber-l.startLineNumber;a=n*o}return s-p+a}getCharacterCountInRange(l,v=0){if(this.j){let p=0;const s=l.startLineNumber,a=l.endLineNumber;for(let r=s;r<=a;r++){const i=this.getLineContent(r),n=r===s?l.startColumn-1:0,o=r===a?l.endColumn-1:i.length;for(let h=n;h<o;h++)M.$hf(i.charCodeAt(h))?(p=p+1,h=h+1):p=p+1}return p+=this.n(v).length*(a-s),p}return this.getValueLengthInRange(l,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,v){return this.c.getLineCharCode(l,v)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const v=M.$5e(this.getLineContent(l));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(l){const v=M.$7e(this.getLineContent(l));return v===-1?0:v+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,v,p){let s=this.g,a=this.h,r=this.j,i=!0,n=[];for(let E=0;E<l.length;E++){const y=l[E];i&&y._isTracked&&(i=!1);const $=y.range;if(y.text){let L=!0;r||(L=!M.$sf(y.text),r=L),!s&&L&&(s=M.$rf(y.text)),!a&&L&&(a=M.$uf(y.text))}let I="",d=0,w=0,b=0;if(y.text){let L;[d,w,b,L]=(0,m.$zt)(y.text);const T=this.getEOL();L===0||L===(T===`\r
`?2:1)?I=y.text:I=y.text.replace(/\r\n|\r|\n/g,T)}n[E]={sortIndex:E,identifier:y.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:I,eolCount:d,firstLineLength:w,lastLineLength:b,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}n.sort(A.u);let o=!1;for(let E=0,y=n.length-1;E<y;E++){const $=n[E].range.getEndPosition(),I=n[E+1].range.getStartPosition();if(I.isBeforeOrEqual($)){if(I.isBefore($))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const h=p||v?A._getInverseEditRanges(n):[],t=[];if(v)for(let E=0;E<n.length;E++){const y=n[E],$=h[E];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let I=$.startLineNumber;I<=$.endLineNumber;I++){let d="";I===$.startLineNumber&&(d=this.getLineContent(y.range.startLineNumber),M.$5e(d)!==-1)||t.push({lineNumber:I,oldContent:d})}}let f=null;if(p){let E=0;f=[];for(let y=0;y<n.length;y++){const $=n[y],I=h[y],d=this.getValueInRange($.range),w=$.rangeOffset+E;E+=$.text.length-d.length,f[y]={sortIndex:$.sortIndex,identifier:$.identifier,range:I,text:d,textChange:new g.$it($.rangeOffset,d,w,$.text)}}o||f.sort((y,$)=>y.sortIndex-$.sortIndex)}this.g=s,this.h=a,this.j=r;const c=this.t(n);let u=null;if(v&&t.length>0){t.sort((E,y)=>y.lineNumber-E.lineNumber),u=[];for(let E=0,y=t.length;E<y;E++){const $=t[E].lineNumber;if(E>0&&t[E-1].lineNumber===$)continue;const I=t[E].oldContent,d=this.getLineContent($);d.length===0||d===I||M.$5e(d)!==-1||u.push($)}}return this.m.fire(),new N.$jv(f,c,u)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let v=!1;const p=l[0].range,s=l[l.length-1].range,a=new P.$Zs(p.startLineNumber,p.startColumn,s.endLineNumber,s.endColumn);let r=p.startLineNumber,i=p.startColumn;const n=[];for(let c=0,u=l.length;c<u;c++){const E=l[c],y=E.range;v=v||E.forceMoveMarkers,n.push(this.getValueInRange(new P.$Zs(r,i,y.startLineNumber,y.startColumn))),E.text.length>0&&n.push(E.text),r=y.endLineNumber,i=y.endColumn}const o=n.join(""),[h,t,f]=(0,m.$zt)(o);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:o,eolCount:h,firstLineLength:t,lastLineLength:f,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const v=[];for(let p=0;p<l.length;p++){const s=l[p],a=s.range.startLineNumber,r=s.range.startColumn,i=s.range.endLineNumber,n=s.range.endColumn;if(a===i&&r===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const o=new P.$Zs(a,r,i,n);v.push({range:o,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(l,v,p,s){return this.c.findMatchesLineByLine(l,v,p,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,v){const p=l.startLineNumber,s=l.startColumn,[a,r,i]=(0,m.$zt)(v);let n;if(v.length>0){const o=a+1;o===1?n=new P.$Zs(p,s,p,s+r):n=new P.$Zs(p,s,p+o-1,i+1)}else n=new P.$Zs(p,s,p,s);return n}static _getInverseEditRanges(l){const v=[];let p=0,s=0,a=null;for(let r=0,i=l.length;r<i;r++){const n=l[r];let o,h;a?a.range.endLineNumber===n.range.startLineNumber?(o=p,h=s+(n.range.startColumn-a.range.endColumn)):(o=p+(n.range.startLineNumber-a.range.endLineNumber),h=n.range.startColumn):(o=n.range.startLineNumber,h=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new P.$Zs(o,h,o,h+n.firstLineLength):t=new P.$Zs(o,h,o+f-1,n.lastLineLength+1)}else t=new P.$Zs(o,h,o,h);p=t.endLineNumber,s=t.endColumn,v.push(t),a=n}return v}static u(l,v){const p=P.$Zs.compareRangesUsingEnds(l.range,v.range);return p===0?l.sortIndex-v.sortIndex:p}static w(l,v){const p=P.$Zs.compareRangesUsingEnds(l.range,v.range);return p===0?v.sortIndex-l.sortIndex:-p}}e.$gC=A}),define(Le[145],Me([1,0,13,90,144]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=void 0;class N{constructor(g,D,A,k,l,v,p,s,a){this.a=g,this.b=D,this.c=A,this.d=k,this.e=l,this.f=v,this.g=p,this.h=s,this.j=a}k(g){const D=this.c+this.d+this.e,A=this.c+this.e;return D===0?g===1?`
`:`\r
`:A>D/2?`\r
`:`
`}create(g){const D=this.k(g),A=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let l=0,v=A.length;l<v;l++){const p=A[l].buffer.replace(/\r\n|\r|\n/g,D),s=(0,M.$bC)(p);A[l]=new M.$eC(p,s)}const k=new P.$gC(A,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&S.$Af(g)&&(this.b=S.$zf,g=g.substr(1));const D=g.charCodeAt(g.length-1);D===13||D>=55296&&D<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=D):(this.m(g,!1),this.c=!1,this.d=D)}m(g,D){!D&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const D=(0,M.$cC)(this.e,g);this.a.push(new M.$eC(g,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=S.$rf(g)),this.k||(this.k=S.$uf(g)))}finish(g=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const D=(0,M.$bC)(g.buffer);g.lineStarts=D,this.d===13&&this.f++}}}e.$hC=R}),define(Le[95],Me([1,0,23,20]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_=e.$d_=void 0;var P;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(P||(P={}));function N(k){for(let l=0,v=k.length;l<v;l+=4){const p=k[l+0],s=k[l+1],a=k[l+2],r=k[l+3];k[l+0]=r,k[l+1]=a,k[l+2]=s,k[l+3]=p}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||N(l),S.$me.wrap(l)}function m(k){const l=k.buffer;if(M.$D()||N(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const v=new Uint8Array(l.byteLength);return v.set(l),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function g(k){const l=new Uint32Array(D(k));let v=0;if(l[v++]=k.id,k.type==="full")l[v++]=1,l[v++]=k.data.length,l.set(k.data,v),v+=k.data.length;else{l[v++]=2,l[v++]=k.deltas.length;for(const p of k.deltas)l[v++]=p.start,l[v++]=p.deleteCount,p.data?(l[v++]=p.data.length,l.set(p.data,v),v+=p.data.length):l[v++]=0}return R(l)}e.$d_=g;function D(k){let l=0;if(l+=2,k.type==="full")l+=1+k.data.length;else{l+=1,l+=3*k.deltas.length;for(const v of k.deltas)v.data&&(l+=v.data.length)}return l}function A(k){const l=m(k);let v=0;const p=l[v++];if(l[v++]===1){const i=l[v++],n=l.subarray(v,v+i);return v+=i,{id:p,type:"full",data:n}}const a=l[v++],r=[];for(let i=0;i<a;i++){const n=l[v++],o=l[v++],h=l[v++];let t;h>0&&(t=l.subarray(v,v+h),v+=h),r[i]={start:n,deleteCount:o,data:t}}return{id:p,type:"delta",deltas:r}}e.$e_=A}),define(Le[146],Me([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Le[147],Me([1,0,18,26,20,130,148,146]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=D;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(_,pe,Ve,Ye){this.id=_,this.name=pe,this.defaultValue=Ve,this.schema=Ye}applyUpdate(_,pe){return v(_,pe)}compute(_,pe,Ve){return Ve}}class l{constructor(_,pe){this.newValue=_,this.didChange=pe}}e.ApplyUpdateResult=l;function v(Z,_){if(typeof Z!="object"||typeof _!="object"||!Z||!_)return new l(_,Z!==_);if(Array.isArray(Z)||Array.isArray(_)){const Ve=Array.isArray(Z)&&Array.isArray(_)&&S.$ub(Z,_);return new l(_,!Ve)}let pe=!1;for(const Ve in _)if(_.hasOwnProperty(Ve)){const Ye=v(Z[Ve],_[Ve]);Ye.didChange&&(Z[Ve]=Ye.newValue,pe=!0)}return new l(Z,pe)}class p{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,pe){return v(_,pe)}validate(_){return this.defaultValue}}class s{constructor(_,pe,Ve,Ye){this.id=_,this.name=pe,this.defaultValue=Ve,this.schema=Ye}applyUpdate(_,pe){return v(_,pe)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,pe,Ve){return Ve}}function a(Z,_){return typeof Z>"u"?_:Z==="false"?!1:!!Z}e.boolean=a;class r extends s{constructor(_,pe,Ve,Ye=void 0){typeof Ye<"u"&&(Ye.type="boolean",Ye.default=Ve),super(_,pe,Ve,Ye)}validate(_){return a(_,this.defaultValue)}}function i(Z,_,pe,Ve){if(typeof Z>"u")return _;let Ye=parseInt(Z,10);return isNaN(Ye)?_:(Ye=Math.max(pe,Ye),Ye=Math.min(Ve,Ye),Ye|0)}e.clampedInt=i;class n extends s{static clampedInt(_,pe,Ve,Ye){return i(_,pe,Ve,Ye)}constructor(_,pe,Ve,Ye,nt,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ve,st.minimum=Ye,st.maximum=nt),super(_,pe,Ve,st),this.minimum=Ye,this.maximum=nt}validate(_){return n.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function o(Z,_,pe,Ve){if(typeof Z>"u")return _;const Ye=h.float(Z,_);return h.clamp(Ye,pe,Ve)}e.clampedFloat=o;class h extends s{static clamp(_,pe,Ve){return _<pe?pe:_>Ve?Ve:_}static float(_,pe){if(typeof _=="number")return _;if(typeof _>"u")return pe;const Ve=parseFloat(_);return isNaN(Ve)?pe:Ve}constructor(_,pe,Ve,Ye,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(_,pe,Ve,nt),this.validationFn=Ye}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class t extends s{static string(_,pe){return typeof _!="string"?pe:_}constructor(_,pe,Ve,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.default=Ve),super(_,pe,Ve,Ye)}validate(_){return t.string(_,this.defaultValue)}}function f(Z,_,pe,Ve){return typeof Z!="string"?_:Ve&&Z in Ve?Ve[Z]:pe.indexOf(Z)===-1?_:Z}e.stringSet=f;class c extends s{constructor(_,pe,Ve,Ye,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ye,nt.default=Ve),super(_,pe,Ve,nt),this.c=Ye}validate(_){return f(_,this.defaultValue,this.c)}}class u extends k{constructor(_,pe,Ve,Ye,nt,st,Te=void 0){typeof Te<"u"&&(Te.type="string",Te.enum=nt,Te.default=Ye),super(_,pe,Ve,Te),this.c=nt,this.d=st}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function E(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class y extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,pe,Ve){return Ve===0?_.accessibilitySupport:Ve}}class $ extends k{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:m.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertSpace:a(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function d(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function b(Z){switch(Z){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function L(Z){switch(Z){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class T extends p{constructor(){super(140)}compute(_,pe,Ve){const Ye=["monaco-editor"];return pe.get(39)&&Ye.push(pe.get(39)),_.extraEditorClassName&&Ye.push(_.extraEditorClassName),pe.get(73)==="default"?Ye.push("mouse-default"):pe.get(73)==="copy"&&Ye.push("mouse-copy"),pe.get(110)&&Ye.push("showUnused"),pe.get(138)&&Ye.push("showDeprecated"),Ye.join(" ")}}class Y extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(_,pe,Ve){return Ve&&_.emptySelectionClipboard}}class q extends k{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:m.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:m.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{cursorMoveOnType:a(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":f(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":f(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(pe.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?U.OFF:_==="true"?U.ON:_:_?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?C.OFF:_==="true"?C.TRANSLATE:_:_?C.TRANSLATE:C.OFF}compute(_,pe,Ve){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class F extends p{constructor(){super(50)}compute(_,pe,Ve){return _.fontInfo}}class W extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(_){const pe=h.float(_,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(_,pe,Ve){return _.fontInfo.fontSize}}class re extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(n.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ue extends k{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Ve,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Ve,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Ve,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Ve,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Ve,description:m.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{multiple:f(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??f(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??f(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??f(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??f(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??f(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends k{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:m.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:a(pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(pe.above,this.defaultValue.above)}}}var ke;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class he extends p{constructor(){super(143)}compute(_,pe,Ve){return he.computeLayout(pe,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const pe=_.height/_.lineHeight,Ve=Math.floor(_.paddingTop/_.lineHeight);let Ye=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Ye=Math.max(Ye,pe-1));const nt=(Ve+_.viewLineCount+Ye)/(_.pixelRatio*_.height),st=Math.floor(_.viewLineCount/nt);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ye,desiredRatio:nt,minimapLineCount:st}}static c(_,pe){const Ve=_.outerWidth,Ye=_.outerHeight,nt=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ye};const st=pe.stableMinimapLayoutInput,Te=st&&_.outerHeight===st.outerHeight&&_.lineHeight===st.lineHeight&&_.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&_.pixelRatio===st.pixelRatio&&_.scrollBeyondLastLine===st.scrollBeyondLastLine&&_.paddingTop===st.paddingTop&&_.paddingBottom===st.paddingBottom&&_.minimap.enabled===st.minimap.enabled&&_.minimap.side===st.minimap.side&&_.minimap.size===st.minimap.size&&_.minimap.showSlider===st.minimap.showSlider&&_.minimap.renderCharacters===st.minimap.renderCharacters&&_.minimap.maxColumn===st.minimap.maxColumn&&_.minimap.scale===st.minimap.scale&&_.verticalScrollbarWidth===st.verticalScrollbarWidth&&_.isViewportWrapping===st.isViewportWrapping,Nt=_.lineHeight,Qt=_.typicalHalfwidthCharacterWidth,ei=_.scrollBeyondLastLine,Ut=_.minimap.renderCharacters;let Et=nt>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const ti=_.minimap.maxColumn,jt=_.minimap.size,si=_.minimap.side,Zt=_.verticalScrollbarWidth,Xt=_.viewLineCount,Xe=_.remainingWidth,Bt=_.isViewportWrapping,ii=Ut?2:3;let ht=Math.floor(nt*Ye);const mt=ht/nt;let Kt=!1,ni=!1,Ct=ii*Et,dt=Et/nt,At=1;if(jt==="fill"||jt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Rt,desiredRatio:Tt,minimapLineCount:Wt}=he.computeContainedMinimapLineCount({viewLineCount:Xt,scrollBeyondLastLine:ei,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Ye,lineHeight:Nt,pixelRatio:nt});if(Xt/Wt>1)Kt=!0,ni=!0,Et=1,Ct=1,dt=Et/nt;else{let kt=!1,Vt=Et+1;if(jt==="fit"){const yt=Math.ceil((Ft+Xt+Rt)*Ct);Bt&&Te&&Xe<=pe.stableFitRemainingWidth?(kt=!0,Vt=pe.stableFitMaxMinimapScale):kt=yt>ht}if(jt==="fill"||kt){Kt=!0;const yt=Et;Ct=Math.min(Nt*nt,Math.max(1,Math.floor(1/Tt))),Bt&&Te&&Xe<=pe.stableFitRemainingWidth&&(Vt=pe.stableFitMaxMinimapScale),Et=Math.min(Vt,Math.max(1,Math.floor(Ct/ii))),Et>yt&&(At=Math.min(2,Et/yt)),dt=Et/nt/At,ht=Math.ceil(Math.max(ft,Ft+Xt+Rt)*Ct),Bt?(pe.stableMinimapLayoutInput=_,pe.stableFitRemainingWidth=Xe,pe.stableFitMaxMinimapScale=Et):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const oi=Math.floor(ti*dt),Lt=Math.min(oi,Math.max(0,Math.floor((Xe-Zt-2)*dt/(Qt+dt)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(nt*Lt);const Gt=He/nt;He=Math.floor(He*At);const Jt=Ut?1:2,_t=si==="left"?0:Ve-Lt-Zt;return{renderMinimap:Jt,minimapLeft:_t,minimapWidth:Lt,minimapHeightIsEditorHeight:Kt,minimapIsSampling:ni,minimapScale:Et,minimapLineHeight:Ct,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Gt,minimapCanvasOuterHeight:mt}}static computeLayout(_,pe){const Ve=pe.outerWidth|0,Ye=pe.outerHeight|0,nt=pe.lineHeight|0,st=pe.lineNumbersDigitCount|0,Te=pe.typicalHalfwidthCharacterWidth,Nt=pe.maxDigitWidth,Qt=pe.pixelRatio,ei=pe.viewLineCount,Ut=_.get(135),Et=Ut==="inherit"?_.get(134):Ut,ti=Et==="inherit"?_.get(130):Et,jt=_.get(133),si=pe.isDominatedByLongLines,Zt=_.get(57),Xt=_.get(67).renderType!==0,Xe=_.get(68),Bt=_.get(104),ii=_.get(83),ht=_.get(72),mt=_.get(102),Kt=mt.verticalScrollbarSize,ni=mt.verticalHasArrows,Ct=mt.arrowSize,dt=mt.horizontalScrollbarSize,At=_.get(43),oi=_.get(109)!=="never";let Lt=_.get(65);At&&oi&&(Lt+=16);let He=0;if(Xt){const St=Math.max(st,Xe);He=Math.round(St*Nt)}let Gt=0;Zt&&(Gt=nt*pe.glyphMarginDecorationLaneCount);let Jt=0,_t=Jt+Gt,ft=_t+He,Ft=ft+Lt;const Rt=Ve-Gt-He-Lt;let Tt=!1,Wt=!1,Ot=-1;Et==="inherit"&&si?(Tt=!0,Wt=!0):ti==="on"||ti==="bounded"?Wt=!0:ti==="wordWrapColumn"&&(Ot=jt);const kt=he.c({outerWidth:Ve,outerHeight:Ye,lineHeight:nt,typicalHalfwidthCharacterWidth:Te,pixelRatio:Qt,scrollBeyondLastLine:Bt,paddingTop:ii.top,paddingBottom:ii.bottom,minimap:ht,verticalScrollbarWidth:Kt,viewLineCount:ei,remainingWidth:Rt,isViewportWrapping:Wt},pe.memory||new A);kt.renderMinimap!==0&&kt.minimapLeft===0&&(Jt+=kt.minimapWidth,_t+=kt.minimapWidth,ft+=kt.minimapWidth,Ft+=kt.minimapWidth);const Vt=Rt-kt.minimapWidth,yt=Math.max(1,Math.floor((Vt-Kt-2)/Te)),bt=ni?Ct:0;return Wt&&(Ot=Math.max(1,yt),ti==="bounded"&&(Ot=Math.min(Ot,jt))),{width:Ve,height:Ye,glyphMarginLeft:Jt,glyphMarginWidth:Gt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:_t,lineNumbersWidth:He,decorationsLeft:ft,decorationsWidth:Lt,contentLeft:Ft,contentWidth:Vt,minimap:kt,viewportColumn:yt,isWordWrapMinified:Tt,isViewportWrapping:Wt,wrappingColumn:Ot,verticalScrollbarWidth:Kt,horizontalScrollbarHeight:dt,overviewRuler:{top:bt,width:Kt,height:Ye-2*bt,right:0}}}}e.EditorLayoutInfoComputer=he;class ve extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(_){return f(_,"simple",["simple","advanced"])}compute(_,pe,Ve){return pe.get(2)===2?"advanced":Ve}}var se;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class $e extends k{constructor(){const _={enabled:se.OnCode};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:_.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:f(_.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class te extends k{constructor(){const _={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:m.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:f(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class X extends k{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:m.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:f(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:a(pe.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):n.clampedInt(_,this.defaultValue,0,1e3)}compute(_,pe,Ve){return Ve<0?n.clampedInt(-Ve*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:m.localize(66,null)})}compute(_,pe,Ve){return _.fontInfo.lineHeight}}class Ce extends k{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:_.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:m.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),autohide:a(pe.autohide,this.defaultValue.autohide),size:f(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(pe.side,this.defaultValue.side,["right","left"]),showSlider:f(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(pe.scale,1,1,3),maxColumn:n.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Fe(Z){return Z==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Pe extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{top:n.clampedInt(pe.top,0,0,1e3),bottom:n.clampedInt(pe.bottom,0,0,1e3)}}}class we extends k{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:m.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),cycle:a(pe.cycle,this.defaultValue.cycle)}}}class me extends p{constructor(){super(141)}compute(_,pe,Ve){return _.pixelRatio}}class J extends k{constructor(){const _={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:_.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:_.comments,description:m.localize(86,null)},other:{anyOf:pe,default:_.other,description:m.localize(87,null)}},default:_,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Qt=_?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!_||typeof _!="object")return this.defaultValue;const{other:pe,comments:Ve,strings:Ye}=_,nt=["on","inline","off"];let st,Te,Nt;return typeof pe=="boolean"?st=pe?"on":"off":st=f(pe,this.defaultValue.other,nt),typeof Ve=="boolean"?Te=Ve?"on":"off":Te=f(Ve,this.defaultValue.comments,nt),typeof Ye=="boolean"?Nt=Ye?"on":"off":Nt=f(Ye,this.defaultValue.strings,nt),{other:st,comments:Te,strings:Nt}}}var x;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(_){let pe=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(pe=4,Ve=_):_==="interval"?pe=3:_==="relative"?pe=2:_==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ve}}}function de(Z){const _=Z.get(97);return _==="editable"?Z.get(90):_!=="on"}e.filterValidationDecorations=de;class Ae extends k{constructor(){const _=[],pe={type:"number",description:m.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:_,description:m.localize(96,null)})}validate(_){if(Array.isArray(_)){const pe=[];for(const Ve of _)if(typeof Ve=="number")pe.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ye=Ve;pe.push({column:n.clampedInt(Ye.column,0,0,1e4),color:Ye.color})}return pe.sort((Ve,Ye)=>Ve.column-Ye.column),pe}return this.defaultValue}}class ge extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function Se(Z,_){if(typeof Z!="string")return _;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends k{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_,Ve=n.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ye=n.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(pe.vertical,this.defaultValue.vertical),horizontal:Se(pe.horizontal,this.defaultValue.horizontal),useShadows:a(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(pe.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ye,verticalSliderSize:n.clampedInt(pe.verticalSliderSize,Ye,0,1e3),scrollByPage:a(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends k{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:m.localize(115,null)}})}applyUpdate(_,pe){let Ve=!1;pe.allowedCharacters&&_&&(M.$Fn(_.allowedCharacters,pe.allowedCharacters)||(_={..._,allowedCharacters:pe.allowedCharacters},Ve=!0)),pe.allowedLocales&&_&&(M.$Fn(_.allowedLocales,pe.allowedLocales)||(_={..._,allowedLocales:pe.allowedLocales},Ve=!0));const Ye=super.applyUpdate(_,pe);return Ve?new l(Ye.newValue,!0):Ye}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{nonBasicASCII:Q(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Q(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Q(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,pe){if(typeof _!="object"||!_)return pe;const Ve={};for(const[Ye,nt]of Object.entries(_))nt===!0&&(Ve[Ye]=!0);return Ve}}class G extends k{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:_.fontFamily,description:m.localize(122,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),mode:f(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class B extends k{constructor(){const _={enabled:N.$xs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$xs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:_.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:_.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:_.highlightActiveIndentation,description:m.localize(138,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{bracketPairs:Q(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Q(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Q(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Q(Z,_,pe){const Ve=pe.indexOf(Z);return Ve===-1?_:pe[Ve]}class ae extends k{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:_.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:_.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertMode:f(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(pe.showIcons,this.defaultValue.showIcons),showStatusBar:a(pe.showStatusBar,this.defaultValue.showStatusBar),preview:a(pe.preview,this.defaultValue.preview),previewMode:f(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(pe.showMethods,this.defaultValue.showMethods),showFunctions:a(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:a(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(pe.showFields,this.defaultValue.showFields),showVariables:a(pe.showVariables,this.defaultValue.showVariables),showClasses:a(pe.showClasses,this.defaultValue.showClasses),showStructs:a(pe.showStructs,this.defaultValue.showStructs),showInterfaces:a(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:a(pe.showModules,this.defaultValue.showModules),showProperties:a(pe.showProperties,this.defaultValue.showProperties),showEvents:a(pe.showEvents,this.defaultValue.showEvents),showOperators:a(pe.showOperators,this.defaultValue.showOperators),showUnits:a(pe.showUnits,this.defaultValue.showUnits),showValues:a(pe.showValues,this.defaultValue.showValues),showConstants:a(pe.showConstants,this.defaultValue.showConstants),showEnums:a(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:a(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(pe.showKeywords,this.defaultValue.showKeywords),showWords:a(pe.showWords,this.defaultValue.showWords),showColors:a(pe.showColors,this.defaultValue.showColors),showFiles:a(pe.showFiles,this.defaultValue.showFiles),showReferences:a(pe.showReferences,this.defaultValue.showReferences),showFolders:a(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:a(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(pe.showSnippets,this.defaultValue.showSnippets),showUsers:a(pe.showUsers,this.defaultValue.showUsers),showIssues:a(pe.showIssues,this.defaultValue.showIssues)}}}class Ee extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(_.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class We extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,pe,Ve){return pe.get(2)===2?0:Ve}}class Qe extends p{constructor(){super(144)}compute(_,pe,Ve){const Ye=pe.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Ye.isWordWrapMinified,isViewportWrapping:Ye.isViewportWrapping,wrappingColumn:Ye.wrappingColumn}}}class xe extends k{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),showDropSelector:f(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ct extends k{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:a(pe.enabled,this.defaultValue.enabled),showPasteSelector:f(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ut="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?et:P.$k?ut:rt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var pt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.letterSpacing=63]="letterSpacing",Z[Z.lightbulb=64]="lightbulb",Z[Z.lineDecorationsWidth=65]="lineDecorationsWidth",Z[Z.lineHeight=66]="lineHeight",Z[Z.lineNumbers=67]="lineNumbers",Z[Z.lineNumbersMinChars=68]="lineNumbersMinChars",Z[Z.linkedEditing=69]="linkedEditing",Z[Z.links=70]="links",Z[Z.matchBrackets=71]="matchBrackets",Z[Z.minimap=72]="minimap",Z[Z.mouseStyle=73]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=75]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=77]="multiCursorModifier",Z[Z.multiCursorPaste=78]="multiCursorPaste",Z[Z.multiCursorLimit=79]="multiCursorLimit",Z[Z.occurrencesHighlight=80]="occurrencesHighlight",Z[Z.overviewRulerBorder=81]="overviewRulerBorder",Z[Z.overviewRulerLanes=82]="overviewRulerLanes",Z[Z.padding=83]="padding",Z[Z.pasteAs=84]="pasteAs",Z[Z.parameterHints=85]="parameterHints",Z[Z.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=88]="quickSuggestions",Z[Z.quickSuggestionsDelay=89]="quickSuggestionsDelay",Z[Z.readOnly=90]="readOnly",Z[Z.readOnlyMessage=91]="readOnlyMessage",Z[Z.renameOnType=92]="renameOnType",Z[Z.renderControlCharacters=93]="renderControlCharacters",Z[Z.renderFinalNewline=94]="renderFinalNewline",Z[Z.renderLineHighlight=95]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=97]="renderValidationDecorations",Z[Z.renderWhitespace=98]="renderWhitespace",Z[Z.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Z[Z.roundedSelection=100]="roundedSelection",Z[Z.rulers=101]="rulers",Z[Z.scrollbar=102]="scrollbar",Z[Z.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=104]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=105]="scrollPredominantAxis",Z[Z.selectionClipboard=106]="selectionClipboard",Z[Z.selectionHighlight=107]="selectionHighlight",Z[Z.selectOnLineNumbers=108]="selectOnLineNumbers",Z[Z.showFoldingControls=109]="showFoldingControls",Z[Z.showUnused=110]="showUnused",Z[Z.snippetSuggestions=111]="snippetSuggestions",Z[Z.smartSelect=112]="smartSelect",Z[Z.smoothScrolling=113]="smoothScrolling",Z[Z.stickyScroll=114]="stickyScroll",Z[Z.stickyTabStops=115]="stickyTabStops",Z[Z.stopRenderingLineAfter=116]="stopRenderingLineAfter",Z[Z.suggest=117]="suggest",Z[Z.suggestFontSize=118]="suggestFontSize",Z[Z.suggestLineHeight=119]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Z[Z.suggestSelection=121]="suggestSelection",Z[Z.tabCompletion=122]="tabCompletion",Z[Z.tabIndex=123]="tabIndex",Z[Z.unicodeHighlighting=124]="unicodeHighlighting",Z[Z.unusualLineTerminators=125]="unusualLineTerminators",Z[Z.useShadowDOM=126]="useShadowDOM",Z[Z.useTabStops=127]="useTabStops",Z[Z.wordBreak=128]="wordBreak",Z[Z.wordSeparators=129]="wordSeparators",Z[Z.wordWrap=130]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=133]="wordWrapColumn",Z[Z.wordWrapOverride1=134]="wordWrapOverride1",Z[Z.wordWrapOverride2=135]="wordWrapOverride2",Z[Z.wrappingIndent=136]="wrappingIndent",Z[Z.wrappingStrategy=137]="wrappingStrategy",Z[Z.showDeprecated=138]="showDeprecated",Z[Z.inlayHints=139]="inlayHints",Z[Z.editorClassName=140]="editorClassName",Z[Z.pixelRatio=141]="pixelRatio",Z[Z.tabFocusMode=142]="tabFocusMode",Z[Z.layoutInfo=143]="layoutInfo",Z[Z.wrappingInfo=144]="wrappingInfo",Z[Z.defaultColorDecorators=145]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(pt||(e.EditorOption=pt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:Ue(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:Ue(new y),accessibilityPageSize:Ue(new n(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:Ue(new t(4,"ariaLabel",m.localize(206,null))),ariaRequired:Ue(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:Ue(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:Ue(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:Ue(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:Ue(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:Ue(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:Ue(new r(13,"automaticLayout",!1)),autoSurround:Ue(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:Ue(new B),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new r(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:Ue(new r(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:Ue(new t(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:Ue(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:Ue(new r(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:Ue(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:Ue(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:Ue(new r(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:Ue(new $),contextmenu:Ue(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new r(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:Ue(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:Ue(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:Ue(new u(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:m.localize(248,null)})),cursorSurroundingLines:Ue(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:Ue(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:Ue(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:Ue(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new r(34,"domReadOnly",!1)),dragAndDrop:Ue(new r(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:Ue(new Y),dropIntoEditor:Ue(new xe),stickyScroll:Ue(new te),experimentalWhitespaceRendering:Ue(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:Ue(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:m.localize(259,null)})),find:Ue(new q),fixedOverflowWidgets:Ue(new r(42,"fixedOverflowWidgets",!1)),folding:Ue(new r(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:Ue(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:Ue(new r(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:Ue(new r(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:Ue(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:Ue(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:Ue(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:Ue(new F),fontLigatures2:Ue(new U),fontSize:Ue(new W),fontWeight:Ue(new re),fontVariations:Ue(new C),formatOnPaste:Ue(new r(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:Ue(new r(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:Ue(new r(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:Ue(new ue),hideCursorInOverviewRuler:Ue(new r(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:Ue(new ye),inDiffEditor:Ue(new r(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:m.localize(273,null)})),lightbulb:Ue(new $e),lineDecorationsWidth:Ue(new V),lineHeight:Ue(new ne),lineNumbers:Ue(new le),lineNumbersMinChars:Ue(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new r(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:Ue(new r(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:Ue(new c(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:Ue(new Ce),mouseStyle:Ue(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(74,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:Ue(new r(75,"mouseWheelZoom",!1,{markdownDescription:P.$j?m.localize(278,null):m.localize(279,null)})),multiCursorMergeOverlapping:Ue(new r(76,"multiCursorMergeOverlapping",!0,{description:m.localize(280,null)})),multiCursorModifier:Ue(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[m.localize(281,null),m.localize(282,null)],markdownDescription:m.localize(283,null)})),multiCursorPaste:Ue(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(284,null),m.localize(285,null)],markdownDescription:m.localize(286,null)})),multiCursorLimit:Ue(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(287,null)})),occurrencesHighlight:Ue(new c(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null),m.localize(290,null)],markdownDescription:m.localize(291,null)})),overviewRulerBorder:Ue(new r(81,"overviewRulerBorder",!0,{description:m.localize(292,null)})),overviewRulerLanes:Ue(new n(82,"overviewRulerLanes",3,0,3)),padding:Ue(new Pe),pasteAs:Ue(new ct),parameterHints:Ue(new we),peekWidgetDefaultFocus:Ue(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(293,null),m.localize(294,null)],description:m.localize(295,null)})),definitionLinkOpensInPeek:Ue(new r(87,"definitionLinkOpensInPeek",!1,{description:m.localize(296,null)})),quickSuggestions:Ue(new J),quickSuggestionsDelay:Ue(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(297,null)})),readOnly:Ue(new r(90,"readOnly",!1)),readOnlyMessage:Ue(new ge),renameOnType:Ue(new r(92,"renameOnType",!1,{description:m.localize(298,null),markdownDeprecationMessage:m.localize(299,null)})),renderControlCharacters:Ue(new r(93,"renderControlCharacters",!0,{description:m.localize(300,null),restricted:!0})),renderFinalNewline:Ue(new c(94,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(301,null)})),renderLineHighlight:Ue(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(302,null)],description:m.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Ue(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(304,null)})),renderValidationDecorations:Ue(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(305,null),m.localize(306,null),m.localize(307,null),""],description:m.localize(308,null)})),revealHorizontalRightPadding:Ue(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new r(100,"roundedSelection",!0,{description:m.localize(309,null)})),rulers:Ue(new Ae),scrollbar:Ue(new Ie),scrollBeyondLastColumn:Ue(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(310,null)})),scrollBeyondLastLine:Ue(new r(104,"scrollBeyondLastLine",!0,{description:m.localize(311,null)})),scrollPredominantAxis:Ue(new r(105,"scrollPredominantAxis",!0,{description:m.localize(312,null)})),selectionClipboard:Ue(new r(106,"selectionClipboard",!0,{description:m.localize(313,null),included:P.$k})),selectionHighlight:Ue(new r(107,"selectionHighlight",!0,{description:m.localize(314,null)})),selectOnLineNumbers:Ue(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),showUnused:Ue(new r(110,"showUnused",!0,{description:m.localize(319,null)})),showDeprecated:Ue(new r(138,"showDeprecated",!0,{description:m.localize(320,null)})),inlayHints:Ue(new X),snippetSuggestions:Ue(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),smartSelect:Ue(new Ee),smoothScrolling:Ue(new r(113,"smoothScrolling",!1,{description:m.localize(326,null)})),stopRenderingLineAfter:Ue(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new ae),inlineSuggest:Ue(new G),inlineCompletionsAccessibilityVerbose:Ue(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(327,null)})),suggestFontSize:Ue(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new r(120,"suggestOnTriggerCharacters",!0,{description:m.localize(330,null)})),suggestSelection:Ue(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(331,null),m.localize(332,null),m.localize(333,null)],description:m.localize(334,null)})),tabCompletion:Ue(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(335,null),m.localize(336,null),m.localize(337,null)],description:m.localize(338,null)})),tabIndex:Ue(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new O),unusualLineTerminators:Ue(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),useShadowDOM:Ue(new r(126,"useShadowDOM",!0)),useTabStops:Ue(new r(127,"useTabStops",!0,{description:m.localize(343,null)})),wordBreak:Ue(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),wordSeparators:Ue(new t(129,"wordSeparators",R.$ys,{description:m.localize(347,null)})),wordWrap:Ue(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(348,null),m.localize(349,null),m.localize(350,null),m.localize(351,null)],description:m.localize(352,null)})),wordWrapBreakAfterCharacters:Ue(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(353,null)})),wordWrapOverride1:Ue(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new T),defaultColorDecorators:Ue(new r(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(354,null)})),pixelRatio:Ue(new me),tabFocusMode:Ue(new r(142,"tabFocusMode",!1,{markdownDescription:m.localize(355,null)})),layoutInfo:Ue(new he),wrappingInfo:Ue(new Qe),wrappingIndent:Ue(new We),wrappingStrategy:Ue(new ve)}}),define(Le[149],Me([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Le[150],Me([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Le[151],Me([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Le[152],Me([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Le[153],Me([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Le[154],Me([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Le[155],Me([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Le[156],Me([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Le[157],Me([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Le[158],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Le[159],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Le[160],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Le[161],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Le[162],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Le[163],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Le[164],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Le[165],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Le[166],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Le[167],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Le[168],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Le[169],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Le[170],Me([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Le[171],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Le[172],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Le[173],Me([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Le[174],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Le[175],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Le[176],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Le[177],Me([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Le[178],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Le[179],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Le[180],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Le[181],Me([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Le[182],Me([1,0,15,151]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.TokenType=void 0;var P;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(P||(e.TokenType=P={}));function N(...D){switch(D.length){case 1:return(0,M.localize)(0,null,D[0]);case 2:return(0,M.localize)(1,null,D[0],D[1]);case 3:return(0,M.localize)(2,null,D[0],D[1],D[2]);default:return}}const R=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,l=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),l=g.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(m);return}const p=this.c.charCodeAt(A);if(k)k=!1;else if(p===47&&!l){A++;break}else p===91?l=!0:p===92?k=!0:p===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$6i=g}),define(Le[183],Me([1,0,24,32,153,297]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(r){return r=r.trim(),r==="*"||R.test(r)}e.$fp=g;function D(r){if(!g(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=r.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$gp=D;function A(r){if(!r)return null;const i=r.majorBase,n=r.majorMustEqual,o=r.minorBase;let h=r.minorMustEqual;const t=r.patchBase;let f=r.patchMustEqual;r.hasCaret&&(i===0||(h=!1),f=!1);let c=0;if(r.preRelease){const u=m.exec(r.preRelease);if(u){const[,E,y,$]=u;c=Date.UTC(Number(E),Number(y)-1,Number($))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:h,patchBase:t,patchMustEqual:f,isMinimum:r.hasGreaterEquals,notBefore:c}}e.$hp=A;function k(r,i,n){let o;typeof r=="string"?o=A(D(r)):o=r;let h;i instanceof Date?h=i.getTime():typeof i=="string"&&(h=new Date(i).getTime());let t;if(typeof n=="string"?t=A(D(n)):t=n,!o||!t)return!1;const f=o.majorBase,c=o.minorBase,u=o.patchBase;let E=t.majorBase,y=t.minorBase,$=t.patchBase;const I=t.notBefore;let d=t.majorMustEqual,w=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?f>E?!0:f<E?!1:c>y?!0:c<y||h&&h<I?!1:u>=$:(f===1&&E===0&&(!d||!w||!b)&&(E=1,y=0,$=0,d=!0,w=!1,b=!1),f<E?!1:f>E?!d:c<y?!1:c>y?!w:u<$?!1:u>$?!b:!(h&&h<I))}e.$ip=k;function l(r,i,n,o,h){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([M.default.Error,P.localize(0,null)]),t;if(typeof o.name!="string")return t.push([M.default.Error,P.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([M.default.Error,P.localize(2,null,"version")]),t;if(!o.engines)return t.push([M.default.Error,P.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([M.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!a(o.extensionDependencies))return t.push([M.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!a(o.activationEvents))return t.push([M.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([M.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([M.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([M.default.Error,P.localize(9,null,"main")]),t;{const u=(0,S.$Lg)(n,o.main);(0,S.$Fg)(u,n)||t.push([M.default.Warning,P.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([M.default.Error,P.localize(11,null,"browser")]),t;{const u=(0,S.$Lg)(n,o.browser);(0,S.$Fg)(u,n)||t.push([M.default.Warning,P.localize(12,null,u.path,n.path)])}}if(!N.valid(o.version))return t.push([M.default.Error,P.localize(13,null)]),t;const f=[];if(!v(r,i,o,h,f))for(const u of f)t.push([M.default.Error,u]);return t}e.$jp=l;function v(r,i,n,o,h){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(r,i,n.engines.vscode,h)}e.$kp=v;function p(r,i,n){return r==="*"||s(i,n,r)}e.$lp=p;function s(r,i,n,o=[]){const h=A(D(n));if(!h)return o.push(P.localize(14,null,n)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return o.push(P.localize(15,null,n)),!1}else if(!h.majorMustEqual)return o.push(P.localize(16,null,n)),!1;return k(r,i,h)?!0:(o.push(P.localize(17,null,r,n)),!1)}function a(r){if(!Array.isArray(r))return!1;for(let i=0,n=r.length;i<n;i++)if(typeof r[i]!="string")return!1;return!0}}),define(Le[70],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=void 0;class S{constructor(P,N=[],R=!1){this.ctor=P,this.staticArguments=N,this.supportsDelayedInstantiation=R}}e.$8h=S}),define(Le[53],Me([1,0,70]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=e.InstantiationType=void 0;const M=[];var P;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function N(m,g,D){g instanceof S.$8h||(g=new S.$8h(g,[],!!D)),M.push([m,g])}e.$4r=N;function R(){return M}e.$5r=R}),define(Le[184],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=void 0;class S{constructor(N,R){this.key=N,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Hq=S;class M{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const R of this.a.values())R.outgoing.size===0&&N.push(R);return N}insertEdge(N,R){const m=this.lookupOrInsertNode(N),g=this.lookupOrInsertNode(R);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(N){const R=this.b(N);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(N){const R=this.b(N);let m=this.a.get(R);return m||(m=new S(R,N),this.a.set(R,m)),m}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[R,m]of this.a)N.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,R]of this.a){const m=new Set([N]),g=this.c(R,m);if(g)return g}}c(N,R){for(const[m,g]of N.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const D=this.c(g,R);if(D)return D;R.delete(m)}}}e.$Iq=M}),define(Le[4],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(S||(e._util=S={})),e.$0h=P("instantiationService");function M(R,m,g){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:R,index:g}):(m[S.DI_DEPENDENCIES]=[{id:R,index:g}],m[S.DI_TARGET]=m)}function P(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const m=function(g,D,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,g,A)};return m.toString=()=>R,S.serviceIds.set(R,m),m}e.$$h=P;function N(R){return R}e.$_h=N}),define(Le[47],Me([1,0,16,2,4]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ConfigurationTarget=e.$Gi=e.$Fi=e.$Ei=void 0,e.$Ei=(0,P.$$h)("configurationService");function N(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof M.URI)}e.$Fi=N;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof M.URI)}e.$Gi=R;var m;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Hi=g;function D(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Ii=D;function A(r,i){const n=Object.create(null);for(const o in r)k(n,o,r[o],i);return n}e.$Ji=A;function k(r,i,n,o){const h=i.split("."),t=h.pop();let f=r;for(let c=0;c<h.length;c++){const u=h[c];let E=f[u];switch(typeof E){case"undefined":E=f[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${h.slice(0,c+1).join(".")} is ${JSON.stringify(E)}`);return}f=E}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{o(`Ignoring ${i} as ${h.join(".")} is ${JSON.stringify(f)}`)}else o(`Ignoring ${i} as ${h.join(".")} is ${JSON.stringify(f)}`)}e.$Ki=k;function l(r,i){const n=i.split(".");v(r,n)}e.$Li=l;function v(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const o=r[n];typeof o=="object"&&!Array.isArray(o)&&(v(o,i),Object.keys(o).length===0&&delete r[n])}}function p(r,i,n){function o(f,c){let u=f;for(const E of c){if(typeof u!="object"||u===null)return;u=u[E]}return u}const h=i.split("."),t=o(r,h);return typeof t>"u"?n:t}e.$Mi=p;function s(r,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in r?S.$Of(r[o])&&S.$Of(i[o])?s(r[o],i[o],n):n&&(r[o]=i[o]):r[o]=i[o])})}e.$Ni=s;function a(r){return r.replace(/[\[\]]/g,"")}e.$Oi=a}),define(Le[35],Me([1,0,20,13,182,4,150,15]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.ContextKeyExprType=e.$7i=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",S.$j),g.set("isLinux",S.$k),g.set("isWindows",S.$i),g.set("isWeb",S.$o),g.set("isMacNative",S.$j&&!S.$o),g.set("isEdge",S.$H),g.set("isFirefox",S.$F),g.set("isChrome",S.$E),g.set("isSafari",S.$G);function D(X,V){if(g.get(X)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(X,V)}e.$7i=D;const A=Object.prototype.hasOwnProperty;var k;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),p=(0,R.localize)(1,null),s=(0,R.localize)(2,null),a=(0,R.localize)(3,null),r=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new P.$6i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ce=this.D(),Fe=Ce.type===17?i:void 0;throw this.h.push({message:r,offset:Ce.offset,lexeme:P.$6i.getLexeme(Ce),additionalInfo:Fe}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),y.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,a),ne?.negate()}case 17:return this.z(),L.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,a),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const Pe=Fe.lexeme,we=Pe.lastIndexOf("/"),me=we===Pe.length-1?void 0:this.w(Pe.substring(we+1));let J;try{J=new RegExp(Pe.substring(1,we),me)}catch{throw this.B("REGEX",Fe)}return F.create(ne,J)}switch(Fe.type){case 10:case 19:{const Pe=[Fe.lexeme];this.z();let we=this.D(),me=0;for(let Ae=0;Ae<Fe.lexeme.length;Ae++)Fe.lexeme.charCodeAt(Ae)===40?me++:Fe.lexeme.charCodeAt(Ae)===41&&me--;for(;!this.E()&&we.type!==15&&we.type!==16;){switch(we.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Ae=0;Ae<we.lexeme.length;Ae++)we.lexeme.charCodeAt(Ae)===40?me++:Fe.lexeme.charCodeAt(Ae)===41&&me--}if(me<0)break;Pe.push(P.$6i.getLexeme(we)),this.z(),we=this.D()}const J=Pe.join(""),x=J.lastIndexOf("/"),le=x===J.length-1?void 0:this.w(J.substring(x+1));let de;try{de=new RegExp(J.substring(1,x),le)}catch{throw this.B("REGEX",Fe)}return t.regex(ne,de)}case 18:{const Pe=Fe.lexeme;this.z();let we=null;if(!(0,M.$Me)(Pe)){const me=Pe.indexOf("/"),J=Pe.lastIndexOf("/");if(me!==J&&me>=0){const x=Pe.slice(me+1,J),le=Pe[J+1]==="i"?"i":"";try{we=new RegExp(x,le)}catch{throw this.B("REGEX",Fe)}}}if(we===null)throw this.B("REGEX",Fe);return F.create(ne,we)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Fe=this.u();return t.notIn(ne,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return t.equals(ne,Fe);switch(Fe){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return t.notEquals(ne,Fe);switch(Fe){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Fe)}}case 5:return this.z(),U.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),Y.create(ne,this.u());case 8:return this.z(),q.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:V.offset,lexeme:"",additionalInfo:o}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ce){const Fe=(0,R.localize)(8,null,V,P.$6i.getLexeme(ne)),Pe=ne.offset,we=P.$6i.getLexeme(ne);return this.h.push({message:Fe,offset:Pe,lexeme:we,additionalInfo:Ce}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$8i=h;class t{static false(){return E.INSTANCE}static true(){return y.INSTANCE}static has(V){return $.create(V)}static equals(V,ne){return I.create(V,ne)}static notEquals(V,ne){return b.create(V,ne)}static regex(V,ne){return F.create(V,ne)}static in(V,ne){return d.create(V,ne)}static notIn(V,ne){return w.create(V,ne)}static not(V){return L.create(V)}static and(...V){return ue.create(V,null,!0)}static or(...V){return ye.create(V,null,!0)}static greater(V,ne){return Y.create(V,ne)}static greaterEquals(V,ne){return q.create(V,ne)}static smaller(V,ne){return U.create(V,ne)}static smallerEquals(V,ne){return C.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$9i=t;function f(X){const V=new h({regexParsingWithErrorRecovery:!1});return X.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?(0,R.localize)(9,null,Ce.additionalInfo):(0,R.localize)(10,null),offset:Ce.offset,length:Ce.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?`${Ce.message}. ${Ce.additionalInfo}`:Ce.message,offset:Ce.offset,length:Ce.lexeme.length})):[]))}e.$0i=f;function c(X,V){const ne=X?X.substituteConstants():void 0,Ce=V?V.substituteConstants():void 0;return!ne&&!Ce?!0:!ne||!Ce?!1:ne.equals(Ce)}e.$$i=c;function u(X,V){return X.cmp(V)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return y.INSTANCE}}e.$_i=E;class y{static{this.INSTANCE=new y}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return E.INSTANCE}}e.$aj=y;class ${static create(V,ne=null){const Ce=g.get(V);return typeof Ce=="boolean"?Ce?y.INSTANCE:E.INSTANCE:new $(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:he(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?y.INSTANCE:E.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$bj=$;class I{static create(V,ne,Ce=null){if(typeof ne=="boolean")return ne?$.create(V,Ce):L.create(V,Ce);const Fe=g.get(V);return typeof Fe=="boolean"?ne===(Fe?"true":"false")?y.INSTANCE:E.INSTANCE:new I(V,ne,Ce)}constructor(V,ne,Ce){this.c=V,this.d=ne,this.f=Ce,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?y.INSTANCE:E.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$cj=I;class d{static create(V,ne){return new d(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ce=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ce):typeof Ce=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Ce):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$dj=d;class w{static create(V,ne){return new w(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=d.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$ej=w;class b{static create(V,ne,Ce=null){if(typeof ne=="boolean")return ne?L.create(V,Ce):$.create(V,Ce);const Fe=g.get(V);return typeof Fe=="boolean"?ne===(Fe?"true":"false")?E.INSTANCE:y.INSTANCE:new b(V,ne,Ce)}constructor(V,ne,Ce){this.c=V,this.d=ne,this.f=Ce,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?E.INSTANCE:y.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$fj=b;class L{static create(V,ne=null){const Ce=g.get(V);return typeof Ce=="boolean"?Ce?E.INSTANCE:y.INSTANCE:new L(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?E.INSTANCE:y.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$gj=L;function T(X,V){if(typeof X=="string"){const ne=parseFloat(X);isNaN(ne)||(X=ne)}return typeof X=="string"||typeof X=="number"?V(X):E.INSTANCE}class Y{static create(V,ne,Ce=null){return T(ne,Fe=>new Y(V,Fe,Ce))}constructor(V,ne,Ce){this.c=V,this.d=ne,this.f=Ce,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$hj=Y;class q{static create(V,ne,Ce=null){return T(ne,Fe=>new q(V,Fe,Ce))}constructor(V,ne,Ce){this.c=V,this.d=ne,this.f=Ce,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$ij=q;class U{static create(V,ne,Ce=null){return T(ne,Fe=>new U(V,Fe,Ce))}constructor(V,ne,Ce){this.c=V,this.d=ne,this.f=Ce,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$jj=U;class C{static create(V,ne,Ce=null){return T(ne,Fe=>new C(V,Fe,Ce))}constructor(V,ne,Ce){this.c=V,this.d=ne,this.f=Ce,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$kj=C;class F{static create(V,ne){return new F(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ce=V.f?V.f.source:"";return ne<Ce?-1:ne>Ce?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ce=V.f?V.f.source:"";return this.d===V.d&&ne===Ce}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$lj=F;class W{static create(V){return new W(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new W(this.c.map(V))}negate(){return this.c}}e.$mj=W;function re(X){let V=null;for(let ne=0,Ce=X.length;ne<Ce;ne++){const Fe=X[ne].substituteConstants();if(X[ne]!==Fe&&V===null){V=[];for(let Pe=0;Pe<ne;Pe++)V[Pe]=X[Pe]}V!==null&&(V[ne]=Fe)}return V===null?X:V}class ue{static create(V,ne,Ce){return ue.d(V,ne,Ce)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++){const Fe=u(this.expr[ne],V.expr[ne]);if(Fe!==0)return Fe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:ue.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ce){const Fe=[];let Pe=!1;for(const we of V)if(we){if(we.type===1){Pe=!0;continue}if(we.type===0)return E.INSTANCE;if(we.type===6){Fe.push(...we.expr);continue}Fe.push(we)}if(Fe.length===0&&Pe)return y.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(u);for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const we=Fe[Fe.length-1];if(we.type!==9)break;Fe.pop();const me=Fe.pop(),J=Fe.length===0,x=ye.create(we.expr.map(le=>ue.create([le,me],null,Ce)),null,J);x&&(Fe.push(x),Fe.sort(u))}if(Fe.length===1)return Fe[0];if(Ce){for(let we=0;we<Fe.length;we++)for(let me=we+1;me<Fe.length;me++)if(Fe[we].negate().equals(Fe[me]))return E.INSTANCE;if(Fe.length===1)return Fe[0]}return new ue(Fe,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ue(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=ye.create(V,this,!0)}return this.c}}e.$nj=ue;class ye{static create(V,ne,Ce){return ye.d(V,ne,Ce)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++){const Fe=u(this.expr[ne],V.expr[ne]);if(Fe!==0)return Fe}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:ye.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ce=this.expr.length;ne<Ce;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ce){let Fe=[],Pe=!1;if(V){for(let we=0,me=V.length;we<me;we++){const J=V[we];if(J){if(J.type===0){Pe=!0;continue}if(J.type===1)return y.INSTANCE;if(J.type===9){Fe=Fe.concat(J.expr);continue}Fe.push(J)}}if(Fe.length===0&&Pe)return E.INSTANCE;Fe.sort(u)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let we=1;we<Fe.length;we++)Fe[we-1].equals(Fe[we])&&(Fe.splice(we,1),we--);if(Fe.length===1)return Fe[0];if(Ce){for(let we=0;we<Fe.length;we++)for(let me=we+1;me<Fe.length;me++)if(Fe[we].negate().equals(Fe[me]))return y.INSTANCE;if(Fe.length===1)return Fe[0]}return new ye(Fe,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new ye(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ce=V.shift(),Fe=[];for(const Pe of te(ne))for(const we of te(Ce))Fe.push(ue.create([Pe,we],null,!1));V.unshift(ye.create(Fe,null,!1))}this.c=ye.create(V,this,!0)}return this.c}}e.$oj=ye;class ke extends ${static{this.d=[]}static all(){return ke.d.values()}constructor(V,ne,Ce){super(V,null),this.f=ne,typeof Ce=="object"?ke.d.push({...Ce,key:V}):Ce!==!0&&ke.d.push({key:V,description:Ce,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return I.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$pj=ke,e.$qj=(0,N.$$h)("contextKeyService");function he(X,V){return X<V?-1:X>V?1:0}function ve(X,V,ne,Ce){return X<ne?-1:X>ne?1:V<Ce?-1:V>Ce?1:0}function se(X,V){if(X.type===0||V.type===1)return!0;if(X.type===9)return V.type===9?$e(X.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(se(X,ne))return!0;return!1}if(X.type===6){if(V.type===6)return $e(V.expr,X.expr);for(const ne of X.expr)if(se(ne,V))return!0;return!1}return X.equals(V)}e.$rj=se;function $e(X,V){let ne=0,Ce=0;for(;ne<X.length&&Ce<V.length;){const Fe=X[ne].cmp(V[Ce]);if(Fe<0)return!1;Fe===0&&ne++,Ce++}return ne===X.length}function te(X){return X.type===9?X.expr:[X]}}),define(Le[185],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=void 0,e.$fi=(0,S.$$h)("environmentService"),e.$gi=(0,S.$_h)(e.$fi)}),define(Le[96],Me([1,0,152,4]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.ExtensionGalleryErrorCode=e.$Fo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Eo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=void 0,e.$so="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$to=new RegExp(e.$so),e.$uo="__web_extension",e.$vo="skipWalkthrough",e.$wo="extensionsSync",e.$xo="dependecyOrPackExtensionInstall";function P(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$yo=P;function N(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$zo=N;function R(n,o){switch(n){case 3:return o==="x64"?"win32-x64":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ao=R;function m(n,o){return o==="web"&&!n.includes("web")}e.$Bo=m;function g(n,o,h){return m(o,h)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===h}e.$Co=g;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Do=D;var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(n){n.Install="install",n.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var v;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Eo=(0,M.$$h)("extensionGalleryService");var p;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var s;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class a extends Error{constructor(o,h){super(o),this.code=h,this.name=h}}e.$Fo=a;var r;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class i extends Error{constructor(o,h){super(o),this.code=h,this.name=h}}e.$Go=i,e.$Ho=(0,M.$$h)("extensionManagementService"),e.$Io="extensionsIdentifiers/disabled",e.$Jo="extensionsIdentifiers/enabled",e.$Ko=(0,M.$$h)("IGlobalExtensionEnablementService"),e.$Lo=(0,M.$$h)("IExtensionTipsService"),e.$Mo=(0,S.localize2)(0,"Extensions"),e.$No=(0,S.localize2)(1,"Preferences")}),define(Le[42],Me([1,0,51,19,13,16,2,154,4,20,12,39]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.FileKind=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.FileOperationResult=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileChangeType=e.$Nk=e.FileOperation=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileSystemProviderErrorCode=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileSystemProviderCapabilities=e.$xk=e.FilePermission=e.FileType=e.$wk=e.$vk=void 0,e.$vk=(0,g.$$h)("fileService");function l(se){return se.create===!0}e.$wk=l;var v;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var p;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function s(se){const $e=se;return!!$e&&typeof $e.onDidChange=="function"}e.$xk=s;var a;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(se){return!!(se.capabilities&2)}e.$yk=r;function i(se){return!!(se.capabilities&8)}e.$zk=i;function n(se){return!!(se.capabilities&131072)}e.$Ak=n;function o(se){return!!(se.capabilities&4)}e.$Bk=o;function h(se){return!!(se.capabilities&16)}e.$Ck=h;function t(se){return r(se)?!!(se.capabilities&16384):!1}e.$Dk=t;function f(se){return r(se)?!!(se.capabilities&32768):!1}e.$Ek=f;function c(se){return!!(se.capabilities&65536)}e.$Fk=c;function u(se){return!!(se.capabilities&2048)}e.$Gk=u;var E;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class y extends Error{static create($e,te){const X=new y($e.toString(),te);return d(X,te),X}constructor($e,te){super($e),this.code=te}}e.$Hk=y;function $(se,$e){return y.create(se,$e)}e.$Ik=$;function I(se){return se||$((0,m.localize)(0,null),E.Unknown)}e.$Jk=I;function d(se,$e){return se.name=$e?`${$e} (FileSystemError)`:"FileSystemError",se}e.$Kk=d;function w(se){if(!se)return E.Unknown;if(se instanceof y)return se.code;const $e=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!$e)return E.Unknown;switch($e[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.$Lk=w;function b(se){if(se instanceof C)return se.fileOperationResult;switch(w(se)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 9;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileTooLarge:return 7;default:return 10}}e.$Mk=b;var L;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class T{constructor($e,te,X){this.resource=$e,this.operation=te,this.target=X}isOperation($e){return this.operation===$e}}e.$Nk=T;var Y;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(Y||(e.FileChangeType=Y={}));class q{static{this.a=null}constructor($e,te){this.c=te,this.b=void 0,this.d=new k.$V(()=>{const X=S.$ei.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new k.$V(()=>{const X=S.$ei.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new k.$V(()=>{const X=S.$ei.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of $e){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains($e,...te){return this.h($e,{includeChildren:!1},...te)}affects($e,...te){return this.h($e,{includeChildren:!0},...te)}h($e,te,...X){if(!$e)return!1;const V=X.length>0;return!!((!V||X.includes(1))&&(this.d.value.get($e)||te.includeChildren&&this.d.value.findSuperstr($e))||(!V||X.includes(0))&&(this.f.value.get($e)||te.includeChildren&&this.f.value.findSuperstr($e))||(!V||X.includes(2))&&(this.g.value.findSubstr($e)||te.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Ok=q;function U(se,$e,te){return!se||!$e||se===$e||$e.length>se.length?!1:($e.charAt($e.length-1)!==M.sep&&($e+=M.sep),te?(0,P.$ef)(se,$e):se.indexOf($e)===0)}e.$Pk=U;class C extends Error{constructor($e,te,X){super($e),this.fileOperationResult=te,this.options=X}}e.$Qk=C;class F extends C{constructor($e,te,X,V){super($e,te,V),this.fileOperationResult=te,this.size=X}}e.$Rk=F;class W extends C{constructor($e,te,X){super($e,2,X),this.stat=te}}e.$Sk=W;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$Tk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Uk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Vk="files.associations",e.$Wk="files.exclude",e.$Xk="files.readonlyInclude",e.$Yk="files.readonlyExclude",e.$Zk="files.readonlyFromPermissions";var ue;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$1k="";function ye(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$2k=ye;async function ke(se,$e){if(!$e.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(te=>{const X=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(X.dispose(),te())})})}e.$3k=ke;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize($e){return(0,N.$Qf)($e)||($e=0),$e<he.KB?(0,m.localize)(1,null,$e.toFixed(0)):$e<he.MB?(0,m.localize)(2,null,($e/he.KB).toFixed(2)):$e<he.GB?(0,m.localize)(3,null,($e/he.MB).toFixed(2)):$e<he.TB?(0,m.localize)(4,null,($e/he.GB).toFixed(2)):(0,m.localize)(5,null,($e/he.TB).toFixed(2))}}e.$4k=he;function ve(se){const $e=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*he.MB:$e?10*he.MB:D.$o?50*he.MB:1024*he.MB}e.$5k=ve}),define(Le[71],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=void 0;class S{constructor(...P){this.a=new Map;for(const[N,R]of P)this.set(N,R)}set(P,N){const R=this.a.get(P);return this.a.set(P,N),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$9h=S}),define(Le[186],Me([1,0,11,15,6,70,184,4,71,187]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;const A=!1;class k extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new g.$9h,r=!1,i,n=A){this.f=a,this.g=r,this.h=i,this.i=n,this.o=new Set,this.f.set(m.$0h,this),this._globalGraph=n?i?._globalGraph??new R.$Iq(o=>o):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...r){const i=p.traceInvocation(this.i,a);let n=!1;try{return a({get:h=>{if(n)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(h,i);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...r)}finally{n=!0,i.stop()}}createInstance(a,...r){let i,n;return a instanceof N.$8h?(i=p.traceCreation(this.i,a.ctor),n=this.j(a.ctor,a.staticArguments.concat(r),i)):(i=p.traceCreation(this.i,a),n=this.j(a,r,i)),i.stop(),n}j(a,r=[],i){const n=m._util.getServiceDependencies(a).sort((t,f)=>t.index-f.index),o=[];for(const t of n){const f=this.m(t.id,i);f||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(f)}const h=n.length>0?n[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${a.name} at position ${h+1} conflicts with ${r.length} static arguments`);const t=h-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,h)}return Reflect.construct(a,r.concat(o))}k(a,r){if(this.f.get(a)instanceof N.$8h)this.f.set(a,r);else if(this.h)this.h.k(a,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const r=this.f.get(a);return!r&&this.h?this.h.l(a):r}m(a,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const i=this.l(a);return i instanceof N.$8h?this.q(a,i,r.branch(a,!0)):(r.branch(a,!1),i)}q(a,r,i){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,r,i)}finally{this.o.delete(a)}}r(a,r,i){const n=new R.$Iq(t=>t.id.toString());let o=0;const h=[{id:a,desc:r,_trace:i}];for(;h.length;){const t=h.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new k(n);for(const f of m._util.getServiceDependencies(t.desc.ctor)){const c=this.l(f.id);if(c||this.u(`[createInstance] ${a} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),c instanceof N.$8h){const u={id:f.id,desc:c,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,u),h.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new k(n);break}for(const{data:f}of t){if(this.l(f.id)instanceof N.$8h){const u=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,u)}n.removeNode(f)}}return this.l(a)}s(a,r,i=[],n,o){if(this.f.get(a)instanceof N.$8h)return this.t(a,r,i,n,o);if(this.h)return this.h.s(a,r,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(a,r,i=[],n,o){if(n){const h=new l(void 0,this.g,this,this.i);h.c=String(a);const t=new Map,f=new S.$rh(()=>{const c=h.j(r,i,o);for(const[u,E]of t){const y=c[u];if(typeof y=="function")for(const $ of E)$.disposable=y.apply(c,$.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,u){if(!f.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let $=t.get(u);return $||($=new D.$4c,t.set(u,$)),(d,w,b)=>{if(f.isInitialized)return f.value[u](d,w,b);{const L={listener:[d,w,b],disposable:void 0},T=$.push(L);return(0,P.$Rc)(()=>{T(),L.disposable?.dispose()})}}}if(u in c)return c[u];const E=f.value;let y=E[u];return typeof y!="function"||(y=y.bind(E),c[u]=y),y},set(c,u,E){return f.value[u]=E,!0},getPrototypeOf(c){return r.prototype}})}else return this.j(r,i,o)}u(a,r){if(r&&console.warn(a),this.g)throw new Error(a)}}e.$Jq=l;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,r){return a?new p(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(a,r){return a?new p(1,r.name):p.c}static{this.f=0}constructor(a,r){this.type=a,this.name=r,this.g=Date.now(),this.h=[]}branch(a,r){const i=new p(3,a.toString());return this.h.push([a,r,i]),i}stop(){const a=Date.now()-this.g;p.f+=a;let r=!1;function i(o,h){const t=[],f=new Array(o+1).join("	");for(const[c,u,E]of h.h)if(u&&E){r=!0,t.push(`${f}CREATES -> ${c}`);const y=i(o+1,E);y&&t.push(y)}else t.push(`${f}uses -> ${c}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(a>2||r)&&p.all.add(n.join(`
`))}}e.$Kq=p}),define(Le[14],Me([1,0,41,5,97,6,28,20,24,16,2,35,4]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.log=e.$vj=e.LogLevel=e.$uj=e.$tj=e.$sj=void 0,e.$sj=(0,l.$$h)("logService"),e.$tj=(0,l.$$h)("loggerService");function v(){return new Date().toISOString()}function p(d){return(0,D.$Qf)(d)}e.$uj=p;var s;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$vj=s.Info;function a(d,w,b){switch(w){case s.Trace:d.trace(b);break;case s.Debug:d.debug(b);break;case s.Info:d.info(b);break;case s.Warning:d.warn(b);break;case s.Error:d.error(b);break;case s.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=a;function r(d,w=!1){let b="";for(let L=0;L<d.length;L++){let T=d[L];if(T instanceof Error&&(T=(0,S.$Vi)(T,w)),typeof T=="object")try{T=JSON.stringify(T)}catch{}b+=(L>0?" ":"")+T}return b}class i extends N.$Tc{constructor(){super(...arguments),this.b=e.$vj,this.c=this.B(new M.$Yd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==s.Off&&this.b<=w}}e.$xj=i;class n extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...b){this.f(s.Trace)&&this.g(s.Trace,r([w,...b],!0))}debug(w,...b){this.f(s.Debug)&&this.g(s.Debug,r([w,...b]))}info(w,...b){this.f(s.Info)&&this.g(s.Info,r([w,...b]))}warn(w,...b){this.f(s.Warning)&&this.g(s.Warning,r([w,...b]))}error(w,...b){if(this.f(s.Error))if(w instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=w.stack,this.g(s.Error,r(L))}else this.g(s.Error,r([w,...b]))}flush(){}}e.$yj=n;class o extends i{constructor(w=e.$vj){super(),this.setLevel(w),this.g=!m.$i}trace(w,...b){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}debug(w,...b){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}info(w,...b){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}warn(w,...b){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,w,...b):console.warn(`[main ${v()}]`,w,...b))}error(w,...b){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,w,...b):console.error(`[main ${v()}]`,w,...b))}flush(){}}e.$zj=o;class h extends i{constructor(w=e.$vj,b=!0){super(),this.g=b,this.setLevel(w)}trace(w,...b){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...b):console.log(w,...b))}debug(w,...b){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...b):console.log(w,...b))}info(w,...b){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...b):console.log(w,...b))}warn(w,...b){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...b):console.log(w,...b))}error(w,...b){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...b):console.error(w,...b))}flush(){}}e.$Aj=h;class t extends i{constructor(w,b=e.$vj){super(),this.g=w,this.setLevel(b)}trace(w,...b){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(w),...b])}debug(w,...b){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(w),...b])}info(w,...b){this.f(s.Info)&&this.g.log(s.Info,[this.h(w),...b])}warn(w,...b){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(w),...b])}error(w,...b){this.f(s.Error)&&this.g.log(s.Error,[this.h(w),...b])}h(w){return typeof w=="string"?w:(0,S.$Vi)(w,this.f(s.Trace))}flush(){}}e.$Bj=t;class f extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const b of this.g)b.setLevel(w);super.setLevel(w)}trace(w,...b){for(const L of this.g)L.trace(w,...b)}debug(w,...b){for(const L of this.g)L.debug(w,...b)}info(w,...b){for(const L of this.g)L.info(w,...b)}warn(w,...b){for(const L of this.g)L.warn(w,...b)}error(w,...b){for(const L of this.g)L.error(w,...b)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$Cj=f;class c extends N.$Tc{constructor(w,b,L){if(super(),this.h=w,this.j=b,this.b=new R.$Ac,this.c=this.B(new M.$Yd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Yd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Yd),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(w){return(0,D.$Mf)(w)?[...this.b.values()].find(b=>b.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,b){const L=this.n(w),T=(0,D.$Mf)(w)?w:b?.id??(0,P.$Yi)(L.toString()).toString(16);let Y=this.b.get(L)?.logger;const q=b?.logLevel==="always"?s.Trace:b?.logLevel;Y||(Y=this.s(L,q??this.getLogLevel(L)??this.h,{...b,id:T}));const U={logger:Y,info:{resource:L,id:T,logLevel:q,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(U.info),this.b.set(L,U),Y}n(w){return(0,D.$Mf)(w)?(0,g.$Lg)(this.j,`${w}.log`):w}setLogLevel(w,b){if(A.URI.isUri(w)){const L=w,T=b,Y=this.b.get(L);Y&&T!==Y.info.logLevel&&(Y.info.logLevel=T===this.h?void 0:T,Y.logger?.setLevel(T),this.b.set(Y.info.resource,Y),this.f.fire([L,T]))}else{this.h=w;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,b){const L=this.m(w);L&&b!==!L.info.hidden&&(L.info.hidden=!b,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,b]))}getLogLevel(w){let b;return w&&(b=this.b.get(w)?.info.logLevel),b??this.h}registerLogger(w){const b=this.b.get(w.resource);b?b.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const b=this.b.get(w);b&&(b.logger&&b.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Dj=c;class u{constructor(){this.onDidChangeLogLevel=new M.$Yd().event}setLevel(w){}getLevel(){return s.Info}trace(w,...b){}debug(w,...b){}info(w,...b){}warn(w,...b){}error(w,...b){}critical(w,...b){}dispose(){}flush(){}}e.$Ej=u;class E extends u{}e.$Fj=E;function y(d){if(d.verbose)return s.Trace;if(typeof d.logLevel=="string"){const w=I(d.logLevel.toLowerCase());if(w!==void 0)return w}return e.$vj}e.$Gj=y;function $(d){switch(d){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Hj=$;function I(d){switch(d){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Ij=I,e.$Jj=new k.$pj("logLevel",$(s.Info))}),define(Le[188],Me([1,0,6,14]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=void 0;class P extends S.$Tc{constructor(R,m=[]){super(),this.a=new M.$Cj([R,...m]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$7O=P}),define(Le[98],Me([1,0,32,155,4]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var N;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(N||(e.MarkerTag=N={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function D(p,s){return s-p}g.compare=D;const A=Object.create(null);A[g.Error]=(0,M.localize)(0,null),A[g.Warning]=(0,M.localize)(1,null),A[g.Info]=(0,M.localize)(2,null);function k(p){return A[p]||""}g.toString=k;function l(p){switch(p){case S.default.Error:return g.Error;case S.default.Warning:return g.Warning;case S.default.Info:return g.Info;case S.default.Ignore:return g.Hint}}g.fromSeverity=l;function v(p){switch(p){case g.Error:return S.default.Error;case g.Warning:return S.default.Warning;case g.Info:return S.default.Info;case g.Hint:return S.default.Ignore}}g.toSeverity=v}(R||(e.MarkerSeverity=R={}));var m;(function(g){const D="";function A(l){return k(l,!0)}g.makeKey=A;function k(l,v){const p=[D];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(D),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(D),l.severity!==void 0&&l.severity!==null?p.push(R.toString(l.severity)):p.push(D),l.message&&v?p.push(l.message.replace("\xA6","\\\xA6")):p.push(D),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(D),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(D),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(D),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(D),p.push(D),p.join("\xA6")}g.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$Ft=(0,P.$$h)("markerService")}),define(Le[189],Me([1,0,5,32,4]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xv=e.$wv=e.NotificationsFilter=e.$vv=e.NeverShowAgainScope=e.NotificationPriority=e.$uv=e.Severity=void 0,e.Severity=M.default,e.$uv=(0,P.$$h)("notificationService");var N;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(N||(e.NotificationPriority=N={}));var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$vv=m;var g;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class D{constructor(){this.progress=new A,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$wv=D;class A{infinite(){}done(){}total(l){}worked(l){}}e.$xv=A}),define(Le[190],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=void 0,e.$Kj=(0,S.$$h)("productService"),e.$Lj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(fe,e,S,M){var P=arguments.length,N=P<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(fe,e,S,M);else for(var m=fe.length-1;m>=0;m--)(R=fe[m])&&(N=(P<3?R(N):P>3?R(e,S,N):R(e,S))||N);return P>3&&N&&Object.defineProperty(e,S,N),N},qe=this&&this.__param||function(fe,e){return function(S,M){e(S,M,fe)}};define(Le[99],Me([1,0,11,21,6,4]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.ProgressLocation=e.$yv=void 0,e.$yv=(0,N.$$h)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$zv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Av=m;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const v=this.d;this.d=()=>{v?.(),l()}}):Promise.resolve()}}e.$Bv=g;let D=class extends P.$Tc{constructor(l,v){super(),this.a=new S.$vh,v.withProgress(l,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Cv=D,e.$Cv=D=Je([qe(1,e.$yv)],D);class A extends P.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Sc)}start(l){this.stop();const v=++this.a,p=new M.$9d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>p.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:v,token:p.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Dv=A,e.$Ev=(0,N.$$h)("editorProgressService")}),define(Le[30],Me([1,0,54,16]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nn=void 0;class P{constructor(){this.a=new Map}add(R,m){S.ok(M.$Mf(R)),S.ok(M.$Of(m)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Nn=new P}),define(Le[72],Me([1,0,5,30]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=void 0,e.$On={JSONContribution:"base.contributions.json"};function P(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class N{constructor(){this.b=new S.$Yd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,D){this.a[P(g)]=D,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new N;M.$Nn.add(e.$On.JSONContribution,R)}),define(Le[55],Me([1,0,18,5,16,149,47,72,30]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.ConfigurationScope=e.$Sn=e.EditPresentationTypes=void 0;var D;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$Sn={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn={properties:{},patternProperties:{}},e.$Xn={properties:{},patternProperties:{}},e.$Yn={properties:{},patternProperties:{}},e.$Zn="vscode://schemas/settings/resourceLanguage",e.$1n="vscode://schemas/settings/configurationDefaults";const k=g.$Nn.as(m.$On.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$Yd,this.onDidSchemaChange=this.i.event,this.j=new M.$Yd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Zn,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const c=new Set;this.n(t,f,c),k.registerSchema(e.$Zn,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const f=new Set;this.o(t,f),k.registerSchema(e.$Zn,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const c=new Set;this.o(f,c),this.n(t,!1,c),k.registerSchema(e.$Zn,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const c=[];for(const{overrides:u,source:E}of t)for(const y in u)if(f.add(y),e.$3n.test(y)){const $=this.a.get(y),I=$?.valuesSources??new Map;if(E)for(const L of Object.keys(u[y]))I.set(L,E);const d={...$?.value||{},...u[y]};this.a.set(y,{source:E,value:d,valuesSources:I});const w=(0,R.$Oi)(y),b={type:"object",default:d,description:N.localize(1,null,w),$ref:e.$Zn,defaultDefaultValue:d,source:P.$Mf(E)?void 0:E,defaultValueSource:E};c.push(...s(y)),this.d[y]=b,this.b.properties[y]=b}else{this.a.set(y,{value:u[y],source:E});const $=this.d[y];$&&(this.w(y,$),this.r(y,$))}this.m(c)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:c,source:u}of t)for(const E in c){const y=this.a.get(E),$=P.$Mf(u)?u:u?.id,I=P.$Mf(y?.source)?y?.source:y?.source?.id;if($===I)if(f.add(E),this.a.delete(E),e.$3n.test(E))delete this.d[E],delete this.b.properties[E];else{const d=this.d[E];d&&(this.w(E,d),this.r(E,d))}}this.u()}deltaConfiguration(t){let f=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,c){t.forEach(u=>{this.p(u,f,u.extensionInfo,u.restrictedProperties,void 0,c),this.c.push(u),this.q(u)})}o(t,f){const c=u=>{if(u.properties)for(const E in u.properties){f.add(E);const y=this.d[E];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[E],this.s(E,u.properties[E])}u.allOf?.forEach(E=>c(E))};for(const u of t){c(u);const E=this.c.indexOf(u);E!==-1&&this.c.splice(E,1)}}p(t,f=!0,c,u,E=3,y){E=P.$Vf(t.scope)?E:t.scope;const $=t.properties;if($)for(const d in $){const w=$[d];if(f&&n(d,w)){delete $[d];continue}if(w.source=c,w.defaultDefaultValue=$[d].default,this.w(d,w),e.$3n.test(d)?w.scope=void 0:(w.scope=P.$Vf(w.scope)?E:w.scope,w.restricted=P.$Vf(w.restricted)?!!u?.includes(d):w.restricted),$[d].hasOwnProperty("included")&&!$[d].included){this.f[d]=$[d],delete $[d];continue}else this.d[d]=$[d],$[d].policy?.name&&this.e.set($[d].policy.name,d);!$[d].deprecationMessage&&$[d].markdownDeprecationMessage&&($[d].deprecationMessage=$[d].markdownDeprecationMessage),y.add(d)}const I=t.allOf;if(I)for(const d of I)this.p(d,f,c,u,E,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=c=>{const u=c.properties;if(u)for(const y in u)this.r(y,u[y]);c.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$Tn.properties[t]=f,f.scope){case 1:e.$Un.properties[t]=f;break;case 2:e.$Vn.properties[t]=f;break;case 6:e.$Wn.properties[t]=f;break;case 3:e.$Xn.properties[t]=f;break;case 4:e.$Yn.properties[t]=f;break;case 5:e.$Yn.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$Tn.properties[t],f.scope){case 1:delete e.$Un.properties[t];break;case 2:delete e.$Vn.properties[t];break;case 6:delete e.$Wn.properties[t];break;case 3:delete e.$Xn.properties[t];break;case 4:case 5:delete e.$Yn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,c={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$Zn};this.w(f,c),e.$Tn.properties[f]=c,e.$Un.properties[f]=c,e.$Vn.properties[f]=c,e.$Wn.properties[f]=c,e.$Xn.properties[f]=c,e.$Yn.properties[f]=c}}v(){const t={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$Zn};e.$Tn.patternProperties[e.$2n]=t,e.$Un.patternProperties[e.$2n]=t,e.$Vn.patternProperties[e.$2n]=t,e.$Wn.patternProperties[e.$2n]=t,e.$Xn.patternProperties[e.$2n]=t,e.$Yn.patternProperties[e.$2n]=t,this.i.fire()}w(t,f){const c=this.a.get(t);let u=c?.value,E=c?.source;P.$Tf(u)&&(u=f.defaultDefaultValue,E=void 0),P.$Tf(u)&&(u=r(f.type)),f.default=u,f.defaultValueSource=E}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$2n=`^(${v})+$`,e.$3n=new RegExp(e.$2n);function s(h){const t=[];if(e.$3n.test(h)){let f=p.exec(h);for(;f?.length;){const c=f[1].trim();c&&t.push(c),f=p.exec(h)}}return(0,S.$Mb)(t)}e.$4n=s;function a(h){return h.reduce((t,f)=>`${t}[${f}]`,"")}e.$5n=a;function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$6n=r;const i=new l;g.$Nn.add(e.$Sn.Configuration,i);function n(h,t){return h.trim()?e.$3n.test(h)?N.localize(7,null,h):i.getConfigurationProperties()[h]!==void 0?N.localize(8,null,h):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?N.localize(9,null,h,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:N.localize(6,null)}e.$7n=n;function o(){const h=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))h.push([f,t[f].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$8n=o}),define(Le[191],Me([1,0,18,5,120,6,28,26,16,2,47,55,30]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=void 0;function v(f){return Object.isFrozen(f)?f:m.$Cn(f)}class p{constructor(c={},u=[],E=[],y){this.b=c,this.c=u,this.d=E,this.raw=y,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(u=>{if(u instanceof p)return u;const E=new s("");return E.parseRaw(u),E.configurationModel});this.f=c.reduce((u,E)=>E===u?E:u.merge(E),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,A.$Mi)(this.contents,c):this.contents}inspect(c,u){const E=this;return{get value(){return v(E.rawConfiguration.getValue(c))},get override(){return u?v(E.rawConfiguration.getOverrideValue(c,u)):void 0},get merged(){return v(u?E.rawConfiguration.override(u).getValue(c):E.rawConfiguration.getValue(c))},get overrides(){const y=[];for(const{contents:$,identifiers:I,keys:d}of E.rawConfiguration.overrides){const w=new p($,d).getValue(c);w!==void 0&&y.push({identifiers:I,value:w})}return y.length?v(y):void 0}}}getOverrideValue(c,u){const E=this.i(u);return E?c?(0,A.$Mi)(E,c):E:void 0}getKeysForOverrideIdentifier(c){const u=[];for(const E of this.overrides)E.identifiers.includes(c)&&u.push(...E.keys);return S.$Mb(u)}getAllOverrideIdentifiers(){const c=[];for(const u of this.overrides)c.push(...u.identifiers);return S.$Mb(c)}override(c){let u=this.a.get(c);return u||(u=this.g(c),this.a.set(c,u)),u}merge(...c){const u=m.$Bn(this.contents),E=m.$Bn(this.overrides),y=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const I of c)if($.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(u,I.contents);for(const d of I.overrides){const[w]=E.filter(b=>S.$ub(b.identifiers,d.identifiers));w?(this.h(w.contents,d.contents),w.keys.push(...d.keys),w.keys=S.$Mb(w.keys)):E.push(m.$Bn(d))}for(const d of I.keys)y.indexOf(d)===-1&&y.push(d)}return new p(u,y,E,$.every(I=>I instanceof p)?void 0:$)}g(c){const u=this.i(c);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const E={};for(const y of S.$Mb([...Object.keys(this.contents),...Object.keys(u)])){let $=this.contents[y];const I=u[y];I&&(typeof $=="object"&&typeof I=="object"?($=m.$Bn($),this.h($,I)):$=I),E[y]=$}return new p(E,this.keys,this.overrides)}h(c,u){for(const E of Object.keys(u)){if(E in c&&g.$Of(c[E])&&g.$Of(u[E])){this.h(c[E],u[E]);continue}c[E]=m.$Bn(u[E])}}i(c){let u=null,E=null;const y=$=>{$&&(E?this.h(E,$):E=m.$Bn($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===c?u=$.contents:$.identifiers.includes(c)&&y($.contents);return y(u),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,u){this.j(c,u,!0)}setValue(c,u){this.j(c,u,!1)}removeValue(c){const u=this.keys.indexOf(c);u!==-1&&(this.keys.splice(u,1),(0,A.$Li)(this.contents,c),k.$3n.test(c)&&this.overrides.splice(this.overrides.findIndex(E=>S.$ub(E.identifiers,(0,k.$4n)(c))),1))}j(c,u,E){(0,A.$Ki)(this.contents,c,u,y=>console.error(y)),E=E||this.keys.indexOf(c)===-1,E&&this.keys.push(c),k.$3n.test(c)&&this.overrides.push({identifiers:(0,k.$4n)(c),keys:Object.keys(this.contents[c]),contents:(0,A.$Ji)(this.contents[c],y=>console.error(y))})}}e.$9n=p;class s{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,u){if(!g.$Vf(c)){const E=this.g(c);this.parseRaw(E,u)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,u){this.a=c;const{contents:E,keys:y,overrides:$,restricted:I,hasExcludedProperties:d}=this.h(c,u);this.b=new p(E,y,$,d?[c]:void 0),this.c=I||[]}g(c){let u={},E=null,y=[];const $=[],I=[];function d(b){Array.isArray(y)?y.push(b):E!==null&&(y[E]=b)}const w={onObjectBegin:()=>{const b={};d(b),$.push(y),y=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{y=$.pop()},onArrayBegin:()=>{const b=[];d(b),$.push(y),y=b,E=null},onArrayEnd:()=>{y=$.pop()},onLiteralValue:d,onError:(b,L,T)=>{I.push({error:b,offset:L,length:T})}};if(c)try{P.$pn(c,w),u=y[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return u}h(c,u){const E=l.$Nn.as(k.$Sn.Configuration).getConfigurationProperties(),y=this.i(c,E,!0,u);c=y.raw;const $=(0,A.$Ji)(c,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),I=Object.keys(c),d=this.j(c,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:$,keys:I,overrides:d,restricted:y.restricted,hasExcludedProperties:y.hasExcludedProperties}}i(c,u,E,y){let $=!1;if(!y?.scopes&&!y?.skipRestricted&&!y?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:$};const I={},d=[];for(const w in c)if(k.$3n.test(w)&&E){const b=this.i(c[w],u,!1,y);I[w]=b.raw,$=$||b.hasExcludedProperties,d.push(...b.restricted)}else{const b=u[w],L=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&d.push(w),!y.exclude?.includes(w)&&(y.include?.includes(w)||(L===void 0||y.scopes===void 0||y.scopes.includes(L))&&!(y.skipRestricted&&b?.restricted))?I[w]=c[w]:$=!0}return{raw:I,restricted:d,hasExcludedProperties:$}}j(c,u){const E=[];for(const y of Object.keys(c))if(k.$3n.test(y)){const $={};for(const I in c[y])$[I]=c[y][I];E.push({identifiers:(0,k.$4n)(y),keys:Object.keys($),contents:(0,A.$Ji)($,u)})}return E}}e.$0n=s;class a extends N.$Tc{constructor(c,u,E,y){super(),this.c=c,this.f=u,this.g=y,this.b=this.B(new M.$Yd),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&E.isEqual($.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$$n=a;class r{constructor(c,u,E,y,$,I,d,w,b,L,T,Y,q){this.a=c,this.b=u,this.c=E,this.overrideIdentifiers=y,this.d=$,this.f=I,this.g=d,this.h=w,this.i=b,this.j=L,this.k=T,this.l=Y,this.m=q}get value(){return v(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(c,u,E,y,$=new p,I=new p,d=new R.$Ac,w=new p,b=new R.$Ac){this.c=c,this.d=u,this.f=E,this.g=y,this.h=$,this.i=I,this.j=d,this.l=w,this.m=b,this.a=null,this.b=new R.$Ac,this.n=null}getValue(c,u,E){return this.p(c,u,E).getValue(c)}updateValue(c,u,E={}){let y;E.resource?(y=this.m.get(E.resource),y||(y=new p,this.m.set(E.resource,y))):y=this.l,u===void 0?y.removeValue(c):y.setValue(c,u),E.resource||(this.a=null)}inspect(c,u,E){const y=this.p(c,u,E),$=this.t(u.resource,E),I=u.resource?this.m.get(u.resource)||this.l:this.l,d=new Set;for(const w of y.overrides)for(const b of w.identifiers)y.getOverrideValue(c,b)!==void 0&&d.add(b);return new r(c,u,y.getValue(c),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,$||void 0,I)}keys(c){const u=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,u){this.j.set(c,u),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,u){const E=[];if(!u){const{added:y,updated:$,removed:I}=h(this.c,c);u=[...y,...$,...I]}for(const y of u)for(const $ of(0,k.$4n)(y)){const I=this.c.getKeysForOverrideIdentifier($),d=c.getKeysForOverrideIdentifier($),w=[...d.filter(b=>I.indexOf(b)===-1),...I.filter(b=>d.indexOf(b)===-1),...I.filter(b=>!m.$Fn(this.c.override($).getValue(b),c.override($).getValue(b)))];E.push([$,w])}return this.updateDefaultConfiguration(c),{keys:u,overrides:E}}compareAndUpdatePolicyConfiguration(c){const{added:u,updated:E,removed:y}=h(this.d,c),$=[...u,...E,...y];return $.length&&this.updatePolicyConfiguration(c),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:u,updated:E,removed:y,overrides:$}=h(this.applicationConfiguration,c),I=[...u,...E,...y];return I.length&&this.updateApplicationConfiguration(c),{keys:I,overrides:$}}compareAndUpdateLocalUserConfiguration(c){const{added:u,updated:E,removed:y,overrides:$}=h(this.localUserConfiguration,c),I=[...u,...E,...y];return I.length&&this.updateLocalUserConfiguration(c),{keys:I,overrides:$}}compareAndUpdateRemoteUserConfiguration(c){const{added:u,updated:E,removed:y,overrides:$}=h(this.remoteUserConfiguration,c),I=[...u,...E,...y];return I.length&&this.updateRemoteUserConfiguration(c),{keys:I,overrides:$}}compareAndUpdateWorkspaceConfiguration(c){const{added:u,updated:E,removed:y,overrides:$}=h(this.workspaceConfiguration,c),I=[...u,...E,...y];return I.length&&this.updateWorkspaceConfiguration(c),{keys:I,overrides:$}}compareAndUpdateFolderConfiguration(c,u){const E=this.folderConfigurations.get(c),{added:y,updated:$,removed:I,overrides:d}=h(E,u),w=[...y,...$,...I];return(w.length||!E)&&this.updateFolderConfiguration(c,u),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(c){const u=this.folderConfigurations.get(c);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:E,updated:y,removed:$,overrides:I}=h(u,void 0);return{keys:[...E,...y,...$],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,u,E){let y=this.q(u,E);return u.overrideIdentifier&&(y=y.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(y=y.merge(this.d)),y}q({resource:c},u){let E=this.r();if(u&&c){const y=u.getFolder(c);y&&(E=this.s(y.uri)||E);const $=this.m.get(c);$&&(E=E.merge($))}return E}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let u=this.b.get(c);if(!u){const E=this.r(),y=this.j.get(c);y?(u=E.merge(y),this.b.set(c,u)):u=E}return u}t(c,u){if(u&&c){const E=u.getFolder(c);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,u)=>{const{contents:E,overrides:y,keys:$}=this.j.get(u);return c.push([u,{contents:E,overrides:y,keys:$}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(u=>c.add(u)),this.userConfiguration.keys.forEach(u=>c.add(u)),this.i.keys.forEach(u=>c.add(u)),this.j.forEach(u=>u.keys.forEach(E=>c.add(E))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>c.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>c.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>c.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(E=>c.add(E))),[...c.values()]}v(c){const u=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(E=>u.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(E=>u.add(E)),this.i.getKeysForOverrideIdentifier(c).forEach(E=>u.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(c).forEach(y=>u.add(y))),[...u.values()]}static parse(c){const u=this.w(c.defaults),E=this.w(c.policy),y=this.w(c.application),$=this.w(c.user),I=this.w(c.workspace),d=c.folders.reduce((w,b)=>(w.set(D.URI.revive(b[0]),this.w(b[1])),w),new R.$Ac);return new i(u,E,y,$,new p,I,d,new p,new R.$Ac)}static w(c){return new p(c.contents,c.keys,c.overrides)}}e.$_n=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const c=new Set,u=new Map;for(const y of f)y.keys.forEach($=>c.add($)),y.overrides.forEach(([$,I])=>{const d=(0,R.$xc)(u,$,new Set);I.forEach(w=>d.add(w))});const E=[];return u.forEach((y,$)=>E.push([$,[...y.values()]])),{keys:[...c.values()],overrides:E}}e.$ao=n;class o{constructor(c,u,E,y){this.change=c,this.f=u,this.g=E,this.h=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of c.keys)this.affectedKeys.add($);for(const[,$]of c.overrides)for(const I of $)this.affectedKeys.add(I);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(c,u){const E=this.a+c,y=this.d.indexOf(E);if(y<0)return!1;const $=y+E.length;if($>=this.d.length)return!1;const I=this.d.charCodeAt($);if(I!==this.b&&I!==this.c)return!1;if(u){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,u,this.f?.workspace):void 0,w=this.g.getValue(c,u,this.h);return!m.$Fn(d,w)}return!0}}e.$bo=o;function h(f,c){const{added:u,removed:E,updated:y}=t(c?.rawConfiguration,f?.rawConfiguration),$=[],I=f?.getAllOverrideIdentifiers()||[],d=c?.getAllOverrideIdentifiers()||[];if(c){const w=d.filter(b=>!I.includes(b));for(const b of w)$.push([b,c.getKeysForOverrideIdentifier(b)])}if(f){const w=I.filter(b=>!d.includes(b));for(const b of w)$.push([b,f.getKeysForOverrideIdentifier(b)])}if(c&&f){for(const w of I)if(d.includes(w)){const b=t({contents:f.getOverrideValue(void 0,w)||{},keys:f.getKeysForOverrideIdentifier(w)},{contents:c.getOverrideValue(void 0,w)||{},keys:c.getKeysForOverrideIdentifier(w)});$.push([w,[...b.added,...b.removed,...b.updated]])}}return{added:u,removed:E,updated:y,overrides:$}}function t(f,c){const u=f?c?f.keys.filter($=>c.keys.indexOf($)===-1):[...f.keys]:[],E=c?f?c.keys.filter($=>f.keys.indexOf($)===-1):[...c.keys]:[],y=[];if(f&&c){for(const $ of c.keys)if(f.keys.indexOf($)!==-1){const I=(0,A.$Mi)(c.contents,$),d=(0,A.$Mi)(f.contents,$);m.$Fn(I,d)||y.push($)}}return{added:u,removed:E,updated:y}}}),define(Le[100],Me([1,0,15,4]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.RemoteAuthorityResolverErrorCode=e.$cl=e.$bl=e.RemoteConnectionType=e.$al=void 0,e.$al=(0,M.$$h)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class N{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$bl=N;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$cl=R;var m;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends S.$bb{static isNotAvailable(k){return k instanceof g&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,l=m.Unknown,v){super(k),this._message=k,this._code=l,this._detail=v,this.isHandled=l===m.NotAvailable&&v===!0,Object.setPrototypeOf(this,g.prototype)}}e.$dl=g;function D(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$el=D}),define(Le[56],Me([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=e.$gl=e.$fl=void 0;function M(D){return D.scheme===S.Schemas.vscodeRemote?D.authority:void 0}e.$fl=M;function P(D){if(!D)return;const A=D.indexOf("+");return A<0?D:D.substr(0,A)}e.$gl=P;function N(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.$hl=N;function R(D){const{host:A,port:k}=g(D);if(typeof k>"u")throw new Error(`Invalid remote authority: ${D}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:k}}e.$il=R;function m(D,A){let{host:k,port:l}=g(D);return typeof l>"u"&&(l=A),{host:k,port:l}}e.$jl=m;function g(D){const A=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=D.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:D,port:void 0}}}),define(Le[22],Me([1,0,13,4,56]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.TargetPlatform=e.ExtensionType=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=void 0,e.$km="extensions.user.cache",e.$lm="extensions.builtin.cache",e.$mm="undefined_publisher",e.$nm=["ui","workspace","web"];function N(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$om=N,e.$pm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,r){if(typeof a>"u"||a===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof a=="string"||typeof r=="string"){const i=typeof a=="string"?a:a.value,n=typeof r=="string"?r:r.value;return S.$df(i,n)}return a._lower===r._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$qm=g;class D{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const r of a)this.add(r)}add(a){this.c.add(g.toKey(a))}delete(a){return this.c.delete(g.toKey(a))}has(a){return this.c.has(g.toKey(a))}}e.$rm=D;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(g.toKey(a))}get(a){return this.c.get(g.toKey(a))}has(a){return this.c.has(g.toKey(a))}set(a,r){this.c.set(g.toKey(a),r)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sm=A;function k(s){return l(s)}e.$tm=k;function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$um=l;function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$vm=v;function p(s,a){if(a){const r=`onResolveRemoteAuthority:${(0,P.$gl)(a)}`;return!!s.activationEvents?.includes(r)}return!1}e.$wm=p,e.$xm=(0,M.$$h)("IBuiltinExtensionsScannerService")}),define(Le[101],Me([1,0,15,22]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=e.$sF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const g of R){const D=this.readActivationEvents(g);D.length>0&&(m[M.$qm.toKey(g.identifier)]=D)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${M.$qm.toKey(R.identifier)}`);if(!R.contributes)return m;for(const g in R.contributes){const D=this.a.get(g);if(!D)continue;const A=R.contributes[g],k=Array.isArray(A)?A:[A];try{D(k,m)}catch(l){(0,S.$1)(l)}}return m}}e.$sF=P,e.$tF=new P}),define(Le[192],Me([1,0,20,73,33]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=void 0;function N(g){if(S.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,D,A,k,l,v,p,s,a){const r=Object.create(null);r["common.machineId"]=v,r["common.sqmId"]=p,r.sessionID=(0,P.$ug)()+Date.now(),r.commitHash=k,r.version=l,r["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.$h)(S.$u),r["common.nodePlatform"]=M.$dc,r["common.nodeArch"]=A,r["common.product"]=a||"desktop",s&&(r["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.$l&&(r["common.snap"]="true");const o=N(D);return o&&(r["common.platformDetail"]=o),r}e.$Oo=R;function m(g){const D=M.env.USERDNSDOMAIN;if(!D)return!1;const A=D.toLowerCase();return g.some(k=>A===k)}e.$Po=m}),define(Le[193],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0,e.$zl=(0,S.$$h)("telemetryService"),e.$Al=(0,S.$$h)("customEndpointTelemetryService"),e.$Bl="telemetry.currentSessionDate",e.$Cl="telemetry.firstSessionDate",e.$Dl="telemetry.lastSessionDate",e.$El="telemetry.machineId",e.$Fl="telemetry.sqmId",e.$Gl="telemetry",e.$Hl="telemetry.telemetryLevel",e.$Il="telemetry.enableCrashReporter",e.$Jl="telemetry.enableTelemetry";var M;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var P;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Le[57],Me([1,0,26,16,56,192,193]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;class m{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$Qo=m;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ro=g,e.$So=new g;class D{async publicLog(f,c,u){}async publicLogError(f,c,u){}}e.$To=D,e.$Uo="telemetry",e.$Vo="extensionTelemetryLog",e.$Wo={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}e.$Xo=A;function k(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Yo=k;function l(t){const f=t.getValue(R.$Hl),c=t.getValue(R.$Il);if(t.getValue(R.$Jl)===!1||c===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Zo=l;function v(t){const f={},c={},u={};a(t,u);for(let E in u){E=E.length>150?E.substr(E.length-149):E;const y=u[E];typeof y=="number"?c[E]=y:typeof y=="boolean"?c[E]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${y.length}`),f[E]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(f[E]=y)}return{properties:f,measurements:c}}e.$1o=v;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const f=(0,P.$gl)(t);return p.has(f)?f:"other"}e.$2o=s;function a(t,f,c=0,u){if(t)for(const E of Object.getOwnPropertyNames(t)){const y=t[E],$=u?u+E:E;Array.isArray(y)?f[$]=(0,S.$Gn)(y):y instanceof Date?f[$]=y.toISOString():(0,M.$Of)(y)?c<2?a(y,f,c+1,$+"."):f[$]=(0,S.$Gn)(y):f[$]=y}}function r(t,f){const c=t.msftInternalDomains||[],u=f.getValue("telemetry.internalTesting");return(0,N.$Po)(c)||u}e.$3o=r;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$4o=i;function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const u=[];for(const I of f)for(;;){const d=I.exec(t);if(!d)break;u.push([d.index,I.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(c="";;){const I=y.exec(t);if(!I)break;const d=u.some(([w,b])=>I.index<b&&w<y.lastIndex);!E.test(I[0])&&!d&&(c+=t.substring($,I.index)+"<REDACTED: user-file-path>",$=y.lastIndex)}return $<t.length&&(c+=t.substr($)),c}function o(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of f)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function h(t,f){return(0,S.$Dn)(t,c=>{if(c instanceof m||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let u=c.replaceAll("%20"," ");u=n(u,f);for(const E of f)u=u.replace(E,"");return u=o(u),u}})}e.$5o=h}),define(Le[194],Me([1,0,13,96,22,20,2,15,73,57]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=void 0;function A(c,u){return c.uuid&&u.uuid?c.uuid===u.uuid:c.id===u.id?!0:(0,S.$$e)(c.id,u.id)===0}e.$6o=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(u){const E=u.manifest?u.manifest.version:u.version,y=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new l(u.identifier,E,y)}static parse(u){const E=k.exec(u);return E&&E[1]&&E[2]?new l({id:E[1]},E[2],E[4]||void 0):null}constructor(u,E,y="undefined"){this.version=E,this.targetPlatform=y,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof l?A(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$7o=l;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(c){const u=v.exec(c);return u&&u[1]?[a(u[1]),u[2]]:[a(c),void 0]}e.$8o=p;function s(c,u){return`${c}.${u}`}e.$9o=s;function a(c){return c.toLowerCase()}e.$0o=a;function r(c,u){return a(s(c??P.$mm,u))}e.$$o=r;function i(c,u){const E=[],y=$=>{for(const I of E)if(I.some(d=>A(u(d),u($))))return I;return null};for(const $ of c){const I=y($);I?I.push($):E.push([$])}return E}e.$_o=i;function n(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$ap=n;function o(c){return{id:new D.$Qo(c.identifier.id),name:new D.$Qo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$bp=o,e.$cp=new P.$qm("pprice.better-merge");function h(c,u){const E=[],y=u.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const $=y.shift();if($&&E.every(I=>!A(I.identifier,{id:$}))){const I=c.filter(d=>A(d.identifier,{id:$}));I.length===1&&(E.push(I[0]),y.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.$dp=h;async function t(c,u){if(!N.$k)return!1;let E;try{E=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){u.debug("Error while getting the os-release file.",(0,m.$0)($))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(c,u){const E=await t(c,u),y=(0,M.$Ao)(E?"alpine":N.$u,g.$ec);return u.debug("ComputeTargetPlatform:",y),y}e.$ep=f}),define(Le[195],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=e.$Tr=e.$Sr=e.$Rr=void 0;function S(g){return[...g.entries()]}e.$Rr=S;function M(g){return g?[...g.entries()]:[]}e.$Sr=M;function P(g){return new Map(g)}e.$Tr=P;function N(g){return new Map(g??[])}e.$Ur=N;function R(g){return Array.from(g.entries()).map(D=>[D[0],S(D[1].map),M(D[1].descriptionMap)])}e.$Vr=R;function m(g){return new Map(g.map(D=>[D[0],{map:P(D[1]),descriptionMap:N(D[2])}]))}e.$Wr=m}),define(Le[196],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$sb=void 0;class S{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,N,R=5){const m=N(g=>{const D=typeof g=="string"?g:g.data;let A=this.a.get(P);if(A){A.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(P),R);A={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(P),m.dispose()}},this.a.set(P,A)});return m}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const N=this.a.get(P);N&&(this.a.delete(P),this.b(P,N.data.join("")))}}e.$$sb=S}),define(Le[197],Me([1,0,11,89,40,5,16,2,156,72,30]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.IconFontDefinition=e.IconContribution=e.$Bw=void 0,e.$Bw={IconContribution:"base.contributions.icons"};var k;(function(o){function h(t,f){let c=t.defaults;for(;P.ThemeIcon.isThemeIcon(c);){const u=p.getIcon(c.id);if(!u)return;c=u.defaults}return c}o.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(o){function h(f){return{weight:f.weight,style:f.style,src:f.src.map(c=>({format:c.format,location:c.location.toString()}))}}o.toJSONObject=h;function t(f){const c=u=>(0,R.$Mf)(u)?u:void 0;if(f&&Array.isArray(f.src)&&f.src.every(u=>(0,R.$Mf)(u.format)&&(0,R.$Mf)(u.location)))return{weight:c(f.weight),style:c(f.style),src:f.src.map(u=>({format:u.format,location:m.URI.parse(u.location)}))}}o.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class v{constructor(){this.a=new N.$Yd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,t,f,c){const u=this.b[h];if(u){if(f&&!u.description){u.description=f,this.d.properties[h].markdownDescription=`${f} $(${h})`;const $=this.e.enum.indexOf(h);$!==-1&&(this.e.enumDescriptions[$]=f),this.a.fire()}return u}const E={id:h,description:f,defaults:t,deprecationMessage:c};this.b[h]=E;const y={$ref:"#/definitions/icons"};return c&&(y.deprecationMessage=c),f&&(y.markdownDescription=`${f}: $(${h})`),this.d.properties[h]=y,this.e.enum.push(h),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const t=this.e.enum.indexOf(h);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,t){const f=this.f[h];return f||(this.f[h]=t,this.a.fire(),t)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(u,E)=>u.id.localeCompare(E.id),t=u=>{for(;P.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(u=>this.b[u]);for(const u of c.filter(E=>!!E.description).sort(h))f.push(`|<i class="${t(u)}"></i>|${u.id}|${P.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const u of c.filter(E=>!P.ThemeIcon.isThemeIcon(E.defaults)).sort(h))f.push(`|<i class="${t(u)}"></i>|${u.id}|`);return f.join(`
`)}}const p=new v;A.$Nn.add(e.$Bw.IconContribution,p);function s(o,h,t,f){return p.registerIcon(o,h,t,f)}e.$Cw=s;function a(){return p}e.$Dw=a;function r(){const o=(0,M.$ck)();for(const h in o){const t="\\"+o[h].toString(16);p.registerIcon(h,{fontCharacter:t})}}r(),e.$Ew="vscode://schemas/icons";const i=A.$Nn.as(D.$On.JSONContribution);i.registerSchema(e.$Ew,p.getIconSchema());const n=new S.$kh(()=>i.notifySchemaChanged(e.$Ew),200);p.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Fw=s("widget-close",M.$ek.close,(0,g.localize)(2,null)),e.$Gw=s("goto-previous-location",M.$ek.arrowUp,(0,g.localize)(3,null)),e.$Hw=s("goto-next-location",M.$ek.arrowDown,(0,g.localize)(4,null)),e.$Iw=P.ThemeIcon.modify(M.$ek.sync,"spin"),e.$Jw=P.ThemeIcon.modify(M.$ek.loading,"spin")}),define(Le[198],Me([1,0,5,2,47,4,14]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.ProvidedOnAutoForward=e.$Hv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Gv=e.$Fv=void 0,e.$Fv=(0,N.$$h)("tunnelService"),e.$Gv=(0,N.$$h)("sharedTunnelsService");var m;(function(r){r.Http="http",r.Https="https"})(m||(e.TunnelProtocol=m={}));var g;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(g||(e.TunnelPrivacyId=g={}));function D(r){return!!r.forwardPort}e.$Hv=D;var A;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function k(r,{checkQuery:i=!0}={}){if(r.scheme!=="http"&&r.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(n)return{address:n[1],port:+n[2]};if(!r.query||!i)return;const o=r.query.split("&");for(const h of o){const t=h.split("=")[1];if(/^https?:/.exec(t)){const f=k(M.URI.parse(t));if(f)return f}}}e.$Iv=k,e.$Jv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(r){return e.$Jv.indexOf(r)>=0}e.$Kv=l,e.$Lv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(r){return e.$Lv.indexOf(r)>=0}e.$Mv=v;function p(r,i,n,o){if(n===1)return!1;if(n===2&&v(i)){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(h?.length===4&&parseInt(h[1])>=18)return!1}return r<1024}e.$Nv=p;class s{constructor(i,n,o){this.remoteAddress=i,this.localAddress=n,this.b=o,this.a=new S.$Yd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Ov=s;let a=class{constructor(i,n){this.k=i,this.l=n,this.a=new S.$Yd,this.onTunnelOpened=this.a.event,this.b=new S.$Yd,this.onTunnelClosed=this.b.event,this.c=new S.$Yd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],n=Array.from(this.e.values());for(const o of n){const h=Array.from(o.values());for(const t of h){const f=await t.value;f&&typeof f!="string"&&i.push(f)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,o,h,t){this.q(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:o,privacy:h,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(v(i)||l(i))&&(i=e.$Jv[0]);const o=this.s(i,n);if(o)return++o.refcount,o.value}openTunnel(i,n,o,h,t,f=!1,c,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${t}.`);const E=this.f??i;if(!E)return;if(n||(n="localhost"),h||(h=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.t(E,n,o,h,t,f,c,u);return y?y.then($=>{if($){if(typeof $=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,o),$}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.o($);return($.tunnelRemoteHost!==n||$.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&$.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const o=n.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,n,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const h=o.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),h}}async closeTunnel(i,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const o=this.e.get(i);if(o&&o.has(n)){const h=o.get(n);h.refcount=0,await this.p(i,n,h)}}q(i,n,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:o})}async r(i,n){const o=this.e.get(i);if(o){const h=o.get(n),t=h?await h.value:void 0;(!t||typeof t=="string")&&o.delete(n),o.size===0&&this.e.delete(i)}}s(i,n){const o=[i];l(i)?(o.push(...e.$Jv),o.push(...e.$Lv)):v(i)&&o.push(...e.$Lv);const h=o.map(t=>this.e.get(t));for(const t of h){const f=t?.get(n);if(f)return f}}canTunnel(i){return!!k(i)}u(i,n,o,h,t,f,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${h}.`);const u=o;this.j.add(u);const E=h===void 0?o:h,y={elevationRequired:t?this.isPortPrivileged(E):!1},$={remoteAddress:{host:n,port:o},localAddressPort:h,privacy:f,public:f?f!==g.Private:void 0,protocol:c},I=i.forwardPort($,y);return I?(this.q(n,o,I),I.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),I}};e.$Pv=a,e.$Pv=a=Je([qe(0,R.$sj),qe(1,P.$Ei)],a)}),define(Le[199],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Qv=void 0,e.$Qv=(0,S.$$h)("editSessionIdentityService");var M;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Le[200],Me([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=void 0;function M(g){return g.scheme!==S.Schemas.file&&g.scheme!==S.Schemas.vscodeRemote}e.$1K=M;function P(g){if(g.folders.length)return g.folders.every(D=>M(D.uri))?g.folders[0].uri:void 0;if(g.configuration&&M(g.configuration))return g.configuration}e.$2K=P;function N(g){return P(g)?.scheme}e.$3K=N;function R(g){return P(g)?.authority}e.$4K=R;function m(g){return P(g)!==void 0}e.$5K=m}),define(Le[48],Me([1,0,157,19,51,24,2,4,12]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.WorkbenchState=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,m.$$h)("contextService");function D(u){const E=u;return typeof E?.id=="string"&&R.URI.isUri(E.uri)}e.$ii=D;function A(u){return typeof u?.id=="string"&&!D(u)&&!l(u)}e.$ji=A,e.$ki={id:"ext-dev"},e.$li={id:"empty-window"};function k(u,E){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,M.$nc)(u)}:E?e.$ki:e.$li;const y=u;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}e.$mi=k;function l(u){const E=u;return typeof E?.id=="string"&&R.URI.isUri(E.configPath)}e.$ni=l;function v(u){const E=u;if(E?.uri)return{id:E.id,uri:R.URI.revive(E.uri)};const y=u;if(y?.configPath)return{id:y.id,configPath:R.URI.revive(y.configPath)};if(u?.id)return{id:u.id}}e.$oi=v;var p;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function s(u){const E=u;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.$pi=s;function a(u){const E=u;return!!(E&&typeof E=="object"&&R.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.$qi=a;class r{constructor(E,y,$,I,d){this.h=E,this.j=$,this.k=I,this.l=d,this.c=P.$ei.forUris(this.l,()=>!0),this.folders=y}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=P.$ei.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ri=r;class i{constructor(E,y){this.raw=y,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,N.$Lg)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$si=i;function n(u){return new i({uri:u,index:0,name:(0,N.$Hg)(u)},{uri:u.toString()})}e.$ti=n,e.$ui="code-workspace",e.$vi=`.${e.$ui}`,e.$wi=[{name:(0,S.localize)(0,null),extensions:[e.$ui]}],e.$xi="workspace.json";function o(u,E){return N.$Cg.isEqualOrParent(u,E.untitledWorkspacesHome)}e.$yi=o;function h(u){let E;return R.URI.isUri(u)?E=u:E=u.configuration,E?.scheme===g.Schemas.tmp}e.$zi=h,e.$Ai="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$Ai}e.$Bi=t;function f(u,E){return!o(u,E)&&!h(u)}e.$Ci=f;function c(u){return(typeof u=="string"?(0,M.$oc)(u):(0,N.$Jg)(u))===e.$vi}e.$Di=c}),define(Le[74],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class S{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const N=this.c++;return this.b.set(N,P),this.e(),N}get(P,N){return this.b.has(P)?this.b.get(P)[N]:void 0}delete(P){this.b.delete(P),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Sgc=S}),define(Le[43],Me([1,0,12,24,4]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;class N{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new M.$Ag(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$Xgc=N,e.$Ygc=(0,P.$$h)("IExtHostFileSystemInfo")}),define(Le[27],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZN=void 0,e.$ZN=(0,S.$$h)("IExtHostInitDataService")}),define(Le[201],Me([1,0,163,14,188,27]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ic=void 0;let R=class extends P.$7O{constructor(g,D,A){const k=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,S.localize)(0,null):g?(0,S.localize)(1,null):(0,S.localize)(2,null);super(D.createLogger(k,{name:l}))}};e.$3ic=R,e.$3ic=R=Je([qe(1,M.$tj),qe(2,N.$ZN)],R)}),define(Le[202],Me([1,0,11]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=e.$Ehc=void 0;class M{constructor(R,m,g){this.h=new Map,this.a=R,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new S.$kh(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of D.values())A.complete()}catch(A){for(const k of D.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let g=this.f[R];return typeof g>"u"&&(g=m),g}update(R,m){this.f[R]=m;const g=this.h.get(R);if(g!==void 0)return g.p;const D=new S.$vh;return this.h.set(R,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$Ehc=M;class P extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$Fhc=P}),define(Le[203],Me([1,0,5,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;class P{constructor(R){this.c=R,this.a=new S.$Yd,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$Yd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,g,D){const k=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(m.value,g,D);this.b.fire(k)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$sic=P}),define(Le[17],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=void 0,e.$JN=(0,S.$$h)("IExtHostRpcService");class M{constructor(N){this.getProxy=N.getProxy.bind(N),this.set=N.set.bind(N),this.dispose=N.dispose.bind(N),this.assertRegistered=N.assertRegistered.bind(N),this.drain=N.drain.bind(N)}}e.$KN=M}),define(Le[204],Me([1,0,22,5]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=void 0;class P{#e;constructor(R,m){this.b=new M.$Yd,this.onDidChange=this.b.event,this.a=S.$qm.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$Mhc=P}),define(Le[58],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=void 0,e.$chc=(0,S.$$h)("IURITransformerService");class M{constructor(N){N?(this.transformIncoming=N.transformIncoming.bind(N),this.transformOutgoing=N.transformOutgoing.bind(N),this.transformOutgoingURI=N.transformOutgoingURI.bind(N),this.transformOutgoingScheme=N.transformOutgoingScheme.bind(N)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$dhc=M}),define(Le[205],Me([1,0,23]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fmb=e.$emb=void 0;class M{constructor(){this.buffers=[]}add(g){let D=this.buffers.indexOf(g);return D<0&&(D=this.buffers.length,this.buffers.push(g)),D}}function P(m,g){if(g.serializeBuffersForPostMessage){const D=new M,k=JSON.stringify(m,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add(p)};if(ArrayBuffer.isView(p)){const s=N(p);if(s)return{$$vscode_array_buffer_reference$$:!0,index:D.add(p.buffer),view:{type:s,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),l=D.buffers.map(v=>{const p=new Uint8Array(v);return S.$me.wrap(p)});return{message:k,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$emb=P;function N(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,g){const D=g.map(l=>{const v=new ArrayBuffer(l.byteLength);return new Uint8Array(v).set(l.buffer),v}),A=g.length?(l,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:s}=p,a=D[s];if(p.view)switch(p.view.type){case 1:return new Int8Array(a,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return v}:void 0;return{message:JSON.parse(m,A),arrayBuffers:D}}e.$fmb=R}),define(Le[102],Me([1,0,172,16,2,6,4,30,42,12,41,135,32]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.$$E=e.$0E=e.EditorsOrder=e.$9E=e.CloseDirection=e.$8E=e.$7E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.EditorInputCapabilities=e.$XE=e.SaveReason=e.Verbosity=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=void 0,e.$KE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$LE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$ME="workbench.editor.sidebysideEditor",e.$NE="workbench.editors.textDiffEditor",e.$OE="workbench.editors.binaryResourceDiffEditor";var v;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function s(te){const X=te;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.$PE=s;function a(te,X,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===X&&te.matches(ne.input))return ne.getViewState()}e.$QE=a;function r(te){if($(te))return!1;const X=te;return P.URI.isUri(X?.resource)}e.$RE=r;function i(te){if($(te))return!1;const X=te;return X?.original!==void 0&&X.modified!==void 0}e.$SE=i;function n(te){if($(te))return!1;const X=te;return!X||X.resources&&!Array.isArray(X.resources)?!1:!!X.resources||!!X.multiDiffSource}e.$TE=n;function o(te){if($(te)||i(te))return!1;const X=te;return X?.primary!==void 0&&X.secondary!==void 0}e.$UE=o;function h(te){if($(te))return!1;const X=te;return X?X.resource===void 0||X.resource.scheme===D.Schemas.untitled||X.forceUntitled===!0:!1}e.$VE=h;function t(te){if($(te))return!1;const X=te;return P.URI.isUri(X?.base?.resource)&&P.URI.isUri(X?.input1?.resource)&&P.URI.isUri(X?.input2?.resource)&&P.URI.isUri(X?.result?.resource)}e.$WE=t;var f;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var c;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class u{constructor(){this.a=new Map}registerSource(X,V){let ne=this.a.get(X);return ne||(ne={source:X,label:V},this.a.set(X,ne)),ne.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$XE=new u;var E;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad",te[te.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(E||(e.EditorInputCapabilities=E={}));class y extends N.$Tc{}e.$YE=y;function $(te){return te instanceof y}e.$ZE=$;function I(te){const X=te;return P.URI.isUri(X?.preferredResource)}function d(te){const X=te;return $(X?.primary)&&$(X?.secondary)}e.$1E=d;function w(te){const X=te;return $(X?.modified)&&$(X?.original)}e.$2E=w;function b(te,X,V,ne,Ce){return $e(ne,[(0,k.$Ui)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Fe={...V,limits:{size:Number.MAX_VALUE}};te.openEditor(X,Fe)}}),(0,k.$Ui)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$3E=b;function L(te){return $(te?.editor)}e.$4E=L;function T(te){const X=te;return L(te)&&X?.group!==void 0}e.$5E=T;function Y(te){const X=te;return typeof X?.groupId=="number"&&$(X.editor)}e.$6E=Y;var q;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var U;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_STICKY=11]="EDITOR_STICKY",te[te.EDITOR_DIRTY=12]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class F{getOriginalUri(X,V){if(!X)return;if(t(X))return e.$8E.getOriginalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ce,secondary:Fe}=this.a(X);if(Ce&&Fe){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Fe,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ce,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Fe,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ce:Fe}}if(i(X)||n(X)||o(X)||t(X))return;const ne=I(X)?X.preferredResource:X.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(X){return d(X)||o(X)?{primary:X.primary,secondary:X.secondary}:w(X)||i(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,V){if(!X)return;if(t(X))return e.$8E.getCanonicalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ce,secondary:Fe}=this.a(X);if(Ce&&Fe){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Fe,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ce,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Fe,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ce:Fe}}if(i(X)||n(X)||o(X)||t(X))return;const ne=X.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(X,V){if(Array.isArray(V)){if(V.some(ne=>X.scheme===ne))return X}else if(V===X.scheme)return X}}var W;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function re(te,X,V,ne){if(!te.isSticky(X))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===W.MOUSE||V===W.KEYBOARD;case"mouse":return V===W.MOUSE;case"keyboard":return V===W.KEYBOARD}return!1}e.$7E=re,e.$8E=new F;var ue;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(X){const V=this.a=X.get(R.$0h);for(const[ne,Ce]of this.c)this.e(ne,Ce,V);this.c.clear()}e(X,V,ne){const Ce=ne.createInstance(V);this.d.set(X,Ce)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,M.$Xf)(this.b)}registerEditorSerializer(X,V){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,V,this.a):this.c.set(X,V),(0,N.$Rc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}m.$Nn.add(e.$KE.EditorFactory,new ye);async function ke(te,X,V){return!te||!te.length?[]:await Promise.all(te.map(async ne=>{const Ce=P.URI.revive(ne.fileUri);if(!Ce){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await X.canHandleResource(Ce)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Pe=ne.exists,we=ne.type;if(typeof Pe!="boolean"||typeof we!="number")try{we=(await X.stat(Ce)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Pe=!0}catch(J){V.error(J),Pe=!1}if(!Pe&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(we===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const me={...ne.options,pinned:!0};return Pe?{resource:Ce,options:me}:{resource:Ce,options:me,forceUntitled:!0}}))}e.$9E=ke;var he;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ve(te){const X=te;if(!X)return!1;const V=X;if(V.modified)return ve(V.modified);const ne=X;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$0E=ve;function se(te){return(0,A.$Wi)(te)}e.$$E=se;function $e(te,X,V){const ne=(0,A.$Xi)(te,X);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$_E=$e}),define(Le[206],Me([1,0,5,173,4,6,28,30,18,26,89,197]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$fF=e.ViewContentGroups=e.$eF=e.$dF=e.ViewContainerLocation=e.Extensions=e.$cF=e.$bF=e.$aF=void 0,e.$aF="views",e.$bF=(0,M.localize)(0,null),e.$cF=(0,k.$Cw)("default-view-icon",A.$ek.window,(0,M.localize)(1,null));var l;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var v;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$dF=[0,1,2];function p(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$eF=p;class s extends N.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Yd),this.onDidRegister=this.c.event,this.f=this.B(new S.$Yd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(c,u,E){const y=this.get(c.id);if(y)return y;const $=c;return $.openCommandActionDescriptor=E?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,u,[]).push($),E?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:u}),$}deregisterViewContainer(c){for(const u of this.g.keys()){const E=this.g.get(u),y=E?.indexOf(c);if(y!==-1){E?.splice(y,1),E.length===0&&this.g.delete(u),this.f.fire({viewContainer:c,viewContainerLocation:u});return}}}get(c){return this.all.filter(u=>u.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(E=>E?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(u=>this.getViewContainerLocation(u)===c)}}m.$Nn.add(l.ViewContainersRegistry,new s);var a;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(a||(e.ViewContentGroups=a={}));function r(f,c){const u=f.group??a.More,E=c.group??a.More;return u!==E?u.localeCompare(E):(f.order??5)-(c.order??5)}class i extends N.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Yd),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$Yd),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$Yd),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$Yd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(c,u){this.registerViews2([{views:c,viewContainer:u}])}registerViews2(c){c.forEach(({views:u,viewContainer:E})=>this.r(u,E)),this.c.fire(c)}deregisterViews(c,u){const E=this.s(c,u);E.length&&this.f.fire({views:E,viewContainer:u})}moveViews(c,u){for(const E of this.m.keys())if(E!==u){const y=this.s(c,E);y.length&&(this.r(y,u),this.g.fire({views:y,from:E,to:u}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const u of this.j){const E=(this.m.get(u)||[]).filter(y=>y.id===c)[0];if(E)return E}return null}getViewContainer(c){for(const u of this.j)if((this.m.get(u)||[]).filter(y=>y.id===c)[0])return u;return null}registerViewWelcomeContent(c,u){return this.n.add(c,u),this.h.fire(c),(0,N.$Rc)(()=>{this.n.delete(c,u),this.h.fire(c)})}registerViewWelcomeContent2(c,u){const E=new Map;for(const[y,$]of u)this.n.add(c,$),E.set(y,(0,N.$Rc)(()=>{this.n.delete(c,$),this.h.fire(c)}));return this.h.fire(c),E}getViewWelcomeContent(c){const u=[];return this.n.forEach(c,E=>u.push(E)),u.sort(r)}r(c,u){let E=this.m.get(u);E||(E=[],this.m.set(u,E),this.j.push(u));for(const y of c){if(this.getView(y.id)!==null)throw new Error((0,M.localize)(2,null,y.id));E.push(y)}}s(c,u){const E=this.m.get(u);if(!E)return[];const y=[],$=[];for(const I of E)c.includes(I)?y.push(I):$.push(I);return y.length&&($.length?this.m.set(u,$):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),y}}m.$Nn.add(l.ViewsRegistry,new i),e.$fF=(0,P.$$h)("viewDescriptorService");var n;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class h{constructor(c,u){this.c=!1,this.d=!1,(0,D.$En)(this,c),this.d=!!u,this.resolve=async E=>{if(u&&!this.c){const y=await u(E);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}E.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$gF=h;class t extends Error{constructor(c){super((0,M.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$hF=t}),define(Le[207],Me([1,0,2,29,4]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$pF=e.$oF=void 0;function N(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof S.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(M.$Zs.isIRange)}e.$oF=N;function R(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(N)}e.$pF=R;var m;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(g||(e.ChatAgentCopyKind=g={})),e.$qF=(0,P.$$h)("IChatService"),e.$rF="accessibility.voice.keywordActivation"}),define(Le[208],Me([1,0,5,11,174]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmb=void 0;class N{constructor(){this.f=new Map,this.m=[],this.n=new S.$Yd,this.o=new S.$Yd,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,g,D,A){const k={command:m};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.u("request",k),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const v=this.f.get(k.seq);if(v){this.f.delete(k.seq);const p={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,P.localize)(0,null,A,m)};v(p)}},A)}return D&&this.f.set(k.seq,D),k.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,g){return m.type!=="event"||g.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,M.$_g)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,D=this.f.get(g.request_seq);D&&(this.f.delete(g.request_seq),D(g));break}}}}u(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,D)=>m.set(D,g)),await(0,M.$_g)(500),m.forEach((g,D)=>{g({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Kmb=N}),define(Le[209],Me([1,0,2,175,35,4]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$2H=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$1H=e.MemoryRangeType=e.$ZH=e.State=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=void 0,e.$RG="workbench.view.debug",e.$SG="workbench.debug.variablesView",e.$TG="workbench.debug.watchExpressionsView",e.$UG="workbench.debug.callStackView",e.$VG="workbench.debug.loadedScriptsView",e.$WG="workbench.debug.breakPointsView",e.$XG="workbench.debug.disassemblyView",e.$YG="workbench.panel.repl",e.$ZG="workbench.panel.repl.view",e.$1G=new P.$pj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$2G=new P.$pj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$3G=new P.$pj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$4G="debugUx",e.$5G=new P.$pj(e.$4G,"default",{type:"string",description:M.localize(3,null)}),e.$6G=new P.$pj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$7G=new P.$pj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$8G=new P.$pj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$9G=new P.$pj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$0G=new P.$pj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$$G=new P.$pj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$_G=new P.$pj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$aH=new P.$pj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$bH=new P.$pj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$cH=new P.$pj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$dH=new P.$pj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$eH=new P.$pj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$fH=new P.$pj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$gH=new P.$pj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$hH=new P.$pj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$iH=new P.$pj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$jH=new P.$pj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$kH=new P.$pj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$lH=new P.$pj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(22,null)}),e.$mH=new P.$pj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(23,null)}),e.$nH=new P.$pj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(24,null)}),e.$oH=new P.$pj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(25,null)}),e.$pH=new P.$pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(26,null)}),e.$qH=new P.$pj("stepBackSupported",!1,{type:"boolean",description:M.localize(27,null)}),e.$rH=new P.$pj("restartFrameSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$sH=new P.$pj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(29,null)}),e.$tH=new P.$pj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$uH=new P.$pj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$vH=new P.$pj("breakpointsExist",!1,{type:"boolean",description:M.localize(32,null)}),e.$wH=new P.$pj("debuggersAvailable",!1,{type:"boolean",description:M.localize(33,null)}),e.$xH=new P.$pj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(34,null)}),e.$yH=new P.$pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(35,null)}),e.$zH=new P.$pj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(36,null)}),e.$AH=new P.$pj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$BH=new P.$pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$CH=new P.$pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$DH=new P.$pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$EH=new P.$pj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$FH=new P.$pj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$GH=new P.$pj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(43,null)}),e.$HH=new P.$pj("variableIsReadonly",!1,{type:"boolean",description:M.localize(44,null)}),e.$IH=new P.$pj("variableValue",!1,{type:"string",description:M.localize(45,null)}),e.$JH=new P.$pj("variableType",!1,{type:"string",description:M.localize(46,null)}),e.$KH=new P.$pj("variableName",!1,{type:"string",description:M.localize(47,null)}),e.$LH=new P.$pj("variableLanguage",!1,{type:"string",description:M.localize(48,null)}),e.$MH=new P.$pj("variableExtensionId",!1,{type:"string",description:M.localize(49,null)}),e.$NH=new P.$pj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(50,null)}),e.$OH=new P.$pj("multiSessionRepl",!1,{type:"boolean",description:M.localize(51,null)}),e.$PH=new P.$pj("multiSessionDebug",!1,{type:"boolean",description:M.localize(52,null)}),e.$QH=new P.$pj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(53,null)}),e.$RH=new P.$pj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(54,null)}),e.$SH=new P.$pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(55,null)}),e.$TH=new P.$pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(56,null)});const R=r=>M.localize(57,null,r);e.$UH=R,e.$VH="editor.contrib.debug",e.$WH="editor.contrib.breakpoint",e.$XH="debug",e.$YH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(58,null)};var m;(function(r){r[r.Inactive=0]="Inactive",r[r.Initializing=1]="Initializing",r[r.Stopped=2]="Stopped",r[r.Running=3]="Running"})(m||(e.State=m={}));function g(r){switch(r){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$ZH=g;var D;(function(r){r[r.Valid=0]="Valid",r[r.Unreadable=1]="Unreadable",r[r.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$1H="vscode-debug-memory";var A;(function(r){r[r.Initial=1]="Initial",r[r.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var k;(function(r){r.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$2H=(0,N.$$h)("debugService");var l;(function(r){r[r.CONDITION=0]="CONDITION",r[r.HIT_COUNT=1]="HIT_COUNT",r[r.LOG_MESSAGE=2]="LOG_MESSAGE",r[r.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var v;(function(r){r[r.Command=0]="Command",r[r.Tree=1]="Tree"})(v||(e.DebugVisualizationType=v={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p||(e.DebugTreeItemCollapsibleState=p={}));var s;(function(r){r.deserialize=i=>i,r.serialize=i=>i})(s||(e.IDebugVisualizationTreeItem=s={}));var a;(function(r){r.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:S.URI.revive(i.iconPath.light),dark:S.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),r.serialize=i=>i})(a||(e.IDebugVisualization=a={}))}),define(Le[210],Me([1,0,13,2,19,26,12,29,21,18]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0;const A=/{([^}]+)}/g;function k(I,d,w){return I.replace(A,function(b,L){return d&&L.length>0&&L[0]!=="_"?b:w&&w.hasOwnProperty(L)?w[L]:b})}e.$gG=k;function l(I){const d={};for(const w of Object.keys(I))w.startsWith("!")||(d[w]=I[w]);return d}e.$hG=l;function v(I){return I.configuration.request==="attach"&&!p(I)&&(!I.parentSession||v(I.parentSession))}e.$iG=v;function p(I){let d=I.configuration.type;if(d)return d==="vslsShare"&&(d=I.configuration.adapterProxy.configuration.type),(0,S.$df)(d,"extensionhost")||(0,S.$df)(d,"pwa-extensionhost")?I:I.parentSession?p(I.parentSession):void 0}e.$jG=p;function s(I){return I.type&&(I.label||I.program||I.runtime)}e.$kG=s;function a(I,d,w){let b,L=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Y=null;for(;Y=T.exec(I);){const q=Y.index+1,U=q+Y[0].length;if(q<=d&&U>=w){b=Y[0],L=q;break}}if(b){const q=/\w+/g;let U=null;for(;(U=q.exec(b))&&!(U.index+1+L+U[0].length>=w););U&&(b=b.substring(0,q.lastIndex))}return b?{start:L,end:L+b.length-1}:{start:0,end:0}}e.$lG=a;async function r(I,d,w,b){if(I.evaluatableExpressionProvider.has(d)){const L=I.evaluatableExpressionProvider.ordered(d),T=(0,D.$Hb)(await Promise.all(L.map(async Y=>{try{return await Y.provideEvaluatableExpression(d,w,b??g.CancellationToken.None)}catch{return}})));if(T.length>0){let Y=T[0].expression;const q=T[0].range;return Y||(Y=d.getLineContent(w.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:Y}}}else{const L=d.getLineContent(w.lineNumber),{start:T,end:Y}=a(L,w.column,w.column),q=L.substring(T-1,Y);return{matchingExpression:q,range:new m.$Zs(w.lineNumber,T,w.lineNumber,T+q.length)}}return null}e.$mG=r;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(I){return!!(I&&I.match(i))}e.$nG=n;function o(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(n(I.path))return M.URI.parse(I.path);if((0,P.$ic)(I.path))return M.URI.file(I.path)}return I.path}function h(I){if(typeof I.path=="object"){const d=M.URI.revive(I.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return I.path}function t(I,d){const w=d?o:h,b=(0,N.$Bn)(I);return c(b,(L,T)=>{L&&T&&(T.path=w(T))}),b}e.$oG=t;function f(I,d){const w=d?o:h,b=(0,N.$Bn)(I);return c(b,(L,T)=>{!L&&T&&(T.path=w(T))}),b}e.$pG=f;function c(I,d){switch(I.type){case"event":{const w=I;switch(w.event){case"output":d(!1,w.body.source);break;case"loadedSource":d(!1,w.body.source);break;case"breakpoint":d(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=I;switch(w.command){case"setBreakpoints":d(!0,w.arguments.source);break;case"breakpointLocations":d(!0,w.arguments.source);break;case"source":d(!0,w.arguments.source);break;case"gotoTargets":d(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(b=>d(!1,b));break;default:break}break}case"response":{const w=I;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(b=>d(!1,b.source));break;case"loadedSources":w.body.sources.forEach(b=>d(!1,b));break;case"scopes":w.body.scopes.forEach(b=>d(!1,b.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(b=>d(!1,b.source));break;case"setBreakpoints":w.body.breakpoints.forEach(b=>d(!1,b.source));break;case"disassemble":w.body?.instructions.forEach(L=>d(!1,L.location));break;default:break}break}}}function u(I){return I.filter(d=>!d.presentation?.hidden).sort((d,w)=>d.presentation?w.presentation?d.presentation.group?w.presentation.group?d.presentation.group!==w.presentation.group?d.presentation.group.localeCompare(w.presentation.group):E(d.presentation.order,w.presentation.order):-1:w.presentation.group?1:E(d.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$qG=u;function E(I,d){return typeof I!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:I-d}async function y(I,d){const w=I.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(w!=="none"&&(await d.saveAll(),w==="allEditorsInActiveGroup")){const b=d.activeEditorPane;b&&b.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}e.$rG=y;const $=(I,d)=>!I||!d?I===d:I.name===d.name&&I.path===d.path&&I.sourceReference===d.sourceReference;e.$sG=$}),define(Le[211],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=e.CellExecutionUpdateType=void 0;var M;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$xJ=(0,S.$$h)("INotebookExecutionService")}),define(Le[212],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fb=e.$6fb=e.ProxyKernelState=e.$5fb=void 0,e.$5fb=100;var M;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$6fb=(0,S.$$h)("INotebookKernelService"),e.$7fb=(0,S.$$h)("INotebookKernelHistoryService")}),define(Le[213],Me([1,0,6,29,145,93]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qSb=void 0;class R extends S.$Tc{constructor(g,D,A){super(),this._source=g,this.b=D,this.c=A,this.a=void 0}f(g){const D=g.getLineCount();return new M.$Zs(1,1,D,this.g(g,D))}g(g,D){if(D<1||D>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const g=new P.$hC;g.acceptChunk(this._source);const D=g.finish(!0),{textBuffer:A,disposable:k}=D.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const D=new P.$hC;D.acceptChunk(g);const A=D.finish(!0),{textBuffer:k,disposable:l}=A.create(1);return this.B(l),k})),this.a}findInInputs(g){const A=new N.$8B(g,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(g){const A=new N.$8B(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$qSb=R}),define(Le[49],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(N){N.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var M;(function(N){N[N.IsSame=0]="IsSame",N[N.Disconnected=1]="Disconnected",N[N.IsChild=2]="IsChild",N[N.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class P{static fromExtHostTestItem(R,m,g=R.parent){if(R._isRoot)return new P([m]);const D=[R.id];for(let A=g;A&&A.id!==m;A=A.parent)D.push(A.id);return D.push(m),new P(D.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new P(R.split("\0"))}static join(R,m){return new P([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:P.isChild(R,m)?2:P.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$iK=P}),define(Le[59],Me([1,0,2,91,29,49]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$pK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$oK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nK=e.$mK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kK=e.$jK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$jK=[2,4,8,16,32,64];const D=C=>"runId"in C;e.$kK=D;var A;(function(C){C.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),C.deserialize=(F,W)=>({range:P.$Zs.lift(W.range),uri:F.asCanonicalUri(S.URI.revive(W.uri))})})(A||(e.IRichLocation=A={}));var k;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(C){C.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&A.serialize(F.location)}),C.deserialize=(F,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&A.deserialize(F,W.location)})})(l||(e.ITestErrorMessage=l={}));const v=(C,F)=>`${F?"s":"e"}${C}`;e.$lK=v;var p;(function(C){C.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&A.serialize(F.location)}),C.deserialize=(F,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&A.deserialize(F,W.location)})})(p||(e.ITestOutputMessage=p={}));var s;(function(C){C.serialize=F=>F.type===0?l.serialize(F):p.serialize(F),C.deserialize=(F,W)=>W.type===0?l.deserialize(F,W):p.deserialize(F,W)})(s||(e.ITestMessage=s={}));var a;(function(C){C.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),C.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(s.serialize)}),C.deserialize=(F,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(re=>s.deserialize(F,re))})})(a||(e.ITestTaskState=a={}));const r="\0",i=(C,F)=>C+r+F;e.$mK=i;const n=C=>{const F=C.indexOf(r);return{ctrlId:C.slice(0,F),tagId:C.slice(F+1)}};e.$nK=n;var o;(function(C){C.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),C.deserialize=(F,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?F.asCanonicalUri(S.URI.revive(W.uri)):void 0,range:W.range?P.$Zs.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(o||(e.ITestItem=o={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(C){C.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),C.deserialize=(F,W)=>({controllerId:N.$iK.root(W.item.extId),expand:W.expand,item:o.deserialize(F,W.item)})})(t||(e.InternalTestItem=t={}));var f;(function(C){C.serialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.uri!==void 0&&(W.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(W.range=F.item.range?.toJSON()),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}},C.deserialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.range!==void 0&&(W.range=F.item.range?P.$Zs.lift(F.item.range):null),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}}})(f||(e.ITestItemUpdate=f={}));const c=(C,F)=>{F.expand!==void 0&&(C.expand=F.expand),F.item!==void 0&&(C.item=C.item?Object.assign(C.item,F.item):F.item)};e.$oK=c;var u;(function(C){C.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(a.serializeWithoutMessages)}),C.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(a.serialize)}),C.deserialize=(F,W)=>({...t.deserialize(F,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(re=>a.deserialize(F,re)),retired:!0})})(u||(e.TestResultItem=u={}));var E;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(F,W)=>{F.covered+=W.covered,F.total+=W.total}})(E||(e.ICoveredCount=E={}));var y;(function(C){C.serialize=F=>({statement:F.statement,branch:F.branch,declaration:F.declaration,details:F.details?.map(w.serialize),uri:F.uri.toJSON()}),C.deserialize=(F,W)=>({statement:W.statement,branch:W.branch,declaration:W.declaration,details:W.details?.map(w.deserialize),uri:F.asCanonicalUri(S.URI.revive(W.uri))})})(y||(e.IFileCoverage=y={}));function $(C){return{...C,location:C.location?.toJSON()}}function I(C){return C.location=C.location?M.$Ys.isIPosition(C.location)?M.$Ys.lift(C.location):P.$Zs.lift(C.location):void 0,C}e.$pK=3;var d;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(d||(e.DetailType=d={}));var w;(function(C){C.serialize=F=>F.type===0?L.serialize(F):T.serialize(F),C.deserialize=F=>F.type===0?L.deserialize(F):T.deserialize(F)})(w||(e.CoverageDetails=w={}));var b;(function(C){C.serialize=$,C.deserialize=I})(b||(e.IBranchCoverage=b={}));var L;(function(C){C.serialize=$,C.deserialize=I})(L||(e.IDeclarationCoverage=L={}));var T;(function(C){C.serialize=F=>({...$(F),branches:F.branches?.map(b.serialize)}),C.deserialize=F=>({...I(F),branches:F.branches?.map(b.deserialize)})})(T||(e.IStatementCoverage=T={}));var Y;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(Y||(e.TestDiffOpType=Y={}));var q;(function(C){C.deserialize=(F,W)=>W.op===0?{op:W.op,item:t.deserialize(F,W.item)}:W.op===1?{op:W.op,item:f.deserialize(W.item)}:W.op===2?{op:W.op,uri:F.asCanonicalUri(S.URI.revive(W.uri)),docv:W.docv}:W,C.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:f.serialize(F.item)}:F})(q||(e.TestsDiffOp=q={}));class U{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const W=this.v();for(const re of F)switch(re.op){case 0:this.l(t.deserialize(this.k,re.item),W);break;case 1:this.o(f.deserialize(re.item),W);break;case 3:this.p(re.itemId,W);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}W.complete?.()}l(F,W){const re=N.$iK.parentId(F.item.extId)?.toString();let ue;if(!re)ue=this.w(F),this.g.add(ue),this.f.set(F.item.extId,ue);else if(this.f.has(re)){const ye=this.f.get(re);ye.children.add(F.item.extId),ue=this.w(F,ye),this.f.set(F.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return W.add?.(ue),F.expand===2&&this.h++,ue}o(F,W){const re=this.f.get(F.extId);if(re)return F.expand!==void 0&&(re.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$oK)(re,F),W.update?.(re),re}p(F,W){const re=this.f.get(F);if(!re)return;const ue=N.$iK.parentId(re.item.extId)?.toString();ue?this.f.get(ue).children.delete(re.item.extId):this.g.delete(re);const ye=[[F]];for(;ye.length;)for(const ke of ye.pop()){const he=this.f.get(ke);he&&(ye.push(he.children),this.f.delete(ke),W.remove?.(he,he!==re),he.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$qK=U}),define(Le[75],Me([1,0,11,5,6,54,59,49]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.TestItemEventOp=void 0;var g;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const D=(i,n)=>i===n,k=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:D,label:D,description:D,error:D,sortText:D,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),l=(i,n)=>{let o;for(const[h,t]of k)t(i[h],n[h])||(o?o[h]=n[h]:o={[h]:n[h]});return o};class v extends P.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new S.$kh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Yd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$oK)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$oK)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const h=this.tree.get(n);if(h){if((h.expandLevels===void 0||o>h.expandLevels)&&(h.expandLevels=o),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,o-1):t.wait().then(()=>this.L(h,o-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,o-1)):this.L(h,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case 3:this.O(m.$iK.joinToString(n.fullId,o.id));break;case 0:this.z(o.item,n);break;case 5:for(const h of o.ops)this.w(n,h);break;case 1:this.C(o.new,o.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.y(n.actual.uri);break;default:(0,N.$9c)(o)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const h=m.$iK.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(h.toString());if(!f){f={fullId:h,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,o);return}if(f.actual===n){this.H(n,f,o);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(h.toString()),this.z(n,o);const c=this.s.getChildren(f.actual),u=f.actual,E=l(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,f.actual=n,f.expand=0,E&&(E.hasOwnProperty("tags")&&(this.C(n.tags,u.tags,h.toString()),delete E.tags),this.w(f,{op:4,update:E})),this.I(n,f,o);for(const[y,$]of c)this.s.getChildren(n).get($.id)||this.O(m.$iK.joinToString(h,$.id));this.y(f.actual.uri)}C(n,o,h){const t=new Set(o.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:h,item:{tags:n.map(f=>(0,R.$mK)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$mK)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$mK)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,h){this.G(n,h);const t=this.s.getApiFor(n);t.parent=h?.actual,t.listener=f=>this.w(o,f),this.J(o)}I(n,o,h){this.H(n,o,h);for(const[t,f]of this.s.getChildren(n))this.z(f,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const h=[];for(const[t,f]of this.s.getChildren(n.actual)){const c=this.expand(m.$iK.joinToString(n.fullId,f.id),o);(0,S.$Wg)(c)&&h.push(c)}if(h.length)return Promise.all(h).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new S.$0g;return f.open(),f}n.expand=2,this.N(n);const o=n.resolveBarrier=new S.$0g,h=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){h(f)}return(0,S.$Wg)(t)?t.catch(h).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const h=[o];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,c]of this.s.getChildren(t.actual))h.push(this.tree.get(m.$iK.joinToString(t.fullId,c.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$zN=v;class p extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$AN=p;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$BN=s;class a extends Error{constructor(n,o,h){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${h}".`)}}e.$CN=a;const r=(i,n,o)=>{let h=new Map;return{get size(){return h.size},forEach(t,f){for(const c of h.values())t.call(f,c,this)},[Symbol.iterator](){return h.entries()},replace(t){const f=new Map,c=new Set(h.keys()),u={op:5,ops:[]};for(const E of t){if(!(E instanceof o))throw new s(E.id);const y=n(E).controllerId;if(y!==i.controllerId)throw new a(E.id,y,i.controllerId);if(f.has(E.id))throw new p(E.id);f.set(E.id,E),c.delete(E.id),u.ops.push({op:0,item:E})}for(const E of c.keys())u.ops.push({op:3,id:E});i.listener?.(u),h=f},add(t){if(!(t instanceof o))throw new s(t.id);h.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){h.delete(t)&&i.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$DN=r}),define(Le[103],Me([1,0,75]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=void 0;const M=new WeakMap,P=(R,m)=>{const g={controllerId:m};return M.set(R,g),g};e.$EN=P;const N=R=>{const m=M.get(R);if(!m)throw new S.$BN(R?.id||"<unknown>");return m};e.$FN=N}),define(Le[76],Me([1,0,12,2]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2wb=e.$1wb=e.$Zwb=e.$Ywb=e.$Xwb=void 0,e.$Xwb="vscode-cdn.net",e.$Ywb=`vscode-resource.${e.$Xwb}`,e.$Zwb=`'self' https://*.${e.$Xwb}`;function P(m,g){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===S.Schemas.file&&(m=M.URI.from({scheme:S.Schemas.vscodeRemote,authority:g.authority,path:m.path})),M.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${N(m.authority)}.${e.$Ywb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$1wb=P;function N(m){return m.replace(/./g,g=>{const D=g.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?g:"-"+D.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(g,D)=>String.fromCharCode(parseInt(D,16)))}e.$2wb=R}),define(Le[214],Me([1,0,5,6,76]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class N{constructor(m,g,D){this.d=m,this.e=g,this.f=D,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,D,A,k){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===m){l=n;break}if(!l)throw new Error("not a visible editor");const v=this,p=this.a++,s=new S.$Yd,a=new S.$Yd,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,P.$1wb)(n,v.f)}get cspSource(){return P.$Zwb}set options(n){this.b=n,v.d.$setOptions(p,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(p,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return v.d.$postMessage(p,n)}},i=new class{constructor(){this.editor=m,this.line=g,this.height=D,this.webview=r,this.onDidDispose=a.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),a.fire(),a.dispose(),s.dispose())}};return this.d.$createEditorInset(p,l.id,l.value.document.uri,g+1,D,A||{},k.identifier,k.extensionLocation),this.c.set(p,{editor:m,inset:i,onDidReceiveMessage:s}),i}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$ahc=N}),define(Le[104],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yK=e.$xK=void 0,e.$xK="__",e.$yK=(0,S.$$h)("IAuthenticationService")}),define(Le[215],Me([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wO=e.VariableKind=e.$vO=void 0,e.$vO=(0,S.$$h)("configurationResolverService");var M;(function(N){N.Unknown="unknown",N.Env="env",N.Config="config",N.Command="command",N.Input="input",N.ExtensionInstallFolder="extensionInstallFolder",N.WorkspaceFolder="workspaceFolder",N.Cwd="cwd",N.WorkspaceFolderBasename="workspaceFolderBasename",N.UserHome="userHome",N.LineNumber="lineNumber",N.SelectedText="selectedText",N.File="file",N.FileWorkspaceFolder="fileWorkspaceFolder",N.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",N.RelativeFile="relativeFile",N.RelativeFileDirname="relativeFileDirname",N.FileDirname="fileDirname",N.FileExtname="fileExtname",N.FileBasename="fileBasename",N.FileBasenameNoExtension="fileBasenameNoExtension",N.FileDirnameBasename="fileDirnameBasename",N.ExecPath="execPath",N.ExecInstallFolder="execInstallFolder",N.PathSeparator="pathSeparator",N.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class P extends Error{constructor(R,m){super(m),this.variable=R}}e.$wO=P}),define(Le[216],Me([1,0,19,73,16,26,20,94,178,215,13]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,s,a){this.h=new Map,this.a=v,this.b=p,this.g=s,a&&(this.c=a.then(r=>this.i(r)))}i(v){if(R.$i){const p=Object.create(null);return Object.keys(v).forEach(s=>{p[s.toLowerCase()]=v[s]}),p}return v}resolveWithEnvironment(v,p,s){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,s)}async resolveAsync(v,p){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,p)}async j(v,p,s,a){const r=N.$Bn(p);R.$i&&r.windows?Object.keys(r.windows).forEach(n=>r[n]=r.windows[n]):R.$j&&r.osx?Object.keys(r.osx).forEach(n=>r[n]=r.osx[n]):R.$k&&r.linux&&Object.keys(r.linux).forEach(n=>r[n]=r.linux[n]),delete r.windows,delete r.osx,delete r.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,r,s,a)}async resolveAnyAsync(v,p,s){return this.j(v,p,s)}async resolveAnyMap(v,p,s){const a=new Map;return{newConfig:await this.j(v,p,s,a),resolvedVariables:a}}resolveWithInteractionReplace(v,p,s,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,s,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,s,a,r){if(P.$Mf(s))return this.m(v,p,s,a,r);if(Array.isArray(s))return Promise.all(s.map(i=>this.l(v,p,i,a,r)));if(P.$Of(s)){const i=Object.create(null),n=await Promise.all(Object.keys(s).map(async o=>[await this.m(v,p,o,a,r),await this.l(v,p,s[o],a,r)]));for(const[o,h]of n)i[o]=h;return i}return s}m(v,p,s,a,r){return(0,A.$8e)(s,k.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(k.VARIABLE_LHS))return i;let o=await this.o(v,i,n,p,a);return r?.set(n,o),o!==i&&P.$Mf(o)&&o.match(k.VARIABLE_REGEXP)&&(o=await this.m(v,p,o,a,r)),o})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,s,a,r){let i;const n=s.split(":");n.length>1&&(s=n[0],i=n[1]);const o=f=>{const c=this.a.getFilePath();if(c)return(0,m.$2v)(c);throw new D.$wO(f,(0,g.localize)(0,null,p))},h=f=>{const c=o(f);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,m.$2v)(u)}throw new D.$wO(f,(0,g.localize)(1,null,p,S.$nc(c)))},t=f=>{if(i){const c=this.a.getFolderUri(i);if(c)return c;throw new D.$wO(f,(0,g.localize)(2,null,p,i))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new D.$wO(f,(0,g.localize)(3,null,p)):new D.$wO(f,(0,g.localize)(4,null,p))};switch(s){case"env":if(i){if(v.env){const f=v.env[R.$i?i.toLowerCase():i];if(P.$Mf(f))return f}return""}throw new D.$wO(D.VariableKind.Env,(0,g.localize)(5,null,p));case"config":if(i){const f=this.a.getConfigurationValue(a,i);if(P.$Vf(f))throw new D.$wO(D.VariableKind.Config,(0,g.localize)(6,null,p,i));if(P.$Of(f))throw new D.$wO(D.VariableKind.Config,(0,g.localize)(7,null,p,i));return f}throw new D.$wO(D.VariableKind.Config,(0,g.localize)(8,null,p));case"command":return this.p(D.VariableKind.Command,p,i,r,"command");case"input":return this.p(D.VariableKind.Input,p,i,r,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new D.$wO(D.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,p,i));return this.n(f.extensionLocation)}throw new D.$wO(D.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,p));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,m.$2v)(this.n(t(D.VariableKind.WorkspaceFolder)));case"cwd":return a||i?(0,m.$2v)(this.n(t(D.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$2v)(S.$nc(this.n(t(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new D.$wO(D.VariableKind.UserHome,(0,g.localize)(11,null,p))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new D.$wO(D.VariableKind.LineNumber,(0,g.localize)(12,null,p))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new D.$wO(D.VariableKind.SelectedText,(0,g.localize)(13,null,p))}case"file":return o(D.VariableKind.File);case"fileWorkspaceFolder":return h(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(h(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||i?S.$lc(this.n(t(D.VariableKind.RelativeFile)),o(D.VariableKind.RelativeFile)):o(D.VariableKind.RelativeFile);case"relativeFileDirname":{const f=S.$mc(o(D.VariableKind.RelativeFileDirname));if(a||i){const c=S.$lc(this.n(t(D.VariableKind.RelativeFileDirname)),f);return c.length===0?".":c}return f}case"fileDirname":return S.$mc(o(D.VariableKind.FileDirname));case"fileExtname":return S.$oc(o(D.VariableKind.FileExtname));case"fileBasename":return S.$nc(o(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=S.$nc(o(D.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-S.$oc(f).length)}case"fileDirnameBasename":return S.$nc(S.$mc(o(D.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||p}case"execInstallFolder":{const f=this.a.getAppRoot();return f||p}case"pathSeparator":case"/":return S.sep;default:try{const f=i?`${s}:${i}`:s;return this.p(D.VariableKind.Unknown,p,f,r,void 0)}catch{return p}}}}p(v,p,s,a,r){if(s&&a){const i=r===void 0?a[s]:a[r+":"+s];if(typeof i=="string")return i;throw new D.$wO(v,(0,g.localize)(14,null,p))}return p}}e.$KO=k}),define(Le[105],Me([1,0,4,102]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gD=e.$fD=e.OpenEditorContext=e.GroupsOrder=e.$eD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$dD=void 0,e.$dD=(0,S.$$h)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var N;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(N||(e.GroupOrientation=N={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function D(p){const s=p;return(0,M.$ZE)(s?.editor)&&(0,M.$ZE)(s?.replacement)}e.$eD=D;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(p){const s=p;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$fD=l;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$gD=v}),define(Le[217],Me([1,0,4,105]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=void 0,e.$hD=(0,S.$$h)("editorService"),e.$iD=-1,e.$jD=-2,e.$kD=-3;function P(N){const R=N;return typeof N=="number"||(0,M.$fD)(R)}e.$lD=P}),define(Le[218],Me([1,0,4,185]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OK=void 0,e.$OK=(0,S.$_h)(M.$fi)}),define(Le[106],Me([1,0,22,5,19,6,11]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X8b=e.$W8b=e.$V8b=e.$U8b=e.$T8b=void 0;class m{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$T8b=m;class g{static isHostExtension(i,n,o){if(n.getExtensionDescription(i))return!1;const h=o.getExtensionDescription(i);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(i,n){this.j=i,this.c=new M.$Yd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new S.$sm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=a(this.e,n),this.e=this.e.concat(i);const o=g.l(this.e);return this.e=a(this.e,o.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,o)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,u){this.addNode(c),this.addNode(u),this.c.has(c)?this.c.get(c).push(u):this.c.set(c,[u])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,u){const E=n.getArcs(c);for(let y=0;y<E.length;y++)if(!u.has(E[y]))return!1;return!0}getNodes(){return this.e}},o=new S.$sm;for(const c of i)if(o.set(c.identifier,c),c.extensionDependencies)for(const u of c.extensionDependencies)n.addArc(S.$qm.toKey(c.identifier),S.$qm.toKey(u));const h=new Set;n.getNodes().filter(c=>n.getArcs(c).length===0).forEach(c=>h.add(c));const t=n.getNodes().filter(c=>!h.has(c));let f;do{f=!1;for(let c=0;c<t.length;c++){const u=t[c];n.hasOnlyGoodArcs(u,h)&&(t.splice(c,1),c--,h.add(u),f=!0)}}while(f);return t.map(c=>o.get(c))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$U8b=g;class D{constructor(i,n){this.versionId=i,this.extensions=n}}e.$V8b=D;class A{constructor(i){this.d=new v,this.c=new g(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new k(this,n)}deltaExtensions(i,n,o){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$W8b=A;class k extends N.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$X8b=k;class l{constructor(i){this.name=i;const n=(0,R.$4g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class v{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new l(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};i.resolve((0,N.$Rc)(h))}}var p;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(p||(p={}));function s(r,i){const n=r.isBuiltin?0:r.isUnderDevelopment?2:1,o=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==o)return n-o;const h=P.$gc.basename(r.extensionLocation.path),t=P.$gc.basename(i.extensionLocation.path);return h<t?-1:h>t?1:0}function a(r,i){const n=new S.$rm(i);return r.filter(o=>!n.has(o.identifier))}}),define(Le[77],Me([1,0,23]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$zm=e.$ym=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(M||(e.UIKind=M={}));var P;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var N;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(N||(e.MessageType=N={}));function R(D){const A=S.$me.alloc(1);switch(D){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$ym=R;function m(D,A){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$zm=m;var g;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Le[60],Me([1,0,4,5,14,27,77,56,57,26,2,6,166]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4N=e.$3N=e.$2N=e.$1N=void 0;let v=class extends k.$Tc{constructor(r,i){super(),this.s=r,this.t=i,this.a=this.B(new M.$Yd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Yd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:g.$Vo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,P.$uj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,i,n){const o=this.getTelemetryDetails(),h=new p(i,n,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,i,n){this.f=r,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const i=Object.create(null);switch(i["common.extname"]=`${r.publisher}.${r.name}`,i["common.extversion"]=r.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$gl)((0,g.$2o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const h=n.filter(t=>!t.isDisposed);h.length===0?this.r.delete(o):this.r.set(o,h)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,i){const o=this.r.get(r.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(r.value),!1;let h=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),h=!0);return h}};e.$1N=v,e.$1N=v=Je([qe(0,N.$ZN),qe(1,P.$tj)],v);class p{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,i,n,o,h,t,f){this.g=n,this.h=o,this.i=h,this.j=t,this.a=new M.$Yd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(r,i){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let i="properties"in r?r.properties??{}:r;return i=(0,g.$5o)(i,[]),this.c&&(i=(0,D.$En)(i,this.c)),this.b||(i=(0,D.$En)(i,this.j)),"properties"in r?r.properties=i:r=i,r}k(r,i){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(r,i),this.h.trace(r,i))}logUsage(r,i){this.d.isUsageEnabled&&this.k(r,i)}logError(r,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,i);else{const n={name:r.name,message:r.message,stack:r.stack,cause:r.cause},o=(0,g.$5o)(n,[]),h=new Error(o.message,{cause:o.cause});h.stack=o.stack,h.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(h,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const r=this,i={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$2N=p;function s(a){const r=Date.now()-new Date(a).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$3N=s,e.$4N=(0,S.$$h)("IExtHostTelemetry")}),define(Le[25],Me([1,0,5,2,194,101,22,4]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=e.$RF=e.ActivationKind=e.$QF=e.$PF=e.$OF=e.$NF=e.$MF=e.ExtensionHostStartup=e.$LF=e.$KF=e.$JF=e.$IF=void 0,e.$IF=Object.freeze({identifier:new R.$qm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$JF="extensions.webWorker",e.$KF=(0,m.$$h)("extensionService");class g{constructor(h){this.dependency=h}}e.$LF=g;var D;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,t,f){this.c=h,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:N.$tF.createActivationEventsMap(this.d)}}set(h,t,f){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const c=[],u=[],E=[],y=[],$=k(this.d),I=k(t),d=(Y,q)=>Y.extensionLocation.toString()===q.extensionLocation.toString()||Y.isBuiltin===q.isBuiltin||Y.isUserBuiltin===q.isUserBuiltin||Y.isUnderDevelopment===q.isUnderDevelopment;for(const Y of this.d){const q=I.get(Y.identifier);if(!q){c.push(Y.identifier),$.delete(Y.identifier);continue}if(!d(Y,q)){c.push(Y.identifier),$.delete(Y.identifier);continue}}for(const Y of t){const q=$.get(Y.identifier);if(!q){u.push(Y);continue}if(!d(q,Y)){c.push(q.identifier),$.delete(q.identifier);continue}}const w=new R.$rm(this.e),b=new R.$rm(f);for(const Y of this.e)b.has(Y)||E.push(Y);for(const Y of f)w.has(Y)||y.push(Y);const L=N.$tF.createActivationEventsMap(u),T={versionId:h,toRemove:c,toAdd:u,addActivationEvents:L,myToRemove:E,myToAdd:y};return this.delta(T),T}delta(h){if(this.c>=h.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:c,myToAdd:u}=h,E=new R.$rm(t),y=new R.$rm(c);for(let $=0;$<this.d.length;$++)E.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)y.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of f)this.d.push($);for(const $ of u)this.e.push($);return this.f=null,h}containsExtension(h){for(const t of this.e)if(R.$qm.equals(t,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=N.$tF.readActivationEvents(t);for(const c of f)h.add(c)}return h}}e.$MF=A;function k(o){const h=new R.$sm;for(const t of o)h.set(t.identifier,t);return h}function l(o,h){return o.enabledApiProposals?o.enabledApiProposals.includes(h):!1}e.$NF=l;function v(o,h){if(!l(o,h))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$OF=v;class p{constructor(h,t,f,c){this.codeLoadingTime=h,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=c}}e.$PF=p;class s{constructor(h,t){this.description=h,this.value=t}}e.$QF=s;var a;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function r(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$$o)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$RF=r;function i(o,h){return{identifier:new R.$qm((0,P.$9o)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!h,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$SF=i;class n{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,t){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$TF=n}),define(Le[219],Me([1,0,15,106,22,25,14,11]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=e.$xhc=e.$whc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(r,i,n,o){this.startup=r,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$whc=g;class D{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,i){return r===-1||i===-1?-1:i-r}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$xhc=D;class A{constructor(r,i,n,o,h,t){this.activationFailed=r,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=h,this.subscriptions=t}}e.$yhc=A;class k extends A{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$zhc=k;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Ahc=l;class v extends A{constructor(r){super(!0,r,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(r,i,n,o){this.g=o,this.a=r,this.b=i,this.c=n,this.d=new P.$sm,this.f=Object.create(null)}dispose(){for(const[r,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const r=[];for(const[i,n]of this.d)r.push(n.wait());await Promise.all(r)}isActivated(r){const i=this.d.get(r);return!!(i&&i.value)}getActivatedExtension(r){const i=this.d.get(r);if(!i||!i.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return i.value}async activateByEvent(r,i){if(this.f[r])return;const n=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,i){const n=this.a.getExtensionDescription(r);if(!n)throw new Error(`Extension '${r}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(r){const i=r.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const i=this.a.getExtensionDescription(r.id);if(!i){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this.k(r,null,[],new v(h));return this.c.onExtensionActivationError(r.id,h,new N.$LF(r.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const h of o){if(this.m(h))continue;const t=this.d.get(h);if(t){n.push(t);continue}if(this.l(h)){n.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const f=this.a.getExtensionDescription(h);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:r.reason}));continue}const c=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${h}'`),E=this.k(r,i.displayName,[],new v(u));return this.c.onExtensionActivationError(i.identifier,u,new N.$LF(h)),E}return this.k(r,i.displayName,n,null)}k(r,i,n,o){const h=new s(r.id,i,r.reason,n,o,this.c,this.g);return this.d.set(r.id,h),h}l(r){return M.$U8b.isHostExtension(r,this.a,this.b)}m(r){const i=this.b.getExtensionDescription(r);return i?!i.main&&!i.browser:!1}};e.$Bhc=p,e.$Bhc=p=Je([qe(3,R.$sj)],p);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,i,n,o,h,t,f){this.c=r,this.d=i,this.f=n,this.g=o,this.h=h,this.j=t,this.k=f,this.a=new m.$0g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const i=this.g[r];if(i.value&&!i.value.activationFailed){this.g.splice(r,1),r--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const i=new Error;if(r&&r.name&&(i.name=r.name),r&&r.message?i.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(i.stack=r.stack),this.h=new v(i),this.b&&S.$4(r))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([qe(6,R.$sj)],s)}),define(Le[220],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Le[221],Me([1,0,180,15,32,96,72,30,22,220,190,101]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=void 0;const l=m.$Nn.as(R.$On.JSONContribution);class v{constructor(h,t,f){this.a=h,this.b=t,this.c=f}d(h,t){this.a({type:h,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(P.default.Error,h)}warn(h){this.d(P.default.Warning,h)}info(h){this.d(P.default.Info,h)}}e.$CF=v;class p{static a(h){const t=new g.$rm;for(let f=0,c=h.length;f<c;f++)t.add(h[f].description.identifier);return t}static compute(h,t){if(!h||!h.length)return new p(t,[]);if(!t||!t.length)return new p([],h);const f=this.a(h),c=this.a(t),u=t.filter(y=>!f.has(y.description.identifier)),E=h.filter(y=>!c.has(y.description.identifier));return new p(u,E)}constructor(h,t){this.added=h,this.removed=t}}e.$DF=p;class s{constructor(h,t){this.name=h,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=p.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,M.$1)(h)}}}e.$EF=s;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$FF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$pm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$so}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:N.$so}},extensionKind:{description:S.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const t=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,t),h.activationEventsGenerator&&k.$tF.register(h.extensionPoint,h.activationEventsGenerator),e.$FF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(r,e.$FF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$GF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};m.$Nn.add(n.ExtensionsRegistry,new i),e.$HF=m.$Nn.as(n.ExtensionsRegistry),l.registerSchema(r,e.$FF),l.registerSchema(A.$Lj,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Le[222],Me([1,0,176,16,26,221,35,5]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var D;(function(l){function v(p,s,a){if(!p)return;const r=M.$Mf(p.type)?p.type:void 0;if(!r||r.length===0){a.error(S.localize(3,null));return}const i=[];if(Array.isArray(p.required))for(const n of p.required)M.$Mf(n)&&i.push(n);return{extensionId:s.value,taskType:r,required:i,properties:p.properties?P.$Bn(p.properties):{},when:p.when?R.$9i.deserialize(p.when):void 0}}l.from=v})(D||(D={}));const A=N.$HF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,v)=>{for(const p of l)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new m.$Yd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{A.setHandler((s,a)=>{this.c=void 0;try{for(const r of a.removed){const i=r.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const r of a.added){const i=r.value;for(const n of i){const o=D.from(n,r.description.identifier,r.collector);o&&(this.a[o.taskType]=o)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const s={type:"object",additionalProperties:!1};p.required.length>0&&(s.required=p.required.slice(0)),p.properties!==void 0?s.properties=P.$Bn(p.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[p.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$GG=new k}),define(Le[223],Me([1,0,177,16,24,26,35,222]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$QG=e.JsonSchemaVersion=e.ExecutionEngine=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$KG=e.ShellQuoting=e.$JG=e.$IG=e.$HG=void 0,e.$HG="settings",e.$IG=new R.$pj("taskRunning",!1,S.localize(0,null)),e.$JG=S.localize2(2,"Tasks");var g;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$KG="$customized",function(C){function F(W){if(!W)return C.Strong;switch(W.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=F}(g||(e.ShellQuoting=g={}));var D;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var A;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(A||(e.RevealKind=A={})),function(C){function F(W){switch(W.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=F}(A||(e.RevealKind=A={}));var k;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(C){function F(W){switch(W.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=F}(k||(e.RevealProblemKind=k={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function F(W){switch(W.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=F}(l||(e.PanelKind=l={}));var v;(function(C){C.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(C){function F(re){switch(re.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=F;function W(re){switch(re){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=W}(p||(e.RuntimeType=p={}));var s;(function(C){function F(W){return M.$Mf(W)?W:W.value}C.value=F})(s||(e.CommandString=s={}));var a;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function F(re){return re===C.Clean._id||re===C.Build._id||re===C.Rebuild._id||re===C.Test._id}C.is=F;function W(re){if(re!==void 0)return M.$Mf(re)?F(re)?{_id:re,isDefault:!1}:void 0:re}C.from=W})(a||(e.TaskGroup=a={}));var r;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var i;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function F(W){switch(W){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var n;(function(C){C.parallel="parallel",C.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class t{constructor(F,W,re,ue,ye,ke){this._label="",this._id=F,W&&(this._label=W),re&&(this.type=re),this.runOptions=ue,this.configurationProperties=ye,this._source=ke}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,W=!1){if(F===void 0)return!1;if(M.$Mf(F))return F===this._label||F===this.configurationProperties.identifier||W&&F===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$LG=t;class f extends t{constructor(F,W,re,ue,ye,ke,he,ve){super(F,re,void 0,he,ve,W),this.command={},this._source=W,this.hasDefinedMatchers=ke,ye&&(this.command=ye)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case p.Shell:W="shell";break;case p.Process:W="process";break;case p.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(F){return F instanceof f}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$HG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const re={type:e.$KG,folder:F,id:W};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Ig(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new f(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$MG=f;class c extends t{constructor(F,W,re,ue,ye,ke,he){super(F,re,ue,ke,he,W),this._source=W,this.configures=ye}static is(F){return F instanceof c}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Ig(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$HG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const re={type:e.$KG,folder:F,id:W};return JSON.stringify(re)}}e.$NG=c;class u extends t{constructor(F,W,re,ue,ye,ke,he,ve,se){super(F,re,ue,ve,se,W),this.defines=ye,this.hasDefinedMatchers=he,this.command=ke,this.icon=se.icon,this.hide=se.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof u}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new u(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$OG=u;class E extends t{constructor(F,W,re,ue,ye,ke){super(F,re,ue,ye,ke,W),this._source=W}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new E(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$PG=E;var y;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(y||(e.ExecutionEngine=y={})),function(C){C._default=C.Terminal}(y||(e.ExecutionEngine=y={}));var $;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class I{constructor(F){this.c=new Map;for(let W=0;W<F.length;W++)this.c.set(F[W].uri.toString(),W)}compare(F,W){const re=F.getWorkspaceFolder(),ue=W.getWorkspaceFolder();if(re&&ue){let ye=this.c.get(re.uri.toString());ye=ye===void 0?0:ye+1;let ke=this.c.get(ue.uri.toString());return ke=ke===void 0?0:ke+1,ye===ke?F._label.localeCompare(W._label):ye-ke}else return!re&&ue?-1:re&&!ue?1:0}}e.$QG=I;var d;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(d||(e.TaskEventKind=d={}));var w;(function(C){C.SingleRun="singleRun",C.Background="background"})(w||(e.TaskRunType=w={}));var b;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var L;(function(C){function F(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function W(ve,se,$e){return{...F(ve),kind:"start",terminalId:se,resolvedVariables:$e}}C.start=W;function re(ve,se,$e){return{...F(ve),kind:"processStarted",terminalId:se,processId:$e}}C.processStarted=re;function ue(ve,se,$e){return{...F(ve),kind:"processEnded",terminalId:se,exitCode:$e}}C.processEnded=ue;function ye(ve,se,$e){return{...F(ve),kind:"terminated",exitReason:$e,terminalId:se}}C.terminated=ye;function ke(ve,se,$e){return{...F(se),kind:ve,terminalId:$e}}C.general=ke;function he(){return{kind:"changed"}}C.changed=he})(L||(e.TaskEvent=L={}));var T;(function(C){function F(re){const ue=Object.keys(re).sort();let ye="";for(const ke of ue){let he=re[ke];he instanceof Object?he=F(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),ye+=ke+","+he+","}return ye}function W(re){const ye={_key:F(re),type:re.taskType};return Object.assign(ye,re),ye}C.create=W})(T||(e.KeyedTaskIdentifier=T={}));var Y;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(Y||(e.TaskSettingId=Y={}));var q;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var U;(function(C){function F(W,re){const ue=m.$GG.get(W.type);if(ue===void 0){const ve=N.$Bn(W);return delete ve._key,T.create(ve)}const ye=Object.create(null);ye.type=ue.taskType;const ke=new Set;ue.required.forEach(ve=>ke.add(ve));const he=ue.properties;for(const ve of Object.keys(he)){const se=W[ve];if(se!=null)ye[ve]=se;else if(ke.has(ve)){const $e=he[ve];if($e.default!==void 0)ye[ve]=N.$Bn($e.default);else switch($e.type){case"boolean":ye[ve]=!1;break;case"number":case"integer":ye[ve]=0;break;case"string":ye[ve]="";break;default:re.error(S.localize(1,null,JSON.stringify(W,void 0,0),ve));return}}}return T.create(ye)}C.createTaskIdentifier=F})(U||(e.TaskDefinition=U={}))}),define(Le[224],Me([1,0,15]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=e.$Y8b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$Y8b=M;class P extends M{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$Z8b=P}),define(Le[50],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;class S{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++S.count}}e.$Vv=S;const M=[];function P(m){const g=new S(m);return M[g.nid]=g,g}e.$Wv=P;function N(m){return M[m].sid}e.$Xv=N;class R{constructor(g){this.value=g}}e.$Yv=R}),define(Le[3],Me([1,0,50]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sL=e.$rL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$qL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var P;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var N;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(N||(e.TabModelOperationKind=N={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var D;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var A;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(a){return a._id=k.a++,a}}e.$qL=k;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$rL={MainThreadAuthentication:(0,S.$Wv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$Wv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$Wv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$Wv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$Wv)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$Wv)("MainThreadClipboard"),MainThreadCommands:(0,S.$Wv)("MainThreadCommands"),MainThreadComments:(0,S.$Wv)("MainThreadComments"),MainThreadConfiguration:(0,S.$Wv)("MainThreadConfiguration"),MainThreadConsole:(0,S.$Wv)("MainThreadConsole"),MainThreadDebugService:(0,S.$Wv)("MainThreadDebugService"),MainThreadDecorations:(0,S.$Wv)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$Wv)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$Wv)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$Wv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$Wv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$Wv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$Wv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$Wv)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$Wv)("MainThreadErrors"),MainThreadTreeViews:(0,S.$Wv)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$Wv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$Wv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$Wv)("MainThreadLanguages"),MainThreadLogger:(0,S.$Wv)("MainThreadLogger"),MainThreadMessageService:(0,S.$Wv)("MainThreadMessageService"),MainThreadOutputService:(0,S.$Wv)("MainThreadOutputService"),MainThreadProgress:(0,S.$Wv)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$Wv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$Wv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$Wv)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$Wv)("MainThreadSecretState"),MainThreadStorage:(0,S.$Wv)("MainThreadStorage"),MainThreadSpeech:(0,S.$Wv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$Wv)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$Wv)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$Wv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$Wv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$Wv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$Wv)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$Wv)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$Wv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$Wv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$Wv)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$Wv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$Wv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$Wv)("MainThreadExtensionService"),MainThreadSCM:(0,S.$Wv)("MainThreadSCM"),MainThreadSearch:(0,S.$Wv)("MainThreadSearch"),MainThreadShare:(0,S.$Wv)("MainThreadShare"),MainThreadTask:(0,S.$Wv)("MainThreadTask"),MainThreadWindow:(0,S.$Wv)("MainThreadWindow"),MainThreadLabelService:(0,S.$Wv)("MainThreadLabelService"),MainThreadNotebook:(0,S.$Wv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$Wv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$Wv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$Wv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$Wv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$Wv)("MainThreadInteractive"),MainThreadChat:(0,S.$Wv)("MainThreadChat"),MainThreadInlineChat:(0,S.$Wv)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$Wv)("MainThreadTheming"),MainThreadTunnelService:(0,S.$Wv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$Wv)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$Wv)("MainThreadTimeline"),MainThreadTesting:(0,S.$Wv)("MainThreadTesting"),MainThreadLocalization:(0,S.$Wv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$Wv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$Wv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$Wv)("MainThreadIssueReporter")},e.$sL={ExtHostCommands:(0,S.$Wv)("ExtHostCommands"),ExtHostConfiguration:(0,S.$Wv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$Wv)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$Wv)("ExtHostDebugService"),ExtHostDecorations:(0,S.$Wv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$Wv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$Wv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$Wv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$Wv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$Wv)("ExtHostEditors"),ExtHostTreeViews:(0,S.$Wv)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$Wv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$Wv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$Wv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$Wv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$Wv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$Wv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$Wv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$Wv)("ExtHostStatusBar"),ExtHostShare:(0,S.$Wv)("ExtHostShare"),ExtHostExtensionService:(0,S.$Wv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$Wv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$Wv)("ExtHostTerminalService"),ExtHostSCM:(0,S.$Wv)("ExtHostSCM"),ExtHostSearch:(0,S.$Wv)("ExtHostSearch"),ExtHostTask:(0,S.$Wv)("ExtHostTask"),ExtHostWorkspace:(0,S.$Wv)("ExtHostWorkspace"),ExtHostWindow:(0,S.$Wv)("ExtHostWindow"),ExtHostWebviews:(0,S.$Wv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$Wv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$Wv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$Wv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$Wv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$Wv)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$Wv)("ExtHostProgress"),ExtHostComments:(0,S.$Wv)("ExtHostComments"),ExtHostSecretState:(0,S.$Wv)("ExtHostSecretState"),ExtHostStorage:(0,S.$Wv)("ExtHostStorage"),ExtHostUrls:(0,S.$Wv)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$Wv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$Wv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$Wv)("ExtHostOutputService"),ExtHostLabelService:(0,S.$Wv)("ExtHostLabelService"),ExtHostNotebook:(0,S.$Wv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$Wv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$Wv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$Wv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$Wv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$Wv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$Wv)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$Wv)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$Wv)("ExtHostChat"),ExtHostChatAgents2:(0,S.$Wv)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$Wv)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$Wv)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$Wv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$Wv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$Wv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$Wv)("ExtHostTheming"),ExtHostTunnelService:(0,S.$Wv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$Wv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$Wv)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$Wv)("ExtHostTimeline"),ExtHostTesting:(0,S.$Wv)("ExtHostTesting"),ExtHostTelemetry:(0,S.$Wv)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$Wv)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$Wv)("ExtHostIssueReporter")}}),define(Le[78],Me([1,0,4,14,3,17]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=e.$Vgc=e.$Ugc=void 0,e.$Ugc=(0,S.$$h)("IExtHostApiDeprecationService");let R=class{constructor(g,D){this.c=D,this.a=new Set,this.b=g.getProxy(P.$rL.MainThreadTelemetry)}report(g,D,A){const k=this.d(g,D);this.a.has(k)||(this.a.add(k),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:g}))}d(g,D){return`${g}-${D.identifier.value}`}};e.$Vgc=R,e.$Vgc=R=Je([qe(0,N.$JN),qe(1,M.$sj)],R),e.$Wgc=Object.freeze(new class{report(m,g,D){}})}),define(Le[225],Me([1,0,68,6,3]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=void 0;class N{static{this.a=0}constructor(g,D){this.extension=g,this.provider=D,this.handle=N.a++}}class R{static{this.a=0}constructor(g){this.b=new Map,this.c=new Map,this.d=g.getProxy(P.$rL.MainThreadChat)}registerChatProvider(g,D,A){const k=new N(g,A);return this.b.set(k.handle,k),this.d.$registerChatProvider(k.handle,D),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(k.handle),this.b.delete(k.handle)})}transferChatSession(g,D){const A=S.Iterable.find(this.c.keys(),k=>this.c.get(k)===g)??0;typeof A=="number"&&this.d.$transferChatSession(A,D)}sendInteractiveRequestToProvider(g,D){this.d.$sendRequestToProvider(g,D)}async $prepareChat(g,D){const A=this.b.get(g);if(!A)return;const k=await A.provider.prepareSession(D);if(!k)return;const l=R.a++;return this.c.set(l,k),{id:l,requesterUsername:k.requester?.name,requesterAvatarIconUri:k.requester?.icon,responderUsername:k.responder?.name,responderAvatarIconUri:k.responder?.icon,inputPlaceholder:k.inputPlaceholder}}$releaseSession(g){this.c.delete(g)}}e.$7gc=R}),define(Le[226],Me([1,0,3]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class M{constructor(N){const R=N.getProxy(S.$rL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$$gc=M}),define(Le[227],Me([1,0,26,3,27,17]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let R=class{constructor(A,k){this.a=A.getProxy(M.$rL.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,k){const l=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,k,v,arguments)}})}e(A,k,l,v){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g(v,this.b)}),this.c&&this.f(A,l,v)}};e.$2ic=R,e.$2ic=R=Je([qe(0,N.$JN),qe(1,P.$ZN)],R);const m=1e5;function g(D,A){const k=[];if(D.length)for(let l=0;l<D.length;l++){let v=D[l];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}k.push(v)}if(A){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Gn)(k);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Le[228],Me([1,0,2,3,25]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class N{constructor(m){this.a=m.getProxy(M.$rL.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,P.$OF)(m,"showLocal"),this.a.$showOpenDialog(g).then(D=>D?D.map(A=>S.URI.revive(A)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?S.URI.revive(g):void 0)}}e.$6hc=N}),define(Le[229],Me([1,0,6,3]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(M.$rL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$oic=P}),define(Le[79],Me([1,0,20,13,2,4,14,3,27,17]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=void 0;let A=class{constructor(l,v,p){this.f=p,this.d=new Map,this.a=v.getProxy(m.$rL.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,v){const{message:p,args:s,comment:a}=v;if(this.c)return(0,M.$Oe)(p,s??{});let r=p;a&&a.length>0&&(r+=`/${Array.isArray(a)?a.join(""):a}`);const i=this.d.get(l)?.contents[r];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,M.$Oe)(i??p,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let v;const p=await this.g(l);if(!p){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(p),a=JSON.parse(s);v=l.isBuiltin?a.contents?.bundle:a}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${p}: ${s.message}`);return}v&&this.d.set(l.identifier.value,{contents:v,uri:p})}async g(l){if(l.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(v)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Nhc=A,e.$Nhc=A=Je([qe(0,g.$ZN),qe(1,D.$JN),qe(2,R.$sj)],A),e.$Ohc=(0,N.$$h)("IExtHostLocalizationService")}),define(Le[230],Me([1,0,14,3,27,17,2,52]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;let g=class extends S.$Dj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(v=>(0,m.$Hh)(v))),this.r=k.getProxy(M.$rL.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,v){return new D(this.r,k,l,v)}};e.$1ic=g,e.$1ic=g=Je([qe(0,N.$JN),qe(1,P.$ZN)],g);class D extends S.$yj{constructor(k,l,v,p){super(p?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(l,p).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const v=[[k,l]];this.m?this.u(v):this.n.push(...v)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Le[80],Me([1,0,3,4,6,17,23]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0,e.$Phc=(0,M.$$h)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(S.$rL.MainThreadManagedSockets)}setFactory(k,l){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,v=await this.c.makeConnection(),p=new P.$Sc;return this.d.set(l,new D(l,v,p)),p.add((0,P.$Rc)(()=>this.d.delete(l))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),p.dispose()})),p.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),p.dispose()})),p.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,R.$me.wrap(s)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$Qhc=m,e.$Qhc=m=Je([qe(0,N.$JN)],m);class g{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class D extends P.$Tc{constructor(k,l,v){super(),this.socketId=k,this.actual=l,this.B(v)}}}),define(Le[231],Me([1,0,3,14,25]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;function N(m){return m&&m.title}let R=class{constructor(g,D){this.b=D,this.a=g.getProxy(S.$rL.MainThreadMessageService)}showMessage(g,D,A,k,l){const v={source:{identifier:g.identifier,label:g.displayName||g.name}};let p;typeof k=="string"||N(k)?p=[k,...l]:(v.modal=k?.modal,v.useCustom=k?.useCustom,v.detail=k?.detail,p=l),v.useCustom&&(0,P.$OF)(g,"resolvers");const s=[];let a=!1;for(let r=0;r<p.length;r++){const i=p[r];if(typeof i=="string")s.push({title:i,handle:r,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:o}=i;s.push({title:n,isCloseAffordance:!!o,handle:r}),o&&(a?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,i):a=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,i)}return this.a.$showMessage(D,A,v,s).then(r=>{if(typeof r=="number")return p[r]})}};e.$qic=R,e.$qic=R=Je([qe(1,M.$sj)],R)}),define(Le[232],Me([1,0,6,16,2,25,3]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;class m{constructor(D){this.b=new Map,this.a=D.getProxy(R.$rL.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,A,k){if((0,N.$OF)(D,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,D.identifier.value),(0,S.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(D,A,k,l){const v=this.b.get(D);if(!v)throw new Error(`Unknown handler with id: ${D}`);return v.saveProfile(A,k,l)}async $readProfile(D,A,k){const l=this.b.get(D);if(!l)throw new Error(`Unknown handler with id: ${D}`);return l.readProfile((0,M.$Mf)(A)?A:P.URI.revive(A),k)}}e.$zic=m}),define(Le[81],Me([1,0,3,5,4]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lhc=e.$Khc=void 0;class N{constructor(m){this.b=new M.$Yd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$rL.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,D){return this.a.$setPassword(m,g,D)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$Khc=N,e.$Lhc=(0,P.$$h)("IExtHostSecretState")}),define(Le[233],Me([1,0,21,6,3]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;class N{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(P.$rL.MainThreadSpeech)}async $createSpeechToTextSession(m,g){const D=this.c.get(m);if(!D)return;const A=new M.$Sc,k=new S.$9d;this.d.set(g,k);const l=A.add(D.provideSpeechToTextSession(k.token));A.add(l.onDidChange(v=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,v)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,g){const D=this.c.get(m);if(!D)return;const A=new M.$Sc,k=new S.$9d;this.d.set(g,k);const l=A.add(D.provideKeywordRecognitionSession(k.token));A.add(l.onDidChange(v=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,v)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,D){const A=N.a++;return this.c.set(A,D),this.b.$registerProvider(A,g,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Gic=N}),define(Le[82],Me([1,0,3,5,4]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=e.$Chc=void 0;class N{constructor(m,g){this.c=g,this.b=new M.$Yd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$rL.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,D){const A=await this.a.$initializeExtensionStorage(m,g);let k;return A&&(k=this.d(m,g,A)),k||D}setValue(m,g,D){return this.a.$setValue(m,g,D)}$acceptValue(m,g,D){const A=this.d(m,g,D);A&&this.b.fire({shared:m,key:g,value:A})}d(m,g,D){try{return JSON.parse(D)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${A}`)}}}e.$Chc=N,e.$Dhc=(0,P.$$h)("IExtHostStorage")}),define(Le[234],Me([1,0,6,12,2,3]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uic=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(N.$rL.MainThreadUriOpeners)}registerExternalUriOpener(g,D,A,k){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const l=k.schemes.find(v=>!R.a.has(v));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(D,A),this.b.$registerUriOpener(D,k.schemes,g,k.label),(0,S.$Rc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(g,D,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const l=P.URI.revive(D);return k.canOpenExternalUri(l,A)}async $openUri(g,D,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(P.URI.revive(D.resolvedUri),{sourceUri:P.URI.revive(D.sourceUri)},A)}}e.$Uic=R}),define(Le[235],Me([1,0,3,2,6,15,22]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=void 0;class m{static{this.a=0}constructor(D){this.c=new R.$rm,this.d=new Map,this.b=D.getProxy(S.$rL.MainThreadUrls)}registerUriHandler(D,A){const k=D.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=m.a++;return this.c.add(k),this.d.set(l,A),this.b.$registerUriHandler(l,k,D.displayName||D.name),(0,P.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(D,A){const k=this.d.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(A))}catch(l){(0,N.$1)(l)}return Promise.resolve(void 0)}async createAppUri(D){return M.URI.revive(await this.b.$createAppUri(D))}}e.$Vic=m}),define(Le[61],Me([1,0,5,6,12,26,2,183,205,76,3]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=e.$qhc=e.$phc=e.$ohc=e.$nhc=void 0;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(o,h,t,f,c,u,E){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$Yd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$Yd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=h,this.#o=t,this.#n=f,this.#s=c,this.#r=u,this.#l=l(u),this.#d=v(u),this.#i=E}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,D.$1wb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let h=o.toString();return h.endsWith("/")||(h+="/"),h+" "+D.$Zwb}return D.$Zwb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),N.$Fn(this.#o,o)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const h=(0,g.$emb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const h=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,c,u,E,y,$)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(y)}),d=(0,D.$1wb)(I,{isRemote:h,authority:t}).toString();return`${c}${d}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,c,u,E,y,$)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(y)}),d=(0,D.$1wb)(I,{isRemote:h,authority:t}).toString();return`${c}${d}${$}`})}}e.$nhc=k;function l(n){try{const o=(0,m.$hp)((0,m.$gp)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$ohc=l;function v(n){try{const o=(0,m.$hp)((0,m.$gp)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends M.$Tc{constructor(o,h,t,f,c){super(),this.c=h,this.f=t,this.g=f,this.h=c,this.b=new Map,this.a=o.getProxy(A.$rL.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,h,t){const f=this.j(o);if(f){const{message:c}=(0,g.$fmb)(h,t.value);f._onMessageEmitter.fire(c)}}$onMissingCsp(o,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,h,t){const f=new k(o,this.a,r(h),this.c,this.f,t,this.h);this.b.set(o,f);const c=f._onDidDispose(()=>{c.dispose(),this.deleteWebview(o)});return f}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$phc=p;function s(n){return{id:n.identifier,location:n.extensionLocation}}e.$qhc=s;function a(n,o,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||i(n,o)}}e.$rhc=a;function r(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(h=>h.uri),n.extensionLocation]}}),define(Le[107],Me([1,0,5,3,2,12,13,4,17,25]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=e.$Xic=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,D.$OF)(v,"windowActivity"),p.active}}}constructor(v){this.c=new S.$Yd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(M.$rL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:s})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let s;if(typeof v=="string"){s=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Me)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,s,p)}async asExternalUri(v,p){if((0,R.$Me)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(v,p);return P.URI.from(s)}};e.$Xic=k,e.$Xic=k=A=Je([qe(0,g.$JN)],k),e.$Yic=(0,m.$$h)("IExtHostWindow")}),define(Le[236],Me([1,0,227,27,17]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;let N=class extends S.$2ic{constructor(m,g){super(m,g)}f(m,g,D){g.apply(console,D)}};e.$$kc=N,e.$$kc=N=Je([qe(0,P.$JN),qe(1,M.$ZN)],N)}),define(Le[237],Me([1,0,11,23,21,15,5,6,140,224,50]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$38b=e.ResponsiveState=e.RequestInitiator=e.$28b=e.$18b=void 0;function l(b,L){try{return JSON.stringify(b,L)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class s{constructor(L,T){this.jsonString=L,this.referencedBuffers=T}}function a(b,L=null,T=!1){const Y=[];return{jsonString:(T?l:JSON.stringify)(b,(U,C)=>{if(typeof C>"u")return p;if(typeof C=="object"){if(C instanceof M.$me){const F=Y.push(C)-1;return{[v]:F}}if(L)return L(U,C)}return C}),referencedBuffers:Y}}e.$18b=a;function r(b,L,T){return JSON.parse(b,(Y,q)=>{if(q){const U=q[v];if(typeof U=="number")return L[U];if(T&&q.$mid===1)return T.transformIncoming(q)}return q})}e.$28b=r;function i(b,L){return JSON.stringify(b,L)}function n(b){return b?(L,T)=>T&&T.$mid===1?b.transformOutgoing(T):T:null}var o;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var h;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const t=()=>{},f=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class u extends m.$Tc{static{k=f}static{this.a=3*1e3}constructor(L,T=null,Y=null){super(),this[k]=!0,this.b=this.B(new R.$Yd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=T,this.g=Y,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,U=A.$Vv.count;q<U;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$kh(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const T=this.w[L];delete this.w[L],T.resolveErr(N.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,g.$an)(L,this.g):L}getProxy(L){const{nid:T,sid:Y}=L;return this.s[T]||(this.s[T]=this.J(T,Y)),this.s[T]}J(L,T){const Y={get:(q,U)=>(typeof U=="string"&&!q[U]&&U.charCodeAt(0)===36&&(q[U]=(...C)=>this.U(L,U,C)),U===c?T:q[U])};return new Proxy(Object.create(null),Y)}set(L,T){return this.m[L.nid]=T,T}assertRegistered(L){for(let T=0,Y=L.length;T<Y;T++){const q=L[T];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(L){if(this.j)return;const T=L.byteLength,Y=y.read(L,0),q=Y.readUInt8(),U=Y.readUInt32();switch(q){case 1:case 2:{let{rpcId:C,method:F,args:W}=I.deserializeRequestJSONArgs(Y);this.g&&(W=(0,g.$an)(W,this.g)),this.M(T,U,C,F,W,q===2);break}case 3:case 4:{let{rpcId:C,method:F,args:W}=I.deserializeRequestMixedArgs(Y);this.g&&(W=(0,g.$an)(W,this.g)),this.M(T,U,C,F,W,q===4);break}case 5:{this.f?.logIncoming(T,U,0,"ack"),this.G(U);break}case 6:{this.N(T,U);break}case 7:{this.O(T,U,void 0);break}case 9:{let C=I.deserializeReplyOKJSON(Y);this.g&&(C=(0,g.$an)(C,this.g)),this.O(T,U,C);break}case 10:{const C=I.deserializeReplyOKJSONWithBuffers(Y,this.g);this.O(T,U,C);break}case 8:{const C=I.deserializeReplyOKVSBuffer(Y);this.O(T,U,C);break}case 11:{let C=I.deserializeReplyErrError(Y);this.g&&(C=(0,g.$an)(C,this.g)),this.P(T,U,C);break}case 12:{this.P(T,U,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,T,Y,q,U,C){this.f?.logIncoming(L,T,1,`receiveRequest ${(0,A.$Xv)(Y)}.${q}(`,U);const F=String(T);let W,re;if(C){const ye=new P.$9d;U.push(ye.token),W=this.Q(Y,q,U),re=()=>ye.cancel()}else W=this.Q(Y,q,U),re=t;this.u[F]=re;const ue=I.serializeAcknowledged(T);this.f?.logOutgoing(ue.byteLength,T,1,"ack"),this.c.send(ue),W.then(ye=>{delete this.u[F];const ke=I.serializeReplyOK(T,ye,this.h);this.f?.logOutgoing(ke.byteLength,T,1,"reply:",ye),this.c.send(ke)},ye=>{delete this.u[F];const ke=I.serializeReplyErr(T,ye);this.f?.logOutgoing(ke.byteLength,T,1,"replyErr:",ye),this.c.send(ke)})}N(L,T){this.f?.logIncoming(L,T,1,"receiveCancel");const Y=String(T);this.u[Y]?.()}O(L,T,Y){this.f?.logIncoming(L,T,0,"receiveReply:",Y);const q=String(T);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q],U.resolveOk(Y)}P(L,T,Y){this.f?.logIncoming(L,T,0,"receiveReplyErr:",Y);const q=String(T);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q];let C;Y&&(Y.$isError?(C=new Error,C.name=Y.name,C.message=Y.message,C.stack=Y.stack):C=Y),U.resolveErr(C)}Q(L,T,Y){try{return Promise.resolve(this.S(L,T,Y))}catch(q){return Promise.reject(q)}}S(L,T,Y){const q=this.m[L];if(!q)throw new Error("Unknown actor "+(0,A.$Xv)(L));const U=q[T];if(typeof U!="function")throw new Error("Unknown method "+T+" on actor "+(0,A.$Xv)(L));return U.apply(q,Y)}U(L,T,Y){if(this.j)return new D.$Z8b;let q=null;if(Y.length>0&&P.CancellationToken.isCancellationToken(Y[Y.length-1])&&(q=Y.pop()),q&&q.isCancellationRequested)return Promise.reject(N.$6());const U=I.serializeRequestArguments(Y,this.h),C=++this.t,F=String(C),W=new D.$Y8b,re=new m.$Sc;q&&re.add(q.onCancellationRequested(()=>{const ye=I.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(I.serializeCancel(C))})),this.w[F]=new E(W,re),this.F(C);const ue=I.serializeRequest(C,L,T,U,!!q);return this.f?.logOutgoing(ue.byteLength,C,0,`request: ${(0,A.$Xv)(L)}.${T}(`,Y),this.c.send(ue),W}}e.$38b=u;class E{constructor(L,T){this.a=L,this.b=T}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class y{static alloc(L,T,Y){const q=new y(M.$me.alloc(Y+1+4),0);return q.writeUInt8(L),q.writeUInt32(T),q}static read(L,T){return new y(L,T)}get buffer(){return this.a}constructor(L,T){this.a=L,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const Y=this.a.slice(this.b,this.b+L).toString();return this.b+=L,Y}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const Y=this.a.slice(this.b,this.b+L).toString();return this.b+=L,Y}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+L);return this.b+=L,T}static sizeMixedArray(L){let T=0;T+=1;for(let Y=0,q=L.length;Y<q;Y++){const U=L[Y];switch(T+=1,U.type){case 1:T+=this.sizeLongString(U.value);break;case 2:T+=this.sizeVSBuffer(U.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)T+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return T}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let T=0,Y=L.length;T<Y;T++){const q=L[T];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let U=0;U<q.buffers.length;++U)this.writeBuffer(q.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const T=new Array(L);for(let Y=0;Y<L;Y++)switch(this.readUInt8()){case 1:T[Y]=this.readLongString();break;case 2:T[Y]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),F=[];for(let W=0;W<U;++W)F.push(this.readVSBuffer());T[Y]=new A.$Yv(r(C,F,null));break}case 4:T[Y]=void 0;break}return T}}var $;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})($||($={}));class I{static a(L){for(let T=0,Y=L.length;T<Y;T++)if(L[T]instanceof M.$me||L[T]instanceof A.$Yv||typeof L[T]>"u")return!0;return!1}static serializeRequestArguments(L,T){if(this.a(L)){const Y=[];for(let q=0,U=L.length;q<U;q++){const C=L[q];if(C instanceof M.$me)Y[q]={type:2,value:C};else if(typeof C>"u")Y[q]={type:4};else if(C instanceof A.$Yv){const{jsonString:F,referencedBuffers:W}=a(C.value,T);Y[q]={type:3,value:M.$me.fromString(F),buffers:W}}else Y[q]={type:1,value:M.$me.fromString(i(C,T))}}return{type:1,args:Y}}return{type:0,args:i(L,T)}}static serializeRequest(L,T,Y,q,U){switch(q.type){case 0:return this.b(L,T,Y,q.args,U);case 1:return this.c(L,T,Y,q.args,U)}}static b(L,T,Y,q,U){const C=M.$me.fromString(Y),F=M.$me.fromString(q);let W=0;W+=y.sizeUInt8(),W+=y.sizeShortString(C),W+=y.sizeLongString(F);const re=y.alloc(U?2:1,L,W);return re.writeUInt8(T),re.writeShortString(C),re.writeLongString(F),re.buffer}static deserializeRequestJSONArgs(L){const T=L.readUInt8(),Y=L.readShortString(),q=L.readLongString();return{rpcId:T,method:Y,args:JSON.parse(q)}}static c(L,T,Y,q,U){const C=M.$me.fromString(Y);let F=0;F+=y.sizeUInt8(),F+=y.sizeShortString(C),F+=y.sizeMixedArray(q);const W=y.alloc(U?4:3,L,F);return W.writeUInt8(T),W.writeShortString(C),W.writeMixedArray(q),W.buffer}static deserializeRequestMixedArgs(L){const T=L.readUInt8(),Y=L.readShortString(),q=L.readMixedArray(),U=new Array(q.length);for(let C=0,F=q.length;C<F;C++){const W=q[C];typeof W=="string"?U[C]=JSON.parse(W):U[C]=W}return{rpcId:T,method:Y,args:U}}static serializeAcknowledged(L){return y.alloc(5,L,0).buffer}static serializeCancel(L){return y.alloc(6,L,0).buffer}static serializeReplyOK(L,T,Y){if(typeof T>"u")return this.d(L);if(T instanceof M.$me)return this.e(L,T);if(T instanceof A.$Yv){const{jsonString:q,referencedBuffers:U}=a(T.value,Y,!0);return this.g(L,q,U)}else return this.f(L,l(T,Y))}static d(L){return y.alloc(7,L,0).buffer}static e(L,T){let Y=0;Y+=y.sizeVSBuffer(T);const q=y.alloc(8,L,Y);return q.writeVSBuffer(T),q.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,T){const Y=M.$me.fromString(T);let q=0;q+=y.sizeLongString(Y);const U=y.alloc(9,L,q);return U.writeLongString(Y),U.buffer}static g(L,T,Y){const q=M.$me.fromString(T);let U=0;U+=y.sizeUInt32,U+=y.sizeLongString(q);for(const F of Y)U+=y.sizeVSBuffer(F);const C=y.alloc(10,L,U);C.writeUInt32(Y.length),C.writeLongString(q);for(const F of Y)C.writeBuffer(F);return C.buffer}static deserializeReplyOKJSON(L){const T=L.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(L,T){const Y=L.readUInt32(),q=L.readLongString(),U=[];for(let C=0;C<Y;++C)U.push(L.readVSBuffer());return new A.$Yv(r(q,U,T))}static serializeReplyErr(L,T){const Y=T?l(N.$3(T),null):void 0;if(typeof Y!="string")return this.h(L);const q=M.$me.fromString(Y);let U=0;U+=y.sizeLongString(q);const C=y.alloc(11,L,U);return C.writeLongString(q),C.buffer}static deserializeReplyErrError(L){const T=L.readLongString();return JSON.parse(T)}static h(L){return y.alloc(12,L,0).buffer}}var d;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var w;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(w||(w={}))}),define(Le[238],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;const S=function(N){const R=m=>{globalThis.removeEventListener("message",R);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(D,A){g.postMessage(D,A)}},onmessage:{get(){return g.onmessage},set(D){g.onmessage=D}}}),g.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(N)};globalThis.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(N,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${S})('${R}'))`,D=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(D),k=new MessageChannel,l=A,v={type:"_newWorker",id:l,port:k.port2,url:A,options:m};N(v,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{N({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(p){k.port1.onmessage=p}},onmessageerror:{get(){return k.port1.onmessageerror},set(p){k.port1.onmessageerror=p}}}),k.port1.addEventListener("messageerror",p=>{const s=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",p=>{const s=new MessageEvent("message",{data:p.data});this.dispatchEvent(s)}),k.port1.start()}}e.$alc=M}),define(Le[239],Me([1,0,23,28,12,53,4]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dJ=e.$cJ=e.$bJ=e.$aJ=void 0,e.$aJ=(0,R.$$h)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${m.join("")}]+`),D=7;function A(v){if(v.scheme!==P.Schemas.vscodeNotebookCell)return;const p=v.fragment.indexOf("s");if(p<0)return;const s=parseInt(v.fragment.substring(0,p).replace(g,""),D),a=(0,S.$Fe)(v.fragment.substring(p+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:a,fragment:null})}}e.$bJ=A;function k(v,p){const s=p.toString(D),r=`${s.length<m.length?m[s.length-1]:"z"}${s}s${(0,S.$Ge)(S.$me.fromString(v.scheme),!0,!0)}`;return v.with({scheme:P.Schemas.vscodeNotebookCell,fragment:r})}e.$cJ=k;class l{constructor(){this.a=new M.$Ac}getNotebook(p){if(p.scheme===P.Schemas.vscodeNotebookCell){const s=A(p);if(s){const a=this.a.get(s.notebook);if(a)return a}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$dJ=l,(0,N.$4r)(e.$aJ,l,1)}),define(Le[83],Me([1,0,23,34,68,69,12,19,20,35,239]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.CellStatusbarAlignment=e.$rJ=e.$qJ=e.$pJ=e.NotebookEditorPriority=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.CellKind=e.$gJ=e.$fJ=e.$eJ=void 0,e.$eJ="workbench.editor.notebook",e.$fJ="workbench.editor.notebookTextDiffEditor",e.$gJ="workbench.editor.interactive";var k;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(k||(e.CellKind=k={})),e.$hJ=["application/json","application/javascript","text/html","image/svg+xml",N.$ks.latex,N.$ks.markdown,"image/png","image/jpeg",N.$ks.text],e.$iJ=[N.$ks.latex,N.$ks.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",N.$ks.text],e.$jJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$kJ="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var v;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var p;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var s;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var a;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var r;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var i;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(W){W.scheme=R.Schemas.vscodeNotebookCell;function re(se,$e){return(0,A.$cJ)(se,$e)}W.generate=re;function ue(se){return(0,A.$bJ)(se)}W.parse=ue;function ye(se,$e){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}W.generateCellOutputUri=ye;function ke(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!$e)return;const te=$e[1]&&$e[1]!==""?$e[1]:void 0,X=$e[2];return{outputId:te,notebook:se.with({scheme:X||R.Schemas.file,fragment:null})}}W.parseCellOutputUri=ke;function he(se,$e,te){return W.generate(se,$e).with({scheme:te})}W.generateCellPropertyUri=he;function ve(se,$e){if(se.scheme===$e)return W.parse(se.with({scheme:W.scheme}))}W.parseCellPropertyUri=ve})(o||(e.CellUri=o={}));const h=W=>g.$i?W.replace(/\//g,"\\"):W;class t{constructor(re=[],ue=e.$hJ){this.e=ue,this.d=[...new Set(re)].map(ye=>({pattern:ye,matches:M.$Rj(h(ye))}))}sort(re){const ue=new Map(P.Iterable.map(re,ke=>[ke,h(ke)]));let ye=[];for(const{matches:ke}of this.d)for(const[he,ve]of ue)if(ke(ve)){ye.push(he),ue.delete(he);break}return ue.size&&(ye=ye.concat([...ue.keys()].sort((ke,he)=>this.e.indexOf(ke)-this.e.indexOf(he)))),ye}prioritize(re,ue){const ye=this.f(re);if(ye===-1){this.d.unshift({pattern:re,matches:M.$Rj(h(re))});return}const ke=new Set(ue.map(ve=>this.f(ve,ye)));ke.delete(-1);const he=Array.from(ke).sort();this.d.splice(ye+1,0,...he.map(ve=>this.d[ve]));for(let ve=he.length-1;ve>=0;ve--)this.d.splice(he[ve],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ue=this.d.length){const ye=h(re);for(let ke=0;ke<ue;ke++)if(this.d[ke].matches(ye))return ke;return-1}}e.$lJ=t;function f(W,re,ue,ye=(ke,he)=>ke===he){const ke=[];function he($e,te,X){if(te===0&&X.length===0)return;const V=ke[ke.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=te,V.toInsert.push(...X)):ke.push({start:$e,deleteCount:te,toInsert:X})}let ve=0,se=0;for(;;){if(ve===W.length){he(ve,0,re.slice(se));break}if(se===re.length){he(ve,W.length-ve,[]);break}const $e=W[ve],te=re[se];if(ye($e,te)){ve+=1,se+=1;continue}ue(te)?(he(ve,1,[]),ve+=1):(he(ve,0,[te]),se+=1)}return ke}e.$mJ=f,e.$nJ=new D.$pj("notebookEditorCursorAtBoundary","none"),e.$oJ=new D.$pj("notebookEditorCursorAtLineBoundary","none");var c;(function(W){W.default="default",W.option="option"})(c||(e.NotebookEditorPriority=c={}));function u(W){const re=W;return!!((typeof re.include=="string"||M.$Sj(re.include))&&(typeof re.exclude=="string"||M.$Sj(re.exclude)))}e.$pJ=u;function E(W,re,ue){if(Array.isArray(W.viewType)&&W.viewType.indexOf(re)>=0||W.viewType===re)return!0;if(W.filenamePattern){const ye=u(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,ke=u(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(M.$Qj(ye,(0,m.$nc)(ue.fsPath).toLowerCase()))return!(ke&&M.$Qj(ke,(0,m.$nc)(ue.fsPath).toLowerCase()))}return!1}e.$qJ=E,e.$rJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var y;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class ${static{this.d="notebook/"}static create(re){return`${$.d}${re}`}static parse(re){if(re.startsWith($.d))return re.substring($.d.length)}}e.$sJ=$;function I(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}e.$tJ=I;const d=new TextDecoder;function w(W){const re=[];let ue=!1;for(const ve of W)(re.length===0||ue)&&(re.push(ve),ue=!0);let ye=T(re);const ke=S.$me.concat(re.map(ve=>S.$me.wrap(ve))),he=F(ke);return ye=ye||he.byteLength!==ke.byteLength,{data:he,didCompression:ye}}e.$uJ=w,e.$vJ="\x1B[A";const b=e.$vJ.split("").map(W=>W.charCodeAt(0)),L=10;function T(W){let re=!1;return W.forEach((ue,ye)=>{if(ye===0||ue.length<e.$vJ.length)return;const ke=W[ye-1],he=ue.subarray(0,e.$vJ.length);if(he[0]===b[0]&&he[1]===b[1]&&he[2]===b[2]){const ve=ke.lastIndexOf(L);if(ve===-1)return;re=!0,W[ye-1]=ke.subarray(0,ve),W[ye]=ue.subarray(e.$vJ.length)}}),re}function Y(W){let re=W;do W=re,re=W.replace(/[^\n]\x08/gm,"");while(re.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const re=W.match(/^(.*)\r+/m)[1];let ue=W.match(/\r+(.*)$/m)[1];ue=ue+re.slice(ue.length,re.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return W}const U=8,C=13;function F(W){return!W.buffer.includes(U)&&!W.buffer.includes(C)?W:S.$me.fromString(q(Y(d.decode(W.buffer))))}}),define(Le[7],Me([1,0,18,15,46,28,69,13,16,2,33,22,42,100,83]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p){"use strict";var s,a,r,i,n,o,h,t,f,c,u,E,y,$,I,d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.ChatAgentResultFeedbackKind=e.$mN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$lN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.TestRunProfileKind=e.TestResultState=e.$4M=e.$3M=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$2M=e.NotebookVariablesRequestKind=e.$1M=e.$ZM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$YM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.ColorThemeKind=e.$SM=e.$RM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$QM=e.$PM=e.DebugConsoleMode=e.$OM=e.$NM=e.$MM=e.$LM=e.$KM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$JM=e.$IM=e.FileChangeType=e.$HM=e.NewSymbolNameTag=e.$GM=e.$FM=e.$EM=e.$DM=e.InlineCompletionTriggerKind=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.ConfigurationTarget=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$gM=e.ViewBadge=e.ProgressLocation=e.$fM=e.$eM=e.TaskScope=e.ShellQuoting=e.$dM=e.$cM=e.$bM=e.TaskPanelKind=e.TaskRevealKind=e.$aM=e.TerminalLocation=e.$_L=e.$$L=e.$0L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$9L=e.$8L=e.$7L=e.$6L=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$5L=e.StatusBarAlignment=e.ViewColumn=e.$4L=e.$3L=e.$2L=e.$1L=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$ZL=e.$YL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.LanguageStatusSeverity=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.CodeActionTriggerKind=e.$ML=e.$LL=e.SymbolTag=e.SymbolKind=e.$KL=e.$JL=e.DocumentHighlightKind=e.$IL=e.$HL=e.$GL=e.$FL=e.DiagnosticSeverity=e.DiagnosticTag=e.$EL=e.$DL=e.FileEditType=e.$CL=e.$BL=e.$AL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function b(j){return Object.assign(j,{apply:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const De=ie.length===1?[]:ie[1];return Reflect.construct(j,De,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const[De,...Ge]=ie;return Reflect.construct(j,Ge,De.constructor)}}})}var L;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(L||(e.TerminalOutputAnchor=L={}));var T;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let Y=s=class{static from(...z){let ie=z;return new s(function(){if(ie){for(const De of ie)De&&typeof De.dispose=="function"&&De.dispose();ie=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$tL=Y,e.$tL=Y=s=Je([b],Y);let q=a=class{static Min(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let De=1;De<z.length;De++){const Ge=z[De];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let De=1;De<z.length;De++){const Ge=z[De];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(z){if(!z)return!1;if(z instanceof a)return!0;const{line:ie,character:De}=z;return typeof ie=="number"&&typeof De=="number"}static of(z){if(z instanceof a)return z;if(this.isPosition(z))return new a(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ie){if(z<0)throw(0,M.$7)("line must be non-negative");if(ie<0)throw(0,M.$7)("character must be non-negative");this.c=z,this.e=ie}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ie=0){if(z===null||ie===null)throw(0,M.$7)();let De;return typeof z>"u"?De=0:typeof z=="number"?De=z:(De=typeof z.lineDelta=="number"?z.lineDelta:0,ie=typeof z.characterDelta=="number"?z.characterDelta:0),De===0&&ie===0?this:new a(this.line+De,this.character+ie)}with(z,ie=this.character){if(z===null||ie===null)throw(0,M.$7)();let De;return typeof z>"u"?De=this.line:typeof z=="number"?De=z:(De=typeof z.line=="number"?z.line:this.line,ie=typeof z.character=="number"?z.character:this.character),De===this.line&&ie===this.character?this:new a(De,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$uL=q,e.$uL=q=a=Je([b],q);let U=r=class{static isRange(z){return z instanceof r?!0:z?q.isPosition(z.start)&&q.isPosition(z.end):!1}static of(z){if(z instanceof r)return z;if(this.isRange(z))return new r(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ie,De,Ge){let _e,lt;if(typeof z=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new q(z,ie),lt=new q(De,Ge)):q.isPosition(z)&&q.isPosition(ie)&&(_e=q.of(z),lt=q.of(ie)),!_e||!lt)throw new Error("Invalid arguments");_e.isBefore(lt)?(this.c=_e,this.e=lt):(this.c=lt,this.e=_e)}contains(z){return r.isRange(z)?this.contains(z.start)&&this.contains(z.end):q.isPosition(z)?!(q.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ie=q.Max(z.start,this.c),De=q.Min(z.end,this.e);if(!ie.isAfter(De))return new r(ie,De)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ie=q.Min(z.start,this.c),De=q.Max(z.end,this.end);return new r(ie,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ie=this.end){if(z===null||ie===null)throw(0,M.$7)();let De;return z?q.isPosition(z)?De=z:(De=z.start||this.start,ie=z.end||this.end):De=this.start,De.isEqual(this.c)&&ie.isEqual(this.end)?this:new r(De,ie)}toJSON(){return[this.start,this.end]}};e.$vL=U,e.$vL=U=r=Je([b],U);let C=i=class extends U{static isSelection(z){return z instanceof i?!0:z?U.isRange(z)&&q.isPosition(z.anchor)&&q.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ie,De,Ge){let _e,lt;if(typeof z=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"?(_e=new q(z,ie),lt=new q(De,Ge)):q.isPosition(z)&&q.isPosition(ie)&&(_e=q.of(z),lt=q.of(ie)),!_e||!lt)throw new Error("Invalid arguments");super(_e,lt),this.f=_e,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$wL=C,e.$wL=C=i=Je([b],C);const F=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,M.$7)("connectionToken")};class W{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie,De){if(typeof z!="string"||z.length===0)throw(0,M.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.$7)("port");typeof De<"u"&&F(De),this.host=z,this.port=Math.round(ie),this.connectionToken=De}}e.$xL=W;class re{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie){this.makeConnection=z,this.connectionToken=ie,typeof ie<"u"&&F(ie)}}e.$yL=re;class ue extends Error{static NotAvailable(z,ie){return new ue(z,v.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(z){return new ue(z,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ie=v.RemoteAuthorityResolverErrorCode.Unknown,De){super(z),this._message=z,this._code=ie,this._detail=De,Object.setPrototypeOf(this,ue.prototype)}}e.$zL=ue;var ye;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var ke;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let he=n=class{static isTextEdit(z){return z instanceof n?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ie){return new n(z,ie)}static insert(z,ie){return n.replace(new U(z,z),ie)}static delete(z){return n.replace(z,"")}static setEndOfLine(z){const ie=new n(new U(new q(0,0),new q(0,0)),"");return ie.newEol=z,ie}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,M.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,M.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,M.$7)("newEol");this.f=z}constructor(z,ie){this.c=z,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$AL=he,e.$AL=he=n=Je([b],he);let ve=o=class{static isNotebookCellEdit(z){return z instanceof o?!0:z?di.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ie){return new o(z,ie)}static insertCells(z,ie){return new o(new di(z,z),ie)}static deleteCells(z){return new o(z,[])}static updateCellMetadata(z,ie){const De=new o(new di(z,z),[]);return De.newCellMetadata=ie,De}static updateNotebookMetadata(z){const ie=new o(new di(0,0),[]);return ie.newNotebookMetadata=z,ie}constructor(z,ie){this.range=z,this.newCells=ie}};e.$BL=ve,e.$BL=ve=o=Je([b],ve);class se{static isSnippetTextEdit(z){return z instanceof se?!0:z?U.isRange(z.range)&&X.isSnippetString(z.snippet):!1}static replace(z,ie){return new se(z,ie)}static insert(z,ie){return se.replace(new U(z,z),ie)}constructor(z,ie){this.range=z,this.snippet=ie}}e.$CL=se;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ie,De,Ge){this.c.push({_type:1,from:z,to:ie,options:De,metadata:Ge})}createFile(z,ie,De){this.c.push({_type:1,from:void 0,to:z,options:ie,metadata:De})}deleteFile(z,ie,De){this.c.push({_type:1,from:z,to:void 0,options:ie,metadata:De})}e(z,ie,De){this.c.push({_type:3,metadata:De,uri:z,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(z,ie,De,Ge){const _e=ie.start,lt=ie.end;(_e!==lt||De.length>0)&&this.c.push({_type:5,uri:z,index:_e,count:lt-_e,cells:De,metadata:Ge})}g(z,ie,De,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:ie,metadata:De}})}replace(z,ie,De,Ge){this.c.push({_type:2,uri:z,edit:new he(ie,De),metadata:Ge})}insert(z,ie,De,Ge){this.replace(z,new U(ie,ie),De,Ge)}delete(z,ie,De){this.replace(z,ie,"",De)}has(z){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===z.toString())}set(z,ie){if(ie)for(const De of ie){if(!De)continue;let Ge,_e;Array.isArray(De)?(Ge=De[0],_e=De[1]):Ge=De,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,_e):this.f(z,Ge.range,Ge.newCells,_e):se.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:z,edit:Ge,metadata:_e})}else{for(let De=0;De<this.c.length;De++){const Ge=this.c[De];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[De]=void 0);break}}(0,S.$Ib)(this.c)}}get(z){const ie=[];for(const De of this.c)De._type===2&&De.uri.toString()===z.toString()&&ie.push(De.edit);return ie}entries(){const z=new N.$Ac;for(const ie of this.c)if(ie._type===2){let De=z.get(ie.uri);De||(De=[ie.uri,[]],z.set(ie.uri,De)),De[1].push(ie.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$DL=te,e.$DL=te=Je([b],te);let X=h=class{static isSnippetString(z){return z instanceof h?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=h.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ie=this.e++){if(typeof z=="function"){const De=new h;De.e=this.e,z(De),this.e=De.e,z=De.value}else z=h.c(z);return this.value+="${",this.value+=ie,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ie=this.e++){const De=z.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(z,ie){if(typeof ie=="function"){const De=new h;De.e=this.e,ie(De),this.e=De.e,ie=De.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$EL=X,e.$EL=X=h=Je([b],X);var V;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ce=t=class{static isLocation(z){return z instanceof t?!0:z?U.isRange(z.range)&&D.URI.isUri(z.uri):!1}constructor(z,ie){if(this.uri=z,ie)if(U.isRange(ie))this.range=U.of(ie);else if(q.isPosition(ie))this.range=new U(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$FL=Ce,e.$FL=Ce=t=Je([b],Ce);let Fe=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}constructor(z,ie){this.location=z,this.message=ie}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.location.range.isEqual(ie.location.range)&&z.location.uri.toString()===ie.location.uri.toString()}};e.$GL=Fe,e.$GL=Fe=Je([b],Fe);let Pe=class{constructor(z,ie,De=ne.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=z,this.message=ie,this.severity=De}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.severity===ie.severity&&z.code===ie.code&&z.severity===ie.severity&&z.source===ie.source&&z.range.isEqual(ie.range)&&(0,S.$ub)(z.tags,ie.tags)&&(0,S.$ub)(z.relatedInformation,ie.relatedInformation,Fe.isEqual)}};e.$HL=Pe,e.$HL=Pe=Je([b],Pe);let we=class{constructor(z,ie){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ie}};e.$IL=we,e.$IL=we=Je([b],we);var me;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let J=class{constructor(z,ie=me.Text){this.range=z,this.kind=ie}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.$JL=J,e.$JL=J=Je([b],J);let x=class{constructor(z,ie){this.uri=z,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$KL=x,e.$KL=x=Je([b],x);var le;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(j){j[j.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ae=f=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ie,De,Ge,_e){this.name=z,this.kind=ie,this.containerName=_e,typeof De=="string"&&(this.containerName=De),Ge instanceof Ce?this.location=Ge:De instanceof U&&(this.location=new Ce(Ge,De)),f.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$LL=Ae,e.$LL=Ae=f=Je([b],Ae);let ge=c=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(c.validate)}constructor(z,ie,De,Ge,_e){this.name=z,this.detail=ie,this.kind=De,this.range=Ge,this.selectionRange=_e,this.children=[],c.validate(this)}};e.$ML=ge,e.$ML=ge=c=Je([b],ge);var Se;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Se||(e.CodeActionTriggerKind=Se={}));let Ie=class{constructor(z,ie){this.title=z,this.kind=ie}};e.$NL=Ie,e.$NL=Ie=Je([b],Ie);let O=class{static{u=this}static{this.c="."}constructor(z){this.value=z}append(z){return new u(this.value?this.value+u.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+u.c)}};e.$OL=O,e.$OL=O=u=Je([b],O),O.Empty=new O(""),O.QuickFix=O.Empty.append("quickfix"),O.Refactor=O.Empty.append("refactor"),O.RefactorExtract=O.Refactor.append("extract"),O.RefactorInline=O.Refactor.append("inline"),O.RefactorMove=O.Refactor.append("move"),O.RefactorRewrite=O.Refactor.append("rewrite"),O.Source=O.Empty.append("source"),O.SourceOrganizeImports=O.Source.append("organizeImports"),O.SourceFixAll=O.Source.append("fixAll"),O.Notebook=O.Empty.append("notebook");let G=class{constructor(z,ie){if(this.range=z,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$PL=G,e.$PL=G=Je([b],G);class B{constructor(z,ie,De,Ge,_e,lt){this.kind=z,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$QL=B;class H{constructor(z,ie){this.fromRanges=ie,this.from=z}}e.$RL=H;class Q{constructor(z,ie){this.fromRanges=ie,this.to=z}}e.$SL=Q;var ae;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(ae||(e.LanguageStatusSeverity=ae={}));let Ee=class{constructor(z,ie){this.range=z,this.command=ie}get isResolved(){return!!this.command}};e.$TL=Ee,e.$TL=Ee=Je([b],Ee);let Be=E=class{#e;static isMarkdownString(z){return z instanceof E?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ie=!1){this.#e=new P.$mk(z,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ie){return this.#e.appendCodeblock(ie??"",z),this}};e.$UL=Be,e.$UL=Be=E=Je([b],Be);let We=class{constructor(z,ie){this.label=z,this.documentation=ie}};e.$VL=We,e.$VL=We=Je([b],We);let Qe=class{constructor(z,ie){this.label=z,this.documentation=ie,this.parameters=[]}};e.$WL=Qe,e.$WL=Qe=Je([b],Qe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$XL=xe,e.$XL=xe=Je([b],xe);var ct;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(ct||(e.SignatureHelpTriggerKind=ct={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let et=class{constructor(z){this.value=z}};e.$YL=et,e.$YL=et=Je([b],et);let ut=class{constructor(z,ie,De){this.position=z,this.label=ie,this.kind=De}};e.$ZL=ut,e.$ZL=ut=Je([b],ut);var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var pt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let _=class{constructor(z,ie){this.label=z,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$1L=_,e.$1L=_=Je([b],_);let pe=class{constructor(z=[],ie=!1){this.items=z,this.isIncomplete=ie}};e.$2L=pe,e.$2L=pe=Je([b],pe);let Ve=class{constructor(z,ie,De){this.insertText=z,this.range=ie,this.command=De}};e.$3L=Ve,e.$3L=Ve=Je([b],Ve);let Ye=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$4L=Ye,e.$4L=Ye=Je([b],Ye);var nt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var st;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Te(j,z){return`${k.$qm.toKey(j)}.${z}`}e.$5L=Te;var Nt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Nt||(e.TextEditorLineNumbersStyle=Nt={}));var Qt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var ei;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ei||(e.TextEditorRevealType=ei={}));var Ut;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Et;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var ti;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(ti||(e.DecorationRangeBehavior=ti={})),function(j){function z(ie){switch(ie){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var jt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(jt||(e.SyntaxTokenType=jt={})),function(j){function z(ie){switch(ie){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=z}(jt||(e.SyntaxTokenType=jt={}));let si=class{constructor(z,ie){if(ie&&!D.URI.isUri(ie))throw(0,M.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.target=ie}};e.$6L=si,e.$6L=si=Je([b],si);let Zt=class{constructor(z,ie,De,Ge){this.red=z,this.green=ie,this.blue=De,this.alpha=Ge}};e.$7L=Zt,e.$7L=Zt=Je([b],Zt);let Xt=class{constructor(z,ie){if(ie&&!(ie instanceof Zt))throw(0,M.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.color=ie}};e.$8L=Xt,e.$8L=Xt=Je([b],Xt);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,M.$7)("label");this.label=z}};e.$9L=Xe,e.$9L=Xe=Je([b],Xe);var Bt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var ii;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var ht;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class mt{constructor(z,ie,De){if(this.startIndex=z,this.length=ie,this.tooltip=De,typeof z!="number"||z<0)throw(0,M.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,M.$7)("tooltip")}}e.$0L=mt;class Kt{constructor(z){this.uri=z}}e.$$L=Kt;class ni{constructor(z){this.terminalCommand=z}}e.$_L=ni;var Ct;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ct||(e.TerminalLocation=Ct={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,M.$7)("options")}}e.$aM=dt;var At;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var oi;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Lt=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(z){switch(z){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(z,ie){if(this.label=ie,typeof z!="string"||typeof ie!="string")throw(0,M.$7)("name");this.c=z}get id(){return this.c}};e.$bM=Lt,e.$bM=Lt=y=Je([b],Lt);function He(j){let z="";for(let ie=0;ie<j.length;ie++)z+=j[ie].replace(/,/g,",,")+",";return z}let Gt=class{constructor(z,ie,De){if(typeof z!="string")throw(0,M.$7)("process");this.e=[],this.c=z,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=De):this.f=ie)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,M.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)z.push(ie);return He(z)}};e.$cM=Gt,e.$cM=Gt=Je([b],Gt);let Jt=class{constructor(z,ie,De){if(this.f=[],Array.isArray(ie)){if(!z)throw(0,M.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z,this.f=ie,this.g=De}else{if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z,this.g=ie}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)z.push(typeof ie=="string"?ie:ie.value);return He(z)}};e.$dM=Jt,e.$dM=Jt=Je([b],Jt);var _t;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(_t||(e.ShellQuoting=_t={}));var ft;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Ft{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$ug)()}set callback(z){this.c=z}get callback(){return this.c}}e.$eM=Ft;let Rt=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ie,De,Ge,_e,lt){this.k=!1,this.l=this.definition=z;let gt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=De,this.execution=Ge,gt=_e,this.k=!0):ie===ft.Global||ie===ft.Workspace?(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=lt):(this.target=ie,this.o=this.name=De,this.w=this.source=Ge,this.execution=_e,gt=lt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Gt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Jt?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,A.$ug)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,M.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ie=this.l.type;($.g===ie||$.e===ie||$.f===ie||$.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$fM=Rt,e.$fM=Rt=$=Je([b],Rt);var Tt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Tt||(e.ProgressLocation=Tt={}));var Wt;(function(j){function z(ie){const De=ie;return(0,g.$Qf)(De.value)?De.tooltip&&!(0,g.$Mf)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}j.isViewBadge=z})(Wt||(e.ViewBadge=Wt={}));let Ot=I=class{static isTreeItem(z,ie){const De=z;if(De.checkboxState!==void 0){const Ge=(0,g.$Qf)(De.checkboxState)?De.checkboxState:(0,g.$Of)(De.checkboxState)&&(0,g.$Qf)(De.checkboxState.state)?De.checkboxState.state:void 0,_e=!(0,g.$Qf)(De.checkboxState)&&(0,g.$Of)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Vt.Checked&&Ge!==Vt.Unchecked||_e!==void 0&&!(0,g.$Mf)(_e))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(z instanceof I)return!0;if(De.label!==void 0&&!(0,g.$Mf)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$Mf)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$Mf)(De.iconPath)&&!D.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$Mf)(De.iconPath.id))){const Ge=De.iconPath;if(!Ge||!(0,g.$Mf)(Ge.light)&&!D.URI.isUri(Ge.light)&&!(0,g.$Mf)(Ge.dark)&&!D.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$Mf)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!D.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$Mf)(De.tooltip)&&!(De.tooltip instanceof Be)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<kt.None&&De.collapsibleState>kt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$Mf)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(z,ie=kt.None){this.collapsibleState=ie,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$gM=Ot,e.$gM=Ot=I=Je([b],Ot);var kt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(kt||(e.TreeItemCollapsibleState=kt={}));var Vt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Vt||(e.TreeItemCheckboxState=Vt={}));let yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$hM=yt,e.$hM=yt=Je([b],yt);class bt extends yt{}e.$iM=bt;class St extends bt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$jM=St;class Dt{constructor(z,ie,De,Ge){this.name=z,this.uri=ie,this._itemId=De,this.c=Ge}data(){return this.c()}}e.$kM=Dt;let ci=class{#e=new Map;constructor(z){for(const[ie,De]of z??[]){const Ge=this.#e.get(this.#t(ie));Ge?Ge.push(De):this.#e.set(this.#t(ie),[De])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ie){this.#e.set(this.#t(z),[ie])}forEach(z,ie){for(const[De,Ge]of this.#e)for(const _e of Ge)z.call(ie,_e,De,this)}*[Symbol.iterator](){for(const[z,ie]of this.#e)for(const De of ie)yield[z,De]}#t(z){return z.toLowerCase()}};e.$lM=ci,e.$lM=ci=Je([b],ci);let Yt=class{constructor(z){this.insertText=z}};e.$mM=Yt,e.$mM=Yt=Je([b],Yt);let gi=class{constructor(z,ie){this.label=ie,this.insertText=z}};e.$nM=gi,e.$nM=gi=Je([b],gi);let qt=class{constructor(z,ie){this.id=z,this.color=ie}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$oM=qt,e.$oM=qt=Je([b],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let mi=class{constructor(z){this.id=z}};e.$pM=mi,e.$pM=mi=Je([b],mi);var Pt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Pt||(e.ConfigurationTarget=Pt={}));let be=class{get base(){return this.c}set base(z){this.c=z,this.e=D.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ie){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,M.$7)("base");if(typeof ie!="string")throw(0,M.$7)("pattern");typeof z=="string"?this.baseUri=D.URI.file(z):D.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$qM=be,e.$qM=be=Je([b],be);const Ne=new WeakMap;function oe(j,z){Ne.set(j,z)}e.$rM=oe;let K=class{constructor(z,ie,De,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof ie=="string"&&(this.condition=ie),typeof De=="string"&&(this.hitCondition=De),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Ne.get(this)??(0,A.$ug)()),this.c}};e.$sM=K,e.$sM=K=Je([b],K);let Re=class extends K{constructor(z,ie,De,Ge,_e){if(super(ie,De,Ge,_e),z===null)throw(0,M.$7)("location");this.location=z}};e.$tM=Re,e.$tM=Re=Je([b],Re);let je=class extends K{constructor(z,ie,De,Ge,_e){super(ie,De,Ge,_e),this.functionName=z}};e.$uM=je,e.$uM=je=Je([b],je);let Ze=class extends K{constructor(z,ie,De,Ge,_e,lt,gt){if(super(Ge,_e,lt,gt),!ie)throw(0,M.$7)("dataId");this.label=z,this.dataId=ie,this.canPersist=De}};e.$vM=Ze,e.$vM=Ze=Je([b],Ze);let Ke=class{constructor(z,ie,De){this.command=z,this.args=ie||[],this.options=De}};e.$wM=Ke,e.$wM=Ke=Je([b],Ke);let tt=class{constructor(z,ie){this.port=z,this.host=ie}};e.$xM=tt,e.$xM=tt=Je([b],tt);let wt=class{constructor(z){this.path=z}};e.$yM=wt,e.$yM=wt=Je([b],wt);let Ht=class{constructor(z){this.implementation=z}};e.$zM=Ht,e.$zM=Ht=Je([b],Ht);let zt=class{constructor(z,ie,De){this.session=z,this.threadId=ie,this.frameId=De}};e.$AM=zt,e.$AM=zt=Je([b],zt);let It=class{constructor(z,ie){this.session=z,this.threadId=ie}};e.$BM=It,e.$BM=It=Je([b],It);let ot=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$CM=ot,e.$CM=ot=Je([b],ot);var Qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let ui=class{constructor(z,ie){this.range=z,this.text=ie}};e.$DM=ui,e.$DM=ui=Je([b],ui);let $i=class{constructor(z,ie,De=!0){this.range=z,this.variableName=ie,this.caseSensitiveLookup=De}};e.$EM=$i,e.$EM=$i=Je([b],$i);let yi=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$FM=yi,e.$FM=yi=Je([b],yi);let Ai=class{constructor(z,ie){this.frameId=z,this.stoppedLocation=ie}};e.$GM=Ai,e.$GM=Ai=Je([b],Ai);var Zi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Zi||(e.NewSymbolNameTag=Zi={}));class ln{constructor(z,ie){this.newSymbolName=z,this.tags=ie}}e.$HM=ln;var Li;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Li||(e.FileChangeType=Li={}));let Mi=d=class extends Error{static FileExists(z){return new d(z,l.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(z){return new d(z,l.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(z){return new d(z,l.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(z){return new d(z,l.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(z){return new d(z,l.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(z){return new d(z,l.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(z,ie=l.FileSystemProviderErrorCode.Unknown,De){super(D.URI.isUri(z)?z.toString(!0):z),this.code=De?.name??"Unknown",(0,l.$Kk)(this,ie),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$IM=Mi,e.$IM=Mi=d=Je([b],Mi);let Ei=class{constructor(z,ie,De){this.start=z,this.end=ie,this.kind=De}};e.$JM=Ei,e.$JM=Ei=Je([b],Ei);var pi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(pi||(e.FoldingRangeKind=pi={}));var Xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Di;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Di||(e.CommentMode=Di={}));var ki;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ki||(e.CommentState=ki={}));var _i;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class hn{constructor(z,ie=[]){this.tokenTypes=z,this.tokenModifiers=ie}}e.$KM=hn;function bi(j){return typeof j>"u"||(0,g.$Nf)(j)}class Ni{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ie=0,De=z.tokenTypes.length;ie<De;ie++)this.k.set(z.tokenTypes[ie],ie);for(let ie=0,De=z.tokenModifiers.length;ie<De;ie++)this.l.set(z.tokenModifiers[ie],ie)}}push(z,ie,De,Ge,_e){if(typeof z=="number"&&typeof ie=="number"&&typeof De=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(z,ie,De,Ge,_e);if(U.isRange(z)&&typeof ie=="string"&&bi(De))return this.o(z,ie,De);throw(0,M.$7)()}o(z,ie,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,_e=z.start.character,lt=z.end.character-z.start.character,gt=this.k.get(ie);let xt=0;if(De)for(const ai of De){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);xt|=1<<hi>>>0}this.q(Ge,_e,lt,gt,xt)}q(z,ie,De,Ge,_e){if(this.f&&(z<this.c||z===this.c&&ie<this.e)){this.f=!1;const xt=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<xt;fi++){let vi=this.g[5*fi],Ji=this.g[5*fi+1];vi===0?(vi=ai,Ji+=hi):vi+=ai,this.g[5*fi]=vi,this.g[5*fi+1]=Ji,ai=vi,hi=Ji}}let lt=z,gt=ie;this.f&&this.j>0&&(lt-=this.c,lt===0&&(gt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=gt,this.g[this.j++]=De,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=z,this.e=ie}static r(z){const ie=[],De=z.length/5|0;for(let gt=0;gt<De;gt++)ie[gt]=gt;ie.sort((gt,xt)=>{const ai=z[5*gt],hi=z[5*xt];if(ai===hi){const fi=z[5*gt+1],vi=z[5*xt+1];return fi-vi}return ai-hi});const Ge=new Uint32Array(z.length);let _e=0,lt=0;for(let gt=0;gt<De;gt++){const xt=5*ie[gt],ai=z[xt+0],hi=z[xt+1],fi=z[xt+2],vi=z[xt+3],Ji=z[xt+4],Cn=ai-_e,xn=Cn===0?hi-lt:hi,Yi=5*gt;Ge[Yi+0]=Cn,Ge[Yi+1]=xn,Ge[Yi+2]=fi,Ge[Yi+3]=vi,Ge[Yi+4]=Ji,_e=ai,lt=hi}return Ge}build(z){return this.f?new Fi(new Uint32Array(this.g),z):new Fi(Ni.r(this.g),z)}}e.$LM=Ni;class Fi{constructor(z,ie){this.resultId=ie,this.data=z}}e.$MM=Fi;class dn{constructor(z,ie,De){this.start=z,this.deleteCount=ie,this.data=De}}e.$NM=dn;class Si{constructor(z,ie){this.resultId=ie,this.edits=z}}e.$OM=Si;var xi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class fn{constructor(z){this.name=z}}e.$PM=fn;let wi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.$QM=wi,e.$QM=wi=Je([b],wi);var Ti;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ti||(e.QuickPickItemKind=Ti={}));var en;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(en||(e.InputBoxValidationSeverity=en={}));var Oi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Oi||(e.ExtensionKind=Oi={}));class tn{static validate(z){if(typeof z.badge=="string"){let ie=(0,m.$nf)(z.badge,0);if(ie<z.badge.length&&(ie+=(0,m.$nf)(z.badge,ie)),z.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!qt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ie,De){this.badge=z,this.tooltip=ie,this.color=De}}e.$RM=tn;let zi=class{constructor(z){this.kind=z}};e.$SM=zi,e.$SM=zi=Je([b],zi);var nn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class di{static isNotebookRange(z){return z instanceof di?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ie){if(z<0)throw(0,M.$7)("start must be positive");if(ie<0)throw(0,M.$7)("end must be positive");z<=ie?(this.c=z,this.e=ie):(this.c=ie,this.e=z)}with(z){let ie=this.c,De=this.e;return z.start!==void 0&&(ie=z.start),z.end!==void 0&&(De=z.end),ie===this.c&&De===this.e?this:new di(ie,De)}}e.$TM=di;class Ii{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ie=>Ii.isNotebookCellData(ie))}static isNotebookCellData(z){return!0}constructor(z,ie,De,Ge,_e,lt,gt){this.kind=z,this.value=ie,this.languageId=De,this.mime=Ge,this.outputs=_e??[],this.metadata=lt,this.executionSummary=gt,Ii.validate(this)}}e.$UM=Ii;class Ui{constructor(z){this.cells=z}}e.$VM=Ui;class ri{static isNotebookCellOutputItem(z){return z instanceof ri?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ie={name:z.name,message:z.message,stack:z.stack};return ri.json(ie,"application/vnd.code.notebook.error")}static stdout(z){return ri.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return ri.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ie="application/octet-stream"){return new ri(z,ie)}static#e=new TextEncoder;static text(z,ie=R.$ks.text){const De=ri.#e.encode(String(z));return new ri(De,ie)}static json(z,ie="text/x-json"){const De=JSON.stringify(z,void 0,"	");return ri.text(De,ie)}constructor(z,ie){this.data=z,this.mime=ie;const De=(0,R.$os)(ie,!0);if(!De)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$WM=ri;class Oe{static isNotebookCellOutput(z){return z instanceof Oe?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ie=!1){const De=new Set,Ge=new Set;for(let _e=0;_e<z.length;_e++){const lt=z[_e],gt=(0,R.$os)(lt.mime);if(!De.has(gt)||(0,p.$tJ)(gt)){De.add(gt);continue}Ge.add(_e),ie&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ge.size===0?z:z.filter((_e,lt)=>!Ge.has(lt))}constructor(z,ie,De){this.items=Oe.ensureUniqueMimeTypes(z,!0),typeof ie=="string"?(this.id=ie,this.metadata=De):(this.id=(0,A.$ug)(),this.metadata=ie??De)}}e.$XM=Oe;var li;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var ji;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(ji||(e.NotebookCellExecutionState=ji={}));var it;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(it||(e.NotebookCellStatusBarAlignment=it={}));var $t;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})($t||(e.NotebookEditorRevealType=$t={}));class gn{constructor(z,ie){this.text=z,this.alignment=ie}}e.$YM=gn;var rn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var Bi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Bi||(e.NotebookControllerAffinity2=Bi={}));class mn{constructor(z,ie=[]){this.uri=z,this.provides=(0,S.$3b)(ie)}}e.$ZM=mn;class Ci{constructor(z){this.label=z}}e.$1M=Ci;var sn;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Wi=class{constructor(z,ie){this.label=z,this.timestamp=ie}};e.$2M=Wi,e.$2M=Wi=Je([b],Wi);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Vi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Vi||(e.ExtensionRuntime=Vi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class $n{constructor(z,ie){this.ranges=z,this.wordPattern=ie}}e.$3M=$n;class pn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$4M=pn;var cn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let qi=class{constructor(z=void 0,ie=void 0,De=void 0,Ge=!1){this.include=z,this.exclude=ie,this.profile=De,this.continuous=Ge}};e.$5M=qi,e.$5M=qi=Je([b],qi);let Hi=w=class{static diff(z,ie,De){const Ge=new w(z);return Ge.expectedOutput=ie,Ge.actualOutput=De,Ge}constructor(z){this.message=z}};e.$6M=Hi,e.$6M=Hi=w=Je([b],Hi);let Ki=class{constructor(z){this.id=z}};e.$7M=Ki,e.$7M=Ki=Je([b],Ki);class Pi{constructor(z,ie){this.covered=z,this.total=ie}}e.$8M=Pi;const Gi=j=>{if(j&&j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`)};class ee{static fromDetails(z,ie){const De=new Pi(0,0),Ge=new Pi(0,0),_e=new Pi(0,0);for(const gt of ie)if("branches"in gt){De.total+=1,De.covered+=gt.executed?1:0;for(const xt of gt.branches)Ge.total+=1,Ge.covered+=xt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const lt=new ee(z,De,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return lt.detailedCoverage=ie,lt}constructor(z,ie,De,Ge){this.uri=z,this.statementCoverage=ie,this.branchCoverage=De,this.declarationCoverage=Ge,Gi(ie),Gi(De),Gi(Ge)}}e.$9M=ee;class ce{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,De=[]){this.executed=z,this.location=ie,this.branches=De}}e.$0M=ce;class ze{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,De){this.executed=z,this.location=ie,this.label=De}}e.$$M=ze;class at{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,De){this.name=z,this.executed=ie,this.location=De}}e.$_M=at;var vt;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(vt||(e.ExternalUriOpenerPriority=vt={}));var Mt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Mt||(e.WorkspaceTrustState=Mt={}));var Ri;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Ri||(e.PortAutoForwardAction=Ri={}));class Pn{constructor(z,ie,De,Ge,_e,lt){this.kind=z,this.name=ie,this.detail=De,this.uri=Ge,this.range=_e,this.selectionRange=lt}}e.$aN=Pn;class Rn{constructor(z){this.uri=z}}e.$bN=Rn;class An{constructor(z,ie){this.original=z,this.modified=ie}}e.$cN=An;class Ln{constructor(z,ie,De,Ge){this.base=z,this.input1=ie,this.input2=De,this.result=Ge}}e.$dN=Ln;class Mn{constructor(z,ie){this.uri=z,this.viewType=ie}}e.$eN=Mn;class Nn{constructor(z){this.viewType=z}}e.$fN=Nn;class Fn{constructor(z,ie){this.uri=z,this.notebookType=ie}}e.$gN=Fn;class Tn{constructor(z,ie,De){this.original=z,this.modified=ie,this.notebookType=De}}e.$hN=Tn;class On{constructor(){}}e.$iN=On;class zn{constructor(z,ie){this.uri=z,this.inputBoxUri=ie}}e.$jN=zn;class Un{constructor(z){this.providerId=z}}e.$kN=Un;var vn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class jn{constructor(z,ie){this.label=z,this.values=ie}}e.$lN=jn;var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant"})(En||(e.ChatMessageRole=En={}));class Bn{constructor(z,ie){this.role=z,this.content=ie}}e.$mN=Bn;var Dn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));class Wn{constructor(z){this.value=z}}e.$nN=Wn;class Vn{constructor(z){this.value=typeof z=="string"?new Be(z):z}}e.$oN=Vn;class qn{constructor(z,ie){this.value=z,this.baseUri=ie}}e.$pN=qn;class Hn{constructor(z,ie){this.value=z,this.title=ie}}e.$qN=Hn;class Kn{constructor(z){this.value=z}}e.$rN=Kn;class Gn{constructor(z){this.value=z}}e.$sN=Gn;class Jn{constructor(z){this.value=z}}e.$tN=Jn;class Yn{constructor(z,ie,De,Ge){this.prompt=z,this.command=ie,this.variables=De,this.agent=Ge,this.agentId=Ge.agentId}}e.$uN=Yn;class Qn{constructor(z,ie,De){this.response=z,this.result=ie,this.agent=De,this.agentId=De.agentId}}e.$vN=Qn;class Zn{constructor(z){this.content=z}}e.$wN=Zn;class Xn{constructor(z,ie){this.content=z,this.name=ie}}e.$xN=Xn;class _n{constructor(z){this.content=z}}e.$yN=_n;var kn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}))}),define(Le[240],Me([1,0,3,7]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$rL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(R);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(m,g)??[]}getRelatedInformation(R,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(R,m,g){const D=this.b;return this.b++,this.a.set(D,g),this.c.$registerAiRelatedInformationProvider(D,m),new M.$tL(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$Tgc=P}),define(Le[241],Me([1,0,5,3,7,22,104]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class m{constructor(A){this.b=new Map,this.c=new S.$Yd,this.onDidChangeSessions=this.c.event,this.d=new g,this.f=new g,this.a=A.getProxy(M.$rL.MainThreadAuthentication)}async getSession(A,k,l,v={}){const p=N.$qm.toKey(A.identifier),s=[...l].sort().join(" ");return await this.d.getOrCreate(`${p} ${k} ${s}`,async()=>{await this.a.$ensureProvider(k);const a=A.displayName||A.name;return this.a.$getSession(k,l,p,a,v)})}async getSessions(A,k,l){const v=N.$qm.toKey(A.identifier),p=[...l].sort().join(" ");return await this.f.getOrCreate(`${v} ${p}`,async()=>{await this.a.$ensureProvider(k);const s=A.displayName||A.name;return this.a.$getSessions(k,l,v,s)})}async removeSession(A,k){const l=this.b.get(A);return l?l.provider.removeSession(k):this.a.$removeSession(A,k)}registerAuthenticationProvider(A,k,l,v){if(this.b.get(A))throw new Error(`An authentication provider with id '${A}' is already registered.`);this.b.set(A,{label:k,provider:l,options:v??{supportsMultipleAccounts:!1}});const p=l.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(A,s));return this.a.$registerAuthenticationProvider(A,k,v?.supportsMultipleAccounts??!1),new P.$tL(()=>{p.dispose(),this.b.delete(A),this.a.$unregisterAuthenticationProvider(A)})}$createSession(A,k,l){const v=this.b.get(A);if(v)return Promise.resolve(v.provider.createSession(k,l));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$removeSession(A,k){const l=this.b.get(A);if(l)return Promise.resolve(l.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$getSessions(A,k){const l=this.b.get(A);if(l)return Promise.resolve(l.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$onDidChangeAuthenticationSessions(A,k){return A.startsWith(R.$xK)||this.c.fire({provider:{id:A,label:k}}),Promise.resolve()}}e.$5gc=m;class g{constructor(){this.a=new Map}getOrCreate(A,k){const l=this.a.get(A);if(l)return l;const v=k().finally(()=>this.a.delete(A));return this.a.set(A,v),v}}}),define(Le[108],Me([1,0,2,3,7,4,17,14,18,13,19,25]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=void 0;let v=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,a){this.h=a,this.f=new Map,this.g=s.getProxy(M.$rL.MainThreadDecorations)}registerFileDecorationProvider(s,a){const r=l.c++;this.f.set(r,{provider:s,extensionDescription:a}),this.g.$registerDecorationProvider(r,a.identifier.value);const i=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(r,null);return}const o=(0,g.$3b)(n);if(o.length<=l.d){this.g.$onDidChange(r,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,o.length);const h=o.map(c=>({uri:c,rank:(0,D.$Se)(c.path,"/")})),t=(0,g.$zb)(h,(c,u)=>c.rank-u.rank||(0,D.$9e)(c.uri.path,u.uri.path)),f=[];e:for(const c of t){let u;for(const E of c){const y=(0,A.$mc)(E.uri.path);if(u!==y&&(u=y,f.push(E.uri)>=l.d))break e}}this.g.$onDidChange(r,f)});return new P.$tL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,a,r){if(!this.f.has(s))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(s);return await Promise.all(a.map(async h=>{try{const{uri:t,id:f}=h,c=await Promise.resolve(n.provideFileDecoration(S.URI.revive(t),r));if(!c)return;try{P.$RM.validate(c),c.badge&&typeof c.badge!="string"&&(0,k.$OF)(o,"codiconDecoration"),i[f]=[c.propagate,c.tooltip,c.badge,c.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$4hc=v,e.$4hc=v=l=Je([qe(0,R.$JN),qe(1,m.$sj)],v),e.$5hc=(0,N.$$h)("IExtHostDecorations")}),define(Le[242],Me([1,0,15,2,7,3,12,21,13]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class D{static{this.a=0}constructor(k,l,v){this.d=l,this.e=v,this.b=new Map,this.c=k.getProxy(N.$rL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const v=D.a++;this.b.set(v,l),this.c.$registerTextContentProvider(v,k);let p;if(typeof l.onDidChange=="function"){let s;p=l.onDidChange(async a=>{if(a.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;s&&await s;const r=this.$provideTextDocumentContent(v,a).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(a);if(!n)return;const o=(0,g.$3e)(i);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(a,i)}).catch(S.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new P.$tL(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(k,l){const v=this.b.get(k);return v?Promise.resolve(v.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$7hc=D}),define(Le[109],Me([1,0,54,12,13,298,148,7,18]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=e.$MN=e.$LN=void 0;const D=new Map;function A(p,s){s?D.set(p,s):D.delete(p)}e.$LN=A;function k(p){return D.get(p)}class l extends N.$qv{constructor(s,a,r,i,n,o,h,t){super(a,r,i,n),this.c=s,this.m=o,this.q=h,this.notebook=t,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,g.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===M.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(a){return a?s.s(a):s.getText()},get eol(){return s.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(a){return s.t(a)},offsetAt(a){return s.u(a)},positionAt(a){return s.v(a)},validateRange(a){return s.w(a)},validatePosition(a){return s.x(a)},getWordRangeAtPosition(a,r){return s.y(a,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const a=this.w(s);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const r=this.g,i=a.start.line,n=a.end.line,o=[];o.push(this.f[i].substring(a.start.character));for(let h=i+1;h<n;h++)o.push(this.f[h]);return o.push(this.f[n].substring(0,a.end.character)),o.join(r)}t(s){let a;if(s instanceof m.$uL?a=s.line:typeof s=="number"&&(a=s),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new v(a,this.f[a],a===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const a=this.j.getIndexOf(s),r=this.f[a.index].length;return new m.$uL(a.index,Math.min(a.remainder,r))}w(s){if(!(s instanceof m.$vL))throw new Error("Invalid argument");const a=this.x(s.start),r=this.x(s.end);return a===s.start&&r===s.end?s:new m.$vL(a.line,a.character,r.line,r.character)}x(s){if(!(s instanceof m.$uL))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:a,character:r}=s,i=!1;if(a<0)a=0,r=0,i=!0;else if(a>=this.f.length)a=this.f.length-1,r=this.f[a].length,i=!0;else{const n=this.f[a].length;r<0?(r=0,i=!0):r>n&&(r=n,i=!0)}return i?new m.$uL(a,r):s}y(s,a){const r=this.x(s);if(!a)a=k(this.m);else if((0,P.$2e)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const i=(0,R.$Cs)(r.character+1,(0,R.$As)(a),this.f[r.line],0);if(i)return new m.$vL(r.line,i.startColumn-1,r.line,i.endColumn-1)}}e.$MN=l;class v{constructor(s,a,r){this.a=s,this.b=a,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$vL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$vL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$NN=v}),define(Le[243],Me([1,0,3,7]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$rL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(R);if(!D)throw new Error("Embedding vector provider not found");const A=await D.provideEmbeddingVector(m,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,m,g){const D=this.b;return this.b++,this.a.set(D,g),this.c.$registerAiEmbeddingVectorProvider(m,D),new M.$tL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$9hc=P}),define(Le[62],Me([1,0,3,42,7,23,4,17,43,6,11,24,12]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0;let p=v=class{constructor(a,r){this.b=new Map,this.c=new A.$hh,this.a=a.getProxy(S.$rL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const h=i.b.get(n.scheme);return h?(await i.a.$ensureActivation(n.scheme),o=await h.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===M.FilePermission.Readonly?1:void 0}}catch(o){v.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return v.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return v.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return v.e(o)}},async writeFile(n,o){try{const h=i.b.get(n.scheme);return h&&!h.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(h.impl,h.extUri,h.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(h.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,N.$me.wrap(o))}catch(h){return v.e(h)}},async delete(n,o){try{const h=i.b.get(n.scheme);return h&&!h.isReadonly&&!o?.useTrash?(await i.a.$ensureActivation(n.scheme),await h.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(h){return v.e(h)}},async rename(n,o,h){try{return await i.a.$rename(n,o,{overwrite:!1,...h})}catch(t){return v.e(t)}},async copy(n,o,h){try{return await i.a.$copy(n,o,{overwrite:!1,...h})}catch(t){return v.e(t)}},isWritableFileSystem(n){const o=r.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(a,r,i){const n=[];for(;!r.isEqual(i,r.dirname(i));)try{if(!((await a.stat(i)).type&M.FileType.Directory))throw P.$IM.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(M.$Lk(o)!==M.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(r.basename(i)),i=r.dirname(i)}for(let o=n.length-1;o>=0;o--){i=r.joinPath(i,n[o]);try{await a.createDirectory(i)}catch(h){if(M.$Lk(h)!==M.FileSystemProviderErrorCode.FileExists)throw h}}}static e(a){if(a instanceof P.$IM)throw a;if(a instanceof M.$Hk)switch(a.code){case M.FileSystemProviderErrorCode.FileExists:throw P.$IM.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$IM.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$IM.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$IM.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$IM.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$IM.Unavailable(a.message);default:throw new P.$IM(a.message,a.name)}if(!(a instanceof Error))throw new P.$IM(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw P.$IM.Unavailable(a.message);switch(a.name){case M.FileSystemProviderErrorCode.FileExists:throw P.$IM.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$IM.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$IM.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$IM.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$IM.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$IM.Unavailable(a.message);default:throw new P.$IM(a.message,a.name)}}addFileSystemProvider(a,r,i){return this.b.set(a,{impl:r,extUri:i?.isCaseSensitive?k.$Bg:k.$Dg,isReadonly:!!i?.isReadonly}),(0,D.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??k.$Bg}};e.$jhc=p,e.$jhc=p=v=Je([qe(0,m.$JN),qe(1,g.$Ygc)],p),e.$khc=(0,R.$$h)("IExtHostConsumerFileSystem")}),define(Le[244],Me([1,0,3,7]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$rL.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const D=await g.handleIssueUrlRequest();if(!D)throw new Error("Issue request handler returned no result");return D}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const D=await g.provideIssueData(m);if(!D)throw new Error("Issue data provider returned no result");return D}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const D=await g.provideIssueTemplate(m);if(!D)throw new Error("Issue template provider returned no result");return D}registerIssueUriRequestHandler(R,m){const g=R.identifier.value;return this.a.set(g,m),this.c.$registerIssueUriRequestHandler(g),new M.$tL(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,m){const g=R.identifier.value;return this.b.set(g,m),this.c.$registerIssueDataProvider(g),new M.$tL(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$nic=P}),define(Le[84],Me([1,0,4,27,14,62,2]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0,e.$lhc=(0,S.$$h)("IExtensionStoragePaths");let m=class{constructor(D,A,k){this.d=A,this.f=k,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(D){return R.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,A=await this.g(D);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this.c)return R.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return R.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$mhc=m,e.$mhc=m=Je([qe(0,M.$ZN),qe(1,P.$sj),qe(2,N.$khc)],m)}),define(Le[245],Me([1,0,7,17,5]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;let N=class{constructor(m){this.a=new S.$SM(S.ColorThemeKind.Dark),this.b=new P.$Yd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=S.ColorThemeKind.Light;break;case"hcDark":g=S.ColorThemeKind.HighContrast;break;case"hcLight":g=S.ColorThemeKind.HighContrastLight;break;default:g=S.ColorThemeKind.Dark}this.a=new S.$SM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Qic=N,e.$Qic=N=Je([qe(0,M.$JN)],N)}),define(Le[85],Me([1,0,21,5,6,169,4,14,198,3,27,17,7]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lzb=e.$Kzb=e.TunnelDtoConverter=void 0;class v extends g.$Ov{}var p;(function(a){function r(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:n.protocol}}a.fromApiTunnel=r;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==g.TunnelPrivacyId.ConstantPrivate&&n.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}a.fromServiceTunnel=i})(p||(e.TunnelDtoConverter=p={})),e.$Kzb=(0,R.$$h)("IExtHostTunnelService");let s=class extends P.$Tc{constructor(r,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Yd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(D.$rL.MainThreadTunnelService)}async openTunnel(r,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,r.displayName);if(n){const o=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,i){const n=this.u();return this.r.set(n,{selector:r,provider:i}),this.a.$registerPortsAttributesProvider(r,n),new l.$tL(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(r,i,n,o,h){const t=[];for(const c of r){const u=this.r.get(c);if(!u)return[];t.push(...await Promise.all(i.map(async E=>{let y;try{y=await u.provider.providePortAttributes({port:E,pid:n,commandLine:o},h)}catch{y=await u.provider.providePortAttributes(E,n,o,h)}return{providedAttributes:y,port:E}})))}const f=t.filter(c=>!!c.providedAttributes);return f.length>0?f.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,h)=>await r.provideTunnel(o,h,new S.$9d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,i){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const n=r.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:N.localize(0,null),themeIcon:"lock"},{id:"public",label:N.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,i){if(this.g.has(r.host)){const n=this.g.get(r.host);n.has(r.port)&&(i&&n.get(r.port).disposeListener.dispose(),await n.get(r.port).tunnel.dispose(),n.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(r,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:o,disposeListener:h}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(r){const i=await Promise.all(r.map(o=>this.f(o.host,o.port,o.detail??""))),n=r.filter((o,h)=>i[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$Lzb=s,e.$Lzb=s=Je([qe(0,k.$JN),qe(1,A.$ZN),qe(2,m.$sj)],s)}),define(Le[8],Me([1,0,18,23,128,246,46,28,121,52,69,26,24,16,2,29,86,98,103,102,83,49,59,217,25,7]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.LanguageModelMessage=e.ChatMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$IN=e.$HN=e.MarkdownString=e.$GN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var E;(function(be){function Ne(K){const{selectionStartLineNumber:Re,selectionStartColumn:je,positionLineNumber:Ze,positionColumn:Ke}=K,tt=new u.$uL(Re-1,je-1),wt=new u.$uL(Ze-1,Ke-1);return new u.$wL(tt,wt)}be.to=Ne;function oe(K){const{anchor:Re,active:je}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}be.from=oe})(E||(e.Selection=E={}));var y;(function(be){function Ne(K){if(!K)return;const{start:Re,end:je}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}be.from=Ne;function oe(K){if(!K)return;const{startLineNumber:Re,startColumn:je,endLineNumber:Ze,endColumn:Ke}=K;return new u.$vL(Re-1,je-1,Ze-1,Ke-1)}be.to=oe})(y||(e.Range=y={}));var $;(function(be){function Ne(K){return{uri:K.uri,range:y.from(K.range)}}be.from=Ne;function oe(K){return new u.$FL(p.URI.revive(K.uri),y.to(K.range))}be.to=oe})($||(e.Location=$={}));var I;(function(be){function Ne(oe){switch(oe){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}be.to=Ne})(I||(e.TokenType=I={}));var d;(function(be){function Ne(K){return new u.$uL(K.lineNumber-1,K.column-1)}be.to=Ne;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}be.from=oe})(d||(e.Position=d={}));var w;(function(be){function Ne(Re,je,Ze){return(0,S.$Hb)((0,S.$3b)(Re).map(Ke=>oe(Ke,je,Ze)))}be.from=Ne;function oe(Re,je,Ze){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:Ze?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:K(Re.scheme,je),pattern:pe.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:Ze?.isBuiltin}}function K(Re,je){return je&&typeof Re=="string"?je.transformOutgoingScheme(Re):Re}})(w||(e.DocumentSelector=w={}));var b;(function(be){function Ne(K){switch(K){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}be.from=Ne;function oe(K){switch(K){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}be.to=oe})(b||(e.DiagnosticTag=b={}));var L;(function(be){function Ne(K){let Re;return K.code&&((0,v.$Mf)(K.code)||(0,v.$Qf)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),{...y.from(K.range),message:K.message,source:K.source,code:Re,severity:Y.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(T.from),tags:Array.isArray(K.tags)?(0,S.$Hb)(K.tags.map(b.from)):void 0}}be.from=Ne;function oe(K){const Re=new u.$HL(y.to(K),K.message,Y.to(K.severity));return Re.source=K.source,Re.code=(0,v.$Mf)(K.code)?K.code:K.code?.value,Re.relatedInformation=K.relatedInformation&&K.relatedInformation.map(T.to),Re.tags=K.tags&&(0,S.$Hb)(K.tags.map(b.to)),Re}be.to=oe})(L||(e.Diagnostic=L={}));var T;(function(be){function Ne(K){return{...y.from(K.location.range),message:K.message,resource:K.location.uri}}be.from=Ne;function oe(K){return new u.$GL(new u.$FL(K.resource,y.to(K)),K.message)}be.to=oe})(T||(e.DiagnosticRelatedInformation=T={}));var Y;(function(be){function Ne(K){switch(K){case u.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}be.from=Ne;function oe(K){switch(K){case r.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}be.to=oe})(Y||(e.DiagnosticSeverity=Y={}));var q;(function(be){function Ne(K){return typeof K=="number"&&K>=u.ViewColumn.One?K-1:K===u.ViewColumn.Beside?f.$jD:f.$iD}be.from=Ne;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=oe})(q||(e.ViewColumn=q={}));function U(be){return typeof be.range<"u"}function C(be){return be.length===0?!0:!!U(be[0])}e.$GN=C;var F;(function(be){function Ne(Ke){return Ke.map(be.from)}be.fromMany=Ne;function oe(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function K(Ke){let tt;if(oe(Ke)){const{language:It,value:ot}=Ke;tt={value:"```"+It+`
`+ot+"\n```\n"}}else u.$UL.isMarkdownString(Ke)?tt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?tt={value:Ke}:tt={value:""};const wt=Object.create(null);tt.uris=wt;const Ht=It=>{try{let ot=p.URI.parse(It,!0);ot=ot.with({query:Re(ot.query,wt)}),wt[It]=ot}catch{}return""},zt=new g.marked.Renderer;return zt.link=Ht,zt.image=It=>typeof It=="string"?Ht(R.$uk(It).href):"",(0,g.marked)(tt.value,{renderer:zt}),tt}be.from=K;function Re(Ke,tt){if(!Ke)return Ke;let wt;try{wt=(0,D.$Gh)(Ke)}catch{}if(!wt)return Ke;let Ht=!1;return wt=(0,k.$Dn)(wt,zt=>{if(p.URI.isUri(zt)){const It=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[It]=zt,Ht=!0,It}else return}),Ht?JSON.stringify(wt):Ke}function je(Ke){const tt=new u.$UL(Ke.value,Ke.supportThemeIcons);return tt.isTrusted=Ke.isTrusted,tt.supportHtml=Ke.supportHtml,tt.baseUri=Ke.baseUri?p.URI.from(Ke.baseUri):void 0,tt}be.to=je;function Ze(Ke){if(Ke)return typeof Ke=="string"?Ke:be.from(Ke)}be.fromStrict=Ze})(F||(e.MarkdownString=F={}));function W(be){return C(be)?be.map(Ne=>({range:y.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?F.fromMany(Ne.hoverMessage):Ne.hoverMessage?F.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):be.map(Ne=>({range:y.from(Ne)}))}e.$HN=W;function re(be){return typeof be>"u"?be:typeof be=="string"?p.URI.file(be):be}e.$IN=re;var ue;(function(be){function Ne(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?re(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}be.from=Ne})(ue||(e.ThemableDecorationAttachmentRenderOptions=ue={}));var ye;(function(be){function Ne(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?re(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ue.from(oe.before):void 0,after:oe.after?ue.from(oe.after):void 0}}be.from=Ne})(ye||(e.ThemableDecorationRenderOptions=ye={}));var ke;(function(be){function Ne(oe){if(typeof oe>"u")return oe;switch(oe){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Ne})(ke||(e.DecorationRangeBehavior=ke={}));var he;(function(be){function Ne(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?ke.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?ye.from(oe.light):void 0,dark:oe.dark?ye.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?re(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ue.from(oe.before):void 0,after:oe.after?ue.from(oe.after):void 0}}be.from=Ne})(he||(e.DecorationRenderOptions=he={}));var ve;(function(be){function Ne(K){return{text:K.newText,eol:K.newEol&&ut.from(K.newEol),range:y.from(K.range)}}be.from=Ne;function oe(K){const Re=new u.$AL(y.to(K.range),K.text);return Re.newEol=typeof K.eol>"u"?void 0:ut.to(K.eol),Re}be.to=oe})(ve||(e.TextEdit=ve={}));var se;(function(be){function Ne(K,Re){const je={edits:[]};if(K instanceof u.$DL){const Ze=new m.$Bc;for(const Ke of K._allEntries())Ke._type===1&&p.URI.isUri(Ke.to)&&Ke.from===void 0&&Ze.add(Ke.to);for(const Ke of K._allEntries())if(Ke._type===1){let tt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?tt={type:"base64",value:(0,M.$Ge)(M.$me.wrap(Ke.options.contents))}:tt={type:"dataTransferItem",id:Ke.options.contents._itemId}),je.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:tt},metadata:Ke.metadata})}else Ke._type===2?je.edits.push({resource:Ke.uri,textEdit:ve.from(Ke.edit),versionId:Ze.has(Ke.uri)?void 0:Re?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?je.edits.push({resource:Ke.uri,textEdit:{range:y.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ke.uri)?void 0:Re?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?je.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&je.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(ei.from)}})}return je}be.from=Ne;function oe(K){const Re=new u.$DL,je=new m.$Ac;for(const Ze of K.edits)if(Ze.textEdit){const Ke=Ze,tt=p.URI.revive(Ke.resource),wt=y.to(Ke.textEdit.range),Ht=Ke.textEdit.text,zt=Ke.textEdit.insertAsSnippet;let It;zt?It=u.$CL.replace(wt,new u.$EL(Ht)):It=u.$AL.replace(wt,Ht);const ot=je.get(tt);ot?ot.push(It):je.set(tt,[It])}else Re.renameFile(p.URI.revive(Ze.oldResource),p.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ke]of je)Re.set(Ze,Ke);return Re}be.to=oe})(se||(e.WorkspaceEdit=se={}));var $e;(function(be){const Ne=Object.create(null);Ne[u.SymbolKind.File]=0,Ne[u.SymbolKind.Module]=1,Ne[u.SymbolKind.Namespace]=2,Ne[u.SymbolKind.Package]=3,Ne[u.SymbolKind.Class]=4,Ne[u.SymbolKind.Method]=5,Ne[u.SymbolKind.Property]=6,Ne[u.SymbolKind.Field]=7,Ne[u.SymbolKind.Constructor]=8,Ne[u.SymbolKind.Enum]=9,Ne[u.SymbolKind.Interface]=10,Ne[u.SymbolKind.Function]=11,Ne[u.SymbolKind.Variable]=12,Ne[u.SymbolKind.Constant]=13,Ne[u.SymbolKind.String]=14,Ne[u.SymbolKind.Number]=15,Ne[u.SymbolKind.Boolean]=16,Ne[u.SymbolKind.Array]=17,Ne[u.SymbolKind.Object]=18,Ne[u.SymbolKind.Key]=19,Ne[u.SymbolKind.Null]=20,Ne[u.SymbolKind.EnumMember]=21,Ne[u.SymbolKind.Struct]=22,Ne[u.SymbolKind.Event]=23,Ne[u.SymbolKind.Operator]=24,Ne[u.SymbolKind.TypeParameter]=25;function oe(Re){return typeof Ne[Re]=="number"?Ne[Re]:6}be.from=oe;function K(Re){for(const je in Ne)if(Ne[je]===Re)return Number(je);return u.SymbolKind.Property}be.to=K})($e||(e.SymbolKind=$e={}));var te;(function(be){function Ne(K){switch(K){case u.SymbolTag.Deprecated:return 1}}be.from=Ne;function oe(K){switch(K){case 1:return u.SymbolTag.Deprecated}}be.to=oe})(te||(e.SymbolTag=te={}));var X;(function(be){function Ne(K){return{name:K.name,kind:$e.from(K.kind),tags:K.tags&&K.tags.map(te.from),containerName:K.containerName,location:Pe.from(K.location)}}be.from=Ne;function oe(K){const Re=new u.$LL(K.name,$e.to(K.kind),K.containerName,Pe.to(K.location));return Re.tags=K.tags&&K.tags.map(te.to),Re}be.to=oe})(X||(e.WorkspaceSymbol=X={}));var V;(function(be){function Ne(K){const Re={name:K.name||"!!MISSING: name!!",detail:K.detail,range:y.from(K.range),selectionRange:y.from(K.selectionRange),kind:$e.from(K.kind),tags:K.tags?.map(te.from)??[]};return K.children&&(Re.children=K.children.map(Ne)),Re}be.from=Ne;function oe(K){const Re=new u.$ML(K.name,K.detail,$e.to(K.kind),y.to(K.range),y.to(K.selectionRange));return(0,S.$Lb)(K.tags)&&(Re.tags=K.tags.map(te.to)),K.children&&(Re.children=K.children.map(oe)),Re}be.to=oe})(V||(e.DocumentSymbol=V={}));var ne;(function(be){function Ne(K){const Re=new u.$QL($e.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),y.to(K.range),y.to(K.selectionRange));return Re._sessionId=K._sessionId,Re._itemId=K._itemId,Re}be.to=Ne;function oe(K,Re,je){if(Re=Re??K._sessionId,je=je??K._itemId,Re===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:je,name:K.name,detail:K.detail,kind:$e.from(K.kind),uri:K.uri,range:y.from(K.range),selectionRange:y.from(K.selectionRange),tags:K.tags?.map(te.from)}}be.from=oe})(ne||(e.CallHierarchyItem=ne={}));var Ce;(function(be){function Ne(oe){return new u.$RL(ne.to(oe.from),oe.fromRanges.map(K=>y.to(K)))}be.to=Ne})(Ce||(e.CallHierarchyIncomingCall=Ce={}));var Fe;(function(be){function Ne(oe){return new u.$SL(ne.to(oe.to),oe.fromRanges.map(K=>y.to(K)))}be.to=Ne})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var Pe;(function(be){function Ne(K){return{range:K.range&&y.from(K.range),uri:K.uri}}be.from=Ne;function oe(K){return new u.$FL(p.URI.revive(K.uri),y.to(K.range))}be.to=oe})(Pe||(e.location=Pe={}));var we;(function(be){function Ne(K){const Re=K,je=K;return{originSelectionRange:Re.originSelectionRange?y.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:je.uri,range:y.from(Re.targetRange?Re.targetRange:je.range),targetSelectionRange:Re.targetSelectionRange?y.from(Re.targetSelectionRange):void 0}}be.from=Ne;function oe(K){return{targetUri:p.URI.revive(K.uri),targetRange:y.to(K.range),targetSelectionRange:K.targetSelectionRange?y.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?y.to(K.originSelectionRange):void 0}}be.to=oe})(we||(e.DefinitionLink=we={}));var me;(function(be){function Ne(K){return{range:y.from(K.range),contents:F.fromMany(K.contents)}}be.from=Ne;function oe(K){return new u.$IL(K.contents.map(F.to),y.to(K.range))}be.to=oe})(me||(e.Hover=me={}));var J;(function(be){function Ne(K){return{range:y.from(K.range),expression:K.expression}}be.from=Ne;function oe(K){return new u.$CM(y.to(K.range),K.expression)}be.to=oe})(J||(e.EvaluatableExpression=J={}));var x;(function(be){function Ne(K){if(K instanceof u.$DM)return{type:"text",range:y.from(K.range),text:K.text};if(K instanceof u.$EM)return{type:"variable",range:y.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof u.$FM)return{type:"expression",range:y.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Ne;function oe(K){switch(K.type){case"text":return{range:y.to(K.range),text:K.text};case"variable":return{range:y.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:y.to(K.range),expression:K.expression}}}be.to=oe})(x||(e.InlineValue=x={}));var le;(function(be){function Ne(K){return{frameId:K.frameId,stoppedLocation:y.from(K.stoppedLocation)}}be.from=Ne;function oe(K){return new u.$GM(K.frameId,y.to(K.stoppedLocation))}be.to=oe})(le||(e.InlineValueContext=le={}));var de;(function(be){function Ne(K){return{range:y.from(K.range),kind:K.kind}}be.from=Ne;function oe(K){return new u.$JL(y.to(K.range),K.kind)}be.to=oe})(de||(e.DocumentHighlight=de={}));var Ae;(function(be){function Ne(K){return{uri:K.uri,highlights:K.highlights.map(de.from)}}be.from=Ne;function oe(K){return new u.$KL(p.URI.revive(K.uri),K.highlights.map(de.to))}be.to=oe})(Ae||(e.MultiDocumentHighlight=Ae={}));var ge;(function(be){function Ne(oe){switch(oe){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}be.to=Ne})(ge||(e.CompletionTriggerKind=ge={}));var Se;(function(be){function Ne(oe){return{triggerKind:ge.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}be.to=Ne})(Se||(e.CompletionContext=Se={}));var Ie;(function(be){function Ne(K){switch(K){case u.CompletionItemTag.Deprecated:return 1}}be.from=Ne;function oe(K){switch(K){case 1:return u.CompletionItemTag.Deprecated}}be.to=oe})(Ie||(e.CompletionItemTag=Ie={}));var O;(function(be){const Ne=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function oe(je){return Ne.get(je)??9}be.from=oe;const K=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Re(je){return K.get(je)??u.CompletionItemKind.Property}be.to=Re})(O||(e.CompletionItemKind=O={}));var G;(function(be){function Ne(oe,K){const Re=new u.$1L(oe.label);return Re.insertText=oe.insertText,Re.kind=O.to(oe.kind),Re.tags=oe.tags?.map(Ie.to),Re.detail=oe.detail,Re.documentation=R.$ok(oe.documentation)?F.to(oe.documentation):oe.documentation,Re.sortText=oe.sortText,Re.filterText=oe.filterText,Re.preselect=oe.preselect,Re.commitCharacters=oe.commitCharacters,s.$Zs.isIRange(oe.range)?Re.range=y.to(oe.range):typeof oe.range=="object"&&(Re.range={inserting:y.to(oe.range.insert),replacing:y.to(oe.range.replace)}),Re.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?Re.insertText=new u.$EL(oe.insertText):(Re.insertText=oe.insertText,Re.textEdit=Re.range instanceof u.$vL?new u.$AL(Re.range,Re.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Re.additionalTextEdits=oe.additionalTextEdits.map(je=>ve.to(je))),Re.command=K&&oe.command?K.fromInternal(oe.command):void 0,Re}be.to=Ne})(G||(e.CompletionItem=G={}));var B;(function(be){function Ne(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:F.fromStrict(K.documentation)}}be.from=Ne;function oe(K){return{label:K.label,documentation:R.$ok(K.documentation)?F.to(K.documentation):K.documentation}}be.to=oe})(B||(e.ParameterInformation=B={}));var H;(function(be){function Ne(K){return{label:K.label,documentation:F.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(B.from):[],activeParameter:K.activeParameter}}be.from=Ne;function oe(K){return{label:K.label,documentation:R.$ok(K.documentation)?F.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(B.to):[],activeParameter:K.activeParameter}}be.to=oe})(H||(e.SignatureInformation=H={}));var Q;(function(be){function Ne(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.from):[]}}be.from=Ne;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.to):[]}}be.to=oe})(Q||(e.SignatureHelp=Q={}));var ae;(function(be){function Ne(oe,K){const Re=new u.$ZL(d.to(K.position),typeof K.label=="string"?K.label:K.label.map(Ee.to.bind(void 0,oe)),K.kind&&Be.to(K.kind));return Re.textEdits=K.textEdits&&K.textEdits.map(ve.to),Re.tooltip=R.$ok(K.tooltip)?F.to(K.tooltip):K.tooltip,Re.paddingLeft=K.paddingLeft,Re.paddingRight=K.paddingRight,Re}be.to=Ne})(ae||(e.InlayHint=ae={}));var Ee;(function(be){function Ne(oe,K){const Re=new u.$YL(K.label);return Re.tooltip=R.$ok(K.tooltip)?F.to(K.tooltip):K.tooltip,a.Command.is(K.command)&&(Re.command=oe.fromInternal(K.command)),K.location&&(Re.location=Pe.to(K.location)),Re}be.to=Ne})(Ee||(e.InlayHintLabelPart=Ee={}));var Be;(function(be){function Ne(K){return K}be.from=Ne;function oe(K){return K}be.to=oe})(Be||(e.InlayHintKind=Be={}));var We;(function(be){function Ne(K){return{range:y.from(K.range),url:K.target,tooltip:K.tooltip}}be.from=Ne;function oe(K){let Re;if(K.url)try{Re=typeof K.url=="string"?p.URI.parse(K.url,!0):p.URI.revive(K.url)}catch{}return new u.$6L(y.to(K.range),Re)}be.to=oe})(We||(e.DocumentLink=We={}));var Qe;(function(be){function Ne(K){const Re=new u.$9L(K.label);return K.textEdit&&(Re.textEdit=ve.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(je=>ve.to(je))),Re}be.to=Ne;function oe(K){return{label:K.label,textEdit:K.textEdit?ve.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>ve.from(Re)):void 0}}be.from=oe})(Qe||(e.ColorPresentation=Qe={}));var xe;(function(be){function Ne(K){return new u.$7L(K[0],K[1],K[2],K[3])}be.to=Ne;function oe(K){return[K.red,K.green,K.blue,K.alpha]}be.from=oe})(xe||(e.Color=xe={}));var ct;(function(be){function Ne(K){return{range:y.from(K.range)}}be.from=Ne;function oe(K){return new u.$PL(y.to(K.range))}be.to=oe})(ct||(e.SelectionRange=ct={}));var rt;(function(be){function Ne(oe){switch(oe){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}be.to=Ne})(rt||(e.TextDocumentSaveReason=rt={}));var et;(function(be){function Ne(K){switch(K){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.Interval:return 3;case u.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Ne;function oe(K){switch(K){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 3:return u.TextEditorLineNumbersStyle.Interval;case 1:default:return u.TextEditorLineNumbersStyle.On}}be.to=oe})(et||(e.TextEditorLineNumbersStyle=et={}));var ut;(function(be){function Ne(K){if(K===u.EndOfLine.CRLF)return 1;if(K===u.EndOfLine.LF)return 0}be.from=Ne;function oe(K){if(K===1)return u.EndOfLine.CRLF;if(K===0)return u.EndOfLine.LF}be.to=oe})(ut||(e.EndOfLine=ut={}));var Ue;(function(be){function Ne(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Ne})(Ue||(e.ProgressLocation=Ue={}));var pt;(function(be){function Ne(K){const Re={start:K.start+1,end:K.end+1};return K.kind&&(Re.kind=Z.from(K.kind)),Re}be.from=Ne;function oe(K){const Re={start:K.start-1,end:K.end-1};return K.kind&&(Re.kind=Z.to(K.kind)),Re}be.to=oe})(pt||(e.FoldingRange=pt={}));var Z;(function(be){function Ne(K){if(K)switch(K){case u.FoldingRangeKind.Comment:return a.$Pt.Comment;case u.FoldingRangeKind.Imports:return a.$Pt.Imports;case u.FoldingRangeKind.Region:return a.$Pt.Region}}be.from=Ne;function oe(K){if(K)switch(K.value){case a.$Pt.Comment.value:return u.FoldingRangeKind.Comment;case a.$Pt.Imports.value:return u.FoldingRangeKind.Imports;case a.$Pt.Region.value:return u.FoldingRangeKind.Region}}be.to=oe})(Z||(e.FoldingRangeKind=Z={}));var _;(function(be){function Ne(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?y.from(oe.selection):void 0,override:typeof oe.override=="boolean"?n.$LE.id:void 0}}be.from=Ne})(_||(e.TextEditorOpenOptions=_={}));var pe;(function(be){function Ne(je){return je instanceof u.$qM?je.toJSON():typeof je=="string"?je:oe(je)||K(je)?new u.$qM(je.baseUri??je.base,je.pattern).toJSON():je}be.from=Ne;function oe(je){const Ze=je;return Ze?p.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function K(je){const Ze=je;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Re(je){return typeof je=="string"?je:new u.$qM(p.URI.revive(je.baseUri),je.pattern)}be.to=Re})(pe||(e.GlobPattern=pe={}));var Ve;(function(be){function Ne(oe){if(oe){if(Array.isArray(oe))return oe.map(Ne);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:pe.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}be.from=Ne})(Ve||(e.LanguageSelector=Ve={}));var Ye;(function(be){function Ne(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Re=>Array.isArray(Re)&&Re.every(je=>je&&typeof je=="object"&&"uri"in je&&p.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ze=>Ze instanceof u.$vL)))}be.is=Ne;function oe(K){return{documents:K.documents.map(Re=>Re.map(je=>({uri:p.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ze=>y.from(Ze))})))}}be.from=oe})(Ye||(e.MappedEditsContext=Ye={}));var nt;(function(be){function Ne(K){return{start:K.start,end:K.end}}be.from=Ne;function oe(K){return new u.$TM(K.start,K.end)}be.to=oe})(nt||(e.NotebookRange=nt={}));var st;(function(be){function Ne(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}be.to=Ne;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}be.from=oe})(st||(e.NotebookCellExecutionSummary=st={}));var Te;(function(be){function Ne(oe){if(oe===o.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(oe===o.NotebookCellExecutionState.Pending)return;if(oe===o.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}be.to=Ne})(Te||(e.NotebookCellExecutionState=Te={}));var Nt;(function(be){function Ne(K){switch(K){case u.NotebookCellKind.Markup:return o.CellKind.Markup;case u.NotebookCellKind.Code:default:return o.CellKind.Code}}be.from=Ne;function oe(K){switch(K){case o.CellKind.Markup:return u.NotebookCellKind.Markup;case o.CellKind.Code:default:return u.NotebookCellKind.Code}}be.to=oe})(Nt||(e.NotebookCellKind=Nt={}));var Qt;(function(be){function Ne(K){const Re={metadata:K.metadata??Object.create(null),cells:[]};for(const je of K.cells)u.$UM.validate(je),Re.cells.push(ei.from(je));return Re}be.from=Ne;function oe(K){const Re=new u.$VM(K.cells.map(ei.to));return(0,v.$Zf)(K.metadata)||(Re.metadata=K.metadata),Re}be.to=oe})(Qt||(e.NotebookData=Qt={}));var ei;(function(be){function Ne(K){return{cellKind:Nt.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:st.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Et.from):[]}}be.from=Ne;function oe(K){return new u.$UM(Nt.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Et.to):void 0,K.metadata,K.internalMetadata?st.to(K.internalMetadata):void 0)}be.to=oe})(ei||(e.NotebookCellData=ei={}));var Ut;(function(be){function Ne(K){return{mime:K.mime,valueBytes:M.$me.wrap(K.data)}}be.from=Ne;function oe(K){return new u.$WM(K.valueBytes.buffer,K.mime)}be.to=oe})(Ut||(e.NotebookCellOutputItem=Ut={}));var Et;(function(be){function Ne(K){return{outputId:K.id,items:K.items.map(Ut.from),metadata:K.metadata}}be.from=Ne;function oe(K){const Re=K.items.map(Ut.to);return new u.$XM(Re,K.outputId,K.metadata)}be.to=oe})(Et||(e.NotebookCellOutput=Et={}));var ti;(function(be){function Ne(Re){return K(Re)?{include:pe.from(Re.include)??void 0,exclude:pe.from(Re.exclude)??void 0}:pe.from(Re)??void 0}be.from=Ne;function oe(Re){return K(Re)?{include:pe.to(Re.include),exclude:pe.to(Re.exclude)}:pe.to(Re)}be.to=oe;function K(Re){const je=Re;return je?!(0,v.$Vf)(je.include)&&!(0,v.$Vf)(je.exclude):!1}})(ti||(e.NotebookExclusiveDocumentPattern=ti={}));var jt;(function(be){function Ne(oe,K,Re){const je=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(je,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}be.from=Ne})(jt||(e.NotebookStatusBarItem=jt={}));var si;(function(be){function Ne(oe,K,Re){const je=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:K.toInternal(je,Re),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}be.from=Ne})(si||(e.NotebookKernelSourceAction=si={}));var Zt;(function(be){function Ne(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}be.from=Ne})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var Xt;(function(be){function Ne(K){return{uri:K.uri,provides:K.provides}}be.from=Ne;function oe(K){return new u.$ZM(p.URI.revive(K.uri),K.provides)}be.to=oe})(Xt||(e.NotebookRendererScript=Xt={}));var Xe;(function(be){function Ne(K){return{message:F.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:y.from(K.location.range),uri:K.location.uri}}}be.from=Ne;function oe(K){const Re=new u.$6M(typeof K.message=="string"?K.message:F.to(K.message));return Re.actualOutput=K.actual,Re.expectedOutput=K.expected,Re.contextValue=K.contextValue,Re.location=K.location?Pe.to(K.location):void 0,Re}be.to=oe})(Xe||(e.TestMessage=Xe={}));var Bt;(function(be){be.namespace=t.$mK,be.denamespace=t.$nK})(Bt||(e.TestTag=Bt={}));var ii;(function(be){function Ne(K){const Re=(0,i.$FN)(K).controllerId;return{extId:h.$iK.fromExtHostTestItem(K,Re).toString(),label:K.label,uri:p.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(je=>Bt.namespace(Re,je.id)),range:s.$Zs.lift(y.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&F.fromStrict(K.error)||null}}be.from=Ne;function oe(K){return{parent:void 0,error:void 0,id:h.$iK.fromString(K.extId).localId,label:K.label,uri:p.URI.revive(K.uri),tags:(K.tags||[]).map(Re=>{const{tagId:je}=Bt.denamespace(Re);return new u.$7M(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}be.toPlain=oe})(ii||(e.TestItem=ii={})),function(be){function Ne(K){return{id:K.id}}be.from=Ne;function oe(K){return new u.$7M(K.id)}be.to=oe}(Bt||(e.TestTag=Bt={}));var ht;(function(be){const Ne=(K,Re)=>{const je=[];for(const[Ke,tt]of Re)h.$iK.compare(tt.item.extId,Ke)===2&&(Re.delete(Ke),je.push(tt));const Ze={...ii.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(tt=>tt.type===0).map(Xe.to)})),children:je.map(Ke=>Ne(Ke,Re))};for(const Ke of Ze.children)Ke.parent=Ze;return Ze};function oe(K){const Re=[],je=new Map;for(const Ze of K.items){je.set(Ze.item.extId,Ze);const Ke=h.$iK.root(Ze.item.extId);K.request.targets.some(tt=>tt.controllerId===Ke&&tt.testIds.includes(Ze.item.extId))&&Re.push(Ze)}return{completedAt:K.completedAt,results:Re.map(Ze=>Ne(Ze,je))}}be.to=oe})(ht||(e.TestResults=ht={}));var mt;(function(be){function Ne(je){return{covered:je.covered,total:je.total}}function oe(je){return"line"in je?d.from(je):y.from(je)}function K(je){return"branches"in je?{count:je.executed,location:oe(je.location),type:1,branches:je.branches.length?je.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&oe(Ze.location),label:Ze.label})):void 0}:{type:0,name:je.name,count:je.executed,location:oe(je.location)}}be.fromDetailed=K;function Re(je){return{uri:je.uri,statement:Ne(je.statementCoverage),branch:je.branchCoverage&&Ne(je.branchCoverage),declaration:je.declarationCoverage&&Ne(je.declarationCoverage),details:je.detailedCoverage?.map(K)}}be.fromFile=Re})(mt||(e.TestCoverage=mt={}));var Kt;(function(be){function Ne(oe){switch(oe){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}be.to=Ne})(Kt||(e.CodeActionTriggerKind=Kt={}));var ni;(function(be){function Ne(K){const Re=new u.$aN($e.to(K.kind),K.name,K.detail||"",p.URI.revive(K.uri),y.to(K.range),y.to(K.selectionRange));return Re._sessionId=K._sessionId,Re._itemId=K._itemId,Re}be.to=Ne;function oe(K,Re,je){if(Re=Re??K._sessionId,je=je??K._itemId,Re===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:je,kind:$e.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:y.from(K.range),selectionRange:y.from(K.selectionRange),tags:K.tags?.map(te.from)}}be.from=oe})(ni||(e.TypeHierarchyItem=ni={}));var Ct;(function(be){function Ne(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}be.from=Ne})(Ct||(e.ViewBadge=Ct={}));var dt;(function(be){function Ne(je,Ze,Ke){const tt=Ze.fileData;return tt?new u.$jM(new u.$kM(tt.name,p.URI.revive(tt.uri),tt.id,(0,N.$db)(()=>Ke(tt.id)))):je===A.$ks.uriList&&Ze.uriListData?new u.$iM(Re(Ze.uriListData)):new u.$iM(Ze.asString)}be.to=Ne;async function oe(je,Ze){const Ke=await Ze.asString();if(je===A.$ks.uriList)return{asString:Ke,fileData:void 0,uriListData:K(Ke)};const tt=Ze.asFile();return{asString:Ke,fileData:tt?{name:tt.name,uri:tt.uri,id:tt._itemId??tt.id}:void 0}}be.from=oe;function K(je){return P.$wt.split(je).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return p.URI.parse(Ze)}catch{}return Ze})}function Re(je){return P.$wt.create(je.map(Ze=>typeof Ze=="string"?Ze:p.URI.revive(Ze)))}})(dt||(e.DataTransferItem=dt={}));var At;(function(be){function Ne(K,Re){const je=K.items.map(([Ze,Ke])=>[Ze,dt.to(Ze,Ke,Re)]);return new u.$lM(je)}be.toDataTransfer=Ne;async function oe(K){const Re={items:[]},je=[];for(const[Ze,Ke]of K)je.push((async()=>{Re.items.push([Ze,await dt.from(Ze,Ke)])})());return await Promise.all(je),Re}be.from=oe})(At||(e.DataTransfer=At={}));var oi;(function(be){function Ne(K,Re){return{kind:"reply",agentId:K.agentId??Re?.agentId??"",subCommand:K.command??Re?.command,message:K.prompt,title:K.title,tooltip:K.tooltip}}be.from=Ne;function oe(K){return{prompt:K.message,title:K.title,agentId:K.agentId,command:K.subCommand,tooltip:K.tooltip}}be.to=oe})(oi||(e.ChatFollowup=oi={}));var Lt;(function(be){function Ne(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}be.from=Ne})(Lt||(e.ChatInlineFollowup=Lt={}));var He;(function(be){function Ne(oe){return new u.$mN(Jt.to(oe.role),oe.content)}be.to=Ne})(He||(e.ChatMessage=He={}));var Gt;(function(be){function Ne(K){switch(K.role){case 0:return new u.$wN(K.content);case 1:return new u.$xN(K.content);case 2:return new u.$yN(K.content)}}be.to=Ne;function oe(K){if(K instanceof u.$wN)return{role:0,content:K.content};if(K instanceof u.$xN)return{role:1,content:K.content};if(K instanceof u.$yN)return{role:2,content:K.content};throw new Error("Invalid LanguageModelMessage")}be.from=oe})(Gt||(e.LanguageModelMessage=Gt={}));var Jt;(function(be){function Ne(K){switch(K){case 0:return u.ChatMessageRole.System;case 1:return u.ChatMessageRole.User;case 2:return u.ChatMessageRole.Assistant}}be.to=Ne;function oe(K){switch(K){case u.ChatMessageRole.System:return 0;case u.ChatMessageRole.Assistant:return 2;case u.ChatMessageRole.User:default:return 1}}be.from=oe})(Jt||(e.ChatMessageRole=Jt={}));var _t;(function(be){function Ne(Re){const je={};for(const Ze of Object.keys(Re))je[Ze]=Re[Ze].map(be.to);return je}be.objectTo=Ne;function oe(Re){return{level:ft.to(Re.level),kind:Re.kind,value:(0,p.$vc)(Re.value)?p.URI.revive(Re.value):Re.value,description:Re.description}}be.to=oe;function K(Re){return{level:ft.from(Re.level),kind:Re.kind,value:Re.value,description:Re.description}}be.from=K})(_t||(e.ChatVariable=_t={}));var ft;(function(be){function Ne(K){switch(K){case"short":return u.ChatVariableLevel.Short;case"medium":return u.ChatVariableLevel.Medium;case"full":default:return u.ChatVariableLevel.Full}}be.to=Ne;function oe(K){switch(K){case u.ChatVariableLevel.Short:return"short";case u.ChatVariableLevel.Medium:return"medium";case u.ChatVariableLevel.Full:default:return"full"}}be.from=oe})(ft||(e.ChatVariableLevel=ft={}));var Ft;(function(be){function Ne(oe){switch(oe){case 1:return u.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return u.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return u.InteractiveEditorResponseFeedbackKind.Undone;case 3:return u.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return u.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Ne})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Rt;(function(be){function Ne(K){return{kind:"markdownContent",content:F.from(new u.$UL().appendText(K.value))}}be.to=Ne;function oe(K){return new u.$nN(K.content.value)}be.from=oe})(Rt||(e.ChatResponseTextPart=Rt={}));var Tt;(function(be){function Ne(K){return{kind:"markdownContent",content:F.from(K.value)}}be.to=Ne;function oe(K){return new u.$oN(F.to(K.content))}be.from=oe})(Tt||(e.ChatResponseMarkdownPart=Tt={}));var Wt;(function(be){function Ne(K){const{value:Re,baseUri:je}=K;function Ze(Ke,tt){return Ke.map(wt=>{const Ht=p.URI.joinPath(tt,wt.name);return{label:wt.name,uri:Ht,children:wt.children&&Ze(wt.children,Ht)}})}return{kind:"treeData",treeData:{label:(0,l.$Ig)(je),uri:je,children:Ze(Re,je)}}}be.to=Ne;function oe(K){const Re=(0,D.$Hh)(K.treeData);function je(tt){return tt.map(wt=>({name:wt.label,children:wt.children&&je(wt.children)}))}const Ze=Re.uri,Ke=Re.children?je(Re.children):[];return new u.$pN(Ke,Ze)}be.from=oe})(Wt||(e.ChatResponseFilesPart=Wt={}));var Ot;(function(be){function Ne(K){return{kind:"inlineReference",name:K.title,inlineReference:p.URI.isUri(K.value)?K.value:$.from(K.value)}}be.to=Ne;function oe(K){const Re=(0,D.$Hh)(K);return new u.$qN(p.URI.isUri(Re.inlineReference)?Re.inlineReference:$.to(Re.inlineReference),K.name)}be.from=oe})(Ot||(e.ChatResponseAnchorPart=Ot={}));var kt;(function(be){function Ne(K){return{kind:"progressMessage",content:F.from(K.value)}}be.to=Ne;function oe(K){return new u.$rN(K.content.value)}be.from=oe})(kt||(e.ChatResponseProgressPart=kt={}));var Vt;(function(be){function Ne(K,Re,je){return{kind:"command",command:Re.toInternal(K.value,je)??{command:K.value.command,title:K.value.title}}}be.to=Ne;function oe(K,Re){return new u.$sN(Re.fromInternal(K.command)??{command:K.command.id,title:K.command.title})}be.from=oe})(Vt||(e.ChatResponseCommandButtonPart=Vt={}));var yt;(function(be){function Ne(K){return{kind:"reference",reference:p.URI.isUri(K.value)?K.value:$.from(K.value)}}be.to=Ne;function oe(K){const Re=(0,D.$Hh)(K);return new u.$tN(p.URI.isUri(Re.reference)?Re.reference:$.to(Re.reference))}be.from=oe})(yt||(e.ChatResponseReferencePart=yt={}));var bt;(function(be){function Ne(K){return K instanceof u.$oN?Tt.to(K):K instanceof u.$qN?Ot.to(K):K instanceof u.$tN?yt.to(K):K instanceof u.$rN?kt.to(K):K instanceof u.$pN?Wt.to(K):{kind:"content",content:""}}be.to=Ne;function oe(K,Re){switch(K.kind){case"markdownContent":return Tt.from(K);case"inlineReference":return Ot.from(K);case"reference":return yt.from(K);case"progressMessage":return kt.from(K);case"treeData":return Wt.from(K);case"command":return Vt.from(K,Re)}}be.from=oe})(bt||(e.ChatResponsePart=bt={}));var St;(function(be){function Ne(Re,je){return"markdownContent"in je?((0,c.$OF)(Re,"chatAgents2Additions"),{content:F.from(je.markdownContent),kind:"markdownContent"}):"content"in je?"vulnerabilities"in je&&je.vulnerabilities?((0,c.$OF)(Re,"chatAgents2Additions"),{content:je.content,vulnerabilities:je.vulnerabilities,kind:"vulnerability"}):typeof je.content=="string"?{content:je.content,kind:"content"}:((0,c.$OF)(Re,"chatAgents2Additions"),{content:F.from(je.content),kind:"markdownContent"}):"documents"in je?{documents:je.documents.map(Ze=>({uri:Ze.uri,version:Ze.version,ranges:Ze.ranges.map(Ke=>y.from(Ke))})),kind:"usedContext"}:"reference"in je?{reference:"uri"in je.reference?{uri:je.reference.uri,range:y.from(je.reference.range)}:je.reference,kind:"reference"}:"inlineReference"in je?{inlineReference:"uri"in je.inlineReference?{uri:je.inlineReference.uri,range:y.from(je.inlineReference.range)}:je.inlineReference,name:je.title,kind:"inlineReference"}:"agentName"in je?((0,c.$OF)(Re,"chatAgents2Additions"),{agentName:je.agentName,command:je.command,kind:"agentDetection"}):"message"in je?{content:F.from(je.message),kind:"progressMessage"}:void 0}be.from=Ne;function oe(Re){switch(Re.kind){case"markdownContent":case"inlineReference":case"treeData":return be.to(Re);case"content":return{content:Re.content};case"usedContext":return{documents:Re.documents.map(je=>({uri:p.URI.revive(je.uri),version:je.version,ranges:je.ranges.map(Ze=>y.to(Ze))}))};case"reference":return{reference:(0,p.$vc)(Re.reference)?p.URI.revive(Re.reference):$.to(Re.reference)};case"agentDetection":return;case"progressMessage":return{message:Re.content.value};case"vulnerability":return{content:Re.content,vulnerabilities:Re.vulnerabilities};default:return}}be.to=oe;function K(Re,je){switch(Re.kind){case"markdownContent":return{content:Re.content.value};case"inlineReference":return{inlineReference:(0,p.$vc)(Re.inlineReference)?p.URI.revive(Re.inlineReference):$.to(Re.inlineReference),title:Re.name};case"command":return{command:je.fromInternal(Re.command)??{command:Re.command.id,title:Re.command.title}};default:return}}be.toProgressContent=K})(St||(e.ChatResponseProgress=St={}));var Dt;(function(be){function Ne(oe){return{prompt:oe.message,command:oe.command,variables:oe.variables.variables.map(ci.to)}}be.to=Ne})(Dt||(e.ChatAgentRequest=Dt={}));var ci;(function(be){function Ne(oe){return{name:oe.name,range:[oe.range.start,oe.range.endExclusive],values:oe.values.map(_t.to)}}be.to=Ne})(ci||(e.ChatAgentResolvedVariable=ci={}));var Yt;(function(be){function Ne(oe){return{label:oe.label,values:oe.values.map(_t.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation}}be.from=Ne})(Yt||(e.ChatAgentCompletionItem=Yt={}));var gi;(function(be){function Ne(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}be.to=Ne})(gi||(e.ChatAgentResult=gi={}));var qt;(function(be){function Ne(oe,K,Re){if(K.action.kind==="vote")return;const je=gi.to(oe);return K.action.kind==="command"?{action:{kind:"command",commandButton:St.toProgressContent(K.action.commandButton,Re)},result:je}:K.action.kind==="followUp"?{action:{kind:"followUp",followup:oi.to(K.action.followup)},result:je}:{action:K.action,result:je}}be.to=Ne})(qt||(e.ChatAgentUserActionEvent=qt={}));var mi;(function(be){function Ne(oe,K,Re){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:K.toInternal(oe,Re)}be.from=Ne})(mi||(e.TerminalQuickFix=mi={}));var Pt;(function(be){function Ne(oe,K){return{id:K,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}be.from=Ne})(Pt||(e.DebugTreeItem=Pt={}))}),define(Le[247],Me([1,0,3,17,8]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6gc=void 0;let N=class{constructor(m,g){this.a=m.getProxy(S.$rL.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>g.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,g,D){const A=P.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,D?.isRefactoring??!1)}};e.$6gc=N,e.$6gc=N=Je([qe(0,M.$JN)],N)}),define(Le[248],Me([1,0,18,11,41,5,46,6,63,2,158,3,8,7,207,25]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=void 0;class a{constructor(o,h,t,f,c,u){this.i=o,this.j=h,this.k=t,this.l=f,this.m=c,this.n=u,this.a=g.$Ud.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let h=function(f){if(o.b){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,f),c}};const o=this;this.a.reset();const t=f=>{typeof this.d>"u"&&"content"in f&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,f)};this.g={text(f){return h(this.text),this.markdown(new R.$mk().appendText(f)),this},markdown(f){h(this.markdown);const c=new v.$oN(f),u=l.ChatResponseMarkdownPart.to(c);return t(u),this},filetree(f,c){h(this.filetree);const u=new v.$pN(f,c),E=l.ChatResponseFilesPart.to(u);return t(E),this},anchor(f,c){h(this.anchor);const u=new v.$qN(f,c),E=l.ChatResponseAnchorPart.to(u);return t(E),this},button(f){h(this.anchor);const c=new v.$sN(f),u=l.ChatResponseCommandButtonPart.to(c,o.m,o.n);return t(u),this},progress(f){h(this.progress);const c=new v.$rN(f),u=l.ChatResponseProgressPart.to(c);return t(u),this},reference(f){h(this.reference);const c=new v.$tN(f),u=l.ChatResponseReferencePart.to(c);return t(u),this},push(f){h(this.push);const c=l.ChatResponsePart.to(f);return t(c),this},report(f){if(h(this.report),"placeholder"in f&&"resolvedContent"in f)return;const c=l.ChatResponseProgress.from(o.i,f);if(!c){o.l.error("Unknown progress type: "+JSON.stringify(f));return}return t(c),this}}}return this.g}}class r{static{this.a=0}constructor(o,h,t){this.i=h,this.j=t,this.b=new Map,this.g=new m.$3c,this.d=o.getProxy(k.$rL.MainThreadChatAgents2)}createChatAgent(o,h,t){const f=r.a++,c=new i(o,h,this.d,f,t);return this.b.set(f,c),this.d.$registerAgent(f,o.identifier,h,{}),c.apiAgent}async $invokeAgent(o,h,t,f){const c=this.b.get(o);if(!c)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let u=this.g.get(h.sessionId);u||(u=new m.$Sc,this.g.set(h.sessionId,u));const E=new a(c.extension,h,this.d,this.i,this.j.converter,u);try{const y=await this.k(h,t),$=c.invoke(l.ChatAgentRequest.to(h),{history:y},E.apiObject,f);return await(0,M.$Yg)(Promise.resolve($).then(I=>{if(I?.metadata)try{JSON.stringify(I.metadata)}catch(d){const w=`result.metadata MUST be JSON.stringify-able. Got error: ${d.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${w}`,c.extension),{errorDetails:{message:w},timings:E.timings}}return{errorDetails:I?.errorDetails,timings:E.timings,metadata:I?.metadata}}),f)}catch(y){return this.i.error(y,c.extension),{errorDetails:{message:(0,A.localize)(0,null,(0,P.$Vi)(y)),responseIsIncomplete:!0}}}finally{E.close()}}async k(o,h){const t=[];for(const f of h.history){const c=l.ChatAgentResult.to(f.result),u=o.agentId===f.request.agentId?c:{...c,metadata:void 0};t.push(new v.$uN(f.request.message,f.request.command,f.request.variables.variables.map(l.ChatAgentResolvedVariable.to),{extensionId:"",agentId:f.request.agentId}));const E=(0,S.$Hb)(f.response.map(y=>l.ChatResponsePart.from(y,this.j.converter)));t.push(new v.$vN(E,u,{extensionId:"",agentId:f.request.agentId}))}return t}$releaseSession(o){this.g.deleteAndDispose(o)}async $provideSlashCommands(o,h){const t=this.b.get(o);return t?t.provideSlashCommands(h):[]}async $provideFollowups(o,h,t,f){const c=this.b.get(h);if(!c)return Promise.resolve([]);const u=l.ChatAgentResult.to(t);return(await c.provideFollowups(u,f)).map(E=>l.ChatFollowup.from(E,o))}$acceptFeedback(o,h,t,f){const c=this.b.get(o);if(!c)return;const u=l.ChatAgentResult.to(h);let E;switch(t){case p.InteractiveSessionVoteDirection.Down:E=v.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:E=v.ChatAgentResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(f?{result:u,kind:E,reportIssue:f}:{result:u,kind:E}))}$acceptAction(o,h,t){const f=this.b.get(o);if(!f||t.action.kind==="vote")return;const c=l.ChatAgentUserActionEvent.to(h,t,this.j.converter);c&&f.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(o,h,t){const f=this.b.get(o);return f?(await f.invokeCompletionProvider(h,t)).map(l.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(o,h){const t=this.b.get(o);if(t)return await t.provideWelcomeMessage(h)}async $provideSampleQuestions(o,h){const t=this.b.get(o);if(t)return(await t.provideSampleQuestions(h)).map(f=>l.ChatFollowup.from(f,void 0))}}e.$8gc=r;class i{constructor(o,h,t,f,c){this.extension=o,this.id=h,this.u=t,this.w=f,this.x=c,this.o=new N.$Yd,this.p=new N.$Yd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.p.fire(o)}async invokeCompletionProvider(o,h){return this.s?await this.s.provider.provideCompletionItems(o,h)??[]:[]}async provideSlashCommands(o){if(!this.a)return[];const h=await this.a.provideCommands(o);return h?h.map(t=>("repopulate2"in t&&(0,s.$OF)(this.extension,"chatAgents2Additions"),{name:t.name,description:t.description,followupPlaceholder:t.isSticky2?.placeholder,shouldRepopulate:t.isSticky2?.isSticky??t.isSticky,sampleRequest:t.sampleRequest})):[]}async provideFollowups(o,h){if(!this.b)return[];const t=await this.b.provideFollowups(o,h);return t?t.filter(f=>!(f&&"commandId"in f)).filter(f=>!(f&&"message"in f)):[]}async provideWelcomeMessage(o){if(!this.t)return[];const h=await this.t.provideWelcomeMessage(o);return h?h.map(t=>typeof t=="string"?t:l.MarkdownString.from(t)):[]}async provideSampleQuestions(o){if(!this.t||!this.t.provideSampleQuestions)return[];const h=await this.t.provideSampleQuestions(o);return h||[]}get apiAgent(){let o=!1,h=!1;const t=()=>{o||h||(h=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof D.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$oM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q}),h=!1}))},f=this;return{get name(){return f.id},get description(){return f.d??""},set description(c){f.d=c,t()},get fullName(){return f.g??f.extension.displayName??f.extension.name},set fullName(c){f.g=c,t()},get iconPath(){return f.i},set iconPath(c){f.i=c,t()},get commandProvider(){return f.a},set commandProvider(c){f.a=c,t()},get followupProvider(){return f.b},set followupProvider(c){f.b=c,t()},get isDefault(){return(0,s.$OF)(f.extension,"defaultChatAgent"),f.j},set isDefault(c){(0,s.$OF)(f.extension,"defaultChatAgent"),f.j=c,t()},get helpTextPrefix(){return(0,s.$OF)(f.extension,"defaultChatAgent"),f.k},set helpTextPrefix(c){if((0,s.$OF)(f.extension,"defaultChatAgent"),!f.j)throw new Error("helpTextPrefix is only available on the default chat agent");f.k=c,t()},get helpTextPostfix(){return(0,s.$OF)(f.extension,"defaultChatAgent"),f.l},set helpTextPostfix(c){if((0,s.$OF)(f.extension,"defaultChatAgent"),!f.j)throw new Error("helpTextPostfix is only available on the default chat agent");f.l=c,t()},get isSecondary(){return(0,s.$OF)(f.extension,"defaultChatAgent"),f.n},set isSecondary(c){(0,s.$OF)(f.extension,"defaultChatAgent"),f.n=c,t()},get sampleRequest(){return f.m},set sampleRequest(c){f.m=c,t()},get supportIssueReporting(){return(0,s.$OF)(f.extension,"chatAgents2Additions"),f.q},set supportIssueReporting(c){(0,s.$OF)(f.extension,"chatAgents2Additions"),f.q=c,t()},get onDidReceiveFeedback(){return f.o.event},set agentVariableProvider(c){if(f.s=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");f.u.$registerAgentCompletionsProvider(f.w,c.triggerCharacters)}else f.u.$unregisterAgentCompletionsProvider(f.w)},get agentVariableProvider(){return f.s},set welcomeMessageProvider(c){f.t=c,t()},get welcomeMessageProvider(){return f.t},onDidPerformAction:(0,s.$NF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,dispose(){o=!0,f.a=void 0,f.b=void 0,f.o.dispose(),f.u.$unregisterAgent(f.w)}}}invoke(o,h,t,f){return this.x(o,h,t,f)}}}),define(Le[249],Me([1,0,21,6,3,8,99,22,11,5,159,104]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class l{constructor(a,r){this.option=a,this.stream=new g.$Bh,this.stream=r??new g.$Bh}}class v{constructor(a,r){this.cts=r,this.a=new Map,this.b=new g.$Bh,this.c=!1;const i=this;this.apiObject={result:a,stream:i.b.asyncIterable},a.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,n]of this.a)n.stream.resolve();else this.b.resolve()})}handleFragment(a){if(this.c)return;let r=this.a.get(a.index);r||(this.a.size===0?r=new l(a.index,this.b):r=new l(a.index),this.a.set(a.index,r)),r.stream.emitOne(a.part)}}class p{static{this.a=1}constructor(a,r,i){this.k=r,this.l=i,this.c=new D.$Yd,this.d=new D.$Yd,this.f=new D.$Yd,this.onDidChangeProviders=this.f.event,this.g=new Map,this.h=new Set,this.i=new m.$sm,this.j=new Map,this.b=a.getProxy(P.$rL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.f.dispose()}registerLanguageModel(a,r,i,n){const o=p.a++;this.g.set(o,{extension:a.identifier,provider:i});let h;return n.auth&&(h={providerLabel:a.displayName||a.name,accountLabel:typeof n.auth=="object"?n.auth.label:void 0}),this.b.$registerProvider(o,r,{extension:a.identifier,model:n.name??"",auth:h}),(0,M.$Rc)(()=>{this.g.delete(o),this.b.$unregisterProvider(o)})}async $provideLanguageModelResponse(a,r,i,n,o,h){const t=this.g.get(a);if(!t)return;const f=new R.$Av(async c=>{if(h.isCancellationRequested){this.k.warn(`[CHAT](${t.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:c.index,part:c.part})});return t.provider.provideLanguageModelResponse2?t.provider.provideLanguageModelResponse2(n.map(N.LanguageModelMessage.to),o,m.$qm.toKey(i),f,h):t.provider.provideLanguageModelResponse(n.map(N.ChatMessage.to),o,m.$qm.toKey(i),f,h)}$updateLanguageModels(a){const r=[],i=[];if(a.added)for(const n of a.added)this.h.add(n),r.push(n);if(a.removed)for(const n of a.removed){this.h.delete(n),i.push(n);for(const[o,h]of this.j)h.languageModelId===n&&(h.res.cts.cancel(),this.j.delete(o))}this.f.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(i)}))}getLanguageModelIds(){return Array.from(this.h)}$updateModelAccesslist(a){const r=new Array;for(const{from:i,to:n,enabled:o}of a){const h=this.i.get(i)??new m.$rm;if(h.has(n)!==o){o?h.add(n):h.delete(n),this.i.set(i,h);const f={from:i,to:n};r.push(f),this.d.fire(f)}}}async requestLanguageModelAccess(a,r,i){const n=a.identifier,o=i?.justification,h=await this.b.$prepareChatAccess(n,r,o);if(!h)throw new Error(`Language model '${r}' NOT found`);this.n(n,h)&&await this.m(a,{identifier:h.extension,displayName:h.auth.providerLabel},o);const t=this;return{get model(){return h.model},get isRevoked(){return t.n(n,h)&&!t.i.get(n)?.has(h.extension)||!t.h.has(r)},get onDidChangeAccess(){const f=D.Event.filter(t.c.event,E=>E.has(n)),c=D.Event.filter(t.f.event,E=>E.removed.includes(r)),u=D.Event.filter(t.d.event,E=>m.$qm.equals(E.from,n)&&m.$qm.equals(E.to,h.extension));return D.Event.signal(D.Event.any(f,c,u))},makeChatRequest(f,c,u){if(t.n(n,h)&&!t.i.get(n)?.has(h.extension))throw new Error("Access to chat has been revoked");if(!t.h.has(r))throw new Error("Language Model has been removed");const E=new S.$9d(u),y=Math.random()*1e6|0,$=t.b.$fetchResponse(n,r,y,f.map(N.LanguageModelMessage.from),c??{},E.token),I=new v($,E);return t.j.set(y,{languageModelId:r,res:I}),$.finally(()=>{t.j.delete(y),E.dispose()}),I.apiObject}}}async $handleResponseFragment(a,r){const i=this.j.get(a);i&&i.res.handleFragment(r)}async m(a,r,i){const n=k.$xK+r.identifier.value;if(!await this.l.getSession(a,n,[],{silent:!0}))try{await this.l.getSession(a,n,[],{forceNewSession:{detail:i??(0,A.localize)(0,null,r.displayName)}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:a.identifier,to:r.identifier,enabled:!0}])}n(a,r){return!!r.auth&&!m.$qm.equals(r.extension,a)}}e.$9gc=p}),define(Le[250],Me([1,0,6,3,15,8]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(M.$rL.MainThreadChatVariables)}async $resolveVariable(g,D,A){const k=this.b.get(g);if(k)try{const l=await k.resolver.resolve(k.data.name,{prompt:D},A);if(l)return l.map(N.ChatVariable.from)}catch(l){(0,P.$2)(l)}}registerVariableResolver(g,D,A,k){const l=R.a++;return this.b.set(l,{extension:g.identifier,data:{name:D,description:A},resolver:k}),this.c.$registerVariable(l,{name:D,description:A}),(0,S.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$0gc=R}),define(Le[251],Me([1,0,11,67,5,6,2,86,22,8,7,3,25]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;function v(p,s,a){const r=p.getProxy(k.$rL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$sm,s.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===6){const $=this.b.get(y.handle);return $?$.value:y}else if(y&&y.$mid===7){const $=this.b.get(y.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.commentThreadHandle);return I?I.value:y}else if(y&&(y.$mid===9||y.$mid===8)){const $=this.b.get(y.thread.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.thread.commentThreadHandle);return I?y.$mid===8?I.value:{thread:I.value,text:y.text}:y}else if(y&&y.$mid===10){const $=this.b.get(y.thread.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.thread.commentThreadHandle);if(!I)return y;const d=y.commentUniqueId,w=I.getCommentByUniqueId(d);return w||y}else if(y&&y.$mid===11){const $=this.b.get(y.thread.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.thread.commentThreadHandle);if(!I)return y;const d=y.text,w=y.commentUniqueId,b=I.getCommentByUniqueId(w);return b?(typeof b.body=="string"?b.body=d:b.body=new A.$UL(d),b):y}return y}})}createCommentController(y,$,I){const d=i.a++,w=new o(y,d,$,I);this.b.set(w.handle,w);const b=this.c.get(y.identifier)||[];return b.push(w),this.c.set(y.identifier,b),w.value}async $createCommentThreadTemplate(y,$,I){const d=this.b.get(y);d&&d.$createCommentThreadTemplate($,I)}async $setActiveComment(y,$){const I=this.b.get(y);I&&I.$setActiveComment($??void 0)}async $updateCommentThreadTemplate(y,$,I){const d=this.b.get(y);d&&d.$updateCommentThreadTemplate($,I)}$deleteCommentThread(y,$){this.b.get(y)?.$deleteCommentThread($)}$provideCommentingRanges(y,$,I){const d=this.b.get(y);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=a.getDocument(R.URI.revive($));return(0,S.$3g)(async()=>{const b=await d.commentingRangeProvider.provideCommentingRanges(w,I);let L;return Array.isArray(b)?L={ranges:b,fileComments:!1}:b?L={ranges:b.ranges||[],fileComments:b.fileComments||!1}:L=b??void 0,L}).then(b=>{let L;return b&&(L={ranges:b.ranges.map(T=>D.Range.from(T)),fileComments:b.fileComments}),L})}$toggleReaction(y,$,I,d,w){const b=this.b.get(y);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,S.$3g)(()=>{const L=b.getCommentThread($);if(L){const T=L.getCommentByUniqueId(d.uniqueIdInThread);if(b!==void 0&&T&&b.reactionHandler)return b.reactionHandler(T,f(w))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,$,I,d,w,b,L,T){this.m=$,this.n=I,this.o=d,this.p=w,this.q=b,this.extensionDescription=L,this.r=T,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Yd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new N.$Uc,this.l.value=new N.$Sc,this.n===void 0&&(this.n=`${y}.${this.handle}`),r.$createCommentThread($,this.handle,this.n,this.o,D.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{r.$deleteCommentThread($,this.handle)}});const Y=this;this.value={get uri(){return Y.uri},get range(){return Y.range},set range(q){Y.range=q},get comments(){return Y.comments},set comments(q){Y.comments=q},get collapsibleState(){return Y.collapsibleState},set collapsibleState(q){Y.collapsibleState=q},get canReply(){return Y.canReply},set canReply(q){Y.canReply=q},get contextValue(){return Y.contextValue},set contextValue(q){Y.contextValue=q},get label(){return Y.label},set label(q){Y.label=q},get state(){return Y.state},set state(q){Y.state=q},dispose:()=>{Y.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new N.$Sc);const y=I=>Object.prototype.hasOwnProperty.call(this.b,I),$={};y("range")&&($.range=D.Range.from(this.p)),y("label")&&($.label=this.label),y("contextValue")&&($.contextValue=this.contextValue??null),y("comments")&&($.comments=this.q.map(I=>h(this,I,this.k,this.extensionDescription))),y("collapsibleState")&&($.collapseState=c(this.g)),y("canReply")&&($.canReply=this.canReply),y("state")&&($.state=u(this.h)),y("isTemplate")&&($.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(y){for(const $ of this.k){const I=$[0],d=$[1];if(y===d)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Je([(0,M.$Dh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$OF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$OF)(this.h,"activeComment"),this.f}constructor(y,$,I,d){this.h=y,this.i=$,this.j=I,this.k=d,this.a=new Map,r.$registerCommentController(this.handle,I,d,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(b){w.options=b},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(b){w.commentingRangeProvider=b},get reactionHandler(){return w.reactionHandler},set reactionHandler(b){w.reactionHandler=b},get activeCommentThread(){return w.activeCommentThread},createCommentThread(b,L,T){return w.createCommentThread(b,L,T).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(y,$,I){$===void 0&&(0,l.$OF)(this.h,"fileComments");const d=new n(this.id,this.handle,void 0,y,$,I,this.h,!1);return this.a.set(d.handle,d),d}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const $=this.a.get(y.commentThreadHandle);$&&(this.e=y.uniqueIdInThread?$.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=$)}$createCommentThreadTemplate(y,$){const I=new n(this.id,this.handle,void 0,R.URI.revive(y),D.Range.to($),[],this.h,!0);return I.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(y,$){const I=this.a.get(y);I&&(I.range=D.Range.to($))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function h(E,y,$,I){let d=$.get(y);return d||(d=++E.commentHandle,$.set(y,d)),y.state!==void 0&&(0,l.$OF)(I,"commentsDraftState"),y.reactions?.some(w=>w.reactors!==void 0)&&(0,l.$OF)(I,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:d,body:typeof y.body=="string"?y.body:D.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(w=>t(w)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function t(E){return{label:E.label,iconPath:E.iconPath?D.$IN(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted,reactors:E.reactors&&E.reactors.length>0&&typeof E.reactors[0]!="string"?E.reactors.map(y=>y.name):E.reactors}}function f(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?R.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1,reactors:E.reactors?.map(y=>({name:y}))}}function c(E){if(E!==void 0)switch(E){case A.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function u(E){if(E!==void 0)switch(E){case A.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new i}e.$bhc=v}),define(Le[252],Me([1,0,21,97,6,12,24,2,8,61,74,3,7]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=void 0;class v{constructor(f,c){this.document=f,this.b=c,this.a=1,this.c=new A.$Sgc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,c){await this.f(f).undo(),c||this.disposeBackup()}async redo(f,c){await this.f(f).redo(),c||this.disposeBackup()}disposeEdits(f){for(const c of f)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=h(this.document.uri)+this.a++;return(0,R.$Lg)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const c=this.c.get(f,0);if(!c)throw new Error("No edit found");return c}}class p{constructor(){this.a=new Map}get(f,c){return this.a.get(this.b(f,c))}add(f,c,u){const E=this.b(f,c.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${f} resource:${c.uri}`);const y=new v(c,u);return this.a.set(E,y),y}delete(f,c){const u=this.b(f,c.uri);this.a.delete(u)}b(f,c){return`${f}@@@${c}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class a{constructor(){this.a=new Map}addTextProvider(f,c,u){return this.b(0,f,c,u)}addCustomProvider(f,c,u){return this.b(1,f,c,u)}get(f){return this.a.get(f)}b(f,c,u,E){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:f,extension:u,provider:E}),new l.$tL(()=>this.a.delete(c))}}class r{constructor(f,c,u,E,y){this.d=c,this.f=u,this.g=E,this.h=y,this.b=new a,this.c=new p,this.a=f.getProxy(k.$rL.MainThreadCustomEditors)}registerCustomEditorProvider(f,c,u,E){const y=new P.$Sc;return n(u)?(y.add(this.b.addTextProvider(c,f,u)),this.a.$registerTextEditorProvider((0,D.$qhc)(f),c,E.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,D.$ohc)(f))):(y.add(this.b.addCustomProvider(c,f,u)),i(u)&&y.add(u.onDidChangeCustomDocument($=>{const I=this.i(c,$.document.uri);if(o($)){const d=I.addEdit($);this.a.$onDidEdit($.document.uri,c,d,$.label)}else this.a.$onContentChange($.document.uri,c)})),this.a.$registerCustomEditorProvider((0,D.$qhc)(f),c,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,D.$ohc)(f))),l.$tL.from(y,new l.$tL(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(f,c,u,E,y){const $=this.b.get(c);if(!$)throw new Error(`No provider found for '${c}'`);if($.type!==1)throw new Error(`Invalid provide type for '${c}'`);const I=m.URI.revive(f),d=await $.provider.openCustomDocument(I,{backupId:u,untitledDocumentData:E?.buffer},y);let w;return i($.provider)&&this.f&&(w=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(c,d,w),{editable:i($.provider)}}async $disposeCustomDocument(f,c){const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${c}'`);const E=m.URI.revive(f),{document:y}=this.i(c,E);this.c.delete(c,y),y.dispose()}async $resolveCustomEditor(f,c,u,E,y,$){const I=this.b.get(u);if(!I)throw new Error(`No provider found for '${u}'`);const d=g.ViewColumn.to(y),w=this.g.createNewWebview(c,E.contentOptions,I.extension),b=this.h.createNewWebviewPanel(c,u,E.title,d,E.options,w,E.active),L=m.URI.revive(f);switch(I.type){case 1:{const{document:T}=this.i(u,L);return I.provider.resolveCustomEditor(T,b,$)}case 0:{const T=this.d.getDocument(L);return I.provider.resolveCustomTextEditor(T,b,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,c,u){this.i(c,f).disposeEdits(u)}async $onMoveCustomEditor(f,c,u){const E=this.b.get(u);if(!E)throw new Error(`No provider found for '${u}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const y=this.h.getWebviewPanel(f);if(!y)throw new Error("No webview found");const $=m.URI.revive(c),I=this.d.getDocument($);await E.provider.moveCustomTextEditor(I,y,S.CancellationToken.None)}async $undo(f,c,u,E){return this.i(c,f).undo(u,E)}async $redo(f,c,u,E){return this.i(c,f).redo(u,E)}async $revert(f,c,u){const E=this.i(c,f);await this.j(c).revertCustomDocument(E.document,u),E.disposeBackup()}async $onSave(f,c,u){const E=this.i(c,f);await this.j(c).saveCustomDocument(E.document,u),E.disposeBackup()}async $onSaveAs(f,c,u,E){const y=this.i(c,f);return this.j(c).saveCustomDocumentAs(y.document,m.URI.revive(u),E)}async $backup(f,c,u){const E=this.i(c,f),$=await this.j(c).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},u);return E.updateBackup($),$.id}i(f,c){const u=this.c.get(f,m.URI.revive(c));if(!u)throw new Error("No custom document found");return u}j(f){const u=this.b.get(f)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$thc=r;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function h(t){const f=t.scheme===N.Schemas.file||t.scheme===N.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Yi)(f)+""}}),define(Le[253],Me([1,0,160,98,2,3,7,8,5,14,28,43]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;class v{#e;#t;#i;constructor(a,r,i,n,o,h,t,f){this.d=a,this.e=r,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$Ac(c=>h.getComparisonKey(c)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,r){if(!a){this.clear();return}this.j();let i=[];if(P.URI.isUri(a)){if(!r){this.delete(a);return}this.#i.set(a,r.slice()),i=[a]}else if(Array.isArray(a)){i=[];let h;a=[...a].sort(v.k);for(const t of a){const[f,c]=t;if((!h||f.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=f,i.push(f),this.#i.set(f,[])),c)this.#i.get(f)?.push(...c);else{const u=this.#i.get(f);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const h of i){let t=[];const f=this.#i.get(h);if(f)if(f.length>this.g){t=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const E of f)if(E.severity===c[u]&&t.push({...m.Diagnostic.from(E),modelVersionId:this.h(h)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,S.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(c=>({...m.Diagnostic.from(c),modelVersionId:this.h(h)}));if(n.push([h,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,r){this.j();for(const[i,n]of this)a.call(r,i,n,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const r=this.#i.get(a);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,r){return a[0].toString()<r[0].toString()?-1:a[0].toString()>r[0].toString()?1:0}}e.$Zgc=v;let p=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const r=new A.$Ac;for(const i of a)r.set(i,i);return{uris:Object.freeze(Array.from(r.values()))}}constructor(a,r,i,n){this.j=r,this.k=i,this.l=n,this.g=new Map,this.h=new g.$3d({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=a.getProxy(N.$rL.MainThreadDiagnostics)}createDiagnosticCollection(a,r){const{g:i,f:n,h:o,j:h,k:t,l:f}=this,c=new class{$changeMany(y,$){n.$changeMany(y,$),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,y,$.length===0?"CLEARING":$)}$clear(y){n.$clear(y),h.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,y)}dispose(){n.dispose()}};let u;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,u=r;else if(!i.has(r))u=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do u=r+l.c++;while(i.has(u))}return new class extends v{constructor(){super(r,u,l.e,l.d,y=>f.getDocument(y)?.version,t.extUri,c,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(a){if(a)return this.m(a);{const r=new Map,i=[];for(const n of this.g.values())n.forEach((o,h)=>{let t=r.get(o.toString());typeof t>"u"&&(t=i.length,r.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...h)});return i}}m(a){let r=[];for(const i of this.g.values())i.has(a)&&(r=r.concat(i.get(a)));return r}$acceptMarkersChange(a){if(!this.n){const r="_generated_mirror",i=new v(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(r,i),this.n=i}for(const[r,i]of a)this.n.set(P.URI.revive(r),i.map(m.Diagnostic.to))}};e.$1gc=p,e.$1gc=p=l=Je([qe(1,D.$sj),qe(2,k.$Ygc)],p)}),define(Le[254],Me([1,0,2,15,7,8,187]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class m{constructor(D,A,k,l={timeout:1500,errors:3}){this.c=D,this.d=A,this.f=k,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(A,k,l)=>{const p={dispose:this.a.push([A,k,D])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(D,A){const k=S.URI.revive(D);let l=!1;const v=setTimeout(()=>l=!0,this.g.timeout),p=[];try{for(const s of[...this.a]){if(l)break;const a=this.d.getDocument(k),r=await this.h(s,{document:a,reason:N.TextDocumentSaveReason.to(A)});p.push(r)}}finally{clearTimeout(v)}return p}h([D,A,k],l){const v=this.b.get(D);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(k,D,A,l).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const s=this.b.get(D);this.b.set(D,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,A,k,l){const v=[],p=Date.now(),{document:s,reason:a}=l,{version:r}=s,i=Object.freeze({document:s,reason:a,waitUntil(n){if(Object.isFrozen(v))throw(0,M.$8)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{A.apply(k,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,o)=>{const h=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(h),n(t)}).catch(t=>{clearTimeout(h),o(t)})}).then(n=>{const o={edits:[]};for(const h of n)if(Array.isArray(h)&&h.every(t=>t instanceof P.$AL))for(const{newText:t,newEol:f,range:c}of h)o.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:c&&N.Range.from(c),text:t,eol:f&&N.EndOfLine.from(f)}});if(o.edits.length!==0)return r===s.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$8hc=m}),define(Le[255],Me([1,0,5,6,2,3,109,8,16,26,7]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0;class k{constructor(v,p){this.a=new S.$Yd,this.b=new S.$Yd,this.c=new S.$Yd,this.d=new S.$Yd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=v.getProxy(N.$rL.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(s=>{for(const a of s)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const a of s)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const p=this.g.getDocument(v);if(p)return p}getDocument(v){const p=this.getDocumentData(v);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return p.document}ensureDocumentData(v){const p=this.g.getDocument(v);if(p)return Promise.resolve(p);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(a=>{this.h.delete(v.toString());const r=P.URI.revive(a);return(0,g.$Xf)(this.g.getDocument(r))},a=>(this.h.delete(v.toString()),Promise.reject(a))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(p=>P.URI.revive(p))}$acceptModelLanguageChanged(v,p){const s=P.URI.revive(v),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(p),this.a.fire(a.document)}$acceptModelSaved(v){const p=P.URI.revive(v),s=this.g.getDocument(p);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,p){const s=P.URI.revive(v),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(p),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,p,s){const a=P.URI.revive(v),r=this.g.getDocument(a);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(p);let i;p.isUndoing?i=A.TextDocumentChangeReason.Undo:p.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,D.$Cn)({document:r.document,contentChanges:p.changes.map(n=>({range:m.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(v,p){(0,R.$LN)(v,p)}}e.$2gc=k}),define(Le[64],Me([1,0,256,5,16,2,4,3,17,8,7]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0,e.$uhc=(0,R.$$h)("IExtHostEditorTabs");class k{constructor(a,r,i){this.e=i,this.d=r,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$bN(N.URI.revive(this.b.input.uri));case 2:return new A.$cN(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified));case 3:return new A.$dN(N.URI.revive(this.b.input.base),N.URI.revive(this.b.input.input1),N.URI.revive(this.b.input.input2),N.URI.revive(this.b.input.result));case 6:return new A.$eN(N.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$fN(this.b.input.viewType);case 4:return new A.$gN(N.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$hN(N.URI.revive(this.b.input.original),N.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$iN;case 9:return new A.$jN(N.URI.revive(this.b.input.uri),N.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$kN(this.b.input.providerId);default:return}}}class l{constructor(a,r){this.c=[],this.d="",this.b=a,this.e=r;for(const i of a.tabs)i.isActive&&(this.d=i.id),this.c.push(new k(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return D.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(i=>i.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(i=>i.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const i=new k(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,i),a.tabDto.isActive&&(this.d=i.tabId),i}else if(a.kind===1){const i=this.c.splice(a.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(a.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,i),i}const r=this.c.find(i=>i.tabId===a.tabDto.id);if(!r)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(a.tabDto),r}activeTabId(){return this.d}}let v=class{constructor(a){this.b=new M.$Yd,this.c=new M.$Yd,this.e=[],this.a=a.getProxy(m.$rL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,r={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(i=>i.apiObject))},get activeTabGroup(){const i=a.d;return(0,P.$Xf)(a.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?p(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(a){const r=new Set(this.e.map(c=>c.groupId)),i=new Set(a.map(c=>c.groupId)),n=(0,S.$L)(r,i),o=this.e.filter(c=>n.removed.includes(c.groupId)).map(c=>c.apiObject),h=[],t=[];this.e=a.map(c=>{const u=new l(c,()=>this.d);return n.added.includes(u.groupId)?h.push(u.apiObject):t.push(u.apiObject),u});const f=(0,P.$Xf)(a.find(c=>c.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:h,closed:o,changed:t}))}$acceptTabGroupUpdate(a){const r=this.e.find(i=>i.groupId===a.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const r=this.e.find(n=>n.groupId===a.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const i=r.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(a){for(const r of this.e)for(const i of r.tabs)if(i.apiObject===a)return i}h(a){return this.e.find(r=>r.apiObject===a)}async i(a,r){const i=[];for(const n of a){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,r)}async j(a,r){const i=[];for(const n of a){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,r)}};e.$vhc=v,e.$vhc=v=Je([qe(0,g.$JN)],v);function p(s){return s.tabs!==void 0}}),define(Le[257],Me([1,0,2,3,6,7,8,299,13,23,25,46]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const a=this.a.indexOf(s);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),a=[];let r,i,n=14,o=14;for(const h of s){let t=r?(0,g.$ff)(r,h):0;for(t===0?i=1:i=o;t<h.length;t++)t+1===h.length?(n=o,o=9):o+=1,a.push([i,h.toUpperCase().charCodeAt(t),o]),a.push([i,h.toLowerCase().charCodeAt(t),o]),i=o;r=h,o=n}a.push([9,58,10]),a.push([10,47,12]),this.b=new m.$9Z(a)}}provideDocumentLinks(s){this.c();const a=[],r=m.$0Z.computeLinks({getLineContent(i){return s.lineAt(i-1).text},getLineCount(){return s.lineCount}},this.b);for(const i of r){const n=R.DocumentLink.to(i);n.target&&a.push(n)}return a}}class v{constructor(s,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(M.$rL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,a,r,i={}){if(v.j(r),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(a),this.d.add(a),this.c.set(n,r);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof r.copy=="function"&&(o+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,A.$OF)(s,"fsChunks"),o+=4);let h;i.isReadonly&&(0,k.$ok)(i.isReadonly)&&i.isReadonly.value!==""&&(h={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,a,o,h).catch(f=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(f)});const t=r.onDidChangeFile(f=>{const c=[];for(const u of f){const{uri:E,type:y}=u;if(E.scheme!==a)continue;let $;switch(y){case N.FileChangeType.Changed:$=0;break;case N.FileChangeType.Created:$=1;break;case N.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:E,type:$})}this.a.$onFileSystemChange(n,c)});return(0,P.$Rc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:a,ctime:r,mtime:i,size:n,permissions:o}=s;return{type:a,ctime:r,mtime:i,size:n,permissions:o}}$stat(s,a){return Promise.resolve(this.l(s).stat(S.URI.revive(a))).then(r=>v.k(r))}$readdir(s,a){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this.l(s).readFile(S.URI.revive(a))).then(r=>D.$me.wrap(r))}$writeFile(s,a,r,i){return Promise.resolve(this.l(s).writeFile(S.URI.revive(a),r.buffer,i))}$delete(s,a,r){return Promise.resolve(this.l(s).delete(S.URI.revive(a),r))}$rename(s,a,r,i){return Promise.resolve(this.l(s).rename(S.URI.revive(a),S.URI.revive(r),i))}$copy(s,a,r,i){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(S.URI.revive(a),S.URI.revive(r),i))}$mkdir(s,a){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(a)))}$watch(s,a,r,i){const n=this.l(s).watch(S.URI.revive(r),i);this.f.set(a,n)}$unwatch(s,a){const r=this.f.get(a);r&&(r.dispose(),this.f.delete(a))}$open(s,a,r){const i=this.l(s);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(S.URI.revive(a),r))}$close(s,a){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(a))}$read(s,a,r,i){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=D.$me.alloc(i);return Promise.resolve(n.read(a,r,o.buffer,0,i)).then(h=>o.slice(0,h))}$write(s,a,r,i){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(a,r,i.buffer,0,i.byteLength))}l(s){const a=this.c.get(s);if(!a){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return a}}e.$0hc=v}),define(Le[258],Me([1,0,5,34,2,3,8,7,39]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,p,s,a,r,i){this.a=Math.random(),this.b=new S.$Yd,this.c=new S.$Yd,this.d=new S.$Yd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,M.$Rj)(r),o=typeof r=="string",h=i?.correlate,t=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(h&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const c of f.created){const u=P.URI.revive(c);n(u.fsPath)&&(!o||p.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const c of f.changed){const u=P.URI.revive(c);n(u.fsPath)&&(!o||p.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const c of f.deleted){const u=P.URI.revive(c);n(u.fsPath)&&(!o||p.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=m.$tL.from(this.i(v,s,r,i,i?.correlate),this.b,this.c,this.d,t)}i(v,p,s,a,r){const i=m.$tL.from();if(typeof s=="string")return i;const n=v.getProxy(N.$rL.MainThreadFileSystemEventService);let o=!1;return(s.pattern.includes(M.$Nj)||s.pattern.includes(M.$Oj))&&(o=!0),n.$watch(p.identifier.value,this.a,s.baseUri,{recursive:o,excludes:a?.excludes??[]},!!r),m.$tL.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(P.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(v,p,s){this.j=v,this.k=p,this.l=s,this.a=new S.$Yd,this.b=new S.$Yd,this.c=new S.$Yd,this.d=new S.$Yd,this.g=new S.$1d,this.h=new S.$1d,this.i=new S.$1d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,p,s,a){return new D(this.j,v,p,this.a.event,R.GlobPattern.from(s),a)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this.b.fire(Object.freeze({files:p.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,p){return(s,a,r)=>{const i=function(o){s.call(a,o)};return i.extension=v,p.event(i,void 0,r)}}async $onWillRunFileOperation(v,p,s,a){switch(v){case 2:return await this.n(this.g,{files:p.map(r=>({oldUri:P.URI.revive(r.source),newUri:P.URI.revive(r.target)}))},s,a);case 1:return await this.n(this.i,{files:p.map(r=>P.URI.revive(r.target))},s,a);case 0:case 3:return await this.n(this.h,{files:p.map(r=>P.URI.revive(r.target))},s,a)}}async n(v,p,s,a){const r=new Set,i=[];if(await v.fireAsync(p,a,async(o,h)=>{const t=Date.now(),f=await Promise.resolve(o);f instanceof m.$DL&&(i.push([h.extension,f]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),a.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:h}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(h)}return{edit:n,extensionNames:Array.from(r)}}}e.$$hc=k}),define(Le[259],Me([1,0,18,11,21,15,88,6,26,63,13,16,2,29,300,86,95,162,22,8,7,25,74,3]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0;class c{constructor(O,G){this.d=O,this.e=G}async provideDocumentSymbols(O,G){const B=this.d.getDocument(O),H=await this.e.provideDocumentSymbols(B,G);if(!(0,S.$Kb)(H))return H[0]instanceof o.$ML?H.map(n.DocumentSymbol.from):c.f(H)}static f(O){O=O.slice(0).sort((H,Q)=>{let ae=H.location.range.start.compareTo(Q.location.range.start);return ae===0&&(ae=Q.location.range.end.compareTo(H.location.range.end)),ae});const G=[],B=[];for(const H of O){const Q={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(B.length===0){B.push(Q),G.push(Q);break}const ae=B[B.length-1];if(v.$Zs.containsRange(ae.range,Q.range)&&!v.$Zs.equalsRange(ae.range,Q.range)){ae.children?.push(Q),B.push(Q);break}B.pop()}}return G}}class u{constructor(O,G,B,H,Q,ae){this.f=O,this.g=G,this.h=B,this.j=H,this.k=Q,this.l=ae,this.d=new t.$Sgc("CodeLens"),this.e=new Map}async provideCodeLenses(O,G){const B=this.f.getDocument(O),H=await this.h.provideCodeLenses(B,G);if(!H||G.isCancellationRequested)return;const Q=this.d.add(H),ae=new m.$Sc;this.e.set(Q,ae);const Ee={cacheId:Q,lenses:[]};for(let Be=0;Be<H.length;Be++)Ee.lenses.push({cacheId:[Q,Be],range:n.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,ae)});return Ee}async resolveCodeLens(O,G){const B=O.cacheId&&this.d.get(...O.cacheId);if(!B)return;let H;if(typeof this.h.resolveCodeLens!="function"||B.isResolved?H=B:H=await this.h.resolveCodeLens(B,G),H||(H=B),G.isCancellationRequested)return;const Q=O.cacheId&&this.e.get(O.cacheId[0]);if(Q){if(!H.command){const ae=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ae),this.l.error(ae);return}return O.command=this.g.toInternal(H.command,Q),O}}releaseCodeLenses(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}}function E(Ie){return Array.isArray(Ie)?Ie.map(n.DefinitionLink.from):Ie?[n.DefinitionLink.from(Ie)]:[]}class y{constructor(O,G){this.d=O,this.e=G}async provideDefinition(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideDefinition(H,Q,B);return E(ae)}}class ${constructor(O,G){this.d=O,this.e=G}async provideDeclaration(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideDeclaration(H,Q,B);return E(ae)}}class I{constructor(O,G){this.d=O,this.e=G}async provideImplementation(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideImplementation(H,Q,B);return E(ae)}}class d{constructor(O,G){this.d=O,this.e=G}async provideTypeDefinition(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideTypeDefinition(H,Q,B);return E(ae)}}class w{constructor(O,G){this.d=O,this.e=G}async provideHover(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideHover(H,Q,B);if(!(!ae||(0,S.$Kb)(ae.contents)))return ae.range||(ae.range=H.getWordRangeAtPosition(Q)),ae.range||(ae.range=new o.$vL(Q,Q)),n.Hover.from(ae)}}class b{constructor(O,G){this.d=O,this.e=G}async provideEvaluatableExpression(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideEvaluatableExpression(H,Q,B);if(ae)return n.EvaluatableExpression.from(ae)}}class L{constructor(O,G){this.d=O,this.e=G}async provideInlineValues(O,G,B,H){const Q=this.d.getDocument(O),ae=await this.e.provideInlineValues(Q,n.Range.to(G),n.InlineValueContext.to(B),H);if(Array.isArray(ae))return ae.map(Ee=>n.InlineValue.from(Ee))}}class T{constructor(O,G){this.d=O,this.e=G}async provideDocumentHighlights(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideDocumentHighlights(H,Q,B);if(Array.isArray(ae))return ae.map(n.DocumentHighlight.from)}}class Y{constructor(O,G){this.d=O,this.e=G}async provideMultiDocumentHighlights(O,G,B,H){const Q=this.d.getDocument(O),ae=B.map(We=>this.d.getDocument(We)),Ee=n.Position.to(G),Be=await this.e.provideMultiDocumentHighlights(Q,Ee,ae,H);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class q{constructor(O,G){this.d=O,this.e=G}async provideLinkedEditingRanges(O,G,B){const H=this.d.getDocument(O),Q=n.Position.to(G),ae=await this.e.provideLinkedEditingRanges(H,Q,B);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,S.$Hb)(ae.ranges.map(n.Range.from)),wordPattern:ae.wordPattern}}}class U{constructor(O,G){this.d=O,this.e=G}async provideReferences(O,G,B,H){const Q=this.d.getDocument(O),ae=n.Position.to(G),Ee=await this.e.provideReferences(Q,ae,B,H);if(Array.isArray(Ee))return Ee.map(n.location.from)}}class C{static{this.d=1e3}constructor(O,G,B,H,Q,ae,Ee){this.g=O,this.h=G,this.j=B,this.k=H,this.l=Q,this.m=ae,this.n=Ee,this.e=new t.$Sgc("CodeAction"),this.f=new Map}async provideCodeActions(O,G,B,H){const Q=this.g.getDocument(O),ae=p.$2s.isISelection(G)?n.Selection.to(G):n.Range.to(G),Ee=[];for(const rt of this.j.getDiagnostics(O))if(ae.intersection(rt.range)&&Ee.push(rt)>C.d)break;const Be={diagnostics:Ee,only:B.only?new o.$OL(B.only):void 0,triggerKind:n.CodeActionTriggerKind.to(B.trigger)},We=await this.k.provideCodeActions(Q,ae,Be,H);if(!(0,S.$Lb)(We)||H.isCancellationRequested)return;const Qe=this.e.add(We),xe=new m.$Sc;this.f.set(Qe,xe);const ct=[];for(let rt=0;rt<We.length;rt++){const et=We[rt];if(et)if(C.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ct.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,xe)});else{Be.only&&(et.kind?Be.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ut=et.ranges??[];ct.push({cacheId:[Qe,rt],title:et.title,command:et.command&&this.h.toInternal(et.command,xe),diagnostics:et.diagnostics&&et.diagnostics.map(n.Diagnostic.from),edit:et.edit&&n.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,h.$NF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,h.$NF)(this.m,"codeActionRanges")?(0,S.$Hb)(ut.map(n.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Qe,actions:ct}}async resolveCodeAction(O,G){const[B,H]=O,Q=this.e.get(B,H);if(!Q||C.o(Q))return{};if(!this.k.resolveCodeAction)return{};const ae=await this.k.resolveCodeAction(Q,G)??Q;let Ee;ae.edit&&(Ee=n.WorkspaceEdit.from(ae.edit,void 0));let Be;if(ae.command){const We=this.f.get(B);We&&(Be=this.h.toInternal(ae.command,We))}return{edit:Ee,command:Be}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}class F{static toInternalProviderId(O,G){return O+"."+G}constructor(O,G,B,H,Q){this.d=O,this.e=G,this.f=B,this.g=H,this.h=Q}async prepareDocumentPaste(O,G,B,H){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(O),ae=G.map(We=>n.Range.to(We)),Ee=n.DataTransfer.toDataTransfer(B,()=>{throw new N.$$});if(await this.f.prepareDocumentPaste(Q,ae,Ee,H),H.isCancellationRequested)return;const Be=Array.from(Ee).filter(([,We])=>!(We instanceof o.$iM));return n.DataTransfer.from(Be)}async providePasteEdits(O,G,B,H,Q){if(!this.f.provideDocumentPasteEdits)return;const ae=this.e.getDocument(G),Ee=B.map(Qe=>n.Range.to(Qe)),Be=n.DataTransfer.toDataTransfer(H,async Qe=>(await this.d.$resolvePasteFileData(this.g,O,Qe)).buffer),We=await this.f.provideDocumentPasteEdits(ae,Ee,Be,Q);if(We)return{label:We.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:F.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?n.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class W{constructor(O,G){this.d=O,this.e=G}async provideDocumentFormattingEdits(O,G,B){const H=this.d.getDocument(O),Q=await this.e.provideDocumentFormattingEdits(H,G,B);if(Array.isArray(Q))return Q.map(n.TextEdit.from)}}class re{constructor(O,G){this.d=O,this.e=G}async provideDocumentRangeFormattingEdits(O,G,B,H){const Q=this.d.getDocument(O),ae=n.Range.to(G),Ee=await this.e.provideDocumentRangeFormattingEdits(Q,ae,B,H);if(Array.isArray(Ee))return Ee.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,G,B,H){(0,k.$Wf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(O),ae=G.map(n.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Q,ae,B,H);if(Array.isArray(Ee))return Ee.map(n.TextEdit.from)}}class ue{constructor(O,G){this.d=O,this.e=G,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,G,B,H,Q){const ae=this.d.getDocument(O),Ee=n.Position.to(G),Be=await this.e.provideOnTypeFormattingEdits(ae,Ee,B,H,Q);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ye{constructor(O,G){this.e=O,this.f=G,this.d=new t.$Sgc("WorkspaceSymbols")}async provideWorkspaceSymbols(O,G){const B=await this.e.provideWorkspaceSymbols(O,G);if(!(0,S.$Lb)(B))return{symbols:[]};const H=this.d.add(B),Q={cacheId:H,symbols:[]};for(let ae=0;ae<B.length;ae++){const Ee=B[ae];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Q.symbols.push({...n.WorkspaceSymbol.from(Ee),cacheId:[H,ae]})}return Q}async resolveWorkspaceSymbol(O,G){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const B=this.d.get(...O.cacheId);if(B){const H=await this.e.resolveWorkspaceSymbol(B,G);return H&&(0,g.$En)(O,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class ke{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,G,B){this.d=O,this.e=G,this.f=B}async provideRenameEdits(O,G,B,H){const Q=this.d.getDocument(O),ae=n.Position.to(G);try{const Ee=await this.e.provideRenameEdits(Q,ae,B,H);return Ee?n.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Be=ke.g(Ee);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(O,G,B){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(O),Q=n.Position.to(G);try{const ae=await this.e.prepareRename(H,Q,B);let Ee,Be;if(o.$vL.isRange(ae)?(Ee=ae,Be=H.getText(ae)):(0,k.$Of)(ae)&&(Ee=ae.range,Be=ae.placeholder),!Ee||!Be)return;if(Ee.start.line>Q.line||Ee.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ee),text:Be}}catch(ae){const Ee=ke.g(ae);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(ae)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class he{constructor(O,G,B){this.d=O,this.e=G,this.f=B}async provideNewSymbolNames(O,G,B){const H=this.d.getDocument(O),Q=n.Range.to(G);try{const ae=await this.e.provideNewSymbolNames(H,Q,B);return ae?ae.map(Ee=>typeof Ee=="string"?{newSymbolName:Ee}:{newSymbolName:Ee.newSymbolName,tags:Ee.tags}):void 0}catch(ae){this.f.error(he.g(ae)??JSON.stringify(ae,null,"	"));return}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class ve{constructor(O,G){this.resultId=O,this.tokens=G}}class se{constructor(O,G){this.f=O,this.g=G,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,G,B){const H=this.f.getDocument(O),Q=G!==0?this.d.get(G):null;let ae=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,Q.resultId,B):await this.g.provideDocumentSemanticTokens(H,B);return Q&&this.d.delete(G),ae?(ae=se.h(ae),this.o(se.n(Q,ae),ae)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return se.j(O)?se.k(O)?O:new o.$MM(new Uint32Array(O.data),O.resultId):se.l(O)?se.m(O)?O:new o.$OM(O.edits.map(G=>new o.$NM(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const G of O.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static n(O,G){if(!se.j(G)||!O||!O.tokens)return G;const B=O.tokens,H=B.length,Q=G.data,ae=Q.length;let Ee=0;const Be=Math.min(H,ae);for(;Ee<Be&&B[Ee]===Q[Ee];)Ee++;if(Ee===H&&Ee===ae)return new o.$OM([],G.resultId);let We=0;const Qe=Be-Ee;for(;We<Qe&&B[H-We-1]===Q[ae-We-1];)We++;return new o.$OM([{start:Ee,deleteCount:H-Ee-We,data:Q.subarray(Ee,ae-We)}],G.resultId)}o(O,G){if(se.j(O)){const B=this.e++;return this.d.set(B,new ve(O.resultId,O.data)),(0,a.$d_)({id:B,type:"full",data:O.data})}if(se.l(O)){const B=this.e++;return se.j(G)?this.d.set(B,new ve(G.resultId,G.data)):this.d.set(B,new ve(O.resultId)),(0,a.$d_)({id:B,type:"delta",deltas:(O.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(O,G){this.d=O,this.e=G}async provideDocumentRangeSemanticTokens(O,G,B){const H=this.d.getDocument(O),Q=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(G),B);return Q?this.f(Q):null}f(O){return(0,a.$d_)({id:0,type:"full",data:O.data})}}class te{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,G,B,H,Q){this.f=O,this.g=G,this.h=B,this.j=H,this.k=Q,this.d=new t.$Sgc("CompletionItem"),this.e=new Map}async provideCompletionItems(O,G,B,H){const Q=this.f.getDocument(O),ae=n.Position.to(G),Ee=Q.getWordRangeAtPosition(ae)||new o.$vL(ae,ae),Be=Ee.with({end:ae}),We=new D.$Ud,Qe=await this.h.provideCompletionItems(Q,ae,H,n.CompletionContext.to(B));if(!Qe||H.isCancellationRequested)return;const xe=Array.isArray(Qe)?new o.$2L(Qe):Qe,ct=te.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),rt=new m.$Sc;this.e.set(ct,rt);const et=[],ut={x:ct,b:et,a:{replace:n.Range.from(Ee),insert:n.Range.from(Be)},c:xe.isIncomplete||void 0,d:We.elapsed()};for(let Ue=0;Ue<xe.items.length;Ue++){const pt=xe.items[Ue],Z=this.l(pt,[ct,Ue],Be,Ee);et.push(Z)}return ut}async resolveCompletionItem(O,G){if(typeof this.h.resolveCompletionItem!="function")return;const B=this.d.get(...O);if(!B)return;const H=this.l(B,O),Q=await this.h.resolveCompletionItem(B,G);if(!Q)return;const ae=this.l(Q,O);return(H.h!==ae.h||H.i!==ae.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==ae.n||H.o!==ae.o||!(0,g.$Fn)(H.p,ae.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:ae.d,c:ae.c,l:ae.l,h:ae.h,i:ae.i,n:ae.n,o:ae.o,p:ae.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,G,B,H){const Q=this.e.get(G[0]);if(!Q)throw Error("DisposableStore is missing...");const ae=this.g.toInternal(O.command,Q),Ee={x:G,a:O.label,b:O.kind!==void 0?n.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(n.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:n.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(n.TextEdit.from),n:ae?.$ident,o:ae?.id,p:ae?.$ident?void 0:ae?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=O.textEdit.newText):typeof O.insertText=="string"?Ee.h=O.insertText:O.insertText instanceof o.$EL&&(Ee.h=O.insertText.value,Ee.i|=4);let Be;return O.textEdit?Be=O.textEdit.range:O.range&&(Be=O.range),o.$vL.isRange(Be)?Ee.j=n.Range.from(Be):Be&&(!B?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Ee.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Ee}}class X{async provideInlineCompletions(O,G,B,H){}disposeCompletions(O){}handleDidShowCompletionItem(O,G,B){}handlePartialAccept(O,G,B){}}class V extends X{constructor(O,G,B,H){super(),this.f=O,this.g=G,this.h=B,this.j=H,this.d=new ne,this.e=(0,h.$NF)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$NF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,G,B,H){const Q=this.g.getDocument(O),ae=n.Position.to(G),Ee=await this.h.provideInlineCompletionItems(Q,ae,{selectedCompletionInfo:B.selectedSuggestionInfo?{range:n.Range.to(B.selectedSuggestionInfo.range),text:B.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[B.triggerKind]},H);if(!Ee||H.isCancellationRequested)return;const Be=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Qe=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((rt,et)=>{let ut;rt.command&&(xe||(xe=new m.$Sc),ut=this.j.toInternal(rt.command,xe));const Ue=rt.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:ut,idx:et,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:We.map(rt=>(xe||(xe=new m.$Sc),this.j.toInternal(rt,xe))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,G,B){const H=this.d.get(O)?.items[G];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,B)}handlePartialAccept(O,G,B){const H=this.d.get(O)?.items[G];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,B)}}class ne{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const G=this.e++;return this.d.set(G,O),G}disposeReferenceId(O){const G=this.d.get(O);return this.d.delete(O),G}get(O){return this.d.get(O)}}class Ce{constructor(O,G){this.e=O,this.f=G,this.d=new t.$Sgc("SignatureHelp")}async provideSignatureHelp(O,G,B,H){const Q=this.e.getDocument(O),ae=n.Position.to(G),Ee=this.g(B),Be=await this.f.provideSignatureHelp(Q,ae,H,Ee);if(Be){const We=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:We}}}g(O){let G;if(O.activeSignatureHelp){const B=n.SignatureHelp.to(O.activeSignatureHelp),H=this.d.get(O.activeSignatureHelp.id,0);H?(G=H,G.activeSignature=B.activeSignature,G.activeParameter=B.activeParameter):G=B}return{...O,activeSignatureHelp:G}}releaseSignatureHelp(O){this.d.delete(O)}}class Fe{constructor(O,G,B,H,Q){this.f=O,this.g=G,this.h=B,this.j=H,this.k=Q,this.d=new t.$Sgc("InlayHints"),this.e=new Map}async provideInlayHints(O,G,B){const H=this.f.getDocument(O),Q=n.Range.to(G),ae=await this.h.provideInlayHints(H,Q,B);if(!Array.isArray(ae)||ae.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`);return}if(B.isCancellationRequested)return;const Ee=this.d.add(ae);this.e.set(Ee,new m.$Sc);const Be={hints:[],cacheId:Ee};for(let We=0;We<ae.length;We++)this.l(ae[We],Q)&&Be.hints.push(this.m(ae[We],[Ee,We]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(G)}`),Be}async resolveInlayHint(O,G){if(typeof this.h.resolveInlayHint!="function")return;const B=this.d.get(...O);if(!B)return;const H=await this.h.resolveInlayHint(B,G);if(H&&this.l(H))return this.m(H,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,G){return O.label.length===0||Array.isArray(O.label)&&O.label.every(B=>B.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(G&&!G.contains(O.position))}m(O,G){const B=this.e.get(G[0]);if(!B)throw Error("DisposableStore is missing...");const H={label:"",cacheId:G,tooltip:n.MarkdownString.fromStrict(O.tooltip),position:n.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(n.TextEdit.from),kind:O.kind&&n.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};if(typeof O.label=="string")H.label=O.label;else{const Q=[];H.label=Q;for(const ae of O.label){if(!ae.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:ae.value,tooltip:n.MarkdownString.fromStrict(ae.tooltip)};o.$FL.isLocation(ae.location)&&(Ee.location=n.location.from(ae.location)),ae.command&&(Ee.command=this.g.toInternal(ae.command,B)),Q.push(Ee)}}return H}}class Pe{constructor(O,G){this.e=O,this.f=G,this.d=new t.$Sgc("DocumentLink")}async provideLinks(O,G){const B=this.e.getDocument(O),H=await this.f.provideDocumentLinks(B,G);if(!(!Array.isArray(H)||H.length===0)&&!G.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(Pe.g).map(n.DocumentLink.from)};{const Q=this.d.add(H),ae={links:[],cacheId:Q};for(let Ee=0;Ee<H.length;Ee++){if(!Pe.g(H[Ee]))continue;const Be=n.DocumentLink.from(H[Ee]);Be.cacheId=[Q,Ee],ae.links.push(Be)}return ae}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,G){if(typeof this.f.resolveDocumentLink!="function")return;const B=this.d.get(...O);if(!B)return;const H=await this.f.resolveDocumentLink(B,G);if(!(!H||!Pe.g(H)))return n.DocumentLink.from(H)}releaseLinks(O){this.d.delete(O)}}class we{constructor(O,G){this.d=O,this.e=G}async provideColors(O,G){const B=this.d.getDocument(O),H=await this.e.provideDocumentColors(B,G);return Array.isArray(H)?H.map(ae=>({color:n.Color.from(ae.color),range:n.Range.from(ae.range)})):[]}async provideColorPresentations(O,G,B){const H=this.d.getDocument(O),Q=n.Range.to(G.range),ae=n.Color.to(G.color),Ee=await this.e.provideColorPresentations(ae,{document:H,range:Q},B);if(Array.isArray(Ee))return Ee.map(n.ColorPresentation.from)}}class me{constructor(O,G){this.d=O,this.e=G}async provideFoldingRanges(O,G,B){const H=this.d.getDocument(O),Q=await this.e.provideFoldingRanges(H,G,B);if(Array.isArray(Q))return Q.map(n.FoldingRange.from)}}class J{constructor(O,G,B){this.d=O,this.e=G,this.f=B}async provideSelectionRanges(O,G,B){const H=this.d.getDocument(O),Q=G.map(n.Position.to),ae=await this.e.provideSelectionRanges(H,Q,B);if(!(0,S.$Lb)(ae))return[];if(ae.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Be=0;Be<Q.length;Be++){const We=[];Ee.push(We);let Qe=Q[Be],xe=ae[Be];for(;;){if(!xe.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(We.push(n.SelectionRange.from(xe)),!xe.parent)break;Qe=xe.range,xe=xe.parent}}return Ee}}class x{constructor(O,G){this.f=O,this.g=G,this.d=new R.$ON(""),this.e=new Map}async prepareSession(O,G,B){const H=this.f.getDocument(O),Q=n.Position.to(G),ae=await this.g.prepareCallHierarchy(H,Q,B);if(!ae)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ae)?ae.map(Be=>this.h(Ee,Be)):[this.h(Ee,ae)]}async provideCallsTo(O,G,B){const H=this.j(O,G);if(!H)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(H,B);if(Q)return Q.map(ae=>({from:this.h(O,ae.from),fromRanges:ae.fromRanges.map(Ee=>n.Range.from(Ee))}))}async provideCallsFrom(O,G,B){const H=this.j(O,G);if(!H)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(H,B);if(Q)return Q.map(ae=>({to:this.h(O,ae.to),fromRanges:ae.fromRanges.map(Ee=>n.Range.from(Ee))}))}releaseSession(O){this.e.delete(O)}h(O,G){const B=this.e.get(O),H=n.CallHierarchyItem.from(G,O,B.size.toString(36));return B.set(H._itemId,G),H}j(O,G){return this.e.get(O)?.get(G)}}class le{constructor(O,G){this.f=O,this.g=G,this.d=new R.$ON(""),this.e=new Map}async prepareSession(O,G,B){const H=this.f.getDocument(O),Q=n.Position.to(G),ae=await this.g.prepareTypeHierarchy(H,Q,B);if(!ae)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(ae)?ae.map(Be=>this.h(Ee,Be)):[this.h(Ee,ae)]}async provideSupertypes(O,G,B){const H=this.j(O,G);if(!H)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(H,B);if(Q)return Q.map(ae=>this.h(O,ae))}async provideSubtypes(O,G,B){const H=this.j(O,G);if(!H)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(H,B);if(Q)return Q.map(ae=>this.h(O,ae))}releaseSession(O){this.e.delete(O)}h(O,G){const B=this.e.get(O),H=n.TypeHierarchyItem.from(G,O,B.size.toString(36));return B.set(H._itemId,G),H}j(O,G){return this.e.get(O)?.get(G)}}class de{static toInternalProviderId(O,G){return O+"."+G}constructor(O,G,B,H,Q){this.d=O,this.e=G,this.f=B,this.g=H,this.h=Q}async provideDocumentOnDropEdits(O,G,B,H,Q){const ae=this.e.getDocument(G),Ee=n.Position.to(B),Be=n.DataTransfer.toDataTransfer(H,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Qe)).buffer),We=await this.f.provideDocumentDropEdits(ae,Ee,Be,Q);if(We)return{label:We.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:de.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?n.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class Ae{constructor(O,G){this.d=O,this.e=G}async provideMappedEdits(O,G,B,H){const Q=l.URI.revive(O),ae=this.d.getDocument(Q),Ee=B.documents.map(Qe=>Qe.map(xe=>({uri:l.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(ct=>n.Range.to(ct))}))),Be={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ae,G,Be,H);return We?n.WorkspaceEdit.from(We):null}}class ge{constructor(O,G){this.adapter=O,this.extension=G}}class Se{static{this.d=0}constructor(O,G,B,H,Q,ae,Ee,Be){this.g=G,this.h=B,this.j=H,this.k=Q,this.l=ae,this.m=Ee,this.n=Be,this.f=new Map,this.e=O.getProxy(f.$rL.MainThreadLanguageFeatures)}o(O,G){return n.DocumentSelector.from(O,this.g,G)}p(O){return new o.$tL(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return Se.d++}async s(O,G,B,H,Q,ae=!1){const Ee=this.f.get(O);if(!Ee||!(Ee.adapter instanceof G))return H;const Be=Date.now();ae||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${B.toString().replace(/[\r\n]/g,"")}'`);const We=B(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(Qe=>{(0,N.$4)(Qe)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Ee.extension.identifier,Qe))}).finally(()=>{ae||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),P.CancellationToken.isCancellationToken(Q)?(0,M.$Zg)(We,Q):We}t(O,G){const B=this.q();return this.f.set(B,new ge(O,G)),B}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,G,B,H){const Q=this.t(new c(this.h,B),O),ae=H&&H.label||Se.u(O);return this.e.$registerDocumentSymbolProvider(Q,this.o(G,O),ae),this.p(Q)}$provideDocumentSymbols(O,G,B){return this.s(O,c,H=>H.provideDocumentSymbols(l.URI.revive(G),B),void 0,B)}registerCodeLensProvider(O,G,B){const H=this.q(),Q=typeof B.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new ge(new u(this.h,this.j.converter,B,O,this.n,this.l),O)),this.e.$registerCodeLensSupport(H,this.o(G,O),Q);let ae=this.p(H);if(Q!==void 0){const Ee=B.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(Q));ae=o.$tL.from(ae,Ee)}return ae}$provideCodeLenses(O,G,B){return this.s(O,u,H=>H.provideCodeLenses(l.URI.revive(G),B),void 0,B)}$resolveCodeLens(O,G,B){return this.s(O,u,H=>H.resolveCodeLens(G,B),void 0,void 0)}$releaseCodeLenses(O,G){this.s(O,u,B=>Promise.resolve(B.releaseCodeLenses(G)),void 0,void 0)}registerDefinitionProvider(O,G,B){const H=this.t(new y(this.h,B),O);return this.e.$registerDefinitionSupport(H,this.o(G,O)),this.p(H)}$provideDefinition(O,G,B,H){return this.s(O,y,Q=>Q.provideDefinition(l.URI.revive(G),B,H),[],H)}registerDeclarationProvider(O,G,B){const H=this.t(new $(this.h,B),O);return this.e.$registerDeclarationSupport(H,this.o(G,O)),this.p(H)}$provideDeclaration(O,G,B,H){return this.s(O,$,Q=>Q.provideDeclaration(l.URI.revive(G),B,H),[],H)}registerImplementationProvider(O,G,B){const H=this.t(new I(this.h,B),O);return this.e.$registerImplementationSupport(H,this.o(G,O)),this.p(H)}$provideImplementation(O,G,B,H){return this.s(O,I,Q=>Q.provideImplementation(l.URI.revive(G),B,H),[],H)}registerTypeDefinitionProvider(O,G,B){const H=this.t(new d(this.h,B),O);return this.e.$registerTypeDefinitionSupport(H,this.o(G,O)),this.p(H)}$provideTypeDefinition(O,G,B,H){return this.s(O,d,Q=>Q.provideTypeDefinition(l.URI.revive(G),B,H),[],H)}registerHoverProvider(O,G,B,H){const Q=this.t(new w(this.h,B),O);return this.e.$registerHoverProvider(Q,this.o(G,O)),this.p(Q)}$provideHover(O,G,B,H){return this.s(O,w,Q=>Q.provideHover(l.URI.revive(G),B,H),void 0,H)}registerEvaluatableExpressionProvider(O,G,B,H){const Q=this.t(new b(this.h,B),O);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(G,O)),this.p(Q)}$provideEvaluatableExpression(O,G,B,H){return this.s(O,b,Q=>Q.provideEvaluatableExpression(l.URI.revive(G),B,H),void 0,H)}registerInlineValuesProvider(O,G,B,H){const Q=typeof B.onDidChangeInlineValues=="function"?this.q():void 0,ae=this.t(new L(this.h,B),O);this.e.$registerInlineValuesProvider(ae,this.o(G,O),Q);let Ee=this.p(ae);if(Q!==void 0){const Be=B.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Q));Ee=o.$tL.from(Ee,Be)}return Ee}$provideInlineValues(O,G,B,H,Q){return this.s(O,L,ae=>ae.provideInlineValues(l.URI.revive(G),B,H,Q),void 0,Q)}registerDocumentHighlightProvider(O,G,B){const H=this.t(new T(this.h,B),O);return this.e.$registerDocumentHighlightProvider(H,this.o(G,O)),this.p(H)}registerMultiDocumentHighlightProvider(O,G,B){const H=this.t(new Y(this.h,B),O);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(G,O)),this.p(H)}$provideDocumentHighlights(O,G,B,H){return this.s(O,T,Q=>Q.provideDocumentHighlights(l.URI.revive(G),B,H),void 0,H)}$provideMultiDocumentHighlights(O,G,B,H,Q){return this.s(O,Y,ae=>ae.provideMultiDocumentHighlights(l.URI.revive(G),B,H.map(Ee=>l.URI.revive(Ee)),Q),void 0,Q)}registerLinkedEditingRangeProvider(O,G,B){const H=this.t(new q(this.h,B),O);return this.e.$registerLinkedEditingRangeProvider(H,this.o(G,O)),this.p(H)}$provideLinkedEditingRanges(O,G,B,H){return this.s(O,q,async Q=>{const ae=await Q.provideLinkedEditingRanges(l.URI.revive(G),B,H);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?Se.w(ae.wordPattern):void 0}},void 0,H)}registerReferenceProvider(O,G,B){const H=this.t(new U(this.h,B),O);return this.e.$registerReferenceSupport(H,this.o(G,O)),this.p(H)}$provideReferences(O,G,B,H,Q){return this.s(O,U,ae=>ae.provideReferences(l.URI.revive(G),B,H,Q),void 0,Q)}registerCodeActionProvider(O,G,B,H){const Q=new m.$Sc,ae=this.t(new C(this.h,this.j.converter,this.k,B,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(ae,this.o(G,O),{providedKinds:H?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:H?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Q)}))},Se.u(O),!!B.resolveCodeAction),Q.add(this.p(ae)),Q}$provideCodeActions(O,G,B,H,Q){return this.s(O,C,ae=>ae.provideCodeActions(l.URI.revive(G),B,H,Q),void 0,Q)}$resolveCodeAction(O,G,B){return this.s(O,C,H=>H.resolveCodeAction(G,B),{},void 0)}$releaseCodeActions(O,G){this.s(O,C,B=>Promise.resolve(B.releaseCodeActions(G)),void 0,void 0)}registerDocumentFormattingEditProvider(O,G,B){const H=this.t(new W(this.h,B),O);return this.e.$registerDocumentFormattingSupport(H,this.o(G,O),O.identifier,O.displayName||O.name),this.p(H)}$provideDocumentFormattingEdits(O,G,B,H){return this.s(O,W,Q=>Q.provideDocumentFormattingEdits(l.URI.revive(G),B,H),void 0,H)}registerDocumentRangeFormattingEditProvider(O,G,B){const H=typeof B.provideDocumentRangesFormattingEdits=="function",Q=this.t(new re(this.h,B),O);return this.e.$registerRangeFormattingSupport(Q,this.o(G,O),O.identifier,O.displayName||O.name,H),this.p(Q)}$provideDocumentRangeFormattingEdits(O,G,B,H,Q){return this.s(O,re,ae=>ae.provideDocumentRangeFormattingEdits(l.URI.revive(G),B,H,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(O,G,B,H,Q){return this.s(O,re,ae=>ae.provideDocumentRangesFormattingEdits(l.URI.revive(G),B,H,Q),void 0,Q)}registerOnTypeFormattingEditProvider(O,G,B,H){const Q=this.t(new ue(this.h,B),O);return this.e.$registerOnTypeFormattingSupport(Q,this.o(G,O),H,O.identifier),this.p(Q)}$provideOnTypeFormattingEdits(O,G,B,H,Q,ae){return this.s(O,ue,Ee=>Ee.provideOnTypeFormattingEdits(l.URI.revive(G),B,H,Q,ae),void 0,ae)}registerWorkspaceSymbolProvider(O,G){const B=this.t(new ye(G,this.l),O);return this.e.$registerNavigateTypeSupport(B,typeof G.resolveWorkspaceSymbol=="function"),this.p(B)}$provideWorkspaceSymbols(O,G,B){return this.s(O,ye,H=>H.provideWorkspaceSymbols(G,B),{symbols:[]},B)}$resolveWorkspaceSymbol(O,G,B){return this.s(O,ye,H=>H.resolveWorkspaceSymbol(G,B),void 0,void 0)}$releaseWorkspaceSymbols(O,G){this.s(O,ye,B=>B.releaseWorkspaceSymbols(G),void 0,void 0)}registerRenameProvider(O,G,B){const H=this.t(new ke(this.h,B,this.l),O);return this.e.$registerRenameSupport(H,this.o(G,O),ke.supportsResolving(B)),this.p(H)}$provideRenameEdits(O,G,B,H,Q){return this.s(O,ke,ae=>ae.provideRenameEdits(l.URI.revive(G),B,H,Q),void 0,Q)}$resolveRenameLocation(O,G,B,H){return this.s(O,ke,Q=>Q.resolveRenameLocation(l.URI.revive(G),B,H),void 0,H)}registerNewSymbolNamesProvider(O,G,B){const H=this.t(new he(this.h,B,this.l),O);return this.e.$registerNewSymbolNamesProvider(H,this.o(G,O)),this.p(H)}$provideNewSymbolNames(O,G,B,H){return this.s(O,he,Q=>Q.provideNewSymbolNames(l.URI.revive(G),B,H),void 0,H)}registerDocumentSemanticTokensProvider(O,G,B,H){const Q=this.t(new se(this.h,B),O),ae=typeof B.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(G,O),H,ae);let Ee=this.p(Q);if(ae){const Be=B.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ae));Ee=o.$tL.from(Ee,Be)}return Ee}$provideDocumentSemanticTokens(O,G,B,H){return this.s(O,se,Q=>Q.provideDocumentSemanticTokens(l.URI.revive(G),B,H),null,H)}$releaseDocumentSemanticTokens(O,G){this.s(O,se,B=>B.releaseDocumentSemanticColoring(G),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,G,B,H){const Q=this.t(new $e(this.h,B),O);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(G,O),H),this.p(Q)}$provideDocumentRangeSemanticTokens(O,G,B,H){return this.s(O,$e,Q=>Q.provideDocumentRangeSemanticTokens(l.URI.revive(G),B,H),null,H)}registerCompletionItemProvider(O,G,B,H){const Q=this.t(new te(this.h,this.j.converter,B,this.m,O),O);return this.e.$registerCompletionsProvider(Q,this.o(G,O),H,te.supportsResolving(B),O.identifier),this.p(Q)}$provideCompletionItems(O,G,B,H,Q){return this.s(O,te,ae=>ae.provideCompletionItems(l.URI.revive(G),B,H,Q),void 0,Q)}$resolveCompletionItem(O,G,B){return this.s(O,te,H=>H.resolveCompletionItem(G,B),void 0,B)}$releaseCompletionItems(O,G){this.s(O,te,B=>B.releaseCompletionItems(G),void 0,void 0)}registerInlineCompletionsProvider(O,G,B,H){const Q=new V(O,this.h,B,this.j.converter),ae=this.t(Q,O);return this.e.$registerInlineCompletionsSupport(ae,this.o(G,O),Q.supportsHandleEvents,i.$qm.toKey(O.identifier.value),H?.yieldTo?.map(Ee=>i.$qm.toKey(Ee))||[]),this.p(ae)}$provideInlineCompletions(O,G,B,H,Q){return this.s(O,X,ae=>ae.provideInlineCompletions(l.URI.revive(G),B,H,Q),void 0,Q)}$handleInlineCompletionDidShow(O,G,B,H){this.s(O,X,async Q=>{Q.handleDidShowCompletionItem(G,B,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,G,B,H){this.s(O,X,async Q=>{Q.handlePartialAccept(G,B,H)},void 0,void 0)}$freeInlineCompletionsList(O,G){this.s(O,X,async B=>{B.disposeCompletions(G)},void 0,void 0)}registerSignatureHelpProvider(O,G,B,H){const Q=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,ae=this.t(new Ce(this.h,B),O);return this.e.$registerSignatureHelpProvider(ae,this.o(G,O),Q),this.p(ae)}$provideSignatureHelp(O,G,B,H,Q){return this.s(O,Ce,ae=>ae.provideSignatureHelp(l.URI.revive(G),B,H,Q),void 0,Q)}$releaseSignatureHelp(O,G){this.s(O,Ce,B=>B.releaseSignatureHelp(G),void 0,void 0)}registerInlayHintsProvider(O,G,B){const H=typeof B.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.t(new Fe(this.h,this.j.converter,B,this.l,O),O);this.e.$registerInlayHintsProvider(Q,this.o(G,O),typeof B.resolveInlayHint=="function",H,Se.u(O));let ae=this.p(Q);if(H!==void 0){const Ee=B.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));ae=o.$tL.from(ae,Ee)}return ae}$provideInlayHints(O,G,B,H){return this.s(O,Fe,Q=>Q.provideInlayHints(l.URI.revive(G),B,H),void 0,H)}$resolveInlayHint(O,G,B){return this.s(O,Fe,H=>H.resolveInlayHint(G,B),void 0,B)}$releaseInlayHints(O,G){this.s(O,Fe,B=>B.releaseHints(G),void 0,void 0)}registerDocumentLinkProvider(O,G,B){const H=this.t(new Pe(this.h,B),O);return this.e.$registerDocumentLinkProvider(H,this.o(G,O),typeof B.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(O,G,B){return this.s(O,Pe,H=>H.provideLinks(l.URI.revive(G),B),void 0,B,G.scheme==="output")}$resolveDocumentLink(O,G,B){return this.s(O,Pe,H=>H.resolveLink(G,B),void 0,void 0,!0)}$releaseDocumentLinks(O,G){this.s(O,Pe,B=>B.releaseLinks(G),void 0,void 0,!0)}registerColorProvider(O,G,B){const H=this.t(new we(this.h,B),O);return this.e.$registerDocumentColorProvider(H,this.o(G,O)),this.p(H)}$provideDocumentColors(O,G,B){return this.s(O,we,H=>H.provideColors(l.URI.revive(G),B),[],B)}$provideColorPresentations(O,G,B,H){return this.s(O,we,Q=>Q.provideColorPresentations(l.URI.revive(G),B,H),void 0,H)}registerFoldingRangeProvider(O,G,B){const H=this.q(),Q=typeof B.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new ge(new me(this.h,B),O)),this.e.$registerFoldingRangeProvider(H,this.o(G,O),O.identifier,Q);let ae=this.p(H);if(Q!==void 0){const Ee=B.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));ae=o.$tL.from(ae,Ee)}return ae}$provideFoldingRanges(O,G,B,H){return this.s(O,me,Q=>Q.provideFoldingRanges(l.URI.revive(G),B,H),void 0,H)}registerSelectionRangeProvider(O,G,B){const H=this.t(new J(this.h,B,this.l),O);return this.e.$registerSelectionRangeProvider(H,this.o(G,O)),this.p(H)}$provideSelectionRanges(O,G,B,H){return this.s(O,J,Q=>Q.provideSelectionRanges(l.URI.revive(G),B,H),[],H)}registerCallHierarchyProvider(O,G,B){const H=this.t(new x(this.h,B),O);return this.e.$registerCallHierarchyProvider(H,this.o(G,O)),this.p(H)}$prepareCallHierarchy(O,G,B,H){return this.s(O,x,Q=>Promise.resolve(Q.prepareSession(l.URI.revive(G),B,H)),void 0,H)}$provideCallHierarchyIncomingCalls(O,G,B,H){return this.s(O,x,Q=>Q.provideCallsTo(G,B,H),void 0,H)}$provideCallHierarchyOutgoingCalls(O,G,B,H){return this.s(O,x,Q=>Q.provideCallsFrom(G,B,H),void 0,H)}$releaseCallHierarchy(O,G){this.s(O,x,B=>Promise.resolve(B.releaseSession(G)),void 0,void 0)}registerTypeHierarchyProvider(O,G,B){const H=this.t(new le(this.h,B),O);return this.e.$registerTypeHierarchyProvider(H,this.o(G,O)),this.p(H)}$prepareTypeHierarchy(O,G,B,H){return this.s(O,le,Q=>Promise.resolve(Q.prepareSession(l.URI.revive(G),B,H)),void 0,H)}$provideTypeHierarchySupertypes(O,G,B,H){return this.s(O,le,Q=>Q.provideSupertypes(G,B,H),void 0,H)}$provideTypeHierarchySubtypes(O,G,B,H){return this.s(O,le,Q=>Q.provideSubtypes(G,B,H),void 0,H)}$releaseTypeHierarchy(O,G){this.s(O,le,B=>Promise.resolve(B.releaseSession(G)),void 0,void 0)}registerDocumentOnDropEditProvider(O,G,B,H){const Q=this.q();this.f.set(Q,new ge(new de(this.e,this.h,B,Q,O),O));const ae=(0,h.$NF)(O,"dropMetadata")&&H?de.toInternalProviderId(O.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(G,O),ae,(0,h.$NF)(O,"dropMetadata")?H:void 0),this.p(Q)}$provideDocumentOnDropEdits(O,G,B,H,Q,ae){return this.s(O,de,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(G,l.URI.revive(B),H,Q,ae)),void 0,void 0)}registerMappedEditsProvider(O,G,B){const H=this.t(new Ae(this.h,B),O);return this.e.$registerMappedEditsProvider(H,this.o(G,O)),this.p(H)}$provideMappedEdits(O,G,B,H,Q){return this.s(O,Ae,ae=>Promise.resolve(ae.provideMappedEdits(G,B,H,Q)),null,Q)}registerDocumentPasteEditProvider(O,G,B,H){const Q=this.q();this.f.set(Q,new ge(new F(this.e,this.h,B,Q,O),O));const ae=F.toInternalProviderId(O.identifier.value,H.id);return this.e.$registerPasteEditProvider(Q,this.o(G,O),ae,{supportsCopy:!!B.prepareDocumentPaste,supportsPaste:!!B.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(O,G,B,H,Q){return this.s(O,F,ae=>ae.prepareDocumentPaste(l.URI.revive(G),B,H,Q),void 0,Q)}$providePasteEdits(O,G,B,H,Q,ae){return this.s(O,F,Ee=>Ee.providePasteEdits(G,l.URI.revive(B),H,Q,ae),void 0,ae)}static w(O){return{pattern:O.source,flags:O.flags}}static y(O){return{decreaseIndentPattern:Se.w(O.decreaseIndentPattern),increaseIndentPattern:Se.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?Se.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?Se.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:Se.w(O.beforeText),afterText:O.afterText?Se.w(O.afterText):void 0,previousLineText:O.previousLineText?Se.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(Se.z)}static C(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(G=>o.SyntaxTokenType.toString(G)):void 0}}static D(O){return O.map(Se.C)}setLanguageConfiguration(O,G,B){const{wordPattern:H}=B;if(H&&(0,A.$2e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(G,H):this.h.setWordDefinitionFor(G,void 0),B.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),B.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const Q=this.q(),ae={comments:B.comments,brackets:B.brackets,wordPattern:B.wordPattern?Se.w(B.wordPattern):void 0,indentationRules:B.indentationRules?Se.y(B.indentationRules):void 0,onEnterRules:B.onEnterRules?Se.B(B.onEnterRules):void 0,__electricCharacterSupport:B.__electricCharacterSupport,__characterPairSupport:B.__characterPairSupport,autoClosingPairs:B.autoClosingPairs?Se.D(B.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,G,ae),this.p(Q)}$setWordDefinitions(O){for(const G of O)this.h.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.$3gc=Se}),define(Le[260],Me([1,0,3,8,7,32,11,6,25]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class D{constructor(k,l,v,p){this.c=l,this.d=v,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(S.$rL.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const v=this.c.getDocumentData(k);if(!v)throw new Error(`document '${k.toString()}' NOT found`);return v.document}async tokenAtPosition(k,l){const v=k.version,p=M.Position.from(l),s=await this.a.$tokensAtPosition(k.uri,p),a={type:P.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new P.$vL(l.line,l.character,l.line,l.character)};if(!s)return a;const r={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!r.range.contains(l)||v!==k.version?a:r}createLanguageStatusItem(k,l,v){const p=this.f++,s=this.a,a=this.g,r=`${k.identifier.value}/${l}`;if(a.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(r);const i={selector:v,id:l,name:k.displayName??k.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new m.$Sc,h=()=>{if(n?.dispose(),!a.has(r)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$ah)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:r,name:i.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===P.LanguageStatusSeverity.Error?N.default.Error:i.severity===P.LanguageStatusSeverity.Warning?N.default.Warning:N.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),s.$removeLanguageStatus(p),a.delete(r)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,h()},get selector(){return i.selector},set selector(f){i.selector=f,h()},get text(){return i.text},set text(f){i.text=f,h()},set text2(f){(0,g.$OF)(k,"languageStatusText"),i.text=f,h()},get text2(){return(0,g.$OF)(k,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,h()},get severity(){return i.severity},set severity(f){i.severity=f,h()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,h()},get command(){return i.command},set command(f){i.command=f,h()},get busy(){return i.busy},set busy(f){i.busy=f,h()}};return h(),t}}e.$pic=D}),define(Le[261],Me([1,0,12,2,8,7,83]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=void 0;class m{constructor(k,l,v,p){this.start=k,this.deletedCount=l,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new N.$TM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,v){this.notebook=k,this.h=l,this.j=v,this.handle=v.handle,this.uri=M.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(p){k.g=p},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(v)}return this.f}setOutputs(k){this.a=k.map(P.NotebookCellOutput.to)}setOutputItems(k,l,v){const p=v.map(P.NotebookCellOutputItem.to),s=this.a.find(a=>a.id===k);if(s&&(l||(s.items.length=0),s.items.push(...p),s.items.length>1&&s.items.every(a=>R.$tJ(a.mime)))){const a=new Map,r=[];s.items.forEach(i=>{let n;a.has(i.mime)?n=a.get(i.mime):(n=[],a.set(i.mime,n),r.push(i.mime)),n.push(i.data)}),s.items.length=0,r.forEach(i=>{const n=R.$uJ(a.get(i));s.items.push({mime:i,data:n.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$aic=g;class D{static{this.a=0}constructor(k,l,v,p,s){this.k=k,this.l=l,this.m=v,this.uri=p,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===S.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(v){return v=k.n(v),k.b[v].apiCell},getCells(v){return(v?k.p(v):k.b).map(s=>s.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,v){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const r of k.rawEvents)r.kind===R.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,p.contentChanges):r.kind===R.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,p.contentChanges):r.kind===R.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const a=new Map;for(let r=0;r<s.length;r++){const i=s[r],n=a.get(i.cell);if(n===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});a.set(i.cell,o-1)}else p.cellChanges[n]={...p.cellChanges[n],...i}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,v=k.end|0;return l<0&&(l=0),v>this.b.length&&(v=this.b.length),k.with({start:l,end:v})}p(k){k=this.o(k);const l=[];for(let v=k.start;v<k.end;v++)l.push(this.b[v]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,v){if(this.j)return;const p=[],s=[],a=[];if(k.reverse().forEach(r=>{const n=r[2].map(t=>{const f=new g(this,this.l,t);return l||s.push(g.asModelAddData(this.apiNotebook,t)),f}),o=new m(r[0],r[1],[],n),h=this.b.splice(r[0],r[1],...n);for(const t of h)a.push(t.uri),o.deletedItems.push(t.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),v)for(const r of p)v.push(r.asApiEvent())}s(k,l,v,p){const s=this.b.splice(k,l);this.b.splice(v,0,...s);const a=[new m(k,l,s.map(r=>r.apiCell),[]),new m(v,0,[],s)];for(const r of a)p.push(r.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,v,p){this.b[k].setOutputItems(l,v,p)}v(k,l){const v=this.b[k];v.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(v.uri,l)}w(k,l){const v=this.b[k];v.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$bic=D}),define(Le[262],Me([1,0,5,2,8,7]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;class R{constructor(g,D,A,k={timeout:1500,errors:3}){this.b=g,this.c=D,this.d=A,this.f=k,this.a=new S.$1d}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(D,A,k)=>{const l=function(p){D.call(A,p)};return l.extension=g,this.a.event(l,void 0,k)}}async $participateInSave(g,D,A){const k=M.URI.revive(g),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:P.TextDocumentSaveReason.to(D)},A,async(s,a)=>{const r=Date.now(),i=await await Promise.resolve(s);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof N.$DL?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const s of v){const{edits:a}=P.WorkspaceEdit.from(s);p.edits=p.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$ric=R}),define(Le[110],Me([1,0,15,8,7]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;class N{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,D,A,k,l){this.id=m,this.f=g,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(P.$TM.isNotebookRange))throw(0,S.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,D){m.f.$tryRevealRange(m.id,M.NotebookRange.from(g),D??P.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},N.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$cic=N}),define(Le[263],Me([1,0,5,14,8]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;let N=class{constructor(m,g){this.c=m,this.d=g,this.a=new S.$Yd,this.b=new S.$Yd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,g);const D=this.d.getEditorById(m);g.visibleRanges&&D._acceptVisibleRanges(g.visibleRanges.ranges.map(P.NotebookRange.to)),g.selections&&D._acceptSelections(g.selections.selections.map(P.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const g in m)this.d.getEditorById(g)._acceptViewColumn(P.ViewColumn.to(m[g]))}};e.$tic=N,e.$tic=N=Je([qe(0,M.$sj)],N)}),define(Le[264],Me([1,0,5,3,110]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class N{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(M.$rL.MainThreadNotebookRenderers)}$postRendererMessage(m,g,D){const A=this.c.getEditorById(m);this.a.get(g)?.fire({editor:A.apiEditor,message:D})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,k,l)=>this.d(g).event(A,k,l),postMessage:(A,k)=>{P.$cic.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const l=k&&P.$cic.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,g,A)}}}d(m){let g=this.a.get(m);return g||(g=new S.$Yd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$wic=N}),define(Le[265],Me([1,0,8,99,21,67,15]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class m{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,v){const p=this.b++,{title:s,location:a,cancellable:r}=l,i={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(p,{location:S.ProgressLocation.from(a),title:s,source:i,cancellable:r},k.isUnderDevelopment?void 0:k.identifier.value).catch(R.$2),this.d(p,v,!!r)}d(k,l,v){let p;v&&(p=new P.$9d,this.c.set(k,p));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),p?.dispose()};let a;try{a=l(new D(this.a,k),v&&p?p.token:P.CancellationToken.None)}catch(r){throw s(k),r}return a.then(r=>s(k),r=>s(k)),a}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$Aic=m;function g(A,k){return A.message=k.message,typeof k.increment=="number"&&(typeof A.increment=="number"?A.increment+=k.increment:A.increment=k.increment),A}class D extends M.$Av{constructor(k,l){super(v=>this.throttledReport(v)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,N.$Eh)(100,(A,k)=>g(A,k),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(Le[266],Me([1,0,2,3,11,8]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;class R{static{this.a=0}constructor(g,D){this.d=D,this.c=new Map,this.b=g.getProxy(M.$rL.MainThreadQuickDiff)}$provideOriginalResource(g,D,A){const k=S.URI.revive(D),l=this.c.get(g);return l?(0,P.$3g)(()=>l.provideOriginalResource(k,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(g,D,A,k){const l=R.a++;return this.c.set(l,D),this.b.$registerQuickDiffProvider(l,N.DocumentSelector.from(g,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Bic=R}),define(Le[267],Me([1,0,21,5,6,3,2,7,15,18,32,40,25,8]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;function p(s,a,r){const i=s.getProxy(N.$rL.MainThreadQuickOpen);class n{constructor($,I){this.e=new Map,this.f=0,this.a=$,this.b=I}showQuickPick($,I,d,w=S.CancellationToken.None){this.c=void 0;const b=Promise.resolve(I),L=++this.f,T=i.$show(L,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},w),Y={},q=T.then(()=>Y);return Promise.race([q,b]).then(U=>{if(U===Y)return;const C=(0,l.$NF)($,"quickPickItemTooltip");return b.then(F=>{const W=[];for(let re=0;re<F.length;re++){const ue=F[re];if(typeof ue=="string")W.push({label:ue,handle:re});else if(ue.kind===m.QuickPickItemKind.Separator)W.push({type:"separator",label:ue.label});else{ue.tooltip&&!C&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const ye=ue.iconPath?c(ue.iconPath):void 0;W.push({label:ue.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:C?v.MarkdownString.fromStrict(ue.tooltip):void 0,handle:re})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=re=>{d.onDidSelectItem(F[re])}),i.$setItems(L,W),T.then(re=>{if(typeof re=="number")return F[re];if(Array.isArray(re))return re.map(ue=>F[ue])})})}).then(void 0,U=>{if(!(0,g.$4)(U))return i.$setError(L,U),Promise.reject(U)})}$onItemSelected($){this.c?.($)}showInput($,I=S.CancellationToken.None){return this.d=$?.validateInput,i.$input($,typeof this.d=="function",I).then(void 0,d=>{if(!(0,g.$4)(d))return Promise.reject(d)})}async $validateInput($){if(!this.d)return;const I=await this.d($);if(!I||typeof I=="string")return I;let d;switch(I.severity){case m.InputBoxValidationSeverity.Info:d=A.default.Info;break;case m.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case m.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=I.message?A.default.Error:A.default.Ignore;break}return{content:I.message,severity:d}}async showWorkspaceFolderPick($,I=S.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!d)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(b=>b.uri.toString()===d.uri.toString())}createQuickPick($){const I=new u($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox($){const I=new E($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue($,I){this.e.get($)?._fireDidChangeValue(I)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,I){const d=this.e.get($);d instanceof u&&d._fireDidChangeActive(I)}$onDidChangeSelection($,I){const d=this.e.get($);d instanceof u&&d._fireDidChangeSelection(I)}$onDidTriggerButton($,I){this.e.get($)?._fireDidTriggerButton(I)}$onDidTriggerItemButton($,I,d){const w=this.e.get($);w instanceof u&&w._fireDidTriggerItemButton(I,d)}$onDidHide($){this.e.get($)?._fireDidHide()}}class o{static{this.a=1}constructor($,I){this.x=$,this.y=I,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Yd,this.q=new M.$Yd,this.r=new M.$Yd,this.s=new M.$Yd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((I,d)=>{const w=I===m.$QM.Back?-1:d;this.o.set(w,I)}),this.z({buttons:$.map((I,d)=>({...c(I.iconPath),tooltip:I.tooltip,handle:I===m.$QM.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const I=this.o.get($);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z($){if(!this.v){for(const I of Object.keys($)){const d=$[I];this.u[I]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function h(y){if(y instanceof m.$oM)return{id:y.id};const $=f(y),I=t(y);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof I=="string"?R.URI.file(I):I}}function t(y){return typeof y=="object"&&"light"in y?y.light:y}function f(y){return typeof y=="object"&&"dark"in y?y.dark:y}function c(y){const $=h(y);let I,d;return"id"in $?d=k.ThemeIcon.asClassName($):I=$,{iconPath:I,iconClass:d}}class u extends o{constructor($,I){super($.identifier,I),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Yd,this.L=[],this.M=new M.$Yd,this.N=new M.$Yd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((w,b)=>{this.C.set(b,w),this.D.set(w,b)});const I=(0,l.$NF)(this.O,"quickPickItemTooltip"),d=[];for(let w=0;w<$.length;w++){const b=$[w];if(b.kind===m.QuickPickItemKind.Separator)d.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=b.iconPath?c(b.iconPath):void 0;d.push({handle:w,label:b.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((T,Y)=>({...c(T.iconPath),tooltip:T.tooltip,handle:Y}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive($){const I=(0,D.$Hb)($.map(d=>this.C.get(d)));this.J=I,this.K.fire(I)}_fireDidChangeSelection($){const I=(0,D.$Hb)($.map(d=>this.C.get(d)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton($,I){const d=this.C.get($);if(!d||!d.buttons||!d.buttons.length)return;const w=d.buttons[I];w&&this.N.fire({button:w,item:d})}}class E extends o{constructor($,I){super($.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:A.default.Error}):this.z({validationMessage:$.message,severity:$.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(a,r)}e.$Cic=p}),define(Le[268],Me([1,0,2,5,67,6,11,3,18,139,14,22,40,8,25,12,20]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=void 0;function i(L){return L instanceof S.URI}function n(L,T){return L.scheme===s.Schemas.file&&T.scheme===s.Schemas.file&&a.$k?L.toString()===T.toString():L.toString().toLowerCase()===T.toString().toLowerCase()}function o(L){if(L)return typeof L.iconPath=="string"?S.URI.file(L.iconPath):S.URI.isUri(L.iconPath)||l.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function h(L){if(L.icon){if(S.URI.isUri(L.icon))return L.icon;if(l.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const T=L.icon;return{light:T.light,dark:T.dark}}}else return}function t(L,T){if(!L.iconPath&&!T.iconPath)return 0;if(L.iconPath){if(!T.iconPath)return 1}else return-1;const Y=typeof L.iconPath=="string"?L.iconPath:S.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,q=typeof T.iconPath=="string"?T.iconPath:S.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,D.$Xq)(Y,q)}function f(L,T){let Y=0;if(L.strikeThrough!==T.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==T.faded)return L.faded?1:-1;if(L.tooltip!==T.tooltip)return(L.tooltip||"").localeCompare(T.tooltip||"");if(Y=t(L,T),Y!==0)return Y;if(L.light&&T.light)Y=t(L.light,T.light);else{if(L.light)return 1;if(T.light)return-1}if(Y!==0)return Y;if(L.dark&&T.dark)Y=t(L.dark,T.dark);else{if(L.dark)return 1;if(T.dark)return-1}return Y}function c(L,T){if(L.command!==T.command)return L.command<T.command?-1:1;if(L.title!==T.title)return L.title<T.title?-1:1;if(L.tooltip!==T.tooltip){if(L.tooltip!==void 0&&T.tooltip!==void 0)return L.tooltip<T.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(L.arguments===T.arguments)return 0;if(L.arguments)if(T.arguments){if(L.arguments.length!==T.arguments.length)return L.arguments.length-T.arguments.length}else return 1;else return-1;for(let Y=0;Y<L.arguments.length;Y++){const q=L.arguments[Y],U=T.arguments[Y];if(q!==U&&!(i(q)&&i(U)&&n(q,U)))return q<U?-1:1}return 0}function u(L,T){let Y=(0,D.$Xq)(L.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(Y!==0)return Y;if(L.command&&T.command)Y=c(L.command,T.command);else{if(L.command)return 1;if(T.command)return-1}if(Y!==0)return Y;if(L.decorations&&T.decorations)Y=f(L.decorations,T.decorations);else{if(L.decorations)return 1;if(T.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)Y=(0,D.$Xq)(L.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)Y=(0,D.$Xq)(L.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return Y}function E(L,T){for(let Y=0;Y<L.length;Y++)if(L[Y]!==T[Y])return!1;return!0}function y(L,T){return L.command===T.command&&L.title===T.title&&L.tooltip===T.tooltip&&(L.arguments&&T.arguments?E(L.arguments,T.arguments):L.arguments===T.arguments)}function $(L,T){return(0,g.$ub)(L,T,y)}class I{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,p.$OF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,p.$OF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,p.$OF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,Y,q,U,C){this.k=T,this.l=U,this.m=C,this.d="",this.e=new M.$Yd,this.f="",this.h=!0,this.j=!0,this.#t=Y,this.#e=q}showValidationMessage(T,Y){(0,p.$OF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,Y)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Dic=I;class d{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,Y,q,U,C,F,W){this.q=T,this.s=Y,this.t=q,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=F,this.w=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Yd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Yd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=d.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,Y){const q=this.h.get(T);return q?(0,R.$3g)(()=>this.s.executeCommand(q.command,...q.arguments||[],Y)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(u),q=(0,g.$Db)(this.o,T,u).map(F=>{const W=F.toInsert.map(re=>{const ue=this.e++;this.g.set(ue,re);const ye=re.resourceUri;let ke;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const me=new N.$Sc;ke=this.s.converter.toInternal(re.command,me),this.j.set(ue,me)}else this.h.set(ue,re.command);const he=(0,p.$NF)(this.w,"scmMultiDiffEditor"),ve=he?re.multiDiffEditorOriginalUri:void 0,se=he?re.multiFileDiffEditorModifiedUri:void 0,$e=o(re.decorations),te=re.decorations&&o(re.decorations.light)||$e,X=re.decorations&&o(re.decorations.dark)||$e,V=[te,X],ne=re.decorations&&re.decorations.tooltip||"",Ce=re.decorations&&!!re.decorations.strikeThrough,Fe=re.decorations&&!!re.decorations.faded,Pe=re.contextValue||"";return{rawResource:[ue,ye,V,ne,Ce,Fe,Pe,ke,ve,se],handle:ue}});return{start:F.start,deleteCount:F.deleteCount,toInsert:W}}),U=q.map(({start:F,deleteCount:W,toInsert:re})=>[F,W,re.map(ue=>ue.rawResource)]),C=q.reverse();for(const{start:F,deleteCount:W,toInsert:re}of C){const ue=re.map(ke=>ke.handle),ye=this.n.splice(F,W,...ue);for(const ke of ye)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=T,U}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let Y;(0,p.$NF)(this.x,"quickDiffProvider")&&(Y=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:Y})}get historyProvider(){return(0,p.$OF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,p.$OF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new N.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new N.$Sc,this.o=T;const Y=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:Y})}get actionButton(){return(0,p.$OF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,p.$OF)(this.x,"scmActionButton"),this.p.value=new N.$Sc,this.q=T;const Y=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(q=>q.map(U=>this.y.converter.toInternal(U,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:Y??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&$(this.t,T))return;this.s.value=new N.$Sc,this.t=T;const Y=(T||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:Y})}get selected(){return this.u}constructor(T,Y,q,U,C,F,W){this.x=T,this.y=U,this.z=C,this.A=F,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new N.$Uc,this.m=void 0,this.n=new N.$Uc,this.o=void 0,this.p=new N.$Uc,this.s=new N.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Yd,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=q;const re=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new I(T,Y,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,C,F,W,re)}createResourceGroup(T,Y,q){const U=(0,p.$NF)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,C=new d(this.#e,this.y,this.w,T,Y,U,this.x),F=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,F),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const T=[],Y=[];for(const[q,U]of this.C){U.dispose();const C=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});M.Event.once(q.onDidDispose)(()=>{this.D.delete(q),C.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),T.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const F=q._takeResourceStateSnapshot();F.length>0&&Y.push([q.handle,F]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,T,Y),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(Y=>{const q=Y._takeResourceStateSnapshot();q.length!==0&&T.push([Y.handle,q])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,P.$Dh)(100)],w.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$Dh)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,Y,q,U){this.l=Y,this.m=q,this.n=U,this.g=new Map,this.h=new k.$sm,this.j=new M.$Yd,this.e=T.getProxy(m.$rL.MainThreadSCM),this.f=T.getProxy(m.$rL.MainThreadTelemetry),Y.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const F=this.g.get(C.sourceControlHandle);if(!F)return C;const W=F.getResourceGroup(C.groupHandle);return W?W.getResourceState(C.handle):C}else if(C&&C.$mid===4){const F=this.g.get(C.sourceControlHandle);return F?F.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const F=this.g.get(C.handle);return F||C}return C}})}createSourceControl(T,Y,q,U){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,Y,q,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const C=r.d++,F=new w(T,this.m,this.e,this.l,Y,q,U);this.g.set(C,F);const W=this.h.get(T.identifier)||[];return W.push(F),this.h.set(T.identifier,W),F}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const Y=this.h.get(T.identifier),q=Y&&Y[Y.length-1];return q&&q.inputBox}$provideOriginalResource(T,Y,q){const U=S.URI.revive(Y);this.n.trace("ExtHostSCM#$provideOriginalResource",T,U.toString());const C=this.g.get(T);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$3g)(()=>C.quickDiffProvider.provideOriginalResource(U,q)).then(F=>F||null)}$onInputBoxValueChange(T,Y){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const q=this.g.get(T);return q&&q.inputBox.$onInputBoxValueChange(Y),Promise.resolve(void 0)}$executeResourceCommand(T,Y,q,U){this.n.trace("ExtHostSCM#$executeResourceCommand",T,Y,q);const C=this.g.get(T);if(!C)return Promise.resolve(void 0);const F=C.getResourceGroup(Y);return F?F.$executeResourceCommand(q,U):Promise.resolve(void 0)}$validateInput(T,Y,q){this.n.trace("ExtHostSCM#$validateInput",T);const U=this.g.get(T);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$3g)(()=>U.inputBox.validateInput(Y,q)).then(C=>{if(!C)return Promise.resolve(void 0);const F=v.MarkdownString.fromStrict(C.message);return F?Promise.resolve([F,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,Y,q,U){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(Y,q,U)??void 0}async $provideHistoryItems(T,Y,q,U){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(Y,q,U))?.map(W=>({...W,icon:h(W)}))??void 0}async $provideHistoryItemSummary(T,Y,q,U){const C=this.g.get(T)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const F=await C.provideHistoryItemSummary(Y,q,U);return F?{...F,icon:h(F)}:void 0}async $provideHistoryItemChanges(T,Y,q,U){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(Y,q,U)??void 0}};e.$Eic=b,e.$Eic=b=r=Je([qe(3,A.$sj)],b)}),define(Le[269],Me([1,0,3,8,2]),function(fe,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;class N{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(S.$rL.MainThreadShare)}async $provideShare(m,g,D){return await this.c.get(m)?.provideShare({selection:M.Range.to(g.selection),resourceUri:P.URI.revive(g.resourceUri)},D)??void 0}registerShareProvider(m,g){const D=N.a++;return this.c.set(D,g),this.b.$registerShareProvider(D,M.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$Fic=N}),define(Le[270],Me([1,0,7,3,165,6,8,16]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$pM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$pM("statusBarItem.warningForeground")]])}#e;#t;constructor(l,v,p,s,a,r=S.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new N.$Sc,this.#e=l,this.#t=v,a&&s){this.c=(0,S.$5L)(s.identifier,a);const n=p.get(this.c);n&&(r=n.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(g.a++);this.e=s,this.f=a,this.g=r,this.h=this.u(i)}u(l){if((0,m.$Qf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new N.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=g.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,v,this.k,s,this.r?.internal,p,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Hic=g;class D{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const v={message:l};return this.b.unshift(v),this.c(),new S.$tL(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,v){this.e=new Map,this.a=l.getProxy(M.$rL.MainThreadStatusBar),this.b=v,this.c=new D(this)}$acceptStaticEntries(l){for(const v of l)this.e.set(v.entryId,v)}createStatusBarEntry(l,v,p,s){return new g(this.a,this.b,this.e,l,v,p,s)}setStatusBarMessage(l,v){const p=this.c.setMessage(l);let s;return typeof v=="number"?s=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new S.$tL(()=>{p.dispose(),clearTimeout(s)})}}e.$Iic=A}),define(Le[111],Me([1,0,29,103,49,75,59,8,2]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=e.$XN=e.$WN=e.$VN=void 0;const D=(n,o,h,t)=>{let f=o;return{enumerable:!0,configurable:!1,get(){return f},set(c){if(!h(f,c)){const u=f;f=c,n.listener?.(t(c,u))}}}},A=(n,o)=>n===o,k={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,o)=>!(n.length!==o.length||n.some(h=>!o.find(t=>h.id===t.id)))},l=n=>o=>({op:4,update:n(o)}),v=(n,o)=>({range:(()=>{let h;const t=l(f=>({range:S.$Zs.lift(m.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return h},set(f){n.listener?.({op:6}),k.range(h,f)||(h=f,n.listener?.(t(f)))}}})(),label:D(n,o,k.label,l(h=>({label:h}))),description:D(n,void 0,k.description,l(h=>({description:h}))),sortText:D(n,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:D(n,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:D(n,!1,k.busy,l(h=>({busy:h}))),error:D(n,void 0,k.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:D(n,[],k.tags,(h,t)=>({op:1,new:h.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),p=n=>{const o=P.$iK.fromString(n.extId),h=new a(o.controllerId,o.localId,n.label,g.URI.revive(n.uri)||void 0);return h.range=m.Range.to(n.range||void 0),h.description=n.description||void 0,h.sortText=n.sortText||void 0,h.tags=n.tags.map(t=>m.TestTag.to({id:(0,R.$nK)(t).tagId})),h},s=n=>{let o;for(const h of n.tests){const t=p(h.item);(0,M.$FN)(t).parent=o,o=t}return o};e.$VN=s;class a{constructor(o,h,t,f){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const c=(0,M.$EN)(this,o);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof r?void 0:c.parent}},children:{value:(0,N.$DN)(c,M.$FN,a),enumerable:!0,writable:!1},...v(c,t)})}}e.$WN=a;class r extends a{constructor(o,h){super(o,o,h,void 0),this._isRoot=!0}}e.$XN=r;class i extends N.$zN{constructor(o,h,t){super({controllerId:o,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:M.$FN,getChildren:f=>f.children,root:new r(o,h),toITestItem:m.TestItem.from})}}e.$YN=i}),define(Le[31],Me([1,0,16,7,8,26,3,18,14,52,29,91,2,6,4,17,111,23,50,41,63,57,60,33]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=void 0;let c=class{#e;#t;#i;constructor(d,w,b){this.b=new Map,this.c=new Map,this.#e=d.getProxy(R.$rL.MainThreadCommands),this.d=w,this.#i=b,this.#t=d.getProxy(R.$rL.MainThreadTelemetry),this.converter=new u(this,L=>{const T=this.c.get(L);return T?.result===y.Void?T:void 0},w),this.f=[{processArgument(L){return(0,D.$Hh)(L)}},{processArgument(L){return(0,N.$Dn)(L,function(T){if(A.$Zs.isIRange(T))return P.Range.to(T);if(k.$Ys.isIPosition(T))return P.Position.to(T);if(A.$Zs.isIRange(T.range)&&l.URI.isUri(T.uri))return P.location.to(T);if(T instanceof r.$me)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const w=this.registerCommand(!1,d.id,async(...b)=>{const L=d.args.map((Y,q)=>{if(!Y.validate(b[q]))throw new Error(`Invalid argument '${Y.name}' when running '${d.id}', received: ${typeof b[q]=="object"?JSON.stringify(b[q],null,"	"):b[q]} `);return Y.convert(b[q])}),T=await this.executeCommand(d.internalId,...L);return d.result.convert(T,b,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new M.$tL(()=>{w.dispose(),this.c.delete(d.id)})}registerCommand(d,w,b,L,T,Y){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:b,thisArg:L,metadata:T,extension:Y}),d&&this.#e.$registerCommand(w),new M.$tL(()=>{this.b.delete(w)&&d&&this.#e.$unregisterCommand(w)})}executeCommand(d,...w){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,w,!0)}async g(d,w,b){if(this.b.has(d))return this.#e.$fireCommandActivationEvent(d),this.h(d,w,!1);{let L=!1;const T=(0,N.$Dn)(w,function(Y){if(Y instanceof M.$uL)return P.Position.from(Y);if(Y instanceof M.$vL)return P.Range.from(Y);if(Y instanceof M.$FL)return P.location.from(Y);if(M.$TM.isNotebookRange(Y))return P.NotebookRange.from(Y);if(Y instanceof ArrayBuffer)return L=!0,r.$me.wrap(new Uint8Array(Y));if(Y instanceof Uint8Array)return L=!0,r.$me.wrap(Y);if(Y instanceof r.$me)return L=!0,Y;if(!Array.isArray(Y))return Y});try{const Y=await this.#e.$executeCommand(d,L?new i.$Yv(T):T,b);return(0,D.$Hh)(Y)}catch(Y){if(Y instanceof Error&&Y.message==="$executeCommand:retry")return this.g(d,w,!1);throw Y}}}async h(d,w,b){const L=this.b.get(d);if(!L)throw new Error("Unknown command");const{callback:T,thisArg:Y,metadata:q}=L;if(q?.args)for(let C=0;C<q.args.length;C++)try{(0,S.$4f)(w[C],q.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${q.args[C].name}' - ${q.args[C].description}`)}const U=o.$Ud.create();try{return await T.apply(Y,w)}catch(C){if(d===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...w);F&&(d=F.command)}if(this.d.error(C,d,L.extension?.identifier),!b)throw C;if(L.extension?.identifier){const F=this.#i.onExtensionError(L.extension.identifier,C);this.d.trace("forwarded error to extension?",F,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Vi)(C)),this.id=d,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,d,U.elapsed())}}j(d,w,b){d.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new h.$Qo(w),duration:b})}$executeContributedCommand(d,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const b=this.b.get(d);return b?(w=w.map(L=>this.f.reduce((T,Y)=>Y.processArgument(T,b.extension?.identifier),L)),this.h(d,w,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),this.#e.$getCommands().then(w=>(d&&(w=w.filter(b=>b[0]!=="_")),w))}$getContributedCommandMetadata(){const d=Object.create(null);for(const[w,b]of this.b){const{metadata:L}=b;L&&(d[w]=L)}return Promise.resolve(d)}};e.$5N=c,e.$5N=c=Je([qe(0,s.$JN),qe(1,g.$sj),qe(2,t.$4N)],c),e.$6N=(0,p.$$h)("IExtHostCommands");class u{constructor(d,w,b){this.d=d,this.f=w,this.g=b,this.delegatingCommandId=`__vsc${(0,f.$ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,w){if(!d)return;const b={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return b;const L=this.f(d.command);if(L)b.id=L.internalId,b.arguments=L.args.map((T,Y)=>T.convert(d.arguments&&d.arguments[Y]));else if((0,m.$Lb)(d.arguments)){const T=`${d.command} /${++this.c}`;this.b.set(T,d),w.add((0,v.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),b.$ident=T,b.id=this.delegatingCommandId,b.arguments=[T],this.g.trace("CommandsConverter#CREATE",d.command,T)}return b}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const w=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.$7N=u;class E{static{this.Uri=new E("uri","Uri of a text document",d=>l.URI.isUri(d),d=>d)}static{this.Position=new E("position","A position in a text document",d=>M.$uL.isPosition(d),P.Position.from)}static{this.Range=new E("range","A range in a text document",d=>M.$vL.isRange(d),P.Range.from)}static{this.Selection=new E("selection","A selection in a text document",d=>M.$wL.isSelection(d),P.Selection.from)}static{this.Number=new E("number","",d=>typeof d=="number",d=>d)}static{this.String=new E("string","",d=>typeof d=="string",d=>d)}static{this.StringArray=E.Arr(E.String)}static Arr(d){return new E(`${d.name}_array`,`Array of ${d.name}, ${d.description}`,w=>Array.isArray(w)&&w.every(b=>d.validate(b)),w=>w.map(b=>d.convert(b)))}static{this.CallHierarchyItem=new E("item","A call hierarchy item",d=>d instanceof M.$QL,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new E("item","A type hierarchy item",d=>d instanceof M.$aN,P.TypeHierarchyItem.from)}static{this.TestItem=new E("testItem","A VS Code TestItem",d=>d instanceof a.$WN,P.TestItem.from)}constructor(d,w,b,L){this.name=d,this.description=w,this.validate=b,this.convert=L}optional(){return new E(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,w){return new E(d??this.name,w??this.description,this.validate,this.convert)}}e.$8N=E;class y{static{this.Void=new y("no result",d=>d)}constructor(d,w){this.description=d,this.convert=w}}e.$9N=y;class ${constructor(d,w,b,L,T){this.id=d,this.internalId=w,this.description=b,this.args=L,this.result=T}}e.$0N=$}),define(Le[271],Me([1,0,18,12,2,86,95,35,31,8,7]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;const k=[new g.$0N("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of DocumentHighlight-instances.",v(D.DocumentHighlight.to))),new g.$0N("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$8N.Uri],new g.$9N("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,a)=>{if((0,S.$Kb)(s))return;class r extends A.$LL{static to(n){const o=new r(n.name,D.SymbolKind.to(n.kind),n.containerName||"",new A.$FL(a[0],D.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=D.Range.to(n.selectionRange),o.children=n.children?n.children.map(r.to):[],o}}return s.map(r.to)})),new g.$0N("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$8N.Uri,new g.$8N("options","Formatting options",s=>!0,s=>s)],new g.$9N("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new g.$0N("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$8N.Uri,g.$8N.Range,new g.$8N("options","Formatting options",s=>!0,s=>s)],new g.$9N("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new g.$0N("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$8N.Uri,g.$8N.Position,new g.$8N("ch","Trigger character",s=>typeof s=="string",s=>s),new g.$8N("options","Formatting options",s=>!0,s=>s)],new g.$9N("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new g.$0N("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$0N("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$0N("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$0N("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of Location or LocationLink instances.",p)),new g.$0N("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of Location-instances.",v(D.location.to))),new g.$0N("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of Hover-instances.",v(D.Hover.to))),new g.$0N("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$8N.Uri,new g.$8N("position","A position in a text document",s=>Array.isArray(s)&&s.every(a=>A.$uL.isPosition(a)),s=>s.map(D.Position.from))],new g.$9N("A promise that resolves to an array of ranges.",s=>s.map(a=>{let r;for(const i of a.reverse())r=new A.$PL(D.Range.to(i),r);return r}))),new g.$0N("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$8N.String.with("query","Search string")],new g.$9N("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(D.WorkspaceSymbol.to))),new g.$0N("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(D.CallHierarchyItem.to))),new g.$0N("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$8N.CallHierarchyItem],new g.$9N("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(D.CallHierarchyIncomingCall.to))),new g.$0N("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$8N.CallHierarchyItem],new g.$9N("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(D.CallHierarchyOutgoingCall.to))),new g.$0N("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:D.Range.to(s.range),placeholder:s.text}})),new g.$0N("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$8N.Uri,g.$8N.Position,g.$8N.String.with("newName","The new symbol name")],new g.$9N("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return D.WorkspaceEdit.to(s)}})),new g.$0N("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$8N.Uri,g.$8N.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$9N("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(D.DocumentLink.to))),new g.$0N("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$8N.Uri],new g.$9N("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$KM(s.tokenTypes,s.tokenModifiers)})),new g.$0N("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$8N.Uri],new g.$9N("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$e_)(s);if(a.type==="full")return new A.$MM(a.data,void 0)})),new g.$0N("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$8N.Uri,g.$8N.Range.optional()],new g.$9N("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$KM(s.tokenTypes,s.tokenModifiers)})),new g.$0N("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$8N.Uri,g.$8N.Range],new g.$9N("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$e_)(s);if(a.type==="full")return new A.$MM(a.data,void 0)})),new g.$0N("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$8N.Uri,g.$8N.Position,g.$8N.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$8N.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$9N("A promise that resolves to a CompletionList-instance.",(s,a,r)=>{if(!s)return new A.$2L([]);const i=s.suggestions.map(n=>D.CompletionItem.to(n,r));return new A.$2L(i,s.incomplete)})),new g.$0N("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$8N.Uri,g.$8N.Position,g.$8N.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$9N("A promise that resolves to SignatureHelp.",s=>{if(s)return D.SignatureHelp.to(s)})),new g.$0N("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$8N.Uri,g.$8N.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$9N("A promise that resolves to an array of CodeLens-instances.",(s,a,r)=>v(i=>new A.$TL(D.Range.to(i.range),i.command&&r.fromInternal(i.command)))(s))),new g.$0N("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$8N.Uri,new g.$8N("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>A.$vL.isRange(s),s=>A.$wL.isSelection(s)?D.Selection.from(s):D.Range.from(s)),g.$8N.String.with("kind","Code action kind to return code actions for").optional(),g.$8N.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$9N("A promise that resolves to an array of Command-instances.",(s,a,r)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(i.command)}else{const n=new A.$NL(i.title,i.kind?new A.$OL(i.kind):void 0);return i.edit&&(n.edit=D.WorkspaceEdit.to(i.edit)),i.command&&(n.command=r.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(s))),new g.$0N("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$8N.Uri],new g.$9N("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(a=>new A.$8L(D.Range.to(a.range),D.Color.to(a.color))):[])),new g.$0N("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$8N("color","The color to show and insert",s=>s instanceof A.$7L,D.Color.from),new g.$8N("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:D.Range.from(s.range)}))],new g.$9N("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(D.ColorPresentation.to):[])),new g.$0N("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$8N.Uri,g.$8N.Range],new g.$9N("A promise that resolves to an array of Inlay objects",(s,a,r)=>s.map(D.InlayHint.to.bind(void 0,r)))),new g.$0N("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$8N.Uri],new g.$9N("A promise that resolves to an array of FoldingRange objects",(s,a)=>{if(s)return s.map(D.FoldingRange.to)})),new g.$0N("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$9N("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(a=>D.NotebookExclusiveDocumentPattern.to(a))})))),new g.$0N("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$8N.Uri,g.$8N.Range,new g.$8N("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof A.$vL,s=>D.InlineValueContext.from(s))],new g.$9N("A promise that resolves to an array of InlineValue objects",s=>s.map(D.InlineValue.to))),new g.$0N("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$8N("uriOrString","Uri-instance or string (only http/https)",s=>P.URI.isUri(s)||typeof s=="string"&&(0,M.$jg)(s,M.Schemas.http,M.Schemas.https),s=>s),new g.$8N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional(),g.$8N.String.with("label","").optional()],g.$9N.Void),new g.$0N("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$8N.Uri.with("resource","Resource to open"),g.$8N.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$8N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional()],g.$9N.Void),new g.$0N("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$8N.Uri.with("left","Left-hand side resource of the diff editor"),g.$8N.Uri.with("right","Right-hand side resource of the diff editor"),g.$8N.String.with("title","Human readable title for the diff editor").optional(),new g.$8N("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)]).optional()],g.$9N.Void),new g.$0N("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$8N.String.with("title","Human readable title for the changes editor"),new g.$8N("resourceList","List of resources to compare",s=>{for(const a of s){if(a.length!==3)return!1;const[r,i,n]=a;if(!P.URI.isUri(r)||!P.URI.isUri(i)&&i!==void 0&&i!==null||!P.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],g.$9N.Void),new g.$0N("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$8N.Uri,g.$8N.Position],new g.$9N("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new g.$0N("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$8N.TypeHierarchyItem],new g.$9N("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new g.$0N("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$8N.TypeHierarchyItem],new g.$9N("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new g.$0N("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$8N.TestItem],g.$9N.Void),new g.$0N("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$8N.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$9N.Void),new g.$0N("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$8N.String.with("name","The context key name"),new g.$8N("value","The context key value",()=>!0,s=>s)],g.$9N.Void),new g.$0N("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$8N.Uri,g.$8N.StringArray,new g.$8N("MappedEditsContext","Mapped Edits Context",s=>D.MappedEditsContext.is(s),s=>D.MappedEditsContext.from(s))],new g.$9N("A promise that resolves to a workspace edit or null",s=>s?D.WorkspaceEdit.to(s):null))];class l{static register(a){k.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",m.$0i)}}e.$4gc=l;function v(s){return a=>{if(Array.isArray(a))return a.map(s)}}function p(s){if(!Array.isArray(s))return;const a=[];for(const r of s)N.$Lt(r)?a.push(D.DefinitionLink.to(r)):a.push(D.location.to(r));return a}}),define(Le[272],Me([1,0,11,6,2,3,31,8,7]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class D{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=D.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class k{static{this.a=0}constructor(v,p,s,a){this.f=s,this.g=a,this.b=new Map,this.d=new Map,this.e=v.getProxy(N.$rL.MainThreadInlineChat),p.registerApiCommand(new R.$0N("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$8N("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?m.Range.from(r.initialRange):void 0,initialSelection:g.$wL.isSelection(r.initialSelection)?m.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?m.Position.from(r.position):void 0}})],R.$9N.Void))}registerProvider(v,p,s){const a=new D(v,p);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,s?.label??v.displayName??v.name,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",s?.supportReportIssue??!1),(0,M.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(v,p,s,a){const r=this.b.get(v);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(P.URI.revive(p)),n=m.Selection.to(s),o=await r.provider.prepareInteractiveEditorSession({document:i,selection:n},a);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new A(o)),{id:h,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,p,s,a){const r=this.b.get(v);if(!r)return;const i=this.d.get(p.id);if(!i)return;const n={prompt:s.prompt,selection:m.Selection.to(s.selection),wholeRange:m.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(P.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let o=!1;const h={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||a.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(m.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:g.$UL.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(i.session,n,h,a));let f;try{f=await(0,S.$Yg)(t,a)}finally{o=!0}if(!f)return;const c=i.responses.push(f)-1,u={wholeRange:m.Range.from(f.wholeRange),placeholder:f.placeholder};if(!k.h(f))return{...u,id:c,type:"editorEdit",message:m.MarkdownString.from(f.contents),edits:[]};const{edits:E,contents:y}=f,$=y!==void 0?m.MarkdownString.from(y):void 0;return E instanceof g.$DL?{...u,id:c,type:"bulkEdit",edits:m.WorkspaceEdit.from(E),message:$}:{...u,id:c,type:"editorEdit",edits:E.map(m.TextEdit.from),message:$}}async $provideFollowups(v,p,s,a){const r=this.b.get(v),i=this.d.get(p),n=i?.responses[s];if(r&&n&&r.provider.provideFollowups){const o=Promise.resolve(r.provider.provideFollowups(i.session,n,a));return(await(0,S.$Yg)(o,a))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(v,p,s,a){const r=this.b.get(v),i=this.d.get(p),n=i?.responses[s];if(r&&n){const o=m.InteractiveEditorResponseFeedbackKind.to(a);r.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(v,p){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$_hc=k}),define(Le[273],Me([1,0,2,31]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class P{constructor(R,m,g,D,A){this.a=m,this.b=g,this.c=D;const k=new M.$0N("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$8N("showOptions","Show Options",l=>!0,l=>l),new M.$8N("resource","Interactive resource Uri",l=>!0,l=>l),new M.$8N("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$8N("title","Interactive editor title",l=>!0,l=>l)],new M.$9N("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const v=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,m,g,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(S.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$mic=P}),define(Le[274],Me([1,0,18,11,21,5,6,28,2,22,14,3,31,8,7,76,211,25,50,212]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=e.$uic=void 0;let o=class{constructor($,I,d,w,b){this.m=I,this.n=d,this.o=w,this.q=b,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new N.$Yd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(k.$rL.MainThreadNotebookKernels);const L=new l.$0N("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$8N("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const Y=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:Y}}else if(T&&"notebookEditor"in T){const Y=this.n.getIdByEditor(T.notebookEditor);if(Y===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:Y}}return T})],l.$9N.Void);this.o.registerApiCommand(L)}createNotebookController($,I,d,w,b,L){for(const $e of this.j.values())if($e.controller.id===I&&D.$qm.equals($.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const T=this.k++,Y=this;this.q.trace(`NotebookController[${T}], CREATED by ${$.identifier.value}, ${I}`);const q=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${$.identifier}'`);let U=!1;const C=new N.$Yd,F=new N.$Yd,W={id:E($.identifier,I),notebookType:d,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:w||$.identifier.value,preloads:L?L.map(v.NotebookRendererScript.from):[]};let re=b??q,ue,ye;this.a.$addKernel(T,W).catch($e=>{console.log($e),U=!0});let ke=0;const he=()=>{if(U)return;const $e=++ke;Promise.resolve().then(()=>{$e===ke&&this.a.$updateKernel(T,W)})},ve=new m.$Ac,se={get id(){return I},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return W.label},set label($e){W.label=$e??$.displayName??$.name,he()},get detail(){return W.detail??""},set detail($e){W.detail=$e,he()},get description(){return W.description??""},set description($e){W.description=$e,he()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages($e){W.supportedLanguages=$e,he()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder($e){W.supportsExecutionOrder=$e,he()},get rendererScripts(){return W.preloads?W.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler($e){re=$e??q},get interruptHandler(){return ue},set interruptHandler($e){ue=$e,W.supportsInterrupt=!!$e,he()},set variableProvider($e){(0,r.$OF)($,"notebookVariableProvider"),ye=$e,W.hasVariableProvider=!!$e,$e?.onDidChangeVariables(te=>Y.a.$variablesUpdated(te.uri)),he()},get variableProvider(){return ye},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw Y.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return Y._createNotebookCellExecution($e,E($.identifier,this.id))},createNotebookExecution($e){if((0,r.$OF)($,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw Y.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return Y._createNotebookExecution($e,E($.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${T}], DISPOSED`),U=!0,this.j.delete(T),C.dispose(),F.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity($e,te){te===p.NotebookControllerAffinity2.Hidden&&(0,r.$OF)($,"notebookControllerAffinityHidden"),Y.a.$updateNotebookPriority(T,$e.uri,te)},onDidReceiveMessage:F.event,postMessage($e,te){return(0,r.$OF)($,"notebookMessaging"),Y.a.$postMessage(T,te&&Y.n.getIdByEditor(te),$e)},asWebviewUri($e){return(0,r.$OF)($,"notebookMessaging"),(0,s.$1wb)($e,Y.m.remote)}};return this.j.set(T,{extensionId:$.identifier,controller:se,onDidReceiveMessage:F,onDidChangeSelection:C,associatedNotebooks:ve}),se}getIdByController($){for(const[I,d]of this.j)if(d.controller===$)return E(d.extensionId,$.id);return null}createNotebookControllerDetectionTask($,I){const d=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${d}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(d,I);const b={dispose:()=>{this.f.delete(d),w.a.$removeKernelDetectionTask(d)}};return this.f.set(d,b),b}registerKernelSourceActionProvider($,I,d){const w=this.i++,b=typeof d.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,L=this;this.h.set(w,d),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,I);let T;return b!==void 0&&(T=d.onDidChangeNotebookKernelSourceActions(Y=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(w),L.a.$removeKernelSourceActionProvider(w,w),T?.dispose()}}}async $provideKernelSourceActions($,I){const d=this.h.get($);if(d){const w=new R.$Sc;return(await d.provideNotebookKernelSourceActions(I)??[]).map(L=>v.NotebookKernelSourceAction.from(L,this.o.converter,w))}return[]}$acceptNotebookAssociation($,I,d){const w=this.j.get($);if(w){const b=this.n.getNotebookDocument(g.URI.revive(I));d?w.associatedNotebooks.set(b.uri,!0):w.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,b.uri.toString(),d),w.onDidChangeSelection.fire({selected:d,notebook:b.apiNotebook})}}async $executeCells($,I,d){const w=this.j.get($);if(!w)return;const b=this.n.getNotebookDocument(g.URI.revive(I)),L=[];for(const T of d){const Y=b.getCell(T);Y&&L.push(Y.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,b.uri.toString(),L.length),await w.controller.executeHandler.call(w.controller,L,b.apiNotebook,w.controller)}catch(T){this.q.error(`NotebookController[${$}] execute cells FAILED`,T),console.error(T)}}async $cancelCells($,I,d){const w=this.j.get($);if(!w)return;const b=this.n.getNotebookDocument(g.URI.revive(I));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,b.apiNotebook);else for(const L of d){const T=b.getCell(L);T&&this.b.get(T.uri)?.cancel()}if(w.controller.interruptHandler){const L=this.c.get(b.uri);d.length&&Array.isArray(L)&&L.length&&L.forEach(T=>T.dispose())}}async $provideVariables($,I,d,w,b,L,T){const Y=this.j.get($);if(!Y)return;const q=this.n.getNotebookDocument(g.URI.revive(d)),U=Y.controller.variableProvider;if(!U)return;let C;if(w!==void 0){if(C=this.s[w],!C)return}else this.s={};const F=b==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,W=U.provideVariables(q.apiNotebook,C,F,L,T);let re=0;for await(const ue of W){if(T.isCancellationRequested)return;const ye={id:this.r++,name:ue.variable.name,value:ue.variable.value,type:ue.variable.type,hasNamedChildren:ue.hasNamedChildren,indexedChildrenCount:ue.indexedChildrenCount,extensionId:Y.extensionId.value};if(this.s[ye.id]=ue.variable,this.a.$receiveVariable(I,ye),re++>=n.$5fb)return}}$acceptKernelMessageFromRenderer($,I,d){const w=this.j.get($);if(!w)return;const b=this.n.getEditorById(I);w.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:d}))}$cellExecutionChanged($,I,d){const b=this.n.getNotebookDocument(g.URI.revive($)).getCell(I);if(b){const L=d?v.NotebookCellExecutionState.to(d):p.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:b.apiCell,state:L})}}_createNotebookCellExecution($,I){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const b=new t(I,w,this.a);this.b.set(w.uri,b);const L=b.onDidChangeState(()=>{b.state===h.Resolved&&(b.dispose(),L.dispose(),this.b.delete(w.uri))});return b.asApiObject()}_createNotebookExecution($,I){const d=this.n.getNotebookDocument($.uri),w=$.getCells().find(T=>{const Y=d.getCellFromApiCell(T);return Y&&this.b.has(Y.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(d.uri))throw new Error(`duplicate notebook execution for ${d.uri}`);const b=new c(I,d,this.a),L=b.onDidChangeState(()=>{b.state===f.Resolved&&(b.dispose(),L.dispose(),this.c.delete(d.uri))});return this.c.set(d.uri,[b,L]),b.asApiObject()}};e.$uic=o,e.$uic=o=Je([qe(4,A.$sj)],o);var h;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(h||(h={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,d){super(),this.m=I,this.n=d,this.b=t.a++,this.c=new N.$Yd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new P.$9d),this.h=new u(10,w=>this.s(w)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const I=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new i.$Yv(I))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let I=this.m;if($&&(I=this.m.notebook.getCellFromApiCell($)),!I)throw new Error("INVALID cell");return I.handle}y($){return $.map(I=>{const d=p.$XM.ensureUniqueMimeTypes(I.items,!0);return d===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:d,id:I.id,metadata:I.metadata})})}async z($,I,d){const w=this.w(I),b=this.y((0,S.$3b)($));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:w,append:d,outputs:b})}async C($,I,d){return $=p.$XM.ensureUniqueMimeTypes((0,S.$3b)($),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:$.map(v.NotebookCellOutputItem.from),outputId:I.id,append:d})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(d){$.j=d,$.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(d){if($.f===h.Resolved||$.f===h.Started)throw new Error("Cannot call start again");$.f=h.Started,$.c.fire(),$.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,w){if($.f===h.Resolved)throw new Error("Cannot call resolve twice");$.f=h.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new i.$Yv({runEndTime:w,lastRunSuccess:d}))},clearOutput(d){return $.t(),$.z([],d,!1)},appendOutput(d,w){return $.t(),$.z(d,w,!0)},replaceOutput(d,w){return $.t(),$.z(d,w,!1)},appendOutputItems(d,w){return $.t(),$.C(d,w,!0)},replaceOutputItems(d,w){return $.t(),$.C(d,w,!1)}})}}var f;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(f||(f={}));class c extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,d){super(),this.h=I,this.j=d,this.b=c.a++,this.c=new N.$Yd,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new P.$9d),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor($,I){this.f=$,this.g=I,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new M.$vh,this.b=Date.now(),(0,M.$_g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>$.complete())}}function E(y,$){return`${y.value}/${$}`}e.$vic=E}),define(Le[65],Me([1,0,5,3,4,2,17,6,7,167,15,195,21,33,196,40,11,8,31]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=e.$Hhc=e.$Ghc=void 0,e.$Ghc=(0,P.$$h)("IExtHostTerminalService");class n{constructor(d,w,b,L){this.l=d,this._id=w,this.m=b,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(Y=>this.f=Y);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(Y,q=!0){T.q(),T.l.$sendText(T._id,Y,q)},show(Y){T.q(),T.l.$show(T._id,Y)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(d,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??w?.cwd??void 0,env:d.env??void 0,icon:E(d.iconPath)??void 0,color:s.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(d.location,w?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,w,b,L,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:L,color:s.ThemeColor.isThemeColor(T)?T.id:void 0,location:w?.location||this.o(d,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,w){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in d?{viewColumn:r.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,w){this.h=Object.freeze({code:d,reason:w})}setDimensions(d,w){return d===this.d&&w===this.g||d===0||w===0?!1:(this.d=d,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(w=>{w!==d&&(this.b=Promise.resolve(d))})}}e.$Hhc=n;class o{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new S.$Yd,this.onProcessData=this.a.event,this.b=new S.$Yd,this.d=new S.$Yd,this.onDidChangeProperty=this.d.event,this.f=new S.$Yd,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,w){this.g.setDimensions?.({columns:d,rows:w})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,w,b){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$Yd,this.onDidCloseTerminal=this.H.event,this.I=new S.$Yd,this.onDidOpenTerminal=this.I.event,this.J=new S.$Yd,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$Yd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$Yd,this.onDidChangeTerminalState=this.M.event,this.N=new S.$Yd,this.onDidChangeShell=this.N.event,this.O=new S.$Yd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$Yd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(M.$rL.MainThreadTerminalService),this.y=new p.$$sb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:L=>{const T=Y=>{const q=Y;return this.W(q.instanceId)?.value};switch(L?.$mid){case 15:return T(L);default:{if(Array.isArray(L))for(let Y=0;Y<L.length&&L[Y].$mid===15;Y++)L[Y]=T(L[Y]);return L}}}}),this.B({dispose:()=>{for(const[L,T]of this.g)T.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,w){const b=new n(this.a,(0,v.$ug)(),d,d.name),L=new o(d.pty);return b.createExtensionTerminal(d.location,w,this.R(d,w).resolvedExtHostIdentifier,E(d.iconPath),y(d.color)).then(T=>{const Y=this.S(T,L);this.h[T]=Y}),this.f.push(b),b.value}R(d,w){if(w=w||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const b=d.location.parentTerminal;if(b){const L=this.f.find(T=>T.value===b);L&&(w.resolvedExtHostIdentifier=L._id)}}else d.location&&typeof d.location!="object"?w.location=d.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(d,w){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const L=new o(w),T=this.S(d,L);this.h[d]=T}async $acceptActiveTerminalChanged(d){const w=this.b;if(d===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const b=this.W(d);b&&(this.b=b,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,w){const b=this.W(d);b&&this.O.fire({terminal:b.value,data:w})}async $acceptTerminalDimensions(d,w,b){const L=this.W(d);L&&L.setDimensions(w,b)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(d,w){const b=this.W(d);b&&this.P.fire({terminal:b.value,...w})}async $acceptTerminalMaximumDimensions(d,w,b){this.g.get(d)?.resize(w,b)}async $acceptTerminalTitleChange(d,w){const b=this.W(d);b&&(b.name=w)}async $acceptTerminalClosed(d,w,b){const L=this.Y(this.f,d);if(L!==null){const T=this.f.splice(L,1)[0];T.setExitStatus(w,b),this.H.fire(T.value)}}$acceptTerminalOpened(d,w,b,L){if(w){const q=this.Y(this.f,w);if(q!==null){this.f[q]._id=d,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const T={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:N.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},Y=new n(this.a,d,T,b);this.f.push(Y),this.I.fire(Y.value),Y.isOpen=!0}async $acceptTerminalProcessId(d,w){this.W(d)?._setProcessId(w)}async $startExtensionTerminal(d,w){const b=this.W(d);if(!b)return{message:(0,D.localize)(0,null,d)};b.isOpen||await new Promise(T=>{const Y=this.onDidOpenTerminal(async q=>{q===b.value&&(Y.dispose(),T())})});const L=this.g.get(d);L?L.startSendingEvents(w):this.j[d]={initialDimensions:w}}S(d,w){const b=new m.$Sc;b.add(w.onProcessReady(T=>this.a.$sendProcessReady(d,T.pid,T.cwd,T.windowsPty))),b.add(w.onDidChangeProperty(T=>this.a.$sendProcessProperty(d,T))),this.y.startBuffering(d,w.onProcessData),b.add(w.onProcessExit(T=>this.U(d,T))),this.g.set(d,w);const L=this.j[d];return L&&w instanceof o&&(w.startSendingEvents(L.initialDimensions),delete this.j[d]),b}$acceptProcessAckDataEvent(d,w){this.g.get(d)?.acknowledgeDataEvent(w)}$acceptProcessInput(d,w){this.g.get(d)?.input(w)}$acceptTerminalInteraction(d){const w=this.W(d);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(d,w){this.W(d)?.setSelection(w)}$acceptProcessResize(d,w,b){try{this.g.get(d)?.resize(w,b)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(d,w){this.g.get(d)?.shutdown(w)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(w=>this.a.$sendProcessProperty(d,{type:"cwd",value:w}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new g.$tL(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,w,b){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,b),this.a.$registerProfileProvider(w,d.identifier.value),new g.$tL(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(d,w,b){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,b),this.a.$registerQuickFixProvider(d,w),new g.$tL(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,w){const b=new l.$9d().token;if(b.isCancellationRequested)return;const L=this.D.get(d);if(!L)return;const T=await L.provideTerminalQuickFixes(w,b);if(T===null||Array.isArray(T)&&T.length===0)return;const Y=new m.$Sc;if(this.w.value=Y,!Array.isArray(T))return T?r.TerminalQuickFix.from(T,this.Q.converter,Y):void 0;const q=[];for(const U of T){const C=r.TerminalQuickFix.from(U,this.Q.converter,Y);C&&q.push(C)}return q}async $createContributedProfileTerminal(d,w){const b=new l.$9d().token;let L=await this.C.get(d)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,w);return}this.createTerminalFromOptions(L.options,w)}}async $provideLinks(d,w){const b=this.W(d);if(!b)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const T=new l.$9d;this.G.set(d,T);const Y=[],q={terminal:b.value,line:w},U=[];for(const W of this.z)U.push(a.Promises.withAsyncBody(async re=>{T.token.onCancellationRequested(()=>re({provider:W,links:[]}));const ue=await W.provideTerminalLinks(q,T.token)||[];T.token.isCancellationRequested||re({provider:W,links:ue})}));const C=await Promise.all(U);if(T.token.isCancellationRequested)return[];const F=new Map;for(const W of C)W&&W.links.length>0&&Y.push(...W.links.map(re=>{const ue={id:h++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return F.set(ue.id,{provider:W.provider,link:re}),ue}));return this.F.set(d,F),Y}$activateLink(d,w){const b=this.F.get(d)?.get(w);b&&b.provider.handleTerminalLink(b.link)}U(d,w){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const b=this.h[d];b&&(b.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,w)}W(d){return this.X(this.f,d)}X(d,w){const b=this.Y(d,w);return b!==null?d[b]:null}Y(d,w){const b=d.findIndex(L=>L._id===w);return b===-1?null:b}getEnvironmentVariableCollection(d){let w=this.n.get(d.identifier.value);return w||(w=new f,this.$(d.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(d,w){const b=(0,k.$Rr)(w.map),L=(0,k.$Sr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(d,w.persistent,b.length===0?void 0:b,L)}$initEnvironmentVariableCollections(d){d.forEach(w=>{const b=w[0],L=new f(w[1]);this.$(b,L)})}$acceptDefaultProfile(d,w){const b=this.s;this.s=d,this.u=w,b?.path!==d.path&&this.N.fire(d.path)}$(d,w){this.n.set(d,w),w.onDidChangeCollection(()=>{this.Z(d,w)})}};e.$Ihc=t,e.$Ihc=t=Je([qe(1,i.$6N),qe(2,R.$JN)],t);class f{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$Yd,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const w=this.h(d);let b=this.a.get(w);return b||(b=new c(this,d),this.a.set(w,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(d,w,b,L){this.f(d,{value:w,type:g.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:L})}append(d,w,b,L){this.f(d,{value:w,type:g.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:L})}prepend(d,w,b,L){this.f(d,{value:w,type:g.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:L})}f(d,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(d,w.scope),L=this.map.get(b),T=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==w.value||L.type!==w.type||L.options?.applyAtProcessCreation!==T.applyAtProcessCreation||L.options?.applyAtShellIntegration!==T.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const Y=this.g(d,w.scope),q={variable:d,...w,options:T};this.map.set(Y,q),this.d.fire()}}get(d,w){const b=this.g(d,w),L=this.map.get(b);return L?$(L):void 0}g(d,w){const b=this.h(w);return b.length?`${d}:::${b}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const w=new Map;for(const[b,L]of this.map)this.h(L.scope)===this.h(d)&&w.set(L.variable,$(L));return w}delete(d,w){const b=this.g(d,w);this.map.delete(b),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[w,b]of this.map)b.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(w);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,w){const b=this.h(w),L=this.descriptionMap.get(b);if(!L||L.description!==d){let T;typeof d=="string"?T=d:T=d?.value.split(`

`)[0];const Y={description:T,scope:w};this.descriptionMap.set(b,Y),this.d.fire()}}getDescription(d){const w=this.h(d);return this.descriptionMap.get(w)?.description}k(d){const w=this.h(d);this.descriptionMap.delete(w)}}class c{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,w){this.b=d,this.d=w,this.a=new S.$Yd}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,w,b){this.b.replace(d,w,b,this.d)}append(d,w,b){this.b.append(d,w,b,this.d)}prepend(d,w,b){this.b.prepend(d,w,b,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,w){this.b.getVariableMap(this.d).forEach((b,L)=>d.call(w,L,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(d,w){super(!1,d,w)}createTerminal(d,w,b){throw new A.$_}createTerminalFromOptions(d,w){throw new A.$_}};e.$Jhc=u,e.$Jhc=u=Je([qe(0,i.$6N),qe(1,R.$JN)],u);function E(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function y(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function $(I){const d={...I};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Le[275],Me([1,0,11,23,21,5,246,97,6,26,16,33,14,3,17,111,8,7,49,75,59,25]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=e.$Nic=e.$Mic=void 0;let t=class extends g.$Tc{constructor(U,C,F,W){super(),this.w=W,this.f=this.B(new N.$Yd),this.g=new Map,this.s=this.B(new N.$Yd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(v.$rL.MainThreadTesting),this.m=new b(this.h),this.j=new E(this.h,C),F.registerArgumentProcessor({processArgument:re=>{switch(re?.$mid){case 16:{const ue=re,ye=ue.tests[ue.tests.length-1].item.extId;return this.g.get(i.$iK.root(ye))?.collection.tree.get(ye)?.actual??(0,s.$VN)(re)}case 18:{const{extId:ue,message:ye}=re;return{test:this.g.get(i.$iK.root(ue))?.collection.tree.get(ue)?.actual,message:a.TestMessage.to(ye)}}default:return re}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const re=await F.executeCommand("_testing.getExplorerSelection"),ue=ye=>{const ke=this.g.get(i.$iK.root(ye));if(ke)return i.$iK.isRoot(ye)?ke.controller:ke.collection.tree.get(ye)?.actual};return{include:re?.include.map(ue).filter(A.$Uf)||[],exclude:re?.exclude.map(ue).filter(A.$Uf)||[]}})}createTestController(U,C,F,W){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const re=new g.$Sc,ue=re.add(new s.$YN(C,F,this.w));ue.root.label=F;const ye=new Map,ke=new Set,he=this.h,ve={items:ue.root.children,get label(){return F},set label($e){F=$e,ue.root.label=$e,he.$updateController(C,{label:F})},get refreshHandler(){return W},set refreshHandler($e){W=$e,he.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,te,X,V,ne,Ce)=>{let Fe=(0,m.$Yi)($e);for(;ye.has(Fe);)Fe++;return new T(this.h,ye,ke,this.s.event,C,Fe,$e,te,X,V,ne,Ce)},createTestItem($e,te,X){return new s.$WN(C,$e,te,X)},createTestRun:($e,te,X=!0)=>this.j.createTestRun(U,C,ue,$e,te,X),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const te=$e instanceof Array?$e:[$e];this.h.$markTestRetired(te.map(X=>i.$iK.fromExtHostTestItem(X,C).toString()))}},set resolveHandler($e){ue.resolveHandler=$e},get resolveHandler(){return ue.resolveHandler},dispose:()=>{re.dispose()}};he.$registerTestController(C,F,!!W),re.add((0,g.$Rc)(()=>he.$unregisterTestController(C)));const se={controller:ve,collection:ue,profiles:ye,extension:U,activeProfiles:ke};return this.g.set(C,se),re.add((0,g.$Rc)(()=>this.g.delete(C))),re.add(ue.onDidGenerateDiff($e=>he.$publishDiff(C,$e.map(o.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=P.CancellationToken.None){const F=y(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(F.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(re=>i.$iK.fromExtHostTestItem(re,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:Y[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(re=>re.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,F){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(F)??[]}async $resolveFileCoverage(U,C,F,W){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(F,W)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[F,W]of Object.entries(U)){const re=this.g.get(F);if(!re)continue;const ue=new Map,ye=W.filter(he=>!re.activeProfiles.has(he)),ke=[...re.activeProfiles].filter(he=>!W.includes(he));for(const he of ye)ue.set(he,!0),re.activeProfiles.add(he);for(const he of ke)ue.set(he,!1),re.activeProfiles.delete(he);ue.size&&C.set(F,ue)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,D.$Cn)(a.TestResults.to(C))).concat(this.results).sort((C,F)=>F.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const F=this.g.get(i.$iK.fromString(U).controllerId)?.collection;F&&(await F.expand(U,C<0?1/0:C),F.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>o.TestsDiffOp.deserialize({asCanonicalUri:F=>F},C)))}async $runControllerTests(U,C){return Promise.all(U.map(F=>this.y(F,!1,C)))}async $startContinuousRun(U,C){const F=new P.$9d(C),W=await Promise.all(U.map(re=>this.y(re,!0,F.token)));return!C.isCancellationRequested&&!W.some(re=>re.error)&&await new Promise(re=>C.onCancellationRequested(re)),F.dispose(!0),W}async y(U,C,F){const W=this.g.get(U.controllerId);if(!W)return{};const{collection:re,profiles:ue,extension:ye}=W,ke=ue.get(U.profileId);if(!ke)return{};const he=U.testIds.map(te=>re.tree.get(te)).filter(A.$Uf),ve=U.excludeExtIds.map(te=>W.collection.tree.get(te)).filter(A.$Uf).filter(te=>he.some(X=>X.fullId.compare(te.fullId)===2));if(!he.length)return{};const se=new r.$5M(he.some(te=>te.actual instanceof s.$XN)?void 0:he.map(te=>te.actual),ve.map(te=>te.actual),ke,C),$e=(0,o.$kK)(U)&&this.j.prepareForMainThreadTestRun(se,$.fromInternal(U,W.collection),ye,F);try{return await ke.runHandler(se,F),{}}catch(te){return{error:String(te)}}finally{$e&&($e.hasRunningTasks&&!F.isCancellationRequested&&await N.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Mic=t,e.$Mic=t=Je([qe(0,p.$JN),qe(1,l.$sj)],t);const f=1e4;var c;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(c||(c={}));class u extends g.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,F,W,re){super(),this.s=U,this.w=C,this.y=F,this.z=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new N.$Yd),this.m=this.B(new N.$Yd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new P.$9d(re));const ue=this.B(new S.$kh(()=>this.C(),f));this.B(this.h.token.onCancellationRequested(()=>ue.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,F=this.s.controllerId,W=(0,k.$ug)(),re=this.y,ue=this.m;let ye;const ke=$e=>(te,...X)=>{if(ve){this.z.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.s.isIncluded(te)&&(this.F(te),$e(te,...X))},he=($e,te)=>{const X=te instanceof Array?te.map(a.TestMessage.from):[a.TestMessage.from(te)];if($e.uri&&$e.range){const V={range:a.Range.from($e.range),uri:$e.uri};for(const ne of X)ne.location=ne.location||V}this.w.$appendTestMessagesInRun(C,W,i.$iK.fromExtHostTestItem($e,F).toString(),X)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,h.$OF)(re,"testCoverage"),ye=$e&&new I($e),ue.fire({taskId:W,runId:C,coverage:ye})},enqueued:ke($e=>{this.w.$updateTestStateInRun(C,W,i.$iK.fromExtHostTestItem($e,F).toString(),1)}),skipped:ke($e=>{this.w.$updateTestStateInRun(C,W,i.$iK.fromExtHostTestItem($e,F).toString(),5)}),started:ke($e=>{this.w.$updateTestStateInRun(C,W,i.$iK.fromExtHostTestItem($e,F).toString(),2)}),errored:ke(($e,te,X)=>{he($e,te),this.w.$updateTestStateInRun(C,W,i.$iK.fromExtHostTestItem($e,F).toString(),6,X)}),failed:ke(($e,te,X)=>{he($e,te),this.w.$updateTestStateInRun(C,W,i.$iK.fromExtHostTestItem($e,F).toString(),4,X)}),passed:ke(($e,te)=>{this.w.$updateTestStateInRun(C,W,i.$iK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,te)}),appendOutput:($e,te,X)=>{ve||(X&&(this.s.isIncluded(X)?this.F(X):X=void 0),this.w.$appendOutputToRun(C,W,M.$me.fromString($e),te&&a.location.from(te),X&&i.$iK.fromExtHostTestItem(X,F).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,W),this.f.delete(W),this.f.size||this.D())}};return this.f.set(W,{run:se}),this.w.$startedTestRunTask(C,{id:W,name:U,running:!0}),se}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$WN))throw new n.$BN(U.id);if(this.g.has(i.$iK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],F=this.s.colllection.root;for(;;){const W=a.TestItem.from(U);if(C.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),U===F))break;U=U.parent||F}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class E{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(F=>F.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,F,W){return this.j(U,C,F,W)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,F,W,re,ue){const ye=this.c.get(W);if(ye)return ye.createRun(re);const ke=$.fromPublic(C,F,W,ue),he=y(W);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!W.continuous,profile:he&&{group:Y[he.kind],id:he.profileId},exclude:W.exclude?.map(se=>i.$iK.fromExtHostTestItem(se,F.root.id).toString())??[],id:ke.id,include:W.include?.map(se=>i.$iK.fromExtHostTestItem(se,F.root.id).toString())??[F.root.id],persist:ue});const ve=this.j(W,ke,U);return N.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(ke.id),ve.dispose()}),ve.createRun(re)}j(U,C,F,W){const re=new u(C,this.g,F,this.h,W);this.c.set(U,re);let ue;const ye=re.onDidCoverage(({runId:ke,taskId:he,coverage:ve})=>{ue||(ue={runId:ke,coverage:new Map},this.f.unshift(ue),this.f.length>o.$pK&&this.f.pop()),ue.coverage.set(he,ve),this.g.$signalCoverageAvailable(ke,he,!!ve)});return N.Event.once(re.onEnd)(()=>{this.c.delete(U),ye.dispose()}),re}}e.$Nic=E;const y=q=>{if(q.profile){if(!(q.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class ${static fromPublic(U,C,F,W){return new $(U,(0,k.$ug)(),F.include?.map(re=>i.$iK.fromExtHostTestItem(re,U).toString())??[U],F.exclude?.map(re=>i.$iK.fromExtHostTestItem(re,U).toString())??[],W,C)}static fromInternal(U,C){return new $(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,F,W,re,ue){this.controllerId=U,this.id=C,this.isPersisted=re,this.colllection=ue,this.c=F.map(ye=>ye+"\0"),this.f=W.map(ye=>ye+"\0")}isIncluded(U){const C=i.$iK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.f)if(C===F||C.startsWith(F))return!1;for(const F of this.c)if(C===F||C.startsWith(F))return!0;return!1}}e.$Oic=$;class I{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const F=await this.c;let W=F?.[U];return!this.provider||!F||!W?[]:(W.detailedCoverage||(W=F[U]=await this.provider.resolveFileCoverage?.(W,C)??W),W.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=i.$iK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:F}=this;return{get added(){return[...U].map(W=>W.revived)},get updated(){return[...C].map(W=>W.revived)},get removed(){return[...F].map(W=>W.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends o.$qK{constructor(){super(...arguments),this.s=new N.$Yd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:a.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new d(this.s)}}class b{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new w({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const L=(q,U,C,F)=>{C?Object.assign(C,F):U.$updateTestRunConfig(q.controllerId,q.profileId,F)};class T{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,L(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,L(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),L(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,L(this,this.#e,this.#n,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,L(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return N.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(A.$Uf))}constructor(U,C,F,W,re,ue,ye,ke,he,ve=!1,se=void 0,$e=!1){this.controllerId=re,this.profileId=ue,this.f=ye,this.kind=ke,this.runHandler=he,this._tag=se,this.g=$e,this.#e=U,this.#s=C,this.#t=F,this.#i=W,C.set(ue,this);const te=Y[ke];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${ke}`);ve&&F.add(ue),this.#n={profileId:ue,controllerId:re,tag:se?a.TestTag.namespace(this.controllerId,se.id):null,label:ye,group:te,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Pic=T;const Y={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Le[112],Me([1,0,54,15,88,8,7]),function(fe,e,S,M,P,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=e.$RN=e.$QN=void 0;class m{static{this.c=new P.$ON("TextEditorDecorationType")}constructor(l,v,p){const s=m.c.nextId();l.$registerTextEditorDecorationType(v.identifier,s,N.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$QN=m;class g{constructor(l,v){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,v){this.k();let p=null;if(l instanceof R.$uL)p=new R.$vL(l,l);else if(l instanceof R.$vL)p=l;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(l,v){this.k(),this.l(new R.$vL(l,l),v,!0)}delete(l){this.k();let v=null;if(l instanceof R.$vL)v=l;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(l,v,p){const s=this.c.validateRange(l);this.g.push({range:s,text:v,forceMoveMarkers:p})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class D{constructor(l,v,p,s){this.c=l,this.d=v,this._accept(p),this.e=s;const a=this;this.value={get tabSize(){return a.f},set tabSize(r){a.n(r)},get indentSize(){return a.g},set indentSize(r){a.p(r)},get insertSpaces(){return a.j},set insertSpaces(r){a.s(r)},get cursorStyle(){return a.k},set cursorStyle(r){a.t(r)},get lineNumbers(){return a.l},set lineNumbers(r){a.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=N.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const v=Math.floor(l);return v>0?v:null}if(typeof l=="string"){const v=parseInt(l,10);return isNaN(v)?null:v>0?v:null}return null}n(l){const v=this.m(l);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const v=Math.floor(l);return v>0?v:null}if(typeof l=="string"){const v=parseInt(l,10);return isNaN(v)?null:v>0?v:null}return null}p(l){const v=this.o(l);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const v=this.q(l);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:N.TextEditorLineNumbersStyle.from(l)})))}assign(l){const v={};let p=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(p=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,p=!0,v.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(p=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,p=!0,v.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(p=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,p=!0,v.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,p=!0,v.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,p=!0,v.lineNumbers=N.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(l,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(p)})}}e.$RN=D;class A{constructor(l,v,p,s,a,r,i,n){this.id=l,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=a,this.d=new D(this.j,this.id,r,p),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new M.$9("document")},get selection(){return o.c&&o.c[0]},set selection(h){if(!(h instanceof R.$wL))throw(0,M.$7)("selection");o.c=[h],o.l()},get selections(){return o.c},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof R.$wL)))throw(0,M.$7)("selections");o.c=h,o.l()},get visibleRanges(){return o.e},set visibleRanges(h){throw new M.$9("visibleRanges")},get options(){return o.d.value},set options(h){o.g||o.d.assign(h)},get viewColumn(){return o.f},set viewColumn(h){throw new M.$9("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new g(s.value,t);return h(f),o.m(f)},insertSnippet(h,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=o.c.map(u=>N.Range.from(u));else if(t instanceof R.$uL){const{lineNumber:u,column:E}=N.Position.from(t);c=[{startLineNumber:u,startColumn:E,endLineNumber:u,endColumn:E}]}else if(t instanceof R.$vL)c=[N.Range.from(t)];else{c=[];for(const u of t)if(u instanceof R.$vL)c.push(N.Range.from(u));else{const{lineNumber:E,column:y}=N.Position.from(u);c.push({startLineNumber:E,startColumn:y,endLineNumber:E,endColumn:y})}}return v.$tryInsertSnippet(l,s.value.version,h.value,c,f)},setDecorations(h,t){const f=t.length===0;f&&!o.h.has(h.key)||(f?o.h.delete(h.key):o.h.add(h.key),o.n(()=>{if(N.$GN(t))return v.$trySetDecorations(l,h.key,N.$HN(t));{const c=new Array(4*t.length);for(let u=0,E=t.length;u<E;u++){const y=t[u];c[4*u]=y.start.line+1,c[4*u+1]=y.start.character+1,c[4*u+2]=y.end.line+1,c[4*u+3]=y.end.character+1}return v.$trySetDecorationsFast(l,h.key,c)}}))},revealRange(h,t){o.n(()=>v.$tryRevealRange(l,N.Range.from(h),t||R.TextEditorRevealType.Default))},show(h){v.$tryShowEditor(l,N.ViewColumn.from(h))},hide(){v.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(N.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const v=l.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(a=>a.range);p.sort((a,r)=>a.end.line===r.end.line?a.end.character===r.end.character?a.start.line===r.start.line?a.start.character-r.start.character:a.start.line-r.start.line:a.end.character-r.end.character:a.end.line-r.end.line);for(let a=0,r=p.length-1;a<r;a++){const i=p[a].end;if(p[a+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(a=>({range:N.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?N.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$SN=A}),define(Le[66],Me([1,0,54,5,6,2,4,3,109,17,112,8,14,28,12,68,39]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0;class r{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,h){this.h=o,this.i=h,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new M.$Yd,this.e=new M.$Yd,this.f=new M.$Yd,this.g=new M.$Yd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const h=[],t=[],f=[];if(o.removedDocuments)for(const c of o.removedDocuments){const u=N.URI.revive(c),E=this.c.get(u);E?.unref()&&(this.c.delete(u),h.push(E.value))}if(o.addedDocuments)for(const c of o.addedDocuments){const u=N.URI.revive(c.uri);let E=this.c.get(u);if(E&&u.scheme!==p.Schemas.vscodeNotebookCell&&u.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);E||(E=new r(new g.$MN(this.h.getProxy(m.$rL.MainThreadDocuments),u,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(u,E),t.push(E.value)),E.ref()}if(o.removedEditors)for(const c of o.removedEditors){const u=this.b.get(c);this.b.delete(c),u&&f.push(u)}if(o.addedEditors)for(const c of o.addedEditors){const u=N.URI.revive(c.documentUri);S.ok(this.c.has(u),`document '${u}' does not exist`),S.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const E=this.c.get(u).value,y=new A.$SN(c.id,this.h.getProxy(m.$rL.MainThreadTextEditors),this.i,new a.$V(()=>E.document),c.selections.map(k.Selection.to),c.options,c.visibleRanges.map($=>k.Range.to($)),typeof c.editorPosition=="number"?k.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,y)}o.newActiveEditor!==void 0&&(S.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Oc)(h),(0,P.$Oc)(f),o.removedDocuments&&this.e.fire(h),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return s.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const h=this.b.get(this.a);return o?h:h?.value}allEditors(){return[...this.b.values()]}};e.$TN=i,e.$TN=i=Je([qe(0,D.$JN),qe(1,l.$sj)],i),e.$UN=(0,R.$$h)("IExtHostDocumentsAndEditors")}),define(Le[276],Me([1,0,18,5,3,112,8,7]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class g{constructor(A,k){this.i=k,this.a=new M.$Yd,this.b=new M.$Yd,this.c=new M.$Yd,this.d=new M.$Yd,this.f=new M.$Yd,this.g=new M.$Yd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(P.$rL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const k=this.i.allEditors();return A?k:k.map(l=>l.value)}async showTextDocument(A,k,l){let v;typeof k=="number"?v={position:R.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?v={position:R.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?R.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:v={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(A.uri,v),s=p&&this.i.getEditor(p);if(s)return s.value;throw p?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new N.$QN(this.h,A,k).value}$acceptEditorPropertiesChanged(A,k){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const v=k.selections.selections.map(R.Selection.to);l._acceptSelections(v)}if(k.visibleRanges){const v=S.$Hb(k.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(v)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:R.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const v=m.TextEditorSelectionChangeKind.fromValue(k.selections.source),p=k.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:p,kind:v})}if(k.visibleRanges){const v=S.$Hb(k.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:v})}}$acceptEditorPositionData(A){for(const k in A){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const v=R.ViewColumn.to(A[k]);l.value.viewColumn!==v&&(l._acceptViewColumn(v),this.d.fire({textEditor:l.value,viewColumn:v}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$_gc=g}),define(Le[277],Me([1,0,2,4,3,6,7,8,22,16]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=e.$Ric=void 0,e.$Ric=(0,M.$$h)("IExtHostTimeline");class A{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$rL.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(s,a)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&g.$qm.equals(a,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(k(r))?.get(s.handle)}else return;return s}})}async $getTimeline(v,p,s,a){return this.b.get(v)?.provider.provideTimeline(S.URI.revive(p),s,a)}registerTimelineProvider(v,p,s,a){const r=new N.$Sc,i=this.d(p.id,a,r).bind(this);let n;p.onDidChange&&(n=p.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:p.id}),this));const o=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline(h,t,f){t?.resetCache&&(r.clear(),o.get(p.id)?.clear());const c=await p.provideTimeline(h,t,f);if(c==null)return;const u=i(h,t);return{...c,source:p.id,items:c.items.map(u)}},dispose(){for(const h of o.values())h.get(p.id)?.clear();n?.dispose(),r.dispose()}},s)}d(v,p,s){return(a,r)=>{let i;if(r?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const o=k(a);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...h}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let f,c,u;n.iconPath&&(o instanceof R.$oM?u={id:o.id,color:o.color}:S.URI.isUri(o)?(f=o,c=o):{light:f,dark:c}=o);let E;return R.$UL.isMarkdownString(h.tooltip)?E=m.MarkdownString.from(h.tooltip):(0,D.$Mf)(h.tooltip)?E=h.tooltip:R.$UL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=m.MarkdownString.from(h.detail)):(0,D.$Mf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=h.detail),{...h,id:h.id??void 0,handle:t,source:v,command:n.command?p.toInternal(n.command,s):void 0,icon:f,iconDark:c,themeIcon:u,tooltip:E,accessibilityInformation:n.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,N.$Rc)(()=>{for(const a of this.c.values())a.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Sic=A;function k(l){return l?.toString()}}),define(Le[278],Me([1,0,168,24,2,5,6,206,11,7,16,18,8,46,21,133,25]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;function r(o,h){if((0,A.$Mf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Tc{constructor(h,t,f){super(),this.f=h,this.g=t,this.h=f,this.a=new Map,this.b=new s.$48;function c(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>c(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(E=>c(E)?this.r(E):E):u})}registerTreeDataProvider(h,t,f){const c=this.createTreeView(h,{treeDataProvider:t},f);return{dispose:()=>c.dispose()}}createTreeView(h,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],E=!!t.dragAndDropController?.handleDrag,y=!!t.dragAndDropController?.handleDrop,$=this.m(h,t,f),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:u,hasHandleDrag:E,hasHandleDrop:y,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(h,I),w={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,a.$OF)(f,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,a.$OF)(f,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(b){(0,v.$ok)(b)&&(0,a.$OF)(f,"treeViewMarkdownMessage"),$.message=b},get title(){return $.title},set title(b){$.title=b},get description(){return $.description},set description(b){$.description=b},get badge(){return $.badge},set badge(b){b!==void 0&&D.ViewBadge.isViewBadge(b)?$.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&($.badge=void 0)},reveal:(b,L)=>$.reveal(b,L),dispose:async()=>{await d,this.a.delete(h),$.dispose()}};return this.B(w),w}$getChildren(h,t){const f=this.a.get(h);return f?f.getChildren(t):Promise.reject(new m.$hF(h))}async $handleDrop(h,t,f,c,u,E,y,$){const I=this.a.get(h);if(!I)return Promise.reject(new m.$hF(h));const d=l.DataTransfer.toDataTransfer(f,async w=>(await this.f.$resolveDropFileData(h,t,w)).buffer);return y===h&&$&&await this.j(d,I,$,u,E),I.onDrop(d,c,u)}async j(h,t,f,c,u){const E=this.b.removeDragOperationTransfer(u);if(E)(await E)?.forEach((y,$)=>{y&&h.set($,y)});else if(u&&t.handleDrag){const y=t.handleDrag(f,h,c);this.b.addDragOperationTransfer(u,y),await y}return h}async $handleDrag(h,t,f,c){const u=this.a.get(h);if(!u)return Promise.reject(new m.$hF(h));const E=await this.j(new D.$lM,u,t,c,f);if(!(!E||c.isCancellationRequested))return l.DataTransfer.from(E)}async $hasResolve(h){const t=this.a.get(h);if(!t)throw new m.$hF(h);return t.hasResolve}$resolve(h,t,f){const c=this.a.get(h);if(!c)throw new m.$hF(h);return c.resolveTreeItem(t,f)}$setExpanded(h,t,f){const c=this.a.get(h);if(!c)throw new m.$hF(h);c.setExpanded(t,f)}$setSelectionAndFocus(h,t,f){const c=this.a.get(h);if(!c)throw new m.$hF(h);c.setSelectionAndFocus(t,f)}$setVisible(h,t){const f=this.a.get(h);if(!f){if(!t)return;throw new m.$hF(h)}f.setVisible(t)}$changeCheckboxState(h,t){const f=this.a.get(h);if(!f)throw new m.$hF(h);f.setCheckboxState(t)}m(h,t,f){const c=this.B(new n(h,t,this.f,this.g.converter,this.h,f));return this.a.set(h,c),c}r(h){const t=this.a.get(h.$treeViewId);return t&&"$treeItemHandle"in h?t.getExtensionElement(h.$treeItemHandle):t&&"$focusedTreeItem"in h&&h.$focusedTreeItem?t.focusedElement:null}}e.$Tic=i;class n extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Vf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,t,f,c,u,E){if(super(),this.I=h,this.J=f,this.L=c,this.M=u,this.N=E,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new N.$Yd),this.onDidExpandElement=this.u.event,this.w=this.B(new N.$Yd),this.onDidCollapseElement=this.w.event,this.y=this.B(new N.$Yd),this.onDidChangeSelection=this.y.event,this.z=this.B(new N.$Yd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new N.$Yd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new N.$Yd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new N.$Yd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$9d,E.contributes&&E.contributes.views)for(const d in E.contributes.views)for(const w of E.contributes.views[d])w.id===h&&(this.P=w.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let y,$;const I=N.Event.debounce(this.F.event,(d,w)=>(d||(d={message:!1,elements:[]}),w.element!==!1&&(y||(y=new Promise(b=>$=b),this.G=this.G.then(()=>y)),Array.isArray(w.element)?d.elements.push(...w.element):d.elements.push(w.element)),w.message&&(d.message=!0),d),200,!0);this.B(I(({message:d,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const b=$;return y=null,this.$(w).then(()=>b())})),d&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const t=h?this.getExtensionElement(h):void 0;if(h&&!t)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let f=this.X(h);return f||(f=await this.Y(t)),f?f.map(c=>c.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,t){t=t||{select:!0,focus:!1};const f=(0,A.$Vf)(t.select)?!0:t.select,c=(0,A.$Vf)(t.focus)?!1:t.focus,u=(0,A.$Vf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(E=>this.W(h,E[E.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:E.map($=>$.item)},{select:f,focus:c,expand:u})),E=>this.M.error(E)):this.J.$reveal(this.I,void 0,{select:f,focus:c,expand:u})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,t){const f=this.getExtensionElement(h);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(h,t){const f=!(0,k.$ub)(this.s,h);this.s=h;const c=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const t=(await Promise.all(h.map(async f=>{const c=this.getExtensionElement(f.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:f.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(h,t,f){const c=[];for(const u of h){const E=this.getExtensionElement(u);E&&c.push(E)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,t,f){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,g.$3g)(()=>this.g?.handleDrop?this.g.handleDrop(c,h,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(h);if(f){const c=this.m.get(f);if(c){const u=await this.f.resolveTreeItem(c.extensionItem,f,t)??c.extensionItem;return this.hb(u),c.item.tooltip=this.eb(u.tooltip),c.item.command=this.fb(c.disposableStore,u.command),c.item}}}S(h){return this.U(h).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(c=>(f.push(c),f))):Promise.resolve([]))}U(h){const t=this.m.get(h);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,g.$3g)(()=>this.f.getParent(h))}W(h,t){const f=this.m.get(h);return f?Promise.resolve(f):(0,g.$3g)(()=>this.f.getTreeItem(h)).then(c=>this.kb(h,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(c);if(u){const E=this.m.get(u);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let t;if(typeof h=="string"){const f=this.getExtensionElement(h);t=f?this.m.get(f):void 0}else t=h;return t&&t.children||void 0}return this.h}async Y(h){this.rb(h);const t=new p.$9d(this.Z.token);try{const f=h?this.m.get(h):void 0,c=await this.f.getChildren(h);if(t.token.isCancellationRequested)return;const u=(0,k.$Hb)(c||[]),E=await Promise.all((0,k.$Hb)(u).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const y=E.map(($,I)=>$?this.db(u[I],$,f):null);return(0,k.$Hb)(y)}finally{t.dispose()}}$(h){if(h.some(f=>!f))return this.Z.dispose(!0),this.Z=new p.$9d,this.tb(),this.J.$refresh(this.I);{const f=this.ab(h);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(h){const t=new Set,f=h.map(u=>this.m.get(u));for(const u of f)if(u&&!t.has(u.item.handle)){let E=u;for(;E&&E.parent&&f.findIndex(y=>E&&E.parent&&y&&y.item.handle===E.parent.item.handle)===-1;){const y=this.j.get(E.parent.item.handle);E=y?this.m.get(y):void 0}E&&!E.parent&&t.add(u.item.handle)}const c=[];return t.forEach(u=>{const E=this.j.get(u);if(E){const y=this.m.get(E);y&&(!y.parent||!t.has(y.parent.item.handle))&&c.push(u)}}),c}bb(h){const t={};return Promise.all(h.map(f=>this.cb(f).then(c=>{c&&(t[f]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(h){const t=this.getExtensionElement(h);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,g.$3g)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const u=this.ib(t,c,f.parent);return this.pb(t,u,f,f.parent),f.dispose(),u}return null})}return Promise.resolve(null)}db(h,t,f){const c=this.ib(h,t,f);if(t.id&&this.j.has(c.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(h,c),this.qb(c,f),c}eb(h){return D.$UL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,t){return t?{...this.L.toInternal(t,h),originalId:t.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let t,f,c;return typeof h.checkboxState=="number"?t=h.checkboxState:(t=h.checkboxState.state,f=h.checkboxState.tooltip,c=h.checkboxState.accessibilityInformation),{isChecked:t===D.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:c}}hb(h){if(!D.$gM.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,t,f){this.hb(t);const c=this.B(new R.$Sc),u=this.kb(h,t,f),E=this.lb(t);return{item:{handle:u,parentHandle:f?f.item.handle:void 0,label:r(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:E,iconDark:this.mb(t)||E,themeIcon:this.jb(t),collapsibleState:(0,A.$Vf)(t.collapsibleState)?D.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(h){return h.iconPath instanceof D.$oM?h.iconPath:void 0}kb(h,{id:t,label:f,resourceUri:c},u,E){if(t)return`${n.b}/${t}`;const y=r(f,this.N),$=u?u.item.handle:n.a;let I=y?y.label:c?(0,M.$Ig)(c):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const d=this.m.has(h)?this.m.get(h).item.handle:void 0,w=this.X(u)||[];let b,L=0;do{if(b=`${$}/${L}:${I}`,E||!this.j.has(b)||d===b)break;L++}while(L<=w.length);return b}lb(h){if(h.iconPath&&!(h.iconPath instanceof D.$oM))return typeof h.iconPath=="string"||P.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof D.$oM)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return P.URI.isUri(h)?h:P.URI.file(h)}ob(h,t){this.j.set(t.item.handle,h),this.m.set(h,t)}pb(h,t,f,c){this.j.delete(t.item.handle),this.m.delete(h),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(h,t);const u=this.X(c)||[],E=u.filter(y=>y.item.handle===f.item.handle)[0];E&&u.splice(u.indexOf(E),1,t)}qb(h,t){t?(t.children||(t.children=[]),t.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const t=this.m.get(h);if(t){if(t.children)for(const f of t.children){const c=this.j.get(f.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(h){const t=this.m.get(h);if(t){if(t.children)for(const f of t.children){const c=this.j.get(f.item.handle);c&&this.sb(c)}this.m.delete(h),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Le[279],Me([1,0,5,6,2,33,8,61,3,7]),function(fe,e,S,M,P,N,R,m,g,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=void 0;class A extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(p,s,a,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$Yd),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$Yd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=s,this.#n=a,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends M.$Tc{static c(){return(0,N.$ug)()}constructor(p,s,a){super(),this.j=s,this.m=a,this.g=new Map,this.h=new Map,this.f=p.getProxy(g.$rL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,s,a,r,i={}){const n=typeof r=="object"?r.viewColumn:r,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,m.$ohc)(p),t=k.c();this.f.$createWebviewPanel((0,m.$qhc)(p),t,s,{title:a,panelOptions:l(i),webviewOptions:(0,m.$rhc)(p,this.m,i),serializeBuffersForPostMessage:h},o);const f=this.j.createNewWebview(t,i,p);return this.createNewWebviewPanel(t,s,a,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(p){const s=Object.keys(p);s.sort((a,r)=>{const i=p[a],n=p[r];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const a of s){const r=this.getWebviewPanel(a);if(!r)continue;const i=p[a];r._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,s,a){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:a,extension:p}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,m.$ohc)(p)}),new D.$tL(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(p,s,a,r){const i=this.h.get(s);if(!i)throw new Error(`No serializer found for '${s}'`);const{serializer:n,extension:o}=i,h=this.j.createNewWebview(p,a.webviewOptions,o),t=this.createNewWebviewPanel(p,s,a.title,r,a.panelOptions,h,a.active);await n.deserializeWebviewPanel(t,a.state)}createNewWebviewPanel(p,s,a,r,i,n,o){const h=new A(p,this.f,n,{viewType:s,title:a,viewColumn:r,panelOptions:i,active:o});return this.g.set(p,h),h}getWebviewPanel(p){return this.g.get(p)}}e.$shc=k;function l(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Le[280],Me([1,0,5,6,61,8,3,7]),function(fe,e,S,M,P,N,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class g extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,l,v,p,s,a){super(),this.#s=!1,this.#u=this.B(new S.$Yd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$Yd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=p,this.#e=k,this.#t=l,this.#n=s,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=N.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$rL.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,v,p){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:v,extension:k}),this.a.$registerWebviewViewProvider((0,P.$qhc)(k),l,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$ohc)(k)}),new m.$tL(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,v,p,s){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:i}=a,n=this.d.createNewWebview(k,{},i),o=new g(k,this.a,l,v,n,!0);this.c.set(k,o),await r.resolveWebviewView(o,{state:p},s)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$Wic=D}),define(Le[281],Me([1,0,5,30,35,4]),function(fe,e,S,M,P,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.OutputChannelUpdateMode=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=void 0,e.$CK="text/x-code-output",e.$DK="output",e.$EK="Log",e.$FK="text/x-code-log-output",e.$GK="log",e.$HK="workbench.panel.output",e.$IK=new P.$pj("inOutput",!1),e.$JK=new P.$pj("activeLogOutput",!1),e.$KK=new P.$pj("outputView.scrollLock",!1),e.$LK=(0,N.$$h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$MK={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$Yd,this.onDidRegisterChannel=this.b.event,this.c=new S.$Yd,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(A=>D.push(A)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}M.$Nn.add(e.$MK.OutputChannels,new m),e.$NK=new P.$pj("activeOutputChannel","")}),define(Le[113],Me([1,0,3,4,17,22,14,281,62,27,43,137,23,16,42,5,6]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=e.$xic=void 0;class r extends R.$yj{get disposed(){return this.n}constructor(h,t,f,c,u){super(),this.id=h,this.name=t,this.r=f,this.s=c,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const t=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(h,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:t))}hide(){this.s.$close(this.id)}g(h,t){this.m+=l.$me.fromString(t).byteLength,(0,R.log)(this.r,h,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends r{appendLine(h){this.append(h)}}let n=class{constructor(h,t,f,c,u,E){this.i=t,this.j=f,this.k=c,this.l=u,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(S.$rL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$Cm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(h,t,f){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,u=(0,v.$Mf)(t)?t:void 0;if((0,v.$Mf)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const y=this.i.environment.extensionLogLevel?.find(([I])=>N.$qm.equals(f.identifier,I))?.[1];y&&(E=(0,R.$Ij)(y));const $=c?this.o(h,E,f):this.n(h,u,f);return $.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),c?this.r(h,E??this.m.getLevel(),$):this.q(h,$)}async n(h,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,u=this.k.extUri.joinPath(c,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(h,u,t,f.identifier.value);return new r(y,h,E,this.a,f)}async o(h,t,f){const c=await this.p(f),u=h.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(c,`${u}.log`),y=`${f.identifier.value}.${u}`,$=this.l.createLogger(E,{id:y,name:h,logLevel:t,extensionId:f.identifier.value});return new i(y,h,$,this.a,f)}p(h){let t=this.d.get(h.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(c){if((0,p.$Lk)(c)!==p.FileSystemProviderErrorCode.FileExists)throw c}return f})())}return t}q(h,t){let f=!1;const c=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return h},append(u){c(),t.then(E=>E.append(u))},appendLine(u){c(),t.then(E=>E.appendLine(u))},clear(){c(),t.then(u=>u.clear())},replace(u){c(),t.then(E=>E.replace(u))},show(u,E){c(),t.then(y=>y.show(u,E))},hide(){c(),t.then(u=>u.hide())},dispose(){f=!0,t.then(u=>u.dispose())}}}r(h,t,f){const c=new a.$Sc,u=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},E=c.add(new s.$Yd);function y($){t=$,E.fire($)}return f.then($=>{c.add($),$.logLevel!==t&&y($.logLevel),c.add($.onDidChangeLogLevel(I=>y(I)))}),{...this.q(h,f),get logLevel(){return t},onDidChangeLogLevel:E.event,trace($,...I){u(),f.then(d=>d.trace($,...I))},debug($,...I){u(),f.then(d=>d.debug($,...I))},info($,...I){u(),f.then(d=>d.info($,...I))},warn($,...I){u(),f.then(d=>d.warn($,...I))},error($,...I){u(),f.then(d=>d.error($,...I))},dispose(){c.dispose()}}}};e.$xic=n,e.$xic=n=Je([qe(0,P.$JN),qe(1,D.$ZN),qe(2,g.$khc),qe(3,A.$Ygc),qe(4,R.$tj),qe(5,R.$sj)],n),e.$yic=(0,M.$$h)("IExtHostOutputService")}),define(Le[114],Me([1,0,4,11]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=e.$Rm=void 0,e.$Rm=(0,S.$$h)("remoteAgentService"),e.$Sm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let N=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await P.getRoundTripTime();if(g===void 0)return;N=Math.min(N,g/2),await(0,M.$_g)(this.sampleDelay)}this.average.push(N),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(N):R=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:N,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:typeof R>"u"?!1:N>this.highLatencyMaxThreshold||N>this.highLatencyMinThreshold&&N>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Le[282],Me([1,0,171,55,30,48,47,6,5,114,20,26,11]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=void 0,e.$0H=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$$H=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$_H=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$aI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$bI={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new g.$Yd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const p=new v;P.$Nn.add(e.$bI.ConfigurationMigration,p);let s=class extends m.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const h of o.added)await this.f(h,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(o=>this.g(o,i?.uri))])}async g(i,n){const o=this.a.inspect(i.key,{resource:n}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of h){const c=o[t];if(!c)continue;const u=[];if(c.value!==void 0){const E=await this.h(i,t,c.value,n,void 0);for(const y of E??[])u.push([y,[]])}for(const{identifiers:E,value:y}of c.overrides??[])if(y!==void 0){const $=await this.h(i,t,y,n,E);for(const I of $??[])u.push([I,E])}u.length&&await Promise.allSettled(u.map(async([[E,y],$])=>this.a.updateValue(E,y.value,{resource:n,overrideIdentifiers:$},f)))}}async h(i,n,o,h,t){const f=u=>{const y=this.a.inspect(u,{resource:h})[n];if(y)return t?y.overrides?.find(({identifiers:$})=>(0,k.$Fn)($,t))?.value:y.value},c=await i.migrateFn(o,f);return Array.isArray(c)?c:[[i.key,c]]}};e.$cI=s,e.$cI=s=Je([qe(0,R.$Ei),qe(1,N.$hi)],s);let a=class extends m.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;P.$Nn.as(M.$Sn.Configuration).registerConfiguration({...e.$_H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$dI=a,e.$dI=a=Je([qe(0,D.$Rm)],a)}),define(Le[283],Me([1,0,34,12,19,24,179,282,55,4,30]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9db=e.$8db=e.ResolvedStatus=e.RegisteredEditorPriority=e.$7db=e.$6db=void 0,e.$6db=(0,D.$$h)("editorResolverService"),e.$7db="workbench.editorAssociations";const k=A.$Nn.as(g.$Sn.Configuration),l={...m.$$H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var v;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(v||(e.RegisteredEditorPriority=v={}));var p;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function s(r){switch(r){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$8db=s;function a(r,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const h=typeof r=="string"&&r.indexOf(P.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,N.$Ig)(i);return S.$Qj(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}e.$9db=a}),define(Le[284],Me([1,0,45,12,19,20,24,2,4,200,48,218,114]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$7K=e.$6K=void 0,e.$6K=(0,g.$$h)("pathService");let p=v=class{constructor(a,r,i,n){this.d=a,this.e=r,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||N.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??a})()}hasValidBasename(a,r,i){return typeof r=="string"||typeof r>"u"?this.a.then(n=>this.h(a,n,r)):this.h(a,r,i)}h(a,r,i){return a.scheme===M.Schemas.file||a.scheme===M.Schemas.vscodeRemote?(0,S.$0f)(i??(0,R.$Ig)(a),r===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,r){if(a.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,D.$3K)(r.getWorkspace());if(i)return i;const n=r.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=r.getWorkspace().configuration;return o?o.scheme:M.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?P.$fc:P.$gc)}async fileURI(a){let r="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const n=a.indexOf("/",2);n===-1?(r=a.substring(2),a="/"):(r=a.substring(2,n),a=a.substring(n)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:r,path:a,query:"",fragment:""})}};e.$7K=p,e.$7K=p=v=Je([qe(1,l.$Rm),qe(2,k.$OK),qe(3,A.$hi)],p)}),define(Le[115],Me([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GJ=e.$FJ=void 0;class S{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new S(0,0)}with(R){return new S(0,0)}}e.$FJ=S;class M{constructor(R,m,g,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,m),this.end=new S(g,D)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$GJ=M;var P;(function(N){N[N.Information=1]="Information",N[N.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Le[44],Me([1,0,18,34,26,45,13,4,19,15,115,11]),function(fe,e,S,M,P,N,R,m,g,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.SearchErrorCode=e.$VJ=e.$UJ=e.SearchSortOrder=e.ViewMode=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.SearchCompletionExitCode=e.$PJ=e.$OJ=e.$NJ=e.QueryType=e.SearchProviderType=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$HJ="workbench.view.search",e.$IJ="workbench.panel.search",e.$JJ="workbench.view.search",e.$KJ="search-result",e.$LJ="search.exclude";const l="\u27EA ",v=" characters skipped \u27EB",p=(l.length+v.length+5)*2;e.$MJ=(0,m.$$h)("searchService");var s;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(s||(e.SearchProviderType=s={}));var a;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(a||(e.QueryType=a={}));function r(he){return!!he.preview}e.$NJ=r;function i(he){return!!he.resource}e.$OJ=i;function n(he){return!!he.message}e.$PJ=n;var o;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$QJ=h;class t{constructor(ve,se,$e,te){this.ranges=se,this.webviewIndex=te;const X=Array.isArray(se)?se:[se];if($e&&$e.matchLines===1&&f(X)){ve=(0,R.$Ff)(ve,$e.matchLines);let V="",ne=0,Ce=0;const Fe=Math.floor($e.charsPerLine/5),Pe=[];for(const we of X){const me=Math.max(we.startColumn-Fe,0),J=we.startColumn+$e.charsPerLine;if(me>Ce+Fe+p){const x=l+(me-Ce)+v;V+=x+ve.slice(me,J),ne+=me-(Ce+x.length)}else V+=ve.slice(Ce,J);Pe.push(new u(0,we.startColumn-ne,we.endColumn-ne)),Ce=J}this.preview={text:V,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const V=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(se,ne=>new c(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$RJ=t;function f(he){const ve=he[0].startLineNumber;for(const se of he)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class c{constructor(ve,se,$e,te){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=$e,this.endColumn=te}}e.$SJ=c;class u extends c{constructor(ve,se,$e){super(ve,se,ve,$e)}}e.$TJ=u;var E;(function(he){he.List="list",he.Tree="tree"})(E||(e.ViewMode=E={}));var y;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function $(he,ve=!0){const se=he&&he.files&&he.files.exclude,$e=ve&&he&&he.search&&he.search.exclude;if(!se&&!$e)return;if(!se||!$e)return se||$e;let te=Object.create(null);return te=P.$En(te,P.$Bn(se)),te=P.$En(te,P.$Bn($e),!0),te}e.$UJ=$;function I(he,ve){return he.excludePattern&&M.$Qj(he.excludePattern,ve)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&M.$Qj(he.includePattern,ve)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(se=>{const $e=se.folder.fsPath;if(N.$_f(ve,$e)){const te=g.$lc($e,ve);return!se.includePattern||!!M.$Qj(se.includePattern,te)}else return!1}):!1:!0}e.$VJ=I;var d;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class w extends Error{constructor(ve,se){super(ve),this.code=se}}e.$WJ=w;function b(he){const ve=he.message;if((0,D.$4)(he))return new w(ve,d.canceled);try{const se=JSON.parse(ve);return new w(se.message,se.code)}catch{return new w(ve,d.other)}}e.$XJ=b;function L(he){const ve={message:he.message,code:he.code};return new Error(JSON.stringify(ve))}e.$YJ=L;function T(he){return he.type==="error"?!0:he.type==="success"}e.$ZJ=T;function Y(he){return he.type==="success"}e.$1J=Y;function q(he){return!!he.path}e.$2J=q;function U(he,ve,se=!0){const $e=he.searchPath?he.searchPath:he.relativePath;return se?(0,R.$Cf)($e,ve):M.$Qj(ve,$e)}e.$3J=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$4J=C;function F(he,ve){const se={...he||{},...ve||{}};return Object.keys(se).filter($e=>{const te=se[$e];return typeof te=="boolean"&&te})}e.$5J=F;class W{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=M.$Rj(this.a);let $e=ve.includePattern;se.includePattern&&($e?$e={...$e,...se.includePattern}:$e=se.includePattern),$e&&(this.c=M.$Rj($e))}matchesExcludesSync(ve,se,$e){return!!(this.b&&this.b(ve,se,$e))}includedInQuerySync(ve,se,$e){return!(this.b&&this.b(ve,se,$e)||this.c&&!this.c(ve,se,$e))}includedInQuery(ve,se,$e){const te=this.b(ve,se,$e),X=()=>this.c?!!this.c(ve,se,$e):!0;return(0,k.$Wg)(te)?te.then(V=>V?!1:X()):X()}hasSiblingExcludeClauses(){return re(this.a)}}e.$6J=W;function re(he){for(const ve in he)if(typeof he[ve]!="boolean")return!0;return!1}function ue(he){if(!he)return;let ve;return se=>(ve||(ve=(he()||Promise.resolve([])).then($e=>$e?ke($e):{})),ve.then($e=>!!$e[se]))}e.$7J=ue;function ye(he){if(!he)return;let ve;return se=>{if(!ve){const $e=he();ve=$e?ke($e):{}}return!!ve[se]}}e.$8J=ye;function ke(he){const ve={};for(const se of he)ve[se]=!0;return ve}}),define(Le[36],Me([1,0,18,11,21,5,6,51,12,123,24,13,2,170,4,14,189,48,43,27,17,8,7,58,44,3,52]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f,c,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;function y(Y,q,U){return new A.$Ag(C=>w(C,U)).isEqual(Y,q)}function $(Y,q,U){return y(Y.uri,q.uri,U)?0:(0,k.$9e)(Y.uri.toString(),q.uri.toString())}function I(Y,q,U){return Y.index!==q.index?Y.index<q.index?-1:1:y(Y.uri,q.uri,U)?(0,k.$9e)(Y.name,q.name):(0,k.$9e)(Y.uri.toString(),q.uri.toString())}function d(Y,q,U,C){const F=Y.slice(0).sort((re,ue)=>U(re,ue,C)),W=q.slice(0).sort((re,ue)=>U(re,ue,C));return(0,S.$Eb)(F,W,(re,ue)=>U(re,ue,C))}function w(Y,q){const U=q.getCapabilities(Y.scheme);return!(U&&U&1024)}class b extends r.$ri{static toExtHostWorkspace(q,U,C,F){if(!q)return{workspace:null,added:[],removed:[]};const{id:W,name:re,folders:ue,configuration:ye,transient:ke,isUntitled:he}=q,ve=[],se=U;U?ue.forEach((V,ne)=>{const Ce=l.URI.revive(V.uri),Fe=b.o(C||U,Ce,F);Fe?(Fe.name=V.name,Fe.index=V.index,ve.push(Fe)):ve.push({uri:Ce,name:V.name,index:ne})}):ve.push(...ue.map(({uri:V,name:ne,index:Ce})=>({uri:l.URI.revive(V),name:ne,index:Ce}))),ve.sort((V,ne)=>V.index<ne.index?-1:1);const $e=new b(W,re,ve,!!ke,ye?l.URI.revive(ye):null,!!he,V=>w(V,F)),{added:te,removed:X}=d(se?se.workspaceFolders:[],$e.workspaceFolders,$,F);return{workspace:$e,added:te,removed:X}}static o(q,U,C){for(let F=0;F<q.folders.length;F++){const W=q.workspaceFolders[F];if(y(W.uri,U,C))return W}}constructor(q,U,C,F,W,re,ue){super(q,C.map(ye=>new r.$si(ye)),F,W,ue),this.t=U,this.u=re,this.q=[],this.s=m.$ei.forUris(ue),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,U){return U&&this.s.get(q)&&(q=(0,A.$Kg)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let L=class{constructor(q,U,C,F,W){this.c=new N.$Yd,this.onDidChangeWorkspace=this.c.event,this.g=new N.$Yd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new N.$1d,this.C=new Map,this.h=F,this.s=C,this.t=W,this.j=new D.$bm,this.k=new M.$0g,this.o=q.getProxy(u.$rL.MainThreadWorkspace),this.q=q.getProxy(u.$rL.MainThreadMessageService);const re=U.workspace;this.l=re?new b(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,ue=>w(ue,C)):void 0}$initializeWorkspace(q,U){this.v=U,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Ig)((0,A.$Kg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,U,C,...F){const W=[];if(Array.isArray(F)&&F.forEach(he=>{l.URI.isUri(he.uri)&&!W.some(ve=>y(ve.uri,he.uri,this.s))&&W.push({uri:he.uri,name:he.name||(0,A.$Hg)(he.uri)})}),this.n||[U,C].some(he=>typeof he!="number"||he<0)||C===0&&W.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(U+C>re.length)return!1;const ue=re.slice(0);ue.splice(U,C,...W.map(he=>({uri:he.uri,name:he.name||(0,A.$Hg)(he.uri),index:void 0})));for(let he=0;he<ue.length;he++){const ve=ue[he];if(ue.some((se,$e)=>$e!==he&&y(ve.uri,se.uri,this.s)))return!1}ue.forEach((he,ve)=>he.index=ve);const{added:ye,removed:ke}=d(re,ue,I,this.s);if(ye.length===0&&ke.length===0)return!1;if(this.o){const he=q.displayName||q.name;this.o.$updateWorkspaceFolders(he,U,C,W).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(a.Severity.Error,(0,v.localize)(0,null,he,ve.toString()),se,[])})}return this.y(ue),!0}getWorkspaceFolder(q,U){if(this.x)return this.x.getWorkspaceFolder(q,U)}async getWorkspaceFolder2(q,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,U)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,U){let C,F="";if(typeof q=="string"?(C=l.URI.file(q),F=q):typeof q<"u"&&(C=q,F=q.fsPath),!C)return F;const W=this.getWorkspaceFolder(C,!0);if(!W)return F;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let re=(0,A.$Ng)(W.uri,C);return U&&W.name&&(re=`${W.name}/${re}`),re}y(q){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:U,added:C,removed:F}=b.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:F}))}findFiles(q,U,C,F,W=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let re="",ue=!0;return U===null?ue=!1:U!==void 0&&(typeof U=="string"?re=U:re=U.pattern),this.z(q,void 0,{exclude:re,maxResults:C,useDefaultExcludes:ue,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},W)}findFiles2(q,U={},C,F=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,q,U,F)}async z(q,U,C,F=P.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const W=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,re={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:W,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ue;if(q){const{includePattern:ye,folder:ke}=T(h.GlobPattern.from(q));ue=ke,re.includePattern=ye}else{const{includePattern:ye,folder:ke}=T(h.GlobPattern.from(U));ue=ke,re.filePattern=ye}return this.o.$startFileSearch(ue??null,re,F).then(ye=>Array.isArray(ye)?ye.map(ke=>l.URI.revive(ke)):[])}async findTextInFiles(q,U,C,F,W=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ue=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:ke}=T(h.GlobPattern.from(U.include)),he=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ue,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:he},se=!1;if(this.u[re]=$e=>{if(se)return;const te=l.URI.revive($e.resource);$e.results.forEach(X=>{const V=(0,E.$Hh)(X);(0,c.$NJ)(V)?C({uri:te,preview:{text:V.preview.text,matches:(0,S.$2b)(V.preview.matches,ne=>new t.$vL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.$2b)(V.ranges,ne=>new t.$vL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:te,text:V.text,lineNumber:V.lineNumber})})},W.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(q,ke??null,ve,re,W);return delete this.u[re],$e||{}}catch($e){throw delete this.u[re],$e}}$handleTextSearchResult(q,U){this.u[U]?.(q)}async save(q){const U=await this.o.$save(q,{saveAs:!1});return l.URI.revive(U)}async saveAs(q){const U=await this.o.$save(q,{saveAs:!0});return l.URI.revive(U)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,U){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,U);const C=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,C),(0,R.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(q,U){this.h.info("Getting edit session identifier for workspaceFolder",q);const C=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const F=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!F),!F)return;const W=await F.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(q,U,C,F){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const re=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!re),!re)return;const ue=await re.provideEditSessionIdentityMatch?.(U,C,F);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(q){return(U,C,F)=>{const W=function(ue){U.call(C,ue)};return W.extension=q,this.B.event(W,void 0,F)}}async $onWillCreateEditSessionIdentity(q,U,C){const F=await this.resolveWorkspaceFolder(l.URI.revive(q));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},U,async(W,re)=>{const ue=Date.now();await Promise.resolve(W),Date.now()-ue>C&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(q,U){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,U);const C=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerCanonicalUriProvider(F,C),(0,R.$Rc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(q,U,C){const F=this.C.get(q.scheme);if(!F)return;const W=await F.provideCanonicalUri?.(l.URI.revive(q),U,C);if(W)return W}async $provideCanonicalUri(q,U,C){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:U},C)}};e.$ehc=L,e.$ehc=L=Je([qe(0,o.$JN),qe(1,n.$ZN),qe(2,i.$Ygc),qe(3,s.$sj),qe(4,f.$chc)],L),e.$fhc=(0,p.$$h)("IExtHostWorkspace");function T(Y){let q,U;return Y&&(typeof Y=="string"?q=Y:(q=Y.pattern,U=l.URI.revive(Y.baseUri))),{includePattern:q,folder:U}}}),define(Le[37],Me([1,0,26,5,36,3,7,191,55,16,11,4,17,14,2]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=e.$hhc=e.$ghc=void 0;function s(f,c){if(c){const u=c.split(".");let E=f;for(let y=0;E&&y<u.length;y++)E=E[u[y]];return E}}function a(f){return f instanceof p.URI}function r(f){return f&&f.uri instanceof p.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof p.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function o(f){if(a(f))return{resource:f};if(r(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let h=class{constructor(c,u,E){this.a=c.getProxy(N.$rL.MainThreadConfiguration),this.c=u,this.b=E,this.d=new A.$0g,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,u){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(c,u))}};e.$ghc=h,e.$ghc=h=Je([qe(0,l.$JN),qe(1,P.$fhc),qe(2,v.$sj)],h);class t{constructor(c,u,E,y){this.a=new M.$Yd,this.b=c,this.f=y,this.c=u,this.e=m.$_n.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,u){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$_n.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(u,E))}getConfiguration(c,u,E){const y=o(u)||{},$=this.g(c?s(this.e.getValue(void 0,y,this.c.workspace),c):this.e.getValue(void 0,y,this.c.workspace));c&&this.h(c,y,E?.identifier);function I(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(w){return typeof s($,w)<"u"},get:(w,b)=>{this.h(c?`${c}.${w}`:w,y,E?.identifier);let L=s($,w);if(typeof L>"u")L=b;else{let T;const Y=(q,U)=>{if((0,D.$Of)(q)){let C;const F=()=>{T=T||(0,S.$Bn)($),C=C||s(T,U)};return new Proxy(q,{get:(W,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return F(),()=>C;if(T)return C=C||s(T,U),C[re];const ue=W[re];return typeof re=="string"?Y(ue,`${U}.${re}`):ue},set:(W,re,ue)=>(F(),C&&(C[re]=ue),!0),deleteProperty:(W,re)=>(F(),C&&delete C[re],!0),defineProperty:(W,re,ue)=>(F(),C&&Object.defineProperty(C,re,ue),!0)})}return Array.isArray(q)?(0,S.$Bn)(q):q};L=Y(L,w)}return L},update:(w,b,L,T)=>{w=c?`${c}.${w}`:w;const Y=I(L);return b!==void 0?this.b.$updateConfigurationOption(Y,w,b,y,T):this.b.$removeConfigurationOption(Y,w,y,T)},inspect:w=>{w=c?`${c}.${w}`:w;const b=this.e.inspect(w,y,this.c.workspace);if(b)return{key:w,defaultValue:(0,S.$Bn)(b.policy?.value??b.default?.value),globalValue:(0,S.$Bn)(b.user?.value??b.application?.value),workspaceValue:(0,S.$Bn)(b.workspace?.value),workspaceFolderValue:(0,S.$Bn)(b.workspaceFolder?.value),defaultLanguageValue:(0,S.$Bn)(b.default?.override),globalLanguageValue:(0,S.$Bn)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,S.$Bn)(b.workspace?.override),workspaceFolderLanguageValue:(0,S.$Bn)(b.workspaceFolder?.override),languageIds:(0,S.$Bn)(b.overrideIdentifiers)}}};return typeof $=="object"&&(0,S.$En)(d,$,!1),Object.freeze(d)}g(c){const u=E=>(0,D.$Of)(E)?new Proxy(E,{get:(y,$)=>u(y[$]),set:(y,$,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(y,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(y,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:y=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return u(c)}h(c,u,E){const y=g.$3n.test(c)?4:this.d.get(c),$=E?`[${E.value}] `:"";if(y===4){typeof u?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(y===3){u?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,u){const E=new m.$bo(c,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(y,$)=>E.affectsConfiguration(y,o($))})}k(c){return c.reduce((u,E)=>(u.set(E[0],E[1]),u),new Map)}}e.$hhc=t,e.$ihc=(0,k.$$h)("IExtHostConfiguration")}),define(Le[116],Me([1,0,2,11,5,3,7,36,66,37,21,65,17,27,4,12,20,14,78,223,15]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=e.$Kic=e.$Jic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(Y){function q(C){if(C!=null)return C}Y.from=q;function U(C){if(C!=null)return C}Y.to=U})(h||(h={}));var t;(function(Y){function q(C){if(C!=null)return C}Y.from=q;function U(C){if(C!=null)return C}Y.to=U})(t||(t={}));var f;(function(Y){function q(C){if(C!=null)return C}Y.from=q;function U(C){if(C!=null)return C}Y.to=U})(f||(f={}));var c;(function(Y){function q(F){if(F){const W=F;return W&&!!W.process}else return!1}Y.is=q;function U(F){if(F==null)return;const W={process:F.process,args:F.args};return F.options&&(W.options=f.from(F.options)),W}Y.from=U;function C(F){if(F!=null)return new R.$cM(F.process,F.args,F.options)}Y.to=C})(c||(c={}));var u;(function(Y){function q(C){if(C!=null)return C}Y.from=q;function U(C){if(C!=null)return C}Y.to=U})(u||(u={}));var E;(function(Y){function q(F){if(F){const W=F;return W&&(!!W.commandLine||!!W.command)}else return!1}Y.is=q;function U(F){if(F==null)return;const W={};return F.commandLine!==void 0?W.commandLine=F.commandLine:(W.command=F.command,W.args=F.args),F.options&&(W.options=u.from(F.options)),W}Y.from=U;function C(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new R.$dM(F.commandLine,F.options):new R.$dM(F.command,F.args?F.args:[],F.options)}Y.to=C})(E||(E={}));var y;(function(Y){function q(F){if(F){const W=F;return W&&W.customExecution==="customExecution"}else return!1}Y.is=q;function U(F){return{customExecution:"customExecution"}}Y.from=U;function C(F,W){return W.get(F)}Y.to=C})(y||(e.CustomExecutionDTO=y={}));var $;(function(Y){function q(U,C){let F;return U.scope!==void 0&&typeof U.scope!="number"?F=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?F=C.workspaceFile:F=n.$HG),{id:U._id,workspaceFolder:F}}Y.from=q})($||(e.TaskHandleDTO=$={}));var I;(function(Y){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}Y.from=q})(I||(I={}));var d;(function(Y){function q(F,W){if(F==null)return[];const re=[];for(const ue of F){const ye=U(ue,W);ye&&re.push(ye)}return re}Y.fromMany=q;function U(F,W){if(F==null)return;let re;F.execution instanceof R.$cM?re=c.from(F.execution):F.execution instanceof R.$dM?re=E.from(F.execution):F.execution&&F.execution instanceof R.$eM&&(re=y.from(F.execution));const ue=h.from(F.definition);let ye;return F.scope?typeof F.scope=="number"?ye=F.scope:ye=F.scope.uri:ye=R.TaskScope.Workspace,!ue||!ye?void 0:{_id:F._id,definition:ue,name:F.name,source:{extensionId:W.identifier.value,label:F.source,scope:ye},execution:re,isBackground:F.isBackground,group:I.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}Y.from=U;async function C(F,W,re){if(F==null)return;let ue;c.is(F.execution)?ue=c.to(F.execution):E.is(F.execution)?ue=E.to(F.execution):y.is(F.execution)&&(ue=y.to(F._id,re));const ye=h.to(F.definition);let ke;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ke=F.source.scope:ke=await W.resolveWorkspaceFolder(S.URI.revive(F.source.scope)):ke=R.TaskScope.Workspace),!ye||!ke)return;const he=new R.$fM(ye,ke,F.name,F.source.label,ue,F.problemMatchers);return F.isBackground!==void 0&&(he.isBackground=F.isBackground),F.group!==void 0&&(he.group=R.$bM.from(F.group._id),he.group&&F.group.isDefault&&(he.group=new R.$bM(he.group.id,he.group.label),F.group.isDefault===!0&&(he.group.isDefault=F.group.isDefault))),F.presentationOptions&&(he.presentationOptions=t.to(F.presentationOptions)),F._id&&(he._id=F._id),F.detail&&(he.detail=F.detail),he}Y.to=C})(d||(e.TaskDTO=d={}));var w;(function(Y){function q(C){return C}Y.from=q;function U(C){if(C)return Object.assign(Object.create(null),C)}Y.to=U})(w||(w={}));class b{#e;constructor(q,U,C){this._id=U,this.a=C,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let L=class{constructor(q,U,C,F,W,re,ue,ye){this.q=new P.$Yd,this.r=new P.$Yd,this.s=new P.$Yd,this.u=new P.$Yd,this.a=q.getProxy(N.$rL.MainThreadTask),this.b=C,this.c=F,this.d=W,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,C){if(!C)return new R.$tL(()=>{});const F=this.x();return this.j.set(F,{type:U,provider:C,extension:q}),this.a.$registerTaskProvider(F,U),new R.$tL(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(w.from(q)).then(async U=>{const C=[];for(const F of U){const W=await d.to(F,this.b,this.m);W&&C.push(W)}return C})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,C){const F=this.m.get(q.id);F&&(this.o.set(q.id,F),this.e.attachPtyToTerminal(U,await F.callback(C))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const U=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.z(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const U=await this.z(q.id);this.u.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));const F=[],W=(0,M.$3g)(()=>C.provider.provideTasks(A.CancellationToken.None)).then(re=>this.v(U,F,C,re));return new Promise(re=>{W.then(ue=>{Promise.all(F).then(()=>{re(ue)})})})}async $resolveTask(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const F=await d.to(U,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const W=await C.provider.resolveTask(F,A.CancellationToken.None);if(!W)return;this.A(W,C);const re=d.from(W,C.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(re.execution)&&await this.y(re,W,!0),await this.w(re)}x(){return this.h++}async y(q,U,C){const F=await this.a.$createTaskId(q);!C&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,U.execution)),this.m.set(F,U.execution)}async z(q,U){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new o.$bb("Unexpected: The specified task is missing an execution");return W}const C=this.l.get(q.id);if(C)return C;let F;return U?F=Promise.resolve(new b(this,q.id,U)):F=d.to(q.task,this.b,this.m).then(W=>{if(!W)throw new o.$bb("Unexpected: Task does not exist.");return new b(this,q.id,W)}),this.l.set(q.id,F),F.then(W=>(this.k.set(q.id,W),W))}A(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const C=this.n.values();let F=C.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=C.next()}};e.$Jic=L,e.$Jic=L=Je([qe(0,l.$JN),qe(1,v.$ZN),qe(2,m.$fhc),qe(3,g.$UN),qe(4,D.$ihc),qe(5,k.$Ghc),qe(6,r.$sj),qe(7,i.$Ugc)],L);let T=class extends L{constructor(q,U,C,F,W,re,ue,ye){super(q,U,C,F,W,re,ue,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=d.from(U,q);if(C===void 0)throw new Error("Task is not valid");if(y.is(C.execution))await this.y(C,U,!1);else throw new o.$_;const F=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(W=>{throw new Error(W)}),F}v(q,U,C,F){const W=[];if(F)for(const re of F){if(this.A(re,C),!re.definition||!q[re.definition.type]){const ye=re.source?re.source:"No task source";this.f.warn(`The task [${ye}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=d.from(re,C.extension);ue&&y.is(ue.execution)?(W.push(ue),U.push(this.y(ue,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:C.extension}}async w(q){if(y.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,C){}};e.$Kic=T,e.$Kic=T=Je([qe(0,l.$JN),qe(1,v.$ZN),qe(2,m.$fhc),qe(3,g.$UN),qe(4,D.$ihc),qe(5,k.$Ghc),qe(6,r.$sj),qe(7,i.$Ugc)],T),e.$Lic=(0,p.$$h)("IExtHostTask")}),define(Le[285],Me([1,0,44,29]),function(fe,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=e.$bK=void 0;function P(R){return"cellResults"in R}e.$bK=P,e.$cK="rawCell#";function N(R,m){let g=-1;const D=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(D.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&D.push([...A]),D.map(l=>{const v=[],p=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let a=p;a<=s;a++)v.push(m.getLineContent(a));return new S.$RJ(v.join(`
`)+`
`,l.map(a=>new M.$Zs(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$dK=N}),define(Le[286],Me([1,0,164,23,5,6,28,13,16,2,42,74,3,31,8,7,50,261,110,26,12,213,285,283]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,y,$,I,d,w){this.q=$,this.r=I,this.s=d,this.t=w,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new P.$Yd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Yd,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Yd,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Yd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$Sgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=E.getProxy(l.$rL.MainThreadNotebook),this.c=E.getProxy(l.$rL.MainThreadNotebookDocuments),this.d=E.getProxy(l.$rL.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===13){const L=b.notebookEditor?.notebookUri,T=b.cell.handle,q=this.g.get(L)?.getCell(T);if(q)return q.apiCell}if(b&&b.$mid===14){const L=b.uri,T=this.g.get(L);if(T)return T.apiNotebook}return b}}),c.B(y)}getEditorById(E){const y=this.h.get(E);if(!y)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(E){for(const[y,$]of this.h)if($.apiEditor===E)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,y){const $=this.g.get(E);if(!$&&!y)throw new Error(`NO notebook document for '${E}'`);return $}static u(E,y){if(!y)return;const $=y.filenamePattern.map(I=>p.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(y.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:y.displayName,filenamePattern:$,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,y,$){const I=c.a++,d=typeof $.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(I,$),this.b.$registerNotebookCellStatusBarItemProvider(I,d,y);let w;return d!==void 0&&(w=$.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(d))),new s.$tL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,d),w?.dispose()})}async createNotebookDocument(E){const y=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&p.NotebookData.from(E.content)});return D.URI.revive(y)}async openNotebookDocument(E){const y=this.g.get(E);if(y)return y.apiNotebook;const $=await this.c.$tryOpenNotebook(E),I=this.g.get(D.URI.revive($));return(0,g.$Xf)(I?.apiNotebook)}async showNotebookDocument(E,y){D.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let $;typeof y=="object"?$={position:p.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(p.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:$={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,$),d=I&&this.h.get(I)?.apiEditor;if(d)return d;throw I?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,y,$,I){const d=this.f.get(E),w=D.URI.revive(y),b=this.g.get(w);if(!b||!d)return;const L=b.getCellFromIndex($);if(!L)return;const T=await d.provideCellStatusBarItems(L.apiCell,I);if(!T)return;const Y=new N.$Sc,q=this.p.add([Y]),C=(Array.isArray(T)?T:[T]).map(F=>p.NotebookStatusBarItem.from(F,this.i,Y));return{cacheId:q,items:C}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,y,$,I,d){if((0,m.$Me)(y))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:y,serializer:$,options:I}),this.b.$registerNotebookSerializer(w,{id:E.identifier,location:E.extensionLocation},y,p.NotebookDocumentContentOptions.from(I),c.u(E,d)),(0,N.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(E,y,$){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.deserializeNotebook(y.buffer,$);return new a.$Yv(p.NotebookData.from(d))}async $notebookToData(E,y,$){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.serializeNotebook(p.NotebookData.to(y.value),$);return M.$me.wrap(d)}async $saveNotebook(E,y,$,I,d){const w=D.URI.revive(y),b=this.x.get(E);if(!b)throw new Error("NO serializer found");const L=this.g.get(w);if(!L)throw new Error("Document NOT found");if(L.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new A.$Qk((0,S.localize)(0,null,this.z(w)),6);await this.y(w,I);const T={metadata:(0,n.$Jn)(L.apiNotebook.metadata,F=>!(b.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of L.apiNotebook.getCells()){const W=new s.$UM(F.kind,F.document.getText(),F.document.languageId,F.mime,b.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);W.metadata=(0,n.$Jn)(F.metadata,re=>!(b.options?.transientCellMetadata??{})[re]),T.cells.push(W)}const Y=await b.serializer.serializeNotebook(T,d);await this.s.value.writeFile(w,Y);const q=this.s.getFileSystemProviderExtUri(w.scheme),U=await this.s.value.stat(w);return{name:q.basename(w),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$2k({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(E,y,$,I,d){const w=this.x.get(E)?.serializer;if(!w)return{limitHit:!1,results:[]};const b=new R.$Bc;await(async(U,C,F)=>{await Promise.all(U.map(async W=>await Promise.all(W.filenamePatterns.map(re=>{const ue={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ue,C,ye=>{ye.forEach(ke=>{b.has(ke)||I.some(ve=>W.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,f.$9db)(se,ke)))||b.add(ke)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})($,d,y);const T=new R.$Ac;let Y=!1;const q=Array.from(b).map(async U=>{const C=[];try{if(d.isCancellationRequested)return;if(y.maxResults&&[...T.values()].reduce((ue,ye)=>ue+ye.cellResults.length,0)>y.maxResults){Y=!0;return}const F=[],W=this.g.get(U);if(W)W.apiNotebook.getCells().forEach(ye=>F.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(ke=>ke.items.map(he=>he.data.toString()))}));else{const ue=await this.s.value.readFile(U),ye=M.$me.fromString(ue.toString()),ke=await w.deserializeNotebook(ye.buffer,d);if(d.isCancellationRequested)return;p.NotebookData.from(ke).cells.forEach(ve=>F.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map($e=>$e.valueBytes.toString()))}))}if(d.isCancellationRequested)return;F.forEach((ue,ye)=>{const ke=y.contentPattern.pattern,he=new h.$qSb(ue.input,void 0,ue.outputs),ve=he.findInInputs(ke),se=he.findInOutputs(ke),$e=se.flatMap(te=>(0,t.$dK)(te.matches,te.textBuffer)).map((te,X)=>(te.webviewIndex=X,te));if(ve.length>0||se.length>0){const te={index:ye,contentResults:(0,t.$dK)(ve,he.inputTextBuffer),webviewResults:$e};C.push(te)}});const re={resource:U,cellResults:C};T.set(U,re);return}catch{return}});return await Promise.all(q),{limitHit:Y,results:[...T.values()]}}async y(E,y){const $=await this.s.value.stat(E);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==A.$1k&&typeof $.mtime=="number"&&typeof $.size=="number"&&y.mtime<$.mtime&&y.etag!==A.$2k({mtime:y.mtime,size:$.size}))throw new A.$Qk((0,S.localize)(1,null),3,y)}z(E){return E.scheme===o.Schemas.file?E.fsPath:E.toString()}A(E,y,$){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const I=new i.$cic(y,this.d,E,$.visibleRanges.map(p.NotebookRange.to),$.selections.map(p.NotebookRange.to),typeof $.viewColumn=="number"?p.ViewColumn.to($.viewColumn):void 0);this.h.set(y,I)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const $ of E.value.removedDocuments){const I=D.URI.revive($),d=this.g.get(I);d&&(d.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(d.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===I.toString()&&this.h.delete(w.id)}if(E.value.addedDocuments){const $=[];for(const I of E.value.addedDocuments){const d=D.URI.revive(I.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const w=new r.$bic(this.c,this.q,this.r,d,I);$.push(...I.cells.map(b=>r.$aic.asModelAddData(w.apiNotebook,b))),this.g.get(d)?.dispose(),this.g.set(d,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(w.apiNotebook)}}if(E.value.addedEditors)for(const $ of E.value.addedEditors){if(this.h.has($.id))return;const I=D.URI.revive($.documentUri),d=this.g.get(I);d&&this.A(d,$.id,$)}const y=[];if(E.value.removedEditors)for(const $ of E.value.removedEditors){const I=this.h.get($);I&&(this.h.delete($),this.k?.id===I.id&&(this.k=void 0),y.push(I))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const $=new Set;this.l.forEach(I=>$.add(I.id));for(const I of this.h.values()){const d=$.has(I.id);I._acceptVisibility(d)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(E){const y=v.$8N.String.with("notebookType","A notebook type"),$=new v.$0N("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new v.$8N("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>M.$me.wrap(d))],new v.$9N("Notebook Data",d=>p.NotebookData.to(d.value))),I=new v.$0N("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new v.$8N("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new a.$Yv(p.NotebookData.from(d)))],new v.$9N("Bytes",d=>d.buffer));E.registerApiCommand($),E.registerApiCommand(I)}}e.$lic=c}),define(Le[287],Me([1,0,19,21,41,34,24,63,44]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class D{constructor(l,v,p){this.k=l,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&N.$Rj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&N.$Rj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const v=this.k.folderQueries||[];return new Promise((p,s)=>{const a=r=>{this.f++,l(r)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const i=r.toString(),n=S.$nc(i);this.j&&this.j(i,n)||this.v(a,{base:r,basename:n})}),Promise.all(v.map(r=>this.p(r,a))).then(r=>{p({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,P.$Vi)(r)))})})}async p(l,v){const p=new M.$9d,s=this.q(l),a=this.r(),r=new g.$6J(this.k,l),i=!r.hasSiblingExcludeClauses();let n;try{this.h.add(p),n=m.$Ud.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,p.token),h=n.elapsed(),t=m.$Ud.create();return this.g&&!this.e||(o&&o.forEach(f=>{const c=S.$gc.relative(l.folder.path,f.path);if(i){const u=S.$nc(f.path);this.v(v,{base:l.folder,relativePath:c,basename:u});return}this.s(a,l.folder,c,v)}),this.g&&!this.e)?null:(this.u(a,r,v),{providerTime:h,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(l){const v=(0,g.$5J)(this.k.includePattern,l.includePattern),p=(0,g.$5J)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:v,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},v,p,s){if(p===this.a){const r=S.$nc(this.a);this.v(s,{base:v,relativePath:this.a,basename:r})}function a(r){const i=S.$nc(r),n=S.$mc(r);let o=l[n];o||(o=l[n]=[],a(n)),o.push({base:v,relativePath:r,basename:i})}a(p)}u({rootEntries:l,pathToEntries:v},p,s){const a=this,r=this.a;function i(n){const o=(0,g.$8J)(()=>n.map(h=>h.basename));for(let h=0,t=n.length;h<t;h++){const f=n[h],{relativePath:c,basename:u}=f;if(p.matchesExcludesSync(c,u,r!==u?o:void 0))continue;const E=v[c];if(E)i(E);else{if(c===r)continue;a.v(s,f)}if(a.e)break}}i(l)}v(l,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,v,p,s){const a=this.c(l.cacheKey),r=new D(l,v,a&&a.token);let i=0;const n=o=>{i+=o.length,p(o.map(h=>this.d(h)))};return this.e(r,A.a,n,s).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$9d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Lg(l.base,l.relativePath)}:{resource:l.base}}e(l,v,p,s){const a=s.onCancellationRequested(()=>{l.cancel()}),r=n=>{n&&(i.push(n),v>0&&i.length>=v&&(p(i),i=[]))};let i=[];return l.search(r).then(n=>(i.length&&p(i),a.dispose(),n),n=>(i.length&&p(i),a.dispose(),Promise.reject(n)))}}e.$dic=A}),define(Le[288],Me([1,0,18,256,34,94,28,12,19,24,13,16,2,93,181,47,14,48,105,284,44]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9K=e.$8K=void 0;let h=class{constructor(w,b,L,T,Y){this.a=w,this.b=b,this.c=L,this.d=T,this.e=Y}text(w,b,L={}){w=this.f(w,L);const T=this.a.getValue(),Y=b&&b.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(b?.map(r.$ti),L),type:2,contentPattern:w,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:T.search.usePCRE2||Y||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(w,b){const L=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const T={...w,wordSeparators:L.editor.wordSeparators};return this.j(w,b)&&(T.isCaseSensitive=!0),this.k(w)&&(T.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),T}file(w,b={}){return{...this.h(w,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(w,b){return w?(w=Array.isArray(w)?w.map(E):E(w),b?this.parseSearchPaths(w):{pattern:f(...Array.isArray(w)?w:[w])}):{}}h(w=[],b={}){const L=this.g(b.includePattern,b.expandPatterns),T=this.g(b.excludePattern,b.expandPatterns),Y=w.length>1,q=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(F=>this.q(F,b,T)):w.map(F=>this.r(F,b,T,Y))).filter(F=>!!F),U={_reason:b._reason,folderQueries:q,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:T.pattern,includePattern:L.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const F=S.$Hb(S.$Rb(this.c.groups.map(ue=>ue.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const W=F.filter(ue=>(0,o.$VJ)(U,ue.fsPath)),re=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...U,...re}}const C=b.extraFileResources&&b.extraFileResources.filter(F=>(0,o.$VJ)(U,F.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(w){const b=[],L=new R.$Ac,T={};let Y=!1;return w.forEach(q=>{if(q.scheme===m.Schemas.walkThrough)return;if((0,D.$Pg)(q)){const C=this.b.getWorkspaceFolder(q)?.uri??q.with({path:g.$mc(q.fsPath)});let F=L.get(C);F||(Y=!0,F={folder:C,includePattern:{}},b.push(F),L.set(C,F));const W=g.$lc(C.fsPath,q.fsPath);(0,k.$Xf)(F.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(Y=!0,T[q.fsPath]=!0)}),{folderQueries:b,includePattern:T,usingSearchPaths:!0,excludePattern:Y?void 0:{"**/*":!0}}}j(w,b){if(b.isSmartCase){if(w.isRegExp){if(A.$Df(w.pattern,!0))return!0}else if(A.$Df(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,v.$9B)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const b=re=>g.$ic(re)||/^\.\.?([\/\\]|$)/.test(re),T=(Array.isArray(w)?w:c(w)).map(re=>{const ue=this.e.resolvedUserHome;return ue?(0,N.$4v)(re,ue.scheme===m.Schemas.file?ue.fsPath:ue.path):re}),Y=M.$K(T,re=>b(re)?"searchPaths":"exprSegments"),q=(Y.exprSegments||[]).map(re=>A.$Xe(re,"/")).map(re=>A.$Xe(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),u(re))),U={},C=this.m(Y.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const F=S.$Rb(q),W=f(...F);return W&&(U.pattern=W),U}l(w,b){return b.disregardExcludeSettings?void 0:(0,o.$UJ)(w,!b.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const b=w.flatMap(T=>{let{pathPortion:Y,globPortion:q}=t(T);return q&&(q=y(q)),this.n(Y).flatMap(C=>this.o(C,q))}),L=new Map;return b.forEach(T=>{const Y=T.searchPath.toString(),q=L.get(Y);q?T.pattern&&(q.pattern=q.pattern||{},q.pattern[T.pattern]=!0):L.set(Y,{searchPath:T.searchPath,pattern:T.pattern?f(T.pattern):void 0})}),Array.from(L.values())}n(w){if(g.$ic(w)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==m.Schemas.file?[{searchPath:b[0].uri.with({path:w})}]:[{searchPath:l.URI.file(g.$hc(w))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(w=E(w),w.startsWith("../")||w===".."){const T=g.$gc.resolve(b.path,w);return[{searchPath:b.with({path:T})}]}const L=y(w);return[{searchPath:b,pattern:L}]}else{if(w==="./"||w===".\\")return[];{const b=w.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(Y=>{const q=b.match(new RegExp(`^${A.$Re(Y.name)}(?:/(.*)|$)`));return q?{match:q,folder:Y}:null}).filter(k.$Uf);if(T.length)return T.map(Y=>{const q=Y.match[1];return{searchPath:Y.folder.uri,pattern:q&&y(q)}});{const Y=w.match(/\.[\/\\](.+)[\/\\]?/),q=Y?Y[1]:w,U=p.localize(0,null,q);throw new Error(U)}}}}o(w,b){const L=w.pattern&&b?`${w.pattern}/${b}`:w.pattern||b,T=[{searchPath:w.searchPath,pattern:L}];return L&&!L.endsWith("**")&&T.push({searchPath:w.searchPath,pattern:L+"/**"}),T}q(w,b,L){const T=this.r((0,r.$ti)(w.searchPath),b,L,!1);return T?{...T,includePattern:w.pattern}:null}r(w,b,L,T){let Y;const q=l.URI.isUri(w)?w:w.uri;if(L.searchPaths){const re=L.searchPaths.filter(ue=>(0,D.$Eg)(ue.searchPath,q))[0];if(re&&!re.pattern)return null;re&&(Y=re.pattern)}const U=this.a.getValue({resource:q}),F={...this.l(U,b)||{},...Y||{}},W=l.URI.isUri(w)?(0,D.$Ig)(w):w.name;return{folder:q,folderName:T?W:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!U.search.followSymlinks}}};e.$8K=h,e.$8K=h=Je([qe(0,s.$Ei),qe(1,r.$hi),qe(2,i.$dD),qe(3,a.$sj),qe(4,n.$6K)],h);function t(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const b=w.index,L=d.substr(0,b).match(/[/|\\][^/\\]*$/);if(L){let T=d.substr(0,L.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:d.substr((L.index||0)+1)}}}return{pathPortion:d}}function f(...d){return d.length?d.reduce((w,b)=>(w[b]=!0,w),Object.create(null)):void 0}function c(d){return P.$Pj(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function u(d){return[`**/${d}/**`,`**/${d}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function E(d){return d.replace(/\\/g,"/")}function y(d){return E(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(d){return d.replace(/([?*[\]])/g,"[$1]")}function I(d,w){d=S.$Mb(d,T=>T.toString());const b=[],L=w.getWorkspace();return d&&d.forEach(T=>{let Y;if(w.getWorkbenchState()===2)Y=(0,D.$Ng)(L.folders[0].uri,T),Y&&Y!=="."&&(Y="./"+Y);else{const q=w.getWorkspaceFolder(T);if(q){const U=q.name;if(L.folders.filter(F=>F.name===U).length===1){const F=(0,D.$Ng)(q.uri,T);F===""?Y=`./${q.name}`:Y=`./${q.name}/${F}`}else Y=T.fsPath}}Y&&b.push($(Y))}),b}e.$9K=I}),define(Le[289],Me([1,0,24,2,21,15,4,288,44,48,11]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rtb=e.$Qtb=void 0;const k=7e3;function l(a,r){const i=r.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],o=[];for(const E of i)if(/^workspaceContains:/.test(E)){const y=E.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||a.forceUsingSearch?o.push(y):n.push(y)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:h,resolve:t}=(0,A.$4g)(),f=E=>t({activationEvent:E}),c=Promise.all(n.map(E=>v(a,E,f))).then(()=>{}),u=p(a,r.identifier,o,f);return Promise.all([c,u]).then(()=>{t(void 0)}),h}e.$Qtb=l;async function v(a,r,i){for(const n of a.folders)if(await a.exists(S.$Lg(M.URI.revive(n),r))){i(`workspaceContains:${r}`);return}}async function p(a,r,i,n){if(i.length===0)return Promise.resolve(void 0);const o=new P.$9d,h=a.checkExists(a.folders,i,o.token),t=setTimeout(async()=>{o.cancel(),a.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},k);let f=!1;try{f=await h}catch(c){N.$4(c)||N.$1(c)}o.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function s(a,r,i,n){const o=a.get(R.$0h),h=a.get(g.$MJ),f=o.createInstance(m.$8K).file(r.map(c=>(0,D.$ti)(M.URI.revive(c))),{_reason:"checkExists",includePattern:i,exists:!0});return h.fileSearch(f,n).then(c=>!!c.limitHit,c=>N.$4(c)?!1:Promise.reject(c))}e.$Rtb=s}),define(Le[38],Me([1,0,161,19,87,24,11,6,51,2,14,3,37,219,82,36,25,106,15,22,23,202,7,100,4,27,84,17,71,85,65,5,289,81,204,12,79,63,20,80]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f,c,u,E,y,$,I,d,w,b,L,T,Y,q,U,C,F){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=e.$Uhc=e.$Thc=e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,c.$$h)("IHostUtils");let re=W=class extends m.$Tc{constructor(X,V,ne,Ce,Fe,Pe,we,me,J,x,le,de){super(),this.X=de,this.a=this.B(new w.$Yd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=we,this.j=Ce,this.m=Fe,this.s=Pe,this.t=J,this.u=x,this.w=le,this.y=this.g.getProxy(k.$rL.MainThreadWorkspace),this.z=this.g.getProxy(k.$rL.MainThreadTelemetry),this.C=this.g.getProxy(k.$rL.MainThreadExtensionService),this.D=new R.$0g,this.F=new R.$0g,this.G=new R.$0g,this.H=new R.$0g,this.I=new $e(this.f.extensions.activationEvents),this.L=new r.$U8b(this.I,this.f.extensions.allExtensions);const Ae=new n.$rm(this.f.extensions.myExtensions);this.J=new r.$U8b(this.I,ve(this.L,Ae)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new p.$Chc(this.g,this.s),this.N=new L.$Khc(this.g),this.O=me,this.h=X.createChild(new $.$9h([p.$Dhc,this.M],[L.$Lhc,this.N])),this.P=this.B(new v.$Bhc(this.J,this.L,{onExtensionActivationError:(ge,Se,Ie)=>{this.C.$onExtensionActivationError(ge,i.$3(Se),Ie)},actualActivateExtension:async(ge,Se)=>{if(r.$U8b.isHostExtension(ge,this.J,this.L))return await this.C.$activateExtension(ge,Se),new v.$Ahc;const Ie=this.J.getExtensionDescription(ge);return this.db(Ie,Se)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(X){i.$1(X)}}async Y(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Fe=>Fe.identifier).filter(Fe=>this.isActivated(Fe)).map(Fe=>this.cb(Fe))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ce=>{this.s.error(Ce)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$_g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new n.$qm(V.identifier.value),extensionLocation:D.URI.revive(V.extensionLocation)}}Z(X,V){return this.P.activateByEvent(X,V)}$(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.$(X,V).then(()=>{const ne=this.P.getActivatedExtension(X);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async ab(X){if(X.scheme===Y.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(X.fsPath);return D.URI.file(V)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(X=>new se(X))),this.Q}async bb(X){const V=g.$ei.forUris(ne=>N.$Cg.ignorePathCasing(ne));return await Promise.all(X.map(async ne=>{if(this.ub(ne)){const Ce=await this.ab(ne.extensionLocation);V.set(Ce,ne)}})),V}cb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const ne=this.P.getActivatedExtension(X);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ce=>(this.s.error(Ce),Promise.resolve(void 0))))}catch(Ce){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(Ce)}try{(0,m.$Oc)(ne.subscriptions)}catch(Ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(Ce)}return V}async db(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.fb(X,V).then(ne=>{const Ce=ne.activationTimes;return this.C.$onDidActivateExtension(X.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,V),this.eb(X,V,"success",Ce),ne},ne=>{throw this.eb(X,V,"failure"),ne})}eb(X,V,ne,Ce){const Fe=ye(X,V);this.z.$publicLog2("extensionActivationTimes",{...Fe,...Ce||{},outcome:ne})}fb(X,V){const ne=ye(X,V);this.z.$publicLog2("activatePlugin",ne);const Ce=this.ub(X);if(!Ce)return Promise.resolve(new v.$zhc(v.$whc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Fe=new v.$xhc(V.startup);return Promise.all([this.vb(X,(0,N.$Lg)(X.extensionLocation,Ce),Fe),this.gb(X)]).then(Pe=>(P.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),W.hb(this.s,X.identifier,Pe[0],Pe[1],Fe))).then(Pe=>(P.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Pe))}gb(X){const V=new h.$Fhc(X,this.M),ne=new h.$Ehc(X.identifier.value,!1,this.M),Ce=new T.$Mhc(X,this.N),Fe=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Pe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const we=this;let me,J;const x=(0,a.$NF)(X,"ipc")?this.f.messagePorts?.get(n.$qm.toKey(X.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ce,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(le){return M.$jc(X.extensionLocation.fsPath,le)},get storagePath(){return we.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return we.O.globalValue(X).fsPath},get logPath(){return M.$jc(we.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return D.URI.joinPath(we.f.logsLocation,X.identifier.value)},get storageUri(){return we.O.workspaceValue(X)},get globalStorageUri(){return we.O.globalValue(X)},get extensionMode(){return Fe},get extension(){return me===void 0&&(me=new he(we,X.identifier,X,Pe,!1)),me},get extensionRuntime(){return(0,a.$OF)(X,"extensionRuntime"),we.extensionRuntime},get environmentVariableCollection(){return we.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!J){if(!x)return;const le=w.Event.buffer(w.Event.fromDOMEventEmitter(x,"message",de=>de.data));x.start(),J={onDidReceiveMessage:le,postMessage:x.postMessage.bind(x)}}return J}})})}static hb(X,V,ne,Ce,Fe){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(X,V,ne,Ce,Fe).then(Pe=>new v.$yhc(!1,null,Fe.build(),ne,Pe,Ce.subscriptions))}static ib(X,V,ne,Ce,Fe){if(typeof ne.activate=="function")try{Fe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Pe=typeof global=="object"?global:self,we=ne.activate.apply(Pe,[Ce]);return Fe.activateCallStop(),Fe.activateResolveStart(),Promise.resolve(we).then(me=>(Fe.activateResolveStop(),me))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(ne)}jb(X,V){this.$(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(X,V=0){const Ce=Date.now();(0,C.$B)(()=>{for(let Fe=V;Fe<X.length;Fe+=1){const Pe=X[Fe];for(const we of Pe.activationEvents??[])if(we==="onStartupFinished")if(Date.now()-Ce>50){this.kb(X,Fe);break}else this.jb(Pe,we)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ce of ne)if(Ce.activationEvents)for(const Fe of Ce.activationEvents)Fe==="onStartupFinished"&&this.jb(Ce,Fe)})}mb(){const X=this.Z("*",!0).then(void 0,Pe=>{this.s.error(Pe)});this.B(this.j.onDidChangeWorkspace(Pe=>this.nb(Pe.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ce=this.pb(),Fe=Promise.all([Ce,X,ne]).then(()=>{});return Promise.race([Fe,(0,R.$_g)(1e4)]).then(()=>{this.lb()}),Fe}nb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(X,V))).then(()=>{})}async ob(X,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ce={logService:this.s,folders:X.map(Pe=>Pe.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Pe=>this.c.fsExists(Pe.fsPath),checkExists:(Pe,we,me)=>this.y.$checkExists(Pe,we,me)},Fe=await(0,b.$Qtb)(Ce,V);if(Fe)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Fe.activationEvent}).then(void 0,Pe=>this.s.error(Pe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(X){throw console.error(X),X}}async qb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(S.localize(0,null));const ne=await this.vb(null,V,new v.$xhc(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(1,null,V.toString()));return new Promise((Ce,Fe)=>{const Pe=(J,x)=>{J?(C.$t&&this.s.error("Test runner called back with error",J),Fe(J)):(C.$t&&(x?this.s.info(`Test runner called back with ${x} failures.`):this.s.info("Test runner called back with successful outcome.")),Ce(typeof x=="number"&&x>0?1:0))},we=(0,N.$zg)(V),me=ne.run(we,Pe);me&&me.then&&me.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ce(0)}).catch(J=>{C.$t&&this.s.error("Test runner finished with error",J),Fe(J instanceof Error&&J.stack?J.stack:String(J))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$_g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.R[X]=V,(0,m.$Rc)(()=>{delete this.R[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.sb(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async sb(X){const V=X.indexOf("+");if(V===-1)throw new t.$zL("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=X.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(X,V){const ne=U.$Ud.create(!1),Ce=()=>`[resolveAuthority(${(0,f.$el)(X)},${V})][${ne.elapsed()}ms] `,Fe=G=>this.s.info(`${Ce()}${G}`),Pe=G=>this.s.warn(`${Ce()}${G}`),we=(G,B=void 0)=>this.s.error(`${Ce()}${G}`,B),me=G=>{if(G instanceof t.$zL)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},J=async G=>{Fe(`activating resolver for ${G}...`);const{resolver:B,authorityPrefix:H}=await this.sb(G);if(!B)throw we(`no resolver for ${H}`),new t.$zL(`No remote extension installed to resolve ${H}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:B,authorityPrefix:H,remoteAuthority:G}},x=X.split(/@|%40/g).reverse();Fe(`activating remote resolvers ${x.join(" -> ")}`);let le;try{le=await Promise.all(x.map(J)).catch(async G=>{if(!(G instanceof t.$zL)||G._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return Pe(`resolving nested authorities failed: ${G.message}`),[await J(X)]})}catch(G){return me(G)}const de=new R.$jh;de.cancelAndSet(()=>Fe("waiting..."),1e3);let Ae,ge;for(const[G,{authorityPrefix:B,resolver:H,remoteAuthority:Q}]of le.entries())try{if(G===le.length-1)Fe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${B}`),Ae=await H.resolve(Q,{resolveAttempt:V,execServer:ge}),P.mark(`code/extHost/didResolveAuthorityOK/${B}`),Fe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$yL.isManagedResolvedAuthority(Ae)?Ae:void 0));else{if(Fe(`invoking resolveExecServer() for ${Q}`),P.mark(`code/extHost/willResolveExecServer/${B}`),ge=await H.resolveExecServer?.(Q,{resolveAttempt:V,execServer:ge}),!ge)throw new t.$zL(`Exec server was not available for ${Q}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${B}`)}}catch(ae){return P.mark(`code/extHost/didResolveAuthorityError/${B}`),we("returned an error",ae),de.dispose(),me(ae)}de.dispose();const Se={environmentTunnels:Ae.environmentTunnels,features:Ae.tunnelFeatures?{elevation:Ae.tunnelFeatures.elevation,privacyOptions:Ae.tunnelFeatures.privacyOptions,protocol:Ae.tunnelFeatures.protocol===void 0?!0:Ae.tunnelFeatures.protocol}:void 0},Ie={extensionHostEnv:Ae.extensionHostEnv,isTrusted:Ae.isTrusted,authenticationSession:Ae.authenticationSessionForInitializingExtensions?{id:Ae.authenticationSessionForInitializingExtensions.id,providerId:Ae.authenticationSessionForInitializingExtensions.providerId}:void 0};Fe(`returned ${t.$yL.isManagedResolvedAuthority(Ae)?"managed authority":`${Ae.host}:${Ae.port}`}`);let O;if(t.$yL.isManagedResolvedAuthority(Ae)){const G=V;this.X.setFactory(G,Ae.makeConnection),O={authority:X,connectTo:new f.$bl(G),connectionToken:Ae.connectionToken}}else O={authority:X,connectTo:new f.$cl(Ae.host,Ae.port),connectionToken:Ae.connectionToken};return{type:"ok",value:{authority:O,options:Ie,tunnelInformation:Se}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$el)(X)})`);const{resolver:ne}=await this.sb(X);if(!ne)return null;const Ce=D.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ce;const Fe=await(0,R.$3g)(()=>ne.getCanonicalURI(Ce));return Fe||Ce}$startExtensionHost(X){X.toAdd.forEach(Ce=>Ce.extensionLocation=D.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ue(this.I,this.L,this.J,X);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(X,V){return V===1?this.D.wait().then(ne=>this.Z(X,!1)):this.G.wait().then(ne=>this.Z(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.$(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Pe=>Pe.extensionLocation=D.URI.revive(Pe.extensionLocation));const{globalRegistry:V,myExtensions:ne}=ue(this.I,this.L,this.J,X),Ce=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=o.$me.alloc(X),ne=Math.random()%256;for(let Ce=0;Ce<X;Ce++)V.writeUInt8(ne,Ce);return V}async $updateRemoteConnectionData(X){this.W=X,this.a.fire()}};e.$Shc=re,e.$Shc=re=W=Je([qe(0,c.$0h),qe(1,e.$Rhc),qe(2,y.$JN),qe(3,s.$fhc),qe(4,l.$ihc),qe(5,A.$sj),qe(6,u.$ZN),qe(7,E.$lhc),qe(8,I.$Kzb),qe(9,d.$Ghc),qe(10,q.$Ohc),qe(11,F.$Phc)],re);function ue(te,X,V,ne){te.addActivationEvents(ne.addActivationEvents);const Ce=new r.$U8b(te,X.getAllExtensionDescriptions());Ce.deltaExtensions(ne.toAdd,ne.toRemove);const Fe=new n.$rm(V.getAllExtensionDescriptions().map(we=>we.identifier));for(const we of ne.myToRemove)Fe.delete(we);for(const we of ne.myToAdd)Fe.add(we);const Pe=ve(Ce,Fe);return{globalRegistry:Ce,myExtensions:Pe}}function ye(te,X){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function ke(te){return te.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$Thc=(0,c.$$h)("IExtHostExtensionService");class he{#e;#t;#i;constructor(X,V,ne,Ce,Fe){this.#e=X,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=M.$hc((0,N.$zg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ce,this.isFromDifferentExtensionHost=Fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Uhc=he;function ve(te,X){return te.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class se{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$Vhc=se;class $e{constructor(X){this.a=new n.$sm,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Le[290],Me([1,0,87,2,3,37,25,22,17,27,4,38,14,13]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=void 0;let s=class{constructor(o,h,t,f,c,u,E){this.c=o,this.d=h,this.e=t,this.f=f,this.g=c,this.h=u,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,o,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,h,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const h of o.nodeModuleName)this.a.set(h,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(h=>o.alternativeModuleName(h))}};e.$4ic=s,e.$4ic=s=Je([qe(2,A.$0h),qe(3,N.$ihc),qe(4,k.$Thc),qe(5,D.$ZN),qe(6,l.$sj)],s);let a=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const h=(0,v.$Re)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${c}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const h=this.b.exec(this.c(o));if(!h)return;const[,t,f,c]=h,u=p.a.get(f);if(u!==void 0)return console.warn(`${f} as been renamed to ${u}, please update your imports`),t+u+c}c(o){return o.replace(/\\/g,"/")}};a=p=Je([qe(0,D.$ZN)],a);class r{constructor(o,h,t,f,c){this.c=o,this.d=h,this.e=t,this.f=f,this.g=c,this.nodeModuleName="vscode",this.a=new m.$sm}load(o,h){const t=this.d.findSubstr(h);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((c,u)=>f+=`	${u} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${f}`),this.b=this.c(R.$IF,this.e,this.f)}return this.b}}let i=class{constructor(o,h,t){this.e=o,this.f=h,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$rL.MainThreadTelemetry);const f=t.getProxy(P.$rL.MainThreadWindow);this.c=(c,u)=>{const E=M.URI.parse(c);return u?this.g(c,u):E.scheme==="http"||E.scheme==="https"?f.$openUri(E,c,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?f.$openUri(E,c,{}):this.g(c,u)}}load(o,h,t){const f=this.e.findSubstr(h);return f&&(this.a=f.identifier.value,this.h()),this.b=t(o),this.c}g(o,h){return this.i(),this.b(o,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([qe(2,g.$JN)],i)}),define(Le[117],Me([1,0,39,6,19,73,4,66,64,38,7,36,216,37]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=e.$Whc=void 0,e.$Whc=(0,R.$$h)("IExtHostVariableResolverProvider");class p extends l.$KO{constructor(r,i,n,o,h,t,f){function c(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const E=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof A.$cN||E.input instanceof A.$hN)return E.input.modified;if(E.input instanceof A.$bN||E.input instanceof A.$gN||E.input instanceof A.$eN)return E.input.uri}}}super({getFolderUri:u=>{const E=t.folders.filter(y=>y.name===u);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,E)=>h.getConfiguration(void 0,u).get(E),getAppRoot:()=>N.cwd(),getExecPath:()=>N.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=c();if(u)return P.$hc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=c();if(u){const E=i.getWorkspaceFolder(u);if(E)return P.$hc(E.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>r.getExtension(u)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(N.env))}}let s=class extends M.$Tc{constructor(r,i,n,o,h){super(),this.b=r,this.c=i,this.g=n,this.h=o,this.j=h,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xhc=s,e.$Xhc=s=Je([qe(0,D.$Thc),qe(1,k.$fhc),qe(2,m.$UN),qe(3,v.$ihc),qe(4,g.$uhc)],s)}),define(Le[118],Me([1,0,11,5,2,22,4,3,64,38,17,7,36,208,210,37,117,6,40,31,8]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=e.$2hc=e.$1hc=e.$Zhc=e.$Yhc=void 0,e.$Yhc=(0,R.$$h)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor($,I,d,w,b,L,T){this.N=I,this.O=d,this.P=w,this.Q=b,this.R=L,this.S=T,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new M.$Yd,this.o=new M.$Yd,this.q=new M.$Yd,this.w=new M.$Yd,this.l=$.getProxy(m.$rL.MainThreadDebugService),this.A=new M.$Yd,this.C=new M.$Yd,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(Y=>{Y.onDidChange(q=>{this.V(Y)}),this.V(Y)})}async $getVisualizerTreeItem($,I){const d=this.W(I);if(!d)return;const w=await this.H.get($)?.getTreeItem?.(d);return w?this.U($,w):void 0}registerDebugVisualizationTree($,I,d){const w=N.$qm.toKey($.identifier),b=this.jb(w,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(b,d),this.l.$registerDebugVisualizerTree(b,!!d.editItem),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(b),this.H.delete(I)})}async $getVisualizerTreeItemChildren($,I){const d=this.J.get(I)?.item;return d?(await this.H.get($)?.getChildren?.(d))?.map(b=>this.U($,b))||[]:[]}async $editVisualizerTreeItem($,I){const d=this.J.get($);if(!d)return;const w=await this.H.get(d.provider)?.editItem?.(d.item,I);return this.U(d.provider,w||d.item)}$disposeVisualizedTree($){const I=this.J.get($);if(!I)return;const d=[I.children];for(const w of d)if(w)for(const b of w)d.push(this.J.get(b)?.children),this.J.delete(b)}U($,I){let d=this.I.get(I);return d||(d=this.F++,this.I.set(I,d),this.J.set(d,{provider:$,item:I})),o.DebugTreeItem.from(I,d)}asDebugSourceUri($,I){const d=$;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let w=`debug:${encodeURIComponent(d.path||"")}`,b="?";return I&&(w+=`${b}session=${encodeURIComponent(I.id)}`,b="&"),w+=`${b}ref=${d.sourceReference}`,P.URI.parse(w)}else{if(d.path)return P.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V($){const I=[];for(const d of $.getAllExtensionDescriptions())if(d.contributes){const w=d.contributes.debuggers;if(w&&w.length>0)for(const b of w)(0,p.$kG)(b)&&I.push(b.type)}this.l.$registerDebugTypes(I)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const $=[];return this.z.forEach(I=>$.push(I)),$}async $resolveDebugVisualizer($,I){const d=this.L.get($);if(!d)throw new Error(`No debug visualizer found with id '${$}'`);let{v:w,provider:b,extensionId:L}=d;if(w.visualization||(w=await b.resolveDebugVisualization?.(w,I)||w,d.v=w),!w.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${b}'`);return this.kb(L,w.visualization)}async $executeDebugVisualizerCommand($){const I=this.L.get($);if(!I)throw new Error(`No debug visualizer found with id '${$}'`);const d=I.v.visualization;d&&"command"in d&&this.S.executeCommand(d.command,...d.arguments||[])}W($){const I=this.m.get($.sessionId);return I&&{session:I.api,variable:$.variable,containerId:$.containerId,frameId:$.frameId,threadId:$.threadId}}async $provideDebugVisualizers($,I,d,w){const b=this.W(d),L=this.jb($,I),T=this.G.get(L);if(!b||!T)return[];const Y=await T.provideDebugVisualization(b,w);return Y?Y.map(q=>{const U=++this.M;this.L.set(U,{v:q,provider:T,extensionId:$});const C=q.iconPath?this.lb(q.iconPath):void 0;return{id:U,name:q.name,iconClass:C?.iconClass,iconPath:C?.iconPath,visualization:this.kb($,q.visualization)}}):[]}$disposeDebugVisualizers($){for(const I of $)this.L.delete(I)}registerDebugVisualizationProvider($,I,d){if(!$.contributes?.debugVisualizers?.some(L=>L.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const w=N.$qm.toKey($.identifier),b=this.jb(w,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(b,d),this.l.$registerDebugVisualizer(w,I),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizer(w,I),this.G.delete(I)})}addBreakpoints($){const I=$.filter(b=>{const L=b.id;return this.z.has(L)?!1:(this.z.set(L,b),!0)});this.gb(I,[],[]);const d=[],w=new Map;for(const b of I)if(b instanceof k.$tM){let L=w.get(b.location.uri.toString());L||(L={type:"sourceMulti",uri:b.location.uri,lines:[]},w.set(b.location.uri.toString(),L),d.push(L)),L.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character})}else b instanceof k.$uM&&d.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName});return this.l.$registerBreakpoints(d)}removeBreakpoints($){const I=$.filter(L=>this.z.delete(L.id));this.gb([],I,[]);const d=I.filter(L=>L instanceof k.$tM).map(L=>L.id),w=I.filter(L=>L instanceof k.$uM).map(L=>L.id),b=I.filter(L=>L instanceof k.$vM).map(L=>L.id);return this.l.$unregisterBreakpoints(d,w,b)}startDebugging($,I,d){return this.l.$startDebugging($?$.uri:void 0,I,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging($){return this.l.$stopDebugging($?$.id:void 0)}registerDebugConfigurationProvider($,I,d){if(!I)return new k.$tL(()=>{});const w=this.d++;return this.f.push({type:$,handle:w,provider:I}),this.l.$registerDebugConfigurationProvider($,d,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,w),new k.$tL(()=>{this.f=this.f.filter(b=>b.provider!==I),this.l.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory($,I,d){if(!d)return new k.$tL(()=>{});if(!this.cb($,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:I,handle:w,factory:d}),this.l.$registerDebugAdapterDescriptorFactory(I,w),new k.$tL(()=>{this.h=this.h.filter(b=>b.factory!==d),this.l.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory($,I){if(!I)return new k.$tL(()=>{});const d=this.j++;return this.k.push({type:$,handle:d,factory:I}),new k.$tL(()=>{this.k=this.k.filter(w=>w.factory!==I)})}async $runInTerminal($,I){return Promise.resolve(void 0)}async $substituteVariables($,I){let d;const w=await this.ib($);return w&&(d={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(d,I)}X($,I){if($.type==="implementation")return new u($.implementation)}Y(){}async $startDASession($,I){const d=this,w=await this.hb(I);return this.eb(this.$(w.type),w).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const L=this.Z(b),T=this.X(L,w);if(!T)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const Y=T;return this.D.set($,Y),this.db(w).then(q=>(q&&this.E.set($,q),Y.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const C=U,F={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const W=await this.K.sign(C.arguments.value);F.body={signature:W},Y.sendResponse(F)}else throw new Error("no signer")}catch(W){F.success=!1,F.message=W.message,Y.sendResponse(F)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(U),U=(0,p.$pG)(U,!0),d.l.$acceptDAMessage($,U)}),Y.onError(U=>{q&&q.onError&&q.onError(U),this.l.$acceptDAError($,U.name,U.message,U.stack)}),Y.onExit(U=>{q&&q.onExit&&q.onExit(U??void 0,void 0),this.l.$acceptDAExit($,U??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),Y.startSession()))})}$sendDAMessage($,I){I=(0,p.$oG)(I,!1);const d=this.E.get($);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(I),this.D.get($)?.sendMessage(I)}$stopDASession($){const I=this.E.get($);this.E.delete($),I&&I.onWillStopSession&&I.onWillStopSession();const d=this.D.get($);return this.D.delete($),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta($){const I=[],d=[],w=[];if($.added)for(const b of $.added){const L=b.id;if(L&&!this.z.has(L)){let T;if(b.type==="function")T=new k.$uM(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage);else if(b.type==="data")T=new k.$vM(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage);else{const Y=P.URI.revive(b.uri);T=new k.$tM(new k.$FL(Y,new k.$uL(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage)}(0,k.$rM)(T,L),this.z.set(L,T),I.push(T)}}if($.removed)for(const b of $.removed){const L=this.z.get(b);L&&(this.z.delete(b),d.push(L))}if($.changed){for(const b of $.changed)if(b.id){const L=this.z.get(b.id);if(L){if(L instanceof k.$uM&&b.type==="function"){const T=L;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.functionName=b.functionName}else if(L instanceof k.$tM&&b.type==="source"){const T=L;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.location=new k.$FL(P.URI.revive(b.uri),new k.$uL(b.line,b.character))}w.push(L)}}}this.gb(I,d,w)}async $acceptStackFrameFocus($){let I;const d=$.sessionId?await this.hb($.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");$.kind==="thread"?I=new k.$BM(d.api,$.threadId):I=new k.$AM(d.api,$.threadId,$.frameId),this.B=I,this.C.fire(this.B)}$provideDebugConfigurations($,I,d){return(0,S.$3g)(async()=>{const w=this.bb($);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.ib(I);return w.provideDebugConfigurations(b,d)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration($,I,d,w){return(0,S.$3g)(async()=>{const b=this.bb($);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.ib(I);return b.resolveDebugConfiguration(L,d,w)})}$resolveDebugConfigurationWithSubstitutedVariables($,I,d,w){return(0,S.$3g)(async()=>{const b=this.bb($);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.ib(I);return b.resolveDebugConfigurationWithSubstitutedVariables(L,d,w)})}async $provideDebugAdapter($,I){const d=this.ab($);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.hb(I);return this.eb(d,w).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.Z(b)})}async $acceptDebugSessionStarted($){const I=await this.hb($);this.n.fire(I.api)}async $acceptDebugSessionTerminated($){const I=await this.hb($);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged($){this.u=$?await this.hb($):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged($,I){(await this.hb($))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent($,I){const w={session:(await this.hb($)).api,event:I.event,body:I.body};this.w.fire(w)}Z($){if($ instanceof k.$wM)return{type:"executable",command:$.command,args:$.args,options:$.options};if($ instanceof k.$xM)return{type:"server",port:$.port,host:$.host};if($ instanceof k.$yM)return{type:"pipeServer",path:$.path};if($ instanceof k.$zM)return{type:"implementation",implementation:$.implementation};throw new Error("convertToDto unexpected type")}$($){const I=this.h.filter(d=>d.type===$);if(I.length>0)return I[0].factory}ab($){const I=this.h.filter(d=>d.handle===$);if(I.length>0)return I[0].factory}bb($){const I=this.f.filter(d=>d.handle===$);if(I.length>0)return I[0].provider}cb($,I){if($.contributes){const d=$.contributes.debuggers;if(d&&d.length>0){for(const w of d)if(w.label&&w.type&&w.type===I)return!0}}return!1}db($){const d=$.configuration.type,w=this.k.filter(b=>b.type===d||b.type==="*").map(b=>(0,S.$3g)(()=>b.factory.createDebugAdapterTracker($.api)).then(L=>L,L=>null));return Promise.race([Promise.all(w).then(b=>{const L=b.filter(T=>!!T);if(L.length>0)return new c(L)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async eb($,I){const d=I.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new k.$xM(d));if($){const b=await this.O.getExtensionRegistry();return(0,S.$3g)(()=>$.createDebugAdapterDescriptor(I.api,this.fb(I,b))).then(L=>{if(L)return L})}const w=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,w))}fb($,I){}gb($,I,d){($.length>0||I.length>0||d.length>0)&&this.A.fire(Object.freeze({added:$,removed:I,changed:d}))}async hb($){if($)if(typeof $=="string"){const I=this.m.get($);if(I)return I}else{let I=this.m.get($.id);if(!I){const d=await this.ib($.folderUri),w=$.parent?this.m.get($.parent):void 0;I=new t(this.l,$.id,$.type,$.name,d,$.configuration,w?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib($){if($){const I=P.URI.revive($);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb($,I){return`${$}\0${I}`}kb($,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${$}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb($){const I=this.mb($);let d,w;return"id"in I?w=i.ThemeIcon.asClassName(I):d=I,{iconPath:d,iconClass:w}}mb($){if($ instanceof k.$oM)return{id:$.id};const I=typeof $=="object"&&"dark"in $?$.dark:$,d=typeof $=="object"&&"light"in $?$.light:$;return{dark:typeof I=="string"?P.URI.file(I):I,light:typeof d=="string"?P.URI.file(d):d}}};e.$Zhc=h,e.$Zhc=h=Je([qe(0,A.$JN),qe(1,l.$fhc),qe(2,D.$Thc),qe(3,s.$ihc),qe(4,g.$uhc),qe(5,a.$Whc),qe(6,n.$6N)],h);class t{constructor($,I,d,w,b,L,T){this.f=$,this.g=I,this.h=d,this.j=w,this.k=b,this.l=L,this.m=T}get api(){const $=this;return this.d??=Object.freeze({id:$.g,type:$.h,get name(){return $.j},set name(I){$.j=I,$.f.$setDebugSessionName($.g,I)},parentSession:$.m,workspaceFolder:$.k,configuration:$.l,customRequest(I,d){return $.f.$customDebugAdapterRequest($.g,I,d)},getDebugProtocolBreakpoint(I){return $.f.$getDebugProtocolBreakpoint($.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged($){this.j=$}get configuration(){return this.l}}e.$1hc=t;class f{constructor($){this.value=Object.freeze({append(I){$.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$2hc=f;class c{constructor($){this.d=$}onWillStartSession(){this.d.forEach($=>$.onWillStartSession?$.onWillStartSession():void 0)}onWillReceiveMessage($){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage($):void 0)}onDidSendMessage($){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage($):void 0)}onWillStopSession(){this.d.forEach($=>$.onWillStopSession?$.onWillStopSession():void 0)}onError($){this.d.forEach(I=>I.onError?I.onError($):void 0)}onExit($,I){this.d.forEach(d=>d.onExit?d.onExit($,I):void 0)}}class u extends v.$Kmb{constructor($){super(),this.h=$,$.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage($){this.h.handleMessage($)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let E=class extends h{constructor($,I,d,w,b,L,T){super($,I,d,w,b,L,T)}};e.$3hc=E,e.$3hc=E=Je([qe(0,A.$JN),qe(1,l.$fhc),qe(2,D.$Thc),qe(3,s.$ihc),qe(4,g.$uhc),qe(5,a.$Whc),qe(6,n.$6N)],E)}),define(Le[291],Me([1,0,15,87,2,3,237,14,53,71,27,186,17,58,38,60]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=void 0;class a{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(m.$sj),t=n.get(l.$JN).getProxy(N.$rL.MainThreadErrors);S.setUnexpectedErrorHandler(f=>{o.error(f);const c=S.$3(f);t.$onUnexpectedError(c)})}static async installFullHandler(n){const o=n.get(m.$sj),h=n.get(l.$JN),t=n.get(p.$Thc),f=n.get(s.$4N),c=h.getProxy(N.$rL.MainThreadExtensionService),u=h.getProxy(N.$rL.MainThreadErrors),E=await t.getExtensionPathIndex(),y=new WeakMap;function $(w,b){if(y.has(w))return y.get(w).stack;let L="",T,Y;for(const U of b)L+=`
	at ${U.toString()}`,Y=U.getFileName(),!T&&Y&&(T=E.findSubstr(P.URI.file(Y)));const q=`${w.name||"Error"}: ${w.message||""}${L}`;return y.set(w,{extensionIdentifier:T?.identifier,stack:q}),q}const I=Symbol("prepareStackTrace wrapped");let d=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(w){if(w===$||!w||w[I]){d=w||$;return}d=function(b,L){return $(b,L),w.call(Error,b,L)},Object.assign(d,{[I]:!0})}}),S.setUnexpectedErrorHandler(w=>{o.error(w);const b=S.$3(w),L=y.get(w);if(!L?.extensionIdentifier){u.$onUnexpectedError(b);return}c.$onExtensionRuntimeError(L.extensionIdentifier,b);const T=f.onExtensionError(L.extensionIdentifier,w);o.trace("forwarded error to extension?",T,L)})}}e.$5ic=a;class r{constructor(n,o,h,t,f){this.a=h,this.b=new R.$38b(n,null,t),o=r.e(o,this.b);const c=new D.$9h(...(0,g.$5r)());c.set(A.$ZN,{_serviceBrand:void 0,...o,messagePorts:f}),c.set(l.$JN,new l.$KN(this.b)),c.set(v.$chc,new v.$dhc(t)),c.set(p.$Rhc,h);const u=new k.$Jq(c,!0);u.invokeFunction(a.installEarlyHandler),this.d=u.invokeFunction(E=>E.get(m.$sj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(E=>E.get(p.$Thc)),this.c.initialize(),u.invokeFunction(a.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(N.$rL.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=P.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const h=n.environment.extensionDevelopmentLocationURI;return h&&(n.environment.extensionDevelopmentLocationURI=h.map(t=>P.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=P.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$6ic=r}),define(Le[292],Me([1,0,18,11,21,41,12,19,24,2,44]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=e.$gic=e.$fic=e.$eic=void 0;class k{constructor(i,n,o,h){this.d=i,this.e=n,this.f=o,this.g=h,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],h=new P.$9d(n);return new Promise((t,f)=>{this.a=new v(i);let c=!1;const u=(E,y)=>{if(!c&&!this.b){const $=this.h(E);s(E)&&typeof this.d.maxResults=="number"&&this.c+$>this.d.maxResults&&(this.b=!0,c=!0,h.cancel(),E=this.j(E,this.d.maxResults-this.c));const I=this.h(E);this.c+=I,(I>0||!s(E))&&this.a.add(E,y)}};Promise.all(o.map((E,y)=>this.k(E,$=>u($,y),h.token))).then(E=>{h.dispose(),this.a.flush();const y=E.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||y,messages:(0,S.$Rb)(E.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.g}})},E=>{h.dispose();const y=(0,N.$Vi)(E);f(new Error(y))})})}h(i){return s(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],h=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:h.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const h=new A.$6J(this.d,i),t=[],f={report:E=>{if(!this.l(E))return;const y=i.folder.scheme===R.Schemas.file?(0,A.$7J)(()=>this.f.readdir(g.$Kg(E.uri))):void 0,$=g.$Ng(i.folder,E.uri);if($){const I=h.includedInQuery($,m.$nc($),y);(0,M.$Wg)(I)?t.push(I.then(d=>{d&&n(E)})):I&&n(E)}}},c=this.n(i),u=await this.e.provideTextSearchResults(l(this.d.contentPattern),c,f,o);return t.length&&await Promise.all(t),u}l(i){if(s(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$5J)(this.d.includePattern,i.includePattern),o=(0,A.$5J)(this.d.excludePattern,i.excludePattern),h={folder:D.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$eic=k;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new a(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!g.$Eg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(p(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$fic=v;function p(r){return s(r)?{preview:{matches:(0,S.$2b)(r.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:r.preview.text},ranges:(0,S.$2b)(r.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}e.$gic=s;class a{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$hic=a}),define(Le[119],Me([1,0,6,3,4,287,17,58,14,2,292]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=e.$iic=void 0,e.$iic=(0,P.$$h)("IExtHostSearch");let k=class{constructor(s,a,r){this.k=s,this.l=a,this.n=r,this.c=this.k.getProxy(M.$rL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new N.$dic}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,a){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,a),this.c.$registerTextSearchProvider(r,this.o(s)),(0,S.$Rc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,a){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,a),this.c.$registerFileSearchProvider(r,this.o(s)),(0,S.$Rc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,a,r,i){const n=l(r),o=this.h.get(s);if(o)return this.j.fileSearch(n,o,h=>{this.c.$handleFileMatch(s,a,h.map(t=>t.resource))},i);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,a,r){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,a,r,i){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const o=l(r);return this.q(o,n).search(t=>this.c.$handleTextMatch(s,a,t),i)}$enableExtensionHostSearch(){}q(s,a){return new A.$eic(s,a,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$jic=k,e.$jic=k=Je([qe(0,R.$JN),qe(1,m.$chc),qe(2,g.$sj)],k);function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(s=>D.URI.revive(s))}}e.$kic=l;function v(p){return{...p,folder:D.URI.revive(p.folder)}}}),define(Le[293],Me([1,0,21,15,5,6,12,32,2,147,143,131,92,22,42,14,56,57,199,3,240,271,78,241,247,225,248,249,250,226,214,31,251,37,252,118,108,253,228,242,254,255,66,64,243,38,257,62,258,43,27,272,273,244,229,259,260,79,80,231,286,262,203,263,274,264,113,232,265,266,267,17,268,119,81,269,233,270,82,84,116,60,65,275,276,245,277,278,85,8,7,234,58,235,61,279,280,107,36,209,77,25,115]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f,c,u,E,y,$,I,d,w,b,L,T,Y,q,U,C,F,W,re,ue,ye,ke,he,ve,se,$e,te,X,V,ne,Ce,Fe,Pe,we,me,J,x,le,de,Ae,ge,Se,Ie,O,G,B,H,Q,ae,Ee,Be,We,Qe,xe,ct,rt,et,ut,Ue,pt,Z,_,pe,Ve,Ye,nt,st,Te,Nt,Qt,ei,Ut,Et,ti,jt,si,Zt,Xt,Xe,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=void 0;function ii(ht){const mt=ht.get(X.$ZN),Kt=ht.get(te.$Ygc),ni=ht.get(se.$khc),Ct=ht.get(he.$Thc),dt=ht.get(si.$fhc),At=ht.get(Ue.$4N),oi=ht.get(L.$ihc),Lt=ht.get(Qt.$chc),He=ht.get(ae.$JN),Gt=ht.get(rt.$Dhc),Jt=ht.get(et.$lhc),_t=ht.get(s.$tj),ft=ht.get(s.$sj),Ft=ht.get(nt.$Kzb),Rt=ht.get(t.$Ugc),Tt=ht.get(jt.$Yic),Wt=ht.get(We.$Lhc),Ot=ht.get(ye.$uhc),kt=ht.get(J.$Phc);He.set(n.$sL.ExtHostFileSystemInfo,Kt),He.set(n.$sL.ExtHostLogLevelServiceShape,_t),He.set(n.$sL.ExtHostWorkspace,dt),He.set(n.$sL.ExtHostConfiguration,oi),He.set(n.$sL.ExtHostExtensionService,Ct),He.set(n.$sL.ExtHostStorage,Gt),He.set(n.$sL.ExtHostTunnelService,Ft),He.set(n.$sL.ExtHostWindow,Tt),He.set(n.$sL.ExtHostSecretState,Wt),He.set(n.$sL.ExtHostTelemetry,At),He.set(n.$sL.ExtHostEditorTabs,Ot),He.set(n.$sL.ExtHostManagedSockets,kt);const Vt=He.set(n.$sL.ExtHostDecorations,ht.get(q.$5hc)),yt=He.set(n.$sL.ExtHostDocumentsAndEditors,ht.get(ue.$UN)),bt=He.set(n.$sL.ExtHostCommands,ht.get(w.$6N)),St=He.set(n.$sL.ExtHostTerminalService,ht.get(pt.$Ghc)),Dt=He.set(n.$sL.ExtHostDebugService,ht.get(Y.$Yhc)),ci=He.set(n.$sL.ExtHostSearch,ht.get(Be.$iic)),Yt=He.set(n.$sL.ExtHostTask,ht.get(ut.$Lic)),gi=He.set(n.$sL.ExtHostOutputService,ht.get(O.$yic)),qt=He.set(n.$sL.ExtHostLocalization,ht.get(me.$Ohc)),mi=He.set(n.$sL.ExtHostUrls,new ei.$Vic(He)),Pt=He.set(n.$sL.ExtHostDocuments,new re.$2gc(He,yt)),be=He.set(n.$sL.ExtHostDocumentContentProviders,new F.$7hc(He,yt,ft)),Ne=He.set(n.$sL.ExtHostDocumentSaveParticipant,new W.$8hc(ft,Pt,He.getProxy(n.$rL.MainThreadBulkEdits))),oe=He.set(n.$sL.ExtHostNotebook,new le.$lic(He,bt,yt,Pt,ni,ci)),K=He.set(n.$sL.ExtHostNotebookDocuments,new Ae.$sic(oe)),Re=He.set(n.$sL.ExtHostNotebookEditors,new ge.$tic(ft,oe)),je=He.set(n.$sL.ExtHostNotebookKernels,new Se.$uic(He,mt,oe,bt,ft)),Ze=He.set(n.$sL.ExtHostNotebookRenderers,new Ie.$wic(He,oe)),Ke=He.set(n.$sL.ExtHostNotebookDocumentSaveParticipant,new de.$ric(ft,oe,He.getProxy(n.$rL.MainThreadBulkEdits))),tt=He.set(n.$sL.ExtHostEditors,new _.$_gc(He,yt)),wt=He.set(n.$sL.ExtHostTreeViews,new Ye.$Tic(He.getProxy(n.$rL.MainThreadTreeViews),bt,ft)),Ht=He.set(n.$sL.ExtHostEditorInsets,new d.$ahc(He.getProxy(n.$rL.MainThreadEditorInsets),tt,mt.remote)),zt=He.set(n.$sL.ExtHostDiagnostics,new U.$1gc(He,ft,Kt,yt)),It=He.set(n.$sL.ExtHostLanguages,new we.$pic(He,Pt,bt.converter,Lt)),ot=He.set(n.$sL.ExtHostLanguageFeatures,new Pe.$3gc(He,Lt,Pt,bt,zt,ft,Rt,At)),Qi=He.set(n.$sL.ExtHostFileSystem,new ve.$0hc(He,ot)),ui=He.set(n.$sL.ExtHostFileSystemEventService,new $e.$$hc(He,ft,yt)),$i=He.set(n.$sL.ExtHostQuickOpen,(0,Q.$Cic)(He,dt,bt)),yi=He.set(n.$sL.ExtHostSCM,new Ee.$Eic(He,bt,Pt,ft)),Ai=He.set(n.$sL.ExtHostQuickDiff,new H.$Bic(He,Lt)),Zi=He.set(n.$sL.ExtHostShare,new Qe.$Fic(He,Lt)),ln=He.set(n.$sL.ExtHostComments,(0,b.$bhc)(He,bt,Pt)),Li=He.set(n.$sL.ExtHostProgress,new B.$Aic(He.getProxy(n.$rL.MainThreadProgress))),Mi=He.set(n.$sL.ExtHostLabelService,new Fe.$oic(He)),Ei=He.set(n.$sL.ExtHostTheming,new pe.$Qic(He)),pi=He.set(n.$sL.ExtHostAuthentication,new f.$5gc(He)),Xi=He.set(n.$sL.ExtHostTimeline,new Ve.$Sic(He,bt)),Di=He.set(n.$sL.ExtHostWebviews,new Ut.$phc(He,mt.remote,dt,ft,Rt)),ki=He.set(n.$sL.ExtHostWebviewPanels,new Et.$shc(He,Di,dt)),_i=He.set(n.$sL.ExtHostCustomEditors,new T.$thc(He,Pt,Jt,Di,ki)),hn=He.set(n.$sL.ExtHostWebviewViews,new ti.$Wic(He,Di)),bi=He.set(n.$sL.ExtHostTesting,new Z.$Mic(He,ft,bt,yt)),Ni=He.set(n.$sL.ExtHostUriOpeners,new Nt.$Uic(He)),Fi=He.set(n.$sL.ExtHostProfileContentHandlers,new G.$zic(He));He.set(n.$sL.ExtHostInteractive,new ne.$mic(He,oe,yt,bt,ft));const dn=He.set(n.$sL.ExtHostInlineChat,new V.$_hc(He,bt,Pt,ft)),Si=He.set(n.$sL.ExtHostChatProvider,new y.$9gc(He,ft,pi)),xi=He.set(n.$sL.ExtHostChatAgents2,new E.$8gc(He,ft,bt)),fn=He.set(n.$sL.ExtHostChatVariables,new $.$0gc(He)),wi=He.set(n.$sL.ExtHostChat,new u.$7gc(He)),Ti=He.set(n.$sL.ExtHostAiRelatedInformation,new o.$Tgc(He)),en=He.set(n.$sL.ExtHostAiEmbeddingVector,new ke.$9hc(He)),Oi=He.set(n.$sL.ExtHostIssueReporter,new Ce.$nic(He)),tn=He.set(n.$sL.ExtHostStatusBar,new ct.$Iic(He,bt.converter)),zi=He.set(n.$sL.ExtHostSpeech,new xe.$Gic(He)),nn=Object.values(n.$sL);He.assertRegistered(nn);const di=new c.$6gc(He,yt),Ii=new I.$$gc(He),Ui=new x.$qic(He,ft),ri=new C.$6hc(He);return h.$4gc.register(bt),function(Oe,li,ji){function it(ee){return(ce,ze,at)=>{const vt=ee(Mt=>{try{ce.call(ze,Mt)}catch(Ri){M.$2(new Error(`[ExtensionListenerError] Extension '${Oe.identifier.value}' FAILED to handle event: ${Ri.toString()}`,{cause:Ri})),At.onExtensionError(Oe.identifier,Ri)}});return at?.push(vt),vt}}const $t=function(){let ee=!Oe.isUnderDevelopment;function ce(){ee||(ft.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")ce();else{const vt=at;typeof vt.scheme>"u"&&ce(),typeof vt.exclusive=="boolean"&&(0,Xe.$OF)(Oe,"documentFiltersExclusive")}return at}}(),gn={getSession(ee,ce,ze){return pi.getSession(Oe,ee,ce,ze)},getSessions(ee,ce){return(0,Xe.$OF)(Oe,"authGetSessions"),pi.getSessions(Oe,ee,ce)},async hasSession(ee,ce){return(0,Xe.$OF)(Oe,"authSession"),!!await pi.getSession(Oe,ee,ce,{silent:!0})},get onDidChangeSessions(){return it(pi.onDidChangeSessions)},registerAuthenticationProvider(ee,ce,ze,at){return pi.registerAuthenticationProvider(ee,ce,ze,at)}},rn={registerCommand(ee,ce,ze){return bt.registerCommand(!0,ee,ce,ze,void 0,Oe)},registerTextEditorCommand(ee,ce,ze){return bt.registerCommand(!0,ee,(...at)=>{const vt=tt.getActiveTextEditor();if(!vt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}return vt.edit(Mt=>{ce.apply(ze,[vt,Mt,...at])}).then(Mt=>{Mt||ft.warn("Edits from command "+ee+" were not applied.")},Mt=>{ft.warn("An error occurred while running command "+ee,Mt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(ee,ce,ze)=>((0,Xe.$OF)(Oe,"diffCommand"),bt.registerCommand(!0,ee,async(...at)=>{const vt=yt.activeEditor(!0);if(!vt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Mt=await tt.getDiffInformation(vt.id);ce.apply(ze,[Mt,...at])},void 0,void 0,Oe)),executeCommand(ee,...ce){return bt.executeCommand(ee,...ce)},getCommands(ee=!1){return bt.getCommands(ee)}},Bi={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Ii.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return it(St.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return it(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$OF)(Oe,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$OF)(Oe,"telemetry"),it(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Ue.$3N)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ce){return Ue.$2N.validateSender(ee),At.instantiateLogger(Oe,ee,ce)},openExternal(ee,ce){return Tt.openUri(ee,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===mt.environment.appUriScheme)return mi.createAppUri(ee);try{return await Tt.asExternalUri(ee,{allowTunneling:!!mt.remote.authority})}catch(ce){if((0,R.$ig)(ee,R.Schemas.http)||(0,R.$ig)(ee,R.Schemas.https))return ee;throw ce}},get remoteName(){return(0,a.$gl)(mt.remote.authority)},get remoteAuthority(){return(0,Xe.$OF)(Oe,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return it(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(ee){return(0,Xe.$OF)(Oe,"handleIssueUri"),Oi.registerIssueUriRequestHandler(Oe,ee)},registerIssueDataProvider(ee){return(0,Xe.$OF)(Oe,"handleIssueUri"),Oi.registerIssueDataProvider(Oe,ee)},get appQuality(){return(0,Xe.$OF)(Oe,"resolvers"),mt.quality},get appCommit(){return(0,Xe.$OF)(Oe,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(Bi);const mn={createTestController(ee,ce,ze){return bi.createTestController(Oe,ee,ce,ze)},createTestObserver(){return(0,Xe.$OF)(Oe,"testObserver"),bi.createTestObserver()},runTests(ee){return(0,Xe.$OF)(Oe,"testObserver"),bi.runTests(ee)},get onDidChangeTestResults(){return(0,Xe.$OF)(Oe,"testObserver"),it(bi.onResultsChanged)},get testResults(){return(0,Xe.$OF)(Oe,"testObserver"),bi.results}},Ci=mt.remote.isRemote?Te.ExtensionKind.Workspace:Te.ExtensionKind.UI,sn={getExtension(ee,ce){(0,Xe.$NF)(Oe,"extensionsAny")||(ce=!1);const ze=li.mine.getExtensionDescription(ee);if(ze)return new he.$Uhc(Ct,Oe.identifier,ze,Ci,!1);if(ce){const at=li.all.getExtensionDescription(ee);if(at)return new he.$Uhc(Ct,Oe.identifier,at,Ci,!0)}},get all(){const ee=[];for(const ce of li.mine.getAllExtensionDescriptions())ee.push(new he.$Uhc(Ct,Oe.identifier,ce,Ci,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.$OF)(Oe,"extensionsAny");const ee=new v.$rm(li.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ce=[];for(const ze of li.all.getAllExtensionDescriptions()){const at=!ee.has(ze.identifier);ce.push(new he.$Uhc(Ct,Oe.identifier,ze,Ci,at))}return ce},get onDidChange(){return(0,Xe.$NF)(Oe,"extensionsAny")?it(P.Event.any(li.mine.onDidChange,li.all.onDidChange)):it(li.mine.onDidChange)}},Wi={createDiagnosticCollection(ee){return zt.createDiagnosticCollection(Oe.identifier,ee)},get onDidChangeDiagnostics(){return it(zt.onDidChangeDiagnostics)},getDiagnostics:ee=>zt.getDiagnostics(ee),getLanguages(){return It.getLanguages()},setTextDocumentLanguage(ee,ce){return It.changeLanguage(ee.uri,ce)},match(ee,ce){const ze=Pt.getDocumentData(ce.uri)?.notebook;return(0,A.$Gt)(st.LanguageSelector.from(ee),ce.uri,ce.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(ee,ce,ze){return ot.registerCodeActionProvider(Oe,$t(ee),ce,ze)},registerDocumentPasteEditProvider(ee,ce,ze){return(0,Xe.$OF)(Oe,"documentPaste"),ot.registerDocumentPasteEditProvider(Oe,$t(ee),ce,ze)},registerCodeLensProvider(ee,ce){return ot.registerCodeLensProvider(Oe,$t(ee),ce)},registerDefinitionProvider(ee,ce){return ot.registerDefinitionProvider(Oe,$t(ee),ce)},registerDeclarationProvider(ee,ce){return ot.registerDeclarationProvider(Oe,$t(ee),ce)},registerImplementationProvider(ee,ce){return ot.registerImplementationProvider(Oe,$t(ee),ce)},registerTypeDefinitionProvider(ee,ce){return ot.registerTypeDefinitionProvider(Oe,$t(ee),ce)},registerHoverProvider(ee,ce){return ot.registerHoverProvider(Oe,$t(ee),ce,Oe.identifier)},registerEvaluatableExpressionProvider(ee,ce){return ot.registerEvaluatableExpressionProvider(Oe,$t(ee),ce,Oe.identifier)},registerInlineValuesProvider(ee,ce){return ot.registerInlineValuesProvider(Oe,$t(ee),ce,Oe.identifier)},registerDocumentHighlightProvider(ee,ce){return ot.registerDocumentHighlightProvider(Oe,$t(ee),ce)},registerMultiDocumentHighlightProvider(ee,ce){return ot.registerMultiDocumentHighlightProvider(Oe,$t(ee),ce)},registerLinkedEditingRangeProvider(ee,ce){return ot.registerLinkedEditingRangeProvider(Oe,$t(ee),ce)},registerReferenceProvider(ee,ce){return ot.registerReferenceProvider(Oe,$t(ee),ce)},registerRenameProvider(ee,ce){return ot.registerRenameProvider(Oe,$t(ee),ce)},registerNewSymbolNamesProvider(ee,ce){return(0,Xe.$OF)(Oe,"newSymbolNamesProvider"),ot.registerNewSymbolNamesProvider(Oe,$t(ee),ce)},registerDocumentSymbolProvider(ee,ce,ze){return ot.registerDocumentSymbolProvider(Oe,$t(ee),ce,ze)},registerWorkspaceSymbolProvider(ee){return ot.registerWorkspaceSymbolProvider(Oe,ee)},registerDocumentFormattingEditProvider(ee,ce){return ot.registerDocumentFormattingEditProvider(Oe,$t(ee),ce)},registerDocumentRangeFormattingEditProvider(ee,ce){return ot.registerDocumentRangeFormattingEditProvider(Oe,$t(ee),ce)},registerOnTypeFormattingEditProvider(ee,ce,ze,...at){return ot.registerOnTypeFormattingEditProvider(Oe,$t(ee),ce,[ze].concat(at))},registerDocumentSemanticTokensProvider(ee,ce,ze){return ot.registerDocumentSemanticTokensProvider(Oe,$t(ee),ce,ze)},registerDocumentRangeSemanticTokensProvider(ee,ce,ze){return ot.registerDocumentRangeSemanticTokensProvider(Oe,$t(ee),ce,ze)},registerSignatureHelpProvider(ee,ce,ze,...at){return typeof ze=="object"?ot.registerSignatureHelpProvider(Oe,$t(ee),ce,ze):ot.registerSignatureHelpProvider(Oe,$t(ee),ce,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(ee,ce,...ze){return ot.registerCompletionItemProvider(Oe,$t(ee),ce,ze)},registerInlineCompletionItemProvider(ee,ce,ze){return ce.handleDidShowCompletionItem&&(0,Xe.$OF)(Oe,"inlineCompletionsAdditions"),ce.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$OF)(Oe,"inlineCompletionsAdditions"),ze&&(0,Xe.$OF)(Oe,"inlineCompletionsAdditions"),ot.registerInlineCompletionsProvider(Oe,$t(ee),ce,ze)},registerDocumentLinkProvider(ee,ce){return ot.registerDocumentLinkProvider(Oe,$t(ee),ce)},registerColorProvider(ee,ce){return ot.registerColorProvider(Oe,$t(ee),ce)},registerFoldingRangeProvider(ee,ce){return ot.registerFoldingRangeProvider(Oe,$t(ee),ce)},registerSelectionRangeProvider(ee,ce){return ot.registerSelectionRangeProvider(Oe,ee,ce)},registerCallHierarchyProvider(ee,ce){return ot.registerCallHierarchyProvider(Oe,ee,ce)},registerTypeHierarchyProvider(ee,ce){return ot.registerTypeHierarchyProvider(Oe,ee,ce)},setLanguageConfiguration:(ee,ce)=>ot.setLanguageConfiguration(Oe,ee,ce),getTokenInformationAtPosition(ee,ce){return(0,Xe.$OF)(Oe,"tokenInformation"),It.tokenAtPosition(ee,ce)},registerInlayHintsProvider(ee,ce){return ot.registerInlayHintsProvider(Oe,ee,ce)},createLanguageStatusItem(ee,ce){return It.createLanguageStatusItem(Oe,ee,ce)},registerDocumentDropEditProvider(ee,ce,ze){return ot.registerDocumentOnDropEditProvider(Oe,ee,ce,(0,Xe.$NF)(Oe,"dropMetadata")?ze:void 0)}},on={get activeTextEditor(){return tt.getActiveTextEditor()},get visibleTextEditors(){return tt.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(ee,ce,ze){g.URI.isUri(ee)&&ee.scheme===R.Schemas.vscodeRemote&&!ee.authority&&Rt.report("workspace.showTextDocument",Oe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(g.URI.isUri(ee)?Promise.resolve(Vi.openTextDocument(ee)):Promise.resolve(ee));return tt.showTextDocument(at,ce,ze)},createTextEditorDecorationType(ee){return tt.createTextEditorDecorationType(Oe,ee)},onDidChangeActiveTextEditor(ee,ce,ze){return it(tt.onDidChangeActiveTextEditor)(ee,ce,ze)},onDidChangeVisibleTextEditors(ee,ce,ze){return it(tt.onDidChangeVisibleTextEditors)(ee,ce,ze)},onDidChangeTextEditorSelection(ee,ce,ze){return it(tt.onDidChangeTextEditorSelection)(ee,ce,ze)},onDidChangeTextEditorOptions(ee,ce,ze){return it(tt.onDidChangeTextEditorOptions)(ee,ce,ze)},onDidChangeTextEditorVisibleRanges(ee,ce,ze){return it(tt.onDidChangeTextEditorVisibleRanges)(ee,ce,ze)},onDidChangeTextEditorViewColumn(ee,ce,ze){return it(tt.onDidChangeTextEditorViewColumn)(ee,ce,ze)},onDidCloseTerminal(ee,ce,ze){return it(St.onDidCloseTerminal)(ee,ce,ze)},onDidOpenTerminal(ee,ce,ze){return it(St.onDidOpenTerminal)(ee,ce,ze)},onDidChangeActiveTerminal(ee,ce,ze){return it(St.onDidChangeActiveTerminal)(ee,ce,ze)},onDidChangeTerminalDimensions(ee,ce,ze){return(0,Xe.$OF)(Oe,"terminalDimensions"),it(St.onDidChangeTerminalDimensions)(ee,ce,ze)},onDidChangeTerminalState(ee,ce,ze){return it(St.onDidChangeTerminalState)(ee,ce,ze)},onDidWriteTerminalData(ee,ce,ze){return(0,Xe.$OF)(Oe,"terminalDataWriteEvent"),it(St.onDidWriteTerminalData)(ee,ce,ze)},onDidExecuteTerminalCommand(ee,ce,ze){return(0,Xe.$OF)(Oe,"terminalExecuteCommandEvent"),it(St.onDidExecuteTerminalCommand)(ee,ce,ze)},get state(){return Tt.getState(Oe)},onDidChangeWindowState(ee,ce,ze){return it(Tt.onDidChangeWindowState)(ee,ce,ze)},showInformationMessage(ee,...ce){return Ui.showMessage(Oe,m.default.Info,ee,ce[0],ce.slice(1))},showWarningMessage(ee,...ce){return Ui.showMessage(Oe,m.default.Warning,ee,ce[0],ce.slice(1))},showErrorMessage(ee,...ce){return Ui.showMessage(Oe,m.default.Error,ee,ce[0],ce.slice(1))},showQuickPick(ee,ce,ze){return $i.showQuickPick(Oe,ee,ce,ze)},showWorkspaceFolderPick(ee){return $i.showWorkspaceFolderPick(ee)},showInputBox(ee,ce){return $i.showInput(ee,ce)},showOpenDialog(ee){return ri.showOpenDialog(Oe,ee)},showSaveDialog(ee){return ri.showSaveDialog(ee)},createStatusBarItem(ee,ce,ze){let at,vt,Mt;return typeof ee=="string"?(at=ee,vt=ce,Mt=ze):(vt=ee,Mt=ce),tn.createStatusBarEntry(Oe,at,vt,Mt)},setStatusBarMessage(ee,ce){return tn.setStatusBarMessage(ee,ce)},withScmProgress(ee){return Rt.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),Li.withProgress(Oe,{location:Te.ProgressLocation.SourceControl},(ce,ze)=>ee({report(at){}}))},withProgress(ee,ce){return Li.withProgress(Oe,ee,ce)},createOutputChannel(ee,ce){return gi.createOutputChannel(ee,ce,Oe)},createWebviewPanel(ee,ce,ze,at){return ki.createWebviewPanel(Oe,ee,ce,ze,at)},createWebviewTextEditorInset(ee,ce,ze,at){return(0,Xe.$OF)(Oe,"editorInsets"),Ht.createWebviewEditorInset(ee,ce,ze,at,Oe)},createTerminal(ee,ce,ze){return typeof ee=="object"?"pty"in ee?St.createExtensionTerminal(ee):St.createTerminalFromOptions(ee):St.createTerminal(ee,ce,ze)},registerTerminalLinkProvider(ee){return St.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ce){return St.registerProfileProvider(Oe,ee,ce)},registerTerminalQuickFixProvider(ee,ce){return(0,Xe.$OF)(Oe,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(ee,Oe.identifier.value,ce)},registerTreeDataProvider(ee,ce){return wt.registerTreeDataProvider(ee,ce,Oe)},createTreeView(ee,ce){return wt.createTreeView(ee,ce,Oe)},registerWebviewPanelSerializer:(ee,ce)=>ki.registerWebviewPanelSerializer(Oe,ee,ce),registerCustomEditorProvider:(ee,ce,ze={})=>_i.registerCustomEditorProvider(Oe,ee,ce,ze),registerFileDecorationProvider(ee){return Vt.registerFileDecorationProvider(ee,Oe)},registerUriHandler(ee){return mi.registerUriHandler(Oe,ee)},createQuickPick(){return $i.createQuickPick(Oe)},createInputBox(){return $i.createInputBox(Oe)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(ee,ce,ze){return it(Ei.onDidChangeActiveColorTheme)(ee,ce,ze)},registerWebviewViewProvider(ee,ce,ze){return hn.registerWebviewViewProvider(Oe,ee,ce,ze?.webviewOptions)},get activeNotebookEditor(){return oe.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ce,ze){return it(oe.onDidChangeActiveNotebookEditor)(ee,ce,ze)},get visibleNotebookEditors(){return oe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return it(oe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,ce,ze){return it(Re.onDidChangeNotebookEditorSelection)(ee,ce,ze)},onDidChangeNotebookEditorVisibleRanges(ee,ce,ze){return it(Re.onDidChangeNotebookEditorVisibleRanges)(ee,ce,ze)},showNotebookDocument(ee,ce){return oe.showNotebookDocument(ee,ce)},registerExternalUriOpener(ee,ce,ze){return(0,Xe.$OF)(Oe,"externalUriOpener"),Ni.registerExternalUriOpener(Oe.identifier,ee,ce,ze)},registerProfileContentHandler(ee,ce){return(0,Xe.$OF)(Oe,"profileContentHandlers"),Fi.registerProfileContentHandler(Oe,ee,ce)},registerQuickDiffProvider(ee,ce,ze,at){return(0,Xe.$OF)(Oe,"quickDiffProvider"),Ai.registerQuickDiffProvider($t(ee),ce,ze,at)},get tabGroups(){return Ot.tabGroups},registerShareProvider(ee,ce){return(0,Xe.$OF)(Oe,"shareProvider"),Zi.registerShareProvider($t(ee),ce)}},Vi={get rootPath(){return Rt.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new M.$9("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new M.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(ee,ce,...ze)=>dt.updateWorkspaceFolders(Oe,ee,ce||0,...ze),onDidChangeWorkspaceFolders:function(ee,ce,ze){return it(dt.onDidChangeWorkspace)(ee,ce,ze)},asRelativePath:(ee,ce)=>dt.getRelativePath(ee,ce),findFiles:(ee,ce,ze,at)=>dt.findFiles(ee,ce,ze,Oe.identifier,at),findFiles2:(ee,ce,ze)=>((0,Xe.$OF)(Oe,"findFiles2"),dt.findFiles2(ee,ce,Oe.identifier,ze)),findTextInFiles:(ee,ce,ze,at)=>{(0,Xe.$OF)(Oe,"findTextInFiles");let vt,Mt;return typeof ce=="object"?(vt=ce,Mt=ze):(vt={},Mt=ce,at=ze),dt.findTextInFiles(ee,vt||{},Mt,Oe.identifier,at)},save:ee=>dt.save(ee),saveAs:ee=>dt.saveAs(ee),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,ce){return di.applyWorkspaceEdit(ee,Oe,ce)},createFileSystemWatcher:(ee,ce,ze,at)=>{let vt;return typeof ce=="boolean"?vt={ignoreCreateEvents:!!ce,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!at,correlate:!1}:ce&&((0,Xe.$OF)(Oe,"createFileSystemWatcher"),vt={...ce,correlate:!0}),ui.createFileSystemWatcher(dt,Oe,ee,vt)},get textDocuments(){return Pt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new M.$9("textDocuments")},openTextDocument(ee){let ce;const ze=ee;if(typeof ee=="string")ce=Promise.resolve(g.URI.file(ee));else if(g.URI.isUri(ee))ce=Promise.resolve(ee);else if(!ze||typeof ze=="object")ce=Pt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&Rt.report("workspace.openTextDocument",Oe,"A URI of 'vscode-remote' scheme requires an authority."),Pt.ensureDocumentData(at).then(vt=>vt.document)))},onDidOpenTextDocument:(ee,ce,ze)=>it(Pt.onDidAddDocument)(ee,ce,ze),onDidCloseTextDocument:(ee,ce,ze)=>it(Pt.onDidRemoveDocument)(ee,ce,ze),onDidChangeTextDocument:(ee,ce,ze)=>it(Pt.onDidChangeDocument)(ee,ce,ze),onDidSaveTextDocument:(ee,ce,ze)=>it(Pt.onDidSaveDocument)(ee,ce,ze),onWillSaveTextDocument:(ee,ce,ze)=>it(Ne.getOnWillSaveTextDocumentEvent(Oe))(ee,ce,ze),get notebookDocuments(){return oe.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ce){let ze;if(g.URI.isUri(ee))ze=ee,await oe.openNotebookDocument(ee);else if(typeof ee=="string")ze=g.URI.revive(await oe.createNotebookDocument({viewType:ee,content:ce}));else throw new Error("Invalid arguments");return oe.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(ee,ce,ze){return it(K.onDidSaveNotebookDocument)(ee,ce,ze)},onDidChangeNotebookDocument(ee,ce,ze){return it(K.onDidChangeNotebookDocument)(ee,ce,ze)},onWillSaveNotebookDocument(ee,ce,ze){return it(Ke.getOnWillSaveNotebookDocumentEvent(Oe))(ee,ce,ze)},get onDidOpenNotebookDocument(){return it(oe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return it(oe.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,ce,ze,at){return oe.registerNotebookSerializer(Oe,ee,ce,ze,(0,Xe.$NF)(Oe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ee,ce,ze)=>it(ji.onDidChangeConfiguration)(ee,ce,ze),getConfiguration(ee,ce){return ce=arguments.length===1?void 0:ce,ji.getConfiguration(ee,ce,Oe)},registerTextDocumentContentProvider(ee,ce){return be.registerTextDocumentContentProvider(ee,ce)},registerTaskProvider:(ee,ce)=>(Rt.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Yt.registerTaskProvider(Oe,ee,ce)),registerFileSystemProvider(ee,ce,ze){return(0,N.$Qc)(Qi.registerFileSystemProvider(Oe,ee,ce,ze),ni.addFileSystemProvider(ee,ce,ze))},get fs(){return ni.value},registerFileSearchProvider:(ee,ce)=>((0,Xe.$OF)(Oe,"fileSearchProvider"),ci.registerFileSearchProvider(ee,ce)),registerTextSearchProvider:(ee,ce)=>((0,Xe.$OF)(Oe,"textSearchProvider"),ci.registerTextSearchProvider(ee,ce)),registerRemoteAuthorityResolver:(ee,ce)=>((0,Xe.$OF)(Oe,"resolvers"),Ct.registerRemoteAuthorityResolver(ee,ce)),registerResourceLabelFormatter:ee=>((0,Xe.$OF)(Oe,"resolvers"),Mi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.$OF)(Oe,"resolvers"),Ct.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ce,ze)=>it(ui.onDidCreateFile)(ee,ce,ze),onDidDeleteFiles:(ee,ce,ze)=>it(ui.onDidDeleteFile)(ee,ce,ze),onDidRenameFiles:(ee,ce,ze)=>it(ui.onDidRenameFile)(ee,ce,ze),onWillCreateFiles:(ee,ce,ze)=>it(ui.getOnWillCreateFileEvent(Oe))(ee,ce,ze),onWillDeleteFiles:(ee,ce,ze)=>it(ui.getOnWillDeleteFileEvent(Oe))(ee,ce,ze),onWillRenameFiles:(ee,ce,ze)=>it(ui.getOnWillRenameFileEvent(Oe))(ee,ce,ze),openTunnel:ee=>((0,Xe.$OF)(Oe,"tunnels"),Ft.openTunnel(Oe,ee).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,Xe.$OF)(Oe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ee,ce,ze)=>((0,Xe.$OF)(Oe,"tunnels"),it(Ft.onDidChangeTunnels)(ee,ce,ze)),registerPortAttributesProvider:(ee,ce)=>((0,Xe.$OF)(Oe,"portsAttributes"),Ft.registerPortsAttributesProvider(ee,ce)),registerTunnelProvider:(ee,ce)=>((0,Xe.$OF)(Oe,"tunnelFactory"),Ft.registerTunnelProvider(ee,ce)),registerTimelineProvider:(ee,ce)=>((0,Xe.$OF)(Oe,"timeline"),Xi.registerTimelineProvider(ee,ce,Oe.identifier,bt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,Xe.$OF)(Oe,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ce,ze)=>it(dt.onDidGrantWorkspaceTrust)(ee,ce,ze),registerEditSessionIdentityProvider:(ee,ce)=>((0,Xe.$OF)(Oe,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,ce)),onWillCreateEditSessionIdentity:(ee,ce,ze)=>((0,Xe.$OF)(Oe,"editSessionIdentityProvider"),it(dt.getOnWillCreateEditSessionIdentityEvent(Oe))(ee,ce,ze)),registerCanonicalUriProvider:(ee,ce)=>((0,Xe.$OF)(Oe,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,ce)),getCanonicalUri:(ee,ce,ze)=>((0,Xe.$OF)(Oe,"canonicalUriProvider"),dt.provideCanonicalUri(ee,ce,ze))},an={get inputBox(){return Rt.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Oe)},createSourceControl(ee,ce,ze){return yi.createSourceControl(Oe,ee,ce,ze)}},$n={createCommentController(ee,ce){return ln.createCommentController(Oe,ee,ce)}},pn={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get stackFrameFocus(){return Dt.stackFrameFocus},registerDebugVisualizationProvider(ee,ce){return(0,Xe.$OF)(Oe,"debugVisualization"),Dt.registerDebugVisualizationProvider(Oe,ee,ce)},registerDebugVisualizationTreeProvider(ee,ce){return(0,Xe.$OF)(Oe,"debugVisualization"),Dt.registerDebugVisualizationTree(Oe,ee,ce)},onDidStartDebugSession(ee,ce,ze){return it(Dt.onDidStartDebugSession)(ee,ce,ze)},onDidTerminateDebugSession(ee,ce,ze){return it(Dt.onDidTerminateDebugSession)(ee,ce,ze)},onDidChangeActiveDebugSession(ee,ce,ze){return it(Dt.onDidChangeActiveDebugSession)(ee,ce,ze)},onDidReceiveDebugSessionCustomEvent(ee,ce,ze){return it(Dt.onDidReceiveDebugSessionCustomEvent)(ee,ce,ze)},onDidChangeBreakpoints(ee,ce,ze){return it(Dt.onDidChangeBreakpoints)(ee,ce,ze)},onDidChangeStackFrameFocus(ee,ce,ze){return(0,Xe.$OF)(Oe,"debugFocus"),it(Dt.onDidChangeStackFrameFocus)(ee,ce,ze)},registerDebugConfigurationProvider(ee,ce,ze){return Dt.registerDebugConfigurationProvider(ee,ce,ze||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ce){return Dt.registerDebugAdapterDescriptorFactory(Oe,ee,ce)},registerDebugAdapterTrackerFactory(ee,ce){return Dt.registerDebugAdapterTrackerFactory(ee,ce)},startDebugging(ee,ce,ze){return!ze||typeof ze=="object"&&"configuration"in ze?Dt.startDebugging(ee,ce,{parentSession:ze}):Dt.startDebugging(ee,ce,ze||{})},stopDebugging(ee){return Dt.stopDebugging(ee)},addBreakpoints(ee){return Dt.addBreakpoints(ee)},removeBreakpoints(ee){return Dt.removeBreakpoints(ee)},asDebugSourceUri(ee,ce){return Dt.asDebugSourceUri(ee,ce)}},cn={registerTaskProvider:(ee,ce)=>Yt.registerTaskProvider(Oe,ee,ce),fetchTasks:ee=>Yt.fetchTasks(ee),executeTask:ee=>Yt.executeTask(Oe,ee),get taskExecutions(){return Yt.taskExecutions},onDidStartTask:(ee,ce,ze)=>it(Yt.onDidStartTask)(ee,ce,ze),onDidEndTask:(ee,ce,ze)=>it(Yt.onDidEndTask)(ee,ce,ze),onDidStartTaskProcess:(ee,ce,ze)=>it(Yt.onDidStartTaskProcess)(ee,ce,ze),onDidEndTaskProcess:(ee,ce,ze)=>it(Yt.onDidEndTaskProcess)(ee,ce,ze)},un={createNotebookController(ee,ce,ze,at,vt){return je.createNotebookController(Oe,ee,ce,ze,at,(0,Xe.$NF)(Oe,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ce)=>oe.registerNotebookCellStatusBarItemProvider(Oe,ee,ce),createRendererMessaging(ee){return Ze.createRendererMessaging(Oe,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.$OF)(Oe,"notebookKernelSource"),je.createNotebookControllerDetectionTask(Oe,ee)},registerKernelSourceActionProvider(ee,ce){return(0,Xe.$OF)(Oe,"notebookKernelSource"),je.registerKernelSourceActionProvider(Oe,ee,ce)},onDidChangeNotebookCellExecutionState(ee,ce,ze){return(0,Xe.$OF)(Oe,"notebookCellExecutionState"),it(je.onDidChangeNotebookCellExecutionState)(ee,ce,ze)}},qi={t(...ee){if(typeof ee[0]=="string"){const ce=ee.shift(),ze=!ee||typeof ee[0]!="object"?ee:ee[0];return qt.getMessage(Oe.identifier.value,{message:ce,args:ze})}return qt.getMessage(Oe.identifier.value,ee[0])},get bundle(){return qt.getBundle(Oe.identifier.value)},get uri(){return qt.getBundleUri(Oe.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(ee,ce){return(0,Xe.$OF)(Oe,"interactive"),dn.registerProvider(Oe,ee,ce)},registerInteractiveSessionProvider(ee,ce){return(0,Xe.$OF)(Oe,"interactive"),wi.registerChatProvider(Oe,ee,ce)},sendInteractiveRequestToProvider(ee,ce){return(0,Xe.$OF)(Oe,"interactive"),wi.sendInteractiveRequestToProvider(ee,ce)},transferChatSession(ee,ce){return(0,Xe.$OF)(Oe,"interactive"),wi.transferChatSession(ee,ce)}},Ki={getRelatedInformation(ee,ce){return(0,Xe.$OF)(Oe,"aiRelatedInformation"),Ti.getRelatedInformation(Oe,ee,ce)},registerRelatedInformationProvider(ee,ce){return(0,Xe.$OF)(Oe,"aiRelatedInformation"),Ti.registerRelatedInformationProvider(Oe,ee,ce)},registerEmbeddingVectorProvider(ee,ce){return(0,Xe.$OF)(Oe,"aiRelatedInformation"),en.registerEmbeddingVectorProvider(Oe,ee,ce)}},Pi={registerChatResponseProvider(ee,ce,ze){return(0,Xe.$OF)(Oe,"chatProvider"),Si.registerLanguageModel(Oe,ee,ce,ze)},requestLanguageModelAccess(ee,ce){return(0,Xe.$OF)(Oe,"chatRequestAccess"),Si.requestLanguageModelAccess(Oe,ee,ce)},get languageModels(){return(0,Xe.$OF)(Oe,"chatRequestAccess"),Si.getLanguageModelIds()},onDidChangeLanguageModels:(ee,ce,ze)=>((0,Xe.$OF)(Oe,"chatRequestAccess"),Si.onDidChangeProviders(ee,ce,ze)),registerVariable(ee,ce,ze){return(0,Xe.$OF)(Oe,"chatAgents2"),fn.registerVariableResolver(Oe,ee,ce,ze)},registerMappedEditsProvider(ee,ce){return(0,Xe.$OF)(Oe,"mappedEditsProvider"),ot.registerMappedEditsProvider(Oe,ee,ce)},createChatAgent(ee,ce){return(0,Xe.$OF)(Oe,"chatAgents2"),xi.createChatAgent(Oe,ee,ce)}},Gi={registerSpeechProvider(ee,ce){return(0,Xe.$OF)(Oe,"speech"),zi.registerProvider(Oe.identifier,ee,ce)}};return{version:mt.version,ai:Ki,authentication:gn,commands:rn,comments:$n,chat:Pi,debug:pn,env:Bi,extensions:sn,interactive:Hi,l10n:qi,languages:Wi,notebooks:un,scm:an,speech:Gi,tasks:cn,tests:mn,window:on,workspace:Vi,Breakpoint:Te.$sM,TerminalOutputAnchor:Te.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Te.ChatAgentResultFeedbackKind,ChatMessage:Te.$mN,ChatMessageRole:Te.ChatMessageRole,ChatVariableLevel:Te.ChatVariableLevel,ChatAgentCompletionItem:Te.$lN,CallHierarchyIncomingCall:Te.$RL,CallHierarchyItem:Te.$QL,CallHierarchyOutgoingCall:Te.$SL,CancellationError:M.$5,CancellationTokenSource:S.$9d,CandidatePortSource:n.CandidatePortSource,CodeAction:Te.$NL,CodeActionKind:Te.$OL,CodeActionTriggerKind:Te.CodeActionTriggerKind,CodeLens:Te.$TL,Color:Te.$7L,ColorInformation:Te.$8L,ColorPresentation:Te.$9L,ColorThemeKind:Te.ColorThemeKind,CommentMode:Te.CommentMode,CommentState:Te.CommentState,CommentThreadCollapsibleState:Te.CommentThreadCollapsibleState,CommentThreadState:Te.CommentThreadState,CompletionItem:Te.$1L,CompletionItemKind:Te.CompletionItemKind,CompletionItemTag:Te.CompletionItemTag,CompletionList:Te.$2L,CompletionTriggerKind:Te.CompletionTriggerKind,ConfigurationTarget:Te.ConfigurationTarget,CustomExecution:Te.$eM,DebugAdapterExecutable:Te.$wM,DebugAdapterInlineImplementation:Te.$zM,DebugAdapterNamedPipeServer:Te.$yM,DebugAdapterServer:Te.$xM,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Te.DebugConsoleMode,DebugVisualization:Te.$PM,DecorationRangeBehavior:Te.DecorationRangeBehavior,Diagnostic:Te.$HL,DiagnosticRelatedInformation:Te.$GL,DiagnosticSeverity:Te.DiagnosticSeverity,DiagnosticTag:Te.DiagnosticTag,Disposable:Te.$tL,DocumentHighlight:Te.$JL,DocumentHighlightKind:Te.DocumentHighlightKind,MultiDocumentHighlight:Te.$KL,DocumentLink:Te.$6L,DocumentSymbol:Te.$ML,EndOfLine:Te.EndOfLine,EnvironmentVariableMutatorType:Te.EnvironmentVariableMutatorType,EvaluatableExpression:Te.$CM,InlineValueText:Te.$DM,InlineValueVariableLookup:Te.$EM,InlineValueEvaluatableExpression:Te.$FM,InlineCompletionTriggerKind:Te.InlineCompletionTriggerKind,EventEmitter:P.$Yd,ExtensionKind:Te.ExtensionKind,ExtensionMode:Te.ExtensionMode,ExternalUriOpenerPriority:Te.ExternalUriOpenerPriority,FileChangeType:Te.FileChangeType,FileDecoration:Te.$RM,FileDecoration2:Te.$RM,FileSystemError:Te.$IM,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Te.$JM,FoldingRangeKind:Te.FoldingRangeKind,FunctionBreakpoint:Te.$uM,InlineCompletionItem:Te.$3L,InlineCompletionList:Te.$4L,Hover:Te.$IL,IndentAction:k.IndentAction,Location:Te.$FL,MarkdownString:Te.$UL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Te.$VL,PortAutoForwardAction:Te.PortAutoForwardAction,Position:Te.$uL,ProcessExecution:Te.$cM,ProgressLocation:Te.ProgressLocation,QuickInputButtons:Te.$QM,Range:Te.$vL,RelativePattern:Te.$qM,Selection:Te.$wL,SelectionRange:Te.$PL,SemanticTokens:Te.$MM,SemanticTokensBuilder:Te.$LM,SemanticTokensEdit:Te.$NM,SemanticTokensEdits:Te.$OM,SemanticTokensLegend:Te.$KM,ShellExecution:Te.$dM,ShellQuoting:Te.ShellQuoting,SignatureHelp:Te.$XL,SignatureHelpTriggerKind:Te.SignatureHelpTriggerKind,SignatureInformation:Te.$WL,SnippetString:Te.$EL,SourceBreakpoint:Te.$tM,StandardTokenType:Te.StandardTokenType,StatusBarAlignment:Te.StatusBarAlignment,SymbolInformation:Te.$LL,SymbolKind:Te.SymbolKind,SymbolTag:Te.SymbolTag,Task:Te.$fM,TaskGroup:Te.$bM,TaskPanelKind:Te.TaskPanelKind,TaskRevealKind:Te.TaskRevealKind,TaskScope:Te.TaskScope,TerminalLink:Te.$0L,TerminalQuickFixTerminalCommand:Te.$_L,TerminalQuickFixOpener:Te.$$L,TerminalLocation:Te.TerminalLocation,TerminalProfile:Te.$aM,TerminalExitReason:Te.TerminalExitReason,TextDocumentSaveReason:Te.TextDocumentSaveReason,TextEdit:Te.$AL,SnippetTextEdit:Te.$CL,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:Te.TextEditorLineNumbersStyle,TextEditorRevealType:Te.TextEditorRevealType,TextEditorSelectionChangeKind:Te.TextEditorSelectionChangeKind,SyntaxTokenType:Te.SyntaxTokenType,TextDocumentChangeReason:Te.TextDocumentChangeReason,ThemeColor:Te.$pM,ThemeIcon:Te.$oM,TreeItem:Te.$gM,TreeItemCheckboxState:Te.TreeItemCheckboxState,TreeItemCollapsibleState:Te.TreeItemCollapsibleState,TypeHierarchyItem:Te.$aN,UIKind:Xt.UIKind,Uri:g.URI,ViewColumn:Te.ViewColumn,WorkspaceEdit:Te.$DL,DocumentDropEdit:Te.$mM,DocumentPasteEdit:Te.$nM,InlayHint:Te.$ZL,InlayHintLabelPart:Te.$YL,InlayHintKind:Te.InlayHintKind,RemoteAuthorityResolverError:Te.$zL,ResolvedAuthority:Te.$xL,ManagedResolvedAuthority:Te.$yL,SourceControlInputBoxValidationType:Te.SourceControlInputBoxValidationType,ExtensionRuntime:Te.ExtensionRuntime,TimelineItem:Te.$2M,NotebookRange:Te.$TM,NotebookCellKind:Te.NotebookCellKind,NotebookCellExecutionState:Te.NotebookCellExecutionState,NotebookCellData:Te.$UM,NotebookData:Te.$VM,NotebookRendererScript:Te.$ZM,NotebookCellStatusBarAlignment:Te.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Te.NotebookEditorRevealType,NotebookCellOutput:Te.$XM,NotebookCellOutputItem:Te.$WM,NotebookCellStatusBarItem:Te.$YM,NotebookControllerAffinity:Te.NotebookControllerAffinity,NotebookControllerAffinity2:Te.NotebookControllerAffinity2,NotebookEdit:Te.$BL,NotebookKernelSourceAction:Te.$1M,NotebookVariablesRequestKind:Te.NotebookVariablesRequestKind,PortAttributes:Te.$4M,LinkedEditingRanges:Te.$3M,TestResultState:Te.TestResultState,TestRunRequest:Te.$5M,TestMessage:Te.$6M,TestTag:Te.$7M,TestRunProfileKind:Te.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:Te.$lM,DataTransferItem:Te.$hM,CoveredCount:Te.$8M,FileCoverage:Te.$9M,StatementCoverage:Te.$0M,BranchCoverage:Te.$$M,DeclarationCoverage:Te.$_M,FunctionCoverage:Te.$_M,WorkspaceTrustState:Te.WorkspaceTrustState,LanguageStatusSeverity:Te.LanguageStatusSeverity,QuickPickItemKind:Te.QuickPickItemKind,InputBoxValidationSeverity:Te.InputBoxValidationSeverity,TabInputText:Te.$bN,TabInputTextDiff:Te.$cN,TabInputTextMerge:Te.$dN,TabInputCustom:Te.$eN,TabInputNotebook:Te.$gN,TabInputNotebookDiff:Te.$hN,TabInputWebview:Te.$fN,TabInputTerminal:Te.$iN,TabInputInteractiveWindow:Te.$jN,TabInputChat:Te.$kN,TelemetryTrustedValue:r.$Qo,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Te.InteractiveSessionVoteDirection,ChatAgentCopyKind:Te.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Te.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Te.$AM,ThreadFocus:Te.$BM,RelatedInformationType:Te.RelatedInformationType,SpeechToTextStatus:Te.SpeechToTextStatus,KeywordRecognitionStatus:Te.KeywordRecognitionStatus,ChatResponseTextPart:Te.$nN,ChatResponseMarkdownPart:Te.$oN,ChatResponseFileTreePart:Te.$pN,ChatResponseAnchorPart:Te.$qN,ChatResponseProgressPart:Te.$rN,ChatResponseReferencePart:Te.$tN,ChatResponseCommandButtonPart:Te.$sN,ChatAgentRequestTurn:Te.$uN,ChatAgentResponseTurn:Te.$vN,LanguageModelSystemMessage:Te.$wN,LanguageModelUserMessage:Te.$xN,LanguageModelAssistantMessage:Te.$yN,NewSymbolName:Te.$HM,NewSymbolNameTag:Te.NewSymbolNameTag}}}e.$Zic=ii}),define(Le[294],Me([1,0,53,113,36,108,37,31,66,65,116,118,119,82,85,78,107,62,43,81,60,64,230,14,117,79,80]),function(fe,e,S,M,P,N,R,m,g,D,A,k,l,v,p,s,a,r,i,n,o,h,t,f,c,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$4r)(u.$Ohc,u.$Nhc,1),(0,S.$4r)(f.$tj,t.$1ic,1),(0,S.$4r)(s.$Ugc,s.$Vgc,1),(0,S.$4r)(m.$6N,m.$5N,0),(0,S.$4r)(R.$ihc,R.$ghc,0),(0,S.$4r)(r.$khc,r.$jhc,0),(0,S.$4r)(k.$Yhc,k.$3hc,0),(0,S.$4r)(N.$5hc,N.$4hc,0),(0,S.$4r)(g.$UN,g.$TN,0),(0,S.$4r)(E.$Phc,E.$Qhc,0),(0,S.$4r)(i.$Ygc,i.$Xgc,0),(0,S.$4r)(M.$yic,M.$xic,1),(0,S.$4r)(l.$iic,l.$jic,0),(0,S.$4r)(v.$Dhc,v.$Chc,0),(0,S.$4r)(A.$Lic,A.$Kic,0),(0,S.$4r)(D.$Ghc,D.$Jhc,0),(0,S.$4r)(p.$Kzb,p.$Lzb,0),(0,S.$4r)(a.$Yic,a.$Xic,0),(0,S.$4r)(P.$fhc,P.$ehc,0),(0,S.$4r)(n.$Lhc,n.$Khc,0),(0,S.$4r)(o.$4N,o.$1N,0),(0,S.$4r)(h.$uhc,h.$vhc,0),(0,S.$4r)(c.$Whc,c.$Xhc,0)}),define(Le[295],Me([1,0,293,38,2,290,7,11,236]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;class D extends N.$4ic{j(){}getModule(v,p){for(const s of this.b){const a=s(v);if(a){v=a;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends M.$Shc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$$kc);const v=this.h.invokeFunction(S.$Zic);this.r=this.h.createInstance(D,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,s){p=p.with({path:k(p.path,".js")});const a=v?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const r=P.URI.revive(await this.C.$asBrowserUri(p)),i=await fetch(r.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),o=`${p.toString(!0)}#vscode-extension`,h=`${n}
//# sourceURL=${o}`;let t;try{t=new Function("module","exports","require",h)}catch(E){throw console.error(a?`Loading code for extension ${a} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${p.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}v&&await this.w.initializeLocalizedMessages(v);const f={},c={exports:f},u=E=>{const y=this.r.getModule(E,p);if(y===void 0)throw new Error(`Cannot load module '${E}'`);return y};try{return s.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(c,f,u),c.exports!==f?c.exports:f}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,m.$_g)(10)}}e.$_kc=A;function k(l,v){return l.endsWith(v)?l:l+v}}),define(Le[296],Me([1,0,70,53,14,38,201,84,295]),function(fe,e,S,M,P,N,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$4r)(P.$sj,new S.$8h(R.$3ic,[!0],!0)),(0,M.$4r)(N.$Thc,g.$_kc,0),(0,M.$4r)(m.$lhc,m.$mhc,0)}),define(Le[301],Me([1,0,23,5,77,291,238,19,87,12,2,294,296]),function(fe,e,S,M,P,N,R,m,g,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function s(t){self.fetch=async function(f,c){return f instanceof Request||v(String(f))&&(f=(await t(A.URI.parse(String(f)))).toString(!0)),p(f,c)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,c,u,E,y){(async()=>(v(c.toString())&&(c=(await t(A.URI.parse(c.toString()))).toString(!0)),super.open(f,c,u??!0,E,y)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,c){if(/^file:/i.test(f.toString()))f=D.$sg.uriToBrowserUri(A.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(d){function w(T){return typeof T=="string"||T instanceof URL?String(T).replace(/^file:\/\//i,"vscode-file://vscode-app"):T}const b=fetch.bind(self);self.fetch=function(T,Y){return T instanceof Request?b(T,Y):b(w(T),Y)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,Y,q,U,C){return super.open(T,w(Y),q??!0,U,C)}};const L=importScripts.bind(self);self.importScripts=(...T)=>{L(...T.map(w))},L(d)}.toString()}('${f}'))`;c=c||{},c.name=`${name} -> ${c.name||m.$nc(f.toString())}`;const y=new Blob([E],{type:"application/javascript"}),$=URL.createObjectURL(y);return new t($,c)}}else self.Worker=class extends R.$alc{constructor(t,f){super(l,t,{name:m.$nc(t.toString()),...f})}};const a=new class{constructor(){this.pid=void 0}exit(t){k()}};class r{constructor(){const f=new MessageChannel,c=new M.$Yd;let u=!1;l(f.port2,[f.port2]),f.port1.onmessage=E=>{const{data:y}=E;if(!(y instanceof ArrayBuffer)){console.warn("UNKNOWN data received",y);return}const $=S.$me.wrap(new Uint8Array(y,0,y.byteLength));if((0,P.$zm)($,2)){u=!0,n("received terminate message from renderer");return}c.fire($)},this.protocol={onMessage:c.event,send:E=>{if(!u){const y=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);f.port1.postMessage(y,[y])}}}}}function i(t){return new Promise(f=>{const c=t.onMessage(u=>{c.dispose();const E=JSON.parse(u.toString());t.send((0,P.$ym)(0)),f({protocol:t,initData:E})});t.send((0,P.$ym)(1))})}let n=t=>k();function o(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const t=new r;return{onmessage(f){o(f)&&i(t.protocol).then(c=>{g.mark("code/extHost/didWaitForInitData");const u=new N.$6ic(c.protocol,c.initData,a,null,f.data);s(E=>u.asBrowserUri(E)),n=E=>u.terminate(E)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4f2ff19ecacffa0aa4874db4d63ed4e899d98431/core/vs/workbench/api/worker/extensionHostWorker.js.map
