/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],G=function(z){for(var e=[],A=0,T=z.length;A<T;A++)e[A]=V[z[A]];return e};define(V[23],G([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class A{static get(){const E=new Map,C=new Map,r=new Map,d=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function c(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let b=[];typeof z=="function"&&typeof z.getStats=="function"&&(b=z.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of b)switch(a.type){case 10:t(E,a);break;case 11:case 12:c(E,a);break;case 21:t(C,a);break;case 22:c(C,a);break;case 33:t(r,a);break;case 34:c(r,a);break;case 31:t(d,a);break;case 32:c(d,a);break}let g=0;r.forEach(a=>g+=a);function o(a){const i=[];return a.forEach((n,s)=>i.push([s,n])),i}return{amdLoad:o(E),amdInvoke:o(C),nodeRequire:o(r),nodeEval:o(d),nodeRequireTotal:g}}static toMarkdownTable(E,C){let r="";const d=[];return E.forEach((t,c)=>{d[c]=t.length}),C.forEach(t=>{t.forEach((c,b)=>{typeof c>"u"&&(c=t[b]="-");const g=c.toString().length;d[b]=Math.max(g,d[b])})}),E.forEach((t,c)=>{r+=`| ${t+" ".repeat(d[c]-t.toString().length)} `}),r+=`|
`,E.forEach((t,c)=>{r+=`| ${"-".repeat(d[c])} `}),r+=`|
`,C.forEach(t=>{t.forEach((c,b)=>{typeof c<"u"&&(r+=`| ${c+" ".repeat(d[b]-c.toString().length)} `)}),r+=`|
`}),r}}e.$U=A}),define(V[5],G([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=void 0;class A{constructor(i,n,s){this.owner=i,this.debugNameSource=n,this.referenceFn=s}getDebugName(i){return C(i,this)}}e.$5c=A;const T=new Map,E=new WeakMap;function C(a,i){const n=E.get(a);if(n)return n;const s=r(a,i);if(s){let l=T.get(s)??0;l++,T.set(s,l);const k=l===1?s:`${s}#${l}`;return E.set(a,k),k}}e.$6c=C;function r(a,i){const n=E.get(a);if(n)return n;const s=i.owner?b(i.owner)+".":"";let l;const k=i.debugNameSource;if(k!==void 0)if(typeof k=="function"){if(l=k(),l!==void 0)return s+l}else return s+k;const N=i.referenceFn;if(N!==void 0&&(l=o(N),l!==void 0))return s+l;if(i.owner!==void 0){const P=d(i.owner,a);if(P!==void 0)return s+P}}function d(a,i){for(const n in a)if(a[n]===i)return n}const t=new Map,c=new WeakMap;function b(a){const i=c.get(a);if(i)return i;const n=g(a);let s=t.get(n)??0;s++,t.set(n,s);const l=s===1?n:`${n}#${s}`;return c.set(a,l),l}function g(a){const i=a.constructor;return i?i.name:"Object"}function o(a){const i=a.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(i);return(s?s[1]:void 0)?.trim()}e.$7c=o}),define(V[4],G([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zd=e.$yd=e.$xd=void 0;let A;function T(n){A=n}e.$xd=T;function E(){return A}e.$yd=E;class C{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([d(a("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[d(" "),c(b(s.oldValue,70),{color:"red",strikeThrough:!0}),d(" "),c(b(s.newValue,60),{color:"green"})]:[d(" (unchanged)")]:[d(" "),c(b(s.newValue,60),{color:"green"}),d(" (initial)")]}handleObservableChanged(s,l){console.log(...this.b([t("observable value changed"),c(s.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(s){if(s.size!==0)return c(" (changed deps: "+[...s].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(k,N)=>(this.d.get(s).add(k),l.apply(s,[k,N]))}handleDerivedRecomputed(s,l){const k=this.d.get(s);console.log(...this.b([t("derived recomputed"),c(s.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(k),{data:[{fn:s._computeFn}]}])),k.clear()}handleFromEventObservableTriggered(s,l){console.log(...this.b([t("observable from event triggered"),c(s.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const l=s.handleChange;this.d.set(s,new Set),s.handleChange=(k,N)=>(this.d.get(s).add(k),l.apply(s,[k,N]))}handleAutorunTriggered(s){const l=this.d.get(s);console.log(...this.b([t("autorun"),c(s.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:s._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let l=s.getDebugName();l===void 0&&(l=""),console.log(...this.b([t("transaction"),c(l,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$zd=C;function r(n){const s=new Array,l=[];let k="";function N(O){if("length"in O)for(const u of O)u&&N(u);else"text"in O?(k+=`%c${O.text}`,s.push(O.style),O.data&&l.push(...O.data)):"data"in O&&l.push(...O.data)}N(n);const P=[k,...s];return P.push(...l),P}function d(n){return c(n,{color:"black"})}function t(n){return c(i(`${n}: `,10),{color:"black",bold:!0})}function c(n,s={color:"black"}){function l(N){return Object.entries(N).reduce((P,[O,u])=>`${P}${O}:${u};`,"")}const k={color:s.color};return s.strikeThrough&&(k["text-decoration"]="line-through"),s.bold&&(k["font-weight"]="bold"),{text:n,style:l(k)}}function b(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?g(n,s):o(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function g(n,s){let l="[ ",k=!0;for(const N of n){if(k||(l+=", "),l.length-5>s){l+="...";break}k=!1,l+=`${b(N,s-l.length)}`}return l+=" ]",l}function o(n,s){let l="{ ",k=!0;for(const[N,P]of Object.entries(n)){if(k||(l+=", "),l.length-5>s){l+="...";break}k=!1,l+=`${N}: ${b(P,s-l.length)}`}return l+=" }",l}function a(n,s){let l="";for(let k=1;k<=s;k++)l+=n;return l}function i(n,s){for(;n.length<s;)n+=" ";return n}}),define(V[10],G([0,1,24,2,5,4]),function(z,e,A,T,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function r(i){return new a(new E.$5c(void 0,void 0,i),i,void 0,void 0)}e.$bd=r;function d(i,n){return new a(new E.$5c(i.owner,i.debugName,i.debugReferenceFn??n),n,void 0,void 0)}e.$cd=d;function t(i,n){return new a(new E.$5c(i.owner,i.debugName,i.debugReferenceFn??n),n,i.createEmptyChangeSummary,i.handleChange)}e.$dd=t;function c(i,n){const s=new T.$Sc,l=t({owner:i.owner,debugName:i.debugName,debugReferenceFn:i.debugReferenceFn,createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(k,N)=>{s.clear(),n(k,N,s)});return(0,T.$Rc)(()=>{l.dispose(),s.dispose()})}e.$ed=c;function b(i){const n=new T.$Sc,s=d({owner:void 0,debugName:void 0,debugReferenceFn:i},l=>{n.clear(),i(l,n)});return(0,T.$Rc)(()=>{s.dispose(),n.dispose()})}e.$fd=b;function g(i,n){let s;return d({debugReferenceFn:n},l=>{const k=i.read(l),N=s;s=k,n({lastValue:N,newValue:k})})}e.$gd=g;var o;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(o||(o={}));class a{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,s,l,k){this.h=n,this._runFn=s,this.i=l,this.j=k,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,C.$yd)()?.handleAutorunCreated(this),this.k(),(0,T.$Kc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,T.$Lc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const s=this.c;try{if(!s){(0,C.$yd)()?.handleAutorunTriggered(this);const l=this.g;this.g=this.i?.(),this._runFn(this,l)}}finally{s||(0,C.$yd)()?.handleAutorunFinished(this);for(const l of this.f)l.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,A.$_c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,s){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:s,didChange:k=>k===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const s=n.get();return this.e.add(n),this.f.delete(n),s}}e.$hd=a,function(i){i.Observer=a}(r||(e.$bd=r={}))}),define(V[6],G([0,1,5,4]),function(z,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=void 0;let E;function C(u){E=u}e.$Gd=C;let r;function d(u){r=u}e.$Hd=d;let t;function c(u){t=u}e.$Id=c;class b{get TChange(){return null}reportChanges(){this.get()}read(m){return m?m.readObservable(this):this.get()}map(m,v){const B=v===void 0?void 0:m,q=v===void 0?m:v;return t({owner:B,debugName:()=>{const f=(0,A.$7c)(q);if(f!==void 0)return f;const L=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(q.toString());if(L)return`${this.debugName}.${L[2]}`;if(!B)return`${this.debugName} (mapped)`}},f=>q(this.read(f),f))}recomputeInitiallyAndOnChange(m,v){return m.add(E(this,v)),this}keepObserved(m){return m.add(r(this)),this}}e.$Jd=b;class g extends b{constructor(){super(...arguments),this.c=new Set}addObserver(m){const v=this.c.size;this.c.add(m),v===0&&this.f()}removeObserver(m){this.c.delete(m)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Kd=g;function o(u,m){const v=new l(u,m);try{u(v)}finally{v.finish()}}e.$Ld=o;let a;function i(u){if(a)u(a);else{const m=new l(u,void 0);a=m;try{u(m)}finally{m.finish(),a=void 0}}}e.$Md=i;async function n(u,m){const v=new l(u,m);try{await u(v)}finally{v.finish()}}e.$Nd=n;function s(u,m,v){u?m(u):o(m,v)}e.$Od=s;class l{constructor(m,v){this._fn=m,this.b=v,this.a=[],(0,T.$yd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,A.$7c)(this._fn)}updateObserver(m,v){this.a.push({observer:m,observable:v}),m.beginUpdate(v)}finish(){const m=this.a;for(let v=0;v<m.length;v++){const{observer:B,observable:q}=m[v];B.endUpdate(q)}this.a=null,(0,T.$yd)()?.handleEndTransaction()}}e.$Pd=l;function k(u,m){return typeof u=="string"?new N(void 0,u,m):new N(u,void 0,m)}e.$Qd=k;class N extends g{get debugName(){return new A.$5c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor(m,v,B){super(),this.b=m,this.d=v,this.a=B}get(){return this.a}set(m,v,B){if(this.a===m)return;let q;v||(v=q=new l(()=>{},()=>`Setting ${this.debugName}`));try{const f=this.a;this.e(m),(0,T.$yd)()?.handleObservableChanged(this,{oldValue:f,newValue:m,change:B,didChange:!0,hadValue:!0});for(const w of this.c)v.updateObserver(w,this),w.handleChange(this,B)}finally{q&&q.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(m){this.a=m}}e.$Rd=N;function P(u,m){return typeof u=="string"?new O(void 0,u,m):new O(u,void 0,m)}e.$Sd=P;class O extends N{e(m){this.a!==m&&(this.a&&this.a.dispose(),this.a=m)}dispose(){this.a?.dispose()}}e.$Td=O}),define(V[11],G([0,1,24,2,6,5,4]),function(z,e,A,T,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=void 0;const d=(n,s)=>n===s;function t(n,s){return s!==void 0?new i(new C.$5c(n,void 0,s),s,void 0,void 0,void 0,d):new i(new C.$5c(void 0,void 0,n),n,void 0,void 0,void 0,d)}e.$Ad=t;function c(n,s){return new i(new C.$5c(n.owner,n.debugName,n.debugReferenceFn),s,void 0,void 0,n.onLastObserverRemoved,n.equalityComparer??d)}e.$Bd=c,(0,E.$Id)(c);function b(n,s){return new i(new C.$5c(n.owner,n.debugName,void 0),s,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??d)}e.$Cd=b;function g(n,s){let l,k;s===void 0?(l=n,k=void 0):(k=n,l=s);const N=new T.$Sc;return new i(new C.$5c(k,void 0,l),P=>(N.clear(),l(P,N)),void 0,void 0,()=>N.dispose(),d)}e.$Dd=g;function o(n,s){let l,k;s===void 0?(l=n,k=void 0):(k=n,l=s);const N=new T.$Sc;return new i(new C.$5c(k,void 0,l),P=>{N.clear();const O=l(P);return O&&N.add(O),O},void 0,void 0,()=>N.dispose(),d)}e.$Ed=o;var a;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(a||(a={}));class i extends E.$Kd{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(s,l,k,N,P=void 0,O){super(),this.n=s,this._computeFn=l,this.p=k,this.q=N,this.s=P,this.t=O,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,r.$yd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const s of this.k)s.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const s=this._computeFn(this,this.p?.());return this.g(),s}else{do{if(this.e===1){for(const s of this.k)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const s=this.l;this.l=this.k,this.k=s;const l=this.e!==0,k=this.h;this.e=3;const N=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,N)}finally{for(const O of this.l)O.removeObserver(this);this.l.clear()}const P=l&&!this.t(k,this.h);if((0,r.$yd)()?.handleDerivedRecomputed(this,{oldValue:k,newValue:this.h,change:void 0,didChange:P,hadValue:l}),P)for(const O of this.c)O.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.j++;const l=this.j===1;if(this.e===3&&(this.e=1,!l))for(const k of this.c)k.handlePossibleChange(this);if(l)for(const k of this.c)k.beginUpdate(this)}endUpdate(s){if(this.j--,this.j===0){const l=[...this.c];for(const k of l)k.endUpdate(this)}(0,A.$_c)(()=>this.j>=0)}handlePossibleChange(s){if(this.e===3&&this.k.has(s)&&!this.l.has(s)){this.e=1;for(const l of this.c)l.handlePossibleChange(this)}}handleChange(s,l){if(this.k.has(s)&&!this.l.has(s)){const k=this.q?this.q({changedObservable:s,change:l,didChange:P=>P===s},this.m):!0,N=this.e===3;if(k&&(this.e===1||N)&&(this.e=2,N))for(const P of this.c)P.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const l=s.get();return this.k.add(s),this.l.delete(s),l}addObserver(s){const l=!this.c.has(s)&&this.j>0;super.addObserver(s),l&&s.beginUpdate(this)}removeObserver(s){const l=this.c.has(s)&&this.j>0;super.removeObserver(s),l&&s.endUpdate(this)}}e.$Fd=i}),define(V[25],G([0,1,2,10,6,5,11,4]),function(z,e,A,T,E,C,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=void 0;function t(f){return new c(f)}e.$id=t;class c extends E.$Jd{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function b(f){const w=(0,E.$Qd)("promiseValue",{});return f.then(L=>{w.set({value:L},void 0)}),w}e.$jd=b;function g(f,w){return new Promise(L=>{let D=!1,S=!1;const $=f.map(F=>({isFinished:w(F),state:F})),R=(0,T.$bd)(F=>{const{isFinished:K,state:p}=$.read(F);K&&(D?R.dispose():S=!0,L(p))});D=!0,S&&R.dispose()})}e.$kd=g;function o(f,w){return new a(f,w)}e.$ld=o;class a extends E.$Kd{constructor(w,L){super(),this.h=w,this._getValue=L,this.b=!1,this.l=D=>{const S=this._getValue(D),$=this.a,R=!this.b||$!==S;let F=!1;R&&(this.a=S,this.b&&(F=!0,(0,E.$Od)(a.globalTransaction,K=>{(0,d.$yd)()?.handleFromEventObservableTriggered(this,{oldValue:$,newValue:S,change:void 0,didChange:R,hadValue:this.b});for(const p of this.c)K.updateObserver(p,this),p.handleChange(this,void 0)},()=>{const K=this.j();return"Event fired"+(K?`: ${K}`:"")})),this.b=!0),F||(0,d.$yd)()?.handleFromEventObservableTriggered(this,{oldValue:$,newValue:S,change:void 0,didChange:R,hadValue:this.b})}}j(){return(0,C.$7c)(this._getValue)}get debugName(){const w=this.j();return"From Event"+(w?`: ${w}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$md=a,function(f){f.Observer=a;function w(L,D){let S=!1;a.globalTransaction===void 0&&(a.globalTransaction=L,S=!0);try{D()}finally{S&&(a.globalTransaction=void 0)}}f.batchEventsGlobally=w}(o||(e.$ld=o={}));function i(f,w){return new n(f,w)}e.$nd=i;class n extends E.$Kd{constructor(w,L){super(),this.debugName=w,this.b=L,this.h=()=>{(0,E.$Ld)(D=>{for(const S of this.c)D.updateObserver(S,this),S.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function s(f){return typeof f=="string"?new l(f):new l(void 0,f)}e.$od=s;class l extends E.$Kd{get debugName(){return new C.$5c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor(w,L){super(),this.a=w,this.b=L}trigger(w,L){if(!w){(0,E.$Ld)(D=>{this.trigger(D,L)},()=>`Trigger signal ${this.debugName}`);return}for(const D of this.c)w.updateObserver(D,this),D.handleChange(this,L)}get(){}}function k(f,w,L){const D=(0,E.$Qd)("debounced",void 0);let S;return L.add((0,T.$bd)($=>{const R=f.read($);S&&clearTimeout(S),S=setTimeout(()=>{(0,E.$Ld)(F=>{D.set(R,F)})},w)})),D}e.$pd=k;function N(f,w,L){const D=(0,E.$Qd)("triggeredRecently",!1);let S;return L.add(f(()=>{D.set(!0,void 0),S&&clearTimeout(S),S=setTimeout(()=>{D.set(!1,void 0)},w)})),D}e.$qd=N;function P(f){const w=new u(!1,void 0);return f.addObserver(w),(0,A.$Rc)(()=>{f.removeObserver(w)})}e.$rd=P,(0,E.$Hd)(P);function O(f,w){const L=new u(!0,w);return f.addObserver(L),w?w(f.get()):f.reportChanges(),(0,A.$Rc)(()=>{f.removeObserver(L)})}e.$sd=O,(0,E.$Gd)(O);class u{constructor(w,L){this.b=w,this.c=L,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&(this.c?this.c(w.get()):w.reportChanges())}handlePossibleChange(w){}handleChange(w,L){}}e.$td=u;function m(f){let w;return(0,r.$Ad)(D=>(w=f(D,w),w))}e.$ud=m;function v(f,w){let L;const D=(0,E.$Qd)("derivedObservableWithWritableCache.counter",0),S=(0,r.$Ad)(f,$=>(D.read($),L=w($,L),L));return Object.assign(S,{clearCache:$=>{L=void 0,D.set(D.get()+1,$)}})}e.$vd=v;function B(f,w,L,D){let S=new q(L,D);return(0,r.$Bd)({debugReferenceFn:L,owner:f,onLastObserverRemoved:()=>{S.dispose(),S=new q(L)}},R=>(S.setItems(w.read(R)),S.getItems()))}e.$wd=B;class q{constructor(w,L){this.c=w,this.e=L,this.a=new Map,this.b=[]}dispose(){this.a.forEach(w=>w.store.dispose()),this.a.clear()}setItems(w){const L=[],D=new Set(this.a.keys());for(const S of w){const $=this.e?this.e(S):S;let R=this.a.get($);if(R)D.delete($);else{const F=new A.$Sc;R={out:this.c(S,F),store:F},this.a.set($,R)}L.push(R.out)}for(const S of D)this.a.get(S).store.dispose(),this.a.delete(S);this.b=L}getItems(){return this.b}}}),define(V[12],G([0,1,6,11,10,25,4]),function(z,e,A,T,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return A.$Qd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return A.$Sd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return A.$Ld}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return A.$Od}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return T.$Ad}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return T.$Bd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return T.$Cd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return T.$Dd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return E.$bd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return E.$gd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return E.$dd}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return E.$fd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return E.$cd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return E.$ed}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return C.$id}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return C.$pd}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return C.$ud}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return C.$vd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return C.$rd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return C.$sd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return C.$ld}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return C.$jd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return C.$od}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return C.$nd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return C.$kd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return C.$qd}}),!1&&(0,r.$xd)(new r.$zd)}),define(V[26],G([0,1,7,2]),function(z,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=void 0;function E(P){const O=P;return O?typeof O.read=="function":!1}e.$0d=E;function C(P){const O=P;return O?[O.on,O.pause,O.resume,O.destroy].every(u=>typeof u=="function"):!1}e.$$d=C;function r(P){const O=P;return O?C(O.stream)&&Array.isArray(O.buffer)&&typeof O.ended=="boolean":!1}e.$_d=r;function d(P,O){return new t(P,O)}e.$ae=d;class t{constructor(O,u){this.e=O,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(O){if(!this.a.destroyed){if(this.a.flowing)this.g(O);else if(this.b.data.push(O),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(O){this.a.destroyed||(this.a.flowing?this.h(O):this.b.error.push(O))}end(O){this.a.destroyed||(typeof O<"u"&&this.write(O),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(O){this.c.data.slice(0).forEach(u=>u(O))}h(O){this.c.error.length===0?(0,A.$1)(O):this.c.error.slice(0).forEach(u=>u(O))}i(){this.c.end.slice(0).forEach(O=>O())}on(O,u){if(!this.a.destroyed)switch(O){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(O,u){if(this.a.destroyed)return;let m;switch(O){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const v=m.indexOf(u);v>=0&&m.splice(v,1)}}j(){if(this.b.data.length>0){const O=this.e(this.b.data);this.g(O),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const O of this.b.error)this.h(O);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(P,O){const u=[];let m;for(;(m=P.read())!==null;)u.push(m);return O(u)}e.$be=c;function b(P,O,u){const m=[];let v;for(;(v=P.read())!==null&&m.length<u;)m.push(v);return v===null&&m.length>0?O(m):{read:()=>{if(m.length>0)return m.shift();if(typeof v<"u"){const B=v;return v=void 0,B}return P.read()}}}e.$ce=b;function g(P,O){return new Promise((u,m)=>{const v=[];o(P,{onData:B=>{O&&v.push(B)},onError:B=>{O?m(B):u(void 0)},onEnd:()=>{u(O?O(v):void 0)}})})}e.$de=g;function o(P,O,u){P.on("error",m=>{u?.isCancellationRequested||O.onError(m)}),P.on("end",()=>{u?.isCancellationRequested||O.onEnd()}),P.on("data",m=>{u?.isCancellationRequested||O.onData(m)})}e.$ee=o;function a(P,O){return new Promise((u,m)=>{const v=new T.$Sc,B=[],q=L=>{if(B.push(L),B.length>O)return v.dispose(),P.pause(),u({stream:P,buffer:B,ended:!1})},f=L=>(v.dispose(),m(L)),w=()=>(v.dispose(),u({stream:P,buffer:B,ended:!0}));v.add((0,T.$Rc)(()=>P.removeListener("error",f))),P.on("error",f),v.add((0,T.$Rc)(()=>P.removeListener("end",w))),P.on("end",w),v.add((0,T.$Rc)(()=>P.removeListener("data",q))),P.on("data",q)})}e.$fe=a;function i(P,O){const u=d(O);return u.end(P),u}e.$ge=i;function n(){const P=d(()=>{throw new Error("not supported")});return P.end(),P}e.$he=n;function s(P){let O=!1;return{read:()=>O?null:(O=!0,P)}}e.$ie=s;function l(P,O,u){const m=d(u);return o(P,{onData:v=>m.write(O.data(v)),onError:v=>m.error(O.error?O.error(v):v),onEnd:()=>m.end()}),m}e.$je=l;function k(P,O,u){let m=!1;return{read:()=>{const v=O.read();return m?v:(m=!0,v!==null?u([P,v]):P)}}}e.$ke=k;function N(P,O,u){let m=!1;const v=d(u);return o(O,{onData:B=>m?v.write(B):(m=!0,v.write(u([P,B]))),onError:B=>v.error(B),onEnd:()=>{m||(m=!0,v.write(P)),v.end()}}),v}e.$le=N}),define(V[13],G([0,1,27,26]),function(z,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;const E=typeof Buffer<"u",C=new A.$V(()=>new Uint8Array(256));let r,d;class t{static alloc($){return E?new t(Buffer.allocUnsafe($)):new t(new Uint8Array($))}static wrap($){return E&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new t($)}static fromString($,R){return!(R?.dontUseNodeBuffer||!1)&&E?new t(Buffer.from($)):(r||(r=new TextEncoder),new t(r.encode($)))}static fromByteArray($){const R=t.alloc($.length);for(let F=0,K=$.length;F<K;F++)R.buffer[F]=$[F];return R}static concat($,R){if(typeof R>"u"){R=0;for(let p=0,_=$.length;p<_;p++)R+=$[p].byteLength}const F=t.alloc(R);let K=0;for(let p=0,_=$.length;p<_;p++){const W=$[p];F.set(W,K),K+=W.byteLength}return F}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=t.alloc(this.byteLength);return $.set(this),$}toString(){return E?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice($,R){return new t(this.buffer.subarray($,R))}set($,R){if($ instanceof t)this.buffer.set($.buffer,R);else if($ instanceof Uint8Array)this.buffer.set($,R);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),R);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return o(this.buffer,$)}writeUInt32BE($,R){a(this.buffer,$,R)}readUInt32LE($){return i(this.buffer,$)}writeUInt32LE($,R){n(this.buffer,$,R)}readUInt8($){return s(this.buffer,$)}writeUInt8($,R){l(this.buffer,$,R)}indexOf($,R=0){return c(this.buffer,$ instanceof t?$.buffer:$,R)}}e.$me=t;function c(S,$,R=0){const F=$.byteLength,K=S.byteLength;if(F===0)return 0;if(F===1)return S.indexOf($[0]);if(F>K-R)return-1;const p=C.value;p.fill($.length);for(let J=0;J<$.length;J++)p[$[J]]=$.length-J-1;let _=R+$.length-1,W=_,H=-1;for(;_<K;)if(S[_]===$[W]){if(W===0){H=_;break}_--,W--}else _+=Math.max($.length-W,p[S[_]]),W=$.length-1;return H}e.$ne=c;function b(S,$){return S[$+0]<<0>>>0|S[$+1]<<8>>>0}e.$oe=b;function g(S,$,R){S[R+0]=$&255,$=$>>>8,S[R+1]=$&255}e.$pe=g;function o(S,$){return S[$]*2**24+S[$+1]*2**16+S[$+2]*2**8+S[$+3]}e.$qe=o;function a(S,$,R){S[R+3]=$,$=$>>>8,S[R+2]=$,$=$>>>8,S[R+1]=$,$=$>>>8,S[R]=$}e.$re=a;function i(S,$){return S[$+0]<<0>>>0|S[$+1]<<8>>>0|S[$+2]<<16>>>0|S[$+3]<<24>>>0}e.$se=i;function n(S,$,R){S[R+0]=$&255,$=$>>>8,S[R+1]=$&255,$=$>>>8,S[R+2]=$&255,$=$>>>8,S[R+3]=$&255}e.$te=n;function s(S,$){return S[$]}e.$ue=s;function l(S,$,R){S[R]=$}e.$ve=l;function k(S){return T.$be(S,$=>t.concat($))}e.$we=k;function N(S){return T.$ie(S)}e.$xe=N;function P(S){return T.$de(S,$=>t.concat($))}e.$ye=P;async function O(S){return S.ended?t.concat(S.buffer):t.concat([...S.buffer,await P(S.stream)])}e.$ze=O;function u(S){return T.$ge(S,$=>t.concat($))}e.$Ae=u;function m(S){return T.$je(S,{data:$=>typeof $=="string"?t.fromString($):t.wrap($)},$=>t.concat($))}e.$Be=m;function v(S){return T.$ae($=>t.concat($),S)}e.$Ce=v;function B(S,$){return T.$ke(S,$,R=>t.concat(R))}e.$De=B;function q(S,$){return T.$le(S,$,R=>t.concat(R))}e.$Ee=q;function f(S){let $=0,R=0,F=0;const K=new Uint8Array(Math.floor(S.length/4*3)),p=W=>{switch(R){case 3:K[F++]=$|W,R=0;break;case 2:K[F++]=$|W>>>2,$=W<<6,R=3;break;case 1:K[F++]=$|W>>>4,$=W<<4,R=2;break;default:$=W<<2,R=1}};for(let W=0;W<S.length;W++){const H=S.charCodeAt(W);if(H>=65&&H<=90)p(H-65);else if(H>=97&&H<=122)p(H-97+26);else if(H>=48&&H<=57)p(H-48+52);else if(H===43||H===45)p(62);else if(H===47||H===95)p(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${S[W]}`)}}const _=F;for(;R>0;)p(0);return t.wrap(K).slice(0,_)}e.$Fe=f;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:S},$=!0,R=!1){const F=R?L:w;let K="";const p=S.byteLength%3;let _=0;for(;_<S.byteLength-p;_+=3){const W=S[_+0],H=S[_+1],J=S[_+2];K+=F[W>>>2],K+=F[(W<<4|H>>>4)&63],K+=F[(H<<2|J>>>6)&63],K+=F[J&63]}if(p===1){const W=S[_+0];K+=F[W>>>2],K+=F[W<<4&63],$&&(K+="==")}else if(p===2){const W=S[_+0],H=S[_+1];K+=F[W>>>2],K+=F[(W<<4|H>>>4)&63],K+=F[H<<2&63],$&&(K+="=")}return K}e.$Ge=D}),define(V[28],G([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=void 0,e.$Vd=Symbol("MicrotaskDelay")}),define(V[14],G([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=e.StringEOL=void 0;var A;(function(E){E[E.Unknown=0]="Unknown",E[E.Invalid=3]="Invalid",E[E.LF=1]="LF",E[E.CRLF=2]="CRLF"})(A||(e.StringEOL=A={}));function T(E){let C=0,r=0,d=0,t=0;for(let c=0,b=E.length;c<b;c++){const g=E.charCodeAt(c);g===13?(C===0&&(r=c),C++,c+1<b&&E.charCodeAt(c+1)===10?(t|=2,c++):t|=3,d=c+1):g===10&&(t|=1,C===0&&(r=c),C++,d=c+1)}return C===0&&(r=E.length),[C,r,E.length-d,t]}e.$zt=T}),define(V[15],G([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(A||(e.LanguageId=A={}));var T;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(T||(e.FontStyle=T={}));var E;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(E||(e.ColorId=E={}));var C;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(C||(e.StandardTokenType=C={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class d{static getLanguageId(c){return(c&255)>>>0}static getTokenType(c){return(c&768)>>>8}static containsBalancedBrackets(c){return(c&1024)!==0}static getFontStyle(c){return(c&30720)>>>11}static getForeground(c){return(c&16744448)>>>15}static getBackground(c){return(c&4278190080)>>>24}static getClassNameFromMetadata(c){let g="mtk"+this.getForeground(c);const o=this.getFontStyle(c);return o&1&&(g+=" mtki"),o&2&&(g+=" mtkb"),o&4&&(g+=" mtku"),o&8&&(g+=" mtks"),g}static getInlineStyleFromMetadata(c,b){const g=this.getForeground(c),o=this.getFontStyle(c);let a=`color: ${b[g]};`;o&1&&(a+="font-style: italic;"),o&2&&(a+="font-weight: bold;");let i="";return o&4&&(i+=" underline"),o&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(c){const b=this.getForeground(c),g=this.getFontStyle(c);return{foreground:b,italic:!!(g&1),bold:!!(g&2),underline:!!(g&4),strikethrough:!!(g&8)}}}e.$xt=d}),define(V[29],G([0,1,30]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=void 0;class T{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,d){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=d}replace(r,d,t){if(r>=this.a.length)return;if(d===0){this.insert(r,t);return}else if(t===0){this.delete(r,d);return}const c=this.a.slice(0,r),b=this.a.slice(r+d),g=E(t,this.b);this.a=c.concat(g,b)}delete(r,d){d===0||r>=this.a.length||this.a.splice(r,d)}insert(r,d){if(d===0||r>=this.a.length)return;const t=[];for(let c=0;c<d;c++)t[c]=this.b;this.a=(0,A.$Wb)(this.a,r,t)}}e.$lC=T;function E(C,r){const d=[];for(let t=0;t<C;t++)d[t]=r;return d}}),define(V[8],G([0,1,15]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=void 0;class T{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,d){const t=T.defaultTokenMetadata,c=new Uint32Array(2);return c[0]=r.length,c[1]=t,new T(c,r,d)}constructor(r,d,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=d,this.d=t}equals(r){return r instanceof T?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,d,t){if(this.c!==r.c||this.b!==r.b)return!1;const c=d<<1,b=c+(t<<1);for(let g=c;g<b;g++)if(this.a[g]!==r.a[g])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const d=this.a[(r<<1)+1],t=A.$xt.getLanguageId(d);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const d=this.a[(r<<1)+1];return A.$xt.getTokenType(d)}getForeground(r){const d=this.a[(r<<1)+1];return A.$xt.getForeground(d)}getClassName(r){const d=this.a[(r<<1)+1];return A.$xt.getClassNameFromMetadata(d)}getInlineStyle(r,d){const t=this.a[(r<<1)+1];return A.$xt.getInlineStyleFromMetadata(t,d)}getPresentation(r){const d=this.a[(r<<1)+1];return A.$xt.getPresentationFromMetadata(d)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return T.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,d,t){return new E(this,r,d,t)}static convertToEndOffset(r,d){const c=(r.length>>>1)-1;for(let b=0;b<c;b++)r[b<<1]=r[b+1<<1];r[c<<1]=d}static findIndexInTokensArray(r,d){if(r.length<=2)return 0;let t=0,c=(r.length>>>1)-1;for(;t<c;){const b=t+Math.floor((c-t)/2),g=r[b<<1];if(g===d)return b+1;g<d?t=b+1:g>d&&(c=b)}return t}withInserted(r){if(r.length===0)return this;let d=0,t=0,c="";const b=new Array;let g=0;for(;;){const o=d<this.b?this.a[d<<1]:-1,a=t<r.length?r[t]:null;if(o!==-1&&(a===null||o<=a.offset)){c+=this.c.substring(g,o);const i=this.a[(d<<1)+1];b.push(c.length,i),d++,g=o}else if(a){if(a.offset>g){c+=this.c.substring(g,a.offset);const i=this.a[(d<<1)+1];b.push(c.length,i),g=a.offset}c+=a.text,b.push(c.length,a.tokenMetadata),t++}else break}return new T(new Uint32Array(b),c,this.d)}}e.$At=T;class E{constructor(r,d,t,c){this.a=r,this.b=d,this.c=t,this.d=c,this.e=r.findTokenIndexAtOffset(d),this.f=0;for(let b=this.e,g=r.getCount();b<g&&!(r.getStartOffset(b)>=t);b++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof E?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const d=this.a.getEndOffset(this.e+r);return Math.min(this.c,d)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,d){return this.a.getInlineStyle(this.e+r,d)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(V[31],G([0,1,8]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.$Ct=e.$Bt=void 0,e.$Bt=new Uint32Array(0).buffer;class T{static deleteBeginning(r,d){return r===null||r===e.$Bt?r:T.delete(r,0,d)}static deleteEnding(r,d){if(r===null||r===e.$Bt)return r;const t=E(r),c=t[t.length-2];return T.delete(r,d,c)}static delete(r,d,t){if(r===null||r===e.$Bt||d===t)return r;const c=E(r),b=c.length>>>1;if(d===0&&c[c.length-2]===t)return e.$Bt;const g=A.$At.findIndexInTokensArray(c,d),o=g>0?c[g-1<<1]:0,a=c[g<<1];if(t<a){const k=t-d;for(let N=g;N<b;N++)c[N<<1]-=k;return r}let i,n;o!==d?(c[g<<1]=d,i=g+1<<1,n=d):(i=g<<1,n=o);const s=t-d;for(let k=g+1;k<b;k++){const N=c[k<<1]-s;N>n&&(c[i++]=N,c[i++]=c[(k<<1)+1],n=N)}if(i===c.length)return r;const l=new Uint32Array(i);return l.set(c.subarray(0,i),0),l.buffer}static append(r,d){if(d===e.$Bt)return r;if(r===e.$Bt)return d;if(r===null)return r;if(d===null)return null;const t=E(r),c=E(d),b=c.length>>>1,g=new Uint32Array(t.length+c.length);g.set(t,0);let o=t.length;const a=t[t.length-2];for(let i=0;i<b;i++)g[o++]=c[i<<1]+a,g[o++]=c[(i<<1)+1];return g.buffer}static insert(r,d,t){if(r===null||r===e.$Bt)return r;const c=E(r),b=c.length>>>1;let g=A.$At.findIndexInTokensArray(c,d);g>0&&c[g-1<<1]===d&&g--;for(let o=g;o<b;o++)c[o<<1]+=t;return r}}e.$Ct=T;function E(C){return C instanceof Uint32Array?C:new Uint32Array(C)}e.$Dt=E}),define(V[32],G([0,1,30,13,45,14,31,16]),function(z,e,A,T,E,C,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0;class t{static deserialize(b,g,o){const a=new Uint32Array(b.buffer),i=(0,T.$qe)(b,g);g+=4;const n=(0,T.$qe)(b,g);g+=4;const s=[];for(let l=0;l<n;l++){const k=(0,T.$qe)(b,g);g+=4,s.push(a.subarray(g/4,g/4+k/4)),g+=k}return o.push(new t(i,s)),g}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(b,g){this.a=b,this.b=g}getLineRange(){return new d.$9s(this.a,this.a+this.b.length)}getLineTokens(b){return this.b[b-this.a]}appendLineTokens(b){this.b.push(b)}serializeSize(){let b=0;b+=4,b+=4;for(let g=0;g<this.b.length;g++){const o=this.b[g];if(!(o instanceof Uint32Array))throw new Error("Not supported!");b+=4,b+=o.byteLength}return b}serialize(b,g){(0,T.$re)(b,this.a,g),g+=4,(0,T.$re)(b,this.b.length,g),g+=4;for(let o=0;o<this.b.length;o++){const a=this.b[o];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,T.$re)(b,a.byteLength,g),g+=4,b.set(new Uint8Array(a.buffer),g),g+=a.byteLength}return g}applyEdit(b,g){const[o,a]=(0,C.$zt)(g);this.c(b),this.d(new E.$Ys(b.startLineNumber,b.startColumn),o,a)}c(b){if(b.startLineNumber===b.endLineNumber&&b.startColumn===b.endColumn)return;const g=b.startLineNumber-this.a,o=b.endLineNumber-this.a;if(o<0){const a=o-g;this.a-=a;return}if(!(g>=this.b.length)){if(g<0&&o>=this.b.length){this.a=0,this.b=[];return}if(g===o){this.b[g]=r.$Ct.delete(this.b[g],b.startColumn-1,b.endColumn-1);return}if(g>=0)if(this.b[g]=r.$Ct.deleteEnding(this.b[g],b.startColumn-1),o<this.b.length){const a=r.$Ct.deleteBeginning(this.b[o],b.endColumn-1);this.b[g]=r.$Ct.append(this.b[g],a),this.b.splice(g+1,o-g)}else this.b[g]=r.$Ct.append(this.b[g],null),this.b=this.b.slice(0,g+1);else{const a=-g;this.a-=a,this.b[o]=r.$Ct.deleteBeginning(this.b[o],b.endColumn-1),this.b=this.b.slice(o)}}}d(b,g,o){if(g===0&&o===0)return;const a=b.lineNumber-this.a;if(a<0){this.a+=g;return}if(!(a>=this.b.length)){if(g===0){this.b[a]=r.$Ct.insert(this.b[a],b.column-1,o);return}this.b[a]=r.$Ct.deleteEnding(this.b[a],b.column-1),this.b[a]=r.$Ct.insert(this.b[a],b.column-1,o),this.e(b.lineNumber,g)}}e(b,g){if(g===0)return;const o=[];for(let a=0;a<g;a++)o[a]=null;this.b=A.$Wb(this.b,b,o)}}e.$Et=t}),define(V[17],G([0,1,13,32]),function(z,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=void 0;class E{static deserialize(r){let d=0;const t=(0,A.$qe)(r,d);d+=4;const c=[];for(let b=0;b<t;b++)d=T.$Et.deserialize(r,d,c);return c}constructor(){this.a=[]}add(r,d){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(d);return}}this.a.push(new T.$Et(r,[d]))}finalize(){return this.a}serialize(){const r=this.b(),d=new Uint8Array(r);return this.c(d),d}b(){let r=0;r+=4;for(let d=0;d<this.a.length;d++)r+=this.a[d].serializeSize();return r}c(r){let d=0;(0,A.$re)(r,this.a.length,d),d+=4;for(let t=0;t<this.a.length;t++)d=this.a[t].serialize(r,d)}}e.$mC=E}),define(V[33],G([0,1,34,3,18,46]),function(z,e,A,T,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=void 0;function r(f){return f===47||f===92}e.$5f=r;function d(f){return f.replace(/[\\/]/g,A.$gc.sep)}e.$6f=d;function t(f){return f.indexOf("/")===-1&&(f=d(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$7f=t;function c(f,w=A.$gc.sep){if(!f)return"";const L=f.length,D=f.charCodeAt(0);if(r(D)){if(r(f.charCodeAt(1))&&!r(f.charCodeAt(2))){let $=3;const R=$;for(;$<L&&!r(f.charCodeAt($));$++);if(R!==$&&!r(f.charCodeAt($+1))){for($+=1;$<L;$++)if(r(f.charCodeAt($)))return f.slice(0,$+1).replace(/[\\/]/g,w)}}return w}else if(l(D)&&f.charCodeAt(1)===58)return r(f.charCodeAt(2))?f.slice(0,2)+w:f.slice(0,2);let S=f.indexOf("://");if(S!==-1){for(S+=3;S<L;S++)if(r(f.charCodeAt(S)))return f.slice(0,S+1)}return""}e.$8f=c;function b(f){if(!T.$i||!f||f.length<5)return!1;let w=f.charCodeAt(0);if(w!==92||(w=f.charCodeAt(1),w!==92))return!1;let L=2;const D=L;for(;L<f.length&&(w=f.charCodeAt(L),w!==92);L++);return!(D===L||(w=f.charCodeAt(L+1),isNaN(w)||w===92))}e.$9f=b;const g=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(f,w=T.$i){const L=w?g:o;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||w&&a.test(f)||f==="."||f===".."||w&&f[f.length-1]==="."||w&&f.length!==f.trim().length||f.length>255)}e.$0f=i;function n(f,w,L){const D=f===w;return!L||D?D:!f||!w?!1:(0,E.$df)(f,w)}e.$$f=n;function s(f,w,L,D=A.sep){if(f===w)return!0;if(!f||!w||w.length>f.length)return!1;if(L){if(!(0,E.$ef)(f,w))return!1;if(w.length===f.length)return!0;let $=w.length;return w.charAt(w.length-1)===D&&$--,f.charAt($)===D}return w.charAt(w.length-1)!==D&&(w+=D),f.indexOf(w)===0}e.$_f=s;function l(f){return f>=65&&f<=90||f>=97&&f<=122}e.$ag=l;function k(f,w){return T.$i&&f.endsWith(":")&&(f+=A.sep),(0,A.$ic)(f)||(f=(0,A.$jc)(w,f)),f=(0,A.$hc)(f),T.$i?(f=(0,E.$Xe)(f,A.sep),f.endsWith(":")&&(f+=A.sep)):(f=(0,E.$Xe)(f,A.sep),f||(f=A.sep)),f}e.$bg=k;function N(f){const w=(0,A.$hc)(f);return T.$i?f.length>3?!1:P(w)&&(f.length===2||w.charCodeAt(2)===92):w===A.$gc.sep}e.$cg=N;function P(f,w=T.$i){return w?l(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$dg=P;function O(f,w=T.$i){return P(f,w)?f[0]:void 0}e.$eg=O;function u(f,w,L){return w.length>f.length?-1:f===w?0:(L&&(f=f.toLowerCase(),w=w.toLowerCase()),f.indexOf(w))}e.$fg=u;function m(f){const w=f.split(":");let L,D,S;for(const $ of w){const R=Number($);(0,C.$Qf)(R)?D===void 0?D=R:S===void 0&&(S=R):L=L?[L,$].join(":"):$}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:D!==void 0?D:void 0,column:S!==void 0?S:D!==void 0?1:void 0}}e.$gg=m;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",B="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function q(f,w,L=8){let D="";for(let $=0;$<L;$++){let R;$===0&&T.$i&&!w&&(L===3||L===4)?R=B:R=v,D+=R.charAt(Math.floor(Math.random()*R.length))}let S;return w?S=`${w}-${D}`:S=D,f?(0,A.$jc)(f,S):S}e.$hg=q}),define(V[19],G([0,1,7,3,18,9]),function(z,e,A,T,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.Schemas=void 0;var r;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatCodeBlock="vscode-chat-code-block",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm",o.codeSetting="code-setting"})(r||(e.Schemas=r={}));function d(o,a){return C.URI.isUri(o)?(0,E.$df)(o.scheme,a):(0,E.$ef)(o,a+":")}e.$ig=d;function t(o,...a){return a.some(i=>d(o,i))}e.$jg=t,e.$kg="vscode-tkn",e.$lg="tkn";class c{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${r.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${r.vscodeRemoteResource}`}set(a,i,n){this.a[a]=i,this.b[a]=n}setConnectionToken(a,i){this.c[a]=i}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(N){return A.$1(N),a}const i=a.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this.b[i],l=this.c[i];let k=`path=${encodeURIComponent(a.path)}`;return typeof l=="string"&&(k+=`&${e.$lg}=${encodeURIComponent(l)}`),C.URI.from({scheme:T.$o?this.d:r.vscodeRemoteResource,authority:`${n}:${s}`,path:this.f,query:k})}}e.$mg=new c,e.$ng="vs/../../extensions",e.$og="vs/../../node_modules",e.$pg="vs/../../node_modules.asar",e.$qg="vs/../../node_modules.asar.unpacked",e.$rg="vscode-app";class b{static{this.a=e.$rg}asBrowserUri(a){const i=this.b(a,z);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===r.vscodeRemote?e.$mg.rewrite(a):a.scheme===r.file&&(T.$m||T.$q===`${r.vscodeFileResource}://${b.a}`)?a.with({scheme:r.vscodeFileResource,authority:a.authority||b.a,query:null,fragment:null}):a}asFileUri(a){const i=this.b(a,z);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===r.vscodeFileResource?a.with({scheme:r.file,authority:a.authority!==b.a?a.authority:null,query:null,fragment:null}):a}b(a,i){return C.URI.isUri(a)?a:C.URI.parse(i.toUrl(a))}}e.$sg=new b;var g;(function(o){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(l){let k;typeof l=="string"?k=new URL(l).searchParams:l instanceof URL?k=l.searchParams:C.URI.isUri(l)&&(k=new URL(l.toString(!0)).searchParams);const N=k?.get(i);if(N)return a.get(N)}o.getHeadersFromQuery=n;function s(l,k,N){if(!globalThis.crossOriginIsolated)return;const P=k&&N?"3":N?"2":"1";l instanceof URLSearchParams?l.set(i,P):l[i]=P}o.addSearchParam=s})(g||(e.COI=g={}))}),define(V[35],G([0,1,23,19,3,9]),function(z,e,A,T,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mD=void 0;class r{constructor(o,a,i){this.id=o,this.dependencies=a,this.callback=i}}class d{static{this.INSTANCE=new d}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(o,a,i)=>{typeof o!="string"&&(i=a,a=o,o=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this.c.push(new r(o,a,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){if(o.startsWith(window.location.origin)||o.startsWith("vscode-file://vscode-app"))return o;throw new Error(`[trusted_script_src] Invalid script url: ${o}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){return o}})))}async load(o){this.g();const a=await(this.a?this.i(o):this.b?this.h(o):this.j(o));if(!a)throw new Error(`Did not receive a define call from script ${o}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${o}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(o){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const s=()=>{n.removeEventListener("load",l),n.removeEventListener("error",k)},l=N=>{s(),a(this.c.pop())},k=N=>{s(),i(N)};n.addEventListener("load",l),n.addEventListener("error",k),this.f&&(o=this.f.createScriptURL(o)),n.setAttribute("src",o),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(o){return new Promise((a,i)=>{try{this.f&&(o=this.f.createScriptURL(o)),importScripts(o),a(this.c.pop())}catch(n){i(n)}})}async j(o){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,s=C.URI.parse(o).fsPath,l=a.readFileSync(s).toString(),k=n.wrap(l.replace(/^#!.*/,""));return new i.Script(k).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const t=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function b(g,o,a){if(A.$T){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[g]&&(g=c[g]);const i=`${g}/${o}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const N=`${a&&!E.$o?T.$pg:T.$og}/${i}`;n=T.$sg.asBrowserUri(N).toString(!0)}const s=d.INSTANCE.load(n);return t.set(i,s),s}else return await new Promise((i,n)=>{z([g],i,n)})}e.$mD=b}),define(V[20],G([0,1,33,19,34,3,18,9]),function(z,e,A,T,E,C,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.DataUri=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=void 0;function t(a){return(0,d.$wc)(a,!0)}e.$zg=t;class c{constructor(i){this.a=i}compare(i,n,s=!1){return i===n?0:(0,r.$9e)(this.getComparisonKey(i,s),this.getComparisonKey(n,s))}isEqual(i,n,s=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,s)===this.getComparisonKey(n,s)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,s=!1){if(i.scheme===n.scheme){if(i.scheme===T.Schemas.file)return A.$_f(t(i),t(n),this.a(i))&&i.query===n.query&&(s||i.fragment===n.fragment);if((0,e.$Qg)(i.authority,n.authority))return A.$_f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(s||i.fragment===n.fragment)}return!1}joinPath(i,...n){return d.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$Ig)(i)||i.authority}basename(i){return E.$gc.basename(i.path)}extname(i){return E.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===T.Schemas.file?n=d.URI.file(E.$mc(t(i))).path:(n=E.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===T.Schemas.file?n=d.URI.file(E.$hc(t(i))).path:n=E.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Qg)(i.authority,n.authority))return;if(i.scheme===T.Schemas.file){const k=E.$lc(t(i),t(n));return C.$i?A.$6f(k):k}let s=i.path||"/";const l=n.path||"/";if(this.a(i)){let k=0;for(const N=Math.min(s.length,l.length);k<N&&!(s.charCodeAt(k)!==l.charCodeAt(k)&&s.charAt(k).toLowerCase()!==l.charAt(k).toLowerCase());k++);s=l.substr(0,k)+s.substr(k)}return E.$gc.relative(s,l)}resolvePath(i,n){if(i.scheme===T.Schemas.file){const s=d.URI.file(E.$kc(t(i),n));return i.with({authority:s.authority,path:s.path})}return n=A.$7f(n),i.with({path:E.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,r.$df)(i,n)}hasTrailingPathSeparator(i,n=E.sep){if(i.scheme===T.Schemas.file){const s=t(i);return s.length>A.$8f(s).length&&s[s.length-1]===n}else{const s=i.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=E.sep){return(0,e.$Rg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=E.sep){let s=!1;if(i.scheme===T.Schemas.file){const l=t(i);s=l!==void 0&&l.length===A.$8f(l).length&&l[l.length-1]===n}else{n="/";const l=i.path;s=l.length===1&&l.charCodeAt(l.length-1)===47}return!s&&!(0,e.$Rg)(i,n)?i.with({path:i.path+"/"}):i}}e.$Ag=c,e.$Bg=new c(()=>!1),e.$Cg=new c(a=>a.scheme===T.Schemas.file?!C.$k:!0),e.$Dg=new c(a=>!0),e.$Eg=e.$Bg.isEqual.bind(e.$Bg),e.$Fg=e.$Bg.isEqualOrParent.bind(e.$Bg),e.$Gg=e.$Bg.getComparisonKey.bind(e.$Bg),e.$Hg=e.$Bg.basenameOrAuthority.bind(e.$Bg),e.$Ig=e.$Bg.basename.bind(e.$Bg),e.$Jg=e.$Bg.extname.bind(e.$Bg),e.$Kg=e.$Bg.dirname.bind(e.$Bg),e.$Lg=e.$Bg.joinPath.bind(e.$Bg),e.$Mg=e.$Bg.normalizePath.bind(e.$Bg),e.$Ng=e.$Bg.relativePath.bind(e.$Bg),e.$Og=e.$Bg.resolvePath.bind(e.$Bg),e.$Pg=e.$Bg.isAbsolutePath.bind(e.$Bg),e.$Qg=e.$Bg.isEqualAuthority.bind(e.$Bg),e.$Rg=e.$Bg.hasTrailingPathSeparator.bind(e.$Bg),e.$Sg=e.$Bg.removeTrailingPathSeparator.bind(e.$Bg),e.$Tg=e.$Bg.addTrailingPathSeparator.bind(e.$Bg);function b(a,i){const n=[];for(let s=0;s<a.length;s++){const l=i(a[s]);a.some((k,N)=>N===s?!1:(0,e.$Fg)(l,i(k)))||n.push(a[s])}return n}e.$Ug=b;var g;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const s=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(N=>{const[P,O]=N.split(":");P&&O&&s.set(P,O)});const k=n.path.substring(0,n.path.indexOf(";"));return k&&s.set(a.META_DATA_MIME,k),s}a.parseMetaData=i})(g||(e.DataUri=g={}));function o(a,i,n){if(i){let s=a.path;return s&&s[0]!==E.$gc.sep&&(s=E.$gc.sep+s),a.with({scheme:n,authority:i,path:s})}return a.with({scheme:n})}e.$Vg=o}),define(V[21],G([0,1,47,7,36,2,20,3,28,27]),function(z,e,A,T,E,C,r,d,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.Promises=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=void 0;function b(j){return!!j&&typeof j.then=="function"}e.$Wg=b;function g(j){const h=new A.$9d,y=j(h.token),I=new Promise((M,U)=>{const Q=h.token.onCancellationRequested(()=>{Q.dispose(),U(new T.$5)});Promise.resolve(y).then(Z=>{Q.dispose(),h.dispose(),M(Z)},Z=>{Q.dispose(),h.dispose(),U(Z)})});return new class{cancel(){h.cancel(),h.dispose()}then(M,U){return I.then(M,U)}catch(M){return this.then(void 0,M)}finally(M){return I.finally(M)}}}e.$Xg=g;function o(j,h,y){return new Promise((I,M)=>{const U=h.onCancellationRequested(()=>{U.dispose(),I(y)});j.then(I,M).finally(()=>U.dispose())})}e.$Yg=o;function a(j,h){return new Promise((y,I)=>{const M=h.onCancellationRequested(()=>{M.dispose(),I(new T.$5)});j.then(y,I).finally(()=>M.dispose())})}e.$Zg=a;async function i(j){let h=-1;const y=j.map((I,M)=>I.then(U=>(h=M,U)));try{return await Promise.race(y)}finally{j.forEach((I,M)=>{M!==h&&I.cancel()})}}e.$1g=i;function n(j,h,y){let I;const M=setTimeout(()=>{I?.(void 0),y?.()},h);return Promise.race([j.finally(()=>clearTimeout(M)),new Promise(U=>I=U)])}e.$2g=n;function s(j){return new Promise((h,y)=>{const I=j();b(I)?I.then(h,y):h(I)})}e.$3g=s;function l(){let j,h;return{promise:new Promise((I,M)=>{j=I,h=M}),resolve:j,reject:h}}e.$4g=l;class k{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(h){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=h,!this.b){const y=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(y,y).then(I)})}return new Promise((y,I)=>{this.b.then(y,I)})}return this.a=h(),new Promise((y,I)=>{this.a.then(M=>{this.a=null,y(M)},M=>{this.a=null,I(M)})})}dispose(){this.f=!0}}e.$5g=k;class N{constructor(){this.a=Promise.resolve(null)}queue(h){return this.a=this.a.then(()=>h(),()=>h())}}e.$6g=N;class P{constructor(){this.a=new Map}queue(h,y){const M=(this.a.get(h)??Promise.resolve()).catch(()=>{}).then(y).finally(()=>{this.a.get(h)===M&&this.a.delete(h)});return this.a.set(h,M),M}}e.$7g=P;const O=(j,h)=>{let y=!0;const I=setTimeout(()=>{y=!1,h()},j);return{isTriggered:()=>y,dispose:()=>{clearTimeout(I),y=!1}}},u=j=>{let h=!0;return queueMicrotask(()=>{h&&(h=!1,j())}),{isTriggered:()=>h,dispose:()=>{h=!1}}};class m{constructor(h){this.defaultDelay=h,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(h,y=this.defaultDelay){this.g=h,this.h(),this.b||(this.b=new Promise((M,U)=>{this.d=M,this.f=U}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=y===t.$Vd?u(I):O(y,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$8g=m;class v{constructor(h){this.a=new m(h),this.b=new k}trigger(h,y){return this.a.trigger(()=>this.b.queue(h),y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$9g=v;class B{constructor(){this.a=!1,this.b=new Promise((h,y)=>{this.d=h})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$0g=B;class q extends B{constructor(h){super(),this.f=setTimeout(()=>this.open(),h)}open(){clearTimeout(this.f),super.open()}}e.$$g=q;function f(j,h){return h?new Promise((y,I)=>{const M=setTimeout(()=>{U.dispose(),y()},j),U=h.onCancellationRequested(()=>{clearTimeout(M),U.dispose(),I(new T.$5)})}):g(y=>f(j,y))}e.$_g=f;function w(j,h=0,y){const I=setTimeout(()=>{j(),y&&M.dispose()},h),M=(0,C.$Rc)(()=>{clearTimeout(I),y?.deleteAndLeak(M)});return y?.add(M),M}e.$ah=w;function L(j){const h=[];let y=0;const I=j.length;function M(){return y<I?j[y++]():null}function U(Q){Q!=null&&h.push(Q);const Z=M();return Z?Z.then(U):Promise.resolve(h)}return Promise.resolve(null).then(U)}e.$bh=L;function D(j,h=I=>!!I,y=null){let I=0;const M=j.length,U=()=>{if(I>=M)return Promise.resolve(y);const Q=j[I++];return Promise.resolve(Q()).then(X=>h(X)?Promise.resolve(X):U())};return U()}e.$ch=D;function S(j,h=I=>!!I,y=null){if(j.length===0)return Promise.resolve(y);let I=j.length;const M=()=>{I=-1;for(const U of j)U.cancel?.()};return new Promise((U,Q)=>{for(const Z of j)Z.then(X=>{--I>=0&&h(X)?(M(),U(X)):I===0&&U(y)}).catch(X=>{--I>=0&&(M(),Q(X))})})}e.$dh=S;class ${constructor(h){this.a=0,this.b=!1,this.f=h,this.g=[],this.d=0,this.h=new E.$Yd}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(h){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((y,I)=>{this.g.push({factory:h,c:y,e:I}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const h=this.g.shift();this.d++;const y=h.factory();y.then(h.c,h.e),y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$eh=$;class R extends ${constructor(){super(1)}}e.$fh=R;class F{constructor(){this.a=new te,this.b=0}queue(h){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,h())):this.a.run(this.b++,h())}}e.$gh=F;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const h=new x;return this.b.add(h),h.p}g(){for(const[,h]of this.a)if(h.size>0)return!1;return!0}queueSize(h,y=r.$Bg){const I=y.getComparisonKey(h);return this.a.get(I)?.size??0}queueFor(h,y,I=r.$Bg){const M=I.getComparisonKey(h);let U=this.a.get(M);if(!U){U=new R;const Q=this.f++,Z=E.Event.once(U.onDrained)(()=>{U?.dispose(),this.a.delete(M),this.h(),this.d?.deleteAndDispose(Q),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new C.$3c),this.d.set(Q,Z),this.a.set(M,U)}return U.queue(y)}h(){this.g()&&this.j()}j(){for(const h of this.b)h.complete();this.b.clear()}dispose(){for(const[,h]of this.a)h.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$hh=K;class p{constructor(h,y){this.a=-1,typeof h=="function"&&typeof y=="number"&&this.setIfNotSet(h,y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(h,y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,h()},y)}setIfNotSet(h,y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,h()},y))}}e.$ih=p;class _{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(h,y,I=globalThis){this.cancel();const M=I.setInterval(()=>{h()},y);this.d=(0,C.$Rc)(()=>{I.clearInterval(M),this.d=void 0})}dispose(){this.cancel()}}e.$jh=_;class W{constructor(h,y){this.b=-1,this.a=h,this.d=y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(h=this.d){this.cancel(),this.b=setTimeout(this.f,h)}get delay(){return this.d}set delay(h){this.d=h}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$kh=W;class H{constructor(h,y){y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${y}ms is not a multiple of 1000ms.`),this.a=h,this.b=y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(h=this.b){h%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(h/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$lh=H;class J extends W{constructor(h,y){super(h,y),this.j=[]}work(h){this.j.push(h),this.isScheduled()||this.schedule()}h(){const h=this.j;this.j=[],this.a?.(h)}dispose(){this.j=[],super.dispose()}}e.$mh=J;class he extends C.$Tc{constructor(h,y){super(),this.g=h,this.h=y,this.a=[],this.b=this.B(new C.$Uc),this.f=!1}get pending(){return this.a.length}work(h){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+h.length>this.g.maxBufferedWork)return!1}else if(this.pending+h.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const y of h)this.a.push(y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$nh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ph=(j,h)=>{(0,d.$B)(()=>{if(y)return;const I=Date.now()+15;h(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let y=!1;return{dispose(){y||(y=!0)}}}:e.$ph=(j,h,y)=>{const I=j.requestIdleCallback(h,typeof y=="number"?{timeout:y}:void 0);let M=!1;return{dispose(){M||(M=!0,j.cancelIdleCallback(I))}}},e.$oh=j=>(0,e.$ph)(globalThis,j)}();class ee{constructor(h,y){this.g=!1,this.d=()=>{try{this.j=y()}catch(I){this.l=I}finally{this.g=!0}},this.f=(0,e.$ph)(h,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$qh=ee;class oe extends ee{constructor(h){super(globalThis,h)}}e.$rh=oe;async function ue(j,h,y){let I;for(let M=0;M<y;M++)try{return await j()}catch(U){I=U,await f(h)}throw I}e.$sh=ue;class te{isRunning(h){return typeof h=="number"?this.a?.taskId===h:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(h,y,I){return this.a={taskId:h,cancel:()=>I?.(),promise:y},y.then(()=>this.d(h),()=>this.d(h)),y}d(h){this.a&&h===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const h=this.b;this.b=void 0,h.run().then(h.promiseResolve,h.promiseReject)}}queue(h){if(this.b)this.b.run=h;else{const{promise:y,resolve:I,reject:M}=l();this.b={run:h,promise:y,promiseResolve:I,promiseReject:M}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$th=te;class ce{constructor(h,y=()=>Date.now()){this.d=h,this.f=y,this.a=0,this.b=0}increment(){const h=this.f();return h-this.a>this.d&&(this.a=h,this.b=0),this.b++,this.b}}e.$uh=ce;var ne;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((h,y)=>{this.a=h,this.b=y})}complete(h){return new Promise(y=>{this.a(h),this.d={outcome:0,value:h},y()})}error(h){return new Promise(y=>{this.b(h),this.d={outcome:1,value:h},y()})}cancel(){return this.error(new T.$5)}}e.$vh=x;var ie;(function(j){async function h(I){let M;const U=await Promise.all(I.map(Q=>Q.then(Z=>Z,Z=>{M||(M=Z)})));if(typeof M<"u")throw M;return U}j.settled=h;function y(I){return new Promise(async(M,U)=>{try{await I(M,U)}catch(Q){U(Q)}})}j.withAsyncBody=y})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(h){this.a=void 0,this.b=void 0,this.d=!1,this.promise=h.then(y=>(this.a=y,this.d=!0,y),y=>{throw this.b=y,this.d=!0,y})}requireValue(){if(!this.d)throw new T.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$wh=se;class de{constructor(h){this.b=h,this.a=new c.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$xh=de;var re;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(re||(re={}));class Y{static fromArray(h){return new Y(y=>{y.emitMany(h)})}static fromPromise(h){return new Y(async y=>{y.emitMany(await h)})}static fromPromises(h){return new Y(async y=>{await Promise.all(h.map(async I=>y.emitOne(await I)))})}static merge(h){return new Y(async y=>{await Promise.all(h.map(async I=>{for await(const M of I)y.emitOne(M)}))})}static{this.EMPTY=Y.fromArray([])}constructor(h){this.a=0,this.b=[],this.d=null,this.f=new E.$Yd,queueMicrotask(async()=>{const y={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(h(y)),this.j()}catch(I){this.k(I)}finally{y.emitOne=void 0,y.emitMany=void 0,y.reject=void 0}})}[Symbol.asyncIterator](){let h=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(h<this.b.length)return{done:!1,value:this.b[h++]};if(this.a===1)return{done:!0,value:void 0};await E.Event.toPromise(this.f.event)}while(!0)}}}static map(h,y){return new Y(async I=>{for await(const M of h)I.emitOne(y(M))})}map(h){return Y.map(this,h)}static filter(h,y){return new Y(async I=>{for await(const M of h)y(M)&&I.emitOne(M)})}filter(h){return Y.filter(this,h)}static coalesce(h){return Y.filter(h,y=>!!y)}coalesce(){return Y.coalesce(this)}static async toPromise(h){const y=[];for await(const I of h)y.push(I);return y}toPromise(){return Y.toPromise(this)}g(h){this.a===0&&(this.b.push(h),this.f.fire())}h(h){this.a===0&&(this.b=this.b.concat(h),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(h){this.a===0&&(this.a=2,this.d=h,this.f.fire())}}e.$yh=Y;class ae extends Y{constructor(h,y){super(y),this.l=h}cancel(){this.l.cancel()}}e.$zh=ae;function le(j){const h=new A.$9d,y=j(h.token);return new ae(h,async I=>{const M=h.token.onCancellationRequested(()=>{M.dispose(),h.dispose(),I.reject(new T.$5)});try{for await(const U of y){if(h.token.isCancellationRequested)return;I.emitOne(U)}M.dispose(),h.dispose()}catch(U){M.dispose(),h.dispose(),I.reject(U)}})}e.$Ah=le;class fe{constructor(){this.a=new x,this.b=new Y(I=>{if(h){I.reject(h);return}return y&&I.emitMany(y),this.d=M=>I.reject(M),this.f=M=>I.emitOne(M),this.a.p});let h,y;this.f=I=>{y||(y=[]),y.push(I)},this.d=I=>{h||(h=I)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(h){this.d(h),this.a.complete()}emitOne(h){this.f(h)}}e.$Bh=fe}),define(V[22],G([0,1,37]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=e.$jC=e.$iC=void 0,e.$iC=new class{clone(){return this}equals(C){return this===C}};function T(C,r){return new A.$It([new A.$Ht(0,"",C)],r)}e.$jC=T;function E(C,r){const d=new Uint32Array(2);return d[0]=0,d[1]=(C<<0|0|0|32768|2<<24)>>>0,new A.$Jt(d,r===null?e.$iC:r)}e.$kC=E}),define(V[38],G([0,1,21,7,3,39,14,16,48,22,29,17,8]),function(z,e,A,T,E,C,r,d,t,c,b,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sC=e.$rC=e.$qC=e.$pC=e.$oC=e.$nC=void 0;var a;(function(O){O[O.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(u,m){this.tokenizationSupport=m,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(u)}getStartState(u){return this.store.getStartState(u,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$nC=i;class n extends i{constructor(u,m,v,B){super(u,m),this._textModel=v,this._languageIdCodec=B}updateTokensUntilLine(u,m){const v=this._textModel.getLanguageId();for(;;){const B=this.getFirstInvalidLine();if(!B||B.lineNumber>m)break;const q=this._textModel.getLineContent(B.lineNumber),f=N(this._languageIdCodec,v,this.tokenizationSupport,q,!0,B.startState);u.add(B.lineNumber,f.tokens),this.store.setEndState(B.lineNumber,f.endState)}}getTokenTypeIfInsertingCharacter(u,m){const v=this.getStartState(u.lineNumber);if(!v)return 0;const B=this._textModel.getLanguageId(),q=this._textModel.getLineContent(u.lineNumber),f=q.substring(0,u.column-1)+m+q.substring(u.column-1),w=N(this._languageIdCodec,B,this.tokenizationSupport,f,!0,v),L=new o.$At(w.tokens,f,this._languageIdCodec);if(L.getCount()===0)return 0;const D=L.findTokenIndexAtOffset(u.column-1);return L.getStandardTokenType(D)}tokenizeLineWithEdit(u,m,v){const B=u.lineNumber,q=u.column,f=this.getStartState(B);if(!f)return null;const w=this._textModel.getLineContent(B),L=w.substring(0,q-1)+v+w.substring(q-1+m),D=this._textModel.getLanguageIdAtPosition(B,0),S=N(this._languageIdCodec,D,this.tokenizationSupport,L,!0,f);return new o.$At(S.tokens,L,this._languageIdCodec)}isCheapToTokenize(u){const m=this.store.getFirstInvalidEndStateLineNumberOrMax();return u<m||u===m&&this._textModel.getLineLength(u)<2048}tokenizeHeuristically(u,m,v){if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(m<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(u,v),{heuristicTokens:!1};let B=this.b(m);const q=this._textModel.getLanguageId();for(let f=m;f<=v;f++){const w=this._textModel.getLineContent(f),L=N(this._languageIdCodec,q,this.tokenizationSupport,w,!0,B);u.add(f,L.tokens),B=L.endState}return{heuristicTokens:!0}}b(u){let m=this._textModel.getLineFirstNonWhitespaceColumn(u);const v=[];let B=null;for(let w=u-1;m>1&&w>=1;w--){const L=this._textModel.getLineFirstNonWhitespaceColumn(w);if(L!==0&&L<m&&(v.push(this._textModel.getLineContent(w)),m=L,B=this.getStartState(w),B))break}B||(B=this.tokenizationSupport.getInitialState()),v.reverse();const q=this._textModel.getLanguageId();let f=B;for(const w of v)f=N(this._languageIdCodec,q,this.tokenizationSupport,w,!1,f).endState;return f}}e.$oC=n;class s{constructor(u){this.d=u,this.a=new l,this.b=new k,this.b.addRange(new t.$7s(1,u+1))}getEndState(u){return this.a.getEndState(u)}setEndState(u,m){if(!m)throw new T.$cb("Cannot set null/undefined state");this.b.delete(u);const v=this.a.setEndState(u,m);return v&&u<this.d&&this.b.addRange(new t.$7s(u+1,u+2)),v}acceptChange(u,m){this.d+=m-u.length,this.a.acceptChange(u,m),this.b.addRangeAndResize(new t.$7s(u.startLineNumber,u.endLineNumberExclusive),m)}acceptChanges(u){for(const m of u){const[v]=(0,r.$zt)(m.text);this.acceptChange(new d.$9s(m.range.startLineNumber,m.range.endLineNumber+1),v+1)}}invalidateEndStateRange(u){this.b.addRange(new t.$7s(u.startLineNumber,u.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(u,m){return u===1?m:this.getEndState(u-1)}getFirstInvalidLine(u){const m=this.getFirstInvalidEndStateLineNumber();if(m===null)return null;const v=this.getStartState(m,u);if(!v)throw new T.$cb("Start state must be defined");return{lineNumber:m,startState:v}}}e.$pC=s;class l{constructor(){this.a=new b.$lC(null)}getEndState(u){return this.a.get(u)}setEndState(u,m){const v=this.a.get(u);return v&&v.equals(m)?!1:(this.a.set(u,m),!0)}acceptChange(u,m){let v=u.length;m>0&&v>0&&(v--,m--),this.a.replace(u.startLineNumber,v,m)}acceptChanges(u){for(const m of u){const[v]=(0,r.$zt)(m.text);this.acceptChange(new d.$9s(m.range.startLineNumber,m.range.endLineNumber+1),v+1)}}}e.$qC=l;class k{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const u=this.a[0];return u.start+1===u.endExclusive?this.a.shift():this.a[0]=new t.$7s(u.start+1,u.endExclusive),u.start}delete(u){const m=this.a.findIndex(v=>v.contains(u));if(m!==-1){const v=this.a[m];v.start===u?v.endExclusive===u+1?this.a.splice(m,1):this.a[m]=new t.$7s(u+1,v.endExclusive):v.endExclusive===u+1?this.a[m]=new t.$7s(v.start,u):this.a.splice(m,1,new t.$7s(v.start,u),new t.$7s(u+1,v.endExclusive))}}addRange(u){t.$7s.addRange(u,this.a)}addRangeAndResize(u,m){let v=0;for(;!(v>=this.a.length||u.start<=this.a[v].endExclusive);)v++;let B=v;for(;!(B>=this.a.length||u.endExclusive<this.a[B].start);)B++;const q=m-u.length;for(let f=B;f<this.a.length;f++)this.a[f]=this.a[f].delta(q);if(v===B){const f=new t.$7s(u.start,u.start+m);f.isEmpty||this.a.splice(v,0,f)}else{const f=Math.min(u.start,this.a[v].start),w=Math.max(u.endExclusive,this.a[B-1].endExclusive),L=new t.$7s(f,w+q);L.isEmpty?this.a.splice(v,B-v):this.a.splice(v,B-v,L)}}toString(){return this.a.map(u=>u.toString()).join(" + ")}}e.$rC=k;function N(O,u,m,v,B,q){let f=null;if(m)try{f=m.tokenizeEncoded(v,B,q.clone())}catch(w){(0,T.$1)(w)}return f||(f=(0,c.$kC)(O.encodeLanguageId(u),q)),o.$At.convertToEndOffset(f.tokens,v.length),f}class P{constructor(u,m){this.b=u,this.d=m,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,A.$oh)(u=>{this.f=!1,this.h(u)}))}h(u){const m=Date.now()+u.timeRemaining(),v=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<m?(0,E.$B)(v):this.g())};v()}j(){const u=this.b._textModel.getLineCount(),m=new g.$mC,v=C.$Ud.create(!1);do if(v.elapsed()>1||this.l(m)>=u)break;while(this.k());this.d.setTokens(m.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(u){const m=this.b?.getFirstInvalidLine();return m?(this.b.updateTokensUntilLine(u,m.lineNumber),m.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(u,m){this.b.store.invalidateEndStateRange(new d.$9s(u,m))}}e.$sC=P}),define(V[40],G([0,1,36,2,39,15,37]),function(z,e,A,T,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dIb=void 0;class d extends T.$Tc{constructor(c,b,g,o,a,i,n){super(),this.c=c,this.f=b,this.g=g,this.h=o,this.j=a,this.m=i,this.n=n,this.a=[],this.b=this.B(new A.$Yd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(c,b,g){throw new Error("Not supported!")}createBackgroundTokenizer(c,b){if(this.h)return this.h(c,b)}tokenizeEncoded(c,b,g){const o=Math.random()*1e4<1,a=this.n||o,i=a?new E.$Ud(!0):void 0,n=this.c.tokenizeLine2(c,g,500);if(a){const l=i.elapsed();(o||l>32)&&this.m(l,c.length,o)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${c.substring(0,100)}`),new r.$Jt(n.tokens,g);if(this.g){const l=this.a,k=n.tokens;for(let N=0,P=k.length>>>1;N<P;N++){const O=k[(N<<1)+1],u=C.$xt.getLanguageId(O);l[u]||(l[u]=!0,this.b.fire(u))}}let s;return g.equals(n.ruleStack)?s=g:s=n.ruleStack,new r.$Jt(n.tokens,s)}}e.$dIb=d}),define(V[41],G([0,1,22,2,12]),function(z,e,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eIb=void 0;class C extends T.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(d,t,c){super(),this.a=d,this.b=t,this.c=c,this.B((0,E.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(d,t,c){throw new Error("Not supported!")}tokenizeEncoded(d,t,c){return d.length>=this.c.get()?(0,A.$kC)(this.a,c):this.b.tokenizeEncoded(d,t,c)}createBackgroundTokenizer(d,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(d,t)}}e.$eIb=C}),define(V[42],G([0,1,35,21,12,3,16,49,38,17,8,40,41]),function(z,e,A,T,E,C,r,d,t,c,b,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jIb=void 0;class a extends d.$qv{constructor(s,l,k,N,P,O,u,m){super(s,l,k,N),this.s=P,this.t=O,this.u=u,this.a=null,this.b=!1,this.c=(0,E.observableValue)(this,-1),this.q=new T.$kh(()=>this.w(),10),this.c.set(m,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,l){this.t=s,this.u=l,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,l){this.a&&(this.a.store.invalidateEndStateRange(new r.$9s(s,l)),this.q.schedule())}async v(){this.a=null;const s=this.t,l=this.u,k=await this.s.getOrCreateGrammar(s,l);if(!(this.b||s!==this.t||l!==this.u||!k)){if(k.grammar){const N=new o.$eIb(this.u,new g.$dIb(k.grammar,k.initialState,!1,void 0,()=>!1,(P,O,u)=>{this.s.reportTokenizationTime(P,s,k.sourceExtensionId,O,u)},!1),this.c);this.a=new t.$nC(this.f.length,N)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:l}=await(0,A.$mD)("vscode-textmate","release/main.js");this.m=l}const s=new Date().getTime();for(;;){let l=0;const k=new c.$mC,N=new i;for(;;){const u=this.a.getFirstInvalidLine();if(u===null||l>200)break;l++;const m=this.f[u.lineNumber-1],v=this.a.tokenizationSupport.tokenizeEncoded(m,!0,u.startState);if(this.a.store.setEndState(u.lineNumber,v.endState)){const q=this.m(u.startState,v.endState);N.setState(u.lineNumber,q)}else N.setState(u.lineNumber,null);if(b.$At.convertToEndOffset(v.tokens,m.length),k.add(u.lineNumber,v.tokens),new Date().getTime()-s>20)break}if(l===0)break;const P=N.getStateDeltas();if(this.s.setTokensAndStates(this.h,k.serialize(),P),new Date().getTime()-s>20){(0,C.$B)(()=>this.w());return}}}}e.$jIb=a;class i{constructor(){this.a=-1,this.b=[]}setState(s,l){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(l):this.b.push({startLineNumber:s,stateDeltas:[l]}),this.a=s}getStateDeltas(){return this.b}}}),define(V[43],G([0,1,20]),function(z,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gIb=void 0;class T{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(C){if(this.a[C.scopeName]){const r=this.a[C.scopeName];A.$Eg(r.location,C.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${C.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${C.location.toString()}`)}this.a[C.scopeName]=C}getGrammarDefinition(C){return this.a[C]||null}}e.$gIb=T}),define(V[44],G([0,1,2,43]),function(z,e,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iIb=e.$hIb=void 0,e.$hIb="No TM Grammar registered for this language.";class E extends A.$Tc{constructor(r,d,t,c){super(),this.a=r,this.b=t.INITIAL,this.c=new T.$gIb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:c,loadGrammar:async b=>{const g=this.c.getGrammarDefinition(b);if(!g)return this.a.logTrace(`No grammar found for scope ${b}`),null;const o=g.location;try{const a=await this.a.readFile(o);return t.parseRawGrammar(a,o.path)}catch(a){return this.a.logError(`Unable to load and parse grammar for scope ${b} from ${o}`,a),null}},getInjections:b=>{const g=b.split(".");let o=[];for(let a=1;a<=g.length;a++){const i=g.slice(0,a).join(".");o=[...o,...this.f[i]||[]]}return o}}));for(const b of d){if(this.c.register(b),b.injectTo){for(const g of b.injectTo){let o=this.f[g];o||(this.f[g]=o=[]),o.push(b.scopeName)}if(b.embeddedLanguages)for(const g of b.injectTo){let o=this.g[g];o||(this.g[g]=o=[]),o.push(b.embeddedLanguages)}}b.language&&this.h.set(b.language,b.scopeName)}}has(r){return this.h.has(r)}setTheme(r,d){this.j.setTheme(r,d)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,d){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$hIb);const c=this.c.getGrammarDefinition(t);if(!c)throw new Error(e.$hIb);const b=c.embeddedLanguages;if(this.g[t]){const a=this.g[t];for(const i of a)for(const n of Object.keys(i))b[n]=i[n]}const g=Object.keys(b).length>0;let o;try{o=await this.j.loadGrammarWithConfiguration(t,d,{embeddedLanguages:b,tokenTypes:c.tokenTypes,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.$hIb):a}return{languageId:r,grammar:o,initialState:this.b,containsEmbeddedLanguages:g,sourceExtensionId:c.sourceExtensionId}}}e.$iIb=E}),define(V[50],G([0,1,9,44,42]),function(z,e,A,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function C(d,t){return new r(d,t)}e.create=C;class r{constructor(t,c){this.f=c,this.b=new Map,this.c=[],this.a=t.host;const b=c.grammarDefinitions.map(g=>({location:A.URI.revive(g.location),language:g.language,scopeName:g.scopeName,embeddedLanguages:g.embeddedLanguages,tokenTypes:g.tokenTypes,injectTo:g.injectTo,balancedBracketSelectors:g.balancedBracketSelectors,unbalancedBracketSelectors:g.unbalancedBracketSelectors,sourceExtensionId:g.sourceExtensionId}));this.d=this.g(b)}async g(t){const c=this.f.textmateMainUri,b=await new Promise((n,s)=>{z([c],n,s)}),g=await new Promise((n,s)=>{z([this.f.onigurumaMainUri],n,s)}),a=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await g.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>g.createOnigScanner(n),createOnigString:n=>g.createOnigString(n)});return new T.$iIb({logTrace:n=>{},logError:(n,s)=>console.error(n,s),readFile:n=>this.a.readFile(n)},t,b,i)}acceptNewModel(t){const c=A.URI.revive(t.uri),b=this;this.b.set(t.controllerId,new E.$jIb(c,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(g,o){const a=await b.d;return a?(b.c[o]||(b.c[o]=a.createGrammar(g,o)),b.c[o]):Promise.resolve(null)},setTokensAndStates(g,o,a){b.a.setTokensAndStates(t.controllerId,g,o,a)},reportTokenizationTime(g,o,a,i,n){b.a.reportTokenizationTime(g,o,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,c){this.b.get(t).onEvents(c)}retokenize(t,c,b){this.b.get(t).retokenize(c,b)}acceptModelLanguageChanged(t,c,b){this.b.get(t).onLanguageId(c,b)}acceptRemovedModel(t){const c=this.b.get(t);c&&(c.dispose(),this.b.delete(t))}async acceptTheme(t,c){(await this.d)?.setTheme(t,c)}acceptMaxTokenizationLineLength(t,c){this.b.get(t).acceptMaxTokenizationLineLength(c)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4f2ff19ecacffa0aa4874db4d63ed4e899d98431/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
